/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the BPF target                             *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 11;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(BPFInstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(BPFInstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static BPFInstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static BPFInstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testMOPredicate_MO(unsigned PredicateID, const MachineOperand &MO, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(0),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s32,
  GILLT_s64,
};
const static size_t NumTypeObjects = 2;
const static LLT TypeObjects[] = {
  LLT::scalar(32),
  LLT::scalar(64),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_BPFIsLittleEndianBit = 7,
  Feature_BPFIsBigEndianBit = 8,
  Feature_BPFHasALU32Bit = 5,
  Feature_BPFNoALU32Bit = 2,
  Feature_BPFHasLdsxBit = 4,
  Feature_BPFHasMovsxBit = 1,
  Feature_BPFHasBswapBit = 6,
  Feature_BPFHasSdivSmodBit = 0,
  Feature_BPFNoMovsxBit = 10,
  Feature_BPFHasStoreImmBit = 3,
  Feature_BPFHasLoadAcqStoreRelBit = 9,
};

PredicateBitset BPFInstructionSelector::
computeAvailableModuleFeatures(const BPFSubtarget *Subtarget) const {
  PredicateBitset Features{};
  if (Subtarget->isLittleEndian())
    Features.set(Feature_BPFIsLittleEndianBit);
  if (!Subtarget->isLittleEndian())
    Features.set(Feature_BPFIsBigEndianBit);
  if (Subtarget->getHasAlu32())
    Features.set(Feature_BPFHasALU32Bit);
  if (!Subtarget->getHasAlu32())
    Features.set(Feature_BPFNoALU32Bit);
  if (Subtarget->hasLdsx())
    Features.set(Feature_BPFHasLdsxBit);
  if (Subtarget->hasMovsx())
    Features.set(Feature_BPFHasMovsxBit);
  if (Subtarget->hasBswap())
    Features.set(Feature_BPFHasBswapBit);
  if (Subtarget->hasSdivSmod())
    Features.set(Feature_BPFHasSdivSmodBit);
  if (!Subtarget->hasMovsx())
    Features.set(Feature_BPFNoMovsxBit);
  if (Subtarget->hasStoreImm())
    Features.set(Feature_BPFHasStoreImmBit);
  if (Subtarget->hasLoadAcqStoreRel())
    Features.set(Feature_BPFHasLoadAcqStoreRelBit);
  return Features;
}

void BPFInstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const BPFSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset BPFInstructionSelector::
computeAvailableFunctionFeatures(const BPFSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_BPFHasBswap,
  GIFBS_BPFHasMovsx,
  GIFBS_BPFHasSdivSmod,
  GIFBS_BPFIsBigEndian,
  GIFBS_BPFIsLittleEndian,
  GIFBS_BPFNoMovsx,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_BPFHasBswapBit, },
  {Feature_BPFHasMovsxBit, },
  {Feature_BPFHasSdivSmodBit, },
  {Feature_BPFIsBigEndianBit, },
  {Feature_BPFIsLittleEndianBit, },
  {Feature_BPFNoMovsxBit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
};
// See constructor for table contents

BPFInstructionSelector::ComplexMatcherMemFn
BPFInstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
};

// PatFrag predicates.
enum {
  GICXXPred_MI_Predicate_or_disjoint = GICXXPred_Invalid + 1,
};
bool BPFInstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_or_disjoint: {
    
        return MI.getFlag(MachineInstr::Disjoint);
      
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool BPFInstructionSelector::testMOPredicate_MO(unsigned PredicateID, const MachineOperand & MO, const MatcherState &State) const {
  const auto &Operands = State.RecordedOperands;
  Register Reg = MO.getReg();
  (void)Operands;
  (void)Reg;
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool BPFInstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool BPFInstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool BPFInstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool BPFInstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("BPFInstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
};
BPFInstructionSelector::CustomRendererFn
BPFInstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
};

bool BPFInstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool BPFInstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("BPFInstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *BPFInstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*    0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(253), /*)*//*default:*//*Label 22*/ GIMT_Encode4(2659),
     /*   10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(810),
     /*   14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(876),
     /*   18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(990),
     /*   22 */ /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(1056),
     /*   26 */ /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(1128),
     /*   30 */ /*TargetOpcode::G_SREM*//*Label 5*/ GIMT_Encode4(1194),
     /*   34 */ /*TargetOpcode::G_UREM*//*Label 6*/ GIMT_Encode4(1266), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   46 */ /*TargetOpcode::G_AND*//*Label 7*/ GIMT_Encode4(1332),
     /*   50 */ /*TargetOpcode::G_OR*//*Label 8*/ GIMT_Encode4(1458),
     /*   54 */ /*TargetOpcode::G_XOR*//*Label 9*/ GIMT_Encode4(1524), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  318 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 10*/ GIMT_Encode4(1590), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  330 */ /*TargetOpcode::G_ANYEXT*//*Label 11*/ GIMT_Encode4(1654),
     /*  334 */ /*TargetOpcode::G_TRUNC*//*Label 12*/ GIMT_Encode4(1717), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  350 */ /*TargetOpcode::G_CONSTANT*//*Label 13*/ GIMT_Encode4(1759), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  366 */ /*TargetOpcode::G_SEXT*//*Label 14*/ GIMT_Encode4(1782),
     /*  370 */ /*TargetOpcode::G_SEXT_INREG*//*Label 15*/ GIMT_Encode4(1898),
     /*  374 */ /*TargetOpcode::G_ZEXT*//*Label 16*/ GIMT_Encode4(2094),
     /*  378 */ /*TargetOpcode::G_SHL*//*Label 17*/ GIMT_Encode4(2121),
     /*  382 */ /*TargetOpcode::G_LSHR*//*Label 18*/ GIMT_Encode4(2187),
     /*  386 */ /*TargetOpcode::G_ASHR*//*Label 19*/ GIMT_Encode4(2511), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  742 */ /*TargetOpcode::G_BR*//*Label 20*/ GIMT_Encode4(2577), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  806 */ /*TargetOpcode::G_BSWAP*//*Label 21*/ GIMT_Encode4(2593),
     /*  810 */ // Label 0: @810
     /*  810 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 25*/ GIMT_Encode4(875),
     /*  821 */ /*GILLT_s32*//*Label 23*/ GIMT_Encode4(829),
     /*  825 */ /*GILLT_s64*//*Label 24*/ GIMT_Encode4(852),
     /*  829 */ // Label 23: @829
     /*  829 */ GIM_Try, /*On fail goto*//*Label 26*/ GIMT_Encode4(851), // Rule ID 46 //
     /*  834 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  837 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /*  844 */   // (add:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)  =>  (ADD_rr_32:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)
     /*  844 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::ADD_rr_32),
     /*  849 */   GIR_RootConstrainSelectedInstOperands,
     /*  850 */   // GIR_Coverage, 46,
     /*  850 */   GIR_Done,
     /*  851 */ // Label 26: @851
     /*  851 */ GIM_Reject,
     /*  852 */ // Label 24: @852
     /*  852 */ GIM_Try, /*On fail goto*//*Label 27*/ GIMT_Encode4(874), // Rule ID 44 //
     /*  857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  860 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  863 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /*  867 */   // (add:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)  =>  (ADD_rr:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)
     /*  867 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::ADD_rr),
     /*  872 */   GIR_RootConstrainSelectedInstOperands,
     /*  873 */   // GIR_Coverage, 44,
     /*  873 */   GIR_Done,
     /*  874 */ // Label 27: @874
     /*  874 */ GIM_Reject,
     /*  875 */ // Label 25: @875
     /*  875 */ GIM_Reject,
     /*  876 */ // Label 1: @876
     /*  876 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 30*/ GIMT_Encode4(989),
     /*  887 */ /*GILLT_s32*//*Label 28*/ GIMT_Encode4(895),
     /*  891 */ /*GILLT_s64*//*Label 29*/ GIMT_Encode4(942),
     /*  895 */ // Label 28: @895
     /*  895 */ GIM_Try, /*On fail goto*//*Label 31*/ GIMT_Encode4(941),
     /*  900 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  903 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /*  910 */   GIM_Try, /*On fail goto*//*Label 32*/ GIMT_Encode4(928), // Rule ID 97 //
     /*  915 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  919 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, i32:{ *:[i32] }:$src)  =>  (NEG_32:{ *:[i32] } i32:{ *:[i32] }:$src)
     /*  919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::NEG_32),
     /*  922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  924 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  926 */     GIR_RootConstrainSelectedInstOperands,
     /*  927 */     // GIR_Coverage, 97,
     /*  927 */     GIR_EraseRootFromParent_Done,
     /*  928 */   // Label 32: @928
     /*  928 */   GIM_Try, /*On fail goto*//*Label 33*/ GIMT_Encode4(940), // Rule ID 50 //
     /*  933 */     // (sub:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)  =>  (SUB_rr_32:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)
     /*  933 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::SUB_rr_32),
     /*  938 */     GIR_RootConstrainSelectedInstOperands,
     /*  939 */     // GIR_Coverage, 50,
     /*  939 */     GIR_Done,
     /*  940 */   // Label 33: @940
     /*  940 */   GIM_Reject,
     /*  941 */ // Label 31: @941
     /*  941 */ GIM_Reject,
     /*  942 */ // Label 29: @942
     /*  942 */ GIM_Try, /*On fail goto*//*Label 34*/ GIMT_Encode4(988),
     /*  947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  950 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /*  957 */   GIM_Try, /*On fail goto*//*Label 35*/ GIMT_Encode4(975), // Rule ID 96 //
     /*  962 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  966 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, i64:{ *:[i64] }:$src)  =>  (NEG_64:{ *:[i64] } i64:{ *:[i64] }:$src)
     /*  966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::NEG_64),
     /*  969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  971 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  973 */     GIR_RootConstrainSelectedInstOperands,
     /*  974 */     // GIR_Coverage, 96,
     /*  974 */     GIR_EraseRootFromParent_Done,
     /*  975 */   // Label 35: @975
     /*  975 */   GIM_Try, /*On fail goto*//*Label 36*/ GIMT_Encode4(987), // Rule ID 48 //
     /*  980 */     // (sub:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)  =>  (SUB_rr:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)
     /*  980 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::SUB_rr),
     /*  985 */     GIR_RootConstrainSelectedInstOperands,
     /*  986 */     // GIR_Coverage, 48,
     /*  986 */     GIR_Done,
     /*  987 */   // Label 36: @987
     /*  987 */   GIM_Reject,
     /*  988 */ // Label 34: @988
     /*  988 */ GIM_Reject,
     /*  989 */ // Label 30: @989
     /*  989 */ GIM_Reject,
     /*  990 */ // Label 2: @990
     /*  990 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 39*/ GIMT_Encode4(1055),
     /* 1001 */ /*GILLT_s32*//*Label 37*/ GIMT_Encode4(1009),
     /* 1005 */ /*GILLT_s64*//*Label 38*/ GIMT_Encode4(1032),
     /* 1009 */ // Label 37: @1009
     /* 1009 */ GIM_Try, /*On fail goto*//*Label 40*/ GIMT_Encode4(1031), // Rule ID 78 //
     /* 1014 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 1017 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 1020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1024 */   // (mul:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)  =>  (MUL_rr_32:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)
     /* 1024 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::MUL_rr_32),
     /* 1029 */   GIR_RootConstrainSelectedInstOperands,
     /* 1030 */   // GIR_Coverage, 78,
     /* 1030 */   GIR_Done,
     /* 1031 */ // Label 40: @1031
     /* 1031 */ GIM_Reject,
     /* 1032 */ // Label 38: @1032
     /* 1032 */ GIM_Try, /*On fail goto*//*Label 41*/ GIMT_Encode4(1054), // Rule ID 76 //
     /* 1037 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 1040 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 1043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1047 */   // (mul:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)  =>  (MUL_rr:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)
     /* 1047 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::MUL_rr),
     /* 1052 */   GIR_RootConstrainSelectedInstOperands,
     /* 1053 */   // GIR_Coverage, 76,
     /* 1053 */   GIR_Done,
     /* 1054 */ // Label 41: @1054
     /* 1054 */ GIM_Reject,
     /* 1055 */ // Label 39: @1055
     /* 1055 */ GIM_Reject,
     /* 1056 */ // Label 3: @1056
     /* 1056 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 44*/ GIMT_Encode4(1127),
     /* 1067 */ /*GILLT_s32*//*Label 42*/ GIMT_Encode4(1075),
     /* 1071 */ /*GILLT_s64*//*Label 43*/ GIMT_Encode4(1101),
     /* 1075 */ // Label 42: @1075
     /* 1075 */ GIM_Try, /*On fail goto*//*Label 45*/ GIMT_Encode4(1100), // Rule ID 90 //
     /* 1080 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFHasSdivSmod),
     /* 1083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 1086 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 1089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1093 */   // (sdiv:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)  =>  (SDIV_rr_32:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)
     /* 1093 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::SDIV_rr_32),
     /* 1098 */   GIR_RootConstrainSelectedInstOperands,
     /* 1099 */   // GIR_Coverage, 90,
     /* 1099 */   GIR_Done,
     /* 1100 */ // Label 45: @1100
     /* 1100 */ GIM_Reject,
     /* 1101 */ // Label 43: @1101
     /* 1101 */ GIM_Try, /*On fail goto*//*Label 46*/ GIMT_Encode4(1126), // Rule ID 88 //
     /* 1106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFHasSdivSmod),
     /* 1109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 1112 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 1115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1119 */   // (sdiv:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)  =>  (SDIV_rr:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)
     /* 1119 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::SDIV_rr),
     /* 1124 */   GIR_RootConstrainSelectedInstOperands,
     /* 1125 */   // GIR_Coverage, 88,
     /* 1125 */   GIR_Done,
     /* 1126 */ // Label 46: @1126
     /* 1126 */ GIM_Reject,
     /* 1127 */ // Label 44: @1127
     /* 1127 */ GIM_Reject,
     /* 1128 */ // Label 4: @1128
     /* 1128 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 49*/ GIMT_Encode4(1193),
     /* 1139 */ /*GILLT_s32*//*Label 47*/ GIMT_Encode4(1147),
     /* 1143 */ /*GILLT_s64*//*Label 48*/ GIMT_Encode4(1170),
     /* 1147 */ // Label 47: @1147
     /* 1147 */ GIM_Try, /*On fail goto*//*Label 50*/ GIMT_Encode4(1169), // Rule ID 82 //
     /* 1152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 1155 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 1158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1162 */   // (udiv:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)  =>  (DIV_rr_32:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)
     /* 1162 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::DIV_rr_32),
     /* 1167 */   GIR_RootConstrainSelectedInstOperands,
     /* 1168 */   // GIR_Coverage, 82,
     /* 1168 */   GIR_Done,
     /* 1169 */ // Label 50: @1169
     /* 1169 */ GIM_Reject,
     /* 1170 */ // Label 48: @1170
     /* 1170 */ GIM_Try, /*On fail goto*//*Label 51*/ GIMT_Encode4(1192), // Rule ID 80 //
     /* 1175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 1178 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 1181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1185 */   // (udiv:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)  =>  (DIV_rr:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)
     /* 1185 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::DIV_rr),
     /* 1190 */   GIR_RootConstrainSelectedInstOperands,
     /* 1191 */   // GIR_Coverage, 80,
     /* 1191 */   GIR_Done,
     /* 1192 */ // Label 51: @1192
     /* 1192 */ GIM_Reject,
     /* 1193 */ // Label 49: @1193
     /* 1193 */ GIM_Reject,
     /* 1194 */ // Label 5: @1194
     /* 1194 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 54*/ GIMT_Encode4(1265),
     /* 1205 */ /*GILLT_s32*//*Label 52*/ GIMT_Encode4(1213),
     /* 1209 */ /*GILLT_s64*//*Label 53*/ GIMT_Encode4(1239),
     /* 1213 */ // Label 52: @1213
     /* 1213 */ GIM_Try, /*On fail goto*//*Label 55*/ GIMT_Encode4(1238), // Rule ID 94 //
     /* 1218 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFHasSdivSmod),
     /* 1221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 1224 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 1227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1231 */   // (srem:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)  =>  (SMOD_rr_32:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)
     /* 1231 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::SMOD_rr_32),
     /* 1236 */   GIR_RootConstrainSelectedInstOperands,
     /* 1237 */   // GIR_Coverage, 94,
     /* 1237 */   GIR_Done,
     /* 1238 */ // Label 55: @1238
     /* 1238 */ GIM_Reject,
     /* 1239 */ // Label 53: @1239
     /* 1239 */ GIM_Try, /*On fail goto*//*Label 56*/ GIMT_Encode4(1264), // Rule ID 92 //
     /* 1244 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFHasSdivSmod),
     /* 1247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 1250 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 1253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1257 */   // (srem:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)  =>  (SMOD_rr:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)
     /* 1257 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::SMOD_rr),
     /* 1262 */   GIR_RootConstrainSelectedInstOperands,
     /* 1263 */   // GIR_Coverage, 92,
     /* 1263 */   GIR_Done,
     /* 1264 */ // Label 56: @1264
     /* 1264 */ GIM_Reject,
     /* 1265 */ // Label 54: @1265
     /* 1265 */ GIM_Reject,
     /* 1266 */ // Label 6: @1266
     /* 1266 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 59*/ GIMT_Encode4(1331),
     /* 1277 */ /*GILLT_s32*//*Label 57*/ GIMT_Encode4(1285),
     /* 1281 */ /*GILLT_s64*//*Label 58*/ GIMT_Encode4(1308),
     /* 1285 */ // Label 57: @1285
     /* 1285 */ GIM_Try, /*On fail goto*//*Label 60*/ GIMT_Encode4(1307), // Rule ID 86 //
     /* 1290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 1293 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 1296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1300 */   // (urem:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)  =>  (MOD_rr_32:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)
     /* 1300 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::MOD_rr_32),
     /* 1305 */   GIR_RootConstrainSelectedInstOperands,
     /* 1306 */   // GIR_Coverage, 86,
     /* 1306 */   GIR_Done,
     /* 1307 */ // Label 60: @1307
     /* 1307 */ GIM_Reject,
     /* 1308 */ // Label 58: @1308
     /* 1308 */ GIM_Try, /*On fail goto*//*Label 61*/ GIMT_Encode4(1330), // Rule ID 84 //
     /* 1313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 1316 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 1319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1323 */   // (urem:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)  =>  (MOD_rr:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)
     /* 1323 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::MOD_rr),
     /* 1328 */   GIR_RootConstrainSelectedInstOperands,
     /* 1329 */   // GIR_Coverage, 84,
     /* 1329 */   GIR_Done,
     /* 1330 */ // Label 61: @1330
     /* 1330 */ GIM_Reject,
     /* 1331 */ // Label 59: @1331
     /* 1331 */ GIM_Reject,
     /* 1332 */ // Label 7: @1332
     /* 1332 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 64*/ GIMT_Encode4(1457),
     /* 1343 */ /*GILLT_s32*//*Label 62*/ GIMT_Encode4(1351),
     /* 1347 */ /*GILLT_s64*//*Label 63*/ GIMT_Encode4(1374),
     /* 1351 */ // Label 62: @1351
     /* 1351 */ GIM_Try, /*On fail goto*//*Label 65*/ GIMT_Encode4(1373), // Rule ID 58 //
     /* 1356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 1359 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 1362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1366 */   // (and:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)  =>  (AND_rr_32:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)
     /* 1366 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::AND_rr_32),
     /* 1371 */   GIR_RootConstrainSelectedInstOperands,
     /* 1372 */   // GIR_Coverage, 58,
     /* 1372 */   GIR_Done,
     /* 1373 */ // Label 65: @1373
     /* 1373 */ GIM_Reject,
     /* 1374 */ // Label 63: @1374
     /* 1374 */ GIM_Try, /*On fail goto*//*Label 66*/ GIMT_Encode4(1456),
     /* 1379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 1382 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 1385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1389 */   GIM_Try, /*On fail goto*//*Label 67*/ GIMT_Encode4(1443), // Rule ID 171 //
     /* 1394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1398 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /* 1409 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$src, 4294967295:{ *:[i64] })  =>  (SRL_ri:{ *:[i64] } (SLL_ri:{ *:[i64] } GPR:{ *:[i64] }:$src, 32:{ *:[i64] }), 32:{ *:[i64] })
     /* 1409 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 1412 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(BPF::SLL_ri),
     /* 1416 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 1421 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 1425 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 1428 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 1430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::SRL_ri),
     /* 1433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 1435 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 1438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/32,
     /* 1441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442 */     // GIR_Coverage, 171,
     /* 1442 */     GIR_EraseRootFromParent_Done,
     /* 1443 */   // Label 67: @1443
     /* 1443 */   GIM_Try, /*On fail goto*//*Label 68*/ GIMT_Encode4(1455), // Rule ID 56 //
     /* 1448 */     // (and:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)  =>  (AND_rr:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)
     /* 1448 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::AND_rr),
     /* 1453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454 */     // GIR_Coverage, 56,
     /* 1454 */     GIR_Done,
     /* 1455 */   // Label 68: @1455
     /* 1455 */   GIM_Reject,
     /* 1456 */ // Label 66: @1456
     /* 1456 */ GIM_Reject,
     /* 1457 */ // Label 64: @1457
     /* 1457 */ GIM_Reject,
     /* 1458 */ // Label 8: @1458
     /* 1458 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 71*/ GIMT_Encode4(1523),
     /* 1469 */ /*GILLT_s32*//*Label 69*/ GIMT_Encode4(1477),
     /* 1473 */ /*GILLT_s64*//*Label 70*/ GIMT_Encode4(1500),
     /* 1477 */ // Label 69: @1477
     /* 1477 */ GIM_Try, /*On fail goto*//*Label 72*/ GIMT_Encode4(1499), // Rule ID 54 //
     /* 1482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 1485 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 1488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1492 */   // (or:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)  =>  (OR_rr_32:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)
     /* 1492 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::OR_rr_32),
     /* 1497 */   GIR_RootConstrainSelectedInstOperands,
     /* 1498 */   // GIR_Coverage, 54,
     /* 1498 */   GIR_Done,
     /* 1499 */ // Label 72: @1499
     /* 1499 */ GIM_Reject,
     /* 1500 */ // Label 70: @1500
     /* 1500 */ GIM_Try, /*On fail goto*//*Label 73*/ GIMT_Encode4(1522), // Rule ID 52 //
     /* 1505 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 1508 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 1511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1515 */   // (or:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)  =>  (OR_rr:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)
     /* 1515 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::OR_rr),
     /* 1520 */   GIR_RootConstrainSelectedInstOperands,
     /* 1521 */   // GIR_Coverage, 52,
     /* 1521 */   GIR_Done,
     /* 1522 */ // Label 73: @1522
     /* 1522 */ GIM_Reject,
     /* 1523 */ // Label 71: @1523
     /* 1523 */ GIM_Reject,
     /* 1524 */ // Label 9: @1524
     /* 1524 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 76*/ GIMT_Encode4(1589),
     /* 1535 */ /*GILLT_s32*//*Label 74*/ GIMT_Encode4(1543),
     /* 1539 */ /*GILLT_s64*//*Label 75*/ GIMT_Encode4(1566),
     /* 1543 */ // Label 74: @1543
     /* 1543 */ GIM_Try, /*On fail goto*//*Label 77*/ GIMT_Encode4(1565), // Rule ID 70 //
     /* 1548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 1551 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 1554 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1558 */   // (xor:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)  =>  (XOR_rr_32:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)
     /* 1558 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::XOR_rr_32),
     /* 1563 */   GIR_RootConstrainSelectedInstOperands,
     /* 1564 */   // GIR_Coverage, 70,
     /* 1564 */   GIR_Done,
     /* 1565 */ // Label 77: @1565
     /* 1565 */ GIM_Reject,
     /* 1566 */ // Label 75: @1566
     /* 1566 */ GIM_Try, /*On fail goto*//*Label 78*/ GIMT_Encode4(1588), // Rule ID 68 //
     /* 1571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 1574 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 1577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1581 */   // (xor:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)  =>  (XOR_rr:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)
     /* 1581 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::XOR_rr),
     /* 1586 */   GIR_RootConstrainSelectedInstOperands,
     /* 1587 */   // GIR_Coverage, 68,
     /* 1587 */   GIR_Done,
     /* 1588 */ // Label 78: @1588
     /* 1588 */ GIM_Reject,
     /* 1589 */ // Label 76: @1589
     /* 1589 */ GIM_Reject,
     /* 1590 */ // Label 10: @1590
     /* 1590 */ GIM_Try, /*On fail goto*//*Label 79*/ GIMT_Encode4(1653), // Rule ID 107 //
     /* 1595 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 1598 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::bpf_pseudo),
     /* 1603 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 1606 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 1609 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1616 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1620 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1624 */   // MIs[1] Operand 1
     /* 1624 */   // No operand predicates
     /* 1624 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 1628 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1632 */   // MIs[2] Operand 1
     /* 1632 */   // No operand predicates
     /* 1632 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1634 */   // (intrinsic_w_chain:{ *:[i64] } 3962:{ *:[iPTR] }, (imm:{ *:[i64] }):$pseudo, (imm:{ *:[i64] }):$imm)  =>  (LD_pseudo:{ *:[i64] } (imm:{ *:[i64] }):$pseudo, (imm:{ *:[i64] }):$imm)
     /* 1634 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::LD_pseudo),
     /* 1637 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 1639 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // pseudo
     /* 1642 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 1645 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 1651 */   GIR_RootConstrainSelectedInstOperands,
     /* 1652 */   // GIR_Coverage, 107,
     /* 1652 */   GIR_EraseRootFromParent_Done,
     /* 1653 */ // Label 79: @1653
     /* 1653 */ GIM_Reject,
     /* 1654 */ // Label 11: @1654
     /* 1654 */ GIM_Try, /*On fail goto*//*Label 80*/ GIMT_Encode4(1716), // Rule ID 238 //
     /* 1659 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 1662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 1665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1669 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1673 */   // (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$src, sub_32:{ *:[i32] })
     /* 1673 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 1676 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 1680 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 1685 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 1687 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 1690 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 1692 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 1695 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 1697 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1700 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(BPF::GPRRegClassID),
     /* 1705 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(BPF::GPRRegClassID),
     /* 1710 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1715 */   // GIR_Coverage, 238,
     /* 1715 */   GIR_EraseRootFromParent_Done,
     /* 1716 */ // Label 80: @1716
     /* 1716 */ GIM_Reject,
     /* 1717 */ // Label 12: @1717
     /* 1717 */ GIM_Try, /*On fail goto*//*Label 81*/ GIMT_Encode4(1758), // Rule ID 237 //
     /* 1722 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 1725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 1728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1736 */   // (trunc:{ *:[i32] } GPR:{ *:[i64] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i32] } GPR:{ *:[i64] }:$src, sub_32:{ *:[i32] })
     /* 1736 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 1739 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 1741 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src
     /* 1747 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1752 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(BPF::GPRRegClassID),
     /* 1757 */   // GIR_Coverage, 237,
     /* 1757 */   GIR_EraseRootFromParent_Done,
     /* 1758 */ // Label 81: @1758
     /* 1758 */ GIM_Reject,
     /* 1759 */ // Label 13: @1759
     /* 1759 */ GIM_Try, /*On fail goto*//*Label 82*/ GIMT_Encode4(1781), // Rule ID 98 //
     /* 1764 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 1767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1771 */   // MIs[0] Operand 1
     /* 1771 */   // No operand predicates
     /* 1771 */   // (imm:{ *:[i64] }):$imm  =>  (LD_imm64:{ *:[i64] } (imm:{ *:[i64] }):$imm)
     /* 1771 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::LD_imm64),
     /* 1774 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 1776 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 1779 */   GIR_RootConstrainSelectedInstOperands,
     /* 1780 */   // GIR_Coverage, 98,
     /* 1780 */   GIR_EraseRootFromParent_Done,
     /* 1781 */ // Label 82: @1781
     /* 1781 */ GIM_Reject,
     /* 1782 */ // Label 14: @1782
     /* 1782 */ GIM_Try, /*On fail goto*//*Label 83*/ GIMT_Encode4(1897),
     /* 1787 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 1790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 1793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1797 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1801 */   GIM_Try, /*On fail goto*//*Label 84*/ GIMT_Encode4(1860), // Rule ID 234 //
     /* 1806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFNoMovsx),
     /* 1809 */     // (sext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (SRA_ri:{ *:[i64] } (SLL_ri:{ *:[i64] } (MOV_32_64:{ *:[i64] } GPR32:{ *:[i32] }:$src), 32:{ *:[i64] }), 32:{ *:[i64] })
     /* 1809 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 1812 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(BPF::MOV_32_64),
     /* 1816 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 1821 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 1825 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 1827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 1830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(BPF::SLL_ri),
     /* 1834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 1839 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 1842 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 1845 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 1847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::SRA_ri),
     /* 1850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 1852 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 1855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/32,
     /* 1858 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859 */     // GIR_Coverage, 234,
     /* 1859 */     GIR_EraseRootFromParent_Done,
     /* 1860 */   // Label 84: @1860
     /* 1860 */   GIM_Try, /*On fail goto*//*Label 85*/ GIMT_Encode4(1896), // Rule ID 235 //
     /* 1865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFHasMovsx),
     /* 1868 */     // (sext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (MOVSX_rr_32:{ *:[i64] } (MOV_32_64:{ *:[i64] } GPR32:{ *:[i32] }:$src))
     /* 1868 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 1871 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(BPF::MOV_32_64),
     /* 1875 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 1880 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 1884 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 1886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::MOVSX_rr_32),
     /* 1889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 1891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 1894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895 */     // GIR_Coverage, 235,
     /* 1895 */     GIR_EraseRootFromParent_Done,
     /* 1896 */   // Label 85: @1896
     /* 1896 */   GIM_Reject,
     /* 1897 */ // Label 83: @1897
     /* 1897 */ GIM_Reject,
     /* 1898 */ // Label 15: @1898
     /* 1898 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 88*/ GIMT_Encode4(2093),
     /* 1909 */ /*GILLT_s32*//*Label 86*/ GIMT_Encode4(1917),
     /* 1913 */ /*GILLT_s64*//*Label 87*/ GIMT_Encode4(1991),
     /* 1917 */ // Label 86: @1917
     /* 1917 */ GIM_Try, /*On fail goto*//*Label 89*/ GIMT_Encode4(1990),
     /* 1922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 1925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1929 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1933 */   GIM_Try, /*On fail goto*//*Label 90*/ GIMT_Encode4(1961), // Rule ID 104 //
     /* 1938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFHasMovsx),
     /* 1941 */     // MIs[0] Operand 2
     /* 1941 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 1952 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i8:{ *:[Other] })  =>  (MOVSX_rr_32_8:{ *:[i32] } GPR32:{ *:[i32] }:$src)
     /* 1952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::MOVSX_rr_32_8),
     /* 1955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 1957 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 1959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960 */     // GIR_Coverage, 104,
     /* 1960 */     GIR_EraseRootFromParent_Done,
     /* 1961 */   // Label 90: @1961
     /* 1961 */   GIM_Try, /*On fail goto*//*Label 91*/ GIMT_Encode4(1989), // Rule ID 105 //
     /* 1966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFHasMovsx),
     /* 1969 */     // MIs[0] Operand 2
     /* 1969 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 1980 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i16:{ *:[Other] })  =>  (MOVSX_rr_32_16:{ *:[i32] } GPR32:{ *:[i32] }:$src)
     /* 1980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::MOVSX_rr_32_16),
     /* 1983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 1985 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 1987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988 */     // GIR_Coverage, 105,
     /* 1988 */     GIR_EraseRootFromParent_Done,
     /* 1989 */   // Label 91: @1989
     /* 1989 */   GIM_Reject,
     /* 1990 */ // Label 89: @1990
     /* 1990 */ GIM_Reject,
     /* 1991 */ // Label 87: @1991
     /* 1991 */ GIM_Try, /*On fail goto*//*Label 92*/ GIMT_Encode4(2092),
     /* 1996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 1999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 2003 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 2007 */   GIM_Try, /*On fail goto*//*Label 93*/ GIMT_Encode4(2035), // Rule ID 101 //
     /* 2012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFHasMovsx),
     /* 2015 */     // MIs[0] Operand 2
     /* 2015 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2026 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$src, i8:{ *:[Other] })  =>  (MOVSX_rr_8:{ *:[i64] } GPR:{ *:[i64] }:$src)
     /* 2026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::MOVSX_rr_8),
     /* 2029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2031 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 2033 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034 */     // GIR_Coverage, 101,
     /* 2034 */     GIR_EraseRootFromParent_Done,
     /* 2035 */   // Label 93: @2035
     /* 2035 */   GIM_Try, /*On fail goto*//*Label 94*/ GIMT_Encode4(2063), // Rule ID 102 //
     /* 2040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFHasMovsx),
     /* 2043 */     // MIs[0] Operand 2
     /* 2043 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2054 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$src, i16:{ *:[Other] })  =>  (MOVSX_rr_16:{ *:[i64] } GPR:{ *:[i64] }:$src)
     /* 2054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::MOVSX_rr_16),
     /* 2057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2059 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 2061 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062 */     // GIR_Coverage, 102,
     /* 2062 */     GIR_EraseRootFromParent_Done,
     /* 2063 */   // Label 94: @2063
     /* 2063 */   GIM_Try, /*On fail goto*//*Label 95*/ GIMT_Encode4(2091), // Rule ID 103 //
     /* 2068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFHasMovsx),
     /* 2071 */     // MIs[0] Operand 2
     /* 2071 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 2082 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$src, i32:{ *:[Other] })  =>  (MOVSX_rr_32:{ *:[i64] } GPR:{ *:[i64] }:$src)
     /* 2082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::MOVSX_rr_32),
     /* 2085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2087 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 2089 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090 */     // GIR_Coverage, 103,
     /* 2090 */     GIR_EraseRootFromParent_Done,
     /* 2091 */   // Label 95: @2091
     /* 2091 */   GIM_Reject,
     /* 2092 */ // Label 92: @2092
     /* 2092 */ GIM_Reject,
     /* 2093 */ // Label 88: @2093
     /* 2093 */ GIM_Reject,
     /* 2094 */ // Label 16: @2094
     /* 2094 */ GIM_Try, /*On fail goto*//*Label 96*/ GIMT_Encode4(2120), // Rule ID 236 //
     /* 2099 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 2109 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 2113 */   // (zext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (MOV_32_64:{ *:[i64] } GPR32:{ *:[i32] }:$src)
     /* 2113 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::MOV_32_64),
     /* 2118 */   GIR_RootConstrainSelectedInstOperands,
     /* 2119 */   // GIR_Coverage, 236,
     /* 2119 */   GIR_Done,
     /* 2120 */ // Label 96: @2120
     /* 2120 */ GIM_Reject,
     /* 2121 */ // Label 17: @2121
     /* 2121 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 99*/ GIMT_Encode4(2186),
     /* 2132 */ /*GILLT_s32*//*Label 97*/ GIMT_Encode4(2140),
     /* 2136 */ /*GILLT_s64*//*Label 98*/ GIMT_Encode4(2163),
     /* 2140 */ // Label 97: @2140
     /* 2140 */ GIM_Try, /*On fail goto*//*Label 100*/ GIMT_Encode4(2162), // Rule ID 62 //
     /* 2145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2148 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 2155 */   // (shl:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)  =>  (SLL_rr_32:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)
     /* 2155 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::SLL_rr_32),
     /* 2160 */   GIR_RootConstrainSelectedInstOperands,
     /* 2161 */   // GIR_Coverage, 62,
     /* 2161 */   GIR_Done,
     /* 2162 */ // Label 100: @2162
     /* 2162 */ GIM_Reject,
     /* 2163 */ // Label 98: @2163
     /* 2163 */ GIM_Try, /*On fail goto*//*Label 101*/ GIMT_Encode4(2185), // Rule ID 60 //
     /* 2168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2171 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 2178 */   // (shl:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)  =>  (SLL_rr:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)
     /* 2178 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::SLL_rr),
     /* 2183 */   GIR_RootConstrainSelectedInstOperands,
     /* 2184 */   // GIR_Coverage, 60,
     /* 2184 */   GIR_Done,
     /* 2185 */ // Label 101: @2185
     /* 2185 */ GIM_Reject,
     /* 2186 */ // Label 99: @2186
     /* 2186 */ GIM_Reject,
     /* 2187 */ // Label 18: @2187
     /* 2187 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 104*/ GIMT_Encode4(2510),
     /* 2198 */ /*GILLT_s32*//*Label 102*/ GIMT_Encode4(2206),
     /* 2202 */ /*GILLT_s64*//*Label 103*/ GIMT_Encode4(2229),
     /* 2206 */ // Label 102: @2206
     /* 2206 */ GIM_Try, /*On fail goto*//*Label 105*/ GIMT_Encode4(2228), // Rule ID 66 //
     /* 2211 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2214 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 2221 */   // (srl:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)  =>  (SRL_rr_32:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)
     /* 2221 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::SRL_rr_32),
     /* 2226 */   GIR_RootConstrainSelectedInstOperands,
     /* 2227 */   // GIR_Coverage, 66,
     /* 2227 */   GIR_Done,
     /* 2228 */ // Label 105: @2228
     /* 2228 */ GIM_Reject,
     /* 2229 */ // Label 103: @2229
     /* 2229 */ GIM_Try, /*On fail goto*//*Label 106*/ GIMT_Encode4(2509),
     /* 2234 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2237 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 2244 */   GIM_Try, /*On fail goto*//*Label 107*/ GIMT_Encode4(2286), // Rule ID 139 //
     /* 2249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFHasBswap),
     /* 2252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 2260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2264 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 2269 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 48,
     /* 2273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2275 */     // (srl:{ *:[i64] } (bswap:{ *:[i64] } GPR:{ *:[i64] }:$src), 48:{ *:[i64] })  =>  (BSWAP16:{ *:[i64] } GPR:{ *:[i64] }:$src)
     /* 2275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::BSWAP16),
     /* 2278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 2284 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285 */     // GIR_Coverage, 139,
     /* 2285 */     GIR_EraseRootFromParent_Done,
     /* 2286 */   // Label 107: @2286
     /* 2286 */   GIM_Try, /*On fail goto*//*Label 108*/ GIMT_Encode4(2328), // Rule ID 140 //
     /* 2291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFHasBswap),
     /* 2294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 2302 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2306 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 2311 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 32,
     /* 2315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2317 */     // (srl:{ *:[i64] } (bswap:{ *:[i64] } GPR:{ *:[i64] }:$src), 32:{ *:[i64] })  =>  (BSWAP32:{ *:[i64] } GPR:{ *:[i64] }:$src)
     /* 2317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::BSWAP32),
     /* 2320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 2326 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327 */     // GIR_Coverage, 140,
     /* 2327 */     GIR_EraseRootFromParent_Done,
     /* 2328 */   // Label 108: @2328
     /* 2328 */   GIM_Try, /*On fail goto*//*Label 109*/ GIMT_Encode4(2370), // Rule ID 142 //
     /* 2333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFIsLittleEndian),
     /* 2336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 2344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2348 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 2353 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 48,
     /* 2357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2359 */     // (srl:{ *:[i64] } (bswap:{ *:[i64] } GPR:{ *:[i64] }:$src), 48:{ *:[i64] })  =>  (BE16:{ *:[i64] } GPR:{ *:[i64] }:$src)
     /* 2359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::BE16),
     /* 2362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 2368 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369 */     // GIR_Coverage, 142,
     /* 2369 */     GIR_EraseRootFromParent_Done,
     /* 2370 */   // Label 109: @2370
     /* 2370 */   GIM_Try, /*On fail goto*//*Label 110*/ GIMT_Encode4(2412), // Rule ID 143 //
     /* 2375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFIsLittleEndian),
     /* 2378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 2386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2390 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 2395 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 32,
     /* 2399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2401 */     // (srl:{ *:[i64] } (bswap:{ *:[i64] } GPR:{ *:[i64] }:$src), 32:{ *:[i64] })  =>  (BE32:{ *:[i64] } GPR:{ *:[i64] }:$src)
     /* 2401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::BE32),
     /* 2404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 2410 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411 */     // GIR_Coverage, 143,
     /* 2411 */     GIR_EraseRootFromParent_Done,
     /* 2412 */   // Label 110: @2412
     /* 2412 */   GIM_Try, /*On fail goto*//*Label 111*/ GIMT_Encode4(2454), // Rule ID 145 //
     /* 2417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFIsBigEndian),
     /* 2420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 2428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2432 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 2437 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 48,
     /* 2441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2443 */     // (srl:{ *:[i64] } (bswap:{ *:[i64] } GPR:{ *:[i64] }:$src), 48:{ *:[i64] })  =>  (LE16:{ *:[i64] } GPR:{ *:[i64] }:$src)
     /* 2443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::LE16),
     /* 2446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 2452 */     GIR_RootConstrainSelectedInstOperands,
     /* 2453 */     // GIR_Coverage, 145,
     /* 2453 */     GIR_EraseRootFromParent_Done,
     /* 2454 */   // Label 111: @2454
     /* 2454 */   GIM_Try, /*On fail goto*//*Label 112*/ GIMT_Encode4(2496), // Rule ID 146 //
     /* 2459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFIsBigEndian),
     /* 2462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 2470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2474 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 2479 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 32,
     /* 2483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2485 */     // (srl:{ *:[i64] } (bswap:{ *:[i64] } GPR:{ *:[i64] }:$src), 32:{ *:[i64] })  =>  (LE32:{ *:[i64] } GPR:{ *:[i64] }:$src)
     /* 2485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::LE32),
     /* 2488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 2494 */     GIR_RootConstrainSelectedInstOperands,
     /* 2495 */     // GIR_Coverage, 146,
     /* 2495 */     GIR_EraseRootFromParent_Done,
     /* 2496 */   // Label 112: @2496
     /* 2496 */   GIM_Try, /*On fail goto*//*Label 113*/ GIMT_Encode4(2508), // Rule ID 64 //
     /* 2501 */     // (srl:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)  =>  (SRL_rr:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)
     /* 2501 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::SRL_rr),
     /* 2506 */     GIR_RootConstrainSelectedInstOperands,
     /* 2507 */     // GIR_Coverage, 64,
     /* 2507 */     GIR_Done,
     /* 2508 */   // Label 113: @2508
     /* 2508 */   GIM_Reject,
     /* 2509 */ // Label 106: @2509
     /* 2509 */ GIM_Reject,
     /* 2510 */ // Label 104: @2510
     /* 2510 */ GIM_Reject,
     /* 2511 */ // Label 19: @2511
     /* 2511 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 116*/ GIMT_Encode4(2576),
     /* 2522 */ /*GILLT_s32*//*Label 114*/ GIMT_Encode4(2530),
     /* 2526 */ /*GILLT_s64*//*Label 115*/ GIMT_Encode4(2553),
     /* 2530 */ // Label 114: @2530
     /* 2530 */ GIM_Try, /*On fail goto*//*Label 117*/ GIMT_Encode4(2552), // Rule ID 74 //
     /* 2535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2538 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 2545 */   // (sra:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)  =>  (SRA_rr_32:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)
     /* 2545 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::SRA_rr_32),
     /* 2550 */   GIR_RootConstrainSelectedInstOperands,
     /* 2551 */   // GIR_Coverage, 74,
     /* 2551 */   GIR_Done,
     /* 2552 */ // Label 117: @2552
     /* 2552 */ GIM_Reject,
     /* 2553 */ // Label 115: @2553
     /* 2553 */ GIM_Try, /*On fail goto*//*Label 118*/ GIMT_Encode4(2575), // Rule ID 72 //
     /* 2558 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2561 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 2568 */   // (sra:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)  =>  (SRA_rr:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)
     /* 2568 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::SRA_rr),
     /* 2573 */   GIR_RootConstrainSelectedInstOperands,
     /* 2574 */   // GIR_Coverage, 72,
     /* 2574 */   GIR_Done,
     /* 2575 */ // Label 118: @2575
     /* 2575 */ GIM_Reject,
     /* 2576 */ // Label 116: @2576
     /* 2576 */ GIM_Reject,
     /* 2577 */ // Label 20: @2577
     /* 2577 */ GIM_Try, /*On fail goto*//*Label 119*/ GIMT_Encode4(2592), // Rule ID 123 //
     /* 2582 */   // MIs[0] BrDst
     /* 2582 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 2585 */   // (br (bb:{ *:[Other] }):$BrDst)  =>  (JMP (bb:{ *:[Other] }):$BrDst)
     /* 2585 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::JMP),
     /* 2590 */   GIR_RootConstrainSelectedInstOperands,
     /* 2591 */   // GIR_Coverage, 123,
     /* 2591 */   GIR_Done,
     /* 2592 */ // Label 119: @2592
     /* 2592 */ GIM_Reject,
     /* 2593 */ // Label 21: @2593
     /* 2593 */ GIM_Try, /*On fail goto*//*Label 120*/ GIMT_Encode4(2658),
     /* 2598 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2601 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 2608 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 2612 */   GIM_Try, /*On fail goto*//*Label 121*/ GIMT_Encode4(2627), // Rule ID 141 //
     /* 2617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFHasBswap),
     /* 2620 */     // (bswap:{ *:[i64] } GPR:{ *:[i64] }:$src)  =>  (BSWAP64:{ *:[i64] } GPR:{ *:[i64] }:$src)
     /* 2620 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::BSWAP64),
     /* 2625 */     GIR_RootConstrainSelectedInstOperands,
     /* 2626 */     // GIR_Coverage, 141,
     /* 2626 */     GIR_Done,
     /* 2627 */   // Label 121: @2627
     /* 2627 */   GIM_Try, /*On fail goto*//*Label 122*/ GIMT_Encode4(2642), // Rule ID 144 //
     /* 2632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFIsLittleEndian),
     /* 2635 */     // (bswap:{ *:[i64] } GPR:{ *:[i64] }:$src)  =>  (BE64:{ *:[i64] } GPR:{ *:[i64] }:$src)
     /* 2635 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::BE64),
     /* 2640 */     GIR_RootConstrainSelectedInstOperands,
     /* 2641 */     // GIR_Coverage, 144,
     /* 2641 */     GIR_Done,
     /* 2642 */   // Label 122: @2642
     /* 2642 */   GIM_Try, /*On fail goto*//*Label 123*/ GIMT_Encode4(2657), // Rule ID 147 //
     /* 2647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFIsBigEndian),
     /* 2650 */     // (bswap:{ *:[i64] } GPR:{ *:[i64] }:$src)  =>  (LE64:{ *:[i64] } GPR:{ *:[i64] }:$src)
     /* 2650 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::LE64),
     /* 2655 */     GIR_RootConstrainSelectedInstOperands,
     /* 2656 */     // GIR_Coverage, 147,
     /* 2656 */     GIR_Done,
     /* 2657 */   // Label 123: @2657
     /* 2657 */   GIM_Reject,
     /* 2658 */ // Label 120: @2658
     /* 2658 */ GIM_Reject,
     /* 2659 */ // Label 22: @2659
     /* 2659 */ GIM_Reject,
     /* 2660 */ }; // Size: 2660 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const BPFSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const BPFSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
