/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* RISCVPostLegalizerCombinerImpl Combiner Match Table                        *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GICOMBINER_DEPS
#include "llvm/ADT/SparseBitVector.h"
namespace llvm {
extern cl::OptionCategory GICombinerOptionCategory;
} // end namespace llvm
#endif // ifdef GET_GICOMBINER_DEPS

#ifdef GET_GICOMBINER_TYPES
struct RISCVPostLegalizerCombinerImplRuleConfig {
  SparseBitVector<> DisabledRules;

  bool isRuleEnabled(unsigned RuleID) const;
  bool parseCommandLineOption();
  bool setRuleEnabled(StringRef RuleIdentifier);
  bool setRuleDisabled(StringRef RuleIdentifier);
};

static std::optional<uint64_t> getRuleIdxForIdentifier(StringRef RuleIdentifier) {
  uint64_t I;
  // getAtInteger(...) returns false on success
  bool Parsed = !RuleIdentifier.getAsInteger(0, I);
  if (Parsed)
    return I;

#ifndef NDEBUG
  switch (RuleIdentifier.size()) {
  default: break;
  case 10:	 // 3 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2p_to_p2i", 9) != 0)
        break;
      return 10;	 // "i2p_to_p2i"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2i_to_i2p", 9) != 0)
        break;
      return 9;	 // "p2i_to_i2p"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ub_to_add", 9) != 0)
        break;
      return 0;	 // "sub_to_add"
    }
    break;
  case 11:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "add_sub_reg", 11) != 0)
      break;
    return 15;	 // "add_sub_reg"
  case 13:	 // 2 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'l':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oad_and_mask", 12) != 0)
        break;
      return 2;	 // "load_and_mask"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_and", 12) != 0)
        break;
      return 3;	 // "redundant_and"
    }
    break;
  case 14:	 // 2 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_same_val", 13) != 0)
        break;
      return 6;	 // "binop_same_val"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "neg_fneg_fold", 13) != 0)
        break;
      return 12;	 // "fneg_fneg_fold"
    }
    break;
  case 15:	 // 2 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtending_loads", 14) != 0)
        break;
      return 1;	 // "extending_loads"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "elect_same_val", 14) != 0)
        break;
      return 4;	 // "select_same_val"
    }
    break;
  case 17:	 // 2 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nyext_trunc_fold", 16) != 0)
        break;
      return 11;	 // "anyext_trunc_fold"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "hift_immed_chain", 16) != 0)
        break;
      return 23;	 // "shift_immed_chain"
    }
    break;
  case 18:	 // 2 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_left_to_zero", 17) != 0)
        break;
      return 7;	 // "binop_left_to_zero"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ptrunc_fpext_fold", 17) != 0)
        break;
      return 20;	 // "fptrunc_fpext_fold"
    }
    break;
  case 19:	 // 3 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_right_to_zero", 18) != 0)
        break;
      return 8;	 // "binop_right_to_zero"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_zero", 18) != 0)
        break;
      return 5;	 // "right_identity_zero"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "implify_neg_minmax", 18) != 0)
        break;
      return 26;	 // "simplify_neg_minmax"
    }
    break;
  case 20:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "bitcast_bitcast_fold", 20) != 0)
      break;
    return 19;	 // "bitcast_bitcast_fold"
  case 21:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "right_identity_one_fp", 21) != 0)
      break;
    return 14;	 // "right_identity_one_fp"
  case 22:	 // 2 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_one_int", 21) != 0)
        break;
      return 13;	 // "right_identity_one_int"
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_buildvector_fold", 21) != 0)
        break;
      return 17;	 // "trunc_buildvector_fold"
    }
    break;
  case 25:	 // 2 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "uildvector_identity_fold", 24) != 0)
        break;
      return 16;	 // "buildvector_identity_fold"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_neg_one_fp", 24) != 0)
        break;
      return 22;	 // "right_identity_neg_one_fp"
    }
    break;
  case 26:	 // 2 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ommute_fp_constant_to_rhs", 25) != 0)
        break;
      return 25;	 // "commute_fp_constant_to_rhs"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_neg_zero_fp", 25) != 0)
        break;
      return 21;	 // "right_identity_neg_zero_fp"
    }
    break;
  case 27:	 // 2 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ommute_int_constant_to_rhs", 26) != 0)
        break;
      return 24;	 // "commute_int_constant_to_rhs"
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_lshr_buildvector_fold", 26) != 0)
        break;
      return 18;	 // "trunc_lshr_buildvector_fold"
    }
    break;
  }
#endif // ifndef NDEBUG

  return std::nullopt;
}
static std::optional<std::pair<uint64_t, uint64_t>> getRuleRangeForIdentifier(StringRef RuleIdentifier) {
  std::pair<StringRef, StringRef> RangePair = RuleIdentifier.split('-');
  if (!RangePair.second.empty()) {
    const auto First = getRuleIdxForIdentifier(RangePair.first);
    const auto Last = getRuleIdxForIdentifier(RangePair.second);
    if (!First || !Last)
      return std::nullopt;
    if (First >= Last)
      report_fatal_error("Beginning of range should be before end of range");
    return {{*First, *Last + 1}};
  }
  if (RangePair.first == "*") {
    return {{0, 27}};
  }
  const auto I = getRuleIdxForIdentifier(RangePair.first);
  if (!I)
    return std::nullopt;
  return {{*I, *I + 1}};
}

bool RISCVPostLegalizerCombinerImplRuleConfig::setRuleEnabled(StringRef RuleIdentifier) {
  auto MaybeRange = getRuleRangeForIdentifier(RuleIdentifier);
  if (!MaybeRange)
    return false;
  for (auto I = MaybeRange->first; I < MaybeRange->second; ++I)
    DisabledRules.reset(I);
  return true;
}

bool RISCVPostLegalizerCombinerImplRuleConfig::setRuleDisabled(StringRef RuleIdentifier) {
  auto MaybeRange = getRuleRangeForIdentifier(RuleIdentifier);
  if (!MaybeRange)
    return false;
  for (auto I = MaybeRange->first; I < MaybeRange->second; ++I)
    DisabledRules.set(I);
  return true;
}

static std::vector<std::string> RISCVPostLegalizerCombinerOption;
static cl::list<std::string> RISCVPostLegalizerCombinerDisableOption(
    "riscvpostlegalizercombiner-disable-rule",
    cl::desc("Disable one or more combiner rules temporarily in the RISCVPostLegalizerCombiner pass"),
    cl::CommaSeparated,
    cl::Hidden,
    cl::cat(GICombinerOptionCategory),
    cl::callback([](const std::string &Str) {
      RISCVPostLegalizerCombinerOption.push_back(Str);
    }));
static cl::list<std::string> RISCVPostLegalizerCombinerOnlyEnableOption(
    "riscvpostlegalizercombiner-only-enable-rule",
    cl::desc("Disable all rules in the RISCVPostLegalizerCombiner pass then re-enable the specified ones"),
    cl::Hidden,
    cl::cat(GICombinerOptionCategory),
    cl::callback([](const std::string &CommaSeparatedArg) {
      StringRef Str = CommaSeparatedArg;
      RISCVPostLegalizerCombinerOption.push_back("*");
      do {
        auto X = Str.split(",");
        RISCVPostLegalizerCombinerOption.push_back(("!" + X.first).str());
        Str = X.second;
      } while (!Str.empty());
    }));


bool RISCVPostLegalizerCombinerImplRuleConfig::isRuleEnabled(unsigned RuleID) const {
    return  !DisabledRules.test(RuleID);
}
bool RISCVPostLegalizerCombinerImplRuleConfig::parseCommandLineOption() {
  for (StringRef Identifier : RISCVPostLegalizerCombinerOption) {
    bool Enabled = Identifier.consume_front("!");
    if (Enabled && !setRuleEnabled(Identifier))
      return false;
    if (!Enabled && !setRuleDisabled(Identifier))
      return false;
  }
  return true;
}

#endif // ifdef GET_GICOMBINER_TYPES

#ifdef GET_GICOMBINER_TYPES
const unsigned MAX_SUBTARGET_PREDICATES = 0;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GICOMBINER_TYPES

#ifdef GET_GICOMBINER_CLASS_MEMBERS
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const RISCVSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const RISCVSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GICOMBINER_CLASS_MEMBERS
#ifdef GET_GICOMBINER_CLASS_MEMBERS
  mutable MatcherState State;
  typedef ComplexRendererFns(RISCVPostLegalizerCombinerImpl::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(RISCVPostLegalizerCombinerImpl::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static RISCVPostLegalizerCombinerImpl::ComplexMatcherMemFn ComplexPredicateFns[];
  static RISCVPostLegalizerCombinerImpl::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testMOPredicate_MO(unsigned PredicateID, const MachineOperand &MO, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GICOMBINER_CLASS_MEMBERS

#ifdef GET_GICOMBINER_IMPL
// LLT Objects.
enum {
  GILLT_s1,
};
const static size_t NumTypeObjects = 1;
const static LLT TypeObjects[] = {
  LLT::scalar(1),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
};

PredicateBitset RISCVPostLegalizerCombinerImpl::
computeAvailableModuleFeatures(const RISCVSubtarget *Subtarget) const {
  PredicateBitset Features{};
  return Features;
}

void RISCVPostLegalizerCombinerImpl::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const RISCVSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset RISCVPostLegalizerCombinerImpl::
computeAvailableFunctionFeatures(const RISCVSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
};
// See constructor for table contents

RISCVPostLegalizerCombinerImpl::ComplexMatcherMemFn
RISCVPostLegalizerCombinerImpl::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
};

enum {
  GICXXPred_MI_Predicate_GICombiner0 = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_GICombiner1,
  GICXXPred_MI_Predicate_GICombiner2,
};
bool RISCVPostLegalizerCombinerImpl::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_GICombiner0: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), 1.0);
  }
  case GICXXPred_MI_Predicate_GICombiner1: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), -0.0);
  }
  case GICXXPred_MI_Predicate_GICombiner2: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), -1.0);
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool RISCVPostLegalizerCombinerImpl::testMOPredicate_MO(unsigned PredicateID, const MachineOperand & MO, const MatcherState &State) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool RISCVPostLegalizerCombinerImpl::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool RISCVPostLegalizerCombinerImpl::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool RISCVPostLegalizerCombinerImpl::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
enum {
  GICXXPred_Simple_IsRule0Enabled = GICXXPred_Invalid + 1,
  GICXXPred_Simple_IsRule1Enabled,
  GICXXPred_Simple_IsRule2Enabled,
  GICXXPred_Simple_IsRule3Enabled,
  GICXXPred_Simple_IsRule4Enabled,
  GICXXPred_Simple_IsRule5Enabled,
  GICXXPred_Simple_IsRule6Enabled,
  GICXXPred_Simple_IsRule7Enabled,
  GICXXPred_Simple_IsRule8Enabled,
  GICXXPred_Simple_IsRule9Enabled,
  GICXXPred_Simple_IsRule10Enabled,
  GICXXPred_Simple_IsRule11Enabled,
  GICXXPred_Simple_IsRule12Enabled,
  GICXXPred_Simple_IsRule13Enabled,
  GICXXPred_Simple_IsRule14Enabled,
  GICXXPred_Simple_IsRule15Enabled,
  GICXXPred_Simple_IsRule16Enabled,
  GICXXPred_Simple_IsRule17Enabled,
  GICXXPred_Simple_IsRule18Enabled,
  GICXXPred_Simple_IsRule19Enabled,
  GICXXPred_Simple_IsRule20Enabled,
  GICXXPred_Simple_IsRule21Enabled,
  GICXXPred_Simple_IsRule22Enabled,
  GICXXPred_Simple_IsRule23Enabled,
  GICXXPred_Simple_IsRule24Enabled,
  GICXXPred_Simple_IsRule25Enabled,
  GICXXPred_Simple_IsRule26Enabled,
};

bool RISCVPostLegalizerCombinerImpl::testSimplePredicate(unsigned Predicate) const {
    return RuleConfig.isRuleEnabled(Predicate - GICXXPred_Invalid - 1);
}
// Custom renderers.
enum {
  GICR_Invalid,
};
RISCVPostLegalizerCombinerImpl::CustomRendererFn
RISCVPostLegalizerCombinerImpl::CustomRenderers[] = {
  nullptr, // GICR_Invalid
};

bool RISCVPostLegalizerCombinerImpl::tryCombineAll(MachineInstr &I) const {
  const TargetSubtargetInfo &ST = MF.getSubtarget();
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  B.setInstrAndDebugLoc(I);
  State.MIs.clear();
  State.MIs.push_back(&I);
  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), *ST.getInstrInfo(), MRI, *MRI.getTargetRegisterInfo(), *ST.getRegBankInfo(), AvailableFeatures, /*CoverageInfo*/ nullptr)) {
    return true;
  }

  return false;
}

enum {
  GICXXCustomAction_GICombiner0 = GICXXCustomAction_Invalid + 1,
  GICXXCustomAction_GICombiner1,
  GICXXCustomAction_GICombiner2,
  GICXXCustomAction_GICombiner3,
  GICXXCustomAction_GICombiner4,
  GICXXCustomAction_GICombiner5,
  GICXXCustomAction_GICombiner6,
  GICXXCustomAction_GICombiner7,
  GICXXCustomAction_GICombiner8,
  GICXXCustomAction_GICombiner9,
  GICXXCustomAction_GICombiner10,
  GICXXCustomAction_GICombiner11,
  GICXXCustomAction_GICombiner12,
  GICXXCustomAction_GICombiner13,
  GICXXCustomAction_GICombiner14,
  GICXXCustomAction_GICombiner15,
  GICXXCustomAction_GICombiner16,
};
bool RISCVPostLegalizerCombinerImpl::runCustomAction(unsigned ApplyID, const MatcherState &State, NewMIVector &OutMIs) const {
  Helper.getBuilder().setInstrAndDebugLoc(*State.MIs[0]);
  switch(ApplyID) {
  case GICXXCustomAction_GICombiner0:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineSubToAdd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner1:{
    PreferredTuple GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineExtendingLoads(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineExtendingLoads(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner2:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineLoadWithAndMask(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner3:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantAnd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner4:{
    // Match Patterns
    if(![&](){return Helper.matchSelectSameVal(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 2);
    return true;
  }
  case GICXXCustomAction_GICombiner5:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsZero(*State.MIs[0], 1);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 1);
    return true;
  }
  case GICXXCustomAction_GICombiner6:{
    Register GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineI2PToP2I(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineI2PToP2I(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner7:{
    Register GIMatchData_info;
    // Match Patterns
    if(![&](){GIMatchData_info = State.MIs[1]->getOperand(1).getReg(); return true;}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineP2IToI2P(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner8:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineAnyExtTrunc(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner9:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchBuildVectorIdentityFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner10:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncBuildVectorFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner11:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncLshrBuildVectorFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner12:{
    // Match Patterns
    if(![&](){return MRI.getType(State.MIs[1]->getOperand(1).getReg()) == MRI.getType(State.MIs[0]->getOperand(0).getReg());}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], State.MIs[1]->getOperand(1).getReg());
    return true;
  }
  case GICXXCustomAction_GICombiner13:{
    RegisterImmPair GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShiftImmedChain(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyShiftImmedChain(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner14:{
    // Match Patterns
    if(![&](){return Helper.matchCommuteConstantToRHS(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCommuteBinOpOperands(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner15:{
    // Match Patterns
    if(![&](){return Helper.matchCommuteFPConstantToRHS(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCommuteBinOpOperands(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner16:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSimplifyNegMinMax(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  }
  llvm_unreachable("Unknown Apply Action");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *RISCVPostLegalizerCombinerImpl::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*    0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(233), /*)*//*default:*//*Label 55*/ GIMT_Encode4(1950),
     /*   10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(730),
     /*   14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(833),
     /*   18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(889),
     /*   22 */ /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(947),
     /*   26 */ /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(959),
     /*   30 */ /*TargetOpcode::G_SREM*//*Label 5*/ GIMT_Encode4(971),
     /*   34 */ /*TargetOpcode::G_UREM*//*Label 6*/ GIMT_Encode4(983), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   46 */ /*TargetOpcode::G_AND*//*Label 7*/ GIMT_Encode4(995),
     /*   50 */ /*TargetOpcode::G_OR*//*Label 8*/ GIMT_Encode4(1053),
     /*   54 */ /*TargetOpcode::G_XOR*//*Label 9*/ GIMT_Encode4(1112), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  106 */ /*TargetOpcode::G_BUILD_VECTOR*//*Label 10*/ GIMT_Encode4(1147),
     /*  110 */ /*TargetOpcode::G_BUILD_VECTOR_TRUNC*//*Label 11*/ GIMT_Encode4(1159), GIMT_Encode4(0),
     /*  118 */ /*TargetOpcode::G_PTRTOINT*//*Label 12*/ GIMT_Encode4(1171),
     /*  122 */ /*TargetOpcode::G_INTTOPTR*//*Label 13*/ GIMT_Encode4(1193),
     /*  126 */ /*TargetOpcode::G_BITCAST*//*Label 14*/ GIMT_Encode4(1205), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  170 */ /*TargetOpcode::G_LOAD*//*Label 15*/ GIMT_Encode4(1227),
     /*  174 */ /*TargetOpcode::G_SEXTLOAD*//*Label 16*/ GIMT_Encode4(1239),
     /*  178 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 17*/ GIMT_Encode4(1251), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  330 */ /*TargetOpcode::G_ANYEXT*//*Label 18*/ GIMT_Encode4(1263),
     /*  334 */ /*TargetOpcode::G_TRUNC*//*Label 19*/ GIMT_Encode4(1275), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  378 */ /*TargetOpcode::G_SHL*//*Label 20*/ GIMT_Encode4(1298),
     /*  382 */ /*TargetOpcode::G_LSHR*//*Label 21*/ GIMT_Encode4(1344),
     /*  386 */ /*TargetOpcode::G_ASHR*//*Label 22*/ GIMT_Encode4(1390), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  398 */ /*TargetOpcode::G_ROTR*//*Label 23*/ GIMT_Encode4(1436),
     /*  402 */ /*TargetOpcode::G_ROTL*//*Label 24*/ GIMT_Encode4(1460), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  422 */ /*TargetOpcode::G_SELECT*//*Label 25*/ GIMT_Encode4(1484),
     /*  426 */ /*TargetOpcode::G_UADDO*//*Label 26*/ GIMT_Encode4(1496), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  442 */ /*TargetOpcode::G_SADDO*//*Label 27*/ GIMT_Encode4(1508), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  458 */ /*TargetOpcode::G_UMULO*//*Label 28*/ GIMT_Encode4(1520),
     /*  462 */ /*TargetOpcode::G_SMULO*//*Label 29*/ GIMT_Encode4(1532),
     /*  466 */ /*TargetOpcode::G_UMULH*//*Label 30*/ GIMT_Encode4(1544),
     /*  470 */ /*TargetOpcode::G_SMULH*//*Label 31*/ GIMT_Encode4(1556),
     /*  474 */ /*TargetOpcode::G_UADDSAT*//*Label 32*/ GIMT_Encode4(1568),
     /*  478 */ /*TargetOpcode::G_SADDSAT*//*Label 33*/ GIMT_Encode4(1580), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  490 */ /*TargetOpcode::G_USHLSAT*//*Label 34*/ GIMT_Encode4(1592),
     /*  494 */ /*TargetOpcode::G_SSHLSAT*//*Label 35*/ GIMT_Encode4(1604),
     /*  498 */ /*TargetOpcode::G_SMULFIX*//*Label 36*/ GIMT_Encode4(1616),
     /*  502 */ /*TargetOpcode::G_UMULFIX*//*Label 37*/ GIMT_Encode4(1628),
     /*  506 */ /*TargetOpcode::G_SMULFIXSAT*//*Label 38*/ GIMT_Encode4(1640),
     /*  510 */ /*TargetOpcode::G_UMULFIXSAT*//*Label 39*/ GIMT_Encode4(1652), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  530 */ /*TargetOpcode::G_FADD*//*Label 40*/ GIMT_Encode4(1664), GIMT_Encode4(0),
     /*  538 */ /*TargetOpcode::G_FMUL*//*Label 41*/ GIMT_Encode4(1699), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  598 */ /*TargetOpcode::G_FNEG*//*Label 42*/ GIMT_Encode4(1754), GIMT_Encode4(0),
     /*  606 */ /*TargetOpcode::G_FPTRUNC*//*Label 43*/ GIMT_Encode4(1784), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  650 */ /*TargetOpcode::G_FMINNUM*//*Label 44*/ GIMT_Encode4(1806),
     /*  654 */ /*TargetOpcode::G_FMAXNUM*//*Label 45*/ GIMT_Encode4(1818),
     /*  658 */ /*TargetOpcode::G_FMINNUM_IEEE*//*Label 46*/ GIMT_Encode4(1830),
     /*  662 */ /*TargetOpcode::G_FMAXNUM_IEEE*//*Label 47*/ GIMT_Encode4(1842),
     /*  666 */ /*TargetOpcode::G_FMINIMUM*//*Label 48*/ GIMT_Encode4(1854),
     /*  670 */ /*TargetOpcode::G_FMAXIMUM*//*Label 49*/ GIMT_Encode4(1866), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  706 */ /*TargetOpcode::G_PTR_ADD*//*Label 50*/ GIMT_Encode4(1878), GIMT_Encode4(0),
     /*  714 */ /*TargetOpcode::G_SMIN*//*Label 51*/ GIMT_Encode4(1902),
     /*  718 */ /*TargetOpcode::G_SMAX*//*Label 52*/ GIMT_Encode4(1914),
     /*  722 */ /*TargetOpcode::G_UMIN*//*Label 53*/ GIMT_Encode4(1926),
     /*  726 */ /*TargetOpcode::G_UMAX*//*Label 54*/ GIMT_Encode4(1938),
     /*  730 */ // Label 0: @730
     /*  730 */ GIM_Try, /*On fail goto*//*Label 56*/ GIMT_Encode4(741), // Rule ID 48 //
     /*  735 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /*  738 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_ADD'
     /*  738 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /*  741 */ // Label 56: @741
     /*  741 */ GIM_Try, /*On fail goto*//*Label 57*/ GIMT_Encode4(775), // Rule ID 34 //
     /*  746 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule15Enabled),
     /*  749 */   // MIs[0] dst
     /*  749 */   // No operand predicates
     /*  749 */   // MIs[0] __add_sub_reg_match_0.tmp
     /*  749 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  753 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  757 */   // MIs[1] src
     /*  757 */   // No operand predicates
     /*  757 */   // MIs[1] __add_sub_reg_match_0.x
     /*  757 */   // No operand predicates
     /*  757 */   // MIs[0] __add_sub_reg_match_0.x
     /*  757 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  762 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /*  767 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  769 */   // Combiner Rule #15: add_sub_reg @ [__add_sub_reg_match_0[1]]
     /*  769 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /*  774 */   GIR_EraseRootFromParent_Done,
     /*  775 */ // Label 57: @775
     /*  775 */ GIM_Try, /*On fail goto*//*Label 58*/ GIMT_Encode4(809), // Rule ID 33 //
     /*  780 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule15Enabled),
     /*  783 */   // MIs[0] dst
     /*  783 */   // No operand predicates
     /*  783 */   // MIs[0] __add_sub_reg_match_0.x
     /*  783 */   // No operand predicates
     /*  783 */   // MIs[0] __add_sub_reg_match_0.tmp
     /*  783 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  787 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  791 */   // MIs[1] src
     /*  791 */   // No operand predicates
     /*  791 */   // MIs[1] __add_sub_reg_match_0.x
     /*  791 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  796 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /*  801 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  803 */   // Combiner Rule #15: add_sub_reg @ [__add_sub_reg_match_0[0]]
     /*  803 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /*  808 */   GIR_EraseRootFromParent_Done,
     /*  809 */ // Label 58: @809
     /*  809 */ GIM_Try, /*On fail goto*//*Label 59*/ GIMT_Encode4(832), // Rule ID 8 //
     /*  814 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /*  817 */   // MIs[0] dst
     /*  817 */   // No operand predicates
     /*  817 */   // MIs[0] lhs
     /*  817 */   // No operand predicates
     /*  817 */   // MIs[0] Operand 2
     /*  817 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  821 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /*  826 */   // Combiner Rule #5: right_identity_zero @ [__right_identity_zero_match_0[1]]
     /*  826 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /*  831 */   GIR_EraseRootFromParent_Done,
     /*  832 */ // Label 59: @832
     /*  832 */ GIM_Reject,
     /*  833 */ // Label 1: @833
     /*  833 */ GIM_Try, /*On fail goto*//*Label 60*/ GIMT_Encode4(844), // Rule ID 77 //
     /*  838 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule26Enabled),
     /*  841 */   // Combiner Rule #26: simplify_neg_minmax; wip_match_opcode 'G_SUB'
     /*  841 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner16),
     /*  844 */ // Label 60: @844
     /*  844 */ GIM_Try, /*On fail goto*//*Label 61*/ GIMT_Encode4(867), // Rule ID 7 //
     /*  849 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /*  852 */   // MIs[0] dst
     /*  852 */   // No operand predicates
     /*  852 */   // MIs[0] lhs
     /*  852 */   // No operand predicates
     /*  852 */   // MIs[0] Operand 2
     /*  852 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  856 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /*  861 */   // Combiner Rule #5: right_identity_zero @ [__right_identity_zero_match_0[0]]
     /*  861 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /*  866 */   GIR_EraseRootFromParent_Done,
     /*  867 */ // Label 61: @867
     /*  867 */ GIM_Try, /*On fail goto*//*Label 62*/ GIMT_Encode4(888), // Rule ID 0 //
     /*  872 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule0Enabled),
     /*  875 */   // MIs[0] d
     /*  875 */   // No operand predicates
     /*  875 */   // MIs[0] op1
     /*  875 */   // No operand predicates
     /*  875 */   // MIs[0] c
     /*  875 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  879 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  883 */   // MIs[1] imm
     /*  883 */   // No operand predicates
     /*  883 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  885 */   // Combiner Rule #0: sub_to_add
     /*  885 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner0),
     /*  888 */ // Label 62: @888
     /*  888 */ GIM_Reject,
     /*  889 */ // Label 2: @889
     /*  889 */ GIM_Try, /*On fail goto*//*Label 63*/ GIMT_Encode4(900), // Rule ID 49 //
     /*  894 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /*  897 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_MUL'
     /*  897 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /*  900 */ // Label 63: @900
     /*  900 */ GIM_Try, /*On fail goto*//*Label 64*/ GIMT_Encode4(923), // Rule ID 26 //
     /*  905 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule8Enabled),
     /*  908 */   // MIs[0] dst
     /*  908 */   // No operand predicates
     /*  908 */   // MIs[0] lhs
     /*  908 */   // No operand predicates
     /*  908 */   // MIs[0] zero
     /*  908 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  912 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/2,
     /*  917 */   // Combiner Rule #8: binop_right_to_zero
     /*  917 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/2,
     /*  922 */   GIR_EraseRootFromParent_Done,
     /*  923 */ // Label 64: @923
     /*  923 */ GIM_Try, /*On fail goto*//*Label 65*/ GIMT_Encode4(946), // Rule ID 31 //
     /*  928 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule13Enabled),
     /*  931 */   // MIs[0] dst
     /*  931 */   // No operand predicates
     /*  931 */   // MIs[0] x
     /*  931 */   // No operand predicates
     /*  931 */   // MIs[0] Operand 2
     /*  931 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  935 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /*  940 */   // Combiner Rule #13: right_identity_one_int
     /*  940 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /*  945 */   GIR_EraseRootFromParent_Done,
     /*  946 */ // Label 65: @946
     /*  946 */ GIM_Reject,
     /*  947 */ // Label 3: @947
     /*  947 */ GIM_Try, /*On fail goto*//*Label 66*/ GIMT_Encode4(958), // Rule ID 22 //
     /*  952 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule7Enabled),
     /*  955 */   // Combiner Rule #7: binop_left_to_zero; wip_match_opcode 'G_SDIV'
     /*  955 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner5),
     /*  958 */ // Label 66: @958
     /*  958 */ GIM_Reject,
     /*  959 */ // Label 4: @959
     /*  959 */ GIM_Try, /*On fail goto*//*Label 67*/ GIMT_Encode4(970), // Rule ID 23 //
     /*  964 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule7Enabled),
     /*  967 */   // Combiner Rule #7: binop_left_to_zero; wip_match_opcode 'G_UDIV'
     /*  967 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner5),
     /*  970 */ // Label 67: @970
     /*  970 */ GIM_Reject,
     /*  971 */ // Label 5: @971
     /*  971 */ GIM_Try, /*On fail goto*//*Label 68*/ GIMT_Encode4(982), // Rule ID 24 //
     /*  976 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule7Enabled),
     /*  979 */   // Combiner Rule #7: binop_left_to_zero; wip_match_opcode 'G_SREM'
     /*  979 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner5),
     /*  982 */ // Label 68: @982
     /*  982 */ GIM_Reject,
     /*  983 */ // Label 6: @983
     /*  983 */ GIM_Try, /*On fail goto*//*Label 69*/ GIMT_Encode4(994), // Rule ID 25 //
     /*  988 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule7Enabled),
     /*  991 */   // Combiner Rule #7: binop_left_to_zero; wip_match_opcode 'G_UREM'
     /*  991 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner5),
     /*  994 */ // Label 69: @994
     /*  994 */ GIM_Reject,
     /*  995 */ // Label 7: @995
     /*  995 */ GIM_Try, /*On fail goto*//*Label 70*/ GIMT_Encode4(1006), // Rule ID 4 //
     /* 1000 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule2Enabled),
     /* 1003 */   // Combiner Rule #2: load_and_mask; wip_match_opcode 'G_AND'
     /* 1003 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner2),
     /* 1006 */ // Label 70: @1006
     /* 1006 */ GIM_Try, /*On fail goto*//*Label 71*/ GIMT_Encode4(1017), // Rule ID 5 //
     /* 1011 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule3Enabled),
     /* 1014 */   // Combiner Rule #3: redundant_and; wip_match_opcode 'G_AND'
     /* 1014 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner3),
     /* 1017 */ // Label 71: @1017
     /* 1017 */ GIM_Try, /*On fail goto*//*Label 72*/ GIMT_Encode4(1028), // Rule ID 50 //
     /* 1022 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1025 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_AND'
     /* 1025 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1028 */ // Label 72: @1028
     /* 1028 */ GIM_Try, /*On fail goto*//*Label 73*/ GIMT_Encode4(1052), // Rule ID 17 //
     /* 1033 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule6Enabled),
     /* 1036 */   // MIs[0] dst
     /* 1036 */   // No operand predicates
     /* 1036 */   // MIs[0] src
     /* 1036 */   // No operand predicates
     /* 1036 */   // MIs[0] src
     /* 1036 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1041 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1046 */   // Combiner Rule #6: binop_same_val @ [__binop_same_val_match_0[0]]
     /* 1046 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1051 */   GIR_EraseRootFromParent_Done,
     /* 1052 */ // Label 73: @1052
     /* 1052 */ GIM_Reject,
     /* 1053 */ // Label 8: @1053
     /* 1053 */ GIM_Try, /*On fail goto*//*Label 74*/ GIMT_Encode4(1064), // Rule ID 51 //
     /* 1058 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1061 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_OR'
     /* 1061 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1064 */ // Label 74: @1064
     /* 1064 */ GIM_Try, /*On fail goto*//*Label 75*/ GIMT_Encode4(1088), // Rule ID 18 //
     /* 1069 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule6Enabled),
     /* 1072 */   // MIs[0] dst
     /* 1072 */   // No operand predicates
     /* 1072 */   // MIs[0] src
     /* 1072 */   // No operand predicates
     /* 1072 */   // MIs[0] src
     /* 1072 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1077 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1082 */   // Combiner Rule #6: binop_same_val @ [__binop_same_val_match_0[1]]
     /* 1082 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1087 */   GIR_EraseRootFromParent_Done,
     /* 1088 */ // Label 75: @1088
     /* 1088 */ GIM_Try, /*On fail goto*//*Label 76*/ GIMT_Encode4(1111), // Rule ID 9 //
     /* 1093 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /* 1096 */   // MIs[0] dst
     /* 1096 */   // No operand predicates
     /* 1096 */   // MIs[0] lhs
     /* 1096 */   // No operand predicates
     /* 1096 */   // MIs[0] Operand 2
     /* 1096 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1100 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1105 */   // Combiner Rule #5: right_identity_zero @ [__right_identity_zero_match_0[2]]
     /* 1105 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1110 */   GIR_EraseRootFromParent_Done,
     /* 1111 */ // Label 76: @1111
     /* 1111 */ GIM_Reject,
     /* 1112 */ // Label 9: @1112
     /* 1112 */ GIM_Try, /*On fail goto*//*Label 77*/ GIMT_Encode4(1123), // Rule ID 52 //
     /* 1117 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1120 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_XOR'
     /* 1120 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1123 */ // Label 77: @1123
     /* 1123 */ GIM_Try, /*On fail goto*//*Label 78*/ GIMT_Encode4(1146), // Rule ID 10 //
     /* 1128 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /* 1131 */   // MIs[0] dst
     /* 1131 */   // No operand predicates
     /* 1131 */   // MIs[0] lhs
     /* 1131 */   // No operand predicates
     /* 1131 */   // MIs[0] Operand 2
     /* 1131 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1135 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1140 */   // Combiner Rule #5: right_identity_zero @ [__right_identity_zero_match_0[3]]
     /* 1140 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1145 */   GIR_EraseRootFromParent_Done,
     /* 1146 */ // Label 78: @1146
     /* 1146 */ GIM_Reject,
     /* 1147 */ // Label 10: @1147
     /* 1147 */ GIM_Try, /*On fail goto*//*Label 79*/ GIMT_Encode4(1158), // Rule ID 36 //
     /* 1152 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule16Enabled),
     /* 1155 */   // Combiner Rule #16: buildvector_identity_fold; wip_match_opcode 'G_BUILD_VECTOR'
     /* 1155 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner9),
     /* 1158 */ // Label 79: @1158
     /* 1158 */ GIM_Reject,
     /* 1159 */ // Label 11: @1159
     /* 1159 */ GIM_Try, /*On fail goto*//*Label 80*/ GIMT_Encode4(1170), // Rule ID 35 //
     /* 1164 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule16Enabled),
     /* 1167 */   // Combiner Rule #16: buildvector_identity_fold; wip_match_opcode 'G_BUILD_VECTOR_TRUNC'
     /* 1167 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner9),
     /* 1170 */ // Label 80: @1170
     /* 1170 */ GIM_Reject,
     /* 1171 */ // Label 12: @1171
     /* 1171 */ GIM_Try, /*On fail goto*//*Label 81*/ GIMT_Encode4(1192), // Rule ID 28 //
     /* 1176 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule10Enabled),
     /* 1179 */   // MIs[0] dst
     /* 1179 */   // No operand predicates
     /* 1179 */   // MIs[0] t
     /* 1179 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1183 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTTOPTR),
     /* 1187 */   // MIs[1] ptr
     /* 1187 */   // No operand predicates
     /* 1187 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1189 */   // Combiner Rule #10: i2p_to_p2i
     /* 1189 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner7),
     /* 1192 */ // Label 81: @1192
     /* 1192 */ GIM_Reject,
     /* 1193 */ // Label 13: @1193
     /* 1193 */ GIM_Try, /*On fail goto*//*Label 82*/ GIMT_Encode4(1204), // Rule ID 27 //
     /* 1198 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule9Enabled),
     /* 1201 */   // Combiner Rule #9: p2i_to_i2p; wip_match_opcode 'G_INTTOPTR'
     /* 1201 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner6),
     /* 1204 */ // Label 82: @1204
     /* 1204 */ GIM_Reject,
     /* 1205 */ // Label 14: @1205
     /* 1205 */ GIM_Try, /*On fail goto*//*Label 83*/ GIMT_Encode4(1226), // Rule ID 39 //
     /* 1210 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule19Enabled),
     /* 1213 */   // MIs[0] dst
     /* 1213 */   // No operand predicates
     /* 1213 */   // MIs[0] src1
     /* 1213 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1217 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 1221 */   // MIs[1] src0
     /* 1221 */   // No operand predicates
     /* 1221 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1223 */   // Combiner Rule #19: bitcast_bitcast_fold
     /* 1223 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner12),
     /* 1226 */ // Label 83: @1226
     /* 1226 */ GIM_Reject,
     /* 1227 */ // Label 15: @1227
     /* 1227 */ GIM_Try, /*On fail goto*//*Label 84*/ GIMT_Encode4(1238), // Rule ID 1 //
     /* 1232 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule1Enabled),
     /* 1235 */   // Combiner Rule #1: extending_loads; wip_match_opcode 'G_LOAD'
     /* 1235 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner1),
     /* 1238 */ // Label 84: @1238
     /* 1238 */ GIM_Reject,
     /* 1239 */ // Label 16: @1239
     /* 1239 */ GIM_Try, /*On fail goto*//*Label 85*/ GIMT_Encode4(1250), // Rule ID 2 //
     /* 1244 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule1Enabled),
     /* 1247 */   // Combiner Rule #1: extending_loads; wip_match_opcode 'G_SEXTLOAD'
     /* 1247 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner1),
     /* 1250 */ // Label 85: @1250
     /* 1250 */ GIM_Reject,
     /* 1251 */ // Label 17: @1251
     /* 1251 */ GIM_Try, /*On fail goto*//*Label 86*/ GIMT_Encode4(1262), // Rule ID 3 //
     /* 1256 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule1Enabled),
     /* 1259 */   // Combiner Rule #1: extending_loads; wip_match_opcode 'G_ZEXTLOAD'
     /* 1259 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner1),
     /* 1262 */ // Label 86: @1262
     /* 1262 */ GIM_Reject,
     /* 1263 */ // Label 18: @1263
     /* 1263 */ GIM_Try, /*On fail goto*//*Label 87*/ GIMT_Encode4(1274), // Rule ID 29 //
     /* 1268 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule11Enabled),
     /* 1271 */   // Combiner Rule #11: anyext_trunc_fold; wip_match_opcode 'G_ANYEXT'
     /* 1271 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner8),
     /* 1274 */ // Label 87: @1274
     /* 1274 */ GIM_Reject,
     /* 1275 */ // Label 19: @1275
     /* 1275 */ GIM_Try, /*On fail goto*//*Label 88*/ GIMT_Encode4(1286), // Rule ID 37 //
     /* 1280 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule17Enabled),
     /* 1283 */   // Combiner Rule #17: trunc_buildvector_fold; wip_match_opcode 'G_TRUNC'
     /* 1283 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner10),
     /* 1286 */ // Label 88: @1286
     /* 1286 */ GIM_Try, /*On fail goto*//*Label 89*/ GIMT_Encode4(1297), // Rule ID 38 //
     /* 1291 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule18Enabled),
     /* 1294 */   // Combiner Rule #18: trunc_lshr_buildvector_fold; wip_match_opcode 'G_TRUNC'
     /* 1294 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner11),
     /* 1297 */ // Label 89: @1297
     /* 1297 */ GIM_Reject,
     /* 1298 */ // Label 20: @1298
     /* 1298 */ GIM_Try, /*On fail goto*//*Label 90*/ GIMT_Encode4(1309), // Rule ID 19 //
     /* 1303 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule7Enabled),
     /* 1306 */   // Combiner Rule #7: binop_left_to_zero; wip_match_opcode 'G_SHL'
     /* 1306 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner5),
     /* 1309 */ // Label 90: @1309
     /* 1309 */ GIM_Try, /*On fail goto*//*Label 91*/ GIMT_Encode4(1320), // Rule ID 43 //
     /* 1314 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule23Enabled),
     /* 1317 */   // Combiner Rule #23: shift_immed_chain; wip_match_opcode 'G_SHL'
     /* 1317 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 1320 */ // Label 91: @1320
     /* 1320 */ GIM_Try, /*On fail goto*//*Label 92*/ GIMT_Encode4(1343), // Rule ID 11 //
     /* 1325 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /* 1328 */   // MIs[0] dst
     /* 1328 */   // No operand predicates
     /* 1328 */   // MIs[0] lhs
     /* 1328 */   // No operand predicates
     /* 1328 */   // MIs[0] Operand 2
     /* 1328 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1332 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1337 */   // Combiner Rule #5: right_identity_zero @ [__right_identity_zero_match_0[4]]
     /* 1337 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1342 */   GIR_EraseRootFromParent_Done,
     /* 1343 */ // Label 92: @1343
     /* 1343 */ GIM_Reject,
     /* 1344 */ // Label 21: @1344
     /* 1344 */ GIM_Try, /*On fail goto*//*Label 93*/ GIMT_Encode4(1355), // Rule ID 20 //
     /* 1349 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule7Enabled),
     /* 1352 */   // Combiner Rule #7: binop_left_to_zero; wip_match_opcode 'G_LSHR'
     /* 1352 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner5),
     /* 1355 */ // Label 93: @1355
     /* 1355 */ GIM_Try, /*On fail goto*//*Label 94*/ GIMT_Encode4(1366), // Rule ID 45 //
     /* 1360 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule23Enabled),
     /* 1363 */   // Combiner Rule #23: shift_immed_chain; wip_match_opcode 'G_LSHR'
     /* 1363 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 1366 */ // Label 94: @1366
     /* 1366 */ GIM_Try, /*On fail goto*//*Label 95*/ GIMT_Encode4(1389), // Rule ID 13 //
     /* 1371 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /* 1374 */   // MIs[0] dst
     /* 1374 */   // No operand predicates
     /* 1374 */   // MIs[0] lhs
     /* 1374 */   // No operand predicates
     /* 1374 */   // MIs[0] Operand 2
     /* 1374 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1378 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1383 */   // Combiner Rule #5: right_identity_zero @ [__right_identity_zero_match_0[6]]
     /* 1383 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1388 */   GIR_EraseRootFromParent_Done,
     /* 1389 */ // Label 95: @1389
     /* 1389 */ GIM_Reject,
     /* 1390 */ // Label 22: @1390
     /* 1390 */ GIM_Try, /*On fail goto*//*Label 96*/ GIMT_Encode4(1401), // Rule ID 21 //
     /* 1395 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule7Enabled),
     /* 1398 */   // Combiner Rule #7: binop_left_to_zero; wip_match_opcode 'G_ASHR'
     /* 1398 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner5),
     /* 1401 */ // Label 96: @1401
     /* 1401 */ GIM_Try, /*On fail goto*//*Label 97*/ GIMT_Encode4(1412), // Rule ID 44 //
     /* 1406 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule23Enabled),
     /* 1409 */   // Combiner Rule #23: shift_immed_chain; wip_match_opcode 'G_ASHR'
     /* 1409 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 1412 */ // Label 97: @1412
     /* 1412 */ GIM_Try, /*On fail goto*//*Label 98*/ GIMT_Encode4(1435), // Rule ID 12 //
     /* 1417 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /* 1420 */   // MIs[0] dst
     /* 1420 */   // No operand predicates
     /* 1420 */   // MIs[0] lhs
     /* 1420 */   // No operand predicates
     /* 1420 */   // MIs[0] Operand 2
     /* 1420 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1424 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1429 */   // Combiner Rule #5: right_identity_zero @ [__right_identity_zero_match_0[5]]
     /* 1429 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1434 */   GIR_EraseRootFromParent_Done,
     /* 1435 */ // Label 98: @1435
     /* 1435 */ GIM_Reject,
     /* 1436 */ // Label 23: @1436
     /* 1436 */ GIM_Try, /*On fail goto*//*Label 99*/ GIMT_Encode4(1459), // Rule ID 16 //
     /* 1441 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /* 1444 */   // MIs[0] dst
     /* 1444 */   // No operand predicates
     /* 1444 */   // MIs[0] lhs
     /* 1444 */   // No operand predicates
     /* 1444 */   // MIs[0] Operand 2
     /* 1444 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1448 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1453 */   // Combiner Rule #5: right_identity_zero @ [__right_identity_zero_match_0[9]]
     /* 1453 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1458 */   GIR_EraseRootFromParent_Done,
     /* 1459 */ // Label 99: @1459
     /* 1459 */ GIM_Reject,
     /* 1460 */ // Label 24: @1460
     /* 1460 */ GIM_Try, /*On fail goto*//*Label 100*/ GIMT_Encode4(1483), // Rule ID 15 //
     /* 1465 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /* 1468 */   // MIs[0] dst
     /* 1468 */   // No operand predicates
     /* 1468 */   // MIs[0] lhs
     /* 1468 */   // No operand predicates
     /* 1468 */   // MIs[0] Operand 2
     /* 1468 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1472 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1477 */   // Combiner Rule #5: right_identity_zero @ [__right_identity_zero_match_0[8]]
     /* 1477 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1482 */   GIR_EraseRootFromParent_Done,
     /* 1483 */ // Label 100: @1483
     /* 1483 */ GIM_Reject,
     /* 1484 */ // Label 25: @1484
     /* 1484 */ GIM_Try, /*On fail goto*//*Label 101*/ GIMT_Encode4(1495), // Rule ID 6 //
     /* 1489 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule4Enabled),
     /* 1492 */   // Combiner Rule #4: select_same_val; wip_match_opcode 'G_SELECT'
     /* 1492 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner4),
     /* 1495 */ // Label 101: @1495
     /* 1495 */ GIM_Reject,
     /* 1496 */ // Label 26: @1496
     /* 1496 */ GIM_Try, /*On fail goto*//*Label 102*/ GIMT_Encode4(1507), // Rule ID 57 //
     /* 1501 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1504 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_UADDO'
     /* 1504 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1507 */ // Label 102: @1507
     /* 1507 */ GIM_Reject,
     /* 1508 */ // Label 27: @1508
     /* 1508 */ GIM_Try, /*On fail goto*//*Label 103*/ GIMT_Encode4(1519), // Rule ID 58 //
     /* 1513 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1516 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_SADDO'
     /* 1516 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1519 */ // Label 103: @1519
     /* 1519 */ GIM_Reject,
     /* 1520 */ // Label 28: @1520
     /* 1520 */ GIM_Try, /*On fail goto*//*Label 104*/ GIMT_Encode4(1531), // Rule ID 59 //
     /* 1525 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1528 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULO'
     /* 1528 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1531 */ // Label 104: @1531
     /* 1531 */ GIM_Reject,
     /* 1532 */ // Label 29: @1532
     /* 1532 */ GIM_Try, /*On fail goto*//*Label 105*/ GIMT_Encode4(1543), // Rule ID 60 //
     /* 1537 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1540 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULO'
     /* 1540 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1543 */ // Label 105: @1543
     /* 1543 */ GIM_Reject,
     /* 1544 */ // Label 30: @1544
     /* 1544 */ GIM_Try, /*On fail goto*//*Label 106*/ GIMT_Encode4(1555), // Rule ID 61 //
     /* 1549 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1552 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULH'
     /* 1552 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1555 */ // Label 106: @1555
     /* 1555 */ GIM_Reject,
     /* 1556 */ // Label 31: @1556
     /* 1556 */ GIM_Try, /*On fail goto*//*Label 107*/ GIMT_Encode4(1567), // Rule ID 62 //
     /* 1561 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1564 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULH'
     /* 1564 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1567 */ // Label 107: @1567
     /* 1567 */ GIM_Reject,
     /* 1568 */ // Label 32: @1568
     /* 1568 */ GIM_Try, /*On fail goto*//*Label 108*/ GIMT_Encode4(1579), // Rule ID 63 //
     /* 1573 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1576 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_UADDSAT'
     /* 1576 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1579 */ // Label 108: @1579
     /* 1579 */ GIM_Reject,
     /* 1580 */ // Label 33: @1580
     /* 1580 */ GIM_Try, /*On fail goto*//*Label 109*/ GIMT_Encode4(1591), // Rule ID 64 //
     /* 1585 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1588 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_SADDSAT'
     /* 1588 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1591 */ // Label 109: @1591
     /* 1591 */ GIM_Reject,
     /* 1592 */ // Label 34: @1592
     /* 1592 */ GIM_Try, /*On fail goto*//*Label 110*/ GIMT_Encode4(1603), // Rule ID 47 //
     /* 1597 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule23Enabled),
     /* 1600 */   // Combiner Rule #23: shift_immed_chain; wip_match_opcode 'G_USHLSAT'
     /* 1600 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 1603 */ // Label 110: @1603
     /* 1603 */ GIM_Reject,
     /* 1604 */ // Label 35: @1604
     /* 1604 */ GIM_Try, /*On fail goto*//*Label 111*/ GIMT_Encode4(1615), // Rule ID 46 //
     /* 1609 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule23Enabled),
     /* 1612 */   // Combiner Rule #23: shift_immed_chain; wip_match_opcode 'G_SSHLSAT'
     /* 1612 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 1615 */ // Label 111: @1615
     /* 1615 */ GIM_Reject,
     /* 1616 */ // Label 36: @1616
     /* 1616 */ GIM_Try, /*On fail goto*//*Label 112*/ GIMT_Encode4(1627), // Rule ID 65 //
     /* 1621 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1624 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULFIX'
     /* 1624 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1627 */ // Label 112: @1627
     /* 1627 */ GIM_Reject,
     /* 1628 */ // Label 37: @1628
     /* 1628 */ GIM_Try, /*On fail goto*//*Label 113*/ GIMT_Encode4(1639), // Rule ID 66 //
     /* 1633 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1636 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULFIX'
     /* 1636 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1639 */ // Label 113: @1639
     /* 1639 */ GIM_Reject,
     /* 1640 */ // Label 38: @1640
     /* 1640 */ GIM_Try, /*On fail goto*//*Label 114*/ GIMT_Encode4(1651), // Rule ID 67 //
     /* 1645 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1648 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULFIXSAT'
     /* 1648 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1651 */ // Label 114: @1651
     /* 1651 */ GIM_Reject,
     /* 1652 */ // Label 39: @1652
     /* 1652 */ GIM_Try, /*On fail goto*//*Label 115*/ GIMT_Encode4(1663), // Rule ID 68 //
     /* 1657 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1660 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULFIXSAT'
     /* 1660 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1663 */ // Label 115: @1663
     /* 1663 */ GIM_Reject,
     /* 1664 */ // Label 40: @1664
     /* 1664 */ GIM_Try, /*On fail goto*//*Label 116*/ GIMT_Encode4(1675), // Rule ID 69 //
     /* 1669 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule25Enabled),
     /* 1672 */   // Combiner Rule #25: commute_fp_constant_to_rhs; wip_match_opcode 'G_FADD'
     /* 1672 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner15),
     /* 1675 */ // Label 116: @1675
     /* 1675 */ GIM_Try, /*On fail goto*//*Label 117*/ GIMT_Encode4(1698), // Rule ID 41 //
     /* 1680 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule21Enabled),
     /* 1683 */   // MIs[0] dst
     /* 1683 */   // No operand predicates
     /* 1683 */   // MIs[0] x
     /* 1683 */   // No operand predicates
     /* 1683 */   // MIs[0] y
     /* 1683 */   // No operand predicates
     /* 1683 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner1),
     /* 1687 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1692 */   // Combiner Rule #21: right_identity_neg_zero_fp
     /* 1692 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1697 */   GIR_EraseRootFromParent_Done,
     /* 1698 */ // Label 117: @1698
     /* 1698 */ GIM_Reject,
     /* 1699 */ // Label 41: @1699
     /* 1699 */ GIM_Try, /*On fail goto*//*Label 118*/ GIMT_Encode4(1710), // Rule ID 70 //
     /* 1704 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule25Enabled),
     /* 1707 */   // Combiner Rule #25: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMUL'
     /* 1707 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner15),
     /* 1710 */ // Label 118: @1710
     /* 1710 */ GIM_Try, /*On fail goto*//*Label 119*/ GIMT_Encode4(1733), // Rule ID 32 //
     /* 1715 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule14Enabled),
     /* 1718 */   // MIs[0] dst
     /* 1718 */   // No operand predicates
     /* 1718 */   // MIs[0] x
     /* 1718 */   // No operand predicates
     /* 1718 */   // MIs[0] y
     /* 1718 */   // No operand predicates
     /* 1718 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner0),
     /* 1722 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1727 */   // Combiner Rule #14: right_identity_one_fp
     /* 1727 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1732 */   GIR_EraseRootFromParent_Done,
     /* 1733 */ // Label 119: @1733
     /* 1733 */ GIM_Try, /*On fail goto*//*Label 120*/ GIMT_Encode4(1753), // Rule ID 42 //
     /* 1738 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule22Enabled),
     /* 1741 */   // MIs[0] dst
     /* 1741 */   // No operand predicates
     /* 1741 */   // MIs[0] x
     /* 1741 */   // No operand predicates
     /* 1741 */   // MIs[0] y
     /* 1741 */   // No operand predicates
     /* 1741 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner2),
     /* 1745 */   // Combiner Rule #22: right_identity_neg_one_fp
     /* 1745 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 1748 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 1750 */   GIR_RootToRootCopy, /*OpIdx*/1, // x
     /* 1752 */   GIR_EraseRootFromParent_Done,
     /* 1753 */ // Label 120: @1753
     /* 1753 */ GIM_Reject,
     /* 1754 */ // Label 42: @1754
     /* 1754 */ GIM_Try, /*On fail goto*//*Label 121*/ GIMT_Encode4(1783), // Rule ID 30 //
     /* 1759 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule12Enabled),
     /* 1762 */   // MIs[0] dst
     /* 1762 */   // No operand predicates
     /* 1762 */   // MIs[0] t
     /* 1762 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1766 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 1770 */   // MIs[1] src
     /* 1770 */   // No operand predicates
     /* 1770 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1775 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1777 */   // Combiner Rule #12: fneg_fneg_fold
     /* 1777 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1782 */   GIR_EraseRootFromParent_Done,
     /* 1783 */ // Label 121: @1783
     /* 1783 */ GIM_Reject,
     /* 1784 */ // Label 43: @1784
     /* 1784 */ GIM_Try, /*On fail goto*//*Label 122*/ GIMT_Encode4(1805), // Rule ID 40 //
     /* 1789 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule20Enabled),
     /* 1792 */   // MIs[0] dst
     /* 1792 */   // No operand predicates
     /* 1792 */   // MIs[0] src1
     /* 1792 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1796 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPEXT),
     /* 1800 */   // MIs[1] src0
     /* 1800 */   // No operand predicates
     /* 1800 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1802 */   // Combiner Rule #20: fptrunc_fpext_fold
     /* 1802 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner12),
     /* 1805 */ // Label 122: @1805
     /* 1805 */ GIM_Reject,
     /* 1806 */ // Label 44: @1806
     /* 1806 */ GIM_Try, /*On fail goto*//*Label 123*/ GIMT_Encode4(1817), // Rule ID 71 //
     /* 1811 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule25Enabled),
     /* 1814 */   // Combiner Rule #25: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINNUM'
     /* 1814 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner15),
     /* 1817 */ // Label 123: @1817
     /* 1817 */ GIM_Reject,
     /* 1818 */ // Label 45: @1818
     /* 1818 */ GIM_Try, /*On fail goto*//*Label 124*/ GIMT_Encode4(1829), // Rule ID 72 //
     /* 1823 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule25Enabled),
     /* 1826 */   // Combiner Rule #25: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXNUM'
     /* 1826 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner15),
     /* 1829 */ // Label 124: @1829
     /* 1829 */ GIM_Reject,
     /* 1830 */ // Label 46: @1830
     /* 1830 */ GIM_Try, /*On fail goto*//*Label 125*/ GIMT_Encode4(1841), // Rule ID 73 //
     /* 1835 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule25Enabled),
     /* 1838 */   // Combiner Rule #25: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINNUM_IEEE'
     /* 1838 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner15),
     /* 1841 */ // Label 125: @1841
     /* 1841 */ GIM_Reject,
     /* 1842 */ // Label 47: @1842
     /* 1842 */ GIM_Try, /*On fail goto*//*Label 126*/ GIMT_Encode4(1853), // Rule ID 74 //
     /* 1847 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule25Enabled),
     /* 1850 */   // Combiner Rule #25: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXNUM_IEEE'
     /* 1850 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner15),
     /* 1853 */ // Label 126: @1853
     /* 1853 */ GIM_Reject,
     /* 1854 */ // Label 48: @1854
     /* 1854 */ GIM_Try, /*On fail goto*//*Label 127*/ GIMT_Encode4(1865), // Rule ID 75 //
     /* 1859 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule25Enabled),
     /* 1862 */   // Combiner Rule #25: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINIMUM'
     /* 1862 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner15),
     /* 1865 */ // Label 127: @1865
     /* 1865 */ GIM_Reject,
     /* 1866 */ // Label 49: @1866
     /* 1866 */ GIM_Try, /*On fail goto*//*Label 128*/ GIMT_Encode4(1877), // Rule ID 76 //
     /* 1871 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule25Enabled),
     /* 1874 */   // Combiner Rule #25: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXIMUM'
     /* 1874 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner15),
     /* 1877 */ // Label 128: @1877
     /* 1877 */ GIM_Reject,
     /* 1878 */ // Label 50: @1878
     /* 1878 */ GIM_Try, /*On fail goto*//*Label 129*/ GIMT_Encode4(1901), // Rule ID 14 //
     /* 1883 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /* 1886 */   // MIs[0] dst
     /* 1886 */   // No operand predicates
     /* 1886 */   // MIs[0] lhs
     /* 1886 */   // No operand predicates
     /* 1886 */   // MIs[0] Operand 2
     /* 1886 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1890 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1895 */   // Combiner Rule #5: right_identity_zero @ [__right_identity_zero_match_0[7]]
     /* 1895 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1900 */   GIR_EraseRootFromParent_Done,
     /* 1901 */ // Label 129: @1901
     /* 1901 */ GIM_Reject,
     /* 1902 */ // Label 51: @1902
     /* 1902 */ GIM_Try, /*On fail goto*//*Label 130*/ GIMT_Encode4(1913), // Rule ID 53 //
     /* 1907 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1910 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_SMIN'
     /* 1910 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1913 */ // Label 130: @1913
     /* 1913 */ GIM_Reject,
     /* 1914 */ // Label 52: @1914
     /* 1914 */ GIM_Try, /*On fail goto*//*Label 131*/ GIMT_Encode4(1925), // Rule ID 54 //
     /* 1919 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1922 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_SMAX'
     /* 1922 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1925 */ // Label 131: @1925
     /* 1925 */ GIM_Reject,
     /* 1926 */ // Label 53: @1926
     /* 1926 */ GIM_Try, /*On fail goto*//*Label 132*/ GIMT_Encode4(1937), // Rule ID 55 //
     /* 1931 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1934 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_UMIN'
     /* 1934 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1937 */ // Label 132: @1937
     /* 1937 */ GIM_Reject,
     /* 1938 */ // Label 54: @1938
     /* 1938 */ GIM_Try, /*On fail goto*//*Label 133*/ GIMT_Encode4(1949), // Rule ID 56 //
     /* 1943 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1946 */   // Combiner Rule #24: commute_int_constant_to_rhs; wip_match_opcode 'G_UMAX'
     /* 1946 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 1949 */ // Label 133: @1949
     /* 1949 */ GIM_Reject,
     /* 1950 */ // Label 55: @1950
     /* 1950 */ GIM_Reject,
     /* 1951 */ }; // Size: 1951 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GICOMBINER_IMPL

#ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
#ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
, State(0),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GICOMBINER_CONSTRUCTOR_INITS

