/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* AArch64PostLegalizerCombinerImpl Combiner Match Table                      *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GICOMBINER_DEPS
#include "llvm/ADT/SparseBitVector.h"
namespace llvm {
extern cl::OptionCategory GICombinerOptionCategory;
} // end namespace llvm
#endif // ifdef GET_GICOMBINER_DEPS

#ifdef GET_GICOMBINER_TYPES
struct AArch64PostLegalizerCombinerImplRuleConfig {
  SparseBitVector<> DisabledRules;

  bool isRuleEnabled(unsigned RuleID) const;
  bool parseCommandLineOption();
  bool setRuleEnabled(StringRef RuleIdentifier);
  bool setRuleDisabled(StringRef RuleIdentifier);
};

static std::optional<uint64_t> getRuleIdxForIdentifier(StringRef RuleIdentifier) {
  uint64_t I;
  // getAtInteger(...) returns false on success
  bool Parsed = !RuleIdentifier.getAsInteger(0, I);
  if (Parsed)
    return I;

#ifndef NDEBUG
  switch (RuleIdentifier.size()) {
  default: break;
  case 9:	 // 3 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "opy_prop", 8) != 0)
        break;
      return 0;	 // "copy_prop"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ul_const", 8) != 0)
        break;
      return 24;	 // "mul_const"
    case 'o':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "r_to_bsp", 8) != 0)
        break;
      return 85;	 // "or_to_bsp"
    }
    break;
  case 10:	 // 2 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2p_to_p2i", 9) != 0)
        break;
      return 56;	 // "i2p_to_p2i"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2i_to_i2p", 9) != 0)
        break;
      return 55;	 // "p2i_to_i2p"
    }
    break;
  case 11:	 // 3 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dd_sub_reg", 10) != 0)
        break;
      return 61;	 // "add_sub_reg"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_addos", 10) != 0)
        break;
      return 32;	 // "match_addos"
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nmerge_cst", 10) != 0)
        break;
      return 42;	 // "unmerge_cst"
    }
    break;
  case 12:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtmultomull", 11) != 0)
        break;
      return 94;	 // "extmultomull"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_or", 11) != 0)
        break;
      return 23;	 // "redundant_or"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_of_sext", 11) != 0)
        break;
      return 6;	 // "sext_of_sext"
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_of_zext", 11) != 0)
        break;
      return 4;	 // "zext_of_zext"
    }
    break;
  case 13:	 // 6 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'l':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oad_and_mask", 12) != 0)
        break;
      return 16;	 // "load_and_mask"
    case 'm':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "tch_selects", 11) != 0)
          break;
        return 37;	 // "match_selects"
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "rge_unmerge", 11) != 0)
          break;
        return 41;	 // "merge_unmerge"
      }
      break;
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_and", 12) != 0)
        break;
      return 20;	 // "redundant_and"
    case 'u':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "nmerge_", 7) != 0)
        break;
      switch (RuleIdentifier[8]) {
      default: break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "erge", 4) != 0)
          break;
        return 40;	 // "unmerge_merge"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "ndef", 4) != 0)
          break;
        return 43;	 // "unmerge_undef"
      }
      break;
    }
    break;
  case 14:	 // 6 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "nyext_of_", 9) != 0)
        break;
      switch (RuleIdentifier[10]) {
      default: break;
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+11, "ext", 3) != 0)
          break;
        return 10;	 // "anyext_of_sext"
      case 'z':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+11, "ext", 3) != 0)
          break;
        return 9;	 // "anyext_of_zext"
      }
      break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_same_val", 13) != 0)
        break;
      return 52;	 // "binop_same_val"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "neg_fneg_fold", 13) != 0)
        break;
      return 58;	 // "fneg_fneg_fold"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_of_anyext", 13) != 0)
        break;
      return 7;	 // "sext_of_anyext"
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_of_anyext", 13) != 0)
        break;
      return 5;	 // "zext_of_anyext"
    }
    break;
  case 15:	 // 3 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtending_loads", 14) != 0)
        break;
      return 15;	 // "extending_loads"
    case 'o':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "verlapping_and", 14) != 0)
        break;
      return 70;	 // "overlapping_and"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "elect_same_val", 14) != 0)
        break;
      return 50;	 // "select_same_val"
    }
    break;
  case 16:	 // 7 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nyext_of_anyext", 15) != 0)
        break;
      return 8;	 // "anyext_of_anyext"
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_mul_cmlt", 15) != 0)
        break;
      return 92;	 // "combine_mul_cmlt"
    case 's':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "elect_", 6) != 0)
        break;
      switch (RuleIdentifier[7]) {
      default: break;
      case 't':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+8, "o_minmax", 8) != 0)
          break;
        return 84;	 // "select_to_minmax"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+8, "ndef_cmp", 8) != 0)
          break;
        return 34;	 // "select_undef_cmp"
      }
      break;
    case 't':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "runcate_of_", 11) != 0)
        break;
      switch (RuleIdentifier[12]) {
      default: break;
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+13, "ext", 3) != 0)
          break;
        return 2;	 // "truncate_of_sext"
      case 'z':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+13, "ext", 3) != 0)
          break;
        return 1;	 // "truncate_of_zext"
      }
      break;
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ndef_to_fp_zero", 15) != 0)
        break;
      return 72;	 // "undef_to_fp_zero"
    }
    break;
  case 17:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nyext_trunc_fold", 16) != 0)
        break;
      return 57;	 // "anyext_trunc_fold"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "rase_undef_store", 16) != 0)
        break;
      return 82;	 // "erase_undef_store"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "elect_to_iminmax", 16) != 0)
        break;
      return 36;	 // "select_to_iminmax"
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ndef_to_int_zero", 16) != 0)
        break;
      return 73;	 // "undef_to_int_zero"
    }
    break;
  case 18:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_left_to_zero", 17) != 0)
        break;
      return 53;	 // "binop_left_to_zero"
    case 'f':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ld_merge_to_zext", 16) != 0)
          break;
        return 38;	 // "fold_merge_to_zext"
      case 'p':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "trunc_fpext_fold", 16) != 0)
          break;
        return 66;	 // "fptrunc_fpext_fold"
      }
      break;
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runcate_of_anyext", 17) != 0)
        break;
      return 3;	 // "truncate_of_anyext"
    }
    break;
  case 19:	 // 10 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_right_to_zero", 18) != 0)
        break;
      return 54;	 // "binop_right_to_zero"
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "onstant_fold_binop", 18) != 0)
        break;
      return 48;	 // "constant_fold_binop"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nteger_of_truncate", 18) != 0)
        break;
      return 13;	 // "integer_of_truncate"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "erge_of_x_and_zero", 18) != 0)
        break;
      return 47;	 // "merge_of_x_and_zero"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "tr_add_immed_chain", 18) != 0)
        break;
      return 69;	 // "ptr_add_immed_chain"
    case 'r':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'i':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ght_identity_zero", 17) != 0)
          break;
        return 51;	 // "right_identity_zero"
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "tate_out_of_range", 17) != 0)
          break;
        return 30;	 // "rotate_out_of_range"
      }
      break;
    case 's':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'e')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'l':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "ect_constant_cmp", 16) != 0)
          break;
        return 35;	 // "select_constant_cmp"
      case 'x':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "t_trunc_sextload", 16) != 0)
          break;
        return 18;	 // "sext_trunc_sextload"
      }
      break;
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nary_undef_to_zero", 18) != 0)
        break;
      return 77;	 // "unary_undef_to_zero"
    }
    break;
  case 20:	 // 6 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itcast_bitcast_fold", 19) != 0)
        break;
      return 65;	 // "bitcast_bitcast_fold"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "erge_of_x_and_undef", 19) != 0)
        break;
      return 46;	 // "merge_of_x_and_undef"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_sext_inreg", 19) != 0)
        break;
      return 25;	 // "redundant_sext_inreg"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "plit_store_zero_128", 19) != 0)
        break;
      return 71;	 // "split_store_zero_128"
    case 'u':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'n')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "ry_undef_to_undef", 17) != 0)
          break;
        return 78;	 // "unary_undef_to_undef"
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "erge_zext_to_zext", 17) != 0)
          break;
        return 45;	 // "unmerge_zext_to_zext"
      }
      break;
    }
    break;
  case 21:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_concat_vector", 20) != 0)
        break;
      return 86;	 // "combine_concat_vector"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "utate_anyext_to_zext", 20) != 0)
        break;
      return 14;	 // "mutate_anyext_to_zext"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_one_fp", 20) != 0)
        break;
      return 60;	 // "right_identity_one_fp"
    case 'u':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'n')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "ef_to_negative_one", 18) != 0)
          break;
        return 74;	 // "undef_to_negative_one"
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "erge_dead_to_trunc", 18) != 0)
          break;
        return 44;	 // "unmerge_dead_to_trunc"
      }
      break;
    }
    break;
  case 22:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "onstant_fold_fp_binop", 21) != 0)
        break;
      return 49;	 // "constant_fold_fp_binop"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_subo_no_overflow", 21) != 0)
        break;
      return 33;	 // "match_subo_no_overflow"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ropagate_undef_any_op", 21) != 0)
        break;
      return 79;	 // "propagate_undef_any_op"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_one_int", 21) != 0)
        break;
      return 59;	 // "right_identity_one_int"
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_buildvector_fold", 21) != 0)
        break;
      return 63;	 // "trunc_buildvector_fold"
    }
    break;
  case 23:	 // 2 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "uildvector_of_truncate", 22) != 0)
        break;
      return 12;	 // "buildvector_of_truncate"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ropagate_undef_all_ops", 22) != 0)
        break;
      return 80;	 // "propagate_undef_all_ops"
    }
    break;
  case 24:	 // 3 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_left_undef_to_zero", 23) != 0)
        break;
      return 75;	 // "binop_left_undef_to_zero"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_inreg_of_sext_inreg", 23) != 0)
        break;
      return 11;	 // "sext_inreg_of_sext_inreg"
    case 'x':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "or_of_and_with_same_reg", 23) != 0)
        break;
      return 21;	 // "xor_of_and_with_same_reg"
    }
    break;
  case 25:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'i':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "tfield_extract_from_", 20) != 0)
          break;
        switch (RuleIdentifier[22]) {
        default: break;
        case 'a':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+23, "nd", 2) != 0)
            break;
          return 27;	 // "bitfield_extract_from_and"
        case 's':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+23, "hr", 2) != 0)
            break;
          return 28;	 // "bitfield_extract_from_shr"
        }
        break;
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ildvector_identity_fold", 23) != 0)
          break;
        return 62;	 // "buildvector_identity_fold"
      }
      break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vec_elt_build_vec", 24) != 0)
        break;
      return 89;	 // "extract_vec_elt_build_vec"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_neg_one_fp", 24) != 0)
        break;
      return 68;	 // "right_identity_neg_one_fp"
    }
    break;
  case 26:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_right_undef_to_undef", 25) != 0)
        break;
      return 76;	 // "binop_right_undef_to_undef"
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "om", 2) != 0)
        break;
      switch (RuleIdentifier[3]) {
      default: break;
      case 'b':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+4, "ine_indexed_load_store", 22) != 0)
          break;
        return 17;	 // "combine_indexed_load_store"
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+4, "ute_fp_constant_to_rhs", 22) != 0)
          break;
        return 88;	 // "commute_fp_constant_to_rhs"
      }
      break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtractvecelt_pairwise_add", 25) != 0)
        break;
      return 22;	 // "extractvecelt_pairwise_add"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_neg_zero_fp", 25) != 0)
        break;
      return 67;	 // "right_identity_neg_zero_fp"
    }
    break;
  case 27:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "om", 2) != 0)
        break;
      switch (RuleIdentifier[3]) {
      default: break;
      case 'b':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+4, "ine_use_vector_truncate", 23) != 0)
          break;
        return 93;	 // "combine_use_vector_truncate"
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+4, "ute_int_constant_to_rhs", 23) != 0)
          break;
        return 87;	 // "commute_int_constant_to_rhs"
      }
      break;
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_lshr_buildvector_fold", 26) != 0)
        break;
      return 64;	 // "trunc_lshr_buildvector_fold"
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nmerge_anyext_build_vector", 26) != 0)
        break;
      return 39;	 // "unmerge_anyext_build_vector"
    }
    break;
  case 28:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "propagate_undef_shuffle_mask", 28) != 0)
      break;
    return 81;	 // "propagate_undef_shuffle_mask"
  case 29:	 // 2 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itfield_extract_from_shr_and", 28) != 0)
        break;
      return 29;	 // "bitfield_extract_from_shr_and"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "cmp_to_true_false_known_bits", 28) != 0)
        break;
      return 31;	 // "icmp_to_true_false_known_bits"
    }
    break;
  case 32:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "bitfield_extract_from_sext_inreg", 32) != 0)
      break;
    return 26;	 // "bitfield_extract_from_sext_inreg"
  case 34:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "extract_all_elts_from_build_vector", 34) != 0)
      break;
    return 90;	 // "extract_all_elts_from_build_vector"
  case 36:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "insert_extract_vec_elt_out_of_bounds", 36) != 0)
      break;
    return 83;	 // "insert_extract_vec_elt_out_of_bounds"
  case 37:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "hoist_logic_op_with_same_opcode_hands", 37) != 0)
      break;
    return 19;	 // "hoist_logic_op_with_same_opcode_hands"
  case 46:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "push_freeze_to_prevent_poison_from_propagating", 46) != 0)
      break;
    return 91;	 // "push_freeze_to_prevent_poison_from_propagating"
  }
#endif // ifndef NDEBUG

  return std::nullopt;
}
static std::optional<std::pair<uint64_t, uint64_t>> getRuleRangeForIdentifier(StringRef RuleIdentifier) {
  std::pair<StringRef, StringRef> RangePair = RuleIdentifier.split('-');
  if (!RangePair.second.empty()) {
    const auto First = getRuleIdxForIdentifier(RangePair.first);
    const auto Last = getRuleIdxForIdentifier(RangePair.second);
    if (!First || !Last)
      return std::nullopt;
    if (First >= Last)
      report_fatal_error("Beginning of range should be before end of range");
    return {{*First, *Last + 1}};
  }
  if (RangePair.first == "*") {
    return {{0, 95}};
  }
  const auto I = getRuleIdxForIdentifier(RangePair.first);
  if (!I)
    return std::nullopt;
  return {{*I, *I + 1}};
}

bool AArch64PostLegalizerCombinerImplRuleConfig::setRuleEnabled(StringRef RuleIdentifier) {
  auto MaybeRange = getRuleRangeForIdentifier(RuleIdentifier);
  if (!MaybeRange)
    return false;
  for (auto I = MaybeRange->first; I < MaybeRange->second; ++I)
    DisabledRules.reset(I);
  return true;
}

bool AArch64PostLegalizerCombinerImplRuleConfig::setRuleDisabled(StringRef RuleIdentifier) {
  auto MaybeRange = getRuleRangeForIdentifier(RuleIdentifier);
  if (!MaybeRange)
    return false;
  for (auto I = MaybeRange->first; I < MaybeRange->second; ++I)
    DisabledRules.set(I);
  return true;
}

static std::vector<std::string> AArch64PostLegalizerCombinerOption;
static cl::list<std::string> AArch64PostLegalizerCombinerDisableOption(
    "aarch64postlegalizercombiner-disable-rule",
    cl::desc("Disable one or more combiner rules temporarily in the AArch64PostLegalizerCombiner pass"),
    cl::CommaSeparated,
    cl::Hidden,
    cl::cat(GICombinerOptionCategory),
    cl::callback([](const std::string &Str) {
      AArch64PostLegalizerCombinerOption.push_back(Str);
    }));
static cl::list<std::string> AArch64PostLegalizerCombinerOnlyEnableOption(
    "aarch64postlegalizercombiner-only-enable-rule",
    cl::desc("Disable all rules in the AArch64PostLegalizerCombiner pass then re-enable the specified ones"),
    cl::Hidden,
    cl::cat(GICombinerOptionCategory),
    cl::callback([](const std::string &CommaSeparatedArg) {
      StringRef Str = CommaSeparatedArg;
      AArch64PostLegalizerCombinerOption.push_back("*");
      do {
        auto X = Str.split(",");
        AArch64PostLegalizerCombinerOption.push_back(("!" + X.first).str());
        Str = X.second;
      } while (!Str.empty());
    }));


bool AArch64PostLegalizerCombinerImplRuleConfig::isRuleEnabled(unsigned RuleID) const {
    return  !DisabledRules.test(RuleID);
}
bool AArch64PostLegalizerCombinerImplRuleConfig::parseCommandLineOption() {
  for (StringRef Identifier : AArch64PostLegalizerCombinerOption) {
    bool Enabled = Identifier.consume_front("!");
    if (Enabled && !setRuleEnabled(Identifier))
      return false;
    if (!Enabled && !setRuleDisabled(Identifier))
      return false;
  }
  return true;
}

#endif // ifdef GET_GICOMBINER_TYPES

#ifdef GET_GICOMBINER_TYPES
const unsigned MAX_SUBTARGET_PREDICATES = 0;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GICOMBINER_TYPES

#ifdef GET_GICOMBINER_CLASS_MEMBERS
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GICOMBINER_CLASS_MEMBERS
#ifdef GET_GICOMBINER_CLASS_MEMBERS
  mutable MatcherState State;
  typedef ComplexRendererFns(AArch64PostLegalizerCombinerImpl::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(AArch64PostLegalizerCombinerImpl::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static AArch64PostLegalizerCombinerImpl::ComplexMatcherMemFn ComplexPredicateFns[];
  static AArch64PostLegalizerCombinerImpl::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testMOPredicate_MO(unsigned PredicateID, const MachineOperand &MO, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GICOMBINER_CLASS_MEMBERS

#ifdef GET_GICOMBINER_IMPL
// LLT Objects.
enum {
  GILLT_s1,
};
const static size_t NumTypeObjects = 1;
const static LLT TypeObjects[] = {
  LLT::scalar(1),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
};

PredicateBitset AArch64PostLegalizerCombinerImpl::
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const {
  PredicateBitset Features{};
  return Features;
}

void AArch64PostLegalizerCombinerImpl::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const AArch64Subtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset AArch64PostLegalizerCombinerImpl::
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
};
// See constructor for table contents

AArch64PostLegalizerCombinerImpl::ComplexMatcherMemFn
AArch64PostLegalizerCombinerImpl::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
};

enum {
  GICXXPred_MI_Predicate_GICombiner0 = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_GICombiner1,
  GICXXPred_MI_Predicate_GICombiner2,
};
bool AArch64PostLegalizerCombinerImpl::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_GICombiner0: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), 1.0);
  }
  case GICXXPred_MI_Predicate_GICombiner1: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), -0.0);
  }
  case GICXXPred_MI_Predicate_GICombiner2: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), -1.0);
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AArch64PostLegalizerCombinerImpl::testMOPredicate_MO(unsigned PredicateID, const MachineOperand & MO, const MatcherState &State) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AArch64PostLegalizerCombinerImpl::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AArch64PostLegalizerCombinerImpl::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AArch64PostLegalizerCombinerImpl::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
enum {
  GICXXPred_Simple_IsRule0Enabled = GICXXPred_Invalid + 1,
  GICXXPred_Simple_IsRule1Enabled,
  GICXXPred_Simple_IsRule2Enabled,
  GICXXPred_Simple_IsRule3Enabled,
  GICXXPred_Simple_IsRule4Enabled,
  GICXXPred_Simple_IsRule5Enabled,
  GICXXPred_Simple_IsRule6Enabled,
  GICXXPred_Simple_IsRule7Enabled,
  GICXXPred_Simple_IsRule8Enabled,
  GICXXPred_Simple_IsRule9Enabled,
  GICXXPred_Simple_IsRule10Enabled,
  GICXXPred_Simple_IsRule11Enabled,
  GICXXPred_Simple_IsRule12Enabled,
  GICXXPred_Simple_IsRule13Enabled,
  GICXXPred_Simple_IsRule14Enabled,
  GICXXPred_Simple_IsRule15Enabled,
  GICXXPred_Simple_IsRule16Enabled,
  GICXXPred_Simple_IsRule17Enabled,
  GICXXPred_Simple_IsRule18Enabled,
  GICXXPred_Simple_IsRule19Enabled,
  GICXXPred_Simple_IsRule20Enabled,
  GICXXPred_Simple_IsRule21Enabled,
  GICXXPred_Simple_IsRule22Enabled,
  GICXXPred_Simple_IsRule23Enabled,
  GICXXPred_Simple_IsRule24Enabled,
  GICXXPred_Simple_IsRule25Enabled,
  GICXXPred_Simple_IsRule26Enabled,
  GICXXPred_Simple_IsRule27Enabled,
  GICXXPred_Simple_IsRule28Enabled,
  GICXXPred_Simple_IsRule29Enabled,
  GICXXPred_Simple_IsRule30Enabled,
  GICXXPred_Simple_IsRule31Enabled,
  GICXXPred_Simple_IsRule32Enabled,
  GICXXPred_Simple_IsRule33Enabled,
  GICXXPred_Simple_IsRule34Enabled,
  GICXXPred_Simple_IsRule35Enabled,
  GICXXPred_Simple_IsRule36Enabled,
  GICXXPred_Simple_IsRule37Enabled,
  GICXXPred_Simple_IsRule38Enabled,
  GICXXPred_Simple_IsRule39Enabled,
  GICXXPred_Simple_IsRule40Enabled,
  GICXXPred_Simple_IsRule41Enabled,
  GICXXPred_Simple_IsRule42Enabled,
  GICXXPred_Simple_IsRule43Enabled,
  GICXXPred_Simple_IsRule44Enabled,
  GICXXPred_Simple_IsRule45Enabled,
  GICXXPred_Simple_IsRule46Enabled,
  GICXXPred_Simple_IsRule47Enabled,
  GICXXPred_Simple_IsRule48Enabled,
  GICXXPred_Simple_IsRule49Enabled,
  GICXXPred_Simple_IsRule50Enabled,
  GICXXPred_Simple_IsRule51Enabled,
  GICXXPred_Simple_IsRule52Enabled,
  GICXXPred_Simple_IsRule53Enabled,
  GICXXPred_Simple_IsRule54Enabled,
  GICXXPred_Simple_IsRule55Enabled,
  GICXXPred_Simple_IsRule56Enabled,
  GICXXPred_Simple_IsRule57Enabled,
  GICXXPred_Simple_IsRule58Enabled,
  GICXXPred_Simple_IsRule59Enabled,
  GICXXPred_Simple_IsRule60Enabled,
  GICXXPred_Simple_IsRule61Enabled,
  GICXXPred_Simple_IsRule62Enabled,
  GICXXPred_Simple_IsRule63Enabled,
  GICXXPred_Simple_IsRule64Enabled,
  GICXXPred_Simple_IsRule65Enabled,
  GICXXPred_Simple_IsRule66Enabled,
  GICXXPred_Simple_IsRule67Enabled,
  GICXXPred_Simple_IsRule68Enabled,
  GICXXPred_Simple_IsRule69Enabled,
  GICXXPred_Simple_IsRule70Enabled,
  GICXXPred_Simple_IsRule71Enabled,
  GICXXPred_Simple_IsRule72Enabled,
  GICXXPred_Simple_IsRule73Enabled,
  GICXXPred_Simple_IsRule74Enabled,
  GICXXPred_Simple_IsRule75Enabled,
  GICXXPred_Simple_IsRule76Enabled,
  GICXXPred_Simple_IsRule77Enabled,
  GICXXPred_Simple_IsRule78Enabled,
  GICXXPred_Simple_IsRule79Enabled,
  GICXXPred_Simple_IsRule80Enabled,
  GICXXPred_Simple_IsRule81Enabled,
  GICXXPred_Simple_IsRule82Enabled,
  GICXXPred_Simple_IsRule83Enabled,
  GICXXPred_Simple_IsRule84Enabled,
  GICXXPred_Simple_IsRule85Enabled,
  GICXXPred_Simple_IsRule86Enabled,
  GICXXPred_Simple_IsRule87Enabled,
  GICXXPred_Simple_IsRule88Enabled,
  GICXXPred_Simple_IsRule89Enabled,
  GICXXPred_Simple_IsRule90Enabled,
  GICXXPred_Simple_IsRule91Enabled,
  GICXXPred_Simple_IsRule92Enabled,
  GICXXPred_Simple_IsRule93Enabled,
  GICXXPred_Simple_IsRule94Enabled,
};

bool AArch64PostLegalizerCombinerImpl::testSimplePredicate(unsigned Predicate) const {
    return RuleConfig.isRuleEnabled(Predicate - GICXXPred_Invalid - 1);
}
// Custom renderers.
enum {
  GICR_Invalid,
};
AArch64PostLegalizerCombinerImpl::CustomRendererFn
AArch64PostLegalizerCombinerImpl::CustomRenderers[] = {
  nullptr, // GICR_Invalid
};

bool AArch64PostLegalizerCombinerImpl::tryCombineAll(MachineInstr &I) const {
  const TargetSubtargetInfo &ST = MF.getSubtarget();
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  B.setInstrAndDebugLoc(I);
  State.MIs.clear();
  State.MIs.push_back(&I);
  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), *ST.getInstrInfo(), MRI, *MRI.getTargetRegisterInfo(), *ST.getRegBankInfo(), AvailableFeatures, /*CoverageInfo*/ nullptr)) {
    return true;
  }

  return false;
}

enum {
  GICXXCustomAction_GICombiner0 = GICXXCustomAction_Invalid + 1,
  GICXXCustomAction_GICombiner1,
  GICXXCustomAction_GICombiner2,
  GICXXCustomAction_GICombiner3,
  GICXXCustomAction_GICombiner4,
  GICXXCustomAction_GICombiner5,
  GICXXCustomAction_GICombiner6,
  GICXXCustomAction_GICombiner7,
  GICXXCustomAction_GICombiner8,
  GICXXCustomAction_GICombiner9,
  GICXXCustomAction_GICombiner10,
  GICXXCustomAction_GICombiner11,
  GICXXCustomAction_GICombiner12,
  GICXXCustomAction_GICombiner13,
  GICXXCustomAction_GICombiner14,
  GICXXCustomAction_GICombiner15,
  GICXXCustomAction_GICombiner16,
  GICXXCustomAction_GICombiner17,
  GICXXCustomAction_GICombiner18,
  GICXXCustomAction_GICombiner19,
  GICXXCustomAction_GICombiner20,
  GICXXCustomAction_GICombiner21,
  GICXXCustomAction_GICombiner22,
  GICXXCustomAction_GICombiner23,
  GICXXCustomAction_GICombiner24,
  GICXXCustomAction_GICombiner25,
  GICXXCustomAction_GICombiner26,
  GICXXCustomAction_GICombiner27,
  GICXXCustomAction_GICombiner28,
  GICXXCustomAction_GICombiner29,
  GICXXCustomAction_GICombiner30,
  GICXXCustomAction_GICombiner31,
  GICXXCustomAction_GICombiner32,
  GICXXCustomAction_GICombiner33,
  GICXXCustomAction_GICombiner34,
  GICXXCustomAction_GICombiner35,
  GICXXCustomAction_GICombiner36,
  GICXXCustomAction_GICombiner37,
  GICXXCustomAction_GICombiner38,
  GICXXCustomAction_GICombiner39,
  GICXXCustomAction_GICombiner40,
  GICXXCustomAction_GICombiner41,
  GICXXCustomAction_GICombiner42,
  GICXXCustomAction_GICombiner43,
  GICXXCustomAction_GICombiner44,
  GICXXCustomAction_GICombiner45,
  GICXXCustomAction_GICombiner46,
  GICXXCustomAction_GICombiner47,
  GICXXCustomAction_GICombiner48,
  GICXXCustomAction_GICombiner49,
  GICXXCustomAction_GICombiner50,
  GICXXCustomAction_GICombiner51,
  GICXXCustomAction_GICombiner52,
  GICXXCustomAction_GICombiner53,
  GICXXCustomAction_GICombiner54,
  GICXXCustomAction_GICombiner55,
  GICXXCustomAction_GICombiner56,
  GICXXCustomAction_GICombiner57,
  GICXXCustomAction_GICombiner58,
  GICXXCustomAction_GICombiner59,
  GICXXCustomAction_GICombiner60,
  GICXXCustomAction_GICombiner61,
  GICXXCustomAction_GICombiner62,
  GICXXCustomAction_GICombiner63,
  GICXXCustomAction_GICombiner64,
  GICXXCustomAction_GICombiner65,
  GICXXCustomAction_GICombiner66,
  GICXXCustomAction_GICombiner67,
  GICXXCustomAction_GICombiner68,
  GICXXCustomAction_GICombiner69,
  GICXXCustomAction_GICombiner70,
  GICXXCustomAction_GICombiner71,
  GICXXCustomAction_GICombiner72,
  GICXXCustomAction_GICombiner73,
  GICXXCustomAction_GICombiner74,
};
bool AArch64PostLegalizerCombinerImpl::runCustomAction(unsigned ApplyID, const MatcherState &State, NewMIVector &OutMIs) const {
  Helper.getBuilder().setInstrAndDebugLoc(*State.MIs[0]);
  switch(ApplyID) {
  case GICXXCustomAction_GICombiner0:{
    // Match Patterns
    if(![&](){return Helper.matchCombineCopy(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineCopy(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner1:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncateOfExt(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner2:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtOfExt(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner3:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantSextInReg(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner4:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCastOfBuildVector(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner5:{
    APInt GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCastOfInteger(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner6:{
    // Match Patterns
    if(![&](){return matchMutateAnyExtToZExt(*State.MIs[0], MRI);}()) {
      return false;
    }
    // Apply Patterns
    applyMutateAnyExtToZExt(*State.MIs[0], MRI, B, Observer);
    return true;
  }
  case GICXXCustomAction_GICombiner7:{
    PreferredTuple GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineExtendingLoads(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineExtendingLoads(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner8:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineLoadWithAndMask(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner9:{
    IndexedLoadStoreMatchInfo GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineIndexedLoadStore(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineIndexedLoadStore(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner10:{
    // Match Patterns
    if(![&](){return Helper.matchSextTruncSextLoad(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySextTruncSextLoad(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner11:{
    InstructionStepsMatchInfo GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchHoistLogicOpWithSameOpcodeHands(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildInstructionSteps(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner12:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantAnd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner13:{
    std::pair<Register, Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchXorOfAndWithSameReg(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyXorOfAndWithSameReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner14:{
    std::tuple<unsigned, LLT, Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchExtractVecEltPairwiseAdd(*State.MIs[0], MRI, GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    applyExtractVecEltPairwiseAdd(*State.MIs[0], MRI, B, GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner15:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantOr(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner16:{
    std::function<void(MachineIRBuilder&, Register)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchAArch64MulConstCombine(*State.MIs[0], MRI, GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    applyAArch64MulConstCombine(*State.MIs[0], MRI, B, GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner17:{
    // Match Patterns
    if(![&](){return Helper.matchRedundantSExtInReg(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 1);
    return true;
  }
  case GICXXCustomAction_GICombiner18:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromSExtInReg(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner19:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromAnd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner20:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromShr(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner21:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromShrAnd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner22:{
    // Match Patterns
    if(![&](){return Helper.matchRotateOutOfRange(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyRotateOutOfRange(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner23:{
    int64_t GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchICmpToTrueFalseKnownBits(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner24:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAddOverflow(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner25:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSuboCarryOut(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner26:{
    unsigned GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantSelectCmp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner27:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchSelectIMinMax(State.MIs[0]->getOperand(0), GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner28:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSelect(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner29:{
    // Match Patterns
    if(![&](){return matchFoldMergeToZext(*State.MIs[0], MRI);}()) {
      return false;
    }
    // Apply Patterns
    applyFoldMergeToZext(*State.MIs[0], MRI, B, Observer);
    return true;
  }
  case GICXXCustomAction_GICombiner30:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchUnmergeValuesAnyExtBuildVector(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner31:{
    SmallVector<Register> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeMergeToPlainValues(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeMergeToPlainValues(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner32:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineMergeUnmerge(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner33:{
    SmallVector<APInt, 8> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeConstant(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeConstant(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner34:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeUndef(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner35:{
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeWithDeadLanesToTrunc(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeWithDeadLanesToTrunc(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner36:{
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeZExtToZExt(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeZExtToZExt(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner37:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMergeXAndUndef(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner38:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMergeXAndZero(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner39:{
    APInt GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldBinOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner40:{
    ConstantFP* GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldFPBinOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner41:{
    // Match Patterns
    if(![&](){return Helper.matchSelectSameVal(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 2);
    return true;
  }
  case GICXXCustomAction_GICombiner42:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsZero(*State.MIs[0], 1);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 1);
    return true;
  }
  case GICXXCustomAction_GICombiner43:{
    Register GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineI2PToP2I(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineI2PToP2I(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner44:{
    Register GIMatchData_info;
    // Match Patterns
    if(![&](){GIMatchData_info = State.MIs[1]->getOperand(1).getReg(); return true;}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineP2IToI2P(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner45:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineAnyExtTrunc(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner46:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchBuildVectorIdentityFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner47:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncBuildVectorFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner48:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncLshrBuildVectorFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner49:{
    // Match Patterns
    if(![&](){return MRI.getType(State.MIs[1]->getOperand(1).getReg()) == MRI.getType(State.MIs[0]->getOperand(0).getReg());}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], State.MIs[1]->getOperand(1).getReg());
    return true;
  }
  case GICXXCustomAction_GICombiner50:{
    PtrAddChain GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchPtrAddImmedChain(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyPtrAddImmedChain(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner51:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchOverlappingAnd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner52:{
    // Match Patterns
    if(![&](){return matchSplitStoreZero128(*State.MIs[0], MRI);}()) {
      return false;
    }
    // Apply Patterns
    applySplitStoreZero128(*State.MIs[0], MRI, B, Observer);
    return true;
  }
  case GICXXCustomAction_GICombiner53:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0], 0.0);
    return true;
  }
  case GICXXCustomAction_GICombiner54:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], 0);
    return true;
  }
  case GICXXCustomAction_GICombiner55:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], -1);
    return true;
  }
  case GICXXCustomAction_GICombiner56:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsUndef(*State.MIs[0], 1);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], 0);
    return true;
  }
  case GICXXCustomAction_GICombiner57:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsUndef(*State.MIs[0], 2);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner58:{
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]->getOperand(0).getParent());
    return true;
  }
  case GICXXCustomAction_GICombiner59:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner60:{
    // Match Patterns
    if(![&](){return Helper.matchAllExplicitUsesAreUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner61:{
    // Match Patterns
    if(![&](){return Helper.matchUndefShuffleVectorMask(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner62:{
    // Match Patterns
    if(![&](){return Helper.matchUndefStore(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.eraseInst(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner63:{
    // Match Patterns
    if(![&](){return Helper.matchInsertExtractVecEltOutOfBounds(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner64:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchSimplifySelectToMinMax(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner65:{
    std::tuple<Register, Register, Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchOrToBSP(*State.MIs[0], MRI, GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    applyOrToBSP(*State.MIs[0], MRI, B, GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner66:{
    SmallVector<Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineConcatVectors(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineConcatVectors(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner67:{
    // Match Patterns
    if(![&](){return Helper.matchCommuteConstantToRHS(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCommuteBinOpOperands(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner68:{
    // Match Patterns
    if(![&](){return Helper.matchCommuteFPConstantToRHS(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCommuteBinOpOperands(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner69:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVecEltBuildVec(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExtractVecEltBuildVec(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner70:{
    SmallVector<std::pair<Register, MachineInstr*>> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractAllEltsFromBuildVector(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExtractAllEltsFromBuildVector(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner71:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return !isGuaranteedNotToBePoison(State.MIs[0]->getOperand(1).getReg(), MRI) && Helper.matchFreezeOfSingleMaybePoisonOperand(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner72:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchCombineMulCMLT(*State.MIs[0], MRI, GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    applyCombineMulCMLT(*State.MIs[0], MRI, B, GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner73:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchUseVectorTruncate(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUseVectorTruncate(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner74:{
    std::tuple<bool, Register, Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchExtMulToMULL(*State.MIs[0], MRI, VT, GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    applyExtMulToMULL(*State.MIs[0], MRI, B, Observer, GIMatchData_matchinfo);
    return true;
  }
  }
  llvm_unreachable("Unknown Apply Action");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *AArch64PostLegalizerCombinerImpl::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*    0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(20), GIMT_Encode2(244), /*)*//*default:*//*Label 75*/ GIMT_Encode4(3646),
     /*   10 */ /*TargetOpcode::COPY*//*Label 0*/ GIMT_Encode4(906), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  142 */ /*TargetOpcode::G_ADD*//*Label 1*/ GIMT_Encode4(918),
     /*  146 */ /*TargetOpcode::G_SUB*//*Label 2*/ GIMT_Encode4(1043),
     /*  150 */ /*TargetOpcode::G_MUL*//*Label 3*/ GIMT_Encode4(1089),
     /*  154 */ /*TargetOpcode::G_SDIV*//*Label 4*/ GIMT_Encode4(1202),
     /*  158 */ /*TargetOpcode::G_UDIV*//*Label 5*/ GIMT_Encode4(1225),
     /*  162 */ /*TargetOpcode::G_SREM*//*Label 6*/ GIMT_Encode4(1259),
     /*  166 */ /*TargetOpcode::G_UREM*//*Label 7*/ GIMT_Encode4(1282), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  178 */ /*TargetOpcode::G_AND*//*Label 8*/ GIMT_Encode4(1316),
     /*  182 */ /*TargetOpcode::G_OR*//*Label 9*/ GIMT_Encode4(1455),
     /*  186 */ /*TargetOpcode::G_XOR*//*Label 10*/ GIMT_Encode4(1569), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  226 */ /*TargetOpcode::G_UNMERGE_VALUES*//*Label 11*/ GIMT_Encode4(1648), GIMT_Encode4(0),
     /*  234 */ /*TargetOpcode::G_MERGE_VALUES*//*Label 12*/ GIMT_Encode4(1715),
     /*  238 */ /*TargetOpcode::G_BUILD_VECTOR*//*Label 13*/ GIMT_Encode4(1800),
     /*  242 */ /*TargetOpcode::G_BUILD_VECTOR_TRUNC*//*Label 14*/ GIMT_Encode4(1848),
     /*  246 */ /*TargetOpcode::G_CONCAT_VECTORS*//*Label 15*/ GIMT_Encode4(1860),
     /*  250 */ /*TargetOpcode::G_PTRTOINT*//*Label 16*/ GIMT_Encode4(1872),
     /*  254 */ /*TargetOpcode::G_INTTOPTR*//*Label 17*/ GIMT_Encode4(1915),
     /*  258 */ /*TargetOpcode::G_BITCAST*//*Label 18*/ GIMT_Encode4(1948),
     /*  262 */ /*TargetOpcode::G_FREEZE*//*Label 19*/ GIMT_Encode4(1991), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  302 */ /*TargetOpcode::G_LOAD*//*Label 20*/ GIMT_Encode4(2003),
     /*  306 */ /*TargetOpcode::G_SEXTLOAD*//*Label 21*/ GIMT_Encode4(2026),
     /*  310 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 22*/ GIMT_Encode4(2049), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  326 */ /*TargetOpcode::G_STORE*//*Label 23*/ GIMT_Encode4(2072), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  462 */ /*TargetOpcode::G_ANYEXT*//*Label 24*/ GIMT_Encode4(2106),
     /*  466 */ /*TargetOpcode::G_TRUNC*//*Label 25*/ GIMT_Encode4(2213), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  498 */ /*TargetOpcode::G_SEXT*//*Label 26*/ GIMT_Encode4(2365),
     /*  502 */ /*TargetOpcode::G_SEXT_INREG*//*Label 27*/ GIMT_Encode4(2408),
     /*  506 */ /*TargetOpcode::G_ZEXT*//*Label 28*/ GIMT_Encode4(2463),
     /*  510 */ /*TargetOpcode::G_SHL*//*Label 29*/ GIMT_Encode4(2506),
     /*  514 */ /*TargetOpcode::G_LSHR*//*Label 30*/ GIMT_Encode4(2574),
     /*  518 */ /*TargetOpcode::G_ASHR*//*Label 31*/ GIMT_Encode4(2653), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  530 */ /*TargetOpcode::G_ROTR*//*Label 32*/ GIMT_Encode4(2732),
     /*  534 */ /*TargetOpcode::G_ROTL*//*Label 33*/ GIMT_Encode4(2767),
     /*  538 */ /*TargetOpcode::G_ICMP*//*Label 34*/ GIMT_Encode4(2802), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  554 */ /*TargetOpcode::G_SELECT*//*Label 35*/ GIMT_Encode4(2814),
     /*  558 */ /*TargetOpcode::G_UADDO*//*Label 36*/ GIMT_Encode4(2909), GIMT_Encode4(0),
     /*  566 */ /*TargetOpcode::G_USUBO*//*Label 37*/ GIMT_Encode4(2932), GIMT_Encode4(0),
     /*  574 */ /*TargetOpcode::G_SADDO*//*Label 38*/ GIMT_Encode4(2944), GIMT_Encode4(0),
     /*  582 */ /*TargetOpcode::G_SSUBO*//*Label 39*/ GIMT_Encode4(2967), GIMT_Encode4(0),
     /*  590 */ /*TargetOpcode::G_UMULO*//*Label 40*/ GIMT_Encode4(2979),
     /*  594 */ /*TargetOpcode::G_SMULO*//*Label 41*/ GIMT_Encode4(2991),
     /*  598 */ /*TargetOpcode::G_UMULH*//*Label 42*/ GIMT_Encode4(3003),
     /*  602 */ /*TargetOpcode::G_SMULH*//*Label 43*/ GIMT_Encode4(3015),
     /*  606 */ /*TargetOpcode::G_UADDSAT*//*Label 44*/ GIMT_Encode4(3027),
     /*  610 */ /*TargetOpcode::G_SADDSAT*//*Label 45*/ GIMT_Encode4(3039), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  630 */ /*TargetOpcode::G_SMULFIX*//*Label 46*/ GIMT_Encode4(3051),
     /*  634 */ /*TargetOpcode::G_UMULFIX*//*Label 47*/ GIMT_Encode4(3063),
     /*  638 */ /*TargetOpcode::G_SMULFIXSAT*//*Label 48*/ GIMT_Encode4(3075),
     /*  642 */ /*TargetOpcode::G_UMULFIXSAT*//*Label 49*/ GIMT_Encode4(3087), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  662 */ /*TargetOpcode::G_FADD*//*Label 50*/ GIMT_Encode4(3099),
     /*  666 */ /*TargetOpcode::G_FSUB*//*Label 51*/ GIMT_Encode4(3145),
     /*  670 */ /*TargetOpcode::G_FMUL*//*Label 52*/ GIMT_Encode4(3157), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  682 */ /*TargetOpcode::G_FDIV*//*Label 53*/ GIMT_Encode4(3223), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  730 */ /*TargetOpcode::G_FNEG*//*Label 54*/ GIMT_Encode4(3235), GIMT_Encode4(0),
     /*  738 */ /*TargetOpcode::G_FPTRUNC*//*Label 55*/ GIMT_Encode4(3265),
     /*  742 */ /*TargetOpcode::G_FPTOSI*//*Label 56*/ GIMT_Encode4(3287),
     /*  746 */ /*TargetOpcode::G_FPTOUI*//*Label 57*/ GIMT_Encode4(3309),
     /*  750 */ /*TargetOpcode::G_SITOFP*//*Label 58*/ GIMT_Encode4(3331),
     /*  754 */ /*TargetOpcode::G_UITOFP*//*Label 59*/ GIMT_Encode4(3343), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  782 */ /*TargetOpcode::G_FMINNUM*//*Label 60*/ GIMT_Encode4(3355),
     /*  786 */ /*TargetOpcode::G_FMAXNUM*//*Label 61*/ GIMT_Encode4(3367),
     /*  790 */ /*TargetOpcode::G_FMINNUM_IEEE*//*Label 62*/ GIMT_Encode4(3379),
     /*  794 */ /*TargetOpcode::G_FMAXNUM_IEEE*//*Label 63*/ GIMT_Encode4(3391),
     /*  798 */ /*TargetOpcode::G_FMINIMUM*//*Label 64*/ GIMT_Encode4(3403),
     /*  802 */ /*TargetOpcode::G_FMAXIMUM*//*Label 65*/ GIMT_Encode4(3415), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  838 */ /*TargetOpcode::G_PTR_ADD*//*Label 66*/ GIMT_Encode4(3427), GIMT_Encode4(0),
     /*  846 */ /*TargetOpcode::G_SMIN*//*Label 67*/ GIMT_Encode4(3473),
     /*  850 */ /*TargetOpcode::G_SMAX*//*Label 68*/ GIMT_Encode4(3496),
     /*  854 */ /*TargetOpcode::G_UMIN*//*Label 69*/ GIMT_Encode4(3519),
     /*  858 */ /*TargetOpcode::G_UMAX*//*Label 70*/ GIMT_Encode4(3542),
     /*  862 */ /*TargetOpcode::G_ABS*//*Label 71*/ GIMT_Encode4(3565), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  894 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 72*/ GIMT_Encode4(3577),
     /*  898 */ /*TargetOpcode::G_EXTRACT_VECTOR_ELT*//*Label 73*/ GIMT_Encode4(3589),
     /*  902 */ /*TargetOpcode::G_SHUFFLE_VECTOR*//*Label 74*/ GIMT_Encode4(3623),
     /*  906 */ // Label 0: @906
     /*  906 */ GIM_Try, /*On fail goto*//*Label 76*/ GIMT_Encode4(917), // Rule ID 0 //
     /*  911 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule0Enabled),
     /*  914 */   // MIs[0] d
     /*  914 */   // No operand predicates
     /*  914 */   // MIs[0] s
     /*  914 */   // No operand predicates
     /*  914 */   // Combiner Rule #0: copy_prop
     /*  914 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner0),
     /*  917 */ // Label 76: @917
     /*  917 */ GIM_Reject,
     /*  918 */ // Label 1: @918
     /*  918 */ GIM_Try, /*On fail goto*//*Label 77*/ GIMT_Encode4(929), // Rule ID 60 //
     /*  923 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /*  926 */   // Combiner Rule #48: constant_fold_binop; wip_match_opcode 'G_ADD'
     /*  926 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /*  929 */ // Label 77: @929
     /*  929 */ GIM_Try, /*On fail goto*//*Label 78*/ GIMT_Encode4(940), // Rule ID 141 //
     /*  934 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule79Enabled),
     /*  937 */   // Combiner Rule #79: propagate_undef_any_op; wip_match_opcode 'G_ADD'
     /*  937 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner59),
     /*  940 */ // Label 78: @940
     /*  940 */ GIM_Try, /*On fail goto*//*Label 79*/ GIMT_Encode4(951), // Rule ID 153 //
     /*  945 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /*  948 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_ADD'
     /*  948 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /*  951 */ // Label 79: @951
     /*  951 */ GIM_Try, /*On fail goto*//*Label 80*/ GIMT_Encode4(985), // Rule ID 110 //
     /*  956 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule61Enabled),
     /*  959 */   // MIs[0] dst
     /*  959 */   // No operand predicates
     /*  959 */   // MIs[0] __add_sub_reg_match_0.tmp
     /*  959 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  963 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  967 */   // MIs[1] src
     /*  967 */   // No operand predicates
     /*  967 */   // MIs[1] __add_sub_reg_match_0.x
     /*  967 */   // No operand predicates
     /*  967 */   // MIs[0] __add_sub_reg_match_0.x
     /*  967 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  972 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /*  977 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979 */   // Combiner Rule #61: add_sub_reg @ [__add_sub_reg_match_0[1]]
     /*  979 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /*  984 */   GIR_EraseRootFromParent_Done,
     /*  985 */ // Label 80: @985
     /*  985 */ GIM_Try, /*On fail goto*//*Label 81*/ GIMT_Encode4(1019), // Rule ID 109 //
     /*  990 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule61Enabled),
     /*  993 */   // MIs[0] dst
     /*  993 */   // No operand predicates
     /*  993 */   // MIs[0] __add_sub_reg_match_0.x
     /*  993 */   // No operand predicates
     /*  993 */   // MIs[0] __add_sub_reg_match_0.tmp
     /*  993 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  997 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1001 */   // MIs[1] src
     /* 1001 */   // No operand predicates
     /* 1001 */   // MIs[1] __add_sub_reg_match_0.x
     /* 1001 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1006 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1011 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1013 */   // Combiner Rule #61: add_sub_reg @ [__add_sub_reg_match_0[0]]
     /* 1013 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1018 */   GIR_EraseRootFromParent_Done,
     /* 1019 */ // Label 81: @1019
     /* 1019 */ GIM_Try, /*On fail goto*//*Label 82*/ GIMT_Encode4(1042), // Rule ID 84 //
     /* 1024 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule51Enabled),
     /* 1027 */   // MIs[0] dst
     /* 1027 */   // No operand predicates
     /* 1027 */   // MIs[0] lhs
     /* 1027 */   // No operand predicates
     /* 1027 */   // MIs[0] Operand 2
     /* 1027 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1031 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1036 */   // Combiner Rule #51: right_identity_zero @ [__right_identity_zero_match_0[1]]
     /* 1036 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1041 */   GIR_EraseRootFromParent_Done,
     /* 1042 */ // Label 82: @1042
     /* 1042 */ GIM_Reject,
     /* 1043 */ // Label 2: @1043
     /* 1043 */ GIM_Try, /*On fail goto*//*Label 83*/ GIMT_Encode4(1054), // Rule ID 68 //
     /* 1048 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 1051 */   // Combiner Rule #48: constant_fold_binop; wip_match_opcode 'G_SUB'
     /* 1051 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 1054 */ // Label 83: @1054
     /* 1054 */ GIM_Try, /*On fail goto*//*Label 84*/ GIMT_Encode4(1065), // Rule ID 142 //
     /* 1059 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule79Enabled),
     /* 1062 */   // Combiner Rule #79: propagate_undef_any_op; wip_match_opcode 'G_SUB'
     /* 1062 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner59),
     /* 1065 */ // Label 84: @1065
     /* 1065 */ GIM_Try, /*On fail goto*//*Label 85*/ GIMT_Encode4(1088), // Rule ID 83 //
     /* 1070 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule51Enabled),
     /* 1073 */   // MIs[0] dst
     /* 1073 */   // No operand predicates
     /* 1073 */   // MIs[0] lhs
     /* 1073 */   // No operand predicates
     /* 1073 */   // MIs[0] Operand 2
     /* 1073 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1077 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1082 */   // Combiner Rule #51: right_identity_zero @ [__right_identity_zero_match_0[0]]
     /* 1082 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1087 */   GIR_EraseRootFromParent_Done,
     /* 1088 */ // Label 85: @1088
     /* 1088 */ GIM_Reject,
     /* 1089 */ // Label 3: @1089
     /* 1089 */ GIM_Try, /*On fail goto*//*Label 86*/ GIMT_Encode4(1100), // Rule ID 31 //
     /* 1094 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1097 */   // Combiner Rule #24: mul_const; wip_match_opcode 'G_MUL'
     /* 1097 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner16),
     /* 1100 */ // Label 86: @1100
     /* 1100 */ GIM_Try, /*On fail goto*//*Label 87*/ GIMT_Encode4(1111), // Rule ID 65 //
     /* 1105 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 1108 */   // Combiner Rule #48: constant_fold_binop; wip_match_opcode 'G_MUL'
     /* 1108 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 1111 */ // Label 87: @1111
     /* 1111 */ GIM_Try, /*On fail goto*//*Label 88*/ GIMT_Encode4(1122), // Rule ID 125 //
     /* 1116 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule73Enabled),
     /* 1119 */   // Combiner Rule #73: undef_to_int_zero; wip_match_opcode 'G_MUL'
     /* 1119 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner54),
     /* 1122 */ // Label 88: @1122
     /* 1122 */ GIM_Try, /*On fail goto*//*Label 89*/ GIMT_Encode4(1133), // Rule ID 154 //
     /* 1127 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 1130 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_MUL'
     /* 1130 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 1133 */ // Label 89: @1133
     /* 1133 */ GIM_Try, /*On fail goto*//*Label 90*/ GIMT_Encode4(1144), // Rule ID 185 //
     /* 1138 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule92Enabled),
     /* 1141 */   // Combiner Rule #92: combine_mul_cmlt; wip_match_opcode 'G_MUL'
     /* 1141 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner72),
     /* 1144 */ // Label 90: @1144
     /* 1144 */ GIM_Try, /*On fail goto*//*Label 91*/ GIMT_Encode4(1167), // Rule ID 102 //
     /* 1149 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule54Enabled),
     /* 1152 */   // MIs[0] dst
     /* 1152 */   // No operand predicates
     /* 1152 */   // MIs[0] lhs
     /* 1152 */   // No operand predicates
     /* 1152 */   // MIs[0] zero
     /* 1152 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1156 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/2,
     /* 1161 */   // Combiner Rule #54: binop_right_to_zero
     /* 1161 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/2,
     /* 1166 */   GIR_EraseRootFromParent_Done,
     /* 1167 */ // Label 91: @1167
     /* 1167 */ GIM_Try, /*On fail goto*//*Label 92*/ GIMT_Encode4(1190), // Rule ID 107 //
     /* 1172 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule59Enabled),
     /* 1175 */   // MIs[0] dst
     /* 1175 */   // No operand predicates
     /* 1175 */   // MIs[0] x
     /* 1175 */   // No operand predicates
     /* 1175 */   // MIs[0] Operand 2
     /* 1175 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 1179 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1184 */   // Combiner Rule #59: right_identity_one_int
     /* 1184 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1189 */   GIR_EraseRootFromParent_Done,
     /* 1190 */ // Label 92: @1190
     /* 1190 */ GIM_Try, /*On fail goto*//*Label 93*/ GIMT_Encode4(1201), // Rule ID 187 //
     /* 1195 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule94Enabled),
     /* 1198 */   // MIs[0] dst
     /* 1198 */   // No operand predicates
     /* 1198 */   // MIs[0] src1
     /* 1198 */   // No operand predicates
     /* 1198 */   // MIs[0] src2
     /* 1198 */   // No operand predicates
     /* 1198 */   // Combiner Rule #94: extmultomull
     /* 1198 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner74),
     /* 1201 */ // Label 93: @1201
     /* 1201 */ GIM_Reject,
     /* 1202 */ // Label 4: @1202
     /* 1202 */ GIM_Try, /*On fail goto*//*Label 94*/ GIMT_Encode4(1213), // Rule ID 71 //
     /* 1207 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 1210 */   // Combiner Rule #48: constant_fold_binop; wip_match_opcode 'G_SDIV'
     /* 1210 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 1213 */ // Label 94: @1213
     /* 1213 */ GIM_Try, /*On fail goto*//*Label 95*/ GIMT_Encode4(1224), // Rule ID 98 //
     /* 1218 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule53Enabled),
     /* 1221 */   // Combiner Rule #53: binop_left_to_zero; wip_match_opcode 'G_SDIV'
     /* 1221 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner42),
     /* 1224 */ // Label 95: @1224
     /* 1224 */ GIM_Reject,
     /* 1225 */ // Label 5: @1225
     /* 1225 */ GIM_Try, /*On fail goto*//*Label 96*/ GIMT_Encode4(1236), // Rule ID 70 //
     /* 1230 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 1233 */   // Combiner Rule #48: constant_fold_binop; wip_match_opcode 'G_UDIV'
     /* 1233 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 1236 */ // Label 96: @1236
     /* 1236 */ GIM_Try, /*On fail goto*//*Label 97*/ GIMT_Encode4(1247), // Rule ID 99 //
     /* 1241 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule53Enabled),
     /* 1244 */   // Combiner Rule #53: binop_left_to_zero; wip_match_opcode 'G_UDIV'
     /* 1244 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner42),
     /* 1247 */ // Label 97: @1247
     /* 1247 */ GIM_Try, /*On fail goto*//*Label 98*/ GIMT_Encode4(1258), // Rule ID 128 //
     /* 1252 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule75Enabled),
     /* 1255 */   // Combiner Rule #75: binop_left_undef_to_zero; wip_match_opcode 'G_UDIV'
     /* 1255 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner56),
     /* 1258 */ // Label 98: @1258
     /* 1258 */ GIM_Reject,
     /* 1259 */ // Label 6: @1259
     /* 1259 */ GIM_Try, /*On fail goto*//*Label 99*/ GIMT_Encode4(1270), // Rule ID 73 //
     /* 1264 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 1267 */   // Combiner Rule #48: constant_fold_binop; wip_match_opcode 'G_SREM'
     /* 1267 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 1270 */ // Label 99: @1270
     /* 1270 */ GIM_Try, /*On fail goto*//*Label 100*/ GIMT_Encode4(1281), // Rule ID 100 //
     /* 1275 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule53Enabled),
     /* 1278 */   // Combiner Rule #53: binop_left_to_zero; wip_match_opcode 'G_SREM'
     /* 1278 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner42),
     /* 1281 */ // Label 100: @1281
     /* 1281 */ GIM_Reject,
     /* 1282 */ // Label 7: @1282
     /* 1282 */ GIM_Try, /*On fail goto*//*Label 101*/ GIMT_Encode4(1293), // Rule ID 72 //
     /* 1287 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 1290 */   // Combiner Rule #48: constant_fold_binop; wip_match_opcode 'G_UREM'
     /* 1290 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 1293 */ // Label 101: @1293
     /* 1293 */ GIM_Try, /*On fail goto*//*Label 102*/ GIMT_Encode4(1304), // Rule ID 101 //
     /* 1298 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule53Enabled),
     /* 1301 */   // Combiner Rule #53: binop_left_to_zero; wip_match_opcode 'G_UREM'
     /* 1301 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner42),
     /* 1304 */ // Label 102: @1304
     /* 1304 */ GIM_Try, /*On fail goto*//*Label 103*/ GIMT_Encode4(1315), // Rule ID 129 //
     /* 1309 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule75Enabled),
     /* 1312 */   // Combiner Rule #75: binop_left_undef_to_zero; wip_match_opcode 'G_UREM'
     /* 1312 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner56),
     /* 1315 */ // Label 103: @1315
     /* 1315 */ GIM_Reject,
     /* 1316 */ // Label 8: @1316
     /* 1316 */ GIM_Try, /*On fail goto*//*Label 104*/ GIMT_Encode4(1327), // Rule ID 18 //
     /* 1321 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule16Enabled),
     /* 1324 */   // Combiner Rule #16: load_and_mask; wip_match_opcode 'G_AND'
     /* 1324 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner8),
     /* 1327 */ // Label 104: @1327
     /* 1327 */ GIM_Try, /*On fail goto*//*Label 105*/ GIMT_Encode4(1338), // Rule ID 24 //
     /* 1332 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule19Enabled),
     /* 1335 */   // Combiner Rule #19: hoist_logic_op_with_same_opcode_hands; wip_match_opcode 'G_AND'
     /* 1335 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner11),
     /* 1338 */ // Label 105: @1338
     /* 1338 */ GIM_Try, /*On fail goto*//*Label 106*/ GIMT_Encode4(1349), // Rule ID 27 //
     /* 1343 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule20Enabled),
     /* 1346 */   // Combiner Rule #20: redundant_and; wip_match_opcode 'G_AND'
     /* 1346 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner12),
     /* 1349 */ // Label 106: @1349
     /* 1349 */ GIM_Try, /*On fail goto*//*Label 107*/ GIMT_Encode4(1360), // Rule ID 62 //
     /* 1354 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 1357 */   // Combiner Rule #48: constant_fold_binop; wip_match_opcode 'G_AND'
     /* 1357 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 1360 */ // Label 107: @1360
     /* 1360 */ GIM_Try, /*On fail goto*//*Label 108*/ GIMT_Encode4(1371), // Rule ID 120 //
     /* 1365 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule70Enabled),
     /* 1368 */   // Combiner Rule #70: overlapping_and; wip_match_opcode 'G_AND'
     /* 1368 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner51),
     /* 1371 */ // Label 108: @1371
     /* 1371 */ GIM_Try, /*On fail goto*//*Label 109*/ GIMT_Encode4(1382), // Rule ID 124 //
     /* 1376 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule73Enabled),
     /* 1379 */   // Combiner Rule #73: undef_to_int_zero; wip_match_opcode 'G_AND'
     /* 1379 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner54),
     /* 1382 */ // Label 109: @1382
     /* 1382 */ GIM_Try, /*On fail goto*//*Label 110*/ GIMT_Encode4(1393), // Rule ID 155 //
     /* 1387 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 1390 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_AND'
     /* 1390 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 1393 */ // Label 110: @1393
     /* 1393 */ GIM_Try, /*On fail goto*//*Label 111*/ GIMT_Encode4(1430), // Rule ID 34 //
     /* 1398 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule27Enabled),
     /* 1401 */   // MIs[0] root
     /* 1401 */   // No operand predicates
     /* 1401 */   // MIs[0] shift
     /* 1401 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1405 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 1409 */   // MIs[1] x
     /* 1409 */   // No operand predicates
     /* 1409 */   // MIs[1] lsb
     /* 1409 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1413 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1417 */   // MIs[2] imm1
     /* 1417 */   // No operand predicates
     /* 1417 */   // MIs[0] mask
     /* 1417 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 1421 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425 */   // MIs[3] imm2
     /* 1425 */   // No operand predicates
     /* 1425 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1427 */   // Combiner Rule #27: bitfield_extract_from_and
     /* 1427 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner19),
     /* 1430 */ // Label 111: @1430
     /* 1430 */ GIM_Try, /*On fail goto*//*Label 112*/ GIMT_Encode4(1454), // Rule ID 93 //
     /* 1435 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule52Enabled),
     /* 1438 */   // MIs[0] dst
     /* 1438 */   // No operand predicates
     /* 1438 */   // MIs[0] src
     /* 1438 */   // No operand predicates
     /* 1438 */   // MIs[0] src
     /* 1438 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1443 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1448 */   // Combiner Rule #52: binop_same_val @ [__binop_same_val_match_0[0]]
     /* 1448 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1453 */   GIR_EraseRootFromParent_Done,
     /* 1454 */ // Label 112: @1454
     /* 1454 */ GIM_Reject,
     /* 1455 */ // Label 9: @1455
     /* 1455 */ GIM_Try, /*On fail goto*//*Label 113*/ GIMT_Encode4(1466), // Rule ID 25 //
     /* 1460 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule19Enabled),
     /* 1463 */   // Combiner Rule #19: hoist_logic_op_with_same_opcode_hands; wip_match_opcode 'G_OR'
     /* 1463 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner11),
     /* 1466 */ // Label 113: @1466
     /* 1466 */ GIM_Try, /*On fail goto*//*Label 114*/ GIMT_Encode4(1477), // Rule ID 30 //
     /* 1471 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule23Enabled),
     /* 1474 */   // Combiner Rule #23: redundant_or; wip_match_opcode 'G_OR'
     /* 1474 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner15),
     /* 1477 */ // Label 114: @1477
     /* 1477 */ GIM_Try, /*On fail goto*//*Label 115*/ GIMT_Encode4(1488), // Rule ID 66 //
     /* 1482 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 1485 */   // Combiner Rule #48: constant_fold_binop; wip_match_opcode 'G_OR'
     /* 1485 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 1488 */ // Label 115: @1488
     /* 1488 */ GIM_Try, /*On fail goto*//*Label 116*/ GIMT_Encode4(1499), // Rule ID 126 //
     /* 1493 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule74Enabled),
     /* 1496 */   // Combiner Rule #74: undef_to_negative_one; wip_match_opcode 'G_OR'
     /* 1496 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner55),
     /* 1499 */ // Label 116: @1499
     /* 1499 */ GIM_Try, /*On fail goto*//*Label 117*/ GIMT_Encode4(1510), // Rule ID 156 //
     /* 1504 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 1507 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_OR'
     /* 1507 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 1510 */ // Label 117: @1510
     /* 1510 */ GIM_Try, /*On fail goto*//*Label 118*/ GIMT_Encode4(1534), // Rule ID 94 //
     /* 1515 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule52Enabled),
     /* 1518 */   // MIs[0] dst
     /* 1518 */   // No operand predicates
     /* 1518 */   // MIs[0] src
     /* 1518 */   // No operand predicates
     /* 1518 */   // MIs[0] src
     /* 1518 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1523 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1528 */   // Combiner Rule #52: binop_same_val @ [__binop_same_val_match_0[1]]
     /* 1528 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1533 */   GIR_EraseRootFromParent_Done,
     /* 1534 */ // Label 118: @1534
     /* 1534 */ GIM_Try, /*On fail goto*//*Label 119*/ GIMT_Encode4(1557), // Rule ID 85 //
     /* 1539 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule51Enabled),
     /* 1542 */   // MIs[0] dst
     /* 1542 */   // No operand predicates
     /* 1542 */   // MIs[0] lhs
     /* 1542 */   // No operand predicates
     /* 1542 */   // MIs[0] Operand 2
     /* 1542 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1546 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1551 */   // Combiner Rule #51: right_identity_zero @ [__right_identity_zero_match_0[2]]
     /* 1551 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1556 */   GIR_EraseRootFromParent_Done,
     /* 1557 */ // Label 119: @1557
     /* 1557 */ GIM_Try, /*On fail goto*//*Label 120*/ GIMT_Encode4(1568), // Rule ID 151 //
     /* 1562 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 1565 */   // MIs[0] dst
     /* 1565 */   // No operand predicates
     /* 1565 */   // MIs[0] src1
     /* 1565 */   // No operand predicates
     /* 1565 */   // MIs[0] src2
     /* 1565 */   // No operand predicates
     /* 1565 */   // Combiner Rule #85: or_to_bsp
     /* 1565 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner65),
     /* 1568 */ // Label 120: @1568
     /* 1568 */ GIM_Reject,
     /* 1569 */ // Label 10: @1569
     /* 1569 */ GIM_Try, /*On fail goto*//*Label 121*/ GIMT_Encode4(1580), // Rule ID 26 //
     /* 1574 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule19Enabled),
     /* 1577 */   // Combiner Rule #19: hoist_logic_op_with_same_opcode_hands; wip_match_opcode 'G_XOR'
     /* 1577 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner11),
     /* 1580 */ // Label 121: @1580
     /* 1580 */ GIM_Try, /*On fail goto*//*Label 122*/ GIMT_Encode4(1591), // Rule ID 28 //
     /* 1585 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule21Enabled),
     /* 1588 */   // Combiner Rule #21: xor_of_and_with_same_reg; wip_match_opcode 'G_XOR'
     /* 1588 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 1591 */ // Label 122: @1591
     /* 1591 */ GIM_Try, /*On fail goto*//*Label 123*/ GIMT_Encode4(1602), // Rule ID 69 //
     /* 1596 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 1599 */   // Combiner Rule #48: constant_fold_binop; wip_match_opcode 'G_XOR'
     /* 1599 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 1602 */ // Label 123: @1602
     /* 1602 */ GIM_Try, /*On fail goto*//*Label 124*/ GIMT_Encode4(1613), // Rule ID 143 //
     /* 1607 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule79Enabled),
     /* 1610 */   // Combiner Rule #79: propagate_undef_any_op; wip_match_opcode 'G_XOR'
     /* 1610 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner59),
     /* 1613 */ // Label 124: @1613
     /* 1613 */ GIM_Try, /*On fail goto*//*Label 125*/ GIMT_Encode4(1624), // Rule ID 157 //
     /* 1618 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 1621 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_XOR'
     /* 1621 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 1624 */ // Label 125: @1624
     /* 1624 */ GIM_Try, /*On fail goto*//*Label 126*/ GIMT_Encode4(1647), // Rule ID 86 //
     /* 1629 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule51Enabled),
     /* 1632 */   // MIs[0] dst
     /* 1632 */   // No operand predicates
     /* 1632 */   // MIs[0] lhs
     /* 1632 */   // No operand predicates
     /* 1632 */   // MIs[0] Operand 2
     /* 1632 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1636 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1641 */   // Combiner Rule #51: right_identity_zero @ [__right_identity_zero_match_0[3]]
     /* 1641 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1646 */   GIR_EraseRootFromParent_Done,
     /* 1647 */ // Label 126: @1647
     /* 1647 */ GIM_Reject,
     /* 1648 */ // Label 11: @1648
     /* 1648 */ GIM_Try, /*On fail goto*//*Label 127*/ GIMT_Encode4(1659), // Rule ID 51 //
     /* 1653 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule39Enabled),
     /* 1656 */   // Combiner Rule #39: unmerge_anyext_build_vector; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 1656 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner30),
     /* 1659 */ // Label 127: @1659
     /* 1659 */ GIM_Try, /*On fail goto*//*Label 128*/ GIMT_Encode4(1670), // Rule ID 52 //
     /* 1664 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule40Enabled),
     /* 1667 */   // Combiner Rule #40: unmerge_merge; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 1667 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner31),
     /* 1670 */ // Label 128: @1670
     /* 1670 */ GIM_Try, /*On fail goto*//*Label 129*/ GIMT_Encode4(1681), // Rule ID 54 //
     /* 1675 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule42Enabled),
     /* 1678 */   // Combiner Rule #42: unmerge_cst; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 1678 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner33),
     /* 1681 */ // Label 129: @1681
     /* 1681 */ GIM_Try, /*On fail goto*//*Label 130*/ GIMT_Encode4(1692), // Rule ID 55 //
     /* 1686 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule43Enabled),
     /* 1689 */   // Combiner Rule #43: unmerge_undef; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 1689 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner34),
     /* 1692 */ // Label 130: @1692
     /* 1692 */ GIM_Try, /*On fail goto*//*Label 131*/ GIMT_Encode4(1703), // Rule ID 56 //
     /* 1697 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule44Enabled),
     /* 1700 */   // Combiner Rule #44: unmerge_dead_to_trunc; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 1700 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner35),
     /* 1703 */ // Label 131: @1703
     /* 1703 */ GIM_Try, /*On fail goto*//*Label 132*/ GIMT_Encode4(1714), // Rule ID 57 //
     /* 1708 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule45Enabled),
     /* 1711 */   // Combiner Rule #45: unmerge_zext_to_zext; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 1711 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner36),
     /* 1714 */ // Label 132: @1714
     /* 1714 */ GIM_Reject,
     /* 1715 */ // Label 12: @1715
     /* 1715 */ GIM_Try, /*On fail goto*//*Label 133*/ GIMT_Encode4(1726), // Rule ID 50 //
     /* 1720 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule38Enabled),
     /* 1723 */   // Combiner Rule #38: fold_merge_to_zext; wip_match_opcode 'G_MERGE_VALUES'
     /* 1723 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner29),
     /* 1726 */ // Label 133: @1726
     /* 1726 */ GIM_Try, /*On fail goto*//*Label 134*/ GIMT_Encode4(1737), // Rule ID 53 //
     /* 1731 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule41Enabled),
     /* 1734 */   // Combiner Rule #41: merge_unmerge; wip_match_opcode 'G_MERGE_VALUES'
     /* 1734 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner32),
     /* 1737 */ // Label 134: @1737
     /* 1737 */ GIM_Try, /*On fail goto*//*Label 135*/ GIMT_Encode4(1799),
     /* 1742 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 1745 */   GIM_Try, /*On fail goto*//*Label 136*/ GIMT_Encode4(1766), // Rule ID 58 //
     /* 1750 */     GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule46Enabled),
     /* 1753 */     // MIs[0] root
     /* 1753 */     // No operand predicates
     /* 1753 */     // MIs[0] x
     /* 1753 */     // No operand predicates
     /* 1753 */     // MIs[0] undef
     /* 1753 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 1761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1763 */     // Combiner Rule #46: merge_of_x_and_undef
     /* 1763 */     GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 1766 */   // Label 136: @1766
     /* 1766 */   GIM_Try, /*On fail goto*//*Label 137*/ GIMT_Encode4(1798), // Rule ID 59 //
     /* 1771 */     GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule47Enabled),
     /* 1774 */     // MIs[0] root
     /* 1774 */     // No operand predicates
     /* 1774 */     // MIs[0] x
     /* 1774 */     // No operand predicates
     /* 1774 */     // MIs[0] zero
     /* 1774 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1782 */     // MIs[1] Operand 1
     /* 1782 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/1, GIMT_Encode8(0),
     /* 1793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1795 */     // Combiner Rule #47: merge_of_x_and_zero
     /* 1795 */     GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 1798 */   // Label 137: @1798
     /* 1798 */   GIM_Reject,
     /* 1799 */ // Label 135: @1799
     /* 1799 */ GIM_Reject,
     /* 1800 */ // Label 13: @1800
     /* 1800 */ GIM_Try, /*On fail goto*//*Label 138*/ GIMT_Encode4(1811), // Rule ID 112 //
     /* 1805 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule62Enabled),
     /* 1808 */   // Combiner Rule #62: buildvector_identity_fold; wip_match_opcode 'G_BUILD_VECTOR'
     /* 1808 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner46),
     /* 1811 */ // Label 138: @1811
     /* 1811 */ GIM_Try, /*On fail goto*//*Label 139*/ GIMT_Encode4(1822), // Rule ID 145 //
     /* 1816 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule80Enabled),
     /* 1819 */   // Combiner Rule #80: propagate_undef_all_ops; wip_match_opcode 'G_BUILD_VECTOR'
     /* 1819 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner60),
     /* 1822 */ // Label 139: @1822
     /* 1822 */ GIM_Try, /*On fail goto*//*Label 140*/ GIMT_Encode4(1833), // Rule ID 183 //
     /* 1827 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule90Enabled),
     /* 1830 */   // Combiner Rule #90: extract_all_elts_from_build_vector; wip_match_opcode 'G_BUILD_VECTOR'
     /* 1830 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner70),
     /* 1833 */ // Label 140: @1833
     /* 1833 */ GIM_Try, /*On fail goto*//*Label 141*/ GIMT_Encode4(1847), // Rule ID 186 //
     /* 1838 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule93Enabled),
     /* 1841 */   GIM_CheckNumOperandsGE, /*MI*/0, /*Expected*/2,
     /* 1844 */   // MIs[0] dst
     /* 1844 */   // No operand predicates
     /* 1844 */   // MIs[0] unused
     /* 1844 */   // No operand predicates
     /* 1844 */   // Combiner Rule #93: combine_use_vector_truncate
     /* 1844 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner73),
     /* 1847 */ // Label 141: @1847
     /* 1847 */ GIM_Reject,
     /* 1848 */ // Label 14: @1848
     /* 1848 */ GIM_Try, /*On fail goto*//*Label 142*/ GIMT_Encode4(1859), // Rule ID 111 //
     /* 1853 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule62Enabled),
     /* 1856 */   // Combiner Rule #62: buildvector_identity_fold; wip_match_opcode 'G_BUILD_VECTOR_TRUNC'
     /* 1856 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner46),
     /* 1859 */ // Label 142: @1859
     /* 1859 */ GIM_Reject,
     /* 1860 */ // Label 15: @1860
     /* 1860 */ GIM_Try, /*On fail goto*//*Label 143*/ GIMT_Encode4(1871), // Rule ID 152 //
     /* 1865 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 1868 */   // Combiner Rule #86: combine_concat_vector; wip_match_opcode 'G_CONCAT_VECTORS'
     /* 1868 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner66),
     /* 1871 */ // Label 143: @1871
     /* 1871 */ GIM_Reject,
     /* 1872 */ // Label 16: @1872
     /* 1872 */ GIM_Try, /*On fail goto*//*Label 144*/ GIMT_Encode4(1893), // Rule ID 104 //
     /* 1877 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule56Enabled),
     /* 1880 */   // MIs[0] dst
     /* 1880 */   // No operand predicates
     /* 1880 */   // MIs[0] t
     /* 1880 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1884 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTTOPTR),
     /* 1888 */   // MIs[1] ptr
     /* 1888 */   // No operand predicates
     /* 1888 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1890 */   // Combiner Rule #56: i2p_to_p2i
     /* 1890 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 1893 */ // Label 144: @1893
     /* 1893 */ GIM_Try, /*On fail goto*//*Label 145*/ GIMT_Encode4(1914), // Rule ID 137 //
     /* 1898 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 1901 */   // MIs[0] dst
     /* 1901 */   // No operand predicates
     /* 1901 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 1901 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1905 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 1909 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1911 */   // Combiner Rule #78: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[3]]
     /* 1911 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner58),
     /* 1914 */ // Label 145: @1914
     /* 1914 */ GIM_Reject,
     /* 1915 */ // Label 17: @1915
     /* 1915 */ GIM_Try, /*On fail goto*//*Label 146*/ GIMT_Encode4(1926), // Rule ID 103 //
     /* 1920 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule55Enabled),
     /* 1923 */   // Combiner Rule #55: p2i_to_i2p; wip_match_opcode 'G_INTTOPTR'
     /* 1923 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner43),
     /* 1926 */ // Label 146: @1926
     /* 1926 */ GIM_Try, /*On fail goto*//*Label 147*/ GIMT_Encode4(1947), // Rule ID 138 //
     /* 1931 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 1934 */   // MIs[0] dst
     /* 1934 */   // No operand predicates
     /* 1934 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 1934 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1938 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 1942 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1944 */   // Combiner Rule #78: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[4]]
     /* 1944 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner58),
     /* 1947 */ // Label 147: @1947
     /* 1947 */ GIM_Reject,
     /* 1948 */ // Label 18: @1948
     /* 1948 */ GIM_Try, /*On fail goto*//*Label 148*/ GIMT_Encode4(1969), // Rule ID 115 //
     /* 1953 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule65Enabled),
     /* 1956 */   // MIs[0] dst
     /* 1956 */   // No operand predicates
     /* 1956 */   // MIs[0] src1
     /* 1956 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1960 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 1964 */   // MIs[1] src0
     /* 1964 */   // No operand predicates
     /* 1964 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1966 */   // Combiner Rule #65: bitcast_bitcast_fold
     /* 1966 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner49),
     /* 1969 */ // Label 148: @1969
     /* 1969 */ GIM_Try, /*On fail goto*//*Label 149*/ GIMT_Encode4(1990), // Rule ID 135 //
     /* 1974 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 1977 */   // MIs[0] dst
     /* 1977 */   // No operand predicates
     /* 1977 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 1977 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1981 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 1985 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1987 */   // Combiner Rule #78: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[1]]
     /* 1987 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner58),
     /* 1990 */ // Label 149: @1990
     /* 1990 */ GIM_Reject,
     /* 1991 */ // Label 19: @1991
     /* 1991 */ GIM_Try, /*On fail goto*//*Label 150*/ GIMT_Encode4(2002), // Rule ID 184 //
     /* 1996 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule91Enabled),
     /* 1999 */   // MIs[0] dst
     /* 1999 */   // No operand predicates
     /* 1999 */   // MIs[0] src
     /* 1999 */   // No operand predicates
     /* 1999 */   // Combiner Rule #91: push_freeze_to_prevent_poison_from_propagating
     /* 1999 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner71),
     /* 2002 */ // Label 150: @2002
     /* 2002 */ GIM_Reject,
     /* 2003 */ // Label 20: @2003
     /* 2003 */ GIM_Try, /*On fail goto*//*Label 151*/ GIMT_Encode4(2014), // Rule ID 15 //
     /* 2008 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule15Enabled),
     /* 2011 */   // Combiner Rule #15: extending_loads; wip_match_opcode 'G_LOAD'
     /* 2011 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner7),
     /* 2014 */ // Label 151: @2014
     /* 2014 */ GIM_Try, /*On fail goto*//*Label 152*/ GIMT_Encode4(2025), // Rule ID 19 //
     /* 2019 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule17Enabled),
     /* 2022 */   // Combiner Rule #17: combine_indexed_load_store; wip_match_opcode 'G_LOAD'
     /* 2022 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner9),
     /* 2025 */ // Label 152: @2025
     /* 2025 */ GIM_Reject,
     /* 2026 */ // Label 21: @2026
     /* 2026 */ GIM_Try, /*On fail goto*//*Label 153*/ GIMT_Encode4(2037), // Rule ID 16 //
     /* 2031 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule15Enabled),
     /* 2034 */   // Combiner Rule #15: extending_loads; wip_match_opcode 'G_SEXTLOAD'
     /* 2034 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner7),
     /* 2037 */ // Label 153: @2037
     /* 2037 */ GIM_Try, /*On fail goto*//*Label 154*/ GIMT_Encode4(2048), // Rule ID 20 //
     /* 2042 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule17Enabled),
     /* 2045 */   // Combiner Rule #17: combine_indexed_load_store; wip_match_opcode 'G_SEXTLOAD'
     /* 2045 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner9),
     /* 2048 */ // Label 154: @2048
     /* 2048 */ GIM_Reject,
     /* 2049 */ // Label 22: @2049
     /* 2049 */ GIM_Try, /*On fail goto*//*Label 155*/ GIMT_Encode4(2060), // Rule ID 17 //
     /* 2054 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule15Enabled),
     /* 2057 */   // Combiner Rule #15: extending_loads; wip_match_opcode 'G_ZEXTLOAD'
     /* 2057 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner7),
     /* 2060 */ // Label 155: @2060
     /* 2060 */ GIM_Try, /*On fail goto*//*Label 156*/ GIMT_Encode4(2071), // Rule ID 21 //
     /* 2065 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule17Enabled),
     /* 2068 */   // Combiner Rule #17: combine_indexed_load_store; wip_match_opcode 'G_ZEXTLOAD'
     /* 2068 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner9),
     /* 2071 */ // Label 156: @2071
     /* 2071 */ GIM_Reject,
     /* 2072 */ // Label 23: @2072
     /* 2072 */ GIM_Try, /*On fail goto*//*Label 157*/ GIMT_Encode4(2083), // Rule ID 22 //
     /* 2077 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule17Enabled),
     /* 2080 */   // Combiner Rule #17: combine_indexed_load_store; wip_match_opcode 'G_STORE'
     /* 2080 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner9),
     /* 2083 */ // Label 157: @2083
     /* 2083 */ GIM_Try, /*On fail goto*//*Label 158*/ GIMT_Encode4(2094), // Rule ID 147 //
     /* 2088 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule82Enabled),
     /* 2091 */   // Combiner Rule #82: erase_undef_store; wip_match_opcode 'G_STORE'
     /* 2091 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner62),
     /* 2094 */ // Label 158: @2094
     /* 2094 */ GIM_Try, /*On fail goto*//*Label 159*/ GIMT_Encode4(2105), // Rule ID 121 //
     /* 2099 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule71Enabled),
     /* 2102 */   // MIs[0] src
     /* 2102 */   // No operand predicates
     /* 2102 */   // MIs[0] addr
     /* 2102 */   // No operand predicates
     /* 2102 */   // Combiner Rule #71: split_store_zero_128
     /* 2102 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner52),
     /* 2105 */ // Label 159: @2105
     /* 2105 */ GIM_Reject,
     /* 2106 */ // Label 24: @2106
     /* 2106 */ GIM_Try, /*On fail goto*//*Label 160*/ GIMT_Encode4(2117), // Rule ID 14 //
     /* 2111 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule14Enabled),
     /* 2114 */   // Combiner Rule #14: mutate_anyext_to_zext; wip_match_opcode 'G_ANYEXT'
     /* 2114 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner6),
     /* 2117 */ // Label 160: @2117
     /* 2117 */ GIM_Try, /*On fail goto*//*Label 161*/ GIMT_Encode4(2128), // Rule ID 105 //
     /* 2122 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule57Enabled),
     /* 2125 */   // Combiner Rule #57: anyext_trunc_fold; wip_match_opcode 'G_ANYEXT'
     /* 2125 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 2128 */ // Label 161: @2128
     /* 2128 */ GIM_Try, /*On fail goto*//*Label 162*/ GIMT_Encode4(2149), // Rule ID 8 //
     /* 2133 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule8Enabled),
     /* 2136 */   // MIs[0] root
     /* 2136 */   // No operand predicates
     /* 2136 */   // MIs[0] second
     /* 2136 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2140 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 2144 */   // MIs[1] src
     /* 2144 */   // No operand predicates
     /* 2144 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2146 */   // Combiner Rule #8: anyext_of_anyext
     /* 2146 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner2),
     /* 2149 */ // Label 162: @2149
     /* 2149 */ GIM_Try, /*On fail goto*//*Label 163*/ GIMT_Encode4(2170), // Rule ID 10 //
     /* 2154 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule10Enabled),
     /* 2157 */   // MIs[0] root
     /* 2157 */   // No operand predicates
     /* 2157 */   // MIs[0] second
     /* 2157 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2161 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2165 */   // MIs[1] src
     /* 2165 */   // No operand predicates
     /* 2165 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2167 */   // Combiner Rule #10: anyext_of_sext
     /* 2167 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner2),
     /* 2170 */ // Label 163: @2170
     /* 2170 */ GIM_Try, /*On fail goto*//*Label 164*/ GIMT_Encode4(2191), // Rule ID 9 //
     /* 2175 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule9Enabled),
     /* 2178 */   // MIs[0] root
     /* 2178 */   // No operand predicates
     /* 2178 */   // MIs[0] second
     /* 2178 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2182 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2186 */   // MIs[1] src
     /* 2186 */   // No operand predicates
     /* 2186 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2188 */   // Combiner Rule #9: anyext_of_zext
     /* 2188 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner2),
     /* 2191 */ // Label 164: @2191
     /* 2191 */ GIM_Try, /*On fail goto*//*Label 165*/ GIMT_Encode4(2212), // Rule ID 136 //
     /* 2196 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 2199 */   // MIs[0] dst
     /* 2199 */   // No operand predicates
     /* 2199 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 2199 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2203 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 2207 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2209 */   // Combiner Rule #78: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[2]]
     /* 2209 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner58),
     /* 2212 */ // Label 165: @2212
     /* 2212 */ GIM_Reject,
     /* 2213 */ // Label 25: @2213
     /* 2213 */ GIM_Try, /*On fail goto*//*Label 166*/ GIMT_Encode4(2224), // Rule ID 113 //
     /* 2218 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule63Enabled),
     /* 2221 */   // Combiner Rule #63: trunc_buildvector_fold; wip_match_opcode 'G_TRUNC'
     /* 2221 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner47),
     /* 2224 */ // Label 166: @2224
     /* 2224 */ GIM_Try, /*On fail goto*//*Label 167*/ GIMT_Encode4(2235), // Rule ID 114 //
     /* 2229 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule64Enabled),
     /* 2232 */   // Combiner Rule #64: trunc_lshr_buildvector_fold; wip_match_opcode 'G_TRUNC'
     /* 2232 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner48),
     /* 2235 */ // Label 167: @2235
     /* 2235 */ GIM_Try, /*On fail goto*//*Label 168*/ GIMT_Encode4(2256), // Rule ID 3 //
     /* 2240 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule3Enabled),
     /* 2243 */   // MIs[0] root
     /* 2243 */   // No operand predicates
     /* 2243 */   // MIs[0] ext
     /* 2243 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2247 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 2251 */   // MIs[1] src
     /* 2251 */   // No operand predicates
     /* 2251 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2253 */   // Combiner Rule #3: truncate_of_anyext
     /* 2253 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner1),
     /* 2256 */ // Label 168: @2256
     /* 2256 */ GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(2280), // Rule ID 12 //
     /* 2261 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule12Enabled),
     /* 2264 */   // MIs[0] root
     /* 2264 */   // No operand predicates
     /* 2264 */   // MIs[0] bv
     /* 2264 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2268 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 2272 */   GIM_CheckNumOperandsGE, /*MI*/1, /*Expected*/2,
     /* 2275 */   // MIs[1] unused
     /* 2275 */   // No operand predicates
     /* 2275 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2277 */   // Combiner Rule #12: buildvector_of_truncate
     /* 2277 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner4),
     /* 2280 */ // Label 169: @2280
     /* 2280 */ GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(2301), // Rule ID 2 //
     /* 2285 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule2Enabled),
     /* 2288 */   // MIs[0] root
     /* 2288 */   // No operand predicates
     /* 2288 */   // MIs[0] ext
     /* 2288 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2292 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2296 */   // MIs[1] src
     /* 2296 */   // No operand predicates
     /* 2296 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2298 */   // Combiner Rule #2: truncate_of_sext
     /* 2298 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner1),
     /* 2301 */ // Label 170: @2301
     /* 2301 */ GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(2322), // Rule ID 1 //
     /* 2306 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule1Enabled),
     /* 2309 */   // MIs[0] root
     /* 2309 */   // No operand predicates
     /* 2309 */   // MIs[0] ext
     /* 2309 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2313 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2317 */   // MIs[1] src
     /* 2317 */   // No operand predicates
     /* 2317 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2319 */   // Combiner Rule #1: truncate_of_zext
     /* 2319 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner1),
     /* 2322 */ // Label 171: @2322
     /* 2322 */ GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(2343), // Rule ID 134 //
     /* 2327 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 2330 */   // MIs[0] dst
     /* 2330 */   // No operand predicates
     /* 2330 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 2330 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2334 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 2338 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2340 */   // Combiner Rule #78: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[0]]
     /* 2340 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner58),
     /* 2343 */ // Label 172: @2343
     /* 2343 */ GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(2364), // Rule ID 13 //
     /* 2348 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule13Enabled),
     /* 2351 */   // MIs[0] root
     /* 2351 */   // No operand predicates
     /* 2351 */   // MIs[0] int
     /* 2351 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2355 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2359 */   // MIs[1] imm
     /* 2359 */   // No operand predicates
     /* 2359 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2361 */   // Combiner Rule #13: integer_of_truncate
     /* 2361 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner5),
     /* 2364 */ // Label 173: @2364
     /* 2364 */ GIM_Reject,
     /* 2365 */ // Label 26: @2365
     /* 2365 */ GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(2386), // Rule ID 7 //
     /* 2370 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule7Enabled),
     /* 2373 */   // MIs[0] root
     /* 2373 */   // No operand predicates
     /* 2373 */   // MIs[0] second
     /* 2373 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2377 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 2381 */   // MIs[1] src
     /* 2381 */   // No operand predicates
     /* 2381 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2383 */   // Combiner Rule #7: sext_of_anyext
     /* 2383 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner2),
     /* 2386 */ // Label 174: @2386
     /* 2386 */ GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(2407), // Rule ID 6 //
     /* 2391 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule6Enabled),
     /* 2394 */   // MIs[0] root
     /* 2394 */   // No operand predicates
     /* 2394 */   // MIs[0] second
     /* 2394 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2398 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2402 */   // MIs[1] src
     /* 2402 */   // No operand predicates
     /* 2402 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2404 */   // Combiner Rule #6: sext_of_sext
     /* 2404 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner2),
     /* 2407 */ // Label 175: @2407
     /* 2407 */ GIM_Reject,
     /* 2408 */ // Label 27: @2408
     /* 2408 */ GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(2419), // Rule ID 23 //
     /* 2413 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule18Enabled),
     /* 2416 */   // Combiner Rule #18: sext_trunc_sextload; wip_match_opcode 'G_SEXT_INREG'
     /* 2416 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner10),
     /* 2419 */ // Label 176: @2419
     /* 2419 */ GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(2430), // Rule ID 32 //
     /* 2424 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule25Enabled),
     /* 2427 */   // Combiner Rule #25: redundant_sext_inreg; wip_match_opcode 'G_SEXT_INREG'
     /* 2427 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner17),
     /* 2430 */ // Label 177: @2430
     /* 2430 */ GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(2441), // Rule ID 33 //
     /* 2435 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule26Enabled),
     /* 2438 */   // Combiner Rule #26: bitfield_extract_from_sext_inreg; wip_match_opcode 'G_SEXT_INREG'
     /* 2438 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner18),
     /* 2441 */ // Label 178: @2441
     /* 2441 */ GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(2462), // Rule ID 11 //
     /* 2446 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule11Enabled),
     /* 2449 */   // MIs[0] dst
     /* 2449 */   // No operand predicates
     /* 2449 */   // MIs[0] x
     /* 2449 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2453 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 2457 */   // MIs[1] src
     /* 2457 */   // No operand predicates
     /* 2457 */   // MIs[1] a
     /* 2457 */   // No operand predicates
     /* 2457 */   // MIs[0] b
     /* 2457 */   // No operand predicates
     /* 2457 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2459 */   // Combiner Rule #11: sext_inreg_of_sext_inreg
     /* 2459 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner3),
     /* 2462 */ // Label 179: @2462
     /* 2462 */ GIM_Reject,
     /* 2463 */ // Label 28: @2463
     /* 2463 */ GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(2484), // Rule ID 5 //
     /* 2468 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /* 2471 */   // MIs[0] root
     /* 2471 */   // No operand predicates
     /* 2471 */   // MIs[0] second
     /* 2471 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2475 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 2479 */   // MIs[1] src
     /* 2479 */   // No operand predicates
     /* 2479 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2481 */   // Combiner Rule #5: zext_of_anyext
     /* 2481 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner2),
     /* 2484 */ // Label 180: @2484
     /* 2484 */ GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(2505), // Rule ID 4 //
     /* 2489 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule4Enabled),
     /* 2492 */   // MIs[0] root
     /* 2492 */   // No operand predicates
     /* 2492 */   // MIs[0] second
     /* 2492 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2496 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2500 */   // MIs[1] src
     /* 2500 */   // No operand predicates
     /* 2500 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2502 */   // Combiner Rule #4: zext_of_zext
     /* 2502 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner2),
     /* 2505 */ // Label 181: @2505
     /* 2505 */ GIM_Reject,
     /* 2506 */ // Label 29: @2506
     /* 2506 */ GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(2517), // Rule ID 67 //
     /* 2511 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 2514 */   // Combiner Rule #48: constant_fold_binop; wip_match_opcode 'G_SHL'
     /* 2514 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 2517 */ // Label 182: @2517
     /* 2517 */ GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(2528), // Rule ID 95 //
     /* 2522 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule53Enabled),
     /* 2525 */   // Combiner Rule #53: binop_left_to_zero; wip_match_opcode 'G_SHL'
     /* 2525 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner42),
     /* 2528 */ // Label 183: @2528
     /* 2528 */ GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(2539), // Rule ID 127 //
     /* 2533 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule75Enabled),
     /* 2536 */   // Combiner Rule #75: binop_left_undef_to_zero; wip_match_opcode 'G_SHL'
     /* 2536 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner56),
     /* 2539 */ // Label 184: @2539
     /* 2539 */ GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(2550), // Rule ID 130 //
     /* 2544 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 2547 */   // Combiner Rule #76: binop_right_undef_to_undef; wip_match_opcode 'G_SHL'
     /* 2547 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner57),
     /* 2550 */ // Label 185: @2550
     /* 2550 */ GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(2573), // Rule ID 87 //
     /* 2555 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule51Enabled),
     /* 2558 */   // MIs[0] dst
     /* 2558 */   // No operand predicates
     /* 2558 */   // MIs[0] lhs
     /* 2558 */   // No operand predicates
     /* 2558 */   // MIs[0] Operand 2
     /* 2558 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 2562 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2567 */   // Combiner Rule #51: right_identity_zero @ [__right_identity_zero_match_0[4]]
     /* 2567 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2572 */   GIR_EraseRootFromParent_Done,
     /* 2573 */ // Label 186: @2573
     /* 2573 */ GIM_Reject,
     /* 2574 */ // Label 30: @2574
     /* 2574 */ GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(2585), // Rule ID 36 //
     /* 2579 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule28Enabled),
     /* 2582 */   // Combiner Rule #28: bitfield_extract_from_shr; wip_match_opcode 'G_LSHR'
     /* 2582 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner20),
     /* 2585 */ // Label 187: @2585
     /* 2585 */ GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(2596), // Rule ID 38 //
     /* 2590 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule29Enabled),
     /* 2593 */   // Combiner Rule #29: bitfield_extract_from_shr_and; wip_match_opcode 'G_LSHR'
     /* 2593 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 2596 */ // Label 188: @2596
     /* 2596 */ GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(2607), // Rule ID 64 //
     /* 2601 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 2604 */   // Combiner Rule #48: constant_fold_binop; wip_match_opcode 'G_LSHR'
     /* 2604 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 2607 */ // Label 189: @2607
     /* 2607 */ GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(2618), // Rule ID 96 //
     /* 2612 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule53Enabled),
     /* 2615 */   // Combiner Rule #53: binop_left_to_zero; wip_match_opcode 'G_LSHR'
     /* 2615 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner42),
     /* 2618 */ // Label 190: @2618
     /* 2618 */ GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(2629), // Rule ID 132 //
     /* 2623 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 2626 */   // Combiner Rule #76: binop_right_undef_to_undef; wip_match_opcode 'G_LSHR'
     /* 2626 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner57),
     /* 2629 */ // Label 191: @2629
     /* 2629 */ GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(2652), // Rule ID 89 //
     /* 2634 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule51Enabled),
     /* 2637 */   // MIs[0] dst
     /* 2637 */   // No operand predicates
     /* 2637 */   // MIs[0] lhs
     /* 2637 */   // No operand predicates
     /* 2637 */   // MIs[0] Operand 2
     /* 2637 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 2641 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2646 */   // Combiner Rule #51: right_identity_zero @ [__right_identity_zero_match_0[6]]
     /* 2646 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2651 */   GIR_EraseRootFromParent_Done,
     /* 2652 */ // Label 192: @2652
     /* 2652 */ GIM_Reject,
     /* 2653 */ // Label 31: @2653
     /* 2653 */ GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(2664), // Rule ID 35 //
     /* 2658 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule28Enabled),
     /* 2661 */   // Combiner Rule #28: bitfield_extract_from_shr; wip_match_opcode 'G_ASHR'
     /* 2661 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner20),
     /* 2664 */ // Label 193: @2664
     /* 2664 */ GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(2675), // Rule ID 37 //
     /* 2669 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule29Enabled),
     /* 2672 */   // Combiner Rule #29: bitfield_extract_from_shr_and; wip_match_opcode 'G_ASHR'
     /* 2672 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 2675 */ // Label 194: @2675
     /* 2675 */ GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(2686), // Rule ID 63 //
     /* 2680 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 2683 */   // Combiner Rule #48: constant_fold_binop; wip_match_opcode 'G_ASHR'
     /* 2683 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 2686 */ // Label 195: @2686
     /* 2686 */ GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(2697), // Rule ID 97 //
     /* 2691 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule53Enabled),
     /* 2694 */   // Combiner Rule #53: binop_left_to_zero; wip_match_opcode 'G_ASHR'
     /* 2694 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner42),
     /* 2697 */ // Label 196: @2697
     /* 2697 */ GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(2708), // Rule ID 131 //
     /* 2702 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 2705 */   // Combiner Rule #76: binop_right_undef_to_undef; wip_match_opcode 'G_ASHR'
     /* 2705 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner57),
     /* 2708 */ // Label 197: @2708
     /* 2708 */ GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(2731), // Rule ID 88 //
     /* 2713 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule51Enabled),
     /* 2716 */   // MIs[0] dst
     /* 2716 */   // No operand predicates
     /* 2716 */   // MIs[0] lhs
     /* 2716 */   // No operand predicates
     /* 2716 */   // MIs[0] Operand 2
     /* 2716 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 2720 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2725 */   // Combiner Rule #51: right_identity_zero @ [__right_identity_zero_match_0[5]]
     /* 2725 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2730 */   GIR_EraseRootFromParent_Done,
     /* 2731 */ // Label 198: @2731
     /* 2731 */ GIM_Reject,
     /* 2732 */ // Label 32: @2732
     /* 2732 */ GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(2743), // Rule ID 39 //
     /* 2737 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule30Enabled),
     /* 2740 */   // Combiner Rule #30: rotate_out_of_range; wip_match_opcode 'G_ROTR'
     /* 2740 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner22),
     /* 2743 */ // Label 199: @2743
     /* 2743 */ GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(2766), // Rule ID 92 //
     /* 2748 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule51Enabled),
     /* 2751 */   // MIs[0] dst
     /* 2751 */   // No operand predicates
     /* 2751 */   // MIs[0] lhs
     /* 2751 */   // No operand predicates
     /* 2751 */   // MIs[0] Operand 2
     /* 2751 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 2755 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2760 */   // Combiner Rule #51: right_identity_zero @ [__right_identity_zero_match_0[9]]
     /* 2760 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2765 */   GIR_EraseRootFromParent_Done,
     /* 2766 */ // Label 200: @2766
     /* 2766 */ GIM_Reject,
     /* 2767 */ // Label 33: @2767
     /* 2767 */ GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(2778), // Rule ID 40 //
     /* 2772 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule30Enabled),
     /* 2775 */   // Combiner Rule #30: rotate_out_of_range; wip_match_opcode 'G_ROTL'
     /* 2775 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner22),
     /* 2778 */ // Label 201: @2778
     /* 2778 */ GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(2801), // Rule ID 91 //
     /* 2783 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule51Enabled),
     /* 2786 */   // MIs[0] dst
     /* 2786 */   // No operand predicates
     /* 2786 */   // MIs[0] lhs
     /* 2786 */   // No operand predicates
     /* 2786 */   // MIs[0] Operand 2
     /* 2786 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 2790 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2795 */   // Combiner Rule #51: right_identity_zero @ [__right_identity_zero_match_0[8]]
     /* 2795 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2800 */   GIR_EraseRootFromParent_Done,
     /* 2801 */ // Label 202: @2801
     /* 2801 */ GIM_Reject,
     /* 2802 */ // Label 34: @2802
     /* 2802 */ GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(2813), // Rule ID 41 //
     /* 2807 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule31Enabled),
     /* 2810 */   // Combiner Rule #31: icmp_to_true_false_known_bits; wip_match_opcode 'G_ICMP'
     /* 2810 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner23),
     /* 2813 */ // Label 203: @2813
     /* 2813 */ GIM_Reject,
     /* 2814 */ // Label 35: @2814
     /* 2814 */ GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(2825), // Rule ID 47 //
     /* 2819 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule35Enabled),
     /* 2822 */   // Combiner Rule #35: select_constant_cmp; wip_match_opcode 'G_SELECT'
     /* 2822 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner26),
     /* 2825 */ // Label 204: @2825
     /* 2825 */ GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(2836), // Rule ID 49 //
     /* 2830 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule37Enabled),
     /* 2833 */   // Combiner Rule #37: match_selects; wip_match_opcode 'G_SELECT'
     /* 2833 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner28),
     /* 2836 */ // Label 205: @2836
     /* 2836 */ GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(2847), // Rule ID 82 //
     /* 2841 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule50Enabled),
     /* 2844 */   // Combiner Rule #50: select_same_val; wip_match_opcode 'G_SELECT'
     /* 2844 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner41),
     /* 2847 */ // Label 206: @2847
     /* 2847 */ GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(2858), // Rule ID 150 //
     /* 2852 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 2855 */   // Combiner Rule #84: select_to_minmax; wip_match_opcode 'G_SELECT'
     /* 2855 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner64),
     /* 2858 */ // Label 207: @2858
     /* 2858 */ GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(2879), // Rule ID 48 //
     /* 2863 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule36Enabled),
     /* 2866 */   // MIs[0] root
     /* 2866 */   // No operand predicates
     /* 2866 */   // MIs[0] tst
     /* 2866 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2870 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2874 */   // MIs[1] tst1
     /* 2874 */   // No operand predicates
     /* 2874 */   // MIs[1] a
     /* 2874 */   // No operand predicates
     /* 2874 */   // MIs[1] b
     /* 2874 */   // No operand predicates
     /* 2874 */   // MIs[0] x
     /* 2874 */   // No operand predicates
     /* 2874 */   // MIs[0] y
     /* 2874 */   // No operand predicates
     /* 2874 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2876 */   // Combiner Rule #36: select_to_iminmax
     /* 2876 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner27),
     /* 2879 */ // Label 208: @2879
     /* 2879 */ GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(2908), // Rule ID 46 //
     /* 2884 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule34Enabled),
     /* 2887 */   // MIs[0] dst
     /* 2887 */   // No operand predicates
     /* 2887 */   // MIs[0] undef
     /* 2887 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2891 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 2895 */   // MIs[0] x
     /* 2895 */   // No operand predicates
     /* 2895 */   // MIs[0] y
     /* 2895 */   // No operand predicates
     /* 2895 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/3,
     /* 2900 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2902 */   // Combiner Rule #34: select_undef_cmp
     /* 2902 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/3,
     /* 2907 */   GIR_EraseRootFromParent_Done,
     /* 2908 */ // Label 209: @2908
     /* 2908 */ GIM_Reject,
     /* 2909 */ // Label 36: @2909
     /* 2909 */ GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(2920), // Rule ID 43 //
     /* 2914 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule32Enabled),
     /* 2917 */   // Combiner Rule #32: match_addos; wip_match_opcode 'G_UADDO'
     /* 2917 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner24),
     /* 2920 */ // Label 210: @2920
     /* 2920 */ GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(2931), // Rule ID 162 //
     /* 2925 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 2928 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_UADDO'
     /* 2928 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 2931 */ // Label 211: @2931
     /* 2931 */ GIM_Reject,
     /* 2932 */ // Label 37: @2932
     /* 2932 */ GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(2943), // Rule ID 45 //
     /* 2937 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule33Enabled),
     /* 2940 */   // Combiner Rule #33: match_subo_no_overflow; wip_match_opcode 'G_USUBO'
     /* 2940 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 2943 */ // Label 212: @2943
     /* 2943 */ GIM_Reject,
     /* 2944 */ // Label 38: @2944
     /* 2944 */ GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(2955), // Rule ID 42 //
     /* 2949 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule32Enabled),
     /* 2952 */   // Combiner Rule #32: match_addos; wip_match_opcode 'G_SADDO'
     /* 2952 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner24),
     /* 2955 */ // Label 213: @2955
     /* 2955 */ GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(2966), // Rule ID 163 //
     /* 2960 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 2963 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_SADDO'
     /* 2963 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 2966 */ // Label 214: @2966
     /* 2966 */ GIM_Reject,
     /* 2967 */ // Label 39: @2967
     /* 2967 */ GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(2978), // Rule ID 44 //
     /* 2972 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule33Enabled),
     /* 2975 */   // Combiner Rule #33: match_subo_no_overflow; wip_match_opcode 'G_SSUBO'
     /* 2975 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 2978 */ // Label 215: @2978
     /* 2978 */ GIM_Reject,
     /* 2979 */ // Label 40: @2979
     /* 2979 */ GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(2990), // Rule ID 164 //
     /* 2984 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 2987 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULO'
     /* 2987 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 2990 */ // Label 216: @2990
     /* 2990 */ GIM_Reject,
     /* 2991 */ // Label 41: @2991
     /* 2991 */ GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(3002), // Rule ID 165 //
     /* 2996 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 2999 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULO'
     /* 2999 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 3002 */ // Label 217: @3002
     /* 3002 */ GIM_Reject,
     /* 3003 */ // Label 42: @3003
     /* 3003 */ GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(3014), // Rule ID 166 //
     /* 3008 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 3011 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULH'
     /* 3011 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 3014 */ // Label 218: @3014
     /* 3014 */ GIM_Reject,
     /* 3015 */ // Label 43: @3015
     /* 3015 */ GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(3026), // Rule ID 167 //
     /* 3020 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 3023 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULH'
     /* 3023 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 3026 */ // Label 219: @3026
     /* 3026 */ GIM_Reject,
     /* 3027 */ // Label 44: @3027
     /* 3027 */ GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(3038), // Rule ID 168 //
     /* 3032 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 3035 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_UADDSAT'
     /* 3035 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 3038 */ // Label 220: @3038
     /* 3038 */ GIM_Reject,
     /* 3039 */ // Label 45: @3039
     /* 3039 */ GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(3050), // Rule ID 169 //
     /* 3044 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 3047 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_SADDSAT'
     /* 3047 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 3050 */ // Label 221: @3050
     /* 3050 */ GIM_Reject,
     /* 3051 */ // Label 46: @3051
     /* 3051 */ GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(3062), // Rule ID 170 //
     /* 3056 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 3059 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULFIX'
     /* 3059 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 3062 */ // Label 222: @3062
     /* 3062 */ GIM_Reject,
     /* 3063 */ // Label 47: @3063
     /* 3063 */ GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(3074), // Rule ID 171 //
     /* 3068 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 3071 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULFIX'
     /* 3071 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 3074 */ // Label 223: @3074
     /* 3074 */ GIM_Reject,
     /* 3075 */ // Label 48: @3075
     /* 3075 */ GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(3086), // Rule ID 172 //
     /* 3080 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 3083 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULFIXSAT'
     /* 3083 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 3086 */ // Label 224: @3086
     /* 3086 */ GIM_Reject,
     /* 3087 */ // Label 49: @3087
     /* 3087 */ GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(3098), // Rule ID 173 //
     /* 3092 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 3095 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULFIXSAT'
     /* 3095 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 3098 */ // Label 225: @3098
     /* 3098 */ GIM_Reject,
     /* 3099 */ // Label 50: @3099
     /* 3099 */ GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(3110), // Rule ID 78 //
     /* 3104 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule49Enabled),
     /* 3107 */   // Combiner Rule #49: constant_fold_fp_binop; wip_match_opcode 'G_FADD'
     /* 3107 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner40),
     /* 3110 */ // Label 226: @3110
     /* 3110 */ GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(3121), // Rule ID 174 //
     /* 3115 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule88Enabled),
     /* 3118 */   // Combiner Rule #88: commute_fp_constant_to_rhs; wip_match_opcode 'G_FADD'
     /* 3118 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner68),
     /* 3121 */ // Label 227: @3121
     /* 3121 */ GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(3144), // Rule ID 117 //
     /* 3126 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule67Enabled),
     /* 3129 */   // MIs[0] dst
     /* 3129 */   // No operand predicates
     /* 3129 */   // MIs[0] x
     /* 3129 */   // No operand predicates
     /* 3129 */   // MIs[0] y
     /* 3129 */   // No operand predicates
     /* 3129 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner1),
     /* 3133 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3138 */   // Combiner Rule #67: right_identity_neg_zero_fp
     /* 3138 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3143 */   GIR_EraseRootFromParent_Done,
     /* 3144 */ // Label 228: @3144
     /* 3144 */ GIM_Reject,
     /* 3145 */ // Label 51: @3145
     /* 3145 */ GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(3156), // Rule ID 79 //
     /* 3150 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule49Enabled),
     /* 3153 */   // Combiner Rule #49: constant_fold_fp_binop; wip_match_opcode 'G_FSUB'
     /* 3153 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner40),
     /* 3156 */ // Label 229: @3156
     /* 3156 */ GIM_Reject,
     /* 3157 */ // Label 52: @3157
     /* 3157 */ GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(3168), // Rule ID 80 //
     /* 3162 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule49Enabled),
     /* 3165 */   // Combiner Rule #49: constant_fold_fp_binop; wip_match_opcode 'G_FMUL'
     /* 3165 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner40),
     /* 3168 */ // Label 230: @3168
     /* 3168 */ GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(3179), // Rule ID 175 //
     /* 3173 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule88Enabled),
     /* 3176 */   // Combiner Rule #88: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMUL'
     /* 3176 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner68),
     /* 3179 */ // Label 231: @3179
     /* 3179 */ GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(3202), // Rule ID 108 //
     /* 3184 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule60Enabled),
     /* 3187 */   // MIs[0] dst
     /* 3187 */   // No operand predicates
     /* 3187 */   // MIs[0] x
     /* 3187 */   // No operand predicates
     /* 3187 */   // MIs[0] y
     /* 3187 */   // No operand predicates
     /* 3187 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner0),
     /* 3191 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3196 */   // Combiner Rule #60: right_identity_one_fp
     /* 3196 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3201 */   GIR_EraseRootFromParent_Done,
     /* 3202 */ // Label 232: @3202
     /* 3202 */ GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(3222), // Rule ID 118 //
     /* 3207 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule68Enabled),
     /* 3210 */   // MIs[0] dst
     /* 3210 */   // No operand predicates
     /* 3210 */   // MIs[0] x
     /* 3210 */   // No operand predicates
     /* 3210 */   // MIs[0] y
     /* 3210 */   // No operand predicates
     /* 3210 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner2),
     /* 3214 */   // Combiner Rule #68: right_identity_neg_one_fp
     /* 3214 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 3217 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 3219 */   GIR_RootToRootCopy, /*OpIdx*/1, // x
     /* 3221 */   GIR_EraseRootFromParent_Done,
     /* 3222 */ // Label 233: @3222
     /* 3222 */ GIM_Reject,
     /* 3223 */ // Label 53: @3223
     /* 3223 */ GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(3234), // Rule ID 81 //
     /* 3228 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule49Enabled),
     /* 3231 */   // Combiner Rule #49: constant_fold_fp_binop; wip_match_opcode 'G_FDIV'
     /* 3231 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner40),
     /* 3234 */ // Label 234: @3234
     /* 3234 */ GIM_Reject,
     /* 3235 */ // Label 54: @3235
     /* 3235 */ GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(3264), // Rule ID 106 //
     /* 3240 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule58Enabled),
     /* 3243 */   // MIs[0] dst
     /* 3243 */   // No operand predicates
     /* 3243 */   // MIs[0] t
     /* 3243 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3247 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 3251 */   // MIs[1] src
     /* 3251 */   // No operand predicates
     /* 3251 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 3256 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3258 */   // Combiner Rule #58: fneg_fneg_fold
     /* 3258 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 3263 */   GIR_EraseRootFromParent_Done,
     /* 3264 */ // Label 235: @3264
     /* 3264 */ GIM_Reject,
     /* 3265 */ // Label 55: @3265
     /* 3265 */ GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(3286), // Rule ID 116 //
     /* 3270 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule66Enabled),
     /* 3273 */   // MIs[0] dst
     /* 3273 */   // No operand predicates
     /* 3273 */   // MIs[0] src1
     /* 3273 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3277 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPEXT),
     /* 3281 */   // MIs[1] src0
     /* 3281 */   // No operand predicates
     /* 3281 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3283 */   // Combiner Rule #66: fptrunc_fpext_fold
     /* 3283 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner49),
     /* 3286 */ // Label 236: @3286
     /* 3286 */ GIM_Reject,
     /* 3287 */ // Label 56: @3287
     /* 3287 */ GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(3308), // Rule ID 139 //
     /* 3292 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 3295 */   // MIs[0] dst
     /* 3295 */   // No operand predicates
     /* 3295 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3295 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3299 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3303 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3305 */   // Combiner Rule #78: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[5]]
     /* 3305 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner58),
     /* 3308 */ // Label 237: @3308
     /* 3308 */ GIM_Reject,
     /* 3309 */ // Label 57: @3309
     /* 3309 */ GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(3330), // Rule ID 140 //
     /* 3314 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 3317 */   // MIs[0] dst
     /* 3317 */   // No operand predicates
     /* 3317 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3317 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3321 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3325 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3327 */   // Combiner Rule #78: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[6]]
     /* 3327 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner58),
     /* 3330 */ // Label 238: @3330
     /* 3330 */ GIM_Reject,
     /* 3331 */ // Label 58: @3331
     /* 3331 */ GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(3342), // Rule ID 123 //
     /* 3336 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule72Enabled),
     /* 3339 */   // Combiner Rule #72: undef_to_fp_zero; wip_match_opcode 'G_SITOFP'
     /* 3339 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner53),
     /* 3342 */ // Label 239: @3342
     /* 3342 */ GIM_Reject,
     /* 3343 */ // Label 59: @3343
     /* 3343 */ GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(3354), // Rule ID 122 //
     /* 3348 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule72Enabled),
     /* 3351 */   // Combiner Rule #72: undef_to_fp_zero; wip_match_opcode 'G_UITOFP'
     /* 3351 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner53),
     /* 3354 */ // Label 240: @3354
     /* 3354 */ GIM_Reject,
     /* 3355 */ // Label 60: @3355
     /* 3355 */ GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(3366), // Rule ID 176 //
     /* 3360 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule88Enabled),
     /* 3363 */   // Combiner Rule #88: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINNUM'
     /* 3363 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner68),
     /* 3366 */ // Label 241: @3366
     /* 3366 */ GIM_Reject,
     /* 3367 */ // Label 61: @3367
     /* 3367 */ GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(3378), // Rule ID 177 //
     /* 3372 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule88Enabled),
     /* 3375 */   // Combiner Rule #88: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXNUM'
     /* 3375 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner68),
     /* 3378 */ // Label 242: @3378
     /* 3378 */ GIM_Reject,
     /* 3379 */ // Label 62: @3379
     /* 3379 */ GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(3390), // Rule ID 178 //
     /* 3384 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule88Enabled),
     /* 3387 */   // Combiner Rule #88: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINNUM_IEEE'
     /* 3387 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner68),
     /* 3390 */ // Label 243: @3390
     /* 3390 */ GIM_Reject,
     /* 3391 */ // Label 63: @3391
     /* 3391 */ GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(3402), // Rule ID 179 //
     /* 3396 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule88Enabled),
     /* 3399 */   // Combiner Rule #88: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXNUM_IEEE'
     /* 3399 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner68),
     /* 3402 */ // Label 244: @3402
     /* 3402 */ GIM_Reject,
     /* 3403 */ // Label 64: @3403
     /* 3403 */ GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(3414), // Rule ID 180 //
     /* 3408 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule88Enabled),
     /* 3411 */   // Combiner Rule #88: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINIMUM'
     /* 3411 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner68),
     /* 3414 */ // Label 245: @3414
     /* 3414 */ GIM_Reject,
     /* 3415 */ // Label 65: @3415
     /* 3415 */ GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(3426), // Rule ID 181 //
     /* 3420 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule88Enabled),
     /* 3423 */   // Combiner Rule #88: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXIMUM'
     /* 3423 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner68),
     /* 3426 */ // Label 246: @3426
     /* 3426 */ GIM_Reject,
     /* 3427 */ // Label 66: @3427
     /* 3427 */ GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(3438), // Rule ID 61 //
     /* 3432 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 3435 */   // Combiner Rule #48: constant_fold_binop; wip_match_opcode 'G_PTR_ADD'
     /* 3435 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 3438 */ // Label 247: @3438
     /* 3438 */ GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(3449), // Rule ID 119 //
     /* 3443 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule69Enabled),
     /* 3446 */   // Combiner Rule #69: ptr_add_immed_chain; wip_match_opcode 'G_PTR_ADD'
     /* 3446 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner50),
     /* 3449 */ // Label 248: @3449
     /* 3449 */ GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(3472), // Rule ID 90 //
     /* 3454 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule51Enabled),
     /* 3457 */   // MIs[0] dst
     /* 3457 */   // No operand predicates
     /* 3457 */   // MIs[0] lhs
     /* 3457 */   // No operand predicates
     /* 3457 */   // MIs[0] Operand 2
     /* 3457 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 3461 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3466 */   // Combiner Rule #51: right_identity_zero @ [__right_identity_zero_match_0[7]]
     /* 3466 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3471 */   GIR_EraseRootFromParent_Done,
     /* 3472 */ // Label 249: @3472
     /* 3472 */ GIM_Reject,
     /* 3473 */ // Label 67: @3473
     /* 3473 */ GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(3484), // Rule ID 74 //
     /* 3478 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 3481 */   // Combiner Rule #48: constant_fold_binop; wip_match_opcode 'G_SMIN'
     /* 3481 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 3484 */ // Label 250: @3484
     /* 3484 */ GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(3495), // Rule ID 158 //
     /* 3489 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 3492 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_SMIN'
     /* 3492 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 3495 */ // Label 251: @3495
     /* 3495 */ GIM_Reject,
     /* 3496 */ // Label 68: @3496
     /* 3496 */ GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(3507), // Rule ID 75 //
     /* 3501 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 3504 */   // Combiner Rule #48: constant_fold_binop; wip_match_opcode 'G_SMAX'
     /* 3504 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 3507 */ // Label 252: @3507
     /* 3507 */ GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(3518), // Rule ID 159 //
     /* 3512 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 3515 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_SMAX'
     /* 3515 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 3518 */ // Label 253: @3518
     /* 3518 */ GIM_Reject,
     /* 3519 */ // Label 69: @3519
     /* 3519 */ GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(3530), // Rule ID 76 //
     /* 3524 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 3527 */   // Combiner Rule #48: constant_fold_binop; wip_match_opcode 'G_UMIN'
     /* 3527 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 3530 */ // Label 254: @3530
     /* 3530 */ GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(3541), // Rule ID 160 //
     /* 3535 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 3538 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_UMIN'
     /* 3538 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 3541 */ // Label 255: @3541
     /* 3541 */ GIM_Reject,
     /* 3542 */ // Label 70: @3542
     /* 3542 */ GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(3553), // Rule ID 77 //
     /* 3547 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 3550 */   // Combiner Rule #48: constant_fold_binop; wip_match_opcode 'G_UMAX'
     /* 3550 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 3553 */ // Label 256: @3553
     /* 3553 */ GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(3564), // Rule ID 161 //
     /* 3558 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 3561 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_UMAX'
     /* 3561 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 3564 */ // Label 257: @3564
     /* 3564 */ GIM_Reject,
     /* 3565 */ // Label 71: @3565
     /* 3565 */ GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(3576), // Rule ID 133 //
     /* 3570 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 3573 */   // Combiner Rule #77: unary_undef_to_zero; wip_match_opcode 'G_ABS'
     /* 3573 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner56),
     /* 3576 */ // Label 258: @3576
     /* 3576 */ GIM_Reject,
     /* 3577 */ // Label 72: @3577
     /* 3577 */ GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(3588), // Rule ID 148 //
     /* 3582 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 3585 */   // Combiner Rule #83: insert_extract_vec_elt_out_of_bounds; wip_match_opcode 'G_INSERT_VECTOR_ELT'
     /* 3585 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner63),
     /* 3588 */ // Label 259: @3588
     /* 3588 */ GIM_Reject,
     /* 3589 */ // Label 73: @3589
     /* 3589 */ GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(3600), // Rule ID 29 //
     /* 3594 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule22Enabled),
     /* 3597 */   // Combiner Rule #22: extractvecelt_pairwise_add; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 3597 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 3600 */ // Label 260: @3600
     /* 3600 */ GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(3611), // Rule ID 149 //
     /* 3605 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 3608 */   // Combiner Rule #83: insert_extract_vec_elt_out_of_bounds; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 3608 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner63),
     /* 3611 */ // Label 261: @3611
     /* 3611 */ GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(3622), // Rule ID 182 //
     /* 3616 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule89Enabled),
     /* 3619 */   // Combiner Rule #89: extract_vec_elt_build_vec; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 3619 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner69),
     /* 3622 */ // Label 262: @3622
     /* 3622 */ GIM_Reject,
     /* 3623 */ // Label 74: @3623
     /* 3623 */ GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(3634), // Rule ID 144 //
     /* 3628 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule80Enabled),
     /* 3631 */   // Combiner Rule #80: propagate_undef_all_ops; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 3631 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner60),
     /* 3634 */ // Label 263: @3634
     /* 3634 */ GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(3645), // Rule ID 146 //
     /* 3639 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule81Enabled),
     /* 3642 */   // Combiner Rule #81: propagate_undef_shuffle_mask; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 3642 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner61),
     /* 3645 */ // Label 264: @3645
     /* 3645 */ GIM_Reject,
     /* 3646 */ // Label 75: @3646
     /* 3646 */ GIM_Reject,
     /* 3647 */ }; // Size: 3647 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GICOMBINER_IMPL

#ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
#ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
, State(0),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GICOMBINER_CONSTRUCTOR_INITS

