/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* AArch64PreLegalizerCombinerImpl Combiner Match Table                       *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GICOMBINER_DEPS
#include "llvm/ADT/SparseBitVector.h"
namespace llvm {
extern cl::OptionCategory GICombinerOptionCategory;
} // end namespace llvm
#endif // ifdef GET_GICOMBINER_DEPS

#ifdef GET_GICOMBINER_TYPES
struct AArch64PreLegalizerCombinerImplRuleConfig {
  SparseBitVector<> DisabledRules;

  bool isRuleEnabled(unsigned RuleID) const;
  bool parseCommandLineOption();
  bool setRuleEnabled(StringRef RuleIdentifier);
  bool setRuleDisabled(StringRef RuleIdentifier);
};

static std::optional<uint64_t> getRuleIdxForIdentifier(StringRef RuleIdentifier) {
  uint64_t I;
  // getAtInteger(...) returns false on success
  bool Parsed = !RuleIdentifier.getAsInteger(0, I);
  if (Parsed)
    return I;

#ifndef NDEBUG
  switch (RuleIdentifier.size()) {
  default: break;
  case 9:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "opy_prop", 8) != 0)
        break;
      return 13;	 // "copy_prop"
    case 'm':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "tch_ors", 7) != 0)
          break;
        return 194;	 // "match_ors"
      case 'u':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "lo_by_", 6) != 0)
          break;
        switch (RuleIdentifier[8]) {
        default: break;
        case '0':	 // 1 string to match.
          return 144;	 // "mulo_by_0"
        case '2':	 // 1 string to match.
          return 143;	 // "mulo_by_2"
        }
        break;
      }
      break;
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "neg_zext", 8) != 0)
        break;
      return 199;	 // "nneg_zext"
    }
    break;
  case 10:	 // 7 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2p_to_p2i", 9) != 0)
        break;
      return 89;	 // "i2p_to_p2i"
    case 'm':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "tch_ands", 8) != 0)
          break;
        return 193;	 // "match_ands"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "l_to_shl", 8) != 0)
          break;
        return 14;	 // "mul_to_shl"
      }
      break;
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2i_to_i2p", 9) != 0)
        break;
      return 88;	 // "p2i_to_i2p"
    case 's':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "xt_trunc", 8) != 0)
          break;
        return 197;	 // "sext_trunc"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "b_to_add", 8) != 0)
          break;
        return 15;	 // "sub_to_add"
      }
      break;
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_trunc", 9) != 0)
        break;
      return 198;	 // "zext_trunc"
    }
    break;
  case 11:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dd_sub_reg", 10) != 0)
        break;
      return 94;	 // "add_sub_reg"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_addos", 10) != 0)
        break;
      return 213;	 // "match_addos"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ub_add_reg", 10) != 0)
        break;
      return 188;	 // "sub_add_reg"
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_shift", 10) != 0)
        break;
      return 131;	 // "trunc_shift"
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nmerge_cst", 10) != 0)
        break;
      return 207;	 // "unmerge_cst"
    }
    break;
  case 12:	 // 11 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "PlusBMinusB", 11) != 0)
        break;
      return 2;	 // "APlusBMinusB"
    case 'B':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "MinusAPlusA", 11) != 0)
        break;
      return 3;	 // "BMinusAPlusA"
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dde_to_addo", 11) != 0)
        break;
      return 145;	 // "adde_to_addo"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "sub_to_fneg", 11) != 0)
        break;
      return 190;	 // "fsub_to_fneg"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ulh_to_lshr", 11) != 0)
        break;
      return 175;	 // "mulh_to_lshr"
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ot_cmp_fold", 11) != 0)
        break;
      return 132;	 // "not_cmp_fold"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_or", 11) != 0)
        break;
      return 127;	 // "redundant_or"
    case 's':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "iv_by_pow2", 10) != 0)
          break;
        return 173;	 // "sdiv_by_pow2"
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "xt_of_sext", 10) != 0)
          break;
        return 48;	 // "sext_of_sext"
      }
      break;
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "div_by_pow2", 11) != 0)
        break;
      return 174;	 // "udiv_by_pow2"
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_of_zext", 11) != 0)
        break;
      return 46;	 // "zext_of_zext"
    }
    break;
  case 13:	 // 14 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dd_of_vscale", 12) != 0)
        break;
      return 37;	 // "add_of_vscale"
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ommute_shift", 12) != 0)
        break;
      return 161;	 // "commute_shift"
    case 'l':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oad_and_mask", 12) != 0)
        break;
      return 69;	 // "load_and_mask"
    case 'm':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "tch_selects", 11) != 0)
          break;
        return 124;	 // "match_selects"
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "rge_unmerge", 11) != 0)
          break;
        return 206;	 // "merge_unmerge"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "l_of_vscale", 11) != 0)
          break;
        return 38;	 // "mul_of_vscale"
      }
      break;
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_and", 12) != 0)
        break;
      return 125;	 // "redundant_and"
    case 's':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "iv_by_const", 11) != 0)
          break;
        return 172;	 // "sdiv_by_const"
      case 'h':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "l_of_vscale", 11) != 0)
          break;
        return 39;	 // "shl_of_vscale"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "b_of_vscale", 11) != 0)
          break;
        return 40;	 // "sub_of_vscale"
      }
      break;
    case 'u':	 // 4 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "iv_by_const", 11) != 0)
          break;
        return 171;	 // "udiv_by_const"
      case 'n':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "merge_", 6) != 0)
          break;
        switch (RuleIdentifier[8]) {
        default: break;
        case 'm':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+9, "erge", 4) != 0)
            break;
          return 205;	 // "unmerge_merge"
        case 'u':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+9, "ndef", 4) != 0)
            break;
          return 208;	 // "unmerge_undef"
        }
        break;
      case 'r':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "em_by_const", 11) != 0)
          break;
        return 187;	 // "urem_by_const"
      }
      break;
    }
    break;
  case 14:	 // 15 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'M':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "inusC1PlusC2", 12) != 0)
          break;
        return 12;	 // "AMinusC1PlusC2"
      case 'P':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lusC1MinusC2", 12) != 0)
          break;
        return 8;	 // "APlusC1MinusC2"
      }
      break;
    case 'C':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2MinusAPlusC1", 13) != 0)
        break;
      return 9;	 // "C2MinusAPlusC1"
    case 'a':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "nyext_of_", 9) != 0)
        break;
      switch (RuleIdentifier[10]) {
      default: break;
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+11, "ext", 3) != 0)
          break;
        return 52;	 // "anyext_of_sext"
      case 'z':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+11, "ext", 3) != 0)
          break;
        return 51;	 // "anyext_of_zext"
      }
      break;
    case 'b':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'i')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "op_same_val", 11) != 0)
          break;
        return 85;	 // "binop_same_val"
      case 't':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "reverse_shl", 11) != 0)
          break;
        return 159;	 // "bitreverse_shl"
      }
      break;
    case 'f':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "bs_fneg_fold", 12) != 0)
          break;
        return 170;	 // "fabs_fneg_fold"
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "eg_fneg_fold", 12) != 0)
          break;
        return 91;	 // "fneg_fneg_fold"
      }
      break;
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ul_by_neg_one", 13) != 0)
        break;
      return 17;	 // "mul_by_neg_one"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "eassoc_ptradd", 13) != 0)
        break;
      return 106;	 // "reassoc_ptradd"
    case 's':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 2 strings to match.
        switch (RuleIdentifier[2]) {
        default: break;
        case 'l':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+3, "ect_of_zext", 11) != 0)
            break;
          return 54;	 // "select_of_zext"
        case 'x':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+3, "t_of_anyext", 11) != 0)
            break;
          return 49;	 // "sext_of_anyext"
        }
        break;
      case 'h':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ifts_too_big", 12) != 0)
          break;
        return 105;	 // "shifts_too_big"
      }
      break;
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_of_anyext", 13) != 0)
        break;
      return 47;	 // "zext_of_anyext"
    }
    break;
  case 15:	 // 12 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'M':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "inusC1MinusC2", 13) != 0)
          break;
        return 10;	 // "AMinusC1MinusC2"
      case 'P':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lusZeroMinusB", 13) != 0)
          break;
        return 1;	 // "APlusZeroMinusB"
      }
      break;
    case 'C':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "1Minus2MinusC2", 14) != 0)
        break;
      return 11;	 // "C1Minus2MinusC2"
    case 'Z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "eroMinusAPlusB", 14) != 0)
        break;
      return 0;	 // "ZeroMinusAPlusB"
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itreverse_lshr", 14) != 0)
        break;
      return 160;	 // "bitreverse_lshr"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtending_loads", 14) != 0)
        break;
      return 68;	 // "extending_loads"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dempotent_prop", 14) != 0)
        break;
      return 18;	 // "idempotent_prop"
    case 'l':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oad_or_combine", 14) != 0)
        break;
      return 152;	 // "load_or_combine"
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "arrow_binop_or", 14) != 0)
        break;
      return 62;	 // "narrow_binop_or"
    case 'o':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "verlapping_and", 14) != 0)
        break;
      return 142;	 // "overlapping_and"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "elect_same_val", 14) != 0)
        break;
      return 83;	 // "select_same_val"
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_trunc_fold", 14) != 0)
        break;
      return 129;	 // "zext_trunc_fold"
    }
    break;
  case 16:	 // 12 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nyext_of_anyext", 15) != 0)
        break;
      return 50;	 // "anyext_of_anyext"
    case 'n':	 // 5 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "arrow_binop_", 12) != 0)
        break;
      switch (RuleIdentifier[13]) {
      default: break;
      case 'a':	 // 2 strings to match.
        switch (RuleIdentifier[14]) {
        default: break;
        case 'd':	 // 1 string to match.
          if (RuleIdentifier[15] != 'd')
            break;
          return 58;	 // "narrow_binop_add"
        case 'n':	 // 1 string to match.
          if (RuleIdentifier[15] != 'd')
            break;
          return 61;	 // "narrow_binop_and"
        }
        break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+14, "ul", 2) != 0)
          break;
        return 60;	 // "narrow_binop_mul"
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+14, "ub", 2) != 0)
          break;
        return 59;	 // "narrow_binop_sub"
      case 'x':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+14, "or", 2) != 0)
          break;
        return 63;	 // "narrow_binop_xor"
      }
      break;
    case 's':	 // 3 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "elect_", 6) != 0)
        break;
      switch (RuleIdentifier[7]) {
      default: break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+8, "f_anyext", 8) != 0)
          break;
        return 55;	 // "select_of_anyext"
      case 't':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+8, "o_minmax", 8) != 0)
          break;
        return 189;	 // "select_to_minmax"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+8, "ndef_cmp", 8) != 0)
          break;
        return 121;	 // "select_undef_cmp"
      }
      break;
    case 't':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "runcate_of_", 11) != 0)
        break;
      switch (RuleIdentifier[12]) {
      default: break;
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+13, "ext", 3) != 0)
          break;
        return 44;	 // "truncate_of_sext"
      case 'z':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+13, "ext", 3) != 0)
          break;
        return 43;	 // "truncate_of_zext"
      }
      break;
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ndef_to_fp_zero", 15) != 0)
        break;
      return 71;	 // "undef_to_fp_zero"
    }
    break;
  case 17:	 // 14 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "PlusBMinus", 10) != 0)
        break;
      switch (RuleIdentifier[11]) {
      default: break;
      case 'A':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "plusC", 5) != 0)
          break;
        return 6;	 // "APlusBMinusAplusC"
      case 'C':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "PlusA", 5) != 0)
          break;
        return 7;	 // "APlusBMinusCPlusA"
      }
      break;
    case 'a':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "d_p2i_to_ptradd", 15) != 0)
          break;
        return 16;	 // "add_p2i_to_ptradd"
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "yext_trunc_fold", 15) != 0)
          break;
        return 90;	 // "anyext_trunc_fold"
      }
      break;
    case 'c':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "nonicalize_", 11) != 0)
          break;
        switch (RuleIdentifier[13]) {
        default: break;
        case 'f':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "cmp", 3) != 0)
            break;
          return 110;	 // "canonicalize_fcmp"
        case 'i':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "cmp", 3) != 0)
            break;
          return 109;	 // "canonicalize_icmp"
        }
        break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "nstant_fold_fma", 15) != 0)
          break;
        return 168;	 // "constant_fold_fma"
      }
      break;
    case 'd':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "iv_rem_to_divrem", 16) != 0)
        break;
      return 153;	 // "div_rem_to_divrem"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "rase_undef_store", 16) != 0)
        break;
      return 81;	 // "erase_undef_store"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "tr_add_with_zero", 16) != 0)
        break;
      return 149;	 // "ptr_add_with_zero"
    case 's':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lect_to_iminmax", 15) != 0)
          break;
        return 123;	 // "select_to_iminmax"
      case 'h':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ift_immed_chain", 15) != 0)
          break;
        return 150;	 // "shift_immed_chain"
      }
      break;
    case 'u':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "def_to_int_zero", 15) != 0)
          break;
        return 72;	 // "undef_to_int_zero"
      case 'r':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "em_pow2_to_mask", 15) != 0)
          break;
        return 128;	 // "urem_pow2_to_mask"
      }
      break;
    }
    break;
  case 18:	 // 13 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "MinusBPlus", 10) != 0)
        break;
      switch (RuleIdentifier[11]) {
      default: break;
      case 'B':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "MinusC", 6) != 0)
          break;
        return 5;	 // "AMinusBPlusBMinusC"
      case 'C':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "MinusA", 6) != 0)
          break;
        return 4;	 // "AMinusBPlusCMinusA"
      }
      break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_left_to_zero", 17) != 0)
        break;
      return 86;	 // "binop_left_to_zero"
    case 'c':	 // 3 strings to match.
      if (RuleIdentifier[1] != 'o')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "bine_minmax_nan", 15) != 0)
          break;
        return 146;	 // "combine_minmax_nan"
      case 'n':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+3, "stant_fold_f", 12) != 0)
          break;
        switch (RuleIdentifier[15]) {
        default: break;
        case 'a':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+16, "bs", 2) != 0)
            break;
          return 135;	 // "constant_fold_fabs"
        case 'n':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+16, "eg", 2) != 0)
            break;
          return 134;	 // "constant_fold_fneg"
        }
        break;
      }
      break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xpand_const_fpowi", 17) != 0)
        break;
      return 147;	 // "expand_const_fpowi"
    case 'f':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ld_global_offset", 16) != 0)
          break;
        return 217;	 // "fold_global_offset"
      case 'p':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "trunc_fpext_fold", 16) != 0)
          break;
        return 99;	 // "fptrunc_fpext_fold"
      }
      break;
    case 's':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 2 strings to match.
        switch (RuleIdentifier[2]) {
        default: break;
        case 'l':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+3, "ect_of_truncate", 15) != 0)
            break;
          return 56;	 // "select_of_truncate"
        case 'x':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+3, "t_inreg_of_load", 15) != 0)
            break;
          return 118;	 // "sext_inreg_of_load"
        }
        break;
      case 'h':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "uffle_to_extract", 16) != 0)
          break;
        return 218;	 // "shuffle_to_extract"
      }
      break;
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runcate_of_anyext", 17) != 0)
        break;
      return 45;	 // "truncate_of_anyext"
    }
    break;
  case 19:	 // 16 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_right_to_zero", 18) != 0)
        break;
      return 87;	 // "binop_right_to_zero"
    case 'c':	 // 4 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "onst", 4) != 0)
        break;
      switch (RuleIdentifier[5]) {
      default: break;
      case '_':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+6, "ptradd_to_i2p", 13) != 0)
          break;
        return 141;	 // "const_ptradd_to_i2p"
      case 'a':	 // 3 strings to match.
        if (memcmp(RuleIdentifier.data()+6, "nt_fold_", 8) != 0)
          break;
        switch (RuleIdentifier[14]) {
        default: break;
        case 'b':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+15, "inop", 4) != 0)
            break;
          return 166;	 // "constant_fold_binop"
        case 'f':	 // 2 strings to match.
          switch (RuleIdentifier[15]) {
          default: break;
          case 'l':	 // 1 string to match.
            if (memcmp(RuleIdentifier.data()+16, "og2", 3) != 0)
              break;
            return 137;	 // "constant_fold_flog2"
          case 's':	 // 1 string to match.
            if (memcmp(RuleIdentifier.data()+16, "qrt", 3) != 0)
              break;
            return 136;	 // "constant_fold_fsqrt"
          }
          break;
        }
        break;
      }
      break;
    case 'e':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "xt", 2) != 0)
        break;
      switch (RuleIdentifier[3]) {
      default: break;
      case '_':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+4, "uaddv_to_uaddlv", 15) != 0)
          break;
        return 220;	 // "ext_uaddv_to_uaddlv"
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+4, "nd_through_phis", 15) != 0)
          break;
        return 102;	 // "extend_through_phis"
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nteger_of_truncate", 18) != 0)
        break;
      return 64;	 // "integer_of_truncate"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "erge_of_x_and_zero", 18) != 0)
        break;
      return 212;	 // "merge_of_x_and_zero"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "tr_add_immed_chain", 18) != 0)
        break;
      return 108;	 // "ptr_add_immed_chain"
    case 'r':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "assoc_comm_binops", 17) != 0)
          break;
        return 107;	 // "reassoc_comm_binops"
      case 'i':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ght_identity_zero", 17) != 0)
          break;
        return 84;	 // "right_identity_zero"
      }
      break;
    case 's':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lect_constant_cmp", 17) != 0)
          break;
        return 122;	 // "select_constant_cmp"
      case 'i':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "mplify_", 7) != 0)
          break;
        switch (RuleIdentifier[9]) {
        default: break;
        case 'a':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+10, "dd_to_sub", 9) != 0)
            break;
          return 103;	 // "simplify_add_to_sub"
        case 'n':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+10, "eg_minmax", 9) != 0)
            break;
          return 195;	 // "simplify_neg_minmax"
        }
        break;
      }
      break;
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nary_undef_to_zero", 18) != 0)
        break;
      return 76;	 // "unary_undef_to_zero"
    }
    break;
  case 20:	 // 8 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nd_or_disjoint_mask", 19) != 0)
        break;
      return 177;	 // "and_or_disjoint_mask"
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itcast_bitcast_fold", 19) != 0)
        break;
      return 98;	 // "bitcast_bitcast_fold"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "cmp_redundant_trunc", 19) != 0)
        break;
      return 216;	 // "icmp_redundant_trunc"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "erge_of_x_and_undef", 19) != 0)
        break;
      return 211;	 // "merge_of_x_and_undef"
    case 'r':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "edu", 3) != 0)
        break;
      switch (RuleIdentifier[4]) {
      default: break;
      case 'c':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+5, "e_shl_of_extend", 15) != 0)
          break;
        return 119;	 // "reduce_shl_of_extend"
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+5, "dant_sext_inreg", 15) != 0)
          break;
        return 126;	 // "redundant_sext_inreg"
      }
      break;
    case 'u':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'n')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "ry_undef_to_undef", 17) != 0)
          break;
        return 77;	 // "unary_undef_to_undef"
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "erge_zext_to_zext", 17) != 0)
          break;
        return 210;	 // "unmerge_zext_to_zext"
      }
      break;
    }
    break;
  case 21:	 // 13 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 3 strings to match.
      if (RuleIdentifier[1] != 'o')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "bine_concat_vector", 18) != 0)
          break;
        return 196;	 // "combine_concat_vector"
      case 'n':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+3, "stant_fold_", 11) != 0)
          break;
        switch (RuleIdentifier[14]) {
        default: break;
        case 'c':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+15, "ast_op", 6) != 0)
            break;
          return 169;	 // "constant_fold_cast_op"
        case 'f':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+15, "ptrunc", 6) != 0)
            break;
          return 138;	 // "constant_fold_fptrunc"
        }
        break;
      }
      break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xt_addv_to_udot_addv", 20) != 0)
        break;
      return 219;	 // "ext_addv_to_udot_addv"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "constant_to_constant", 20) != 0)
        break;
      return 215;	 // "fconstant_to_constant"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nsert_vector_elt_oob", 20) != 0)
        break;
      return 24;	 // "insert_vector_elt_oob"
    case 'p':	 // 4 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ush_", 4) != 0)
        break;
      switch (RuleIdentifier[5]) {
      default: break;
      case 'a':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+6, "dd_through_", 11) != 0)
          break;
        switch (RuleIdentifier[17]) {
        default: break;
        case 's':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+18, "ext", 3) != 0)
            break;
          return 224;	 // "push_add_through_sext"
        case 'z':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+18, "ext", 3) != 0)
            break;
          return 222;	 // "push_add_through_zext"
        }
        break;
      case 's':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+6, "ub_through_", 11) != 0)
          break;
        switch (RuleIdentifier[17]) {
        default: break;
        case 's':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+18, "ext", 3) != 0)
            break;
          return 223;	 // "push_sub_through_sext"
        case 'z':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+18, "ext", 3) != 0)
            break;
          return 221;	 // "push_sub_through_zext"
        }
        break;
      }
      break;
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_one_fp", 20) != 0)
        break;
      return 93;	 // "right_identity_one_fp"
    case 'u':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'n')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "ef_to_negative_one", 18) != 0)
          break;
        return 73;	 // "undef_to_negative_one"
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "erge_dead_to_trunc", 18) != 0)
          break;
        return 209;	 // "unmerge_dead_to_trunc"
      }
      break;
    }
    break;
  case 22:	 // 13 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'o')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "bine_shuffle_concat", 19) != 0)
          break;
        return 200;	 // "combine_shuffle_concat"
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "stant_fold_fp_binop", 19) != 0)
          break;
        return 167;	 // "constant_fold_fp_binop"
      }
      break;
    case 'f':	 // 4 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ld_binop_into_select", 20) != 0)
          break;
        return 186;	 // "fold_binop_into_select"
      case 'u':	 // 3 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "nnel_shift_", 11) != 0)
          break;
        switch (RuleIdentifier[13]) {
        default: break;
        case 'l':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "eft_zero", 8) != 0)
            break;
          return 157;	 // "funnel_shift_left_zero"
        case 'o':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "vershift", 8) != 0)
            break;
          return 158;	 // "funnel_shift_overshift"
        case 't':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "o_rotate", 8) != 0)
            break;
          return 155;	 // "funnel_shift_to_rotate"
        }
        break;
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "cmp_to_lhs_known_bits", 21) != 0)
        break;
      return 112;	 // "icmp_to_lhs_known_bits"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_subo_no_overflow", 21) != 0)
        break;
      return 214;	 // "match_subo_no_overflow"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ropagate_undef_any_op", 21) != 0)
        break;
      return 78;	 // "propagate_undef_any_op"
    case 'r':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "dundant_neg_operands", 20) != 0)
          break;
        return 176;	 // "redundant_neg_operands"
      case 'i':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ght_identity_one_int", 20) != 0)
          break;
        return 92;	 // "right_identity_one_int"
      }
      break;
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "hl_ashr_to_sext_inreg", 21) != 0)
        break;
      return 116;	 // "shl_ashr_to_sext_inreg"
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_buildvector_fold", 21) != 0)
        break;
      return 96;	 // "trunc_buildvector_fold"
    }
    break;
  case 23:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "uildvector_of_truncate", 22) != 0)
        break;
      return 57;	 // "buildvector_of_truncate"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "unnel_shift_right_zero", 22) != 0)
        break;
      return 156;	 // "funnel_shift_right_zero"
    case 'i':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "tof_const_zero_fold_", 20) != 0)
        break;
      switch (RuleIdentifier[21]) {
      default: break;
      case 's':	 // 1 string to match.
        if (RuleIdentifier[22] != 'i')
          break;
        return 139;	 // "itof_const_zero_fold_si"
      case 'u':	 // 1 string to match.
        if (RuleIdentifier[22] != 'i')
          break;
        return 140;	 // "itof_const_zero_fold_ui"
      }
      break;
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ropagate_undef_all_ops", 22) != 0)
        break;
      return 79;	 // "propagate_undef_all_ops"
    }
    break;
  case 24:	 // 6 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_left_undef_to_zero", 23) != 0)
        break;
      return 74;	 // "binop_left_undef_to_zero"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_extract_of_element", 23) != 0)
        break;
      return 23;	 // "match_extract_of_element"
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "arrow_binop_feeding_and", 23) != 0)
        break;
      return 120;	 // "narrow_binop_feeding_and"
    case 's':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_inreg_", 10) != 0)
        break;
      switch (RuleIdentifier[11]) {
      default: break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "f_sext_inreg", 12) != 0)
          break;
        return 53;	 // "sext_inreg_of_sext_inreg"
      case 't':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "o_zext_inreg", 12) != 0)
          break;
        return 130;	 // "sext_inreg_to_zext_inreg"
      }
      break;
    case 'x':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "or_of_and_with_same_reg", 23) != 0)
        break;
      return 148;	 // "xor_of_and_with_same_reg"
    }
    break;
  case 25:	 // 7 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'i':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "tfield_extract_from_", 20) != 0)
          break;
        switch (RuleIdentifier[22]) {
        default: break;
        case 'a':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+23, "nd", 2) != 0)
            break;
          return 163;	 // "bitfield_extract_from_and"
        case 's':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+23, "hr", 2) != 0)
            break;
          return 164;	 // "bitfield_extract_from_shr"
        }
        break;
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ildvector_identity_fold", 23) != 0)
          break;
        return 95;	 // "buildvector_identity_fold"
      }
      break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_shuffle_undef_rhs", 24) != 0)
        break;
      return 201;	 // "combine_shuffle_undef_rhs"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vec_elt_build_vec", 24) != 0)
        break;
      return 66;	 // "extract_vec_elt_build_vec"
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "eg_and_one_to_sext_inreg", 24) != 0)
        break;
      return 117;	 // "neg_and_one_to_sext_inreg"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_neg_one_fp", 24) != 0)
        break;
      return 101;	 // "right_identity_neg_one_fp"
    }
    break;
  case 26:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_right_undef_to_undef", 25) != 0)
        break;
      return 75;	 // "binop_right_undef_to_undef"
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ommute_fp_constant_to_rhs", 25) != 0)
        break;
      return 192;	 // "commute_fp_constant_to_rhs"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "unnel_shift_from_or_shift", 25) != 0)
        break;
      return 154;	 // "funnel_shift_from_or_shift"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_neg_zero_fp", 25) != 0)
        break;
      return 100;	 // "right_identity_neg_zero_fp"
    }
    break;
  case 27:	 // 6 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "om", 2) != 0)
        break;
      switch (RuleIdentifier[3]) {
      default: break;
      case 'b':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+4, "ine_use_vector_truncate", 23) != 0)
          break;
        return 203;	 // "combine_use_vector_truncate"
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+4, "ute_int_constant_to_rhs", 23) != 0)
          break;
        return 191;	 // "commute_int_constant_to_rhs"
      }
      break;
    case 'd':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ouble_icmp_zero_or_combine", 26) != 0)
        break;
      return 114;	 // "double_icmp_zero_or_combine"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_binop_in_equality", 26) != 0)
        break;
      return 115;	 // "redundant_binop_in_equality"
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_lshr_buildvector_fold", 26) != 0)
        break;
      return 97;	 // "trunc_lshr_buildvector_fold"
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nmerge_anyext_build_vector", 26) != 0)
        break;
      return 204;	 // "unmerge_anyext_build_vector"
    }
    break;
  case 28:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'd':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ouble_icmp_zero_and_combine", 27) != 0)
        break;
      return 113;	 // "double_icmp_zero_and_combine"
    case 'o':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "pt_brcond_by_inverting_cond", 27) != 0)
        break;
      return 133;	 // "opt_brcond_by_inverting_cond"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ropagate_undef_shuffle_mask", 27) != 0)
        break;
      return 80;	 // "propagate_undef_shuffle_mask"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "hift_of_shifted_logic_chain", 27) != 0)
        break;
      return 151;	 // "shift_of_shifted_logic_chain"
    }
    break;
  case 29:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itfield_extract_from_shr_and", 28) != 0)
        break;
      return 165;	 // "bitfield_extract_from_shr_and"
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_", 7) != 0)
        break;
      switch (RuleIdentifier[8]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "xtracted_vector_load", 20) != 0)
          break;
        return 70;	 // "combine_extracted_vector_load"
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "huffle_disjoint_mask", 20) != 0)
          break;
        return 202;	 // "combine_shuffle_disjoint_mask"
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "cmp_to_true_false_known_bits", 28) != 0)
        break;
      return 111;	 // "icmp_to_true_false_known_bits"
    }
    break;
  case 30:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "freeze_of_non_undef_non_poison", 30) != 0)
      break;
    return 41;	 // "freeze_of_non_undef_non_poison"
  case 31:	 // 2 strings to match.
    if (memcmp(RuleIdentifier.data()+0, "insert_vector_element_", 22) != 0)
      break;
    switch (RuleIdentifier[22]) {
    default: break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+23, "lt_undef", 8) != 0)
        break;
      return 22;	 // "insert_vector_element_elt_undef"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+23, "dx_undef", 8) != 0)
        break;
      return 21;	 // "insert_vector_element_idx_undef"
    }
    break;
  case 32:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itfield_extract_from_sext_inreg", 31) != 0)
        break;
      return 162;	 // "bitfield_extract_from_sext_inreg"
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_f", 8) != 0)
        break;
      switch (RuleIdentifier[9]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+10, "dd_fmul_to_fmad_or_fma", 22) != 0)
          break;
        return 178;	 // "combine_fadd_fmul_to_fmad_or_fma"
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+10, "ub_fmul_to_fmad_or_fma", 22) != 0)
          break;
        return 182;	 // "combine_fsub_fmul_to_fmad_or_fma"
      }
      break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vector_element_not_const", 31) != 0)
        break;
      return 25;	 // "extract_vector_element_not_const"
    }
    break;
  case 34:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "extract_all_elts_from_build_vector", 34) != 0)
      break;
    return 67;	 // "extract_all_elts_from_build_vector"
  case 35:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "extract_vector_element_build_vector", 35) != 0)
      break;
    return 27;	 // "extract_vector_element_build_vector"
  case 36:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_", 7) != 0)
        break;
      switch (RuleIdentifier[8]) {
      default: break;
      case 'f':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "add_fma_fmul_to_fmad_or_fma", 27) != 0)
          break;
        return 180;	 // "combine_fadd_fma_fmul_to_fmad_or_fma"
      case 'i':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "nsert_vec_elts_build_vector", 27) != 0)
          break;
        return 65;	 // "combine_insert_vec_elts_build_vector"
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nsert_extract_vec_elt_out_of_bounds", 35) != 0)
        break;
      return 82;	 // "insert_extract_vec_elt_out_of_bounds"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_extract_of_element_undef_index", 35) != 0)
        break;
      return 20;	 // "match_extract_of_element_undef_index"
    }
    break;
  case 37:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_fsub_fneg_fmul_to_fmad_or_fma", 36) != 0)
        break;
      return 183;	 // "combine_fsub_fneg_fmul_to_fmad_or_fma"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vector_element_shuffle_vector", 36) != 0)
        break;
      return 35;	 // "extract_vector_element_shuffle_vector"
    case 'h':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oist_logic_op_with_same_opcode_hands", 36) != 0)
        break;
      return 104;	 // "hoist_logic_op_with_same_opcode_hands"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_extract_of_element_undef_vector", 36) != 0)
        break;
      return 19;	 // "match_extract_of_element_undef_vector"
    }
    break;
  case 38:	 // 2 strings to match.
    if (memcmp(RuleIdentifier.data()+0, "combine_f", 9) != 0)
      break;
    switch (RuleIdentifier[9]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+10, "dd_fpext_fmul_to_fmad_or_fma", 28) != 0)
        break;
      return 179;	 // "combine_fadd_fpext_fmul_to_fmad_or_fma"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+10, "ub_fpext_fmul_to_fmad_or_fma", 28) != 0)
        break;
      return 184;	 // "combine_fsub_fpext_fmul_to_fmad_or_fma"
    }
    break;
  case 40:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "extract_vector_element_different_indices", 40) != 0)
      break;
    return 26;	 // "extract_vector_element_different_indices"
  case 42:	 // 8 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_fadd_fpext_fma_fmul_to_fmad_or_fma", 41) != 0)
        break;
      return 181;	 // "combine_fadd_fpext_fma_fmul_to_fmad_or_fma"
    case 'e':	 // 7 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vector_element_build_vector_trunc", 40) != 0)
        break;
      switch (RuleIdentifier[41]) {
      default: break;
      case '2':	 // 1 string to match.
        return 28;	 // "extract_vector_element_build_vector_trunc2"
      case '3':	 // 1 string to match.
        return 29;	 // "extract_vector_element_build_vector_trunc3"
      case '4':	 // 1 string to match.
        return 30;	 // "extract_vector_element_build_vector_trunc4"
      case '5':	 // 1 string to match.
        return 31;	 // "extract_vector_element_build_vector_trunc5"
      case '6':	 // 1 string to match.
        return 32;	 // "extract_vector_element_build_vector_trunc6"
      case '7':	 // 1 string to match.
        return 33;	 // "extract_vector_element_build_vector_trunc7"
      case '8':	 // 1 string to match.
        return 34;	 // "extract_vector_element_build_vector_trunc8"
      }
      break;
    }
    break;
  case 43:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "combine_fsub_fpext_fneg_fmul_to_fmad_or_fma", 43) != 0)
      break;
    return 185;	 // "combine_fsub_fpext_fneg_fmul_to_fmad_or_fma"
  case 44:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "insert_vector_element_extract_vector_element", 44) != 0)
      break;
    return 36;	 // "insert_vector_element_extract_vector_element"
  case 46:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "push_freeze_to_prevent_poison_from_propagating", 46) != 0)
      break;
    return 42;	 // "push_freeze_to_prevent_poison_from_propagating"
  }
#endif // ifndef NDEBUG

  return std::nullopt;
}
static std::optional<std::pair<uint64_t, uint64_t>> getRuleRangeForIdentifier(StringRef RuleIdentifier) {
  std::pair<StringRef, StringRef> RangePair = RuleIdentifier.split('-');
  if (!RangePair.second.empty()) {
    const auto First = getRuleIdxForIdentifier(RangePair.first);
    const auto Last = getRuleIdxForIdentifier(RangePair.second);
    if (!First || !Last)
      return std::nullopt;
    if (First >= Last)
      report_fatal_error("Beginning of range should be before end of range");
    return {{*First, *Last + 1}};
  }
  if (RangePair.first == "*") {
    return {{0, 225}};
  }
  const auto I = getRuleIdxForIdentifier(RangePair.first);
  if (!I)
    return std::nullopt;
  return {{*I, *I + 1}};
}

bool AArch64PreLegalizerCombinerImplRuleConfig::setRuleEnabled(StringRef RuleIdentifier) {
  auto MaybeRange = getRuleRangeForIdentifier(RuleIdentifier);
  if (!MaybeRange)
    return false;
  for (auto I = MaybeRange->first; I < MaybeRange->second; ++I)
    DisabledRules.reset(I);
  return true;
}

bool AArch64PreLegalizerCombinerImplRuleConfig::setRuleDisabled(StringRef RuleIdentifier) {
  auto MaybeRange = getRuleRangeForIdentifier(RuleIdentifier);
  if (!MaybeRange)
    return false;
  for (auto I = MaybeRange->first; I < MaybeRange->second; ++I)
    DisabledRules.set(I);
  return true;
}

static std::vector<std::string> AArch64PreLegalizerCombinerOption;
static cl::list<std::string> AArch64PreLegalizerCombinerDisableOption(
    "aarch64prelegalizercombiner-disable-rule",
    cl::desc("Disable one or more combiner rules temporarily in the AArch64PreLegalizerCombiner pass"),
    cl::CommaSeparated,
    cl::Hidden,
    cl::cat(GICombinerOptionCategory),
    cl::callback([](const std::string &Str) {
      AArch64PreLegalizerCombinerOption.push_back(Str);
    }));
static cl::list<std::string> AArch64PreLegalizerCombinerOnlyEnableOption(
    "aarch64prelegalizercombiner-only-enable-rule",
    cl::desc("Disable all rules in the AArch64PreLegalizerCombiner pass then re-enable the specified ones"),
    cl::Hidden,
    cl::cat(GICombinerOptionCategory),
    cl::callback([](const std::string &CommaSeparatedArg) {
      StringRef Str = CommaSeparatedArg;
      AArch64PreLegalizerCombinerOption.push_back("*");
      do {
        auto X = Str.split(",");
        AArch64PreLegalizerCombinerOption.push_back(("!" + X.first).str());
        Str = X.second;
      } while (!Str.empty());
    }));


bool AArch64PreLegalizerCombinerImplRuleConfig::isRuleEnabled(unsigned RuleID) const {
    return  !DisabledRules.test(RuleID);
}
bool AArch64PreLegalizerCombinerImplRuleConfig::parseCommandLineOption() {
  for (StringRef Identifier : AArch64PreLegalizerCombinerOption) {
    bool Enabled = Identifier.consume_front("!");
    if (Enabled && !setRuleEnabled(Identifier))
      return false;
    if (!Enabled && !setRuleDisabled(Identifier))
      return false;
  }
  return true;
}

#endif // ifdef GET_GICOMBINER_TYPES

#ifdef GET_GICOMBINER_TYPES
const unsigned MAX_SUBTARGET_PREDICATES = 1;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GICOMBINER_TYPES

#ifdef GET_GICOMBINER_CLASS_MEMBERS
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GICOMBINER_CLASS_MEMBERS
#ifdef GET_GICOMBINER_CLASS_MEMBERS
  mutable MatcherState State;
  typedef ComplexRendererFns(AArch64PreLegalizerCombinerImpl::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(AArch64PreLegalizerCombinerImpl::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static AArch64PreLegalizerCombinerImpl::ComplexMatcherMemFn ComplexPredicateFns[];
  static AArch64PreLegalizerCombinerImpl::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testMOPredicate_MO(unsigned PredicateID, const MachineOperand &MO, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GICOMBINER_CLASS_MEMBERS

#ifdef GET_GICOMBINER_IMPL
// LLT Objects.
enum {
  GILLT_s1,
};
const static size_t NumTypeObjects = 1;
const static LLT TypeObjects[] = {
  LLT::scalar(1),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_HasDotProdBit = 0,
};

PredicateBitset AArch64PreLegalizerCombinerImpl::
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const {
  PredicateBitset Features{};
  if (Subtarget->hasDotProd())
    Features.set(Feature_HasDotProdBit);
  return Features;
}

void AArch64PreLegalizerCombinerImpl::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const AArch64Subtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset AArch64PreLegalizerCombinerImpl::
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HasDotProd,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HasDotProdBit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
};
// See constructor for table contents

AArch64PreLegalizerCombinerImpl::ComplexMatcherMemFn
AArch64PreLegalizerCombinerImpl::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
};

enum {
  GICXXPred_MI_Predicate_GICombiner0 = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_GICombiner1,
  GICXXPred_MI_Predicate_GICombiner2,
  GICXXPred_MI_Predicate_GICombiner3,
  GICXXPred_MI_Predicate_GICombiner4,
  GICXXPred_MI_Predicate_GICombiner5,
  GICXXPred_MI_Predicate_GICombiner6,
  GICXXPred_MI_Predicate_GICombiner7,
  GICXXPred_MI_Predicate_GICombiner8,
  GICXXPred_MI_Predicate_GICombiner9,
};
bool AArch64PreLegalizerCombinerImpl::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_GICombiner0: {
    return isGuaranteedNotToBePoison(State.MIs[0]->getOperand(1).getReg(), MRI);
  }
  case GICXXPred_MI_Predicate_GICombiner1: {
    return isGuaranteedNotToBeUndefOrPoison(State.MIs[0]->getOperand(1).getReg(), MRI);
  }
  case GICXXPred_MI_Predicate_GICombiner2: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), 1.0);
  }
  case GICXXPred_MI_Predicate_GICombiner3: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), -0.0);
  }
  case GICXXPred_MI_Predicate_GICombiner4: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), -1.0);
  }
  case GICXXPred_MI_Predicate_GICombiner5: {
    return State.MIs[1]->getOperand(1).getPredicate() == CmpInst::ICMP_EQ &&
                               !MRI.getType(State.MIs[1]->getOperand(2).getReg()).getScalarType().isPointer() &&
                               (MRI.getType(State.MIs[1]->getOperand(2).getReg()) ==
                                   MRI.getType(State.MIs[2]->getOperand(2).getReg()));
  }
  case GICXXPred_MI_Predicate_GICombiner6: {
    return State.MIs[1]->getOperand(1).getPredicate() == CmpInst::ICMP_NE &&
                               !MRI.getType(State.MIs[1]->getOperand(2).getReg()).getScalarType().isPointer() &&
                               (MRI.getType(State.MIs[1]->getOperand(2).getReg()) ==
                                   MRI.getType(State.MIs[2]->getOperand(2).getReg()));
  }
  case GICXXPred_MI_Predicate_GICombiner7: {
    return MRI.hasOneNonDBGUse(State.MIs[0]->getOperand(2).getReg()) &&
                    Helper.isLegalOrBeforeLegalizer(
                      {TargetOpcode::G_SEXT_INREG, {MRI.getType(State.MIs[1]->getOperand(1).getReg())}});
  }
  case GICXXPred_MI_Predicate_GICombiner8: {
    return Helper.isLegalOrBeforeLegalizer({TargetOpcode::G_LSHR,
                                                           {MRI.getType(State.MIs[2]->getOperand(1).getReg()),
                                                            MRI.getType(State.MIs[1]->getOperand(2).getReg())}});
  }
  case GICXXPred_MI_Predicate_GICombiner9: {
    return Helper.isLegalOrBeforeLegalizer({TargetOpcode::G_SHL,
                                                           {MRI.getType(State.MIs[2]->getOperand(1).getReg()),
                                                            MRI.getType(State.MIs[1]->getOperand(2).getReg())}});
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AArch64PreLegalizerCombinerImpl::testMOPredicate_MO(unsigned PredicateID, const MachineOperand & MO, const MatcherState &State) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AArch64PreLegalizerCombinerImpl::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AArch64PreLegalizerCombinerImpl::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AArch64PreLegalizerCombinerImpl::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
enum {
  GICXXPred_Simple_IsRule0Enabled = GICXXPred_Invalid + 1,
  GICXXPred_Simple_IsRule1Enabled,
  GICXXPred_Simple_IsRule2Enabled,
  GICXXPred_Simple_IsRule3Enabled,
  GICXXPred_Simple_IsRule4Enabled,
  GICXXPred_Simple_IsRule5Enabled,
  GICXXPred_Simple_IsRule6Enabled,
  GICXXPred_Simple_IsRule7Enabled,
  GICXXPred_Simple_IsRule8Enabled,
  GICXXPred_Simple_IsRule9Enabled,
  GICXXPred_Simple_IsRule10Enabled,
  GICXXPred_Simple_IsRule11Enabled,
  GICXXPred_Simple_IsRule12Enabled,
  GICXXPred_Simple_IsRule13Enabled,
  GICXXPred_Simple_IsRule14Enabled,
  GICXXPred_Simple_IsRule15Enabled,
  GICXXPred_Simple_IsRule16Enabled,
  GICXXPred_Simple_IsRule17Enabled,
  GICXXPred_Simple_IsRule18Enabled,
  GICXXPred_Simple_IsRule19Enabled,
  GICXXPred_Simple_IsRule20Enabled,
  GICXXPred_Simple_IsRule21Enabled,
  GICXXPred_Simple_IsRule22Enabled,
  GICXXPred_Simple_IsRule23Enabled,
  GICXXPred_Simple_IsRule24Enabled,
  GICXXPred_Simple_IsRule25Enabled,
  GICXXPred_Simple_IsRule26Enabled,
  GICXXPred_Simple_IsRule27Enabled,
  GICXXPred_Simple_IsRule28Enabled,
  GICXXPred_Simple_IsRule29Enabled,
  GICXXPred_Simple_IsRule30Enabled,
  GICXXPred_Simple_IsRule31Enabled,
  GICXXPred_Simple_IsRule32Enabled,
  GICXXPred_Simple_IsRule33Enabled,
  GICXXPred_Simple_IsRule34Enabled,
  GICXXPred_Simple_IsRule35Enabled,
  GICXXPred_Simple_IsRule36Enabled,
  GICXXPred_Simple_IsRule37Enabled,
  GICXXPred_Simple_IsRule38Enabled,
  GICXXPred_Simple_IsRule39Enabled,
  GICXXPred_Simple_IsRule40Enabled,
  GICXXPred_Simple_IsRule41Enabled,
  GICXXPred_Simple_IsRule42Enabled,
  GICXXPred_Simple_IsRule43Enabled,
  GICXXPred_Simple_IsRule44Enabled,
  GICXXPred_Simple_IsRule45Enabled,
  GICXXPred_Simple_IsRule46Enabled,
  GICXXPred_Simple_IsRule47Enabled,
  GICXXPred_Simple_IsRule48Enabled,
  GICXXPred_Simple_IsRule49Enabled,
  GICXXPred_Simple_IsRule50Enabled,
  GICXXPred_Simple_IsRule51Enabled,
  GICXXPred_Simple_IsRule52Enabled,
  GICXXPred_Simple_IsRule53Enabled,
  GICXXPred_Simple_IsRule54Enabled,
  GICXXPred_Simple_IsRule55Enabled,
  GICXXPred_Simple_IsRule56Enabled,
  GICXXPred_Simple_IsRule57Enabled,
  GICXXPred_Simple_IsRule58Enabled,
  GICXXPred_Simple_IsRule59Enabled,
  GICXXPred_Simple_IsRule60Enabled,
  GICXXPred_Simple_IsRule61Enabled,
  GICXXPred_Simple_IsRule62Enabled,
  GICXXPred_Simple_IsRule63Enabled,
  GICXXPred_Simple_IsRule64Enabled,
  GICXXPred_Simple_IsRule65Enabled,
  GICXXPred_Simple_IsRule66Enabled,
  GICXXPred_Simple_IsRule67Enabled,
  GICXXPred_Simple_IsRule68Enabled,
  GICXXPred_Simple_IsRule69Enabled,
  GICXXPred_Simple_IsRule70Enabled,
  GICXXPred_Simple_IsRule71Enabled,
  GICXXPred_Simple_IsRule72Enabled,
  GICXXPred_Simple_IsRule73Enabled,
  GICXXPred_Simple_IsRule74Enabled,
  GICXXPred_Simple_IsRule75Enabled,
  GICXXPred_Simple_IsRule76Enabled,
  GICXXPred_Simple_IsRule77Enabled,
  GICXXPred_Simple_IsRule78Enabled,
  GICXXPred_Simple_IsRule79Enabled,
  GICXXPred_Simple_IsRule80Enabled,
  GICXXPred_Simple_IsRule81Enabled,
  GICXXPred_Simple_IsRule82Enabled,
  GICXXPred_Simple_IsRule83Enabled,
  GICXXPred_Simple_IsRule84Enabled,
  GICXXPred_Simple_IsRule85Enabled,
  GICXXPred_Simple_IsRule86Enabled,
  GICXXPred_Simple_IsRule87Enabled,
  GICXXPred_Simple_IsRule88Enabled,
  GICXXPred_Simple_IsRule89Enabled,
  GICXXPred_Simple_IsRule90Enabled,
  GICXXPred_Simple_IsRule91Enabled,
  GICXXPred_Simple_IsRule92Enabled,
  GICXXPred_Simple_IsRule93Enabled,
  GICXXPred_Simple_IsRule94Enabled,
  GICXXPred_Simple_IsRule95Enabled,
  GICXXPred_Simple_IsRule96Enabled,
  GICXXPred_Simple_IsRule97Enabled,
  GICXXPred_Simple_IsRule98Enabled,
  GICXXPred_Simple_IsRule99Enabled,
  GICXXPred_Simple_IsRule100Enabled,
  GICXXPred_Simple_IsRule101Enabled,
  GICXXPred_Simple_IsRule102Enabled,
  GICXXPred_Simple_IsRule103Enabled,
  GICXXPred_Simple_IsRule104Enabled,
  GICXXPred_Simple_IsRule105Enabled,
  GICXXPred_Simple_IsRule106Enabled,
  GICXXPred_Simple_IsRule107Enabled,
  GICXXPred_Simple_IsRule108Enabled,
  GICXXPred_Simple_IsRule109Enabled,
  GICXXPred_Simple_IsRule110Enabled,
  GICXXPred_Simple_IsRule111Enabled,
  GICXXPred_Simple_IsRule112Enabled,
  GICXXPred_Simple_IsRule113Enabled,
  GICXXPred_Simple_IsRule114Enabled,
  GICXXPred_Simple_IsRule115Enabled,
  GICXXPred_Simple_IsRule116Enabled,
  GICXXPred_Simple_IsRule117Enabled,
  GICXXPred_Simple_IsRule118Enabled,
  GICXXPred_Simple_IsRule119Enabled,
  GICXXPred_Simple_IsRule120Enabled,
  GICXXPred_Simple_IsRule121Enabled,
  GICXXPred_Simple_IsRule122Enabled,
  GICXXPred_Simple_IsRule123Enabled,
  GICXXPred_Simple_IsRule124Enabled,
  GICXXPred_Simple_IsRule125Enabled,
  GICXXPred_Simple_IsRule126Enabled,
  GICXXPred_Simple_IsRule127Enabled,
  GICXXPred_Simple_IsRule128Enabled,
  GICXXPred_Simple_IsRule129Enabled,
  GICXXPred_Simple_IsRule130Enabled,
  GICXXPred_Simple_IsRule131Enabled,
  GICXXPred_Simple_IsRule132Enabled,
  GICXXPred_Simple_IsRule133Enabled,
  GICXXPred_Simple_IsRule134Enabled,
  GICXXPred_Simple_IsRule135Enabled,
  GICXXPred_Simple_IsRule136Enabled,
  GICXXPred_Simple_IsRule137Enabled,
  GICXXPred_Simple_IsRule138Enabled,
  GICXXPred_Simple_IsRule139Enabled,
  GICXXPred_Simple_IsRule140Enabled,
  GICXXPred_Simple_IsRule141Enabled,
  GICXXPred_Simple_IsRule142Enabled,
  GICXXPred_Simple_IsRule143Enabled,
  GICXXPred_Simple_IsRule144Enabled,
  GICXXPred_Simple_IsRule145Enabled,
  GICXXPred_Simple_IsRule146Enabled,
  GICXXPred_Simple_IsRule147Enabled,
  GICXXPred_Simple_IsRule148Enabled,
  GICXXPred_Simple_IsRule149Enabled,
  GICXXPred_Simple_IsRule150Enabled,
  GICXXPred_Simple_IsRule151Enabled,
  GICXXPred_Simple_IsRule152Enabled,
  GICXXPred_Simple_IsRule153Enabled,
  GICXXPred_Simple_IsRule154Enabled,
  GICXXPred_Simple_IsRule155Enabled,
  GICXXPred_Simple_IsRule156Enabled,
  GICXXPred_Simple_IsRule157Enabled,
  GICXXPred_Simple_IsRule158Enabled,
  GICXXPred_Simple_IsRule159Enabled,
  GICXXPred_Simple_IsRule160Enabled,
  GICXXPred_Simple_IsRule161Enabled,
  GICXXPred_Simple_IsRule162Enabled,
  GICXXPred_Simple_IsRule163Enabled,
  GICXXPred_Simple_IsRule164Enabled,
  GICXXPred_Simple_IsRule165Enabled,
  GICXXPred_Simple_IsRule166Enabled,
  GICXXPred_Simple_IsRule167Enabled,
  GICXXPred_Simple_IsRule168Enabled,
  GICXXPred_Simple_IsRule169Enabled,
  GICXXPred_Simple_IsRule170Enabled,
  GICXXPred_Simple_IsRule171Enabled,
  GICXXPred_Simple_IsRule172Enabled,
  GICXXPred_Simple_IsRule173Enabled,
  GICXXPred_Simple_IsRule174Enabled,
  GICXXPred_Simple_IsRule175Enabled,
  GICXXPred_Simple_IsRule176Enabled,
  GICXXPred_Simple_IsRule177Enabled,
  GICXXPred_Simple_IsRule178Enabled,
  GICXXPred_Simple_IsRule179Enabled,
  GICXXPred_Simple_IsRule180Enabled,
  GICXXPred_Simple_IsRule181Enabled,
  GICXXPred_Simple_IsRule182Enabled,
  GICXXPred_Simple_IsRule183Enabled,
  GICXXPred_Simple_IsRule184Enabled,
  GICXXPred_Simple_IsRule185Enabled,
  GICXXPred_Simple_IsRule186Enabled,
  GICXXPred_Simple_IsRule187Enabled,
  GICXXPred_Simple_IsRule188Enabled,
  GICXXPred_Simple_IsRule189Enabled,
  GICXXPred_Simple_IsRule190Enabled,
  GICXXPred_Simple_IsRule191Enabled,
  GICXXPred_Simple_IsRule192Enabled,
  GICXXPred_Simple_IsRule193Enabled,
  GICXXPred_Simple_IsRule194Enabled,
  GICXXPred_Simple_IsRule195Enabled,
  GICXXPred_Simple_IsRule196Enabled,
  GICXXPred_Simple_IsRule197Enabled,
  GICXXPred_Simple_IsRule198Enabled,
  GICXXPred_Simple_IsRule199Enabled,
  GICXXPred_Simple_IsRule200Enabled,
  GICXXPred_Simple_IsRule201Enabled,
  GICXXPred_Simple_IsRule202Enabled,
  GICXXPred_Simple_IsRule203Enabled,
  GICXXPred_Simple_IsRule204Enabled,
  GICXXPred_Simple_IsRule205Enabled,
  GICXXPred_Simple_IsRule206Enabled,
  GICXXPred_Simple_IsRule207Enabled,
  GICXXPred_Simple_IsRule208Enabled,
  GICXXPred_Simple_IsRule209Enabled,
  GICXXPred_Simple_IsRule210Enabled,
  GICXXPred_Simple_IsRule211Enabled,
  GICXXPred_Simple_IsRule212Enabled,
  GICXXPred_Simple_IsRule213Enabled,
  GICXXPred_Simple_IsRule214Enabled,
  GICXXPred_Simple_IsRule215Enabled,
  GICXXPred_Simple_IsRule216Enabled,
  GICXXPred_Simple_IsRule217Enabled,
  GICXXPred_Simple_IsRule218Enabled,
  GICXXPred_Simple_IsRule219Enabled,
  GICXXPred_Simple_IsRule220Enabled,
  GICXXPred_Simple_IsRule221Enabled,
  GICXXPred_Simple_IsRule222Enabled,
  GICXXPred_Simple_IsRule223Enabled,
  GICXXPred_Simple_IsRule224Enabled,
};

bool AArch64PreLegalizerCombinerImpl::testSimplePredicate(unsigned Predicate) const {
    return RuleConfig.isRuleEnabled(Predicate - GICXXPred_Invalid - 1);
}
// Custom renderers.
enum {
  GICR_Invalid,
};
AArch64PreLegalizerCombinerImpl::CustomRendererFn
AArch64PreLegalizerCombinerImpl::CustomRenderers[] = {
  nullptr, // GICR_Invalid
};

bool AArch64PreLegalizerCombinerImpl::tryCombineAllImpl(MachineInstr &I) const {
  const TargetSubtargetInfo &ST = MF.getSubtarget();
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  B.setInstrAndDebugLoc(I);
  State.MIs.clear();
  State.MIs.push_back(&I);
  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), *ST.getInstrInfo(), MRI, *MRI.getTargetRegisterInfo(), *ST.getRegBankInfo(), AvailableFeatures, /*CoverageInfo*/ nullptr)) {
    return true;
  }

  return false;
}

enum {
  GICXXCustomAction_GICombiner0 = GICXXCustomAction_Invalid + 1,
  GICXXCustomAction_GICombiner1,
  GICXXCustomAction_GICombiner2,
  GICXXCustomAction_GICombiner3,
  GICXXCustomAction_GICombiner4,
  GICXXCustomAction_GICombiner5,
  GICXXCustomAction_GICombiner6,
  GICXXCustomAction_GICombiner7,
  GICXXCustomAction_GICombiner8,
  GICXXCustomAction_GICombiner9,
  GICXXCustomAction_GICombiner10,
  GICXXCustomAction_GICombiner11,
  GICXXCustomAction_GICombiner12,
  GICXXCustomAction_GICombiner13,
  GICXXCustomAction_GICombiner14,
  GICXXCustomAction_GICombiner15,
  GICXXCustomAction_GICombiner16,
  GICXXCustomAction_GICombiner17,
  GICXXCustomAction_GICombiner18,
  GICXXCustomAction_GICombiner19,
  GICXXCustomAction_GICombiner20,
  GICXXCustomAction_GICombiner21,
  GICXXCustomAction_GICombiner22,
  GICXXCustomAction_GICombiner23,
  GICXXCustomAction_GICombiner24,
  GICXXCustomAction_GICombiner25,
  GICXXCustomAction_GICombiner26,
  GICXXCustomAction_GICombiner27,
  GICXXCustomAction_GICombiner28,
  GICXXCustomAction_GICombiner29,
  GICXXCustomAction_GICombiner30,
  GICXXCustomAction_GICombiner31,
  GICXXCustomAction_GICombiner32,
  GICXXCustomAction_GICombiner33,
  GICXXCustomAction_GICombiner34,
  GICXXCustomAction_GICombiner35,
  GICXXCustomAction_GICombiner36,
  GICXXCustomAction_GICombiner37,
  GICXXCustomAction_GICombiner38,
  GICXXCustomAction_GICombiner39,
  GICXXCustomAction_GICombiner40,
  GICXXCustomAction_GICombiner41,
  GICXXCustomAction_GICombiner42,
  GICXXCustomAction_GICombiner43,
  GICXXCustomAction_GICombiner44,
  GICXXCustomAction_GICombiner45,
  GICXXCustomAction_GICombiner46,
  GICXXCustomAction_GICombiner47,
  GICXXCustomAction_GICombiner48,
  GICXXCustomAction_GICombiner49,
  GICXXCustomAction_GICombiner50,
  GICXXCustomAction_GICombiner51,
  GICXXCustomAction_GICombiner52,
  GICXXCustomAction_GICombiner53,
  GICXXCustomAction_GICombiner54,
  GICXXCustomAction_GICombiner55,
  GICXXCustomAction_GICombiner56,
  GICXXCustomAction_GICombiner57,
  GICXXCustomAction_GICombiner58,
  GICXXCustomAction_GICombiner59,
  GICXXCustomAction_GICombiner60,
  GICXXCustomAction_GICombiner61,
  GICXXCustomAction_GICombiner62,
  GICXXCustomAction_GICombiner63,
  GICXXCustomAction_GICombiner64,
  GICXXCustomAction_GICombiner65,
  GICXXCustomAction_GICombiner66,
  GICXXCustomAction_GICombiner67,
  GICXXCustomAction_GICombiner68,
  GICXXCustomAction_GICombiner69,
  GICXXCustomAction_GICombiner70,
  GICXXCustomAction_GICombiner71,
  GICXXCustomAction_GICombiner72,
  GICXXCustomAction_GICombiner73,
  GICXXCustomAction_GICombiner74,
  GICXXCustomAction_GICombiner75,
  GICXXCustomAction_GICombiner76,
  GICXXCustomAction_GICombiner77,
  GICXXCustomAction_GICombiner78,
  GICXXCustomAction_GICombiner79,
  GICXXCustomAction_GICombiner80,
  GICXXCustomAction_GICombiner81,
  GICXXCustomAction_GICombiner82,
  GICXXCustomAction_GICombiner83,
  GICXXCustomAction_GICombiner84,
  GICXXCustomAction_GICombiner85,
  GICXXCustomAction_GICombiner86,
  GICXXCustomAction_GICombiner87,
  GICXXCustomAction_GICombiner88,
  GICXXCustomAction_GICombiner89,
  GICXXCustomAction_GICombiner90,
  GICXXCustomAction_GICombiner91,
  GICXXCustomAction_GICombiner92,
  GICXXCustomAction_GICombiner93,
  GICXXCustomAction_GICombiner94,
  GICXXCustomAction_GICombiner95,
  GICXXCustomAction_GICombiner96,
  GICXXCustomAction_GICombiner97,
  GICXXCustomAction_GICombiner98,
  GICXXCustomAction_GICombiner99,
  GICXXCustomAction_GICombiner100,
  GICXXCustomAction_GICombiner101,
  GICXXCustomAction_GICombiner102,
  GICXXCustomAction_GICombiner103,
  GICXXCustomAction_GICombiner104,
  GICXXCustomAction_GICombiner105,
  GICXXCustomAction_GICombiner106,
  GICXXCustomAction_GICombiner107,
  GICXXCustomAction_GICombiner108,
  GICXXCustomAction_GICombiner109,
  GICXXCustomAction_GICombiner110,
  GICXXCustomAction_GICombiner111,
  GICXXCustomAction_GICombiner112,
  GICXXCustomAction_GICombiner113,
  GICXXCustomAction_GICombiner114,
  GICXXCustomAction_GICombiner115,
  GICXXCustomAction_GICombiner116,
  GICXXCustomAction_GICombiner117,
  GICXXCustomAction_GICombiner118,
  GICXXCustomAction_GICombiner119,
  GICXXCustomAction_GICombiner120,
  GICXXCustomAction_GICombiner121,
  GICXXCustomAction_GICombiner122,
  GICXXCustomAction_GICombiner123,
  GICXXCustomAction_GICombiner124,
  GICXXCustomAction_GICombiner125,
  GICXXCustomAction_GICombiner126,
  GICXXCustomAction_GICombiner127,
  GICXXCustomAction_GICombiner128,
  GICXXCustomAction_GICombiner129,
  GICXXCustomAction_GICombiner130,
  GICXXCustomAction_GICombiner131,
  GICXXCustomAction_GICombiner132,
  GICXXCustomAction_GICombiner133,
  GICXXCustomAction_GICombiner134,
  GICXXCustomAction_GICombiner135,
  GICXXCustomAction_GICombiner136,
  GICXXCustomAction_GICombiner137,
  GICXXCustomAction_GICombiner138,
  GICXXCustomAction_GICombiner139,
  GICXXCustomAction_GICombiner140,
  GICXXCustomAction_GICombiner141,
  GICXXCustomAction_GICombiner142,
  GICXXCustomAction_GICombiner143,
  GICXXCustomAction_GICombiner144,
  GICXXCustomAction_GICombiner145,
  GICXXCustomAction_GICombiner146,
  GICXXCustomAction_GICombiner147,
  GICXXCustomAction_GICombiner148,
  GICXXCustomAction_GICombiner149,
  GICXXCustomAction_GICombiner150,
  GICXXCustomAction_GICombiner151,
  GICXXCustomAction_GICombiner152,
  GICXXCustomAction_GICombiner153,
  GICXXCustomAction_GICombiner154,
  GICXXCustomAction_GICombiner155,
  GICXXCustomAction_GICombiner156,
  GICXXCustomAction_GICombiner157,
};
bool AArch64PreLegalizerCombinerImpl::runCustomAction(unsigned ApplyID, const MatcherState &State, NewMIVector &OutMIs) const {
  Helper.getBuilder().setInstrAndDebugLoc(*State.MIs[0]);
  switch(ApplyID) {
  case GICXXCustomAction_GICombiner0:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldAPlusC1MinusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner1:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldC2MinusAPlusC1(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner2:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldAMinusC1MinusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner3:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldC1Minus2MinusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner4:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldAMinusC1PlusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner5:{
    // Match Patterns
    if(![&](){return Helper.matchCombineCopy(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineCopy(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner6:{
    unsigned GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineMulToShl(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineMulToShl(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner7:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineSubToAdd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner8:{
    std::pair<Register, bool> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineAddP2IToPtrAdd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineAddP2IToPtrAdd(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner9:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElement(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner10:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchInsertVectorElementOOB(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner11:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithDifferentIndices(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner12:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithBuildVector(*State.MIs[0], *State.MIs[1],
              GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner13:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithBuildVectorTrunc(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner14:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithShuffleVector(*State.MIs[0], *State.MIs[1],
              GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner15:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAddOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner16:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMulOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner17:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShlOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner18:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSubOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner19:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return !isGuaranteedNotToBePoison(State.MIs[0]->getOperand(1).getReg(), MRI) && Helper.matchFreezeOfSingleMaybePoisonOperand(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner20:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncateOfExt(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner21:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtOfExt(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner22:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantSextInReg(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner23:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCastOfSelect(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner24:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCastOfBuildVector(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner25:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchNarrowBinop(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner26:{
    APInt GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCastOfInteger(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner27:{
    SmallVector<Register> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineInsertVecElts(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineInsertVecElts(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner28:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVecEltBuildVec(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExtractVecEltBuildVec(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner29:{
    SmallVector<std::pair<Register, MachineInstr*>> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractAllEltsFromBuildVector(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExtractAllEltsFromBuildVector(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner30:{
    PreferredTuple GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineExtendingLoads(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineExtendingLoads(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner31:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineLoadWithAndMask(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner32:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineExtractedVectorLoad(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner33:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0], 0.0);
    return true;
  }
  case GICXXCustomAction_GICombiner34:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], 0);
    return true;
  }
  case GICXXCustomAction_GICombiner35:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], -1);
    return true;
  }
  case GICXXCustomAction_GICombiner36:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsUndef(*State.MIs[0], 1);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], 0);
    return true;
  }
  case GICXXCustomAction_GICombiner37:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsUndef(*State.MIs[0], 2);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner38:{
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]->getOperand(0).getParent());
    return true;
  }
  case GICXXCustomAction_GICombiner39:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner40:{
    // Match Patterns
    if(![&](){return Helper.matchAllExplicitUsesAreUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner41:{
    // Match Patterns
    if(![&](){return Helper.matchUndefShuffleVectorMask(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner42:{
    // Match Patterns
    if(![&](){return Helper.matchUndefStore(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.eraseInst(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner43:{
    // Match Patterns
    if(![&](){return Helper.matchInsertExtractVecEltOutOfBounds(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner44:{
    // Match Patterns
    if(![&](){return Helper.matchSelectSameVal(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 2);
    return true;
  }
  case GICXXCustomAction_GICombiner45:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsZero(*State.MIs[0], 1);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 1);
    return true;
  }
  case GICXXCustomAction_GICombiner46:{
    Register GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineI2PToP2I(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineI2PToP2I(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner47:{
    Register GIMatchData_info;
    // Match Patterns
    if(![&](){GIMatchData_info = State.MIs[1]->getOperand(1).getReg(); return true;}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineP2IToI2P(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner48:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineAnyExtTrunc(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner49:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchBuildVectorIdentityFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner50:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncBuildVectorFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner51:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncLshrBuildVectorFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner52:{
    // Match Patterns
    if(![&](){return MRI.getType(State.MIs[1]->getOperand(1).getReg()) == MRI.getType(State.MIs[0]->getOperand(0).getReg());}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], State.MIs[1]->getOperand(1).getReg());
    return true;
  }
  case GICXXCustomAction_GICombiner53:{
    MachineInstr* GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtendThroughPhis(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExtendThroughPhis(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner54:{
    std::tuple<Register, Register> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchSimplifyAddToSub(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySimplifyAddToSub(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner55:{
    InstructionStepsMatchInfo GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchHoistLogicOpWithSameOpcodeHands(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildInstructionSteps(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner56:{
    std::optional<int64_t> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShiftsTooBig(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    if (GIMatchData_matchinfo) {
              Helper.replaceInstWithConstant(*State.MIs[0], *GIMatchData_matchinfo);
            } else {
              Helper.replaceInstWithUndef(*State.MIs[0]);
            }
    return true;
  }
  case GICXXCustomAction_GICombiner57:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchReassocPtrAdd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner58:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchReassocCommBinOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner59:{
    PtrAddChain GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchPtrAddImmedChain(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyPtrAddImmedChain(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner60:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCanonicalizeICmp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner61:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCanonicalizeFCmp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner62:{
    int64_t GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchICmpToTrueFalseKnownBits(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner63:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchICmpToLHSKnownBits(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner64:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchRedundantBinOpInEquality(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner65:{
    std::tuple<Register, int64_t> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchAshrShlToSextInreg(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyAshShlToSextInreg(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner66:{
    std::tuple<Register, unsigned> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSextInRegOfLoad(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySextInRegOfLoad(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner67:{
    RegisterImmPair GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineShlOfExtend(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineShlOfExtend(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner68:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchNarrowBinopFeedingAnd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner69:{
    unsigned GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantSelectCmp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner70:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchSelectIMinMax(State.MIs[0]->getOperand(0), GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner71:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSelect(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner72:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantAnd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner73:{
    // Match Patterns
    if(![&](){return Helper.matchRedundantSExtInReg(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 1);
    return true;
  }
  case GICXXCustomAction_GICombiner74:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantOr(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner75:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsKnownToBeAPowerOfTwo(*State.MIs[0], 2);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySimplifyURemByPow2(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner76:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineZextTrunc(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner77:{
    // Match Patterns
    if(![&](){unsigned BitWidth = MRI.getType(State.MIs[0]->getOperand(1).getReg()).getScalarSizeInBits();
                return Helper.getValueTracking()->maskedValueIsZero(State.MIs[0]->getOperand(1).getReg(),
                         APInt::getOneBitSet(BitWidth, State.MIs[0]->getOperand(2).getImm() - 1));}()) {
      return false;
    }
    // Apply Patterns
    Helper.getBuilder().setInstrAndDebugLoc(*State.MIs[0]);
              Helper.getBuilder().buildZExtInReg(State.MIs[0]->getOperand(0), State.MIs[0]->getOperand(1), State.MIs[0]->getOperand(2).getImm());
              State.MIs[0]->eraseFromParent();
    return true;
  }
  case GICXXCustomAction_GICombiner78:{
    std::pair<MachineInstr*, LLT> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineTruncOfShift(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineTruncOfShift(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner79:{
    SmallVector<Register> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchNotCmp(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyNotCmp(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner80:{
    MachineInstr * GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchOptBrCondByInvertingCond(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyOptBrCondByInvertingCond(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner81:{
    // Apply Patterns
    Helper.applyCombineConstantFoldFpUnary(*State.MIs[0], State.MIs[1]->getOperand(1).getFPImm());
    return true;
  }
  case GICXXCustomAction_GICombiner82:{
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0]->getOperand(0).getParent(), 0.0);
    return true;
  }
  case GICXXCustomAction_GICombiner83:{
    APInt GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineConstPtrAddToI2P(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineConstPtrAddToI2P(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner84:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchOverlappingAnd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner85:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMulOBy2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner86:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMulOBy0(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner87:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAddEToAddO(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner88:{
    unsigned GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFMinMaxNaN(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner89:{
    // Match Patterns
    if(![&](){return Helper.matchFPowIExpansion(*State.MIs[0], State.MIs[1]->getOperand(1).getCImm()->getSExtValue());}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExpandFPowI(*State.MIs[0], State.MIs[1]->getOperand(1).getCImm()->getSExtValue());
    return true;
  }
  case GICXXCustomAction_GICombiner90:{
    std::pair<Register, Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchXorOfAndWithSameReg(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyXorOfAndWithSameReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner91:{
    // Match Patterns
    if(![&](){return Helper.matchPtrAddZero(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyPtrAddZero(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner92:{
    RegisterImmPair GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShiftImmedChain(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyShiftImmedChain(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner93:{
    ShiftOfShiftedLogic GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShiftOfShiftedLogic(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyShiftOfShiftedLogic(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner94:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchLoadOrCombine(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner95:{
    MachineInstr * GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineDivRem(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineDivRem(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner96:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchOrShiftToFunnelShift(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner97:{
    // Match Patterns
    if(![&](){return Helper.matchFunnelShiftToRotate(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFunnelShiftToRotate(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner98:{
    // Match Patterns
    if(![&](){return Helper.matchConstantLargerBitWidth(*State.MIs[0], 3);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFunnelShiftConstantModulo(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner99:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCommuteShift(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner100:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromSExtInReg(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner101:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromAnd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner102:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromShr(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner103:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromShrAnd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner104:{
    APInt GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldBinOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner105:{
    ConstantFP* GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldFPBinOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner106:{
    ConstantFP* GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldFMA(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner107:{
    APInt GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldCastOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner108:{
    // Match Patterns
    if(![&](){return Helper.matchUDivorURemByConst(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUDivorURemByConst(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner109:{
    // Match Patterns
    if(![&](){return Helper.matchSDivByConst(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySDivByConst(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner110:{
    // Match Patterns
    if(![&](){return Helper.matchDivByPow2(*State.MIs[0], /*IsSigned=*/true);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySDivByPow2(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner111:{
    // Match Patterns
    if(![&](){return Helper.matchDivByPow2(*State.MIs[0], /*IsSigned=*/false);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUDivByPow2(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner112:{
    // Match Patterns
    if(![&](){return Helper.matchUMulHToLShr(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUMulHToLShr(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner113:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantNegOperands(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner114:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchAndOrDisjointMask(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner115:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFMulToFMadOrFMA(*State.MIs[0],
                                                                  GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner116:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFpExtFMulToFMadOrFMA(*State.MIs[0],
                                                                       GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner117:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFMAFMulToFMadOrFMA(*State.MIs[0],
                                                                     GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner118:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFpExtFMulToFMadOrFMAAggressive(
                                                          *State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner119:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFMulToFMadOrFMA(*State.MIs[0],
                                                                  GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner120:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFNegFMulToFMadOrFMA(*State.MIs[0],
                                                                      GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner121:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFpExtFMulToFMadOrFMA(*State.MIs[0],
                                                                       GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner122:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFpExtFNegFMulToFMadOrFMA(
                                                    *State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner123:{
    unsigned GIMatchData_select_op_no;
    // Match Patterns
    if(![&](){return Helper.matchFoldBinOpIntoSelect(*State.MIs[0], GIMatchData_select_op_no);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFoldBinOpIntoSelect(*State.MIs[0], GIMatchData_select_op_no);
    return true;
  }
  case GICXXCustomAction_GICombiner124:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSubAddSameReg(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner125:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchSimplifySelectToMinMax(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner126:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFsubToFneg(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFsubToFneg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner127:{
    // Match Patterns
    if(![&](){return Helper.matchCommuteConstantToRHS(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCommuteBinOpOperands(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner128:{
    // Match Patterns
    if(![&](){return Helper.matchCommuteFPConstantToRHS(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCommuteBinOpOperands(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner129:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAnd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner130:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchOr(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner131:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSimplifyNegMinMax(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner132:{
    SmallVector<Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineConcatVectors(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineConcatVectors(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner133:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSextOfTrunc(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner134:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchZextOfTrunc(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner135:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchNonNegZext(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner136:{
    SmallVector<Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineShuffleConcat(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineShuffleConcat(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner137:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShuffleUndefRHS(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner138:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShuffleDisjointMask(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner139:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchUseVectorTruncate(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUseVectorTruncate(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner140:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchUnmergeValuesAnyExtBuildVector(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner141:{
    SmallVector<Register> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeMergeToPlainValues(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeMergeToPlainValues(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner142:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineMergeUnmerge(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner143:{
    SmallVector<APInt, 8> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeConstant(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeConstant(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner144:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeUndef(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner145:{
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeWithDeadLanesToTrunc(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeWithDeadLanesToTrunc(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner146:{
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeZExtToZExt(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeZExtToZExt(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner147:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMergeXAndUndef(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner148:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMergeXAndZero(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner149:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAddOverflow(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner150:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSuboCarryOut(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner151:{
    // Match Patterns
    if(![&](){return matchFConstantToConstant(*State.MIs[0], MRI);}()) {
      return false;
    }
    // Apply Patterns
    applyFConstantToConstant(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner152:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchICmpRedundantTrunc(*State.MIs[0], MRI, Helper.getValueTracking(), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    applyICmpRedundantTrunc(*State.MIs[0], MRI, B, Observer, GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner153:{
    std::pair<uint64_t, uint64_t> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchFoldGlobalOffset(*State.MIs[0], MRI, GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    applyFoldGlobalOffset(*State.MIs[0], MRI, B, Observer, GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner154:{
    // Match Patterns
    if(![&](){return Helper.matchShuffleToExtract(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyShuffleToExtract(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner155:{
    std::tuple<Register, Register, bool> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchExtAddvToUdotAddv(*State.MIs[0], MRI, STI, GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    applyExtAddvToUdotAddv(*State.MIs[0], MRI, B, Observer, STI, GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner156:{
    std::pair<Register, bool> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchExtUaddvToUaddlv(*State.MIs[0], MRI, GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    applyExtUaddvToUaddlv(*State.MIs[0], MRI, B, Observer, GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner157:{
    // Match Patterns
    if(![&](){return matchPushAddSubExt(*State.MIs[0], MRI, State.MIs[0]->getOperand(0).getReg(), State.MIs[1]->getOperand(1).getReg(), State.MIs[2]->getOperand(1).getReg());}()) {
      return false;
    }
    // Apply Patterns
    applyPushAddSubExt(*State.MIs[0], MRI, B, State.MIs[1]->getOpcode() == TargetOpcode::G_SEXT, State.MIs[0]->getOperand(0).getReg(), State.MIs[1]->getOperand(1).getReg(), State.MIs[2]->getOperand(1).getReg());
    return true;
  }
  }
  llvm_unreachable("Unknown Apply Action");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *AArch64PreLegalizerCombinerImpl::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*    0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(20), GIMT_Encode2(303), /*)*//*default:*//*Label 98*/ GIMT_Encode4(7374),
     /*   10 */ /*TargetOpcode::COPY*//*Label 0*/ GIMT_Encode4(1142), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  142 */ /*TargetOpcode::G_ADD*//*Label 1*/ GIMT_Encode4(1154),
     /*  146 */ /*TargetOpcode::G_SUB*//*Label 2*/ GIMT_Encode4(1769),
     /*  150 */ /*TargetOpcode::G_MUL*//*Label 3*/ GIMT_Encode4(2145),
     /*  154 */ /*TargetOpcode::G_SDIV*//*Label 4*/ GIMT_Encode4(2311),
     /*  158 */ /*TargetOpcode::G_UDIV*//*Label 5*/ GIMT_Encode4(2384),
     /*  162 */ /*TargetOpcode::G_SREM*//*Label 6*/ GIMT_Encode4(2468),
     /*  166 */ /*TargetOpcode::G_UREM*//*Label 7*/ GIMT_Encode4(2513), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  178 */ /*TargetOpcode::G_AND*//*Label 8*/ GIMT_Encode4(2591),
     /*  182 */ /*TargetOpcode::G_OR*//*Label 9*/ GIMT_Encode4(2872),
     /*  186 */ /*TargetOpcode::G_XOR*//*Label 10*/ GIMT_Encode4(3117), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  202 */ /*TargetOpcode::G_PHI*//*Label 11*/ GIMT_Encode4(3218), GIMT_Encode4(0),
     /*  210 */ /*TargetOpcode::G_GLOBAL_VALUE*//*Label 12*/ GIMT_Encode4(3230), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  226 */ /*TargetOpcode::G_UNMERGE_VALUES*//*Label 13*/ GIMT_Encode4(3242), GIMT_Encode4(0),
     /*  234 */ /*TargetOpcode::G_MERGE_VALUES*//*Label 14*/ GIMT_Encode4(3309),
     /*  238 */ /*TargetOpcode::G_BUILD_VECTOR*//*Label 15*/ GIMT_Encode4(3383),
     /*  242 */ /*TargetOpcode::G_BUILD_VECTOR_TRUNC*//*Label 16*/ GIMT_Encode4(3431),
     /*  246 */ /*TargetOpcode::G_CONCAT_VECTORS*//*Label 17*/ GIMT_Encode4(3443),
     /*  250 */ /*TargetOpcode::G_PTRTOINT*//*Label 18*/ GIMT_Encode4(3455),
     /*  254 */ /*TargetOpcode::G_INTTOPTR*//*Label 19*/ GIMT_Encode4(3498),
     /*  258 */ /*TargetOpcode::G_BITCAST*//*Label 20*/ GIMT_Encode4(3531),
     /*  262 */ /*TargetOpcode::G_FREEZE*//*Label 21*/ GIMT_Encode4(3574), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  302 */ /*TargetOpcode::G_LOAD*//*Label 22*/ GIMT_Encode4(3638),
     /*  306 */ /*TargetOpcode::G_SEXTLOAD*//*Label 23*/ GIMT_Encode4(3650),
     /*  310 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 24*/ GIMT_Encode4(3662), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  326 */ /*TargetOpcode::G_STORE*//*Label 25*/ GIMT_Encode4(3674), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  462 */ /*TargetOpcode::G_ANYEXT*//*Label 26*/ GIMT_Encode4(3686),
     /*  466 */ /*TargetOpcode::G_TRUNC*//*Label 27*/ GIMT_Encode4(3814), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  486 */ /*TargetOpcode::G_FCONSTANT*//*Label 28*/ GIMT_Encode4(4172), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  498 */ /*TargetOpcode::G_SEXT*//*Label 29*/ GIMT_Encode4(4184),
     /*  502 */ /*TargetOpcode::G_SEXT_INREG*//*Label 30*/ GIMT_Encode4(4259),
     /*  506 */ /*TargetOpcode::G_ZEXT*//*Label 31*/ GIMT_Encode4(4325),
     /*  510 */ /*TargetOpcode::G_SHL*//*Label 32*/ GIMT_Encode4(4455),
     /*  514 */ /*TargetOpcode::G_LSHR*//*Label 33*/ GIMT_Encode4(4624),
     /*  518 */ /*TargetOpcode::G_ASHR*//*Label 34*/ GIMT_Encode4(4747),
     /*  522 */ /*TargetOpcode::G_FSHL*//*Label 35*/ GIMT_Encode4(4881),
     /*  526 */ /*TargetOpcode::G_FSHR*//*Label 36*/ GIMT_Encode4(4924),
     /*  530 */ /*TargetOpcode::G_ROTR*//*Label 37*/ GIMT_Encode4(4967),
     /*  534 */ /*TargetOpcode::G_ROTL*//*Label 38*/ GIMT_Encode4(4991),
     /*  538 */ /*TargetOpcode::G_ICMP*//*Label 39*/ GIMT_Encode4(5015),
     /*  542 */ /*TargetOpcode::G_FCMP*//*Label 40*/ GIMT_Encode4(5071), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  554 */ /*TargetOpcode::G_SELECT*//*Label 41*/ GIMT_Encode4(5083),
     /*  558 */ /*TargetOpcode::G_UADDO*//*Label 42*/ GIMT_Encode4(5178),
     /*  562 */ /*TargetOpcode::G_UADDE*//*Label 43*/ GIMT_Encode4(5201),
     /*  566 */ /*TargetOpcode::G_USUBO*//*Label 44*/ GIMT_Encode4(5213),
     /*  570 */ /*TargetOpcode::G_USUBE*//*Label 45*/ GIMT_Encode4(5225),
     /*  574 */ /*TargetOpcode::G_SADDO*//*Label 46*/ GIMT_Encode4(5237),
     /*  578 */ /*TargetOpcode::G_SADDE*//*Label 47*/ GIMT_Encode4(5260),
     /*  582 */ /*TargetOpcode::G_SSUBO*//*Label 48*/ GIMT_Encode4(5272),
     /*  586 */ /*TargetOpcode::G_SSUBE*//*Label 49*/ GIMT_Encode4(5284),
     /*  590 */ /*TargetOpcode::G_UMULO*//*Label 50*/ GIMT_Encode4(5296),
     /*  594 */ /*TargetOpcode::G_SMULO*//*Label 51*/ GIMT_Encode4(5330),
     /*  598 */ /*TargetOpcode::G_UMULH*//*Label 52*/ GIMT_Encode4(5364),
     /*  602 */ /*TargetOpcode::G_SMULH*//*Label 53*/ GIMT_Encode4(5387),
     /*  606 */ /*TargetOpcode::G_UADDSAT*//*Label 54*/ GIMT_Encode4(5399),
     /*  610 */ /*TargetOpcode::G_SADDSAT*//*Label 55*/ GIMT_Encode4(5411), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  622 */ /*TargetOpcode::G_USHLSAT*//*Label 56*/ GIMT_Encode4(5423),
     /*  626 */ /*TargetOpcode::G_SSHLSAT*//*Label 57*/ GIMT_Encode4(5446),
     /*  630 */ /*TargetOpcode::G_SMULFIX*//*Label 58*/ GIMT_Encode4(5469),
     /*  634 */ /*TargetOpcode::G_UMULFIX*//*Label 59*/ GIMT_Encode4(5481),
     /*  638 */ /*TargetOpcode::G_SMULFIXSAT*//*Label 60*/ GIMT_Encode4(5493),
     /*  642 */ /*TargetOpcode::G_UMULFIXSAT*//*Label 61*/ GIMT_Encode4(5505), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  662 */ /*TargetOpcode::G_FADD*//*Label 62*/ GIMT_Encode4(5517),
     /*  666 */ /*TargetOpcode::G_FSUB*//*Label 63*/ GIMT_Encode4(5629),
     /*  670 */ /*TargetOpcode::G_FMUL*//*Label 64*/ GIMT_Encode4(5718),
     /*  674 */ /*TargetOpcode::G_FMA*//*Label 65*/ GIMT_Encode4(5806),
     /*  678 */ /*TargetOpcode::G_FMAD*//*Label 66*/ GIMT_Encode4(5829),
     /*  682 */ /*TargetOpcode::G_FDIV*//*Label 67*/ GIMT_Encode4(5852),
     /*  686 */ /*TargetOpcode::G_FREM*//*Label 68*/ GIMT_Encode4(5886), GIMT_Encode4(0),
     /*  694 */ /*TargetOpcode::G_FPOWI*//*Label 69*/ GIMT_Encode4(5898), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  714 */ /*TargetOpcode::G_FLOG2*//*Label 70*/ GIMT_Encode4(5920), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  730 */ /*TargetOpcode::G_FNEG*//*Label 71*/ GIMT_Encode4(5942), GIMT_Encode4(0),
     /*  738 */ /*TargetOpcode::G_FPTRUNC*//*Label 72*/ GIMT_Encode4(5993),
     /*  742 */ /*TargetOpcode::G_FPTOSI*//*Label 73*/ GIMT_Encode4(6036),
     /*  746 */ /*TargetOpcode::G_FPTOUI*//*Label 74*/ GIMT_Encode4(6058),
     /*  750 */ /*TargetOpcode::G_SITOFP*//*Label 75*/ GIMT_Encode4(6080),
     /*  754 */ /*TargetOpcode::G_UITOFP*//*Label 76*/ GIMT_Encode4(6107), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  766 */ /*TargetOpcode::G_FABS*//*Label 77*/ GIMT_Encode4(6134), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  778 */ /*TargetOpcode::G_FCANONICALIZE*//*Label 78*/ GIMT_Encode4(6213),
     /*  782 */ /*TargetOpcode::G_FMINNUM*//*Label 79*/ GIMT_Encode4(6243),
     /*  786 */ /*TargetOpcode::G_FMAXNUM*//*Label 80*/ GIMT_Encode4(6277),
     /*  790 */ /*TargetOpcode::G_FMINNUM_IEEE*//*Label 81*/ GIMT_Encode4(6311),
     /*  794 */ /*TargetOpcode::G_FMAXNUM_IEEE*//*Label 82*/ GIMT_Encode4(6323),
     /*  798 */ /*TargetOpcode::G_FMINIMUM*//*Label 83*/ GIMT_Encode4(6335),
     /*  802 */ /*TargetOpcode::G_FMAXIMUM*//*Label 84*/ GIMT_Encode4(6369), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  838 */ /*TargetOpcode::G_PTR_ADD*//*Label 85*/ GIMT_Encode4(6403), GIMT_Encode4(0),
     /*  846 */ /*TargetOpcode::G_SMIN*//*Label 86*/ GIMT_Encode4(6493),
     /*  850 */ /*TargetOpcode::G_SMAX*//*Label 87*/ GIMT_Encode4(6527),
     /*  854 */ /*TargetOpcode::G_UMIN*//*Label 88*/ GIMT_Encode4(6561),
     /*  858 */ /*TargetOpcode::G_UMAX*//*Label 89*/ GIMT_Encode4(6595),
     /*  862 */ /*TargetOpcode::G_ABS*//*Label 90*/ GIMT_Encode4(6629), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  874 */ /*TargetOpcode::G_BR*//*Label 91*/ GIMT_Encode4(6641), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  894 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 92*/ GIMT_Encode4(6653),
     /*  898 */ /*TargetOpcode::G_EXTRACT_VECTOR_ELT*//*Label 93*/ GIMT_Encode4(6783),
     /*  902 */ /*TargetOpcode::G_SHUFFLE_VECTOR*//*Label 94*/ GIMT_Encode4(7160), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  942 */ /*TargetOpcode::G_BITREVERSE*//*Label 95*/ GIMT_Encode4(7237), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  994 */ /*TargetOpcode::G_FSQRT*//*Label 96*/ GIMT_Encode4(7326), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 1138 */ /*TargetOpcode::G_VECREDUCE_ADD*//*Label 97*/ GIMT_Encode4(7348),
     /* 1142 */ // Label 0: @1142
     /* 1142 */ GIM_Try, /*On fail goto*//*Label 99*/ GIMT_Encode4(1153), // Rule ID 13 //
     /* 1147 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule13Enabled),
     /* 1150 */   // MIs[0] d
     /* 1150 */   // No operand predicates
     /* 1150 */   // MIs[0] s
     /* 1150 */   // No operand predicates
     /* 1150 */   // Combiner Rule #13: copy_prop
     /* 1150 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner5),
     /* 1153 */ // Label 99: @1153
     /* 1153 */ GIM_Reject,
     /* 1154 */ // Label 1: @1154
     /* 1154 */ GIM_Try, /*On fail goto*//*Label 100*/ GIMT_Encode4(1165), // Rule ID 16 //
     /* 1159 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule16Enabled),
     /* 1162 */   // Combiner Rule #16: add_p2i_to_ptradd; wip_match_opcode 'G_ADD'
     /* 1162 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner8),
     /* 1165 */ // Label 100: @1165
     /* 1165 */ GIM_Try, /*On fail goto*//*Label 101*/ GIMT_Encode4(1176), // Rule ID 94 //
     /* 1170 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 1173 */   // Combiner Rule #78: propagate_undef_any_op; wip_match_opcode 'G_ADD'
     /* 1173 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 1176 */ // Label 101: @1176
     /* 1176 */ GIM_Try, /*On fail goto*//*Label 102*/ GIMT_Encode4(1187), // Rule ID 141 //
     /* 1181 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule103Enabled),
     /* 1184 */   // Combiner Rule #103: simplify_add_to_sub; wip_match_opcode 'G_ADD'
     /* 1184 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner54),
     /* 1187 */ // Label 102: @1187
     /* 1187 */ GIM_Try, /*On fail goto*//*Label 103*/ GIMT_Encode4(1198), // Rule ID 231 //
     /* 1192 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 1195 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_ADD'
     /* 1195 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 1198 */ // Label 103: @1198
     /* 1198 */ GIM_Try, /*On fail goto*//*Label 104*/ GIMT_Encode4(1209), // Rule ID 279 //
     /* 1203 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 1206 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_ADD'
     /* 1206 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 1209 */ // Label 104: @1209
     /* 1209 */ GIM_Try, /*On fail goto*//*Label 105*/ GIMT_Encode4(1220), // Rule ID 309 //
     /* 1214 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 1217 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_ADD'
     /* 1217 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 1220 */ // Label 105: @1220
     /* 1220 */ GIM_Try, /*On fail goto*//*Label 106*/ GIMT_Encode4(1254), // Rule ID 0 //
     /* 1225 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule0Enabled),
     /* 1228 */   // MIs[0] root
     /* 1228 */   // No operand predicates
     /* 1228 */   // MIs[0] sub
     /* 1228 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1232 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1236 */   // MIs[1] Operand 1
     /* 1236 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /* 1240 */   // MIs[1] A
     /* 1240 */   // No operand predicates
     /* 1240 */   // MIs[0] B
     /* 1240 */   // No operand predicates
     /* 1240 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1242 */   // Combiner Rule #0: ZeroMinusAPlusB
     /* 1242 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1245 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1247 */   GIR_RootToRootCopy, /*OpIdx*/2, // B
     /* 1249 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // A
     /* 1253 */   GIR_EraseRootFromParent_Done,
     /* 1254 */ // Label 106: @1254
     /* 1254 */ GIM_Try, /*On fail goto*//*Label 107*/ GIMT_Encode4(1291), // Rule ID 12 //
     /* 1259 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule12Enabled),
     /* 1262 */   // MIs[0] root
     /* 1262 */   // No operand predicates
     /* 1262 */   // MIs[0] sub
     /* 1262 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1266 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1270 */   // MIs[1] A
     /* 1270 */   // No operand predicates
     /* 1270 */   // MIs[1] c1
     /* 1270 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1274 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1278 */   // MIs[2] imm1
     /* 1278 */   // No operand predicates
     /* 1278 */   // MIs[0] c2
     /* 1278 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 1282 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1286 */   // MIs[3] imm2
     /* 1286 */   // No operand predicates
     /* 1286 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1288 */   // Combiner Rule #12: AMinusC1PlusC2
     /* 1288 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner4),
     /* 1291 */ // Label 107: @1291
     /* 1291 */ GIM_Try, /*On fail goto*//*Label 108*/ GIMT_Encode4(1325), // Rule ID 3 //
     /* 1296 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule3Enabled),
     /* 1299 */   // MIs[0] root
     /* 1299 */   // No operand predicates
     /* 1299 */   // MIs[0] sub
     /* 1299 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1303 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1307 */   // MIs[1] B
     /* 1307 */   // No operand predicates
     /* 1307 */   // MIs[1] A
     /* 1307 */   // No operand predicates
     /* 1307 */   // MIs[0] A
     /* 1307 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 1312 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1317 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1319 */   // Combiner Rule #3: BMinusAPlusA
     /* 1319 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1324 */   GIR_EraseRootFromParent_Done,
     /* 1325 */ // Label 108: @1325
     /* 1325 */ GIM_Try, /*On fail goto*//*Label 109*/ GIMT_Encode4(1359), // Rule ID 131 //
     /* 1330 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule94Enabled),
     /* 1333 */   // MIs[0] dst
     /* 1333 */   // No operand predicates
     /* 1333 */   // MIs[0] __add_sub_reg_match_0.tmp
     /* 1333 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1337 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1341 */   // MIs[1] src
     /* 1341 */   // No operand predicates
     /* 1341 */   // MIs[1] __add_sub_reg_match_0.x
     /* 1341 */   // No operand predicates
     /* 1341 */   // MIs[0] __add_sub_reg_match_0.x
     /* 1341 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 1346 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1351 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1353 */   // Combiner Rule #94: add_sub_reg @ [__add_sub_reg_match_0[1]]
     /* 1353 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1358 */   GIR_EraseRootFromParent_Done,
     /* 1359 */ // Label 109: @1359
     /* 1359 */ GIM_Try, /*On fail goto*//*Label 110*/ GIMT_Encode4(1404), // Rule ID 5 //
     /* 1364 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /* 1367 */   // MIs[0] root
     /* 1367 */   // No operand predicates
     /* 1367 */   // MIs[0] sub1
     /* 1367 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1371 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1375 */   // MIs[1] A
     /* 1375 */   // No operand predicates
     /* 1375 */   // MIs[1] B
     /* 1375 */   // No operand predicates
     /* 1375 */   // MIs[0] sub2
     /* 1375 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1379 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1383 */   // MIs[2] B
     /* 1383 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 1388 */   // MIs[2] C
     /* 1388 */   // No operand predicates
     /* 1388 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1390 */   // Combiner Rule #5: AMinusBPlusBMinusC
     /* 1390 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1393 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1395 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // A
     /* 1399 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // C
     /* 1403 */   GIR_EraseRootFromParent_Done,
     /* 1404 */ // Label 110: @1404
     /* 1404 */ GIM_Try, /*On fail goto*//*Label 111*/ GIMT_Encode4(1449), // Rule ID 4 //
     /* 1409 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule4Enabled),
     /* 1412 */   // MIs[0] root
     /* 1412 */   // No operand predicates
     /* 1412 */   // MIs[0] sub1
     /* 1412 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1416 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1420 */   // MIs[1] A
     /* 1420 */   // No operand predicates
     /* 1420 */   // MIs[1] B
     /* 1420 */   // No operand predicates
     /* 1420 */   // MIs[0] sub2
     /* 1420 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1424 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1428 */   // MIs[2] C
     /* 1428 */   // No operand predicates
     /* 1428 */   // MIs[2] A
     /* 1428 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 1433 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1435 */   // Combiner Rule #4: AMinusBPlusCMinusA
     /* 1435 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1438 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1440 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // C
     /* 1444 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // B
     /* 1448 */   GIR_EraseRootFromParent_Done,
     /* 1449 */ // Label 111: @1449
     /* 1449 */ GIM_Try, /*On fail goto*//*Label 112*/ GIMT_Encode4(1478), // Rule ID 371 //
     /* 1454 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule224Enabled),
     /* 1457 */   // MIs[0] dst
     /* 1457 */   // No operand predicates
     /* 1457 */   // MIs[0] ext1
     /* 1457 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1461 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 1465 */   // MIs[1] src1
     /* 1465 */   // No operand predicates
     /* 1465 */   // MIs[0] ext2
     /* 1465 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1469 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 1473 */   // MIs[2] src2
     /* 1473 */   // No operand predicates
     /* 1473 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1475 */   // Combiner Rule #224: push_add_through_sext
     /* 1475 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner157),
     /* 1478 */ // Label 112: @1478
     /* 1478 */ GIM_Try, /*On fail goto*//*Label 113*/ GIMT_Encode4(1513), // Rule ID 39 //
     /* 1483 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule37Enabled),
     /* 1486 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 1492 */   // MIs[0] root
     /* 1492 */   // No operand predicates
     /* 1492 */   // MIs[0] left
     /* 1492 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1496 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 1500 */   // MIs[1] imm1
     /* 1500 */   // No operand predicates
     /* 1500 */   // MIs[0] right
     /* 1500 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1504 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 1508 */   // MIs[2] imm2
     /* 1508 */   // No operand predicates
     /* 1508 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1510 */   // Combiner Rule #37: add_of_vscale
     /* 1510 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner15),
     /* 1513 */ // Label 113: @1513
     /* 1513 */ GIM_Try, /*On fail goto*//*Label 114*/ GIMT_Encode4(1542), // Rule ID 369 //
     /* 1518 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule222Enabled),
     /* 1521 */   // MIs[0] dst
     /* 1521 */   // No operand predicates
     /* 1521 */   // MIs[0] ext1
     /* 1521 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1525 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 1529 */   // MIs[1] src1
     /* 1529 */   // No operand predicates
     /* 1529 */   // MIs[0] ext2
     /* 1529 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1533 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 1537 */   // MIs[2] src2
     /* 1537 */   // No operand predicates
     /* 1537 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1539 */   // Combiner Rule #222: push_add_through_zext
     /* 1539 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner157),
     /* 1542 */ // Label 114: @1542
     /* 1542 */ GIM_Try, /*On fail goto*//*Label 115*/ GIMT_Encode4(1576), // Rule ID 1 //
     /* 1547 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule1Enabled),
     /* 1550 */   // MIs[0] root
     /* 1550 */   // No operand predicates
     /* 1550 */   // MIs[0] A
     /* 1550 */   // No operand predicates
     /* 1550 */   // MIs[0] sub
     /* 1550 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1554 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1558 */   // MIs[1] Operand 1
     /* 1558 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /* 1562 */   // MIs[1] B
     /* 1562 */   // No operand predicates
     /* 1562 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1564 */   // Combiner Rule #1: APlusZeroMinusB
     /* 1564 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1567 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1569 */   GIR_RootToRootCopy, /*OpIdx*/1, // A
     /* 1571 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // B
     /* 1575 */   GIR_EraseRootFromParent_Done,
     /* 1576 */ // Label 115: @1576
     /* 1576 */ GIM_Try, /*On fail goto*//*Label 116*/ GIMT_Encode4(1610), // Rule ID 2 //
     /* 1581 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule2Enabled),
     /* 1584 */   // MIs[0] root
     /* 1584 */   // No operand predicates
     /* 1584 */   // MIs[0] A
     /* 1584 */   // No operand predicates
     /* 1584 */   // MIs[0] sub
     /* 1584 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1588 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1592 */   // MIs[1] B
     /* 1592 */   // No operand predicates
     /* 1592 */   // MIs[1] A
     /* 1592 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1597 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1602 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1604 */   // Combiner Rule #2: APlusBMinusB
     /* 1604 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1609 */   GIR_EraseRootFromParent_Done,
     /* 1610 */ // Label 116: @1610
     /* 1610 */ GIM_Try, /*On fail goto*//*Label 117*/ GIMT_Encode4(1644), // Rule ID 130 //
     /* 1615 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule94Enabled),
     /* 1618 */   // MIs[0] dst
     /* 1618 */   // No operand predicates
     /* 1618 */   // MIs[0] __add_sub_reg_match_0.x
     /* 1618 */   // No operand predicates
     /* 1618 */   // MIs[0] __add_sub_reg_match_0.tmp
     /* 1618 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1622 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1626 */   // MIs[1] src
     /* 1626 */   // No operand predicates
     /* 1626 */   // MIs[1] __add_sub_reg_match_0.x
     /* 1626 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1631 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1636 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1638 */   // Combiner Rule #94: add_sub_reg @ [__add_sub_reg_match_0[0]]
     /* 1638 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1643 */   GIR_EraseRootFromParent_Done,
     /* 1644 */ // Label 117: @1644
     /* 1644 */ GIM_Try, /*On fail goto*//*Label 118*/ GIMT_Encode4(1689), // Rule ID 6 //
     /* 1649 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule6Enabled),
     /* 1652 */   // MIs[0] root
     /* 1652 */   // No operand predicates
     /* 1652 */   // MIs[0] A
     /* 1652 */   // No operand predicates
     /* 1652 */   // MIs[0] sub1
     /* 1652 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1656 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1660 */   // MIs[1] B
     /* 1660 */   // No operand predicates
     /* 1660 */   // MIs[1] add1
     /* 1660 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1664 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 1668 */   // MIs[2] A
     /* 1668 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1673 */   // MIs[2] C
     /* 1673 */   // No operand predicates
     /* 1673 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1675 */   // Combiner Rule #6: APlusBMinusAplusC
     /* 1675 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1678 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1680 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // B
     /* 1684 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // C
     /* 1688 */   GIR_EraseRootFromParent_Done,
     /* 1689 */ // Label 118: @1689
     /* 1689 */ GIM_Try, /*On fail goto*//*Label 119*/ GIMT_Encode4(1734), // Rule ID 7 //
     /* 1694 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule7Enabled),
     /* 1697 */   // MIs[0] root
     /* 1697 */   // No operand predicates
     /* 1697 */   // MIs[0] A
     /* 1697 */   // No operand predicates
     /* 1697 */   // MIs[0] sub1
     /* 1697 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1701 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1705 */   // MIs[1] B
     /* 1705 */   // No operand predicates
     /* 1705 */   // MIs[1] add1
     /* 1705 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1709 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 1713 */   // MIs[2] C
     /* 1713 */   // No operand predicates
     /* 1713 */   // MIs[2] A
     /* 1713 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1718 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1720 */   // Combiner Rule #7: APlusBMinusCPlusA
     /* 1720 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1723 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1725 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // B
     /* 1729 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // C
     /* 1733 */   GIR_EraseRootFromParent_Done,
     /* 1734 */ // Label 119: @1734
     /* 1734 */ GIM_Try, /*On fail goto*//*Label 120*/ GIMT_Encode4(1757), // Rule ID 105 //
     /* 1739 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 1742 */   // MIs[0] dst
     /* 1742 */   // No operand predicates
     /* 1742 */   // MIs[0] lhs
     /* 1742 */   // No operand predicates
     /* 1742 */   // MIs[0] Operand 2
     /* 1742 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1746 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1751 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[1]]
     /* 1751 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1756 */   GIR_EraseRootFromParent_Done,
     /* 1757 */ // Label 120: @1757
     /* 1757 */ GIM_Try, /*On fail goto*//*Label 121*/ GIMT_Encode4(1768), // Rule ID 149 //
     /* 1762 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule107Enabled),
     /* 1765 */   // MIs[0] root
     /* 1765 */   // No operand predicates
     /* 1765 */   // MIs[0] src1
     /* 1765 */   // No operand predicates
     /* 1765 */   // MIs[0] src2
     /* 1765 */   // No operand predicates
     /* 1765 */   // Combiner Rule #107: reassoc_comm_binops
     /* 1765 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner58),
     /* 1768 */ // Label 121: @1768
     /* 1768 */ GIM_Reject,
     /* 1769 */ // Label 2: @1769
     /* 1769 */ GIM_Try, /*On fail goto*//*Label 122*/ GIMT_Encode4(1780), // Rule ID 95 //
     /* 1774 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 1777 */   // Combiner Rule #78: propagate_undef_any_op; wip_match_opcode 'G_SUB'
     /* 1777 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 1780 */ // Label 122: @1780
     /* 1780 */ GIM_Try, /*On fail goto*//*Label 123*/ GIMT_Encode4(1791), // Rule ID 239 //
     /* 1785 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 1788 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_SUB'
     /* 1788 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 1791 */ // Label 123: @1791
     /* 1791 */ GIM_Try, /*On fail goto*//*Label 124*/ GIMT_Encode4(1802), // Rule ID 280 //
     /* 1796 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 1799 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_SUB'
     /* 1799 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 1802 */ // Label 124: @1802
     /* 1802 */ GIM_Try, /*On fail goto*//*Label 125*/ GIMT_Encode4(1813), // Rule ID 306 //
     /* 1807 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 1810 */   // Combiner Rule #188: sub_add_reg; wip_match_opcode 'G_SUB'
     /* 1810 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner124),
     /* 1813 */ // Label 125: @1813
     /* 1813 */ GIM_Try, /*On fail goto*//*Label 126*/ GIMT_Encode4(1824), // Rule ID 340 //
     /* 1818 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule195Enabled),
     /* 1821 */   // Combiner Rule #195: simplify_neg_minmax; wip_match_opcode 'G_SUB'
     /* 1821 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner131),
     /* 1824 */ // Label 126: @1824
     /* 1824 */ GIM_Try, /*On fail goto*//*Label 127*/ GIMT_Encode4(1861), // Rule ID 8 //
     /* 1829 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule8Enabled),
     /* 1832 */   // MIs[0] root
     /* 1832 */   // No operand predicates
     /* 1832 */   // MIs[0] add
     /* 1832 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1836 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 1840 */   // MIs[1] A
     /* 1840 */   // No operand predicates
     /* 1840 */   // MIs[1] c1
     /* 1840 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1844 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1848 */   // MIs[2] imm1
     /* 1848 */   // No operand predicates
     /* 1848 */   // MIs[0] c2
     /* 1848 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 1852 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1856 */   // MIs[3] imm2
     /* 1856 */   // No operand predicates
     /* 1856 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1858 */   // Combiner Rule #8: APlusC1MinusC2
     /* 1858 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner0),
     /* 1861 */ // Label 127: @1861
     /* 1861 */ GIM_Try, /*On fail goto*//*Label 128*/ GIMT_Encode4(1898), // Rule ID 11 //
     /* 1866 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule11Enabled),
     /* 1869 */   // MIs[0] root
     /* 1869 */   // No operand predicates
     /* 1869 */   // MIs[0] sub1
     /* 1869 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1873 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1877 */   // MIs[1] c1
     /* 1877 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 1881 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1885 */   // MIs[2] imm1
     /* 1885 */   // No operand predicates
     /* 1885 */   // MIs[1] A
     /* 1885 */   // No operand predicates
     /* 1885 */   // MIs[0] c2
     /* 1885 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 1889 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1893 */   // MIs[3] imm2
     /* 1893 */   // No operand predicates
     /* 1893 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1895 */   // Combiner Rule #11: C1Minus2MinusC2
     /* 1895 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner3),
     /* 1898 */ // Label 128: @1898
     /* 1898 */ GIM_Try, /*On fail goto*//*Label 129*/ GIMT_Encode4(1935), // Rule ID 10 //
     /* 1903 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule10Enabled),
     /* 1906 */   // MIs[0] root
     /* 1906 */   // No operand predicates
     /* 1906 */   // MIs[0] sub1
     /* 1906 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1910 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1914 */   // MIs[1] A
     /* 1914 */   // No operand predicates
     /* 1914 */   // MIs[1] c1
     /* 1914 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1918 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1922 */   // MIs[2] imm1
     /* 1922 */   // No operand predicates
     /* 1922 */   // MIs[0] c2
     /* 1922 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 1926 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1930 */   // MIs[3] imm2
     /* 1930 */   // No operand predicates
     /* 1930 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1932 */   // Combiner Rule #10: AMinusC1MinusC2
     /* 1932 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner2),
     /* 1935 */ // Label 129: @1935
     /* 1935 */ GIM_Try, /*On fail goto*//*Label 130*/ GIMT_Encode4(1964), // Rule ID 370 //
     /* 1940 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule223Enabled),
     /* 1943 */   // MIs[0] dst
     /* 1943 */   // No operand predicates
     /* 1943 */   // MIs[0] ext1
     /* 1943 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1947 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 1951 */   // MIs[1] src1
     /* 1951 */   // No operand predicates
     /* 1951 */   // MIs[0] ext2
     /* 1951 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1955 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 1959 */   // MIs[2] src2
     /* 1959 */   // No operand predicates
     /* 1959 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1961 */   // Combiner Rule #223: push_sub_through_sext
     /* 1961 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner157),
     /* 1964 */ // Label 130: @1964
     /* 1964 */ GIM_Try, /*On fail goto*//*Label 131*/ GIMT_Encode4(1993), // Rule ID 368 //
     /* 1969 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule221Enabled),
     /* 1972 */   // MIs[0] dst
     /* 1972 */   // No operand predicates
     /* 1972 */   // MIs[0] ext1
     /* 1972 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1976 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 1980 */   // MIs[1] src1
     /* 1980 */   // No operand predicates
     /* 1980 */   // MIs[0] ext2
     /* 1980 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1984 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 1988 */   // MIs[2] src2
     /* 1988 */   // No operand predicates
     /* 1988 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1990 */   // Combiner Rule #221: push_sub_through_zext
     /* 1990 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner157),
     /* 1993 */ // Label 131: @1993
     /* 1993 */ GIM_Try, /*On fail goto*//*Label 132*/ GIMT_Encode4(2036), // Rule ID 159 //
     /* 1998 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule117Enabled),
     /* 2001 */   // MIs[0] dst
     /* 2001 */   // No operand predicates
     /* 2001 */   // MIs[0] Operand 1
     /* 2001 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 2005 */   // MIs[0] and
     /* 2005 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2009 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 2013 */   // MIs[1] x
     /* 2013 */   // No operand predicates
     /* 2013 */   // MIs[1] Operand 2
     /* 2013 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 2017 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner7),
     /* 2021 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2023 */   // Combiner Rule #117: neg_and_one_to_sext_inreg
     /* 2023 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 2026 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 2028 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // x
     /* 2032 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2035 */   GIR_EraseRootFromParent_Done,
     /* 2036 */ // Label 132: @2036
     /* 2036 */ GIM_Try, /*On fail goto*//*Label 133*/ GIMT_Encode4(2073), // Rule ID 9 //
     /* 2041 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule9Enabled),
     /* 2044 */   // MIs[0] root
     /* 2044 */   // No operand predicates
     /* 2044 */   // MIs[0] c2
     /* 2044 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2048 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2052 */   // MIs[1] imm2
     /* 2052 */   // No operand predicates
     /* 2052 */   // MIs[0] add
     /* 2052 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2056 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 2060 */   // MIs[2] A
     /* 2060 */   // No operand predicates
     /* 2060 */   // MIs[2] c1
     /* 2060 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 2064 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2068 */   // MIs[3] imm1
     /* 2068 */   // No operand predicates
     /* 2068 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2070 */   // Combiner Rule #9: C2MinusAPlusC1
     /* 2070 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner1),
     /* 2073 */ // Label 133: @2073
     /* 2073 */ GIM_Try, /*On fail goto*//*Label 134*/ GIMT_Encode4(2100), // Rule ID 42 //
     /* 2078 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule40Enabled),
     /* 2081 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 2087 */   // MIs[0] root
     /* 2087 */   // No operand predicates
     /* 2087 */   // MIs[0] x
     /* 2087 */   // No operand predicates
     /* 2087 */   // MIs[0] right
     /* 2087 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2091 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 2095 */   // MIs[1] imm
     /* 2095 */   // No operand predicates
     /* 2095 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2097 */   // Combiner Rule #40: sub_of_vscale
     /* 2097 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner18),
     /* 2100 */ // Label 134: @2100
     /* 2100 */ GIM_Try, /*On fail goto*//*Label 135*/ GIMT_Encode4(2123), // Rule ID 104 //
     /* 2105 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 2108 */   // MIs[0] dst
     /* 2108 */   // No operand predicates
     /* 2108 */   // MIs[0] lhs
     /* 2108 */   // No operand predicates
     /* 2108 */   // MIs[0] Operand 2
     /* 2108 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 2112 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2117 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[0]]
     /* 2117 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2122 */   GIR_EraseRootFromParent_Done,
     /* 2123 */ // Label 135: @2123
     /* 2123 */ GIM_Try, /*On fail goto*//*Label 136*/ GIMT_Encode4(2144), // Rule ID 15 //
     /* 2128 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule15Enabled),
     /* 2131 */   // MIs[0] d
     /* 2131 */   // No operand predicates
     /* 2131 */   // MIs[0] op1
     /* 2131 */   // No operand predicates
     /* 2131 */   // MIs[0] c
     /* 2131 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2135 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2139 */   // MIs[1] imm
     /* 2139 */   // No operand predicates
     /* 2139 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2141 */   // Combiner Rule #15: sub_to_add
     /* 2141 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner7),
     /* 2144 */ // Label 136: @2144
     /* 2144 */ GIM_Reject,
     /* 2145 */ // Label 3: @2145
     /* 2145 */ GIM_Try, /*On fail goto*//*Label 137*/ GIMT_Encode4(2156), // Rule ID 78 //
     /* 2150 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule72Enabled),
     /* 2153 */   // Combiner Rule #72: undef_to_int_zero; wip_match_opcode 'G_MUL'
     /* 2153 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner34),
     /* 2156 */ // Label 137: @2156
     /* 2156 */ GIM_Try, /*On fail goto*//*Label 138*/ GIMT_Encode4(2167), // Rule ID 236 //
     /* 2161 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 2164 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_MUL'
     /* 2164 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 2167 */ // Label 138: @2167
     /* 2167 */ GIM_Try, /*On fail goto*//*Label 139*/ GIMT_Encode4(2178), // Rule ID 310 //
     /* 2172 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 2175 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_MUL'
     /* 2175 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 2178 */ // Label 139: @2178
     /* 2178 */ GIM_Try, /*On fail goto*//*Label 140*/ GIMT_Encode4(2218), // Rule ID 17 //
     /* 2183 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule17Enabled),
     /* 2186 */   // MIs[0] dst
     /* 2186 */   GIM_RecordRegType, /*MI*/0, /*Op*/0, /*TempTypeIdx*/uint8_t(-1),
     /* 2190 */   // MIs[0] x
     /* 2190 */   // No operand predicates
     /* 2190 */   // MIs[0] Operand 2
     /* 2190 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /* 2194 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/uint8_t(-1),
     /* 2197 */   GIR_BuildConstant, /*TempRegID*/0, /*Val*/GIMT_Encode8(0),
     /* 2207 */   // Combiner Rule #17: mul_by_neg_one
     /* 2207 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 2210 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 2212 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215 */   GIR_RootToRootCopy, /*OpIdx*/1, // x
     /* 2217 */   GIR_EraseRootFromParent_Done,
     /* 2218 */ // Label 140: @2218
     /* 2218 */ GIM_Try, /*On fail goto*//*Label 141*/ GIMT_Encode4(2253), // Rule ID 40 //
     /* 2223 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule38Enabled),
     /* 2226 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 2232 */   // MIs[0] root
     /* 2232 */   // No operand predicates
     /* 2232 */   // MIs[0] left
     /* 2232 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2236 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 2240 */   // MIs[1] scale
     /* 2240 */   // No operand predicates
     /* 2240 */   // MIs[0] x
     /* 2240 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2244 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2248 */   // MIs[2] imm1
     /* 2248 */   // No operand predicates
     /* 2248 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2250 */   // Combiner Rule #38: mul_of_vscale
     /* 2250 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner16),
     /* 2253 */ // Label 141: @2253
     /* 2253 */ GIM_Try, /*On fail goto*//*Label 142*/ GIMT_Encode4(2276), // Rule ID 123 //
     /* 2258 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 2261 */   // MIs[0] dst
     /* 2261 */   // No operand predicates
     /* 2261 */   // MIs[0] lhs
     /* 2261 */   // No operand predicates
     /* 2261 */   // MIs[0] zero
     /* 2261 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 2265 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/2,
     /* 2270 */   // Combiner Rule #87: binop_right_to_zero
     /* 2270 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/2,
     /* 2275 */   GIR_EraseRootFromParent_Done,
     /* 2276 */ // Label 142: @2276
     /* 2276 */ GIM_Try, /*On fail goto*//*Label 143*/ GIMT_Encode4(2299), // Rule ID 128 //
     /* 2281 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule92Enabled),
     /* 2284 */   // MIs[0] dst
     /* 2284 */   // No operand predicates
     /* 2284 */   // MIs[0] x
     /* 2284 */   // No operand predicates
     /* 2284 */   // MIs[0] Operand 2
     /* 2284 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 2288 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2293 */   // Combiner Rule #92: right_identity_one_int
     /* 2293 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2298 */   GIR_EraseRootFromParent_Done,
     /* 2299 */ // Label 143: @2299
     /* 2299 */ GIM_Try, /*On fail goto*//*Label 144*/ GIMT_Encode4(2310), // Rule ID 14 //
     /* 2304 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule14Enabled),
     /* 2307 */   // MIs[0] d
     /* 2307 */   // No operand predicates
     /* 2307 */   // MIs[0] op1
     /* 2307 */   // No operand predicates
     /* 2307 */   // MIs[0] op2
     /* 2307 */   // No operand predicates
     /* 2307 */   // Combiner Rule #14: mul_to_shl
     /* 2307 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner6),
     /* 2310 */ // Label 144: @2310
     /* 2310 */ GIM_Reject,
     /* 2311 */ // Label 4: @2311
     /* 2311 */ GIM_Try, /*On fail goto*//*Label 145*/ GIMT_Encode4(2322), // Rule ID 119 //
     /* 2316 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 2319 */   // Combiner Rule #86: binop_left_to_zero; wip_match_opcode 'G_SDIV'
     /* 2319 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 2322 */ // Label 145: @2322
     /* 2322 */ GIM_Try, /*On fail goto*//*Label 146*/ GIMT_Encode4(2333), // Rule ID 211 //
     /* 2327 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule153Enabled),
     /* 2330 */   // Combiner Rule #153: div_rem_to_divrem; wip_match_opcode 'G_SDIV'
     /* 2330 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner95),
     /* 2333 */ // Label 146: @2333
     /* 2333 */ GIM_Try, /*On fail goto*//*Label 147*/ GIMT_Encode4(2344), // Rule ID 242 //
     /* 2338 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 2341 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_SDIV'
     /* 2341 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 2344 */ // Label 147: @2344
     /* 2344 */ GIM_Try, /*On fail goto*//*Label 148*/ GIMT_Encode4(2355), // Rule ID 260 //
     /* 2349 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule172Enabled),
     /* 2352 */   // Combiner Rule #172: sdiv_by_const; wip_match_opcode 'G_SDIV'
     /* 2352 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner109),
     /* 2355 */ // Label 148: @2355
     /* 2355 */ GIM_Try, /*On fail goto*//*Label 149*/ GIMT_Encode4(2366), // Rule ID 285 //
     /* 2360 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 2363 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_SDIV'
     /* 2363 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 2366 */ // Label 149: @2366
     /* 2366 */ GIM_Try, /*On fail goto*//*Label 150*/ GIMT_Encode4(2383), // Rule ID 261 //
     /* 2371 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule173Enabled),
     /* 2374 */   GIM_MIFlagsNot, /*MI*/0, GIMT_Encode4(MachineInstr::IsExact),
     /* 2380 */   // MIs[0] dst
     /* 2380 */   // No operand predicates
     /* 2380 */   // MIs[0] x
     /* 2380 */   // No operand predicates
     /* 2380 */   // MIs[0] y
     /* 2380 */   // No operand predicates
     /* 2380 */   // Combiner Rule #173: sdiv_by_pow2
     /* 2380 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner110),
     /* 2383 */ // Label 150: @2383
     /* 2383 */ GIM_Reject,
     /* 2384 */ // Label 5: @2384
     /* 2384 */ GIM_Try, /*On fail goto*//*Label 151*/ GIMT_Encode4(2395), // Rule ID 81 //
     /* 2389 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule74Enabled),
     /* 2392 */   // Combiner Rule #74: binop_left_undef_to_zero; wip_match_opcode 'G_UDIV'
     /* 2392 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner36),
     /* 2395 */ // Label 151: @2395
     /* 2395 */ GIM_Try, /*On fail goto*//*Label 152*/ GIMT_Encode4(2406), // Rule ID 120 //
     /* 2400 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 2403 */   // Combiner Rule #86: binop_left_to_zero; wip_match_opcode 'G_UDIV'
     /* 2403 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 2406 */ // Label 152: @2406
     /* 2406 */ GIM_Try, /*On fail goto*//*Label 153*/ GIMT_Encode4(2417), // Rule ID 212 //
     /* 2411 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule153Enabled),
     /* 2414 */   // Combiner Rule #153: div_rem_to_divrem; wip_match_opcode 'G_UDIV'
     /* 2414 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner95),
     /* 2417 */ // Label 153: @2417
     /* 2417 */ GIM_Try, /*On fail goto*//*Label 154*/ GIMT_Encode4(2428), // Rule ID 241 //
     /* 2422 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 2425 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_UDIV'
     /* 2425 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 2428 */ // Label 154: @2428
     /* 2428 */ GIM_Try, /*On fail goto*//*Label 155*/ GIMT_Encode4(2439), // Rule ID 259 //
     /* 2433 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule171Enabled),
     /* 2436 */   // Combiner Rule #171: udiv_by_const; wip_match_opcode 'G_UDIV'
     /* 2436 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner108),
     /* 2439 */ // Label 155: @2439
     /* 2439 */ GIM_Try, /*On fail goto*//*Label 156*/ GIMT_Encode4(2450), // Rule ID 287 //
     /* 2444 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 2447 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_UDIV'
     /* 2447 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 2450 */ // Label 156: @2450
     /* 2450 */ GIM_Try, /*On fail goto*//*Label 157*/ GIMT_Encode4(2467), // Rule ID 262 //
     /* 2455 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule174Enabled),
     /* 2458 */   GIM_MIFlagsNot, /*MI*/0, GIMT_Encode4(MachineInstr::IsExact),
     /* 2464 */   // MIs[0] dst
     /* 2464 */   // No operand predicates
     /* 2464 */   // MIs[0] x
     /* 2464 */   // No operand predicates
     /* 2464 */   // MIs[0] y
     /* 2464 */   // No operand predicates
     /* 2464 */   // Combiner Rule #174: udiv_by_pow2
     /* 2464 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner111),
     /* 2467 */ // Label 157: @2467
     /* 2467 */ GIM_Reject,
     /* 2468 */ // Label 6: @2468
     /* 2468 */ GIM_Try, /*On fail goto*//*Label 158*/ GIMT_Encode4(2479), // Rule ID 121 //
     /* 2473 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 2476 */   // Combiner Rule #86: binop_left_to_zero; wip_match_opcode 'G_SREM'
     /* 2476 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 2479 */ // Label 158: @2479
     /* 2479 */ GIM_Try, /*On fail goto*//*Label 159*/ GIMT_Encode4(2490), // Rule ID 213 //
     /* 2484 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule153Enabled),
     /* 2487 */   // Combiner Rule #153: div_rem_to_divrem; wip_match_opcode 'G_SREM'
     /* 2487 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner95),
     /* 2490 */ // Label 159: @2490
     /* 2490 */ GIM_Try, /*On fail goto*//*Label 160*/ GIMT_Encode4(2501), // Rule ID 244 //
     /* 2495 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 2498 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_SREM'
     /* 2498 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 2501 */ // Label 160: @2501
     /* 2501 */ GIM_Try, /*On fail goto*//*Label 161*/ GIMT_Encode4(2512), // Rule ID 286 //
     /* 2506 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 2509 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_SREM'
     /* 2509 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 2512 */ // Label 161: @2512
     /* 2512 */ GIM_Reject,
     /* 2513 */ // Label 7: @2513
     /* 2513 */ GIM_Try, /*On fail goto*//*Label 162*/ GIMT_Encode4(2524), // Rule ID 82 //
     /* 2518 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule74Enabled),
     /* 2521 */   // Combiner Rule #74: binop_left_undef_to_zero; wip_match_opcode 'G_UREM'
     /* 2521 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner36),
     /* 2524 */ // Label 162: @2524
     /* 2524 */ GIM_Try, /*On fail goto*//*Label 163*/ GIMT_Encode4(2535), // Rule ID 122 //
     /* 2529 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 2532 */   // Combiner Rule #86: binop_left_to_zero; wip_match_opcode 'G_UREM'
     /* 2532 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 2535 */ // Label 163: @2535
     /* 2535 */ GIM_Try, /*On fail goto*//*Label 164*/ GIMT_Encode4(2546), // Rule ID 170 //
     /* 2540 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule128Enabled),
     /* 2543 */   // Combiner Rule #128: urem_pow2_to_mask; wip_match_opcode 'G_UREM'
     /* 2543 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner75),
     /* 2546 */ // Label 164: @2546
     /* 2546 */ GIM_Try, /*On fail goto*//*Label 165*/ GIMT_Encode4(2557), // Rule ID 214 //
     /* 2551 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule153Enabled),
     /* 2554 */   // Combiner Rule #153: div_rem_to_divrem; wip_match_opcode 'G_UREM'
     /* 2554 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner95),
     /* 2557 */ // Label 165: @2557
     /* 2557 */ GIM_Try, /*On fail goto*//*Label 166*/ GIMT_Encode4(2568), // Rule ID 243 //
     /* 2562 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 2565 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_UREM'
     /* 2565 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 2568 */ // Label 166: @2568
     /* 2568 */ GIM_Try, /*On fail goto*//*Label 167*/ GIMT_Encode4(2579), // Rule ID 288 //
     /* 2573 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 2576 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_UREM'
     /* 2576 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 2579 */ // Label 167: @2579
     /* 2579 */ GIM_Try, /*On fail goto*//*Label 168*/ GIMT_Encode4(2590), // Rule ID 305 //
     /* 2584 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule187Enabled),
     /* 2587 */   // MIs[0] dst
     /* 2587 */   // No operand predicates
     /* 2587 */   // MIs[0] x
     /* 2587 */   // No operand predicates
     /* 2587 */   // MIs[0] y
     /* 2587 */   // No operand predicates
     /* 2587 */   // Combiner Rule #187: urem_by_const
     /* 2587 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner108),
     /* 2590 */ // Label 168: @2590
     /* 2590 */ GIM_Reject,
     /* 2591 */ // Label 8: @2591
     /* 2591 */ GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(2602), // Rule ID 73 //
     /* 2596 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule69Enabled),
     /* 2599 */   // Combiner Rule #69: load_and_mask; wip_match_opcode 'G_AND'
     /* 2599 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner31),
     /* 2602 */ // Label 169: @2602
     /* 2602 */ GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(2613), // Rule ID 77 //
     /* 2607 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule72Enabled),
     /* 2610 */   // Combiner Rule #72: undef_to_int_zero; wip_match_opcode 'G_AND'
     /* 2610 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner34),
     /* 2613 */ // Label 170: @2613
     /* 2613 */ GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(2624), // Rule ID 142 //
     /* 2618 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule104Enabled),
     /* 2621 */   // Combiner Rule #104: hoist_logic_op_with_same_opcode_hands; wip_match_opcode 'G_AND'
     /* 2621 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner55),
     /* 2624 */ // Label 171: @2624
     /* 2624 */ GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(2635), // Rule ID 162 //
     /* 2629 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule120Enabled),
     /* 2632 */   // Combiner Rule #120: narrow_binop_feeding_and; wip_match_opcode 'G_AND'
     /* 2632 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner68),
     /* 2635 */ // Label 172: @2635
     /* 2635 */ GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(2646), // Rule ID 167 //
     /* 2640 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule125Enabled),
     /* 2643 */   // Combiner Rule #125: redundant_and; wip_match_opcode 'G_AND'
     /* 2643 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner72),
     /* 2646 */ // Label 173: @2646
     /* 2646 */ GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(2657), // Rule ID 184 //
     /* 2651 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule142Enabled),
     /* 2654 */   // Combiner Rule #142: overlapping_and; wip_match_opcode 'G_AND'
     /* 2654 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner84),
     /* 2657 */ // Label 174: @2657
     /* 2657 */ GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(2668), // Rule ID 233 //
     /* 2662 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 2665 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_AND'
     /* 2665 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 2668 */ // Label 175: @2668
     /* 2668 */ GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(2679), // Rule ID 270 //
     /* 2673 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule177Enabled),
     /* 2676 */   // Combiner Rule #177: and_or_disjoint_mask; wip_match_opcode 'G_AND'
     /* 2676 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner114),
     /* 2679 */ // Label 176: @2679
     /* 2679 */ GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(2690), // Rule ID 282 //
     /* 2684 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 2687 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_AND'
     /* 2687 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 2690 */ // Label 177: @2690
     /* 2690 */ GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(2701), // Rule ID 311 //
     /* 2695 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 2698 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_AND'
     /* 2698 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 2701 */ // Label 178: @2701
     /* 2701 */ GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(2712), // Rule ID 338 //
     /* 2706 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule193Enabled),
     /* 2709 */   // Combiner Rule #193: match_ands; wip_match_opcode 'G_AND'
     /* 2709 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner129),
     /* 2712 */ // Label 179: @2712
     /* 2712 */ GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(2810), // Rule ID 155 //
     /* 2717 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule113Enabled),
     /* 2720 */   // MIs[0] root
     /* 2720 */   // No operand predicates
     /* 2720 */   // MIs[0] d1
     /* 2720 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2724 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2728 */   // MIs[1] p
     /* 2728 */   // No operand predicates
     /* 2728 */   // MIs[1] s1
     /* 2728 */   GIM_RecordRegType, /*MI*/1, /*Op*/2, /*TempTypeIdx*/uint8_t(-1),
     /* 2732 */   // MIs[1] Operand 3
     /* 2732 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 2736 */   // MIs[0] d2
     /* 2736 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2740 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2744 */   // MIs[2] p
     /* 2744 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 2749 */   // MIs[2] s2
     /* 2749 */   // No operand predicates
     /* 2749 */   // MIs[2] Operand 3
     /* 2749 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/3, 0,
     /* 2753 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner5),
     /* 2757 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2759 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/uint8_t(-1),
     /* 2762 */   GIR_BuildConstant, /*TempRegID*/1, /*Val*/GIMT_Encode8(0),
     /* 2772 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/uint8_t(-1),
     /* 2775 */   // Combiner Rule #113: double_icmp_zero_and_combine
     /* 2775 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_OR),
     /* 2778 */   GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2783 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 2787 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // s2
     /* 2791 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2795 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, // root
     /* 2799 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // p
     /* 2803 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/0,
     /* 2806 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 2809 */   GIR_EraseRootFromParent_Done,
     /* 2810 */ // Label 180: @2810
     /* 2810 */ GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(2847), // Rule ID 226 //
     /* 2815 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule163Enabled),
     /* 2818 */   // MIs[0] root
     /* 2818 */   // No operand predicates
     /* 2818 */   // MIs[0] shift
     /* 2818 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2822 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 2826 */   // MIs[1] x
     /* 2826 */   // No operand predicates
     /* 2826 */   // MIs[1] lsb
     /* 2826 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 2830 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2834 */   // MIs[2] imm1
     /* 2834 */   // No operand predicates
     /* 2834 */   // MIs[0] mask
     /* 2834 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 2838 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2842 */   // MIs[3] imm2
     /* 2842 */   // No operand predicates
     /* 2842 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2844 */   // Combiner Rule #163: bitfield_extract_from_and
     /* 2844 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner101),
     /* 2847 */ // Label 181: @2847
     /* 2847 */ GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(2871), // Rule ID 114 //
     /* 2852 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 2855 */   // MIs[0] dst
     /* 2855 */   // No operand predicates
     /* 2855 */   // MIs[0] src
     /* 2855 */   // No operand predicates
     /* 2855 */   // MIs[0] src
     /* 2855 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 2860 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2865 */   // Combiner Rule #85: binop_same_val @ [__binop_same_val_match_0[0]]
     /* 2865 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2870 */   GIR_EraseRootFromParent_Done,
     /* 2871 */ // Label 182: @2871
     /* 2871 */ GIM_Reject,
     /* 2872 */ // Label 9: @2872
     /* 2872 */ GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(2883), // Rule ID 79 //
     /* 2877 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule73Enabled),
     /* 2880 */   // Combiner Rule #73: undef_to_negative_one; wip_match_opcode 'G_OR'
     /* 2880 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner35),
     /* 2883 */ // Label 183: @2883
     /* 2883 */ GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(2894), // Rule ID 143 //
     /* 2888 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule104Enabled),
     /* 2891 */   // Combiner Rule #104: hoist_logic_op_with_same_opcode_hands; wip_match_opcode 'G_OR'
     /* 2891 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner55),
     /* 2894 */ // Label 184: @2894
     /* 2894 */ GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(2905), // Rule ID 169 //
     /* 2899 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule127Enabled),
     /* 2902 */   // Combiner Rule #127: redundant_or; wip_match_opcode 'G_OR'
     /* 2902 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner74),
     /* 2905 */ // Label 185: @2905
     /* 2905 */ GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(2916), // Rule ID 210 //
     /* 2910 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule152Enabled),
     /* 2913 */   // Combiner Rule #152: load_or_combine; wip_match_opcode 'G_OR'
     /* 2913 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner94),
     /* 2916 */ // Label 186: @2916
     /* 2916 */ GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(2927), // Rule ID 215 //
     /* 2921 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule154Enabled),
     /* 2924 */   // Combiner Rule #154: funnel_shift_from_or_shift; wip_match_opcode 'G_OR'
     /* 2924 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner96),
     /* 2927 */ // Label 187: @2927
     /* 2927 */ GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(2938), // Rule ID 237 //
     /* 2932 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 2935 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_OR'
     /* 2935 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 2938 */ // Label 188: @2938
     /* 2938 */ GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(2949), // Rule ID 283 //
     /* 2943 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 2946 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_OR'
     /* 2946 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 2949 */ // Label 189: @2949
     /* 2949 */ GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(2960), // Rule ID 312 //
     /* 2954 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 2957 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_OR'
     /* 2957 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 2960 */ // Label 190: @2960
     /* 2960 */ GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(2971), // Rule ID 339 //
     /* 2965 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule194Enabled),
     /* 2968 */   // Combiner Rule #194: match_ors; wip_match_opcode 'G_OR'
     /* 2968 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner130),
     /* 2971 */ // Label 191: @2971
     /* 2971 */ GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(3069), // Rule ID 156 //
     /* 2976 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule114Enabled),
     /* 2979 */   // MIs[0] root
     /* 2979 */   // No operand predicates
     /* 2979 */   // MIs[0] d1
     /* 2979 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2983 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2987 */   // MIs[1] p
     /* 2987 */   // No operand predicates
     /* 2987 */   // MIs[1] s1
     /* 2987 */   GIM_RecordRegType, /*MI*/1, /*Op*/2, /*TempTypeIdx*/uint8_t(-1),
     /* 2991 */   // MIs[1] Operand 3
     /* 2991 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 2995 */   // MIs[0] d2
     /* 2995 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2999 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 3003 */   // MIs[2] p
     /* 3003 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 3008 */   // MIs[2] s2
     /* 3008 */   // No operand predicates
     /* 3008 */   // MIs[2] Operand 3
     /* 3008 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/3, 0,
     /* 3012 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner6),
     /* 3016 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3018 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/uint8_t(-1),
     /* 3021 */   GIR_BuildConstant, /*TempRegID*/1, /*Val*/GIMT_Encode8(0),
     /* 3031 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/uint8_t(-1),
     /* 3034 */   // Combiner Rule #114: double_icmp_zero_or_combine
     /* 3034 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_OR),
     /* 3037 */   GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 3042 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 3046 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // s2
     /* 3050 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 3054 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, // root
     /* 3058 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // p
     /* 3062 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/0,
     /* 3065 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 3068 */   GIR_EraseRootFromParent_Done,
     /* 3069 */ // Label 192: @3069
     /* 3069 */ GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(3093), // Rule ID 115 //
     /* 3074 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 3077 */   // MIs[0] dst
     /* 3077 */   // No operand predicates
     /* 3077 */   // MIs[0] src
     /* 3077 */   // No operand predicates
     /* 3077 */   // MIs[0] src
     /* 3077 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 3082 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3087 */   // Combiner Rule #85: binop_same_val @ [__binop_same_val_match_0[1]]
     /* 3087 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3092 */   GIR_EraseRootFromParent_Done,
     /* 3093 */ // Label 193: @3093
     /* 3093 */ GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(3116), // Rule ID 106 //
     /* 3098 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 3101 */   // MIs[0] dst
     /* 3101 */   // No operand predicates
     /* 3101 */   // MIs[0] lhs
     /* 3101 */   // No operand predicates
     /* 3101 */   // MIs[0] Operand 2
     /* 3101 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 3105 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3110 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[2]]
     /* 3110 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3115 */   GIR_EraseRootFromParent_Done,
     /* 3116 */ // Label 194: @3116
     /* 3116 */ GIM_Reject,
     /* 3117 */ // Label 10: @3117
     /* 3117 */ GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(3128), // Rule ID 96 //
     /* 3122 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 3125 */   // Combiner Rule #78: propagate_undef_any_op; wip_match_opcode 'G_XOR'
     /* 3125 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 3128 */ // Label 195: @3128
     /* 3128 */ GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(3139), // Rule ID 144 //
     /* 3133 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule104Enabled),
     /* 3136 */   // Combiner Rule #104: hoist_logic_op_with_same_opcode_hands; wip_match_opcode 'G_XOR'
     /* 3136 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner55),
     /* 3139 */ // Label 196: @3139
     /* 3139 */ GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(3150), // Rule ID 174 //
     /* 3144 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule132Enabled),
     /* 3147 */   // Combiner Rule #132: not_cmp_fold; wip_match_opcode 'G_XOR'
     /* 3147 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner79),
     /* 3150 */ // Label 197: @3150
     /* 3150 */ GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(3161), // Rule ID 198 //
     /* 3155 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule148Enabled),
     /* 3158 */   // Combiner Rule #148: xor_of_and_with_same_reg; wip_match_opcode 'G_XOR'
     /* 3158 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner90),
     /* 3161 */ // Label 198: @3161
     /* 3161 */ GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(3172), // Rule ID 240 //
     /* 3166 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 3169 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_XOR'
     /* 3169 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 3172 */ // Label 199: @3172
     /* 3172 */ GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(3183), // Rule ID 284 //
     /* 3177 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 3180 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_XOR'
     /* 3180 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 3183 */ // Label 200: @3183
     /* 3183 */ GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(3194), // Rule ID 313 //
     /* 3188 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 3191 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_XOR'
     /* 3191 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 3194 */ // Label 201: @3194
     /* 3194 */ GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(3217), // Rule ID 107 //
     /* 3199 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 3202 */   // MIs[0] dst
     /* 3202 */   // No operand predicates
     /* 3202 */   // MIs[0] lhs
     /* 3202 */   // No operand predicates
     /* 3202 */   // MIs[0] Operand 2
     /* 3202 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 3206 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3211 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[3]]
     /* 3211 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3216 */   GIR_EraseRootFromParent_Done,
     /* 3217 */ // Label 202: @3217
     /* 3217 */ GIM_Reject,
     /* 3218 */ // Label 11: @3218
     /* 3218 */ GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(3229), // Rule ID 140 //
     /* 3223 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule102Enabled),
     /* 3226 */   // Combiner Rule #102: extend_through_phis; wip_match_opcode 'G_PHI'
     /* 3226 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner53),
     /* 3229 */ // Label 203: @3229
     /* 3229 */ GIM_Reject,
     /* 3230 */ // Label 12: @3230
     /* 3230 */ GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(3241), // Rule ID 364 //
     /* 3235 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule217Enabled),
     /* 3238 */   // Combiner Rule #217: fold_global_offset; wip_match_opcode 'G_GLOBAL_VALUE'
     /* 3238 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner153),
     /* 3241 */ // Label 204: @3241
     /* 3241 */ GIM_Reject,
     /* 3242 */ // Label 13: @3242
     /* 3242 */ GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(3253), // Rule ID 349 //
     /* 3247 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule204Enabled),
     /* 3250 */   // Combiner Rule #204: unmerge_anyext_build_vector; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 3250 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner140),
     /* 3253 */ // Label 205: @3253
     /* 3253 */ GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(3264), // Rule ID 350 //
     /* 3258 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule205Enabled),
     /* 3261 */   // Combiner Rule #205: unmerge_merge; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 3261 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner141),
     /* 3264 */ // Label 206: @3264
     /* 3264 */ GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(3275), // Rule ID 352 //
     /* 3269 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule207Enabled),
     /* 3272 */   // Combiner Rule #207: unmerge_cst; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 3272 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner143),
     /* 3275 */ // Label 207: @3275
     /* 3275 */ GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(3286), // Rule ID 353 //
     /* 3280 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule208Enabled),
     /* 3283 */   // Combiner Rule #208: unmerge_undef; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 3283 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner144),
     /* 3286 */ // Label 208: @3286
     /* 3286 */ GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(3297), // Rule ID 354 //
     /* 3291 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule209Enabled),
     /* 3294 */   // Combiner Rule #209: unmerge_dead_to_trunc; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 3294 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner145),
     /* 3297 */ // Label 209: @3297
     /* 3297 */ GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(3308), // Rule ID 355 //
     /* 3302 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule210Enabled),
     /* 3305 */   // Combiner Rule #210: unmerge_zext_to_zext; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 3305 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner146),
     /* 3308 */ // Label 210: @3308
     /* 3308 */ GIM_Reject,
     /* 3309 */ // Label 14: @3309
     /* 3309 */ GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(3320), // Rule ID 351 //
     /* 3314 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule206Enabled),
     /* 3317 */   // Combiner Rule #206: merge_unmerge; wip_match_opcode 'G_MERGE_VALUES'
     /* 3317 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner142),
     /* 3320 */ // Label 211: @3320
     /* 3320 */ GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(3382),
     /* 3325 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 3328 */   GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(3349), // Rule ID 356 //
     /* 3333 */     GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule211Enabled),
     /* 3336 */     // MIs[0] root
     /* 3336 */     // No operand predicates
     /* 3336 */     // MIs[0] x
     /* 3336 */     // No operand predicates
     /* 3336 */     // MIs[0] undef
     /* 3336 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 3340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3346 */     // Combiner Rule #211: merge_of_x_and_undef
     /* 3346 */     GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner147),
     /* 3349 */   // Label 213: @3349
     /* 3349 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(3381), // Rule ID 357 //
     /* 3354 */     GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule212Enabled),
     /* 3357 */     // MIs[0] root
     /* 3357 */     // No operand predicates
     /* 3357 */     // MIs[0] x
     /* 3357 */     // No operand predicates
     /* 3357 */     // MIs[0] zero
     /* 3357 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 3361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3365 */     // MIs[1] Operand 1
     /* 3365 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/1, GIMT_Encode8(0),
     /* 3376 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3378 */     // Combiner Rule #212: merge_of_x_and_zero
     /* 3378 */     GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner148),
     /* 3381 */   // Label 214: @3381
     /* 3381 */   GIM_Reject,
     /* 3382 */ // Label 212: @3382
     /* 3382 */ GIM_Reject,
     /* 3383 */ // Label 15: @3383
     /* 3383 */ GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(3394), // Rule ID 69 //
     /* 3388 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule67Enabled),
     /* 3391 */   // Combiner Rule #67: extract_all_elts_from_build_vector; wip_match_opcode 'G_BUILD_VECTOR'
     /* 3391 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner29),
     /* 3394 */ // Label 215: @3394
     /* 3394 */ GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(3405), // Rule ID 98 //
     /* 3399 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule79Enabled),
     /* 3402 */   // Combiner Rule #79: propagate_undef_all_ops; wip_match_opcode 'G_BUILD_VECTOR'
     /* 3402 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner40),
     /* 3405 */ // Label 216: @3405
     /* 3405 */ GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(3416), // Rule ID 133 //
     /* 3410 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule95Enabled),
     /* 3413 */   // Combiner Rule #95: buildvector_identity_fold; wip_match_opcode 'G_BUILD_VECTOR'
     /* 3413 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner49),
     /* 3416 */ // Label 217: @3416
     /* 3416 */ GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(3430), // Rule ID 348 //
     /* 3421 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule203Enabled),
     /* 3424 */   GIM_CheckNumOperandsGE, /*MI*/0, /*Expected*/2,
     /* 3427 */   // MIs[0] dst
     /* 3427 */   // No operand predicates
     /* 3427 */   // MIs[0] unused
     /* 3427 */   // No operand predicates
     /* 3427 */   // Combiner Rule #203: combine_use_vector_truncate
     /* 3427 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner139),
     /* 3430 */ // Label 218: @3430
     /* 3430 */ GIM_Reject,
     /* 3431 */ // Label 16: @3431
     /* 3431 */ GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(3442), // Rule ID 132 //
     /* 3436 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule95Enabled),
     /* 3439 */   // Combiner Rule #95: buildvector_identity_fold; wip_match_opcode 'G_BUILD_VECTOR_TRUNC'
     /* 3439 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner49),
     /* 3442 */ // Label 219: @3442
     /* 3442 */ GIM_Reject,
     /* 3443 */ // Label 17: @3443
     /* 3443 */ GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(3454), // Rule ID 341 //
     /* 3448 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule196Enabled),
     /* 3451 */   // Combiner Rule #196: combine_concat_vector; wip_match_opcode 'G_CONCAT_VECTORS'
     /* 3451 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner132),
     /* 3454 */ // Label 220: @3454
     /* 3454 */ GIM_Reject,
     /* 3455 */ // Label 18: @3455
     /* 3455 */ GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(3476), // Rule ID 125 //
     /* 3460 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule89Enabled),
     /* 3463 */   // MIs[0] dst
     /* 3463 */   // No operand predicates
     /* 3463 */   // MIs[0] t
     /* 3463 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3467 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTTOPTR),
     /* 3471 */   // MIs[1] ptr
     /* 3471 */   // No operand predicates
     /* 3471 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3473 */   // Combiner Rule #89: i2p_to_p2i
     /* 3473 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner47),
     /* 3476 */ // Label 221: @3476
     /* 3476 */ GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(3497), // Rule ID 90 //
     /* 3481 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 3484 */   // MIs[0] dst
     /* 3484 */   // No operand predicates
     /* 3484 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3484 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3488 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3492 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3494 */   // Combiner Rule #77: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[3]]
     /* 3494 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 3497 */ // Label 222: @3497
     /* 3497 */ GIM_Reject,
     /* 3498 */ // Label 19: @3498
     /* 3498 */ GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(3509), // Rule ID 124 //
     /* 3503 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule88Enabled),
     /* 3506 */   // Combiner Rule #88: p2i_to_i2p; wip_match_opcode 'G_INTTOPTR'
     /* 3506 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner46),
     /* 3509 */ // Label 223: @3509
     /* 3509 */ GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(3530), // Rule ID 91 //
     /* 3514 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 3517 */   // MIs[0] dst
     /* 3517 */   // No operand predicates
     /* 3517 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3517 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3521 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3525 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3527 */   // Combiner Rule #77: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[4]]
     /* 3527 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 3530 */ // Label 224: @3530
     /* 3530 */ GIM_Reject,
     /* 3531 */ // Label 20: @3531
     /* 3531 */ GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(3552), // Rule ID 136 //
     /* 3536 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule98Enabled),
     /* 3539 */   // MIs[0] dst
     /* 3539 */   // No operand predicates
     /* 3539 */   // MIs[0] src1
     /* 3539 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3543 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 3547 */   // MIs[1] src0
     /* 3547 */   // No operand predicates
     /* 3547 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3549 */   // Combiner Rule #98: bitcast_bitcast_fold
     /* 3549 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner52),
     /* 3552 */ // Label 225: @3552
     /* 3552 */ GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(3573), // Rule ID 88 //
     /* 3557 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 3560 */   // MIs[0] dst
     /* 3560 */   // No operand predicates
     /* 3560 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3560 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3564 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3568 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3570 */   // Combiner Rule #77: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[1]]
     /* 3570 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 3573 */ // Label 226: @3573
     /* 3573 */ GIM_Reject,
     /* 3574 */ // Label 21: @3574
     /* 3574 */ GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(3603), // Rule ID 18 //
     /* 3579 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule18Enabled),
     /* 3582 */   // MIs[0] dst
     /* 3582 */   // No operand predicates
     /* 3582 */   // MIs[0] src
     /* 3582 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3586 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FREEZE),
     /* 3590 */   // MIs[1] __idempotent_prop_match_0.x
     /* 3590 */   // No operand predicates
     /* 3590 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3595 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3597 */   // Combiner Rule #18: idempotent_prop @ [__idempotent_prop_match_0[0]]
     /* 3597 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3602 */   GIR_EraseRootFromParent_Done,
     /* 3603 */ // Label 227: @3603
     /* 3603 */ GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(3626), // Rule ID 43 //
     /* 3608 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule41Enabled),
     /* 3611 */   // MIs[0] root
     /* 3611 */   // No operand predicates
     /* 3611 */   // MIs[0] src
     /* 3611 */   // No operand predicates
     /* 3611 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner1),
     /* 3615 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3620 */   // Combiner Rule #41: freeze_of_non_undef_non_poison
     /* 3620 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3625 */   GIR_EraseRootFromParent_Done,
     /* 3626 */ // Label 228: @3626
     /* 3626 */ GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(3637), // Rule ID 44 //
     /* 3631 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule42Enabled),
     /* 3634 */   // MIs[0] dst
     /* 3634 */   // No operand predicates
     /* 3634 */   // MIs[0] src
     /* 3634 */   // No operand predicates
     /* 3634 */   // Combiner Rule #42: push_freeze_to_prevent_poison_from_propagating
     /* 3634 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner19),
     /* 3637 */ // Label 229: @3637
     /* 3637 */ GIM_Reject,
     /* 3638 */ // Label 22: @3638
     /* 3638 */ GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(3649), // Rule ID 70 //
     /* 3643 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule68Enabled),
     /* 3646 */   // Combiner Rule #68: extending_loads; wip_match_opcode 'G_LOAD'
     /* 3646 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner30),
     /* 3649 */ // Label 230: @3649
     /* 3649 */ GIM_Reject,
     /* 3650 */ // Label 23: @3650
     /* 3650 */ GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(3661), // Rule ID 71 //
     /* 3655 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule68Enabled),
     /* 3658 */   // Combiner Rule #68: extending_loads; wip_match_opcode 'G_SEXTLOAD'
     /* 3658 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner30),
     /* 3661 */ // Label 231: @3661
     /* 3661 */ GIM_Reject,
     /* 3662 */ // Label 24: @3662
     /* 3662 */ GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(3673), // Rule ID 72 //
     /* 3667 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule68Enabled),
     /* 3670 */   // Combiner Rule #68: extending_loads; wip_match_opcode 'G_ZEXTLOAD'
     /* 3670 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner30),
     /* 3673 */ // Label 232: @3673
     /* 3673 */ GIM_Reject,
     /* 3674 */ // Label 25: @3674
     /* 3674 */ GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(3685), // Rule ID 100 //
     /* 3679 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule81Enabled),
     /* 3682 */   // Combiner Rule #81: erase_undef_store; wip_match_opcode 'G_STORE'
     /* 3682 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner42),
     /* 3685 */ // Label 233: @3685
     /* 3685 */ GIM_Reject,
     /* 3686 */ // Label 26: @3686
     /* 3686 */ GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(3697), // Rule ID 126 //
     /* 3691 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule90Enabled),
     /* 3694 */   // Combiner Rule #90: anyext_trunc_fold; wip_match_opcode 'G_ANYEXT'
     /* 3694 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner48),
     /* 3697 */ // Label 234: @3697
     /* 3697 */ GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(3708), // Rule ID 257 //
     /* 3702 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule169Enabled),
     /* 3705 */   // Combiner Rule #169: constant_fold_cast_op; wip_match_opcode 'G_ANYEXT'
     /* 3705 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner107),
     /* 3708 */ // Label 235: @3708
     /* 3708 */ GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(3729), // Rule ID 57 //
     /* 3713 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule55Enabled),
     /* 3716 */   // MIs[0] root
     /* 3716 */   // No operand predicates
     /* 3716 */   // MIs[0] select
     /* 3716 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3720 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /* 3724 */   // MIs[1] cond
     /* 3724 */   // No operand predicates
     /* 3724 */   // MIs[1] true
     /* 3724 */   // No operand predicates
     /* 3724 */   // MIs[1] false
     /* 3724 */   // No operand predicates
     /* 3724 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3726 */   // Combiner Rule #55: select_of_anyext
     /* 3726 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner23),
     /* 3729 */ // Label 236: @3729
     /* 3729 */ GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(3750), // Rule ID 52 //
     /* 3734 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule50Enabled),
     /* 3737 */   // MIs[0] root
     /* 3737 */   // No operand predicates
     /* 3737 */   // MIs[0] second
     /* 3737 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3741 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 3745 */   // MIs[1] src
     /* 3745 */   // No operand predicates
     /* 3745 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3747 */   // Combiner Rule #50: anyext_of_anyext
     /* 3747 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 3750 */ // Label 237: @3750
     /* 3750 */ GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(3771), // Rule ID 54 //
     /* 3755 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule52Enabled),
     /* 3758 */   // MIs[0] root
     /* 3758 */   // No operand predicates
     /* 3758 */   // MIs[0] second
     /* 3758 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3762 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 3766 */   // MIs[1] src
     /* 3766 */   // No operand predicates
     /* 3766 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3768 */   // Combiner Rule #52: anyext_of_sext
     /* 3768 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 3771 */ // Label 238: @3771
     /* 3771 */ GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(3792), // Rule ID 53 //
     /* 3776 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule51Enabled),
     /* 3779 */   // MIs[0] root
     /* 3779 */   // No operand predicates
     /* 3779 */   // MIs[0] second
     /* 3779 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3783 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 3787 */   // MIs[1] src
     /* 3787 */   // No operand predicates
     /* 3787 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3789 */   // Combiner Rule #51: anyext_of_zext
     /* 3789 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 3792 */ // Label 239: @3792
     /* 3792 */ GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(3813), // Rule ID 89 //
     /* 3797 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 3800 */   // MIs[0] dst
     /* 3800 */   // No operand predicates
     /* 3800 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3800 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3804 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3808 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3810 */   // Combiner Rule #77: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[2]]
     /* 3810 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 3813 */ // Label 240: @3813
     /* 3813 */ GIM_Reject,
     /* 3814 */ // Label 27: @3814
     /* 3814 */ GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(3825), // Rule ID 134 //
     /* 3819 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule96Enabled),
     /* 3822 */   // Combiner Rule #96: trunc_buildvector_fold; wip_match_opcode 'G_TRUNC'
     /* 3822 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner50),
     /* 3825 */ // Label 241: @3825
     /* 3825 */ GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(3836), // Rule ID 135 //
     /* 3830 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule97Enabled),
     /* 3833 */   // Combiner Rule #97: trunc_lshr_buildvector_fold; wip_match_opcode 'G_TRUNC'
     /* 3833 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner51),
     /* 3836 */ // Label 242: @3836
     /* 3836 */ GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(3847), // Rule ID 173 //
     /* 3841 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule131Enabled),
     /* 3844 */   // Combiner Rule #131: trunc_shift; wip_match_opcode 'G_TRUNC'
     /* 3844 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner78),
     /* 3847 */ // Label 243: @3847
     /* 3847 */ GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(3868), // Rule ID 58 //
     /* 3852 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule56Enabled),
     /* 3855 */   // MIs[0] root
     /* 3855 */   // No operand predicates
     /* 3855 */   // MIs[0] select
     /* 3855 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3859 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /* 3863 */   // MIs[1] cond
     /* 3863 */   // No operand predicates
     /* 3863 */   // MIs[1] true
     /* 3863 */   // No operand predicates
     /* 3863 */   // MIs[1] false
     /* 3863 */   // No operand predicates
     /* 3863 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3865 */   // Combiner Rule #56: select_of_truncate
     /* 3865 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner23),
     /* 3868 */ // Label 244: @3868
     /* 3868 */ GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(3897), // Rule ID 60 //
     /* 3873 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule58Enabled),
     /* 3876 */   // MIs[0] root
     /* 3876 */   // No operand predicates
     /* 3876 */   // MIs[0] binop
     /* 3876 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3880 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 3884 */   // MIs[1] x
     /* 3884 */   // No operand predicates
     /* 3884 */   // MIs[1] const
     /* 3884 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3888 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3892 */   // MIs[2] imm
     /* 3892 */   // No operand predicates
     /* 3892 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3894 */   // Combiner Rule #58: narrow_binop_add
     /* 3894 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 3897 */ // Label 245: @3897
     /* 3897 */ GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(3926), // Rule ID 63 //
     /* 3902 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule61Enabled),
     /* 3905 */   // MIs[0] root
     /* 3905 */   // No operand predicates
     /* 3905 */   // MIs[0] binop
     /* 3905 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3909 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 3913 */   // MIs[1] x
     /* 3913 */   // No operand predicates
     /* 3913 */   // MIs[1] const
     /* 3913 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3917 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3921 */   // MIs[2] imm
     /* 3921 */   // No operand predicates
     /* 3921 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3923 */   // Combiner Rule #61: narrow_binop_and
     /* 3923 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 3926 */ // Label 246: @3926
     /* 3926 */ GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(3955), // Rule ID 62 //
     /* 3931 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule60Enabled),
     /* 3934 */   // MIs[0] root
     /* 3934 */   // No operand predicates
     /* 3934 */   // MIs[0] binop
     /* 3934 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3938 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 3942 */   // MIs[1] x
     /* 3942 */   // No operand predicates
     /* 3942 */   // MIs[1] const
     /* 3942 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3946 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3950 */   // MIs[2] imm
     /* 3950 */   // No operand predicates
     /* 3950 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3952 */   // Combiner Rule #60: narrow_binop_mul
     /* 3952 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 3955 */ // Label 247: @3955
     /* 3955 */ GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(3984), // Rule ID 64 //
     /* 3960 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule62Enabled),
     /* 3963 */   // MIs[0] root
     /* 3963 */   // No operand predicates
     /* 3963 */   // MIs[0] binop
     /* 3963 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3967 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 3971 */   // MIs[1] x
     /* 3971 */   // No operand predicates
     /* 3971 */   // MIs[1] const
     /* 3971 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3975 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3979 */   // MIs[2] imm
     /* 3979 */   // No operand predicates
     /* 3979 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3981 */   // Combiner Rule #62: narrow_binop_or
     /* 3981 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 3984 */ // Label 248: @3984
     /* 3984 */ GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(4013), // Rule ID 61 //
     /* 3989 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule59Enabled),
     /* 3992 */   // MIs[0] root
     /* 3992 */   // No operand predicates
     /* 3992 */   // MIs[0] binop
     /* 3992 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3996 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 4000 */   // MIs[1] x
     /* 4000 */   // No operand predicates
     /* 4000 */   // MIs[1] const
     /* 4000 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 4004 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 4008 */   // MIs[2] imm
     /* 4008 */   // No operand predicates
     /* 4008 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 4010 */   // Combiner Rule #59: narrow_binop_sub
     /* 4010 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 4013 */ // Label 249: @4013
     /* 4013 */ GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(4042), // Rule ID 65 //
     /* 4018 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule63Enabled),
     /* 4021 */   // MIs[0] root
     /* 4021 */   // No operand predicates
     /* 4021 */   // MIs[0] binop
     /* 4021 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4025 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 4029 */   // MIs[1] x
     /* 4029 */   // No operand predicates
     /* 4029 */   // MIs[1] const
     /* 4029 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 4033 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 4037 */   // MIs[2] imm
     /* 4037 */   // No operand predicates
     /* 4037 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 4039 */   // Combiner Rule #63: narrow_binop_xor
     /* 4039 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 4042 */ // Label 250: @4042
     /* 4042 */ GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(4063), // Rule ID 47 //
     /* 4047 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule45Enabled),
     /* 4050 */   // MIs[0] root
     /* 4050 */   // No operand predicates
     /* 4050 */   // MIs[0] ext
     /* 4050 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4054 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 4058 */   // MIs[1] src
     /* 4058 */   // No operand predicates
     /* 4058 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4060 */   // Combiner Rule #45: truncate_of_anyext
     /* 4060 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner20),
     /* 4063 */ // Label 251: @4063
     /* 4063 */ GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(4087), // Rule ID 59 //
     /* 4068 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule57Enabled),
     /* 4071 */   // MIs[0] root
     /* 4071 */   // No operand predicates
     /* 4071 */   // MIs[0] bv
     /* 4071 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4075 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 4079 */   GIM_CheckNumOperandsGE, /*MI*/1, /*Expected*/2,
     /* 4082 */   // MIs[1] unused
     /* 4082 */   // No operand predicates
     /* 4082 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4084 */   // Combiner Rule #57: buildvector_of_truncate
     /* 4084 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner24),
     /* 4087 */ // Label 252: @4087
     /* 4087 */ GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(4108), // Rule ID 46 //
     /* 4092 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule44Enabled),
     /* 4095 */   // MIs[0] root
     /* 4095 */   // No operand predicates
     /* 4095 */   // MIs[0] ext
     /* 4095 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4099 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 4103 */   // MIs[1] src
     /* 4103 */   // No operand predicates
     /* 4103 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4105 */   // Combiner Rule #44: truncate_of_sext
     /* 4105 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner20),
     /* 4108 */ // Label 253: @4108
     /* 4108 */ GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(4129), // Rule ID 45 //
     /* 4113 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule43Enabled),
     /* 4116 */   // MIs[0] root
     /* 4116 */   // No operand predicates
     /* 4116 */   // MIs[0] ext
     /* 4116 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4120 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 4124 */   // MIs[1] src
     /* 4124 */   // No operand predicates
     /* 4124 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4126 */   // Combiner Rule #43: truncate_of_zext
     /* 4126 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner20),
     /* 4129 */ // Label 254: @4129
     /* 4129 */ GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(4150), // Rule ID 87 //
     /* 4134 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 4137 */   // MIs[0] dst
     /* 4137 */   // No operand predicates
     /* 4137 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 4137 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4141 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 4145 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4147 */   // Combiner Rule #77: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[0]]
     /* 4147 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 4150 */ // Label 255: @4150
     /* 4150 */ GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(4171), // Rule ID 66 //
     /* 4155 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule64Enabled),
     /* 4158 */   // MIs[0] root
     /* 4158 */   // No operand predicates
     /* 4158 */   // MIs[0] int
     /* 4158 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4162 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 4166 */   // MIs[1] imm
     /* 4166 */   // No operand predicates
     /* 4166 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4168 */   // Combiner Rule #64: integer_of_truncate
     /* 4168 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner26),
     /* 4171 */ // Label 256: @4171
     /* 4171 */ GIM_Reject,
     /* 4172 */ // Label 28: @4172
     /* 4172 */ GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(4183), // Rule ID 362 //
     /* 4177 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule215Enabled),
     /* 4180 */   // MIs[0] dst
     /* 4180 */   // No operand predicates
     /* 4180 */   // MIs[0] src
     /* 4180 */   // No operand predicates
     /* 4180 */   // Combiner Rule #215: fconstant_to_constant
     /* 4180 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner151),
     /* 4183 */ // Label 257: @4183
     /* 4183 */ GIM_Reject,
     /* 4184 */ // Label 29: @4184
     /* 4184 */ GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(4195), // Rule ID 256 //
     /* 4189 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule169Enabled),
     /* 4192 */   // Combiner Rule #169: constant_fold_cast_op; wip_match_opcode 'G_SEXT'
     /* 4192 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner107),
     /* 4195 */ // Label 258: @4195
     /* 4195 */ GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(4216), // Rule ID 51 //
     /* 4200 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule49Enabled),
     /* 4203 */   // MIs[0] root
     /* 4203 */   // No operand predicates
     /* 4203 */   // MIs[0] second
     /* 4203 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4207 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 4211 */   // MIs[1] src
     /* 4211 */   // No operand predicates
     /* 4211 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4213 */   // Combiner Rule #49: sext_of_anyext
     /* 4213 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 4216 */ // Label 259: @4216
     /* 4216 */ GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(4237), // Rule ID 50 //
     /* 4221 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 4224 */   // MIs[0] root
     /* 4224 */   // No operand predicates
     /* 4224 */   // MIs[0] second
     /* 4224 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4228 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 4232 */   // MIs[1] src
     /* 4232 */   // No operand predicates
     /* 4232 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4234 */   // Combiner Rule #48: sext_of_sext
     /* 4234 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 4237 */ // Label 260: @4237
     /* 4237 */ GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(4258), // Rule ID 342 //
     /* 4242 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule197Enabled),
     /* 4245 */   // MIs[0] root
     /* 4245 */   // No operand predicates
     /* 4245 */   // MIs[0] src
     /* 4245 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4249 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 4253 */   // MIs[1] x
     /* 4253 */   // No operand predicates
     /* 4253 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4255 */   // Combiner Rule #197: sext_trunc
     /* 4255 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner133),
     /* 4258 */ // Label 261: @4258
     /* 4258 */ GIM_Reject,
     /* 4259 */ // Label 30: @4259
     /* 4259 */ GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(4270), // Rule ID 160 //
     /* 4264 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule118Enabled),
     /* 4267 */   // Combiner Rule #118: sext_inreg_of_load; wip_match_opcode 'G_SEXT_INREG'
     /* 4267 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner66),
     /* 4270 */ // Label 262: @4270
     /* 4270 */ GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(4281), // Rule ID 168 //
     /* 4275 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule126Enabled),
     /* 4278 */   // Combiner Rule #126: redundant_sext_inreg; wip_match_opcode 'G_SEXT_INREG'
     /* 4278 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner73),
     /* 4281 */ // Label 263: @4281
     /* 4281 */ GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(4292), // Rule ID 225 //
     /* 4286 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule162Enabled),
     /* 4289 */   // Combiner Rule #162: bitfield_extract_from_sext_inreg; wip_match_opcode 'G_SEXT_INREG'
     /* 4289 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner100),
     /* 4292 */ // Label 264: @4292
     /* 4292 */ GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(4313), // Rule ID 55 //
     /* 4297 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule53Enabled),
     /* 4300 */   // MIs[0] dst
     /* 4300 */   // No operand predicates
     /* 4300 */   // MIs[0] x
     /* 4300 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4304 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 4308 */   // MIs[1] src
     /* 4308 */   // No operand predicates
     /* 4308 */   // MIs[1] a
     /* 4308 */   // No operand predicates
     /* 4308 */   // MIs[0] b
     /* 4308 */   // No operand predicates
     /* 4308 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4310 */   // Combiner Rule #53: sext_inreg_of_sext_inreg
     /* 4310 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner22),
     /* 4313 */ // Label 265: @4313
     /* 4313 */ GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(4324), // Rule ID 172 //
     /* 4318 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule130Enabled),
     /* 4321 */   // MIs[0] dst
     /* 4321 */   // No operand predicates
     /* 4321 */   // MIs[0] src
     /* 4321 */   // No operand predicates
     /* 4321 */   // MIs[0] imm
     /* 4321 */   // No operand predicates
     /* 4321 */   // Combiner Rule #130: sext_inreg_to_zext_inreg
     /* 4321 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner77),
     /* 4324 */ // Label 266: @4324
     /* 4324 */ GIM_Reject,
     /* 4325 */ // Label 31: @4325
     /* 4325 */ GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(4336), // Rule ID 171 //
     /* 4330 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule129Enabled),
     /* 4333 */   // Combiner Rule #129: zext_trunc_fold; wip_match_opcode 'G_ZEXT'
     /* 4333 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner76),
     /* 4336 */ // Label 267: @4336
     /* 4336 */ GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(4347), // Rule ID 255 //
     /* 4341 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule169Enabled),
     /* 4344 */   // Combiner Rule #169: constant_fold_cast_op; wip_match_opcode 'G_ZEXT'
     /* 4344 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner107),
     /* 4347 */ // Label 268: @4347
     /* 4347 */ GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(4368), // Rule ID 56 //
     /* 4352 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule54Enabled),
     /* 4355 */   // MIs[0] root
     /* 4355 */   // No operand predicates
     /* 4355 */   // MIs[0] select
     /* 4355 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4359 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /* 4363 */   // MIs[1] cond
     /* 4363 */   // No operand predicates
     /* 4363 */   // MIs[1] true
     /* 4363 */   // No operand predicates
     /* 4363 */   // MIs[1] false
     /* 4363 */   // No operand predicates
     /* 4363 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4365 */   // Combiner Rule #54: select_of_zext
     /* 4365 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner23),
     /* 4368 */ // Label 269: @4368
     /* 4368 */ GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(4389), // Rule ID 49 //
     /* 4373 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule47Enabled),
     /* 4376 */   // MIs[0] root
     /* 4376 */   // No operand predicates
     /* 4376 */   // MIs[0] second
     /* 4376 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4380 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 4384 */   // MIs[1] src
     /* 4384 */   // No operand predicates
     /* 4384 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4386 */   // Combiner Rule #47: zext_of_anyext
     /* 4386 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 4389 */ // Label 270: @4389
     /* 4389 */ GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(4416), // Rule ID 343 //
     /* 4394 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule198Enabled),
     /* 4397 */   // MIs[0] root
     /* 4397 */   // No operand predicates
     /* 4397 */   // MIs[0] src
     /* 4397 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4401 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 4405 */   GIM_MIFlags, /*MI*/1, GIMT_Encode4(MachineInstr::NoUWrap),
     /* 4411 */   // MIs[1] x
     /* 4411 */   // No operand predicates
     /* 4411 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4413 */   // Combiner Rule #198: zext_trunc
     /* 4413 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner134),
     /* 4416 */ // Label 271: @4416
     /* 4416 */ GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(4437), // Rule ID 48 //
     /* 4421 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule46Enabled),
     /* 4424 */   // MIs[0] root
     /* 4424 */   // No operand predicates
     /* 4424 */   // MIs[0] second
     /* 4424 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4428 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 4432 */   // MIs[1] src
     /* 4432 */   // No operand predicates
     /* 4432 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4434 */   // Combiner Rule #46: zext_of_zext
     /* 4434 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 4437 */ // Label 272: @4437
     /* 4437 */ GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(4454), // Rule ID 344 //
     /* 4442 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule199Enabled),
     /* 4445 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NonNeg),
     /* 4451 */   // MIs[0] root
     /* 4451 */   // No operand predicates
     /* 4451 */   // MIs[0] x
     /* 4451 */   // No operand predicates
     /* 4451 */   // Combiner Rule #199: nneg_zext
     /* 4451 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner135),
     /* 4454 */ // Label 273: @4454
     /* 4454 */ GIM_Reject,
     /* 4455 */ // Label 32: @4455
     /* 4455 */ GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(4466), // Rule ID 80 //
     /* 4460 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule74Enabled),
     /* 4463 */   // Combiner Rule #74: binop_left_undef_to_zero; wip_match_opcode 'G_SHL'
     /* 4463 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner36),
     /* 4466 */ // Label 274: @4466
     /* 4466 */ GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(4477), // Rule ID 83 //
     /* 4471 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule75Enabled),
     /* 4474 */   // Combiner Rule #75: binop_right_undef_to_undef; wip_match_opcode 'G_SHL'
     /* 4474 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 4477 */ // Label 275: @4477
     /* 4477 */ GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(4488), // Rule ID 116 //
     /* 4482 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 4485 */   // Combiner Rule #86: binop_left_to_zero; wip_match_opcode 'G_SHL'
     /* 4485 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 4488 */ // Label 276: @4488
     /* 4488 */ GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(4499), // Rule ID 200 //
     /* 4493 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 4496 */   // Combiner Rule #150: shift_immed_chain; wip_match_opcode 'G_SHL'
     /* 4496 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 4499 */ // Label 277: @4499
     /* 4499 */ GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(4510), // Rule ID 205 //
     /* 4504 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 4507 */   // Combiner Rule #151: shift_of_shifted_logic_chain; wip_match_opcode 'G_SHL'
     /* 4507 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner93),
     /* 4510 */ // Label 278: @4510
     /* 4510 */ GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(4521), // Rule ID 224 //
     /* 4515 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule161Enabled),
     /* 4518 */   // Combiner Rule #161: commute_shift; wip_match_opcode 'G_SHL'
     /* 4518 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner99),
     /* 4521 */ // Label 279: @4521
     /* 4521 */ GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(4532), // Rule ID 238 //
     /* 4526 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 4529 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_SHL'
     /* 4529 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 4532 */ // Label 280: @4532
     /* 4532 */ GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(4543), // Rule ID 291 //
     /* 4537 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 4540 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_SHL'
     /* 4540 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 4543 */ // Label 281: @4543
     /* 4543 */ GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(4578), // Rule ID 41 //
     /* 4548 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule39Enabled),
     /* 4551 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 4557 */   // MIs[0] root
     /* 4557 */   // No operand predicates
     /* 4557 */   // MIs[0] left
     /* 4557 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4561 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 4565 */   // MIs[1] imm
     /* 4565 */   // No operand predicates
     /* 4565 */   // MIs[0] x
     /* 4565 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 4569 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 4573 */   // MIs[2] imm1
     /* 4573 */   // No operand predicates
     /* 4573 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 4575 */   // Combiner Rule #39: shl_of_vscale
     /* 4575 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner17),
     /* 4578 */ // Label 282: @4578
     /* 4578 */ GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(4601), // Rule ID 108 //
     /* 4583 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 4586 */   // MIs[0] dst
     /* 4586 */   // No operand predicates
     /* 4586 */   // MIs[0] lhs
     /* 4586 */   // No operand predicates
     /* 4586 */   // MIs[0] Operand 2
     /* 4586 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4590 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4595 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[4]]
     /* 4595 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4600 */   GIR_EraseRootFromParent_Done,
     /* 4601 */ // Label 283: @4601
     /* 4601 */ GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(4612), // Rule ID 145 //
     /* 4606 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule105Enabled),
     /* 4609 */   // MIs[0] root
     /* 4609 */   // No operand predicates
     /* 4609 */   // MIs[0] mi.shifted
     /* 4609 */   // No operand predicates
     /* 4609 */   // MIs[0] mi.amt
     /* 4609 */   // No operand predicates
     /* 4609 */   // Combiner Rule #105: shifts_too_big @ [mi[0]]
     /* 4609 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner56),
     /* 4612 */ // Label 284: @4612
     /* 4612 */ GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(4623), // Rule ID 161 //
     /* 4617 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule119Enabled),
     /* 4620 */   // MIs[0] dst
     /* 4620 */   // No operand predicates
     /* 4620 */   // MIs[0] src0
     /* 4620 */   // No operand predicates
     /* 4620 */   // MIs[0] src1
     /* 4620 */   // No operand predicates
     /* 4620 */   // Combiner Rule #119: reduce_shl_of_extend
     /* 4620 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 4623 */ // Label 285: @4623
     /* 4623 */ GIM_Reject,
     /* 4624 */ // Label 33: @4624
     /* 4624 */ GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(4635), // Rule ID 85 //
     /* 4629 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule75Enabled),
     /* 4632 */   // Combiner Rule #75: binop_right_undef_to_undef; wip_match_opcode 'G_LSHR'
     /* 4632 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 4635 */ // Label 286: @4635
     /* 4635 */ GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(4646), // Rule ID 117 //
     /* 4640 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 4643 */   // Combiner Rule #86: binop_left_to_zero; wip_match_opcode 'G_LSHR'
     /* 4643 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 4646 */ // Label 287: @4646
     /* 4646 */ GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(4657), // Rule ID 202 //
     /* 4651 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 4654 */   // Combiner Rule #150: shift_immed_chain; wip_match_opcode 'G_LSHR'
     /* 4654 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 4657 */ // Label 288: @4657
     /* 4657 */ GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(4668), // Rule ID 207 //
     /* 4662 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 4665 */   // Combiner Rule #151: shift_of_shifted_logic_chain; wip_match_opcode 'G_LSHR'
     /* 4665 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner93),
     /* 4668 */ // Label 289: @4668
     /* 4668 */ GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(4679), // Rule ID 228 //
     /* 4673 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 4676 */   // Combiner Rule #164: bitfield_extract_from_shr; wip_match_opcode 'G_LSHR'
     /* 4676 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner102),
     /* 4679 */ // Label 290: @4679
     /* 4679 */ GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(4690), // Rule ID 230 //
     /* 4684 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 4687 */   // Combiner Rule #165: bitfield_extract_from_shr_and; wip_match_opcode 'G_LSHR'
     /* 4687 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 4690 */ // Label 291: @4690
     /* 4690 */ GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(4701), // Rule ID 235 //
     /* 4695 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 4698 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_LSHR'
     /* 4698 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 4701 */ // Label 292: @4701
     /* 4701 */ GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(4712), // Rule ID 289 //
     /* 4706 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 4709 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_LSHR'
     /* 4709 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 4712 */ // Label 293: @4712
     /* 4712 */ GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(4735), // Rule ID 110 //
     /* 4717 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 4720 */   // MIs[0] dst
     /* 4720 */   // No operand predicates
     /* 4720 */   // MIs[0] lhs
     /* 4720 */   // No operand predicates
     /* 4720 */   // MIs[0] Operand 2
     /* 4720 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4724 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4729 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[6]]
     /* 4729 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4734 */   GIR_EraseRootFromParent_Done,
     /* 4735 */ // Label 294: @4735
     /* 4735 */ GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(4746), // Rule ID 147 //
     /* 4740 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule105Enabled),
     /* 4743 */   // MIs[0] root
     /* 4743 */   // No operand predicates
     /* 4743 */   // MIs[0] mi.shifted
     /* 4743 */   // No operand predicates
     /* 4743 */   // MIs[0] mi.amt
     /* 4743 */   // No operand predicates
     /* 4743 */   // Combiner Rule #105: shifts_too_big @ [mi[2]]
     /* 4743 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner56),
     /* 4746 */ // Label 295: @4746
     /* 4746 */ GIM_Reject,
     /* 4747 */ // Label 34: @4747
     /* 4747 */ GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(4758), // Rule ID 84 //
     /* 4752 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule75Enabled),
     /* 4755 */   // Combiner Rule #75: binop_right_undef_to_undef; wip_match_opcode 'G_ASHR'
     /* 4755 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 4758 */ // Label 296: @4758
     /* 4758 */ GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(4769), // Rule ID 118 //
     /* 4763 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 4766 */   // Combiner Rule #86: binop_left_to_zero; wip_match_opcode 'G_ASHR'
     /* 4766 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 4769 */ // Label 297: @4769
     /* 4769 */ GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(4780), // Rule ID 158 //
     /* 4774 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule116Enabled),
     /* 4777 */   // Combiner Rule #116: shl_ashr_to_sext_inreg; wip_match_opcode 'G_ASHR'
     /* 4777 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner65),
     /* 4780 */ // Label 298: @4780
     /* 4780 */ GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(4791), // Rule ID 201 //
     /* 4785 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 4788 */   // Combiner Rule #150: shift_immed_chain; wip_match_opcode 'G_ASHR'
     /* 4788 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 4791 */ // Label 299: @4791
     /* 4791 */ GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(4802), // Rule ID 206 //
     /* 4796 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 4799 */   // Combiner Rule #151: shift_of_shifted_logic_chain; wip_match_opcode 'G_ASHR'
     /* 4799 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner93),
     /* 4802 */ // Label 300: @4802
     /* 4802 */ GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(4813), // Rule ID 227 //
     /* 4807 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 4810 */   // Combiner Rule #164: bitfield_extract_from_shr; wip_match_opcode 'G_ASHR'
     /* 4810 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner102),
     /* 4813 */ // Label 301: @4813
     /* 4813 */ GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(4824), // Rule ID 229 //
     /* 4818 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 4821 */   // Combiner Rule #165: bitfield_extract_from_shr_and; wip_match_opcode 'G_ASHR'
     /* 4821 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 4824 */ // Label 302: @4824
     /* 4824 */ GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(4835), // Rule ID 234 //
     /* 4829 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 4832 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_ASHR'
     /* 4832 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 4835 */ // Label 303: @4835
     /* 4835 */ GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(4846), // Rule ID 290 //
     /* 4840 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 4843 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_ASHR'
     /* 4843 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 4846 */ // Label 304: @4846
     /* 4846 */ GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(4869), // Rule ID 109 //
     /* 4851 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 4854 */   // MIs[0] dst
     /* 4854 */   // No operand predicates
     /* 4854 */   // MIs[0] lhs
     /* 4854 */   // No operand predicates
     /* 4854 */   // MIs[0] Operand 2
     /* 4854 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4858 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4863 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[5]]
     /* 4863 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4868 */   GIR_EraseRootFromParent_Done,
     /* 4869 */ // Label 305: @4869
     /* 4869 */ GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(4880), // Rule ID 146 //
     /* 4874 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule105Enabled),
     /* 4877 */   // MIs[0] root
     /* 4877 */   // No operand predicates
     /* 4877 */   // MIs[0] mi.shifted
     /* 4877 */   // No operand predicates
     /* 4877 */   // MIs[0] mi.amt
     /* 4877 */   // No operand predicates
     /* 4877 */   // Combiner Rule #105: shifts_too_big @ [mi[1]]
     /* 4877 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner56),
     /* 4880 */ // Label 306: @4880
     /* 4880 */ GIM_Reject,
     /* 4881 */ // Label 35: @4881
     /* 4881 */ GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(4892), // Rule ID 216 //
     /* 4886 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule155Enabled),
     /* 4889 */   // Combiner Rule #155: funnel_shift_to_rotate; wip_match_opcode 'G_FSHL'
     /* 4889 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner97),
     /* 4892 */ // Label 307: @4892
     /* 4892 */ GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(4903), // Rule ID 220 //
     /* 4897 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule158Enabled),
     /* 4900 */   // Combiner Rule #158: funnel_shift_overshift; wip_match_opcode 'G_FSHL'
     /* 4900 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner98),
     /* 4903 */ // Label 308: @4903
     /* 4903 */ GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(4923), // Rule ID 219 //
     /* 4908 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule157Enabled),
     /* 4911 */   // MIs[0] x
     /* 4911 */   // No operand predicates
     /* 4911 */   // MIs[0] y
     /* 4911 */   // No operand predicates
     /* 4911 */   // MIs[0] z
     /* 4911 */   // No operand predicates
     /* 4911 */   // MIs[0] Operand 3
     /* 4911 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 4915 */   // Combiner Rule #157: funnel_shift_left_zero
     /* 4915 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 4918 */   GIR_RootToRootCopy, /*OpIdx*/0, // x
     /* 4920 */   GIR_RootToRootCopy, /*OpIdx*/1, // y
     /* 4922 */   GIR_EraseRootFromParent_Done,
     /* 4923 */ // Label 309: @4923
     /* 4923 */ GIM_Reject,
     /* 4924 */ // Label 36: @4924
     /* 4924 */ GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(4935), // Rule ID 217 //
     /* 4929 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule155Enabled),
     /* 4932 */   // Combiner Rule #155: funnel_shift_to_rotate; wip_match_opcode 'G_FSHR'
     /* 4932 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner97),
     /* 4935 */ // Label 310: @4935
     /* 4935 */ GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(4946), // Rule ID 221 //
     /* 4940 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule158Enabled),
     /* 4943 */   // Combiner Rule #158: funnel_shift_overshift; wip_match_opcode 'G_FSHR'
     /* 4943 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner98),
     /* 4946 */ // Label 311: @4946
     /* 4946 */ GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(4966), // Rule ID 218 //
     /* 4951 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule156Enabled),
     /* 4954 */   // MIs[0] x
     /* 4954 */   // No operand predicates
     /* 4954 */   // MIs[0] y
     /* 4954 */   // No operand predicates
     /* 4954 */   // MIs[0] z
     /* 4954 */   // No operand predicates
     /* 4954 */   // MIs[0] Operand 3
     /* 4954 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 4958 */   // Combiner Rule #156: funnel_shift_right_zero
     /* 4958 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 4961 */   GIR_RootToRootCopy, /*OpIdx*/0, // x
     /* 4963 */   GIR_RootToRootCopy, /*OpIdx*/2, // z
     /* 4965 */   GIR_EraseRootFromParent_Done,
     /* 4966 */ // Label 312: @4966
     /* 4966 */ GIM_Reject,
     /* 4967 */ // Label 37: @4967
     /* 4967 */ GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(4990), // Rule ID 113 //
     /* 4972 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 4975 */   // MIs[0] dst
     /* 4975 */   // No operand predicates
     /* 4975 */   // MIs[0] lhs
     /* 4975 */   // No operand predicates
     /* 4975 */   // MIs[0] Operand 2
     /* 4975 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4979 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4984 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[9]]
     /* 4984 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4989 */   GIR_EraseRootFromParent_Done,
     /* 4990 */ // Label 313: @4990
     /* 4990 */ GIM_Reject,
     /* 4991 */ // Label 38: @4991
     /* 4991 */ GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(5014), // Rule ID 112 //
     /* 4996 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 4999 */   // MIs[0] dst
     /* 4999 */   // No operand predicates
     /* 4999 */   // MIs[0] lhs
     /* 4999 */   // No operand predicates
     /* 4999 */   // MIs[0] Operand 2
     /* 4999 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 5003 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5008 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[8]]
     /* 5008 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5013 */   GIR_EraseRootFromParent_Done,
     /* 5014 */ // Label 314: @5014
     /* 5014 */ GIM_Reject,
     /* 5015 */ // Label 39: @5015
     /* 5015 */ GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(5026), // Rule ID 153 //
     /* 5020 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule111Enabled),
     /* 5023 */   // Combiner Rule #111: icmp_to_true_false_known_bits; wip_match_opcode 'G_ICMP'
     /* 5023 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner62),
     /* 5026 */ // Label 315: @5026
     /* 5026 */ GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(5037), // Rule ID 154 //
     /* 5031 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule112Enabled),
     /* 5034 */   // Combiner Rule #112: icmp_to_lhs_known_bits; wip_match_opcode 'G_ICMP'
     /* 5034 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner63),
     /* 5037 */ // Label 316: @5037
     /* 5037 */ GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(5048), // Rule ID 157 //
     /* 5042 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule115Enabled),
     /* 5045 */   // Combiner Rule #115: redundant_binop_in_equality; wip_match_opcode 'G_ICMP'
     /* 5045 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner64),
     /* 5048 */ // Label 317: @5048
     /* 5048 */ GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(5059), // Rule ID 151 //
     /* 5053 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule109Enabled),
     /* 5056 */   // MIs[0] root
     /* 5056 */   // No operand predicates
     /* 5056 */   // MIs[0] pred
     /* 5056 */   // No operand predicates
     /* 5056 */   // MIs[0] lhs
     /* 5056 */   // No operand predicates
     /* 5056 */   // MIs[0] rhs
     /* 5056 */   // No operand predicates
     /* 5056 */   // Combiner Rule #109: canonicalize_icmp
     /* 5056 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner60),
     /* 5059 */ // Label 318: @5059
     /* 5059 */ GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(5070), // Rule ID 363 //
     /* 5064 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule216Enabled),
     /* 5067 */   // MIs[0] dst
     /* 5067 */   // No operand predicates
     /* 5067 */   // MIs[0] tst
     /* 5067 */   // No operand predicates
     /* 5067 */   // MIs[0] src1
     /* 5067 */   // No operand predicates
     /* 5067 */   // MIs[0] src2
     /* 5067 */   // No operand predicates
     /* 5067 */   // Combiner Rule #216: icmp_redundant_trunc
     /* 5067 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner152),
     /* 5070 */ // Label 319: @5070
     /* 5070 */ GIM_Reject,
     /* 5071 */ // Label 40: @5071
     /* 5071 */ GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(5082), // Rule ID 152 //
     /* 5076 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule110Enabled),
     /* 5079 */   // MIs[0] root
     /* 5079 */   // No operand predicates
     /* 5079 */   // MIs[0] pred
     /* 5079 */   // No operand predicates
     /* 5079 */   // MIs[0] lhs
     /* 5079 */   // No operand predicates
     /* 5079 */   // MIs[0] rhs
     /* 5079 */   // No operand predicates
     /* 5079 */   // Combiner Rule #110: canonicalize_fcmp
     /* 5079 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner61),
     /* 5082 */ // Label 320: @5082
     /* 5082 */ GIM_Reject,
     /* 5083 */ // Label 41: @5083
     /* 5083 */ GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(5094), // Rule ID 103 //
     /* 5088 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 5091 */   // Combiner Rule #83: select_same_val; wip_match_opcode 'G_SELECT'
     /* 5091 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 5094 */ // Label 321: @5094
     /* 5094 */ GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(5105), // Rule ID 164 //
     /* 5099 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule122Enabled),
     /* 5102 */   // Combiner Rule #122: select_constant_cmp; wip_match_opcode 'G_SELECT'
     /* 5102 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner69),
     /* 5105 */ // Label 322: @5105
     /* 5105 */ GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(5116), // Rule ID 166 //
     /* 5110 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule124Enabled),
     /* 5113 */   // Combiner Rule #124: match_selects; wip_match_opcode 'G_SELECT'
     /* 5113 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner71),
     /* 5116 */ // Label 323: @5116
     /* 5116 */ GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(5127), // Rule ID 307 //
     /* 5121 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 5124 */   // Combiner Rule #189: select_to_minmax; wip_match_opcode 'G_SELECT'
     /* 5124 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner125),
     /* 5127 */ // Label 324: @5127
     /* 5127 */ GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(5148), // Rule ID 165 //
     /* 5132 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule123Enabled),
     /* 5135 */   // MIs[0] root
     /* 5135 */   // No operand predicates
     /* 5135 */   // MIs[0] tst
     /* 5135 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5139 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 5143 */   // MIs[1] tst1
     /* 5143 */   // No operand predicates
     /* 5143 */   // MIs[1] a
     /* 5143 */   // No operand predicates
     /* 5143 */   // MIs[1] b
     /* 5143 */   // No operand predicates
     /* 5143 */   // MIs[0] x
     /* 5143 */   // No operand predicates
     /* 5143 */   // MIs[0] y
     /* 5143 */   // No operand predicates
     /* 5143 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5145 */   // Combiner Rule #123: select_to_iminmax
     /* 5145 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner70),
     /* 5148 */ // Label 325: @5148
     /* 5148 */ GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(5177), // Rule ID 163 //
     /* 5153 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule121Enabled),
     /* 5156 */   // MIs[0] dst
     /* 5156 */   // No operand predicates
     /* 5156 */   // MIs[0] undef
     /* 5156 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5160 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 5164 */   // MIs[0] x
     /* 5164 */   // No operand predicates
     /* 5164 */   // MIs[0] y
     /* 5164 */   // No operand predicates
     /* 5164 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/3,
     /* 5169 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5171 */   // Combiner Rule #121: select_undef_cmp
     /* 5171 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/3,
     /* 5176 */   GIR_EraseRootFromParent_Done,
     /* 5177 */ // Label 326: @5177
     /* 5177 */ GIM_Reject,
     /* 5178 */ // Label 42: @5178
     /* 5178 */ GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(5189), // Rule ID 318 //
     /* 5183 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 5186 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_UADDO'
     /* 5186 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5189 */ // Label 327: @5189
     /* 5189 */ GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(5200), // Rule ID 359 //
     /* 5194 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule213Enabled),
     /* 5197 */   // Combiner Rule #213: match_addos; wip_match_opcode 'G_UADDO'
     /* 5197 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner149),
     /* 5200 */ // Label 328: @5200
     /* 5200 */ GIM_Reject,
     /* 5201 */ // Label 43: @5201
     /* 5201 */ GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(5212), // Rule ID 189 //
     /* 5206 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule145Enabled),
     /* 5209 */   // Combiner Rule #145: adde_to_addo; wip_match_opcode 'G_UADDE'
     /* 5209 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 5212 */ // Label 329: @5212
     /* 5212 */ GIM_Reject,
     /* 5213 */ // Label 44: @5213
     /* 5213 */ GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(5224), // Rule ID 361 //
     /* 5218 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule214Enabled),
     /* 5221 */   // Combiner Rule #214: match_subo_no_overflow; wip_match_opcode 'G_USUBO'
     /* 5221 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner150),
     /* 5224 */ // Label 330: @5224
     /* 5224 */ GIM_Reject,
     /* 5225 */ // Label 45: @5225
     /* 5225 */ GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(5236), // Rule ID 191 //
     /* 5230 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule145Enabled),
     /* 5233 */   // Combiner Rule #145: adde_to_addo; wip_match_opcode 'G_USUBE'
     /* 5233 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 5236 */ // Label 331: @5236
     /* 5236 */ GIM_Reject,
     /* 5237 */ // Label 46: @5237
     /* 5237 */ GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(5248), // Rule ID 319 //
     /* 5242 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 5245 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_SADDO'
     /* 5245 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5248 */ // Label 332: @5248
     /* 5248 */ GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(5259), // Rule ID 358 //
     /* 5253 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule213Enabled),
     /* 5256 */   // Combiner Rule #213: match_addos; wip_match_opcode 'G_SADDO'
     /* 5256 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner149),
     /* 5259 */ // Label 333: @5259
     /* 5259 */ GIM_Reject,
     /* 5260 */ // Label 47: @5260
     /* 5260 */ GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(5271), // Rule ID 190 //
     /* 5265 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule145Enabled),
     /* 5268 */   // Combiner Rule #145: adde_to_addo; wip_match_opcode 'G_SADDE'
     /* 5268 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 5271 */ // Label 334: @5271
     /* 5271 */ GIM_Reject,
     /* 5272 */ // Label 48: @5272
     /* 5272 */ GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(5283), // Rule ID 360 //
     /* 5277 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule214Enabled),
     /* 5280 */   // Combiner Rule #214: match_subo_no_overflow; wip_match_opcode 'G_SSUBO'
     /* 5280 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner150),
     /* 5283 */ // Label 335: @5283
     /* 5283 */ GIM_Reject,
     /* 5284 */ // Label 49: @5284
     /* 5284 */ GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(5295), // Rule ID 192 //
     /* 5289 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule145Enabled),
     /* 5292 */   // Combiner Rule #145: adde_to_addo; wip_match_opcode 'G_SSUBE'
     /* 5292 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 5295 */ // Label 336: @5295
     /* 5295 */ GIM_Reject,
     /* 5296 */ // Label 50: @5296
     /* 5296 */ GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(5307), // Rule ID 185 //
     /* 5301 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule143Enabled),
     /* 5304 */   // Combiner Rule #143: mulo_by_2; wip_match_opcode 'G_UMULO'
     /* 5304 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner85),
     /* 5307 */ // Label 337: @5307
     /* 5307 */ GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(5318), // Rule ID 187 //
     /* 5312 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule144Enabled),
     /* 5315 */   // Combiner Rule #144: mulo_by_0; wip_match_opcode 'G_UMULO'
     /* 5315 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner86),
     /* 5318 */ // Label 338: @5318
     /* 5318 */ GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(5329), // Rule ID 320 //
     /* 5323 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 5326 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULO'
     /* 5326 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5329 */ // Label 339: @5329
     /* 5329 */ GIM_Reject,
     /* 5330 */ // Label 51: @5330
     /* 5330 */ GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(5341), // Rule ID 186 //
     /* 5335 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule143Enabled),
     /* 5338 */   // Combiner Rule #143: mulo_by_2; wip_match_opcode 'G_SMULO'
     /* 5338 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner85),
     /* 5341 */ // Label 340: @5341
     /* 5341 */ GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(5352), // Rule ID 188 //
     /* 5346 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule144Enabled),
     /* 5349 */   // Combiner Rule #144: mulo_by_0; wip_match_opcode 'G_SMULO'
     /* 5349 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner86),
     /* 5352 */ // Label 341: @5352
     /* 5352 */ GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(5363), // Rule ID 321 //
     /* 5357 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 5360 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULO'
     /* 5360 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5363 */ // Label 342: @5363
     /* 5363 */ GIM_Reject,
     /* 5364 */ // Label 52: @5364
     /* 5364 */ GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(5375), // Rule ID 263 //
     /* 5369 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule175Enabled),
     /* 5372 */   // Combiner Rule #175: mulh_to_lshr; wip_match_opcode 'G_UMULH'
     /* 5372 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner112),
     /* 5375 */ // Label 343: @5375
     /* 5375 */ GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(5386), // Rule ID 322 //
     /* 5380 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 5383 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULH'
     /* 5383 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5386 */ // Label 344: @5386
     /* 5386 */ GIM_Reject,
     /* 5387 */ // Label 53: @5387
     /* 5387 */ GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(5398), // Rule ID 323 //
     /* 5392 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 5395 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULH'
     /* 5395 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5398 */ // Label 345: @5398
     /* 5398 */ GIM_Reject,
     /* 5399 */ // Label 54: @5399
     /* 5399 */ GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(5410), // Rule ID 324 //
     /* 5404 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 5407 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_UADDSAT'
     /* 5407 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5410 */ // Label 346: @5410
     /* 5410 */ GIM_Reject,
     /* 5411 */ // Label 55: @5411
     /* 5411 */ GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(5422), // Rule ID 325 //
     /* 5416 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 5419 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_SADDSAT'
     /* 5419 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5422 */ // Label 347: @5422
     /* 5422 */ GIM_Reject,
     /* 5423 */ // Label 56: @5423
     /* 5423 */ GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(5434), // Rule ID 204 //
     /* 5428 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 5431 */   // Combiner Rule #150: shift_immed_chain; wip_match_opcode 'G_USHLSAT'
     /* 5431 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 5434 */ // Label 348: @5434
     /* 5434 */ GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(5445), // Rule ID 208 //
     /* 5439 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 5442 */   // Combiner Rule #151: shift_of_shifted_logic_chain; wip_match_opcode 'G_USHLSAT'
     /* 5442 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner93),
     /* 5445 */ // Label 349: @5445
     /* 5445 */ GIM_Reject,
     /* 5446 */ // Label 57: @5446
     /* 5446 */ GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(5457), // Rule ID 203 //
     /* 5451 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 5454 */   // Combiner Rule #150: shift_immed_chain; wip_match_opcode 'G_SSHLSAT'
     /* 5454 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 5457 */ // Label 350: @5457
     /* 5457 */ GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(5468), // Rule ID 209 //
     /* 5462 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 5465 */   // Combiner Rule #151: shift_of_shifted_logic_chain; wip_match_opcode 'G_SSHLSAT'
     /* 5465 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner93),
     /* 5468 */ // Label 351: @5468
     /* 5468 */ GIM_Reject,
     /* 5469 */ // Label 58: @5469
     /* 5469 */ GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(5480), // Rule ID 326 //
     /* 5474 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 5477 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULFIX'
     /* 5477 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5480 */ // Label 352: @5480
     /* 5480 */ GIM_Reject,
     /* 5481 */ // Label 59: @5481
     /* 5481 */ GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(5492), // Rule ID 327 //
     /* 5486 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 5489 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULFIX'
     /* 5489 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5492 */ // Label 353: @5492
     /* 5492 */ GIM_Reject,
     /* 5493 */ // Label 60: @5493
     /* 5493 */ GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(5504), // Rule ID 328 //
     /* 5498 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 5501 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULFIXSAT'
     /* 5501 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5504 */ // Label 354: @5504
     /* 5504 */ GIM_Reject,
     /* 5505 */ // Label 61: @5505
     /* 5505 */ GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(5516), // Rule ID 329 //
     /* 5510 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 5513 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULFIXSAT'
     /* 5513 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5516 */ // Label 355: @5516
     /* 5516 */ GIM_Reject,
     /* 5517 */ // Label 62: @5517
     /* 5517 */ GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(5528), // Rule ID 249 //
     /* 5522 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule167Enabled),
     /* 5525 */   // Combiner Rule #167: constant_fold_fp_binop; wip_match_opcode 'G_FADD'
     /* 5525 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner105),
     /* 5528 */ // Label 356: @5528
     /* 5528 */ GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(5539), // Rule ID 264 //
     /* 5533 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule176Enabled),
     /* 5536 */   // Combiner Rule #176: redundant_neg_operands; wip_match_opcode 'G_FADD'
     /* 5536 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner113),
     /* 5539 */ // Label 357: @5539
     /* 5539 */ GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(5550), // Rule ID 271 //
     /* 5544 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule178Enabled),
     /* 5547 */   // Combiner Rule #178: combine_fadd_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 5547 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner115),
     /* 5550 */ // Label 358: @5550
     /* 5550 */ GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(5561), // Rule ID 272 //
     /* 5555 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule179Enabled),
     /* 5558 */   // Combiner Rule #179: combine_fadd_fpext_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 5558 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner116),
     /* 5561 */ // Label 359: @5561
     /* 5561 */ GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(5572), // Rule ID 273 //
     /* 5566 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule180Enabled),
     /* 5569 */   // Combiner Rule #180: combine_fadd_fma_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 5569 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner117),
     /* 5572 */ // Label 360: @5572
     /* 5572 */ GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(5583), // Rule ID 274 //
     /* 5577 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule181Enabled),
     /* 5580 */   // Combiner Rule #181: combine_fadd_fpext_fma_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 5580 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner118),
     /* 5583 */ // Label 361: @5583
     /* 5583 */ GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(5594), // Rule ID 297 //
     /* 5588 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 5591 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_FADD'
     /* 5591 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 5594 */ // Label 362: @5594
     /* 5594 */ GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(5605), // Rule ID 330 //
     /* 5599 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule192Enabled),
     /* 5602 */   // Combiner Rule #192: commute_fp_constant_to_rhs; wip_match_opcode 'G_FADD'
     /* 5602 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 5605 */ // Label 363: @5605
     /* 5605 */ GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(5628), // Rule ID 138 //
     /* 5610 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule100Enabled),
     /* 5613 */   // MIs[0] dst
     /* 5613 */   // No operand predicates
     /* 5613 */   // MIs[0] x
     /* 5613 */   // No operand predicates
     /* 5613 */   // MIs[0] y
     /* 5613 */   // No operand predicates
     /* 5613 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner3),
     /* 5617 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5622 */   // Combiner Rule #100: right_identity_neg_zero_fp
     /* 5622 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5627 */   GIR_EraseRootFromParent_Done,
     /* 5628 */ // Label 364: @5628
     /* 5628 */ GIM_Reject,
     /* 5629 */ // Label 63: @5629
     /* 5629 */ GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(5640), // Rule ID 250 //
     /* 5634 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule167Enabled),
     /* 5637 */   // Combiner Rule #167: constant_fold_fp_binop; wip_match_opcode 'G_FSUB'
     /* 5637 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner105),
     /* 5640 */ // Label 365: @5640
     /* 5640 */ GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(5651), // Rule ID 265 //
     /* 5645 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule176Enabled),
     /* 5648 */   // Combiner Rule #176: redundant_neg_operands; wip_match_opcode 'G_FSUB'
     /* 5648 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner113),
     /* 5651 */ // Label 366: @5651
     /* 5651 */ GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(5662), // Rule ID 275 //
     /* 5656 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 5659 */   // Combiner Rule #182: combine_fsub_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 5659 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 5662 */ // Label 367: @5662
     /* 5662 */ GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(5673), // Rule ID 276 //
     /* 5667 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule183Enabled),
     /* 5670 */   // Combiner Rule #183: combine_fsub_fneg_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 5670 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner120),
     /* 5673 */ // Label 368: @5673
     /* 5673 */ GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(5684), // Rule ID 277 //
     /* 5678 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 5681 */   // Combiner Rule #184: combine_fsub_fpext_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 5681 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner121),
     /* 5684 */ // Label 369: @5684
     /* 5684 */ GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(5695), // Rule ID 278 //
     /* 5689 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 5692 */   // Combiner Rule #185: combine_fsub_fpext_fneg_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 5692 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 5695 */ // Label 370: @5695
     /* 5695 */ GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(5706), // Rule ID 298 //
     /* 5700 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 5703 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_FSUB'
     /* 5703 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 5706 */ // Label 371: @5706
     /* 5706 */ GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(5717), // Rule ID 308 //
     /* 5711 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5714 */   // Combiner Rule #190: fsub_to_fneg; wip_match_opcode 'G_FSUB'
     /* 5714 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 5717 */ // Label 372: @5717
     /* 5717 */ GIM_Reject,
     /* 5718 */ // Label 64: @5718
     /* 5718 */ GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(5729), // Rule ID 251 //
     /* 5723 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule167Enabled),
     /* 5726 */   // Combiner Rule #167: constant_fold_fp_binop; wip_match_opcode 'G_FMUL'
     /* 5726 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner105),
     /* 5729 */ // Label 373: @5729
     /* 5729 */ GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(5740), // Rule ID 266 //
     /* 5734 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule176Enabled),
     /* 5737 */   // Combiner Rule #176: redundant_neg_operands; wip_match_opcode 'G_FMUL'
     /* 5737 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner113),
     /* 5740 */ // Label 374: @5740
     /* 5740 */ GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(5751), // Rule ID 296 //
     /* 5745 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 5748 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_FMUL'
     /* 5748 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 5751 */ // Label 375: @5751
     /* 5751 */ GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(5762), // Rule ID 331 //
     /* 5756 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule192Enabled),
     /* 5759 */   // Combiner Rule #192: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMUL'
     /* 5759 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 5762 */ // Label 376: @5762
     /* 5762 */ GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(5785), // Rule ID 129 //
     /* 5767 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule93Enabled),
     /* 5770 */   // MIs[0] dst
     /* 5770 */   // No operand predicates
     /* 5770 */   // MIs[0] x
     /* 5770 */   // No operand predicates
     /* 5770 */   // MIs[0] y
     /* 5770 */   // No operand predicates
     /* 5770 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner2),
     /* 5774 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5779 */   // Combiner Rule #93: right_identity_one_fp
     /* 5779 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5784 */   GIR_EraseRootFromParent_Done,
     /* 5785 */ // Label 377: @5785
     /* 5785 */ GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(5805), // Rule ID 139 //
     /* 5790 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule101Enabled),
     /* 5793 */   // MIs[0] dst
     /* 5793 */   // No operand predicates
     /* 5793 */   // MIs[0] x
     /* 5793 */   // No operand predicates
     /* 5793 */   // MIs[0] y
     /* 5793 */   // No operand predicates
     /* 5793 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner4),
     /* 5797 */   // Combiner Rule #101: right_identity_neg_one_fp
     /* 5797 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 5800 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 5802 */   GIR_RootToRootCopy, /*OpIdx*/1, // x
     /* 5804 */   GIR_EraseRootFromParent_Done,
     /* 5805 */ // Label 378: @5805
     /* 5805 */ GIM_Reject,
     /* 5806 */ // Label 65: @5806
     /* 5806 */ GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(5817), // Rule ID 254 //
     /* 5811 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule168Enabled),
     /* 5814 */   // Combiner Rule #168: constant_fold_fma; wip_match_opcode 'G_FMA'
     /* 5814 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner106),
     /* 5817 */ // Label 379: @5817
     /* 5817 */ GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(5828), // Rule ID 269 //
     /* 5822 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule176Enabled),
     /* 5825 */   // Combiner Rule #176: redundant_neg_operands; wip_match_opcode 'G_FMA'
     /* 5825 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner113),
     /* 5828 */ // Label 380: @5828
     /* 5828 */ GIM_Reject,
     /* 5829 */ // Label 66: @5829
     /* 5829 */ GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(5840), // Rule ID 253 //
     /* 5834 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule168Enabled),
     /* 5837 */   // Combiner Rule #168: constant_fold_fma; wip_match_opcode 'G_FMAD'
     /* 5837 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner106),
     /* 5840 */ // Label 381: @5840
     /* 5840 */ GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(5851), // Rule ID 268 //
     /* 5845 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule176Enabled),
     /* 5848 */   // Combiner Rule #176: redundant_neg_operands; wip_match_opcode 'G_FMAD'
     /* 5848 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner113),
     /* 5851 */ // Label 382: @5851
     /* 5851 */ GIM_Reject,
     /* 5852 */ // Label 67: @5852
     /* 5852 */ GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(5863), // Rule ID 252 //
     /* 5857 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule167Enabled),
     /* 5860 */   // Combiner Rule #167: constant_fold_fp_binop; wip_match_opcode 'G_FDIV'
     /* 5860 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner105),
     /* 5863 */ // Label 383: @5863
     /* 5863 */ GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(5874), // Rule ID 267 //
     /* 5868 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule176Enabled),
     /* 5871 */   // Combiner Rule #176: redundant_neg_operands; wip_match_opcode 'G_FDIV'
     /* 5871 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner113),
     /* 5874 */ // Label 384: @5874
     /* 5874 */ GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(5885), // Rule ID 299 //
     /* 5879 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 5882 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_FDIV'
     /* 5882 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 5885 */ // Label 385: @5885
     /* 5885 */ GIM_Reject,
     /* 5886 */ // Label 68: @5886
     /* 5886 */ GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(5897), // Rule ID 300 //
     /* 5891 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 5894 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_FREM'
     /* 5894 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 5897 */ // Label 386: @5897
     /* 5897 */ GIM_Reject,
     /* 5898 */ // Label 69: @5898
     /* 5898 */ GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(5919), // Rule ID 197 //
     /* 5903 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule147Enabled),
     /* 5906 */   // MIs[0] dst
     /* 5906 */   // No operand predicates
     /* 5906 */   // MIs[0] float
     /* 5906 */   // No operand predicates
     /* 5906 */   // MIs[0] int
     /* 5906 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 5910 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 5914 */   // MIs[1] imm
     /* 5914 */   // No operand predicates
     /* 5914 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5916 */   // Combiner Rule #147: expand_const_fpowi
     /* 5916 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner89),
     /* 5919 */ // Label 387: @5919
     /* 5919 */ GIM_Reject,
     /* 5920 */ // Label 70: @5920
     /* 5920 */ GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(5941), // Rule ID 179 //
     /* 5925 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule137Enabled),
     /* 5928 */   // MIs[0] dst
     /* 5928 */   // No operand predicates
     /* 5928 */   // MIs[0] src0
     /* 5928 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5932 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 5936 */   // MIs[1] cst
     /* 5936 */   // No operand predicates
     /* 5936 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5938 */   // Combiner Rule #137: constant_fold_flog2
     /* 5938 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner81),
     /* 5941 */ // Label 388: @5941
     /* 5941 */ GIM_Reject,
     /* 5942 */ // Label 71: @5942
     /* 5942 */ GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(5963), // Rule ID 176 //
     /* 5947 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule134Enabled),
     /* 5950 */   // MIs[0] dst
     /* 5950 */   // No operand predicates
     /* 5950 */   // MIs[0] src0
     /* 5950 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5954 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 5958 */   // MIs[1] cst
     /* 5958 */   // No operand predicates
     /* 5958 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5960 */   // Combiner Rule #134: constant_fold_fneg
     /* 5960 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner81),
     /* 5963 */ // Label 389: @5963
     /* 5963 */ GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(5992), // Rule ID 127 //
     /* 5968 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule91Enabled),
     /* 5971 */   // MIs[0] dst
     /* 5971 */   // No operand predicates
     /* 5971 */   // MIs[0] t
     /* 5971 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5975 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 5979 */   // MIs[1] src
     /* 5979 */   // No operand predicates
     /* 5979 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 5984 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5986 */   // Combiner Rule #91: fneg_fneg_fold
     /* 5986 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 5991 */   GIR_EraseRootFromParent_Done,
     /* 5992 */ // Label 390: @5992
     /* 5992 */ GIM_Reject,
     /* 5993 */ // Label 72: @5993
     /* 5993 */ GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(6014), // Rule ID 180 //
     /* 5998 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule138Enabled),
     /* 6001 */   // MIs[0] dst
     /* 6001 */   // No operand predicates
     /* 6001 */   // MIs[0] src0
     /* 6001 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6005 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 6009 */   // MIs[1] cst
     /* 6009 */   // No operand predicates
     /* 6009 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6011 */   // Combiner Rule #138: constant_fold_fptrunc
     /* 6011 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner81),
     /* 6014 */ // Label 391: @6014
     /* 6014 */ GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(6035), // Rule ID 137 //
     /* 6019 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule99Enabled),
     /* 6022 */   // MIs[0] dst
     /* 6022 */   // No operand predicates
     /* 6022 */   // MIs[0] src1
     /* 6022 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6026 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPEXT),
     /* 6030 */   // MIs[1] src0
     /* 6030 */   // No operand predicates
     /* 6030 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6032 */   // Combiner Rule #99: fptrunc_fpext_fold
     /* 6032 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner52),
     /* 6035 */ // Label 392: @6035
     /* 6035 */ GIM_Reject,
     /* 6036 */ // Label 73: @6036
     /* 6036 */ GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(6057), // Rule ID 92 //
     /* 6041 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 6044 */   // MIs[0] dst
     /* 6044 */   // No operand predicates
     /* 6044 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 6044 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6048 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6052 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6054 */   // Combiner Rule #77: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[5]]
     /* 6054 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 6057 */ // Label 393: @6057
     /* 6057 */ GIM_Reject,
     /* 6058 */ // Label 74: @6058
     /* 6058 */ GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(6079), // Rule ID 93 //
     /* 6063 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 6066 */   // MIs[0] dst
     /* 6066 */   // No operand predicates
     /* 6066 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 6066 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6070 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6074 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6076 */   // Combiner Rule #77: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[6]]
     /* 6076 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 6079 */ // Label 394: @6079
     /* 6079 */ GIM_Reject,
     /* 6080 */ // Label 75: @6080
     /* 6080 */ GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(6091), // Rule ID 76 //
     /* 6085 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule71Enabled),
     /* 6088 */   // Combiner Rule #71: undef_to_fp_zero; wip_match_opcode 'G_SITOFP'
     /* 6088 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner33),
     /* 6091 */ // Label 395: @6091
     /* 6091 */ GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(6106), // Rule ID 181 //
     /* 6096 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule139Enabled),
     /* 6099 */   // MIs[0] dst
     /* 6099 */   // No operand predicates
     /* 6099 */   // MIs[0] Operand 1
     /* 6099 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 6103 */   // Combiner Rule #139: itof_const_zero_fold_si
     /* 6103 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner82),
     /* 6106 */ // Label 396: @6106
     /* 6106 */ GIM_Reject,
     /* 6107 */ // Label 76: @6107
     /* 6107 */ GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(6118), // Rule ID 75 //
     /* 6112 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule71Enabled),
     /* 6115 */   // Combiner Rule #71: undef_to_fp_zero; wip_match_opcode 'G_UITOFP'
     /* 6115 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner33),
     /* 6118 */ // Label 397: @6118
     /* 6118 */ GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(6133), // Rule ID 182 //
     /* 6123 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule140Enabled),
     /* 6126 */   // MIs[0] dst
     /* 6126 */   // No operand predicates
     /* 6126 */   // MIs[0] Operand 1
     /* 6126 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 6130 */   // Combiner Rule #140: itof_const_zero_fold_ui
     /* 6130 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner82),
     /* 6133 */ // Label 398: @6133
     /* 6133 */ GIM_Reject,
     /* 6134 */ // Label 77: @6134
     /* 6134 */ GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(6163), // Rule ID 19 //
     /* 6139 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule18Enabled),
     /* 6142 */   // MIs[0] dst
     /* 6142 */   // No operand predicates
     /* 6142 */   // MIs[0] src
     /* 6142 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6146 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 6150 */   // MIs[1] __idempotent_prop_match_0.x
     /* 6150 */   // No operand predicates
     /* 6150 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6155 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6157 */   // Combiner Rule #18: idempotent_prop @ [__idempotent_prop_match_0[1]]
     /* 6157 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6162 */   GIR_EraseRootFromParent_Done,
     /* 6163 */ // Label 399: @6163
     /* 6163 */ GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(6184), // Rule ID 177 //
     /* 6168 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule135Enabled),
     /* 6171 */   // MIs[0] dst
     /* 6171 */   // No operand predicates
     /* 6171 */   // MIs[0] src0
     /* 6171 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6175 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 6179 */   // MIs[1] cst
     /* 6179 */   // No operand predicates
     /* 6179 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6181 */   // Combiner Rule #135: constant_fold_fabs
     /* 6181 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner81),
     /* 6184 */ // Label 400: @6184
     /* 6184 */ GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(6212), // Rule ID 258 //
     /* 6189 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule170Enabled),
     /* 6192 */   // MIs[0] dst
     /* 6192 */   // No operand predicates
     /* 6192 */   // MIs[0] tmp
     /* 6192 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6196 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 6200 */   // MIs[1] x
     /* 6200 */   // No operand predicates
     /* 6200 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6202 */   // Combiner Rule #170: fabs_fneg_fold
     /* 6202 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_FABS),
     /* 6205 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 6207 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // x
     /* 6211 */   GIR_EraseRootFromParent_Done,
     /* 6212 */ // Label 401: @6212
     /* 6212 */ GIM_Reject,
     /* 6213 */ // Label 78: @6213
     /* 6213 */ GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(6242), // Rule ID 20 //
     /* 6218 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule18Enabled),
     /* 6221 */   // MIs[0] dst
     /* 6221 */   // No operand predicates
     /* 6221 */   // MIs[0] src
     /* 6221 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6225 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 6229 */   // MIs[1] __idempotent_prop_match_0.x
     /* 6229 */   // No operand predicates
     /* 6229 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6234 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6236 */   // Combiner Rule #18: idempotent_prop @ [__idempotent_prop_match_0[2]]
     /* 6236 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6241 */   GIR_EraseRootFromParent_Done,
     /* 6242 */ // Label 402: @6242
     /* 6242 */ GIM_Reject,
     /* 6243 */ // Label 79: @6243
     /* 6243 */ GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(6254), // Rule ID 193 //
     /* 6248 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule146Enabled),
     /* 6251 */   // Combiner Rule #146: combine_minmax_nan; wip_match_opcode 'G_FMINNUM'
     /* 6251 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner88),
     /* 6254 */ // Label 403: @6254
     /* 6254 */ GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(6265), // Rule ID 301 //
     /* 6259 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 6262 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_FMINNUM'
     /* 6262 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 6265 */ // Label 404: @6265
     /* 6265 */ GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(6276), // Rule ID 332 //
     /* 6270 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule192Enabled),
     /* 6273 */   // Combiner Rule #192: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINNUM'
     /* 6273 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 6276 */ // Label 405: @6276
     /* 6276 */ GIM_Reject,
     /* 6277 */ // Label 80: @6277
     /* 6277 */ GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(6288), // Rule ID 194 //
     /* 6282 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule146Enabled),
     /* 6285 */   // Combiner Rule #146: combine_minmax_nan; wip_match_opcode 'G_FMAXNUM'
     /* 6285 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner88),
     /* 6288 */ // Label 406: @6288
     /* 6288 */ GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(6299), // Rule ID 302 //
     /* 6293 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 6296 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_FMAXNUM'
     /* 6296 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 6299 */ // Label 407: @6299
     /* 6299 */ GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(6310), // Rule ID 333 //
     /* 6304 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule192Enabled),
     /* 6307 */   // Combiner Rule #192: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXNUM'
     /* 6307 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 6310 */ // Label 408: @6310
     /* 6310 */ GIM_Reject,
     /* 6311 */ // Label 81: @6311
     /* 6311 */ GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(6322), // Rule ID 334 //
     /* 6316 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule192Enabled),
     /* 6319 */   // Combiner Rule #192: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINNUM_IEEE'
     /* 6319 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 6322 */ // Label 409: @6322
     /* 6322 */ GIM_Reject,
     /* 6323 */ // Label 82: @6323
     /* 6323 */ GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(6334), // Rule ID 335 //
     /* 6328 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule192Enabled),
     /* 6331 */   // Combiner Rule #192: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXNUM_IEEE'
     /* 6331 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 6334 */ // Label 410: @6334
     /* 6334 */ GIM_Reject,
     /* 6335 */ // Label 83: @6335
     /* 6335 */ GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(6346), // Rule ID 195 //
     /* 6340 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule146Enabled),
     /* 6343 */   // Combiner Rule #146: combine_minmax_nan; wip_match_opcode 'G_FMINIMUM'
     /* 6343 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner88),
     /* 6346 */ // Label 411: @6346
     /* 6346 */ GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(6357), // Rule ID 303 //
     /* 6351 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 6354 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_FMINIMUM'
     /* 6354 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 6357 */ // Label 412: @6357
     /* 6357 */ GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(6368), // Rule ID 336 //
     /* 6362 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule192Enabled),
     /* 6365 */   // Combiner Rule #192: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINIMUM'
     /* 6365 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 6368 */ // Label 413: @6368
     /* 6368 */ GIM_Reject,
     /* 6369 */ // Label 84: @6369
     /* 6369 */ GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(6380), // Rule ID 196 //
     /* 6374 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule146Enabled),
     /* 6377 */   // Combiner Rule #146: combine_minmax_nan; wip_match_opcode 'G_FMAXIMUM'
     /* 6377 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner88),
     /* 6380 */ // Label 414: @6380
     /* 6380 */ GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(6391), // Rule ID 304 //
     /* 6385 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 6388 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_FMAXIMUM'
     /* 6388 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 6391 */ // Label 415: @6391
     /* 6391 */ GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(6402), // Rule ID 337 //
     /* 6396 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule192Enabled),
     /* 6399 */   // Combiner Rule #192: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXIMUM'
     /* 6399 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 6402 */ // Label 416: @6402
     /* 6402 */ GIM_Reject,
     /* 6403 */ // Label 85: @6403
     /* 6403 */ GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(6414), // Rule ID 148 //
     /* 6408 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule106Enabled),
     /* 6411 */   // Combiner Rule #106: reassoc_ptradd; wip_match_opcode 'G_PTR_ADD'
     /* 6411 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner57),
     /* 6414 */ // Label 417: @6414
     /* 6414 */ GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(6425), // Rule ID 150 //
     /* 6419 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule108Enabled),
     /* 6422 */   // Combiner Rule #108: ptr_add_immed_chain; wip_match_opcode 'G_PTR_ADD'
     /* 6422 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner59),
     /* 6425 */ // Label 418: @6425
     /* 6425 */ GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(6436), // Rule ID 183 //
     /* 6430 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule141Enabled),
     /* 6433 */   // Combiner Rule #141: const_ptradd_to_i2p; wip_match_opcode 'G_PTR_ADD'
     /* 6433 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner83),
     /* 6436 */ // Label 419: @6436
     /* 6436 */ GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(6447), // Rule ID 199 //
     /* 6441 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule149Enabled),
     /* 6444 */   // Combiner Rule #149: ptr_add_with_zero; wip_match_opcode 'G_PTR_ADD'
     /* 6444 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner91),
     /* 6447 */ // Label 420: @6447
     /* 6447 */ GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(6458), // Rule ID 232 //
     /* 6452 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 6455 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_PTR_ADD'
     /* 6455 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 6458 */ // Label 421: @6458
     /* 6458 */ GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(6469), // Rule ID 281 //
     /* 6463 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 6466 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_PTR_ADD'
     /* 6466 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 6469 */ // Label 422: @6469
     /* 6469 */ GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(6492), // Rule ID 111 //
     /* 6474 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 6477 */   // MIs[0] dst
     /* 6477 */   // No operand predicates
     /* 6477 */   // MIs[0] lhs
     /* 6477 */   // No operand predicates
     /* 6477 */   // MIs[0] Operand 2
     /* 6477 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 6481 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6486 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[7]]
     /* 6486 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6491 */   GIR_EraseRootFromParent_Done,
     /* 6492 */ // Label 423: @6492
     /* 6492 */ GIM_Reject,
     /* 6493 */ // Label 86: @6493
     /* 6493 */ GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(6504), // Rule ID 245 //
     /* 6498 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 6501 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_SMIN'
     /* 6501 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 6504 */ // Label 424: @6504
     /* 6504 */ GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(6515), // Rule ID 292 //
     /* 6509 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 6512 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_SMIN'
     /* 6512 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 6515 */ // Label 425: @6515
     /* 6515 */ GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(6526), // Rule ID 314 //
     /* 6520 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 6523 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_SMIN'
     /* 6523 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 6526 */ // Label 426: @6526
     /* 6526 */ GIM_Reject,
     /* 6527 */ // Label 87: @6527
     /* 6527 */ GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(6538), // Rule ID 246 //
     /* 6532 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 6535 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_SMAX'
     /* 6535 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 6538 */ // Label 427: @6538
     /* 6538 */ GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(6549), // Rule ID 293 //
     /* 6543 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 6546 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_SMAX'
     /* 6546 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 6549 */ // Label 428: @6549
     /* 6549 */ GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(6560), // Rule ID 315 //
     /* 6554 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 6557 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_SMAX'
     /* 6557 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 6560 */ // Label 429: @6560
     /* 6560 */ GIM_Reject,
     /* 6561 */ // Label 88: @6561
     /* 6561 */ GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(6572), // Rule ID 247 //
     /* 6566 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 6569 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_UMIN'
     /* 6569 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 6572 */ // Label 430: @6572
     /* 6572 */ GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(6583), // Rule ID 294 //
     /* 6577 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 6580 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_UMIN'
     /* 6580 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 6583 */ // Label 431: @6583
     /* 6583 */ GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(6594), // Rule ID 316 //
     /* 6588 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 6591 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_UMIN'
     /* 6591 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 6594 */ // Label 432: @6594
     /* 6594 */ GIM_Reject,
     /* 6595 */ // Label 89: @6595
     /* 6595 */ GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(6606), // Rule ID 248 //
     /* 6600 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 6603 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_UMAX'
     /* 6603 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 6606 */ // Label 433: @6606
     /* 6606 */ GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(6617), // Rule ID 295 //
     /* 6611 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 6614 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_UMAX'
     /* 6614 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 6617 */ // Label 434: @6617
     /* 6617 */ GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(6628), // Rule ID 317 //
     /* 6622 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 6625 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_UMAX'
     /* 6625 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 6628 */ // Label 435: @6628
     /* 6628 */ GIM_Reject,
     /* 6629 */ // Label 90: @6629
     /* 6629 */ GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(6640), // Rule ID 86 //
     /* 6634 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 6637 */   // Combiner Rule #76: unary_undef_to_zero; wip_match_opcode 'G_ABS'
     /* 6637 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner36),
     /* 6640 */ // Label 436: @6640
     /* 6640 */ GIM_Reject,
     /* 6641 */ // Label 91: @6641
     /* 6641 */ GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(6652), // Rule ID 175 //
     /* 6646 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule133Enabled),
     /* 6649 */   // Combiner Rule #133: opt_brcond_by_inverting_cond; wip_match_opcode 'G_BR'
     /* 6649 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner80),
     /* 6652 */ // Label 437: @6652
     /* 6652 */ GIM_Reject,
     /* 6653 */ // Label 92: @6653
     /* 6653 */ GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(6664), // Rule ID 26 //
     /* 6658 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 6661 */   // Combiner Rule #24: insert_vector_elt_oob; wip_match_opcode 'G_INSERT_VECTOR_ELT'
     /* 6661 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner10),
     /* 6664 */ // Label 438: @6664
     /* 6664 */ GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(6675), // Rule ID 67 //
     /* 6669 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule65Enabled),
     /* 6672 */   // Combiner Rule #65: combine_insert_vec_elts_build_vector; wip_match_opcode 'G_INSERT_VECTOR_ELT'
     /* 6672 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner27),
     /* 6675 */ // Label 439: @6675
     /* 6675 */ GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(6686), // Rule ID 101 //
     /* 6680 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule82Enabled),
     /* 6683 */   // Combiner Rule #82: insert_extract_vec_elt_out_of_bounds; wip_match_opcode 'G_INSERT_VECTOR_ELT'
     /* 6683 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner43),
     /* 6686 */ // Label 440: @6686
     /* 6686 */ GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(6725), // Rule ID 38 //
     /* 6691 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule36Enabled),
     /* 6694 */   // MIs[0] root
     /* 6694 */   // No operand predicates
     /* 6694 */   // MIs[0] src
     /* 6694 */   // No operand predicates
     /* 6694 */   // MIs[0] elt
     /* 6694 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 6698 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 6702 */   // MIs[1] src
     /* 6702 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 6707 */   // MIs[1] idx
     /* 6707 */   // No operand predicates
     /* 6707 */   // MIs[0] idx
     /* 6707 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 6712 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6717 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6719 */   // Combiner Rule #36: insert_vector_element_extract_vector_element
     /* 6719 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6724 */   GIR_EraseRootFromParent_Done,
     /* 6725 */ // Label 441: @6725
     /* 6725 */ GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(6758), // Rule ID 24 //
     /* 6730 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule22Enabled),
     /* 6733 */   // MIs[0] root
     /* 6733 */   // No operand predicates
     /* 6733 */   // MIs[0] src
     /* 6733 */   // No operand predicates
     /* 6733 */   // MIs[0] elt
     /* 6733 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 6737 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6741 */   // MIs[0] idx
     /* 6741 */   // No operand predicates
     /* 6741 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner0),
     /* 6745 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6750 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6752 */   // Combiner Rule #22: insert_vector_element_elt_undef
     /* 6752 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6757 */   GIR_EraseRootFromParent_Done,
     /* 6758 */ // Label 442: @6758
     /* 6758 */ GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(6782), // Rule ID 23 //
     /* 6763 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule21Enabled),
     /* 6766 */   // MIs[0] root
     /* 6766 */   // No operand predicates
     /* 6766 */   // MIs[0] src
     /* 6766 */   // No operand predicates
     /* 6766 */   // MIs[0] elt
     /* 6766 */   // No operand predicates
     /* 6766 */   // MIs[0] idx
     /* 6766 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 6770 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6774 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6776 */   // Combiner Rule #21: insert_vector_element_idx_undef
     /* 6776 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6779 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 6781 */   GIR_EraseRootFromParent_Done,
     /* 6782 */ // Label 443: @6782
     /* 6782 */ GIM_Reject,
     /* 6783 */ // Label 93: @6783
     /* 6783 */ GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(6794), // Rule ID 25 //
     /* 6788 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule23Enabled),
     /* 6791 */   // Combiner Rule #23: match_extract_of_element; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 6791 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner9),
     /* 6794 */ // Label 444: @6794
     /* 6794 */ GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(6805), // Rule ID 68 //
     /* 6799 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule66Enabled),
     /* 6802 */   // Combiner Rule #66: extract_vec_elt_build_vec; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 6802 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner28),
     /* 6805 */ // Label 445: @6805
     /* 6805 */ GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(6816), // Rule ID 74 //
     /* 6810 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule70Enabled),
     /* 6813 */   // Combiner Rule #70: combine_extracted_vector_load; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 6813 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner32),
     /* 6816 */ // Label 446: @6816
     /* 6816 */ GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(6827), // Rule ID 102 //
     /* 6821 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule82Enabled),
     /* 6824 */   // Combiner Rule #82: insert_extract_vec_elt_out_of_bounds; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 6824 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner43),
     /* 6827 */ // Label 447: @6827
     /* 6827 */ GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(6851), // Rule ID 36 //
     /* 6832 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule34Enabled),
     /* 6835 */   // MIs[0] root
     /* 6835 */   // No operand predicates
     /* 6835 */   // MIs[0] src
     /* 6835 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6839 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6843 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/9,
     /* 6846 */   // MIs[1] x
     /* 6846 */   // No operand predicates
     /* 6846 */   // MIs[1] y
     /* 6846 */   // No operand predicates
     /* 6846 */   // MIs[1] z
     /* 6846 */   // No operand predicates
     /* 6846 */   // MIs[1] a
     /* 6846 */   // No operand predicates
     /* 6846 */   // MIs[1] b
     /* 6846 */   // No operand predicates
     /* 6846 */   // MIs[1] c
     /* 6846 */   // No operand predicates
     /* 6846 */   // MIs[1] d
     /* 6846 */   // No operand predicates
     /* 6846 */   // MIs[1] e
     /* 6846 */   // No operand predicates
     /* 6846 */   // MIs[0] idx
     /* 6846 */   // No operand predicates
     /* 6846 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6848 */   // Combiner Rule #34: extract_vector_element_build_vector_trunc8
     /* 6848 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6851 */ // Label 448: @6851
     /* 6851 */ GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(6875), // Rule ID 35 //
     /* 6856 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule33Enabled),
     /* 6859 */   // MIs[0] root
     /* 6859 */   // No operand predicates
     /* 6859 */   // MIs[0] src
     /* 6859 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6863 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6867 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/8,
     /* 6870 */   // MIs[1] x
     /* 6870 */   // No operand predicates
     /* 6870 */   // MIs[1] y
     /* 6870 */   // No operand predicates
     /* 6870 */   // MIs[1] z
     /* 6870 */   // No operand predicates
     /* 6870 */   // MIs[1] a
     /* 6870 */   // No operand predicates
     /* 6870 */   // MIs[1] b
     /* 6870 */   // No operand predicates
     /* 6870 */   // MIs[1] c
     /* 6870 */   // No operand predicates
     /* 6870 */   // MIs[1] d
     /* 6870 */   // No operand predicates
     /* 6870 */   // MIs[0] idx
     /* 6870 */   // No operand predicates
     /* 6870 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6872 */   // Combiner Rule #33: extract_vector_element_build_vector_trunc7
     /* 6872 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6875 */ // Label 449: @6875
     /* 6875 */ GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(6899), // Rule ID 34 //
     /* 6880 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule32Enabled),
     /* 6883 */   // MIs[0] root
     /* 6883 */   // No operand predicates
     /* 6883 */   // MIs[0] src
     /* 6883 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6887 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6891 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/7,
     /* 6894 */   // MIs[1] x
     /* 6894 */   // No operand predicates
     /* 6894 */   // MIs[1] y
     /* 6894 */   // No operand predicates
     /* 6894 */   // MIs[1] z
     /* 6894 */   // No operand predicates
     /* 6894 */   // MIs[1] a
     /* 6894 */   // No operand predicates
     /* 6894 */   // MIs[1] b
     /* 6894 */   // No operand predicates
     /* 6894 */   // MIs[1] c
     /* 6894 */   // No operand predicates
     /* 6894 */   // MIs[0] idx
     /* 6894 */   // No operand predicates
     /* 6894 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6896 */   // Combiner Rule #32: extract_vector_element_build_vector_trunc6
     /* 6896 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6899 */ // Label 450: @6899
     /* 6899 */ GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(6923), // Rule ID 33 //
     /* 6904 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule31Enabled),
     /* 6907 */   // MIs[0] root
     /* 6907 */   // No operand predicates
     /* 6907 */   // MIs[0] src
     /* 6907 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6911 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6915 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/6,
     /* 6918 */   // MIs[1] x
     /* 6918 */   // No operand predicates
     /* 6918 */   // MIs[1] y
     /* 6918 */   // No operand predicates
     /* 6918 */   // MIs[1] z
     /* 6918 */   // No operand predicates
     /* 6918 */   // MIs[1] a
     /* 6918 */   // No operand predicates
     /* 6918 */   // MIs[1] b
     /* 6918 */   // No operand predicates
     /* 6918 */   // MIs[0] idx
     /* 6918 */   // No operand predicates
     /* 6918 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6920 */   // Combiner Rule #31: extract_vector_element_build_vector_trunc5
     /* 6920 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6923 */ // Label 451: @6923
     /* 6923 */ GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(6947), // Rule ID 32 //
     /* 6928 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule30Enabled),
     /* 6931 */   // MIs[0] root
     /* 6931 */   // No operand predicates
     /* 6931 */   // MIs[0] src
     /* 6931 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6935 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6939 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/5,
     /* 6942 */   // MIs[1] x
     /* 6942 */   // No operand predicates
     /* 6942 */   // MIs[1] y
     /* 6942 */   // No operand predicates
     /* 6942 */   // MIs[1] z
     /* 6942 */   // No operand predicates
     /* 6942 */   // MIs[1] a
     /* 6942 */   // No operand predicates
     /* 6942 */   // MIs[0] idx
     /* 6942 */   // No operand predicates
     /* 6942 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6944 */   // Combiner Rule #30: extract_vector_element_build_vector_trunc4
     /* 6944 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6947 */ // Label 452: @6947
     /* 6947 */ GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(6971), // Rule ID 31 //
     /* 6952 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule29Enabled),
     /* 6955 */   // MIs[0] root
     /* 6955 */   // No operand predicates
     /* 6955 */   // MIs[0] src
     /* 6955 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6959 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6963 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 6966 */   // MIs[1] x
     /* 6966 */   // No operand predicates
     /* 6966 */   // MIs[1] y
     /* 6966 */   // No operand predicates
     /* 6966 */   // MIs[1] z
     /* 6966 */   // No operand predicates
     /* 6966 */   // MIs[0] idx
     /* 6966 */   // No operand predicates
     /* 6966 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6968 */   // Combiner Rule #29: extract_vector_element_build_vector_trunc3
     /* 6968 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6971 */ // Label 453: @6971
     /* 6971 */ GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(7005), // Rule ID 27 //
     /* 6976 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule25Enabled),
     /* 6979 */   // MIs[0] root
     /* 6979 */   // No operand predicates
     /* 6979 */   // MIs[0] src
     /* 6979 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6983 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INSERT_VECTOR_ELT),
     /* 6987 */   // MIs[1] x
     /* 6987 */   // No operand predicates
     /* 6987 */   // MIs[1] value
     /* 6987 */   // No operand predicates
     /* 6987 */   // MIs[1] idx
     /* 6987 */   // No operand predicates
     /* 6987 */   // MIs[0] idx
     /* 6987 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/3,
     /* 6992 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/2,
     /* 6997 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6999 */   // Combiner Rule #25: extract_vector_element_not_const
     /* 6999 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/2,
     /* 7004 */   GIR_EraseRootFromParent_Done,
     /* 7005 */ // Label 454: @7005
     /* 7005 */ GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(7026), // Rule ID 28 //
     /* 7010 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule26Enabled),
     /* 7013 */   // MIs[0] root
     /* 7013 */   // No operand predicates
     /* 7013 */   // MIs[0] src
     /* 7013 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 7017 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INSERT_VECTOR_ELT),
     /* 7021 */   // MIs[1] x
     /* 7021 */   // No operand predicates
     /* 7021 */   // MIs[1] value
     /* 7021 */   // No operand predicates
     /* 7021 */   // MIs[1] idx2
     /* 7021 */   // No operand predicates
     /* 7021 */   // MIs[0] idx1
     /* 7021 */   // No operand predicates
     /* 7021 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 7023 */   // Combiner Rule #26: extract_vector_element_different_indices
     /* 7023 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner11),
     /* 7026 */ // Label 455: @7026
     /* 7026 */ GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(7055), // Rule ID 37 //
     /* 7031 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule35Enabled),
     /* 7034 */   // MIs[0] root
     /* 7034 */   // No operand predicates
     /* 7034 */   // MIs[0] src
     /* 7034 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 7038 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHUFFLE_VECTOR),
     /* 7042 */   // MIs[1] src1
     /* 7042 */   // No operand predicates
     /* 7042 */   // MIs[1] src2
     /* 7042 */   // No operand predicates
     /* 7042 */   // MIs[1] mask
     /* 7042 */   // No operand predicates
     /* 7042 */   // MIs[0] idx
     /* 7042 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 7046 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 7050 */   // MIs[2] imm
     /* 7050 */   // No operand predicates
     /* 7050 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 7052 */   // Combiner Rule #35: extract_vector_element_shuffle_vector
     /* 7052 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 7055 */ // Label 456: @7055
     /* 7055 */ GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(7079), // Rule ID 30 //
     /* 7060 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule28Enabled),
     /* 7063 */   // MIs[0] root
     /* 7063 */   // No operand predicates
     /* 7063 */   // MIs[0] src
     /* 7063 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 7067 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 7071 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 7074 */   // MIs[1] x
     /* 7074 */   // No operand predicates
     /* 7074 */   // MIs[1] y
     /* 7074 */   // No operand predicates
     /* 7074 */   // MIs[0] idx
     /* 7074 */   // No operand predicates
     /* 7074 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 7076 */   // Combiner Rule #28: extract_vector_element_build_vector_trunc2
     /* 7076 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 7079 */ // Label 457: @7079
     /* 7079 */ GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(7111), // Rule ID 29 //
     /* 7084 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule27Enabled),
     /* 7087 */   // MIs[0] root
     /* 7087 */   // No operand predicates
     /* 7087 */   // MIs[0] src
     /* 7087 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 7091 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 7095 */   GIM_CheckNumOperandsGE, /*MI*/1, /*Expected*/2,
     /* 7098 */   // MIs[1] unused
     /* 7098 */   // No operand predicates
     /* 7098 */   // MIs[0] idx
     /* 7098 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 7102 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 7106 */   // MIs[2] imm
     /* 7106 */   // No operand predicates
     /* 7106 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 7108 */   // Combiner Rule #27: extract_vector_element_build_vector
     /* 7108 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner12),
     /* 7111 */ // Label 458: @7111
     /* 7111 */ GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(7135), // Rule ID 21 //
     /* 7116 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule19Enabled),
     /* 7119 */   // MIs[0] root
     /* 7119 */   // No operand predicates
     /* 7119 */   // MIs[0] vector
     /* 7119 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 7123 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 7127 */   // MIs[0] idx
     /* 7127 */   // No operand predicates
     /* 7127 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 7129 */   // Combiner Rule #19: match_extract_of_element_undef_vector
     /* 7129 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 7132 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 7134 */   GIR_EraseRootFromParent_Done,
     /* 7135 */ // Label 459: @7135
     /* 7135 */ GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(7159), // Rule ID 22 //
     /* 7140 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule20Enabled),
     /* 7143 */   // MIs[0] root
     /* 7143 */   // No operand predicates
     /* 7143 */   // MIs[0] vector
     /* 7143 */   // No operand predicates
     /* 7143 */   // MIs[0] idx
     /* 7143 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 7147 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 7151 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 7153 */   // Combiner Rule #20: match_extract_of_element_undef_index
     /* 7153 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 7156 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 7158 */   GIR_EraseRootFromParent_Done,
     /* 7159 */ // Label 460: @7159
     /* 7159 */ GIM_Reject,
     /* 7160 */ // Label 94: @7160
     /* 7160 */ GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(7171), // Rule ID 97 //
     /* 7165 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule79Enabled),
     /* 7168 */   // Combiner Rule #79: propagate_undef_all_ops; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 7168 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner40),
     /* 7171 */ // Label 461: @7171
     /* 7171 */ GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(7182), // Rule ID 99 //
     /* 7176 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule80Enabled),
     /* 7179 */   // Combiner Rule #80: propagate_undef_shuffle_mask; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 7179 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner41),
     /* 7182 */ // Label 462: @7182
     /* 7182 */ GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(7193), // Rule ID 345 //
     /* 7187 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule200Enabled),
     /* 7190 */   // Combiner Rule #200: combine_shuffle_concat; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 7190 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner136),
     /* 7193 */ // Label 463: @7193
     /* 7193 */ GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(7204), // Rule ID 347 //
     /* 7198 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule202Enabled),
     /* 7201 */   // Combiner Rule #202: combine_shuffle_disjoint_mask; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 7201 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner138),
     /* 7204 */ // Label 464: @7204
     /* 7204 */ GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(7215), // Rule ID 365 //
     /* 7209 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule218Enabled),
     /* 7212 */   // Combiner Rule #218: shuffle_to_extract; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 7212 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner154),
     /* 7215 */ // Label 465: @7215
     /* 7215 */ GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(7236), // Rule ID 346 //
     /* 7220 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule201Enabled),
     /* 7223 */   // MIs[0] root
     /* 7223 */   // No operand predicates
     /* 7223 */   // MIs[0] src1
     /* 7223 */   // No operand predicates
     /* 7223 */   // MIs[0] undef
     /* 7223 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 7227 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 7231 */   // MIs[0] mask
     /* 7231 */   // No operand predicates
     /* 7231 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 7233 */   // Combiner Rule #201: combine_shuffle_undef_rhs
     /* 7233 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner137),
     /* 7236 */ // Label 466: @7236
     /* 7236 */ GIM_Reject,
     /* 7237 */ // Label 95: @7237
     /* 7237 */ GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(7281), // Rule ID 223 //
     /* 7242 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule160Enabled),
     /* 7245 */   // MIs[0] d
     /* 7245 */   // No operand predicates
     /* 7245 */   // MIs[0] src
     /* 7245 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 7249 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 7253 */   // MIs[1] rev
     /* 7253 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 7257 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITREVERSE),
     /* 7261 */   // MIs[2] val
     /* 7261 */   // No operand predicates
     /* 7261 */   // MIs[1] amt
     /* 7261 */   // No operand predicates
     /* 7261 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner9),
     /* 7265 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 7267 */   // Combiner Rule #160: bitreverse_lshr
     /* 7267 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SHL),
     /* 7270 */   GIR_RootToRootCopy, /*OpIdx*/0, // d
     /* 7272 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 7276 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // amt
     /* 7280 */   GIR_EraseRootFromParent_Done,
     /* 7281 */ // Label 467: @7281
     /* 7281 */ GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(7325), // Rule ID 222 //
     /* 7286 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule159Enabled),
     /* 7289 */   // MIs[0] d
     /* 7289 */   // No operand predicates
     /* 7289 */   // MIs[0] src
     /* 7289 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 7293 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 7297 */   // MIs[1] rev
     /* 7297 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 7301 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITREVERSE),
     /* 7305 */   // MIs[2] val
     /* 7305 */   // No operand predicates
     /* 7305 */   // MIs[1] amt
     /* 7305 */   // No operand predicates
     /* 7305 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner8),
     /* 7309 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 7311 */   // Combiner Rule #159: bitreverse_shl
     /* 7311 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 7314 */   GIR_RootToRootCopy, /*OpIdx*/0, // d
     /* 7316 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 7320 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // amt
     /* 7324 */   GIR_EraseRootFromParent_Done,
     /* 7325 */ // Label 468: @7325
     /* 7325 */ GIM_Reject,
     /* 7326 */ // Label 96: @7326
     /* 7326 */ GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(7347), // Rule ID 178 //
     /* 7331 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule136Enabled),
     /* 7334 */   // MIs[0] dst
     /* 7334 */   // No operand predicates
     /* 7334 */   // MIs[0] src0
     /* 7334 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 7338 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 7342 */   // MIs[1] cst
     /* 7342 */   // No operand predicates
     /* 7342 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 7344 */   // Combiner Rule #136: constant_fold_fsqrt
     /* 7344 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner81),
     /* 7347 */ // Label 469: @7347
     /* 7347 */ GIM_Reject,
     /* 7348 */ // Label 97: @7348
     /* 7348 */ GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(7362), // Rule ID 366 //
     /* 7353 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 7356 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule219Enabled),
     /* 7359 */   // Combiner Rule #219: ext_addv_to_udot_addv; wip_match_opcode 'G_VECREDUCE_ADD'
     /* 7359 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner155),
     /* 7362 */ // Label 470: @7362
     /* 7362 */ GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(7373), // Rule ID 367 //
     /* 7367 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule220Enabled),
     /* 7370 */   // Combiner Rule #220: ext_uaddv_to_uaddlv; wip_match_opcode 'G_VECREDUCE_ADD'
     /* 7370 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner156),
     /* 7373 */ // Label 471: @7373
     /* 7373 */ GIM_Reject,
     /* 7374 */ // Label 98: @7374
     /* 7374 */ GIM_Reject,
     /* 7375 */ }; // Size: 7375 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GICOMBINER_IMPL

#ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
#ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
, State(0),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GICOMBINER_CONSTRUCTOR_INITS

