/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the PPC target                             *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 41;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(PPCInstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(PPCInstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static PPCInstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static PPCInstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testMOPredicate_MO(unsigned PredicateID, const MachineOperand &MO, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(0),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s1,
  GILLT_s32,
  GILLT_s64,
  GILLT_s128,
  GILLT_v2s64,
  GILLT_v4s32,
  GILLT_v8s16,
  GILLT_v16s8,
  GILLT_v256s1,
  GILLT_v512s1,
  GILLT_v1024s1,
  GILLT_v2048s1,
};
const static size_t NumTypeObjects = 12;
const static LLT TypeObjects[] = {
  LLT::scalar(1),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::scalar(128),
  LLT::vector(ElementCount::getFixed(2), 64),
  LLT::vector(ElementCount::getFixed(4), 32),
  LLT::vector(ElementCount::getFixed(8), 16),
  LLT::vector(ElementCount::getFixed(16), 8),
  LLT::vector(ElementCount::getFixed(256), 1),
  LLT::vector(ElementCount::getFixed(512), 1),
  LLT::vector(ElementCount::getFixed(1024), 1),
  LLT::vector(ElementCount::getFixed(2048), 1),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_In32BitModeBit = 1,
  Feature_In64BitModeBit = 9,
  Feature_HasOnlyMSYNCBit = 23,
  Feature_HasSYNCBit = 22,
  Feature_HasSPEBit = 8,
  Feature_HasICBTBit = 21,
  Feature_HasBPERMDBit = 10,
  Feature_HasExtDivBit = 3,
  Feature_IsISA2_06Bit = 11,
  Feature_IsISA2_07Bit = 40,
  Feature_IsISA3_0Bit = 2,
  Feature_HasFPUBit = 0,
  Feature_PCRelativeMemopsBit = 37,
  Feature_IsNotISA3_1Bit = 39,
  Feature_IsAIXBit = 24,
  Feature_NotAIXBit = 25,
  Feature_IsISAFutureBit = 18,
  Feature_IsNotISAFutureBit = 19,
  Feature_HasAltivecBit = 4,
  Feature_HasP8AltivecBit = 5,
  Feature_HasP8CryptoBit = 6,
  Feature_HasP9AltivecBit = 7,
  Feature_HasVSXBit = 12,
  Feature_IsLittleEndianBit = 26,
  Feature_IsBigEndianBit = 27,
  Feature_IsPPC64Bit = 31,
  Feature_HasOnlySwappingMemOpsBit = 29,
  Feature_NoP8VectorBit = 30,
  Feature_HasP8VectorBit = 13,
  Feature_HasDirectMoveBit = 14,
  Feature_NoP9VectorBit = 28,
  Feature_HasP9VectorBit = 15,
  Feature_NoP9AltivecBit = 32,
  Feature_NoP10VectorBit = 33,
  Feature_HasP10VectorBit = 36,
  Feature_HasHTMBit = 34,
  Feature_MMABit = 20,
  Feature_IsPPC32Bit = 38,
  Feature_PrefixInstrsBit = 16,
  Feature_IsISA3_1Bit = 17,
  Feature_PairedVectorMemopsBit = 35,
};

PredicateBitset PPCInstructionSelector::
computeAvailableModuleFeatures(const PPCSubtarget *Subtarget) const {
  PredicateBitset Features{};
  if (!Subtarget->isPPC64())
    Features.set(Feature_In32BitModeBit);
  if (Subtarget->isPPC64())
    Features.set(Feature_In64BitModeBit);
  if (Subtarget->hasOnlyMSYNC())
    Features.set(Feature_HasOnlyMSYNCBit);
  if (!Subtarget->hasOnlyMSYNC())
    Features.set(Feature_HasSYNCBit);
  if (Subtarget->hasSPE())
    Features.set(Feature_HasSPEBit);
  if (Subtarget->hasICBT())
    Features.set(Feature_HasICBTBit);
  if (Subtarget->hasBPERMD())
    Features.set(Feature_HasBPERMDBit);
  if (Subtarget->hasExtDiv())
    Features.set(Feature_HasExtDivBit);
  if (Subtarget->isISA2_06())
    Features.set(Feature_IsISA2_06Bit);
  if (Subtarget->isISA2_07())
    Features.set(Feature_IsISA2_07Bit);
  if (Subtarget->isISA3_0())
    Features.set(Feature_IsISA3_0Bit);
  if (Subtarget->hasFPU())
    Features.set(Feature_HasFPUBit);
  if (Subtarget->hasPCRelativeMemops())
    Features.set(Feature_PCRelativeMemopsBit);
  if (!Subtarget->isISA3_1())
    Features.set(Feature_IsNotISA3_1Bit);
  if (Subtarget->isAIXABI())
    Features.set(Feature_IsAIXBit);
  if (!Subtarget->isAIXABI())
    Features.set(Feature_NotAIXBit);
  if (Subtarget->isISAFuture())
    Features.set(Feature_IsISAFutureBit);
  if (!Subtarget->isISAFuture())
    Features.set(Feature_IsNotISAFutureBit);
  if (Subtarget->hasAltivec())
    Features.set(Feature_HasAltivecBit);
  if (Subtarget->hasP8Altivec())
    Features.set(Feature_HasP8AltivecBit);
  if (Subtarget->hasP8Crypto())
    Features.set(Feature_HasP8CryptoBit);
  if (Subtarget->hasP9Altivec())
    Features.set(Feature_HasP9AltivecBit);
  if (Subtarget->hasVSX())
    Features.set(Feature_HasVSXBit);
  if (Subtarget->isLittleEndian())
    Features.set(Feature_IsLittleEndianBit);
  if (!Subtarget->isLittleEndian())
    Features.set(Feature_IsBigEndianBit);
  if (Subtarget->isPPC64())
    Features.set(Feature_IsPPC64Bit);
  if (!Subtarget->hasP9Vector())
    Features.set(Feature_HasOnlySwappingMemOpsBit);
  if (!Subtarget->hasP8Vector())
    Features.set(Feature_NoP8VectorBit);
  if (Subtarget->hasP8Vector())
    Features.set(Feature_HasP8VectorBit);
  if (Subtarget->hasDirectMove())
    Features.set(Feature_HasDirectMoveBit);
  if (!Subtarget->hasP9Vector())
    Features.set(Feature_NoP9VectorBit);
  if (Subtarget->hasP9Vector())
    Features.set(Feature_HasP9VectorBit);
  if (!Subtarget->hasP9Altivec())
    Features.set(Feature_NoP9AltivecBit);
  if (!Subtarget->hasP10Vector())
    Features.set(Feature_NoP10VectorBit);
  if (Subtarget->hasP10Vector())
    Features.set(Feature_HasP10VectorBit);
  if (Subtarget->hasHTM())
    Features.set(Feature_HasHTMBit);
  if (Subtarget->hasMMA())
    Features.set(Feature_MMABit);
  if (!Subtarget->isPPC64())
    Features.set(Feature_IsPPC32Bit);
  if (Subtarget->hasPrefixInstrs())
    Features.set(Feature_PrefixInstrsBit);
  if (Subtarget->isISA3_1())
    Features.set(Feature_IsISA3_1Bit);
  if (Subtarget->pairedVectorMemops())
    Features.set(Feature_PairedVectorMemopsBit);
  return Features;
}

void PPCInstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const PPCSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset PPCInstructionSelector::
computeAvailableFunctionFeatures(const PPCSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HasAltivec,
  GIFBS_HasBPERMD,
  GIFBS_HasExtDiv,
  GIFBS_HasFPU,
  GIFBS_HasHTM,
  GIFBS_HasOnlyMSYNC,
  GIFBS_HasP8Altivec,
  GIFBS_HasP8Crypto,
  GIFBS_HasP9Altivec,
  GIFBS_HasSPE,
  GIFBS_HasSYNC,
  GIFBS_HasVSX,
  GIFBS_In32BitMode,
  GIFBS_In64BitMode,
  GIFBS_IsAIX,
  GIFBS_IsISA3_0,
  GIFBS_IsISA3_1,
  GIFBS_IsISAFuture,
  GIFBS_IsNotISA3_1,
  GIFBS_NotAIX,
  GIFBS_PairedVectorMemops,
  GIFBS_HasDirectMove_HasVSX,
  GIFBS_HasFPU_IsISA3_1,
  GIFBS_HasP10Vector_PrefixInstrs,
  GIFBS_HasP8Altivec_HasVSX,
  GIFBS_HasP8Vector_HasVSX,
  GIFBS_HasP9Vector_HasVSX,
  GIFBS_HasVSX_IsISA3_1,
  GIFBS_In64BitMode_IsISA3_0,
  GIFBS_IsISAFuture_MMA,
  GIFBS_IsNotISAFuture_MMA,
  GIFBS_HasP8Altivec_HasVSX_IsBigEndian,
  GIFBS_HasP8Altivec_HasVSX_IsLittleEndian,
  GIFBS_IsISAFuture_MMA_PrefixInstrs,
  GIFBS_IsNotISAFuture_MMA_PrefixInstrs,
  GIFBS_HasDirectMove_HasVSX_IsISA3_0_IsLittleEndian,
  GIFBS_HasDirectMove_HasVSX_IsLittleEndian_NoP9Vector,
  GIFBS_HasVSX_IsBigEndian_IsISA3_1_IsPPC32,
  GIFBS_HasDirectMove_HasVSX_IsBigEndian_IsISA3_0_IsPPC64,
  GIFBS_HasDirectMove_HasVSX_IsBigEndian_IsPPC64_NoP9Vector,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HasAltivecBit, },
  {Feature_HasBPERMDBit, },
  {Feature_HasExtDivBit, },
  {Feature_HasFPUBit, },
  {Feature_HasHTMBit, },
  {Feature_HasOnlyMSYNCBit, },
  {Feature_HasP8AltivecBit, },
  {Feature_HasP8CryptoBit, },
  {Feature_HasP9AltivecBit, },
  {Feature_HasSPEBit, },
  {Feature_HasSYNCBit, },
  {Feature_HasVSXBit, },
  {Feature_In32BitModeBit, },
  {Feature_In64BitModeBit, },
  {Feature_IsAIXBit, },
  {Feature_IsISA3_0Bit, },
  {Feature_IsISA3_1Bit, },
  {Feature_IsISAFutureBit, },
  {Feature_IsNotISA3_1Bit, },
  {Feature_NotAIXBit, },
  {Feature_PairedVectorMemopsBit, },
  {Feature_HasDirectMoveBit, Feature_HasVSXBit, },
  {Feature_HasFPUBit, Feature_IsISA3_1Bit, },
  {Feature_HasP10VectorBit, Feature_PrefixInstrsBit, },
  {Feature_HasP8AltivecBit, Feature_HasVSXBit, },
  {Feature_HasP8VectorBit, Feature_HasVSXBit, },
  {Feature_HasP9VectorBit, Feature_HasVSXBit, },
  {Feature_HasVSXBit, Feature_IsISA3_1Bit, },
  {Feature_In64BitModeBit, Feature_IsISA3_0Bit, },
  {Feature_IsISAFutureBit, Feature_MMABit, },
  {Feature_IsNotISAFutureBit, Feature_MMABit, },
  {Feature_HasP8AltivecBit, Feature_HasVSXBit, Feature_IsBigEndianBit, },
  {Feature_HasP8AltivecBit, Feature_HasVSXBit, Feature_IsLittleEndianBit, },
  {Feature_IsISAFutureBit, Feature_MMABit, Feature_PrefixInstrsBit, },
  {Feature_IsNotISAFutureBit, Feature_MMABit, Feature_PrefixInstrsBit, },
  {Feature_HasDirectMoveBit, Feature_HasVSXBit, Feature_IsISA3_0Bit, Feature_IsLittleEndianBit, },
  {Feature_HasDirectMoveBit, Feature_HasVSXBit, Feature_IsLittleEndianBit, Feature_NoP9VectorBit, },
  {Feature_HasVSXBit, Feature_IsBigEndianBit, Feature_IsISA3_1Bit, Feature_IsPPC32Bit, },
  {Feature_HasDirectMoveBit, Feature_HasVSXBit, Feature_IsBigEndianBit, Feature_IsISA3_0Bit, Feature_IsPPC64Bit, },
  {Feature_HasDirectMoveBit, Feature_HasVSXBit, Feature_IsBigEndianBit, Feature_IsPPC64Bit, Feature_NoP9VectorBit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
};
// See constructor for table contents

PPCInstructionSelector::ComplexMatcherMemFn
PPCInstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
};

// PatFrag predicates.
enum {
  GICXXPred_MI_Predicate_or_disjoint = GICXXPred_Invalid + 1,
};
bool PPCInstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_or_disjoint: {
    
        return MI.getFlag(MachineInstr::Disjoint);
      
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool PPCInstructionSelector::testMOPredicate_MO(unsigned PredicateID, const MachineOperand & MO, const MatcherState &State) const {
  const auto &Operands = State.RecordedOperands;
  Register Reg = MO.getReg();
  (void)Operands;
  (void)Reg;
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_Msk2Imm = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_Msk4Imm,
  GICXXPred_I64_Predicate_Msk8Imm,
  GICXXPred_I64_Predicate_i32immNonAllOneNonZero,
  GICXXPred_I64_Predicate_imm32SExt16,
  GICXXPred_I64_Predicate_imm64SExt16,
  GICXXPred_I64_Predicate_imm64ZExt32,
  GICXXPred_I64_Predicate_immNonAllOneAnyExt8,
  GICXXPred_I64_Predicate_immSExt5NonZero,
};
bool PPCInstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_Msk2Imm: {
     return isUInt<2>(Imm); 
  }
  case GICXXPred_I64_Predicate_Msk4Imm: {
     return isUInt<4>(Imm); 
  }
  case GICXXPred_I64_Predicate_Msk8Imm: {
     return isUInt<8>(Imm); 
  }
  case GICXXPred_I64_Predicate_i32immNonAllOneNonZero: {
     return Imm && (Imm != -1); 
  }
  case GICXXPred_I64_Predicate_imm32SExt16: {
    
      // imm32SExt16 predicate - True if the i32 immediate fits in a 16-bit
      // sign extended field.  Used by instructions like 'addi'.
      return (int32_t)Imm == (short)Imm;
    
    llvm_unreachable("imm32SExt16 should have returned");
  }
  case GICXXPred_I64_Predicate_imm64SExt16: {
    
      // imm64SExt16 predicate - True if the i64 immediate fits in a 16-bit
      // sign extended field.  Used by instructions like 'addi'.
      return (int64_t)Imm == (short)Imm;
    
    llvm_unreachable("imm64SExt16 should have returned");
  }
  case GICXXPred_I64_Predicate_imm64ZExt32: {
    
      // imm64ZExt32 predicate - True if the i64 immediate fits in a 32-bit
      // zero extended field.
      return isUInt<32>(Imm);
    
    llvm_unreachable("imm64ZExt32 should have returned");
  }
  case GICXXPred_I64_Predicate_immNonAllOneAnyExt8: {
    
      return (isInt<8>(Imm) && (Imm != -1)) || (isUInt<8>(Imm) && (Imm != 0xFF));
    
  }
  case GICXXPred_I64_Predicate_immSExt5NonZero: {
     return Imm && isInt<5>(Imm); 
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool PPCInstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool PPCInstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool PPCInstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("PPCInstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
};
PPCInstructionSelector::CustomRendererFn
PPCInstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
};

bool PPCInstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool PPCInstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("PPCInstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *PPCInstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*      0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(292), /*)*//*default:*//*Label 83*/ GIMT_Encode4(211485),
     /*     10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(966),
     /*     14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(1375),
     /*     18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(1816),
     /*     22 */ /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(2098),
     /*     26 */ /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(2254),
     /*     30 */ /*TargetOpcode::G_SREM*//*Label 5*/ GIMT_Encode4(2410),
     /*     34 */ /*TargetOpcode::G_UREM*//*Label 6*/ GIMT_Encode4(2572), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     46 */ /*TargetOpcode::G_AND*//*Label 7*/ GIMT_Encode4(2734),
     /*     50 */ /*TargetOpcode::G_OR*//*Label 8*/ GIMT_Encode4(5295),
     /*     54 */ /*TargetOpcode::G_XOR*//*Label 9*/ GIMT_Encode4(48437), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    106 */ /*TargetOpcode::G_BUILD_VECTOR*//*Label 10*/ GIMT_Encode4(57544), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    126 */ /*TargetOpcode::G_BITCAST*//*Label 11*/ GIMT_Encode4(58511), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    142 */ /*TargetOpcode::G_INTRINSIC_TRUNC*//*Label 12*/ GIMT_Encode4(60788),
     /*    146 */ /*TargetOpcode::G_INTRINSIC_ROUND*//*Label 13*/ GIMT_Encode4(61063),
     /*    150 */ /*TargetOpcode::G_INTRINSIC_LRINT*//*Label 14*/ GIMT_Encode4(61313),
     /*    154 */ /*TargetOpcode::G_INTRINSIC_LLRINT*//*Label 15*/ GIMT_Encode4(61444), GIMT_Encode4(0),
     /*    162 */ /*TargetOpcode::G_READCYCLECOUNTER*//*Label 16*/ GIMT_Encode4(61575), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    294 */ /*TargetOpcode::G_FENCE*//*Label 17*/ GIMT_Encode4(61595), GIMT_Encode4(0),
     /*    302 */ /*TargetOpcode::G_BRCOND*//*Label 18*/ GIMT_Encode4(61720), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    314 */ /*TargetOpcode::G_INTRINSIC*//*Label 19*/ GIMT_Encode4(61783),
     /*    318 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 20*/ GIMT_Encode4(91211), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    330 */ /*TargetOpcode::G_ANYEXT*//*Label 21*/ GIMT_Encode4(94103),
     /*    334 */ /*TargetOpcode::G_TRUNC*//*Label 22*/ GIMT_Encode4(114859), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    350 */ /*TargetOpcode::G_CONSTANT*//*Label 23*/ GIMT_Encode4(115045), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    366 */ /*TargetOpcode::G_SEXT*//*Label 24*/ GIMT_Encode4(115197),
     /*    370 */ /*TargetOpcode::G_SEXT_INREG*//*Label 25*/ GIMT_Encode4(130229),
     /*    374 */ /*TargetOpcode::G_ZEXT*//*Label 26*/ GIMT_Encode4(130582),
     /*    378 */ /*TargetOpcode::G_SHL*//*Label 27*/ GIMT_Encode4(152052),
     /*    382 */ /*TargetOpcode::G_LSHR*//*Label 28*/ GIMT_Encode4(152408),
     /*    386 */ /*TargetOpcode::G_ASHR*//*Label 29*/ GIMT_Encode4(152830), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    402 */ /*TargetOpcode::G_ROTL*//*Label 30*/ GIMT_Encode4(153200),
     /*    406 */ /*TargetOpcode::G_ICMP*//*Label 31*/ GIMT_Encode4(153508),
     /*    410 */ /*TargetOpcode::G_FCMP*//*Label 32*/ GIMT_Encode4(157510), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    422 */ /*TargetOpcode::G_SELECT*//*Label 33*/ GIMT_Encode4(160961), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    466 */ /*TargetOpcode::G_UMULH*//*Label 34*/ GIMT_Encode4(162085),
     /*    470 */ /*TargetOpcode::G_SMULH*//*Label 35*/ GIMT_Encode4(162215),
     /*    474 */ /*TargetOpcode::G_UADDSAT*//*Label 36*/ GIMT_Encode4(162345),
     /*    478 */ /*TargetOpcode::G_SADDSAT*//*Label 37*/ GIMT_Encode4(162447),
     /*    482 */ /*TargetOpcode::G_USUBSAT*//*Label 38*/ GIMT_Encode4(162549),
     /*    486 */ /*TargetOpcode::G_SSUBSAT*//*Label 39*/ GIMT_Encode4(162651), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    530 */ /*TargetOpcode::G_FADD*//*Label 40*/ GIMT_Encode4(162753),
     /*    534 */ /*TargetOpcode::G_FSUB*//*Label 41*/ GIMT_Encode4(163048),
     /*    538 */ /*TargetOpcode::G_FMUL*//*Label 42*/ GIMT_Encode4(163343),
     /*    542 */ /*TargetOpcode::G_FMA*//*Label 43*/ GIMT_Encode4(163693), GIMT_Encode4(0),
     /*    550 */ /*TargetOpcode::G_FDIV*//*Label 44*/ GIMT_Encode4(164274), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    598 */ /*TargetOpcode::G_FNEG*//*Label 45*/ GIMT_Encode4(164544),
     /*    602 */ /*TargetOpcode::G_FPEXT*//*Label 46*/ GIMT_Encode4(167015),
     /*    606 */ /*TargetOpcode::G_FPTRUNC*//*Label 47*/ GIMT_Encode4(167179),
     /*    610 */ /*TargetOpcode::G_FPTOSI*//*Label 48*/ GIMT_Encode4(167336),
     /*    614 */ /*TargetOpcode::G_FPTOUI*//*Label 49*/ GIMT_Encode4(167599),
     /*    618 */ /*TargetOpcode::G_SITOFP*//*Label 50*/ GIMT_Encode4(167862),
     /*    622 */ /*TargetOpcode::G_UITOFP*//*Label 51*/ GIMT_Encode4(168109), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    634 */ /*TargetOpcode::G_FABS*//*Label 52*/ GIMT_Encode4(168356),
     /*    638 */ /*TargetOpcode::G_FCOPYSIGN*//*Label 53*/ GIMT_Encode4(168648), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    650 */ /*TargetOpcode::G_FMINNUM*//*Label 54*/ GIMT_Encode4(168964),
     /*    654 */ /*TargetOpcode::G_FMAXNUM*//*Label 55*/ GIMT_Encode4(169044),
     /*    658 */ /*TargetOpcode::G_FMINNUM_IEEE*//*Label 56*/ GIMT_Encode4(169124),
     /*    662 */ /*TargetOpcode::G_FMAXNUM_IEEE*//*Label 57*/ GIMT_Encode4(169706), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    714 */ /*TargetOpcode::G_SMIN*//*Label 58*/ GIMT_Encode4(170288),
     /*    718 */ /*TargetOpcode::G_SMAX*//*Label 59*/ GIMT_Encode4(170468),
     /*    722 */ /*TargetOpcode::G_UMIN*//*Label 60*/ GIMT_Encode4(170648),
     /*    726 */ /*TargetOpcode::G_UMAX*//*Label 61*/ GIMT_Encode4(170828), GIMT_Encode4(0),
     /*    734 */ /*TargetOpcode::G_LROUND*//*Label 62*/ GIMT_Encode4(171008),
     /*    738 */ /*TargetOpcode::G_LLROUND*//*Label 63*/ GIMT_Encode4(171310),
     /*    742 */ /*TargetOpcode::G_BR*//*Label 64*/ GIMT_Encode4(171475), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    762 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 65*/ GIMT_Encode4(171491), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    786 */ /*TargetOpcode::G_CTTZ*//*Label 66*/ GIMT_Encode4(171609), GIMT_Encode4(0),
     /*    794 */ /*TargetOpcode::G_CTLZ*//*Label 67*/ GIMT_Encode4(171787), GIMT_Encode4(0),
     /*    802 */ /*TargetOpcode::G_CTPOP*//*Label 68*/ GIMT_Encode4(171959),
     /*    806 */ /*TargetOpcode::G_BSWAP*//*Label 69*/ GIMT_Encode4(172131),
     /*    810 */ /*TargetOpcode::G_BITREVERSE*//*Label 70*/ GIMT_Encode4(172395),
     /*    814 */ /*TargetOpcode::G_FCEIL*//*Label 71*/ GIMT_Encode4(208401), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    862 */ /*TargetOpcode::G_FSQRT*//*Label 72*/ GIMT_Encode4(208676),
     /*    866 */ /*TargetOpcode::G_FFLOOR*//*Label 73*/ GIMT_Encode4(208893),
     /*    870 */ /*TargetOpcode::G_FRINT*//*Label 74*/ GIMT_Encode4(209168),
     /*    874 */ /*TargetOpcode::G_FNEARBYINT*//*Label 75*/ GIMT_Encode4(209380), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    902 */ /*TargetOpcode::G_STRICT_FADD*//*Label 76*/ GIMT_Encode4(209617),
     /*    906 */ /*TargetOpcode::G_STRICT_FSUB*//*Label 77*/ GIMT_Encode4(209887),
     /*    910 */ /*TargetOpcode::G_STRICT_FMUL*//*Label 78*/ GIMT_Encode4(210157),
     /*    914 */ /*TargetOpcode::G_STRICT_FDIV*//*Label 79*/ GIMT_Encode4(210427), GIMT_Encode4(0),
     /*    922 */ /*TargetOpcode::G_STRICT_FMA*//*Label 80*/ GIMT_Encode4(210697),
     /*    926 */ /*TargetOpcode::G_STRICT_FSQRT*//*Label 81*/ GIMT_Encode4(211255), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    962 */ /*TargetOpcode::G_TRAP*//*Label 82*/ GIMT_Encode4(211472),
     /*    966 */ // Label 0: @966
     /*    966 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(8), /*)*//*default:*//*Label 92*/ GIMT_Encode4(1374),
     /*    977 */ /*GILLT_s1*//*Label 84*/ GIMT_Encode4(1009),
     /*    981 */ /*GILLT_s32*//*Label 85*/ GIMT_Encode4(1032),
     /*    985 */ /*GILLT_s64*//*Label 86*/ GIMT_Encode4(1092),
     /*    989 */ /*GILLT_s128*//*Label 87*/ GIMT_Encode4(1152),
     /*    993 */ /*GILLT_v2s64*//*Label 88*/ GIMT_Encode4(1178),
     /*    997 */ /*GILLT_v4s32*//*Label 89*/ GIMT_Encode4(1204),
     /*   1001 */ /*GILLT_v8s16*//*Label 90*/ GIMT_Encode4(1230),
     /*   1005 */ /*GILLT_v16s8*//*Label 91*/ GIMT_Encode4(1348),
     /*   1009 */ // Label 84: @1009
     /*   1009 */ GIM_Try, /*On fail goto*//*Label 93*/ GIMT_Encode4(1031), // Rule ID 3669 //
     /*   1014 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*   1017 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*   1020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*   1024 */   // (add:{ *:[i1] } i1:{ *:[i1] }:$a, i1:{ *:[i1] }:$b)  =>  (CRXOR:{ *:[i1] } ?:{ *:[i1] }:$a, ?:{ *:[i1] }:$b)
     /*   1024 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::CRXOR),
     /*   1029 */   GIR_RootConstrainSelectedInstOperands,
     /*   1030 */   // GIR_Coverage, 3669,
     /*   1030 */   GIR_Done,
     /*   1031 */ // Label 93: @1031
     /*   1031 */ GIM_Reject,
     /*   1032 */ // Label 85: @1032
     /*   1032 */ GIM_Try, /*On fail goto*//*Label 94*/ GIMT_Encode4(1091),
     /*   1037 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   1040 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   1043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*   1047 */   GIM_Try, /*On fail goto*//*Label 95*/ GIMT_Encode4(1078), // Rule ID 107 //
     /*   1052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   1060 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*   1064 */     // MIs[1] Operand 1
     /*   1064 */     // No operand predicates
     /*   1064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1066 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$RA, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$D)  =>  (ADDI:{ *:[i32] } i32:{ *:[i32] }:$RA, (imm:{ *:[i32] }):$D)
     /*   1066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ADDI),
     /*   1069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*   1071 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*   1073 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // D
     /*   1076 */     GIR_RootConstrainSelectedInstOperands,
     /*   1077 */     // GIR_Coverage, 107,
     /*   1077 */     GIR_EraseRootFromParent_Done,
     /*   1078 */   // Label 95: @1078
     /*   1078 */   GIM_Try, /*On fail goto*//*Label 96*/ GIMT_Encode4(1090), // Rule ID 199 //
     /*   1083 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)  =>  (ADD4:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*   1083 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::ADD4),
     /*   1088 */     GIR_RootConstrainSelectedInstOperands,
     /*   1089 */     // GIR_Coverage, 199,
     /*   1089 */     GIR_Done,
     /*   1090 */   // Label 96: @1090
     /*   1090 */   GIM_Reject,
     /*   1091 */ // Label 94: @1091
     /*   1091 */ GIM_Reject,
     /*   1092 */ // Label 86: @1092
     /*   1092 */ GIM_Try, /*On fail goto*//*Label 97*/ GIMT_Encode4(1151),
     /*   1097 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   1100 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   1103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*   1107 */   GIM_Try, /*On fail goto*//*Label 98*/ GIMT_Encode4(1138), // Rule ID 663 //
     /*   1112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   1120 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*   1124 */     // MIs[1] Operand 1
     /*   1124 */     // No operand predicates
     /*   1124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1126 */     // (add:{ *:[i64] } i64:{ *:[i64] }:$RA, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$D)  =>  (ADDI8:{ *:[i64] } i64:{ *:[i64] }:$RA, (imm:{ *:[i64] }):$D)
     /*   1126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ADDI8),
     /*   1129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*   1131 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*   1133 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // D
     /*   1136 */     GIR_RootConstrainSelectedInstOperands,
     /*   1137 */     // GIR_Coverage, 663,
     /*   1137 */     GIR_EraseRootFromParent_Done,
     /*   1138 */   // Label 98: @1138
     /*   1138 */   GIM_Try, /*On fail goto*//*Label 99*/ GIMT_Encode4(1150), // Rule ID 659 //
     /*   1143 */     // (add:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)  =>  (ADD8:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)
     /*   1143 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::ADD8),
     /*   1148 */     GIR_RootConstrainSelectedInstOperands,
     /*   1149 */     // GIR_Coverage, 659,
     /*   1149 */     GIR_Done,
     /*   1150 */   // Label 99: @1150
     /*   1150 */   GIM_Reject,
     /*   1151 */ // Label 97: @1151
     /*   1151 */ GIM_Reject,
     /*   1152 */ // Label 87: @1152
     /*   1152 */ GIM_Try, /*On fail goto*//*Label 100*/ GIMT_Encode4(1177), // Rule ID 470 //
     /*   1157 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*   1160 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*   1163 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*   1166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   1170 */   // (add:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)  =>  (VADDUQM:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)
     /*   1170 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDUQM),
     /*   1175 */   GIR_RootConstrainSelectedInstOperands,
     /*   1176 */   // GIR_Coverage, 470,
     /*   1176 */   GIR_Done,
     /*   1177 */ // Label 100: @1177
     /*   1177 */ GIM_Reject,
     /*   1178 */ // Label 88: @1178
     /*   1178 */ GIM_Try, /*On fail goto*//*Label 101*/ GIMT_Encode4(1203), // Rule ID 469 //
     /*   1183 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*   1186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   1189 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   1192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   1196 */   // (add:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VADDUDM:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*   1196 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDUDM),
     /*   1201 */   GIR_RootConstrainSelectedInstOperands,
     /*   1202 */   // GIR_Coverage, 469,
     /*   1202 */   GIR_Done,
     /*   1203 */ // Label 101: @1203
     /*   1203 */ GIM_Reject,
     /*   1204 */ // Label 89: @1204
     /*   1204 */ GIM_Try, /*On fail goto*//*Label 102*/ GIMT_Encode4(1229), // Rule ID 303 //
     /*   1209 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   1212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   1215 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   1218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   1222 */   // (add:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VADDUWM:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*   1222 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDUWM),
     /*   1227 */   GIR_RootConstrainSelectedInstOperands,
     /*   1228 */   // GIR_Coverage, 303,
     /*   1228 */   GIR_Done,
     /*   1229 */ // Label 102: @1229
     /*   1229 */ GIM_Reject,
     /*   1230 */ // Label 90: @1230
     /*   1230 */ GIM_Try, /*On fail goto*//*Label 103*/ GIMT_Encode4(1347),
     /*   1235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   1238 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   1241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   1245 */   GIM_Try, /*On fail goto*//*Label 104*/ GIMT_Encode4(1288), // Rule ID 1296 //
     /*   1250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   1253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   1261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   1265 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   1269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1271 */     // (add:{ *:[v8i16] } (mul:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB), v8i16:{ *:[v8i16] }:$vC)  =>  (VMLADDUHM:{ *:[v8i16] } ?:{ *:[v8i16] }:$vA, ?:{ *:[v8i16] }:$vB, ?:{ *:[v8i16] }:$vC)
     /*   1271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMLADDUHM),
     /*   1274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*   1276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*   1280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   1284 */     GIR_RootToRootCopy, /*OpIdx*/2, // vC
     /*   1286 */     GIR_RootConstrainSelectedInstOperands,
     /*   1287 */     // GIR_Coverage, 1296,
     /*   1287 */     GIR_EraseRootFromParent_Done,
     /*   1288 */   // Label 104: @1288
     /*   1288 */   GIM_Try, /*On fail goto*//*Label 105*/ GIMT_Encode4(1331), // Rule ID 4947 //
     /*   1293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   1296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   1304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   1308 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   1312 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1314 */     // (add:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vC, (mul:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB))  =>  (VMLADDUHM:{ *:[v8i16] } ?:{ *:[v8i16] }:$vA, ?:{ *:[v8i16] }:$vB, ?:{ *:[v8i16] }:$vC)
     /*   1314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMLADDUHM),
     /*   1317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*   1319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*   1323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   1327 */     GIR_RootToRootCopy, /*OpIdx*/1, // vC
     /*   1329 */     GIR_RootConstrainSelectedInstOperands,
     /*   1330 */     // GIR_Coverage, 4947,
     /*   1330 */     GIR_EraseRootFromParent_Done,
     /*   1331 */   // Label 105: @1331
     /*   1331 */   GIM_Try, /*On fail goto*//*Label 106*/ GIMT_Encode4(1346), // Rule ID 302 //
     /*   1336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   1339 */     // (add:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VADDUHM:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*   1339 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDUHM),
     /*   1344 */     GIR_RootConstrainSelectedInstOperands,
     /*   1345 */     // GIR_Coverage, 302,
     /*   1345 */     GIR_Done,
     /*   1346 */   // Label 106: @1346
     /*   1346 */   GIM_Reject,
     /*   1347 */ // Label 103: @1347
     /*   1347 */ GIM_Reject,
     /*   1348 */ // Label 91: @1348
     /*   1348 */ GIM_Try, /*On fail goto*//*Label 107*/ GIMT_Encode4(1373), // Rule ID 301 //
     /*   1353 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   1356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   1359 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*   1362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   1366 */   // (add:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VADDUBM:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*   1366 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDUBM),
     /*   1371 */   GIR_RootConstrainSelectedInstOperands,
     /*   1372 */   // GIR_Coverage, 301,
     /*   1372 */   GIR_Done,
     /*   1373 */ // Label 107: @1373
     /*   1373 */ GIM_Reject,
     /*   1374 */ // Label 92: @1374
     /*   1374 */ GIM_Reject,
     /*   1375 */ // Label 1: @1375
     /*   1375 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(8), /*)*//*default:*//*Label 116*/ GIMT_Encode4(1815),
     /*   1386 */ /*GILLT_s1*//*Label 108*/ GIMT_Encode4(1418),
     /*   1390 */ /*GILLT_s32*//*Label 109*/ GIMT_Encode4(1441),
     /*   1394 */ /*GILLT_s64*//*Label 110*/ GIMT_Encode4(1526),
     /*   1398 */ /*GILLT_s128*//*Label 111*/ GIMT_Encode4(1611),
     /*   1402 */ /*GILLT_v2s64*//*Label 112*/ GIMT_Encode4(1637),
     /*   1406 */ /*GILLT_v4s32*//*Label 113*/ GIMT_Encode4(1700),
     /*   1410 */ /*GILLT_v8s16*//*Label 114*/ GIMT_Encode4(1763),
     /*   1414 */ /*GILLT_v16s8*//*Label 115*/ GIMT_Encode4(1789),
     /*   1418 */ // Label 108: @1418
     /*   1418 */ GIM_Try, /*On fail goto*//*Label 117*/ GIMT_Encode4(1440), // Rule ID 3670 //
     /*   1423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*   1426 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*   1429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*   1433 */   // (sub:{ *:[i1] } i1:{ *:[i1] }:$a, i1:{ *:[i1] }:$b)  =>  (CRXOR:{ *:[i1] } ?:{ *:[i1] }:$a, ?:{ *:[i1] }:$b)
     /*   1433 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::CRXOR),
     /*   1438 */   GIR_RootConstrainSelectedInstOperands,
     /*   1439 */   // GIR_Coverage, 3670,
     /*   1439 */   GIR_Done,
     /*   1440 */ // Label 117: @1440
     /*   1440 */ GIM_Reject,
     /*   1441 */ // Label 109: @1441
     /*   1441 */ GIM_Try, /*On fail goto*//*Label 118*/ GIMT_Encode4(1525),
     /*   1446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   1449 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   1452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*   1456 */   GIM_Try, /*On fail goto*//*Label 119*/ GIMT_Encode4(1474), // Rule ID 211 //
     /*   1461 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   1465 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, i32:{ *:[i32] }:$RA)  =>  (NEG:{ *:[i32] } i32:{ *:[i32] }:$RA)
     /*   1465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::NEG),
     /*   1468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*   1470 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*   1472 */     GIR_RootConstrainSelectedInstOperands,
     /*   1473 */     // GIR_Coverage, 211,
     /*   1473 */     GIR_EraseRootFromParent_Done,
     /*   1474 */   // Label 119: @1474
     /*   1474 */   GIM_Try, /*On fail goto*//*Label 120*/ GIMT_Encode4(1508), // Rule ID 1217 //
     /*   1479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   1487 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*   1491 */     // MIs[1] Operand 1
     /*   1491 */     // No operand predicates
     /*   1491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1493 */     // (sub:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, i32:{ *:[i32] }:$in)  =>  (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$in, (imm:{ *:[i32] }):$imm)
     /*   1493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /*   1496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*   1498 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*   1500 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   1503 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CARRY*/0,
     /*   1506 */     GIR_RootConstrainSelectedInstOperands,
     /*   1507 */     // GIR_Coverage, 1217,
     /*   1507 */     GIR_EraseRootFromParent_Done,
     /*   1508 */   // Label 120: @1508
     /*   1508 */   GIM_Try, /*On fail goto*//*Label 121*/ GIMT_Encode4(1524), // Rule ID 209 //
     /*   1513 */     // (sub:{ *:[i32] } i32:{ *:[i32] }:$RB, i32:{ *:[i32] }:$RA)  =>  (SUBF:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*   1513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SUBF),
     /*   1516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*   1518 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*   1520 */     GIR_RootToRootCopy, /*OpIdx*/1, // RB
     /*   1522 */     GIR_RootConstrainSelectedInstOperands,
     /*   1523 */     // GIR_Coverage, 209,
     /*   1523 */     GIR_EraseRootFromParent_Done,
     /*   1524 */   // Label 121: @1524
     /*   1524 */   GIM_Reject,
     /*   1525 */ // Label 118: @1525
     /*   1525 */ GIM_Reject,
     /*   1526 */ // Label 110: @1526
     /*   1526 */ GIM_Try, /*On fail goto*//*Label 122*/ GIMT_Encode4(1610),
     /*   1531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   1534 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   1537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*   1541 */   GIM_Try, /*On fail goto*//*Label 123*/ GIMT_Encode4(1559), // Rule ID 669 //
     /*   1546 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   1550 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, i64:{ *:[i64] }:$RA)  =>  (NEG8:{ *:[i64] } i64:{ *:[i64] }:$RA)
     /*   1550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::NEG8),
     /*   1553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*   1555 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*   1557 */     GIR_RootConstrainSelectedInstOperands,
     /*   1558 */     // GIR_Coverage, 669,
     /*   1558 */     GIR_EraseRootFromParent_Done,
     /*   1559 */   // Label 123: @1559
     /*   1559 */   GIM_Try, /*On fail goto*//*Label 124*/ GIMT_Encode4(1593), // Rule ID 1539 //
     /*   1564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   1572 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*   1576 */     // MIs[1] Operand 1
     /*   1576 */     // No operand predicates
     /*   1576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1578 */     // (sub:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, i64:{ *:[i64] }:$in)  =>  (SUBFIC8:{ *:[i64] }:{ *:[i32] } ?:{ *:[i64] }:$in, (imm:{ *:[i64] }):$imm)
     /*   1578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SUBFIC8),
     /*   1581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*   1583 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*   1585 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   1588 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CARRY*/0,
     /*   1591 */     GIR_RootConstrainSelectedInstOperands,
     /*   1592 */     // GIR_Coverage, 1539,
     /*   1592 */     GIR_EraseRootFromParent_Done,
     /*   1593 */   // Label 124: @1593
     /*   1593 */   GIM_Try, /*On fail goto*//*Label 125*/ GIMT_Encode4(1609), // Rule ID 668 //
     /*   1598 */     // (sub:{ *:[i64] } i64:{ *:[i64] }:$RB, i64:{ *:[i64] }:$RA)  =>  (SUBF8:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)
     /*   1598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SUBF8),
     /*   1601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*   1603 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*   1605 */     GIR_RootToRootCopy, /*OpIdx*/1, // RB
     /*   1607 */     GIR_RootConstrainSelectedInstOperands,
     /*   1608 */     // GIR_Coverage, 668,
     /*   1608 */     GIR_EraseRootFromParent_Done,
     /*   1609 */   // Label 125: @1609
     /*   1609 */   GIM_Reject,
     /*   1610 */ // Label 122: @1610
     /*   1610 */ GIM_Reject,
     /*   1611 */ // Label 111: @1611
     /*   1611 */ GIM_Try, /*On fail goto*//*Label 126*/ GIMT_Encode4(1636), // Rule ID 475 //
     /*   1616 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*   1619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*   1622 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*   1625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   1629 */   // (sub:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)  =>  (VSUBUQM:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)
     /*   1629 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBUQM),
     /*   1634 */   GIR_RootConstrainSelectedInstOperands,
     /*   1635 */   // GIR_Coverage, 475,
     /*   1635 */   GIR_Done,
     /*   1636 */ // Label 126: @1636
     /*   1636 */ GIM_Reject,
     /*   1637 */ // Label 112: @1637
     /*   1637 */ GIM_Try, /*On fail goto*//*Label 127*/ GIMT_Encode4(1699),
     /*   1642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   1645 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   1648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   1652 */   GIM_Try, /*On fail goto*//*Label 128*/ GIMT_Encode4(1683), // Rule ID 542 //
     /*   1657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*   1660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1664 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   1670 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*   1672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1674 */     // (sub:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, v2i64:{ *:[v2i64] }:$VB)  =>  (VNEGD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VB)
     /*   1674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VNEGD),
     /*   1677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*   1679 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*   1681 */     GIR_RootConstrainSelectedInstOperands,
     /*   1682 */     // GIR_Coverage, 542,
     /*   1682 */     GIR_EraseRootFromParent_Done,
     /*   1683 */   // Label 128: @1683
     /*   1683 */   GIM_Try, /*On fail goto*//*Label 129*/ GIMT_Encode4(1698), // Rule ID 474 //
     /*   1688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*   1691 */     // (sub:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VSUBUDM:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*   1691 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBUDM),
     /*   1696 */     GIR_RootConstrainSelectedInstOperands,
     /*   1697 */     // GIR_Coverage, 474,
     /*   1697 */     GIR_Done,
     /*   1698 */   // Label 129: @1698
     /*   1698 */   GIM_Reject,
     /*   1699 */ // Label 127: @1699
     /*   1699 */ GIM_Reject,
     /*   1700 */ // Label 113: @1700
     /*   1700 */ GIM_Try, /*On fail goto*//*Label 130*/ GIMT_Encode4(1762),
     /*   1705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   1708 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   1711 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   1715 */   GIM_Try, /*On fail goto*//*Label 131*/ GIMT_Encode4(1746), // Rule ID 541 //
     /*   1720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*   1723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1727 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   1733 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*   1735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1737 */     // (sub:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, v4i32:{ *:[v4i32] }:$VB)  =>  (VNEGW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB)
     /*   1737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VNEGW),
     /*   1740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*   1742 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*   1744 */     GIR_RootConstrainSelectedInstOperands,
     /*   1745 */     // GIR_Coverage, 541,
     /*   1745 */     GIR_EraseRootFromParent_Done,
     /*   1746 */   // Label 131: @1746
     /*   1746 */   GIM_Try, /*On fail goto*//*Label 132*/ GIMT_Encode4(1761), // Rule ID 373 //
     /*   1751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   1754 */     // (sub:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSUBUWM:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*   1754 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBUWM),
     /*   1759 */     GIR_RootConstrainSelectedInstOperands,
     /*   1760 */     // GIR_Coverage, 373,
     /*   1760 */     GIR_Done,
     /*   1761 */   // Label 132: @1761
     /*   1761 */   GIM_Reject,
     /*   1762 */ // Label 130: @1762
     /*   1762 */ GIM_Reject,
     /*   1763 */ // Label 114: @1763
     /*   1763 */ GIM_Try, /*On fail goto*//*Label 133*/ GIMT_Encode4(1788), // Rule ID 372 //
     /*   1768 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   1771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   1774 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   1777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   1781 */   // (sub:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VSUBUHM:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*   1781 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBUHM),
     /*   1786 */   GIR_RootConstrainSelectedInstOperands,
     /*   1787 */   // GIR_Coverage, 372,
     /*   1787 */   GIR_Done,
     /*   1788 */ // Label 133: @1788
     /*   1788 */ GIM_Reject,
     /*   1789 */ // Label 115: @1789
     /*   1789 */ GIM_Try, /*On fail goto*//*Label 134*/ GIMT_Encode4(1814), // Rule ID 371 //
     /*   1794 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   1797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   1800 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*   1803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   1807 */   // (sub:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VSUBUBM:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*   1807 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBUBM),
     /*   1812 */   GIR_RootConstrainSelectedInstOperands,
     /*   1813 */   // GIR_Coverage, 371,
     /*   1813 */   GIR_Done,
     /*   1814 */ // Label 134: @1814
     /*   1814 */ GIM_Reject,
     /*   1815 */ // Label 116: @1815
     /*   1815 */ GIM_Reject,
     /*   1816 */ // Label 2: @1816
     /*   1816 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(7), /*)*//*default:*//*Label 141*/ GIMT_Encode4(2097),
     /*   1827 */ /*GILLT_s1*//*Label 135*/ GIMT_Encode4(1855),
     /*   1831 */ /*GILLT_s32*//*Label 136*/ GIMT_Encode4(1878),
     /*   1835 */ /*GILLT_s64*//*Label 137*/ GIMT_Encode4(1938), GIMT_Encode4(0),
     /*   1843 */ /*GILLT_v2s64*//*Label 138*/ GIMT_Encode4(1998),
     /*   1847 */ /*GILLT_v4s32*//*Label 139*/ GIMT_Encode4(2024),
     /*   1851 */ /*GILLT_v8s16*//*Label 140*/ GIMT_Encode4(2050),
     /*   1855 */ // Label 135: @1855
     /*   1855 */ GIM_Try, /*On fail goto*//*Label 142*/ GIMT_Encode4(1877), // Rule ID 3671 //
     /*   1860 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*   1863 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*   1866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*   1870 */   // (mul:{ *:[i1] } i1:{ *:[i1] }:$a, i1:{ *:[i1] }:$b)  =>  (CRAND:{ *:[i1] } ?:{ *:[i1] }:$a, ?:{ *:[i1] }:$b)
     /*   1870 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::CRAND),
     /*   1875 */   GIR_RootConstrainSelectedInstOperands,
     /*   1876 */   // GIR_Coverage, 3671,
     /*   1876 */   GIR_Done,
     /*   1877 */ // Label 142: @1877
     /*   1877 */ GIM_Reject,
     /*   1878 */ // Label 136: @1878
     /*   1878 */ GIM_Try, /*On fail goto*//*Label 143*/ GIMT_Encode4(1937),
     /*   1883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   1886 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   1889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*   1893 */   GIM_Try, /*On fail goto*//*Label 144*/ GIMT_Encode4(1924), // Rule ID 111 //
     /*   1898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   1906 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*   1910 */     // MIs[1] Operand 1
     /*   1910 */     // No operand predicates
     /*   1910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1912 */     // (mul:{ *:[i32] } i32:{ *:[i32] }:$RA, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$D)  =>  (MULLI:{ *:[i32] } i32:{ *:[i32] }:$RA, (imm:{ *:[i32] }):$D)
     /*   1912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MULLI),
     /*   1915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*   1917 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*   1919 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // D
     /*   1922 */     GIR_RootConstrainSelectedInstOperands,
     /*   1923 */     // GIR_Coverage, 111,
     /*   1923 */     GIR_EraseRootFromParent_Done,
     /*   1924 */   // Label 144: @1924
     /*   1924 */   GIM_Try, /*On fail goto*//*Label 145*/ GIMT_Encode4(1936), // Rule ID 208 //
     /*   1929 */     // (mul:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)  =>  (MULLW:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*   1929 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MULLW),
     /*   1934 */     GIR_RootConstrainSelectedInstOperands,
     /*   1935 */     // GIR_Coverage, 208,
     /*   1935 */     GIR_Done,
     /*   1936 */   // Label 145: @1936
     /*   1936 */   GIM_Reject,
     /*   1937 */ // Label 143: @1937
     /*   1937 */ GIM_Reject,
     /*   1938 */ // Label 137: @1938
     /*   1938 */ GIM_Try, /*On fail goto*//*Label 146*/ GIMT_Encode4(1997),
     /*   1943 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   1946 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   1949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*   1953 */   GIM_Try, /*On fail goto*//*Label 147*/ GIMT_Encode4(1984), // Rule ID 706 //
     /*   1958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   1966 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*   1970 */     // MIs[1] Operand 1
     /*   1970 */     // No operand predicates
     /*   1970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1972 */     // (mul:{ *:[i64] } i64:{ *:[i64] }:$RA, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$D)  =>  (MULLI8:{ *:[i64] } i64:{ *:[i64] }:$RA, (imm:{ *:[i64] }):$D)
     /*   1972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MULLI8),
     /*   1975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*   1977 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*   1979 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // D
     /*   1982 */     GIR_RootConstrainSelectedInstOperands,
     /*   1983 */     // GIR_Coverage, 706,
     /*   1983 */     GIR_EraseRootFromParent_Done,
     /*   1984 */   // Label 147: @1984
     /*   1984 */   GIM_Try, /*On fail goto*//*Label 148*/ GIMT_Encode4(1996), // Rule ID 705 //
     /*   1989 */     // (mul:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)  =>  (MULLD:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)
     /*   1989 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MULLD),
     /*   1994 */     GIR_RootConstrainSelectedInstOperands,
     /*   1995 */     // GIR_Coverage, 705,
     /*   1995 */     GIR_Done,
     /*   1996 */   // Label 148: @1996
     /*   1996 */   GIM_Reject,
     /*   1997 */ // Label 146: @1997
     /*   1997 */ GIM_Reject,
     /*   1998 */ // Label 138: @1998
     /*   1998 */ GIM_Try, /*On fail goto*//*Label 149*/ GIMT_Encode4(2023), // Rule ID 1124 //
     /*   2003 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2006 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   2009 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   2012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2016 */   // (mul:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMULLD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*   2016 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMULLD),
     /*   2021 */   GIR_RootConstrainSelectedInstOperands,
     /*   2022 */   // GIR_Coverage, 1124,
     /*   2022 */   GIR_Done,
     /*   2023 */ // Label 149: @2023
     /*   2023 */ GIM_Reject,
     /*   2024 */ // Label 139: @2024
     /*   2024 */ GIM_Try, /*On fail goto*//*Label 150*/ GIMT_Encode4(2049), // Rule ID 461 //
     /*   2029 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*   2032 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   2035 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   2038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2042 */   // (mul:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMULUWM:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*   2042 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMULUWM),
     /*   2047 */   GIR_RootConstrainSelectedInstOperands,
     /*   2048 */   // GIR_Coverage, 461,
     /*   2048 */   GIR_Done,
     /*   2049 */ // Label 150: @2049
     /*   2049 */ GIM_Reject,
     /*   2050 */ // Label 140: @2050
     /*   2050 */ GIM_Try, /*On fail goto*//*Label 151*/ GIMT_Encode4(2096), // Rule ID 1295 //
     /*   2055 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   2058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   2061 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   2064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2068 */   // (mul:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB)  =>  (VMLADDUHM:{ *:[v8i16] } ?:{ *:[v8i16] }:$vA, ?:{ *:[v8i16] }:$vB, (V_SET0H:{ *:[v8i16] }))
     /*   2068 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*   2071 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::V_SET0H),
     /*   2075 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   2080 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   2082 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMLADDUHM),
     /*   2085 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*   2087 */   GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*   2089 */   GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /*   2091 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   2094 */   GIR_RootConstrainSelectedInstOperands,
     /*   2095 */   // GIR_Coverage, 1295,
     /*   2095 */   GIR_EraseRootFromParent_Done,
     /*   2096 */ // Label 151: @2096
     /*   2096 */ GIM_Reject,
     /*   2097 */ // Label 141: @2097
     /*   2097 */ GIM_Reject,
     /*   2098 */ // Label 3: @2098
     /*   2098 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 157*/ GIMT_Encode4(2253),
     /*   2109 */ /*GILLT_s32*//*Label 152*/ GIMT_Encode4(2129),
     /*   2113 */ /*GILLT_s64*//*Label 153*/ GIMT_Encode4(2152),
     /*   2117 */ /*GILLT_s128*//*Label 154*/ GIMT_Encode4(2175),
     /*   2121 */ /*GILLT_v2s64*//*Label 155*/ GIMT_Encode4(2201),
     /*   2125 */ /*GILLT_v4s32*//*Label 156*/ GIMT_Encode4(2227),
     /*   2129 */ // Label 152: @2129
     /*   2129 */ GIM_Try, /*On fail goto*//*Label 158*/ GIMT_Encode4(2151), // Rule ID 202 //
     /*   2134 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   2137 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   2140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*   2144 */   // (sdiv:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)  =>  (DIVW:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*   2144 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::DIVW),
     /*   2149 */   GIR_RootConstrainSelectedInstOperands,
     /*   2150 */   // GIR_Coverage, 202,
     /*   2150 */   GIR_Done,
     /*   2151 */ // Label 158: @2151
     /*   2151 */ GIM_Reject,
     /*   2152 */ // Label 153: @2152
     /*   2152 */ GIM_Try, /*On fail goto*//*Label 159*/ GIMT_Encode4(2174), // Rule ID 697 //
     /*   2157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   2160 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   2163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*   2167 */   // (sdiv:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)  =>  (DIVD:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)
     /*   2167 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::DIVD),
     /*   2172 */   GIR_RootConstrainSelectedInstOperands,
     /*   2173 */   // GIR_Coverage, 697,
     /*   2173 */   GIR_Done,
     /*   2174 */ // Label 159: @2174
     /*   2174 */ GIM_Reject,
     /*   2175 */ // Label 154: @2175
     /*   2175 */ GIM_Try, /*On fail goto*//*Label 160*/ GIMT_Encode4(2200), // Rule ID 1148 //
     /*   2180 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*   2186 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*   2189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2193 */   // (sdiv:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)  =>  (VDIVSQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)
     /*   2193 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VDIVSQ),
     /*   2198 */   GIR_RootConstrainSelectedInstOperands,
     /*   2199 */   // GIR_Coverage, 1148,
     /*   2199 */   GIR_Done,
     /*   2200 */ // Label 160: @2200
     /*   2200 */ GIM_Reject,
     /*   2201 */ // Label 155: @2201
     /*   2201 */ GIM_Try, /*On fail goto*//*Label 161*/ GIMT_Encode4(2226), // Rule ID 1135 //
     /*   2206 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   2212 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   2215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2219 */   // (sdiv:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VDIVSD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*   2219 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VDIVSD),
     /*   2224 */   GIR_RootConstrainSelectedInstOperands,
     /*   2225 */   // GIR_Coverage, 1135,
     /*   2225 */   GIR_Done,
     /*   2226 */ // Label 161: @2226
     /*   2226 */ GIM_Reject,
     /*   2227 */ // Label 156: @2227
     /*   2227 */ GIM_Try, /*On fail goto*//*Label 162*/ GIMT_Encode4(2252), // Rule ID 1133 //
     /*   2232 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   2238 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   2241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2245 */   // (sdiv:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VDIVSW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*   2245 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VDIVSW),
     /*   2250 */   GIR_RootConstrainSelectedInstOperands,
     /*   2251 */   // GIR_Coverage, 1133,
     /*   2251 */   GIR_Done,
     /*   2252 */ // Label 162: @2252
     /*   2252 */ GIM_Reject,
     /*   2253 */ // Label 157: @2253
     /*   2253 */ GIM_Reject,
     /*   2254 */ // Label 4: @2254
     /*   2254 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 168*/ GIMT_Encode4(2409),
     /*   2265 */ /*GILLT_s32*//*Label 163*/ GIMT_Encode4(2285),
     /*   2269 */ /*GILLT_s64*//*Label 164*/ GIMT_Encode4(2308),
     /*   2273 */ /*GILLT_s128*//*Label 165*/ GIMT_Encode4(2331),
     /*   2277 */ /*GILLT_v2s64*//*Label 166*/ GIMT_Encode4(2357),
     /*   2281 */ /*GILLT_v4s32*//*Label 167*/ GIMT_Encode4(2383),
     /*   2285 */ // Label 163: @2285
     /*   2285 */ GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(2307), // Rule ID 203 //
     /*   2290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   2293 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   2296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*   2300 */   // (udiv:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)  =>  (DIVWU:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*   2300 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::DIVWU),
     /*   2305 */   GIR_RootConstrainSelectedInstOperands,
     /*   2306 */   // GIR_Coverage, 203,
     /*   2306 */   GIR_Done,
     /*   2307 */ // Label 169: @2307
     /*   2307 */ GIM_Reject,
     /*   2308 */ // Label 164: @2308
     /*   2308 */ GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(2330), // Rule ID 698 //
     /*   2313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   2316 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   2319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*   2323 */   // (udiv:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)  =>  (DIVDU:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)
     /*   2323 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::DIVDU),
     /*   2328 */   GIR_RootConstrainSelectedInstOperands,
     /*   2329 */   // GIR_Coverage, 698,
     /*   2329 */   GIR_Done,
     /*   2330 */ // Label 170: @2330
     /*   2330 */ GIM_Reject,
     /*   2331 */ // Label 165: @2331
     /*   2331 */ GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(2356), // Rule ID 1149 //
     /*   2336 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2339 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*   2342 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*   2345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2349 */   // (udiv:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)  =>  (VDIVUQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)
     /*   2349 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VDIVUQ),
     /*   2354 */   GIR_RootConstrainSelectedInstOperands,
     /*   2355 */   // GIR_Coverage, 1149,
     /*   2355 */   GIR_Done,
     /*   2356 */ // Label 171: @2356
     /*   2356 */ GIM_Reject,
     /*   2357 */ // Label 166: @2357
     /*   2357 */ GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(2382), // Rule ID 1136 //
     /*   2362 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   2368 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   2371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2375 */   // (udiv:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VDIVUD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*   2375 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VDIVUD),
     /*   2380 */   GIR_RootConstrainSelectedInstOperands,
     /*   2381 */   // GIR_Coverage, 1136,
     /*   2381 */   GIR_Done,
     /*   2382 */ // Label 172: @2382
     /*   2382 */ GIM_Reject,
     /*   2383 */ // Label 167: @2383
     /*   2383 */ GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(2408), // Rule ID 1134 //
     /*   2388 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2391 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   2394 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   2397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2401 */   // (udiv:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VDIVUW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*   2401 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VDIVUW),
     /*   2406 */   GIR_RootConstrainSelectedInstOperands,
     /*   2407 */   // GIR_Coverage, 1134,
     /*   2407 */   GIR_Done,
     /*   2408 */ // Label 173: @2408
     /*   2408 */ GIM_Reject,
     /*   2409 */ // Label 168: @2409
     /*   2409 */ GIM_Reject,
     /*   2410 */ // Label 5: @2410
     /*   2410 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 179*/ GIMT_Encode4(2571),
     /*   2421 */ /*GILLT_s32*//*Label 174*/ GIMT_Encode4(2441),
     /*   2425 */ /*GILLT_s64*//*Label 175*/ GIMT_Encode4(2467),
     /*   2429 */ /*GILLT_s128*//*Label 176*/ GIMT_Encode4(2493),
     /*   2433 */ /*GILLT_v2s64*//*Label 177*/ GIMT_Encode4(2519),
     /*   2437 */ /*GILLT_v4s32*//*Label 178*/ GIMT_Encode4(2545),
     /*   2441 */ // Label 174: @2441
     /*   2441 */ GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(2466), // Rule ID 197 //
     /*   2446 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_0),
     /*   2449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   2452 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   2455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*   2459 */   // (srem:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)  =>  (MODSW:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*   2459 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MODSW),
     /*   2464 */   GIR_RootConstrainSelectedInstOperands,
     /*   2465 */   // GIR_Coverage, 197,
     /*   2465 */   GIR_Done,
     /*   2466 */ // Label 180: @2466
     /*   2466 */ GIM_Reject,
     /*   2467 */ // Label 175: @2467
     /*   2467 */ GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(2492), // Rule ID 702 //
     /*   2472 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_0),
     /*   2475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   2478 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   2481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*   2485 */   // (srem:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)  =>  (MODSD:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)
     /*   2485 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MODSD),
     /*   2490 */   GIR_RootConstrainSelectedInstOperands,
     /*   2491 */   // GIR_Coverage, 702,
     /*   2491 */   GIR_Done,
     /*   2492 */ // Label 181: @2492
     /*   2492 */ GIM_Reject,
     /*   2493 */ // Label 176: @2493
     /*   2493 */ GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(2518), // Rule ID 1158 //
     /*   2498 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*   2504 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*   2507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2511 */   // (srem:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)  =>  (VMODSQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)
     /*   2511 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMODSQ),
     /*   2516 */   GIR_RootConstrainSelectedInstOperands,
     /*   2517 */   // GIR_Coverage, 1158,
     /*   2517 */   GIR_Done,
     /*   2518 */ // Label 182: @2518
     /*   2518 */ GIM_Reject,
     /*   2519 */ // Label 177: @2519
     /*   2519 */ GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(2544), // Rule ID 1131 //
     /*   2524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   2530 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   2533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2537 */   // (srem:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMODSD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*   2537 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMODSD),
     /*   2542 */   GIR_RootConstrainSelectedInstOperands,
     /*   2543 */   // GIR_Coverage, 1131,
     /*   2543 */   GIR_Done,
     /*   2544 */ // Label 183: @2544
     /*   2544 */ GIM_Reject,
     /*   2545 */ // Label 178: @2545
     /*   2545 */ GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(2570), // Rule ID 1129 //
     /*   2550 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   2556 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   2559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2563 */   // (srem:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMODSW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*   2563 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMODSW),
     /*   2568 */   GIR_RootConstrainSelectedInstOperands,
     /*   2569 */   // GIR_Coverage, 1129,
     /*   2569 */   GIR_Done,
     /*   2570 */ // Label 184: @2570
     /*   2570 */ GIM_Reject,
     /*   2571 */ // Label 179: @2571
     /*   2571 */ GIM_Reject,
     /*   2572 */ // Label 6: @2572
     /*   2572 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 190*/ GIMT_Encode4(2733),
     /*   2583 */ /*GILLT_s32*//*Label 185*/ GIMT_Encode4(2603),
     /*   2587 */ /*GILLT_s64*//*Label 186*/ GIMT_Encode4(2629),
     /*   2591 */ /*GILLT_s128*//*Label 187*/ GIMT_Encode4(2655),
     /*   2595 */ /*GILLT_v2s64*//*Label 188*/ GIMT_Encode4(2681),
     /*   2599 */ /*GILLT_v4s32*//*Label 189*/ GIMT_Encode4(2707),
     /*   2603 */ // Label 185: @2603
     /*   2603 */ GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(2628), // Rule ID 198 //
     /*   2608 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_0),
     /*   2611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   2614 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   2617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*   2621 */   // (urem:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)  =>  (MODUW:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*   2621 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MODUW),
     /*   2626 */   GIR_RootConstrainSelectedInstOperands,
     /*   2627 */   // GIR_Coverage, 198,
     /*   2627 */   GIR_Done,
     /*   2628 */ // Label 191: @2628
     /*   2628 */ GIM_Reject,
     /*   2629 */ // Label 186: @2629
     /*   2629 */ GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(2654), // Rule ID 703 //
     /*   2634 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_0),
     /*   2637 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   2640 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   2643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*   2647 */   // (urem:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)  =>  (MODUD:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)
     /*   2647 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MODUD),
     /*   2652 */   GIR_RootConstrainSelectedInstOperands,
     /*   2653 */   // GIR_Coverage, 703,
     /*   2653 */   GIR_Done,
     /*   2654 */ // Label 192: @2654
     /*   2654 */ GIM_Reject,
     /*   2655 */ // Label 187: @2655
     /*   2655 */ GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(2680), // Rule ID 1159 //
     /*   2660 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*   2666 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*   2669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2673 */   // (urem:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)  =>  (VMODUQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)
     /*   2673 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMODUQ),
     /*   2678 */   GIR_RootConstrainSelectedInstOperands,
     /*   2679 */   // GIR_Coverage, 1159,
     /*   2679 */   GIR_Done,
     /*   2680 */ // Label 193: @2680
     /*   2680 */ GIM_Reject,
     /*   2681 */ // Label 188: @2681
     /*   2681 */ GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(2706), // Rule ID 1132 //
     /*   2686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   2692 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   2695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2699 */   // (urem:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMODUD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*   2699 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMODUD),
     /*   2704 */   GIR_RootConstrainSelectedInstOperands,
     /*   2705 */   // GIR_Coverage, 1132,
     /*   2705 */   GIR_Done,
     /*   2706 */ // Label 194: @2706
     /*   2706 */ GIM_Reject,
     /*   2707 */ // Label 189: @2707
     /*   2707 */ GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(2732), // Rule ID 1130 //
     /*   2712 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   2718 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   2721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2725 */   // (urem:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMODUW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*   2725 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMODUW),
     /*   2730 */   GIR_RootConstrainSelectedInstOperands,
     /*   2731 */   // GIR_Coverage, 1130,
     /*   2731 */   GIR_Done,
     /*   2732 */ // Label 195: @2732
     /*   2732 */ GIM_Reject,
     /*   2733 */ // Label 190: @2733
     /*   2733 */ GIM_Reject,
     /*   2734 */ // Label 7: @2734
     /*   2734 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(6), /*)*//*default:*//*Label 200*/ GIMT_Encode4(5294),
     /*   2745 */ /*GILLT_s1*//*Label 196*/ GIMT_Encode4(2769),
     /*   2749 */ /*GILLT_s32*//*Label 197*/ GIMT_Encode4(2878),
     /*   2753 */ /*GILLT_s64*//*Label 198*/ GIMT_Encode4(2987), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   2765 */ /*GILLT_v4s32*//*Label 199*/ GIMT_Encode4(3096),
     /*   2769 */ // Label 196: @2769
     /*   2769 */ GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(2877),
     /*   2774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*   2777 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*   2780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*   2784 */   GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(2824), // Rule ID 4924 //
     /*   2789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   2797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*   2801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*   2805 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   2809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2811 */     // (and:{ *:[i1] } (xor:{ *:[i1] } i1:{ *:[i1] }:$CRB, -1:{ *:[i1] }), i1:{ *:[i1] }:$CRA)  =>  (CRANDC:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*   2811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRANDC),
     /*   2814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /*   2816 */     GIR_RootToRootCopy, /*OpIdx*/2, // CRA
     /*   2818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // CRB
     /*   2822 */     GIR_RootConstrainSelectedInstOperands,
     /*   2823 */     // GIR_Coverage, 4924,
     /*   2823 */     GIR_EraseRootFromParent_Done,
     /*   2824 */   // Label 202: @2824
     /*   2824 */   GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(2864), // Rule ID 182 //
     /*   2829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   2837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*   2841 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*   2845 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   2849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2851 */     // (and:{ *:[i1] } i1:{ *:[i1] }:$CRA, (xor:{ *:[i1] } i1:{ *:[i1] }:$CRB, -1:{ *:[i1] }))  =>  (CRANDC:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*   2851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRANDC),
     /*   2854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /*   2856 */     GIR_RootToRootCopy, /*OpIdx*/1, // CRA
     /*   2858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // CRB
     /*   2862 */     GIR_RootConstrainSelectedInstOperands,
     /*   2863 */     // GIR_Coverage, 182,
     /*   2863 */     GIR_EraseRootFromParent_Done,
     /*   2864 */   // Label 203: @2864
     /*   2864 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(2876), // Rule ID 175 //
     /*   2869 */     // (and:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)  =>  (CRAND:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*   2869 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::CRAND),
     /*   2874 */     GIR_RootConstrainSelectedInstOperands,
     /*   2875 */     // GIR_Coverage, 175,
     /*   2875 */     GIR_Done,
     /*   2876 */   // Label 204: @2876
     /*   2876 */   GIM_Reject,
     /*   2877 */ // Label 201: @2877
     /*   2877 */ GIM_Reject,
     /*   2878 */ // Label 197: @2878
     /*   2878 */ GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(2986),
     /*   2883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   2886 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   2889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*   2893 */   GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(2933), // Rule ID 4918 //
     /*   2898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   2906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2910 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2914 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   2918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2920 */     // (and:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$RB, -1:{ *:[i32] }), i32:{ *:[i32] }:$RST)  =>  (ANDC:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*   2920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ANDC),
     /*   2923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*   2925 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*   2927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RB
     /*   2931 */     GIR_RootConstrainSelectedInstOperands,
     /*   2932 */     // GIR_Coverage, 4918,
     /*   2932 */     GIR_EraseRootFromParent_Done,
     /*   2933 */   // Label 206: @2933
     /*   2933 */   GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(2973), // Rule ID 123 //
     /*   2938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   2946 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2950 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2954 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   2958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2960 */     // (and:{ *:[i32] } i32:{ *:[i32] }:$RST, (xor:{ *:[i32] } i32:{ *:[i32] }:$RB, -1:{ *:[i32] }))  =>  (ANDC:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*   2960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ANDC),
     /*   2963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*   2965 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /*   2967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RB
     /*   2971 */     GIR_RootConstrainSelectedInstOperands,
     /*   2972 */     // GIR_Coverage, 123,
     /*   2972 */     GIR_EraseRootFromParent_Done,
     /*   2973 */   // Label 207: @2973
     /*   2973 */   GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(2985), // Rule ID 122 //
     /*   2978 */     // (and:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)  =>  (AND:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*   2978 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::AND),
     /*   2983 */     GIR_RootConstrainSelectedInstOperands,
     /*   2984 */     // GIR_Coverage, 122,
     /*   2984 */     GIR_Done,
     /*   2985 */   // Label 208: @2985
     /*   2985 */   GIM_Reject,
     /*   2986 */ // Label 205: @2986
     /*   2986 */ GIM_Reject,
     /*   2987 */ // Label 198: @2987
     /*   2987 */ GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(3095),
     /*   2992 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   2995 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   2998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*   3002 */   GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(3042), // Rule ID 4931 //
     /*   3007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3019 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   3023 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   3027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3029 */     // (and:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$RB, -1:{ *:[i64] }), i64:{ *:[i64] }:$RST)  =>  (ANDC8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*   3029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ANDC8),
     /*   3032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*   3034 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*   3036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RB
     /*   3040 */     GIR_RootConstrainSelectedInstOperands,
     /*   3041 */     // GIR_Coverage, 4931,
     /*   3041 */     GIR_EraseRootFromParent_Done,
     /*   3042 */   // Label 210: @3042
     /*   3042 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(3082), // Rule ID 647 //
     /*   3047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3059 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   3063 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   3067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3069 */     // (and:{ *:[i64] } i64:{ *:[i64] }:$RST, (xor:{ *:[i64] } i64:{ *:[i64] }:$RB, -1:{ *:[i64] }))  =>  (ANDC8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*   3069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ANDC8),
     /*   3072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*   3074 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /*   3076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RB
     /*   3080 */     GIR_RootConstrainSelectedInstOperands,
     /*   3081 */     // GIR_Coverage, 647,
     /*   3081 */     GIR_EraseRootFromParent_Done,
     /*   3082 */   // Label 211: @3082
     /*   3082 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(3094), // Rule ID 646 //
     /*   3087 */     // (and:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)  =>  (AND8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*   3087 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /*   3092 */     GIR_RootConstrainSelectedInstOperands,
     /*   3093 */     // GIR_Coverage, 646,
     /*   3093 */     GIR_Done,
     /*   3094 */   // Label 212: @3094
     /*   3094 */   GIM_Reject,
     /*   3095 */ // Label 209: @3095
     /*   3095 */ GIM_Reject,
     /*   3096 */ // Label 199: @3096
     /*   3096 */ GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(5293),
     /*   3101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3104 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3107 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(3185), // Rule ID 5279 //
     /*   3112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   3127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3131 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3135 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3139 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3143 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3147 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3151 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*   3155 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3161 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   3163 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3165 */     // (and:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 16:{ *:[i32] })
     /*   3165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   3168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   3170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   3174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   3178 */     GIR_RootToRootCopy, /*OpIdx*/2, // vC
     /*   3180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*   3183 */     GIR_RootConstrainSelectedInstOperands,
     /*   3184 */     // GIR_Coverage, 5279,
     /*   3184 */     GIR_EraseRootFromParent_Done,
     /*   3185 */   // Label 214: @3185
     /*   3185 */   GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(3263), // Rule ID 5280 //
     /*   3190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   3205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3209 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   3217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3221 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3225 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3229 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*   3233 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3239 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   3241 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3243 */     // (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] })), v4i32:{ *:[v4i32] }:$vC)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 16:{ *:[i32] })
     /*   3243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   3246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   3248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   3252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*   3256 */     GIR_RootToRootCopy, /*OpIdx*/2, // vC
     /*   3258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*   3261 */     GIR_RootConstrainSelectedInstOperands,
     /*   3262 */     // GIR_Coverage, 5280,
     /*   3262 */     GIR_EraseRootFromParent_Done,
     /*   3263 */   // Label 215: @3263
     /*   3263 */   GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(3343), // Rule ID 5281 //
     /*   3268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   3283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3291 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   3295 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3299 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3303 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3307 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*   3311 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3317 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   3319 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3321 */     // (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 16:{ *:[i32] })
     /*   3321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   3324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   3326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   3330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*   3334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   3338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*   3341 */     GIR_RootConstrainSelectedInstOperands,
     /*   3342 */     // GIR_Coverage, 5281,
     /*   3342 */     GIR_EraseRootFromParent_Done,
     /*   3343 */   // Label 216: @3343
     /*   3343 */   GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(3423), // Rule ID 5284 //
     /*   3348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*   3363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3367 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   3375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3379 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3383 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3387 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*   3391 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3397 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   3399 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3401 */     // (and:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 112:{ *:[i32] })
     /*   3401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   3404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   3406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   3410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*   3414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   3418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/112,
     /*   3421 */     GIR_RootConstrainSelectedInstOperands,
     /*   3422 */     // GIR_Coverage, 5284,
     /*   3422 */     GIR_EraseRootFromParent_Done,
     /*   3423 */   // Label 217: @3423
     /*   3423 */   GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(3501), // Rule ID 4968 //
     /*   3428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3443 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3447 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3451 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3455 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   3459 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3463 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3467 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3471 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3477 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   3479 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3481 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 14:{ *:[i32] })
     /*   3481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   3484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   3486 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*   3488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   3492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   3496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3499 */     GIR_RootConstrainSelectedInstOperands,
     /*   3500 */     // GIR_Coverage, 4968,
     /*   3500 */     GIR_EraseRootFromParent_Done,
     /*   3501 */   // Label 218: @3501
     /*   3501 */   GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(3579), // Rule ID 4962 //
     /*   3506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3521 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3525 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3529 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3533 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   3537 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3541 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3545 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3549 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3555 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   3557 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3559 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 8:{ *:[i32] })
     /*   3559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   3562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   3564 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*   3566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   3570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   3574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*   3577 */     GIR_RootConstrainSelectedInstOperands,
     /*   3578 */     // GIR_Coverage, 4962,
     /*   3578 */     GIR_EraseRootFromParent_Done,
     /*   3579 */   // Label 219: @3579
     /*   3579 */   GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(3657), // Rule ID 4966 //
     /*   3584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3603 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3607 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3611 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3615 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3619 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3623 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*   3627 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3633 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   3635 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3637 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 9:{ *:[i32] })
     /*   3637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   3640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   3642 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*   3644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   3648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   3652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /*   3655 */     GIR_RootConstrainSelectedInstOperands,
     /*   3656 */     // GIR_Coverage, 4966,
     /*   3656 */     GIR_EraseRootFromParent_Done,
     /*   3657 */   // Label 220: @3657
     /*   3657 */   GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(3735), // Rule ID 4965 //
     /*   3662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3681 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3689 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3693 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3697 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3701 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3705 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3711 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   3713 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3715 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 9:{ *:[i32] })
     /*   3715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   3718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   3720 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*   3722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   3726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   3730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /*   3733 */     GIR_RootConstrainSelectedInstOperands,
     /*   3734 */     // GIR_Coverage, 4965,
     /*   3734 */     GIR_EraseRootFromParent_Done,
     /*   3735 */   // Label 221: @3735
     /*   3735 */   GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(3813), // Rule ID 4967 //
     /*   3740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3759 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   3767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3771 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3775 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3779 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*   3783 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3789 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   3791 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3793 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, immAllOnesV:{ *:[v4i32] })), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 9:{ *:[i32] })
     /*   3793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   3796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   3798 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*   3800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   3804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*   3808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /*   3811 */     GIR_RootConstrainSelectedInstOperands,
     /*   3812 */     // GIR_Coverage, 4967,
     /*   3812 */     GIR_EraseRootFromParent_Done,
     /*   3813 */   // Label 222: @3813
     /*   3813 */   GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(3893), // Rule ID 3405 //
     /*   3818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3837 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3841 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   3845 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3851 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*   3853 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   3857 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*   3861 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3865 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3869 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3871 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 16:{ *:[i32] })
     /*   3871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   3874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   3876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*   3880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*   3884 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*   3888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*   3891 */     GIR_RootConstrainSelectedInstOperands,
     /*   3892 */     // GIR_Coverage, 3405,
     /*   3892 */     GIR_EraseRootFromParent_Done,
     /*   3893 */   // Label 223: @3893
     /*   3893 */   GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(3973), // Rule ID 3406 //
     /*   3898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3917 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3921 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   3925 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3931 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*   3933 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   3937 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*   3941 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3945 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3949 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3951 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 112:{ *:[i32] })
     /*   3951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   3954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   3956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*   3960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*   3964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*   3968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/112,
     /*   3971 */     GIR_RootConstrainSelectedInstOperands,
     /*   3972 */     // GIR_Coverage, 3406,
     /*   3972 */     GIR_EraseRootFromParent_Done,
     /*   3973 */   // Label 224: @3973
     /*   3973 */   GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(4053), // Rule ID 3404 //
     /*   3978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3997 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4001 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   4005 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   4011 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*   4013 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   4017 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4021 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4025 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4029 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4031 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 96:{ *:[i32] })
     /*   4031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*   4040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*   4044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*   4048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/96,
     /*   4051 */     GIR_RootConstrainSelectedInstOperands,
     /*   4052 */     // GIR_Coverage, 3404,
     /*   4052 */     GIR_EraseRootFromParent_Done,
     /*   4053 */   // Label 225: @4053
     /*   4053 */   GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(4133), // Rule ID 5278 //
     /*   4058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4077 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4081 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   4085 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4089 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4093 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4097 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*   4101 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   4107 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   4109 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4111 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 96:{ *:[i32] })
     /*   4111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   4120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*   4124 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   4128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/96,
     /*   4131 */     GIR_RootConstrainSelectedInstOperands,
     /*   4132 */     // GIR_Coverage, 5278,
     /*   4132 */     GIR_EraseRootFromParent_Done,
     /*   4133 */   // Label 226: @4133
     /*   4133 */   GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(4211), // Rule ID 5282 //
     /*   4138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   4153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4161 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4165 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4169 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4173 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4177 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*   4181 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   4187 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   4189 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4191 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 16:{ *:[i32] })
     /*   4191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   4200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   4204 */     GIR_RootToRootCopy, /*OpIdx*/1, // vC
     /*   4206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*   4209 */     GIR_RootConstrainSelectedInstOperands,
     /*   4210 */     // GIR_Coverage, 5282,
     /*   4210 */     GIR_EraseRootFromParent_Done,
     /*   4211 */   // Label 227: @4211
     /*   4211 */   GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(4289), // Rule ID 5283 //
     /*   4216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   4231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4235 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4239 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   4243 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4247 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4251 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4255 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*   4259 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   4265 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   4267 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4269 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] })))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 16:{ *:[i32] })
     /*   4269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4274 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   4278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*   4282 */     GIR_RootToRootCopy, /*OpIdx*/1, // vC
     /*   4284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*   4287 */     GIR_RootConstrainSelectedInstOperands,
     /*   4288 */     // GIR_Coverage, 5283,
     /*   4288 */     GIR_EraseRootFromParent_Done,
     /*   4289 */   // Label 228: @4289
     /*   4289 */   GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(4367), // Rule ID 3392 //
     /*   4294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4309 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4313 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   4325 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4329 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4333 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   4337 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   4343 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   4345 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4347 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 14:{ *:[i32] })
     /*   4347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4352 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*   4354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   4358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   4362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4365 */     GIR_RootConstrainSelectedInstOperands,
     /*   4366 */     // GIR_Coverage, 3392,
     /*   4366 */     GIR_EraseRootFromParent_Done,
     /*   4367 */   // Label 229: @4367
     /*   4367 */   GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(4445), // Rule ID 3390 //
     /*   4372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4391 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4395 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4399 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   4403 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4407 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4411 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   4415 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   4421 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   4423 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4425 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 8:{ *:[i32] })
     /*   4425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4430 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*   4432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   4436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   4440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*   4443 */     GIR_RootConstrainSelectedInstOperands,
     /*   4444 */     // GIR_Coverage, 3390,
     /*   4444 */     GIR_EraseRootFromParent_Done,
     /*   4445 */   // Label 230: @4445
     /*   4445 */   GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(4523), // Rule ID 4963 //
     /*   4450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4469 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4473 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4477 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4481 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4485 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4489 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*   4493 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   4499 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   4501 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4503 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 9:{ *:[i32] })
     /*   4503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4508 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*   4510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   4514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   4518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /*   4521 */     GIR_RootConstrainSelectedInstOperands,
     /*   4522 */     // GIR_Coverage, 4963,
     /*   4522 */     GIR_EraseRootFromParent_Done,
     /*   4523 */   // Label 231: @4523
     /*   4523 */   GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(4601), // Rule ID 3391 //
     /*   4528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4547 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4559 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4563 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4567 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   4571 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   4577 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   4579 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4581 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 9:{ *:[i32] })
     /*   4581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4586 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*   4588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   4592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   4596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /*   4599 */     GIR_RootConstrainSelectedInstOperands,
     /*   4600 */     // GIR_Coverage, 3391,
     /*   4600 */     GIR_EraseRootFromParent_Done,
     /*   4601 */   // Label 232: @4601
     /*   4601 */   GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(4679), // Rule ID 4964 //
     /*   4606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4625 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4629 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   4633 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4637 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4641 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4645 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*   4649 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   4655 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   4657 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4659 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, immAllOnesV:{ *:[v4i32] })))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 9:{ *:[i32] })
     /*   4659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4664 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*   4666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   4670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*   4674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /*   4677 */     GIR_RootConstrainSelectedInstOperands,
     /*   4678 */     // GIR_Coverage, 4964,
     /*   4678 */     GIR_EraseRootFromParent_Done,
     /*   4679 */   // Label 233: @4679
     /*   4679 */   GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(4734), // Rule ID 4939 //
     /*   4684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*   4687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4699 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4703 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4707 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   4711 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   4717 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*   4719 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4721 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XB, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$XA)  =>  (XXLANDC:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*   4721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLANDC),
     /*   4724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4726 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*   4728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XB
     /*   4732 */     GIR_RootConstrainSelectedInstOperands,
     /*   4733 */     // GIR_Coverage, 4939,
     /*   4733 */     GIR_EraseRootFromParent_Done,
     /*   4734 */   // Label 234: @4734
     /*   4734 */   GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(4789), // Rule ID 933 //
     /*   4739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*   4742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4754 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4758 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4762 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   4766 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   4772 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*   4774 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4776 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XB, immAllOnesV:{ *:[v4i32] }))  =>  (XXLANDC:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*   4776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLANDC),
     /*   4779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4781 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /*   4783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XB
     /*   4787 */     GIR_RootConstrainSelectedInstOperands,
     /*   4788 */     // GIR_Coverage, 933,
     /*   4788 */     GIR_EraseRootFromParent_Done,
     /*   4789 */   // Label 235: @4789
     /*   4789 */   GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(4839), // Rule ID 4959 //
     /*   4794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   4809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4813 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4819 */     // (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 1:{ *:[i32] })
     /*   4819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*   4828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   4832 */     GIR_RootToRootCopy, /*OpIdx*/2, // vC
     /*   4834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   4837 */     GIR_RootConstrainSelectedInstOperands,
     /*   4838 */     // GIR_Coverage, 4959,
     /*   4838 */     GIR_EraseRootFromParent_Done,
     /*   4839 */   // Label 236: @4839
     /*   4839 */   GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(4889), // Rule ID 4961 //
     /*   4844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*   4859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4869 */     // (and:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 7:{ *:[i32] })
     /*   4869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4874 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*   4876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*   4880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   4884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*   4887 */     GIR_RootConstrainSelectedInstOperands,
     /*   4888 */     // GIR_Coverage, 4961,
     /*   4888 */     GIR_EraseRootFromParent_Done,
     /*   4889 */   // Label 237: @4889
     /*   4889 */   GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(4939), // Rule ID 4960 //
     /*   4894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4913 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4919 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 6:{ *:[i32] })
     /*   4919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4924 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*   4926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*   4930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   4934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   4937 */     GIR_RootConstrainSelectedInstOperands,
     /*   4938 */     // GIR_Coverage, 4960,
     /*   4938 */     GIR_EraseRootFromParent_Done,
     /*   4939 */   // Label 238: @4939
     /*   4939 */   GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(4989), // Rule ID 3387 //
     /*   4944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   4959 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4963 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4969 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 1:{ *:[i32] })
     /*   4969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4974 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*   4976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*   4980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   4984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   4987 */     GIR_RootConstrainSelectedInstOperands,
     /*   4988 */     // GIR_Coverage, 3387,
     /*   4988 */     GIR_EraseRootFromParent_Done,
     /*   4989 */   // Label 239: @4989
     /*   4989 */   GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(5039), // Rule ID 3389 //
     /*   4994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   5001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*   5009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5013 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5019 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 7:{ *:[i32] })
     /*   5019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   5022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   5024 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*   5026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*   5030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   5034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*   5037 */     GIR_RootConstrainSelectedInstOperands,
     /*   5038 */     // GIR_Coverage, 3389,
     /*   5038 */     GIR_EraseRootFromParent_Done,
     /*   5039 */   // Label 240: @5039
     /*   5039 */   GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(5089), // Rule ID 3388 //
     /*   5044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   5047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   5051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5059 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5063 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5069 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 6:{ *:[i32] })
     /*   5069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   5072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   5074 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*   5076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*   5080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   5084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   5087 */     GIR_RootConstrainSelectedInstOperands,
     /*   5088 */     // GIR_Coverage, 3388,
     /*   5088 */     GIR_EraseRootFromParent_Done,
     /*   5089 */   // Label 241: @5089
     /*   5089 */   GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(5108), // Rule ID 932 //
     /*   5094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*   5097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   5101 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)  =>  (XXLAND:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*   5101 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XXLAND),
     /*   5106 */     GIR_RootConstrainSelectedInstOperands,
     /*   5107 */     // GIR_Coverage, 932,
     /*   5107 */     GIR_Done,
     /*   5108 */   // Label 242: @5108
     /*   5108 */   GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(5163), // Rule ID 4927 //
     /*   5113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   5116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   5120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5132 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5136 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   5140 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   5146 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*   5148 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5150 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$VA)  =>  (VANDC:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*   5150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VANDC),
     /*   5153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*   5155 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*   5157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // VB
     /*   5161 */     GIR_RootConstrainSelectedInstOperands,
     /*   5162 */     // GIR_Coverage, 4927,
     /*   5162 */     GIR_EraseRootFromParent_Done,
     /*   5163 */   // Label 243: @5163
     /*   5163 */   GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(5218), // Rule ID 312 //
     /*   5168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   5171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   5175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5187 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5191 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   5195 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   5201 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*   5203 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5205 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB, immAllOnesV:{ *:[v4i32] }))  =>  (VANDC:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*   5205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VANDC),
     /*   5208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*   5210 */     GIR_RootToRootCopy, /*OpIdx*/1, // VA
     /*   5212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // VB
     /*   5216 */     GIR_RootConstrainSelectedInstOperands,
     /*   5217 */     // GIR_Coverage, 312,
     /*   5217 */     GIR_EraseRootFromParent_Done,
     /*   5218 */   // Label 244: @5218
     /*   5218 */   GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(5273), // Rule ID 1384 //
     /*   5223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   5226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   5230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5238 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5242 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5246 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   5250 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   5256 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*   5258 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5260 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$A, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$B, immAllOnesV:{ *:[v4i32] }))  =>  (VANDC:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B)
     /*   5260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VANDC),
     /*   5263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*   5265 */     GIR_RootToRootCopy, /*OpIdx*/1, // A
     /*   5267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // B
     /*   5271 */     GIR_RootConstrainSelectedInstOperands,
     /*   5272 */     // GIR_Coverage, 1384,
     /*   5272 */     GIR_EraseRootFromParent_Done,
     /*   5273 */   // Label 245: @5273
     /*   5273 */   GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(5292), // Rule ID 311 //
     /*   5278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   5281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   5285 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VAND:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*   5285 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VAND),
     /*   5290 */     GIR_RootConstrainSelectedInstOperands,
     /*   5291 */     // GIR_Coverage, 311,
     /*   5291 */     GIR_Done,
     /*   5292 */   // Label 246: @5292
     /*   5292 */   GIM_Reject,
     /*   5293 */ // Label 213: @5293
     /*   5293 */ GIM_Reject,
     /*   5294 */ // Label 200: @5294
     /*   5294 */ GIM_Reject,
     /*   5295 */ // Label 8: @5295
     /*   5295 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(6), /*)*//*default:*//*Label 251*/ GIMT_Encode4(48436),
     /*   5306 */ /*GILLT_s1*//*Label 247*/ GIMT_Encode4(5330),
     /*   5310 */ /*GILLT_s32*//*Label 248*/ GIMT_Encode4(5439),
     /*   5314 */ /*GILLT_s64*//*Label 249*/ GIMT_Encode4(5548), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   5326 */ /*GILLT_v4s32*//*Label 250*/ GIMT_Encode4(5657),
     /*   5330 */ // Label 247: @5330
     /*   5330 */ GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(5438),
     /*   5335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*   5338 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*   5341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*   5345 */   GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(5385), // Rule ID 4925 //
     /*   5350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5358 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*   5362 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*   5366 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   5370 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5372 */     // (or:{ *:[i1] } (xor:{ *:[i1] } i1:{ *:[i1] }:$CRB, -1:{ *:[i1] }), i1:{ *:[i1] }:$CRA)  =>  (CRORC:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*   5372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRORC),
     /*   5375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /*   5377 */     GIR_RootToRootCopy, /*OpIdx*/2, // CRA
     /*   5379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // CRB
     /*   5383 */     GIR_RootConstrainSelectedInstOperands,
     /*   5384 */     // GIR_Coverage, 4925,
     /*   5384 */     GIR_EraseRootFromParent_Done,
     /*   5385 */   // Label 253: @5385
     /*   5385 */   GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(5425), // Rule ID 183 //
     /*   5390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5398 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*   5402 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*   5406 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   5410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5412 */     // (or:{ *:[i1] } i1:{ *:[i1] }:$CRA, (xor:{ *:[i1] } i1:{ *:[i1] }:$CRB, -1:{ *:[i1] }))  =>  (CRORC:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*   5412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRORC),
     /*   5415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /*   5417 */     GIR_RootToRootCopy, /*OpIdx*/1, // CRA
     /*   5419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // CRB
     /*   5423 */     GIR_RootConstrainSelectedInstOperands,
     /*   5424 */     // GIR_Coverage, 183,
     /*   5424 */     GIR_EraseRootFromParent_Done,
     /*   5425 */   // Label 254: @5425
     /*   5425 */   GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(5437), // Rule ID 177 //
     /*   5430 */     // (or:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)  =>  (CROR:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*   5430 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::CROR),
     /*   5435 */     GIR_RootConstrainSelectedInstOperands,
     /*   5436 */     // GIR_Coverage, 177,
     /*   5436 */     GIR_Done,
     /*   5437 */   // Label 255: @5437
     /*   5437 */   GIM_Reject,
     /*   5438 */ // Label 252: @5438
     /*   5438 */ GIM_Reject,
     /*   5439 */ // Label 248: @5439
     /*   5439 */ GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(5547),
     /*   5444 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   5447 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   5450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*   5454 */   GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(5494), // Rule ID 4919 //
     /*   5459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5471 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5475 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   5479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5481 */     // (or:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$RB, -1:{ *:[i32] }), i32:{ *:[i32] }:$RST)  =>  (ORC:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*   5481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ORC),
     /*   5484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*   5486 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*   5488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RB
     /*   5492 */     GIR_RootConstrainSelectedInstOperands,
     /*   5493 */     // GIR_Coverage, 4919,
     /*   5493 */     GIR_EraseRootFromParent_Done,
     /*   5494 */   // Label 257: @5494
     /*   5494 */   GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(5534), // Rule ID 126 //
     /*   5499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5511 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5515 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   5519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5521 */     // (or:{ *:[i32] } i32:{ *:[i32] }:$RST, (xor:{ *:[i32] } i32:{ *:[i32] }:$RB, -1:{ *:[i32] }))  =>  (ORC:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*   5521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ORC),
     /*   5524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*   5526 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /*   5528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RB
     /*   5532 */     GIR_RootConstrainSelectedInstOperands,
     /*   5533 */     // GIR_Coverage, 126,
     /*   5533 */     GIR_EraseRootFromParent_Done,
     /*   5534 */   // Label 258: @5534
     /*   5534 */   GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(5546), // Rule ID 124 //
     /*   5539 */     // (or:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)  =>  (OR:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*   5539 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::OR),
     /*   5544 */     GIR_RootConstrainSelectedInstOperands,
     /*   5545 */     // GIR_Coverage, 124,
     /*   5545 */     GIR_Done,
     /*   5546 */   // Label 259: @5546
     /*   5546 */   GIM_Reject,
     /*   5547 */ // Label 256: @5547
     /*   5547 */ GIM_Reject,
     /*   5548 */ // Label 249: @5548
     /*   5548 */ GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(5656),
     /*   5553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   5556 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   5559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*   5563 */   GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(5603), // Rule ID 4932 //
     /*   5568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5580 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   5584 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   5588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5590 */     // (or:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$RB, -1:{ *:[i64] }), i64:{ *:[i64] }:$RST)  =>  (ORC8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*   5590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ORC8),
     /*   5593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*   5595 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*   5597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RB
     /*   5601 */     GIR_RootConstrainSelectedInstOperands,
     /*   5602 */     // GIR_Coverage, 4932,
     /*   5602 */     GIR_EraseRootFromParent_Done,
     /*   5603 */   // Label 261: @5603
     /*   5603 */   GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(5643), // Rule ID 650 //
     /*   5608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5620 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   5624 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   5628 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5630 */     // (or:{ *:[i64] } i64:{ *:[i64] }:$RST, (xor:{ *:[i64] } i64:{ *:[i64] }:$RB, -1:{ *:[i64] }))  =>  (ORC8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*   5630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ORC8),
     /*   5633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*   5635 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /*   5637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RB
     /*   5641 */     GIR_RootConstrainSelectedInstOperands,
     /*   5642 */     // GIR_Coverage, 650,
     /*   5642 */     GIR_EraseRootFromParent_Done,
     /*   5643 */   // Label 262: @5643
     /*   5643 */   GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(5655), // Rule ID 648 //
     /*   5648 */     // (or:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)  =>  (OR8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*   5648 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /*   5653 */     GIR_RootConstrainSelectedInstOperands,
     /*   5654 */     // GIR_Coverage, 648,
     /*   5654 */     GIR_Done,
     /*   5655 */   // Label 263: @5655
     /*   5655 */   GIM_Reject,
     /*   5656 */ // Label 260: @5656
     /*   5656 */ GIM_Reject,
     /*   5657 */ // Label 250: @5657
     /*   5657 */ GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(48435),
     /*   5662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5665 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5668 */   GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(5806), // Rule ID 4979 //
     /*   5673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   5676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   5680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   5688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5692 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5696 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5700 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   5704 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5708 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5712 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   5716 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5720 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5724 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5728 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   5732 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   5736 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5740 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   5744 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   5748 */     // MIs[5] vA
     /*   5748 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   5753 */     // MIs[5] vB
     /*   5753 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5758 */     // MIs[4] vC
     /*   5758 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   5763 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   5767 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   5773 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   5775 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   5777 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   5777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   5780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   5782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   5786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*   5790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   5794 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   5804 */     GIR_RootConstrainSelectedInstOperands,
     /*   5805 */     // GIR_Coverage, 4979,
     /*   5805 */     GIR_EraseRootFromParent_Done,
     /*   5806 */   // Label 265: @5806
     /*   5806 */   GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(5944), // Rule ID 4980 //
     /*   5811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   5814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   5818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   5826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5830 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   5842 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5846 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5850 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   5854 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5858 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5862 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5866 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   5870 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   5874 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5878 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   5882 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   5886 */     // MIs[5] vB
     /*   5886 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5891 */     // MIs[5] vA
     /*   5891 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   5896 */     // MIs[4] vC
     /*   5896 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   5901 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   5905 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   5911 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   5913 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   5915 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   5915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   5918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   5920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   5924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*   5928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   5932 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   5942 */     GIR_RootConstrainSelectedInstOperands,
     /*   5943 */     // GIR_Coverage, 4980,
     /*   5943 */     GIR_EraseRootFromParent_Done,
     /*   5944 */   // Label 266: @5944
     /*   5944 */   GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(6082), // Rule ID 4981 //
     /*   5949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   5952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   5956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   5964 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5968 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5972 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5976 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   5980 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5984 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5988 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   5992 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5996 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6000 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6004 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6008 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6012 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6016 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   6020 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6024 */     // MIs[5] vA
     /*   6024 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   6029 */     // MIs[5] vC
     /*   6029 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   6034 */     // MIs[4] vB
     /*   6034 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   6039 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   6043 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   6049 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   6051 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   6053 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   6053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   6056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   6058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   6062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*   6066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   6070 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   6080 */     GIR_RootConstrainSelectedInstOperands,
     /*   6081 */     // GIR_Coverage, 4981,
     /*   6081 */     GIR_EraseRootFromParent_Done,
     /*   6082 */   // Label 267: @6082
     /*   6082 */   GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(6220), // Rule ID 4982 //
     /*   6087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   6090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   6094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6106 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6110 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6114 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6118 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6122 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6126 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6130 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   6134 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6138 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6142 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6146 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6150 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6154 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   6158 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6162 */     // MIs[5] vC
     /*   6162 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   6167 */     // MIs[5] vA
     /*   6167 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   6172 */     // MIs[4] vB
     /*   6172 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   6177 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   6181 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   6187 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   6189 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   6191 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   6191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   6194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   6196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   6200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*   6204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   6208 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   6218 */     GIR_RootConstrainSelectedInstOperands,
     /*   6219 */     // GIR_Coverage, 4982,
     /*   6219 */     GIR_EraseRootFromParent_Done,
     /*   6220 */   // Label 268: @6220
     /*   6220 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(6358), // Rule ID 4983 //
     /*   6225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   6228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   6232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6240 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6244 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6248 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6252 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6256 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6260 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6264 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6268 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   6272 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6276 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6280 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6284 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6288 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6292 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   6296 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6300 */     // MIs[5] vB
     /*   6300 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   6305 */     // MIs[5] vC
     /*   6305 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   6310 */     // MIs[4] vA
     /*   6310 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   6315 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   6319 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   6325 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   6327 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   6329 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   6329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   6332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   6334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   6338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*   6342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   6346 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   6356 */     GIR_RootConstrainSelectedInstOperands,
     /*   6357 */     // GIR_Coverage, 4983,
     /*   6357 */     GIR_EraseRootFromParent_Done,
     /*   6358 */   // Label 269: @6358
     /*   6358 */   GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(6496), // Rule ID 4984 //
     /*   6363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   6366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   6370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6382 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6394 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6398 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6402 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6406 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   6410 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6414 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6418 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6422 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6426 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6430 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   6434 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6438 */     // MIs[5] vC
     /*   6438 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   6443 */     // MIs[5] vB
     /*   6443 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   6448 */     // MIs[4] vA
     /*   6448 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   6453 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   6457 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   6463 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   6465 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   6467 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   6467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   6470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   6472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   6476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*   6480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   6484 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   6494 */     GIR_RootConstrainSelectedInstOperands,
     /*   6495 */     // GIR_Coverage, 4984,
     /*   6495 */     GIR_EraseRootFromParent_Done,
     /*   6496 */   // Label 270: @6496
     /*   6496 */   GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(6634), // Rule ID 4991 //
     /*   6501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   6504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   6508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6516 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6520 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6532 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6536 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6540 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6544 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   6548 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6552 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6556 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6560 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6564 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6568 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   6572 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6576 */     // MIs[5] vA
     /*   6576 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   6581 */     // MIs[5] vB
     /*   6581 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   6586 */     // MIs[4] vC
     /*   6586 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   6591 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   6595 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   6601 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   6603 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   6605 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   6605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   6608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   6610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   6614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   6618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   6622 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   6632 */     GIR_RootConstrainSelectedInstOperands,
     /*   6633 */     // GIR_Coverage, 4991,
     /*   6633 */     GIR_EraseRootFromParent_Done,
     /*   6634 */   // Label 271: @6634
     /*   6634 */   GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(6772), // Rule ID 4992 //
     /*   6639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   6642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   6646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6654 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6658 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6662 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6666 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6670 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6674 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6678 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6682 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   6686 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6690 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6694 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6698 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6702 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6706 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   6710 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6714 */     // MIs[5] vB
     /*   6714 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   6719 */     // MIs[5] vA
     /*   6719 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   6724 */     // MIs[4] vC
     /*   6724 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   6729 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   6733 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   6739 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   6741 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   6743 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   6743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   6746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   6748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   6752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   6756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   6760 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   6770 */     GIR_RootConstrainSelectedInstOperands,
     /*   6771 */     // GIR_Coverage, 4992,
     /*   6771 */     GIR_EraseRootFromParent_Done,
     /*   6772 */   // Label 272: @6772
     /*   6772 */   GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(6910), // Rule ID 4993 //
     /*   6777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   6780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   6784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6796 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6800 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6804 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6808 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6812 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6816 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6820 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   6824 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6828 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6832 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6836 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6840 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6844 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   6848 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6852 */     // MIs[5] vA
     /*   6852 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   6857 */     // MIs[5] vC
     /*   6857 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   6862 */     // MIs[4] vB
     /*   6862 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   6867 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   6871 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   6877 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   6879 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   6881 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   6881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   6884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   6886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   6890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   6894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   6898 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   6908 */     GIR_RootConstrainSelectedInstOperands,
     /*   6909 */     // GIR_Coverage, 4993,
     /*   6909 */     GIR_EraseRootFromParent_Done,
     /*   6910 */   // Label 273: @6910
     /*   6910 */   GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(7048), // Rule ID 4994 //
     /*   6915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   6918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   6922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6930 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6934 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6942 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6946 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6950 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6954 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6958 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   6962 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6966 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6970 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6974 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6978 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6982 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   6986 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6990 */     // MIs[5] vC
     /*   6990 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   6995 */     // MIs[5] vA
     /*   6995 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   7000 */     // MIs[4] vB
     /*   7000 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   7005 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   7009 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   7015 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   7017 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   7019 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   7019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   7022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   7024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   7028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   7032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   7036 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   7046 */     GIR_RootConstrainSelectedInstOperands,
     /*   7047 */     // GIR_Coverage, 4994,
     /*   7047 */     GIR_EraseRootFromParent_Done,
     /*   7048 */   // Label 274: @7048
     /*   7048 */   GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(7186), // Rule ID 4995 //
     /*   7053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   7056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   7060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7072 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7076 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7080 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7084 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7088 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7092 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   7096 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   7100 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7104 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7108 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   7112 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7116 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7120 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   7124 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7128 */     // MIs[5] vB
     /*   7128 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   7133 */     // MIs[5] vC
     /*   7133 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   7138 */     // MIs[4] vA
     /*   7138 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   7143 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   7147 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   7153 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   7155 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   7157 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   7157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   7160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   7162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   7166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   7170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   7174 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   7184 */     GIR_RootConstrainSelectedInstOperands,
     /*   7185 */     // GIR_Coverage, 4995,
     /*   7185 */     GIR_EraseRootFromParent_Done,
     /*   7186 */   // Label 275: @7186
     /*   7186 */   GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(7324), // Rule ID 4996 //
     /*   7191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   7194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   7198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7210 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7214 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7218 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7222 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7226 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7230 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   7234 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   7238 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7242 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7246 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   7250 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7254 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7258 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   7262 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7266 */     // MIs[5] vC
     /*   7266 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   7271 */     // MIs[5] vB
     /*   7271 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   7276 */     // MIs[4] vA
     /*   7276 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   7281 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   7285 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   7291 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   7293 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   7295 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   7295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   7298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   7300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   7304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   7308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   7312 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   7322 */     GIR_RootConstrainSelectedInstOperands,
     /*   7323 */     // GIR_Coverage, 4996,
     /*   7323 */     GIR_EraseRootFromParent_Done,
     /*   7324 */   // Label 276: @7324
     /*   7324 */   GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(7462), // Rule ID 5003 //
     /*   7329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   7332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   7336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7348 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7360 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7364 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7368 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   7372 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   7376 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7380 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7384 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   7388 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7392 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7396 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   7400 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7404 */     // MIs[5] vA
     /*   7404 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   7409 */     // MIs[5] vB
     /*   7409 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   7414 */     // MIs[4] vC
     /*   7414 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   7419 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   7423 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   7429 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   7431 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   7433 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   7433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   7436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   7438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   7442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   7446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   7450 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   7460 */     GIR_RootConstrainSelectedInstOperands,
     /*   7461 */     // GIR_Coverage, 5003,
     /*   7461 */     GIR_EraseRootFromParent_Done,
     /*   7462 */   // Label 277: @7462
     /*   7462 */   GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(7600), // Rule ID 5004 //
     /*   7467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   7470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   7474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7486 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7490 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7494 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7498 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7502 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7506 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   7510 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   7514 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7518 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7522 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   7526 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7530 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7534 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   7538 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7542 */     // MIs[5] vB
     /*   7542 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   7547 */     // MIs[5] vA
     /*   7547 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   7552 */     // MIs[4] vC
     /*   7552 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   7557 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   7561 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   7567 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   7569 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   7571 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   7571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   7574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   7576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   7580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   7584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   7588 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   7598 */     GIR_RootConstrainSelectedInstOperands,
     /*   7599 */     // GIR_Coverage, 5004,
     /*   7599 */     GIR_EraseRootFromParent_Done,
     /*   7600 */   // Label 278: @7600
     /*   7600 */   GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(7738), // Rule ID 5005 //
     /*   7605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   7608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   7612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7624 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7628 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7632 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7636 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7640 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7644 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   7648 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   7652 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7656 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7660 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   7664 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7668 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7672 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   7676 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7680 */     // MIs[5] vA
     /*   7680 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   7685 */     // MIs[5] vC
     /*   7685 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   7690 */     // MIs[4] vB
     /*   7690 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   7695 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   7699 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   7705 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   7707 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   7709 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   7709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   7712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   7714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   7718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   7722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   7726 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   7736 */     GIR_RootConstrainSelectedInstOperands,
     /*   7737 */     // GIR_Coverage, 5005,
     /*   7737 */     GIR_EraseRootFromParent_Done,
     /*   7738 */   // Label 279: @7738
     /*   7738 */   GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(7876), // Rule ID 5006 //
     /*   7743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   7746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   7750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7758 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7762 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7766 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7770 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7774 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7778 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7782 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   7786 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   7790 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7794 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7798 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   7802 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7806 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7810 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   7814 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7818 */     // MIs[5] vC
     /*   7818 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   7823 */     // MIs[5] vA
     /*   7823 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   7828 */     // MIs[4] vB
     /*   7828 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   7833 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   7837 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   7843 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   7845 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   7847 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   7847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   7850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   7852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   7856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   7860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   7864 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   7874 */     GIR_RootConstrainSelectedInstOperands,
     /*   7875 */     // GIR_Coverage, 5006,
     /*   7875 */     GIR_EraseRootFromParent_Done,
     /*   7876 */   // Label 280: @7876
     /*   7876 */   GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(8014), // Rule ID 5007 //
     /*   7881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   7884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   7888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7900 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7904 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7908 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7912 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7916 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7920 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   7924 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   7928 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7932 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7936 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   7940 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7944 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7948 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   7952 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7956 */     // MIs[5] vB
     /*   7956 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   7961 */     // MIs[5] vC
     /*   7961 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   7966 */     // MIs[4] vA
     /*   7966 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   7971 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   7975 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   7981 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   7983 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   7985 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   7985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   7988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   7990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   7994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   7998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   8002 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   8012 */     GIR_RootConstrainSelectedInstOperands,
     /*   8013 */     // GIR_Coverage, 5007,
     /*   8013 */     GIR_EraseRootFromParent_Done,
     /*   8014 */   // Label 281: @8014
     /*   8014 */   GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(8152), // Rule ID 5008 //
     /*   8019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   8022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   8026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8034 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8038 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8046 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8050 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8054 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8058 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   8062 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   8066 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8070 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8074 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   8078 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8082 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8086 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   8090 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8094 */     // MIs[5] vC
     /*   8094 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   8099 */     // MIs[5] vB
     /*   8099 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   8104 */     // MIs[4] vA
     /*   8104 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   8109 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   8113 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   8119 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   8121 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   8123 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   8123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   8126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   8128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   8132 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   8136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   8140 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   8150 */     GIR_RootConstrainSelectedInstOperands,
     /*   8151 */     // GIR_Coverage, 5008,
     /*   8151 */     GIR_EraseRootFromParent_Done,
     /*   8152 */   // Label 282: @8152
     /*   8152 */   GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(8290), // Rule ID 5015 //
     /*   8157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   8160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   8164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8176 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8180 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8184 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8188 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8192 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8196 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   8200 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   8204 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8208 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8212 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   8216 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8220 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8224 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   8228 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8232 */     // MIs[5] vA
     /*   8232 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   8237 */     // MIs[5] vB
     /*   8237 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   8242 */     // MIs[4] vC
     /*   8242 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   8247 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   8251 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   8257 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   8259 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   8261 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   8261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   8264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   8266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   8270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   8274 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*   8278 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   8288 */     GIR_RootConstrainSelectedInstOperands,
     /*   8289 */     // GIR_Coverage, 5015,
     /*   8289 */     GIR_EraseRootFromParent_Done,
     /*   8290 */   // Label 283: @8290
     /*   8290 */   GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(8428), // Rule ID 5016 //
     /*   8295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   8298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   8302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8310 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8314 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8326 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8330 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8334 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   8338 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   8342 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8346 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8350 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   8354 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8358 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8362 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   8366 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8370 */     // MIs[5] vB
     /*   8370 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   8375 */     // MIs[5] vA
     /*   8375 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   8380 */     // MIs[4] vC
     /*   8380 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   8385 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   8389 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   8395 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   8397 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   8399 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   8399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   8402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   8404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   8408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   8412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*   8416 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   8426 */     GIR_RootConstrainSelectedInstOperands,
     /*   8427 */     // GIR_Coverage, 5016,
     /*   8427 */     GIR_EraseRootFromParent_Done,
     /*   8428 */   // Label 284: @8428
     /*   8428 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(8566), // Rule ID 5017 //
     /*   8433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   8436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   8440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8452 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8464 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8468 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8472 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   8476 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   8480 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8484 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8488 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   8492 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8496 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8500 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   8504 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8508 */     // MIs[5] vA
     /*   8508 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   8513 */     // MIs[5] vC
     /*   8513 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   8518 */     // MIs[4] vB
     /*   8518 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   8523 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   8527 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   8533 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   8535 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   8537 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   8537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   8540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   8542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   8546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   8550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*   8554 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   8564 */     GIR_RootConstrainSelectedInstOperands,
     /*   8565 */     // GIR_Coverage, 5017,
     /*   8565 */     GIR_EraseRootFromParent_Done,
     /*   8566 */   // Label 285: @8566
     /*   8566 */   GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(8704), // Rule ID 5018 //
     /*   8571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   8574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   8578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8590 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8598 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8602 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8606 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8610 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   8614 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   8618 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8622 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8626 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   8630 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8634 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8638 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   8642 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8646 */     // MIs[5] vC
     /*   8646 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   8651 */     // MIs[5] vA
     /*   8651 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   8656 */     // MIs[4] vB
     /*   8656 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   8661 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   8665 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   8671 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   8673 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   8675 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   8675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   8678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   8680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   8684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   8688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*   8692 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   8702 */     GIR_RootConstrainSelectedInstOperands,
     /*   8703 */     // GIR_Coverage, 5018,
     /*   8703 */     GIR_EraseRootFromParent_Done,
     /*   8704 */   // Label 286: @8704
     /*   8704 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(8842), // Rule ID 5019 //
     /*   8709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   8712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   8716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8728 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8732 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8736 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8740 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8744 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8748 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   8752 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   8756 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8760 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8764 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   8768 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8772 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8776 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   8780 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8784 */     // MIs[5] vB
     /*   8784 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   8789 */     // MIs[5] vC
     /*   8789 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   8794 */     // MIs[4] vA
     /*   8794 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   8799 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   8803 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   8809 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   8811 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   8813 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   8813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   8816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   8818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   8822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   8826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*   8830 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   8840 */     GIR_RootConstrainSelectedInstOperands,
     /*   8841 */     // GIR_Coverage, 5019,
     /*   8841 */     GIR_EraseRootFromParent_Done,
     /*   8842 */   // Label 287: @8842
     /*   8842 */   GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(8980), // Rule ID 5020 //
     /*   8847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   8850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   8854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8862 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8866 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8870 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8874 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8878 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8882 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8886 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   8890 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   8894 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8898 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8902 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   8906 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8910 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8914 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   8918 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8922 */     // MIs[5] vC
     /*   8922 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   8927 */     // MIs[5] vB
     /*   8927 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   8932 */     // MIs[4] vA
     /*   8932 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   8937 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   8941 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   8947 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   8949 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   8951 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   8951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   8954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   8956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   8960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   8964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*   8968 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   8978 */     GIR_RootConstrainSelectedInstOperands,
     /*   8979 */     // GIR_Coverage, 5020,
     /*   8979 */     GIR_EraseRootFromParent_Done,
     /*   8980 */   // Label 288: @8980
     /*   8980 */   GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(9118), // Rule ID 5027 //
     /*   8985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   8988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   8992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9000 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9004 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9008 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9012 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9016 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9020 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9024 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   9028 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   9032 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9036 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9040 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   9044 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9048 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9052 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   9056 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9060 */     // MIs[5] vA
     /*   9060 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   9065 */     // MIs[5] vB
     /*   9065 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   9070 */     // MIs[4] vC
     /*   9070 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   9075 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   9079 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   9085 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   9087 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   9089 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   9089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   9092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   9094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*   9098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   9102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   9106 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   9116 */     GIR_RootConstrainSelectedInstOperands,
     /*   9117 */     // GIR_Coverage, 5027,
     /*   9117 */     GIR_EraseRootFromParent_Done,
     /*   9118 */   // Label 289: @9118
     /*   9118 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(9256), // Rule ID 5028 //
     /*   9123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   9126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   9130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9138 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9142 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9146 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9150 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9154 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9158 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9162 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   9166 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   9170 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9174 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9178 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   9182 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9186 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9190 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   9194 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9198 */     // MIs[5] vB
     /*   9198 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   9203 */     // MIs[5] vA
     /*   9203 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   9208 */     // MIs[4] vC
     /*   9208 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   9213 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   9217 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   9223 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   9225 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   9227 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   9227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   9230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   9232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*   9236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   9240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   9244 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   9254 */     GIR_RootConstrainSelectedInstOperands,
     /*   9255 */     // GIR_Coverage, 5028,
     /*   9255 */     GIR_EraseRootFromParent_Done,
     /*   9256 */   // Label 290: @9256
     /*   9256 */   GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(9394), // Rule ID 5029 //
     /*   9261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   9264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   9268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9280 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9284 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9288 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9292 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9296 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9300 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   9304 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   9308 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9312 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9316 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   9320 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9324 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9328 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   9332 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9336 */     // MIs[5] vA
     /*   9336 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   9341 */     // MIs[5] vC
     /*   9341 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   9346 */     // MIs[4] vB
     /*   9346 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   9351 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   9355 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   9361 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   9363 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   9365 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   9365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   9368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   9370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*   9374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   9378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   9382 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   9392 */     GIR_RootConstrainSelectedInstOperands,
     /*   9393 */     // GIR_Coverage, 5029,
     /*   9393 */     GIR_EraseRootFromParent_Done,
     /*   9394 */   // Label 291: @9394
     /*   9394 */   GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(9532), // Rule ID 5030 //
     /*   9399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   9402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   9406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9414 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9418 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9422 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9426 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9430 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9434 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9438 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   9442 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   9446 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9450 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9454 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   9458 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9462 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9466 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   9470 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9474 */     // MIs[5] vC
     /*   9474 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   9479 */     // MIs[5] vA
     /*   9479 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   9484 */     // MIs[4] vB
     /*   9484 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   9489 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   9493 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   9499 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   9501 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   9503 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   9503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   9506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   9508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*   9512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   9516 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   9520 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   9530 */     GIR_RootConstrainSelectedInstOperands,
     /*   9531 */     // GIR_Coverage, 5030,
     /*   9531 */     GIR_EraseRootFromParent_Done,
     /*   9532 */   // Label 292: @9532
     /*   9532 */   GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(9670), // Rule ID 5031 //
     /*   9537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   9540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   9544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9556 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9560 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9564 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9568 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9572 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9576 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   9580 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   9584 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9588 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9592 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   9596 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9600 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9604 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   9608 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9612 */     // MIs[5] vB
     /*   9612 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   9617 */     // MIs[5] vC
     /*   9617 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   9622 */     // MIs[4] vA
     /*   9622 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   9627 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   9631 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   9637 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   9639 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   9641 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   9641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   9644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   9646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*   9650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   9654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   9658 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   9668 */     GIR_RootConstrainSelectedInstOperands,
     /*   9669 */     // GIR_Coverage, 5031,
     /*   9669 */     GIR_EraseRootFromParent_Done,
     /*   9670 */   // Label 293: @9670
     /*   9670 */   GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(9808), // Rule ID 5032 //
     /*   9675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   9678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   9682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9690 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9694 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9702 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9706 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9710 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9714 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   9718 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   9722 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9726 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9730 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   9734 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9738 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9742 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   9746 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9750 */     // MIs[5] vC
     /*   9750 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   9755 */     // MIs[5] vB
     /*   9755 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   9760 */     // MIs[4] vA
     /*   9760 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   9765 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   9769 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   9775 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   9777 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   9779 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   9779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   9782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   9784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*   9788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   9792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   9796 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   9806 */     GIR_RootConstrainSelectedInstOperands,
     /*   9807 */     // GIR_Coverage, 5032,
     /*   9807 */     GIR_EraseRootFromParent_Done,
     /*   9808 */   // Label 294: @9808
     /*   9808 */   GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(9946), // Rule ID 5039 //
     /*   9813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   9816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   9820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9832 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9836 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9840 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9844 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9848 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9852 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   9856 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   9860 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9864 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9868 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   9872 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9876 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9880 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   9884 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9888 */     // MIs[5] vA
     /*   9888 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   9893 */     // MIs[5] vB
     /*   9893 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   9898 */     // MIs[4] vC
     /*   9898 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   9903 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   9907 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   9913 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   9915 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   9917 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   9917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   9920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   9922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*   9926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*   9930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*   9934 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   9944 */     GIR_RootConstrainSelectedInstOperands,
     /*   9945 */     // GIR_Coverage, 5039,
     /*   9945 */     GIR_EraseRootFromParent_Done,
     /*   9946 */   // Label 295: @9946
     /*   9946 */   GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(10084), // Rule ID 5040 //
     /*   9951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   9954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   9958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9970 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9974 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9978 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9982 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9986 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9990 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   9994 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   9998 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10002 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10006 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  10010 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10014 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10018 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  10022 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10026 */     // MIs[5] vB
     /*  10026 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  10031 */     // MIs[5] vA
     /*  10031 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10036 */     // MIs[4] vC
     /*  10036 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  10041 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  10045 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  10051 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  10053 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  10055 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  10055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  10058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  10060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  10064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  10068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  10072 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  10082 */     GIR_RootConstrainSelectedInstOperands,
     /*  10083 */     // GIR_Coverage, 5040,
     /*  10083 */     GIR_EraseRootFromParent_Done,
     /*  10084 */   // Label 296: @10084
     /*  10084 */   GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(10222), // Rule ID 5041 //
     /*  10089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  10092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  10096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10108 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10112 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10116 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10120 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10124 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10128 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  10132 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  10136 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10140 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10144 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  10148 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10152 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10156 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  10160 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10164 */     // MIs[5] vA
     /*  10164 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10169 */     // MIs[5] vC
     /*  10169 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  10174 */     // MIs[4] vB
     /*  10174 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  10179 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  10183 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  10189 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  10191 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  10193 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  10193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  10196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  10198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  10202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  10206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  10210 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  10220 */     GIR_RootConstrainSelectedInstOperands,
     /*  10221 */     // GIR_Coverage, 5041,
     /*  10221 */     GIR_EraseRootFromParent_Done,
     /*  10222 */   // Label 297: @10222
     /*  10222 */   GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(10360), // Rule ID 5042 //
     /*  10227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  10230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  10234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10246 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10258 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10262 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10266 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  10270 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  10274 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10278 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10282 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  10286 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10290 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10294 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  10298 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10302 */     // MIs[5] vC
     /*  10302 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  10307 */     // MIs[5] vA
     /*  10307 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10312 */     // MIs[4] vB
     /*  10312 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  10317 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  10321 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  10327 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  10329 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  10331 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  10331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  10334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  10336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  10340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  10344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  10348 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  10358 */     GIR_RootConstrainSelectedInstOperands,
     /*  10359 */     // GIR_Coverage, 5042,
     /*  10359 */     GIR_EraseRootFromParent_Done,
     /*  10360 */   // Label 298: @10360
     /*  10360 */   GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(10498), // Rule ID 5043 //
     /*  10365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  10368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  10372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10384 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10388 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10392 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10396 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10400 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10404 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  10408 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  10412 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10416 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10420 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  10424 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10428 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10432 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  10436 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10440 */     // MIs[5] vB
     /*  10440 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  10445 */     // MIs[5] vC
     /*  10445 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  10450 */     // MIs[4] vA
     /*  10450 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10455 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  10459 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  10465 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  10467 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  10469 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  10469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  10472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  10474 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  10478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  10482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  10486 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  10496 */     GIR_RootConstrainSelectedInstOperands,
     /*  10497 */     // GIR_Coverage, 5043,
     /*  10497 */     GIR_EraseRootFromParent_Done,
     /*  10498 */   // Label 299: @10498
     /*  10498 */   GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(10636), // Rule ID 5044 //
     /*  10503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  10506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  10510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10522 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10534 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10538 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10542 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  10546 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  10550 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10554 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10558 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  10562 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10566 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10570 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  10574 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10578 */     // MIs[5] vC
     /*  10578 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  10583 */     // MIs[5] vB
     /*  10583 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  10588 */     // MIs[4] vA
     /*  10588 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10593 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  10597 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  10603 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  10605 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  10607 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  10607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  10610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  10612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  10616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  10620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  10624 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  10634 */     GIR_RootConstrainSelectedInstOperands,
     /*  10635 */     // GIR_Coverage, 5044,
     /*  10635 */     GIR_EraseRootFromParent_Done,
     /*  10636 */   // Label 300: @10636
     /*  10636 */   GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(10774), // Rule ID 4985 //
     /*  10641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  10644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  10648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10660 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10664 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10668 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10672 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10676 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10680 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  10684 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  10688 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10692 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10696 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  10700 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10704 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10708 */     // MIs[4] vC
     /*  10708 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10713 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  10717 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10721 */     // MIs[5] vA
     /*  10721 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  10726 */     // MIs[5] vB
     /*  10726 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  10731 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  10735 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  10741 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  10743 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  10745 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  10745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  10748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  10750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  10754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  10758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  10762 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  10772 */     GIR_RootConstrainSelectedInstOperands,
     /*  10773 */     // GIR_Coverage, 4985,
     /*  10773 */     GIR_EraseRootFromParent_Done,
     /*  10774 */   // Label 301: @10774
     /*  10774 */   GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(10912), // Rule ID 4986 //
     /*  10779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  10782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  10786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10798 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10810 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10814 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10818 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  10822 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  10826 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10830 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10834 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  10838 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10842 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10846 */     // MIs[4] vC
     /*  10846 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10851 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  10855 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10859 */     // MIs[5] vB
     /*  10859 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  10864 */     // MIs[5] vA
     /*  10864 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  10869 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  10873 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  10879 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  10881 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  10883 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  10883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  10886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  10888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  10892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  10896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  10900 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  10910 */     GIR_RootConstrainSelectedInstOperands,
     /*  10911 */     // GIR_Coverage, 4986,
     /*  10911 */     GIR_EraseRootFromParent_Done,
     /*  10912 */   // Label 302: @10912
     /*  10912 */   GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(11050), // Rule ID 4987 //
     /*  10917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  10920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  10924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10936 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10948 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10952 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10956 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  10960 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  10964 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10968 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10972 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  10976 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10980 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10984 */     // MIs[4] vB
     /*  10984 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  10989 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  10993 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10997 */     // MIs[5] vA
     /*  10997 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11002 */     // MIs[5] vC
     /*  11002 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11007 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  11011 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  11017 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  11019 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11021 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  11021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  11024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  11026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  11030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  11034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  11038 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  11048 */     GIR_RootConstrainSelectedInstOperands,
     /*  11049 */     // GIR_Coverage, 4987,
     /*  11049 */     GIR_EraseRootFromParent_Done,
     /*  11050 */   // Label 303: @11050
     /*  11050 */   GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(11188), // Rule ID 4988 //
     /*  11055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  11058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  11062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11074 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11082 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11086 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11090 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11094 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  11098 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  11102 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11106 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11110 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  11114 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11118 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11122 */     // MIs[4] vB
     /*  11122 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  11127 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  11131 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11135 */     // MIs[5] vC
     /*  11135 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11140 */     // MIs[5] vA
     /*  11140 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11145 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  11149 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  11155 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  11157 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11159 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  11159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  11162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  11164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  11168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  11172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  11176 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  11186 */     GIR_RootConstrainSelectedInstOperands,
     /*  11187 */     // GIR_Coverage, 4988,
     /*  11187 */     GIR_EraseRootFromParent_Done,
     /*  11188 */   // Label 304: @11188
     /*  11188 */   GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(11326), // Rule ID 4989 //
     /*  11193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  11196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  11200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11208 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11212 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11216 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11220 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11224 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11228 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11232 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  11236 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  11240 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11244 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11248 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  11252 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11256 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11260 */     // MIs[4] vA
     /*  11260 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11265 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  11269 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11273 */     // MIs[5] vB
     /*  11273 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  11278 */     // MIs[5] vC
     /*  11278 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11283 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  11287 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  11293 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  11295 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11297 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  11297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  11300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  11302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  11306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  11310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  11314 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  11324 */     GIR_RootConstrainSelectedInstOperands,
     /*  11325 */     // GIR_Coverage, 4989,
     /*  11325 */     GIR_EraseRootFromParent_Done,
     /*  11326 */   // Label 305: @11326
     /*  11326 */   GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(11464), // Rule ID 4990 //
     /*  11331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  11334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  11338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11346 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11350 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11358 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11362 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11366 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11370 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  11374 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  11378 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11382 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11386 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  11390 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11394 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11398 */     // MIs[4] vA
     /*  11398 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11403 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  11407 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11411 */     // MIs[5] vC
     /*  11411 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11416 */     // MIs[5] vB
     /*  11416 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  11421 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  11425 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  11431 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  11433 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11435 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  11435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  11438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  11440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  11444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  11448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  11452 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  11462 */     GIR_RootConstrainSelectedInstOperands,
     /*  11463 */     // GIR_Coverage, 4990,
     /*  11463 */     GIR_EraseRootFromParent_Done,
     /*  11464 */   // Label 306: @11464
     /*  11464 */   GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(11602), // Rule ID 4997 //
     /*  11469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  11472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  11476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11488 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11492 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11496 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11500 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11504 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11508 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  11512 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  11516 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11520 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11524 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  11528 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11532 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11536 */     // MIs[4] vC
     /*  11536 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11541 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  11545 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11549 */     // MIs[5] vA
     /*  11549 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  11554 */     // MIs[5] vB
     /*  11554 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11559 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  11563 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  11569 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  11571 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11573 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  11573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  11576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  11578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  11582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  11586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  11590 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  11600 */     GIR_RootConstrainSelectedInstOperands,
     /*  11601 */     // GIR_Coverage, 4997,
     /*  11601 */     GIR_EraseRootFromParent_Done,
     /*  11602 */   // Label 307: @11602
     /*  11602 */   GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(11740), // Rule ID 4998 //
     /*  11607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  11610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  11614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11626 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11630 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11634 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11638 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11642 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11646 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  11650 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  11654 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11658 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11662 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  11666 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11670 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11674 */     // MIs[4] vC
     /*  11674 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11679 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  11683 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11687 */     // MIs[5] vB
     /*  11687 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11692 */     // MIs[5] vA
     /*  11692 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  11697 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  11701 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  11707 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  11709 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11711 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  11711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  11714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  11716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  11720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  11724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  11728 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  11738 */     GIR_RootConstrainSelectedInstOperands,
     /*  11739 */     // GIR_Coverage, 4998,
     /*  11739 */     GIR_EraseRootFromParent_Done,
     /*  11740 */   // Label 308: @11740
     /*  11740 */   GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(11878), // Rule ID 4999 //
     /*  11745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  11748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  11752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11760 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11764 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11776 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11780 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11784 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  11788 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  11792 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11796 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11800 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  11804 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11808 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11812 */     // MIs[4] vB
     /*  11812 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11817 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  11821 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11825 */     // MIs[5] vA
     /*  11825 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  11830 */     // MIs[5] vC
     /*  11830 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11835 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  11839 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  11845 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  11847 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11849 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  11849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  11852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  11854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  11858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  11862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  11866 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  11876 */     GIR_RootConstrainSelectedInstOperands,
     /*  11877 */     // GIR_Coverage, 4999,
     /*  11877 */     GIR_EraseRootFromParent_Done,
     /*  11878 */   // Label 309: @11878
     /*  11878 */   GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(12016), // Rule ID 5000 //
     /*  11883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  11886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  11890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11902 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11906 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11910 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11914 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11918 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11922 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  11926 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  11930 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11934 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11938 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  11942 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11946 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11950 */     // MIs[4] vB
     /*  11950 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11955 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  11959 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11963 */     // MIs[5] vC
     /*  11963 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11968 */     // MIs[5] vA
     /*  11968 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  11973 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  11977 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  11983 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  11985 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11987 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  11987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  11990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  11992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  11996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  12000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  12004 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  12014 */     GIR_RootConstrainSelectedInstOperands,
     /*  12015 */     // GIR_Coverage, 5000,
     /*  12015 */     GIR_EraseRootFromParent_Done,
     /*  12016 */   // Label 310: @12016
     /*  12016 */   GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(12154), // Rule ID 5001 //
     /*  12021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  12024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  12028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12040 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12052 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12056 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12060 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12064 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  12068 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12072 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12076 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12080 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12084 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12088 */     // MIs[4] vA
     /*  12088 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  12093 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  12097 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12101 */     // MIs[5] vB
     /*  12101 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12106 */     // MIs[5] vC
     /*  12106 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  12111 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  12115 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  12121 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  12123 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  12125 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  12125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  12128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  12130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  12134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  12138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  12142 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  12152 */     GIR_RootConstrainSelectedInstOperands,
     /*  12153 */     // GIR_Coverage, 5001,
     /*  12153 */     GIR_EraseRootFromParent_Done,
     /*  12154 */   // Label 311: @12154
     /*  12154 */   GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(12292), // Rule ID 5002 //
     /*  12159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  12162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  12166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12174 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12178 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12182 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12186 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12190 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12194 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12198 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12202 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  12206 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12210 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12214 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12218 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12222 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12226 */     // MIs[4] vA
     /*  12226 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  12231 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  12235 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12239 */     // MIs[5] vC
     /*  12239 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  12244 */     // MIs[5] vB
     /*  12244 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12249 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  12253 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  12259 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  12261 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  12263 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  12263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  12266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  12268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  12272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  12276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  12280 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  12290 */     GIR_RootConstrainSelectedInstOperands,
     /*  12291 */     // GIR_Coverage, 5002,
     /*  12291 */     GIR_EraseRootFromParent_Done,
     /*  12292 */   // Label 312: @12292
     /*  12292 */   GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(12430), // Rule ID 5009 //
     /*  12297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  12300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  12304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12316 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12320 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12324 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12328 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12332 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12336 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12340 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  12344 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12348 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12352 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12356 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12360 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12364 */     // MIs[4] vC
     /*  12364 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  12369 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  12373 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12377 */     // MIs[5] vA
     /*  12377 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12382 */     // MIs[5] vB
     /*  12382 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  12387 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  12391 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  12397 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  12399 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  12401 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  12401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  12404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  12406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  12410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  12414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  12418 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  12428 */     GIR_RootConstrainSelectedInstOperands,
     /*  12429 */     // GIR_Coverage, 5009,
     /*  12429 */     GIR_EraseRootFromParent_Done,
     /*  12430 */   // Label 313: @12430
     /*  12430 */   GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(12568), // Rule ID 5010 //
     /*  12435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  12438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  12442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12454 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12462 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12466 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12470 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12474 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12478 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  12482 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12486 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12490 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12494 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12498 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12502 */     // MIs[4] vC
     /*  12502 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  12507 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  12511 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12515 */     // MIs[5] vB
     /*  12515 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  12520 */     // MIs[5] vA
     /*  12520 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12525 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  12529 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  12535 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  12537 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  12539 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  12539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  12542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  12544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  12548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  12552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  12556 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  12566 */     GIR_RootConstrainSelectedInstOperands,
     /*  12567 */     // GIR_Coverage, 5010,
     /*  12567 */     GIR_EraseRootFromParent_Done,
     /*  12568 */   // Label 314: @12568
     /*  12568 */   GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(12706), // Rule ID 5011 //
     /*  12573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  12576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  12580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12596 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12600 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12604 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12608 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12612 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12616 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  12620 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12624 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12628 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12632 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12636 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12640 */     // MIs[4] vB
     /*  12640 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  12645 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  12649 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12653 */     // MIs[5] vA
     /*  12653 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12658 */     // MIs[5] vC
     /*  12658 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  12663 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  12667 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  12673 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  12675 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  12677 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  12677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  12680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  12682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  12686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  12690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  12694 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  12704 */     GIR_RootConstrainSelectedInstOperands,
     /*  12705 */     // GIR_Coverage, 5011,
     /*  12705 */     GIR_EraseRootFromParent_Done,
     /*  12706 */   // Label 315: @12706
     /*  12706 */   GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(12844), // Rule ID 5012 //
     /*  12711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  12714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  12718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12730 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12734 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12738 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12742 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12746 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12750 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12754 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  12758 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12762 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12766 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12770 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12774 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12778 */     // MIs[4] vB
     /*  12778 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  12783 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  12787 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12791 */     // MIs[5] vC
     /*  12791 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  12796 */     // MIs[5] vA
     /*  12796 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12801 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  12805 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  12811 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  12813 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  12815 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  12815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  12818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  12820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  12824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  12828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  12832 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  12842 */     GIR_RootConstrainSelectedInstOperands,
     /*  12843 */     // GIR_Coverage, 5012,
     /*  12843 */     GIR_EraseRootFromParent_Done,
     /*  12844 */   // Label 316: @12844
     /*  12844 */   GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(12982), // Rule ID 5013 //
     /*  12849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  12852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  12856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12868 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12880 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12884 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12888 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12892 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  12896 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12900 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12904 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12908 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12912 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12916 */     // MIs[4] vA
     /*  12916 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12921 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  12925 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12929 */     // MIs[5] vB
     /*  12929 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  12934 */     // MIs[5] vC
     /*  12934 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  12939 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  12943 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  12949 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  12951 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  12953 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  12953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  12956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  12958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  12962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  12966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  12970 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  12980 */     GIR_RootConstrainSelectedInstOperands,
     /*  12981 */     // GIR_Coverage, 5013,
     /*  12981 */     GIR_EraseRootFromParent_Done,
     /*  12982 */   // Label 317: @12982
     /*  12982 */   GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(13120), // Rule ID 5014 //
     /*  12987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  12990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  12994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13006 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13010 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13014 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13018 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13022 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13026 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  13030 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  13034 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13038 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13042 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  13046 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13050 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13054 */     // MIs[4] vA
     /*  13054 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  13059 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  13063 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13067 */     // MIs[5] vC
     /*  13067 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  13072 */     // MIs[5] vB
     /*  13072 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  13077 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  13081 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  13087 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  13089 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  13091 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  13091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  13094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  13096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  13100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  13104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  13108 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  13118 */     GIR_RootConstrainSelectedInstOperands,
     /*  13119 */     // GIR_Coverage, 5014,
     /*  13119 */     GIR_EraseRootFromParent_Done,
     /*  13120 */   // Label 318: @13120
     /*  13120 */   GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(13258), // Rule ID 5021 //
     /*  13125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  13128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  13132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13144 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13148 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13152 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13156 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13160 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13164 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  13168 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  13172 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13176 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13180 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  13184 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13188 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13192 */     // MIs[4] vC
     /*  13192 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  13197 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  13201 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13205 */     // MIs[5] vA
     /*  13205 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  13210 */     // MIs[5] vB
     /*  13210 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  13215 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  13219 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  13225 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  13227 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  13229 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  13229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  13232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  13234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  13238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  13242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  13246 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  13256 */     GIR_RootConstrainSelectedInstOperands,
     /*  13257 */     // GIR_Coverage, 5021,
     /*  13257 */     GIR_EraseRootFromParent_Done,
     /*  13258 */   // Label 319: @13258
     /*  13258 */   GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(13396), // Rule ID 5022 //
     /*  13263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  13266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  13270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13282 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13294 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13298 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13302 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  13306 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  13310 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13314 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13318 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  13322 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13326 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13330 */     // MIs[4] vC
     /*  13330 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  13335 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  13339 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13343 */     // MIs[5] vB
     /*  13343 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  13348 */     // MIs[5] vA
     /*  13348 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  13353 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  13357 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  13363 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  13365 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  13367 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  13367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  13370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  13372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  13376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  13380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  13384 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  13394 */     GIR_RootConstrainSelectedInstOperands,
     /*  13395 */     // GIR_Coverage, 5022,
     /*  13395 */     GIR_EraseRootFromParent_Done,
     /*  13396 */   // Label 320: @13396
     /*  13396 */   GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(13534), // Rule ID 5023 //
     /*  13401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  13404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  13408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13420 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13424 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13428 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13432 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13436 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13440 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  13444 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  13448 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13452 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13456 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  13460 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13464 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13468 */     // MIs[4] vB
     /*  13468 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  13473 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  13477 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13481 */     // MIs[5] vA
     /*  13481 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  13486 */     // MIs[5] vC
     /*  13486 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  13491 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  13495 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  13501 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  13503 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  13505 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  13505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  13508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  13510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  13514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  13518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  13522 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  13532 */     GIR_RootConstrainSelectedInstOperands,
     /*  13533 */     // GIR_Coverage, 5023,
     /*  13533 */     GIR_EraseRootFromParent_Done,
     /*  13534 */   // Label 321: @13534
     /*  13534 */   GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(13672), // Rule ID 5024 //
     /*  13539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  13542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  13546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13554 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13558 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13562 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13566 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13570 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13574 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13578 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  13582 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  13586 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13590 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13594 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  13598 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13602 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13606 */     // MIs[4] vB
     /*  13606 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  13611 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  13615 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13619 */     // MIs[5] vC
     /*  13619 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  13624 */     // MIs[5] vA
     /*  13624 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  13629 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  13633 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  13639 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  13641 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  13643 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  13643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  13646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  13648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  13652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  13656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  13660 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  13670 */     GIR_RootConstrainSelectedInstOperands,
     /*  13671 */     // GIR_Coverage, 5024,
     /*  13671 */     GIR_EraseRootFromParent_Done,
     /*  13672 */   // Label 322: @13672
     /*  13672 */   GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(13810), // Rule ID 5025 //
     /*  13677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  13680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  13684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13696 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13700 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13704 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13708 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13712 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13716 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  13720 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  13724 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13728 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13732 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  13736 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13740 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13744 */     // MIs[4] vA
     /*  13744 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  13749 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  13753 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13757 */     // MIs[5] vB
     /*  13757 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  13762 */     // MIs[5] vC
     /*  13762 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  13767 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  13771 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  13777 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  13779 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  13781 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  13781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  13784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  13786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  13790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  13794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  13798 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  13808 */     GIR_RootConstrainSelectedInstOperands,
     /*  13809 */     // GIR_Coverage, 5025,
     /*  13809 */     GIR_EraseRootFromParent_Done,
     /*  13810 */   // Label 323: @13810
     /*  13810 */   GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(13948), // Rule ID 5026 //
     /*  13815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  13818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  13822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13834 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13838 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13842 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13846 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13850 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13854 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  13858 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  13862 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13866 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13870 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  13874 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13878 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13882 */     // MIs[4] vA
     /*  13882 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  13887 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  13891 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13895 */     // MIs[5] vC
     /*  13895 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  13900 */     // MIs[5] vB
     /*  13900 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  13905 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  13909 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  13915 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  13917 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  13919 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  13919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  13922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  13924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  13928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  13932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  13936 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  13946 */     GIR_RootConstrainSelectedInstOperands,
     /*  13947 */     // GIR_Coverage, 5026,
     /*  13947 */     GIR_EraseRootFromParent_Done,
     /*  13948 */   // Label 324: @13948
     /*  13948 */   GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(14086), // Rule ID 5033 //
     /*  13953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  13956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  13960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13976 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13980 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13984 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13988 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13992 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  13996 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  14000 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14004 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14008 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  14012 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14016 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14020 */     // MIs[4] vC
     /*  14020 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  14025 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  14029 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14033 */     // MIs[5] vA
     /*  14033 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  14038 */     // MIs[5] vB
     /*  14038 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  14043 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  14047 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  14053 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  14055 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  14057 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  14057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  14060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  14062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  14066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  14070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  14074 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  14084 */     GIR_RootConstrainSelectedInstOperands,
     /*  14085 */     // GIR_Coverage, 5033,
     /*  14085 */     GIR_EraseRootFromParent_Done,
     /*  14086 */   // Label 325: @14086
     /*  14086 */   GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(14224), // Rule ID 5034 //
     /*  14091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  14094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  14098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14106 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14110 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14114 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14118 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14122 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14126 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14130 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  14134 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  14138 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14142 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14146 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  14150 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14154 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14158 */     // MIs[4] vC
     /*  14158 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  14163 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  14167 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14171 */     // MIs[5] vB
     /*  14171 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  14176 */     // MIs[5] vA
     /*  14176 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  14181 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  14185 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  14191 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  14193 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  14195 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  14195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  14198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  14200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  14204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  14208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  14212 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  14222 */     GIR_RootConstrainSelectedInstOperands,
     /*  14223 */     // GIR_Coverage, 5034,
     /*  14223 */     GIR_EraseRootFromParent_Done,
     /*  14224 */   // Label 326: @14224
     /*  14224 */   GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(14362), // Rule ID 5035 //
     /*  14229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  14232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  14236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14248 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14260 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14264 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14268 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  14272 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  14276 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14280 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14284 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  14288 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14292 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14296 */     // MIs[4] vB
     /*  14296 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  14301 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  14305 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14309 */     // MIs[5] vA
     /*  14309 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  14314 */     // MIs[5] vC
     /*  14314 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  14319 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  14323 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  14329 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  14331 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  14333 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  14333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  14336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  14338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  14342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  14346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  14350 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  14360 */     GIR_RootConstrainSelectedInstOperands,
     /*  14361 */     // GIR_Coverage, 5035,
     /*  14361 */     GIR_EraseRootFromParent_Done,
     /*  14362 */   // Label 327: @14362
     /*  14362 */   GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(14500), // Rule ID 5036 //
     /*  14367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  14370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  14374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14386 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14394 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14398 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14402 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14406 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  14410 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  14414 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14418 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14422 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  14426 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14430 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14434 */     // MIs[4] vB
     /*  14434 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  14439 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  14443 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14447 */     // MIs[5] vC
     /*  14447 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  14452 */     // MIs[5] vA
     /*  14452 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  14457 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  14461 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  14467 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  14469 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  14471 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  14471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  14474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  14476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  14480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  14484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  14488 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  14498 */     GIR_RootConstrainSelectedInstOperands,
     /*  14499 */     // GIR_Coverage, 5036,
     /*  14499 */     GIR_EraseRootFromParent_Done,
     /*  14500 */   // Label 328: @14500
     /*  14500 */   GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(14638), // Rule ID 5037 //
     /*  14505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  14508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  14512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14520 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14524 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14536 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14540 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14544 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  14548 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  14552 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14556 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14560 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  14564 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14568 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14572 */     // MIs[4] vA
     /*  14572 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  14577 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  14581 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14585 */     // MIs[5] vB
     /*  14585 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  14590 */     // MIs[5] vC
     /*  14590 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  14595 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  14599 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  14605 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  14607 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  14609 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  14609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  14612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  14614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  14618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  14622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  14626 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  14636 */     GIR_RootConstrainSelectedInstOperands,
     /*  14637 */     // GIR_Coverage, 5037,
     /*  14637 */     GIR_EraseRootFromParent_Done,
     /*  14638 */   // Label 329: @14638
     /*  14638 */   GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(14776), // Rule ID 5038 //
     /*  14643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  14646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  14650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14662 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14666 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14670 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14674 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14678 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14682 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  14686 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  14690 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14694 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14698 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  14702 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14706 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14710 */     // MIs[4] vA
     /*  14710 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  14715 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  14719 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14723 */     // MIs[5] vC
     /*  14723 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  14728 */     // MIs[5] vB
     /*  14728 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  14733 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  14737 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  14743 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  14745 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  14747 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  14747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  14750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  14752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  14756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  14760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  14764 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  14774 */     GIR_RootConstrainSelectedInstOperands,
     /*  14775 */     // GIR_Coverage, 5038,
     /*  14775 */     GIR_EraseRootFromParent_Done,
     /*  14776 */   // Label 330: @14776
     /*  14776 */   GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(14914), // Rule ID 5045 //
     /*  14781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  14784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  14788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14800 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14804 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14808 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14812 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14816 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14820 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  14824 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  14828 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14832 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14836 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  14840 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14844 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14848 */     // MIs[4] vC
     /*  14848 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  14853 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  14857 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14861 */     // MIs[5] vA
     /*  14861 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  14866 */     // MIs[5] vB
     /*  14866 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  14871 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  14875 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  14881 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  14883 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  14885 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  14885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  14888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  14890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  14894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  14898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  14902 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  14912 */     GIR_RootConstrainSelectedInstOperands,
     /*  14913 */     // GIR_Coverage, 5045,
     /*  14913 */     GIR_EraseRootFromParent_Done,
     /*  14914 */   // Label 331: @14914
     /*  14914 */   GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(15052), // Rule ID 5046 //
     /*  14919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  14922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  14926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14950 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14954 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14958 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  14962 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  14966 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14970 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14974 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  14978 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14982 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14986 */     // MIs[4] vC
     /*  14986 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  14991 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  14995 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14999 */     // MIs[5] vB
     /*  14999 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  15004 */     // MIs[5] vA
     /*  15004 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  15009 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  15013 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  15019 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  15021 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  15023 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  15023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  15026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  15028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  15032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  15036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  15040 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  15050 */     GIR_RootConstrainSelectedInstOperands,
     /*  15051 */     // GIR_Coverage, 5046,
     /*  15051 */     GIR_EraseRootFromParent_Done,
     /*  15052 */   // Label 332: @15052
     /*  15052 */   GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(15190), // Rule ID 5047 //
     /*  15057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  15060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  15064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15076 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15088 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15092 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15096 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  15100 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  15104 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15108 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15112 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  15116 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15120 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15124 */     // MIs[4] vB
     /*  15124 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  15129 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  15133 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15137 */     // MIs[5] vA
     /*  15137 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  15142 */     // MIs[5] vC
     /*  15142 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  15147 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  15151 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  15157 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  15159 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  15161 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  15161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  15164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  15166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  15170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  15174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  15178 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  15188 */     GIR_RootConstrainSelectedInstOperands,
     /*  15189 */     // GIR_Coverage, 5047,
     /*  15189 */     GIR_EraseRootFromParent_Done,
     /*  15190 */   // Label 333: @15190
     /*  15190 */   GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(15328), // Rule ID 5048 //
     /*  15195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  15198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  15202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15214 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15222 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15226 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15230 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15234 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  15238 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  15242 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15246 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15250 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  15254 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15258 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15262 */     // MIs[4] vB
     /*  15262 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  15267 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  15271 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15275 */     // MIs[5] vC
     /*  15275 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  15280 */     // MIs[5] vA
     /*  15280 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  15285 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  15289 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  15295 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  15297 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  15299 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  15299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  15302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  15304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  15308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  15312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  15316 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  15326 */     GIR_RootConstrainSelectedInstOperands,
     /*  15327 */     // GIR_Coverage, 5048,
     /*  15327 */     GIR_EraseRootFromParent_Done,
     /*  15328 */   // Label 334: @15328
     /*  15328 */   GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(15466), // Rule ID 5049 //
     /*  15333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  15336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  15340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15352 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15356 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15360 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15364 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15368 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15372 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  15376 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  15380 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15384 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15388 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  15392 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15396 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15400 */     // MIs[4] vA
     /*  15400 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  15405 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  15409 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15413 */     // MIs[5] vB
     /*  15413 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  15418 */     // MIs[5] vC
     /*  15418 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  15423 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  15427 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  15433 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  15435 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  15437 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  15437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  15440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  15442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  15446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  15450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  15454 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  15464 */     GIR_RootConstrainSelectedInstOperands,
     /*  15465 */     // GIR_Coverage, 5049,
     /*  15465 */     GIR_EraseRootFromParent_Done,
     /*  15466 */   // Label 335: @15466
     /*  15466 */   GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(15604), // Rule ID 5050 //
     /*  15471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  15474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  15478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15490 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15494 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15498 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15502 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15506 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15510 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  15514 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  15518 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15522 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15526 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  15530 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15534 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15538 */     // MIs[4] vA
     /*  15538 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  15543 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  15547 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15551 */     // MIs[5] vC
     /*  15551 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  15556 */     // MIs[5] vB
     /*  15556 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  15561 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  15565 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  15571 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  15573 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  15575 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  15575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  15578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  15580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  15584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  15588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  15592 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  15602 */     GIR_RootConstrainSelectedInstOperands,
     /*  15603 */     // GIR_Coverage, 5050,
     /*  15603 */     GIR_EraseRootFromParent_Done,
     /*  15604 */   // Label 336: @15604
     /*  15604 */   GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(15742), // Rule ID 5051 //
     /*  15609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  15612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  15616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15628 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15632 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15636 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15640 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15644 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15648 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  15652 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  15656 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15660 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15664 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  15668 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15672 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15676 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  15680 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15684 */     // MIs[5] vA
     /*  15684 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  15689 */     // MIs[5] vB
     /*  15689 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  15694 */     // MIs[4] vC
     /*  15694 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  15699 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  15703 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  15709 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  15711 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  15713 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  15713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  15716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  15718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  15722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  15726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  15730 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  15740 */     GIR_RootConstrainSelectedInstOperands,
     /*  15741 */     // GIR_Coverage, 5051,
     /*  15741 */     GIR_EraseRootFromParent_Done,
     /*  15742 */   // Label 337: @15742
     /*  15742 */   GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(15880), // Rule ID 5052 //
     /*  15747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  15750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  15754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15766 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15778 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15782 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15786 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  15790 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  15794 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15798 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15802 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  15806 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15810 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15814 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  15818 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15822 */     // MIs[5] vB
     /*  15822 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  15827 */     // MIs[5] vA
     /*  15827 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  15832 */     // MIs[4] vC
     /*  15832 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  15837 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  15841 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  15847 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  15849 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  15851 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  15851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  15854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  15856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  15860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  15864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  15868 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  15878 */     GIR_RootConstrainSelectedInstOperands,
     /*  15879 */     // GIR_Coverage, 5052,
     /*  15879 */     GIR_EraseRootFromParent_Done,
     /*  15880 */   // Label 338: @15880
     /*  15880 */   GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(16018), // Rule ID 5053 //
     /*  15885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  15888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  15892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15904 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15916 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15920 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15924 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  15928 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  15932 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15936 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15940 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  15944 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15948 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15952 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  15956 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15960 */     // MIs[5] vA
     /*  15960 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  15965 */     // MIs[5] vC
     /*  15965 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  15970 */     // MIs[4] vB
     /*  15970 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  15975 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  15979 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  15985 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  15987 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  15989 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  15989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  15992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  15994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  15998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  16002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  16006 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  16016 */     GIR_RootConstrainSelectedInstOperands,
     /*  16017 */     // GIR_Coverage, 5053,
     /*  16017 */     GIR_EraseRootFromParent_Done,
     /*  16018 */   // Label 339: @16018
     /*  16018 */   GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(16156), // Rule ID 5054 //
     /*  16023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  16026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  16030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16038 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16042 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16046 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16050 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16054 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16058 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16062 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  16066 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16070 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16074 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16078 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  16082 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16086 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16090 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  16094 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16098 */     // MIs[5] vC
     /*  16098 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  16103 */     // MIs[5] vA
     /*  16103 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  16108 */     // MIs[4] vB
     /*  16108 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  16113 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  16117 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  16123 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  16125 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  16127 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  16127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  16130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  16132 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  16136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  16140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  16144 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  16154 */     GIR_RootConstrainSelectedInstOperands,
     /*  16155 */     // GIR_Coverage, 5054,
     /*  16155 */     GIR_EraseRootFromParent_Done,
     /*  16156 */   // Label 340: @16156
     /*  16156 */   GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(16294), // Rule ID 5055 //
     /*  16161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  16164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  16168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16176 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16180 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16184 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16188 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16192 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16196 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16200 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  16204 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16208 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16212 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16216 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  16220 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16224 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16228 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  16232 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16236 */     // MIs[5] vB
     /*  16236 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  16241 */     // MIs[5] vC
     /*  16241 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  16246 */     // MIs[4] vA
     /*  16246 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  16251 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  16255 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  16261 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  16263 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  16265 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  16265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  16268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  16270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  16274 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  16278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  16282 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  16292 */     GIR_RootConstrainSelectedInstOperands,
     /*  16293 */     // GIR_Coverage, 5055,
     /*  16293 */     GIR_EraseRootFromParent_Done,
     /*  16294 */   // Label 341: @16294
     /*  16294 */   GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(16432), // Rule ID 5056 //
     /*  16299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  16302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  16306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16314 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16318 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16322 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16326 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16330 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16334 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16338 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  16342 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16346 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16350 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16354 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  16358 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16362 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16366 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  16370 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16374 */     // MIs[5] vC
     /*  16374 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  16379 */     // MIs[5] vB
     /*  16379 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  16384 */     // MIs[4] vA
     /*  16384 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  16389 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  16393 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  16399 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  16401 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  16403 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  16403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  16406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  16408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  16412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  16416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  16420 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  16430 */     GIR_RootConstrainSelectedInstOperands,
     /*  16431 */     // GIR_Coverage, 5056,
     /*  16431 */     GIR_EraseRootFromParent_Done,
     /*  16432 */   // Label 342: @16432
     /*  16432 */   GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(16570), // Rule ID 5063 //
     /*  16437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  16440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  16444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16456 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16468 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16472 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16476 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  16480 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16484 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16488 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16492 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  16496 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16500 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16504 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  16508 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16512 */     // MIs[5] vA
     /*  16512 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  16517 */     // MIs[5] vB
     /*  16517 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  16522 */     // MIs[4] vC
     /*  16522 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  16527 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  16531 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  16537 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  16539 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  16541 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  16541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  16544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  16546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  16550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  16554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  16558 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  16568 */     GIR_RootConstrainSelectedInstOperands,
     /*  16569 */     // GIR_Coverage, 5063,
     /*  16569 */     GIR_EraseRootFromParent_Done,
     /*  16570 */   // Label 343: @16570
     /*  16570 */   GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(16708), // Rule ID 5064 //
     /*  16575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  16578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  16582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16590 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16594 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16598 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16602 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16606 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16610 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16614 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  16618 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16622 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16626 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16630 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  16634 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16638 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16642 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  16646 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16650 */     // MIs[5] vB
     /*  16650 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  16655 */     // MIs[5] vA
     /*  16655 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  16660 */     // MIs[4] vC
     /*  16660 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  16665 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  16669 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  16675 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  16677 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  16679 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  16679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  16682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  16684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  16688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  16692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  16696 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  16706 */     GIR_RootConstrainSelectedInstOperands,
     /*  16707 */     // GIR_Coverage, 5064,
     /*  16707 */     GIR_EraseRootFromParent_Done,
     /*  16708 */   // Label 344: @16708
     /*  16708 */   GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(16846), // Rule ID 5065 //
     /*  16713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  16716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  16720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16732 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16744 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16748 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16752 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  16756 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16760 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16764 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16768 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  16772 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16776 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16780 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  16784 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16788 */     // MIs[5] vA
     /*  16788 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  16793 */     // MIs[5] vC
     /*  16793 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  16798 */     // MIs[4] vB
     /*  16798 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  16803 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  16807 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  16813 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  16815 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  16817 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  16817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  16820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  16822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  16826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  16830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  16834 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  16844 */     GIR_RootConstrainSelectedInstOperands,
     /*  16845 */     // GIR_Coverage, 5065,
     /*  16845 */     GIR_EraseRootFromParent_Done,
     /*  16846 */   // Label 345: @16846
     /*  16846 */   GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(16984), // Rule ID 5066 //
     /*  16851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  16854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  16858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16866 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16870 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16878 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16882 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16886 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16890 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  16894 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16898 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16902 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16906 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  16910 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16914 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16918 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  16922 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16926 */     // MIs[5] vC
     /*  16926 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  16931 */     // MIs[5] vA
     /*  16931 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  16936 */     // MIs[4] vB
     /*  16936 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  16941 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  16945 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  16951 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  16953 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  16955 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  16955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  16958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  16960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  16964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  16968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  16972 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  16982 */     GIR_RootConstrainSelectedInstOperands,
     /*  16983 */     // GIR_Coverage, 5066,
     /*  16983 */     GIR_EraseRootFromParent_Done,
     /*  16984 */   // Label 346: @16984
     /*  16984 */   GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(17122), // Rule ID 5067 //
     /*  16989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  16992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  16996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17004 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17008 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17020 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17024 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17028 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  17032 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17036 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17040 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17044 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  17048 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17052 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17056 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  17060 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17064 */     // MIs[5] vB
     /*  17064 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  17069 */     // MIs[5] vC
     /*  17069 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  17074 */     // MIs[4] vA
     /*  17074 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  17079 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  17083 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  17089 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  17091 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  17093 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  17093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  17096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  17098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  17102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  17106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  17110 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  17120 */     GIR_RootConstrainSelectedInstOperands,
     /*  17121 */     // GIR_Coverage, 5067,
     /*  17121 */     GIR_EraseRootFromParent_Done,
     /*  17122 */   // Label 347: @17122
     /*  17122 */   GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(17260), // Rule ID 5068 //
     /*  17127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  17130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  17134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17146 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17150 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17154 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17158 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17162 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17166 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  17170 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17174 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17178 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17182 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  17186 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17190 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17194 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  17198 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17202 */     // MIs[5] vC
     /*  17202 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  17207 */     // MIs[5] vB
     /*  17207 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  17212 */     // MIs[4] vA
     /*  17212 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  17217 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  17221 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  17227 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  17229 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  17231 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  17231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  17234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  17236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  17240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  17244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  17248 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  17258 */     GIR_RootConstrainSelectedInstOperands,
     /*  17259 */     // GIR_Coverage, 5068,
     /*  17259 */     GIR_EraseRootFromParent_Done,
     /*  17260 */   // Label 348: @17260
     /*  17260 */   GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(17398), // Rule ID 5075 //
     /*  17265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  17268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  17272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17284 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17288 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17292 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17296 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17300 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17304 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  17308 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17312 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17316 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17320 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  17324 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17328 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17332 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  17336 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17340 */     // MIs[5] vA
     /*  17340 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  17345 */     // MIs[5] vB
     /*  17345 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  17350 */     // MIs[4] vC
     /*  17350 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  17355 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  17359 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  17365 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  17367 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  17369 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  17369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  17372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  17374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  17378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  17382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  17386 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  17396 */     GIR_RootConstrainSelectedInstOperands,
     /*  17397 */     // GIR_Coverage, 5075,
     /*  17397 */     GIR_EraseRootFromParent_Done,
     /*  17398 */   // Label 349: @17398
     /*  17398 */   GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(17536), // Rule ID 5076 //
     /*  17403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  17406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  17410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17422 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17426 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17430 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17434 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17438 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17442 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  17446 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17450 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17454 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17458 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  17462 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17466 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17470 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  17474 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17478 */     // MIs[5] vB
     /*  17478 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  17483 */     // MIs[5] vA
     /*  17483 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  17488 */     // MIs[4] vC
     /*  17488 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  17493 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  17497 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  17503 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  17505 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  17507 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  17507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  17510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  17512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  17516 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  17520 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  17524 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  17534 */     GIR_RootConstrainSelectedInstOperands,
     /*  17535 */     // GIR_Coverage, 5076,
     /*  17535 */     GIR_EraseRootFromParent_Done,
     /*  17536 */   // Label 350: @17536
     /*  17536 */   GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(17674), // Rule ID 5077 //
     /*  17541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  17544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  17548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17556 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17560 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17572 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17576 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17580 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  17584 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17588 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17592 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17596 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  17600 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17604 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17608 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  17612 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17616 */     // MIs[5] vA
     /*  17616 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  17621 */     // MIs[5] vC
     /*  17621 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  17626 */     // MIs[4] vB
     /*  17626 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  17631 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  17635 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  17641 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  17643 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  17645 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  17645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  17648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  17650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  17654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  17658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  17662 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  17672 */     GIR_RootConstrainSelectedInstOperands,
     /*  17673 */     // GIR_Coverage, 5077,
     /*  17673 */     GIR_EraseRootFromParent_Done,
     /*  17674 */   // Label 351: @17674
     /*  17674 */   GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(17812), // Rule ID 5078 //
     /*  17679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  17682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  17686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17694 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17698 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17706 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17710 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17714 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17718 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  17722 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17726 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17730 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17734 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  17738 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17742 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17746 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  17750 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17754 */     // MIs[5] vC
     /*  17754 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  17759 */     // MIs[5] vA
     /*  17759 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  17764 */     // MIs[4] vB
     /*  17764 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  17769 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  17773 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  17779 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  17781 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  17783 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  17783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  17786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  17788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  17792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  17796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  17800 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  17810 */     GIR_RootConstrainSelectedInstOperands,
     /*  17811 */     // GIR_Coverage, 5078,
     /*  17811 */     GIR_EraseRootFromParent_Done,
     /*  17812 */   // Label 352: @17812
     /*  17812 */   GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(17950), // Rule ID 5079 //
     /*  17817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  17820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  17824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17836 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17840 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17844 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17848 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17852 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17856 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  17860 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17864 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17868 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17872 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  17876 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17880 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17884 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  17888 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17892 */     // MIs[5] vB
     /*  17892 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  17897 */     // MIs[5] vC
     /*  17897 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  17902 */     // MIs[4] vA
     /*  17902 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  17907 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  17911 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  17917 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  17919 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  17921 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  17921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  17924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  17926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  17930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  17934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  17938 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  17948 */     GIR_RootConstrainSelectedInstOperands,
     /*  17949 */     // GIR_Coverage, 5079,
     /*  17949 */     GIR_EraseRootFromParent_Done,
     /*  17950 */   // Label 353: @17950
     /*  17950 */   GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(18088), // Rule ID 5080 //
     /*  17955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  17958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  17962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17974 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17978 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17982 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17986 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17990 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17994 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  17998 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18002 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18006 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18010 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18014 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18018 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18022 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  18026 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18030 */     // MIs[5] vC
     /*  18030 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  18035 */     // MIs[5] vB
     /*  18035 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18040 */     // MIs[4] vA
     /*  18040 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18045 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  18049 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  18055 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  18057 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  18059 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  18059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  18062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  18064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  18068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  18072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  18076 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  18086 */     GIR_RootConstrainSelectedInstOperands,
     /*  18087 */     // GIR_Coverage, 5080,
     /*  18087 */     GIR_EraseRootFromParent_Done,
     /*  18088 */   // Label 354: @18088
     /*  18088 */   GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(18226), // Rule ID 5087 //
     /*  18093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  18096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  18100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18112 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18116 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18120 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18124 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18128 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18132 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  18136 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18140 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18144 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18148 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18152 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18156 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18160 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  18164 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18168 */     // MIs[5] vA
     /*  18168 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  18173 */     // MIs[5] vB
     /*  18173 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18178 */     // MIs[4] vC
     /*  18178 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18183 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  18187 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  18193 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  18195 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  18197 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  18197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  18200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  18202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  18206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  18210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  18214 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  18224 */     GIR_RootConstrainSelectedInstOperands,
     /*  18225 */     // GIR_Coverage, 5087,
     /*  18225 */     GIR_EraseRootFromParent_Done,
     /*  18226 */   // Label 355: @18226
     /*  18226 */   GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(18364), // Rule ID 5088 //
     /*  18231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  18234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  18238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18250 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18262 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18266 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18270 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  18274 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18278 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18282 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18286 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18290 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18294 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18298 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  18302 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18306 */     // MIs[5] vB
     /*  18306 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18311 */     // MIs[5] vA
     /*  18311 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  18316 */     // MIs[4] vC
     /*  18316 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18321 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  18325 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  18331 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  18333 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  18335 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  18335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  18338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  18340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  18344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  18348 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  18352 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  18362 */     GIR_RootConstrainSelectedInstOperands,
     /*  18363 */     // GIR_Coverage, 5088,
     /*  18363 */     GIR_EraseRootFromParent_Done,
     /*  18364 */   // Label 356: @18364
     /*  18364 */   GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(18502), // Rule ID 5089 //
     /*  18369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  18372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  18376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18388 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18392 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18396 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18400 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18404 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18408 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  18412 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18416 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18420 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18424 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18428 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18432 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18436 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  18440 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18444 */     // MIs[5] vA
     /*  18444 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  18449 */     // MIs[5] vC
     /*  18449 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18454 */     // MIs[4] vB
     /*  18454 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18459 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  18463 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  18469 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  18471 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  18473 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  18473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  18476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  18478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  18482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  18486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  18490 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  18500 */     GIR_RootConstrainSelectedInstOperands,
     /*  18501 */     // GIR_Coverage, 5089,
     /*  18501 */     GIR_EraseRootFromParent_Done,
     /*  18502 */   // Label 357: @18502
     /*  18502 */   GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(18640), // Rule ID 5090 //
     /*  18507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  18510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  18514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18526 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18530 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18534 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18538 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18542 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18546 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  18550 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18554 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18558 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18562 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18566 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18570 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18574 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  18578 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18582 */     // MIs[5] vC
     /*  18582 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18587 */     // MIs[5] vA
     /*  18587 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  18592 */     // MIs[4] vB
     /*  18592 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18597 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  18601 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  18607 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  18609 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  18611 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  18611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  18614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  18616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  18620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  18624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  18628 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  18638 */     GIR_RootConstrainSelectedInstOperands,
     /*  18639 */     // GIR_Coverage, 5090,
     /*  18639 */     GIR_EraseRootFromParent_Done,
     /*  18640 */   // Label 358: @18640
     /*  18640 */   GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(18778), // Rule ID 5091 //
     /*  18645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  18648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  18652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18664 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18676 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18680 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18684 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  18688 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18692 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18696 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18700 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18704 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18708 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18712 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  18716 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18720 */     // MIs[5] vB
     /*  18720 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18725 */     // MIs[5] vC
     /*  18725 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18730 */     // MIs[4] vA
     /*  18730 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  18735 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  18739 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  18745 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  18747 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  18749 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  18749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  18752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  18754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  18758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  18762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  18766 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  18776 */     GIR_RootConstrainSelectedInstOperands,
     /*  18777 */     // GIR_Coverage, 5091,
     /*  18777 */     GIR_EraseRootFromParent_Done,
     /*  18778 */   // Label 359: @18778
     /*  18778 */   GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(18916), // Rule ID 5092 //
     /*  18783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  18786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  18790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18798 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18802 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18806 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18810 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18814 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18818 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18822 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  18826 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18830 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18834 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18838 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18842 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18846 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18850 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  18854 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18858 */     // MIs[5] vC
     /*  18858 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18863 */     // MIs[5] vB
     /*  18863 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18868 */     // MIs[4] vA
     /*  18868 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  18873 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  18877 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  18883 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  18885 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  18887 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  18887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  18890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  18892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  18896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  18900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  18904 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  18914 */     GIR_RootConstrainSelectedInstOperands,
     /*  18915 */     // GIR_Coverage, 5092,
     /*  18915 */     GIR_EraseRootFromParent_Done,
     /*  18916 */   // Label 360: @18916
     /*  18916 */   GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(19054), // Rule ID 5099 //
     /*  18921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  18924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  18928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18936 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18940 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18948 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18952 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18956 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18960 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  18964 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18968 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18972 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18976 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18980 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18984 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18988 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  18992 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18996 */     // MIs[5] vA
     /*  18996 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  19001 */     // MIs[5] vB
     /*  19001 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19006 */     // MIs[4] vC
     /*  19006 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  19011 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  19015 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  19021 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  19023 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  19025 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  19025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  19028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  19030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  19034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  19038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  19042 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  19052 */     GIR_RootConstrainSelectedInstOperands,
     /*  19053 */     // GIR_Coverage, 5099,
     /*  19053 */     GIR_EraseRootFromParent_Done,
     /*  19054 */   // Label 361: @19054
     /*  19054 */   GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(19192), // Rule ID 5100 //
     /*  19059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  19062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  19066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19078 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19082 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19086 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19090 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19094 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19098 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19102 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19106 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19110 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19114 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19118 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19122 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19126 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  19130 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19134 */     // MIs[5] vB
     /*  19134 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19139 */     // MIs[5] vA
     /*  19139 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  19144 */     // MIs[4] vC
     /*  19144 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  19149 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  19153 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  19159 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  19161 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  19163 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  19163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  19166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  19168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  19172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  19176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  19180 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  19190 */     GIR_RootConstrainSelectedInstOperands,
     /*  19191 */     // GIR_Coverage, 5100,
     /*  19191 */     GIR_EraseRootFromParent_Done,
     /*  19192 */   // Label 362: @19192
     /*  19192 */   GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(19330), // Rule ID 5101 //
     /*  19197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  19200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  19204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19216 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19224 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19228 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19232 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19236 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19240 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19244 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19248 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19252 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19256 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19260 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19264 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  19268 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19272 */     // MIs[5] vA
     /*  19272 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  19277 */     // MIs[5] vC
     /*  19277 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  19282 */     // MIs[4] vB
     /*  19282 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19287 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  19291 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  19297 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  19299 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  19301 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  19301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  19304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  19306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  19310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  19314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  19318 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  19328 */     GIR_RootConstrainSelectedInstOperands,
     /*  19329 */     // GIR_Coverage, 5101,
     /*  19329 */     GIR_EraseRootFromParent_Done,
     /*  19330 */   // Label 363: @19330
     /*  19330 */   GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(19468), // Rule ID 5102 //
     /*  19335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  19338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  19342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19354 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19358 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19362 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19366 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19370 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19374 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19378 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19382 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19386 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19390 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19394 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19398 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19402 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  19406 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19410 */     // MIs[5] vC
     /*  19410 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  19415 */     // MIs[5] vA
     /*  19415 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  19420 */     // MIs[4] vB
     /*  19420 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19425 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  19429 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  19435 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  19437 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  19439 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  19439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  19442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  19444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  19448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  19452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  19456 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  19466 */     GIR_RootConstrainSelectedInstOperands,
     /*  19467 */     // GIR_Coverage, 5102,
     /*  19467 */     GIR_EraseRootFromParent_Done,
     /*  19468 */   // Label 364: @19468
     /*  19468 */   GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(19606), // Rule ID 5103 //
     /*  19473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  19476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  19480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19492 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19496 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19500 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19504 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19508 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19512 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19516 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19520 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19524 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19528 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19532 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19536 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19540 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  19544 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19548 */     // MIs[5] vB
     /*  19548 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19553 */     // MIs[5] vC
     /*  19553 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  19558 */     // MIs[4] vA
     /*  19558 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  19563 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  19567 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  19573 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  19575 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  19577 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  19577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  19580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  19582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  19586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  19590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  19594 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  19604 */     GIR_RootConstrainSelectedInstOperands,
     /*  19605 */     // GIR_Coverage, 5103,
     /*  19605 */     GIR_EraseRootFromParent_Done,
     /*  19606 */   // Label 365: @19606
     /*  19606 */   GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(19744), // Rule ID 5104 //
     /*  19611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  19614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  19618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19630 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19634 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19638 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19642 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19646 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19650 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19654 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19658 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19662 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19666 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19670 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19674 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19678 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  19682 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19686 */     // MIs[5] vC
     /*  19686 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  19691 */     // MIs[5] vB
     /*  19691 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19696 */     // MIs[4] vA
     /*  19696 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  19701 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  19705 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  19711 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  19713 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  19715 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  19715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  19718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  19720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  19724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  19728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  19732 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  19742 */     GIR_RootConstrainSelectedInstOperands,
     /*  19743 */     // GIR_Coverage, 5104,
     /*  19743 */     GIR_EraseRootFromParent_Done,
     /*  19744 */   // Label 366: @19744
     /*  19744 */   GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(19882), // Rule ID 5110 //
     /*  19749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  19752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  19756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19768 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19780 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19784 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19788 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19792 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19796 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19800 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19804 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19808 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19812 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19816 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  19820 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19824 */     // MIs[5] vA
     /*  19824 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  19829 */     // MIs[5] vB
     /*  19829 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  19834 */     // MIs[4] vC
     /*  19834 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19839 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  19843 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  19849 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  19851 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  19853 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  19853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  19856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  19858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  19862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  19866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  19870 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  19880 */     GIR_RootConstrainSelectedInstOperands,
     /*  19881 */     // GIR_Coverage, 5110,
     /*  19881 */     GIR_EraseRootFromParent_Done,
     /*  19882 */   // Label 367: @19882
     /*  19882 */   GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(20020), // Rule ID 5111 //
     /*  19887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  19890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  19894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19906 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19910 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19914 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19918 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19922 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19926 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19930 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19934 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19938 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19942 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19946 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19950 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19954 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  19958 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19962 */     // MIs[5] vB
     /*  19962 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  19967 */     // MIs[5] vA
     /*  19967 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  19972 */     // MIs[4] vC
     /*  19972 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19977 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  19981 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  19987 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  19989 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  19991 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  19991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  19994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  19996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  20000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  20004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  20008 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  20018 */     GIR_RootConstrainSelectedInstOperands,
     /*  20019 */     // GIR_Coverage, 5111,
     /*  20019 */     GIR_EraseRootFromParent_Done,
     /*  20020 */   // Label 368: @20020
     /*  20020 */   GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(20158), // Rule ID 5112 //
     /*  20025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  20028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  20032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20040 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20044 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20048 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20052 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20056 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20060 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20064 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  20068 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  20072 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20076 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20080 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  20084 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20088 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20092 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  20096 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20100 */     // MIs[5] vA
     /*  20100 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  20105 */     // MIs[5] vC
     /*  20105 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  20110 */     // MIs[4] vB
     /*  20110 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  20115 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  20119 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  20125 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  20127 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  20129 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  20129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  20132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  20134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  20138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  20142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  20146 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  20156 */     GIR_RootConstrainSelectedInstOperands,
     /*  20157 */     // GIR_Coverage, 5112,
     /*  20157 */     GIR_EraseRootFromParent_Done,
     /*  20158 */   // Label 369: @20158
     /*  20158 */   GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(20296), // Rule ID 5113 //
     /*  20163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  20166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  20170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20178 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20182 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20186 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20190 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20194 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20198 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20202 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  20206 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  20210 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20214 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20218 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  20222 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20226 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20230 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  20234 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20238 */     // MIs[5] vC
     /*  20238 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  20243 */     // MIs[5] vA
     /*  20243 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  20248 */     // MIs[4] vB
     /*  20248 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  20253 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  20257 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  20263 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  20265 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  20267 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  20267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  20270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  20272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  20276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  20280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  20284 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  20294 */     GIR_RootConstrainSelectedInstOperands,
     /*  20295 */     // GIR_Coverage, 5113,
     /*  20295 */     GIR_EraseRootFromParent_Done,
     /*  20296 */   // Label 370: @20296
     /*  20296 */   GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(20434), // Rule ID 5114 //
     /*  20301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  20304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  20308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20320 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20324 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20328 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20332 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20336 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20340 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  20344 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  20348 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20352 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20356 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  20360 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20364 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20368 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  20372 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20376 */     // MIs[5] vB
     /*  20376 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  20381 */     // MIs[5] vC
     /*  20381 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  20386 */     // MIs[4] vA
     /*  20386 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  20391 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  20395 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  20401 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  20403 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  20405 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  20405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  20408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  20410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  20414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  20418 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  20422 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  20432 */     GIR_RootConstrainSelectedInstOperands,
     /*  20433 */     // GIR_Coverage, 5114,
     /*  20433 */     GIR_EraseRootFromParent_Done,
     /*  20434 */   // Label 371: @20434
     /*  20434 */   GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(20572), // Rule ID 5115 //
     /*  20439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  20442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  20446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20458 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20470 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20474 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20478 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  20482 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  20486 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20490 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20494 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  20498 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20502 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20506 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  20510 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20514 */     // MIs[5] vC
     /*  20514 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  20519 */     // MIs[5] vB
     /*  20519 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  20524 */     // MIs[4] vA
     /*  20524 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  20529 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  20533 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  20539 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  20541 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  20543 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  20543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  20546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  20548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  20552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  20556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  20560 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  20570 */     GIR_RootConstrainSelectedInstOperands,
     /*  20571 */     // GIR_Coverage, 5115,
     /*  20571 */     GIR_EraseRootFromParent_Done,
     /*  20572 */   // Label 372: @20572
     /*  20572 */   GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(20710), // Rule ID 3399 //
     /*  20577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  20580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  20584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20592 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20596 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20608 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20612 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20616 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  20620 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  20624 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20628 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20632 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  20636 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20640 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20644 */     // MIs[4] vA
     /*  20644 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  20649 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  20653 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20657 */     // MIs[5] vB
     /*  20657 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  20662 */     // MIs[5] vC
     /*  20662 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  20667 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  20671 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  20677 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  20679 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  20681 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  20681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  20684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  20686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  20690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  20694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  20698 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  20708 */     GIR_RootConstrainSelectedInstOperands,
     /*  20709 */     // GIR_Coverage, 3399,
     /*  20709 */     GIR_EraseRootFromParent_Done,
     /*  20710 */   // Label 373: @20710
     /*  20710 */   GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(20848), // Rule ID 5057 //
     /*  20715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  20718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  20722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20734 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20738 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20742 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20746 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20750 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20754 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  20758 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  20762 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20766 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20770 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  20774 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20778 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20782 */     // MIs[4] vC
     /*  20782 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  20787 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  20791 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20795 */     // MIs[5] vA
     /*  20795 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  20800 */     // MIs[5] vB
     /*  20800 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  20805 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  20809 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  20815 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  20817 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  20819 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  20819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  20822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  20824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  20828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  20832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  20836 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  20846 */     GIR_RootConstrainSelectedInstOperands,
     /*  20847 */     // GIR_Coverage, 5057,
     /*  20847 */     GIR_EraseRootFromParent_Done,
     /*  20848 */   // Label 374: @20848
     /*  20848 */   GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(20986), // Rule ID 5058 //
     /*  20853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  20856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  20860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20872 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20876 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20880 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20884 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20888 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20892 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  20896 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  20900 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20904 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20908 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  20912 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20916 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20920 */     // MIs[4] vC
     /*  20920 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  20925 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  20929 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20933 */     // MIs[5] vB
     /*  20933 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  20938 */     // MIs[5] vA
     /*  20938 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  20943 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  20947 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  20953 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  20955 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  20957 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  20957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  20960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  20962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  20966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  20970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  20974 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  20984 */     GIR_RootConstrainSelectedInstOperands,
     /*  20985 */     // GIR_Coverage, 5058,
     /*  20985 */     GIR_EraseRootFromParent_Done,
     /*  20986 */   // Label 375: @20986
     /*  20986 */   GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(21124), // Rule ID 5059 //
     /*  20991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  20994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  20998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21010 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21014 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21018 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21022 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21026 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21030 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21034 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21038 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21042 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21046 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21050 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21054 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21058 */     // MIs[4] vB
     /*  21058 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  21063 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  21067 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21071 */     // MIs[5] vA
     /*  21071 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  21076 */     // MIs[5] vC
     /*  21076 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  21081 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  21085 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21091 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  21093 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  21095 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  21095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  21098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  21100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  21104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  21108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  21112 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  21122 */     GIR_RootConstrainSelectedInstOperands,
     /*  21123 */     // GIR_Coverage, 5059,
     /*  21123 */     GIR_EraseRootFromParent_Done,
     /*  21124 */   // Label 376: @21124
     /*  21124 */   GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(21262), // Rule ID 5060 //
     /*  21129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  21132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  21136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21148 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21160 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21164 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21168 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21172 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21176 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21180 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21184 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21188 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21192 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21196 */     // MIs[4] vB
     /*  21196 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  21201 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  21205 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21209 */     // MIs[5] vC
     /*  21209 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  21214 */     // MIs[5] vA
     /*  21214 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  21219 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  21223 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21229 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  21231 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  21233 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  21233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  21236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  21238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  21242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  21246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  21250 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  21260 */     GIR_RootConstrainSelectedInstOperands,
     /*  21261 */     // GIR_Coverage, 5060,
     /*  21261 */     GIR_EraseRootFromParent_Done,
     /*  21262 */   // Label 377: @21262
     /*  21262 */   GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(21400), // Rule ID 5061 //
     /*  21267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  21270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  21274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21286 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21298 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21302 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21306 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21310 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21314 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21318 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21322 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21326 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21330 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21334 */     // MIs[4] vA
     /*  21334 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  21339 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  21343 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21347 */     // MIs[5] vB
     /*  21347 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  21352 */     // MIs[5] vC
     /*  21352 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  21357 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  21361 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21367 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  21369 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  21371 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  21371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  21374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  21376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  21380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  21384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  21388 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  21398 */     GIR_RootConstrainSelectedInstOperands,
     /*  21399 */     // GIR_Coverage, 5061,
     /*  21399 */     GIR_EraseRootFromParent_Done,
     /*  21400 */   // Label 378: @21400
     /*  21400 */   GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(21538), // Rule ID 5062 //
     /*  21405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  21408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  21412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21440 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21444 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21448 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21452 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21456 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21460 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21464 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21468 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21472 */     // MIs[4] vA
     /*  21472 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  21477 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  21481 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21485 */     // MIs[5] vC
     /*  21485 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  21490 */     // MIs[5] vB
     /*  21490 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  21495 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  21499 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21505 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  21507 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  21509 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  21509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  21512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  21514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  21518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  21522 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  21526 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  21536 */     GIR_RootConstrainSelectedInstOperands,
     /*  21537 */     // GIR_Coverage, 5062,
     /*  21537 */     GIR_EraseRootFromParent_Done,
     /*  21538 */   // Label 379: @21538
     /*  21538 */   GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(21676), // Rule ID 5069 //
     /*  21543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  21546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  21550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21562 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21566 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21570 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21574 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21578 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21582 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21586 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21590 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21594 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21598 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21602 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21606 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21610 */     // MIs[4] vC
     /*  21610 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  21615 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  21619 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21623 */     // MIs[5] vA
     /*  21623 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  21628 */     // MIs[5] vB
     /*  21628 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  21633 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  21637 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21643 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  21645 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  21647 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  21647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  21650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  21652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  21656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  21660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  21664 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  21674 */     GIR_RootConstrainSelectedInstOperands,
     /*  21675 */     // GIR_Coverage, 5069,
     /*  21675 */     GIR_EraseRootFromParent_Done,
     /*  21676 */   // Label 380: @21676
     /*  21676 */   GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(21814), // Rule ID 5070 //
     /*  21681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  21684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  21688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21700 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21712 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21716 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21720 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21724 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21728 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21732 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21736 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21740 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21744 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21748 */     // MIs[4] vC
     /*  21748 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  21753 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  21757 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21761 */     // MIs[5] vB
     /*  21761 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  21766 */     // MIs[5] vA
     /*  21766 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  21771 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  21775 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21781 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  21783 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  21785 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  21785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  21788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  21790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  21794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  21798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  21802 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  21812 */     GIR_RootConstrainSelectedInstOperands,
     /*  21813 */     // GIR_Coverage, 5070,
     /*  21813 */     GIR_EraseRootFromParent_Done,
     /*  21814 */   // Label 381: @21814
     /*  21814 */   GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(21952), // Rule ID 5071 //
     /*  21819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  21822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  21826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21834 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21838 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21842 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21846 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21850 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21854 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21858 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21862 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21866 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21870 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21874 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21878 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21882 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21886 */     // MIs[4] vB
     /*  21886 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  21891 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  21895 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21899 */     // MIs[5] vA
     /*  21899 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  21904 */     // MIs[5] vC
     /*  21904 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  21909 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  21913 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21919 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  21921 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  21923 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  21923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  21926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  21928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  21932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  21936 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  21940 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  21950 */     GIR_RootConstrainSelectedInstOperands,
     /*  21951 */     // GIR_Coverage, 5071,
     /*  21951 */     GIR_EraseRootFromParent_Done,
     /*  21952 */   // Label 382: @21952
     /*  21952 */   GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(22090), // Rule ID 5072 //
     /*  21957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  21960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  21964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21976 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21980 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21984 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21988 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21992 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21996 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22000 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22004 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22008 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22012 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22016 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22020 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22024 */     // MIs[4] vB
     /*  22024 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22029 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  22033 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22037 */     // MIs[5] vC
     /*  22037 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  22042 */     // MIs[5] vA
     /*  22042 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  22047 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  22051 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  22057 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  22059 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  22061 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  22061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  22064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  22066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  22070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  22074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  22078 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  22088 */     GIR_RootConstrainSelectedInstOperands,
     /*  22089 */     // GIR_Coverage, 5072,
     /*  22089 */     GIR_EraseRootFromParent_Done,
     /*  22090 */   // Label 383: @22090
     /*  22090 */   GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(22228), // Rule ID 5073 //
     /*  22095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  22098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  22102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22114 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22118 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22122 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22126 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22130 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22134 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22138 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22142 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22146 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22150 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22154 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22158 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22162 */     // MIs[4] vA
     /*  22162 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  22167 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  22171 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22175 */     // MIs[5] vB
     /*  22175 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22180 */     // MIs[5] vC
     /*  22180 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  22185 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  22189 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  22195 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  22197 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  22199 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  22199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  22202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  22204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  22208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  22212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  22216 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  22226 */     GIR_RootConstrainSelectedInstOperands,
     /*  22227 */     // GIR_Coverage, 5073,
     /*  22227 */     GIR_EraseRootFromParent_Done,
     /*  22228 */   // Label 384: @22228
     /*  22228 */   GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(22366), // Rule ID 5074 //
     /*  22233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  22236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  22240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22252 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22256 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22260 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22264 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22268 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22272 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22276 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22280 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22284 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22288 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22292 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22296 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22300 */     // MIs[4] vA
     /*  22300 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  22305 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  22309 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22313 */     // MIs[5] vC
     /*  22313 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  22318 */     // MIs[5] vB
     /*  22318 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22323 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  22327 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  22333 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  22335 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  22337 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  22337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  22340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  22342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  22346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  22350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  22354 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  22364 */     GIR_RootConstrainSelectedInstOperands,
     /*  22365 */     // GIR_Coverage, 5074,
     /*  22365 */     GIR_EraseRootFromParent_Done,
     /*  22366 */   // Label 385: @22366
     /*  22366 */   GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(22504), // Rule ID 5081 //
     /*  22371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  22374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  22378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22390 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22398 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22402 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22406 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22410 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22414 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22418 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22422 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22426 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22430 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22434 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22438 */     // MIs[4] vC
     /*  22438 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  22443 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  22447 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22451 */     // MIs[5] vA
     /*  22451 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22456 */     // MIs[5] vB
     /*  22456 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  22461 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  22465 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  22471 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  22473 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  22475 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  22475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  22478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  22480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  22484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  22488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  22492 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  22502 */     GIR_RootConstrainSelectedInstOperands,
     /*  22503 */     // GIR_Coverage, 5081,
     /*  22503 */     GIR_EraseRootFromParent_Done,
     /*  22504 */   // Label 386: @22504
     /*  22504 */   GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(22642), // Rule ID 5082 //
     /*  22509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  22512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  22516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22528 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22532 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22536 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22540 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22544 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22548 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22552 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22556 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22560 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22564 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22568 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22572 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22576 */     // MIs[4] vC
     /*  22576 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  22581 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  22585 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22589 */     // MIs[5] vB
     /*  22589 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  22594 */     // MIs[5] vA
     /*  22594 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22599 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  22603 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  22609 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  22611 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  22613 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  22613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  22616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  22618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  22622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  22626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  22630 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  22640 */     GIR_RootConstrainSelectedInstOperands,
     /*  22641 */     // GIR_Coverage, 5082,
     /*  22641 */     GIR_EraseRootFromParent_Done,
     /*  22642 */   // Label 387: @22642
     /*  22642 */   GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(22780), // Rule ID 5083 //
     /*  22647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  22650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  22654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22666 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22678 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22682 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22686 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22690 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22694 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22698 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22702 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22706 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22710 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22714 */     // MIs[4] vB
     /*  22714 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  22719 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  22723 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22727 */     // MIs[5] vA
     /*  22727 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22732 */     // MIs[5] vC
     /*  22732 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  22737 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  22741 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  22747 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  22749 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  22751 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  22751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  22754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  22756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  22760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  22764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  22768 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  22778 */     GIR_RootConstrainSelectedInstOperands,
     /*  22779 */     // GIR_Coverage, 5083,
     /*  22779 */     GIR_EraseRootFromParent_Done,
     /*  22780 */   // Label 388: @22780
     /*  22780 */   GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(22918), // Rule ID 5084 //
     /*  22785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  22788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  22792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22804 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22816 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22820 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22824 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22828 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22832 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22836 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22840 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22844 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22848 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22852 */     // MIs[4] vB
     /*  22852 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  22857 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  22861 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22865 */     // MIs[5] vC
     /*  22865 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  22870 */     // MIs[5] vA
     /*  22870 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22875 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  22879 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  22885 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  22887 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  22889 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  22889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  22892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  22894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  22898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  22902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  22906 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  22916 */     GIR_RootConstrainSelectedInstOperands,
     /*  22917 */     // GIR_Coverage, 5084,
     /*  22917 */     GIR_EraseRootFromParent_Done,
     /*  22918 */   // Label 389: @22918
     /*  22918 */   GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(23056), // Rule ID 5085 //
     /*  22923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  22926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  22930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22938 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22942 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22946 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22950 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22954 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22958 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22962 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22966 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22970 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22974 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22978 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22982 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22986 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22990 */     // MIs[4] vA
     /*  22990 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22995 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  22999 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23003 */     // MIs[5] vB
     /*  23003 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  23008 */     // MIs[5] vC
     /*  23008 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  23013 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  23017 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  23023 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  23025 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  23027 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  23027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  23030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  23032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  23036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  23040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  23044 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  23054 */     GIR_RootConstrainSelectedInstOperands,
     /*  23055 */     // GIR_Coverage, 5085,
     /*  23055 */     GIR_EraseRootFromParent_Done,
     /*  23056 */   // Label 390: @23056
     /*  23056 */   GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(23194), // Rule ID 5086 //
     /*  23061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  23064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  23068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23080 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23084 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23088 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23092 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23096 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23100 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  23104 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  23108 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23112 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23116 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  23120 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23124 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23128 */     // MIs[4] vA
     /*  23128 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  23133 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  23137 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23141 */     // MIs[5] vC
     /*  23141 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  23146 */     // MIs[5] vB
     /*  23146 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  23151 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  23155 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  23161 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  23163 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  23165 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  23165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  23168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  23170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  23174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  23178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  23182 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  23192 */     GIR_RootConstrainSelectedInstOperands,
     /*  23193 */     // GIR_Coverage, 5086,
     /*  23193 */     GIR_EraseRootFromParent_Done,
     /*  23194 */   // Label 391: @23194
     /*  23194 */   GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(23332), // Rule ID 5093 //
     /*  23199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  23202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  23206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23218 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23230 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23234 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23238 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  23242 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  23246 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23250 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23254 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  23258 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23262 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23266 */     // MIs[4] vC
     /*  23266 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  23271 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  23275 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23279 */     // MIs[5] vA
     /*  23279 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  23284 */     // MIs[5] vB
     /*  23284 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  23289 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  23293 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  23299 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  23301 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  23303 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  23303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  23306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  23308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  23312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  23316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  23320 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  23330 */     GIR_RootConstrainSelectedInstOperands,
     /*  23331 */     // GIR_Coverage, 5093,
     /*  23331 */     GIR_EraseRootFromParent_Done,
     /*  23332 */   // Label 392: @23332
     /*  23332 */   GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(23470), // Rule ID 5094 //
     /*  23337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  23340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  23344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23356 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23368 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23372 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23376 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  23380 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  23384 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23388 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23392 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  23396 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23400 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23404 */     // MIs[4] vC
     /*  23404 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  23409 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  23413 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23417 */     // MIs[5] vB
     /*  23417 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  23422 */     // MIs[5] vA
     /*  23422 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  23427 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  23431 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  23437 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  23439 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  23441 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  23441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  23444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  23446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  23450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  23454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  23458 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  23468 */     GIR_RootConstrainSelectedInstOperands,
     /*  23469 */     // GIR_Coverage, 5094,
     /*  23469 */     GIR_EraseRootFromParent_Done,
     /*  23470 */   // Label 393: @23470
     /*  23470 */   GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(23608), // Rule ID 5095 //
     /*  23475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  23478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  23482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23490 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23494 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23498 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23502 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23506 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23510 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23514 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  23518 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  23522 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23526 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23530 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  23534 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23538 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23542 */     // MIs[4] vB
     /*  23542 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  23547 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  23551 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23555 */     // MIs[5] vA
     /*  23555 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  23560 */     // MIs[5] vC
     /*  23560 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  23565 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  23569 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  23575 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  23577 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  23579 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  23579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  23582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  23584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  23588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  23592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  23596 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  23606 */     GIR_RootConstrainSelectedInstOperands,
     /*  23607 */     // GIR_Coverage, 5095,
     /*  23607 */     GIR_EraseRootFromParent_Done,
     /*  23608 */   // Label 394: @23608
     /*  23608 */   GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(23746), // Rule ID 5096 //
     /*  23613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  23616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  23620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23632 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23636 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23640 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23644 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23648 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23652 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  23656 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  23660 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23664 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23668 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  23672 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23676 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23680 */     // MIs[4] vB
     /*  23680 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  23685 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  23689 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23693 */     // MIs[5] vC
     /*  23693 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  23698 */     // MIs[5] vA
     /*  23698 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  23703 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  23707 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  23713 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  23715 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  23717 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  23717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  23720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  23722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  23726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  23730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  23734 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  23744 */     GIR_RootConstrainSelectedInstOperands,
     /*  23745 */     // GIR_Coverage, 5096,
     /*  23745 */     GIR_EraseRootFromParent_Done,
     /*  23746 */   // Label 395: @23746
     /*  23746 */   GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(23884), // Rule ID 5097 //
     /*  23751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  23754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  23758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23770 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23786 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23790 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  23794 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  23798 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23802 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23806 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  23810 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23814 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23818 */     // MIs[4] vA
     /*  23818 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  23823 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  23827 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23831 */     // MIs[5] vB
     /*  23831 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  23836 */     // MIs[5] vC
     /*  23836 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  23841 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  23845 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  23851 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  23853 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  23855 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  23855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  23858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  23860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  23864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  23868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  23872 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  23882 */     GIR_RootConstrainSelectedInstOperands,
     /*  23883 */     // GIR_Coverage, 5097,
     /*  23883 */     GIR_EraseRootFromParent_Done,
     /*  23884 */   // Label 396: @23884
     /*  23884 */   GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(24022), // Rule ID 5098 //
     /*  23889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  23892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  23896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23908 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23912 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23916 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23920 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23924 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23928 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  23932 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  23936 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23940 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23944 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  23948 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23952 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23956 */     // MIs[4] vA
     /*  23956 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  23961 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  23965 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23969 */     // MIs[5] vC
     /*  23969 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  23974 */     // MIs[5] vB
     /*  23974 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  23979 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  23983 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  23989 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  23991 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  23993 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  23993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  23996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  23998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  24002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  24006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  24010 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  24020 */     GIR_RootConstrainSelectedInstOperands,
     /*  24021 */     // GIR_Coverage, 5098,
     /*  24021 */     GIR_EraseRootFromParent_Done,
     /*  24022 */   // Label 397: @24022
     /*  24022 */   GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(24160), // Rule ID 5105 //
     /*  24027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  24030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  24034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24046 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24050 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24054 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24058 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24062 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24066 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  24070 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  24074 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24078 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24082 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  24086 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24090 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24094 */     // MIs[4] vC
     /*  24094 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  24099 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  24103 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24107 */     // MIs[5] vA
     /*  24107 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  24112 */     // MIs[5] vB
     /*  24112 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  24117 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  24121 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  24127 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  24129 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  24131 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  24131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  24134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  24136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  24140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  24144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  24148 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  24158 */     GIR_RootConstrainSelectedInstOperands,
     /*  24159 */     // GIR_Coverage, 5105,
     /*  24159 */     GIR_EraseRootFromParent_Done,
     /*  24160 */   // Label 398: @24160
     /*  24160 */   GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(24298), // Rule ID 5106 //
     /*  24165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  24168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  24172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24184 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24188 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24192 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24196 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24200 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24204 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  24208 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  24212 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24216 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24220 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  24224 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24228 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24232 */     // MIs[4] vC
     /*  24232 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  24237 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  24241 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24245 */     // MIs[5] vB
     /*  24245 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  24250 */     // MIs[5] vA
     /*  24250 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  24255 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  24259 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  24265 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  24267 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  24269 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  24269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  24272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  24274 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  24278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  24282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  24286 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  24296 */     GIR_RootConstrainSelectedInstOperands,
     /*  24297 */     // GIR_Coverage, 5106,
     /*  24297 */     GIR_EraseRootFromParent_Done,
     /*  24298 */   // Label 399: @24298
     /*  24298 */   GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(24436), // Rule ID 5107 //
     /*  24303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  24306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  24310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24322 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24326 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24330 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24334 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24338 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24342 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  24346 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  24350 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24354 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24358 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  24362 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24366 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24370 */     // MIs[4] vB
     /*  24370 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  24375 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  24379 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24383 */     // MIs[5] vA
     /*  24383 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  24388 */     // MIs[5] vC
     /*  24388 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  24393 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  24397 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  24403 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  24405 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  24407 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  24407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  24410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  24412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  24416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  24420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  24424 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  24434 */     GIR_RootConstrainSelectedInstOperands,
     /*  24435 */     // GIR_Coverage, 5107,
     /*  24435 */     GIR_EraseRootFromParent_Done,
     /*  24436 */   // Label 400: @24436
     /*  24436 */   GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(24574), // Rule ID 5108 //
     /*  24441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  24444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  24448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24460 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24464 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24468 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24472 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24476 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24480 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  24484 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  24488 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24492 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24496 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  24500 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24504 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24508 */     // MIs[4] vB
     /*  24508 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  24513 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  24517 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24521 */     // MIs[5] vC
     /*  24521 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  24526 */     // MIs[5] vA
     /*  24526 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  24531 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  24535 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  24541 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  24543 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  24545 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  24545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  24548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  24550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  24554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  24558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  24562 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  24572 */     GIR_RootConstrainSelectedInstOperands,
     /*  24573 */     // GIR_Coverage, 5108,
     /*  24573 */     GIR_EraseRootFromParent_Done,
     /*  24574 */   // Label 401: @24574
     /*  24574 */   GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(24712), // Rule ID 5109 //
     /*  24579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  24582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  24586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24594 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24598 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24602 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24606 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24610 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24614 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24618 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  24622 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  24626 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24630 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24634 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  24638 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24642 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24646 */     // MIs[4] vA
     /*  24646 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  24651 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  24655 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24659 */     // MIs[5] vC
     /*  24659 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  24664 */     // MIs[5] vB
     /*  24664 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  24669 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  24673 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  24679 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  24681 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  24683 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  24683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  24686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  24688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  24692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  24696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  24700 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  24710 */     GIR_RootConstrainSelectedInstOperands,
     /*  24711 */     // GIR_Coverage, 5109,
     /*  24711 */     GIR_EraseRootFromParent_Done,
     /*  24712 */   // Label 402: @24712
     /*  24712 */   GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(24850), // Rule ID 5116 //
     /*  24717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  24720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  24724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24736 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24748 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24752 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24756 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  24760 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  24764 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24768 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24772 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  24776 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24780 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24784 */     // MIs[4] vC
     /*  24784 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  24789 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  24793 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24797 */     // MIs[5] vA
     /*  24797 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  24802 */     // MIs[5] vB
     /*  24802 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  24807 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  24811 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  24817 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  24819 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  24821 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  24821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  24824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  24826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  24830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  24834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  24838 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  24848 */     GIR_RootConstrainSelectedInstOperands,
     /*  24849 */     // GIR_Coverage, 5116,
     /*  24849 */     GIR_EraseRootFromParent_Done,
     /*  24850 */   // Label 403: @24850
     /*  24850 */   GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(24988), // Rule ID 5117 //
     /*  24855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  24858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  24862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24874 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24882 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24886 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24890 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24894 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  24898 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  24902 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24906 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24910 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  24914 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24918 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24922 */     // MIs[4] vC
     /*  24922 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  24927 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  24931 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24935 */     // MIs[5] vB
     /*  24935 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  24940 */     // MIs[5] vA
     /*  24940 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  24945 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  24949 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  24955 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  24957 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  24959 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  24959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  24962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  24964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  24968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  24972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  24976 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  24986 */     GIR_RootConstrainSelectedInstOperands,
     /*  24987 */     // GIR_Coverage, 5117,
     /*  24987 */     GIR_EraseRootFromParent_Done,
     /*  24988 */   // Label 404: @24988
     /*  24988 */   GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(25126), // Rule ID 5118 //
     /*  24993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  24996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  25000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25012 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25016 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25020 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25024 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25028 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25032 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  25036 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  25040 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25044 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25048 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  25052 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25056 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25060 */     // MIs[4] vB
     /*  25060 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  25065 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  25069 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25073 */     // MIs[5] vA
     /*  25073 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  25078 */     // MIs[5] vC
     /*  25078 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  25083 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  25087 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  25093 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  25095 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  25097 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  25097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  25100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  25102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  25106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  25110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  25114 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  25124 */     GIR_RootConstrainSelectedInstOperands,
     /*  25125 */     // GIR_Coverage, 5118,
     /*  25125 */     GIR_EraseRootFromParent_Done,
     /*  25126 */   // Label 405: @25126
     /*  25126 */   GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(25264), // Rule ID 5119 //
     /*  25131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  25134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  25138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25146 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25150 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25162 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25166 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25170 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  25174 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  25178 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25182 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25186 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  25190 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25194 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25198 */     // MIs[4] vB
     /*  25198 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  25203 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  25207 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25211 */     // MIs[5] vC
     /*  25211 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  25216 */     // MIs[5] vA
     /*  25216 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  25221 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  25225 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  25231 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  25233 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  25235 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  25235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  25238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  25240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  25244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  25248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  25252 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  25262 */     GIR_RootConstrainSelectedInstOperands,
     /*  25263 */     // GIR_Coverage, 5119,
     /*  25263 */     GIR_EraseRootFromParent_Done,
     /*  25264 */   // Label 406: @25264
     /*  25264 */   GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(25402), // Rule ID 5120 //
     /*  25269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  25272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  25276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25288 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25292 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25296 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25300 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25304 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25308 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  25312 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  25316 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25320 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25324 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  25328 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25332 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25336 */     // MIs[4] vA
     /*  25336 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  25341 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  25345 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25349 */     // MIs[5] vB
     /*  25349 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  25354 */     // MIs[5] vC
     /*  25354 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  25359 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  25363 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  25369 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  25371 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  25373 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  25373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  25376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  25378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  25382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  25386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  25390 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  25400 */     GIR_RootConstrainSelectedInstOperands,
     /*  25401 */     // GIR_Coverage, 5120,
     /*  25401 */     GIR_EraseRootFromParent_Done,
     /*  25402 */   // Label 407: @25402
     /*  25402 */   GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(25540), // Rule ID 5121 //
     /*  25407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  25410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  25414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25426 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25438 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25442 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25446 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  25450 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  25454 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25458 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25462 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  25466 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25470 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25474 */     // MIs[4] vA
     /*  25474 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  25479 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  25483 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25487 */     // MIs[5] vC
     /*  25487 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  25492 */     // MIs[5] vB
     /*  25492 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  25497 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  25501 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  25507 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  25509 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  25511 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  25511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  25514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  25516 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  25520 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  25524 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  25528 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  25538 */     GIR_RootConstrainSelectedInstOperands,
     /*  25539 */     // GIR_Coverage, 5121,
     /*  25539 */     GIR_EraseRootFromParent_Done,
     /*  25540 */   // Label 408: @25540
     /*  25540 */   GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(25678), // Rule ID 5122 //
     /*  25545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  25548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  25552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  25560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25564 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25568 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25572 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25576 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25580 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25584 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25588 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25592 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25596 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25600 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  25604 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  25610 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  25612 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  25616 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25620 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25624 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  25628 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25632 */     // MIs[6] vA
     /*  25632 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  25637 */     // MIs[6] vB
     /*  25637 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  25642 */     // MIs[5] vC
     /*  25642 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  25647 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  25649 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  25649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  25652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  25654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  25658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  25662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  25666 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  25676 */     GIR_RootConstrainSelectedInstOperands,
     /*  25677 */     // GIR_Coverage, 5122,
     /*  25677 */     GIR_EraseRootFromParent_Done,
     /*  25678 */   // Label 409: @25678
     /*  25678 */   GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(25816), // Rule ID 5123 //
     /*  25683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  25686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  25690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  25698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25702 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25710 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25714 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25718 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25722 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25726 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25730 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25734 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25738 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  25742 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  25748 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  25750 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  25754 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25758 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25762 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  25766 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25770 */     // MIs[6] vB
     /*  25770 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  25775 */     // MIs[6] vA
     /*  25775 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  25780 */     // MIs[5] vC
     /*  25780 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  25785 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  25787 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  25787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  25790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  25792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  25796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  25800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  25804 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  25814 */     GIR_RootConstrainSelectedInstOperands,
     /*  25815 */     // GIR_Coverage, 5123,
     /*  25815 */     GIR_EraseRootFromParent_Done,
     /*  25816 */   // Label 410: @25816
     /*  25816 */   GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(25954), // Rule ID 5124 //
     /*  25821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  25824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  25828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  25836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25840 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25844 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25848 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25852 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25856 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25860 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25864 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25868 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25872 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25876 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  25880 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  25886 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  25888 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  25892 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25896 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25900 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  25904 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25908 */     // MIs[6] vA
     /*  25908 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  25913 */     // MIs[6] vC
     /*  25913 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  25918 */     // MIs[5] vB
     /*  25918 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  25923 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  25925 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  25925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  25928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  25930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  25934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  25938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  25942 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  25952 */     GIR_RootConstrainSelectedInstOperands,
     /*  25953 */     // GIR_Coverage, 5124,
     /*  25953 */     GIR_EraseRootFromParent_Done,
     /*  25954 */   // Label 411: @25954
     /*  25954 */   GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(26092), // Rule ID 5125 //
     /*  25959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  25962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  25966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  25974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25978 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25982 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25986 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25990 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25994 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25998 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26002 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26006 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26010 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26014 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  26018 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  26024 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  26026 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  26030 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26034 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26038 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  26042 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26046 */     // MIs[6] vC
     /*  26046 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  26051 */     // MIs[6] vA
     /*  26051 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26056 */     // MIs[5] vB
     /*  26056 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  26061 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  26063 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  26063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  26066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  26068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  26072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  26076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  26080 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  26090 */     GIR_RootConstrainSelectedInstOperands,
     /*  26091 */     // GIR_Coverage, 5125,
     /*  26091 */     GIR_EraseRootFromParent_Done,
     /*  26092 */   // Label 412: @26092
     /*  26092 */   GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(26230), // Rule ID 5126 //
     /*  26097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  26100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  26104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26112 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26116 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26120 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26124 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26128 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26132 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26136 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26140 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26144 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26148 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26152 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  26156 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  26162 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  26164 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  26168 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26172 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26176 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  26180 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26184 */     // MIs[6] vB
     /*  26184 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  26189 */     // MIs[6] vC
     /*  26189 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  26194 */     // MIs[5] vA
     /*  26194 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26199 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  26201 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  26201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  26204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  26206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  26210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  26214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  26218 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  26228 */     GIR_RootConstrainSelectedInstOperands,
     /*  26229 */     // GIR_Coverage, 5126,
     /*  26229 */     GIR_EraseRootFromParent_Done,
     /*  26230 */   // Label 413: @26230
     /*  26230 */   GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(26368), // Rule ID 5127 //
     /*  26235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  26238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  26242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26254 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26266 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26270 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26274 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26278 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26282 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26286 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26290 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  26294 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  26300 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  26302 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  26306 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26310 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26314 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  26318 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26322 */     // MIs[6] vC
     /*  26322 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  26327 */     // MIs[6] vB
     /*  26327 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  26332 */     // MIs[5] vA
     /*  26332 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26337 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  26339 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  26339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  26342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  26344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  26348 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  26352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  26356 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  26366 */     GIR_RootConstrainSelectedInstOperands,
     /*  26367 */     // GIR_Coverage, 5127,
     /*  26367 */     GIR_EraseRootFromParent_Done,
     /*  26368 */   // Label 414: @26368
     /*  26368 */   GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(26506), // Rule ID 5134 //
     /*  26373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  26376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  26380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26392 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26404 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26408 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26412 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26416 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26420 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26424 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26428 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  26432 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  26438 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  26440 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  26444 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26448 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26452 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  26456 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26460 */     // MIs[6] vA
     /*  26460 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  26465 */     // MIs[6] vB
     /*  26465 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26470 */     // MIs[5] vC
     /*  26470 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  26475 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  26477 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  26477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  26480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  26482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  26486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  26490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  26494 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  26504 */     GIR_RootConstrainSelectedInstOperands,
     /*  26505 */     // GIR_Coverage, 5134,
     /*  26505 */     GIR_EraseRootFromParent_Done,
     /*  26506 */   // Label 415: @26506
     /*  26506 */   GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(26644), // Rule ID 5135 //
     /*  26511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  26514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  26518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26530 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26534 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26538 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26542 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26546 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26550 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26554 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26558 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26562 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26566 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  26570 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  26576 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  26578 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  26582 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26586 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26590 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  26594 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26598 */     // MIs[6] vB
     /*  26598 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26603 */     // MIs[6] vA
     /*  26603 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  26608 */     // MIs[5] vC
     /*  26608 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  26613 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  26615 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  26615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  26618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  26620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  26624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  26628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  26632 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  26642 */     GIR_RootConstrainSelectedInstOperands,
     /*  26643 */     // GIR_Coverage, 5135,
     /*  26643 */     GIR_EraseRootFromParent_Done,
     /*  26644 */   // Label 416: @26644
     /*  26644 */   GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(26782), // Rule ID 5136 //
     /*  26649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  26652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  26656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26672 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26676 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26680 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26684 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26688 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26692 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26696 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26700 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26704 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  26708 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  26714 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  26716 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  26720 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26724 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26728 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  26732 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26736 */     // MIs[6] vA
     /*  26736 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  26741 */     // MIs[6] vC
     /*  26741 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  26746 */     // MIs[5] vB
     /*  26746 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26751 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  26753 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  26753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  26756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  26758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  26762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  26766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  26770 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  26780 */     GIR_RootConstrainSelectedInstOperands,
     /*  26781 */     // GIR_Coverage, 5136,
     /*  26781 */     GIR_EraseRootFromParent_Done,
     /*  26782 */   // Label 417: @26782
     /*  26782 */   GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(26920), // Rule ID 5137 //
     /*  26787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  26790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  26794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26806 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26814 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26818 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26822 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26826 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26830 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26834 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26838 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26842 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  26846 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  26852 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  26854 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  26858 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26862 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26866 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  26870 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26874 */     // MIs[6] vC
     /*  26874 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  26879 */     // MIs[6] vA
     /*  26879 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  26884 */     // MIs[5] vB
     /*  26884 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26889 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  26891 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  26891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  26894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  26896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  26900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  26904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  26908 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  26918 */     GIR_RootConstrainSelectedInstOperands,
     /*  26919 */     // GIR_Coverage, 5137,
     /*  26919 */     GIR_EraseRootFromParent_Done,
     /*  26920 */   // Label 418: @26920
     /*  26920 */   GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(27058), // Rule ID 5138 //
     /*  26925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  26928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  26932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26944 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26956 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26960 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26964 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26968 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26972 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26976 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26980 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  26984 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  26990 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  26992 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  26996 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27000 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27004 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  27008 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27012 */     // MIs[6] vB
     /*  27012 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  27017 */     // MIs[6] vC
     /*  27017 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  27022 */     // MIs[5] vA
     /*  27022 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  27027 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  27029 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  27029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  27032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  27034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  27038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  27042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  27046 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  27056 */     GIR_RootConstrainSelectedInstOperands,
     /*  27057 */     // GIR_Coverage, 5138,
     /*  27057 */     GIR_EraseRootFromParent_Done,
     /*  27058 */   // Label 419: @27058
     /*  27058 */   GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(27196), // Rule ID 5139 //
     /*  27063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  27066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  27070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  27078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27082 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27086 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27090 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27094 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27098 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27102 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27106 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27110 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27114 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27118 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  27122 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  27128 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  27130 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  27134 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27138 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27142 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  27146 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27150 */     // MIs[6] vC
     /*  27150 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  27155 */     // MIs[6] vB
     /*  27155 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  27160 */     // MIs[5] vA
     /*  27160 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  27165 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  27167 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  27167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  27170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  27172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  27176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  27180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  27184 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  27194 */     GIR_RootConstrainSelectedInstOperands,
     /*  27195 */     // GIR_Coverage, 5139,
     /*  27195 */     GIR_EraseRootFromParent_Done,
     /*  27196 */   // Label 420: @27196
     /*  27196 */   GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(27334), // Rule ID 5146 //
     /*  27201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  27204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  27208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  27216 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27220 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27224 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27228 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27232 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27236 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27240 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27244 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27248 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27252 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27256 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  27260 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  27266 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  27268 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  27272 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27276 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27280 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  27284 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27288 */     // MIs[6] vA
     /*  27288 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  27293 */     // MIs[6] vB
     /*  27293 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  27298 */     // MIs[5] vC
     /*  27298 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  27303 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  27305 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  27305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  27308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  27310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  27314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  27318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  27322 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  27332 */     GIR_RootConstrainSelectedInstOperands,
     /*  27333 */     // GIR_Coverage, 5146,
     /*  27333 */     GIR_EraseRootFromParent_Done,
     /*  27334 */   // Label 421: @27334
     /*  27334 */   GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(27472), // Rule ID 5147 //
     /*  27339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  27342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  27346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  27354 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27358 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27370 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27374 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27378 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27382 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27386 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27390 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27394 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  27398 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  27404 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  27406 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  27410 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27414 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27418 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  27422 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27426 */     // MIs[6] vB
     /*  27426 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  27431 */     // MIs[6] vA
     /*  27431 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  27436 */     // MIs[5] vC
     /*  27436 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  27441 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  27443 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  27443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  27446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  27448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  27452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  27456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  27460 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  27470 */     GIR_RootConstrainSelectedInstOperands,
     /*  27471 */     // GIR_Coverage, 5147,
     /*  27471 */     GIR_EraseRootFromParent_Done,
     /*  27472 */   // Label 422: @27472
     /*  27472 */   GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(27610), // Rule ID 5148 //
     /*  27477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  27480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  27484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  27492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27496 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27500 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27504 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27508 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27512 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27516 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27520 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27524 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27528 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27532 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  27536 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  27542 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  27544 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  27548 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27552 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27556 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  27560 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27564 */     // MIs[6] vA
     /*  27564 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  27569 */     // MIs[6] vC
     /*  27569 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  27574 */     // MIs[5] vB
     /*  27574 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  27579 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  27581 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  27581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  27584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  27586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  27590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  27594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  27598 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  27608 */     GIR_RootConstrainSelectedInstOperands,
     /*  27609 */     // GIR_Coverage, 5148,
     /*  27609 */     GIR_EraseRootFromParent_Done,
     /*  27610 */   // Label 423: @27610
     /*  27610 */   GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(27748), // Rule ID 5149 //
     /*  27615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  27618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  27622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  27630 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27634 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27638 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27642 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27646 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27650 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27654 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27658 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27662 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27666 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27670 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  27674 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  27680 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  27682 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  27686 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27690 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27694 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  27698 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27702 */     // MIs[6] vC
     /*  27702 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  27707 */     // MIs[6] vA
     /*  27707 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  27712 */     // MIs[5] vB
     /*  27712 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  27717 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  27719 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  27719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  27722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  27724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  27728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  27732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  27736 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  27746 */     GIR_RootConstrainSelectedInstOperands,
     /*  27747 */     // GIR_Coverage, 5149,
     /*  27747 */     GIR_EraseRootFromParent_Done,
     /*  27748 */   // Label 424: @27748
     /*  27748 */   GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(27886), // Rule ID 5150 //
     /*  27753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  27756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  27760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  27768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27772 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27776 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27780 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27784 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27788 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27792 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27796 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27800 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27804 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27808 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  27812 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  27818 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  27820 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  27824 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27828 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27832 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  27836 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27840 */     // MIs[6] vB
     /*  27840 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  27845 */     // MIs[6] vC
     /*  27845 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  27850 */     // MIs[5] vA
     /*  27850 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  27855 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  27857 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  27857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  27860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  27862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  27866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  27870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  27874 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  27884 */     GIR_RootConstrainSelectedInstOperands,
     /*  27885 */     // GIR_Coverage, 5150,
     /*  27885 */     GIR_EraseRootFromParent_Done,
     /*  27886 */   // Label 425: @27886
     /*  27886 */   GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(28024), // Rule ID 5151 //
     /*  27891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  27894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  27898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  27906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27910 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27918 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27922 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27926 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27930 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27934 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27938 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27942 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27946 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  27950 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  27956 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  27958 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  27962 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27966 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27970 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  27974 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27978 */     // MIs[6] vC
     /*  27978 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  27983 */     // MIs[6] vB
     /*  27983 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  27988 */     // MIs[5] vA
     /*  27988 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  27993 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  27995 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  27995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  27998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  28000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  28004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  28008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  28012 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  28022 */     GIR_RootConstrainSelectedInstOperands,
     /*  28023 */     // GIR_Coverage, 5151,
     /*  28023 */     GIR_EraseRootFromParent_Done,
     /*  28024 */   // Label 426: @28024
     /*  28024 */   GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(28162), // Rule ID 5158 //
     /*  28029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  28032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  28036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28044 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28048 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28052 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28056 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28060 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28064 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28068 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  28072 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28076 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28080 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28084 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  28088 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  28094 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  28096 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  28100 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28104 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28108 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  28112 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28116 */     // MIs[6] vA
     /*  28116 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  28121 */     // MIs[6] vB
     /*  28121 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  28126 */     // MIs[5] vC
     /*  28126 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  28131 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  28133 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  28133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  28136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  28138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  28142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  28146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  28150 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  28160 */     GIR_RootConstrainSelectedInstOperands,
     /*  28161 */     // GIR_Coverage, 5158,
     /*  28161 */     GIR_EraseRootFromParent_Done,
     /*  28162 */   // Label 427: @28162
     /*  28162 */   GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(28300), // Rule ID 5159 //
     /*  28167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  28170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  28174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28186 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28190 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28194 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28198 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28202 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28206 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  28210 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28214 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28218 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28222 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  28226 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  28232 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  28234 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  28238 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28242 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28246 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  28250 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28254 */     // MIs[6] vB
     /*  28254 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  28259 */     // MIs[6] vA
     /*  28259 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  28264 */     // MIs[5] vC
     /*  28264 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  28269 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  28271 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  28271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  28274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  28276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  28280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  28284 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  28288 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  28298 */     GIR_RootConstrainSelectedInstOperands,
     /*  28299 */     // GIR_Coverage, 5159,
     /*  28299 */     GIR_EraseRootFromParent_Done,
     /*  28300 */   // Label 428: @28300
     /*  28300 */   GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(28438), // Rule ID 5160 //
     /*  28305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  28308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  28312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28324 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28328 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28332 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28336 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28340 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28344 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  28348 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28352 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28356 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28360 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  28364 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  28370 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  28372 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  28376 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28380 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28384 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  28388 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28392 */     // MIs[6] vA
     /*  28392 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  28397 */     // MIs[6] vC
     /*  28397 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  28402 */     // MIs[5] vB
     /*  28402 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  28407 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  28409 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  28409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  28412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  28414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  28418 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  28422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  28426 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  28436 */     GIR_RootConstrainSelectedInstOperands,
     /*  28437 */     // GIR_Coverage, 5160,
     /*  28437 */     GIR_EraseRootFromParent_Done,
     /*  28438 */   // Label 429: @28438
     /*  28438 */   GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(28576), // Rule ID 5161 //
     /*  28443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  28446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  28450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28458 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28462 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28466 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28470 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28474 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28478 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28482 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  28486 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28490 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28494 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28498 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  28502 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  28508 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  28510 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  28514 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28518 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28522 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  28526 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28530 */     // MIs[6] vC
     /*  28530 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  28535 */     // MIs[6] vA
     /*  28535 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  28540 */     // MIs[5] vB
     /*  28540 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  28545 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  28547 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  28547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  28550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  28552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  28556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  28560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  28564 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  28574 */     GIR_RootConstrainSelectedInstOperands,
     /*  28575 */     // GIR_Coverage, 5161,
     /*  28575 */     GIR_EraseRootFromParent_Done,
     /*  28576 */   // Label 430: @28576
     /*  28576 */   GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(28714), // Rule ID 5162 //
     /*  28581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  28584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  28588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28600 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28604 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28608 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28612 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28616 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28620 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  28624 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28628 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28632 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28636 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  28640 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  28646 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  28648 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  28652 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28656 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28660 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  28664 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28668 */     // MIs[6] vB
     /*  28668 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  28673 */     // MIs[6] vC
     /*  28673 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  28678 */     // MIs[5] vA
     /*  28678 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  28683 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  28685 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  28685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  28688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  28690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  28694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  28698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  28702 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  28712 */     GIR_RootConstrainSelectedInstOperands,
     /*  28713 */     // GIR_Coverage, 5162,
     /*  28713 */     GIR_EraseRootFromParent_Done,
     /*  28714 */   // Label 431: @28714
     /*  28714 */   GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(28852), // Rule ID 5163 //
     /*  28719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  28722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  28726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28738 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28742 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28746 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28750 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28754 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28758 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  28762 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28766 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28770 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28774 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  28778 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  28784 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  28786 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  28790 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28794 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28798 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  28802 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28806 */     // MIs[6] vC
     /*  28806 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  28811 */     // MIs[6] vB
     /*  28811 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  28816 */     // MIs[5] vA
     /*  28816 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  28821 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  28823 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  28823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  28826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  28828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  28832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  28836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  28840 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  28850 */     GIR_RootConstrainSelectedInstOperands,
     /*  28851 */     // GIR_Coverage, 5163,
     /*  28851 */     GIR_EraseRootFromParent_Done,
     /*  28852 */   // Label 432: @28852
     /*  28852 */   GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(28990), // Rule ID 5170 //
     /*  28857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  28860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  28864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28872 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28876 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28888 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28892 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28896 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  28900 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28904 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28908 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28912 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  28916 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  28922 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  28924 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  28928 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28932 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28936 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  28940 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28944 */     // MIs[6] vA
     /*  28944 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  28949 */     // MIs[6] vB
     /*  28949 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  28954 */     // MIs[5] vC
     /*  28954 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  28959 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  28961 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  28961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  28964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  28966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  28970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  28974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  28978 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  28988 */     GIR_RootConstrainSelectedInstOperands,
     /*  28989 */     // GIR_Coverage, 5170,
     /*  28989 */     GIR_EraseRootFromParent_Done,
     /*  28990 */   // Label 433: @28990
     /*  28990 */   GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(29128), // Rule ID 5171 //
     /*  28995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  28998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  29002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  29010 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29014 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29018 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29022 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29026 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29030 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29034 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  29038 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29042 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29046 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29050 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  29054 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  29060 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  29062 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  29066 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29070 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29074 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  29078 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29082 */     // MIs[6] vB
     /*  29082 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  29087 */     // MIs[6] vA
     /*  29087 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  29092 */     // MIs[5] vC
     /*  29092 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  29097 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  29099 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  29099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  29102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  29104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  29108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  29112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  29116 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  29126 */     GIR_RootConstrainSelectedInstOperands,
     /*  29127 */     // GIR_Coverage, 5171,
     /*  29127 */     GIR_EraseRootFromParent_Done,
     /*  29128 */   // Label 434: @29128
     /*  29128 */   GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(29266), // Rule ID 5172 //
     /*  29133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  29136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  29140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  29148 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29152 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29156 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29160 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29164 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29168 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29172 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  29176 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29180 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29184 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29188 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  29192 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  29198 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  29200 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  29204 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29208 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29212 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  29216 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29220 */     // MIs[6] vA
     /*  29220 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  29225 */     // MIs[6] vC
     /*  29225 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  29230 */     // MIs[5] vB
     /*  29230 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  29235 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  29237 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  29237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  29240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  29242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  29246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  29250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  29254 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  29264 */     GIR_RootConstrainSelectedInstOperands,
     /*  29265 */     // GIR_Coverage, 5172,
     /*  29265 */     GIR_EraseRootFromParent_Done,
     /*  29266 */   // Label 435: @29266
     /*  29266 */   GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(29404), // Rule ID 5173 //
     /*  29271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  29274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  29278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  29286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29290 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29294 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29298 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29302 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29306 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29310 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  29314 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29318 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29322 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29326 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  29330 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  29336 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  29338 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  29342 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29346 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29350 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  29354 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29358 */     // MIs[6] vC
     /*  29358 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  29363 */     // MIs[6] vA
     /*  29363 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  29368 */     // MIs[5] vB
     /*  29368 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  29373 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  29375 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  29375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  29378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  29380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  29384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  29388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  29392 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  29402 */     GIR_RootConstrainSelectedInstOperands,
     /*  29403 */     // GIR_Coverage, 5173,
     /*  29403 */     GIR_EraseRootFromParent_Done,
     /*  29404 */   // Label 436: @29404
     /*  29404 */   GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(29542), // Rule ID 5174 //
     /*  29409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  29412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  29416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  29424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29428 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29436 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29440 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29444 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29448 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  29452 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29456 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29460 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29464 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  29468 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  29474 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  29476 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  29480 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29484 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29488 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  29492 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29496 */     // MIs[6] vB
     /*  29496 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  29501 */     // MIs[6] vC
     /*  29501 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  29506 */     // MIs[5] vA
     /*  29506 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  29511 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  29513 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  29513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  29516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  29518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  29522 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  29526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  29530 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  29540 */     GIR_RootConstrainSelectedInstOperands,
     /*  29541 */     // GIR_Coverage, 5174,
     /*  29541 */     GIR_EraseRootFromParent_Done,
     /*  29542 */   // Label 437: @29542
     /*  29542 */   GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(29680), // Rule ID 5175 //
     /*  29547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  29550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  29554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  29562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29566 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29570 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29574 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29578 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29582 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29586 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  29590 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29594 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29598 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29602 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  29606 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  29612 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  29614 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  29618 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29622 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29626 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  29630 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29634 */     // MIs[6] vC
     /*  29634 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  29639 */     // MIs[6] vB
     /*  29639 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  29644 */     // MIs[5] vA
     /*  29644 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  29649 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  29651 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  29651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  29654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  29656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  29660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  29664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  29668 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  29678 */     GIR_RootConstrainSelectedInstOperands,
     /*  29679 */     // GIR_Coverage, 5175,
     /*  29679 */     GIR_EraseRootFromParent_Done,
     /*  29680 */   // Label 438: @29680
     /*  29680 */   GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(29818), // Rule ID 5182 //
     /*  29685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  29688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  29692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  29700 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29704 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29708 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29712 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29716 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29720 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29724 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  29728 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29732 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29736 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29740 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  29744 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  29750 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  29752 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  29756 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29760 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29764 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  29768 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29772 */     // MIs[6] vA
     /*  29772 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  29777 */     // MIs[6] vB
     /*  29777 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  29782 */     // MIs[5] vC
     /*  29782 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  29787 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  29789 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  29789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  29792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  29794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  29798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  29802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  29806 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  29816 */     GIR_RootConstrainSelectedInstOperands,
     /*  29817 */     // GIR_Coverage, 5182,
     /*  29817 */     GIR_EraseRootFromParent_Done,
     /*  29818 */   // Label 439: @29818
     /*  29818 */   GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(29956), // Rule ID 5183 //
     /*  29823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  29826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  29830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  29838 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29842 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29846 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29850 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29854 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29858 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29862 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  29866 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29870 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29874 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29878 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  29882 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  29888 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  29890 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  29894 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29898 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29902 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  29906 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29910 */     // MIs[6] vB
     /*  29910 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  29915 */     // MIs[6] vA
     /*  29915 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  29920 */     // MIs[5] vC
     /*  29920 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  29925 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  29927 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  29927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  29930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  29932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  29936 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  29940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  29944 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  29954 */     GIR_RootConstrainSelectedInstOperands,
     /*  29955 */     // GIR_Coverage, 5183,
     /*  29955 */     GIR_EraseRootFromParent_Done,
     /*  29956 */   // Label 440: @29956
     /*  29956 */   GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(30094), // Rule ID 5184 //
     /*  29961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  29964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  29968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  29976 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29980 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29984 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29988 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29992 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29996 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30000 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  30004 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30008 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30012 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30016 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  30020 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  30026 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  30028 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  30032 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30036 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30040 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  30044 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30048 */     // MIs[6] vA
     /*  30048 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  30053 */     // MIs[6] vC
     /*  30053 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  30058 */     // MIs[5] vB
     /*  30058 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  30063 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  30065 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  30065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  30068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  30070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  30074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  30078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  30082 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  30092 */     GIR_RootConstrainSelectedInstOperands,
     /*  30093 */     // GIR_Coverage, 5184,
     /*  30093 */     GIR_EraseRootFromParent_Done,
     /*  30094 */   // Label 441: @30094
     /*  30094 */   GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(30232), // Rule ID 5185 //
     /*  30099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  30102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  30106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  30114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30118 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30130 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30134 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30138 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  30142 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30146 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30150 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30154 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  30158 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  30164 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  30166 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  30170 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30174 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30178 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  30182 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30186 */     // MIs[6] vC
     /*  30186 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  30191 */     // MIs[6] vA
     /*  30191 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  30196 */     // MIs[5] vB
     /*  30196 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  30201 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  30203 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  30203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  30206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  30208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  30212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  30216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  30220 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  30230 */     GIR_RootConstrainSelectedInstOperands,
     /*  30231 */     // GIR_Coverage, 5185,
     /*  30231 */     GIR_EraseRootFromParent_Done,
     /*  30232 */   // Label 442: @30232
     /*  30232 */   GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(30370), // Rule ID 5186 //
     /*  30237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  30240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  30244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  30252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30256 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30268 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30272 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30276 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  30280 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30284 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30288 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30292 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  30296 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  30302 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  30304 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  30308 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30312 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30316 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  30320 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30324 */     // MIs[6] vB
     /*  30324 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  30329 */     // MIs[6] vC
     /*  30329 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  30334 */     // MIs[5] vA
     /*  30334 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  30339 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  30341 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  30341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  30344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  30346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  30350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  30354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  30358 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  30368 */     GIR_RootConstrainSelectedInstOperands,
     /*  30369 */     // GIR_Coverage, 5186,
     /*  30369 */     GIR_EraseRootFromParent_Done,
     /*  30370 */   // Label 443: @30370
     /*  30370 */   GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(30508), // Rule ID 5187 //
     /*  30375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  30378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  30382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  30390 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30394 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30398 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30402 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30406 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30410 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30414 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  30418 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30422 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30426 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30430 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  30434 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  30440 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  30442 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  30446 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30450 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30454 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  30458 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30462 */     // MIs[6] vC
     /*  30462 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  30467 */     // MIs[6] vB
     /*  30467 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  30472 */     // MIs[5] vA
     /*  30472 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  30477 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  30479 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  30479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  30482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  30484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  30488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  30492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  30496 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  30506 */     GIR_RootConstrainSelectedInstOperands,
     /*  30507 */     // GIR_Coverage, 5187,
     /*  30507 */     GIR_EraseRootFromParent_Done,
     /*  30508 */   // Label 444: @30508
     /*  30508 */   GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(30646), // Rule ID 5128 //
     /*  30513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  30516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  30520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  30528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30532 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30536 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30540 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30544 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30548 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30552 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  30556 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30560 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30564 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30568 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  30572 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  30578 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  30580 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  30584 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30588 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30592 */     // MIs[5] vC
     /*  30592 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  30597 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  30601 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30605 */     // MIs[6] vA
     /*  30605 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  30610 */     // MIs[6] vB
     /*  30610 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  30615 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  30617 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  30617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  30620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  30622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  30626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  30630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  30634 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  30644 */     GIR_RootConstrainSelectedInstOperands,
     /*  30645 */     // GIR_Coverage, 5128,
     /*  30645 */     GIR_EraseRootFromParent_Done,
     /*  30646 */   // Label 445: @30646
     /*  30646 */   GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(30784), // Rule ID 5129 //
     /*  30651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  30654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  30658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  30666 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30670 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30674 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30678 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30682 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30686 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30690 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  30694 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30698 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30702 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30706 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  30710 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  30716 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  30718 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  30722 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30726 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30730 */     // MIs[5] vC
     /*  30730 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  30735 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  30739 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30743 */     // MIs[6] vB
     /*  30743 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  30748 */     // MIs[6] vA
     /*  30748 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  30753 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  30755 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  30755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  30758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  30760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  30764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  30768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  30772 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  30782 */     GIR_RootConstrainSelectedInstOperands,
     /*  30783 */     // GIR_Coverage, 5129,
     /*  30783 */     GIR_EraseRootFromParent_Done,
     /*  30784 */   // Label 446: @30784
     /*  30784 */   GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(30922), // Rule ID 5130 //
     /*  30789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  30792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  30796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  30804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30808 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30820 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30824 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30828 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  30832 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30836 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30840 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30844 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  30848 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  30854 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  30856 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  30860 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30864 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30868 */     // MIs[5] vB
     /*  30868 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  30873 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  30877 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30881 */     // MIs[6] vA
     /*  30881 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  30886 */     // MIs[6] vC
     /*  30886 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  30891 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  30893 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  30893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  30896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  30898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  30902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  30906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  30910 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  30920 */     GIR_RootConstrainSelectedInstOperands,
     /*  30921 */     // GIR_Coverage, 5130,
     /*  30921 */     GIR_EraseRootFromParent_Done,
     /*  30922 */   // Label 447: @30922
     /*  30922 */   GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(31060), // Rule ID 5131 //
     /*  30927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  30930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  30934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  30942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30946 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30958 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30962 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30966 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  30970 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30974 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30978 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30982 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  30986 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  30992 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  30994 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  30998 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31002 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31006 */     // MIs[5] vB
     /*  31006 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  31011 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  31015 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31019 */     // MIs[6] vC
     /*  31019 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  31024 */     // MIs[6] vA
     /*  31024 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  31029 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  31031 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  31031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  31034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  31036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  31040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  31044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  31048 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  31058 */     GIR_RootConstrainSelectedInstOperands,
     /*  31059 */     // GIR_Coverage, 5131,
     /*  31059 */     GIR_EraseRootFromParent_Done,
     /*  31060 */   // Label 448: @31060
     /*  31060 */   GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(31198), // Rule ID 5132 //
     /*  31065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  31068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  31072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  31080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31084 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31092 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31096 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31100 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31104 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  31108 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31112 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31116 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31120 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  31124 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  31130 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  31132 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  31136 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31140 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31144 */     // MIs[5] vA
     /*  31144 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  31149 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  31153 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31157 */     // MIs[6] vB
     /*  31157 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  31162 */     // MIs[6] vC
     /*  31162 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  31167 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  31169 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  31169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  31172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  31174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  31178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  31182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  31186 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  31196 */     GIR_RootConstrainSelectedInstOperands,
     /*  31197 */     // GIR_Coverage, 5132,
     /*  31197 */     GIR_EraseRootFromParent_Done,
     /*  31198 */   // Label 449: @31198
     /*  31198 */   GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(31336), // Rule ID 5133 //
     /*  31203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  31206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  31210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  31218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31222 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31226 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31230 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31234 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31238 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31242 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  31246 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31250 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31254 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31258 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  31262 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  31268 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  31270 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  31274 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31278 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31282 */     // MIs[5] vA
     /*  31282 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  31287 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  31291 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31295 */     // MIs[6] vC
     /*  31295 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  31300 */     // MIs[6] vB
     /*  31300 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  31305 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  31307 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  31307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  31310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  31312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  31316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  31320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  31324 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  31334 */     GIR_RootConstrainSelectedInstOperands,
     /*  31335 */     // GIR_Coverage, 5133,
     /*  31335 */     GIR_EraseRootFromParent_Done,
     /*  31336 */   // Label 450: @31336
     /*  31336 */   GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(31474), // Rule ID 5140 //
     /*  31341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  31344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  31348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  31356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31360 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31372 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31376 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31380 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  31384 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31388 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31392 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31396 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  31400 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  31406 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  31408 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  31412 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31416 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31420 */     // MIs[5] vC
     /*  31420 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  31425 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  31429 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31433 */     // MIs[6] vA
     /*  31433 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  31438 */     // MIs[6] vB
     /*  31438 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  31443 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  31445 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  31445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  31448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  31450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  31454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  31458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  31462 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  31472 */     GIR_RootConstrainSelectedInstOperands,
     /*  31473 */     // GIR_Coverage, 5140,
     /*  31473 */     GIR_EraseRootFromParent_Done,
     /*  31474 */   // Label 451: @31474
     /*  31474 */   GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(31612), // Rule ID 5141 //
     /*  31479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  31482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  31486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  31494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31498 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31510 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31514 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31518 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  31522 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31526 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31530 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31534 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  31538 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  31544 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  31546 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  31550 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31554 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31558 */     // MIs[5] vC
     /*  31558 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  31563 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  31567 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31571 */     // MIs[6] vB
     /*  31571 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  31576 */     // MIs[6] vA
     /*  31576 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  31581 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  31583 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  31583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  31586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  31588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  31592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  31596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  31600 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  31610 */     GIR_RootConstrainSelectedInstOperands,
     /*  31611 */     // GIR_Coverage, 5141,
     /*  31611 */     GIR_EraseRootFromParent_Done,
     /*  31612 */   // Label 452: @31612
     /*  31612 */   GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(31750), // Rule ID 5142 //
     /*  31617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  31620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  31624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  31632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31636 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31640 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31644 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31648 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31652 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31656 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  31660 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31664 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31668 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31672 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  31676 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  31682 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  31684 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  31688 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31692 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31696 */     // MIs[5] vB
     /*  31696 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  31701 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  31705 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31709 */     // MIs[6] vA
     /*  31709 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  31714 */     // MIs[6] vC
     /*  31714 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  31719 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  31721 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  31721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  31724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  31726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  31730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  31734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  31738 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  31748 */     GIR_RootConstrainSelectedInstOperands,
     /*  31749 */     // GIR_Coverage, 5142,
     /*  31749 */     GIR_EraseRootFromParent_Done,
     /*  31750 */   // Label 453: @31750
     /*  31750 */   GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(31888), // Rule ID 5143 //
     /*  31755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  31758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  31762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  31770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31774 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31782 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31786 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31790 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31794 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  31798 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31802 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31806 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31810 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  31814 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  31820 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  31822 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  31826 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31830 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31834 */     // MIs[5] vB
     /*  31834 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  31839 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  31843 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31847 */     // MIs[6] vC
     /*  31847 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  31852 */     // MIs[6] vA
     /*  31852 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  31857 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  31859 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  31859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  31862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  31864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  31868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  31872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  31876 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  31886 */     GIR_RootConstrainSelectedInstOperands,
     /*  31887 */     // GIR_Coverage, 5143,
     /*  31887 */     GIR_EraseRootFromParent_Done,
     /*  31888 */   // Label 454: @31888
     /*  31888 */   GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(32026), // Rule ID 5144 //
     /*  31893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  31896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  31900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  31908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31912 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31924 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31928 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31932 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  31936 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31940 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31944 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31948 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  31952 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  31958 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  31960 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  31964 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31968 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31972 */     // MIs[5] vA
     /*  31972 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  31977 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  31981 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31985 */     // MIs[6] vB
     /*  31985 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  31990 */     // MIs[6] vC
     /*  31990 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  31995 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  31997 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  31997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  32000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  32002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  32006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  32010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  32014 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  32024 */     GIR_RootConstrainSelectedInstOperands,
     /*  32025 */     // GIR_Coverage, 5144,
     /*  32025 */     GIR_EraseRootFromParent_Done,
     /*  32026 */   // Label 455: @32026
     /*  32026 */   GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(32164), // Rule ID 5145 //
     /*  32031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  32034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  32038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  32046 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32050 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32054 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32058 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32062 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32066 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32070 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  32074 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32078 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32082 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32086 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  32090 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  32096 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  32098 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  32102 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32106 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32110 */     // MIs[5] vA
     /*  32110 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  32115 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  32119 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32123 */     // MIs[6] vC
     /*  32123 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  32128 */     // MIs[6] vB
     /*  32128 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  32133 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  32135 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  32135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  32138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  32140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  32144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  32148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  32152 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  32162 */     GIR_RootConstrainSelectedInstOperands,
     /*  32163 */     // GIR_Coverage, 5145,
     /*  32163 */     GIR_EraseRootFromParent_Done,
     /*  32164 */   // Label 456: @32164
     /*  32164 */   GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(32302), // Rule ID 5152 //
     /*  32169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  32172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  32176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  32184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32188 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32192 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32196 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32200 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32204 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32208 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  32212 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32216 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32220 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32224 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  32228 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  32234 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  32236 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  32240 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32244 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32248 */     // MIs[5] vC
     /*  32248 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  32253 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  32257 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32261 */     // MIs[6] vA
     /*  32261 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  32266 */     // MIs[6] vB
     /*  32266 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  32271 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  32273 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  32273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  32276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  32278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  32282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  32286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  32290 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  32300 */     GIR_RootConstrainSelectedInstOperands,
     /*  32301 */     // GIR_Coverage, 5152,
     /*  32301 */     GIR_EraseRootFromParent_Done,
     /*  32302 */   // Label 457: @32302
     /*  32302 */   GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(32440), // Rule ID 5153 //
     /*  32307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  32310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  32314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  32322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32326 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32338 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32342 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32346 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  32350 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32354 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32358 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32362 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  32366 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  32372 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  32374 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  32378 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32382 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32386 */     // MIs[5] vC
     /*  32386 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  32391 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  32395 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32399 */     // MIs[6] vB
     /*  32399 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  32404 */     // MIs[6] vA
     /*  32404 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  32409 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  32411 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  32411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  32414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  32416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  32420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  32424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  32428 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  32438 */     GIR_RootConstrainSelectedInstOperands,
     /*  32439 */     // GIR_Coverage, 5153,
     /*  32439 */     GIR_EraseRootFromParent_Done,
     /*  32440 */   // Label 458: @32440
     /*  32440 */   GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(32578), // Rule ID 5154 //
     /*  32445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  32448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  32452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  32460 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32464 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32468 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32472 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32476 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32480 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32484 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  32488 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32492 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32496 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32500 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  32504 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  32510 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  32512 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  32516 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32520 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32524 */     // MIs[5] vB
     /*  32524 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  32529 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  32533 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32537 */     // MIs[6] vA
     /*  32537 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  32542 */     // MIs[6] vC
     /*  32542 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  32547 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  32549 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  32549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  32552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  32554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  32558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  32562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  32566 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  32576 */     GIR_RootConstrainSelectedInstOperands,
     /*  32577 */     // GIR_Coverage, 5154,
     /*  32577 */     GIR_EraseRootFromParent_Done,
     /*  32578 */   // Label 459: @32578
     /*  32578 */   GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(32716), // Rule ID 5155 //
     /*  32583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  32586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  32590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  32598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32602 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32606 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32610 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32614 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32618 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32622 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  32626 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32630 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32634 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32638 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  32642 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  32648 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  32650 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  32654 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32658 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32662 */     // MIs[5] vB
     /*  32662 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  32667 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  32671 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32675 */     // MIs[6] vC
     /*  32675 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  32680 */     // MIs[6] vA
     /*  32680 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  32685 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  32687 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  32687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  32690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  32692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  32696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  32700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  32704 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  32714 */     GIR_RootConstrainSelectedInstOperands,
     /*  32715 */     // GIR_Coverage, 5155,
     /*  32715 */     GIR_EraseRootFromParent_Done,
     /*  32716 */   // Label 460: @32716
     /*  32716 */   GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(32854), // Rule ID 5156 //
     /*  32721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  32724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  32728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  32736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32740 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32744 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32748 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32752 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32756 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32760 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  32764 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32768 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32772 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32776 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  32780 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  32786 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  32788 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  32792 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32796 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32800 */     // MIs[5] vA
     /*  32800 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  32805 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  32809 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32813 */     // MIs[6] vB
     /*  32813 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  32818 */     // MIs[6] vC
     /*  32818 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  32823 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  32825 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  32825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  32828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  32830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  32834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  32838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  32842 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  32852 */     GIR_RootConstrainSelectedInstOperands,
     /*  32853 */     // GIR_Coverage, 5156,
     /*  32853 */     GIR_EraseRootFromParent_Done,
     /*  32854 */   // Label 461: @32854
     /*  32854 */   GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(32992), // Rule ID 5157 //
     /*  32859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  32862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  32866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  32874 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32878 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32886 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32890 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32894 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32898 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  32902 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32906 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32910 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32914 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  32918 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  32924 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  32926 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  32930 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32934 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32938 */     // MIs[5] vA
     /*  32938 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  32943 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  32947 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32951 */     // MIs[6] vC
     /*  32951 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  32956 */     // MIs[6] vB
     /*  32956 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  32961 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  32963 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  32963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  32966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  32968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  32972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  32976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  32980 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  32990 */     GIR_RootConstrainSelectedInstOperands,
     /*  32991 */     // GIR_Coverage, 5157,
     /*  32991 */     GIR_EraseRootFromParent_Done,
     /*  32992 */   // Label 462: @32992
     /*  32992 */   GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(33130), // Rule ID 5164 //
     /*  32997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  33000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  33004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  33012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33016 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33028 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33032 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33036 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  33040 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33044 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33048 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33052 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  33056 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  33062 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  33064 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  33068 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33072 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33076 */     // MIs[5] vC
     /*  33076 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  33081 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  33085 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33089 */     // MIs[6] vA
     /*  33089 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  33094 */     // MIs[6] vB
     /*  33094 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  33099 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  33101 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  33101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  33104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  33106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  33110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  33114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  33118 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  33128 */     GIR_RootConstrainSelectedInstOperands,
     /*  33129 */     // GIR_Coverage, 5164,
     /*  33129 */     GIR_EraseRootFromParent_Done,
     /*  33130 */   // Label 463: @33130
     /*  33130 */   GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(33268), // Rule ID 5165 //
     /*  33135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  33138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  33142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  33150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33154 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33158 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33162 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33166 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33170 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33174 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  33178 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33182 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33186 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33190 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  33194 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  33200 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  33202 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  33206 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33210 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33214 */     // MIs[5] vC
     /*  33214 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  33219 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  33223 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33227 */     // MIs[6] vB
     /*  33227 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  33232 */     // MIs[6] vA
     /*  33232 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  33237 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  33239 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  33239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  33242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  33244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  33248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  33252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  33256 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  33266 */     GIR_RootConstrainSelectedInstOperands,
     /*  33267 */     // GIR_Coverage, 5165,
     /*  33267 */     GIR_EraseRootFromParent_Done,
     /*  33268 */   // Label 464: @33268
     /*  33268 */   GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(33406), // Rule ID 5166 //
     /*  33273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  33276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  33280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  33288 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33292 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33296 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33300 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33304 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33308 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33312 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  33316 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33320 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33324 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33328 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  33332 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  33338 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  33340 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  33344 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33348 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33352 */     // MIs[5] vB
     /*  33352 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  33357 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  33361 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33365 */     // MIs[6] vA
     /*  33365 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  33370 */     // MIs[6] vC
     /*  33370 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  33375 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  33377 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  33377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  33380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  33382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  33386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  33390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  33394 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  33404 */     GIR_RootConstrainSelectedInstOperands,
     /*  33405 */     // GIR_Coverage, 5166,
     /*  33405 */     GIR_EraseRootFromParent_Done,
     /*  33406 */   // Label 465: @33406
     /*  33406 */   GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(33544), // Rule ID 5167 //
     /*  33411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  33414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  33418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  33426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33430 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33434 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33438 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33442 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33446 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33450 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  33454 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33458 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33462 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33466 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  33470 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  33476 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  33478 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  33482 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33486 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33490 */     // MIs[5] vB
     /*  33490 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  33495 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  33499 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33503 */     // MIs[6] vC
     /*  33503 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  33508 */     // MIs[6] vA
     /*  33508 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  33513 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  33515 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  33515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  33518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  33520 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  33524 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  33528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  33532 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  33542 */     GIR_RootConstrainSelectedInstOperands,
     /*  33543 */     // GIR_Coverage, 5167,
     /*  33543 */     GIR_EraseRootFromParent_Done,
     /*  33544 */   // Label 466: @33544
     /*  33544 */   GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(33682), // Rule ID 5168 //
     /*  33549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  33552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  33556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  33564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33568 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33572 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33576 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33580 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33584 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33588 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  33592 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33596 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33600 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33604 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  33608 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  33614 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  33616 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  33620 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33624 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33628 */     // MIs[5] vA
     /*  33628 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  33633 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  33637 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33641 */     // MIs[6] vB
     /*  33641 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  33646 */     // MIs[6] vC
     /*  33646 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  33651 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  33653 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  33653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  33656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  33658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  33662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  33666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  33670 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  33680 */     GIR_RootConstrainSelectedInstOperands,
     /*  33681 */     // GIR_Coverage, 5168,
     /*  33681 */     GIR_EraseRootFromParent_Done,
     /*  33682 */   // Label 467: @33682
     /*  33682 */   GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(33820), // Rule ID 5169 //
     /*  33687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  33690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  33694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  33702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33706 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33710 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33714 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33718 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33722 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33726 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  33730 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33734 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33738 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33742 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  33746 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  33752 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  33754 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  33758 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33762 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33766 */     // MIs[5] vA
     /*  33766 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  33771 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  33775 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33779 */     // MIs[6] vC
     /*  33779 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  33784 */     // MIs[6] vB
     /*  33784 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  33789 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  33791 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  33791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  33794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  33796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  33800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  33804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  33808 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  33818 */     GIR_RootConstrainSelectedInstOperands,
     /*  33819 */     // GIR_Coverage, 5169,
     /*  33819 */     GIR_EraseRootFromParent_Done,
     /*  33820 */   // Label 468: @33820
     /*  33820 */   GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(33958), // Rule ID 5176 //
     /*  33825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  33828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  33832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  33840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33844 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33848 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33852 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33856 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33860 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33864 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  33868 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33872 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33876 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33880 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  33884 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  33890 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  33892 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  33896 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33900 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33904 */     // MIs[5] vC
     /*  33904 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  33909 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  33913 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33917 */     // MIs[6] vA
     /*  33917 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  33922 */     // MIs[6] vB
     /*  33922 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  33927 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  33929 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  33929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  33932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  33934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  33938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  33942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  33946 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  33956 */     GIR_RootConstrainSelectedInstOperands,
     /*  33957 */     // GIR_Coverage, 5176,
     /*  33957 */     GIR_EraseRootFromParent_Done,
     /*  33958 */   // Label 469: @33958
     /*  33958 */   GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(34096), // Rule ID 5177 //
     /*  33963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  33966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  33970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  33978 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33982 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33986 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33990 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33994 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33998 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34002 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  34006 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34010 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34014 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34018 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  34022 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  34028 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  34030 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  34034 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34038 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34042 */     // MIs[5] vC
     /*  34042 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  34047 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  34051 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34055 */     // MIs[6] vB
     /*  34055 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  34060 */     // MIs[6] vA
     /*  34060 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  34065 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  34067 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  34067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  34070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  34072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  34076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  34080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  34084 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  34094 */     GIR_RootConstrainSelectedInstOperands,
     /*  34095 */     // GIR_Coverage, 5177,
     /*  34095 */     GIR_EraseRootFromParent_Done,
     /*  34096 */   // Label 470: @34096
     /*  34096 */   GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(34234), // Rule ID 5178 //
     /*  34101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  34104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  34108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  34116 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34120 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34132 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34136 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34140 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  34144 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34148 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34152 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34156 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  34160 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  34166 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  34168 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  34172 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34176 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34180 */     // MIs[5] vB
     /*  34180 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  34185 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  34189 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34193 */     // MIs[6] vA
     /*  34193 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  34198 */     // MIs[6] vC
     /*  34198 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  34203 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  34205 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  34205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  34208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  34210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  34214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  34218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  34222 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  34232 */     GIR_RootConstrainSelectedInstOperands,
     /*  34233 */     // GIR_Coverage, 5178,
     /*  34233 */     GIR_EraseRootFromParent_Done,
     /*  34234 */   // Label 471: @34234
     /*  34234 */   GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(34372), // Rule ID 5179 //
     /*  34239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  34242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  34246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  34254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34258 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34262 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34266 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34270 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34274 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34278 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  34282 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34286 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34290 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34294 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  34298 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  34304 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  34306 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  34310 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34314 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34318 */     // MIs[5] vB
     /*  34318 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  34323 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  34327 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34331 */     // MIs[6] vC
     /*  34331 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  34336 */     // MIs[6] vA
     /*  34336 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  34341 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  34343 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  34343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  34346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  34348 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  34352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  34356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  34360 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  34370 */     GIR_RootConstrainSelectedInstOperands,
     /*  34371 */     // GIR_Coverage, 5179,
     /*  34371 */     GIR_EraseRootFromParent_Done,
     /*  34372 */   // Label 472: @34372
     /*  34372 */   GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(34510), // Rule ID 5180 //
     /*  34377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  34380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  34384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  34392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34396 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34400 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34404 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34408 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34412 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34416 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  34420 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34424 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34428 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34432 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  34436 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  34442 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  34444 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  34448 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34452 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34456 */     // MIs[5] vA
     /*  34456 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  34461 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  34465 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34469 */     // MIs[6] vB
     /*  34469 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  34474 */     // MIs[6] vC
     /*  34474 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  34479 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  34481 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  34481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  34484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  34486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  34490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  34494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  34498 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  34508 */     GIR_RootConstrainSelectedInstOperands,
     /*  34509 */     // GIR_Coverage, 5180,
     /*  34509 */     GIR_EraseRootFromParent_Done,
     /*  34510 */   // Label 473: @34510
     /*  34510 */   GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(34648), // Rule ID 5181 //
     /*  34515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  34518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  34522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  34530 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34534 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34546 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34550 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34554 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  34558 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34562 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34566 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34570 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  34574 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  34580 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  34582 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  34586 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34590 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34594 */     // MIs[5] vA
     /*  34594 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  34599 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  34603 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34607 */     // MIs[6] vC
     /*  34607 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  34612 */     // MIs[6] vB
     /*  34612 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  34617 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  34619 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  34619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  34622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  34624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  34628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  34632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  34636 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  34646 */     GIR_RootConstrainSelectedInstOperands,
     /*  34647 */     // GIR_Coverage, 5181,
     /*  34647 */     GIR_EraseRootFromParent_Done,
     /*  34648 */   // Label 474: @34648
     /*  34648 */   GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(34786), // Rule ID 5188 //
     /*  34653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  34656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  34660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  34668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34672 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34676 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34680 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34684 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34688 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34692 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  34696 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34700 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34704 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34708 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  34712 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  34718 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  34720 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  34724 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34728 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34732 */     // MIs[5] vC
     /*  34732 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  34737 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  34741 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34745 */     // MIs[6] vA
     /*  34745 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  34750 */     // MIs[6] vB
     /*  34750 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  34755 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  34757 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  34757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  34760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  34762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  34766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  34770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  34774 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  34784 */     GIR_RootConstrainSelectedInstOperands,
     /*  34785 */     // GIR_Coverage, 5188,
     /*  34785 */     GIR_EraseRootFromParent_Done,
     /*  34786 */   // Label 475: @34786
     /*  34786 */   GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(34924), // Rule ID 5189 //
     /*  34791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  34794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  34798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  34806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34810 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34814 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34818 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34822 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34826 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34830 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  34834 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34838 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34842 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34846 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  34850 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  34856 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  34858 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  34862 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34866 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34870 */     // MIs[5] vC
     /*  34870 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  34875 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  34879 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34883 */     // MIs[6] vB
     /*  34883 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  34888 */     // MIs[6] vA
     /*  34888 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  34893 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  34895 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  34895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  34898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  34900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  34904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  34908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  34912 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  34922 */     GIR_RootConstrainSelectedInstOperands,
     /*  34923 */     // GIR_Coverage, 5189,
     /*  34923 */     GIR_EraseRootFromParent_Done,
     /*  34924 */   // Label 476: @34924
     /*  34924 */   GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(35062), // Rule ID 5190 //
     /*  34929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  34932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  34936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  34944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34948 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34960 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34964 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34968 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  34972 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34976 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34980 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34984 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  34988 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  34994 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  34996 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  35000 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35004 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35008 */     // MIs[5] vB
     /*  35008 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  35013 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  35017 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35021 */     // MIs[6] vA
     /*  35021 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  35026 */     // MIs[6] vC
     /*  35026 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  35031 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  35033 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  35033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  35036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  35038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  35042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  35046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  35050 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  35060 */     GIR_RootConstrainSelectedInstOperands,
     /*  35061 */     // GIR_Coverage, 5190,
     /*  35061 */     GIR_EraseRootFromParent_Done,
     /*  35062 */   // Label 477: @35062
     /*  35062 */   GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(35200), // Rule ID 5191 //
     /*  35067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  35070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  35074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  35082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35086 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35090 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35094 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35098 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35102 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35106 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  35110 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35114 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35118 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35122 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  35126 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  35132 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  35134 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  35138 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35142 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35146 */     // MIs[5] vB
     /*  35146 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  35151 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  35155 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35159 */     // MIs[6] vC
     /*  35159 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  35164 */     // MIs[6] vA
     /*  35164 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  35169 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  35171 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  35171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  35174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  35176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  35180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  35184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  35188 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  35198 */     GIR_RootConstrainSelectedInstOperands,
     /*  35199 */     // GIR_Coverage, 5191,
     /*  35199 */     GIR_EraseRootFromParent_Done,
     /*  35200 */   // Label 478: @35200
     /*  35200 */   GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(35338), // Rule ID 5192 //
     /*  35205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  35208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  35212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  35220 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35224 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35228 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35232 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35236 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35240 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35244 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  35248 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35252 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35256 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35260 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  35264 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  35270 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  35272 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  35276 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35280 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35284 */     // MIs[5] vA
     /*  35284 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  35289 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  35293 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35297 */     // MIs[6] vB
     /*  35297 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  35302 */     // MIs[6] vC
     /*  35302 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  35307 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  35309 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  35309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  35312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  35314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  35318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  35322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  35326 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  35336 */     GIR_RootConstrainSelectedInstOperands,
     /*  35337 */     // GIR_Coverage, 5192,
     /*  35337 */     GIR_EraseRootFromParent_Done,
     /*  35338 */   // Label 479: @35338
     /*  35338 */   GIM_Try, /*On fail goto*//*Label 480*/ GIMT_Encode4(35476), // Rule ID 5193 //
     /*  35343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  35346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  35350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  35358 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35362 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35366 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35370 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35374 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35378 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35382 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  35386 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35390 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35394 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35398 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  35402 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  35408 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  35410 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  35414 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35418 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35422 */     // MIs[5] vA
     /*  35422 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  35427 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  35431 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35435 */     // MIs[6] vC
     /*  35435 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  35440 */     // MIs[6] vB
     /*  35440 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  35445 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  35447 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  35447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  35450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  35452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  35456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  35460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  35464 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  35474 */     GIR_RootConstrainSelectedInstOperands,
     /*  35475 */     // GIR_Coverage, 5193,
     /*  35475 */     GIR_EraseRootFromParent_Done,
     /*  35476 */   // Label 480: @35476
     /*  35476 */   GIM_Try, /*On fail goto*//*Label 481*/ GIMT_Encode4(35614), // Rule ID 5194 //
     /*  35481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  35484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  35488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  35496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35500 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35504 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35508 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35512 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35516 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35520 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  35524 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35528 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35532 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35536 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  35540 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  35546 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  35548 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  35552 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35556 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35560 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  35564 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35568 */     // MIs[6] vA
     /*  35568 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  35573 */     // MIs[6] vB
     /*  35573 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  35578 */     // MIs[5] vC
     /*  35578 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  35583 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  35585 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  35585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  35588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  35590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  35594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  35598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  35602 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  35612 */     GIR_RootConstrainSelectedInstOperands,
     /*  35613 */     // GIR_Coverage, 5194,
     /*  35613 */     GIR_EraseRootFromParent_Done,
     /*  35614 */   // Label 481: @35614
     /*  35614 */   GIM_Try, /*On fail goto*//*Label 482*/ GIMT_Encode4(35752), // Rule ID 5195 //
     /*  35619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  35622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  35626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  35634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35638 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35650 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35654 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35658 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  35662 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35666 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35670 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35674 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  35678 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  35684 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  35686 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  35690 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35694 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35698 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  35702 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35706 */     // MIs[6] vB
     /*  35706 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  35711 */     // MIs[6] vA
     /*  35711 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  35716 */     // MIs[5] vC
     /*  35716 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  35721 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  35723 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  35723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  35726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  35728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  35732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  35736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  35740 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  35750 */     GIR_RootConstrainSelectedInstOperands,
     /*  35751 */     // GIR_Coverage, 5195,
     /*  35751 */     GIR_EraseRootFromParent_Done,
     /*  35752 */   // Label 482: @35752
     /*  35752 */   GIM_Try, /*On fail goto*//*Label 483*/ GIMT_Encode4(35890), // Rule ID 5196 //
     /*  35757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  35760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  35764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  35772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35776 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35780 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35784 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35788 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35792 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35796 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  35800 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35804 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35808 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35812 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  35816 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  35822 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  35824 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  35828 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35832 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35836 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  35840 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35844 */     // MIs[6] vA
     /*  35844 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  35849 */     // MIs[6] vC
     /*  35849 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  35854 */     // MIs[5] vB
     /*  35854 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  35859 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  35861 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  35861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  35864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  35866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  35870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  35874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  35878 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  35888 */     GIR_RootConstrainSelectedInstOperands,
     /*  35889 */     // GIR_Coverage, 5196,
     /*  35889 */     GIR_EraseRootFromParent_Done,
     /*  35890 */   // Label 483: @35890
     /*  35890 */   GIM_Try, /*On fail goto*//*Label 484*/ GIMT_Encode4(36028), // Rule ID 5197 //
     /*  35895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  35898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  35902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  35910 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35914 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35918 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35922 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35926 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35930 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35934 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  35938 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35942 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35946 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35950 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  35954 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  35960 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  35962 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  35966 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35970 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35974 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  35978 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35982 */     // MIs[6] vC
     /*  35982 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  35987 */     // MIs[6] vA
     /*  35987 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  35992 */     // MIs[5] vB
     /*  35992 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  35997 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  35999 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  35999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  36002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  36004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  36008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  36012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  36016 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  36026 */     GIR_RootConstrainSelectedInstOperands,
     /*  36027 */     // GIR_Coverage, 5197,
     /*  36027 */     GIR_EraseRootFromParent_Done,
     /*  36028 */   // Label 484: @36028
     /*  36028 */   GIM_Try, /*On fail goto*//*Label 485*/ GIMT_Encode4(36166), // Rule ID 5198 //
     /*  36033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  36036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  36040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  36048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36052 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36056 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36060 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36064 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36068 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36072 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  36076 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36080 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36084 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36088 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  36092 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  36098 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  36100 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  36104 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36108 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36112 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  36116 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36120 */     // MIs[6] vB
     /*  36120 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  36125 */     // MIs[6] vC
     /*  36125 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  36130 */     // MIs[5] vA
     /*  36130 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  36135 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  36137 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  36137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  36140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  36142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  36146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  36150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  36154 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  36164 */     GIR_RootConstrainSelectedInstOperands,
     /*  36165 */     // GIR_Coverage, 5198,
     /*  36165 */     GIR_EraseRootFromParent_Done,
     /*  36166 */   // Label 485: @36166
     /*  36166 */   GIM_Try, /*On fail goto*//*Label 486*/ GIMT_Encode4(36304), // Rule ID 5199 //
     /*  36171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  36174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  36178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  36186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36190 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36202 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36206 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36210 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  36214 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36218 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36222 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36226 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  36230 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  36236 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  36238 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  36242 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36246 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36250 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  36254 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36258 */     // MIs[6] vC
     /*  36258 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  36263 */     // MIs[6] vB
     /*  36263 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  36268 */     // MIs[5] vA
     /*  36268 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  36273 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  36275 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  36275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  36278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  36280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  36284 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  36288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  36292 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  36302 */     GIR_RootConstrainSelectedInstOperands,
     /*  36303 */     // GIR_Coverage, 5199,
     /*  36303 */     GIR_EraseRootFromParent_Done,
     /*  36304 */   // Label 486: @36304
     /*  36304 */   GIM_Try, /*On fail goto*//*Label 487*/ GIMT_Encode4(36442), // Rule ID 5206 //
     /*  36309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  36312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  36316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  36324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36328 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36332 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36336 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36340 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36344 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36348 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  36352 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36356 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36360 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36364 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  36368 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  36374 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  36376 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  36380 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36384 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36388 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  36392 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36396 */     // MIs[6] vA
     /*  36396 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  36401 */     // MIs[6] vB
     /*  36401 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  36406 */     // MIs[5] vC
     /*  36406 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  36411 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  36413 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  36413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  36416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  36418 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  36422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  36426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  36430 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  36440 */     GIR_RootConstrainSelectedInstOperands,
     /*  36441 */     // GIR_Coverage, 5206,
     /*  36441 */     GIR_EraseRootFromParent_Done,
     /*  36442 */   // Label 487: @36442
     /*  36442 */   GIM_Try, /*On fail goto*//*Label 488*/ GIMT_Encode4(36580), // Rule ID 5207 //
     /*  36447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  36450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  36454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  36462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36466 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36470 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36474 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36478 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36482 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36486 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  36490 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36494 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36498 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36502 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  36506 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  36512 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  36514 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  36518 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36522 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36526 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  36530 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36534 */     // MIs[6] vB
     /*  36534 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  36539 */     // MIs[6] vA
     /*  36539 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  36544 */     // MIs[5] vC
     /*  36544 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  36549 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  36551 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  36551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  36554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  36556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  36560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  36564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  36568 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  36578 */     GIR_RootConstrainSelectedInstOperands,
     /*  36579 */     // GIR_Coverage, 5207,
     /*  36579 */     GIR_EraseRootFromParent_Done,
     /*  36580 */   // Label 488: @36580
     /*  36580 */   GIM_Try, /*On fail goto*//*Label 489*/ GIMT_Encode4(36718), // Rule ID 5208 //
     /*  36585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  36588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  36592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  36600 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36604 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36608 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36612 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36616 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36620 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36624 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  36628 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36632 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36636 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36640 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  36644 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  36650 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  36652 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  36656 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36660 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36664 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  36668 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36672 */     // MIs[6] vA
     /*  36672 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  36677 */     // MIs[6] vC
     /*  36677 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  36682 */     // MIs[5] vB
     /*  36682 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  36687 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  36689 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  36689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  36692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  36694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  36698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  36702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  36706 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  36716 */     GIR_RootConstrainSelectedInstOperands,
     /*  36717 */     // GIR_Coverage, 5208,
     /*  36717 */     GIR_EraseRootFromParent_Done,
     /*  36718 */   // Label 489: @36718
     /*  36718 */   GIM_Try, /*On fail goto*//*Label 490*/ GIMT_Encode4(36856), // Rule ID 5209 //
     /*  36723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  36726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  36730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  36738 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36742 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36750 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36754 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36758 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36762 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  36766 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36770 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36774 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36778 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  36782 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  36788 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  36790 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  36794 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36798 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36802 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  36806 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36810 */     // MIs[6] vC
     /*  36810 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  36815 */     // MIs[6] vA
     /*  36815 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  36820 */     // MIs[5] vB
     /*  36820 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  36825 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  36827 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  36827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  36830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  36832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  36836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  36840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  36844 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  36854 */     GIR_RootConstrainSelectedInstOperands,
     /*  36855 */     // GIR_Coverage, 5209,
     /*  36855 */     GIR_EraseRootFromParent_Done,
     /*  36856 */   // Label 490: @36856
     /*  36856 */   GIM_Try, /*On fail goto*//*Label 491*/ GIMT_Encode4(36994), // Rule ID 5210 //
     /*  36861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  36864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  36868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  36876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36880 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36892 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36896 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36900 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  36904 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36908 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36912 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36916 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  36920 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  36926 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  36928 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  36932 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36936 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36940 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  36944 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36948 */     // MIs[6] vB
     /*  36948 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  36953 */     // MIs[6] vC
     /*  36953 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  36958 */     // MIs[5] vA
     /*  36958 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  36963 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  36965 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  36965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  36968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  36970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  36974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  36978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  36982 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  36992 */     GIR_RootConstrainSelectedInstOperands,
     /*  36993 */     // GIR_Coverage, 5210,
     /*  36993 */     GIR_EraseRootFromParent_Done,
     /*  36994 */   // Label 491: @36994
     /*  36994 */   GIM_Try, /*On fail goto*//*Label 492*/ GIMT_Encode4(37132), // Rule ID 5211 //
     /*  36999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  37002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  37006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  37014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37018 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37022 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37026 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37030 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37034 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37038 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  37042 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37046 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37050 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37054 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  37058 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37064 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  37066 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  37070 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37074 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37078 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  37082 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37086 */     // MIs[6] vC
     /*  37086 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  37091 */     // MIs[6] vB
     /*  37091 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  37096 */     // MIs[5] vA
     /*  37096 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  37101 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  37103 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  37103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  37106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  37108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  37112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  37116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  37120 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  37130 */     GIR_RootConstrainSelectedInstOperands,
     /*  37131 */     // GIR_Coverage, 5211,
     /*  37131 */     GIR_EraseRootFromParent_Done,
     /*  37132 */   // Label 492: @37132
     /*  37132 */   GIM_Try, /*On fail goto*//*Label 493*/ GIMT_Encode4(37270), // Rule ID 5218 //
     /*  37137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  37140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  37144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  37152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37156 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37168 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37172 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37176 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  37180 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37184 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37188 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37192 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  37196 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37202 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  37204 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  37208 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37212 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37216 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  37220 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37224 */     // MIs[6] vA
     /*  37224 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  37229 */     // MIs[6] vB
     /*  37229 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  37234 */     // MIs[5] vC
     /*  37234 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  37239 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  37241 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  37241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  37244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  37246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  37250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  37254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  37258 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  37268 */     GIR_RootConstrainSelectedInstOperands,
     /*  37269 */     // GIR_Coverage, 5218,
     /*  37269 */     GIR_EraseRootFromParent_Done,
     /*  37270 */   // Label 493: @37270
     /*  37270 */   GIM_Try, /*On fail goto*//*Label 494*/ GIMT_Encode4(37408), // Rule ID 5219 //
     /*  37275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  37278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  37282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  37290 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37294 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37302 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37306 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37310 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37314 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  37318 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37322 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37326 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37330 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  37334 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37340 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  37342 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  37346 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37350 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37354 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  37358 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37362 */     // MIs[6] vB
     /*  37362 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  37367 */     // MIs[6] vA
     /*  37367 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  37372 */     // MIs[5] vC
     /*  37372 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  37377 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  37379 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  37379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  37382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  37384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  37388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  37392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  37396 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  37406 */     GIR_RootConstrainSelectedInstOperands,
     /*  37407 */     // GIR_Coverage, 5219,
     /*  37407 */     GIR_EraseRootFromParent_Done,
     /*  37408 */   // Label 494: @37408
     /*  37408 */   GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(37546), // Rule ID 5220 //
     /*  37413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  37416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  37420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  37428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37432 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37436 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37440 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37444 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37448 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37452 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  37456 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37460 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37464 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37468 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  37472 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37478 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  37480 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  37484 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37488 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37492 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  37496 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37500 */     // MIs[6] vA
     /*  37500 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  37505 */     // MIs[6] vC
     /*  37505 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  37510 */     // MIs[5] vB
     /*  37510 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  37515 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  37517 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  37517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  37520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  37522 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  37526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  37530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  37534 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  37544 */     GIR_RootConstrainSelectedInstOperands,
     /*  37545 */     // GIR_Coverage, 5220,
     /*  37545 */     GIR_EraseRootFromParent_Done,
     /*  37546 */   // Label 495: @37546
     /*  37546 */   GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(37684), // Rule ID 5221 //
     /*  37551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  37554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  37558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  37566 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37570 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37574 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37578 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37582 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37586 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37590 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  37594 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37598 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37602 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37606 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  37610 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37616 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  37618 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  37622 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37626 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37630 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  37634 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37638 */     // MIs[6] vC
     /*  37638 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  37643 */     // MIs[6] vA
     /*  37643 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  37648 */     // MIs[5] vB
     /*  37648 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  37653 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  37655 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  37655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  37658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  37660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  37664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  37668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  37672 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  37682 */     GIR_RootConstrainSelectedInstOperands,
     /*  37683 */     // GIR_Coverage, 5221,
     /*  37683 */     GIR_EraseRootFromParent_Done,
     /*  37684 */   // Label 496: @37684
     /*  37684 */   GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(37822), // Rule ID 5222 //
     /*  37689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  37692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  37696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  37704 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37708 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37712 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37716 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37720 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37724 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37728 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  37732 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37736 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37740 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37744 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  37748 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37754 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  37756 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  37760 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37764 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37768 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  37772 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37776 */     // MIs[6] vB
     /*  37776 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  37781 */     // MIs[6] vC
     /*  37781 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  37786 */     // MIs[5] vA
     /*  37786 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  37791 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  37793 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  37793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  37796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  37798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  37802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  37806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  37810 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  37820 */     GIR_RootConstrainSelectedInstOperands,
     /*  37821 */     // GIR_Coverage, 5222,
     /*  37821 */     GIR_EraseRootFromParent_Done,
     /*  37822 */   // Label 497: @37822
     /*  37822 */   GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(37960), // Rule ID 5223 //
     /*  37827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  37830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  37834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  37842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37846 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37850 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37854 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37858 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37862 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37866 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  37870 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37874 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37878 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37882 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  37886 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37892 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  37894 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  37898 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37902 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37906 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  37910 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37914 */     // MIs[6] vC
     /*  37914 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  37919 */     // MIs[6] vB
     /*  37919 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  37924 */     // MIs[5] vA
     /*  37924 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  37929 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  37931 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  37931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  37934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  37936 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  37940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  37944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  37948 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  37958 */     GIR_RootConstrainSelectedInstOperands,
     /*  37959 */     // GIR_Coverage, 5223,
     /*  37959 */     GIR_EraseRootFromParent_Done,
     /*  37960 */   // Label 498: @37960
     /*  37960 */   GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(38098), // Rule ID 5230 //
     /*  37965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  37968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  37972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  37980 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37984 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37988 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37992 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37996 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38000 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38004 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  38008 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38012 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38016 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38020 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  38024 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38030 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  38032 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  38036 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38040 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38044 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  38048 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38052 */     // MIs[6] vA
     /*  38052 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  38057 */     // MIs[6] vB
     /*  38057 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  38062 */     // MIs[5] vC
     /*  38062 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  38067 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  38069 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  38069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  38072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  38074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  38078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  38082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  38086 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  38096 */     GIR_RootConstrainSelectedInstOperands,
     /*  38097 */     // GIR_Coverage, 5230,
     /*  38097 */     GIR_EraseRootFromParent_Done,
     /*  38098 */   // Label 499: @38098
     /*  38098 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(38236), // Rule ID 5231 //
     /*  38103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  38106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  38110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  38118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38122 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38126 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38130 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38134 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38138 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38142 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  38146 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38150 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38154 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38158 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  38162 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38168 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  38170 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  38174 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38178 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38182 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  38186 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38190 */     // MIs[6] vB
     /*  38190 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  38195 */     // MIs[6] vA
     /*  38195 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  38200 */     // MIs[5] vC
     /*  38200 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  38205 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  38207 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  38207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  38210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  38212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  38216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  38220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  38224 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  38234 */     GIR_RootConstrainSelectedInstOperands,
     /*  38235 */     // GIR_Coverage, 5231,
     /*  38235 */     GIR_EraseRootFromParent_Done,
     /*  38236 */   // Label 500: @38236
     /*  38236 */   GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(38374), // Rule ID 5232 //
     /*  38241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  38244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  38248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  38256 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38260 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38264 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38268 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38272 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38276 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38280 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  38284 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38288 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38292 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38296 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  38300 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38306 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  38308 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  38312 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38316 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38320 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  38324 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38328 */     // MIs[6] vA
     /*  38328 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  38333 */     // MIs[6] vC
     /*  38333 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  38338 */     // MIs[5] vB
     /*  38338 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  38343 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  38345 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  38345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  38348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  38350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  38354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  38358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  38362 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  38372 */     GIR_RootConstrainSelectedInstOperands,
     /*  38373 */     // GIR_Coverage, 5232,
     /*  38373 */     GIR_EraseRootFromParent_Done,
     /*  38374 */   // Label 501: @38374
     /*  38374 */   GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(38512), // Rule ID 5233 //
     /*  38379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  38382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  38386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  38394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38398 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38410 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38414 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38418 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  38422 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38426 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38430 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38434 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  38438 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38444 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  38446 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  38450 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38454 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38458 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  38462 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38466 */     // MIs[6] vC
     /*  38466 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  38471 */     // MIs[6] vA
     /*  38471 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  38476 */     // MIs[5] vB
     /*  38476 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  38481 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  38483 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  38483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  38486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  38488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  38492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  38496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  38500 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  38510 */     GIR_RootConstrainSelectedInstOperands,
     /*  38511 */     // GIR_Coverage, 5233,
     /*  38511 */     GIR_EraseRootFromParent_Done,
     /*  38512 */   // Label 502: @38512
     /*  38512 */   GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(38650), // Rule ID 5234 //
     /*  38517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  38520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  38524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  38532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38536 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38548 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38552 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38556 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  38560 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38564 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38568 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38572 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  38576 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38582 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  38584 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  38588 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38592 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38596 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  38600 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38604 */     // MIs[6] vB
     /*  38604 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  38609 */     // MIs[6] vC
     /*  38609 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  38614 */     // MIs[5] vA
     /*  38614 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  38619 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  38621 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  38621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  38624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  38626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  38630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  38634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  38638 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  38648 */     GIR_RootConstrainSelectedInstOperands,
     /*  38649 */     // GIR_Coverage, 5234,
     /*  38649 */     GIR_EraseRootFromParent_Done,
     /*  38650 */   // Label 503: @38650
     /*  38650 */   GIM_Try, /*On fail goto*//*Label 504*/ GIMT_Encode4(38788), // Rule ID 5235 //
     /*  38655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  38658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  38662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  38670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38674 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38678 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38682 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38686 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38690 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38694 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  38698 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38702 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38706 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38710 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  38714 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38720 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  38722 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  38726 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38730 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38734 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  38738 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38742 */     // MIs[6] vC
     /*  38742 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  38747 */     // MIs[6] vB
     /*  38747 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  38752 */     // MIs[5] vA
     /*  38752 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  38757 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  38759 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  38759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  38762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  38764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  38768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  38772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  38776 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  38786 */     GIR_RootConstrainSelectedInstOperands,
     /*  38787 */     // GIR_Coverage, 5235,
     /*  38787 */     GIR_EraseRootFromParent_Done,
     /*  38788 */   // Label 504: @38788
     /*  38788 */   GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(38926), // Rule ID 5242 //
     /*  38793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  38796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  38800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  38808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38812 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38816 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38820 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38824 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38828 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38832 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  38836 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38840 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38844 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38848 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  38852 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38858 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  38860 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  38864 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38868 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38872 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  38876 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38880 */     // MIs[6] vA
     /*  38880 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  38885 */     // MIs[6] vB
     /*  38885 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  38890 */     // MIs[5] vC
     /*  38890 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  38895 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  38897 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  38897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  38900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  38902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  38906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  38910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  38914 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  38924 */     GIR_RootConstrainSelectedInstOperands,
     /*  38925 */     // GIR_Coverage, 5242,
     /*  38925 */     GIR_EraseRootFromParent_Done,
     /*  38926 */   // Label 505: @38926
     /*  38926 */   GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(39064), // Rule ID 5243 //
     /*  38931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  38934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  38938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  38946 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38950 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38954 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38958 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38962 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38966 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38970 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  38974 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38978 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38982 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38986 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  38990 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38996 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  38998 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  39002 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39006 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39010 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  39014 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39018 */     // MIs[6] vB
     /*  39018 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  39023 */     // MIs[6] vA
     /*  39023 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  39028 */     // MIs[5] vC
     /*  39028 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  39033 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  39035 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  39035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  39038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  39040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  39044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  39048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  39052 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  39062 */     GIR_RootConstrainSelectedInstOperands,
     /*  39063 */     // GIR_Coverage, 5243,
     /*  39063 */     GIR_EraseRootFromParent_Done,
     /*  39064 */   // Label 506: @39064
     /*  39064 */   GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(39202), // Rule ID 5244 //
     /*  39069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  39072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  39076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39088 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39092 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39096 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39100 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39104 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39108 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  39112 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39116 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39120 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39124 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  39128 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  39134 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  39136 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  39140 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39144 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39148 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  39152 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39156 */     // MIs[6] vA
     /*  39156 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  39161 */     // MIs[6] vC
     /*  39161 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  39166 */     // MIs[5] vB
     /*  39166 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  39171 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  39173 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  39173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  39176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  39178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  39182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  39186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  39190 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  39200 */     GIR_RootConstrainSelectedInstOperands,
     /*  39201 */     // GIR_Coverage, 5244,
     /*  39201 */     GIR_EraseRootFromParent_Done,
     /*  39202 */   // Label 507: @39202
     /*  39202 */   GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(39340), // Rule ID 5245 //
     /*  39207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  39210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  39214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39226 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39238 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39242 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39246 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  39250 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39254 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39258 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39262 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  39266 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  39272 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  39274 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  39278 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39282 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39286 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  39290 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39294 */     // MIs[6] vC
     /*  39294 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  39299 */     // MIs[6] vA
     /*  39299 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  39304 */     // MIs[5] vB
     /*  39304 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  39309 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  39311 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  39311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  39314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  39316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  39320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  39324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  39328 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  39338 */     GIR_RootConstrainSelectedInstOperands,
     /*  39339 */     // GIR_Coverage, 5245,
     /*  39339 */     GIR_EraseRootFromParent_Done,
     /*  39340 */   // Label 508: @39340
     /*  39340 */   GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(39478), // Rule ID 5246 //
     /*  39345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  39348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  39352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39364 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39372 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39376 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39380 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39384 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  39388 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39392 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39396 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39400 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  39404 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  39410 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  39412 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  39416 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39420 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39424 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  39428 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39432 */     // MIs[6] vB
     /*  39432 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  39437 */     // MIs[6] vC
     /*  39437 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  39442 */     // MIs[5] vA
     /*  39442 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  39447 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  39449 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  39449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  39452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  39454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  39458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  39462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  39466 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  39476 */     GIR_RootConstrainSelectedInstOperands,
     /*  39477 */     // GIR_Coverage, 5246,
     /*  39477 */     GIR_EraseRootFromParent_Done,
     /*  39478 */   // Label 509: @39478
     /*  39478 */   GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(39616), // Rule ID 5247 //
     /*  39483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  39486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  39490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39502 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39506 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39510 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39514 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39518 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39522 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  39526 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39530 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39534 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39538 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  39542 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  39548 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  39550 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  39554 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39558 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39562 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  39566 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39570 */     // MIs[6] vC
     /*  39570 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  39575 */     // MIs[6] vB
     /*  39575 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  39580 */     // MIs[5] vA
     /*  39580 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  39585 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  39587 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  39587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  39590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  39592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  39596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  39600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  39604 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  39614 */     GIR_RootConstrainSelectedInstOperands,
     /*  39615 */     // GIR_Coverage, 5247,
     /*  39615 */     GIR_EraseRootFromParent_Done,
     /*  39616 */   // Label 510: @39616
     /*  39616 */   GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(39754), // Rule ID 5254 //
     /*  39621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  39624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  39628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39640 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39644 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39648 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39652 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39656 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39660 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  39664 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39668 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39672 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39676 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  39680 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  39686 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  39688 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  39692 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39696 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39700 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  39704 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39708 */     // MIs[6] vA
     /*  39708 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  39713 */     // MIs[6] vB
     /*  39713 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  39718 */     // MIs[5] vC
     /*  39718 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  39723 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  39725 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  39725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  39728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  39730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  39734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  39738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  39742 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  39752 */     GIR_RootConstrainSelectedInstOperands,
     /*  39753 */     // GIR_Coverage, 5254,
     /*  39753 */     GIR_EraseRootFromParent_Done,
     /*  39754 */   // Label 511: @39754
     /*  39754 */   GIM_Try, /*On fail goto*//*Label 512*/ GIMT_Encode4(39892), // Rule ID 5255 //
     /*  39759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  39762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  39766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39778 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39782 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39786 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39790 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39794 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39798 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  39802 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39806 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39810 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39814 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  39818 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  39824 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  39826 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  39830 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39834 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39838 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  39842 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39846 */     // MIs[6] vB
     /*  39846 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  39851 */     // MIs[6] vA
     /*  39851 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  39856 */     // MIs[5] vC
     /*  39856 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  39861 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  39863 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  39863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  39866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  39868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  39872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  39876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  39880 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  39890 */     GIR_RootConstrainSelectedInstOperands,
     /*  39891 */     // GIR_Coverage, 5255,
     /*  39891 */     GIR_EraseRootFromParent_Done,
     /*  39892 */   // Label 512: @39892
     /*  39892 */   GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(40030), // Rule ID 5256 //
     /*  39897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  39900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  39904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39916 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39920 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39924 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39928 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39932 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39936 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  39940 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39944 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39948 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39952 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  39956 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  39962 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  39964 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  39968 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39972 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39976 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  39980 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39984 */     // MIs[6] vA
     /*  39984 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  39989 */     // MIs[6] vC
     /*  39989 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  39994 */     // MIs[5] vB
     /*  39994 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  39999 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  40001 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  40001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  40004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  40006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  40010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  40014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  40018 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  40028 */     GIR_RootConstrainSelectedInstOperands,
     /*  40029 */     // GIR_Coverage, 5256,
     /*  40029 */     GIR_EraseRootFromParent_Done,
     /*  40030 */   // Label 513: @40030
     /*  40030 */   GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(40168), // Rule ID 5257 //
     /*  40035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  40038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  40042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40050 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40054 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40062 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40066 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40070 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40074 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  40078 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40082 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40086 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40090 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  40094 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40100 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  40102 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  40106 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40110 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40114 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  40118 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40122 */     // MIs[6] vC
     /*  40122 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  40127 */     // MIs[6] vA
     /*  40127 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  40132 */     // MIs[5] vB
     /*  40132 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  40137 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  40139 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  40139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  40142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  40144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  40148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  40152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  40156 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  40166 */     GIR_RootConstrainSelectedInstOperands,
     /*  40167 */     // GIR_Coverage, 5257,
     /*  40167 */     GIR_EraseRootFromParent_Done,
     /*  40168 */   // Label 514: @40168
     /*  40168 */   GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(40306), // Rule ID 5258 //
     /*  40173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  40176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  40180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40192 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40196 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40200 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40204 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40208 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40212 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  40216 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40220 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40224 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40228 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  40232 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40238 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  40240 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  40244 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40248 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40252 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  40256 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40260 */     // MIs[6] vB
     /*  40260 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  40265 */     // MIs[6] vC
     /*  40265 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  40270 */     // MIs[5] vA
     /*  40270 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  40275 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  40277 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  40277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  40280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  40282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  40286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  40290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  40294 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  40304 */     GIR_RootConstrainSelectedInstOperands,
     /*  40305 */     // GIR_Coverage, 5258,
     /*  40305 */     GIR_EraseRootFromParent_Done,
     /*  40306 */   // Label 515: @40306
     /*  40306 */   GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(40444), // Rule ID 5259 //
     /*  40311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  40314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  40318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40330 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40334 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40338 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40342 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40346 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40350 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  40354 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40358 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40362 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40366 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  40370 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40376 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  40378 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  40382 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40386 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40390 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  40394 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40398 */     // MIs[6] vC
     /*  40398 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  40403 */     // MIs[6] vB
     /*  40403 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  40408 */     // MIs[5] vA
     /*  40408 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  40413 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  40415 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  40415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  40418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  40420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  40424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  40428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  40432 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  40442 */     GIR_RootConstrainSelectedInstOperands,
     /*  40443 */     // GIR_Coverage, 5259,
     /*  40443 */     GIR_EraseRootFromParent_Done,
     /*  40444 */   // Label 516: @40444
     /*  40444 */   GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(40582), // Rule ID 5200 //
     /*  40449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  40452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  40456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40468 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40472 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40476 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40480 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40484 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40488 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  40492 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40496 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40500 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40504 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  40508 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40514 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  40516 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  40520 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40524 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40528 */     // MIs[5] vC
     /*  40528 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  40533 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  40537 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40541 */     // MIs[6] vA
     /*  40541 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  40546 */     // MIs[6] vB
     /*  40546 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  40551 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  40553 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  40553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  40556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  40558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  40562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  40566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  40570 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  40580 */     GIR_RootConstrainSelectedInstOperands,
     /*  40581 */     // GIR_Coverage, 5200,
     /*  40581 */     GIR_EraseRootFromParent_Done,
     /*  40582 */   // Label 517: @40582
     /*  40582 */   GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(40720), // Rule ID 5201 //
     /*  40587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  40590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  40594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40606 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40610 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40614 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40618 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40622 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40626 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  40630 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40634 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40638 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40642 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  40646 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40652 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  40654 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  40658 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40662 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40666 */     // MIs[5] vC
     /*  40666 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  40671 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  40675 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40679 */     // MIs[6] vB
     /*  40679 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  40684 */     // MIs[6] vA
     /*  40684 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  40689 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  40691 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  40691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  40694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  40696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  40700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  40704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  40708 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  40718 */     GIR_RootConstrainSelectedInstOperands,
     /*  40719 */     // GIR_Coverage, 5201,
     /*  40719 */     GIR_EraseRootFromParent_Done,
     /*  40720 */   // Label 518: @40720
     /*  40720 */   GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(40858), // Rule ID 5202 //
     /*  40725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  40728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  40732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40744 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40748 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40752 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40756 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40760 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40764 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  40768 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40772 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40776 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40780 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  40784 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40790 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  40792 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  40796 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40800 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40804 */     // MIs[5] vB
     /*  40804 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  40809 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  40813 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40817 */     // MIs[6] vA
     /*  40817 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  40822 */     // MIs[6] vC
     /*  40822 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  40827 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  40829 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  40829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  40832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  40834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  40838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  40842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  40846 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  40856 */     GIR_RootConstrainSelectedInstOperands,
     /*  40857 */     // GIR_Coverage, 5202,
     /*  40857 */     GIR_EraseRootFromParent_Done,
     /*  40858 */   // Label 519: @40858
     /*  40858 */   GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(40996), // Rule ID 5203 //
     /*  40863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  40866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  40870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40882 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40886 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40890 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40894 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40898 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40902 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  40906 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40910 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40914 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40918 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  40922 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40928 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  40930 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  40934 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40938 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40942 */     // MIs[5] vB
     /*  40942 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  40947 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  40951 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40955 */     // MIs[6] vC
     /*  40955 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  40960 */     // MIs[6] vA
     /*  40960 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  40965 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  40967 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  40967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  40970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  40972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  40976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  40980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  40984 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  40994 */     GIR_RootConstrainSelectedInstOperands,
     /*  40995 */     // GIR_Coverage, 5203,
     /*  40995 */     GIR_EraseRootFromParent_Done,
     /*  40996 */   // Label 520: @40996
     /*  40996 */   GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(41134), // Rule ID 5204 //
     /*  41001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  41004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  41008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  41016 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41020 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41024 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41028 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41032 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41036 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41040 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  41044 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41048 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41052 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41056 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  41060 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41066 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  41068 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  41072 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41076 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41080 */     // MIs[5] vA
     /*  41080 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  41085 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  41089 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41093 */     // MIs[6] vB
     /*  41093 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  41098 */     // MIs[6] vC
     /*  41098 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  41103 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  41105 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  41105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  41108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  41110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  41114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  41118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  41122 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  41132 */     GIR_RootConstrainSelectedInstOperands,
     /*  41133 */     // GIR_Coverage, 5204,
     /*  41133 */     GIR_EraseRootFromParent_Done,
     /*  41134 */   // Label 521: @41134
     /*  41134 */   GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(41272), // Rule ID 5205 //
     /*  41139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  41142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  41146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  41154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41158 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41162 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41166 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41170 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41174 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41178 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  41182 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41186 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41190 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41194 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  41198 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41204 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  41206 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  41210 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41214 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41218 */     // MIs[5] vA
     /*  41218 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  41223 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  41227 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41231 */     // MIs[6] vC
     /*  41231 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  41236 */     // MIs[6] vB
     /*  41236 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  41241 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  41243 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  41243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  41246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  41248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  41252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  41256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  41260 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  41270 */     GIR_RootConstrainSelectedInstOperands,
     /*  41271 */     // GIR_Coverage, 5205,
     /*  41271 */     GIR_EraseRootFromParent_Done,
     /*  41272 */   // Label 522: @41272
     /*  41272 */   GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(41410), // Rule ID 5212 //
     /*  41277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  41280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  41284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  41292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41308 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41312 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41316 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  41320 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41324 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41328 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41332 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  41336 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41342 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  41344 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  41348 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41352 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41356 */     // MIs[5] vC
     /*  41356 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  41361 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  41365 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41369 */     // MIs[6] vA
     /*  41369 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  41374 */     // MIs[6] vB
     /*  41374 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  41379 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  41381 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  41381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  41384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  41386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  41390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  41394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  41398 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  41408 */     GIR_RootConstrainSelectedInstOperands,
     /*  41409 */     // GIR_Coverage, 5212,
     /*  41409 */     GIR_EraseRootFromParent_Done,
     /*  41410 */   // Label 523: @41410
     /*  41410 */   GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(41548), // Rule ID 5213 //
     /*  41415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  41418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  41422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  41430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41434 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41438 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41442 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41446 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41450 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41454 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  41458 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41462 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41466 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41470 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  41474 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41480 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  41482 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  41486 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41490 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41494 */     // MIs[5] vC
     /*  41494 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  41499 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  41503 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41507 */     // MIs[6] vB
     /*  41507 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  41512 */     // MIs[6] vA
     /*  41512 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  41517 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  41519 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  41519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  41522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  41524 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  41528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  41532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  41536 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  41546 */     GIR_RootConstrainSelectedInstOperands,
     /*  41547 */     // GIR_Coverage, 5213,
     /*  41547 */     GIR_EraseRootFromParent_Done,
     /*  41548 */   // Label 524: @41548
     /*  41548 */   GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(41686), // Rule ID 5214 //
     /*  41553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  41556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  41560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  41568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41572 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41576 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41580 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41584 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41588 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41592 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  41596 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41600 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41604 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41608 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  41612 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41618 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  41620 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  41624 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41628 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41632 */     // MIs[5] vB
     /*  41632 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  41637 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  41641 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41645 */     // MIs[6] vA
     /*  41645 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  41650 */     // MIs[6] vC
     /*  41650 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  41655 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  41657 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  41657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  41660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  41662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  41666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  41670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  41674 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  41684 */     GIR_RootConstrainSelectedInstOperands,
     /*  41685 */     // GIR_Coverage, 5214,
     /*  41685 */     GIR_EraseRootFromParent_Done,
     /*  41686 */   // Label 525: @41686
     /*  41686 */   GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(41824), // Rule ID 5215 //
     /*  41691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  41694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  41698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  41706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41710 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41718 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41722 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41726 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41730 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  41734 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41738 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41742 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41746 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  41750 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41756 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  41758 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  41762 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41766 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41770 */     // MIs[5] vB
     /*  41770 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  41775 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  41779 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41783 */     // MIs[6] vC
     /*  41783 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  41788 */     // MIs[6] vA
     /*  41788 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  41793 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  41795 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  41795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  41798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  41800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  41804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  41808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  41812 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  41822 */     GIR_RootConstrainSelectedInstOperands,
     /*  41823 */     // GIR_Coverage, 5215,
     /*  41823 */     GIR_EraseRootFromParent_Done,
     /*  41824 */   // Label 526: @41824
     /*  41824 */   GIM_Try, /*On fail goto*//*Label 527*/ GIMT_Encode4(41962), // Rule ID 5216 //
     /*  41829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  41832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  41836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  41844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41848 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41860 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41864 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41868 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  41872 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41876 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41880 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41884 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  41888 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41894 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  41896 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  41900 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41904 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41908 */     // MIs[5] vA
     /*  41908 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  41913 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  41917 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41921 */     // MIs[6] vB
     /*  41921 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  41926 */     // MIs[6] vC
     /*  41926 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  41931 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  41933 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  41933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  41936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  41938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  41942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  41946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  41950 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  41960 */     GIR_RootConstrainSelectedInstOperands,
     /*  41961 */     // GIR_Coverage, 5216,
     /*  41961 */     GIR_EraseRootFromParent_Done,
     /*  41962 */   // Label 527: @41962
     /*  41962 */   GIM_Try, /*On fail goto*//*Label 528*/ GIMT_Encode4(42100), // Rule ID 5217 //
     /*  41967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  41970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  41974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  41982 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41986 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41990 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41994 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41998 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42002 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42006 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  42010 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42014 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42018 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42022 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  42026 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42032 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  42034 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  42038 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42042 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42046 */     // MIs[5] vA
     /*  42046 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  42051 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  42055 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42059 */     // MIs[6] vC
     /*  42059 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  42064 */     // MIs[6] vB
     /*  42064 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  42069 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  42071 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  42071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  42074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  42076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  42080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  42084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  42088 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  42098 */     GIR_RootConstrainSelectedInstOperands,
     /*  42099 */     // GIR_Coverage, 5217,
     /*  42099 */     GIR_EraseRootFromParent_Done,
     /*  42100 */   // Label 528: @42100
     /*  42100 */   GIM_Try, /*On fail goto*//*Label 529*/ GIMT_Encode4(42238), // Rule ID 5224 //
     /*  42105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  42108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  42112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42124 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42128 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42132 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42136 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42140 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42144 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  42148 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42152 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42156 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42160 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  42164 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42170 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  42172 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  42176 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42180 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42184 */     // MIs[5] vC
     /*  42184 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  42189 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  42193 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42197 */     // MIs[6] vA
     /*  42197 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  42202 */     // MIs[6] vB
     /*  42202 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  42207 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  42209 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  42209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  42212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  42214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  42218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  42222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  42226 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  42236 */     GIR_RootConstrainSelectedInstOperands,
     /*  42237 */     // GIR_Coverage, 5224,
     /*  42237 */     GIR_EraseRootFromParent_Done,
     /*  42238 */   // Label 529: @42238
     /*  42238 */   GIM_Try, /*On fail goto*//*Label 530*/ GIMT_Encode4(42376), // Rule ID 5225 //
     /*  42243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  42246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  42250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42262 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42266 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42270 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42274 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42278 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42282 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  42286 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42290 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42294 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42298 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  42302 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42308 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  42310 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  42314 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42318 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42322 */     // MIs[5] vC
     /*  42322 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  42327 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  42331 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42335 */     // MIs[6] vB
     /*  42335 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  42340 */     // MIs[6] vA
     /*  42340 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  42345 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  42347 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  42347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  42350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  42352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  42356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  42360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  42364 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  42374 */     GIR_RootConstrainSelectedInstOperands,
     /*  42375 */     // GIR_Coverage, 5225,
     /*  42375 */     GIR_EraseRootFromParent_Done,
     /*  42376 */   // Label 530: @42376
     /*  42376 */   GIM_Try, /*On fail goto*//*Label 531*/ GIMT_Encode4(42514), // Rule ID 5226 //
     /*  42381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  42384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  42388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42400 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42404 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42408 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42412 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42416 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42420 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  42424 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42428 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42432 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42436 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  42440 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42446 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  42448 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  42452 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42456 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42460 */     // MIs[5] vB
     /*  42460 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  42465 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  42469 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42473 */     // MIs[6] vA
     /*  42473 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  42478 */     // MIs[6] vC
     /*  42478 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  42483 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  42485 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  42485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  42488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  42490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  42494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  42498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  42502 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  42512 */     GIR_RootConstrainSelectedInstOperands,
     /*  42513 */     // GIR_Coverage, 5226,
     /*  42513 */     GIR_EraseRootFromParent_Done,
     /*  42514 */   // Label 531: @42514
     /*  42514 */   GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(42652), // Rule ID 5227 //
     /*  42519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  42522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  42526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42534 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42538 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42542 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42546 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42550 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42554 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42558 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  42562 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42566 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42570 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42574 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  42578 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42584 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  42586 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  42590 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42594 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42598 */     // MIs[5] vB
     /*  42598 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  42603 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  42607 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42611 */     // MIs[6] vC
     /*  42611 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  42616 */     // MIs[6] vA
     /*  42616 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  42621 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  42623 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  42623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  42626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  42628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  42632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  42636 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  42640 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  42650 */     GIR_RootConstrainSelectedInstOperands,
     /*  42651 */     // GIR_Coverage, 5227,
     /*  42651 */     GIR_EraseRootFromParent_Done,
     /*  42652 */   // Label 532: @42652
     /*  42652 */   GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(42790), // Rule ID 5228 //
     /*  42657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  42660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  42664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42676 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42680 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42684 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42688 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42692 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42696 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  42700 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42704 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42708 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42712 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  42716 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42722 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  42724 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  42728 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42732 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42736 */     // MIs[5] vA
     /*  42736 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  42741 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  42745 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42749 */     // MIs[6] vB
     /*  42749 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  42754 */     // MIs[6] vC
     /*  42754 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  42759 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  42761 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  42761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  42764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  42766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  42770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  42774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  42778 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  42788 */     GIR_RootConstrainSelectedInstOperands,
     /*  42789 */     // GIR_Coverage, 5228,
     /*  42789 */     GIR_EraseRootFromParent_Done,
     /*  42790 */   // Label 533: @42790
     /*  42790 */   GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(42928), // Rule ID 5229 //
     /*  42795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  42798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  42802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42814 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42826 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42830 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42834 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  42838 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42842 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42846 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42850 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  42854 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42860 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  42862 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  42866 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42870 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42874 */     // MIs[5] vA
     /*  42874 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  42879 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  42883 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42887 */     // MIs[6] vC
     /*  42887 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  42892 */     // MIs[6] vB
     /*  42892 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  42897 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  42899 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  42899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  42902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  42904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  42908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  42912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  42916 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  42926 */     GIR_RootConstrainSelectedInstOperands,
     /*  42927 */     // GIR_Coverage, 5229,
     /*  42927 */     GIR_EraseRootFromParent_Done,
     /*  42928 */   // Label 534: @42928
     /*  42928 */   GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(43066), // Rule ID 5236 //
     /*  42933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  42936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  42940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42952 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42956 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42960 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42964 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42968 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42972 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  42976 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42980 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42984 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42988 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  42992 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42998 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  43000 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  43004 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43008 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43012 */     // MIs[5] vC
     /*  43012 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  43017 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  43021 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43025 */     // MIs[6] vA
     /*  43025 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  43030 */     // MIs[6] vB
     /*  43030 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  43035 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  43037 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  43037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  43040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  43042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  43046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  43050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  43054 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  43064 */     GIR_RootConstrainSelectedInstOperands,
     /*  43065 */     // GIR_Coverage, 5236,
     /*  43065 */     GIR_EraseRootFromParent_Done,
     /*  43066 */   // Label 535: @43066
     /*  43066 */   GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(43204), // Rule ID 5237 //
     /*  43071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  43074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  43078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  43086 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43090 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43094 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43098 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43102 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43106 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43110 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  43114 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43118 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43122 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43126 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  43130 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43136 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  43138 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  43142 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43146 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43150 */     // MIs[5] vC
     /*  43150 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  43155 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  43159 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43163 */     // MIs[6] vB
     /*  43163 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  43168 */     // MIs[6] vA
     /*  43168 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  43173 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  43175 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  43175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  43178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  43180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  43184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  43188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  43192 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  43202 */     GIR_RootConstrainSelectedInstOperands,
     /*  43203 */     // GIR_Coverage, 5237,
     /*  43203 */     GIR_EraseRootFromParent_Done,
     /*  43204 */   // Label 536: @43204
     /*  43204 */   GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(43342), // Rule ID 5238 //
     /*  43209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  43212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  43216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  43224 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43228 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43232 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43236 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43240 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43244 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43248 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  43252 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43256 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43260 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43264 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  43268 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43274 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  43276 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  43280 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43284 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43288 */     // MIs[5] vB
     /*  43288 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  43293 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  43297 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43301 */     // MIs[6] vA
     /*  43301 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  43306 */     // MIs[6] vC
     /*  43306 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  43311 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  43313 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  43313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  43316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  43318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  43322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  43326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  43330 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  43340 */     GIR_RootConstrainSelectedInstOperands,
     /*  43341 */     // GIR_Coverage, 5238,
     /*  43341 */     GIR_EraseRootFromParent_Done,
     /*  43342 */   // Label 537: @43342
     /*  43342 */   GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(43480), // Rule ID 5239 //
     /*  43347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  43350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  43354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  43362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43366 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43370 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43374 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43378 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43382 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43386 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  43390 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43394 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43398 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43402 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  43406 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43412 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  43414 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  43418 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43422 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43426 */     // MIs[5] vB
     /*  43426 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  43431 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  43435 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43439 */     // MIs[6] vC
     /*  43439 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  43444 */     // MIs[6] vA
     /*  43444 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  43449 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  43451 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  43451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  43454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  43456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  43460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  43464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  43468 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  43478 */     GIR_RootConstrainSelectedInstOperands,
     /*  43479 */     // GIR_Coverage, 5239,
     /*  43479 */     GIR_EraseRootFromParent_Done,
     /*  43480 */   // Label 538: @43480
     /*  43480 */   GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(43618), // Rule ID 5240 //
     /*  43485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  43488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  43492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  43500 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43504 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43508 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43512 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43516 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43520 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43524 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  43528 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43532 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43536 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43540 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  43544 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43550 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  43552 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  43556 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43560 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43564 */     // MIs[5] vA
     /*  43564 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  43569 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  43573 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43577 */     // MIs[6] vB
     /*  43577 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  43582 */     // MIs[6] vC
     /*  43582 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  43587 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  43589 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  43589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  43592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  43594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  43598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  43602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  43606 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  43616 */     GIR_RootConstrainSelectedInstOperands,
     /*  43617 */     // GIR_Coverage, 5240,
     /*  43617 */     GIR_EraseRootFromParent_Done,
     /*  43618 */   // Label 539: @43618
     /*  43618 */   GIM_Try, /*On fail goto*//*Label 540*/ GIMT_Encode4(43756), // Rule ID 5241 //
     /*  43623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  43626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  43630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  43638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43642 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43646 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43650 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43654 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43658 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43662 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  43666 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43670 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43674 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43678 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  43682 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43688 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  43690 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  43694 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43698 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43702 */     // MIs[5] vA
     /*  43702 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  43707 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  43711 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43715 */     // MIs[6] vC
     /*  43715 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  43720 */     // MIs[6] vB
     /*  43720 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  43725 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  43727 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  43727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  43730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  43732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  43736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  43740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  43744 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  43754 */     GIR_RootConstrainSelectedInstOperands,
     /*  43755 */     // GIR_Coverage, 5241,
     /*  43755 */     GIR_EraseRootFromParent_Done,
     /*  43756 */   // Label 540: @43756
     /*  43756 */   GIM_Try, /*On fail goto*//*Label 541*/ GIMT_Encode4(43894), // Rule ID 5248 //
     /*  43761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  43764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  43768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  43776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43780 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43784 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43788 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43792 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43796 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43800 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  43804 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43808 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43812 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43816 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  43820 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43826 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  43828 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  43832 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43836 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43840 */     // MIs[5] vC
     /*  43840 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  43845 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  43849 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43853 */     // MIs[6] vA
     /*  43853 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  43858 */     // MIs[6] vB
     /*  43858 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  43863 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  43865 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  43865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  43868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  43870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  43874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  43878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  43882 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  43892 */     GIR_RootConstrainSelectedInstOperands,
     /*  43893 */     // GIR_Coverage, 5248,
     /*  43893 */     GIR_EraseRootFromParent_Done,
     /*  43894 */   // Label 541: @43894
     /*  43894 */   GIM_Try, /*On fail goto*//*Label 542*/ GIMT_Encode4(44032), // Rule ID 5249 //
     /*  43899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  43902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  43906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  43914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43918 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43922 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43926 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43930 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43934 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43938 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  43942 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43946 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43950 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43954 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  43958 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43964 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  43966 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  43970 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43974 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43978 */     // MIs[5] vC
     /*  43978 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  43983 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  43987 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43991 */     // MIs[6] vB
     /*  43991 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  43996 */     // MIs[6] vA
     /*  43996 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  44001 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  44003 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  44003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  44006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  44008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  44012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  44016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  44020 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  44030 */     GIR_RootConstrainSelectedInstOperands,
     /*  44031 */     // GIR_Coverage, 5249,
     /*  44031 */     GIR_EraseRootFromParent_Done,
     /*  44032 */   // Label 542: @44032
     /*  44032 */   GIM_Try, /*On fail goto*//*Label 543*/ GIMT_Encode4(44170), // Rule ID 5250 //
     /*  44037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  44040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  44044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  44052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44056 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44068 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44072 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44076 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44080 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44084 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44088 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44092 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  44096 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44102 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  44104 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  44108 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44112 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44116 */     // MIs[5] vB
     /*  44116 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  44121 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  44125 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44129 */     // MIs[6] vA
     /*  44129 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  44134 */     // MIs[6] vC
     /*  44134 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  44139 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  44141 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  44141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  44144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  44146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  44150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  44154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  44158 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  44168 */     GIR_RootConstrainSelectedInstOperands,
     /*  44169 */     // GIR_Coverage, 5250,
     /*  44169 */     GIR_EraseRootFromParent_Done,
     /*  44170 */   // Label 543: @44170
     /*  44170 */   GIM_Try, /*On fail goto*//*Label 544*/ GIMT_Encode4(44308), // Rule ID 5251 //
     /*  44175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  44178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  44182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  44190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44194 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44198 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44202 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44206 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44210 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44214 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44218 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44222 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44226 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44230 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  44234 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44240 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  44242 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  44246 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44250 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44254 */     // MIs[5] vB
     /*  44254 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  44259 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  44263 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44267 */     // MIs[6] vC
     /*  44267 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  44272 */     // MIs[6] vA
     /*  44272 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  44277 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  44279 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  44279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  44282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  44284 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  44288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  44292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  44296 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  44306 */     GIR_RootConstrainSelectedInstOperands,
     /*  44307 */     // GIR_Coverage, 5251,
     /*  44307 */     GIR_EraseRootFromParent_Done,
     /*  44308 */   // Label 544: @44308
     /*  44308 */   GIM_Try, /*On fail goto*//*Label 545*/ GIMT_Encode4(44446), // Rule ID 5252 //
     /*  44313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  44316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  44320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  44328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44336 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44340 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44344 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44348 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44352 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44356 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44360 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44364 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44368 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  44372 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44378 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  44380 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  44384 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44388 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44392 */     // MIs[5] vA
     /*  44392 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  44397 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  44401 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44405 */     // MIs[6] vB
     /*  44405 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  44410 */     // MIs[6] vC
     /*  44410 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  44415 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  44417 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  44417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  44420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  44422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  44426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  44430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  44434 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  44444 */     GIR_RootConstrainSelectedInstOperands,
     /*  44445 */     // GIR_Coverage, 5252,
     /*  44445 */     GIR_EraseRootFromParent_Done,
     /*  44446 */   // Label 545: @44446
     /*  44446 */   GIM_Try, /*On fail goto*//*Label 546*/ GIMT_Encode4(44584), // Rule ID 5253 //
     /*  44451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  44454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  44458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  44466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44470 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44474 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44478 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44482 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44486 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44490 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44494 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44498 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44502 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44506 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  44510 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44516 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  44518 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  44522 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44526 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44530 */     // MIs[5] vA
     /*  44530 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  44535 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  44539 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44543 */     // MIs[6] vC
     /*  44543 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  44548 */     // MIs[6] vB
     /*  44548 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  44553 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  44555 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  44555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  44558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  44560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  44564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  44568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  44572 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  44582 */     GIR_RootConstrainSelectedInstOperands,
     /*  44583 */     // GIR_Coverage, 5253,
     /*  44583 */     GIR_EraseRootFromParent_Done,
     /*  44584 */   // Label 546: @44584
     /*  44584 */   GIM_Try, /*On fail goto*//*Label 547*/ GIMT_Encode4(44722), // Rule ID 5260 //
     /*  44589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  44592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  44596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  44604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44608 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44612 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44616 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44620 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44624 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44628 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44632 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44636 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44640 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44644 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  44648 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44654 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  44656 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  44660 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44664 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44668 */     // MIs[5] vC
     /*  44668 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  44673 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  44677 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44681 */     // MIs[6] vA
     /*  44681 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  44686 */     // MIs[6] vB
     /*  44686 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  44691 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  44693 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  44693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  44696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  44698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  44702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  44706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  44710 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  44720 */     GIR_RootConstrainSelectedInstOperands,
     /*  44721 */     // GIR_Coverage, 5260,
     /*  44721 */     GIR_EraseRootFromParent_Done,
     /*  44722 */   // Label 547: @44722
     /*  44722 */   GIM_Try, /*On fail goto*//*Label 548*/ GIMT_Encode4(44860), // Rule ID 5261 //
     /*  44727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  44730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  44734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  44742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44746 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44750 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44754 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44758 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44762 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44766 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44770 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44774 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44778 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44782 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  44786 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44792 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  44794 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  44798 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44802 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44806 */     // MIs[5] vC
     /*  44806 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  44811 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  44815 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44819 */     // MIs[6] vB
     /*  44819 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  44824 */     // MIs[6] vA
     /*  44824 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  44829 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  44831 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  44831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  44834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  44836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  44840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  44844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  44848 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  44858 */     GIR_RootConstrainSelectedInstOperands,
     /*  44859 */     // GIR_Coverage, 5261,
     /*  44859 */     GIR_EraseRootFromParent_Done,
     /*  44860 */   // Label 548: @44860
     /*  44860 */   GIM_Try, /*On fail goto*//*Label 549*/ GIMT_Encode4(44998), // Rule ID 5262 //
     /*  44865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  44868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  44872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  44880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44884 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44888 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44892 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44896 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44900 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44904 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44908 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44912 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44916 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44920 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  44924 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44930 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  44932 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  44936 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44940 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44944 */     // MIs[5] vB
     /*  44944 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  44949 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  44953 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44957 */     // MIs[6] vA
     /*  44957 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  44962 */     // MIs[6] vC
     /*  44962 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  44967 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  44969 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  44969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  44972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  44974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  44978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  44982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  44986 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  44996 */     GIR_RootConstrainSelectedInstOperands,
     /*  44997 */     // GIR_Coverage, 5262,
     /*  44997 */     GIR_EraseRootFromParent_Done,
     /*  44998 */   // Label 549: @44998
     /*  44998 */   GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(45136), // Rule ID 5263 //
     /*  45003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  45006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  45010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45022 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45026 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45030 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  45034 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45038 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45042 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45046 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  45050 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45054 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45058 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  45062 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45068 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  45070 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  45074 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45078 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45082 */     // MIs[5] vB
     /*  45082 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  45087 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  45091 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45095 */     // MIs[6] vC
     /*  45095 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  45100 */     // MIs[6] vA
     /*  45100 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  45105 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  45107 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  45107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  45110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  45112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  45116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  45120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  45124 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  45134 */     GIR_RootConstrainSelectedInstOperands,
     /*  45135 */     // GIR_Coverage, 5263,
     /*  45135 */     GIR_EraseRootFromParent_Done,
     /*  45136 */   // Label 550: @45136
     /*  45136 */   GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(45274), // Rule ID 5264 //
     /*  45141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  45144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  45148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  45172 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45176 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45180 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45184 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  45188 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45192 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45196 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  45200 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45206 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  45208 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  45212 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45216 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45220 */     // MIs[5] vA
     /*  45220 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  45225 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  45229 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45233 */     // MIs[6] vB
     /*  45233 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  45238 */     // MIs[6] vC
     /*  45238 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  45243 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  45245 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  45245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  45248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  45250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  45254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  45258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  45262 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  45272 */     GIR_RootConstrainSelectedInstOperands,
     /*  45273 */     // GIR_Coverage, 5264,
     /*  45273 */     GIR_EraseRootFromParent_Done,
     /*  45274 */   // Label 551: @45274
     /*  45274 */   GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(45412), // Rule ID 5265 //
     /*  45279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  45282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  45286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45294 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45298 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45302 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45306 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  45310 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45314 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45318 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45322 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  45326 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45330 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45334 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  45338 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45344 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  45346 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  45350 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45354 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45358 */     // MIs[5] vA
     /*  45358 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  45363 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  45367 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45371 */     // MIs[6] vC
     /*  45371 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  45376 */     // MIs[6] vB
     /*  45376 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  45381 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  45383 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  45383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  45386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  45388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  45392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  45396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  45400 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  45410 */     GIR_RootConstrainSelectedInstOperands,
     /*  45411 */     // GIR_Coverage, 5265,
     /*  45411 */     GIR_EraseRootFromParent_Done,
     /*  45412 */   // Label 552: @45412
     /*  45412 */   GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(45506), // Rule ID 4952 //
     /*  45417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  45420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  45424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45432 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45436 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45448 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45452 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45456 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45460 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45466 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  45468 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  45472 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45476 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45480 */     // MIs[4] C
     /*  45480 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  45485 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45487 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$A), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, v4i32:{ *:[v4i32] }:$B))  =>  (XXSEL:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B, ?:{ *:[v4i32] }:$C)
     /*  45487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /*  45490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  45492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // A
     /*  45496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // B
     /*  45500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // C
     /*  45504 */     GIR_RootConstrainSelectedInstOperands,
     /*  45505 */     // GIR_Coverage, 4952,
     /*  45505 */     GIR_EraseRootFromParent_Done,
     /*  45506 */   // Label 553: @45506
     /*  45506 */   GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(45600), // Rule ID 1588 //
     /*  45511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  45514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  45518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45530 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45534 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45538 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45542 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45546 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45550 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45554 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45560 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  45562 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  45566 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45570 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45574 */     // MIs[4] C
     /*  45574 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  45579 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45581 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$A), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$B, v4i32:{ *:[v4i32] }:$C))  =>  (XXSEL:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B, ?:{ *:[v4i32] }:$C)
     /*  45581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /*  45584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  45586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // A
     /*  45590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // B
     /*  45594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // C
     /*  45598 */     GIR_RootConstrainSelectedInstOperands,
     /*  45599 */     // GIR_Coverage, 1588,
     /*  45599 */     GIR_EraseRootFromParent_Done,
     /*  45600 */   // Label 554: @45600
     /*  45600 */   GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(45694), // Rule ID 4954 //
     /*  45605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  45608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  45612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45624 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45628 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  45632 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45636 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45640 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45644 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45648 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45654 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  45656 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  45660 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45664 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45668 */     // MIs[4] C
     /*  45668 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  45673 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45675 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$A, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, v4i32:{ *:[v4i32] }:$B))  =>  (XXSEL:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B, ?:{ *:[v4i32] }:$C)
     /*  45675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /*  45678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  45680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // A
     /*  45684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // B
     /*  45688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // C
     /*  45692 */     GIR_RootConstrainSelectedInstOperands,
     /*  45693 */     // GIR_Coverage, 4954,
     /*  45693 */     GIR_EraseRootFromParent_Done,
     /*  45694 */   // Label 555: @45694
     /*  45694 */   GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(45788), // Rule ID 4953 //
     /*  45699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  45702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  45706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45718 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45722 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  45726 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45730 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45734 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45738 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45742 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45748 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  45750 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  45754 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45758 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45762 */     // MIs[4] C
     /*  45762 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  45767 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45769 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$A, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$B, v4i32:{ *:[v4i32] }:$C))  =>  (XXSEL:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B, ?:{ *:[v4i32] }:$C)
     /*  45769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /*  45772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  45774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // A
     /*  45778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // B
     /*  45782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // C
     /*  45786 */     GIR_RootConstrainSelectedInstOperands,
     /*  45787 */     // GIR_Coverage, 4953,
     /*  45787 */     GIR_EraseRootFromParent_Done,
     /*  45788 */   // Label 556: @45788
     /*  45788 */   GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(45882), // Rule ID 4955 //
     /*  45793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  45796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  45800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45812 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45816 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  45820 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45824 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45828 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45832 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  45836 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45840 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45844 */     // MIs[3] C
     /*  45844 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  45849 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  45853 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45859 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  45861 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45863 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$B, v4i32:{ *:[v4i32] }:$C), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$A))  =>  (XXSEL:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B, ?:{ *:[v4i32] }:$C)
     /*  45863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /*  45866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  45868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // A
     /*  45872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // B
     /*  45876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // C
     /*  45880 */     GIR_RootConstrainSelectedInstOperands,
     /*  45881 */     // GIR_Coverage, 4955,
     /*  45881 */     GIR_EraseRootFromParent_Done,
     /*  45882 */   // Label 557: @45882
     /*  45882 */   GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(45976), // Rule ID 4957 //
     /*  45887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  45890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  45894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45906 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45910 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  45914 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45918 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45922 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45926 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  45930 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45934 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45938 */     // MIs[3] C
     /*  45938 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  45943 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  45947 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45953 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  45955 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45957 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, v4i32:{ *:[v4i32] }:$B), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$A))  =>  (XXSEL:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B, ?:{ *:[v4i32] }:$C)
     /*  45957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /*  45960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  45962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // A
     /*  45966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // B
     /*  45970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // C
     /*  45974 */     GIR_RootConstrainSelectedInstOperands,
     /*  45975 */     // GIR_Coverage, 4957,
     /*  45975 */     GIR_EraseRootFromParent_Done,
     /*  45976 */   // Label 558: @45976
     /*  45976 */   GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(46070), // Rule ID 4956 //
     /*  45981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  45984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  45988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46000 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  46012 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46016 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46020 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  46024 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46028 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46032 */     // MIs[3] C
     /*  46032 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  46037 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  46041 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46047 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  46049 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  46051 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$B, v4i32:{ *:[v4i32] }:$C), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$A, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, immAllOnesV:{ *:[v4i32] })))  =>  (XXSEL:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B, ?:{ *:[v4i32] }:$C)
     /*  46051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /*  46054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // A
     /*  46060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // B
     /*  46064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // C
     /*  46068 */     GIR_RootConstrainSelectedInstOperands,
     /*  46069 */     // GIR_Coverage, 4956,
     /*  46069 */     GIR_EraseRootFromParent_Done,
     /*  46070 */   // Label 559: @46070
     /*  46070 */   GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(46164), // Rule ID 4958 //
     /*  46075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  46078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  46082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  46090 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46094 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46098 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46102 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  46106 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46110 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46114 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  46118 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46122 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46126 */     // MIs[3] C
     /*  46126 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  46131 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  46135 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46141 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  46143 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  46145 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, v4i32:{ *:[v4i32] }:$B), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$A, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, immAllOnesV:{ *:[v4i32] })))  =>  (XXSEL:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B, ?:{ *:[v4i32] }:$C)
     /*  46145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /*  46148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // A
     /*  46154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // B
     /*  46158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // C
     /*  46162 */     GIR_RootConstrainSelectedInstOperands,
     /*  46163 */     // GIR_Coverage, 4958,
     /*  46163 */     GIR_EraseRootFromParent_Done,
     /*  46164 */   // Label 560: @46164
     /*  46164 */   GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(46251), // Rule ID 4978 //
     /*  46169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  46172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  46176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  46184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46188 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46192 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46196 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46200 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46204 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46208 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  46212 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46218 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  46220 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  46222 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 241:{ *:[i32] })
     /*  46222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  46225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  46231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  46235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  46239 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(241),
     /*  46249 */     GIR_RootConstrainSelectedInstOperands,
     /*  46250 */     // GIR_Coverage, 4978,
     /*  46250 */     GIR_EraseRootFromParent_Done,
     /*  46251 */   // Label 561: @46251
     /*  46251 */   GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(46336), // Rule ID 4972 //
     /*  46256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  46259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  46263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  46271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46275 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46279 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46283 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46287 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46291 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46295 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  46299 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46305 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  46307 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  46309 */     // (or:{ *:[v4i32] } (or:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 247:{ *:[i32] })
     /*  46309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  46312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  46318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  46322 */     GIR_RootToRootCopy, /*OpIdx*/2, // vC
     /*  46324 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(247),
     /*  46334 */     GIR_RootConstrainSelectedInstOperands,
     /*  46335 */     // GIR_Coverage, 4972,
     /*  46335 */     GIR_EraseRootFromParent_Done,
     /*  46336 */   // Label 562: @46336
     /*  46336 */   GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(46421), // Rule ID 4973 //
     /*  46341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  46344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  46348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  46356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46360 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  46368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46372 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46376 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46380 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  46384 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46390 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  46392 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  46394 */     // (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] })), v4i32:{ *:[v4i32] }:$vC)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 247:{ *:[i32] })
     /*  46394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  46397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  46403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  46407 */     GIR_RootToRootCopy, /*OpIdx*/2, // vC
     /*  46409 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(247),
     /*  46419 */     GIR_RootConstrainSelectedInstOperands,
     /*  46420 */     // GIR_Coverage, 4973,
     /*  46420 */     GIR_EraseRootFromParent_Done,
     /*  46421 */   // Label 563: @46421
     /*  46421 */   GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(46508), // Rule ID 4974 //
     /*  46426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  46429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  46433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  46441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46445 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46449 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46453 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46457 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46461 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46465 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  46469 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46475 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  46477 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  46479 */     // (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 247:{ *:[i32] })
     /*  46479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  46482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  46488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  46492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  46496 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(247),
     /*  46506 */     GIR_RootConstrainSelectedInstOperands,
     /*  46507 */     // GIR_Coverage, 4974,
     /*  46507 */     GIR_EraseRootFromParent_Done,
     /*  46508 */   // Label 564: @46508
     /*  46508 */   GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(46593), // Rule ID 5293 //
     /*  46513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  46516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  46520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46532 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46536 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46540 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  46544 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46548 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46552 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  46556 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46562 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  46564 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  46566 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 239:{ *:[i32] })
     /*  46566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  46569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46571 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  46573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  46577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  46581 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(239),
     /*  46591 */     GIR_RootConstrainSelectedInstOperands,
     /*  46592 */     // GIR_Coverage, 5293,
     /*  46592 */     GIR_EraseRootFromParent_Done,
     /*  46593 */   // Label 565: @46593
     /*  46593 */   GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(46678), // Rule ID 5294 //
     /*  46598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  46601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  46605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46617 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46621 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46625 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  46629 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46633 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46637 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  46641 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46647 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  46649 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  46651 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 143:{ *:[i32] })
     /*  46651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  46654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46656 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  46658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  46662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  46666 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(143),
     /*  46676 */     GIR_RootConstrainSelectedInstOperands,
     /*  46677 */     // GIR_Coverage, 5294,
     /*  46677 */     GIR_EraseRootFromParent_Done,
     /*  46678 */   // Label 566: @46678
     /*  46678 */   GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(46763), // Rule ID 5291 //
     /*  46683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  46686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  46690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46702 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46710 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46714 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46718 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46722 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  46726 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46732 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  46734 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  46736 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 159:{ *:[i32] })
     /*  46736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  46739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46741 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  46743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  46747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  46751 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(159),
     /*  46761 */     GIR_RootConstrainSelectedInstOperands,
     /*  46762 */     // GIR_Coverage, 5291,
     /*  46762 */     GIR_EraseRootFromParent_Done,
     /*  46763 */   // Label 567: @46763
     /*  46763 */   GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(46848), // Rule ID 5290 //
     /*  46768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  46771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  46775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46787 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46791 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46795 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46799 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46803 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46807 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  46811 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46817 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  46819 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  46821 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 159:{ *:[i32] })
     /*  46821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  46824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46826 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  46828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  46832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  46836 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(159),
     /*  46846 */     GIR_RootConstrainSelectedInstOperands,
     /*  46847 */     // GIR_Coverage, 5290,
     /*  46847 */     GIR_EraseRootFromParent_Done,
     /*  46848 */   // Label 568: @46848
     /*  46848 */   GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(46933), // Rule ID 5292 //
     /*  46853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  46856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  46860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46872 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46876 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  46880 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46884 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46888 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46892 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  46896 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46902 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  46904 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  46906 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, immAllOnesV:{ *:[v4i32] })), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 159:{ *:[i32] })
     /*  46906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  46909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46911 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  46913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  46917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  46921 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(159),
     /*  46931 */     GIR_RootConstrainSelectedInstOperands,
     /*  46932 */     // GIR_Coverage, 5292,
     /*  46932 */     GIR_EraseRootFromParent_Done,
     /*  46933 */   // Label 569: @46933
     /*  46933 */   GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(47020), // Rule ID 3398 //
     /*  46938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  46941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  46945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46957 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46961 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  46965 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46971 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  46973 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  46977 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  46981 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46985 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46989 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  46991 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 241:{ *:[i32] })
     /*  46991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  46994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  47000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  47004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  47008 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(241),
     /*  47018 */     GIR_RootConstrainSelectedInstOperands,
     /*  47019 */     // GIR_Coverage, 3398,
     /*  47019 */     GIR_EraseRootFromParent_Done,
     /*  47020 */   // Label 570: @47020
     /*  47020 */   GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(47107), // Rule ID 3396 //
     /*  47025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  47028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47040 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47044 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47048 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47052 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47058 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  47060 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  47064 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  47068 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47072 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47076 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47078 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 247:{ *:[i32] })
     /*  47078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  47081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  47087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  47091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  47095 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(247),
     /*  47105 */     GIR_RootConstrainSelectedInstOperands,
     /*  47106 */     // GIR_Coverage, 3396,
     /*  47106 */     GIR_EraseRootFromParent_Done,
     /*  47107 */   // Label 571: @47107
     /*  47107 */   GIM_Try, /*On fail goto*//*Label 572*/ GIMT_Encode4(47194), // Rule ID 3397 //
     /*  47112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  47115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47131 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47135 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47139 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47145 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  47147 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  47151 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47155 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47159 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47163 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47165 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 246:{ *:[i32] })
     /*  47165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  47168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  47174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  47178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  47182 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(246),
     /*  47192 */     GIR_RootConstrainSelectedInstOperands,
     /*  47193 */     // GIR_Coverage, 3397,
     /*  47193 */     GIR_EraseRootFromParent_Done,
     /*  47194 */   // Label 572: @47194
     /*  47194 */   GIM_Try, /*On fail goto*//*Label 573*/ GIMT_Encode4(47281), // Rule ID 4977 //
     /*  47199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  47202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47218 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47230 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47234 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47238 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  47242 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47248 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  47250 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47252 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 246:{ *:[i32] })
     /*  47252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  47255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  47261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  47265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  47269 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(246),
     /*  47279 */     GIR_RootConstrainSelectedInstOperands,
     /*  47280 */     // GIR_Coverage, 4977,
     /*  47280 */     GIR_EraseRootFromParent_Done,
     /*  47281 */   // Label 573: @47281
     /*  47281 */   GIM_Try, /*On fail goto*//*Label 574*/ GIMT_Encode4(47366), // Rule ID 4975 //
     /*  47286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  47289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  47301 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47305 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47317 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47321 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47325 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  47329 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47335 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  47337 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47339 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 247:{ *:[i32] })
     /*  47339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  47342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  47348 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  47352 */     GIR_RootToRootCopy, /*OpIdx*/1, // vC
     /*  47354 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(247),
     /*  47364 */     GIR_RootConstrainSelectedInstOperands,
     /*  47365 */     // GIR_Coverage, 4975,
     /*  47365 */     GIR_EraseRootFromParent_Done,
     /*  47366 */   // Label 574: @47366
     /*  47366 */   GIM_Try, /*On fail goto*//*Label 575*/ GIMT_Encode4(47451), // Rule ID 4976 //
     /*  47371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  47374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  47386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47390 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47398 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47402 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47406 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47410 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  47414 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47420 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  47422 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47424 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] })))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 247:{ *:[i32] })
     /*  47424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  47427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47429 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  47433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  47437 */     GIR_RootToRootCopy, /*OpIdx*/1, // vC
     /*  47439 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(247),
     /*  47449 */     GIR_RootConstrainSelectedInstOperands,
     /*  47450 */     // GIR_Coverage, 4976,
     /*  47450 */     GIR_EraseRootFromParent_Done,
     /*  47451 */   // Label 575: @47451
     /*  47451 */   GIM_Try, /*On fail goto*//*Label 576*/ GIMT_Encode4(47536), // Rule ID 3411 //
     /*  47456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  47459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47475 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47479 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47483 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  47487 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47491 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47495 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  47499 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47505 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  47507 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47509 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 239:{ *:[i32] })
     /*  47509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  47512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47514 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  47516 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  47520 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  47524 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(239),
     /*  47534 */     GIR_RootConstrainSelectedInstOperands,
     /*  47535 */     // GIR_Coverage, 3411,
     /*  47535 */     GIR_EraseRootFromParent_Done,
     /*  47536 */   // Label 576: @47536
     /*  47536 */   GIM_Try, /*On fail goto*//*Label 577*/ GIMT_Encode4(47621), // Rule ID 3412 //
     /*  47541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  47544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47556 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47560 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  47572 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47576 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47580 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  47584 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47590 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  47592 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47594 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 143:{ *:[i32] })
     /*  47594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  47597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47599 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  47601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  47605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  47609 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(143),
     /*  47619 */     GIR_RootConstrainSelectedInstOperands,
     /*  47620 */     // GIR_Coverage, 3412,
     /*  47620 */     GIR_EraseRootFromParent_Done,
     /*  47621 */   // Label 577: @47621
     /*  47621 */   GIM_Try, /*On fail goto*//*Label 578*/ GIMT_Encode4(47706), // Rule ID 5288 //
     /*  47626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  47629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47645 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47649 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47653 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47657 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47661 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47665 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  47669 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47675 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  47677 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47679 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 159:{ *:[i32] })
     /*  47679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  47682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47684 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  47686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  47690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  47694 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(159),
     /*  47704 */     GIR_RootConstrainSelectedInstOperands,
     /*  47705 */     // GIR_Coverage, 5288,
     /*  47705 */     GIR_EraseRootFromParent_Done,
     /*  47706 */   // Label 578: @47706
     /*  47706 */   GIM_Try, /*On fail goto*//*Label 579*/ GIMT_Encode4(47791), // Rule ID 3410 //
     /*  47711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  47714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47730 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47734 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47738 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47742 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47746 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47750 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  47754 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47760 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  47762 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47764 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 159:{ *:[i32] })
     /*  47764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  47767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47769 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  47771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  47775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  47779 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(159),
     /*  47789 */     GIR_RootConstrainSelectedInstOperands,
     /*  47790 */     // GIR_Coverage, 3410,
     /*  47790 */     GIR_EraseRootFromParent_Done,
     /*  47791 */   // Label 579: @47791
     /*  47791 */   GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(47876), // Rule ID 5289 //
     /*  47796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  47799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47815 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47819 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47823 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47827 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47831 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47835 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  47839 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47845 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  47847 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47849 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, immAllOnesV:{ *:[v4i32] })))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 159:{ *:[i32] })
     /*  47849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  47852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47854 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  47856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  47860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  47864 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(159),
     /*  47874 */     GIR_RootConstrainSelectedInstOperands,
     /*  47875 */     // GIR_Coverage, 5289,
     /*  47875 */     GIR_EraseRootFromParent_Done,
     /*  47876 */   // Label 580: @47876
     /*  47876 */   GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(47931), // Rule ID 4942 //
     /*  47881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  47884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47900 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47904 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47908 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47914 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  47916 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47918 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XB, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$XA)  =>  (XXLORC:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*  47918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLORC),
     /*  47921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47923 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  47925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XB
     /*  47929 */     GIR_RootConstrainSelectedInstOperands,
     /*  47930 */     // GIR_Coverage, 4942,
     /*  47930 */     GIR_EraseRootFromParent_Done,
     /*  47931 */   // Label 581: @47931
     /*  47931 */   GIM_Try, /*On fail goto*//*Label 582*/ GIMT_Encode4(47986), // Rule ID 946 //
     /*  47936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  47939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47955 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47959 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47963 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47969 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  47971 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47973 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XB, immAllOnesV:{ *:[v4i32] }))  =>  (XXLORC:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*  47973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLORC),
     /*  47976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47978 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /*  47980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XB
     /*  47984 */     GIR_RootConstrainSelectedInstOperands,
     /*  47985 */     // GIR_Coverage, 946,
     /*  47985 */     GIR_EraseRootFromParent_Done,
     /*  47986 */   // Label 582: @47986
     /*  47986 */   GIM_Try, /*On fail goto*//*Label 583*/ GIMT_Encode4(48036), // Rule ID 5287 //
     /*  47991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  47994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  48006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  48010 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  48014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48016 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 31:{ *:[i32] })
     /*  48016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  48019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  48021 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  48023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  48027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  48031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  48034 */     GIR_RootConstrainSelectedInstOperands,
     /*  48035 */     // GIR_Coverage, 5287,
     /*  48035 */     GIR_EraseRootFromParent_Done,
     /*  48036 */   // Label 583: @48036
     /*  48036 */   GIM_Try, /*On fail goto*//*Label 584*/ GIMT_Encode4(48086), // Rule ID 5286 //
     /*  48041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  48044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  48048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  48056 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  48060 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  48064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48066 */     // (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 127:{ *:[i32] })
     /*  48066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  48069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  48071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  48075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  48079 */     GIR_RootToRootCopy, /*OpIdx*/2, // vC
     /*  48081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/127,
     /*  48084 */     GIR_RootConstrainSelectedInstOperands,
     /*  48085 */     // GIR_Coverage, 5286,
     /*  48085 */     GIR_EraseRootFromParent_Done,
     /*  48086 */   // Label 584: @48086
     /*  48086 */   GIM_Try, /*On fail goto*//*Label 585*/ GIMT_Encode4(48136), // Rule ID 5295 //
     /*  48091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  48094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  48098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  48106 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  48110 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  48114 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48116 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 111:{ *:[i32] })
     /*  48116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  48119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  48121 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  48123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  48127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  48131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/111,
     /*  48134 */     GIR_RootConstrainSelectedInstOperands,
     /*  48135 */     // GIR_Coverage, 5295,
     /*  48135 */     GIR_EraseRootFromParent_Done,
     /*  48136 */   // Label 585: @48136
     /*  48136 */   GIM_Try, /*On fail goto*//*Label 586*/ GIMT_Encode4(48186), // Rule ID 3409 //
     /*  48141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  48144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  48148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  48156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  48160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  48164 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48166 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 31:{ *:[i32] })
     /*  48166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  48169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  48171 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  48173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  48177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  48181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  48184 */     GIR_RootConstrainSelectedInstOperands,
     /*  48185 */     // GIR_Coverage, 3409,
     /*  48185 */     GIR_EraseRootFromParent_Done,
     /*  48186 */   // Label 586: @48186
     /*  48186 */   GIM_Try, /*On fail goto*//*Label 587*/ GIMT_Encode4(48236), // Rule ID 3408 //
     /*  48191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  48194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  48198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  48206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  48210 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  48214 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48216 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 127:{ *:[i32] })
     /*  48216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  48219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  48221 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  48223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  48227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  48231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/127,
     /*  48234 */     GIR_RootConstrainSelectedInstOperands,
     /*  48235 */     // GIR_Coverage, 3408,
     /*  48235 */     GIR_EraseRootFromParent_Done,
     /*  48236 */   // Label 587: @48236
     /*  48236 */   GIM_Try, /*On fail goto*//*Label 588*/ GIMT_Encode4(48286), // Rule ID 3413 //
     /*  48241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  48244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  48248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  48256 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  48260 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  48264 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48266 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 111:{ *:[i32] })
     /*  48266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  48269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  48271 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  48273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  48277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  48281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/111,
     /*  48284 */     GIR_RootConstrainSelectedInstOperands,
     /*  48285 */     // GIR_Coverage, 3413,
     /*  48285 */     GIR_EraseRootFromParent_Done,
     /*  48286 */   // Label 588: @48286
     /*  48286 */   GIM_Try, /*On fail goto*//*Label 589*/ GIMT_Encode4(48305), // Rule ID 935 //
     /*  48291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  48294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  48298 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)  =>  (XXLOR:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*  48298 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XXLOR),
     /*  48303 */     GIR_RootConstrainSelectedInstOperands,
     /*  48304 */     // GIR_Coverage, 935,
     /*  48304 */     GIR_Done,
     /*  48305 */   // Label 589: @48305
     /*  48305 */   GIM_Try, /*On fail goto*//*Label 590*/ GIMT_Encode4(48360), // Rule ID 4930 //
     /*  48310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  48313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  48317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  48325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  48329 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  48333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  48337 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  48343 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  48345 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48347 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$VA)  =>  (VORC:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  48347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VORC),
     /*  48350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  48352 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  48354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // VB
     /*  48358 */     GIR_RootConstrainSelectedInstOperands,
     /*  48359 */     // GIR_Coverage, 4930,
     /*  48359 */     GIR_EraseRootFromParent_Done,
     /*  48360 */   // Label 590: @48360
     /*  48360 */   GIM_Try, /*On fail goto*//*Label 591*/ GIMT_Encode4(48415), // Rule ID 489 //
     /*  48365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  48368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  48372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  48380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  48384 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  48388 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  48392 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  48398 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  48400 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48402 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB, immAllOnesV:{ *:[v4i32] }))  =>  (VORC:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  48402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VORC),
     /*  48405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  48407 */     GIR_RootToRootCopy, /*OpIdx*/1, // VA
     /*  48409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // VB
     /*  48413 */     GIR_RootConstrainSelectedInstOperands,
     /*  48414 */     // GIR_Coverage, 489,
     /*  48414 */     GIR_EraseRootFromParent_Done,
     /*  48415 */   // Label 591: @48415
     /*  48415 */   GIM_Try, /*On fail goto*//*Label 592*/ GIMT_Encode4(48434), // Rule ID 386 //
     /*  48420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  48423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  48427 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VOR:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  48427 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VOR),
     /*  48432 */     GIR_RootConstrainSelectedInstOperands,
     /*  48433 */     // GIR_Coverage, 386,
     /*  48433 */     GIR_Done,
     /*  48434 */   // Label 592: @48434
     /*  48434 */   GIM_Reject,
     /*  48435 */ // Label 264: @48435
     /*  48435 */ GIM_Reject,
     /*  48436 */ // Label 251: @48436
     /*  48436 */ GIM_Reject,
     /*  48437 */ // Label 9: @48437
     /*  48437 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(6), /*)*//*default:*//*Label 597*/ GIMT_Encode4(57543),
     /*  48448 */ /*GILLT_s1*//*Label 593*/ GIMT_Encode4(48472),
     /*  48452 */ /*GILLT_s32*//*Label 594*/ GIMT_Encode4(53909),
     /*  48456 */ /*GILLT_s64*//*Label 595*/ GIMT_Encode4(54164), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  48468 */ /*GILLT_v4s32*//*Label 596*/ GIMT_Encode4(54419),
     /*  48472 */ // Label 593: @48472
     /*  48472 */ GIM_Try, /*On fail goto*//*Label 598*/ GIMT_Encode4(53908),
     /*  48477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*  48480 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*  48483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  48487 */   GIM_Try, /*On fail goto*//*Label 599*/ GIMT_Encode4(48578), // Rule ID 3035 //
     /*  48492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  48495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  48503 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  48507 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  48511 */     // MIs[1] Operand 1
     /*  48511 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  48516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  48520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48524 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  48528 */     // MIs[2] Operand 1
     /*  48528 */     // No operand predicates
     /*  48528 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  48532 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48534 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] })
     /*  48534 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48537 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  48541 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48546 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  48550 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  48553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48560 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  48567 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  48572 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  48577 */     // GIR_Coverage, 3035,
     /*  48577 */     GIR_EraseRootFromParent_Done,
     /*  48578 */   // Label 599: @48578
     /*  48578 */   GIM_Try, /*On fail goto*//*Label 600*/ GIMT_Encode4(48669), // Rule ID 3051 //
     /*  48583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  48586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  48594 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  48598 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  48602 */     // MIs[1] Operand 1
     /*  48602 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  48607 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  48611 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48615 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  48619 */     // MIs[2] Operand 1
     /*  48619 */     // No operand predicates
     /*  48619 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  48623 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48625 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] })
     /*  48625 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48628 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  48632 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48637 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  48641 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  48644 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48651 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  48658 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  48663 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  48668 */     // GIR_Coverage, 3051,
     /*  48668 */     GIR_EraseRootFromParent_Done,
     /*  48669 */   // Label 600: @48669
     /*  48669 */   GIM_Try, /*On fail goto*//*Label 601*/ GIMT_Encode4(48760), // Rule ID 3059 //
     /*  48674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  48677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  48685 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  48689 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  48693 */     // MIs[1] Operand 1
     /*  48693 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  48698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  48702 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48706 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  48710 */     // MIs[2] Operand 1
     /*  48710 */     // No operand predicates
     /*  48710 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  48714 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48716 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] })
     /*  48716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  48723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48728 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  48732 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  48735 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48742 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  48749 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  48754 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  48759 */     // GIR_Coverage, 3059,
     /*  48759 */     GIR_EraseRootFromParent_Done,
     /*  48760 */   // Label 601: @48760
     /*  48760 */   GIM_Try, /*On fail goto*//*Label 602*/ GIMT_Encode4(48851), // Rule ID 3131 //
     /*  48765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  48768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  48776 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  48780 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  48784 */     // MIs[1] Operand 1
     /*  48784 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  48789 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  48793 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48797 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  48801 */     // MIs[2] Operand 1
     /*  48801 */     // No operand predicates
     /*  48801 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  48805 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48807 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] })
     /*  48807 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48810 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  48814 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48819 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  48823 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  48826 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48833 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  48840 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  48845 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  48850 */     // GIR_Coverage, 3131,
     /*  48850 */     GIR_EraseRootFromParent_Done,
     /*  48851 */   // Label 602: @48851
     /*  48851 */   GIM_Try, /*On fail goto*//*Label 603*/ GIMT_Encode4(48942), // Rule ID 3147 //
     /*  48856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  48859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  48867 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  48871 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  48875 */     // MIs[1] Operand 1
     /*  48875 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  48880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  48884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48888 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  48892 */     // MIs[2] Operand 1
     /*  48892 */     // No operand predicates
     /*  48892 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  48896 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48898 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] })
     /*  48898 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48901 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  48905 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48910 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  48914 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  48917 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48924 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  48931 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  48936 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  48941 */     // GIR_Coverage, 3147,
     /*  48941 */     GIR_EraseRootFromParent_Done,
     /*  48942 */   // Label 603: @48942
     /*  48942 */   GIM_Try, /*On fail goto*//*Label 604*/ GIMT_Encode4(49033), // Rule ID 3155 //
     /*  48947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  48950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  48958 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  48962 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  48966 */     // MIs[1] Operand 1
     /*  48966 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  48971 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  48975 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48979 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  48983 */     // MIs[2] Operand 1
     /*  48983 */     // No operand predicates
     /*  48983 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  48987 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48989 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] })
     /*  48989 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48992 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  48996 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49001 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  49005 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  49008 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49015 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  49022 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49027 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49032 */     // GIR_Coverage, 3155,
     /*  49032 */     GIR_EraseRootFromParent_Done,
     /*  49033 */   // Label 604: @49033
     /*  49033 */   GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(49124), // Rule ID 3818 //
     /*  49038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  49041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  49049 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  49053 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  49057 */     // MIs[1] Operand 1
     /*  49057 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  49062 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  49066 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49070 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  49074 */     // MIs[2] Operand 1
     /*  49074 */     // No operand predicates
     /*  49074 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  49078 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49080 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] })
     /*  49080 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49083 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  49087 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49092 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  49096 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  49099 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49106 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  49113 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49118 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49123 */     // GIR_Coverage, 3818,
     /*  49123 */     GIR_EraseRootFromParent_Done,
     /*  49124 */   // Label 605: @49124
     /*  49124 */   GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(49215), // Rule ID 3834 //
     /*  49129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  49132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  49140 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  49144 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  49148 */     // MIs[1] Operand 1
     /*  49148 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  49153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  49157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49161 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  49165 */     // MIs[2] Operand 1
     /*  49165 */     // No operand predicates
     /*  49165 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  49169 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49171 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] })
     /*  49171 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49174 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  49178 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49183 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  49187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  49190 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49197 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  49204 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49209 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49214 */     // GIR_Coverage, 3834,
     /*  49214 */     GIR_EraseRootFromParent_Done,
     /*  49215 */   // Label 606: @49215
     /*  49215 */   GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(49306), // Rule ID 3842 //
     /*  49220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  49223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  49231 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  49235 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  49239 */     // MIs[1] Operand 1
     /*  49239 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  49244 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  49248 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49252 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  49256 */     // MIs[2] Operand 1
     /*  49256 */     // No operand predicates
     /*  49256 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  49260 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49262 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] })
     /*  49262 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49265 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  49269 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49274 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  49278 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  49281 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49288 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  49295 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49300 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49305 */     // GIR_Coverage, 3842,
     /*  49305 */     GIR_EraseRootFromParent_Done,
     /*  49306 */   // Label 607: @49306
     /*  49306 */   GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(49397), // Rule ID 3914 //
     /*  49311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  49314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  49322 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49326 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  49330 */     // MIs[1] Operand 1
     /*  49330 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  49335 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  49339 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49343 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  49347 */     // MIs[2] Operand 1
     /*  49347 */     // No operand predicates
     /*  49347 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  49351 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49353 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] })
     /*  49353 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49356 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  49360 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49365 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  49369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  49372 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49379 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  49386 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49391 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49396 */     // GIR_Coverage, 3914,
     /*  49396 */     GIR_EraseRootFromParent_Done,
     /*  49397 */   // Label 608: @49397
     /*  49397 */   GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(49488), // Rule ID 3930 //
     /*  49402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  49405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  49413 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49417 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  49421 */     // MIs[1] Operand 1
     /*  49421 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  49426 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  49430 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49434 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  49438 */     // MIs[2] Operand 1
     /*  49438 */     // No operand predicates
     /*  49438 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  49442 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49444 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] })
     /*  49444 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49447 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  49451 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49456 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  49460 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  49463 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49470 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  49477 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49482 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49487 */     // GIR_Coverage, 3930,
     /*  49487 */     GIR_EraseRootFromParent_Done,
     /*  49488 */   // Label 609: @49488
     /*  49488 */   GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(49579), // Rule ID 3938 //
     /*  49493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  49496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  49504 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49508 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  49512 */     // MIs[1] Operand 1
     /*  49512 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  49517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  49521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49525 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  49529 */     // MIs[2] Operand 1
     /*  49529 */     // No operand predicates
     /*  49529 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  49533 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49535 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] })
     /*  49535 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49538 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  49542 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49547 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  49551 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  49554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49561 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  49568 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49573 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49578 */     // GIR_Coverage, 3938,
     /*  49578 */     GIR_EraseRootFromParent_Done,
     /*  49579 */   // Label 610: @49579
     /*  49579 */   GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(49659), // Rule ID 3179 //
     /*  49584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  49587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  49595 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  49599 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  49603 */     // MIs[1] Operand 1
     /*  49603 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  49608 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  49612 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49614 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] })
     /*  49614 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49617 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  49621 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49626 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  49630 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  49634 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49641 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  49648 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49653 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49658 */     // GIR_Coverage, 3179,
     /*  49658 */     GIR_EraseRootFromParent_Done,
     /*  49659 */   // Label 611: @49659
     /*  49659 */   GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(49739), // Rule ID 3195 //
     /*  49664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  49667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  49675 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  49679 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  49683 */     // MIs[1] Operand 1
     /*  49683 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  49688 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  49692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49694 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] })
     /*  49694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  49701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49706 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  49710 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  49714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49721 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  49728 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49733 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49738 */     // GIR_Coverage, 3195,
     /*  49738 */     GIR_EraseRootFromParent_Done,
     /*  49739 */   // Label 612: @49739
     /*  49739 */   GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(49819), // Rule ID 3211 //
     /*  49744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  49747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  49755 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  49759 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  49763 */     // MIs[1] Operand 1
     /*  49763 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  49768 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  49772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49774 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] })
     /*  49774 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49777 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  49781 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49786 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  49790 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  49794 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49801 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  49808 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49813 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49818 */     // GIR_Coverage, 3211,
     /*  49818 */     GIR_EraseRootFromParent_Done,
     /*  49819 */   // Label 613: @49819
     /*  49819 */   GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(49899), // Rule ID 3227 //
     /*  49824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  49827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  49835 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  49839 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  49843 */     // MIs[1] Operand 1
     /*  49843 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /*  49848 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  49852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49854 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] })
     /*  49854 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49857 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  49861 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49866 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  49870 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  49874 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49881 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /*  49888 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49893 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49898 */     // GIR_Coverage, 3227,
     /*  49898 */     GIR_EraseRootFromParent_Done,
     /*  49899 */   // Label 614: @49899
     /*  49899 */   GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(49979), // Rule ID 3235 //
     /*  49904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  49907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  49915 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49919 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  49923 */     // MIs[1] Operand 1
     /*  49923 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  49928 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  49932 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49934 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] })
     /*  49934 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49937 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  49941 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49946 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  49950 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  49954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49961 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  49968 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49973 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49978 */     // GIR_Coverage, 3235,
     /*  49978 */     GIR_EraseRootFromParent_Done,
     /*  49979 */   // Label 615: @49979
     /*  49979 */   GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(50059), // Rule ID 3251 //
     /*  49984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  49987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  49995 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49999 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  50003 */     // MIs[1] Operand 1
     /*  50003 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  50008 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50014 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] })
     /*  50014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50017 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  50021 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50026 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50030 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50034 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50041 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  50048 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50053 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50058 */     // GIR_Coverage, 3251,
     /*  50058 */     GIR_EraseRootFromParent_Done,
     /*  50059 */   // Label 616: @50059
     /*  50059 */   GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(50139), // Rule ID 3267 //
     /*  50064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  50067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50075 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  50079 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  50083 */     // MIs[1] Operand 1
     /*  50083 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  50088 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50092 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50094 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] })
     /*  50094 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50097 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  50101 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50106 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50110 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50121 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  50128 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50133 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50138 */     // GIR_Coverage, 3267,
     /*  50138 */     GIR_EraseRootFromParent_Done,
     /*  50139 */   // Label 617: @50139
     /*  50139 */   GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(50219), // Rule ID 3283 //
     /*  50144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  50147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50155 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  50159 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  50163 */     // MIs[1] Operand 1
     /*  50163 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /*  50168 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50172 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50174 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] })
     /*  50174 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50177 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  50181 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50186 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50190 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50201 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /*  50208 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50213 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50218 */     // GIR_Coverage, 3283,
     /*  50218 */     GIR_EraseRootFromParent_Done,
     /*  50219 */   // Label 618: @50219
     /*  50219 */   GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(50299), // Rule ID 3291 //
     /*  50224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  50227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50235 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  50239 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  50243 */     // MIs[1] Operand 1
     /*  50243 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  50248 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50252 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50254 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] })
     /*  50254 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50257 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  50261 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50266 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50270 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50274 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50281 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  50288 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50293 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50298 */     // GIR_Coverage, 3291,
     /*  50298 */     GIR_EraseRootFromParent_Done,
     /*  50299 */   // Label 619: @50299
     /*  50299 */   GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(50379), // Rule ID 3307 //
     /*  50304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  50307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50315 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  50319 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  50323 */     // MIs[1] Operand 1
     /*  50323 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  50328 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50332 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50334 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] })
     /*  50334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  50341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50346 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50350 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50354 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50361 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  50368 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50373 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50378 */     // GIR_Coverage, 3307,
     /*  50378 */     GIR_EraseRootFromParent_Done,
     /*  50379 */   // Label 620: @50379
     /*  50379 */   GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(50459), // Rule ID 3323 //
     /*  50384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  50387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50395 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  50399 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  50403 */     // MIs[1] Operand 1
     /*  50403 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  50408 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50414 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] })
     /*  50414 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  50421 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50426 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50430 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50434 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50441 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  50448 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50453 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50458 */     // GIR_Coverage, 3323,
     /*  50458 */     GIR_EraseRootFromParent_Done,
     /*  50459 */   // Label 621: @50459
     /*  50459 */   GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(50539), // Rule ID 3339 //
     /*  50464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  50467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50475 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  50479 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  50483 */     // MIs[1] Operand 1
     /*  50483 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /*  50488 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50494 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] })
     /*  50494 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50497 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  50501 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50506 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50510 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50514 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50521 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /*  50528 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50533 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50538 */     // GIR_Coverage, 3339,
     /*  50538 */     GIR_EraseRootFromParent_Done,
     /*  50539 */   // Label 622: @50539
     /*  50539 */   GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(50619), // Rule ID 4018 //
     /*  50544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  50547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50555 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50559 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  50563 */     // MIs[1] Operand 1
     /*  50563 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  50568 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50572 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50574 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] })
     /*  50574 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50577 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  50581 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50586 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50590 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50601 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  50608 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50613 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50618 */     // GIR_Coverage, 4018,
     /*  50618 */     GIR_EraseRootFromParent_Done,
     /*  50619 */   // Label 623: @50619
     /*  50619 */   GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(50699), // Rule ID 4050 //
     /*  50624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  50627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50635 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50639 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  50643 */     // MIs[1] Operand 1
     /*  50643 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  50648 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50652 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50654 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] })
     /*  50654 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50657 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  50661 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50666 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50670 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50674 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50681 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  50688 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50693 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50698 */     // GIR_Coverage, 4050,
     /*  50698 */     GIR_EraseRootFromParent_Done,
     /*  50699 */   // Label 624: @50699
     /*  50699 */   GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(50779), // Rule ID 4082 //
     /*  50704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  50707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50715 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50719 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  50723 */     // MIs[1] Operand 1
     /*  50723 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  50728 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50732 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50734 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] })
     /*  50734 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50737 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  50741 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50746 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50750 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50754 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50761 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  50768 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50773 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50778 */     // GIR_Coverage, 4082,
     /*  50778 */     GIR_EraseRootFromParent_Done,
     /*  50779 */   // Label 625: @50779
     /*  50779 */   GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(50859), // Rule ID 4114 //
     /*  50784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  50787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50799 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  50803 */     // MIs[1] Operand 1
     /*  50803 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /*  50808 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50812 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50814 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] })
     /*  50814 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50817 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  50821 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50826 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50830 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50834 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50841 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /*  50848 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50853 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50858 */     // GIR_Coverage, 4114,
     /*  50858 */     GIR_EraseRootFromParent_Done,
     /*  50859 */   // Label 626: @50859
     /*  50859 */   GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(50939), // Rule ID 4130 //
     /*  50864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  50867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  50879 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  50883 */     // MIs[1] Operand 1
     /*  50883 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  50888 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50892 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50894 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] })
     /*  50894 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50897 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  50901 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50906 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50910 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50914 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50921 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  50928 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50933 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50938 */     // GIR_Coverage, 4130,
     /*  50938 */     GIR_EraseRootFromParent_Done,
     /*  50939 */   // Label 627: @50939
     /*  50939 */   GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(51019), // Rule ID 4162 //
     /*  50944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  50947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50955 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  50959 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  50963 */     // MIs[1] Operand 1
     /*  50963 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  50968 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50972 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50974 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] })
     /*  50974 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50977 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  50981 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50986 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50990 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50994 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51001 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  51008 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51013 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51018 */     // GIR_Coverage, 4162,
     /*  51018 */     GIR_EraseRootFromParent_Done,
     /*  51019 */   // Label 628: @51019
     /*  51019 */   GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(51099), // Rule ID 4194 //
     /*  51024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  51027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51035 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51039 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  51043 */     // MIs[1] Operand 1
     /*  51043 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  51048 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51052 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51054 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] })
     /*  51054 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51057 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  51061 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51066 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51070 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51074 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51081 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  51088 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51093 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51098 */     // GIR_Coverage, 4194,
     /*  51098 */     GIR_EraseRootFromParent_Done,
     /*  51099 */   // Label 629: @51099
     /*  51099 */   GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(51179), // Rule ID 4226 //
     /*  51104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  51107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51115 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51119 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  51123 */     // MIs[1] Operand 1
     /*  51123 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /*  51128 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51134 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] })
     /*  51134 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51137 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  51141 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51146 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51150 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51154 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51161 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /*  51168 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51173 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51178 */     // GIR_Coverage, 4226,
     /*  51178 */     GIR_EraseRootFromParent_Done,
     /*  51179 */   // Label 630: @51179
     /*  51179 */   GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(51259), // Rule ID 4256 //
     /*  51184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  51187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51195 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  51199 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  51203 */     // MIs[1] Operand 1
     /*  51203 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  51208 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51214 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] })
     /*  51214 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51217 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  51221 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51226 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51230 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51234 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51241 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  51248 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51253 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51258 */     // GIR_Coverage, 4256,
     /*  51258 */     GIR_EraseRootFromParent_Done,
     /*  51259 */   // Label 631: @51259
     /*  51259 */   GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(51339), // Rule ID 4288 //
     /*  51264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  51267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51275 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  51279 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  51283 */     // MIs[1] Operand 1
     /*  51283 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  51288 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51294 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] })
     /*  51294 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51297 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  51301 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51306 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51310 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51314 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51321 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  51328 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51333 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51338 */     // GIR_Coverage, 4288,
     /*  51338 */     GIR_EraseRootFromParent_Done,
     /*  51339 */   // Label 632: @51339
     /*  51339 */   GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(51419), // Rule ID 4320 //
     /*  51344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  51347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51355 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  51359 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  51363 */     // MIs[1] Operand 1
     /*  51363 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  51368 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51372 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51374 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] })
     /*  51374 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51377 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  51381 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51386 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51390 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51394 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51401 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  51408 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51413 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51418 */     // GIR_Coverage, 4320,
     /*  51418 */     GIR_EraseRootFromParent_Done,
     /*  51419 */   // Label 633: @51419
     /*  51419 */   GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(51499), // Rule ID 4352 //
     /*  51424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  51427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51435 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  51439 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  51443 */     // MIs[1] Operand 1
     /*  51443 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /*  51448 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51454 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] })
     /*  51454 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51457 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  51461 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51466 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51470 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51474 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51481 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /*  51488 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51493 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51498 */     // GIR_Coverage, 4352,
     /*  51498 */     GIR_EraseRootFromParent_Done,
     /*  51499 */   // Label 634: @51499
     /*  51499 */   GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(51579), // Rule ID 4583 //
     /*  51504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /*  51507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51515 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  51519 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  51523 */     // MIs[1] Operand 1
     /*  51523 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  51528 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51534 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPLT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] })
     /*  51534 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51537 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFSCMPLT),
     /*  51541 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51546 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51550 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51561 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  51568 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51573 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51578 */     // GIR_Coverage, 4583,
     /*  51578 */     GIR_EraseRootFromParent_Done,
     /*  51579 */   // Label 635: @51579
     /*  51579 */   GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(51659), // Rule ID 4615 //
     /*  51584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /*  51587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51595 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  51599 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  51603 */     // MIs[1] Operand 1
     /*  51603 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  51608 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51612 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51614 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPGT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] })
     /*  51614 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51617 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFSCMPGT),
     /*  51621 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51626 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51630 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51634 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51641 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  51648 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51653 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51658 */     // GIR_Coverage, 4615,
     /*  51658 */     GIR_EraseRootFromParent_Done,
     /*  51659 */   // Label 636: @51659
     /*  51659 */   GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(51739), // Rule ID 4647 //
     /*  51664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /*  51667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51675 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  51679 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  51683 */     // MIs[1] Operand 1
     /*  51683 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  51688 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51694 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPEQ:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] })
     /*  51694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFSCMPEQ),
     /*  51701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51706 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51710 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51721 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  51728 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51733 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51738 */     // GIR_Coverage, 4647,
     /*  51738 */     GIR_EraseRootFromParent_Done,
     /*  51739 */   // Label 637: @51739
     /*  51739 */   GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(51819), // Rule ID 4691 //
     /*  51744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /*  51747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51755 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51759 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  51763 */     // MIs[1] Operand 1
     /*  51763 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  51768 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51774 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPLT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] })
     /*  51774 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51777 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFDCMPLT),
     /*  51781 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51786 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51790 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51794 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51801 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  51808 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51813 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51818 */     // GIR_Coverage, 4691,
     /*  51818 */     GIR_EraseRootFromParent_Done,
     /*  51819 */   // Label 638: @51819
     /*  51819 */   GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(51899), // Rule ID 4723 //
     /*  51824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /*  51827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51835 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51839 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  51843 */     // MIs[1] Operand 1
     /*  51843 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  51848 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51854 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPGT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] })
     /*  51854 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51857 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFDCMPGT),
     /*  51861 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51866 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51870 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51874 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51881 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  51888 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51893 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51898 */     // GIR_Coverage, 4723,
     /*  51898 */     GIR_EraseRootFromParent_Done,
     /*  51899 */   // Label 639: @51899
     /*  51899 */   GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(51979), // Rule ID 4755 //
     /*  51904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /*  51907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51915 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51919 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  51923 */     // MIs[1] Operand 1
     /*  51923 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  51928 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51932 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51934 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPEQ:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] })
     /*  51934 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51937 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFDCMPEQ),
     /*  51941 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51946 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51950 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51961 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  51968 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51973 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51978 */     // GIR_Coverage, 4755,
     /*  51978 */     GIR_EraseRootFromParent_Done,
     /*  51979 */   // Label 640: @51979
     /*  51979 */   GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(52059), // Rule ID 2981 //
     /*  51984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  51987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  51995 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  51999 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  52003 */     // MIs[1] Operand 1
     /*  52003 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /*  52008 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52014 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] })
     /*  52014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52017 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /*  52021 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52026 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52030 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52034 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52041 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  52048 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52053 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52058 */     // GIR_Coverage, 2981,
     /*  52058 */     GIR_EraseRootFromParent_Done,
     /*  52059 */   // Label 641: @52059
     /*  52059 */   GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(52139), // Rule ID 2995 //
     /*  52064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  52067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52075 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  52079 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  52083 */     // MIs[1] Operand 1
     /*  52083 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  52088 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52092 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52094 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] })
     /*  52094 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52097 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /*  52101 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52106 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52110 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52121 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  52128 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52133 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52138 */     // GIR_Coverage, 2995,
     /*  52138 */     GIR_EraseRootFromParent_Done,
     /*  52139 */   // Label 642: @52139
     /*  52139 */   GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(52219), // Rule ID 3003 //
     /*  52144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  52147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52155 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  52159 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  52163 */     // MIs[1] Operand 1
     /*  52163 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /*  52168 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52172 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52174 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] })
     /*  52174 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52177 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /*  52181 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52186 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52190 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52201 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  52208 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52213 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52218 */     // GIR_Coverage, 3003,
     /*  52218 */     GIR_EraseRootFromParent_Done,
     /*  52219 */   // Label 643: @52219
     /*  52219 */   GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(52299), // Rule ID 3011 //
     /*  52224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  52227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52235 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  52239 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  52243 */     // MIs[1] Operand 1
     /*  52243 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  52248 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52252 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52254 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] })
     /*  52254 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52257 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /*  52261 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52266 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52270 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52274 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52281 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  52288 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52293 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52298 */     // GIR_Coverage, 3011,
     /*  52298 */     GIR_EraseRootFromParent_Done,
     /*  52299 */   // Label 644: @52299
     /*  52299 */   GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(52379), // Rule ID 3019 //
     /*  52304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  52307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52315 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  52319 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  52323 */     // MIs[1] Operand 1
     /*  52323 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  52328 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52332 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52334 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] })
     /*  52334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /*  52341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52346 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52350 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52354 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52361 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  52368 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52373 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52378 */     // GIR_Coverage, 3019,
     /*  52378 */     GIR_EraseRootFromParent_Done,
     /*  52379 */   // Label 645: @52379
     /*  52379 */   GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(52459), // Rule ID 3083 //
     /*  52384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  52387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52395 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52399 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  52403 */     // MIs[1] Operand 1
     /*  52403 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /*  52408 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52414 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] })
     /*  52414 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /*  52421 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52426 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52430 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52434 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52441 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  52448 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52453 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52458 */     // GIR_Coverage, 3083,
     /*  52458 */     GIR_EraseRootFromParent_Done,
     /*  52459 */   // Label 646: @52459
     /*  52459 */   GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(52539), // Rule ID 3091 //
     /*  52464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  52467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52475 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52479 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  52483 */     // MIs[1] Operand 1
     /*  52483 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  52488 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52494 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] })
     /*  52494 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52497 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /*  52501 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52506 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52510 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52514 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52521 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  52528 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52533 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52538 */     // GIR_Coverage, 3091,
     /*  52538 */     GIR_EraseRootFromParent_Done,
     /*  52539 */   // Label 647: @52539
     /*  52539 */   GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(52619), // Rule ID 3099 //
     /*  52544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  52547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52555 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52559 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  52563 */     // MIs[1] Operand 1
     /*  52563 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /*  52568 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52572 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52574 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] })
     /*  52574 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52577 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /*  52581 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52586 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52590 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52601 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  52608 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52613 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52618 */     // GIR_Coverage, 3099,
     /*  52618 */     GIR_EraseRootFromParent_Done,
     /*  52619 */   // Label 648: @52619
     /*  52619 */   GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(52699), // Rule ID 3107 //
     /*  52624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  52627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52635 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52639 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  52643 */     // MIs[1] Operand 1
     /*  52643 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  52648 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52652 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52654 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] })
     /*  52654 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52657 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /*  52661 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52666 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52670 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52674 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52681 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  52688 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52693 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52698 */     // GIR_Coverage, 3107,
     /*  52698 */     GIR_EraseRootFromParent_Done,
     /*  52699 */   // Label 649: @52699
     /*  52699 */   GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(52779), // Rule ID 3115 //
     /*  52704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  52707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52715 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52719 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  52723 */     // MIs[1] Operand 1
     /*  52723 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  52728 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52732 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52734 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] })
     /*  52734 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52737 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /*  52741 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52746 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52750 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52754 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52761 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  52768 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52773 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52778 */     // GIR_Coverage, 3115,
     /*  52778 */     GIR_EraseRootFromParent_Done,
     /*  52779 */   // Label 650: @52779
     /*  52779 */   GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(52859), // Rule ID 3866 //
     /*  52784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  52787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  52799 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  52803 */     // MIs[1] Operand 1
     /*  52803 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /*  52808 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52812 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52814 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] })
     /*  52814 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52817 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /*  52821 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52826 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52830 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52834 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52841 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  52848 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52853 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52858 */     // GIR_Coverage, 3866,
     /*  52858 */     GIR_EraseRootFromParent_Done,
     /*  52859 */   // Label 651: @52859
     /*  52859 */   GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(52939), // Rule ID 3874 //
     /*  52864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  52867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  52879 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  52883 */     // MIs[1] Operand 1
     /*  52883 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  52888 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52892 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52894 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] })
     /*  52894 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52897 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /*  52901 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52906 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52910 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52914 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52921 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  52928 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52933 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52938 */     // GIR_Coverage, 3874,
     /*  52938 */     GIR_EraseRootFromParent_Done,
     /*  52939 */   // Label 652: @52939
     /*  52939 */   GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(53019), // Rule ID 3882 //
     /*  52944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  52947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52955 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  52959 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  52963 */     // MIs[1] Operand 1
     /*  52963 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /*  52968 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52972 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52974 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] })
     /*  52974 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52977 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /*  52981 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52986 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52990 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52994 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53001 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  53008 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  53013 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  53018 */     // GIR_Coverage, 3882,
     /*  53018 */     GIR_EraseRootFromParent_Done,
     /*  53019 */   // Label 653: @53019
     /*  53019 */   GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(53099), // Rule ID 3890 //
     /*  53024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  53027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  53035 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  53039 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  53043 */     // MIs[1] Operand 1
     /*  53043 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  53048 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53052 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53054 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] })
     /*  53054 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53057 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /*  53061 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53066 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  53070 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  53074 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53081 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  53088 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  53093 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  53098 */     // GIR_Coverage, 3890,
     /*  53098 */     GIR_EraseRootFromParent_Done,
     /*  53099 */   // Label 654: @53099
     /*  53099 */   GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(53179), // Rule ID 3898 //
     /*  53104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  53107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  53115 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  53119 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  53123 */     // MIs[1] Operand 1
     /*  53123 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  53128 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53134 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] })
     /*  53134 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53137 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /*  53141 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53146 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  53150 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  53154 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53161 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  53168 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  53173 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  53178 */     // GIR_Coverage, 3898,
     /*  53178 */     GIR_EraseRootFromParent_Done,
     /*  53179 */   // Label 655: @53179
     /*  53179 */   GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(53259), // Rule ID 3962 //
     /*  53184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  53187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  53195 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53199 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  53203 */     // MIs[1] Operand 1
     /*  53203 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /*  53208 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53214 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] })
     /*  53214 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53217 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /*  53221 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53226 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  53230 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  53234 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53241 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  53248 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  53253 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  53258 */     // GIR_Coverage, 3962,
     /*  53258 */     GIR_EraseRootFromParent_Done,
     /*  53259 */   // Label 656: @53259
     /*  53259 */   GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(53339), // Rule ID 3970 //
     /*  53264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  53267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  53275 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53279 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  53283 */     // MIs[1] Operand 1
     /*  53283 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  53288 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53294 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] })
     /*  53294 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53297 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /*  53301 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53306 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  53310 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  53314 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53321 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  53328 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  53333 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  53338 */     // GIR_Coverage, 3970,
     /*  53338 */     GIR_EraseRootFromParent_Done,
     /*  53339 */   // Label 657: @53339
     /*  53339 */   GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(53419), // Rule ID 3978 //
     /*  53344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  53347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  53355 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53359 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  53363 */     // MIs[1] Operand 1
     /*  53363 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /*  53368 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53372 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53374 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] })
     /*  53374 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53377 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /*  53381 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53386 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  53390 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  53394 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53401 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  53408 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  53413 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  53418 */     // GIR_Coverage, 3978,
     /*  53418 */     GIR_EraseRootFromParent_Done,
     /*  53419 */   // Label 658: @53419
     /*  53419 */   GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(53499), // Rule ID 3986 //
     /*  53424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  53427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  53435 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53439 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  53443 */     // MIs[1] Operand 1
     /*  53443 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  53448 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53454 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] })
     /*  53454 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53457 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /*  53461 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53466 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  53470 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  53474 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53481 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  53488 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  53493 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  53498 */     // GIR_Coverage, 3986,
     /*  53498 */     GIR_EraseRootFromParent_Done,
     /*  53499 */   // Label 659: @53499
     /*  53499 */   GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(53579), // Rule ID 3994 //
     /*  53504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  53507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  53515 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53519 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  53523 */     // MIs[1] Operand 1
     /*  53523 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  53528 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53534 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] })
     /*  53534 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53537 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /*  53541 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53546 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  53550 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  53554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53561 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  53568 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  53573 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  53578 */     // GIR_Coverage, 3994,
     /*  53578 */     GIR_EraseRootFromParent_Done,
     /*  53579 */   // Label 660: @53579
     /*  53579 */   GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(53621), // Rule ID 176 //
     /*  53584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  53592 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  53596 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  53600 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53606 */     // (xor:{ *:[i1] } (and:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB), -1:{ *:[i1] })  =>  (CRNAND:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*  53606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNAND),
     /*  53609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /*  53611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // CRA
     /*  53615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // CRB
     /*  53619 */     GIR_RootConstrainSelectedInstOperands,
     /*  53620 */     // GIR_Coverage, 176,
     /*  53620 */     GIR_EraseRootFromParent_Done,
     /*  53621 */   // Label 661: @53621
     /*  53621 */   GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(53663), // Rule ID 179 //
     /*  53626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  53634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  53638 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  53642 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53648 */     // (xor:{ *:[i1] } (or:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB), -1:{ *:[i1] })  =>  (CRNOR:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*  53648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOR),
     /*  53651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /*  53653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // CRA
     /*  53657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // CRB
     /*  53661 */     GIR_RootConstrainSelectedInstOperands,
     /*  53662 */     // GIR_Coverage, 179,
     /*  53662 */     GIR_EraseRootFromParent_Done,
     /*  53663 */   // Label 662: @53663
     /*  53663 */   GIM_Try, /*On fail goto*//*Label 663*/ GIMT_Encode4(53703), // Rule ID 4922 //
     /*  53668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  53680 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  53684 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53688 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53690 */     // (xor:{ *:[i1] } (xor:{ *:[i1] } i1:{ *:[i1] }:$CRA, -1:{ *:[i1] }), i1:{ *:[i1] }:$CRB)  =>  (CREQV:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*  53690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CREQV),
     /*  53693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /*  53695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // CRA
     /*  53699 */     GIR_RootToRootCopy, /*OpIdx*/2, // CRB
     /*  53701 */     GIR_RootConstrainSelectedInstOperands,
     /*  53702 */     // GIR_Coverage, 4922,
     /*  53702 */     GIR_EraseRootFromParent_Done,
     /*  53703 */   // Label 663: @53703
     /*  53703 */   GIM_Try, /*On fail goto*//*Label 664*/ GIMT_Encode4(53745), // Rule ID 180 //
     /*  53708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  53720 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  53724 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53730 */     // (xor:{ *:[i1] } (xor:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB), -1:{ *:[i1] })  =>  (CREQV:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*  53730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CREQV),
     /*  53733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /*  53735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // CRA
     /*  53739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // CRB
     /*  53743 */     GIR_RootConstrainSelectedInstOperands,
     /*  53744 */     // GIR_Coverage, 180,
     /*  53744 */     GIR_EraseRootFromParent_Done,
     /*  53745 */   // Label 664: @53745
     /*  53745 */   GIM_Try, /*On fail goto*//*Label 665*/ GIMT_Encode4(53782), // Rule ID 4855 //
     /*  53750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  53758 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53762 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53768 */     // (xor:{ *:[i1] } (trunc:{ *:[i1] } i32:{ *:[i32] }:$in), -1:{ *:[i1] })  =>  (ANDI_rec_1_EQ_BIT:{ *:[i1] }:{ *:[i32] } ?:{ *:[i32] }:$in)
     /*  53768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ANDI_rec_1_EQ_BIT),
     /*  53771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53773 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // in
     /*  53777 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR0*/0,
     /*  53780 */     GIR_RootConstrainSelectedInstOperands,
     /*  53781 */     // GIR_Coverage, 4855,
     /*  53781 */     GIR_EraseRootFromParent_Done,
     /*  53782 */   // Label 665: @53782
     /*  53782 */   GIM_Try, /*On fail goto*//*Label 666*/ GIMT_Encode4(53819), // Rule ID 4856 //
     /*  53787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  53795 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  53799 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53805 */     // (xor:{ *:[i1] } (trunc:{ *:[i1] } i64:{ *:[i64] }:$in), -1:{ *:[i1] })  =>  (ANDI_rec_1_EQ_BIT8:{ *:[i1] }:{ *:[i32] } ?:{ *:[i64] }:$in)
     /*  53805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ANDI_rec_1_EQ_BIT8),
     /*  53808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // in
     /*  53814 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR0*/0,
     /*  53817 */     GIR_RootConstrainSelectedInstOperands,
     /*  53818 */     // GIR_Coverage, 4856,
     /*  53818 */     GIR_EraseRootFromParent_Done,
     /*  53819 */   // Label 666: @53819
     /*  53819 */   GIM_Try, /*On fail goto*//*Label 667*/ GIMT_Encode4(53859), // Rule ID 4923 //
     /*  53824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  53836 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  53840 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53846 */     // (xor:{ *:[i1] } i1:{ *:[i1] }:$CRB, (xor:{ *:[i1] } i1:{ *:[i1] }:$CRA, -1:{ *:[i1] }))  =>  (CREQV:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*  53846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CREQV),
     /*  53849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /*  53851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // CRA
     /*  53855 */     GIR_RootToRootCopy, /*OpIdx*/1, // CRB
     /*  53857 */     GIR_RootConstrainSelectedInstOperands,
     /*  53858 */     // GIR_Coverage, 4923,
     /*  53858 */     GIR_EraseRootFromParent_Done,
     /*  53859 */   // Label 667: @53859
     /*  53859 */   GIM_Try, /*On fail goto*//*Label 668*/ GIMT_Encode4(53877), // Rule ID 181 //
     /*  53864 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53868 */     // (xor:{ *:[i1] } i1:{ *:[i1] }:$CRA, -1:{ *:[i1] })  =>  (CRNOT:{ *:[i1] } i1:{ *:[i1] }:$CRA)
     /*  53868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /*  53871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /*  53873 */     GIR_RootToRootCopy, /*OpIdx*/1, // CRA
     /*  53875 */     GIR_RootConstrainSelectedInstOperands,
     /*  53876 */     // GIR_Coverage, 181,
     /*  53876 */     GIR_EraseRootFromParent_Done,
     /*  53877 */   // Label 668: @53877
     /*  53877 */   GIM_Try, /*On fail goto*//*Label 669*/ GIMT_Encode4(53895), // Rule ID 2909 //
     /*  53882 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53886 */     // (xor:{ *:[i1] } i1:{ *:[i1] }:$in, -1:{ *:[i1] })  =>  (CRNOT:{ *:[i1] } ?:{ *:[i1] }:$in)
     /*  53886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /*  53889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /*  53891 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /*  53893 */     GIR_RootConstrainSelectedInstOperands,
     /*  53894 */     // GIR_Coverage, 2909,
     /*  53894 */     GIR_EraseRootFromParent_Done,
     /*  53895 */   // Label 669: @53895
     /*  53895 */   GIM_Try, /*On fail goto*//*Label 670*/ GIMT_Encode4(53907), // Rule ID 178 //
     /*  53900 */     // (xor:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)  =>  (CRXOR:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*  53900 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::CRXOR),
     /*  53905 */     GIR_RootConstrainSelectedInstOperands,
     /*  53906 */     // GIR_Coverage, 178,
     /*  53906 */     GIR_Done,
     /*  53907 */   // Label 670: @53907
     /*  53907 */   GIM_Reject,
     /*  53908 */ // Label 598: @53908
     /*  53908 */ GIM_Reject,
     /*  53909 */ // Label 594: @53909
     /*  53909 */ GIM_Try, /*On fail goto*//*Label 671*/ GIMT_Encode4(54163),
     /*  53914 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  53917 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  53920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  53924 */   GIM_Try, /*On fail goto*//*Label 672*/ GIMT_Encode4(53966), // Rule ID 121 //
     /*  53929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  53937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53941 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  53945 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53951 */     // (xor:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB), -1:{ *:[i32] })  =>  (NAND:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*  53951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::NAND),
     /*  53954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  53956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RST
     /*  53960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RB
     /*  53964 */     GIR_RootConstrainSelectedInstOperands,
     /*  53965 */     // GIR_Coverage, 121,
     /*  53965 */     GIR_EraseRootFromParent_Done,
     /*  53966 */   // Label 672: @53966
     /*  53966 */   GIM_Try, /*On fail goto*//*Label 673*/ GIMT_Encode4(54008), // Rule ID 125 //
     /*  53971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  53979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53983 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  53987 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53993 */     // (xor:{ *:[i32] } (or:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB), -1:{ *:[i32] })  =>  (NOR:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*  53993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /*  53996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  53998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RST
     /*  54002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RB
     /*  54006 */     GIR_RootConstrainSelectedInstOperands,
     /*  54007 */     // GIR_Coverage, 125,
     /*  54007 */     GIR_EraseRootFromParent_Done,
     /*  54008 */   // Label 673: @54008
     /*  54008 */   GIM_Try, /*On fail goto*//*Label 674*/ GIMT_Encode4(54048), // Rule ID 4920 //
     /*  54013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  54025 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  54029 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  54033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54035 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$RST, -1:{ *:[i32] }), i32:{ *:[i32] }:$RB)  =>  (EQV:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*  54035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EQV),
     /*  54038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  54040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RST
     /*  54044 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  54046 */     GIR_RootConstrainSelectedInstOperands,
     /*  54047 */     // GIR_Coverage, 4920,
     /*  54047 */     GIR_EraseRootFromParent_Done,
     /*  54048 */   // Label 674: @54048
     /*  54048 */   GIM_Try, /*On fail goto*//*Label 675*/ GIMT_Encode4(54090), // Rule ID 127 //
     /*  54053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  54065 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  54069 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  54073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54075 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB), -1:{ *:[i32] })  =>  (EQV:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*  54075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EQV),
     /*  54078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  54080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RST
     /*  54084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RB
     /*  54088 */     GIR_RootConstrainSelectedInstOperands,
     /*  54089 */     // GIR_Coverage, 127,
     /*  54089 */     GIR_EraseRootFromParent_Done,
     /*  54090 */   // Label 675: @54090
     /*  54090 */   GIM_Try, /*On fail goto*//*Label 676*/ GIMT_Encode4(54130), // Rule ID 4921 //
     /*  54095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  54107 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  54111 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  54115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54117 */     // (xor:{ *:[i32] } i32:{ *:[i32] }:$RB, (xor:{ *:[i32] } i32:{ *:[i32] }:$RST, -1:{ *:[i32] }))  =>  (EQV:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*  54117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EQV),
     /*  54120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  54122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RST
     /*  54126 */     GIR_RootToRootCopy, /*OpIdx*/1, // RB
     /*  54128 */     GIR_RootConstrainSelectedInstOperands,
     /*  54129 */     // GIR_Coverage, 4921,
     /*  54129 */     GIR_EraseRootFromParent_Done,
     /*  54130 */   // Label 676: @54130
     /*  54130 */   GIM_Try, /*On fail goto*//*Label 677*/ GIMT_Encode4(54150), // Rule ID 1213 //
     /*  54135 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  54139 */     // (xor:{ *:[i32] } i32:{ *:[i32] }:$in, -1:{ *:[i32] })  =>  (NOR:{ *:[i32] } ?:{ *:[i32] }:$in, ?:{ *:[i32] }:$in)
     /*  54139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /*  54142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  54144 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /*  54146 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /*  54148 */     GIR_RootConstrainSelectedInstOperands,
     /*  54149 */     // GIR_Coverage, 1213,
     /*  54149 */     GIR_EraseRootFromParent_Done,
     /*  54150 */   // Label 677: @54150
     /*  54150 */   GIM_Try, /*On fail goto*//*Label 678*/ GIMT_Encode4(54162), // Rule ID 128 //
     /*  54155 */     // (xor:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)  =>  (XOR:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*  54155 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XOR),
     /*  54160 */     GIR_RootConstrainSelectedInstOperands,
     /*  54161 */     // GIR_Coverage, 128,
     /*  54161 */     GIR_Done,
     /*  54162 */   // Label 678: @54162
     /*  54162 */   GIM_Reject,
     /*  54163 */ // Label 671: @54163
     /*  54163 */ GIM_Reject,
     /*  54164 */ // Label 595: @54164
     /*  54164 */ GIM_Try, /*On fail goto*//*Label 679*/ GIMT_Encode4(54418),
     /*  54169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  54172 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  54175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  54179 */   GIM_Try, /*On fail goto*//*Label 680*/ GIMT_Encode4(54221), // Rule ID 645 //
     /*  54184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54192 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54196 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54200 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  54204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54206 */     // (xor:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB), -1:{ *:[i64] })  =>  (NAND8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*  54206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::NAND8),
     /*  54209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  54211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RST
     /*  54215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RB
     /*  54219 */     GIR_RootConstrainSelectedInstOperands,
     /*  54220 */     // GIR_Coverage, 645,
     /*  54220 */     GIR_EraseRootFromParent_Done,
     /*  54221 */   // Label 680: @54221
     /*  54221 */   GIM_Try, /*On fail goto*//*Label 681*/ GIMT_Encode4(54263), // Rule ID 649 //
     /*  54226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  54234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54238 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54242 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  54246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54248 */     // (xor:{ *:[i64] } (or:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB), -1:{ *:[i64] })  =>  (NOR8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*  54248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /*  54251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  54253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RST
     /*  54257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RB
     /*  54261 */     GIR_RootConstrainSelectedInstOperands,
     /*  54262 */     // GIR_Coverage, 649,
     /*  54262 */     GIR_EraseRootFromParent_Done,
     /*  54263 */   // Label 681: @54263
     /*  54263 */   GIM_Try, /*On fail goto*//*Label 682*/ GIMT_Encode4(54303), // Rule ID 4933 //
     /*  54268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54280 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54284 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  54288 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54290 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$RST, -1:{ *:[i64] }), i64:{ *:[i64] }:$RB)  =>  (EQV8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*  54290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EQV8),
     /*  54293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  54295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RST
     /*  54299 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  54301 */     GIR_RootConstrainSelectedInstOperands,
     /*  54302 */     // GIR_Coverage, 4933,
     /*  54302 */     GIR_EraseRootFromParent_Done,
     /*  54303 */   // Label 682: @54303
     /*  54303 */   GIM_Try, /*On fail goto*//*Label 683*/ GIMT_Encode4(54345), // Rule ID 651 //
     /*  54308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54320 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54324 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  54328 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54330 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB), -1:{ *:[i64] })  =>  (EQV8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*  54330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EQV8),
     /*  54333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  54335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RST
     /*  54339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RB
     /*  54343 */     GIR_RootConstrainSelectedInstOperands,
     /*  54344 */     // GIR_Coverage, 651,
     /*  54344 */     GIR_EraseRootFromParent_Done,
     /*  54345 */   // Label 683: @54345
     /*  54345 */   GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(54385), // Rule ID 4934 //
     /*  54350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54358 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54362 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54366 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  54370 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54372 */     // (xor:{ *:[i64] } i64:{ *:[i64] }:$RB, (xor:{ *:[i64] } i64:{ *:[i64] }:$RST, -1:{ *:[i64] }))  =>  (EQV8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*  54372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EQV8),
     /*  54375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  54377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RST
     /*  54381 */     GIR_RootToRootCopy, /*OpIdx*/1, // RB
     /*  54383 */     GIR_RootConstrainSelectedInstOperands,
     /*  54384 */     // GIR_Coverage, 4934,
     /*  54384 */     GIR_EraseRootFromParent_Done,
     /*  54385 */   // Label 684: @54385
     /*  54385 */   GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(54405), // Rule ID 1525 //
     /*  54390 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  54394 */     // (xor:{ *:[i64] } i64:{ *:[i64] }:$in, -1:{ *:[i64] })  =>  (NOR8:{ *:[i64] } ?:{ *:[i64] }:$in, ?:{ *:[i64] }:$in)
     /*  54394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /*  54397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  54399 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /*  54401 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /*  54403 */     GIR_RootConstrainSelectedInstOperands,
     /*  54404 */     // GIR_Coverage, 1525,
     /*  54404 */     GIR_EraseRootFromParent_Done,
     /*  54405 */   // Label 685: @54405
     /*  54405 */   GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(54417), // Rule ID 652 //
     /*  54410 */     // (xor:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)  =>  (XOR8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*  54410 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XOR8),
     /*  54415 */     GIR_RootConstrainSelectedInstOperands,
     /*  54416 */     // GIR_Coverage, 652,
     /*  54416 */     GIR_Done,
     /*  54417 */   // Label 686: @54417
     /*  54417 */   GIM_Reject,
     /*  54418 */ // Label 679: @54418
     /*  54418 */ GIM_Reject,
     /*  54419 */ // Label 596: @54419
     /*  54419 */ GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(57542),
     /*  54424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54427 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54430 */   GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(54517), // Rule ID 4969 //
     /*  54435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  54438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  54442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54454 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54462 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54466 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54470 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54474 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  54478 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54484 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  54486 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54488 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 254:{ *:[i32] })
     /*  54488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  54491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  54493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  54497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  54501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  54505 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(254),
     /*  54515 */     GIR_RootConstrainSelectedInstOperands,
     /*  54516 */     // GIR_Coverage, 4969,
     /*  54516 */     GIR_EraseRootFromParent_Done,
     /*  54517 */   // Label 688: @54517
     /*  54517 */   GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(54604), // Rule ID 4971 //
     /*  54522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  54525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  54529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54541 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54545 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54549 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  54553 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54557 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54561 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  54565 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54571 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  54573 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54575 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 248:{ *:[i32] })
     /*  54575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  54578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  54580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  54584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  54588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  54592 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(248),
     /*  54602 */     GIR_RootConstrainSelectedInstOperands,
     /*  54603 */     // GIR_Coverage, 4971,
     /*  54603 */     GIR_EraseRootFromParent_Done,
     /*  54604 */   // Label 689: @54604
     /*  54604 */   GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(54691), // Rule ID 4970 //
     /*  54609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  54612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  54616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54628 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54632 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54636 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54640 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54644 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54648 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  54652 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54658 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  54660 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54662 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 249:{ *:[i32] })
     /*  54662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  54665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  54667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  54671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  54675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  54679 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(249),
     /*  54689 */     GIR_RootConstrainSelectedInstOperands,
     /*  54690 */     // GIR_Coverage, 4970,
     /*  54690 */     GIR_EraseRootFromParent_Done,
     /*  54691 */   // Label 690: @54691
     /*  54691 */   GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(54778), // Rule ID 3393 //
     /*  54696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  54699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  54703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54711 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54715 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54719 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54723 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54727 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54731 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54735 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  54739 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54745 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  54747 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54749 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 254:{ *:[i32] })
     /*  54749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  54752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  54754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  54758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  54762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  54766 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(254),
     /*  54776 */     GIR_RootConstrainSelectedInstOperands,
     /*  54777 */     // GIR_Coverage, 3393,
     /*  54777 */     GIR_EraseRootFromParent_Done,
     /*  54778 */   // Label 691: @54778
     /*  54778 */   GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(54865), // Rule ID 3395 //
     /*  54783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  54786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  54790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54798 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54802 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54806 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54810 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  54814 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54818 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54822 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  54826 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54832 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  54834 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54836 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 248:{ *:[i32] })
     /*  54836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  54839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  54841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  54845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  54849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  54853 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(248),
     /*  54863 */     GIR_RootConstrainSelectedInstOperands,
     /*  54864 */     // GIR_Coverage, 3395,
     /*  54864 */     GIR_EraseRootFromParent_Done,
     /*  54865 */   // Label 692: @54865
     /*  54865 */   GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(54952), // Rule ID 3394 //
     /*  54870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  54873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  54877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54889 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54893 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54897 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54901 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54905 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54909 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  54913 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54919 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  54921 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54923 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 249:{ *:[i32] })
     /*  54923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  54926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  54928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  54932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  54936 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  54940 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(249),
     /*  54950 */     GIR_RootConstrainSelectedInstOperands,
     /*  54951 */     // GIR_Coverage, 3394,
     /*  54951 */     GIR_EraseRootFromParent_Done,
     /*  54952 */   // Label 693: @54952
     /*  54952 */   GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(55039), // Rule ID 5269 //
     /*  54957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  54960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  54964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54976 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54980 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  54984 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54988 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54992 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54996 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  55000 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55006 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  55008 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55010 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 225:{ *:[i32] })
     /*  55010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  55019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  55023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  55027 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(225),
     /*  55037 */     GIR_RootConstrainSelectedInstOperands,
     /*  55038 */     // GIR_Coverage, 5269,
     /*  55038 */     GIR_EraseRootFromParent_Done,
     /*  55039 */   // Label 694: @55039
     /*  55039 */   GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(55126), // Rule ID 5277 //
     /*  55044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  55059 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55063 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55067 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55071 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  55075 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55079 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55083 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  55087 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55093 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  55095 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55097 */     // (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 224:{ *:[i32] })
     /*  55097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  55106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  55110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  55114 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(224),
     /*  55124 */     GIR_RootConstrainSelectedInstOperands,
     /*  55125 */     // GIR_Coverage, 5277,
     /*  55125 */     GIR_EraseRootFromParent_Done,
     /*  55126 */   // Label 695: @55126
     /*  55126 */   GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(55213), // Rule ID 5276 //
     /*  55131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  55146 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55150 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  55162 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55166 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55170 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  55174 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55180 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  55182 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55184 */     // (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 128:{ *:[i32] })
     /*  55184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  55193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  55197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  55201 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /*  55211 */     GIR_RootConstrainSelectedInstOperands,
     /*  55212 */     // GIR_Coverage, 5276,
     /*  55212 */     GIR_EraseRootFromParent_Done,
     /*  55213 */   // Label 696: @55213
     /*  55213 */   GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(55300), // Rule ID 5285 //
     /*  55218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  55233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55237 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55249 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55253 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55257 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  55261 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55267 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  55269 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55271 */     // (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 144:{ *:[i32] })
     /*  55271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  55280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  55284 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  55288 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(144),
     /*  55298 */     GIR_RootConstrainSelectedInstOperands,
     /*  55299 */     // GIR_Coverage, 5285,
     /*  55299 */     GIR_EraseRootFromParent_Done,
     /*  55300 */   // Label 697: @55300
     /*  55300 */   GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(55387), // Rule ID 3403 //
     /*  55305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  55320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55324 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55328 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55332 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  55336 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55340 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55344 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  55348 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55354 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  55356 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55358 */     // (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 224:{ *:[i32] })
     /*  55358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  55367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  55371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  55375 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(224),
     /*  55385 */     GIR_RootConstrainSelectedInstOperands,
     /*  55386 */     // GIR_Coverage, 3403,
     /*  55386 */     GIR_EraseRootFromParent_Done,
     /*  55387 */   // Label 698: @55387
     /*  55387 */   GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(55474), // Rule ID 3402 //
     /*  55392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  55407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55411 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55415 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55419 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  55423 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55427 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55431 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  55435 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55441 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  55443 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55445 */     // (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 128:{ *:[i32] })
     /*  55445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  55454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  55458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  55462 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /*  55472 */     GIR_RootConstrainSelectedInstOperands,
     /*  55473 */     // GIR_Coverage, 3402,
     /*  55473 */     GIR_EraseRootFromParent_Done,
     /*  55474 */   // Label 699: @55474
     /*  55474 */   GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(55561), // Rule ID 3407 //
     /*  55479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  55494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55498 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55510 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55514 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55518 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  55522 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55528 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  55530 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55532 */     // (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 144:{ *:[i32] })
     /*  55532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  55541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  55545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  55549 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(144),
     /*  55559 */     GIR_RootConstrainSelectedInstOperands,
     /*  55560 */     // GIR_Coverage, 3407,
     /*  55560 */     GIR_EraseRootFromParent_Done,
     /*  55561 */   // Label 700: @55561
     /*  55561 */   GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(55648), // Rule ID 5274 //
     /*  55566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  55581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55585 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55589 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  55593 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55597 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55601 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55605 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  55609 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55615 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  55617 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55619 */     // (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 135:{ *:[i32] })
     /*  55619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  55628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  55632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  55636 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(135),
     /*  55646 */     GIR_RootConstrainSelectedInstOperands,
     /*  55647 */     // GIR_Coverage, 5274,
     /*  55647 */     GIR_EraseRootFromParent_Done,
     /*  55648 */   // Label 701: @55648
     /*  55648 */   GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(55733), // Rule ID 5268 //
     /*  55653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55672 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55676 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55680 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  55684 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55688 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55692 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  55696 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55702 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  55704 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55706 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 225:{ *:[i32] })
     /*  55706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55711 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  55713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  55717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  55721 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(225),
     /*  55731 */     GIR_RootConstrainSelectedInstOperands,
     /*  55732 */     // GIR_Coverage, 5268,
     /*  55732 */     GIR_EraseRootFromParent_Done,
     /*  55733 */   // Label 702: @55733
     /*  55733 */   GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(55820), // Rule ID 5266 //
     /*  55738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55757 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  55769 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55773 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55777 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  55781 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55787 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  55789 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55791 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 225:{ *:[i32] })
     /*  55791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  55800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  55804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  55808 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(225),
     /*  55818 */     GIR_RootConstrainSelectedInstOperands,
     /*  55819 */     // GIR_Coverage, 5266,
     /*  55819 */     GIR_EraseRootFromParent_Done,
     /*  55820 */   // Label 703: @55820
     /*  55820 */   GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(55905), // Rule ID 5273 //
     /*  55825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55844 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55848 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55852 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  55856 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55860 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55864 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  55868 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55874 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  55876 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55878 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 135:{ *:[i32] })
     /*  55878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55883 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  55885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  55889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  55893 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(135),
     /*  55903 */     GIR_RootConstrainSelectedInstOperands,
     /*  55904 */     // GIR_Coverage, 5273,
     /*  55904 */     GIR_EraseRootFromParent_Done,
     /*  55905 */   // Label 704: @55905
     /*  55905 */   GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(55992), // Rule ID 5271 //
     /*  55910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55929 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55933 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55937 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  55941 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55945 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55949 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  55953 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55959 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  55961 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55963 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 135:{ *:[i32] })
     /*  55963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  55972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  55976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  55980 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(135),
     /*  55990 */     GIR_RootConstrainSelectedInstOperands,
     /*  55991 */     // GIR_Coverage, 5271,
     /*  55991 */     GIR_EraseRootFromParent_Done,
     /*  55992 */   // Label 705: @55992
     /*  55992 */   GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(56079), // Rule ID 3400 //
     /*  55997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  56000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56016 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  56028 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56032 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56036 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  56040 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56046 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  56048 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  56050 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 225:{ *:[i32] })
     /*  56050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  56053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  56059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  56063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  56067 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(225),
     /*  56077 */     GIR_RootConstrainSelectedInstOperands,
     /*  56078 */     // GIR_Coverage, 3400,
     /*  56078 */     GIR_EraseRootFromParent_Done,
     /*  56079 */   // Label 706: @56079
     /*  56079 */   GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(56166), // Rule ID 3401 //
     /*  56084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  56087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56103 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56107 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56111 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  56115 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56119 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56123 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  56127 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56133 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  56135 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  56137 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 135:{ *:[i32] })
     /*  56137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  56140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  56146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  56150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  56154 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(135),
     /*  56164 */     GIR_RootConstrainSelectedInstOperands,
     /*  56165 */     // GIR_Coverage, 3401,
     /*  56165 */     GIR_EraseRootFromParent_Done,
     /*  56166 */   // Label 707: @56166
     /*  56166 */   GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(56253), // Rule ID 5267 //
     /*  56171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  56174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56190 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56198 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56204 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56206 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  56210 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  56214 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56218 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56222 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  56224 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 225:{ *:[i32] })
     /*  56224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  56227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  56233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  56237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  56241 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(225),
     /*  56251 */     GIR_RootConstrainSelectedInstOperands,
     /*  56252 */     // GIR_Coverage, 5267,
     /*  56252 */     GIR_EraseRootFromParent_Done,
     /*  56253 */   // Label 708: @56253
     /*  56253 */   GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(56340), // Rule ID 5272 //
     /*  56258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  56261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56277 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56281 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56285 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56291 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56293 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  56297 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  56301 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56305 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56309 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  56311 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 135:{ *:[i32] })
     /*  56311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  56314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  56320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  56324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  56328 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(135),
     /*  56338 */     GIR_RootConstrainSelectedInstOperands,
     /*  56339 */     // GIR_Coverage, 5272,
     /*  56339 */     GIR_EraseRootFromParent_Done,
     /*  56340 */   // Label 709: @56340
     /*  56340 */   GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(56425), // Rule ID 5270 //
     /*  56345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  56348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56364 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56372 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  56376 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56380 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56384 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  56388 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56394 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  56396 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  56398 */     // (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 225:{ *:[i32] })
     /*  56398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  56401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56403 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  56405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  56409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  56413 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(225),
     /*  56423 */     GIR_RootConstrainSelectedInstOperands,
     /*  56424 */     // GIR_Coverage, 5270,
     /*  56424 */     GIR_EraseRootFromParent_Done,
     /*  56425 */   // Label 710: @56425
     /*  56425 */   GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(56510), // Rule ID 5275 //
     /*  56430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  56433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56445 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56449 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56453 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56457 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  56461 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56465 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56469 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  56473 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56479 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  56481 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  56483 */     // (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 135:{ *:[i32] })
     /*  56483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  56486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56488 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  56490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  56494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  56498 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(135),
     /*  56508 */     GIR_RootConstrainSelectedInstOperands,
     /*  56509 */     // GIR_Coverage, 5275,
     /*  56509 */     GIR_EraseRootFromParent_Done,
     /*  56510 */   // Label 711: @56510
     /*  56510 */   GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(56567), // Rule ID 944 //
     /*  56515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  56518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  56530 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56534 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  56542 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56548 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56550 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56552 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB), immAllOnesV:{ *:[v4i32] })  =>  (XXLNAND:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*  56552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLNAND),
     /*  56555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /*  56561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /*  56565 */     GIR_RootConstrainSelectedInstOperands,
     /*  56566 */     // GIR_Coverage, 944,
     /*  56566 */     GIR_EraseRootFromParent_Done,
     /*  56567 */   // Label 712: @56567
     /*  56567 */   GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(56624), // Rule ID 934 //
     /*  56572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  56575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  56587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56591 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56595 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  56599 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56605 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56607 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56609 */     // (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB), immAllOnesV:{ *:[v4i32] })  =>  (XXLNOR:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*  56609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLNOR),
     /*  56612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /*  56618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /*  56622 */     GIR_RootConstrainSelectedInstOperands,
     /*  56623 */     // GIR_Coverage, 934,
     /*  56623 */     GIR_EraseRootFromParent_Done,
     /*  56624 */   // Label 713: @56624
     /*  56624 */   GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(56679), // Rule ID 4940 //
     /*  56629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  56632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56648 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56656 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56662 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56664 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56666 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$XB)  =>  (XXLEQV:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*  56666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLEQV),
     /*  56669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /*  56675 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  56677 */     GIR_RootConstrainSelectedInstOperands,
     /*  56678 */     // GIR_Coverage, 4940,
     /*  56678 */     GIR_EraseRootFromParent_Done,
     /*  56679 */   // Label 714: @56679
     /*  56679 */   GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(56736), // Rule ID 943 //
     /*  56684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  56687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56699 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56703 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56707 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  56711 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56717 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56719 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56721 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB), immAllOnesV:{ *:[v4i32] })  =>  (XXLEQV:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*  56721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLEQV),
     /*  56724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /*  56730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /*  56734 */     GIR_RootConstrainSelectedInstOperands,
     /*  56735 */     // GIR_Coverage, 943,
     /*  56735 */     GIR_EraseRootFromParent_Done,
     /*  56736 */   // Label 715: @56736
     /*  56736 */   GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(56791), // Rule ID 4941 //
     /*  56741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  56744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56764 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56768 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56774 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56776 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56778 */     // (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XB, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, immAllOnesV:{ *:[v4i32] }))  =>  (XXLEQV:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*  56778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLEQV),
     /*  56781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /*  56787 */     GIR_RootToRootCopy, /*OpIdx*/1, // XB
     /*  56789 */     GIR_RootConstrainSelectedInstOperands,
     /*  56790 */     // GIR_Coverage, 4941,
     /*  56790 */     GIR_EraseRootFromParent_Done,
     /*  56791 */   // Label 716: @56791
     /*  56791 */   GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(56828), // Rule ID 1587 //
     /*  56796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  56799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56807 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56813 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  56815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56817 */     // (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$A, immAllOnesV:{ *:[v4i32] })  =>  (XXLNOR:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$A)
     /*  56817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLNOR),
     /*  56820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56822 */     GIR_RootToRootCopy, /*OpIdx*/1, // A
     /*  56824 */     GIR_RootToRootCopy, /*OpIdx*/1, // A
     /*  56826 */     GIR_RootConstrainSelectedInstOperands,
     /*  56827 */     // GIR_Coverage, 1587,
     /*  56827 */     GIR_EraseRootFromParent_Done,
     /*  56828 */   // Label 717: @56828
     /*  56828 */   GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(56878), // Rule ID 5297 //
     /*  56833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  56836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  56848 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56852 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56856 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56858 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 30:{ *:[i32] })
     /*  56858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  56861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56863 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  56865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  56869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  56873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/30,
     /*  56876 */     GIR_RootConstrainSelectedInstOperands,
     /*  56877 */     // GIR_Coverage, 5297,
     /*  56877 */     GIR_EraseRootFromParent_Done,
     /*  56878 */   // Label 718: @56878
     /*  56878 */   GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(56928), // Rule ID 5298 //
     /*  56883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  56886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  56898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56902 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56906 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56908 */     // (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 120:{ *:[i32] })
     /*  56908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  56911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56913 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  56915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  56919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  56923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/120,
     /*  56926 */     GIR_RootConstrainSelectedInstOperands,
     /*  56927 */     // GIR_Coverage, 5298,
     /*  56927 */     GIR_EraseRootFromParent_Done,
     /*  56928 */   // Label 719: @56928
     /*  56928 */   GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(56978), // Rule ID 5296 //
     /*  56933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  56936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56952 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56958 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 105:{ *:[i32] })
     /*  56958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  56961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  56967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  56971 */     GIR_RootToRootCopy, /*OpIdx*/2, // vC
     /*  56973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/105,
     /*  56976 */     GIR_RootConstrainSelectedInstOperands,
     /*  56977 */     // GIR_Coverage, 5296,
     /*  56977 */     GIR_EraseRootFromParent_Done,
     /*  56978 */   // Label 720: @56978
     /*  56978 */   GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(57028), // Rule ID 3415 //
     /*  56983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  56986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  56998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  57002 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57006 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  57008 */     // (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 30:{ *:[i32] })
     /*  57008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  57011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  57013 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  57015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  57019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  57023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/30,
     /*  57026 */     GIR_RootConstrainSelectedInstOperands,
     /*  57027 */     // GIR_Coverage, 3415,
     /*  57027 */     GIR_EraseRootFromParent_Done,
     /*  57028 */   // Label 721: @57028
     /*  57028 */   GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(57078), // Rule ID 3416 //
     /*  57033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  57036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  57040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  57048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  57052 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  57058 */     // (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 120:{ *:[i32] })
     /*  57058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  57061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  57063 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  57065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  57069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  57073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/120,
     /*  57076 */     GIR_RootConstrainSelectedInstOperands,
     /*  57077 */     // GIR_Coverage, 3416,
     /*  57077 */     GIR_EraseRootFromParent_Done,
     /*  57078 */   // Label 722: @57078
     /*  57078 */   GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(57128), // Rule ID 3414 //
     /*  57083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  57086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  57090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57098 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  57102 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57106 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  57108 */     // (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 105:{ *:[i32] })
     /*  57108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  57111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  57113 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  57115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  57119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  57123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/105,
     /*  57126 */     GIR_RootConstrainSelectedInstOperands,
     /*  57127 */     // GIR_Coverage, 3414,
     /*  57127 */     GIR_EraseRootFromParent_Done,
     /*  57128 */   // Label 723: @57128
     /*  57128 */   GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(57147), // Rule ID 936 //
     /*  57133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  57136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  57140 */     // (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)  =>  (XXLXOR:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*  57140 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XXLXOR),
     /*  57145 */     GIR_RootConstrainSelectedInstOperands,
     /*  57146 */     // GIR_Coverage, 936,
     /*  57146 */     GIR_Done,
     /*  57147 */   // Label 724: @57147
     /*  57147 */   GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(57204), // Rule ID 488 //
     /*  57152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  57155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  57159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  57167 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  57171 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57175 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  57179 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57185 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57187 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57189 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB), immAllOnesV:{ *:[v4i32] })  =>  (VNAND:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  57189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VNAND),
     /*  57192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  57194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // VA
     /*  57198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // VB
     /*  57202 */     GIR_RootConstrainSelectedInstOperands,
     /*  57203 */     // GIR_Coverage, 488,
     /*  57203 */     GIR_EraseRootFromParent_Done,
     /*  57204 */   // Label 725: @57204
     /*  57204 */   GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(57261), // Rule ID 385 //
     /*  57209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  57212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  57216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  57224 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  57228 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57232 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  57236 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57242 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57244 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57246 */     // (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB), immAllOnesV:{ *:[v4i32] })  =>  (VNOR:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  57246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VNOR),
     /*  57249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  57251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // VA
     /*  57255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // VB
     /*  57259 */     GIR_RootConstrainSelectedInstOperands,
     /*  57260 */     // GIR_Coverage, 385,
     /*  57260 */     GIR_EraseRootFromParent_Done,
     /*  57261 */   // Label 726: @57261
     /*  57261 */   GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(57318), // Rule ID 1383 //
     /*  57266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  57269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  57273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  57281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  57285 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  57293 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57299 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57301 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57303 */     // (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$A, v4i32:{ *:[v4i32] }:$B), immAllOnesV:{ *:[v4i32] })  =>  (VNOR:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B)
     /*  57303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VNOR),
     /*  57306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  57308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // A
     /*  57312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // B
     /*  57316 */     GIR_RootConstrainSelectedInstOperands,
     /*  57317 */     // GIR_Coverage, 1383,
     /*  57317 */     GIR_EraseRootFromParent_Done,
     /*  57318 */   // Label 727: @57318
     /*  57318 */   GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(57373), // Rule ID 4928 //
     /*  57323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  57326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  57330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  57342 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57350 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57356 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57358 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57360 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$VB)  =>  (VEQV:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  57360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEQV),
     /*  57363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  57365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // VA
     /*  57369 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  57371 */     GIR_RootConstrainSelectedInstOperands,
     /*  57372 */     // GIR_Coverage, 4928,
     /*  57372 */     GIR_EraseRootFromParent_Done,
     /*  57373 */   // Label 728: @57373
     /*  57373 */   GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(57430), // Rule ID 487 //
     /*  57378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  57381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  57385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  57397 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  57405 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57411 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57413 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57415 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB), immAllOnesV:{ *:[v4i32] })  =>  (VEQV:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  57415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEQV),
     /*  57418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  57420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // VA
     /*  57424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // VB
     /*  57428 */     GIR_RootConstrainSelectedInstOperands,
     /*  57429 */     // GIR_Coverage, 487,
     /*  57429 */     GIR_EraseRootFromParent_Done,
     /*  57430 */   // Label 729: @57430
     /*  57430 */   GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(57485), // Rule ID 4929 //
     /*  57435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  57438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  57442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  57454 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57462 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57468 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57470 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57472 */     // (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, immAllOnesV:{ *:[v4i32] }))  =>  (VEQV:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  57472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEQV),
     /*  57475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  57477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // VA
     /*  57481 */     GIR_RootToRootCopy, /*OpIdx*/1, // VB
     /*  57483 */     GIR_RootConstrainSelectedInstOperands,
     /*  57484 */     // GIR_Coverage, 4929,
     /*  57484 */     GIR_EraseRootFromParent_Done,
     /*  57485 */   // Label 730: @57485
     /*  57485 */   GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(57522), // Rule ID 1382 //
     /*  57490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  57493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  57497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57501 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57507 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  57509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  57511 */     // (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] })  =>  (VNOR:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vA)
     /*  57511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VNOR),
     /*  57514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  57516 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  57518 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  57520 */     GIR_RootConstrainSelectedInstOperands,
     /*  57521 */     // GIR_Coverage, 1382,
     /*  57521 */     GIR_EraseRootFromParent_Done,
     /*  57522 */   // Label 731: @57522
     /*  57522 */   GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(57541), // Rule ID 387 //
     /*  57527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  57530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  57534 */     // (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VXOR:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  57534 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VXOR),
     /*  57539 */     GIR_RootConstrainSelectedInstOperands,
     /*  57540 */     // GIR_Coverage, 387,
     /*  57540 */     GIR_Done,
     /*  57541 */   // Label 732: @57541
     /*  57541 */   GIM_Reject,
     /*  57542 */ // Label 687: @57542
     /*  57542 */ GIM_Reject,
     /*  57543 */ // Label 597: @57543
     /*  57543 */ GIM_Reject,
     /*  57544 */ // Label 10: @57544
     /*  57544 */ GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(57844),
     /*  57549 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  57552 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  57555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  57558 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  57561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  57565 */   GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(57687), // Rule ID 2131 //
     /*  57570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX_IsBigEndian_IsPPC64_NoP9Vector),
     /*  57573 */     // (build_vector:{ *:[v2i64] } i64:{ *:[i64] }:$A, i64:{ *:[i64] }:$B)  =>  (XXPERMDI:{ *:[v2i64] } (SUBREG_TO_REG:{ *:[v4i32] } 1:{ *:[i64] }, (MTVSRD:{ *:[f64] } ?:{ *:[i64] }:$A), sub_64:{ *:[i32] }), (SUBREG_TO_REG:{ *:[v4i32] } 1:{ *:[i64] }, (MTVSRD:{ *:[f64] } ?:{ *:[i64] }:$B), sub_64:{ *:[i32] }), 0:{ *:[i32] })
     /*  57573 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /*  57576 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::MTVSRD),
     /*  57580 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57585 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // B
     /*  57589 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  57591 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  57594 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  57598 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57603 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /*  57606 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  57609 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  57612 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  57617 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  57622 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  57625 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::MTVSRD),
     /*  57629 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57634 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // A
     /*  57638 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  57640 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  57643 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  57647 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57652 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  57655 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  57658 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  57661 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  57666 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  57671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXPERMDI),
     /*  57674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  57676 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  57679 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  57682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  57685 */     GIR_RootConstrainSelectedInstOperands,
     /*  57686 */     // GIR_Coverage, 2131,
     /*  57686 */     GIR_EraseRootFromParent_Done,
     /*  57687 */   // Label 734: @57687
     /*  57687 */   GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(57809), // Rule ID 2134 //
     /*  57692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX_IsLittleEndian_NoP9Vector),
     /*  57695 */     // (build_vector:{ *:[v2i64] } i64:{ *:[i64] }:$A, i64:{ *:[i64] }:$B)  =>  (XXPERMDI:{ *:[v2i64] } (SUBREG_TO_REG:{ *:[v4i32] } 1:{ *:[i64] }, (MTVSRD:{ *:[f64] } ?:{ *:[i64] }:$B), sub_64:{ *:[i32] }), (SUBREG_TO_REG:{ *:[v4i32] } 1:{ *:[i64] }, (MTVSRD:{ *:[f64] } ?:{ *:[i64] }:$A), sub_64:{ *:[i32] }), 0:{ *:[i32] })
     /*  57695 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /*  57698 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::MTVSRD),
     /*  57702 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57707 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // A
     /*  57711 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  57713 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  57716 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  57720 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57725 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /*  57728 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  57731 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  57734 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  57739 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  57744 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  57747 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::MTVSRD),
     /*  57751 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57756 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // B
     /*  57760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  57762 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  57765 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  57769 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57774 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  57777 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  57780 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  57783 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  57788 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  57793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXPERMDI),
     /*  57796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  57798 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  57801 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  57804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  57807 */     GIR_RootConstrainSelectedInstOperands,
     /*  57808 */     // GIR_Coverage, 2134,
     /*  57808 */     GIR_EraseRootFromParent_Done,
     /*  57809 */   // Label 735: @57809
     /*  57809 */   GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(57824), // Rule ID 2879 //
     /*  57814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX_IsBigEndian_IsISA3_0_IsPPC64),
     /*  57817 */     // (build_vector:{ *:[v2i64] } i64:{ *:[i64] }:$rB, i64:{ *:[i64] }:$rA)  =>  (MTVSRDD:{ *:[v2i64] } ?:{ *:[i64] }:$rB, ?:{ *:[i64] }:$rA)
     /*  57817 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MTVSRDD),
     /*  57822 */     GIR_RootConstrainSelectedInstOperands,
     /*  57823 */     // GIR_Coverage, 2879,
     /*  57823 */     GIR_Done,
     /*  57824 */   // Label 736: @57824
     /*  57824 */   GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(57843), // Rule ID 2883 //
     /*  57829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX_IsISA3_0_IsLittleEndian),
     /*  57832 */     // (build_vector:{ *:[v2i64] } i64:{ *:[i64] }:$rA, i64:{ *:[i64] }:$rB)  =>  (MTVSRDD:{ *:[v2i64] } ?:{ *:[i64] }:$rB, ?:{ *:[i64] }:$rA)
     /*  57832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTVSRDD),
     /*  57835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  57837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rB
     /*  57839 */     GIR_RootToRootCopy, /*OpIdx*/1, // rA
     /*  57841 */     GIR_RootConstrainSelectedInstOperands,
     /*  57842 */     // GIR_Coverage, 2883,
     /*  57842 */     GIR_EraseRootFromParent_Done,
     /*  57843 */   // Label 737: @57843
     /*  57843 */   GIM_Reject,
     /*  57844 */ // Label 733: @57844
     /*  57844 */ GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(58369),
     /*  57849 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /*  57852 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  57855 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  57858 */   GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(57909), // Rule ID 2045 //
     /*  57863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /*  57866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  57870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  57878 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immSExt5NonZero),
     /*  57882 */     // MIs[1] Operand 1
     /*  57882 */     // No operand predicates
     /*  57882 */     // MIs[0] A
     /*  57882 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  57887 */     // MIs[0] A
     /*  57887 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  57892 */     // MIs[0] A
     /*  57892 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/4, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  57897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  57899 */     // (build_vector:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_immSExt5NonZero>>:$A, (imm:{ *:[i32] })<<P:Predicate_immSExt5NonZero>>:$A, (imm:{ *:[i32] })<<P:Predicate_immSExt5NonZero>>:$A, (imm:{ *:[i32] })<<P:Predicate_immSExt5NonZero>>:$A)  =>  (VSPLTISW:{ *:[v4i32] } (imm:{ *:[i32] }):$A)
     /*  57899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSPLTISW),
     /*  57902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  57904 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // A
     /*  57907 */     GIR_RootConstrainSelectedInstOperands,
     /*  57908 */     // GIR_Coverage, 2045,
     /*  57908 */     GIR_EraseRootFromParent_Done,
     /*  57909 */   // Label 739: @57909
     /*  57909 */   GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(57960), // Rule ID 3382 //
     /*  57914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  57917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  57921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  57929 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i32immNonAllOneNonZero),
     /*  57933 */     // MIs[1] Operand 1
     /*  57933 */     // No operand predicates
     /*  57933 */     // MIs[0] A
     /*  57933 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  57938 */     // MIs[0] A
     /*  57938 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  57943 */     // MIs[0] A
     /*  57943 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/4, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  57948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  57950 */     // (build_vector:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_i32immNonAllOneNonZero>>:$A, (imm:{ *:[i32] })<<P:Predicate_i32immNonAllOneNonZero>>:$A, (imm:{ *:[i32] })<<P:Predicate_i32immNonAllOneNonZero>>:$A, (imm:{ *:[i32] })<<P:Predicate_i32immNonAllOneNonZero>>:$A)  =>  (XXSPLTIW:{ *:[v4i32] } (imm:{ *:[i32] }):$A)
     /*  57950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSPLTIW),
     /*  57953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  57955 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // A
     /*  57958 */     GIR_RootConstrainSelectedInstOperands,
     /*  57959 */     // GIR_Coverage, 3382,
     /*  57959 */     GIR_EraseRootFromParent_Done,
     /*  57960 */   // Label 740: @57960
     /*  57960 */   GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(58096), // Rule ID 1735 //
     /*  57965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  57968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  57971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  57974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  57977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  57981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  57989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  57993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  57997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  58001 */     // MIs[2] A
     /*  58001 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  58006 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /*  58010 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  58014 */     // MIs[3] A
     /*  58014 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  58019 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/4, // MIs[4]
     /*  58023 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  58027 */     // MIs[4] A
     /*  58027 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  58032 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  58034 */     // (build_vector:{ *:[v4f32] } (fpround:{ *:[f32] } f64:{ *:[f64] }:$A), (fpround:{ *:[f32] } f64:{ *:[f64] }:$A), (fpround:{ *:[f32] } f64:{ *:[f64] }:$A), (fpround:{ *:[f32] } f64:{ *:[f64] }:$A))  =>  (XXSPLTW:{ *:[v4f32] } (SUBREG_TO_REG:{ *:[v4i32] } 1:{ *:[i64] }, (XSCVDPSP:{ *:[f64] } f64:{ *:[f64] }:$A), sub_64:{ *:[i32] }), 0:{ *:[i32] })
     /*  58034 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  58037 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCVDPSP),
     /*  58041 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58046 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // A
     /*  58050 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  58052 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  58055 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  58059 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58064 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  58067 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  58070 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  58073 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58078 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  58083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSPLTW),
     /*  58086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  58088 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  58094 */     GIR_RootConstrainSelectedInstOperands,
     /*  58095 */     // GIR_Coverage, 1735,
     /*  58095 */     GIR_EraseRootFromParent_Done,
     /*  58096 */   // Label 741: @58096
     /*  58096 */   GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(58154), // Rule ID 1736 //
     /*  58101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  58104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58108 */     // MIs[0] A
     /*  58108 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58113 */     // MIs[0] A
     /*  58113 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58118 */     // MIs[0] A
     /*  58118 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/4, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58123 */     // (build_vector:{ *:[v4f32] } f32:{ *:[f32] }:$A, f32:{ *:[f32] }:$A, f32:{ *:[f32] }:$A, f32:{ *:[f32] }:$A)  =>  (XXSPLTW:{ *:[v4f32] } (XSCVDPSPN:{ *:[v4f32] } ?:{ *:[f32] }:$A), 0:{ *:[i32] })
     /*  58123 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  58126 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCVDPSPN),
     /*  58130 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58135 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // A
     /*  58139 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  58141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSPLTW),
     /*  58144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  58146 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  58152 */     GIR_RootConstrainSelectedInstOperands,
     /*  58153 */     // GIR_Coverage, 1736,
     /*  58153 */     GIR_EraseRootFromParent_Done,
     /*  58154 */   // Label 742: @58154
     /*  58154 */   GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(58243), // Rule ID 2133 //
     /*  58159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX_IsBigEndian_IsPPC64_NoP9Vector),
     /*  58162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58166 */     // MIs[0] A
     /*  58166 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58171 */     // MIs[0] A
     /*  58171 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58176 */     // MIs[0] A
     /*  58176 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/4, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58181 */     // (build_vector:{ *:[v4i32] } i32:{ *:[i32] }:$A, i32:{ *:[i32] }:$A, i32:{ *:[i32] }:$A, i32:{ *:[i32] }:$A)  =>  (XXSPLTW:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[v4i32] } 1:{ *:[i64] }, (MTVSRWZ:{ *:[f64] } ?:{ *:[i32] }:$A), sub_64:{ *:[i32] }), 1:{ *:[i32] })
     /*  58181 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  58184 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::MTVSRWZ),
     /*  58188 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58193 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // A
     /*  58197 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  58199 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  58202 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  58206 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58211 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  58214 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  58217 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  58220 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58225 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  58230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSPLTW),
     /*  58233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  58235 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  58241 */     GIR_RootConstrainSelectedInstOperands,
     /*  58242 */     // GIR_Coverage, 2133,
     /*  58242 */     GIR_EraseRootFromParent_Done,
     /*  58243 */   // Label 743: @58243
     /*  58243 */   GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(58332), // Rule ID 2136 //
     /*  58248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX_IsLittleEndian_NoP9Vector),
     /*  58251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58255 */     // MIs[0] A
     /*  58255 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58260 */     // MIs[0] A
     /*  58260 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58265 */     // MIs[0] A
     /*  58265 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/4, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58270 */     // (build_vector:{ *:[v4i32] } i32:{ *:[i32] }:$A, i32:{ *:[i32] }:$A, i32:{ *:[i32] }:$A, i32:{ *:[i32] }:$A)  =>  (XXSPLTW:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[v4i32] } 1:{ *:[i64] }, (MTVSRWZ:{ *:[f64] } ?:{ *:[i32] }:$A), sub_64:{ *:[i32] }), 1:{ *:[i32] })
     /*  58270 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  58273 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::MTVSRWZ),
     /*  58277 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58282 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // A
     /*  58286 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  58288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  58291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  58295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58300 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  58303 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  58306 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  58309 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58314 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  58319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSPLTW),
     /*  58322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  58324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  58330 */     GIR_RootConstrainSelectedInstOperands,
     /*  58331 */     // GIR_Coverage, 2136,
     /*  58331 */     GIR_EraseRootFromParent_Done,
     /*  58332 */   // Label 744: @58332
     /*  58332 */   GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(58368), // Rule ID 2269 //
     /*  58337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  58340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58344 */     // MIs[0] A
     /*  58344 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58349 */     // MIs[0] A
     /*  58349 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58354 */     // MIs[0] A
     /*  58354 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/4, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58359 */     // (build_vector:{ *:[v4i32] } i32:{ *:[i32] }:$A, i32:{ *:[i32] }:$A, i32:{ *:[i32] }:$A, i32:{ *:[i32] }:$A)  =>  (MTVSRWS:{ *:[v4i32] } ?:{ *:[i32] }:$A)
     /*  58359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTVSRWS),
     /*  58362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  58364 */     GIR_RootToRootCopy, /*OpIdx*/1, // A
     /*  58366 */     GIR_RootConstrainSelectedInstOperands,
     /*  58367 */     // GIR_Coverage, 2269,
     /*  58367 */     GIR_EraseRootFromParent_Done,
     /*  58368 */   // Label 745: @58368
     /*  58368 */   GIM_Reject,
     /*  58369 */ // Label 738: @58369
     /*  58369 */ GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(58510), // Rule ID 2270 //
     /*  58374 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  58377 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/17,
     /*  58380 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  58383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  58386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58390 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58394 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  58398 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immNonAllOneAnyExt8),
     /*  58402 */   // MIs[1] Operand 1
     /*  58402 */   // No operand predicates
     /*  58402 */   // MIs[0] A
     /*  58402 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58407 */   // MIs[0] A
     /*  58407 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58412 */   // MIs[0] A
     /*  58412 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/4, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58417 */   // MIs[0] A
     /*  58417 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/5, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58422 */   // MIs[0] A
     /*  58422 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/6, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58427 */   // MIs[0] A
     /*  58427 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/7, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58432 */   // MIs[0] A
     /*  58432 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/8, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58437 */   // MIs[0] A
     /*  58437 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/9, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58442 */   // MIs[0] A
     /*  58442 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/10, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58447 */   // MIs[0] A
     /*  58447 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/11, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58452 */   // MIs[0] A
     /*  58452 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/12, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58457 */   // MIs[0] A
     /*  58457 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/13, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58462 */   // MIs[0] A
     /*  58462 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/14, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58467 */   // MIs[0] A
     /*  58467 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/15, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58472 */   // MIs[0] A
     /*  58472 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/16, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58477 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  58479 */   // (build_vector:{ *:[v16i8] } (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (XXSPLTIB:{ *:[v4i32] } (imm:{ *:[i32] }):$A), VSRC:{ *:[i32] })
     /*  58479 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  58482 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXSPLTIB),
     /*  58486 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58491 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // A
     /*  58494 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  58496 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58499 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58501 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58504 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58509 */   // GIR_Coverage, 2270,
     /*  58509 */   GIR_EraseRootFromParent_Done,
     /*  58510 */ // Label 746: @58510
     /*  58510 */ GIM_Reject,
     /*  58511 */ // Label 11: @58511
     /*  58511 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 754*/ GIMT_Encode4(60787),
     /*  58522 */ /*GILLT_s32*//*Label 747*/ GIMT_Encode4(58550),
     /*  58526 */ /*GILLT_s64*//*Label 748*/ GIMT_Encode4(58623),
     /*  58530 */ /*GILLT_s128*//*Label 749*/ GIMT_Encode4(58671),
     /*  58534 */ /*GILLT_v2s64*//*Label 750*/ GIMT_Encode4(59075),
     /*  58538 */ /*GILLT_v4s32*//*Label 751*/ GIMT_Encode4(59637),
     /*  58542 */ /*GILLT_v8s16*//*Label 752*/ GIMT_Encode4(60188),
     /*  58546 */ /*GILLT_v16s8*//*Label 753*/ GIMT_Encode4(60516),
     /*  58550 */ // Label 747: @58550
     /*  58550 */ GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(58622), // Rule ID 2029 //
     /*  58555 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /*  58558 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  58561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  58565 */   // (bitconvert:{ *:[i32] } f32:{ *:[f32] }:$A)  =>  (MFVSRWZ:{ *:[i32] } (EXTRACT_SUBREG:{ *:[f64] } (XSCVDPSPN:{ *:[v4i32] } ?:{ *:[f32] }:$A), sub_64:{ *:[i32] }))
     /*  58565 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  58568 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCVDPSPN),
     /*  58572 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58577 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // A
     /*  58581 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  58583 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  58586 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58590 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58595 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_64),
     /*  58602 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /*  58607 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58612 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRWZ),
     /*  58615 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  58617 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58620 */   GIR_RootConstrainSelectedInstOperands,
     /*  58621 */   // GIR_Coverage, 2029,
     /*  58621 */   GIR_EraseRootFromParent_Done,
     /*  58622 */ // Label 755: @58622
     /*  58622 */ GIM_Reject,
     /*  58623 */ // Label 748: @58623
     /*  58623 */ GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(58670),
     /*  58628 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  58631 */   GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(58650), // Rule ID 2031 //
     /*  58636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /*  58639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  58643 */     // (bitconvert:{ *:[i64] } f64:{ *:[f64] }:$A)  =>  (MFVSRD:{ *:[i64] } ?:{ *:[f64] }:$A)
     /*  58643 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MFVSRD),
     /*  58648 */     GIR_RootConstrainSelectedInstOperands,
     /*  58649 */     // GIR_Coverage, 2031,
     /*  58649 */     GIR_Done,
     /*  58650 */   // Label 757: @58650
     /*  58650 */   GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(58669), // Rule ID 2032 //
     /*  58655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /*  58658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  58662 */     // (bitconvert:{ *:[f64] } i64:{ *:[i64] }:$S)  =>  (MTVSRD:{ *:[f64] } ?:{ *:[i64] }:$S)
     /*  58662 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MTVSRD),
     /*  58667 */     GIR_RootConstrainSelectedInstOperands,
     /*  58668 */     // GIR_Coverage, 2032,
     /*  58668 */     GIR_Done,
     /*  58669 */   // Label 758: @58669
     /*  58669 */   GIM_Reject,
     /*  58670 */ // Label 756: @58670
     /*  58670 */ GIM_Reject,
     /*  58671 */ // Label 749: @58671
     /*  58671 */ GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(58728), // Rule ID 1935 //
     /*  58676 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  58679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  58682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58686 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58690 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  58696 */   GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  58698 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  58700 */   // (bitconvert:{ *:[v1i128] } immAllOnesV:{ *:[v16i8] })  =>  (COPY_TO_REGCLASS:{ *:[v1i128] } (XXLEQVOnes:{ *:[v4i32] }), VSRC:{ *:[i32] })
     /*  58700 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  58703 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXLEQVOnes),
     /*  58707 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58712 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  58714 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58717 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58719 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58722 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58727 */   // GIR_Coverage, 1935,
     /*  58727 */   GIR_EraseRootFromParent_Done,
     /*  58728 */ // Label 759: @58728
     /*  58728 */ GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(58754), // Rule ID 1622 //
     /*  58733 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  58736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  58739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58743 */   // (bitconvert:{ *:[v1i128] } v2f64:{ *:[v2f64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v1i128] } ?:{ *:[v2f64] }:$A, VRRC:{ *:[i32] })
     /*  58743 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58748 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58753 */   // GIR_Coverage, 1622,
     /*  58753 */   GIR_Done,
     /*  58754 */ // Label 760: @58754
     /*  58754 */ GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(58786), // Rule ID 1336 //
     /*  58759 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  58762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  58765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58769 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58773 */   // (bitconvert:{ *:[v1i128] } VRRC:{ *:[v16i8] }:$src)  =>  VRRC:{ *:[v1i128] }:$src
     /*  58773 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58776 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  58778 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  58780 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58785 */   // GIR_Coverage, 1336,
     /*  58785 */   GIR_EraseRootFromParent_Done,
     /*  58786 */ // Label 761: @58786
     /*  58786 */ GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(58818), // Rule ID 1337 //
     /*  58791 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  58794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  58797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58801 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58805 */   // (bitconvert:{ *:[v1i128] } VRRC:{ *:[v8i16] }:$src)  =>  VRRC:{ *:[v1i128] }:$src
     /*  58805 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58808 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  58810 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  58812 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58817 */   // GIR_Coverage, 1337,
     /*  58817 */   GIR_EraseRootFromParent_Done,
     /*  58818 */ // Label 762: @58818
     /*  58818 */ GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(58850), // Rule ID 1338 //
     /*  58823 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  58826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  58829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58833 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58837 */   // (bitconvert:{ *:[v1i128] } VRRC:{ *:[v4i32] }:$src)  =>  VRRC:{ *:[v1i128] }:$src
     /*  58837 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58840 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  58842 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  58844 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58849 */   // GIR_Coverage, 1338,
     /*  58849 */   GIR_EraseRootFromParent_Done,
     /*  58850 */ // Label 763: @58850
     /*  58850 */ GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(58882), // Rule ID 1339 //
     /*  58855 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  58858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  58861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58865 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58869 */   // (bitconvert:{ *:[v1i128] } VRRC:{ *:[v4f32] }:$src)  =>  VRRC:{ *:[v1i128] }:$src
     /*  58869 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58872 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  58874 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  58876 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58881 */   // GIR_Coverage, 1339,
     /*  58881 */   GIR_EraseRootFromParent_Done,
     /*  58882 */ // Label 764: @58882
     /*  58882 */ GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(58914), // Rule ID 1340 //
     /*  58887 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  58890 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  58893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58897 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58901 */   // (bitconvert:{ *:[v1i128] } VRRC:{ *:[v2i64] }:$src)  =>  VRRC:{ *:[v1i128] }:$src
     /*  58901 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58904 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  58906 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  58908 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58913 */   // GIR_Coverage, 1340,
     /*  58913 */   GIR_EraseRootFromParent_Done,
     /*  58914 */ // Label 765: @58914
     /*  58914 */ GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(58946), // Rule ID 1341 //
     /*  58919 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  58922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  58925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58929 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58933 */   // (bitconvert:{ *:[f128] } VRRC:{ *:[v16i8] }:$src)  =>  VRRC:{ *:[f128] }:$src
     /*  58933 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58936 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  58938 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  58940 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58945 */   // GIR_Coverage, 1341,
     /*  58945 */   GIR_EraseRootFromParent_Done,
     /*  58946 */ // Label 766: @58946
     /*  58946 */ GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(58978), // Rule ID 1342 //
     /*  58951 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  58954 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  58957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58961 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58965 */   // (bitconvert:{ *:[f128] } VRRC:{ *:[v8i16] }:$src)  =>  VRRC:{ *:[f128] }:$src
     /*  58965 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58968 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  58970 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  58972 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58977 */   // GIR_Coverage, 1342,
     /*  58977 */   GIR_EraseRootFromParent_Done,
     /*  58978 */ // Label 767: @58978
     /*  58978 */ GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(59010), // Rule ID 1343 //
     /*  58983 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  58986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  58989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58993 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58997 */   // (bitconvert:{ *:[f128] } VRRC:{ *:[v4i32] }:$src)  =>  VRRC:{ *:[f128] }:$src
     /*  58997 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59000 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59002 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59004 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59009 */   // GIR_Coverage, 1343,
     /*  59009 */   GIR_EraseRootFromParent_Done,
     /*  59010 */ // Label 768: @59010
     /*  59010 */ GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(59042), // Rule ID 1344 //
     /*  59015 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59018 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  59021 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59025 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59029 */   // (bitconvert:{ *:[f128] } VRRC:{ *:[v4f32] }:$src)  =>  VRRC:{ *:[f128] }:$src
     /*  59029 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59032 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59034 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59036 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59041 */   // GIR_Coverage, 1344,
     /*  59041 */   GIR_EraseRootFromParent_Done,
     /*  59042 */ // Label 769: @59042
     /*  59042 */ GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(59074), // Rule ID 1345 //
     /*  59047 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  59053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59057 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59061 */   // (bitconvert:{ *:[f128] } VRRC:{ *:[v2f64] }:$src)  =>  VRRC:{ *:[f128] }:$src
     /*  59061 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59064 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59066 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59068 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59073 */   // GIR_Coverage, 1345,
     /*  59073 */   GIR_EraseRootFromParent_Done,
     /*  59074 */ // Label 770: @59074
     /*  59074 */ GIM_Reject,
     /*  59075 */ // Label 750: @59075
     /*  59075 */ GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(59132), // Rule ID 1936 //
     /*  59080 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  59083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  59086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59090 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59094 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  59100 */   GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  59102 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  59104 */   // (bitconvert:{ *:[v2i64] } immAllOnesV:{ *:[v16i8] })  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } (XXLEQVOnes:{ *:[v4i32] }), VSRC:{ *:[i32] })
     /*  59104 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  59107 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXLEQVOnes),
     /*  59111 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59116 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  59118 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59121 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59123 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  59126 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59131 */   // GIR_Coverage, 1936,
     /*  59131 */   GIR_EraseRootFromParent_Done,
     /*  59132 */ // Label 771: @59132
     /*  59132 */ GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(59158), // Rule ID 1603 //
     /*  59137 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  59143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59147 */   // (bitconvert:{ *:[v2f64] } v4f32:{ *:[v4f32] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } ?:{ *:[v4f32] }:$A, VSRC:{ *:[i32] })
     /*  59147 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59152 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59157 */   // GIR_Coverage, 1603,
     /*  59157 */   GIR_Done,
     /*  59158 */ // Label 772: @59158
     /*  59158 */ GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(59184), // Rule ID 1604 //
     /*  59163 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  59169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59173 */   // (bitconvert:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } ?:{ *:[v4i32] }:$A, VSRC:{ *:[i32] })
     /*  59173 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59178 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59183 */   // GIR_Coverage, 1604,
     /*  59183 */   GIR_Done,
     /*  59184 */ // Label 773: @59184
     /*  59184 */ GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(59210), // Rule ID 1605 //
     /*  59189 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  59195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59199 */   // (bitconvert:{ *:[v2f64] } v8i16:{ *:[v8i16] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } ?:{ *:[v8i16] }:$A, VSRC:{ *:[i32] })
     /*  59199 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59204 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59209 */   // GIR_Coverage, 1605,
     /*  59209 */   GIR_Done,
     /*  59210 */ // Label 774: @59210
     /*  59210 */ GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(59236), // Rule ID 1606 //
     /*  59215 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59218 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  59221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59225 */   // (bitconvert:{ *:[v2f64] } v16i8:{ *:[v16i8] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } ?:{ *:[v16i8] }:$A, VSRC:{ *:[i32] })
     /*  59225 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59230 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59235 */   // GIR_Coverage, 1606,
     /*  59235 */   GIR_Done,
     /*  59236 */ // Label 775: @59236
     /*  59236 */ GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(59262), // Rule ID 1611 //
     /*  59241 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59244 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  59247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59251 */   // (bitconvert:{ *:[v2i64] } v4f32:{ *:[v4f32] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } ?:{ *:[v4f32] }:$A, VSRC:{ *:[i32] })
     /*  59251 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59256 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59261 */   // GIR_Coverage, 1611,
     /*  59261 */   GIR_Done,
     /*  59262 */ // Label 776: @59262
     /*  59262 */ GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(59288), // Rule ID 1612 //
     /*  59267 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59270 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  59273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59277 */   // (bitconvert:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } ?:{ *:[v4i32] }:$A, VSRC:{ *:[i32] })
     /*  59277 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59282 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59287 */   // GIR_Coverage, 1612,
     /*  59287 */   GIR_Done,
     /*  59288 */ // Label 777: @59288
     /*  59288 */ GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(59314), // Rule ID 1613 //
     /*  59293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  59299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59303 */   // (bitconvert:{ *:[v2i64] } v8i16:{ *:[v8i16] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } ?:{ *:[v8i16] }:$A, VSRC:{ *:[i32] })
     /*  59303 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59308 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59313 */   // GIR_Coverage, 1613,
     /*  59313 */   GIR_Done,
     /*  59314 */ // Label 778: @59314
     /*  59314 */ GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(59340), // Rule ID 1614 //
     /*  59319 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  59325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59329 */   // (bitconvert:{ *:[v2i64] } v16i8:{ *:[v16i8] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } ?:{ *:[v16i8] }:$A, VSRC:{ *:[i32] })
     /*  59329 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59334 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59339 */   // GIR_Coverage, 1614,
     /*  59339 */   GIR_Done,
     /*  59340 */ // Label 779: @59340
     /*  59340 */ GIM_Try, /*On fail goto*//*Label 780*/ GIMT_Encode4(59366), // Rule ID 1619 //
     /*  59345 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  59351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59355 */   // (bitconvert:{ *:[v2f64] } v2i64:{ *:[v2i64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } ?:{ *:[v2i64] }:$A, VRRC:{ *:[i32] })
     /*  59355 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59360 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59365 */   // GIR_Coverage, 1619,
     /*  59365 */   GIR_Done,
     /*  59366 */ // Label 780: @59366
     /*  59366 */ GIM_Try, /*On fail goto*//*Label 781*/ GIMT_Encode4(59392), // Rule ID 1620 //
     /*  59371 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  59377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59381 */   // (bitconvert:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } ?:{ *:[v2f64] }:$A, VRRC:{ *:[i32] })
     /*  59381 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59386 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59391 */   // GIR_Coverage, 1620,
     /*  59391 */   GIR_Done,
     /*  59392 */ // Label 781: @59392
     /*  59392 */ GIM_Try, /*On fail goto*//*Label 782*/ GIMT_Encode4(59418), // Rule ID 1621 //
     /*  59397 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  59403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59407 */   // (bitconvert:{ *:[v2f64] } v1i128:{ *:[v1i128] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } ?:{ *:[v1i128] }:$A, VRRC:{ *:[i32] })
     /*  59407 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59412 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59417 */   // GIR_Coverage, 1621,
     /*  59417 */   GIR_Done,
     /*  59418 */ // Label 782: @59418
     /*  59418 */ GIM_Try, /*On fail goto*//*Label 783*/ GIMT_Encode4(59444), // Rule ID 1623 //
     /*  59423 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  59429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59433 */   // (bitconvert:{ *:[v2i64] } f128:{ *:[f128] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } ?:{ *:[f128] }:$A, VRRC:{ *:[i32] })
     /*  59433 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59438 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59443 */   // GIR_Coverage, 1623,
     /*  59443 */   GIR_Done,
     /*  59444 */ // Label 783: @59444
     /*  59444 */ GIM_Try, /*On fail goto*//*Label 784*/ GIMT_Encode4(59476), // Rule ID 1331 //
     /*  59449 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  59455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59459 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59463 */   // (bitconvert:{ *:[v2i64] } VRRC:{ *:[v16i8] }:$src)  =>  VRRC:{ *:[v2i64] }:$src
     /*  59463 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59466 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59468 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59470 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59475 */   // GIR_Coverage, 1331,
     /*  59475 */   GIR_EraseRootFromParent_Done,
     /*  59476 */ // Label 784: @59476
     /*  59476 */ GIM_Try, /*On fail goto*//*Label 785*/ GIMT_Encode4(59508), // Rule ID 1332 //
     /*  59481 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59484 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  59487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59491 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59495 */   // (bitconvert:{ *:[v2i64] } VRRC:{ *:[v8i16] }:$src)  =>  VRRC:{ *:[v2i64] }:$src
     /*  59495 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59498 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59500 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59502 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59507 */   // GIR_Coverage, 1332,
     /*  59507 */   GIR_EraseRootFromParent_Done,
     /*  59508 */ // Label 785: @59508
     /*  59508 */ GIM_Try, /*On fail goto*//*Label 786*/ GIMT_Encode4(59540), // Rule ID 1333 //
     /*  59513 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  59519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59523 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59527 */   // (bitconvert:{ *:[v2i64] } VRRC:{ *:[v4i32] }:$src)  =>  VRRC:{ *:[v2i64] }:$src
     /*  59527 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59530 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59532 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59534 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59539 */   // GIR_Coverage, 1333,
     /*  59539 */   GIR_EraseRootFromParent_Done,
     /*  59540 */ // Label 786: @59540
     /*  59540 */ GIM_Try, /*On fail goto*//*Label 787*/ GIMT_Encode4(59572), // Rule ID 1334 //
     /*  59545 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  59551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59555 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59559 */   // (bitconvert:{ *:[v2i64] } VRRC:{ *:[v4f32] }:$src)  =>  VRRC:{ *:[v2i64] }:$src
     /*  59559 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59562 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59564 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59566 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59571 */   // GIR_Coverage, 1334,
     /*  59571 */   GIR_EraseRootFromParent_Done,
     /*  59572 */ // Label 787: @59572
     /*  59572 */ GIM_Try, /*On fail goto*//*Label 788*/ GIMT_Encode4(59604), // Rule ID 1335 //
     /*  59577 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  59583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59587 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59591 */   // (bitconvert:{ *:[v2i64] } VRRC:{ *:[v1i128] }:$src)  =>  VRRC:{ *:[v2i64] }:$src
     /*  59591 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59594 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59596 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59598 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59603 */   // GIR_Coverage, 1335,
     /*  59603 */   GIR_EraseRootFromParent_Done,
     /*  59604 */ // Label 788: @59604
     /*  59604 */ GIM_Try, /*On fail goto*//*Label 789*/ GIMT_Encode4(59636), // Rule ID 1350 //
     /*  59609 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59612 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  59615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59619 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59623 */   // (bitconvert:{ *:[v2f64] } VRRC:{ *:[f128] }:$src)  =>  VRRC:{ *:[v2f64] }:$src
     /*  59623 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59626 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59628 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59630 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59635 */   // GIR_Coverage, 1350,
     /*  59635 */   GIR_EraseRootFromParent_Done,
     /*  59636 */ // Label 789: @59636
     /*  59636 */ GIM_Reject,
     /*  59637 */ // Label 751: @59637
     /*  59637 */ GIM_Try, /*On fail goto*//*Label 790*/ GIMT_Encode4(59673), // Rule ID 945 //
     /*  59642 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  59645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  59648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59652 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59656 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  59662 */   GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  59664 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  59666 */   // (bitconvert:{ *:[v4i32] } immAllOnesV:{ *:[v16i8] })  =>  (XXLEQVOnes:{ *:[v4i32] })
     /*  59666 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLEQVOnes),
     /*  59669 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  59671 */   GIR_RootConstrainSelectedInstOperands,
     /*  59672 */   // GIR_Coverage, 945,
     /*  59672 */   GIR_EraseRootFromParent_Done,
     /*  59673 */ // Label 790: @59673
     /*  59673 */ GIM_Try, /*On fail goto*//*Label 791*/ GIMT_Encode4(59699), // Rule ID 1607 //
     /*  59678 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  59684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59688 */   // (bitconvert:{ *:[v4f32] } v2f64:{ *:[v2f64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v4f32] } ?:{ *:[v2f64] }:$A, VRRC:{ *:[i32] })
     /*  59688 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59693 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59698 */   // GIR_Coverage, 1607,
     /*  59698 */   GIR_Done,
     /*  59699 */ // Label 791: @59699
     /*  59699 */ GIM_Try, /*On fail goto*//*Label 792*/ GIMT_Encode4(59725), // Rule ID 1608 //
     /*  59704 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  59710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59714 */   // (bitconvert:{ *:[v4i32] } v2f64:{ *:[v2f64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v2f64] }:$A, VRRC:{ *:[i32] })
     /*  59714 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59719 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59724 */   // GIR_Coverage, 1608,
     /*  59724 */   GIR_Done,
     /*  59725 */ // Label 792: @59725
     /*  59725 */ GIM_Try, /*On fail goto*//*Label 793*/ GIMT_Encode4(59751), // Rule ID 1615 //
     /*  59730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  59736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59740 */   // (bitconvert:{ *:[v4f32] } v2i64:{ *:[v2i64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v4f32] } ?:{ *:[v2i64] }:$A, VRRC:{ *:[i32] })
     /*  59740 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59745 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59750 */   // GIR_Coverage, 1615,
     /*  59750 */   GIR_Done,
     /*  59751 */ // Label 793: @59751
     /*  59751 */ GIM_Try, /*On fail goto*//*Label 794*/ GIMT_Encode4(59777), // Rule ID 1616 //
     /*  59756 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59759 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  59762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59766 */   // (bitconvert:{ *:[v4i32] } v2i64:{ *:[v2i64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v2i64] }:$A, VRRC:{ *:[i32] })
     /*  59766 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59771 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59776 */   // GIR_Coverage, 1616,
     /*  59776 */   GIR_Done,
     /*  59777 */ // Label 794: @59777
     /*  59777 */ GIM_Try, /*On fail goto*//*Label 795*/ GIMT_Encode4(59803), // Rule ID 1624 //
     /*  59782 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59785 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  59788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59792 */   // (bitconvert:{ *:[v4i32] } f128:{ *:[f128] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[f128] }:$A, VRRC:{ *:[i32] })
     /*  59792 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59797 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59802 */   // GIR_Coverage, 1624,
     /*  59802 */   GIR_Done,
     /*  59803 */ // Label 795: @59803
     /*  59803 */ GIM_Try, /*On fail goto*//*Label 796*/ GIMT_Encode4(59835), // Rule ID 1321 //
     /*  59808 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  59814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59818 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59822 */   // (bitconvert:{ *:[v4i32] } VRRC:{ *:[v16i8] }:$src)  =>  VRRC:{ *:[v4i32] }:$src
     /*  59822 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59825 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59827 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59829 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59834 */   // GIR_Coverage, 1321,
     /*  59834 */   GIR_EraseRootFromParent_Done,
     /*  59835 */ // Label 796: @59835
     /*  59835 */ GIM_Try, /*On fail goto*//*Label 797*/ GIMT_Encode4(59867), // Rule ID 1322 //
     /*  59840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  59846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59850 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59854 */   // (bitconvert:{ *:[v4i32] } VRRC:{ *:[v8i16] }:$src)  =>  VRRC:{ *:[v4i32] }:$src
     /*  59854 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59857 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59859 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59861 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59866 */   // GIR_Coverage, 1322,
     /*  59866 */   GIR_EraseRootFromParent_Done,
     /*  59867 */ // Label 797: @59867
     /*  59867 */ GIM_Try, /*On fail goto*//*Label 798*/ GIMT_Encode4(59899), // Rule ID 1323 //
     /*  59872 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  59878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59882 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59886 */   // (bitconvert:{ *:[v4i32] } VRRC:{ *:[v4f32] }:$src)  =>  VRRC:{ *:[v4i32] }:$src
     /*  59886 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59889 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59891 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59893 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59898 */   // GIR_Coverage, 1323,
     /*  59898 */   GIR_EraseRootFromParent_Done,
     /*  59899 */ // Label 798: @59899
     /*  59899 */ GIM_Try, /*On fail goto*//*Label 799*/ GIMT_Encode4(59931), // Rule ID 1324 //
     /*  59904 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  59910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59918 */   // (bitconvert:{ *:[v4i32] } VRRC:{ *:[v2i64] }:$src)  =>  VRRC:{ *:[v4i32] }:$src
     /*  59918 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59921 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59923 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59925 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59930 */   // GIR_Coverage, 1324,
     /*  59930 */   GIR_EraseRootFromParent_Done,
     /*  59931 */ // Label 799: @59931
     /*  59931 */ GIM_Try, /*On fail goto*//*Label 800*/ GIMT_Encode4(59963), // Rule ID 1325 //
     /*  59936 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  59942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59946 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59950 */   // (bitconvert:{ *:[v4i32] } VRRC:{ *:[v1i128] }:$src)  =>  VRRC:{ *:[v4i32] }:$src
     /*  59950 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59953 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59955 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59957 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59962 */   // GIR_Coverage, 1325,
     /*  59962 */   GIR_EraseRootFromParent_Done,
     /*  59963 */ // Label 800: @59963
     /*  59963 */ GIM_Try, /*On fail goto*//*Label 801*/ GIMT_Encode4(59995), // Rule ID 1326 //
     /*  59968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  59974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59982 */   // (bitconvert:{ *:[v4f32] } VRRC:{ *:[v16i8] }:$src)  =>  VRRC:{ *:[v4f32] }:$src
     /*  59982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59985 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59987 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59989 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59994 */   // GIR_Coverage, 1326,
     /*  59994 */   GIR_EraseRootFromParent_Done,
     /*  59995 */ // Label 801: @59995
     /*  59995 */ GIM_Try, /*On fail goto*//*Label 802*/ GIMT_Encode4(60027), // Rule ID 1327 //
     /*  60000 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  60006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60010 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60014 */   // (bitconvert:{ *:[v4f32] } VRRC:{ *:[v8i16] }:$src)  =>  VRRC:{ *:[v4f32] }:$src
     /*  60014 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60017 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60019 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60021 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60026 */   // GIR_Coverage, 1327,
     /*  60026 */   GIR_EraseRootFromParent_Done,
     /*  60027 */ // Label 802: @60027
     /*  60027 */ GIM_Try, /*On fail goto*//*Label 803*/ GIMT_Encode4(60059), // Rule ID 1328 //
     /*  60032 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  60038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60042 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60046 */   // (bitconvert:{ *:[v4f32] } VRRC:{ *:[v4i32] }:$src)  =>  VRRC:{ *:[v4f32] }:$src
     /*  60046 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60049 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60051 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60053 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60058 */   // GIR_Coverage, 1328,
     /*  60058 */   GIR_EraseRootFromParent_Done,
     /*  60059 */ // Label 803: @60059
     /*  60059 */ GIM_Try, /*On fail goto*//*Label 804*/ GIMT_Encode4(60091), // Rule ID 1329 //
     /*  60064 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  60070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60074 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60078 */   // (bitconvert:{ *:[v4f32] } VRRC:{ *:[v2i64] }:$src)  =>  VRRC:{ *:[v4f32] }:$src
     /*  60078 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60081 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60083 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60085 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60090 */   // GIR_Coverage, 1329,
     /*  60090 */   GIR_EraseRootFromParent_Done,
     /*  60091 */ // Label 804: @60091
     /*  60091 */ GIM_Try, /*On fail goto*//*Label 805*/ GIMT_Encode4(60123), // Rule ID 1330 //
     /*  60096 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  60102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60106 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60110 */   // (bitconvert:{ *:[v4f32] } VRRC:{ *:[v1i128] }:$src)  =>  VRRC:{ *:[v4f32] }:$src
     /*  60110 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60113 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60115 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60117 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60122 */   // GIR_Coverage, 1330,
     /*  60122 */   GIR_EraseRootFromParent_Done,
     /*  60123 */ // Label 805: @60123
     /*  60123 */ GIM_Try, /*On fail goto*//*Label 806*/ GIMT_Encode4(60155), // Rule ID 1348 //
     /*  60128 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  60134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60138 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60142 */   // (bitconvert:{ *:[v4i32] } VRRC:{ *:[f128] }:$src)  =>  VRRC:{ *:[v4i32] }:$src
     /*  60142 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60145 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60147 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60149 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60154 */   // GIR_Coverage, 1348,
     /*  60154 */   GIR_EraseRootFromParent_Done,
     /*  60155 */ // Label 806: @60155
     /*  60155 */ GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(60187), // Rule ID 1349 //
     /*  60160 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  60166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60170 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60174 */   // (bitconvert:{ *:[v4f32] } VRRC:{ *:[f128] }:$src)  =>  VRRC:{ *:[v4f32] }:$src
     /*  60174 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60177 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60179 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60181 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60186 */   // GIR_Coverage, 1349,
     /*  60186 */   GIR_EraseRootFromParent_Done,
     /*  60187 */ // Label 807: @60187
     /*  60187 */ GIM_Reject,
     /*  60188 */ // Label 752: @60188
     /*  60188 */ GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(60245), // Rule ID 1937 //
     /*  60193 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  60196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  60199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  60203 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60207 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  60213 */   GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  60215 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  60217 */   // (bitconvert:{ *:[v8i16] } immAllOnesV:{ *:[v16i8] })  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } (XXLEQVOnes:{ *:[v4i32] }), VSRC:{ *:[i32] })
     /*  60217 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  60220 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXLEQVOnes),
     /*  60224 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60229 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60231 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60234 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60236 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60239 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  60244 */   // GIR_Coverage, 1937,
     /*  60244 */   GIR_EraseRootFromParent_Done,
     /*  60245 */ // Label 808: @60245
     /*  60245 */ GIM_Try, /*On fail goto*//*Label 809*/ GIMT_Encode4(60271), // Rule ID 1609 //
     /*  60250 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  60253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  60256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60260 */   // (bitconvert:{ *:[v8i16] } v2f64:{ *:[v2f64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } ?:{ *:[v2f64] }:$A, VRRC:{ *:[i32] })
     /*  60260 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60265 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60270 */   // GIR_Coverage, 1609,
     /*  60270 */   GIR_Done,
     /*  60271 */ // Label 809: @60271
     /*  60271 */ GIM_Try, /*On fail goto*//*Label 810*/ GIMT_Encode4(60297), // Rule ID 1617 //
     /*  60276 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  60279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  60282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60286 */   // (bitconvert:{ *:[v8i16] } v2i64:{ *:[v2i64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } ?:{ *:[v2i64] }:$A, VRRC:{ *:[i32] })
     /*  60286 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60291 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60296 */   // GIR_Coverage, 1617,
     /*  60296 */   GIR_Done,
     /*  60297 */ // Label 810: @60297
     /*  60297 */ GIM_Try, /*On fail goto*//*Label 811*/ GIMT_Encode4(60323), // Rule ID 1625 //
     /*  60302 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  60305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  60308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60312 */   // (bitconvert:{ *:[v8i16] } f128:{ *:[f128] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } ?:{ *:[f128] }:$A, VRRC:{ *:[i32] })
     /*  60312 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60317 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60322 */   // GIR_Coverage, 1625,
     /*  60322 */   GIR_Done,
     /*  60323 */ // Label 811: @60323
     /*  60323 */ GIM_Try, /*On fail goto*//*Label 812*/ GIMT_Encode4(60355), // Rule ID 1316 //
     /*  60328 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  60334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60338 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60342 */   // (bitconvert:{ *:[v8i16] } VRRC:{ *:[v16i8] }:$src)  =>  VRRC:{ *:[v8i16] }:$src
     /*  60342 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60345 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60347 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60349 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60354 */   // GIR_Coverage, 1316,
     /*  60354 */   GIR_EraseRootFromParent_Done,
     /*  60355 */ // Label 812: @60355
     /*  60355 */ GIM_Try, /*On fail goto*//*Label 813*/ GIMT_Encode4(60387), // Rule ID 1317 //
     /*  60360 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  60366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60370 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60374 */   // (bitconvert:{ *:[v8i16] } VRRC:{ *:[v4i32] }:$src)  =>  VRRC:{ *:[v8i16] }:$src
     /*  60374 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60377 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60379 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60381 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60386 */   // GIR_Coverage, 1317,
     /*  60386 */   GIR_EraseRootFromParent_Done,
     /*  60387 */ // Label 813: @60387
     /*  60387 */ GIM_Try, /*On fail goto*//*Label 814*/ GIMT_Encode4(60419), // Rule ID 1318 //
     /*  60392 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60395 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  60398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60402 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60406 */   // (bitconvert:{ *:[v8i16] } VRRC:{ *:[v4f32] }:$src)  =>  VRRC:{ *:[v8i16] }:$src
     /*  60406 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60409 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60411 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60413 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60418 */   // GIR_Coverage, 1318,
     /*  60418 */   GIR_EraseRootFromParent_Done,
     /*  60419 */ // Label 814: @60419
     /*  60419 */ GIM_Try, /*On fail goto*//*Label 815*/ GIMT_Encode4(60451), // Rule ID 1319 //
     /*  60424 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  60430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60434 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60438 */   // (bitconvert:{ *:[v8i16] } VRRC:{ *:[v2i64] }:$src)  =>  VRRC:{ *:[v8i16] }:$src
     /*  60438 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60441 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60443 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60445 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60450 */   // GIR_Coverage, 1319,
     /*  60450 */   GIR_EraseRootFromParent_Done,
     /*  60451 */ // Label 815: @60451
     /*  60451 */ GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(60483), // Rule ID 1320 //
     /*  60456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  60462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60470 */   // (bitconvert:{ *:[v8i16] } VRRC:{ *:[v1i128] }:$src)  =>  VRRC:{ *:[v8i16] }:$src
     /*  60470 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60473 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60475 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60477 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60482 */   // GIR_Coverage, 1320,
     /*  60482 */   GIR_EraseRootFromParent_Done,
     /*  60483 */ // Label 816: @60483
     /*  60483 */ GIM_Try, /*On fail goto*//*Label 817*/ GIMT_Encode4(60515), // Rule ID 1347 //
     /*  60488 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  60494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60498 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60502 */   // (bitconvert:{ *:[v8i16] } VRRC:{ *:[f128] }:$src)  =>  VRRC:{ *:[v8i16] }:$src
     /*  60502 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60505 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60507 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60509 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60514 */   // GIR_Coverage, 1347,
     /*  60514 */   GIR_EraseRootFromParent_Done,
     /*  60515 */ // Label 817: @60515
     /*  60515 */ GIM_Reject,
     /*  60516 */ // Label 753: @60516
     /*  60516 */ GIM_Try, /*On fail goto*//*Label 818*/ GIMT_Encode4(60542), // Rule ID 1610 //
     /*  60521 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  60524 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  60527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60531 */   // (bitconvert:{ *:[v16i8] } v2f64:{ *:[v2f64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } ?:{ *:[v2f64] }:$A, VRRC:{ *:[i32] })
     /*  60531 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60536 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60541 */   // GIR_Coverage, 1610,
     /*  60541 */   GIR_Done,
     /*  60542 */ // Label 818: @60542
     /*  60542 */ GIM_Try, /*On fail goto*//*Label 819*/ GIMT_Encode4(60568), // Rule ID 1618 //
     /*  60547 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  60550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  60553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60557 */   // (bitconvert:{ *:[v16i8] } v2i64:{ *:[v2i64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } ?:{ *:[v2i64] }:$A, VRRC:{ *:[i32] })
     /*  60557 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60562 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60567 */   // GIR_Coverage, 1618,
     /*  60567 */   GIR_Done,
     /*  60568 */ // Label 819: @60568
     /*  60568 */ GIM_Try, /*On fail goto*//*Label 820*/ GIMT_Encode4(60594), // Rule ID 1626 //
     /*  60573 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  60576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  60579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60583 */   // (bitconvert:{ *:[v16i8] } f128:{ *:[f128] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } ?:{ *:[f128] }:$A, VRRC:{ *:[i32] })
     /*  60583 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60588 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60593 */   // GIR_Coverage, 1626,
     /*  60593 */   GIR_Done,
     /*  60594 */ // Label 820: @60594
     /*  60594 */ GIM_Try, /*On fail goto*//*Label 821*/ GIMT_Encode4(60626), // Rule ID 1311 //
     /*  60599 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  60605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60609 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60613 */   // (bitconvert:{ *:[v16i8] } VRRC:{ *:[v8i16] }:$src)  =>  VRRC:{ *:[v16i8] }:$src
     /*  60613 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60616 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60618 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60620 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60625 */   // GIR_Coverage, 1311,
     /*  60625 */   GIR_EraseRootFromParent_Done,
     /*  60626 */ // Label 821: @60626
     /*  60626 */ GIM_Try, /*On fail goto*//*Label 822*/ GIMT_Encode4(60658), // Rule ID 1312 //
     /*  60631 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  60637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60641 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60645 */   // (bitconvert:{ *:[v16i8] } VRRC:{ *:[v4i32] }:$src)  =>  VRRC:{ *:[v16i8] }:$src
     /*  60645 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60648 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60650 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60652 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60657 */   // GIR_Coverage, 1312,
     /*  60657 */   GIR_EraseRootFromParent_Done,
     /*  60658 */ // Label 822: @60658
     /*  60658 */ GIM_Try, /*On fail goto*//*Label 823*/ GIMT_Encode4(60690), // Rule ID 1313 //
     /*  60663 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  60669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60673 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60677 */   // (bitconvert:{ *:[v16i8] } VRRC:{ *:[v4f32] }:$src)  =>  VRRC:{ *:[v16i8] }:$src
     /*  60677 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60680 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60682 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60684 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60689 */   // GIR_Coverage, 1313,
     /*  60689 */   GIR_EraseRootFromParent_Done,
     /*  60690 */ // Label 823: @60690
     /*  60690 */ GIM_Try, /*On fail goto*//*Label 824*/ GIMT_Encode4(60722), // Rule ID 1314 //
     /*  60695 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60698 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  60701 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60705 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60709 */   // (bitconvert:{ *:[v16i8] } VRRC:{ *:[v2i64] }:$src)  =>  VRRC:{ *:[v16i8] }:$src
     /*  60709 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60712 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60714 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60716 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60721 */   // GIR_Coverage, 1314,
     /*  60721 */   GIR_EraseRootFromParent_Done,
     /*  60722 */ // Label 824: @60722
     /*  60722 */ GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(60754), // Rule ID 1315 //
     /*  60727 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  60733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60737 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60741 */   // (bitconvert:{ *:[v16i8] } VRRC:{ *:[v1i128] }:$src)  =>  VRRC:{ *:[v16i8] }:$src
     /*  60741 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60744 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60746 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60748 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60753 */   // GIR_Coverage, 1315,
     /*  60753 */   GIR_EraseRootFromParent_Done,
     /*  60754 */ // Label 825: @60754
     /*  60754 */ GIM_Try, /*On fail goto*//*Label 826*/ GIMT_Encode4(60786), // Rule ID 1346 //
     /*  60759 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  60765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60769 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60773 */   // (bitconvert:{ *:[v16i8] } VRRC:{ *:[f128] }:$src)  =>  VRRC:{ *:[v16i8] }:$src
     /*  60773 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60776 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60778 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60780 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60785 */   // GIR_Coverage, 1346,
     /*  60785 */   GIR_EraseRootFromParent_Done,
     /*  60786 */ // Label 826: @60786
     /*  60786 */ GIM_Reject,
     /*  60787 */ // Label 754: @60787
     /*  60787 */ GIM_Reject,
     /*  60788 */ // Label 12: @60788
     /*  60788 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 832*/ GIMT_Encode4(61062),
     /*  60799 */ /*GILLT_s32*//*Label 827*/ GIMT_Encode4(60819),
     /*  60803 */ /*GILLT_s64*//*Label 828*/ GIMT_Encode4(60912),
     /*  60807 */ /*GILLT_s128*//*Label 829*/ GIMT_Encode4(60960),
     /*  60811 */ /*GILLT_v2s64*//*Label 830*/ GIMT_Encode4(60991),
     /*  60815 */ /*GILLT_v4s32*//*Label 831*/ GIMT_Encode4(61014),
     /*  60819 */ // Label 827: @60819
     /*  60819 */ GIM_Try, /*On fail goto*//*Label 833*/ GIMT_Encode4(60911),
     /*  60824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  60827 */   GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(60891), // Rule ID 1713 //
     /*  60832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  60835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /*  60839 */     // (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$S)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSRDPIZ:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /*  60839 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  60842 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60846 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60851 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /*  60855 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  60860 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  60863 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSRDPIZ),
     /*  60867 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60872 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  60875 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60882 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60885 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /*  60890 */     // GIR_Coverage, 1713,
     /*  60890 */     GIR_EraseRootFromParent_Done,
     /*  60891 */   // Label 834: @60891
     /*  60891 */   GIM_Try, /*On fail goto*//*Label 835*/ GIMT_Encode4(60910), // Rule ID 150 //
     /*  60896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  60899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /*  60903 */     // (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$RB)  =>  (FRIZS:{ *:[f32] } f32:{ *:[f32] }:$RB)
     /*  60903 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FRIZS),
     /*  60908 */     GIR_RootConstrainSelectedInstOperands,
     /*  60909 */     // GIR_Coverage, 150,
     /*  60909 */     GIR_Done,
     /*  60910 */   // Label 835: @60910
     /*  60910 */   GIM_Reject,
     /*  60911 */ // Label 833: @60911
     /*  60911 */ GIM_Reject,
     /*  60912 */ // Label 828: @60912
     /*  60912 */ GIM_Try, /*On fail goto*//*Label 836*/ GIMT_Encode4(60959),
     /*  60917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  60920 */   GIM_Try, /*On fail goto*//*Label 837*/ GIMT_Encode4(60939), // Rule ID 915 //
     /*  60925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  60928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  60932 */     // (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$XB)  =>  (XSRDPIZ:{ *:[f64] } f64:{ *:[f64] }:$XB)
     /*  60932 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSRDPIZ),
     /*  60937 */     GIR_RootConstrainSelectedInstOperands,
     /*  60938 */     // GIR_Coverage, 915,
     /*  60938 */     GIR_Done,
     /*  60939 */   // Label 837: @60939
     /*  60939 */   GIM_Try, /*On fail goto*//*Label 838*/ GIMT_Encode4(60958), // Rule ID 148 //
     /*  60944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  60947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  60951 */     // (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$RB)  =>  (FRIZD:{ *:[f64] } f64:{ *:[f64] }:$RB)
     /*  60951 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FRIZD),
     /*  60956 */     GIR_RootConstrainSelectedInstOperands,
     /*  60957 */     // GIR_Coverage, 148,
     /*  60957 */     GIR_Done,
     /*  60958 */   // Label 838: @60958
     /*  60958 */   GIM_Reject,
     /*  60959 */ // Label 836: @60959
     /*  60959 */ GIM_Reject,
     /*  60960 */ // Label 829: @60960
     /*  60960 */ GIM_Try, /*On fail goto*//*Label 839*/ GIMT_Encode4(60990), // Rule ID 2164 //
     /*  60965 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  60968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  60971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60975 */   // (ftrunc:{ *:[f128] } f128:{ *:[f128] }:$vB)  =>  (XSRQPI:{ *:[f128] } 1:{ *:[i32] }, ?:{ *:[f128] }:$vB, 1:{ *:[i32] })
     /*  60975 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSRQPI),
     /*  60978 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VRT]
     /*  60980 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  60983 */   GIR_RootToRootCopy, /*OpIdx*/1, // vB
     /*  60985 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  60988 */   GIR_RootConstrainSelectedInstOperands,
     /*  60989 */   // GIR_Coverage, 2164,
     /*  60989 */   GIR_EraseRootFromParent_Done,
     /*  60990 */ // Label 839: @60990
     /*  60990 */ GIM_Reject,
     /*  60991 */ // Label 830: @60991
     /*  60991 */ GIM_Try, /*On fail goto*//*Label 840*/ GIMT_Encode4(61013), // Rule ID 923 //
     /*  60996 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  60999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  61002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  61006 */   // (ftrunc:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)  =>  (XVRDPIZ:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)
     /*  61006 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRDPIZ),
     /*  61011 */   GIR_RootConstrainSelectedInstOperands,
     /*  61012 */   // GIR_Coverage, 923,
     /*  61012 */   GIR_Done,
     /*  61013 */ // Label 840: @61013
     /*  61013 */ GIM_Reject,
     /*  61014 */ // Label 831: @61014
     /*  61014 */ GIM_Try, /*On fail goto*//*Label 841*/ GIMT_Encode4(61061),
     /*  61019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  61022 */   GIM_Try, /*On fail goto*//*Label 842*/ GIMT_Encode4(61041), // Rule ID 931 //
     /*  61027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  61030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  61034 */     // (ftrunc:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)  =>  (XVRSPIZ:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)
     /*  61034 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRSPIZ),
     /*  61039 */     GIR_RootConstrainSelectedInstOperands,
     /*  61040 */     // GIR_Coverage, 931,
     /*  61040 */     GIR_Done,
     /*  61041 */   // Label 842: @61041
     /*  61041 */   GIM_Try, /*On fail goto*//*Label 843*/ GIMT_Encode4(61060), // Rule ID 1421 //
     /*  61046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  61049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  61053 */     // (ftrunc:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$vA)  =>  (VRFIZ:{ *:[v4f32] } ?:{ *:[v4f32] }:$vA)
     /*  61053 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VRFIZ),
     /*  61058 */     GIR_RootConstrainSelectedInstOperands,
     /*  61059 */     // GIR_Coverage, 1421,
     /*  61059 */     GIR_Done,
     /*  61060 */   // Label 843: @61060
     /*  61060 */   GIM_Reject,
     /*  61061 */ // Label 841: @61061
     /*  61061 */ GIM_Reject,
     /*  61062 */ // Label 832: @61062
     /*  61062 */ GIM_Reject,
     /*  61063 */ // Label 13: @61063
     /*  61063 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 849*/ GIMT_Encode4(61312),
     /*  61074 */ /*GILLT_s32*//*Label 844*/ GIMT_Encode4(61094),
     /*  61078 */ /*GILLT_s64*//*Label 845*/ GIMT_Encode4(61187),
     /*  61082 */ /*GILLT_s128*//*Label 846*/ GIMT_Encode4(61235),
     /*  61086 */ /*GILLT_v2s64*//*Label 847*/ GIMT_Encode4(61266),
     /*  61090 */ /*GILLT_v4s32*//*Label 848*/ GIMT_Encode4(61289),
     /*  61094 */ // Label 844: @61094
     /*  61094 */ GIM_Try, /*On fail goto*//*Label 850*/ GIMT_Encode4(61186),
     /*  61099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  61102 */   GIM_Try, /*On fail goto*//*Label 851*/ GIMT_Encode4(61166), // Rule ID 1707 //
     /*  61107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  61110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /*  61114 */     // (fround:{ *:[f32] } f32:{ *:[f32] }:$S)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSRDPI:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /*  61114 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  61117 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61121 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61126 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /*  61130 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  61135 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  61138 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSRDPI),
     /*  61142 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61147 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61150 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61157 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61160 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /*  61165 */     // GIR_Coverage, 1707,
     /*  61165 */     GIR_EraseRootFromParent_Done,
     /*  61166 */   // Label 851: @61166
     /*  61166 */   GIM_Try, /*On fail goto*//*Label 852*/ GIMT_Encode4(61185), // Rule ID 142 //
     /*  61171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  61174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /*  61178 */     // (fround:{ *:[f32] } f32:{ *:[f32] }:$RB)  =>  (FRINS:{ *:[f32] } f32:{ *:[f32] }:$RB)
     /*  61178 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FRINS),
     /*  61183 */     GIR_RootConstrainSelectedInstOperands,
     /*  61184 */     // GIR_Coverage, 142,
     /*  61184 */     GIR_Done,
     /*  61185 */   // Label 852: @61185
     /*  61185 */   GIM_Reject,
     /*  61186 */ // Label 850: @61186
     /*  61186 */ GIM_Reject,
     /*  61187 */ // Label 845: @61187
     /*  61187 */ GIM_Try, /*On fail goto*//*Label 853*/ GIMT_Encode4(61234),
     /*  61192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  61195 */   GIM_Try, /*On fail goto*//*Label 854*/ GIMT_Encode4(61214), // Rule ID 909 //
     /*  61200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  61203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  61207 */     // (fround:{ *:[f64] } f64:{ *:[f64] }:$XB)  =>  (XSRDPI:{ *:[f64] } f64:{ *:[f64] }:$XB)
     /*  61207 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSRDPI),
     /*  61212 */     GIR_RootConstrainSelectedInstOperands,
     /*  61213 */     // GIR_Coverage, 909,
     /*  61213 */     GIR_Done,
     /*  61214 */   // Label 854: @61214
     /*  61214 */   GIM_Try, /*On fail goto*//*Label 855*/ GIMT_Encode4(61233), // Rule ID 140 //
     /*  61219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  61222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  61226 */     // (fround:{ *:[f64] } f64:{ *:[f64] }:$RB)  =>  (FRIND:{ *:[f64] } f64:{ *:[f64] }:$RB)
     /*  61226 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FRIND),
     /*  61231 */     GIR_RootConstrainSelectedInstOperands,
     /*  61232 */     // GIR_Coverage, 140,
     /*  61232 */     GIR_Done,
     /*  61233 */   // Label 855: @61233
     /*  61233 */   GIM_Reject,
     /*  61234 */ // Label 853: @61234
     /*  61234 */ GIM_Reject,
     /*  61235 */ // Label 846: @61235
     /*  61235 */ GIM_Try, /*On fail goto*//*Label 856*/ GIMT_Encode4(61265), // Rule ID 2162 //
     /*  61240 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  61243 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  61246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  61250 */   // (fround:{ *:[f128] } f128:{ *:[f128] }:$vB)  =>  (XSRQPI:{ *:[f128] } 0:{ *:[i32] }, ?:{ *:[f128] }:$vB, 0:{ *:[i32] })
     /*  61250 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSRQPI),
     /*  61253 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VRT]
     /*  61255 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61258 */   GIR_RootToRootCopy, /*OpIdx*/1, // vB
     /*  61260 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61263 */   GIR_RootConstrainSelectedInstOperands,
     /*  61264 */   // GIR_Coverage, 2162,
     /*  61264 */   GIR_EraseRootFromParent_Done,
     /*  61265 */ // Label 856: @61265
     /*  61265 */ GIM_Reject,
     /*  61266 */ // Label 847: @61266
     /*  61266 */ GIM_Try, /*On fail goto*//*Label 857*/ GIMT_Encode4(61288), // Rule ID 917 //
     /*  61271 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  61274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  61277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  61281 */   // (fround:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)  =>  (XVRDPI:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)
     /*  61281 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRDPI),
     /*  61286 */   GIR_RootConstrainSelectedInstOperands,
     /*  61287 */   // GIR_Coverage, 917,
     /*  61287 */   GIR_Done,
     /*  61288 */ // Label 857: @61288
     /*  61288 */ GIM_Reject,
     /*  61289 */ // Label 848: @61289
     /*  61289 */ GIM_Try, /*On fail goto*//*Label 858*/ GIMT_Encode4(61311), // Rule ID 925 //
     /*  61294 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  61297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  61300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  61304 */   // (fround:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)  =>  (XVRSPI:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)
     /*  61304 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRSPI),
     /*  61309 */   GIR_RootConstrainSelectedInstOperands,
     /*  61310 */   // GIR_Coverage, 925,
     /*  61310 */   GIR_Done,
     /*  61311 */ // Label 858: @61311
     /*  61311 */ GIM_Reject,
     /*  61312 */ // Label 849: @61312
     /*  61312 */ GIM_Reject,
     /*  61313 */ // Label 14: @61313
     /*  61313 */ GIM_Try, /*On fail goto*//*Label 859*/ GIMT_Encode4(61443),
     /*  61318 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  61321 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 862*/ GIMT_Encode4(61442),
     /*  61332 */   /*GILLT_s32*//*Label 860*/ GIMT_Encode4(61340),
     /*  61336 */   /*GILLT_s64*//*Label 861*/ GIMT_Encode4(61401),
     /*  61340 */   // Label 860: @61340
     /*  61340 */   GIM_Try, /*On fail goto*//*Label 863*/ GIMT_Encode4(61400), // Rule ID 2034 //
     /*  61345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /*  61348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  61352 */     // (lrint:{ *:[i64] } f32:{ *:[f32] }:$S)  =>  (MFVSRD:{ *:[i64] } (FCTID:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, F8RC:{ *:[i32] })))
     /*  61352 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  61355 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61359 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61364 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /*  61368 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::F8RCRegClassID),
     /*  61373 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  61376 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCTID),
     /*  61380 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61385 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61388 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRD),
     /*  61393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  61395 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61398 */     GIR_RootConstrainSelectedInstOperands,
     /*  61399 */     // GIR_Coverage, 2034,
     /*  61399 */     GIR_EraseRootFromParent_Done,
     /*  61400 */   // Label 863: @61400
     /*  61400 */   GIM_Reject,
     /*  61401 */   // Label 861: @61401
     /*  61401 */   GIM_Try, /*On fail goto*//*Label 864*/ GIMT_Encode4(61441), // Rule ID 2033 //
     /*  61406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /*  61409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  61413 */     // (lrint:{ *:[i64] } f64:{ *:[f64] }:$S)  =>  (MFVSRD:{ *:[i64] } (FCTID:{ *:[f64] } ?:{ *:[f64] }:$S))
     /*  61413 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  61416 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCTID),
     /*  61420 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61425 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // S
     /*  61429 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRD),
     /*  61434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  61436 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61439 */     GIR_RootConstrainSelectedInstOperands,
     /*  61440 */     // GIR_Coverage, 2033,
     /*  61440 */     GIR_EraseRootFromParent_Done,
     /*  61441 */   // Label 864: @61441
     /*  61441 */   GIM_Reject,
     /*  61442 */   // Label 862: @61442
     /*  61442 */   GIM_Reject,
     /*  61443 */ // Label 859: @61443
     /*  61443 */ GIM_Reject,
     /*  61444 */ // Label 15: @61444
     /*  61444 */ GIM_Try, /*On fail goto*//*Label 865*/ GIMT_Encode4(61574),
     /*  61449 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  61452 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 868*/ GIMT_Encode4(61573),
     /*  61463 */   /*GILLT_s32*//*Label 866*/ GIMT_Encode4(61471),
     /*  61467 */   /*GILLT_s64*//*Label 867*/ GIMT_Encode4(61532),
     /*  61471 */   // Label 866: @61471
     /*  61471 */   GIM_Try, /*On fail goto*//*Label 869*/ GIMT_Encode4(61531), // Rule ID 2036 //
     /*  61476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /*  61479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  61483 */     // (llrint:{ *:[i64] } f32:{ *:[f32] }:$S)  =>  (MFVSRD:{ *:[i64] } (FCTID:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, F8RC:{ *:[i32] })))
     /*  61483 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  61486 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61490 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61495 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /*  61499 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::F8RCRegClassID),
     /*  61504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  61507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCTID),
     /*  61511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61516 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61519 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRD),
     /*  61524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  61526 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61529 */     GIR_RootConstrainSelectedInstOperands,
     /*  61530 */     // GIR_Coverage, 2036,
     /*  61530 */     GIR_EraseRootFromParent_Done,
     /*  61531 */   // Label 869: @61531
     /*  61531 */   GIM_Reject,
     /*  61532 */   // Label 867: @61532
     /*  61532 */   GIM_Try, /*On fail goto*//*Label 870*/ GIMT_Encode4(61572), // Rule ID 2035 //
     /*  61537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /*  61540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  61544 */     // (llrint:{ *:[i64] } f64:{ *:[f64] }:$S)  =>  (MFVSRD:{ *:[i64] } (FCTID:{ *:[f64] } ?:{ *:[f64] }:$S))
     /*  61544 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  61547 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCTID),
     /*  61551 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61556 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // S
     /*  61560 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRD),
     /*  61565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  61567 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61570 */     GIR_RootConstrainSelectedInstOperands,
     /*  61571 */     // GIR_Coverage, 2035,
     /*  61571 */     GIR_EraseRootFromParent_Done,
     /*  61572 */   // Label 870: @61572
     /*  61572 */   GIM_Reject,
     /*  61573 */   // Label 868: @61573
     /*  61573 */   GIM_Reject,
     /*  61574 */ // Label 865: @61574
     /*  61574 */ GIM_Reject,
     /*  61575 */ // Label 16: @61575
     /*  61575 */ GIM_Try, /*On fail goto*//*Label 871*/ GIMT_Encode4(61594), // Rule ID 639 //
     /*  61580 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  61583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  61587 */   // (readcyclecounter:{ *:[i64] })  =>  (MFTB8:{ *:[i64] })
     /*  61587 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MFTB8),
     /*  61592 */   GIR_RootConstrainSelectedInstOperands,
     /*  61593 */   // GIR_Coverage, 639,
     /*  61593 */   GIR_Done,
     /*  61594 */ // Label 871: @61594
     /*  61594 */ GIM_Reject,
     /*  61595 */ // Label 17: @61595
     /*  61595 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 874*/ GIMT_Encode4(61670),
     /*  61606 */ /*GILLT_s32*//*Label 872*/ GIMT_Encode4(61614),
     /*  61610 */ /*GILLT_s64*//*Label 873*/ GIMT_Encode4(61642),
     /*  61614 */ // Label 872: @61614
     /*  61614 */ GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(61641), // Rule ID 1271 //
     /*  61619 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSYNC),
     /*  61622 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 7,
     /*  61626 */   // MIs[0] Operand 1
     /*  61626 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  61629 */   // (atomic_fence 7:{ *:[i32] }, (timm:{ *:[i32] }))  =>  (SYNC 0:{ *:[i32] })
     /*  61629 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SYNC),
     /*  61632 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61635 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  61639 */   GIR_RootConstrainSelectedInstOperands,
     /*  61640 */   // GIR_Coverage, 1271,
     /*  61640 */   GIR_EraseRootFromParent_Done,
     /*  61641 */ // Label 875: @61641
     /*  61641 */ GIM_Reject,
     /*  61642 */ // Label 873: @61642
     /*  61642 */ GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(61669), // Rule ID 1270 //
     /*  61647 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSYNC),
     /*  61650 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 7,
     /*  61654 */   // MIs[0] Operand 1
     /*  61654 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  61657 */   // (atomic_fence 7:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (SYNC 0:{ *:[i32] })
     /*  61657 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SYNC),
     /*  61660 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61663 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  61667 */   GIR_RootConstrainSelectedInstOperands,
     /*  61668 */   // GIR_Coverage, 1270,
     /*  61668 */   GIR_EraseRootFromParent_Done,
     /*  61669 */ // Label 876: @61669
     /*  61669 */ GIM_Reject,
     /*  61670 */ // Label 874: @61670
     /*  61670 */ GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(61719),
     /*  61675 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /*  61678 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  61681 */   GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(61701), // Rule ID 1272 //
     /*  61686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSYNC),
     /*  61689 */     // (atomic_fence (timm:{ *:[iPTR] }), (timm:{ *:[iPTR] }))  =>  (SYNC 1:{ *:[i32] })
     /*  61689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SYNC),
     /*  61692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  61695 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  61699 */     GIR_RootConstrainSelectedInstOperands,
     /*  61700 */     // GIR_Coverage, 1272,
     /*  61700 */     GIR_EraseRootFromParent_Done,
     /*  61701 */   // Label 878: @61701
     /*  61701 */   GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(61718), // Rule ID 1273 //
     /*  61706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasOnlyMSYNC),
     /*  61709 */     // (atomic_fence (timm:{ *:[iPTR] }), (timm:{ *:[iPTR] }))  =>  (MSYNC)
     /*  61709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MSYNC),
     /*  61712 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  61716 */     GIR_RootConstrainSelectedInstOperands,
     /*  61717 */     // GIR_Coverage, 1273,
     /*  61717 */     GIR_EraseRootFromParent_Done,
     /*  61718 */   // Label 879: @61718
     /*  61718 */   GIM_Reject,
     /*  61719 */ // Label 877: @61719
     /*  61719 */ GIM_Reject,
     /*  61720 */ // Label 18: @61720
     /*  61720 */ GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(61782),
     /*  61725 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /*  61728 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /*  61731 */   GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(61769), // Rule ID 17 //
     /*  61736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  61748 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  61752 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61756 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61758 */     // (brcond (xor:{ *:[i1] } i1:{ *:[i1] }:$BI, -1:{ *:[i1] }), (bb:{ *:[Other] }):$BD)  =>  (BCn i1:{ *:[i1] }:$BI, (bb:{ *:[Other] }):$BD)
     /*  61758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::BCn),
     /*  61761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // BI
     /*  61765 */     GIR_RootToRootCopy, /*OpIdx*/1, // BD
     /*  61767 */     GIR_RootConstrainSelectedInstOperands,
     /*  61768 */     // GIR_Coverage, 17,
     /*  61768 */     GIR_EraseRootFromParent_Done,
     /*  61769 */   // Label 881: @61769
     /*  61769 */   GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(61781), // Rule ID 16 //
     /*  61774 */     // (brcond i1:{ *:[i1] }:$BI, (bb:{ *:[Other] }):$BD)  =>  (BC i1:{ *:[i1] }:$BI, (bb:{ *:[Other] }):$BD)
     /*  61774 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::BC),
     /*  61779 */     GIR_RootConstrainSelectedInstOperands,
     /*  61780 */     // GIR_Coverage, 16,
     /*  61780 */     GIR_Done,
     /*  61781 */   // Label 882: @61781
     /*  61781 */   GIM_Reject,
     /*  61782 */ // Label 880: @61782
     /*  61782 */ GIM_Reject,
     /*  61783 */ // Label 19: @61783
     /*  61783 */ GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(61931),
     /*  61788 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /*  61791 */   GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(61818), // Rule ID 1167 //
     /*  61796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture),
     /*  61799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmsetdmrz),
     /*  61804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  61807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  61811 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10688:{ *:[iPTR] })  =>  (DMSETDMRZ:{ *:[v1024i1] })
     /*  61811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMSETDMRZ),
     /*  61814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  61816 */     GIR_RootConstrainSelectedInstOperands,
     /*  61817 */     // GIR_Coverage, 1167,
     /*  61817 */     GIR_EraseRootFromParent_Done,
     /*  61818 */   // Label 884: @61818
     /*  61818 */   GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(61845), // Rule ID 1172 //
     /*  61823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  61826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xxsetaccz),
     /*  61831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  61834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  61838 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10783:{ *:[iPTR] })  =>  (XXSETACCZ:{ *:[v512i1] })
     /*  61838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSETACCZ),
     /*  61841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  61843 */     GIR_RootConstrainSelectedInstOperands,
     /*  61844 */     // GIR_Coverage, 1172,
     /*  61844 */     GIR_EraseRootFromParent_Done,
     /*  61845 */   // Label 885: @61845
     /*  61845 */   GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(61872), // Rule ID 1173 //
     /*  61850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  61853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xxsetaccz),
     /*  61858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  61861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  61865 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10783:{ *:[iPTR] })  =>  (DMXXSETACCZ:{ *:[v512i1] })
     /*  61865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXXSETACCZ),
     /*  61868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  61870 */     GIR_RootConstrainSelectedInstOperands,
     /*  61871 */     // GIR_Coverage, 1173,
     /*  61871 */     GIR_EraseRootFromParent_Done,
     /*  61872 */   // Label 886: @61872
     /*  61872 */   GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(61896), // Rule ID 4906 //
     /*  61877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mfmsr),
     /*  61882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  61889 */     // (intrinsic_wo_chain:{ *:[i32] } 10679:{ *:[iPTR] })  =>  (MFMSR:{ *:[i32] })
     /*  61889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFMSR),
     /*  61892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  61894 */     GIR_RootConstrainSelectedInstOperands,
     /*  61895 */     // GIR_Coverage, 4906,
     /*  61895 */     GIR_EraseRootFromParent_Done,
     /*  61896 */   // Label 887: @61896
     /*  61896 */   GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(61930), // Rule ID 4907 //
     /*  61901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mftbu),
     /*  61906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  61913 */     // (intrinsic_wo_chain:{ *:[i32] } 10681:{ *:[iPTR] })  =>  (MFTB:{ *:[i32] } 269:{ *:[i32] })
     /*  61913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFTB),
     /*  61916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  61918 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(269),
     /*  61928 */     GIR_RootConstrainSelectedInstOperands,
     /*  61929 */     // GIR_Coverage, 4907,
     /*  61929 */     GIR_EraseRootFromParent_Done,
     /*  61930 */   // Label 888: @61930
     /*  61930 */   GIM_Reject,
     /*  61931 */ // Label 883: @61931
     /*  61931 */ GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(65642),
     /*  61936 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  61939 */   GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(61975), // Rule ID 1755 //
     /*  61944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  61947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_frsqrte),
     /*  61952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  61955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  61958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  61962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  61966 */     // (intrinsic_wo_chain:{ *:[f64] } 10650:{ *:[iPTR] }, vsfrc:{ *:[f64] }:$XB)  =>  (XSRSQRTEDP:{ *:[f64] } ?:{ *:[f64] }:$XB)
     /*  61966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSRSQRTEDP),
     /*  61969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  61971 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  61973 */     GIR_RootConstrainSelectedInstOperands,
     /*  61974 */     // GIR_Coverage, 1755,
     /*  61974 */     GIR_EraseRootFromParent_Done,
     /*  61975 */   // Label 890: @61975
     /*  61975 */   GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(62011), // Rule ID 1946 //
     /*  61980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  61983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_frsqrtes),
     /*  61988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /*  61998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /*  62002 */     // (intrinsic_wo_chain:{ *:[f32] } 10651:{ *:[iPTR] }, vssrc:{ *:[f32] }:$XB)  =>  (XSRSQRTESP:{ *:[f32] } ?:{ *:[f32] }:$XB)
     /*  62002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSRSQRTESP),
     /*  62005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62007 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62009 */     GIR_RootConstrainSelectedInstOperands,
     /*  62010 */     // GIR_Coverage, 1946,
     /*  62010 */     GIR_EraseRootFromParent_Done,
     /*  62011 */   // Label 891: @62011
     /*  62011 */   GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(62043), // Rule ID 876 //
     /*  62016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvdpsp),
     /*  62024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62034 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10879:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$XB)  =>  (XVCVDPSP:{ *:[v4f32] } v2f64:{ *:[v2f64] }:$XB)
     /*  62034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVDPSP),
     /*  62037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62039 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62041 */     GIR_RootConstrainSelectedInstOperands,
     /*  62042 */     // GIR_Coverage, 876,
     /*  62042 */     GIR_EraseRootFromParent_Done,
     /*  62043 */   // Label 892: @62043
     /*  62043 */   GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(62075), // Rule ID 879 //
     /*  62048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvdpsxws),
     /*  62056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62066 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10880:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$XB)  =>  (XVCVDPSXWS:{ *:[v4i32] } v2f64:{ *:[v2f64] }:$XB)
     /*  62066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVDPSXWS),
     /*  62069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62071 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62073 */     GIR_RootConstrainSelectedInstOperands,
     /*  62074 */     // GIR_Coverage, 879,
     /*  62074 */     GIR_EraseRootFromParent_Done,
     /*  62075 */   // Label 893: @62075
     /*  62075 */   GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(62107), // Rule ID 882 //
     /*  62080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvdpuxws),
     /*  62088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62098 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10881:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$XB)  =>  (XVCVDPUXWS:{ *:[v4i32] } v2f64:{ *:[v2f64] }:$XB)
     /*  62098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVDPUXWS),
     /*  62101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62103 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62105 */     GIR_RootConstrainSelectedInstOperands,
     /*  62106 */     // GIR_Coverage, 882,
     /*  62106 */     GIR_EraseRootFromParent_Done,
     /*  62107 */   // Label 894: @62107
     /*  62107 */   GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(62139), // Rule ID 883 //
     /*  62112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvspdp),
     /*  62120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  62123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62130 */     // (intrinsic_wo_chain:{ *:[v2f64] } 10884:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$XB)  =>  (XVCVSPDP:{ *:[v2f64] } v4f32:{ *:[v4f32] }:$XB)
     /*  62130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVSPDP),
     /*  62133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62135 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62137 */     GIR_RootConstrainSelectedInstOperands,
     /*  62138 */     // GIR_Coverage, 883,
     /*  62138 */     GIR_EraseRootFromParent_Done,
     /*  62139 */   // Label 895: @62139
     /*  62139 */   GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(62171), // Rule ID 884 //
     /*  62144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvspsxds),
     /*  62152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  62155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62162 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10886:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$XB)  =>  (XVCVSPSXDS:{ *:[v2i64] } v4f32:{ *:[v4f32] }:$XB)
     /*  62162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVSPSXDS),
     /*  62165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62167 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62169 */     GIR_RootConstrainSelectedInstOperands,
     /*  62170 */     // GIR_Coverage, 884,
     /*  62170 */     GIR_EraseRootFromParent_Done,
     /*  62171 */   // Label 896: @62171
     /*  62171 */   GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(62203), // Rule ID 887 //
     /*  62176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvspuxds),
     /*  62184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  62187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62194 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10887:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$XB)  =>  (XVCVSPUXDS:{ *:[v2i64] } v4f32:{ *:[v4f32] }:$XB)
     /*  62194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVSPUXDS),
     /*  62197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62199 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62201 */     GIR_RootConstrainSelectedInstOperands,
     /*  62202 */     // GIR_Coverage, 887,
     /*  62202 */     GIR_EraseRootFromParent_Done,
     /*  62203 */   // Label 897: @62203
     /*  62203 */   GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(62235), // Rule ID 892 //
     /*  62208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvsxdsp),
     /*  62216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62226 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10888:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$XB)  =>  (XVCVSXDSP:{ *:[v4f32] } v2i64:{ *:[v2i64] }:$XB)
     /*  62226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVSXDSP),
     /*  62229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62231 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62233 */     GIR_RootConstrainSelectedInstOperands,
     /*  62234 */     // GIR_Coverage, 892,
     /*  62234 */     GIR_EraseRootFromParent_Done,
     /*  62235 */   // Label 898: @62235
     /*  62235 */   GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(62267), // Rule ID 897 //
     /*  62240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvuxdsp),
     /*  62248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62258 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10890:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$XB)  =>  (XVCVUXDSP:{ *:[v4f32] } v2i64:{ *:[v2i64] }:$XB)
     /*  62258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVUXDSP),
     /*  62261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62263 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62265 */     GIR_RootConstrainSelectedInstOperands,
     /*  62266 */     // GIR_Coverage, 897,
     /*  62266 */     GIR_EraseRootFromParent_Done,
     /*  62267 */   // Label 899: @62267
     /*  62267 */   GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(62299), // Rule ID 900 //
     /*  62272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvsxwdp),
     /*  62280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  62283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62290 */     // (intrinsic_wo_chain:{ *:[v2f64] } 10889:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$XB)  =>  (XVCVSXWDP:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$XB)
     /*  62290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVSXWDP),
     /*  62293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62295 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62297 */     GIR_RootConstrainSelectedInstOperands,
     /*  62298 */     // GIR_Coverage, 900,
     /*  62298 */     GIR_EraseRootFromParent_Done,
     /*  62299 */   // Label 900: @62299
     /*  62299 */   GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(62331), // Rule ID 901 //
     /*  62304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvuxwdp),
     /*  62312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  62315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62322 */     // (intrinsic_wo_chain:{ *:[v2f64] } 10891:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$XB)  =>  (XVCVUXWDP:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$XB)
     /*  62322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVUXWDP),
     /*  62325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62327 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62329 */     GIR_RootConstrainSelectedInstOperands,
     /*  62330 */     // GIR_Coverage, 901,
     /*  62330 */     GIR_EraseRootFromParent_Done,
     /*  62331 */   // Label 901: @62331
     /*  62331 */   GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(62363), // Rule ID 1009 //
     /*  62336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  62339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_sqrtf128_round_to_odd),
     /*  62344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  62347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  62350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  62354 */     // (intrinsic_wo_chain:{ *:[f128] } 10815:{ *:[iPTR] }, f128:{ *:[f128] }:$RB)  =>  (XSSQRTQPO:{ *:[f128] } f128:{ *:[f128] }:$RB)
     /*  62354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSSQRTQPO),
     /*  62357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  62359 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  62361 */     GIR_RootConstrainSelectedInstOperands,
     /*  62362 */     // GIR_Coverage, 1009,
     /*  62362 */     GIR_EraseRootFromParent_Done,
     /*  62363 */   // Label 902: @62363
     /*  62363 */   GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(62395), // Rule ID 1016 //
     /*  62368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  62371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_truncf128_round_to_odd),
     /*  62376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  62379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  62382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VFRCRegClassID),
     /*  62386 */     // (intrinsic_wo_chain:{ *:[f64] } 10842:{ *:[iPTR] }, f128:{ *:[f128] }:$RB)  =>  (XSCVQPDPO:{ *:[f64] } f128:{ *:[f128] }:$RB)
     /*  62386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVQPDPO),
     /*  62389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  62391 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  62393 */     GIR_RootConstrainSelectedInstOperands,
     /*  62394 */     // GIR_Coverage, 1016,
     /*  62394 */     GIR_EraseRootFromParent_Done,
     /*  62395 */   // Label 903: @62395
     /*  62395 */   GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(62427), // Rule ID 1025 //
     /*  62400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  62403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvsphp),
     /*  62408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62418 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10885:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$XB)  =>  (XVCVSPHP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)
     /*  62418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVSPHP),
     /*  62421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62423 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62425 */     GIR_RootConstrainSelectedInstOperands,
     /*  62426 */     // GIR_Coverage, 1025,
     /*  62426 */     GIR_EraseRootFromParent_Done,
     /*  62427 */   // Label 904: @62427
     /*  62427 */   GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(62459), // Rule ID 1029 //
     /*  62432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  62435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvxexpdp),
     /*  62440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  62443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62450 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10913:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$XB)  =>  (XVXEXPDP:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$XB)
     /*  62450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVXEXPDP),
     /*  62453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62455 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62457 */     GIR_RootConstrainSelectedInstOperands,
     /*  62458 */     // GIR_Coverage, 1029,
     /*  62458 */     GIR_EraseRootFromParent_Done,
     /*  62459 */   // Label 905: @62459
     /*  62459 */   GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(62491), // Rule ID 1030 //
     /*  62464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  62467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvxexpsp),
     /*  62472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62482 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10914:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$XB)  =>  (XVXEXPSP:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$XB)
     /*  62482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVXEXPSP),
     /*  62485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62487 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62489 */     GIR_RootConstrainSelectedInstOperands,
     /*  62490 */     // GIR_Coverage, 1030,
     /*  62490 */     GIR_EraseRootFromParent_Done,
     /*  62491 */   // Label 906: @62491
     /*  62491 */   GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(62523), // Rule ID 1031 //
     /*  62496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  62499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvxsigdp),
     /*  62504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  62507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62514 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10915:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$XB)  =>  (XVXSIGDP:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$XB)
     /*  62514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVXSIGDP),
     /*  62517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62519 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62521 */     GIR_RootConstrainSelectedInstOperands,
     /*  62522 */     // GIR_Coverage, 1031,
     /*  62522 */     GIR_EraseRootFromParent_Done,
     /*  62523 */   // Label 907: @62523
     /*  62523 */   GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(62555), // Rule ID 1032 //
     /*  62528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  62531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvxsigsp),
     /*  62536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62546 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10916:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$XB)  =>  (XVXSIGSP:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$XB)
     /*  62546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVXSIGSP),
     /*  62549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62551 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62553 */     GIR_RootConstrainSelectedInstOperands,
     /*  62554 */     // GIR_Coverage, 1032,
     /*  62554 */     GIR_EraseRootFromParent_Done,
     /*  62555 */   // Label 908: @62555
     /*  62555 */   GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(62610), // Rule ID 1663 //
     /*  62560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvtsqrtdp),
     /*  62568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  62571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  62578 */     // (intrinsic_wo_chain:{ *:[i32] } 10909:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (XVTSQRTDP:{ *:[i32] } ?:{ *:[v2f64] }:$A), GPRC:{ *:[i32] })
     /*  62578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  62581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XVTSQRTDP),
     /*  62585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62590 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  62594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  62596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  62599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62604 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  62609 */     // GIR_Coverage, 1663,
     /*  62609 */     GIR_EraseRootFromParent_Done,
     /*  62610 */   // Label 909: @62610
     /*  62610 */   GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(62665), // Rule ID 1664 //
     /*  62615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvtsqrtsp),
     /*  62623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  62626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  62633 */     // (intrinsic_wo_chain:{ *:[i32] } 10910:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (XVTSQRTSP:{ *:[i32] } ?:{ *:[v4f32] }:$A), GPRC:{ *:[i32] })
     /*  62633 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  62636 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XVTSQRTSP),
     /*  62640 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62645 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  62649 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  62651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  62654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62656 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62659 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  62664 */     // GIR_Coverage, 1664,
     /*  62664 */     GIR_EraseRootFromParent_Done,
     /*  62665 */   // Label 910: @62665
     /*  62665 */   GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(62697), // Rule ID 1665 //
     /*  62670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvresp),
     /*  62678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62688 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10902:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$A)  =>  (XVRESP:{ *:[v4f32] } ?:{ *:[v4f32] }:$A)
     /*  62688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVRESP),
     /*  62691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62693 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  62695 */     GIR_RootConstrainSelectedInstOperands,
     /*  62696 */     // GIR_Coverage, 1665,
     /*  62696 */     GIR_EraseRootFromParent_Done,
     /*  62697 */   // Label 911: @62697
     /*  62697 */   GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(62729), // Rule ID 1666 //
     /*  62702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvredp),
     /*  62710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  62713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62720 */     // (intrinsic_wo_chain:{ *:[v2f64] } 10901:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$A)  =>  (XVREDP:{ *:[v2f64] } ?:{ *:[v2f64] }:$A)
     /*  62720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVREDP),
     /*  62723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62725 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  62727 */     GIR_RootConstrainSelectedInstOperands,
     /*  62728 */     // GIR_Coverage, 1666,
     /*  62728 */     GIR_EraseRootFromParent_Done,
     /*  62729 */   // Label 912: @62729
     /*  62729 */   GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(62761), // Rule ID 1667 //
     /*  62734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvrsqrtesp),
     /*  62742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62752 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10905:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$A)  =>  (XVRSQRTESP:{ *:[v4f32] } ?:{ *:[v4f32] }:$A)
     /*  62752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVRSQRTESP),
     /*  62755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62757 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  62759 */     GIR_RootConstrainSelectedInstOperands,
     /*  62760 */     // GIR_Coverage, 1667,
     /*  62760 */     GIR_EraseRootFromParent_Done,
     /*  62761 */   // Label 913: @62761
     /*  62761 */   GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(62793), // Rule ID 1668 //
     /*  62766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvrsqrtedp),
     /*  62774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  62777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62784 */     // (intrinsic_wo_chain:{ *:[v2f64] } 10904:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$A)  =>  (XVRSQRTEDP:{ *:[v2f64] } ?:{ *:[v2f64] }:$A)
     /*  62784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVRSQRTEDP),
     /*  62787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62789 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  62791 */     GIR_RootConstrainSelectedInstOperands,
     /*  62792 */     // GIR_Coverage, 1668,
     /*  62792 */     GIR_EraseRootFromParent_Done,
     /*  62793 */   // Label 914: @62793
     /*  62793 */   GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(62825), // Rule ID 1754 //
     /*  62798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fre),
     /*  62806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  62809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  62812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  62816 */     // (intrinsic_wo_chain:{ *:[f64] } 10648:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (XSREDP:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  62816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSREDP),
     /*  62819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62821 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  62823 */     GIR_RootConstrainSelectedInstOperands,
     /*  62824 */     // GIR_Coverage, 1754,
     /*  62824 */     GIR_EraseRootFromParent_Done,
     /*  62825 */   // Label 915: @62825
     /*  62825 */   GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(62857), // Rule ID 1756 //
     /*  62830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fnabs),
     /*  62838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  62841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  62844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  62848 */     // (intrinsic_wo_chain:{ *:[f64] } 10643:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (XSNABSDP:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  62848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNABSDP),
     /*  62851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62853 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  62855 */     GIR_RootConstrainSelectedInstOperands,
     /*  62856 */     // GIR_Coverage, 1756,
     /*  62856 */     GIR_EraseRootFromParent_Done,
     /*  62857 */   // Label 916: @62857
     /*  62857 */   GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(62889), // Rule ID 1757 //
     /*  62862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fnabss),
     /*  62870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  62873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  62876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /*  62880 */     // (intrinsic_wo_chain:{ *:[f32] } 10644:{ *:[iPTR] }, f32:{ *:[f32] }:$A)  =>  (XSNABSDPs:{ *:[f32] } ?:{ *:[f32] }:$A)
     /*  62880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNABSDPs),
     /*  62883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62885 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  62887 */     GIR_RootConstrainSelectedInstOperands,
     /*  62888 */     // GIR_Coverage, 1757,
     /*  62888 */     GIR_EraseRootFromParent_Done,
     /*  62889 */   // Label 917: @62889
     /*  62889 */   GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(62921), // Rule ID 1941 //
     /*  62894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  62897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fres),
     /*  62902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  62905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  62908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /*  62912 */     // (intrinsic_wo_chain:{ *:[f32] } 10649:{ *:[iPTR] }, f32:{ *:[f32] }:$A)  =>  (XSRESP:{ *:[f32] } ?:{ *:[f32] }:$A)
     /*  62912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSRESP),
     /*  62915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62917 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  62919 */     GIR_RootConstrainSelectedInstOperands,
     /*  62920 */     // GIR_Coverage, 1941,
     /*  62920 */     GIR_EraseRootFromParent_Done,
     /*  62921 */   // Label 918: @62921
     /*  62921 */   GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(63005), // Rule ID 1942 //
     /*  62926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  62929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_extract_exp),
     /*  62934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  62937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  62940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  62944 */     // (intrinsic_wo_chain:{ *:[i32] } 10628:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (EXTRACT_SUBREG:{ *:[i32] } (XSXEXPDP:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f64] }:$A, VSFRC:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  62944 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  62947 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  62951 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62956 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  62960 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  62965 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  62968 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSXEXPDP),
     /*  62972 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62977 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  62980 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  62982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  62985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62987 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  62994 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  62999 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  63004 */     // GIR_Coverage, 1942,
     /*  63004 */     GIR_EraseRootFromParent_Done,
     /*  63005 */   // Label 919: @63005
     /*  63005 */   GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(63059), // Rule ID 1943 //
     /*  63010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  63013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_extract_sig),
     /*  63018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  63021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  63024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  63028 */     // (intrinsic_wo_chain:{ *:[i64] } 10629:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (XSXSIGDP:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f64] }:$A, VSFRC:{ *:[i32] }))
     /*  63028 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  63031 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  63035 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63040 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  63044 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  63049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSXSIGDP),
     /*  63052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  63054 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63057 */     GIR_RootConstrainSelectedInstOperands,
     /*  63058 */     // GIR_Coverage, 1943,
     /*  63058 */     GIR_EraseRootFromParent_Done,
     /*  63059 */   // Label 920: @63059
     /*  63059 */   GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(63113), // Rule ID 2158 //
     /*  63064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  63067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvhpsp),
     /*  63072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  63078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  63082 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10882:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$A)  =>  (XVCVHPSP:{ *:[v4f32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v8i16] }:$A, VSRC:{ *:[i32] }))
     /*  63082 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63085 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  63089 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63094 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  63098 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  63103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVHPSP),
     /*  63106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  63108 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63111 */     GIR_RootConstrainSelectedInstOperands,
     /*  63112 */     // GIR_Coverage, 2158,
     /*  63112 */     GIR_EraseRootFromParent_Done,
     /*  63113 */   // Label 921: @63113
     /*  63113 */   GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(63193), // Rule ID 2172 //
     /*  63118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  63121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_scalar_extract_expq),
     /*  63126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  63129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  63132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  63136 */     // (intrinsic_wo_chain:{ *:[i64] } 10806:{ *:[iPTR] }, f128:{ *:[f128] }:$vA)  =>  (MFVSRD:{ *:[i64] } (EXTRACT_SUBREG:{ *:[f64] } (XSXEXPQP:{ *:[v2i64] } ?:{ *:[f128] }:$vA), sub_64:{ *:[i32] }))
     /*  63136 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  63139 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSXEXPQP),
     /*  63143 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63148 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // vA
     /*  63152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  63154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  63157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  63161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63166 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_64),
     /*  63173 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VFRCRegClassID),
     /*  63178 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRD),
     /*  63186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  63188 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63191 */     GIR_RootConstrainSelectedInstOperands,
     /*  63192 */     // GIR_Coverage, 2172,
     /*  63192 */     GIR_EraseRootFromParent_Done,
     /*  63193 */   // Label 922: @63193
     /*  63193 */   GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(63236), // Rule ID 1097 //
     /*  63198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  63201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_mtvsrbm),
     /*  63206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  63209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  63212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  63220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63224 */     // MIs[1] Operand 1
     /*  63224 */     // No operand predicates
     /*  63224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63226 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10293:{ *:[iPTR] }, (imm:{ *:[i64] }):$D)  =>  (MTVSRBMI:{ *:[v16i8] } (imm:{ *:[i64] }):$D)
     /*  63226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTVSRBMI),
     /*  63229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  63231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // D
     /*  63234 */     GIR_RootConstrainSelectedInstOperands,
     /*  63235 */     // GIR_Coverage, 1097,
     /*  63235 */     GIR_EraseRootFromParent_Done,
     /*  63236 */   // Label 923: @63236
     /*  63236 */   GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(63269), // Rule ID 4858 //
     /*  63241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_frsqrte),
     /*  63246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  63249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  63252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  63256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  63260 */     // (intrinsic_wo_chain:{ *:[f64] } 10650:{ *:[iPTR] }, f8rc:{ *:[f64] }:$frB)  =>  (FRSQRTE:{ *:[f64] } ?:{ *:[f64] }:$frB)
     /*  63260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FRSQRTE),
     /*  63263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  63265 */     GIR_RootToRootCopy, /*OpIdx*/2, // frB
     /*  63267 */     GIR_RootConstrainSelectedInstOperands,
     /*  63268 */     // GIR_Coverage, 4858,
     /*  63268 */     GIR_EraseRootFromParent_Done,
     /*  63269 */   // Label 924: @63269
     /*  63269 */   GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(63302), // Rule ID 4859 //
     /*  63274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_frsqrtes),
     /*  63279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  63282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /*  63289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /*  63293 */     // (intrinsic_wo_chain:{ *:[f32] } 10651:{ *:[iPTR] }, f4rc:{ *:[f32] }:$frB)  =>  (FRSQRTES:{ *:[f32] } ?:{ *:[f32] }:$frB)
     /*  63293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FRSQRTES),
     /*  63296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  63298 */     GIR_RootToRootCopy, /*OpIdx*/2, // frB
     /*  63300 */     GIR_RootConstrainSelectedInstOperands,
     /*  63301 */     // GIR_Coverage, 4859,
     /*  63301 */     GIR_EraseRootFromParent_Done,
     /*  63302 */   // Label 925: @63302
     /*  63302 */   GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(63331), // Rule ID 73 //
     /*  63307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_popcntb),
     /*  63312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  63315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  63322 */     // (intrinsic_wo_chain:{ *:[i32] } 10801:{ *:[iPTR] }, i32:{ *:[i32] }:$RST)  =>  (POPCNTB:{ *:[i32] } i32:{ *:[i32] }:$RST)
     /*  63322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::POPCNTB),
     /*  63325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  63327 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  63329 */     GIR_RootConstrainSelectedInstOperands,
     /*  63330 */     // GIR_Coverage, 73,
     /*  63330 */     GIR_EraseRootFromParent_Done,
     /*  63331 */   // Label 926: @63331
     /*  63331 */   GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(63360), // Rule ID 74 //
     /*  63336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_cdtbcd),
     /*  63341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  63344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  63351 */     // (intrinsic_wo_chain:{ *:[i32] } 10587:{ *:[iPTR] }, i32:{ *:[i32] }:$RST)  =>  (CDTBCD:{ *:[i32] } i32:{ *:[i32] }:$RST)
     /*  63351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CDTBCD),
     /*  63354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  63356 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  63358 */     GIR_RootConstrainSelectedInstOperands,
     /*  63359 */     // GIR_Coverage, 74,
     /*  63359 */     GIR_EraseRootFromParent_Done,
     /*  63360 */   // Label 927: @63360
     /*  63360 */   GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(63389), // Rule ID 75 //
     /*  63365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_cbcdtd),
     /*  63370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  63373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  63380 */     // (intrinsic_wo_chain:{ *:[i32] } 10585:{ *:[iPTR] }, i32:{ *:[i32] }:$RST)  =>  (CBCDTD:{ *:[i32] } i32:{ *:[i32] }:$RST)
     /*  63380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CBCDTD),
     /*  63383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  63385 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  63387 */     GIR_RootConstrainSelectedInstOperands,
     /*  63388 */     // GIR_Coverage, 75,
     /*  63388 */     GIR_EraseRootFromParent_Done,
     /*  63389 */   // Label 928: @63389
     /*  63389 */   GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(63421), // Rule ID 321 //
     /*  63394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vexptefp),
     /*  63402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63412 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10400:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB)  =>  (VEXPTEFP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VB)
     /*  63412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXPTEFP),
     /*  63415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63417 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63419 */     GIR_RootConstrainSelectedInstOperands,
     /*  63420 */     // GIR_Coverage, 321,
     /*  63420 */     GIR_EraseRootFromParent_Done,
     /*  63421 */   // Label 929: @63421
     /*  63421 */   GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(63453), // Rule ID 322 //
     /*  63426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vlogefp),
     /*  63434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63444 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10438:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB)  =>  (VLOGEFP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VB)
     /*  63444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VLOGEFP),
     /*  63447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63449 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63451 */     GIR_RootConstrainSelectedInstOperands,
     /*  63452 */     // GIR_Coverage, 322,
     /*  63452 */     GIR_EraseRootFromParent_Done,
     /*  63453 */   // Label 930: @63453
     /*  63453 */   GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(63485), // Rule ID 363 //
     /*  63458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrefp),
     /*  63466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63476 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10506:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB)  =>  (VREFP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VB)
     /*  63476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VREFP),
     /*  63479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63481 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63483 */     GIR_RootConstrainSelectedInstOperands,
     /*  63484 */     // GIR_Coverage, 363,
     /*  63484 */     GIR_EraseRootFromParent_Done,
     /*  63485 */   // Label 931: @63485
     /*  63485 */   GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(63517), // Rule ID 364 //
     /*  63490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrfim),
     /*  63498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63508 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10507:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB)  =>  (VRFIM:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VB)
     /*  63508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRFIM),
     /*  63511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63513 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63515 */     GIR_RootConstrainSelectedInstOperands,
     /*  63516 */     // GIR_Coverage, 364,
     /*  63516 */     GIR_EraseRootFromParent_Done,
     /*  63517 */   // Label 932: @63517
     /*  63517 */   GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(63549), // Rule ID 365 //
     /*  63522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrfin),
     /*  63530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63540 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10508:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB)  =>  (VRFIN:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VB)
     /*  63540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRFIN),
     /*  63543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63545 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63547 */     GIR_RootConstrainSelectedInstOperands,
     /*  63548 */     // GIR_Coverage, 365,
     /*  63548 */     GIR_EraseRootFromParent_Done,
     /*  63549 */   // Label 933: @63549
     /*  63549 */   GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(63581), // Rule ID 366 //
     /*  63554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrfip),
     /*  63562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63572 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10509:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB)  =>  (VRFIP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VB)
     /*  63572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRFIP),
     /*  63575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63577 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63579 */     GIR_RootConstrainSelectedInstOperands,
     /*  63580 */     // GIR_Coverage, 366,
     /*  63580 */     GIR_EraseRootFromParent_Done,
     /*  63581 */   // Label 934: @63581
     /*  63581 */   GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(63613), // Rule ID 367 //
     /*  63586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrfiz),
     /*  63594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63604 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10510:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB)  =>  (VRFIZ:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VB)
     /*  63604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRFIZ),
     /*  63607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63609 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63611 */     GIR_RootConstrainSelectedInstOperands,
     /*  63612 */     // GIR_Coverage, 367,
     /*  63612 */     GIR_EraseRootFromParent_Done,
     /*  63613 */   // Label 935: @63613
     /*  63613 */   GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(63645), // Rule ID 368 //
     /*  63618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrsqrtefp),
     /*  63626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63636 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10521:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB)  =>  (VRSQRTEFP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VB)
     /*  63636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRSQRTEFP),
     /*  63639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63641 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63643 */     GIR_RootConstrainSelectedInstOperands,
     /*  63644 */     // GIR_Coverage, 368,
     /*  63644 */     GIR_EraseRootFromParent_Done,
     /*  63645 */   // Label 936: @63645
     /*  63645 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(63677), // Rule ID 419 //
     /*  63650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vupkhpx),
     /*  63658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  63664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63668 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10563:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VB)  =>  (VUPKHPX:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$VB)
     /*  63668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VUPKHPX),
     /*  63671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63673 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63675 */     GIR_RootConstrainSelectedInstOperands,
     /*  63676 */     // GIR_Coverage, 419,
     /*  63676 */     GIR_EraseRootFromParent_Done,
     /*  63677 */   // Label 937: @63677
     /*  63677 */   GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(63709), // Rule ID 420 //
     /*  63682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vupkhsb),
     /*  63690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  63696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63700 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10564:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB)  =>  (VUPKHSB:{ *:[v8i16] } v16i8:{ *:[v16i8] }:$VB)
     /*  63700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VUPKHSB),
     /*  63703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63705 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63707 */     GIR_RootConstrainSelectedInstOperands,
     /*  63708 */     // GIR_Coverage, 420,
     /*  63708 */     GIR_EraseRootFromParent_Done,
     /*  63709 */   // Label 938: @63709
     /*  63709 */   GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(63741), // Rule ID 421 //
     /*  63714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vupkhsh),
     /*  63722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  63728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63732 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10565:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VB)  =>  (VUPKHSH:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$VB)
     /*  63732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VUPKHSH),
     /*  63735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63737 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63739 */     GIR_RootConstrainSelectedInstOperands,
     /*  63740 */     // GIR_Coverage, 421,
     /*  63740 */     GIR_EraseRootFromParent_Done,
     /*  63741 */   // Label 939: @63741
     /*  63741 */   GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(63773), // Rule ID 422 //
     /*  63746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vupklpx),
     /*  63754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  63760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63764 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10567:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VB)  =>  (VUPKLPX:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$VB)
     /*  63764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VUPKLPX),
     /*  63767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63769 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63771 */     GIR_RootConstrainSelectedInstOperands,
     /*  63772 */     // GIR_Coverage, 422,
     /*  63772 */     GIR_EraseRootFromParent_Done,
     /*  63773 */   // Label 940: @63773
     /*  63773 */   GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(63805), // Rule ID 423 //
     /*  63778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vupklsb),
     /*  63786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  63792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63796 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10568:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB)  =>  (VUPKLSB:{ *:[v8i16] } v16i8:{ *:[v16i8] }:$VB)
     /*  63796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VUPKLSB),
     /*  63799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63801 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63803 */     GIR_RootConstrainSelectedInstOperands,
     /*  63804 */     // GIR_Coverage, 423,
     /*  63804 */     GIR_EraseRootFromParent_Done,
     /*  63805 */   // Label 941: @63805
     /*  63805 */   GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(63837), // Rule ID 424 //
     /*  63810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vupklsh),
     /*  63818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  63824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63828 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10569:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VB)  =>  (VUPKLSH:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$VB)
     /*  63828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VUPKLSH),
     /*  63831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63833 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63835 */     GIR_RootConstrainSelectedInstOperands,
     /*  63836 */     // GIR_Coverage, 424,
     /*  63836 */     GIR_EraseRootFromParent_Done,
     /*  63837 */   // Label 942: @63837
     /*  63837 */   GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(63869), // Rule ID 504 //
     /*  63842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  63845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vupkhsw),
     /*  63850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  63853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63860 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10566:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB)  =>  (VUPKHSW:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$VB)
     /*  63860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VUPKHSW),
     /*  63863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63865 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63867 */     GIR_RootConstrainSelectedInstOperands,
     /*  63868 */     // GIR_Coverage, 504,
     /*  63868 */     GIR_EraseRootFromParent_Done,
     /*  63869 */   // Label 943: @63869
     /*  63869 */   GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(63901), // Rule ID 505 //
     /*  63874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  63877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vupklsw),
     /*  63882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  63885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63892 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10570:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB)  =>  (VUPKLSW:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$VB)
     /*  63892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VUPKLSW),
     /*  63895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63897 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63899 */     GIR_RootConstrainSelectedInstOperands,
     /*  63900 */     // GIR_Coverage, 505,
     /*  63900 */     GIR_EraseRootFromParent_Done,
     /*  63901 */   // Label 944: @63901
     /*  63901 */   GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(63933), // Rule ID 506 //
     /*  63906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  63909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vgbbd),
     /*  63914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  63917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  63920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63924 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10420:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB)  =>  (VGBBD:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VB)
     /*  63924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VGBBD),
     /*  63927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63929 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63931 */     GIR_RootConstrainSelectedInstOperands,
     /*  63932 */     // GIR_Coverage, 506,
     /*  63932 */     GIR_EraseRootFromParent_Done,
     /*  63933 */   // Label 945: @63933
     /*  63933 */   GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(63965), // Rule ID 514 //
     /*  63938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Crypto),
     /*  63941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vsbox),
     /*  63946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  63949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  63952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63956 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10275:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA)  =>  (VSBOX:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA)
     /*  63956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSBOX),
     /*  63959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63961 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  63963 */     GIR_RootConstrainSelectedInstOperands,
     /*  63964 */     // GIR_Coverage, 514,
     /*  63964 */     GIR_EraseRootFromParent_Done,
     /*  63965 */   // Label 946: @63965
     /*  63965 */   GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(63997), // Rule ID 530 //
     /*  63970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  63973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vclzlsbb),
     /*  63978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  63981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  63984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  63988 */     // (intrinsic_wo_chain:{ *:[i32] } 10330:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB)  =>  (VCLZLSBB:{ *:[i32] } v16i8:{ *:[v16i8] }:$VB)
     /*  63988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCLZLSBB),
     /*  63991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63993 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63995 */     GIR_RootConstrainSelectedInstOperands,
     /*  63996 */     // GIR_Coverage, 530,
     /*  63996 */     GIR_EraseRootFromParent_Done,
     /*  63997 */   // Label 947: @63997
     /*  63997 */   GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(64029), // Rule ID 531 //
     /*  64002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  64005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vctzlsbb),
     /*  64010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  64016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  64020 */     // (intrinsic_wo_chain:{ *:[i32] } 10388:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB)  =>  (VCTZLSBB:{ *:[i32] } v16i8:{ *:[v16i8] }:$VB)
     /*  64020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCTZLSBB),
     /*  64023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64025 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64027 */     GIR_RootConstrainSelectedInstOperands,
     /*  64028 */     // GIR_Coverage, 531,
     /*  64028 */     GIR_EraseRootFromParent_Done,
     /*  64029 */   // Label 948: @64029
     /*  64029 */   GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(64061), // Rule ID 536 //
     /*  64034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  64037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextsb2w),
     /*  64042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  64048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64052 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10415:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB)  =>  (VEXTSB2W:{ *:[v4i32] } v16i8:{ *:[v16i8] }:$VB)
     /*  64052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTSB2W),
     /*  64055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64057 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64059 */     GIR_RootConstrainSelectedInstOperands,
     /*  64060 */     // GIR_Coverage, 536,
     /*  64060 */     GIR_EraseRootFromParent_Done,
     /*  64061 */   // Label 949: @64061
     /*  64061 */   GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(64093), // Rule ID 537 //
     /*  64066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  64069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextsh2w),
     /*  64074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  64080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64084 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10418:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VB)  =>  (VEXTSH2W:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$VB)
     /*  64084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTSH2W),
     /*  64087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64089 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64091 */     GIR_RootConstrainSelectedInstOperands,
     /*  64092 */     // GIR_Coverage, 537,
     /*  64092 */     GIR_EraseRootFromParent_Done,
     /*  64093 */   // Label 950: @64093
     /*  64093 */   GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(64125), // Rule ID 538 //
     /*  64098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  64101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextsb2d),
     /*  64106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  64109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  64112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64116 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10414:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB)  =>  (VEXTSB2D:{ *:[v2i64] } v16i8:{ *:[v16i8] }:$VB)
     /*  64116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTSB2D),
     /*  64119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64121 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64123 */     GIR_RootConstrainSelectedInstOperands,
     /*  64124 */     // GIR_Coverage, 538,
     /*  64124 */     GIR_EraseRootFromParent_Done,
     /*  64125 */   // Label 951: @64125
     /*  64125 */   GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(64157), // Rule ID 539 //
     /*  64130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  64133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextsh2d),
     /*  64138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  64141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  64144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64148 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10417:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VB)  =>  (VEXTSH2D:{ *:[v2i64] } v8i16:{ *:[v8i16] }:$VB)
     /*  64148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTSH2D),
     /*  64151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64153 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64155 */     GIR_RootConstrainSelectedInstOperands,
     /*  64156 */     // GIR_Coverage, 539,
     /*  64156 */     GIR_EraseRootFromParent_Done,
     /*  64157 */   // Label 952: @64157
     /*  64157 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(64189), // Rule ID 540 //
     /*  64162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  64165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextsw2d),
     /*  64170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  64173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64180 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10419:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB)  =>  (VEXTSW2D:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$VB)
     /*  64180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTSW2D),
     /*  64183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64185 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64187 */     GIR_RootConstrainSelectedInstOperands,
     /*  64188 */     // GIR_Coverage, 540,
     /*  64188 */     GIR_EraseRootFromParent_Done,
     /*  64189 */   // Label 953: @64189
     /*  64189 */   GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(64221), // Rule ID 543 //
     /*  64194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  64197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vprtybw),
     /*  64202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64212 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10505:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB)  =>  (VPRTYBW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB)
     /*  64212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPRTYBW),
     /*  64215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64217 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64219 */     GIR_RootConstrainSelectedInstOperands,
     /*  64220 */     // GIR_Coverage, 543,
     /*  64220 */     GIR_EraseRootFromParent_Done,
     /*  64221 */   // Label 954: @64221
     /*  64221 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(64253), // Rule ID 544 //
     /*  64226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  64229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vprtybd),
     /*  64234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  64237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64244 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10503:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VB)  =>  (VPRTYBD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VB)
     /*  64244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPRTYBD),
     /*  64247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64249 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64251 */     GIR_RootConstrainSelectedInstOperands,
     /*  64252 */     // GIR_Coverage, 544,
     /*  64252 */     GIR_EraseRootFromParent_Done,
     /*  64253 */   // Label 955: @64253
     /*  64253 */   GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(64285), // Rule ID 545 //
     /*  64258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  64261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vprtybq),
     /*  64266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  64269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  64272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64276 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10504:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$VB)  =>  (VPRTYBQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VB)
     /*  64276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPRTYBQ),
     /*  64279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64281 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64283 */     GIR_RootConstrainSelectedInstOperands,
     /*  64284 */     // GIR_Coverage, 545,
     /*  64284 */     GIR_EraseRootFromParent_Done,
     /*  64285 */   // Label 956: @64285
     /*  64285 */   GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(64320), // Rule ID 555 //
     /*  64290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  64293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_packed2national),
     /*  64298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  64301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  64304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64308 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10797:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB)  =>  (BCDCTN_rec:{ *:[v16i8] }:{ *:[i32] } v16i8:{ *:[v16i8] }:$VB)
     /*  64308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::BCDCTN_rec),
     /*  64311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64313 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64315 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR6*/0,
     /*  64318 */     GIR_RootConstrainSelectedInstOperands,
     /*  64319 */     // GIR_Coverage, 555,
     /*  64319 */     GIR_EraseRootFromParent_Done,
     /*  64320 */   // Label 957: @64320
     /*  64320 */   GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(64349), // Rule ID 693 //
     /*  64325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_popcntb),
     /*  64330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  64333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  64336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  64340 */     // (intrinsic_wo_chain:{ *:[i64] } 10801:{ *:[iPTR] }, i64:{ *:[i64] }:$RST)  =>  (POPCNTB8:{ *:[i64] } i64:{ *:[i64] }:$RST)
     /*  64340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::POPCNTB8),
     /*  64343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  64345 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  64347 */     GIR_RootConstrainSelectedInstOperands,
     /*  64348 */     // GIR_Coverage, 693,
     /*  64348 */     GIR_EraseRootFromParent_Done,
     /*  64349 */   // Label 958: @64349
     /*  64349 */   GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(64378), // Rule ID 694 //
     /*  64354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_cdtbcdd),
     /*  64359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  64362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  64365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  64369 */     // (intrinsic_wo_chain:{ *:[i64] } 10588:{ *:[iPTR] }, i64:{ *:[i64] }:$RST)  =>  (CDTBCD8:{ *:[i64] } i64:{ *:[i64] }:$RST)
     /*  64369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CDTBCD8),
     /*  64372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  64374 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  64376 */     GIR_RootConstrainSelectedInstOperands,
     /*  64377 */     // GIR_Coverage, 694,
     /*  64377 */     GIR_EraseRootFromParent_Done,
     /*  64378 */   // Label 959: @64378
     /*  64378 */   GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(64407), // Rule ID 695 //
     /*  64383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_cbcdtdd),
     /*  64388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  64391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  64394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  64398 */     // (intrinsic_wo_chain:{ *:[i64] } 10586:{ *:[iPTR] }, i64:{ *:[i64] }:$RST)  =>  (CBCDTD8:{ *:[i64] } i64:{ *:[i64] }:$RST)
     /*  64398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CBCDTD8),
     /*  64401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  64403 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  64405 */     GIR_RootConstrainSelectedInstOperands,
     /*  64406 */     // GIR_Coverage, 695,
     /*  64406 */     GIR_EraseRootFromParent_Done,
     /*  64407 */   // Label 960: @64407
     /*  64407 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(64439), // Rule ID 1062 //
     /*  64412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vstribr),
     /*  64420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  64423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  64426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64430 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10542:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB)  =>  (VSTRIBR:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VB)
     /*  64430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSTRIBR),
     /*  64433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VT]
     /*  64435 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64437 */     GIR_RootConstrainSelectedInstOperands,
     /*  64438 */     // GIR_Coverage, 1062,
     /*  64438 */     GIR_EraseRootFromParent_Done,
     /*  64439 */   // Label 961: @64439
     /*  64439 */   GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(64471), // Rule ID 1063 //
     /*  64444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vstribl),
     /*  64452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  64455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  64458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64462 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10540:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB)  =>  (VSTRIBL:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VB)
     /*  64462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSTRIBL),
     /*  64465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VT]
     /*  64467 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64469 */     GIR_RootConstrainSelectedInstOperands,
     /*  64470 */     // GIR_Coverage, 1063,
     /*  64470 */     GIR_EraseRootFromParent_Done,
     /*  64471 */   // Label 962: @64471
     /*  64471 */   GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(64503), // Rule ID 1064 //
     /*  64476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vstrihr),
     /*  64484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  64487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  64490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64494 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10546:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VB)  =>  (VSTRIHR:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VB)
     /*  64494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSTRIHR),
     /*  64497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VT]
     /*  64499 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64501 */     GIR_RootConstrainSelectedInstOperands,
     /*  64502 */     // GIR_Coverage, 1064,
     /*  64502 */     GIR_EraseRootFromParent_Done,
     /*  64503 */   // Label 963: @64503
     /*  64503 */   GIM_Try, /*On fail goto*//*Label 964*/ GIMT_Encode4(64535), // Rule ID 1065 //
     /*  64508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vstrihl),
     /*  64516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  64519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  64522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64526 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10544:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VB)  =>  (VSTRIHL:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VB)
     /*  64526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSTRIHL),
     /*  64529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VT]
     /*  64531 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64533 */     GIR_RootConstrainSelectedInstOperands,
     /*  64534 */     // GIR_Coverage, 1065,
     /*  64534 */     GIR_EraseRootFromParent_Done,
     /*  64535 */   // Label 964: @64535
     /*  64535 */   GIM_Try, /*On fail goto*//*Label 965*/ GIMT_Encode4(64567), // Rule ID 1082 //
     /*  64540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextractbm),
     /*  64548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  64554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  64558 */     // (intrinsic_wo_chain:{ *:[i32] } 10409:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB)  =>  (VEXTRACTBM:{ *:[i32] } v16i8:{ *:[v16i8] }:$VB)
     /*  64558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTRACTBM),
     /*  64561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64563 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64565 */     GIR_RootConstrainSelectedInstOperands,
     /*  64566 */     // GIR_Coverage, 1082,
     /*  64566 */     GIR_EraseRootFromParent_Done,
     /*  64567 */   // Label 965: @64567
     /*  64567 */   GIM_Try, /*On fail goto*//*Label 966*/ GIMT_Encode4(64599), // Rule ID 1083 //
     /*  64572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextracthm),
     /*  64580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  64586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  64590 */     // (intrinsic_wo_chain:{ *:[i32] } 10411:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VB)  =>  (VEXTRACTHM:{ *:[i32] } v8i16:{ *:[v8i16] }:$VB)
     /*  64590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTRACTHM),
     /*  64593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64595 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64597 */     GIR_RootConstrainSelectedInstOperands,
     /*  64598 */     // GIR_Coverage, 1083,
     /*  64598 */     GIR_EraseRootFromParent_Done,
     /*  64599 */   // Label 966: @64599
     /*  64599 */   GIM_Try, /*On fail goto*//*Label 967*/ GIMT_Encode4(64631), // Rule ID 1084 //
     /*  64604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextractwm),
     /*  64612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  64622 */     // (intrinsic_wo_chain:{ *:[i32] } 10413:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB)  =>  (VEXTRACTWM:{ *:[i32] } v4i32:{ *:[v4i32] }:$VB)
     /*  64622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTRACTWM),
     /*  64625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64627 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64629 */     GIR_RootConstrainSelectedInstOperands,
     /*  64630 */     // GIR_Coverage, 1084,
     /*  64630 */     GIR_EraseRootFromParent_Done,
     /*  64631 */   // Label 967: @64631
     /*  64631 */   GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(64663), // Rule ID 1085 //
     /*  64636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextractdm),
     /*  64644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  64654 */     // (intrinsic_wo_chain:{ *:[i32] } 10410:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VB)  =>  (VEXTRACTDM:{ *:[i32] } v2i64:{ *:[v2i64] }:$VB)
     /*  64654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTRACTDM),
     /*  64657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64659 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64661 */     GIR_RootConstrainSelectedInstOperands,
     /*  64662 */     // GIR_Coverage, 1085,
     /*  64662 */     GIR_EraseRootFromParent_Done,
     /*  64663 */   // Label 968: @64663
     /*  64663 */   GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(64695), // Rule ID 1086 //
     /*  64668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextractqm),
     /*  64676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  64682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  64686 */     // (intrinsic_wo_chain:{ *:[i32] } 10412:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$VB)  =>  (VEXTRACTQM:{ *:[i32] } v1i128:{ *:[v1i128] }:$VB)
     /*  64686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTRACTQM),
     /*  64689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64691 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64693 */     GIR_RootConstrainSelectedInstOperands,
     /*  64694 */     // GIR_Coverage, 1086,
     /*  64694 */     GIR_EraseRootFromParent_Done,
     /*  64695 */   // Label 969: @64695
     /*  64695 */   GIM_Try, /*On fail goto*//*Label 970*/ GIMT_Encode4(64727), // Rule ID 1087 //
     /*  64700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vexpandbm),
     /*  64708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  64711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  64714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64718 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10395:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB)  =>  (VEXPANDBM:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VB)
     /*  64718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXPANDBM),
     /*  64721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64723 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64725 */     GIR_RootConstrainSelectedInstOperands,
     /*  64726 */     // GIR_Coverage, 1087,
     /*  64726 */     GIR_EraseRootFromParent_Done,
     /*  64727 */   // Label 970: @64727
     /*  64727 */   GIM_Try, /*On fail goto*//*Label 971*/ GIMT_Encode4(64759), // Rule ID 1088 //
     /*  64732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vexpandhm),
     /*  64740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  64743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  64746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64750 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10397:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VB)  =>  (VEXPANDHM:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VB)
     /*  64750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXPANDHM),
     /*  64753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64755 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64757 */     GIR_RootConstrainSelectedInstOperands,
     /*  64758 */     // GIR_Coverage, 1088,
     /*  64758 */     GIR_EraseRootFromParent_Done,
     /*  64759 */   // Label 971: @64759
     /*  64759 */   GIM_Try, /*On fail goto*//*Label 972*/ GIMT_Encode4(64791), // Rule ID 1089 //
     /*  64764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vexpandwm),
     /*  64772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64782 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10399:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB)  =>  (VEXPANDWM:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB)
     /*  64782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXPANDWM),
     /*  64785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64787 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64789 */     GIR_RootConstrainSelectedInstOperands,
     /*  64790 */     // GIR_Coverage, 1089,
     /*  64790 */     GIR_EraseRootFromParent_Done,
     /*  64791 */   // Label 972: @64791
     /*  64791 */   GIM_Try, /*On fail goto*//*Label 973*/ GIMT_Encode4(64823), // Rule ID 1090 //
     /*  64796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vexpanddm),
     /*  64804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  64807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64814 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10396:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VB)  =>  (VEXPANDDM:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VB)
     /*  64814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXPANDDM),
     /*  64817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64819 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64821 */     GIR_RootConstrainSelectedInstOperands,
     /*  64822 */     // GIR_Coverage, 1090,
     /*  64822 */     GIR_EraseRootFromParent_Done,
     /*  64823 */   // Label 973: @64823
     /*  64823 */   GIM_Try, /*On fail goto*//*Label 974*/ GIMT_Encode4(64855), // Rule ID 1091 //
     /*  64828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vexpandqm),
     /*  64836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  64839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  64842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64846 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10398:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$VB)  =>  (VEXPANDQM:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VB)
     /*  64846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXPANDQM),
     /*  64849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64851 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64853 */     GIR_RootConstrainSelectedInstOperands,
     /*  64854 */     // GIR_Coverage, 1091,
     /*  64854 */     GIR_EraseRootFromParent_Done,
     /*  64855 */   // Label 974: @64855
     /*  64855 */   GIM_Try, /*On fail goto*//*Label 975*/ GIMT_Encode4(64887), // Rule ID 1092 //
     /*  64860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_mtvsrbm),
     /*  64868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  64871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  64874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64878 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10293:{ *:[iPTR] }, i64:{ *:[i64] }:$VB)  =>  (MTVSRBM:{ *:[v16i8] } i64:{ *:[i64] }:$VB)
     /*  64878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTVSRBM),
     /*  64881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64883 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64885 */     GIR_RootConstrainSelectedInstOperands,
     /*  64886 */     // GIR_Coverage, 1092,
     /*  64886 */     GIR_EraseRootFromParent_Done,
     /*  64887 */   // Label 975: @64887
     /*  64887 */   GIM_Try, /*On fail goto*//*Label 976*/ GIMT_Encode4(64919), // Rule ID 1093 //
     /*  64892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_mtvsrhm),
     /*  64900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  64903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  64906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64910 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10295:{ *:[iPTR] }, i64:{ *:[i64] }:$VB)  =>  (MTVSRHM:{ *:[v8i16] } i64:{ *:[i64] }:$VB)
     /*  64910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTVSRHM),
     /*  64913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64915 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64917 */     GIR_RootConstrainSelectedInstOperands,
     /*  64918 */     // GIR_Coverage, 1093,
     /*  64918 */     GIR_EraseRootFromParent_Done,
     /*  64919 */   // Label 976: @64919
     /*  64919 */   GIM_Try, /*On fail goto*//*Label 977*/ GIMT_Encode4(64951), // Rule ID 1094 //
     /*  64924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_mtvsrwm),
     /*  64932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  64938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64942 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10297:{ *:[iPTR] }, i64:{ *:[i64] }:$VB)  =>  (MTVSRWM:{ *:[v4i32] } i64:{ *:[i64] }:$VB)
     /*  64942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTVSRWM),
     /*  64945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64947 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64949 */     GIR_RootConstrainSelectedInstOperands,
     /*  64950 */     // GIR_Coverage, 1094,
     /*  64950 */     GIR_EraseRootFromParent_Done,
     /*  64951 */   // Label 977: @64951
     /*  64951 */   GIM_Try, /*On fail goto*//*Label 978*/ GIMT_Encode4(64983), // Rule ID 1095 //
     /*  64956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_mtvsrdm),
     /*  64964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  64967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  64970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64974 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10294:{ *:[iPTR] }, i64:{ *:[i64] }:$VB)  =>  (MTVSRDM:{ *:[v2i64] } i64:{ *:[i64] }:$VB)
     /*  64974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTVSRDM),
     /*  64977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64979 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64981 */     GIR_RootConstrainSelectedInstOperands,
     /*  64982 */     // GIR_Coverage, 1095,
     /*  64982 */     GIR_EraseRootFromParent_Done,
     /*  64983 */   // Label 978: @64983
     /*  64983 */   GIM_Try, /*On fail goto*//*Label 979*/ GIMT_Encode4(65015), // Rule ID 1096 //
     /*  64988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_mtvsrqm),
     /*  64996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  64999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  65006 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10296:{ *:[iPTR] }, i64:{ *:[i64] }:$VB)  =>  (MTVSRQM:{ *:[v1i128] } i64:{ *:[i64] }:$VB)
     /*  65006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTVSRQM),
     /*  65009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  65011 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  65013 */     GIR_RootConstrainSelectedInstOperands,
     /*  65014 */     // GIR_Coverage, 1096,
     /*  65014 */     GIR_EraseRootFromParent_Done,
     /*  65015 */   // Label 979: @65015
     /*  65015 */   GIM_Try, /*On fail goto*//*Label 980*/ GIMT_Encode4(65047), // Rule ID 1160 //
     /*  65020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  65023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextsd2q),
     /*  65028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  65031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  65038 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10416:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VB)  =>  (VEXTSD2Q:{ *:[v1i128] } v2i64:{ *:[v2i64] }:$VB)
     /*  65038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTSD2Q),
     /*  65041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  65043 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  65045 */     GIR_RootConstrainSelectedInstOperands,
     /*  65046 */     // GIR_Coverage, 1160,
     /*  65046 */     GIR_EraseRootFromParent_Done,
     /*  65047 */   // Label 980: @65047
     /*  65047 */   GIM_Try, /*On fail goto*//*Label 981*/ GIMT_Encode4(65079), // Rule ID 1165 //
     /*  65052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture),
     /*  65055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmmr),
     /*  65060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  65063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  65066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  65070 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10687:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$AB)  =>  (DMMR:{ *:[v1024i1] } v1024i1:{ *:[v1024i1] }:$AB)
     /*  65070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMMR),
     /*  65073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  65075 */     GIR_RootToRootCopy, /*OpIdx*/2, // AB
     /*  65077 */     GIR_RootConstrainSelectedInstOperands,
     /*  65078 */     // GIR_Coverage, 1165,
     /*  65078 */     GIR_EraseRootFromParent_Done,
     /*  65079 */   // Label 981: @65079
     /*  65079 */   GIM_Try, /*On fail goto*//*Label 982*/ GIMT_Encode4(65111), // Rule ID 1170 //
     /*  65084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  65087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xxmfacc),
     /*  65092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  65095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  65098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  65102 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10781:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$AT)  =>  (XXMFACC:{ *:[v512i1] } v512i1:{ *:[v512i1] }:$AT)
     /*  65102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXMFACC),
     /*  65105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[ATo]
     /*  65107 */     GIR_RootToRootCopy, /*OpIdx*/2, // AT
     /*  65109 */     GIR_RootConstrainSelectedInstOperands,
     /*  65110 */     // GIR_Coverage, 1170,
     /*  65110 */     GIR_EraseRootFromParent_Done,
     /*  65111 */   // Label 982: @65111
     /*  65111 */   GIM_Try, /*On fail goto*//*Label 983*/ GIMT_Encode4(65143), // Rule ID 1171 //
     /*  65116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  65119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xxmtacc),
     /*  65124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  65127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  65130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  65134 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10782:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi)  =>  (XXMTACC:{ *:[v512i1] } v512i1:{ *:[v512i1] }:$ATi)
     /*  65134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXMTACC),
     /*  65137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  65139 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  65141 */     GIR_RootConstrainSelectedInstOperands,
     /*  65142 */     // GIR_Coverage, 1171,
     /*  65142 */     GIR_EraseRootFromParent_Done,
     /*  65143 */   // Label 983: @65143
     /*  65143 */   GIM_Try, /*On fail goto*//*Label 984*/ GIMT_Encode4(65172), // Rule ID 1286 //
     /*  65148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fre),
     /*  65153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  65163 */     // (intrinsic_wo_chain:{ *:[f64] } 10648:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (FRE:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  65163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FRE),
     /*  65166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  65168 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65170 */     GIR_RootConstrainSelectedInstOperands,
     /*  65171 */     // GIR_Coverage, 1286,
     /*  65171 */     GIR_EraseRootFromParent_Done,
     /*  65172 */   // Label 984: @65172
     /*  65172 */   GIM_Try, /*On fail goto*//*Label 985*/ GIMT_Encode4(65201), // Rule ID 1287 //
     /*  65177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fres),
     /*  65182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  65185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  65188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /*  65192 */     // (intrinsic_wo_chain:{ *:[f32] } 10649:{ *:[iPTR] }, f32:{ *:[f32] }:$A)  =>  (FRES:{ *:[f32] } ?:{ *:[f32] }:$A)
     /*  65192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FRES),
     /*  65195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  65197 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65199 */     GIR_RootConstrainSelectedInstOperands,
     /*  65200 */     // GIR_Coverage, 1287,
     /*  65200 */     GIR_EraseRootFromParent_Done,
     /*  65201 */   // Label 985: @65201
     /*  65201 */   GIM_Try, /*On fail goto*//*Label 986*/ GIMT_Encode4(65230), // Rule ID 1288 //
     /*  65206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fnabs),
     /*  65211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  65221 */     // (intrinsic_wo_chain:{ *:[f64] } 10643:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (FNABSD:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  65221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNABSD),
     /*  65224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  65226 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65228 */     GIR_RootConstrainSelectedInstOperands,
     /*  65229 */     // GIR_Coverage, 1288,
     /*  65229 */     GIR_EraseRootFromParent_Done,
     /*  65230 */   // Label 986: @65230
     /*  65230 */   GIM_Try, /*On fail goto*//*Label 987*/ GIMT_Encode4(65259), // Rule ID 1289 //
     /*  65235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fnabss),
     /*  65240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  65243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  65246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /*  65250 */     // (intrinsic_wo_chain:{ *:[f32] } 10644:{ *:[iPTR] }, f32:{ *:[f32] }:$A)  =>  (FNABSS:{ *:[f32] } ?:{ *:[f32] }:$A)
     /*  65250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNABSS),
     /*  65253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  65255 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65257 */     GIR_RootConstrainSelectedInstOperands,
     /*  65258 */     // GIR_Coverage, 1289,
     /*  65258 */     GIR_EraseRootFromParent_Done,
     /*  65259 */   // Label 987: @65259
     /*  65259 */   GIM_Try, /*On fail goto*//*Label 988*/ GIMT_Encode4(65334), // Rule ID 3364 //
     /*  65264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX_IsISA3_1),
     /*  65267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvspbf16),
     /*  65272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  65275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  65278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  65282 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10883:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (XVCVSPBF16:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] })), VRRC:{ *:[i32] })
     /*  65282 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  65285 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65289 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65294 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  65298 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65303 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65306 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XVCVSPBF16),
     /*  65310 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65315 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  65318 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  65320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65325 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65328 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  65333 */     // GIR_Coverage, 3364,
     /*  65333 */     GIR_EraseRootFromParent_Done,
     /*  65334 */   // Label 988: @65334
     /*  65334 */   GIM_Try, /*On fail goto*//*Label 989*/ GIMT_Encode4(65409), // Rule ID 3365 //
     /*  65339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX_IsISA3_1),
     /*  65342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvbf16spn),
     /*  65347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  65350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  65353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  65357 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10878:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (XVCVBF16SPN:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] })), VRRC:{ *:[i32] })
     /*  65357 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  65360 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65364 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65369 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  65373 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65378 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65381 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XVCVBF16SPN),
     /*  65385 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65390 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  65393 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  65395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65400 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65403 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  65408 */     // GIR_Coverage, 3365,
     /*  65408 */     GIR_EraseRootFromParent_Done,
     /*  65409 */   // Label 989: @65409
     /*  65409 */   GIM_Try, /*On fail goto*//*Label 990*/ GIMT_Encode4(65438), // Rule ID 4898 //
     /*  65414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fcfid),
     /*  65419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65429 */     // (intrinsic_wo_chain:{ *:[f64] } 10630:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (XSCVSXDDP:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  65429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVSXDDP),
     /*  65432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65434 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65436 */     GIR_RootConstrainSelectedInstOperands,
     /*  65437 */     // GIR_Coverage, 4898,
     /*  65437 */     GIR_EraseRootFromParent_Done,
     /*  65438 */   // Label 990: @65438
     /*  65438 */   GIM_Try, /*On fail goto*//*Label 991*/ GIMT_Encode4(65467), // Rule ID 4899 //
     /*  65443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fcfud),
     /*  65448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65458 */     // (intrinsic_wo_chain:{ *:[f64] } 10631:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (XSCVUXDDP:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  65458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVUXDDP),
     /*  65461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65463 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65465 */     GIR_RootConstrainSelectedInstOperands,
     /*  65466 */     // GIR_Coverage, 4899,
     /*  65466 */     GIR_EraseRootFromParent_Done,
     /*  65467 */   // Label 991: @65467
     /*  65467 */   GIM_Try, /*On fail goto*//*Label 992*/ GIMT_Encode4(65496), // Rule ID 4900 //
     /*  65472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fctid),
     /*  65477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  65487 */     // (intrinsic_wo_chain:{ *:[f64] } 10632:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (FCTID:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  65487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FCTID),
     /*  65490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  65492 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65494 */     GIR_RootConstrainSelectedInstOperands,
     /*  65495 */     // GIR_Coverage, 4900,
     /*  65495 */     GIR_EraseRootFromParent_Done,
     /*  65496 */   // Label 992: @65496
     /*  65496 */   GIM_Try, /*On fail goto*//*Label 993*/ GIMT_Encode4(65525), // Rule ID 4901 //
     /*  65501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fctidz),
     /*  65506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65516 */     // (intrinsic_wo_chain:{ *:[f64] } 10633:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (XSCVDPSXDS:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  65516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVDPSXDS),
     /*  65519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65521 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65523 */     GIR_RootConstrainSelectedInstOperands,
     /*  65524 */     // GIR_Coverage, 4901,
     /*  65524 */     GIR_EraseRootFromParent_Done,
     /*  65525 */   // Label 993: @65525
     /*  65525 */   GIM_Try, /*On fail goto*//*Label 994*/ GIMT_Encode4(65554), // Rule ID 4902 //
     /*  65530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fctiw),
     /*  65535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  65545 */     // (intrinsic_wo_chain:{ *:[f64] } 10634:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (FCTIW:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  65545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FCTIW),
     /*  65548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  65550 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65552 */     GIR_RootConstrainSelectedInstOperands,
     /*  65553 */     // GIR_Coverage, 4902,
     /*  65553 */     GIR_EraseRootFromParent_Done,
     /*  65554 */   // Label 994: @65554
     /*  65554 */   GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(65583), // Rule ID 4903 //
     /*  65559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fctiwz),
     /*  65564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65574 */     // (intrinsic_wo_chain:{ *:[f64] } 10635:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (XSCVDPSXWS:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  65574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVDPSXWS),
     /*  65577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65579 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65581 */     GIR_RootConstrainSelectedInstOperands,
     /*  65582 */     // GIR_Coverage, 4903,
     /*  65582 */     GIR_EraseRootFromParent_Done,
     /*  65583 */   // Label 995: @65583
     /*  65583 */   GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(65612), // Rule ID 4904 //
     /*  65588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fctudz),
     /*  65593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65603 */     // (intrinsic_wo_chain:{ *:[f64] } 10636:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (XSCVDPUXDS:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  65603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVDPUXDS),
     /*  65606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65608 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65610 */     GIR_RootConstrainSelectedInstOperands,
     /*  65611 */     // GIR_Coverage, 4904,
     /*  65611 */     GIR_EraseRootFromParent_Done,
     /*  65612 */   // Label 996: @65612
     /*  65612 */   GIM_Try, /*On fail goto*//*Label 997*/ GIMT_Encode4(65641), // Rule ID 4905 //
     /*  65617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fctuwz),
     /*  65622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65632 */     // (intrinsic_wo_chain:{ *:[f64] } 10637:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (XSCVDPUXWS:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  65632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVDPUXWS),
     /*  65635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65637 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65639 */     GIR_RootConstrainSelectedInstOperands,
     /*  65640 */     // GIR_Coverage, 4905,
     /*  65640 */     GIR_EraseRootFromParent_Done,
     /*  65641 */   // Label 997: @65641
     /*  65641 */   GIM_Reject,
     /*  65642 */ // Label 889: @65642
     /*  65642 */ GIM_Try, /*On fail goto*//*Label 998*/ GIMT_Encode4(74435),
     /*  65647 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /*  65650 */   GIM_Try, /*On fail goto*//*Label 999*/ GIMT_Encode4(65721), // Rule ID 2174 //
     /*  65655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  65658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxextractuw),
     /*  65663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  65666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  65672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  65680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65684 */     // MIs[1] Operand 1
     /*  65684 */     // No operand predicates
     /*  65684 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  65686 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10922:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$A, (imm:{ *:[i32] }):$IMM)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } (XXEXTRACTUW:{ *:[f64] } ?:{ *:[v2i64] }:$A, (imm:{ *:[i32] }):$IMM), VSRC:{ *:[i32] })
     /*  65686 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  65689 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXEXTRACTUW),
     /*  65693 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65698 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  65702 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // IMM
     /*  65705 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  65707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65712 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65715 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65720 */     // GIR_Coverage, 2174,
     /*  65720 */     GIR_EraseRootFromParent_Done,
     /*  65721 */   // Label 999: @65721
     /*  65721 */   GIM_Try, /*On fail goto*//*Label 1000*/ GIMT_Encode4(65758), // Rule ID 1033 //
     /*  65726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  65729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvtstdcsp),
     /*  65734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  65737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65744 */     // MIs[0] DCMX
     /*  65744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  65747 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10912:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$XB, (timm:{ *:[i32] }):$DCMX)  =>  (XVTSTDCSP:{ *:[v4i32] } (timm:{ *:[i32] }):$DCMX, v4f32:{ *:[v4f32] }:$XB)
     /*  65747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVTSTDCSP),
     /*  65750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65752 */     GIR_RootToRootCopy, /*OpIdx*/3, // DCMX
     /*  65754 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  65756 */     GIR_RootConstrainSelectedInstOperands,
     /*  65757 */     // GIR_Coverage, 1033,
     /*  65757 */     GIR_EraseRootFromParent_Done,
     /*  65758 */   // Label 1000: @65758
     /*  65758 */   GIM_Try, /*On fail goto*//*Label 1001*/ GIMT_Encode4(65795), // Rule ID 1034 //
     /*  65763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  65766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvtstdcdp),
     /*  65771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  65774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65781 */     // MIs[0] DCMX
     /*  65781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  65784 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10911:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$XB, (timm:{ *:[i32] }):$DCMX)  =>  (XVTSTDCDP:{ *:[v2i64] } (timm:{ *:[i32] }):$DCMX, v2f64:{ *:[v2f64] }:$XB)
     /*  65784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVTSTDCDP),
     /*  65787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65789 */     GIR_RootToRootCopy, /*OpIdx*/3, // DCMX
     /*  65791 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  65793 */     GIR_RootConstrainSelectedInstOperands,
     /*  65794 */     // GIR_Coverage, 1034,
     /*  65794 */     GIR_EraseRootFromParent_Done,
     /*  65795 */   // Label 1001: @65795
     /*  65795 */   GIM_Try, /*On fail goto*//*Label 1002*/ GIMT_Encode4(65840), // Rule ID 902 //
     /*  65800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  65803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xsmaxdp),
     /*  65808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  65817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65829 */     // (intrinsic_wo_chain:{ *:[f64] } 10864:{ *:[iPTR] }, vsfrc:{ *:[f64] }:$XA, vsfrc:{ *:[f64] }:$XB)  =>  (XSMAXDP:{ *:[f64] } vsfrc:{ *:[f64] }:$XA, vsfrc:{ *:[f64] }:$XB)
     /*  65829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMAXDP),
     /*  65832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65834 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  65836 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  65838 */     GIR_RootConstrainSelectedInstOperands,
     /*  65839 */     // GIR_Coverage, 902,
     /*  65839 */     GIR_EraseRootFromParent_Done,
     /*  65840 */   // Label 1002: @65840
     /*  65840 */   GIM_Try, /*On fail goto*//*Label 1003*/ GIMT_Encode4(65885), // Rule ID 903 //
     /*  65845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  65848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xsmindp),
     /*  65853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  65862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65874 */     // (intrinsic_wo_chain:{ *:[f64] } 10865:{ *:[iPTR] }, vsfrc:{ *:[f64] }:$XA, vsfrc:{ *:[f64] }:$XB)  =>  (XSMINDP:{ *:[f64] } vsfrc:{ *:[f64] }:$XA, vsfrc:{ *:[f64] }:$XB)
     /*  65874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMINDP),
     /*  65877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65879 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  65881 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  65883 */     GIR_RootConstrainSelectedInstOperands,
     /*  65884 */     // GIR_Coverage, 903,
     /*  65884 */     GIR_EraseRootFromParent_Done,
     /*  65885 */   // Label 1003: @65885
     /*  65885 */   GIM_Try, /*On fail goto*//*Label 1004*/ GIMT_Encode4(65930), // Rule ID 904 //
     /*  65890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  65893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvmaxdp),
     /*  65898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  65901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  65907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65919 */     // (intrinsic_wo_chain:{ *:[v2f64] } 10896:{ *:[iPTR] }, vsrc:{ *:[v2f64] }:$XA, vsrc:{ *:[v2f64] }:$XB)  =>  (XVMAXDP:{ *:[v2f64] } vsrc:{ *:[v2f64] }:$XA, vsrc:{ *:[v2f64] }:$XB)
     /*  65919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMAXDP),
     /*  65922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65924 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  65926 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  65928 */     GIR_RootConstrainSelectedInstOperands,
     /*  65929 */     // GIR_Coverage, 904,
     /*  65929 */     GIR_EraseRootFromParent_Done,
     /*  65930 */   // Label 1004: @65930
     /*  65930 */   GIM_Try, /*On fail goto*//*Label 1005*/ GIMT_Encode4(65975), // Rule ID 905 //
     /*  65935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  65938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvmindp),
     /*  65943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  65946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  65952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65964 */     // (intrinsic_wo_chain:{ *:[v2f64] } 10898:{ *:[iPTR] }, vsrc:{ *:[v2f64] }:$XA, vsrc:{ *:[v2f64] }:$XB)  =>  (XVMINDP:{ *:[v2f64] } vsrc:{ *:[v2f64] }:$XA, vsrc:{ *:[v2f64] }:$XB)
     /*  65964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMINDP),
     /*  65967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65969 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  65971 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  65973 */     GIR_RootConstrainSelectedInstOperands,
     /*  65974 */     // GIR_Coverage, 905,
     /*  65974 */     GIR_EraseRootFromParent_Done,
     /*  65975 */   // Label 1005: @65975
     /*  65975 */   GIM_Try, /*On fail goto*//*Label 1006*/ GIMT_Encode4(66020), // Rule ID 906 //
     /*  65980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  65983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvmaxsp),
     /*  65988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  65991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66009 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10897:{ *:[iPTR] }, vsrc:{ *:[v4f32] }:$XA, vsrc:{ *:[v4f32] }:$XB)  =>  (XVMAXSP:{ *:[v4f32] } vsrc:{ *:[v4f32] }:$XA, vsrc:{ *:[v4f32] }:$XB)
     /*  66009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMAXSP),
     /*  66012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66014 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  66016 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  66018 */     GIR_RootConstrainSelectedInstOperands,
     /*  66019 */     // GIR_Coverage, 906,
     /*  66019 */     GIR_EraseRootFromParent_Done,
     /*  66020 */   // Label 1006: @66020
     /*  66020 */   GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(66065), // Rule ID 907 //
     /*  66025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  66028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvminsp),
     /*  66033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66054 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10899:{ *:[iPTR] }, vsrc:{ *:[v4f32] }:$XA, vsrc:{ *:[v4f32] }:$XB)  =>  (XVMINSP:{ *:[v4f32] } vsrc:{ *:[v4f32] }:$XA, vsrc:{ *:[v4f32] }:$XB)
     /*  66054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMINSP),
     /*  66057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66059 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  66061 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  66063 */     GIR_RootConstrainSelectedInstOperands,
     /*  66064 */     // GIR_Coverage, 907,
     /*  66064 */     GIR_EraseRootFromParent_Done,
     /*  66065 */   // Label 1007: @66065
     /*  66065 */   GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(66102), // Rule ID 831 //
     /*  66070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  66073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcmpeqdp),
     /*  66078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  66081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  66087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66091 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10866:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)  =>  (XVCMPEQDP:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /*  66091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCMPEQDP),
     /*  66094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66096 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  66098 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  66100 */     GIR_RootConstrainSelectedInstOperands,
     /*  66101 */     // GIR_Coverage, 831,
     /*  66101 */     GIR_EraseRootFromParent_Done,
     /*  66102 */   // Label 1008: @66102
     /*  66102 */   GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(66139), // Rule ID 833 //
     /*  66107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  66110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcmpeqsp),
     /*  66115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66128 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10868:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)  =>  (XVCMPEQSP:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /*  66128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCMPEQSP),
     /*  66131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66133 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  66135 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  66137 */     GIR_RootConstrainSelectedInstOperands,
     /*  66138 */     // GIR_Coverage, 833,
     /*  66138 */     GIR_EraseRootFromParent_Done,
     /*  66139 */   // Label 1009: @66139
     /*  66139 */   GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(66176), // Rule ID 835 //
     /*  66144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  66147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcmpgedp),
     /*  66152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  66155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  66161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66165 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10870:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)  =>  (XVCMPGEDP:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /*  66165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCMPGEDP),
     /*  66168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66170 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  66172 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  66174 */     GIR_RootConstrainSelectedInstOperands,
     /*  66175 */     // GIR_Coverage, 835,
     /*  66175 */     GIR_EraseRootFromParent_Done,
     /*  66176 */   // Label 1010: @66176
     /*  66176 */   GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(66213), // Rule ID 837 //
     /*  66181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  66184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcmpgesp),
     /*  66189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66202 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10872:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)  =>  (XVCMPGESP:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /*  66202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCMPGESP),
     /*  66205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66207 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  66209 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  66211 */     GIR_RootConstrainSelectedInstOperands,
     /*  66212 */     // GIR_Coverage, 837,
     /*  66212 */     GIR_EraseRootFromParent_Done,
     /*  66213 */   // Label 1011: @66213
     /*  66213 */   GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(66250), // Rule ID 839 //
     /*  66218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  66221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcmpgtdp),
     /*  66226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  66229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  66235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66239 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10874:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)  =>  (XVCMPGTDP:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /*  66239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCMPGTDP),
     /*  66242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66244 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  66246 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  66248 */     GIR_RootConstrainSelectedInstOperands,
     /*  66249 */     // GIR_Coverage, 839,
     /*  66249 */     GIR_EraseRootFromParent_Done,
     /*  66250 */   // Label 1012: @66250
     /*  66250 */   GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(66287), // Rule ID 841 //
     /*  66255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  66258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcmpgtsp),
     /*  66263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66276 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10876:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)  =>  (XVCMPGTSP:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /*  66276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCMPGTSP),
     /*  66279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66281 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  66283 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  66285 */     GIR_RootConstrainSelectedInstOperands,
     /*  66286 */     // GIR_Coverage, 841,
     /*  66286 */     GIR_EraseRootFromParent_Done,
     /*  66287 */   // Label 1013: @66287
     /*  66287 */   GIM_Try, /*On fail goto*//*Label 1014*/ GIMT_Encode4(66324), // Rule ID 1005 //
     /*  66292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  66295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_addf128_round_to_odd),
     /*  66300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  66303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  66306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  66309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  66313 */     // (intrinsic_wo_chain:{ *:[f128] } 10262:{ *:[iPTR] }, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSADDQPO:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /*  66313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSADDQPO),
     /*  66316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  66318 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  66320 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  66322 */     GIR_RootConstrainSelectedInstOperands,
     /*  66323 */     // GIR_Coverage, 1005,
     /*  66323 */     GIR_EraseRootFromParent_Done,
     /*  66324 */   // Label 1014: @66324
     /*  66324 */   GIM_Try, /*On fail goto*//*Label 1015*/ GIMT_Encode4(66361), // Rule ID 1006 //
     /*  66329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  66332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mulf128_round_to_odd),
     /*  66337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  66340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  66343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  66346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  66350 */     // (intrinsic_wo_chain:{ *:[f128] } 10790:{ *:[iPTR] }, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSMULQPO:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /*  66350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMULQPO),
     /*  66353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  66355 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  66357 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  66359 */     GIR_RootConstrainSelectedInstOperands,
     /*  66360 */     // GIR_Coverage, 1006,
     /*  66360 */     GIR_EraseRootFromParent_Done,
     /*  66361 */   // Label 1015: @66361
     /*  66361 */   GIM_Try, /*On fail goto*//*Label 1016*/ GIMT_Encode4(66398), // Rule ID 1007 //
     /*  66366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  66369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_subf128_round_to_odd),
     /*  66374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  66377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  66380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  66383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  66387 */     // (intrinsic_wo_chain:{ *:[f128] } 10824:{ *:[iPTR] }, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSSUBQPO:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /*  66387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSSUBQPO),
     /*  66390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  66392 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  66394 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  66396 */     GIR_RootConstrainSelectedInstOperands,
     /*  66397 */     // GIR_Coverage, 1007,
     /*  66397 */     GIR_EraseRootFromParent_Done,
     /*  66398 */   // Label 1016: @66398
     /*  66398 */   GIM_Try, /*On fail goto*//*Label 1017*/ GIMT_Encode4(66435), // Rule ID 1008 //
     /*  66403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  66406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_divf128_round_to_odd),
     /*  66411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  66414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  66417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  66420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  66424 */     // (intrinsic_wo_chain:{ *:[f128] } 10624:{ *:[iPTR] }, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSDIVQPO:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /*  66424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSDIVQPO),
     /*  66427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  66429 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  66431 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  66433 */     GIR_RootConstrainSelectedInstOperands,
     /*  66434 */     // GIR_Coverage, 1008,
     /*  66434 */     GIR_EraseRootFromParent_Done,
     /*  66435 */   // Label 1017: @66435
     /*  66435 */   GIM_Try, /*On fail goto*//*Label 1018*/ GIMT_Encode4(66472), // Rule ID 1027 //
     /*  66440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  66443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xviexpdp),
     /*  66448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  66451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  66457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66461 */     // (intrinsic_wo_chain:{ *:[v2f64] } 10894:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$XA, v2i64:{ *:[v2i64] }:$XB)  =>  (XVIEXPDP:{ *:[v2f64] } v2i64:{ *:[v2i64] }:$XA, v2i64:{ *:[v2i64] }:$XB)
     /*  66461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVIEXPDP),
     /*  66464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66466 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  66468 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  66470 */     GIR_RootConstrainSelectedInstOperands,
     /*  66471 */     // GIR_Coverage, 1027,
     /*  66471 */     GIR_EraseRootFromParent_Done,
     /*  66472 */   // Label 1018: @66472
     /*  66472 */   GIM_Try, /*On fail goto*//*Label 1019*/ GIMT_Encode4(66509), // Rule ID 1028 //
     /*  66477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  66480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xviexpsp),
     /*  66485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66498 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10895:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)  =>  (XVIEXPSP:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*  66498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVIEXPSP),
     /*  66501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66503 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  66505 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  66507 */     GIR_RootConstrainSelectedInstOperands,
     /*  66508 */     // GIR_Coverage, 1028,
     /*  66508 */     GIR_EraseRootFromParent_Done,
     /*  66509 */   // Label 1019: @66509
     /*  66509 */   GIM_Try, /*On fail goto*//*Label 1020*/ GIMT_Encode4(66546), // Rule ID 1659 //
     /*  66514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  66517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvdivsp),
     /*  66522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66535 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10893:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$A, v4f32:{ *:[v4f32] }:$B)  =>  (XVDIVSP:{ *:[v4f32] } ?:{ *:[v4f32] }:$A, ?:{ *:[v4f32] }:$B)
     /*  66535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVDIVSP),
     /*  66538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66540 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  66542 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  66544 */     GIR_RootConstrainSelectedInstOperands,
     /*  66545 */     // GIR_Coverage, 1659,
     /*  66545 */     GIR_EraseRootFromParent_Done,
     /*  66546 */   // Label 1020: @66546
     /*  66546 */   GIM_Try, /*On fail goto*//*Label 1021*/ GIMT_Encode4(66583), // Rule ID 1660 //
     /*  66551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  66554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvdivdp),
     /*  66559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  66562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  66568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66572 */     // (intrinsic_wo_chain:{ *:[v2f64] } 10892:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$A, v2f64:{ *:[v2f64] }:$B)  =>  (XVDIVDP:{ *:[v2f64] } ?:{ *:[v2f64] }:$A, ?:{ *:[v2f64] }:$B)
     /*  66572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVDIVDP),
     /*  66575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66577 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  66579 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  66581 */     GIR_RootConstrainSelectedInstOperands,
     /*  66582 */     // GIR_Coverage, 1660,
     /*  66582 */     GIR_EraseRootFromParent_Done,
     /*  66583 */   // Label 1021: @66583
     /*  66583 */   GIM_Try, /*On fail goto*//*Label 1022*/ GIMT_Encode4(66645), // Rule ID 1661 //
     /*  66588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  66591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvtdivdp),
     /*  66596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  66599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  66605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  66609 */     // (intrinsic_wo_chain:{ *:[i32] } 10906:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$A, v2f64:{ *:[v2f64] }:$B)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (XVTDIVDP:{ *:[i32] } ?:{ *:[v2f64] }:$A, ?:{ *:[v2f64] }:$B), GPRC:{ *:[i32] })
     /*  66609 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  66612 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XVTDIVDP),
     /*  66616 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66621 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  66625 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // B
     /*  66629 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  66631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66636 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66639 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  66644 */     // GIR_Coverage, 1661,
     /*  66644 */     GIR_EraseRootFromParent_Done,
     /*  66645 */   // Label 1022: @66645
     /*  66645 */   GIM_Try, /*On fail goto*//*Label 1023*/ GIMT_Encode4(66707), // Rule ID 1662 //
     /*  66650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  66653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvtdivsp),
     /*  66658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  66661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  66671 */     // (intrinsic_wo_chain:{ *:[i32] } 10907:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$A, v4f32:{ *:[v4f32] }:$B)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (XVTDIVSP:{ *:[i32] } ?:{ *:[v4f32] }:$A, ?:{ *:[v4f32] }:$B), GPRC:{ *:[i32] })
     /*  66671 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  66674 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XVTDIVSP),
     /*  66678 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66683 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  66687 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // B
     /*  66691 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  66693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66698 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66701 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  66706 */     // GIR_Coverage, 1662,
     /*  66706 */     GIR_EraseRootFromParent_Done,
     /*  66707 */   // Label 1023: @66707
     /*  66707 */   GIM_Try, /*On fail goto*//*Label 1024*/ GIMT_Encode4(66744), // Rule ID 1906 //
     /*  66712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  66715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxleqv),
     /*  66720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66733 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10928:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$A, v4i32:{ *:[v4i32] }:$B)  =>  (XXLEQV:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B)
     /*  66733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLEQV),
     /*  66736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66738 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  66740 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  66742 */     GIR_RootConstrainSelectedInstOperands,
     /*  66743 */     // GIR_Coverage, 1906,
     /*  66743 */     GIR_EraseRootFromParent_Done,
     /*  66744 */   // Label 1024: @66744
     /*  66744 */   GIM_Try, /*On fail goto*//*Label 1025*/ GIMT_Encode4(66826), // Rule ID 1944 //
     /*  66749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  66752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_insert_exp),
     /*  66757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  66760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  66763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  66766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  66770 */     // (intrinsic_wo_chain:{ *:[f64] } 10659:{ *:[iPTR] }, f64:{ *:[f64] }:$A, i64:{ *:[i64] }:$B)  =>  (COPY_TO_REGCLASS:{ *:[f64] } (XSIEXPDP:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[i64] } ?:{ *:[f64] }:$A, G8RC:{ *:[i32] }), ?:{ *:[i64] }:$B), F8RC:{ *:[i32] })
     /*  66770 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  66773 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66777 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66782 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  66786 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  66791 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66794 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSIEXPDP),
     /*  66798 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66803 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  66806 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // B
     /*  66810 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  66812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66817 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66820 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::F8RCRegClassID),
     /*  66825 */     // GIR_Coverage, 1944,
     /*  66825 */     GIR_EraseRootFromParent_Done,
     /*  66826 */   // Label 1025: @66826
     /*  66826 */   GIM_Try, /*On fail goto*//*Label 1026*/ GIMT_Encode4(66882), // Rule ID 2171 //
     /*  66831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  66834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_scalar_insert_exp_qp),
     /*  66839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  66842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  66845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  66848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  66852 */     // (intrinsic_wo_chain:{ *:[f128] } 10807:{ *:[iPTR] }, f128:{ *:[f128] }:$vA, i64:{ *:[i64] }:$vB)  =>  (XSIEXPQP:{ *:[f128] } ?:{ *:[f128] }:$vA, (MTVSRD:{ *:[f64] } ?:{ *:[i64] }:$vB))
     /*  66852 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  66855 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::MTVSRD),
     /*  66859 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66864 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vB
     /*  66868 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  66870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSIEXPQP),
     /*  66873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /*  66875 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  66877 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66880 */     GIR_RootConstrainSelectedInstOperands,
     /*  66881 */     // GIR_Coverage, 2171,
     /*  66881 */     GIR_EraseRootFromParent_Done,
     /*  66882 */   // Label 1026: @66882
     /*  66882 */   GIM_Try, /*On fail goto*//*Label 1027*/ GIMT_Encode4(66973), // Rule ID 3354 //
     /*  66887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  66890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvtlsbb),
     /*  66895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  66898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  66901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  66904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  66908 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  66912 */     // (intrinsic_wo_chain:{ *:[i32] } 10908:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XB, 1:{ *:[i32] })  =>  (EXTRACT_SUBREG:{ *:[i32] } (XVTLSBB:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] })), sub_lt:{ *:[i32] })
     /*  66912 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  66915 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66919 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66924 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // XB
     /*  66928 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66933 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  66936 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XVTLSBB),
     /*  66940 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66945 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  66948 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  66950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66955 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  66962 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  66967 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  66972 */     // GIR_Coverage, 3354,
     /*  66972 */     GIR_EraseRootFromParent_Done,
     /*  66973 */   // Label 1027: @66973
     /*  66973 */   GIM_Try, /*On fail goto*//*Label 1028*/ GIMT_Encode4(67064), // Rule ID 3355 //
     /*  66978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  66981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvtlsbb),
     /*  66986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  66989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  66992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  66995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  66999 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  67003 */     // (intrinsic_wo_chain:{ *:[i32] } 10908:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XB, 0:{ *:[i32] })  =>  (EXTRACT_SUBREG:{ *:[i32] } (XVTLSBB:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] })), sub_eq:{ *:[i32] })
     /*  67003 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  67006 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67010 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67015 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // XB
     /*  67019 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  67024 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  67027 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XVTLSBB),
     /*  67031 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67036 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  67039 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  67041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67046 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  67053 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  67058 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  67063 */     // GIR_Coverage, 3355,
     /*  67063 */     GIR_EraseRootFromParent_Done,
     /*  67064 */   // Label 1028: @67064
     /*  67064 */   GIM_Try, /*On fail goto*//*Label 1029*/ GIMT_Encode4(67107), // Rule ID 317 //
     /*  67069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  67072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vcfsx),
     /*  67077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67087 */     // MIs[0] Operand 3
     /*  67087 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /*  67098 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10324:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB, 0:{ *:[i32] })  =>  (VCFSX_0:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$VB)
     /*  67098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCFSX_0),
     /*  67101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  67103 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67105 */     GIR_RootConstrainSelectedInstOperands,
     /*  67106 */     // GIR_Coverage, 317,
     /*  67106 */     GIR_EraseRootFromParent_Done,
     /*  67107 */   // Label 1029: @67107
     /*  67107 */   GIM_Try, /*On fail goto*//*Label 1030*/ GIMT_Encode4(67150), // Rule ID 318 //
     /*  67112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  67115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vctuxs),
     /*  67120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67130 */     // MIs[0] Operand 3
     /*  67130 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /*  67141 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10386:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB, 0:{ *:[i32] })  =>  (VCTUXS_0:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$VB)
     /*  67141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCTUXS_0),
     /*  67144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  67146 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67148 */     GIR_RootConstrainSelectedInstOperands,
     /*  67149 */     // GIR_Coverage, 318,
     /*  67149 */     GIR_EraseRootFromParent_Done,
     /*  67150 */   // Label 1030: @67150
     /*  67150 */   GIM_Try, /*On fail goto*//*Label 1031*/ GIMT_Encode4(67193), // Rule ID 319 //
     /*  67155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  67158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vcfux),
     /*  67163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67173 */     // MIs[0] Operand 3
     /*  67173 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /*  67184 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10326:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB, 0:{ *:[i32] })  =>  (VCFUX_0:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$VB)
     /*  67184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCFUX_0),
     /*  67187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  67189 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67191 */     GIR_RootConstrainSelectedInstOperands,
     /*  67192 */     // GIR_Coverage, 319,
     /*  67192 */     GIR_EraseRootFromParent_Done,
     /*  67193 */   // Label 1031: @67193
     /*  67193 */   GIM_Try, /*On fail goto*//*Label 1032*/ GIMT_Encode4(67236), // Rule ID 320 //
     /*  67198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  67201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vctsxs),
     /*  67206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67216 */     // MIs[0] Operand 3
     /*  67216 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /*  67227 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10385:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB, 0:{ *:[i32] })  =>  (VCTSXS_0:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$VB)
     /*  67227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCTSXS_0),
     /*  67230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  67232 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67234 */     GIR_RootConstrainSelectedInstOperands,
     /*  67235 */     // GIR_Coverage, 320,
     /*  67235 */     GIR_EraseRootFromParent_Done,
     /*  67236 */   // Label 1032: @67236
     /*  67236 */   GIM_Try, /*On fail goto*//*Label 1033*/ GIMT_Encode4(67307), // Rule ID 3350 //
     /*  67241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  67244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxgenpcvbm),
     /*  67249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  67252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  67258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  67266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67270 */     // MIs[1] Operand 1
     /*  67270 */     // No operand predicates
     /*  67270 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  67272 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10923:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VRB, (imm:{ *:[i32] }):$IMM)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (XXGENPCVBM:{ *:[v4i32] } ?:{ *:[v16i8] }:$VRB, (imm:{ *:[i32] }):$IMM), VRRC:{ *:[i32] })
     /*  67272 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67275 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXGENPCVBM),
     /*  67279 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67284 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // VRB
     /*  67288 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // IMM
     /*  67291 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  67293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67298 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67301 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67306 */     // GIR_Coverage, 3350,
     /*  67306 */     GIR_EraseRootFromParent_Done,
     /*  67307 */   // Label 1033: @67307
     /*  67307 */   GIM_Try, /*On fail goto*//*Label 1034*/ GIMT_Encode4(67378), // Rule ID 3351 //
     /*  67312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  67315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxgenpcvhm),
     /*  67320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  67329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  67337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67341 */     // MIs[1] Operand 1
     /*  67341 */     // No operand predicates
     /*  67341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  67343 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10925:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VRB, (imm:{ *:[i32] }):$IMM)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } (XXGENPCVHM:{ *:[v4i32] } ?:{ *:[v8i16] }:$VRB, (imm:{ *:[i32] }):$IMM), VRRC:{ *:[i32] })
     /*  67343 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67346 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXGENPCVHM),
     /*  67350 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67355 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // VRB
     /*  67359 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // IMM
     /*  67362 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  67364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67369 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67372 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67377 */     // GIR_Coverage, 3351,
     /*  67377 */     GIR_EraseRootFromParent_Done,
     /*  67378 */   // Label 1034: @67378
     /*  67378 */   GIM_Try, /*On fail goto*//*Label 1035*/ GIMT_Encode4(67449), // Rule ID 3352 //
     /*  67383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  67386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxgenpcvwm),
     /*  67391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  67400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  67408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67412 */     // MIs[1] Operand 1
     /*  67412 */     // No operand predicates
     /*  67412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  67414 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10926:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VRB, (imm:{ *:[i32] }):$IMM)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } (XXGENPCVWM:{ *:[v4i32] } ?:{ *:[v4i32] }:$VRB, (imm:{ *:[i32] }):$IMM), VRRC:{ *:[i32] })
     /*  67414 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXGENPCVWM),
     /*  67421 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67426 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // VRB
     /*  67430 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // IMM
     /*  67433 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  67435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67440 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67443 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67448 */     // GIR_Coverage, 3352,
     /*  67448 */     GIR_EraseRootFromParent_Done,
     /*  67449 */   // Label 1035: @67449
     /*  67449 */   GIM_Try, /*On fail goto*//*Label 1036*/ GIMT_Encode4(67520), // Rule ID 3353 //
     /*  67454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  67457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxgenpcvdm),
     /*  67462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  67465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  67468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  67471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  67479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67483 */     // MIs[1] Operand 1
     /*  67483 */     // No operand predicates
     /*  67483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  67485 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10924:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VRB, (imm:{ *:[i32] }):$IMM)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } (XXGENPCVDM:{ *:[v4i32] } ?:{ *:[v2i64] }:$VRB, (imm:{ *:[i32] }):$IMM), VRRC:{ *:[i32] })
     /*  67485 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67488 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXGENPCVDM),
     /*  67492 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67497 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // VRB
     /*  67501 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // IMM
     /*  67504 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  67506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67511 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67514 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67519 */     // GIR_Coverage, 3353,
     /*  67519 */     GIR_EraseRootFromParent_Done,
     /*  67520 */   // Label 1036: @67520
     /*  67520 */   GIM_Try, /*On fail goto*//*Label 1037*/ GIMT_Encode4(67557), // Rule ID 313 //
     /*  67525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  67528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vcfsx),
     /*  67533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67543 */     // MIs[0] VA
     /*  67543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  67546 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10324:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB, (timm:{ *:[i32] }):$VA)  =>  (VCFSX:{ *:[v4f32] } (timm:{ *:[i32] }):$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  67546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCFSX),
     /*  67549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  67551 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  67553 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67555 */     GIR_RootConstrainSelectedInstOperands,
     /*  67556 */     // GIR_Coverage, 313,
     /*  67556 */     GIR_EraseRootFromParent_Done,
     /*  67557 */   // Label 1037: @67557
     /*  67557 */   GIM_Try, /*On fail goto*//*Label 1038*/ GIMT_Encode4(67594), // Rule ID 314 //
     /*  67562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  67565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vcfux),
     /*  67570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67580 */     // MIs[0] VA
     /*  67580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  67583 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10326:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB, (timm:{ *:[i32] }):$VA)  =>  (VCFUX:{ *:[v4f32] } (timm:{ *:[i32] }):$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  67583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCFUX),
     /*  67586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  67588 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  67590 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67592 */     GIR_RootConstrainSelectedInstOperands,
     /*  67593 */     // GIR_Coverage, 314,
     /*  67593 */     GIR_EraseRootFromParent_Done,
     /*  67594 */   // Label 1038: @67594
     /*  67594 */   GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(67631), // Rule ID 315 //
     /*  67599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  67602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vctsxs),
     /*  67607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67617 */     // MIs[0] VA
     /*  67617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  67620 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10385:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB, (timm:{ *:[i32] }):$VA)  =>  (VCTSXS:{ *:[v4i32] } (timm:{ *:[i32] }):$VA, v4f32:{ *:[v4f32] }:$VB)
     /*  67620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCTSXS),
     /*  67623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  67625 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  67627 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67629 */     GIR_RootConstrainSelectedInstOperands,
     /*  67630 */     // GIR_Coverage, 315,
     /*  67630 */     GIR_EraseRootFromParent_Done,
     /*  67631 */   // Label 1039: @67631
     /*  67631 */   GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(67668), // Rule ID 316 //
     /*  67636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  67639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vctuxs),
     /*  67644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67654 */     // MIs[0] VA
     /*  67654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  67657 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10386:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB, (timm:{ *:[i32] }):$VA)  =>  (VCTUXS:{ *:[v4i32] } (timm:{ *:[i32] }):$VA, v4f32:{ *:[v4f32] }:$VB)
     /*  67657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCTUXS),
     /*  67660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  67662 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  67664 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67666 */     GIR_RootConstrainSelectedInstOperands,
     /*  67667 */     // GIR_Coverage, 316,
     /*  67667 */     GIR_EraseRootFromParent_Done,
     /*  67668 */   // Label 1040: @67668
     /*  67668 */   GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(67708), // Rule ID 553 //
     /*  67673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  67676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_national2packed),
     /*  67681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  67684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67691 */     // MIs[0] PS
     /*  67691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  67694 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10795:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB, (timm:{ *:[i32] }):$PS)  =>  (BCDCFN_rec:{ *:[v16i8] }:{ *:[i32] } v16i8:{ *:[v16i8] }:$VB, (timm:{ *:[i32] }):$PS)
     /*  67694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::BCDCFN_rec),
     /*  67697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  67699 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67701 */     GIR_RootToRootCopy, /*OpIdx*/3, // PS
     /*  67703 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR6*/0,
     /*  67706 */     GIR_RootConstrainSelectedInstOperands,
     /*  67707 */     // GIR_Coverage, 553,
     /*  67707 */     GIR_EraseRootFromParent_Done,
     /*  67708 */   // Label 1041: @67708
     /*  67708 */   GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(67748), // Rule ID 554 //
     /*  67713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  67716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_zoned2packed),
     /*  67721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  67724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67731 */     // MIs[0] PS
     /*  67731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  67734 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10930:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB, (timm:{ *:[i32] }):$PS)  =>  (BCDCFZ_rec:{ *:[v16i8] }:{ *:[i32] } v16i8:{ *:[v16i8] }:$VB, (timm:{ *:[i32] }):$PS)
     /*  67734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::BCDCFZ_rec),
     /*  67737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  67739 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67741 */     GIR_RootToRootCopy, /*OpIdx*/3, // PS
     /*  67743 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR6*/0,
     /*  67746 */     GIR_RootConstrainSelectedInstOperands,
     /*  67747 */     // GIR_Coverage, 554,
     /*  67747 */     GIR_EraseRootFromParent_Done,
     /*  67748 */   // Label 1042: @67748
     /*  67748 */   GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(67788), // Rule ID 556 //
     /*  67753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  67756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_packed2zoned),
     /*  67761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  67764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67771 */     // MIs[0] PS
     /*  67771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  67774 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10798:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB, (timm:{ *:[i32] }):$PS)  =>  (BCDCTZ_rec:{ *:[v16i8] }:{ *:[i32] } v16i8:{ *:[v16i8] }:$VB, (timm:{ *:[i32] }):$PS)
     /*  67774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::BCDCTZ_rec),
     /*  67777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  67779 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67781 */     GIR_RootToRootCopy, /*OpIdx*/3, // PS
     /*  67783 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR6*/0,
     /*  67786 */     GIR_RootConstrainSelectedInstOperands,
     /*  67787 */     // GIR_Coverage, 556,
     /*  67787 */     GIR_EraseRootFromParent_Done,
     /*  67788 */   // Label 1043: @67788
     /*  67788 */   GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(67825), // Rule ID 1098 //
     /*  67793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  67796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vcntmbb),
     /*  67801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  67804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  67811 */     // MIs[0] MP
     /*  67811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  67814 */     // (intrinsic_wo_chain:{ *:[i64] } 10381:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB, (timm:{ *:[i32] }):$MP)  =>  (VCNTMBB:{ *:[i64] } v16i8:{ *:[v16i8] }:$VB, (timm:{ *:[i32] }):$MP)
     /*  67814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCNTMBB),
     /*  67817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RD]
     /*  67819 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67821 */     GIR_RootToRootCopy, /*OpIdx*/3, // MP
     /*  67823 */     GIR_RootConstrainSelectedInstOperands,
     /*  67824 */     // GIR_Coverage, 1098,
     /*  67824 */     GIR_EraseRootFromParent_Done,
     /*  67825 */   // Label 1044: @67825
     /*  67825 */   GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(67862), // Rule ID 1099 //
     /*  67830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  67833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vcntmbh),
     /*  67838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  67841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  67848 */     // MIs[0] MP
     /*  67848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  67851 */     // (intrinsic_wo_chain:{ *:[i64] } 10383:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VB, (timm:{ *:[i32] }):$MP)  =>  (VCNTMBH:{ *:[i64] } v8i16:{ *:[v8i16] }:$VB, (timm:{ *:[i32] }):$MP)
     /*  67851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCNTMBH),
     /*  67854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RD]
     /*  67856 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67858 */     GIR_RootToRootCopy, /*OpIdx*/3, // MP
     /*  67860 */     GIR_RootConstrainSelectedInstOperands,
     /*  67861 */     // GIR_Coverage, 1099,
     /*  67861 */     GIR_EraseRootFromParent_Done,
     /*  67862 */   // Label 1045: @67862
     /*  67862 */   GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(67899), // Rule ID 1100 //
     /*  67867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  67870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vcntmbw),
     /*  67875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  67878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  67885 */     // MIs[0] MP
     /*  67885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  67888 */     // (intrinsic_wo_chain:{ *:[i64] } 10384:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB, (timm:{ *:[i32] }):$MP)  =>  (VCNTMBW:{ *:[i64] } v4i32:{ *:[v4i32] }:$VB, (timm:{ *:[i32] }):$MP)
     /*  67888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCNTMBW),
     /*  67891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RD]
     /*  67893 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67895 */     GIR_RootToRootCopy, /*OpIdx*/3, // MP
     /*  67897 */     GIR_RootConstrainSelectedInstOperands,
     /*  67898 */     // GIR_Coverage, 1100,
     /*  67898 */     GIR_EraseRootFromParent_Done,
     /*  67899 */   // Label 1046: @67899
     /*  67899 */   GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(67936), // Rule ID 1101 //
     /*  67904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  67907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vcntmbd),
     /*  67912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  67915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  67918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  67922 */     // MIs[0] MP
     /*  67922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  67925 */     // (intrinsic_wo_chain:{ *:[i64] } 10382:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VB, (timm:{ *:[i32] }):$MP)  =>  (VCNTMBD:{ *:[i64] } v2i64:{ *:[v2i64] }:$VB, (timm:{ *:[i32] }):$MP)
     /*  67925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCNTMBD),
     /*  67928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RD]
     /*  67930 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67932 */     GIR_RootToRootCopy, /*OpIdx*/3, // MP
     /*  67934 */     GIR_RootConstrainSelectedInstOperands,
     /*  67935 */     // GIR_Coverage, 1101,
     /*  67935 */     GIR_EraseRootFromParent_Done,
     /*  67936 */   // Label 1047: @67936
     /*  67936 */   GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(67973), // Rule ID 1115 //
     /*  67941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  67944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vgnb),
     /*  67949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  67952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  67955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  67959 */     // MIs[0] N
     /*  67959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  67962 */     // (intrinsic_wo_chain:{ *:[i64] } 10421:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$VB, (timm:{ *:[i32] }):$N)  =>  (VGNB:{ *:[i64] } v1i128:{ *:[v1i128] }:$VB, (timm:{ *:[i32] }):$N)
     /*  67962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VGNB),
     /*  67965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RD]
     /*  67967 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67969 */     GIR_RootToRootCopy, /*OpIdx*/3, // N
     /*  67971 */     GIR_RootConstrainSelectedInstOperands,
     /*  67972 */     // GIR_Coverage, 1115,
     /*  67972 */     GIR_EraseRootFromParent_Done,
     /*  67973 */   // Label 1048: @67973
     /*  67973 */   GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(68010), // Rule ID 1169 //
     /*  67978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture),
     /*  67981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmsha3hash),
     /*  67986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2048s1,
     /*  67989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2048s1,
     /*  67992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRpRCRegClassID),
     /*  67996 */     // MIs[0] SR
     /*  67996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  67999 */     // (intrinsic_wo_chain:{ *:[v2048i1] } 10690:{ *:[iPTR] }, v2048i1:{ *:[v2048i1] }:$ATpi, (timm:{ *:[i32] }):$SR)  =>  (DMSHA3HASH:{ *:[v2048i1] } v2048i1:{ *:[v2048i1] }:$ATpi, (timm:{ *:[i32] }):$SR)
     /*  67999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMSHA3HASH),
     /*  68002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[ATp]
     /*  68004 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATpi
     /*  68006 */     GIR_RootToRootCopy, /*OpIdx*/3, // SR
     /*  68008 */     GIR_RootConstrainSelectedInstOperands,
     /*  68009 */     // GIR_Coverage, 1169,
     /*  68009 */     GIR_EraseRootFromParent_Done,
     /*  68010 */   // Label 1049: @68010
     /*  68010 */   GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(68055), // Rule ID 204 //
     /*  68015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasExtDiv),
     /*  68018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_divwe),
     /*  68023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  68026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  68029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  68032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68044 */     // (intrinsic_wo_chain:{ *:[i32] } 10625:{ *:[iPTR] }, gprc:{ *:[i32] }:$RA, gprc:{ *:[i32] }:$RB)  =>  (DIVWE:{ *:[i32] } gprc:{ *:[i32] }:$RA, gprc:{ *:[i32] }:$RB)
     /*  68044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DIVWE),
     /*  68047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  68049 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  68051 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  68053 */     GIR_RootConstrainSelectedInstOperands,
     /*  68054 */     // GIR_Coverage, 204,
     /*  68054 */     GIR_EraseRootFromParent_Done,
     /*  68055 */   // Label 1050: @68055
     /*  68055 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(68100), // Rule ID 205 //
     /*  68060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasExtDiv),
     /*  68063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_divweu),
     /*  68068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  68071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  68074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  68077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68089 */     // (intrinsic_wo_chain:{ *:[i32] } 10626:{ *:[iPTR] }, gprc:{ *:[i32] }:$RA, gprc:{ *:[i32] }:$RB)  =>  (DIVWEU:{ *:[i32] } gprc:{ *:[i32] }:$RA, gprc:{ *:[i32] }:$RB)
     /*  68089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DIVWEU),
     /*  68092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  68094 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  68096 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  68098 */     GIR_RootConstrainSelectedInstOperands,
     /*  68099 */     // GIR_Coverage, 205,
     /*  68099 */     GIR_EraseRootFromParent_Done,
     /*  68100 */   // Label 1051: @68100
     /*  68100 */   GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(68145), // Rule ID 690 //
     /*  68105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBPERMD),
     /*  68108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_bpermd),
     /*  68113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  68116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  68119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  68122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68134 */     // (intrinsic_wo_chain:{ *:[i64] } 10584:{ *:[iPTR] }, g8rc:{ *:[i64] }:$RST, g8rc:{ *:[i64] }:$RB)  =>  (BPERMD:{ *:[i64] } g8rc:{ *:[i64] }:$RST, g8rc:{ *:[i64] }:$RB)
     /*  68134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::BPERMD),
     /*  68137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  68139 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  68141 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  68143 */     GIR_RootConstrainSelectedInstOperands,
     /*  68144 */     // GIR_Coverage, 690,
     /*  68144 */     GIR_EraseRootFromParent_Done,
     /*  68145 */   // Label 1052: @68145
     /*  68145 */   GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(68190), // Rule ID 699 //
     /*  68150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasExtDiv),
     /*  68153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_divde),
     /*  68158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  68161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  68164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  68167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68179 */     // (intrinsic_wo_chain:{ *:[i64] } 10622:{ *:[iPTR] }, g8rc:{ *:[i64] }:$RA, g8rc:{ *:[i64] }:$RB)  =>  (DIVDE:{ *:[i64] } g8rc:{ *:[i64] }:$RA, g8rc:{ *:[i64] }:$RB)
     /*  68179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DIVDE),
     /*  68182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  68184 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  68186 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  68188 */     GIR_RootConstrainSelectedInstOperands,
     /*  68189 */     // GIR_Coverage, 699,
     /*  68189 */     GIR_EraseRootFromParent_Done,
     /*  68190 */   // Label 1053: @68190
     /*  68190 */   GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(68235), // Rule ID 704 //
     /*  68195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasExtDiv),
     /*  68198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_divdeu),
     /*  68203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  68206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  68209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  68212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68224 */     // (intrinsic_wo_chain:{ *:[i64] } 10623:{ *:[iPTR] }, g8rc:{ *:[i64] }:$RA, g8rc:{ *:[i64] }:$RB)  =>  (DIVDEU:{ *:[i64] } g8rc:{ *:[i64] }:$RA, g8rc:{ *:[i64] }:$RB)
     /*  68224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DIVDEU),
     /*  68227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  68229 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  68231 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  68233 */     GIR_RootConstrainSelectedInstOperands,
     /*  68234 */     // GIR_Coverage, 704,
     /*  68234 */     GIR_EraseRootFromParent_Done,
     /*  68235 */   // Label 1054: @68235
     /*  68235 */   GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(68301), // Rule ID 1564 //
     /*  68240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode_IsISA3_0),
     /*  68243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_cmpeqb),
     /*  68248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  68251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  68254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  68257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68269 */     // (intrinsic_wo_chain:{ *:[i64] } 10592:{ *:[iPTR] }, g8rc:{ *:[i64] }:$a, g8rc:{ *:[i64] }:$b)  =>  (SETB8:{ *:[i64] } (CMPEQB:{ *:[i32] } ?:{ *:[i64] }:$a, ?:{ *:[i64] }:$b))
     /*  68269 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  68272 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPEQB),
     /*  68276 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68281 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // a
     /*  68285 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // b
     /*  68289 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  68291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETB8),
     /*  68294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  68296 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68299 */     GIR_RootConstrainSelectedInstOperands,
     /*  68300 */     // GIR_Coverage, 1564,
     /*  68300 */     GIR_EraseRootFromParent_Done,
     /*  68301 */   // Label 1055: @68301
     /*  68301 */   GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(68367), // Rule ID 1565 //
     /*  68306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode_IsISA3_0),
     /*  68309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_setb),
     /*  68314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  68317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  68320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  68323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68335 */     // (intrinsic_wo_chain:{ *:[i64] } 10812:{ *:[iPTR] }, g8rc:{ *:[i64] }:$a, g8rc:{ *:[i64] }:$b)  =>  (SETB8:{ *:[i64] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$a, ?:{ *:[i64] }:$b))
     /*  68335 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  68338 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /*  68342 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68347 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // a
     /*  68351 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // b
     /*  68355 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  68357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETB8),
     /*  68360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  68362 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68365 */     GIR_RootConstrainSelectedInstOperands,
     /*  68366 */     // GIR_Coverage, 1565,
     /*  68366 */     GIR_EraseRootFromParent_Done,
     /*  68367 */   // Label 1056: @68367
     /*  68367 */   GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(68412), // Rule ID 1569 //
     /*  68372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  68375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mulhd),
     /*  68380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  68383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  68386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  68389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68401 */     // (intrinsic_wo_chain:{ *:[i64] } 10791:{ *:[iPTR] }, g8rc:{ *:[i64] }:$a, g8rc:{ *:[i64] }:$b)  =>  (MULHD:{ *:[i64] } ?:{ *:[i64] }:$a, ?:{ *:[i64] }:$b)
     /*  68401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MULHD),
     /*  68404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  68406 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  68408 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  68410 */     GIR_RootConstrainSelectedInstOperands,
     /*  68411 */     // GIR_Coverage, 1569,
     /*  68411 */     GIR_EraseRootFromParent_Done,
     /*  68412 */   // Label 1057: @68412
     /*  68412 */   GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(68457), // Rule ID 1570 //
     /*  68417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  68420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mulhdu),
     /*  68425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  68428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  68431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  68434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68446 */     // (intrinsic_wo_chain:{ *:[i64] } 10792:{ *:[iPTR] }, g8rc:{ *:[i64] }:$a, g8rc:{ *:[i64] }:$b)  =>  (MULHDU:{ *:[i64] } ?:{ *:[i64] }:$a, ?:{ *:[i64] }:$b)
     /*  68446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MULHDU),
     /*  68449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  68451 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  68453 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  68455 */     GIR_RootConstrainSelectedInstOperands,
     /*  68456 */     // GIR_Coverage, 1570,
     /*  68456 */     GIR_EraseRootFromParent_Done,
     /*  68457 */   // Label 1058: @68457
     /*  68457 */   GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(68499), // Rule ID 1573 //
     /*  68462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_cmpb),
     /*  68467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  68470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  68473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  68476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68488 */     // (intrinsic_wo_chain:{ *:[i64] } 10591:{ *:[iPTR] }, g8rc:{ *:[i64] }:$a, g8rc:{ *:[i64] }:$b)  =>  (CMPB8:{ *:[i64] } ?:{ *:[i64] }:$a, ?:{ *:[i64] }:$b)
     /*  68488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CMPB8),
     /*  68491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  68493 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  68495 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  68497 */     GIR_RootConstrainSelectedInstOperands,
     /*  68498 */     // GIR_Coverage, 1573,
     /*  68498 */     GIR_EraseRootFromParent_Done,
     /*  68499 */   // Label 1059: @68499
     /*  68499 */   GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(68541), // Rule ID 4882 //
     /*  68504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mulhw),
     /*  68509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  68512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  68515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  68518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68530 */     // (intrinsic_wo_chain:{ *:[i32] } 10793:{ *:[iPTR] }, gprc:{ *:[i32] }:$a, gprc:{ *:[i32] }:$b)  =>  (MULHW:{ *:[i32] } ?:{ *:[i32] }:$a, ?:{ *:[i32] }:$b)
     /*  68530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MULHW),
     /*  68533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  68535 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  68537 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  68539 */     GIR_RootConstrainSelectedInstOperands,
     /*  68540 */     // GIR_Coverage, 4882,
     /*  68540 */     GIR_EraseRootFromParent_Done,
     /*  68541 */   // Label 1060: @68541
     /*  68541 */   GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(68583), // Rule ID 4883 //
     /*  68546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mulhwu),
     /*  68551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  68554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  68557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  68560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68572 */     // (intrinsic_wo_chain:{ *:[i32] } 10794:{ *:[iPTR] }, gprc:{ *:[i32] }:$a, gprc:{ *:[i32] }:$b)  =>  (MULHWU:{ *:[i32] } ?:{ *:[i32] }:$a, ?:{ *:[i32] }:$b)
     /*  68572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MULHWU),
     /*  68575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  68577 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  68579 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  68581 */     GIR_RootConstrainSelectedInstOperands,
     /*  68582 */     // GIR_Coverage, 4883,
     /*  68582 */     GIR_EraseRootFromParent_Done,
     /*  68583 */   // Label 1061: @68583
     /*  68583 */   GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(68625), // Rule ID 4884 //
     /*  68588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_cmpb),
     /*  68593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  68596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  68599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  68602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68614 */     // (intrinsic_wo_chain:{ *:[i32] } 10591:{ *:[iPTR] }, gprc:{ *:[i32] }:$a, gprc:{ *:[i32] }:$b)  =>  (CMPB:{ *:[i32] } ?:{ *:[i32] }:$a, ?:{ *:[i32] }:$b)
     /*  68614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CMPB),
     /*  68617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  68619 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  68621 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  68623 */     GIR_RootConstrainSelectedInstOperands,
     /*  68624 */     // GIR_Coverage, 4884,
     /*  68624 */     GIR_EraseRootFromParent_Done,
     /*  68625 */   // Label 1062: @68625
     /*  68625 */   GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(68659), // Rule ID 76 //
     /*  68630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_addg6s),
     /*  68635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  68638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  68641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  68644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68648 */     // (intrinsic_wo_chain:{ *:[i32] } 10263:{ *:[iPTR] }, i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)  =>  (ADDG6S:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*  68648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ADDG6S),
     /*  68651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  68653 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  68655 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  68657 */     GIR_RootConstrainSelectedInstOperands,
     /*  68658 */     // GIR_Coverage, 76,
     /*  68658 */     GIR_EraseRootFromParent_Done,
     /*  68659 */   // Label 1063: @68659
     /*  68659 */   GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(68696), // Rule ID 304 //
     /*  68664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vaddcuw),
     /*  68672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68685 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10307:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VADDCUW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  68685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VADDCUW),
     /*  68688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68690 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68692 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68694 */     GIR_RootConstrainSelectedInstOperands,
     /*  68695 */     // GIR_Coverage, 304,
     /*  68695 */     GIR_EraseRootFromParent_Done,
     /*  68696 */   // Label 1064: @68696
     /*  68696 */   GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(68733), // Rule ID 305 //
     /*  68701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vaddsbs),
     /*  68709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  68712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  68718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68722 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10310:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VADDSBS:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  68722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VADDSBS),
     /*  68725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68727 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68729 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68731 */     GIR_RootConstrainSelectedInstOperands,
     /*  68732 */     // GIR_Coverage, 305,
     /*  68732 */     GIR_EraseRootFromParent_Done,
     /*  68733 */   // Label 1065: @68733
     /*  68733 */   GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(68770), // Rule ID 306 //
     /*  68738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vaddshs),
     /*  68746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68759 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10311:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VADDSHS:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  68759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VADDSHS),
     /*  68762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68764 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68766 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68768 */     GIR_RootConstrainSelectedInstOperands,
     /*  68769 */     // GIR_Coverage, 306,
     /*  68769 */     GIR_EraseRootFromParent_Done,
     /*  68770 */   // Label 1066: @68770
     /*  68770 */   GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(68807), // Rule ID 307 //
     /*  68775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vaddsws),
     /*  68783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68796 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10312:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VADDSWS:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  68796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VADDSWS),
     /*  68799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68801 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68803 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68805 */     GIR_RootConstrainSelectedInstOperands,
     /*  68806 */     // GIR_Coverage, 307,
     /*  68806 */     GIR_EraseRootFromParent_Done,
     /*  68807 */   // Label 1067: @68807
     /*  68807 */   GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(68844), // Rule ID 308 //
     /*  68812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vaddubs),
     /*  68820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  68823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  68829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68833 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10313:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VADDUBS:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  68833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VADDUBS),
     /*  68836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68838 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68840 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68842 */     GIR_RootConstrainSelectedInstOperands,
     /*  68843 */     // GIR_Coverage, 308,
     /*  68843 */     GIR_EraseRootFromParent_Done,
     /*  68844 */   // Label 1068: @68844
     /*  68844 */   GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(68881), // Rule ID 309 //
     /*  68849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vadduhs),
     /*  68857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68870 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10314:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VADDUHS:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  68870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VADDUHS),
     /*  68873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68875 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68877 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68879 */     GIR_RootConstrainSelectedInstOperands,
     /*  68880 */     // GIR_Coverage, 309,
     /*  68880 */     GIR_EraseRootFromParent_Done,
     /*  68881 */   // Label 1069: @68881
     /*  68881 */   GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(68918), // Rule ID 310 //
     /*  68886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vadduws),
     /*  68894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68907 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10315:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VADDUWS:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  68907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VADDUWS),
     /*  68910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68912 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68914 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68916 */     GIR_RootConstrainSelectedInstOperands,
     /*  68917 */     // GIR_Coverage, 310,
     /*  68917 */     GIR_EraseRootFromParent_Done,
     /*  68918 */   // Label 1070: @68918
     /*  68918 */   GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(68955), // Rule ID 323 //
     /*  68923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vavgsb),
     /*  68931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  68934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  68940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68944 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10316:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VAVGSB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  68944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VAVGSB),
     /*  68947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68949 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68951 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68953 */     GIR_RootConstrainSelectedInstOperands,
     /*  68954 */     // GIR_Coverage, 323,
     /*  68954 */     GIR_EraseRootFromParent_Done,
     /*  68955 */   // Label 1071: @68955
     /*  68955 */   GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(68992), // Rule ID 324 //
     /*  68960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vavgsh),
     /*  68968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68981 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10317:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VAVGSH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  68981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VAVGSH),
     /*  68984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68986 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68988 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68990 */     GIR_RootConstrainSelectedInstOperands,
     /*  68991 */     // GIR_Coverage, 324,
     /*  68991 */     GIR_EraseRootFromParent_Done,
     /*  68992 */   // Label 1072: @68992
     /*  68992 */   GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(69029), // Rule ID 325 //
     /*  68997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vavgsw),
     /*  69005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69018 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10318:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VAVGSW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  69018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VAVGSW),
     /*  69021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69023 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69025 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69027 */     GIR_RootConstrainSelectedInstOperands,
     /*  69028 */     // GIR_Coverage, 325,
     /*  69028 */     GIR_EraseRootFromParent_Done,
     /*  69029 */   // Label 1073: @69029
     /*  69029 */   GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(69066), // Rule ID 326 //
     /*  69034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vavgub),
     /*  69042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  69045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69055 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10319:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VAVGUB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  69055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VAVGUB),
     /*  69058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69060 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69062 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69064 */     GIR_RootConstrainSelectedInstOperands,
     /*  69065 */     // GIR_Coverage, 326,
     /*  69065 */     GIR_EraseRootFromParent_Done,
     /*  69066 */   // Label 1074: @69066
     /*  69066 */   GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(69103), // Rule ID 327 //
     /*  69071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vavguh),
     /*  69079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69092 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10320:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VAVGUH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  69092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VAVGUH),
     /*  69095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69097 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69099 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69101 */     GIR_RootConstrainSelectedInstOperands,
     /*  69102 */     // GIR_Coverage, 327,
     /*  69102 */     GIR_EraseRootFromParent_Done,
     /*  69103 */   // Label 1075: @69103
     /*  69103 */   GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(69140), // Rule ID 328 //
     /*  69108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vavguw),
     /*  69116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69129 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10321:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VAVGUW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  69129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VAVGUW),
     /*  69132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69134 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69136 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69138 */     GIR_RootConstrainSelectedInstOperands,
     /*  69139 */     // GIR_Coverage, 328,
     /*  69139 */     GIR_EraseRootFromParent_Done,
     /*  69140 */   // Label 1076: @69140
     /*  69140 */   GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(69177), // Rule ID 329 //
     /*  69145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmaxfp),
     /*  69153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69166 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10440:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VA, v4f32:{ *:[v4f32] }:$VB)  =>  (VMAXFP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VA, v4f32:{ *:[v4f32] }:$VB)
     /*  69166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMAXFP),
     /*  69169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69171 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69173 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69175 */     GIR_RootConstrainSelectedInstOperands,
     /*  69176 */     // GIR_Coverage, 329,
     /*  69176 */     GIR_EraseRootFromParent_Done,
     /*  69177 */   // Label 1077: @69177
     /*  69177 */   GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(69214), // Rule ID 330 //
     /*  69182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmaxsb),
     /*  69190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  69193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69203 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10441:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VMAXSB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  69203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMAXSB),
     /*  69206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69208 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69210 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69212 */     GIR_RootConstrainSelectedInstOperands,
     /*  69213 */     // GIR_Coverage, 330,
     /*  69213 */     GIR_EraseRootFromParent_Done,
     /*  69214 */   // Label 1078: @69214
     /*  69214 */   GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(69251), // Rule ID 331 //
     /*  69219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmaxsh),
     /*  69227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69240 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10443:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VMAXSH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  69240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMAXSH),
     /*  69243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69245 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69247 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69249 */     GIR_RootConstrainSelectedInstOperands,
     /*  69250 */     // GIR_Coverage, 331,
     /*  69250 */     GIR_EraseRootFromParent_Done,
     /*  69251 */   // Label 1079: @69251
     /*  69251 */   GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(69288), // Rule ID 332 //
     /*  69256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmaxsw),
     /*  69264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69277 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10444:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMAXSW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  69277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMAXSW),
     /*  69280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69282 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69284 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69286 */     GIR_RootConstrainSelectedInstOperands,
     /*  69287 */     // GIR_Coverage, 332,
     /*  69287 */     GIR_EraseRootFromParent_Done,
     /*  69288 */   // Label 1080: @69288
     /*  69288 */   GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(69325), // Rule ID 333 //
     /*  69293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmaxub),
     /*  69301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  69304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69314 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10445:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VMAXUB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  69314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMAXUB),
     /*  69317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69319 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69321 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69323 */     GIR_RootConstrainSelectedInstOperands,
     /*  69324 */     // GIR_Coverage, 333,
     /*  69324 */     GIR_EraseRootFromParent_Done,
     /*  69325 */   // Label 1081: @69325
     /*  69325 */   GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(69362), // Rule ID 334 //
     /*  69330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmaxuh),
     /*  69338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69351 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10447:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VMAXUH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  69351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMAXUH),
     /*  69354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69356 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69358 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69360 */     GIR_RootConstrainSelectedInstOperands,
     /*  69361 */     // GIR_Coverage, 334,
     /*  69361 */     GIR_EraseRootFromParent_Done,
     /*  69362 */   // Label 1082: @69362
     /*  69362 */   GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(69399), // Rule ID 335 //
     /*  69367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmaxuw),
     /*  69375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69388 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10448:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMAXUW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  69388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMAXUW),
     /*  69391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69393 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69395 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69397 */     GIR_RootConstrainSelectedInstOperands,
     /*  69398 */     // GIR_Coverage, 335,
     /*  69398 */     GIR_EraseRootFromParent_Done,
     /*  69399 */   // Label 1083: @69399
     /*  69399 */   GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(69436), // Rule ID 336 //
     /*  69404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vminfp),
     /*  69412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69425 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10451:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VA, v4f32:{ *:[v4f32] }:$VB)  =>  (VMINFP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VA, v4f32:{ *:[v4f32] }:$VB)
     /*  69425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMINFP),
     /*  69428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69430 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69432 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69434 */     GIR_RootConstrainSelectedInstOperands,
     /*  69435 */     // GIR_Coverage, 336,
     /*  69435 */     GIR_EraseRootFromParent_Done,
     /*  69436 */   // Label 1084: @69436
     /*  69436 */   GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(69473), // Rule ID 337 //
     /*  69441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vminsb),
     /*  69449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  69452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69462 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10452:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VMINSB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  69462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMINSB),
     /*  69465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69467 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69469 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69471 */     GIR_RootConstrainSelectedInstOperands,
     /*  69472 */     // GIR_Coverage, 337,
     /*  69472 */     GIR_EraseRootFromParent_Done,
     /*  69473 */   // Label 1085: @69473
     /*  69473 */   GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(69510), // Rule ID 338 //
     /*  69478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vminsh),
     /*  69486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69499 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10454:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VMINSH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  69499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMINSH),
     /*  69502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69504 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69506 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69508 */     GIR_RootConstrainSelectedInstOperands,
     /*  69509 */     // GIR_Coverage, 338,
     /*  69509 */     GIR_EraseRootFromParent_Done,
     /*  69510 */   // Label 1086: @69510
     /*  69510 */   GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(69547), // Rule ID 339 //
     /*  69515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vminsw),
     /*  69523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69536 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10455:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMINSW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  69536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMINSW),
     /*  69539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69541 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69543 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69545 */     GIR_RootConstrainSelectedInstOperands,
     /*  69546 */     // GIR_Coverage, 339,
     /*  69546 */     GIR_EraseRootFromParent_Done,
     /*  69547 */   // Label 1087: @69547
     /*  69547 */   GIM_Try, /*On fail goto*//*Label 1088*/ GIMT_Encode4(69584), // Rule ID 340 //
     /*  69552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vminub),
     /*  69560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  69563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69573 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10456:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VMINUB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  69573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMINUB),
     /*  69576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69578 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69580 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69582 */     GIR_RootConstrainSelectedInstOperands,
     /*  69583 */     // GIR_Coverage, 340,
     /*  69583 */     GIR_EraseRootFromParent_Done,
     /*  69584 */   // Label 1088: @69584
     /*  69584 */   GIM_Try, /*On fail goto*//*Label 1089*/ GIMT_Encode4(69621), // Rule ID 341 //
     /*  69589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vminuh),
     /*  69597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69610 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10458:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VMINUH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  69610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMINUH),
     /*  69613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69615 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69617 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69619 */     GIR_RootConstrainSelectedInstOperands,
     /*  69620 */     // GIR_Coverage, 341,
     /*  69620 */     GIR_EraseRootFromParent_Done,
     /*  69621 */   // Label 1089: @69621
     /*  69621 */   GIM_Try, /*On fail goto*//*Label 1090*/ GIMT_Encode4(69658), // Rule ID 342 //
     /*  69626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vminuw),
     /*  69634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69647 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10459:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMINUW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  69647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMINUW),
     /*  69650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69652 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69654 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69656 */     GIR_RootConstrainSelectedInstOperands,
     /*  69657 */     // GIR_Coverage, 342,
     /*  69657 */     GIR_EraseRootFromParent_Done,
     /*  69658 */   // Label 1090: @69658
     /*  69658 */   GIM_Try, /*On fail goto*//*Label 1091*/ GIMT_Encode4(69695), // Rule ID 355 //
     /*  69663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulesb),
     /*  69671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69684 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10469:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VMULESB:{ *:[v8i16] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  69684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULESB),
     /*  69687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69689 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69691 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69693 */     GIR_RootConstrainSelectedInstOperands,
     /*  69694 */     // GIR_Coverage, 355,
     /*  69694 */     GIR_EraseRootFromParent_Done,
     /*  69695 */   // Label 1091: @69695
     /*  69695 */   GIM_Try, /*On fail goto*//*Label 1092*/ GIMT_Encode4(69732), // Rule ID 356 //
     /*  69700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulesh),
     /*  69708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69721 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10471:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VMULESH:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  69721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULESH),
     /*  69724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69726 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69728 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69730 */     GIR_RootConstrainSelectedInstOperands,
     /*  69731 */     // GIR_Coverage, 356,
     /*  69731 */     GIR_EraseRootFromParent_Done,
     /*  69732 */   // Label 1092: @69732
     /*  69732 */   GIM_Try, /*On fail goto*//*Label 1093*/ GIMT_Encode4(69769), // Rule ID 357 //
     /*  69737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmuleub),
     /*  69745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69758 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10473:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VMULEUB:{ *:[v8i16] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  69758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULEUB),
     /*  69761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69763 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69765 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69767 */     GIR_RootConstrainSelectedInstOperands,
     /*  69768 */     // GIR_Coverage, 357,
     /*  69768 */     GIR_EraseRootFromParent_Done,
     /*  69769 */   // Label 1093: @69769
     /*  69769 */   GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(69806), // Rule ID 358 //
     /*  69774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmuleuh),
     /*  69782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69795 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10475:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VMULEUH:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  69795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULEUH),
     /*  69798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69800 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69802 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69804 */     GIR_RootConstrainSelectedInstOperands,
     /*  69805 */     // GIR_Coverage, 358,
     /*  69805 */     GIR_EraseRootFromParent_Done,
     /*  69806 */   // Label 1094: @69806
     /*  69806 */   GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(69843), // Rule ID 359 //
     /*  69811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulosb),
     /*  69819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69832 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10481:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VMULOSB:{ *:[v8i16] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  69832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULOSB),
     /*  69835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69837 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69839 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69841 */     GIR_RootConstrainSelectedInstOperands,
     /*  69842 */     // GIR_Coverage, 359,
     /*  69842 */     GIR_EraseRootFromParent_Done,
     /*  69843 */   // Label 1095: @69843
     /*  69843 */   GIM_Try, /*On fail goto*//*Label 1096*/ GIMT_Encode4(69880), // Rule ID 360 //
     /*  69848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulosh),
     /*  69856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69869 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10483:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VMULOSH:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  69869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULOSH),
     /*  69872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69874 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69876 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69878 */     GIR_RootConstrainSelectedInstOperands,
     /*  69879 */     // GIR_Coverage, 360,
     /*  69879 */     GIR_EraseRootFromParent_Done,
     /*  69880 */   // Label 1096: @69880
     /*  69880 */   GIM_Try, /*On fail goto*//*Label 1097*/ GIMT_Encode4(69917), // Rule ID 361 //
     /*  69885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmuloub),
     /*  69893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69906 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10485:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VMULOUB:{ *:[v8i16] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  69906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULOUB),
     /*  69909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69911 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69913 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69915 */     GIR_RootConstrainSelectedInstOperands,
     /*  69916 */     // GIR_Coverage, 361,
     /*  69916 */     GIR_EraseRootFromParent_Done,
     /*  69917 */   // Label 1097: @69917
     /*  69917 */   GIM_Try, /*On fail goto*//*Label 1098*/ GIMT_Encode4(69954), // Rule ID 362 //
     /*  69922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulouh),
     /*  69930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69943 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10487:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VMULOUH:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  69943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULOUH),
     /*  69946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69948 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69950 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69952 */     GIR_RootConstrainSelectedInstOperands,
     /*  69953 */     // GIR_Coverage, 362,
     /*  69953 */     GIR_EraseRootFromParent_Done,
     /*  69954 */   // Label 1098: @69954
     /*  69954 */   GIM_Try, /*On fail goto*//*Label 1099*/ GIMT_Encode4(69991), // Rule ID 369 //
     /*  69959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsubcuw),
     /*  69967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69980 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10549:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSUBCUW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  69980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUBCUW),
     /*  69983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69985 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69987 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69989 */     GIR_RootConstrainSelectedInstOperands,
     /*  69990 */     // GIR_Coverage, 369,
     /*  69990 */     GIR_EraseRootFromParent_Done,
     /*  69991 */   // Label 1099: @69991
     /*  69991 */   GIM_Try, /*On fail goto*//*Label 1100*/ GIMT_Encode4(70028), // Rule ID 374 //
     /*  69996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsubsbs),
     /*  70004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  70007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  70010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70017 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10552:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VSUBSBS:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  70017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUBSBS),
     /*  70020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70022 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70024 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70026 */     GIR_RootConstrainSelectedInstOperands,
     /*  70027 */     // GIR_Coverage, 374,
     /*  70027 */     GIR_EraseRootFromParent_Done,
     /*  70028 */   // Label 1100: @70028
     /*  70028 */   GIM_Try, /*On fail goto*//*Label 1101*/ GIMT_Encode4(70065), // Rule ID 375 //
     /*  70033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsubshs),
     /*  70041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  70044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  70050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70054 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10553:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VSUBSHS:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  70054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUBSHS),
     /*  70057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70059 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70061 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70063 */     GIR_RootConstrainSelectedInstOperands,
     /*  70064 */     // GIR_Coverage, 375,
     /*  70064 */     GIR_EraseRootFromParent_Done,
     /*  70065 */   // Label 1101: @70065
     /*  70065 */   GIM_Try, /*On fail goto*//*Label 1102*/ GIMT_Encode4(70102), // Rule ID 376 //
     /*  70070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsubsws),
     /*  70078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70091 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10554:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSUBSWS:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUBSWS),
     /*  70094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70096 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70098 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70100 */     GIR_RootConstrainSelectedInstOperands,
     /*  70101 */     // GIR_Coverage, 376,
     /*  70101 */     GIR_EraseRootFromParent_Done,
     /*  70102 */   // Label 1102: @70102
     /*  70102 */   GIM_Try, /*On fail goto*//*Label 1103*/ GIMT_Encode4(70139), // Rule ID 377 //
     /*  70107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsububs),
     /*  70115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  70118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  70121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70128 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10555:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VSUBUBS:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  70128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUBUBS),
     /*  70131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70133 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70135 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70137 */     GIR_RootConstrainSelectedInstOperands,
     /*  70138 */     // GIR_Coverage, 377,
     /*  70138 */     GIR_EraseRootFromParent_Done,
     /*  70139 */   // Label 1103: @70139
     /*  70139 */   GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(70176), // Rule ID 378 //
     /*  70144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsubuhs),
     /*  70152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  70155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  70161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70165 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10556:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VSUBUHS:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  70165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUBUHS),
     /*  70168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70170 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70172 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70174 */     GIR_RootConstrainSelectedInstOperands,
     /*  70175 */     // GIR_Coverage, 378,
     /*  70175 */     GIR_EraseRootFromParent_Done,
     /*  70176 */   // Label 1104: @70176
     /*  70176 */   GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(70213), // Rule ID 379 //
     /*  70181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsubuws),
     /*  70189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70202 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10557:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSUBUWS:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUBUWS),
     /*  70205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70207 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70209 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70211 */     GIR_RootConstrainSelectedInstOperands,
     /*  70212 */     // GIR_Coverage, 379,
     /*  70212 */     GIR_EraseRootFromParent_Done,
     /*  70213 */   // Label 1105: @70213
     /*  70213 */   GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(70250), // Rule ID 388 //
     /*  70218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrlb),
     /*  70226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  70229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  70232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70239 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10511:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VRLB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  70239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRLB),
     /*  70242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70244 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70246 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70248 */     GIR_RootConstrainSelectedInstOperands,
     /*  70249 */     // GIR_Coverage, 388,
     /*  70249 */     GIR_EraseRootFromParent_Done,
     /*  70250 */   // Label 1106: @70250
     /*  70250 */   GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(70287), // Rule ID 389 //
     /*  70255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrlh),
     /*  70263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  70266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  70272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70276 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10515:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VRLH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  70276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRLH),
     /*  70279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70281 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70283 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70285 */     GIR_RootConstrainSelectedInstOperands,
     /*  70286 */     // GIR_Coverage, 389,
     /*  70286 */     GIR_EraseRootFromParent_Done,
     /*  70287 */   // Label 1107: @70287
     /*  70287 */   GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(70324), // Rule ID 390 //
     /*  70292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrlw),
     /*  70300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70313 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10518:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VRLW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRLW),
     /*  70316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70318 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70320 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70322 */     GIR_RootConstrainSelectedInstOperands,
     /*  70323 */     // GIR_Coverage, 390,
     /*  70323 */     GIR_EraseRootFromParent_Done,
     /*  70324 */   // Label 1108: @70324
     /*  70324 */   GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(70361), // Rule ID 391 //
     /*  70329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsl),
     /*  70337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70350 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10523:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSL:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSL),
     /*  70353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70355 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70357 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70359 */     GIR_RootConstrainSelectedInstOperands,
     /*  70360 */     // GIR_Coverage, 391,
     /*  70360 */     GIR_EraseRootFromParent_Done,
     /*  70361 */   // Label 1109: @70361
     /*  70361 */   GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(70398), // Rule ID 392 //
     /*  70366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vslo),
     /*  70374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70387 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10527:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSLO:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSLO),
     /*  70390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70392 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70394 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70396 */     GIR_RootConstrainSelectedInstOperands,
     /*  70397 */     // GIR_Coverage, 392,
     /*  70397 */     GIR_EraseRootFromParent_Done,
     /*  70398 */   // Label 1110: @70398
     /*  70398 */   GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(70435), // Rule ID 393 //
     /*  70403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vslb),
     /*  70411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  70414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  70417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70424 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10524:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VSLB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  70424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSLB),
     /*  70427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70429 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70431 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70433 */     GIR_RootConstrainSelectedInstOperands,
     /*  70434 */     // GIR_Coverage, 393,
     /*  70434 */     GIR_EraseRootFromParent_Done,
     /*  70435 */   // Label 1111: @70435
     /*  70435 */   GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(70472), // Rule ID 394 //
     /*  70440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vslh),
     /*  70448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  70451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  70457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70461 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10526:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VSLH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  70461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSLH),
     /*  70464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70466 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70468 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70470 */     GIR_RootConstrainSelectedInstOperands,
     /*  70471 */     // GIR_Coverage, 394,
     /*  70471 */     GIR_EraseRootFromParent_Done,
     /*  70472 */   // Label 1112: @70472
     /*  70472 */   GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(70509), // Rule ID 395 //
     /*  70477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vslw),
     /*  70485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70498 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10529:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSLW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSLW),
     /*  70501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70503 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70505 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70507 */     GIR_RootConstrainSelectedInstOperands,
     /*  70508 */     // GIR_Coverage, 395,
     /*  70508 */     GIR_EraseRootFromParent_Done,
     /*  70509 */   // Label 1113: @70509
     /*  70509 */   GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(70546), // Rule ID 399 //
     /*  70514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsr),
     /*  70522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70535 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10530:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSR:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSR),
     /*  70538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70540 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70542 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70544 */     GIR_RootConstrainSelectedInstOperands,
     /*  70545 */     // GIR_Coverage, 399,
     /*  70545 */     GIR_EraseRootFromParent_Done,
     /*  70546 */   // Label 1114: @70546
     /*  70546 */   GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(70583), // Rule ID 400 //
     /*  70551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsro),
     /*  70559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70572 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10537:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSRO:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSRO),
     /*  70575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70577 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70579 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70581 */     GIR_RootConstrainSelectedInstOperands,
     /*  70582 */     // GIR_Coverage, 400,
     /*  70582 */     GIR_EraseRootFromParent_Done,
     /*  70583 */   // Label 1115: @70583
     /*  70583 */   GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(70620), // Rule ID 401 //
     /*  70588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsrab),
     /*  70596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  70599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  70602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70609 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10531:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VSRAB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  70609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSRAB),
     /*  70612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70614 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70616 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70618 */     GIR_RootConstrainSelectedInstOperands,
     /*  70619 */     // GIR_Coverage, 401,
     /*  70619 */     GIR_EraseRootFromParent_Done,
     /*  70620 */   // Label 1116: @70620
     /*  70620 */   GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(70657), // Rule ID 402 //
     /*  70625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsrah),
     /*  70633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  70636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  70642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70646 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10532:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VSRAH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  70646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSRAH),
     /*  70649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70651 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70653 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70655 */     GIR_RootConstrainSelectedInstOperands,
     /*  70656 */     // GIR_Coverage, 402,
     /*  70656 */     GIR_EraseRootFromParent_Done,
     /*  70657 */   // Label 1117: @70657
     /*  70657 */   GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(70694), // Rule ID 403 //
     /*  70662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsraw),
     /*  70670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70683 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10533:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSRAW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSRAW),
     /*  70686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70688 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70690 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70692 */     GIR_RootConstrainSelectedInstOperands,
     /*  70693 */     // GIR_Coverage, 403,
     /*  70693 */     GIR_EraseRootFromParent_Done,
     /*  70694 */   // Label 1118: @70694
     /*  70694 */   GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(70731), // Rule ID 404 //
     /*  70699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsrb),
     /*  70707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  70710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  70713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70720 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10534:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VSRB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  70720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSRB),
     /*  70723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70725 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70727 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70729 */     GIR_RootConstrainSelectedInstOperands,
     /*  70730 */     // GIR_Coverage, 404,
     /*  70730 */     GIR_EraseRootFromParent_Done,
     /*  70731 */   // Label 1119: @70731
     /*  70731 */   GIM_Try, /*On fail goto*//*Label 1120*/ GIMT_Encode4(70768), // Rule ID 405 //
     /*  70736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsrh),
     /*  70744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  70747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  70753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70757 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10536:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VSRH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  70757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSRH),
     /*  70760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70762 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70764 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70766 */     GIR_RootConstrainSelectedInstOperands,
     /*  70767 */     // GIR_Coverage, 405,
     /*  70767 */     GIR_EraseRootFromParent_Done,
     /*  70768 */   // Label 1120: @70768
     /*  70768 */   GIM_Try, /*On fail goto*//*Label 1121*/ GIMT_Encode4(70805), // Rule ID 406 //
     /*  70773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsrw),
     /*  70781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70794 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10539:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSRW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSRW),
     /*  70797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70799 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70801 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70803 */     GIR_RootConstrainSelectedInstOperands,
     /*  70804 */     // GIR_Coverage, 406,
     /*  70804 */     GIR_EraseRootFromParent_Done,
     /*  70805 */   // Label 1121: @70805
     /*  70805 */   GIM_Try, /*On fail goto*//*Label 1122*/ GIMT_Encode4(70842), // Rule ID 410 //
     /*  70810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpkpx),
     /*  70818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  70821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70831 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10493:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VPKPX:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPKPX),
     /*  70834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70836 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70838 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70840 */     GIR_RootConstrainSelectedInstOperands,
     /*  70841 */     // GIR_Coverage, 410,
     /*  70841 */     GIR_EraseRootFromParent_Done,
     /*  70842 */   // Label 1122: @70842
     /*  70842 */   GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(70879), // Rule ID 457 //
     /*  70847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  70850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulesw),
     /*  70855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  70858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70868 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10472:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMULESW:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULESW),
     /*  70871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70873 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70875 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70877 */     GIR_RootConstrainSelectedInstOperands,
     /*  70878 */     // GIR_Coverage, 457,
     /*  70878 */     GIR_EraseRootFromParent_Done,
     /*  70879 */   // Label 1123: @70879
     /*  70879 */   GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(70916), // Rule ID 458 //
     /*  70884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  70887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmuleuw),
     /*  70892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  70895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70905 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10476:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMULEUW:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULEUW),
     /*  70908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70910 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70912 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70914 */     GIR_RootConstrainSelectedInstOperands,
     /*  70915 */     // GIR_Coverage, 458,
     /*  70915 */     GIR_EraseRootFromParent_Done,
     /*  70916 */   // Label 1124: @70916
     /*  70916 */   GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(70953), // Rule ID 459 //
     /*  70921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  70924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulosw),
     /*  70929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  70932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70942 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10484:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMULOSW:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULOSW),
     /*  70945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70947 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70949 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70951 */     GIR_RootConstrainSelectedInstOperands,
     /*  70952 */     // GIR_Coverage, 459,
     /*  70952 */     GIR_EraseRootFromParent_Done,
     /*  70953 */   // Label 1125: @70953
     /*  70953 */   GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(70990), // Rule ID 460 //
     /*  70958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  70961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulouw),
     /*  70966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  70969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70979 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10488:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMULOUW:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULOUW),
     /*  70982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70984 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70986 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70988 */     GIR_RootConstrainSelectedInstOperands,
     /*  70989 */     // GIR_Coverage, 460,
     /*  70989 */     GIR_EraseRootFromParent_Done,
     /*  70990 */   // Label 1126: @70990
     /*  70990 */   GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(71027), // Rule ID 462 //
     /*  70995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  70998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmaxsd),
     /*  71003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71016 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10442:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMAXSD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMAXSD),
     /*  71019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71021 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71023 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71025 */     GIR_RootConstrainSelectedInstOperands,
     /*  71026 */     // GIR_Coverage, 462,
     /*  71026 */     GIR_EraseRootFromParent_Done,
     /*  71027 */   // Label 1127: @71027
     /*  71027 */   GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(71064), // Rule ID 463 //
     /*  71032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  71035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmaxud),
     /*  71040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71053 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10446:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMAXUD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMAXUD),
     /*  71056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71058 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71060 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71062 */     GIR_RootConstrainSelectedInstOperands,
     /*  71063 */     // GIR_Coverage, 463,
     /*  71063 */     GIR_EraseRootFromParent_Done,
     /*  71064 */   // Label 1128: @71064
     /*  71064 */   GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(71101), // Rule ID 464 //
     /*  71069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  71072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vminsd),
     /*  71077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71090 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10453:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMINSD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMINSD),
     /*  71093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71095 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71097 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71099 */     GIR_RootConstrainSelectedInstOperands,
     /*  71100 */     // GIR_Coverage, 464,
     /*  71100 */     GIR_EraseRootFromParent_Done,
     /*  71101 */   // Label 1129: @71101
     /*  71101 */   GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(71138), // Rule ID 465 //
     /*  71106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  71109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vminud),
     /*  71114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71127 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10457:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMINUD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMINUD),
     /*  71130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71132 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71134 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71136 */     GIR_RootConstrainSelectedInstOperands,
     /*  71137 */     // GIR_Coverage, 465,
     /*  71137 */     GIR_EraseRootFromParent_Done,
     /*  71138 */   // Label 1130: @71138
     /*  71138 */   GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(71175), // Rule ID 468 //
     /*  71143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  71146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrld),
     /*  71151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71164 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10512:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VRLD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRLD),
     /*  71167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71169 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71171 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71173 */     GIR_RootConstrainSelectedInstOperands,
     /*  71174 */     // GIR_Coverage, 468,
     /*  71174 */     GIR_EraseRootFromParent_Done,
     /*  71175 */   // Label 1131: @71175
     /*  71175 */   GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(71212), // Rule ID 472 //
     /*  71180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  71183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vaddcuq),
     /*  71188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  71191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  71194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  71197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71201 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10306:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)  =>  (VADDCUQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)
     /*  71201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VADDCUQ),
     /*  71204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71206 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71208 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71210 */     GIR_RootConstrainSelectedInstOperands,
     /*  71211 */     // GIR_Coverage, 472,
     /*  71211 */     GIR_EraseRootFromParent_Done,
     /*  71212 */   // Label 1132: @71212
     /*  71212 */   GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(71249), // Rule ID 477 //
     /*  71217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  71220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsubcuq),
     /*  71225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  71228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  71231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  71234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71238 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10548:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)  =>  (VSUBCUQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)
     /*  71238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUBCUQ),
     /*  71241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71243 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71245 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71247 */     GIR_RootConstrainSelectedInstOperands,
     /*  71248 */     // GIR_Coverage, 477,
     /*  71248 */     GIR_EraseRootFromParent_Done,
     /*  71249 */   // Label 1133: @71249
     /*  71249 */   GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(71286), // Rule ID 496 //
     /*  71254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  71257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vpmsumb),
     /*  71262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  71265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  71271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71275 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10271:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VPMSUMB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  71275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPMSUMB),
     /*  71278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71280 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71282 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71284 */     GIR_RootConstrainSelectedInstOperands,
     /*  71285 */     // GIR_Coverage, 496,
     /*  71285 */     GIR_EraseRootFromParent_Done,
     /*  71286 */   // Label 1134: @71286
     /*  71286 */   GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(71323), // Rule ID 497 //
     /*  71291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  71294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vpmsumh),
     /*  71299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  71302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  71308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71312 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10273:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VPMSUMH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  71312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPMSUMH),
     /*  71315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71317 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71319 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71321 */     GIR_RootConstrainSelectedInstOperands,
     /*  71322 */     // GIR_Coverage, 497,
     /*  71322 */     GIR_EraseRootFromParent_Done,
     /*  71323 */   // Label 1135: @71323
     /*  71323 */   GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(71360), // Rule ID 498 //
     /*  71328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  71331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vpmsumw),
     /*  71336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  71339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  71342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  71345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71349 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10274:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VPMSUMW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  71349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPMSUMW),
     /*  71352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71354 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71356 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71358 */     GIR_RootConstrainSelectedInstOperands,
     /*  71359 */     // GIR_Coverage, 498,
     /*  71359 */     GIR_EraseRootFromParent_Done,
     /*  71360 */   // Label 1136: @71360
     /*  71360 */   GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(71397), // Rule ID 499 //
     /*  71365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  71368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vpmsumd),
     /*  71373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71386 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10272:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VPMSUMD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPMSUMD),
     /*  71389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71391 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71393 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71395 */     GIR_RootConstrainSelectedInstOperands,
     /*  71396 */     // GIR_Coverage, 499,
     /*  71396 */     GIR_EraseRootFromParent_Done,
     /*  71397 */   // Label 1137: @71397
     /*  71397 */   GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(71434), // Rule ID 507 //
     /*  71402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  71405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vbpermq),
     /*  71410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  71419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71423 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10323:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VBPERMQ:{ *:[v2i64] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  71423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VBPERMQ),
     /*  71426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71428 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71430 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71432 */     GIR_RootConstrainSelectedInstOperands,
     /*  71433 */     // GIR_Coverage, 507,
     /*  71433 */     GIR_EraseRootFromParent_Done,
     /*  71434 */   // Label 1138: @71434
     /*  71434 */   GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(71471), // Rule ID 510 //
     /*  71439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Crypto),
     /*  71442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vcipher),
     /*  71447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71460 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10265:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VCIPHER:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCIPHER),
     /*  71463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71465 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71467 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71469 */     GIR_RootConstrainSelectedInstOperands,
     /*  71470 */     // GIR_Coverage, 510,
     /*  71470 */     GIR_EraseRootFromParent_Done,
     /*  71471 */   // Label 1139: @71471
     /*  71471 */   GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(71508), // Rule ID 511 //
     /*  71476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Crypto),
     /*  71479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vcipherlast),
     /*  71484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71497 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10266:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VCIPHERLAST:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCIPHERLAST),
     /*  71500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71502 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71504 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71506 */     GIR_RootConstrainSelectedInstOperands,
     /*  71507 */     // GIR_Coverage, 511,
     /*  71507 */     GIR_EraseRootFromParent_Done,
     /*  71508 */   // Label 1140: @71508
     /*  71508 */   GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(71545), // Rule ID 512 //
     /*  71513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Crypto),
     /*  71516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vncipher),
     /*  71521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71534 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10267:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VNCIPHER:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VNCIPHER),
     /*  71537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71539 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71541 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71543 */     GIR_RootConstrainSelectedInstOperands,
     /*  71544 */     // GIR_Coverage, 512,
     /*  71544 */     GIR_EraseRootFromParent_Done,
     /*  71545 */   // Label 1141: @71545
     /*  71545 */   GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(71582), // Rule ID 513 //
     /*  71550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Crypto),
     /*  71553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vncipherlast),
     /*  71558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71571 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10268:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VNCIPHERLAST:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VNCIPHERLAST),
     /*  71574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71576 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71578 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71580 */     GIR_RootConstrainSelectedInstOperands,
     /*  71581 */     // GIR_Coverage, 513,
     /*  71581 */     GIR_EraseRootFromParent_Done,
     /*  71582 */   // Label 1142: @71582
     /*  71582 */   GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(71619), // Rule ID 546 //
     /*  71587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  71590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vbpermd),
     /*  71595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  71604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71608 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10322:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VBPERMD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  71608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VBPERMD),
     /*  71611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71613 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71615 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71617 */     GIR_RootConstrainSelectedInstOperands,
     /*  71618 */     // GIR_Coverage, 546,
     /*  71618 */     GIR_EraseRootFromParent_Done,
     /*  71619 */   // Label 1143: @71619
     /*  71619 */   GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(71656), // Rule ID 547 //
     /*  71624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  71627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrlwnm),
     /*  71632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  71635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  71638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  71641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71645 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10520:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VRLWNM:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  71645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRLWNM),
     /*  71648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71650 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71652 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71654 */     GIR_RootConstrainSelectedInstOperands,
     /*  71655 */     // GIR_Coverage, 547,
     /*  71655 */     GIR_EraseRootFromParent_Done,
     /*  71656 */   // Label 1144: @71656
     /*  71656 */   GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(71693), // Rule ID 549 //
     /*  71661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  71664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrldnm),
     /*  71669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71682 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10514:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VRLDNM:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRLDNM),
     /*  71685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71687 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71689 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71691 */     GIR_RootConstrainSelectedInstOperands,
     /*  71692 */     // GIR_Coverage, 549,
     /*  71692 */     GIR_EraseRootFromParent_Done,
     /*  71693 */   // Label 1145: @71693
     /*  71693 */   GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(71730), // Rule ID 551 //
     /*  71698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  71701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vslv),
     /*  71706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  71709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  71715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71719 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10528:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VSLV:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  71719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSLV),
     /*  71722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71724 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71726 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71728 */     GIR_RootConstrainSelectedInstOperands,
     /*  71729 */     // GIR_Coverage, 551,
     /*  71729 */     GIR_EraseRootFromParent_Done,
     /*  71730 */   // Label 1146: @71730
     /*  71730 */   GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(71767), // Rule ID 552 //
     /*  71735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  71738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsrv),
     /*  71743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  71746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  71752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71756 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10538:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VSRV:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  71756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSRV),
     /*  71759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71761 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71763 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71765 */     GIR_RootConstrainSelectedInstOperands,
     /*  71766 */     // GIR_Coverage, 552,
     /*  71766 */     GIR_EraseRootFromParent_Done,
     /*  71767 */   // Label 1147: @71767
     /*  71767 */   GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(71804), // Rule ID 557 //
     /*  71772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  71775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vabsdub),
     /*  71780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  71783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  71789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71793 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10303:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VABSDUB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  71793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VABSDUB),
     /*  71796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71798 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71800 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71802 */     GIR_RootConstrainSelectedInstOperands,
     /*  71803 */     // GIR_Coverage, 557,
     /*  71803 */     GIR_EraseRootFromParent_Done,
     /*  71804 */   // Label 1148: @71804
     /*  71804 */   GIM_Try, /*On fail goto*//*Label 1149*/ GIMT_Encode4(71841), // Rule ID 558 //
     /*  71809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  71812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vabsduh),
     /*  71817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  71820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  71826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71830 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10304:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VABSDUH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  71830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VABSDUH),
     /*  71833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71835 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71837 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71839 */     GIR_RootConstrainSelectedInstOperands,
     /*  71840 */     // GIR_Coverage, 558,
     /*  71840 */     GIR_EraseRootFromParent_Done,
     /*  71841 */   // Label 1149: @71841
     /*  71841 */   GIM_Try, /*On fail goto*//*Label 1150*/ GIMT_Encode4(71878), // Rule ID 559 //
     /*  71846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  71849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vabsduw),
     /*  71854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  71857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  71860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  71863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71867 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10305:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VABSDUW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  71867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VABSDUW),
     /*  71870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71872 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71874 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71876 */     GIR_RootConstrainSelectedInstOperands,
     /*  71877 */     // GIR_Coverage, 559,
     /*  71877 */     GIR_EraseRootFromParent_Done,
     /*  71878 */   // Label 1150: @71878
     /*  71878 */   GIM_Try, /*On fail goto*//*Label 1151*/ GIMT_Encode4(71912), // Rule ID 696 //
     /*  71883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_addg6sd),
     /*  71888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  71891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  71894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  71897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  71901 */     // (intrinsic_wo_chain:{ *:[i64] } 10264:{ *:[iPTR] }, i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)  =>  (ADDG6S8:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)
     /*  71901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ADDG6S8),
     /*  71904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  71906 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  71908 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  71910 */     GIR_RootConstrainSelectedInstOperands,
     /*  71911 */     // GIR_Coverage, 696,
     /*  71911 */     GIR_EraseRootFromParent_Done,
     /*  71912 */   // Label 1151: @71912
     /*  71912 */   GIM_Try, /*On fail goto*//*Label 1152*/ GIMT_Encode4(71949), // Rule ID 1110 //
     /*  71917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  71920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpdepd),
     /*  71925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71938 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10490:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VPDEPD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPDEPD),
     /*  71941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71943 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71945 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71947 */     GIR_RootConstrainSelectedInstOperands,
     /*  71948 */     // GIR_Coverage, 1110,
     /*  71948 */     GIR_EraseRootFromParent_Done,
     /*  71949 */   // Label 1152: @71949
     /*  71949 */   GIM_Try, /*On fail goto*//*Label 1153*/ GIMT_Encode4(71986), // Rule ID 1111 //
     /*  71954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  71957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpextd),
     /*  71962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71975 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10492:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VPEXTD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPEXTD),
     /*  71978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71980 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71982 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71984 */     GIR_RootConstrainSelectedInstOperands,
     /*  71985 */     // GIR_Coverage, 1111,
     /*  71985 */     GIR_EraseRootFromParent_Done,
     /*  71986 */   // Label 1153: @71986
     /*  71986 */   GIM_Try, /*On fail goto*//*Label 1154*/ GIMT_Encode4(72023), // Rule ID 1112 //
     /*  71991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  71994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_pdepd),
     /*  71999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  72002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  72005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  72008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  72012 */     // (intrinsic_wo_chain:{ *:[i64] } 10799:{ *:[iPTR] }, i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)  =>  (PDEPD:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*  72012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PDEPD),
     /*  72015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  72017 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  72019 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  72021 */     GIR_RootConstrainSelectedInstOperands,
     /*  72022 */     // GIR_Coverage, 1112,
     /*  72022 */     GIR_EraseRootFromParent_Done,
     /*  72023 */   // Label 1154: @72023
     /*  72023 */   GIM_Try, /*On fail goto*//*Label 1155*/ GIMT_Encode4(72060), // Rule ID 1113 //
     /*  72028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_pextd),
     /*  72036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  72039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  72042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  72045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  72049 */     // (intrinsic_wo_chain:{ *:[i64] } 10800:{ *:[iPTR] }, i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)  =>  (PEXTD:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*  72049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PEXTD),
     /*  72052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  72054 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  72056 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  72058 */     GIR_RootConstrainSelectedInstOperands,
     /*  72059 */     // GIR_Coverage, 1113,
     /*  72059 */     GIR_EraseRootFromParent_Done,
     /*  72060 */   // Label 1155: @72060
     /*  72060 */   GIM_Try, /*On fail goto*//*Label 1156*/ GIMT_Encode4(72097), // Rule ID 1114 //
     /*  72065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vcfuged),
     /*  72073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  72076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  72079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  72082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72086 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10325:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VCFUGED:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  72086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCFUGED),
     /*  72089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72091 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72093 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72095 */     GIR_RootConstrainSelectedInstOperands,
     /*  72096 */     // GIR_Coverage, 1114,
     /*  72096 */     GIR_EraseRootFromParent_Done,
     /*  72097 */   // Label 1156: @72097
     /*  72097 */   GIM_Try, /*On fail goto*//*Label 1157*/ GIMT_Encode4(72134), // Rule ID 1116 //
     /*  72102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_cfuged),
     /*  72110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  72113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  72116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  72119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  72123 */     // (intrinsic_wo_chain:{ *:[i64] } 10590:{ *:[iPTR] }, i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)  =>  (CFUGED:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*  72123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CFUGED),
     /*  72126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  72128 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  72130 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  72132 */     GIR_RootConstrainSelectedInstOperands,
     /*  72133 */     // GIR_Coverage, 1116,
     /*  72133 */     GIR_EraseRootFromParent_Done,
     /*  72134 */   // Label 1157: @72134
     /*  72134 */   GIM_Try, /*On fail goto*//*Label 1158*/ GIMT_Encode4(72171), // Rule ID 1118 //
     /*  72139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vclzdm),
     /*  72147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  72150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  72153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  72156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72160 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10329:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VCLZDM:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  72160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCLZDM),
     /*  72163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72165 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72167 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72169 */     GIR_RootConstrainSelectedInstOperands,
     /*  72170 */     // GIR_Coverage, 1118,
     /*  72170 */     GIR_EraseRootFromParent_Done,
     /*  72171 */   // Label 1158: @72171
     /*  72171 */   GIM_Try, /*On fail goto*//*Label 1159*/ GIMT_Encode4(72208), // Rule ID 1119 //
     /*  72176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vctzdm),
     /*  72184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  72187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  72190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  72193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72197 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10387:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VCTZDM:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  72197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCTZDM),
     /*  72200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72202 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72204 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72206 */     GIR_RootConstrainSelectedInstOperands,
     /*  72207 */     // GIR_Coverage, 1119,
     /*  72207 */     GIR_EraseRootFromParent_Done,
     /*  72208 */   // Label 1159: @72208
     /*  72208 */   GIM_Try, /*On fail goto*//*Label 1160*/ GIMT_Encode4(72245), // Rule ID 1120 //
     /*  72213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_cntlzdm),
     /*  72221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  72224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  72227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  72230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  72234 */     // (intrinsic_wo_chain:{ *:[i64] } 10595:{ *:[iPTR] }, i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)  =>  (CNTLZDM:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*  72234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CNTLZDM),
     /*  72237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  72239 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  72241 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  72243 */     GIR_RootConstrainSelectedInstOperands,
     /*  72244 */     // GIR_Coverage, 1120,
     /*  72244 */     GIR_EraseRootFromParent_Done,
     /*  72245 */   // Label 1160: @72245
     /*  72245 */   GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(72282), // Rule ID 1121 //
     /*  72250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_cnttzdm),
     /*  72258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  72261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  72264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  72267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  72271 */     // (intrinsic_wo_chain:{ *:[i64] } 10596:{ *:[iPTR] }, i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)  =>  (CNTTZDM:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*  72271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CNTTZDM),
     /*  72274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  72276 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  72278 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  72280 */     GIR_RootConstrainSelectedInstOperands,
     /*  72281 */     // GIR_Coverage, 1121,
     /*  72281 */     GIR_EraseRootFromParent_Done,
     /*  72282 */   // Label 1161: @72282
     /*  72282 */   GIM_Try, /*On fail goto*//*Label 1162*/ GIMT_Encode4(72319), // Rule ID 1122 //
     /*  72287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vclrlb),
     /*  72295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  72298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  72304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72308 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10327:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, i32:{ *:[i32] }:$VB)  =>  (VCLRLB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, i32:{ *:[i32] }:$VB)
     /*  72308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCLRLB),
     /*  72311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72313 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72315 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72317 */     GIR_RootConstrainSelectedInstOperands,
     /*  72318 */     // GIR_Coverage, 1122,
     /*  72318 */     GIR_EraseRootFromParent_Done,
     /*  72319 */   // Label 1162: @72319
     /*  72319 */   GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(72356), // Rule ID 1123 //
     /*  72324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vclrrb),
     /*  72332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  72335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  72341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72345 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10328:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, i32:{ *:[i32] }:$VB)  =>  (VCLRRB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, i32:{ *:[i32] }:$VB)
     /*  72345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCLRRB),
     /*  72348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72350 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72352 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72354 */     GIR_RootConstrainSelectedInstOperands,
     /*  72355 */     // GIR_Coverage, 1123,
     /*  72355 */     GIR_EraseRootFromParent_Done,
     /*  72356 */   // Label 1163: @72356
     /*  72356 */   GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(72393), // Rule ID 1137 //
     /*  72361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vdivesw),
     /*  72369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72382 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10391:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VDIVESW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  72382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VDIVESW),
     /*  72385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72387 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72389 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72391 */     GIR_RootConstrainSelectedInstOperands,
     /*  72392 */     // GIR_Coverage, 1137,
     /*  72392 */     GIR_EraseRootFromParent_Done,
     /*  72393 */   // Label 1164: @72393
     /*  72393 */   GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(72430), // Rule ID 1138 //
     /*  72398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vdiveuw),
     /*  72406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72419 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10394:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VDIVEUW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  72419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VDIVEUW),
     /*  72422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72424 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72426 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72428 */     GIR_RootConstrainSelectedInstOperands,
     /*  72429 */     // GIR_Coverage, 1138,
     /*  72429 */     GIR_EraseRootFromParent_Done,
     /*  72430 */   // Label 1165: @72430
     /*  72430 */   GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(72467), // Rule ID 1139 //
     /*  72435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vdivesd),
     /*  72443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  72446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  72449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  72452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72456 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10389:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VDIVESD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  72456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VDIVESD),
     /*  72459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72461 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72463 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72465 */     GIR_RootConstrainSelectedInstOperands,
     /*  72466 */     // GIR_Coverage, 1139,
     /*  72466 */     GIR_EraseRootFromParent_Done,
     /*  72467 */   // Label 1166: @72467
     /*  72467 */   GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(72504), // Rule ID 1140 //
     /*  72472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vdiveud),
     /*  72480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  72483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  72486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  72489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72493 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10392:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VDIVEUD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  72493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VDIVEUD),
     /*  72496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72498 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72500 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72502 */     GIR_RootConstrainSelectedInstOperands,
     /*  72503 */     // GIR_Coverage, 1140,
     /*  72503 */     GIR_EraseRootFromParent_Done,
     /*  72504 */   // Label 1167: @72504
     /*  72504 */   GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(72541), // Rule ID 1143 //
     /*  72509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulesd),
     /*  72517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  72520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  72523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  72526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72530 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10470:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMULESD:{ *:[v1i128] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  72530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULESD),
     /*  72533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72535 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72537 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72539 */     GIR_RootConstrainSelectedInstOperands,
     /*  72540 */     // GIR_Coverage, 1143,
     /*  72540 */     GIR_EraseRootFromParent_Done,
     /*  72541 */   // Label 1168: @72541
     /*  72541 */   GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(72578), // Rule ID 1144 //
     /*  72546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmuleud),
     /*  72554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  72557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  72560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  72563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72567 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10474:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMULEUD:{ *:[v1i128] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  72567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULEUD),
     /*  72570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72572 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72574 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72576 */     GIR_RootConstrainSelectedInstOperands,
     /*  72577 */     // GIR_Coverage, 1144,
     /*  72577 */     GIR_EraseRootFromParent_Done,
     /*  72578 */   // Label 1169: @72578
     /*  72578 */   GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(72615), // Rule ID 1145 //
     /*  72583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulosd),
     /*  72591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  72594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  72597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  72600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72604 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10482:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMULOSD:{ *:[v1i128] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  72604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULOSD),
     /*  72607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72609 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72611 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72613 */     GIR_RootConstrainSelectedInstOperands,
     /*  72614 */     // GIR_Coverage, 1145,
     /*  72614 */     GIR_EraseRootFromParent_Done,
     /*  72615 */   // Label 1170: @72615
     /*  72615 */   GIM_Try, /*On fail goto*//*Label 1171*/ GIMT_Encode4(72652), // Rule ID 1146 //
     /*  72620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmuloud),
     /*  72628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  72631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  72634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  72637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72641 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10486:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMULOUD:{ *:[v1i128] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  72641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULOUD),
     /*  72644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72646 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72648 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72650 */     GIR_RootConstrainSelectedInstOperands,
     /*  72651 */     // GIR_Coverage, 1146,
     /*  72651 */     GIR_EraseRootFromParent_Done,
     /*  72652 */   // Label 1171: @72652
     /*  72652 */   GIM_Try, /*On fail goto*//*Label 1172*/ GIMT_Encode4(72689), // Rule ID 1150 //
     /*  72657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vdivesq),
     /*  72665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  72668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  72671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  72674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72678 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10390:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)  =>  (VDIVESQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)
     /*  72678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VDIVESQ),
     /*  72681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72683 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72685 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72687 */     GIR_RootConstrainSelectedInstOperands,
     /*  72688 */     // GIR_Coverage, 1150,
     /*  72688 */     GIR_EraseRootFromParent_Done,
     /*  72689 */   // Label 1172: @72689
     /*  72689 */   GIM_Try, /*On fail goto*//*Label 1173*/ GIMT_Encode4(72726), // Rule ID 1151 //
     /*  72694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vdiveuq),
     /*  72702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  72705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  72708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  72711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72715 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10393:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)  =>  (VDIVEUQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)
     /*  72715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VDIVEUQ),
     /*  72718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72720 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72722 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72724 */     GIR_RootConstrainSelectedInstOperands,
     /*  72725 */     // GIR_Coverage, 1151,
     /*  72725 */     GIR_EraseRootFromParent_Done,
     /*  72726 */   // Label 1173: @72726
     /*  72726 */   GIM_Try, /*On fail goto*//*Label 1174*/ GIMT_Encode4(72763), // Rule ID 1161 //
     /*  72731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrlqnm),
     /*  72739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  72742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  72745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  72748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72752 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10517:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)  =>  (VRLQNM:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)
     /*  72752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRLQNM),
     /*  72755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72757 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72759 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72761 */     GIR_RootConstrainSelectedInstOperands,
     /*  72762 */     // GIR_Coverage, 1161,
     /*  72762 */     GIR_EraseRootFromParent_Done,
     /*  72763 */   // Label 1174: @72763
     /*  72763 */   GIM_Try, /*On fail goto*//*Label 1175*/ GIMT_Encode4(72800), // Rule ID 1166 //
     /*  72768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture),
     /*  72771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxor),
     /*  72776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  72779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  72782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v1024s1,
     /*  72785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  72789 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10691:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v1024i1:{ *:[v1024i1] }:$AB)  =>  (DMXOR:{ *:[v1024i1] } v1024i1:{ *:[v1024i1] }:$ATi, v1024i1:{ *:[v1024i1] }:$AB)
     /*  72789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXOR),
     /*  72792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  72794 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  72796 */     GIR_RootToRootCopy, /*OpIdx*/3, // AB
     /*  72798 */     GIR_RootConstrainSelectedInstOperands,
     /*  72799 */     // GIR_Coverage, 1166,
     /*  72799 */     GIR_EraseRootFromParent_Done,
     /*  72800 */   // Label 1175: @72800
     /*  72800 */   GIM_Try, /*On fail goto*//*Label 1176*/ GIMT_Encode4(72857), // Rule ID 2911 //
     /*  72805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_PairedVectorMemops),
     /*  72808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_assemble_pair),
     /*  72813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v256s1,
     /*  72816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  72822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRpRCRegClassID),
     /*  72826 */     // (intrinsic_wo_chain:{ *:[v256i1] } 10848:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$vs1, v16i8:{ *:[v16i8] }:$vs0)  =>  (REG_SEQUENCE:{ *:[v256i1] } VSRpRC:{ *:[i32] }, ?:{ *:[v16i8] }:$vs0, sub_vsx1:{ *:[i32] }, ?:{ *:[v16i8] }:$vs1, sub_vsx0:{ *:[i32] })
     /*  72826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  72829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72831 */     GIR_RootToRootCopy, /*OpIdx*/3, // vs0
     /*  72833 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/22,
     /*  72836 */     GIR_RootToRootCopy, /*OpIdx*/2, // vs1
     /*  72838 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/21,
     /*  72841 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRpRCRegClassID),
     /*  72846 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  72851 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  72856 */     // GIR_Coverage, 2911,
     /*  72856 */     GIR_EraseRootFromParent_Done,
     /*  72857 */   // Label 1176: @72857
     /*  72857 */   GIM_Try, /*On fail goto*//*Label 1177*/ GIMT_Encode4(72894), // Rule ID 3346 //
     /*  72862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulhsw),
     /*  72870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72883 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10478:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)  =>  (VMULHSW:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB)
     /*  72883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULHSW),
     /*  72886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72888 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  72890 */     GIR_RootToRootCopy, /*OpIdx*/3, // vB
     /*  72892 */     GIR_RootConstrainSelectedInstOperands,
     /*  72893 */     // GIR_Coverage, 3346,
     /*  72893 */     GIR_EraseRootFromParent_Done,
     /*  72894 */   // Label 1177: @72894
     /*  72894 */   GIM_Try, /*On fail goto*//*Label 1178*/ GIMT_Encode4(72931), // Rule ID 3347 //
     /*  72899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulhuw),
     /*  72907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72920 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10480:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)  =>  (VMULHUW:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB)
     /*  72920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULHUW),
     /*  72923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72925 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  72927 */     GIR_RootToRootCopy, /*OpIdx*/3, // vB
     /*  72929 */     GIR_RootConstrainSelectedInstOperands,
     /*  72930 */     // GIR_Coverage, 3347,
     /*  72930 */     GIR_EraseRootFromParent_Done,
     /*  72931 */   // Label 1178: @72931
     /*  72931 */   GIM_Try, /*On fail goto*//*Label 1179*/ GIMT_Encode4(72968), // Rule ID 3348 //
     /*  72936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulhsd),
     /*  72944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  72947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  72950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  72953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72957 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10477:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$vA, v2i64:{ *:[v2i64] }:$vB)  =>  (VMULHSD:{ *:[v2i64] } ?:{ *:[v2i64] }:$vA, ?:{ *:[v2i64] }:$vB)
     /*  72957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULHSD),
     /*  72960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72962 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  72964 */     GIR_RootToRootCopy, /*OpIdx*/3, // vB
     /*  72966 */     GIR_RootConstrainSelectedInstOperands,
     /*  72967 */     // GIR_Coverage, 3348,
     /*  72967 */     GIR_EraseRootFromParent_Done,
     /*  72968 */   // Label 1179: @72968
     /*  72968 */   GIM_Try, /*On fail goto*//*Label 1180*/ GIMT_Encode4(73005), // Rule ID 3349 //
     /*  72973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulhud),
     /*  72981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  72984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  72987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  72990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72994 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10479:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$vA, v2i64:{ *:[v2i64] }:$vB)  =>  (VMULHUD:{ *:[v2i64] } ?:{ *:[v2i64] }:$vA, ?:{ *:[v2i64] }:$vB)
     /*  72994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULHUD),
     /*  72997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72999 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  73001 */     GIR_RootToRootCopy, /*OpIdx*/3, // vB
     /*  73003 */     GIR_RootConstrainSelectedInstOperands,
     /*  73004 */     // GIR_Coverage, 3349,
     /*  73004 */     GIR_EraseRootFromParent_Done,
     /*  73005 */   // Label 1180: @73005
     /*  73005 */   GIM_Try, /*On fail goto*//*Label 1181*/ GIMT_Encode4(73064), // Rule ID 3516 //
     /*  73010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  73013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxvi8gerx4),
     /*  73018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  73021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v256s1,
     /*  73024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  73031 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10702:{ *:[iPTR] }, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB)  =>  (DMXVI8GERX4:{ *:[v1024i1] } ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73031 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73034 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73038 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73043 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73047 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXVI8GERX4),
     /*  73055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73057 */     GIR_RootToRootCopy, /*OpIdx*/2, // XAp
     /*  73059 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73062 */     GIR_RootConstrainSelectedInstOperands,
     /*  73063 */     // GIR_Coverage, 3516,
     /*  73063 */     GIR_EraseRootFromParent_Done,
     /*  73064 */   // Label 1181: @73064
     /*  73064 */   GIM_Try, /*On fail goto*//*Label 1182*/ GIMT_Encode4(73123), // Rule ID 3519 //
     /*  73069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  73072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxvbf16gerx2),
     /*  73077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  73080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v256s1,
     /*  73083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  73090 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10692:{ *:[iPTR] }, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB)  =>  (DMXVBF16GERX2:{ *:[v1024i1] } ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73090 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73093 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73097 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73102 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73106 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXVBF16GERX2),
     /*  73114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73116 */     GIR_RootToRootCopy, /*OpIdx*/2, // XAp
     /*  73118 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73121 */     GIR_RootConstrainSelectedInstOperands,
     /*  73122 */     // GIR_Coverage, 3519,
     /*  73122 */     GIR_EraseRootFromParent_Done,
     /*  73123 */   // Label 1182: @73123
     /*  73123 */   GIM_Try, /*On fail goto*//*Label 1183*/ GIMT_Encode4(73182), // Rule ID 3524 //
     /*  73128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  73131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxvf16gerx2),
     /*  73136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  73139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v256s1,
     /*  73142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  73149 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10697:{ *:[iPTR] }, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB)  =>  (DMXVF16GERX2:{ *:[v1024i1] } ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73149 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73152 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73156 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73161 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73165 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXVF16GERX2),
     /*  73173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73175 */     GIR_RootToRootCopy, /*OpIdx*/2, // XAp
     /*  73177 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73180 */     GIR_RootConstrainSelectedInstOperands,
     /*  73181 */     // GIR_Coverage, 3524,
     /*  73181 */     GIR_EraseRootFromParent_Done,
     /*  73182 */   // Label 1183: @73182
     /*  73182 */   GIM_Try, /*On fail goto*//*Label 1184*/ GIMT_Encode4(73263), // Rule ID 3543 //
     /*  73187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  73190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi4ger8),
     /*  73195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  73208 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10776:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI4GER8:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73208 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  73211 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73215 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73220 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73224 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73241 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  73245 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI4GER8),
     /*  73253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73255 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73258 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  73261 */     GIR_RootConstrainSelectedInstOperands,
     /*  73262 */     // GIR_Coverage, 3543,
     /*  73262 */     GIR_EraseRootFromParent_Done,
     /*  73263 */   // Label 1184: @73263
     /*  73263 */   GIM_Try, /*On fail goto*//*Label 1185*/ GIMT_Encode4(73344), // Rule ID 3545 //
     /*  73268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  73271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi8ger4),
     /*  73276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  73289 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10778:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI8GER4:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73289 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  73292 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73296 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73301 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73305 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73310 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73313 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73317 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73322 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  73326 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI8GER4),
     /*  73334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73339 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  73342 */     GIR_RootConstrainSelectedInstOperands,
     /*  73343 */     // GIR_Coverage, 3545,
     /*  73343 */     GIR_EraseRootFromParent_Done,
     /*  73344 */   // Label 1185: @73344
     /*  73344 */   GIM_Try, /*On fail goto*//*Label 1186*/ GIMT_Encode4(73425), // Rule ID 3547 //
     /*  73349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  73352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi16ger2s),
     /*  73357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  73370 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10774:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI16GER2S:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73370 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  73373 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73377 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73382 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73386 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73391 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73394 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73398 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73403 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  73407 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI16GER2S),
     /*  73415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73417 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73420 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  73423 */     GIR_RootConstrainSelectedInstOperands,
     /*  73424 */     // GIR_Coverage, 3547,
     /*  73424 */     GIR_EraseRootFromParent_Done,
     /*  73425 */   // Label 1186: @73425
     /*  73425 */   GIM_Try, /*On fail goto*//*Label 1187*/ GIMT_Encode4(73506), // Rule ID 3549 //
     /*  73430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  73433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi4ger8),
     /*  73438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  73451 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10776:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI4GER8W:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73451 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  73454 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73458 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73463 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73467 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73484 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  73488 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI4GER8W),
     /*  73496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73498 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73501 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  73504 */     GIR_RootConstrainSelectedInstOperands,
     /*  73505 */     // GIR_Coverage, 3549,
     /*  73505 */     GIR_EraseRootFromParent_Done,
     /*  73506 */   // Label 1187: @73506
     /*  73506 */   GIM_Try, /*On fail goto*//*Label 1188*/ GIMT_Encode4(73587), // Rule ID 3551 //
     /*  73511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  73514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi8ger4),
     /*  73519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  73532 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10778:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI8GER4W:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73532 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  73535 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73539 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73544 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73548 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73553 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73556 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73560 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73565 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  73569 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI8GER4W),
     /*  73577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73579 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73582 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  73585 */     GIR_RootConstrainSelectedInstOperands,
     /*  73586 */     // GIR_Coverage, 3551,
     /*  73586 */     GIR_EraseRootFromParent_Done,
     /*  73587 */   // Label 1188: @73587
     /*  73587 */   GIM_Try, /*On fail goto*//*Label 1189*/ GIMT_Encode4(73668), // Rule ID 3553 //
     /*  73592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  73595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi16ger2s),
     /*  73600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  73613 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10774:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI16GER2SW:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73613 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  73616 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73620 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73625 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73629 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73646 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  73650 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI16GER2SW),
     /*  73658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73660 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73663 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  73666 */     GIR_RootConstrainSelectedInstOperands,
     /*  73667 */     // GIR_Coverage, 3553,
     /*  73667 */     GIR_EraseRootFromParent_Done,
     /*  73668 */   // Label 1189: @73668
     /*  73668 */   GIM_Try, /*On fail goto*//*Label 1190*/ GIMT_Encode4(73749), // Rule ID 3555 //
     /*  73673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  73676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf16ger2),
     /*  73681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  73694 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10757:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF16GER2:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73694 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  73697 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73701 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73706 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73710 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73727 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  73731 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF16GER2),
     /*  73739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73741 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73744 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  73747 */     GIR_RootConstrainSelectedInstOperands,
     /*  73748 */     // GIR_Coverage, 3555,
     /*  73748 */     GIR_EraseRootFromParent_Done,
     /*  73749 */   // Label 1190: @73749
     /*  73749 */   GIM_Try, /*On fail goto*//*Label 1191*/ GIMT_Encode4(73830), // Rule ID 3560 //
     /*  73754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  73757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf16ger2),
     /*  73762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  73775 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10757:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF16GER2W:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73775 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  73778 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73782 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73787 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73791 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73796 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73799 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73803 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73808 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  73812 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF16GER2W),
     /*  73820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73822 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  73828 */     GIR_RootConstrainSelectedInstOperands,
     /*  73829 */     // GIR_Coverage, 3560,
     /*  73829 */     GIR_EraseRootFromParent_Done,
     /*  73830 */   // Label 1191: @73830
     /*  73830 */   GIM_Try, /*On fail goto*//*Label 1192*/ GIMT_Encode4(73911), // Rule ID 3565 //
     /*  73835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  73838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf32ger),
     /*  73843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  73856 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10762:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF32GER:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73856 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  73859 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73863 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73868 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73872 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73889 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  73893 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF32GER),
     /*  73901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73903 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  73909 */     GIR_RootConstrainSelectedInstOperands,
     /*  73910 */     // GIR_Coverage, 3565,
     /*  73910 */     GIR_EraseRootFromParent_Done,
     /*  73911 */   // Label 1192: @73911
     /*  73911 */   GIM_Try, /*On fail goto*//*Label 1193*/ GIMT_Encode4(73970), // Rule ID 3570 //
     /*  73916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  73919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf64ger),
     /*  73924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v256s1,
     /*  73930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  73937 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10767:{ *:[iPTR] }, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF64GER:{ *:[v512i1] } ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73937 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73940 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73944 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73949 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73953 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF64GER),
     /*  73961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73963 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  73965 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73968 */     GIR_RootConstrainSelectedInstOperands,
     /*  73969 */     // GIR_Coverage, 3570,
     /*  73969 */     GIR_EraseRootFromParent_Done,
     /*  73970 */   // Label 1193: @73970
     /*  73970 */   GIM_Try, /*On fail goto*//*Label 1194*/ GIMT_Encode4(74051), // Rule ID 3575 //
     /*  73975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  73978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvbf16ger2),
     /*  73983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  73996 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10752:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVBF16GER2:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73996 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  73999 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74003 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74008 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  74012 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  74017 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74020 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74024 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74029 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  74033 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  74038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVBF16GER2),
     /*  74041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  74043 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74046 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  74049 */     GIR_RootConstrainSelectedInstOperands,
     /*  74050 */     // GIR_Coverage, 3575,
     /*  74050 */     GIR_EraseRootFromParent_Done,
     /*  74051 */   // Label 1194: @74051
     /*  74051 */   GIM_Try, /*On fail goto*//*Label 1195*/ GIMT_Encode4(74132), // Rule ID 3580 //
     /*  74056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  74059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi16ger2),
     /*  74064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  74067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  74077 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10772:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI16GER2:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  74077 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  74080 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74084 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74089 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  74093 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  74098 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74101 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74105 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74110 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  74114 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  74119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI16GER2),
     /*  74122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  74124 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  74130 */     GIR_RootConstrainSelectedInstOperands,
     /*  74131 */     // GIR_Coverage, 3580,
     /*  74131 */     GIR_EraseRootFromParent_Done,
     /*  74132 */   // Label 1195: @74132
     /*  74132 */   GIM_Try, /*On fail goto*//*Label 1196*/ GIMT_Encode4(74213), // Rule ID 3583 //
     /*  74137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  74140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf32ger),
     /*  74145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  74148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  74158 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10762:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF32GERW:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  74158 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  74161 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74165 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74170 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  74174 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  74179 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74182 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74186 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74191 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  74195 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  74200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF32GERW),
     /*  74203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  74205 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  74211 */     GIR_RootConstrainSelectedInstOperands,
     /*  74212 */     // GIR_Coverage, 3583,
     /*  74212 */     GIR_EraseRootFromParent_Done,
     /*  74213 */   // Label 1196: @74213
     /*  74213 */   GIM_Try, /*On fail goto*//*Label 1197*/ GIMT_Encode4(74272), // Rule ID 3588 //
     /*  74218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  74221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf64ger),
     /*  74226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  74229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v256s1,
     /*  74232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  74239 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10767:{ *:[iPTR] }, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF64GERW:{ *:[v512i1] } ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  74239 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74242 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74246 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74251 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  74255 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  74260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF64GERW),
     /*  74263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  74265 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  74267 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74270 */     GIR_RootConstrainSelectedInstOperands,
     /*  74271 */     // GIR_Coverage, 3588,
     /*  74271 */     GIR_EraseRootFromParent_Done,
     /*  74272 */   // Label 1197: @74272
     /*  74272 */   GIM_Try, /*On fail goto*//*Label 1198*/ GIMT_Encode4(74353), // Rule ID 3593 //
     /*  74277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  74280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvbf16ger2),
     /*  74285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  74288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  74298 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10752:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVBF16GER2W:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  74298 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  74301 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74305 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74310 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  74314 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  74319 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74322 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74326 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74331 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  74335 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  74340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVBF16GER2W),
     /*  74343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  74345 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74348 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  74351 */     GIR_RootConstrainSelectedInstOperands,
     /*  74352 */     // GIR_Coverage, 3593,
     /*  74352 */     GIR_EraseRootFromParent_Done,
     /*  74353 */   // Label 1198: @74353
     /*  74353 */   GIM_Try, /*On fail goto*//*Label 1199*/ GIMT_Encode4(74434), // Rule ID 3598 //
     /*  74358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  74361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi16ger2),
     /*  74366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  74369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  74379 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10772:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI16GER2W:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  74379 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  74382 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74386 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74391 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  74395 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  74400 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74403 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74407 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74412 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  74416 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  74421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI16GER2W),
     /*  74424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  74426 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74429 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  74432 */     GIR_RootConstrainSelectedInstOperands,
     /*  74433 */     // GIR_Coverage, 3598,
     /*  74433 */     GIR_EraseRootFromParent_Done,
     /*  74434 */   // Label 1199: @74434
     /*  74434 */   GIM_Reject,
     /*  74435 */ // Label 998: @74435
     /*  74435 */ GIM_Try, /*On fail goto*//*Label 1200*/ GIMT_Encode4(81805),
     /*  74440 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /*  74443 */   GIM_Try, /*On fail goto*//*Label 1201*/ GIMT_Encode4(74501), // Rule ID 1011 //
     /*  74448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  74451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fmaf128_round_to_odd),
     /*  74456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  74459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  74462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  74465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s128,
     /*  74468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  74472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  74476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /*  74480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s128,
     /*  74484 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74486 */     // (intrinsic_wo_chain:{ *:[f128] } 10640:{ *:[iPTR] }, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, (fneg:{ *:[f128] } f128:{ *:[f128] }:$RSTi))  =>  (XSMSUBQPO:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /*  74486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMSUBQPO),
     /*  74489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  74491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RSTi
     /*  74495 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  74497 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  74499 */     GIR_RootConstrainSelectedInstOperands,
     /*  74500 */     // GIR_Coverage, 1011,
     /*  74500 */     GIR_EraseRootFromParent_Done,
     /*  74501 */   // Label 1201: @74501
     /*  74501 */   GIM_Try, /*On fail goto*//*Label 1202*/ GIMT_Encode4(74554), // Rule ID 2173 //
     /*  74506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  74509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxinsertw),
     /*  74514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  74523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  74530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  74534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  74538 */     // MIs[1] Operand 1
     /*  74538 */     // No operand predicates
     /*  74538 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74540 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10927:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$A, v2i64:{ *:[v2i64] }:$B, (imm:{ *:[i32] }):$IMM)  =>  (XXINSERTW:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v2i64] }:$B, (imm:{ *:[i32] }):$IMM)
     /*  74540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXINSERTW),
     /*  74543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  74545 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  74547 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  74549 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // IMM
     /*  74552 */     GIR_RootConstrainSelectedInstOperands,
     /*  74553 */     // GIR_Coverage, 2173,
     /*  74553 */     GIR_EraseRootFromParent_Done,
     /*  74554 */   // Label 1202: @74554
     /*  74554 */   GIM_Try, /*On fail goto*//*Label 1203*/ GIMT_Encode4(74596), // Rule ID 1010 //
     /*  74559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  74562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fmaf128_round_to_odd),
     /*  74567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  74570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  74573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  74576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s128,
     /*  74579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  74583 */     // (intrinsic_wo_chain:{ *:[f128] } 10640:{ *:[iPTR] }, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, f128:{ *:[f128] }:$RSTi)  =>  (XSMADDQPO:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /*  74583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMADDQPO),
     /*  74586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  74588 */     GIR_RootToRootCopy, /*OpIdx*/4, // RSTi
     /*  74590 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  74592 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  74594 */     GIR_RootConstrainSelectedInstOperands,
     /*  74595 */     // GIR_Coverage, 1010,
     /*  74595 */     GIR_EraseRootFromParent_Done,
     /*  74596 */   // Label 1203: @74596
     /*  74596 */   GIM_Try, /*On fail goto*//*Label 1204*/ GIMT_Encode4(74638), // Rule ID 1752 //
     /*  74601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  74604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fmsub),
     /*  74609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  74612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  74615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  74618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  74621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  74625 */     // (intrinsic_wo_chain:{ *:[f64] } 10641:{ *:[iPTR] }, f64:{ *:[f64] }:$A, f64:{ *:[f64] }:$B, f64:{ *:[f64] }:$C)  =>  (XSMSUBMDP:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B, ?:{ *:[f64] }:$C)
     /*  74625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMSUBMDP),
     /*  74628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  74630 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  74632 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  74634 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  74636 */     GIR_RootConstrainSelectedInstOperands,
     /*  74637 */     // GIR_Coverage, 1752,
     /*  74637 */     GIR_EraseRootFromParent_Done,
     /*  74638 */   // Label 1204: @74638
     /*  74638 */   GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(74680), // Rule ID 1753 //
     /*  74643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  74646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fnmadd),
     /*  74651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  74654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  74657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  74660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  74663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  74667 */     // (intrinsic_wo_chain:{ *:[f64] } 10645:{ *:[iPTR] }, f64:{ *:[f64] }:$A, f64:{ *:[f64] }:$B, f64:{ *:[f64] }:$C)  =>  (XSNMADDMDP:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B, ?:{ *:[f64] }:$C)
     /*  74667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMADDMDP),
     /*  74670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  74672 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  74674 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  74676 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  74678 */     GIR_RootConstrainSelectedInstOperands,
     /*  74679 */     // GIR_Coverage, 1753,
     /*  74679 */     GIR_EraseRootFromParent_Done,
     /*  74680 */   // Label 1205: @74680
     /*  74680 */   GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(74722), // Rule ID 1939 //
     /*  74685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  74688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fmsubs),
     /*  74693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  74696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  74699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  74702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /*  74709 */     // (intrinsic_wo_chain:{ *:[f32] } 10642:{ *:[iPTR] }, f32:{ *:[f32] }:$A, f32:{ *:[f32] }:$B, f32:{ *:[f32] }:$C)  =>  (XSMSUBMSP:{ *:[f32] } ?:{ *:[f32] }:$A, ?:{ *:[f32] }:$B, ?:{ *:[f32] }:$C)
     /*  74709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMSUBMSP),
     /*  74712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  74714 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  74716 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  74718 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  74720 */     GIR_RootConstrainSelectedInstOperands,
     /*  74721 */     // GIR_Coverage, 1939,
     /*  74721 */     GIR_EraseRootFromParent_Done,
     /*  74722 */   // Label 1206: @74722
     /*  74722 */   GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(74764), // Rule ID 1940 //
     /*  74727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  74730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fnmadds),
     /*  74735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  74738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  74741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  74744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /*  74751 */     // (intrinsic_wo_chain:{ *:[f32] } 10646:{ *:[iPTR] }, f32:{ *:[f32] }:$A, f32:{ *:[f32] }:$B, f32:{ *:[f32] }:$C)  =>  (XSNMADDMSP:{ *:[f32] } ?:{ *:[f32] }:$A, ?:{ *:[f32] }:$B, ?:{ *:[f32] }:$C)
     /*  74751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMADDMSP),
     /*  74754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  74756 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  74758 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  74760 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  74762 */     GIR_RootConstrainSelectedInstOperands,
     /*  74763 */     // GIR_Coverage, 1940,
     /*  74763 */     GIR_EraseRootFromParent_Done,
     /*  74764 */   // Label 1207: @74764
     /*  74764 */   GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(74806), // Rule ID 508 //
     /*  74769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Crypto),
     /*  74772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vshasigmaw),
     /*  74777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  74787 */     // MIs[0] ST
     /*  74787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  74790 */     // MIs[0] SIX
     /*  74790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  74793 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10277:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, (timm:{ *:[i32] }):$ST, (timm:{ *:[i32] }):$SIX)  =>  (VSHASIGMAW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, (timm:{ *:[i32] }):$ST, (timm:{ *:[i32] }):$SIX)
     /*  74793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSHASIGMAW),
     /*  74796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  74798 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  74800 */     GIR_RootToRootCopy, /*OpIdx*/3, // ST
     /*  74802 */     GIR_RootToRootCopy, /*OpIdx*/4, // SIX
     /*  74804 */     GIR_RootConstrainSelectedInstOperands,
     /*  74805 */     // GIR_Coverage, 508,
     /*  74805 */     GIR_EraseRootFromParent_Done,
     /*  74806 */   // Label 1208: @74806
     /*  74806 */   GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(74848), // Rule ID 509 //
     /*  74811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Crypto),
     /*  74814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vshasigmad),
     /*  74819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  74822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  74829 */     // MIs[0] ST
     /*  74829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  74832 */     // MIs[0] SIX
     /*  74832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  74835 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10276:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, (timm:{ *:[i32] }):$ST, (timm:{ *:[i32] }):$SIX)  =>  (VSHASIGMAD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, (timm:{ *:[i32] }):$ST, (timm:{ *:[i32] }):$SIX)
     /*  74835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSHASIGMAD),
     /*  74838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  74840 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  74842 */     GIR_RootToRootCopy, /*OpIdx*/3, // ST
     /*  74844 */     GIR_RootToRootCopy, /*OpIdx*/4, // SIX
     /*  74846 */     GIR_RootConstrainSelectedInstOperands,
     /*  74847 */     // GIR_Coverage, 509,
     /*  74847 */     GIR_EraseRootFromParent_Done,
     /*  74848 */   // Label 1209: @74848
     /*  74848 */   GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(74890), // Rule ID 1060 //
     /*  74853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  74856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsldbi),
     /*  74861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  74864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  74874 */     // MIs[0] SD
     /*  74874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  74877 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10525:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VRA, v16i8:{ *:[v16i8] }:$VRB, (timm:{ *:[i32] }):$SD)  =>  (VSLDBI:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VRA, v16i8:{ *:[v16i8] }:$VRB, (timm:{ *:[i32] }):$SD)
     /*  74877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSLDBI),
     /*  74880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VRT]
     /*  74882 */     GIR_RootToRootCopy, /*OpIdx*/2, // VRA
     /*  74884 */     GIR_RootToRootCopy, /*OpIdx*/3, // VRB
     /*  74886 */     GIR_RootToRootCopy, /*OpIdx*/4, // SD
     /*  74888 */     GIR_RootConstrainSelectedInstOperands,
     /*  74889 */     // GIR_Coverage, 1060,
     /*  74889 */     GIR_EraseRootFromParent_Done,
     /*  74890 */   // Label 1210: @74890
     /*  74890 */   GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(74932), // Rule ID 1061 //
     /*  74895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  74898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsrdbi),
     /*  74903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  74906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  74916 */     // MIs[0] SD
     /*  74916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  74919 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10535:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VRA, v16i8:{ *:[v16i8] }:$VRB, (timm:{ *:[i32] }):$SD)  =>  (VSRDBI:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VRA, v16i8:{ *:[v16i8] }:$VRB, (timm:{ *:[i32] }):$SD)
     /*  74919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSRDBI),
     /*  74922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VRT]
     /*  74924 */     GIR_RootToRootCopy, /*OpIdx*/2, // VRA
     /*  74926 */     GIR_RootToRootCopy, /*OpIdx*/3, // VRB
     /*  74928 */     GIR_RootToRootCopy, /*OpIdx*/4, // SD
     /*  74930 */     GIR_RootConstrainSelectedInstOperands,
     /*  74931 */     // GIR_Coverage, 1061,
     /*  74931 */     GIR_EraseRootFromParent_Done,
     /*  74932 */   // Label 1211: @74932
     /*  74932 */   GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(74974), // Rule ID 1066 //
     /*  74937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  74940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinsw),
     /*  74945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  74954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  74958 */     // MIs[0] VA
     /*  74958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  74961 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10433:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VDi, i32:{ *:[i32] }:$VB, (timm:{ *:[i32] }):$VA)  =>  (VINSW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VDi, (timm:{ *:[i32] }):$VA, i32:{ *:[i32] }:$VB)
     /*  74961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSW),
     /*  74964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  74966 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  74968 */     GIR_RootToRootCopy, /*OpIdx*/4, // VA
     /*  74970 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  74972 */     GIR_RootConstrainSelectedInstOperands,
     /*  74973 */     // GIR_Coverage, 1066,
     /*  74973 */     GIR_EraseRootFromParent_Done,
     /*  74974 */   // Label 1212: @74974
     /*  74974 */   GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(75016), // Rule ID 1067 //
     /*  74979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  74982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinsd),
     /*  74987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  74990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  74996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75000 */     // MIs[0] VA
     /*  75000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  75003 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10426:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VDi, i64:{ *:[i64] }:$VB, (timm:{ *:[i32] }):$VA)  =>  (VINSD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VDi, (timm:{ *:[i32] }):$VA, i64:{ *:[i64] }:$VB)
     /*  75003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSD),
     /*  75006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  75008 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  75010 */     GIR_RootToRootCopy, /*OpIdx*/4, // VA
     /*  75012 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  75014 */     GIR_RootConstrainSelectedInstOperands,
     /*  75015 */     // GIR_Coverage, 1067,
     /*  75015 */     GIR_EraseRootFromParent_Done,
     /*  75016 */   // Label 1213: @75016
     /*  75016 */   GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(75058), // Rule ID 1168 //
     /*  75021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture),
     /*  75024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmsha2hash),
     /*  75029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  75032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  75035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v1024s1,
     /*  75038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  75042 */     // MIs[0] T
     /*  75042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  75045 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10689:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v1024i1:{ *:[v1024i1] }:$AB, (timm:{ *:[i32] }):$T)  =>  (DMSHA2HASH:{ *:[v1024i1] } v1024i1:{ *:[v1024i1] }:$ATi, v1024i1:{ *:[v1024i1] }:$AB, (timm:{ *:[i32] }):$T)
     /*  75045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMSHA2HASH),
     /*  75048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  75050 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  75052 */     GIR_RootToRootCopy, /*OpIdx*/3, // AB
     /*  75054 */     GIR_RootToRootCopy, /*OpIdx*/4, // T
     /*  75056 */     GIR_RootConstrainSelectedInstOperands,
     /*  75057 */     // GIR_Coverage, 1168,
     /*  75057 */     GIR_EraseRootFromParent_Done,
     /*  75058 */   // Label 1214: @75058
     /*  75058 */   GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(75103), // Rule ID 1450 //
     /*  75063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  75066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_bcdadd),
     /*  75071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  75074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  75077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  75080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75084 */     // MIs[0] PS
     /*  75084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  75087 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10580:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB, (timm:{ *:[i32] }):$PS)  =>  (BCDADD_rec:{ *:[v16i8] }:{ *:[i32] } ?:{ *:[v16i8] }:$vA, ?:{ *:[v16i8] }:$vB, ?:{ *:[i32] }:$PS)
     /*  75087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::BCDADD_rec),
     /*  75090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  75092 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  75094 */     GIR_RootToRootCopy, /*OpIdx*/3, // vB
     /*  75096 */     GIR_RootToRootCopy, /*OpIdx*/4, // PS
     /*  75098 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR6*/0,
     /*  75101 */     GIR_RootConstrainSelectedInstOperands,
     /*  75102 */     // GIR_Coverage, 1450,
     /*  75102 */     GIR_EraseRootFromParent_Done,
     /*  75103 */   // Label 1215: @75103
     /*  75103 */   GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(75148), // Rule ID 1451 //
     /*  75108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  75111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_bcdsub),
     /*  75116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  75119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  75122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  75125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75129 */     // MIs[0] PS
     /*  75129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  75132 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10582:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB, (timm:{ *:[i32] }):$PS)  =>  (BCDSUB_rec:{ *:[v16i8] }:{ *:[i32] } ?:{ *:[v16i8] }:$vA, ?:{ *:[v16i8] }:$vB, ?:{ *:[i32] }:$PS)
     /*  75132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::BCDSUB_rec),
     /*  75135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  75137 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  75139 */     GIR_RootToRootCopy, /*OpIdx*/3, // vB
     /*  75141 */     GIR_RootToRootCopy, /*OpIdx*/4, // PS
     /*  75143 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR6*/0,
     /*  75146 */     GIR_RootConstrainSelectedInstOperands,
     /*  75147 */     // GIR_Coverage, 1451,
     /*  75147 */     GIR_EraseRootFromParent_Done,
     /*  75148 */   // Label 1216: @75148
     /*  75148 */   GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(75202), // Rule ID 1566 //
     /*  75153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode_IsISA3_0),
     /*  75156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_maddhd),
     /*  75161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  75164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  75167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  75170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  75173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  75177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  75181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  75185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  75189 */     // (intrinsic_wo_chain:{ *:[i64] } 10672:{ *:[iPTR] }, g8rc:{ *:[i64] }:$a, g8rc:{ *:[i64] }:$b, g8rc:{ *:[i64] }:$c)  =>  (MADDHD:{ *:[i64] } ?:{ *:[i64] }:$a, ?:{ *:[i64] }:$b, ?:{ *:[i64] }:$c)
     /*  75189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MADDHD),
     /*  75192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75194 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  75196 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  75198 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  75200 */     GIR_RootConstrainSelectedInstOperands,
     /*  75201 */     // GIR_Coverage, 1566,
     /*  75201 */     GIR_EraseRootFromParent_Done,
     /*  75202 */   // Label 1217: @75202
     /*  75202 */   GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(75256), // Rule ID 1567 //
     /*  75207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode_IsISA3_0),
     /*  75210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_maddhdu),
     /*  75215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  75218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  75221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  75224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  75227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  75231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  75235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  75239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  75243 */     // (intrinsic_wo_chain:{ *:[i64] } 10673:{ *:[iPTR] }, g8rc:{ *:[i64] }:$a, g8rc:{ *:[i64] }:$b, g8rc:{ *:[i64] }:$c)  =>  (MADDHDU:{ *:[i64] } ?:{ *:[i64] }:$a, ?:{ *:[i64] }:$b, ?:{ *:[i64] }:$c)
     /*  75243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MADDHDU),
     /*  75246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75248 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  75250 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  75252 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  75254 */     GIR_RootConstrainSelectedInstOperands,
     /*  75255 */     // GIR_Coverage, 1567,
     /*  75255 */     GIR_EraseRootFromParent_Done,
     /*  75256 */   // Label 1218: @75256
     /*  75256 */   GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(75310), // Rule ID 1568 //
     /*  75261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode_IsISA3_0),
     /*  75264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_maddld),
     /*  75269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  75272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  75275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  75278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  75281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  75285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  75289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  75293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  75297 */     // (intrinsic_wo_chain:{ *:[i64] } 10674:{ *:[iPTR] }, g8rc:{ *:[i64] }:$a, g8rc:{ *:[i64] }:$b, g8rc:{ *:[i64] }:$c)  =>  (MADDLD8:{ *:[i64] } ?:{ *:[i64] }:$a, ?:{ *:[i64] }:$b, ?:{ *:[i64] }:$c)
     /*  75297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MADDLD8),
     /*  75300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75302 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  75304 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  75306 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  75308 */     GIR_RootConstrainSelectedInstOperands,
     /*  75309 */     // GIR_Coverage, 1568,
     /*  75309 */     GIR_EraseRootFromParent_Done,
     /*  75310 */   // Label 1219: @75310
     /*  75310 */   GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(75361), // Rule ID 4857 //
     /*  75315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fsel),
     /*  75320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  75323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  75326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  75329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  75332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  75336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  75340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  75344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  75348 */     // (intrinsic_wo_chain:{ *:[f64] } 10652:{ *:[iPTR] }, f8rc:{ *:[f64] }:$FRA, f8rc:{ *:[f64] }:$FRC, f8rc:{ *:[f64] }:$FRB)  =>  (FSELD:{ *:[f64] } ?:{ *:[f64] }:$FRA, ?:{ *:[f64] }:$FRC, ?:{ *:[f64] }:$FRB)
     /*  75348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FSELD),
     /*  75351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /*  75353 */     GIR_RootToRootCopy, /*OpIdx*/2, // FRA
     /*  75355 */     GIR_RootToRootCopy, /*OpIdx*/3, // FRC
     /*  75357 */     GIR_RootToRootCopy, /*OpIdx*/4, // FRB
     /*  75359 */     GIR_RootConstrainSelectedInstOperands,
     /*  75360 */     // GIR_Coverage, 4857,
     /*  75360 */     GIR_EraseRootFromParent_Done,
     /*  75361 */   // Label 1220: @75361
     /*  75361 */   GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(75403), // Rule ID 296 //
     /*  75366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  75369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmladduhm),
     /*  75374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  75377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  75383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  75386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75390 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10460:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v8i16:{ *:[v8i16] }:$RC)  =>  (VMLADDUHM:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v8i16:{ *:[v8i16] }:$RC)
     /*  75390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMLADDUHM),
     /*  75393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75395 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  75397 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  75399 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  75401 */     GIR_RootConstrainSelectedInstOperands,
     /*  75402 */     // GIR_Coverage, 296,
     /*  75402 */     GIR_EraseRootFromParent_Done,
     /*  75403 */   // Label 1221: @75403
     /*  75403 */   GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(75445), // Rule ID 297 //
     /*  75408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  75411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vperm),
     /*  75416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  75425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  75428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75432 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10491:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$RA, v4i32:{ *:[v4i32] }:$RB, v16i8:{ *:[v16i8] }:$RC)  =>  (VPERM:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$RA, v4i32:{ *:[v4i32] }:$RB, v16i8:{ *:[v16i8] }:$RC)
     /*  75432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPERM),
     /*  75435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75437 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  75439 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  75441 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  75443 */     GIR_RootConstrainSelectedInstOperands,
     /*  75444 */     // GIR_Coverage, 297,
     /*  75444 */     GIR_EraseRootFromParent_Done,
     /*  75445 */   // Label 1222: @75445
     /*  75445 */   GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(75487), // Rule ID 298 //
     /*  75450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  75453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsel),
     /*  75458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  75467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75474 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10522:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$RA, v4i32:{ *:[v4i32] }:$RB, v4i32:{ *:[v4i32] }:$RC)  =>  (VSEL:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$RA, v4i32:{ *:[v4i32] }:$RB, v4i32:{ *:[v4i32] }:$RC)
     /*  75474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSEL),
     /*  75477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75479 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  75481 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  75483 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  75485 */     GIR_RootConstrainSelectedInstOperands,
     /*  75486 */     // GIR_Coverage, 298,
     /*  75486 */     GIR_EraseRootFromParent_Done,
     /*  75487 */   // Label 1223: @75487
     /*  75487 */   GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(75529), // Rule ID 349 //
     /*  75492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  75495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmsummbm),
     /*  75500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  75506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  75509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75516 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10462:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$RA, v16i8:{ *:[v16i8] }:$RB, v4i32:{ *:[v4i32] }:$RC)  =>  (VMSUMMBM:{ *:[v4i32] } v16i8:{ *:[v16i8] }:$RA, v16i8:{ *:[v16i8] }:$RB, v4i32:{ *:[v4i32] }:$RC)
     /*  75516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMSUMMBM),
     /*  75519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75521 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  75523 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  75525 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  75527 */     GIR_RootConstrainSelectedInstOperands,
     /*  75528 */     // GIR_Coverage, 349,
     /*  75528 */     GIR_EraseRootFromParent_Done,
     /*  75529 */   // Label 1224: @75529
     /*  75529 */   GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(75571), // Rule ID 350 //
     /*  75534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  75537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmsumshm),
     /*  75542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  75551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75558 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10463:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v4i32:{ *:[v4i32] }:$RC)  =>  (VMSUMSHM:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v4i32:{ *:[v4i32] }:$RC)
     /*  75558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMSUMSHM),
     /*  75561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75563 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  75565 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  75567 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  75569 */     GIR_RootConstrainSelectedInstOperands,
     /*  75570 */     // GIR_Coverage, 350,
     /*  75570 */     GIR_EraseRootFromParent_Done,
     /*  75571 */   // Label 1225: @75571
     /*  75571 */   GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(75613), // Rule ID 351 //
     /*  75576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  75579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmsumubm),
     /*  75584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  75590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  75593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75600 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10465:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$RA, v16i8:{ *:[v16i8] }:$RB, v4i32:{ *:[v4i32] }:$RC)  =>  (VMSUMUBM:{ *:[v4i32] } v16i8:{ *:[v16i8] }:$RA, v16i8:{ *:[v16i8] }:$RB, v4i32:{ *:[v4i32] }:$RC)
     /*  75600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMSUMUBM),
     /*  75603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75605 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  75607 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  75609 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  75611 */     GIR_RootConstrainSelectedInstOperands,
     /*  75612 */     // GIR_Coverage, 351,
     /*  75612 */     GIR_EraseRootFromParent_Done,
     /*  75613 */   // Label 1226: @75613
     /*  75613 */   GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(75655), // Rule ID 352 //
     /*  75618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  75621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmsumuhm),
     /*  75626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  75635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75642 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10467:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v4i32:{ *:[v4i32] }:$RC)  =>  (VMSUMUHM:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v4i32:{ *:[v4i32] }:$RC)
     /*  75642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMSUMUHM),
     /*  75645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75647 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  75649 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  75651 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  75653 */     GIR_RootConstrainSelectedInstOperands,
     /*  75654 */     // GIR_Coverage, 352,
     /*  75654 */     GIR_EraseRootFromParent_Done,
     /*  75655 */   // Label 1227: @75655
     /*  75655 */   GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(75697), // Rule ID 471 //
     /*  75660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  75663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vaddeuqm),
     /*  75668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  75671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  75674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  75677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s128,
     /*  75680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75684 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10309:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$RA, v1i128:{ *:[v1i128] }:$RB, v1i128:{ *:[v1i128] }:$RC)  =>  (VADDEUQM:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$RA, v1i128:{ *:[v1i128] }:$RB, v1i128:{ *:[v1i128] }:$RC)
     /*  75684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VADDEUQM),
     /*  75687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75689 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  75691 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  75693 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  75695 */     GIR_RootConstrainSelectedInstOperands,
     /*  75696 */     // GIR_Coverage, 471,
     /*  75696 */     GIR_EraseRootFromParent_Done,
     /*  75697 */   // Label 1228: @75697
     /*  75697 */   GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(75739), // Rule ID 473 //
     /*  75702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  75705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vaddecuq),
     /*  75710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  75713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  75716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  75719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s128,
     /*  75722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75726 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10308:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$RA, v1i128:{ *:[v1i128] }:$RB, v1i128:{ *:[v1i128] }:$RC)  =>  (VADDECUQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$RA, v1i128:{ *:[v1i128] }:$RB, v1i128:{ *:[v1i128] }:$RC)
     /*  75726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VADDECUQ),
     /*  75729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75731 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  75733 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  75735 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  75737 */     GIR_RootConstrainSelectedInstOperands,
     /*  75738 */     // GIR_Coverage, 473,
     /*  75738 */     GIR_EraseRootFromParent_Done,
     /*  75739 */   // Label 1229: @75739
     /*  75739 */   GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(75781), // Rule ID 476 //
     /*  75744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  75747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsubeuqm),
     /*  75752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  75755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  75758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  75761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s128,
     /*  75764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75768 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10551:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$RA, v1i128:{ *:[v1i128] }:$RB, v1i128:{ *:[v1i128] }:$RC)  =>  (VSUBEUQM:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$RA, v1i128:{ *:[v1i128] }:$RB, v1i128:{ *:[v1i128] }:$RC)
     /*  75768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUBEUQM),
     /*  75771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75773 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  75775 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  75777 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  75779 */     GIR_RootConstrainSelectedInstOperands,
     /*  75780 */     // GIR_Coverage, 476,
     /*  75780 */     GIR_EraseRootFromParent_Done,
     /*  75781 */   // Label 1230: @75781
     /*  75781 */   GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(75823), // Rule ID 478 //
     /*  75786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  75789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsubecuq),
     /*  75794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  75797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  75800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  75803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s128,
     /*  75806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75810 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10550:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$RA, v1i128:{ *:[v1i128] }:$RB, v1i128:{ *:[v1i128] }:$RC)  =>  (VSUBECUQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$RA, v1i128:{ *:[v1i128] }:$RB, v1i128:{ *:[v1i128] }:$RC)
     /*  75810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUBECUQ),
     /*  75813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75815 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  75817 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  75819 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  75821 */     GIR_RootConstrainSelectedInstOperands,
     /*  75822 */     // GIR_Coverage, 478,
     /*  75822 */     GIR_EraseRootFromParent_Done,
     /*  75823 */   // Label 1231: @75823
     /*  75823 */   GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(75865), // Rule ID 515 //
     /*  75828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  75831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmsumudm),
     /*  75836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  75839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  75842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  75845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s128,
     /*  75848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75852 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10466:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$RA, v2i64:{ *:[v2i64] }:$RB, v1i128:{ *:[v1i128] }:$RC)  =>  (VMSUMUDM:{ *:[v1i128] } v2i64:{ *:[v2i64] }:$RA, v2i64:{ *:[v2i64] }:$RB, v1i128:{ *:[v1i128] }:$RC)
     /*  75852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMSUMUDM),
     /*  75855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75857 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  75859 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  75861 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  75863 */     GIR_RootConstrainSelectedInstOperands,
     /*  75864 */     // GIR_Coverage, 515,
     /*  75864 */     GIR_EraseRootFromParent_Done,
     /*  75865 */   // Label 1232: @75865
     /*  75865 */   GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(75907), // Rule ID 548 //
     /*  75870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  75873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrlwmi),
     /*  75878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  75887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75894 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10519:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB, v4i32:{ *:[v4i32] }:$VDi)  =>  (VRLWMI:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB, v4i32:{ *:[v4i32] }:$VDi)
     /*  75894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRLWMI),
     /*  75897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  75899 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  75901 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  75903 */     GIR_RootToRootCopy, /*OpIdx*/4, // VDi
     /*  75905 */     GIR_RootConstrainSelectedInstOperands,
     /*  75906 */     // GIR_Coverage, 548,
     /*  75906 */     GIR_EraseRootFromParent_Done,
     /*  75907 */   // Label 1233: @75907
     /*  75907 */   GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(75949), // Rule ID 550 //
     /*  75912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  75915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrldmi),
     /*  75920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  75923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  75926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  75929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  75932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75936 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10513:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB, v2i64:{ *:[v2i64] }:$VDi)  =>  (VRLDMI:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB, v2i64:{ *:[v2i64] }:$VDi)
     /*  75936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRLDMI),
     /*  75939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  75941 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  75943 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  75945 */     GIR_RootToRootCopy, /*OpIdx*/4, // VDi
     /*  75947 */     GIR_RootConstrainSelectedInstOperands,
     /*  75948 */     // GIR_Coverage, 550,
     /*  75948 */     GIR_EraseRootFromParent_Done,
     /*  75949 */   // Label 1234: @75949
     /*  75949 */   GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(75991), // Rule ID 1068 //
     /*  75954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  75957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinsbvlx),
     /*  75962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  75965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  75968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  75974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75978 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10424:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VDi, i32:{ *:[i32] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VINSBVLX:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VDi, i32:{ *:[i32] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  75978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSBVLX),
     /*  75981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  75983 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  75985 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  75987 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  75989 */     GIR_RootConstrainSelectedInstOperands,
     /*  75990 */     // GIR_Coverage, 1068,
     /*  75990 */     GIR_EraseRootFromParent_Done,
     /*  75991 */   // Label 1235: @75991
     /*  75991 */   GIM_Try, /*On fail goto*//*Label 1236*/ GIMT_Encode4(76033), // Rule ID 1069 //
     /*  75996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  75999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinsbvrx),
     /*  76004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  76007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  76016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76020 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10425:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VDi, i32:{ *:[i32] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VINSBVRX:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VDi, i32:{ *:[i32] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  76020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSBVRX),
     /*  76023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  76025 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  76027 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  76029 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  76031 */     GIR_RootConstrainSelectedInstOperands,
     /*  76032 */     // GIR_Coverage, 1069,
     /*  76032 */     GIR_EraseRootFromParent_Done,
     /*  76033 */   // Label 1236: @76033
     /*  76033 */   GIM_Try, /*On fail goto*//*Label 1237*/ GIMT_Encode4(76075), // Rule ID 1070 //
     /*  76038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinshvlx),
     /*  76046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  76049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  76058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76062 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10431:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VDi, i32:{ *:[i32] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VINSHVLX:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VDi, i32:{ *:[i32] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  76062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSHVLX),
     /*  76065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  76067 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  76069 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  76071 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  76073 */     GIR_RootConstrainSelectedInstOperands,
     /*  76074 */     // GIR_Coverage, 1070,
     /*  76074 */     GIR_EraseRootFromParent_Done,
     /*  76075 */   // Label 1237: @76075
     /*  76075 */   GIM_Try, /*On fail goto*//*Label 1238*/ GIMT_Encode4(76117), // Rule ID 1071 //
     /*  76080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinshvrx),
     /*  76088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  76091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  76100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76104 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10432:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VDi, i32:{ *:[i32] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VINSHVRX:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VDi, i32:{ *:[i32] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  76104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSHVRX),
     /*  76107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  76109 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  76111 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  76113 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  76115 */     GIR_RootConstrainSelectedInstOperands,
     /*  76116 */     // GIR_Coverage, 1071,
     /*  76116 */     GIR_EraseRootFromParent_Done,
     /*  76117 */   // Label 1238: @76117
     /*  76117 */   GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(76159), // Rule ID 1072 //
     /*  76122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinswvlx),
     /*  76130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  76133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  76136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  76142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76146 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10436:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VDi, i32:{ *:[i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VINSWVLX:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VDi, i32:{ *:[i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  76146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSWVLX),
     /*  76149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  76151 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  76153 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  76155 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  76157 */     GIR_RootConstrainSelectedInstOperands,
     /*  76158 */     // GIR_Coverage, 1072,
     /*  76158 */     GIR_EraseRootFromParent_Done,
     /*  76159 */   // Label 1239: @76159
     /*  76159 */   GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(76201), // Rule ID 1073 //
     /*  76164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinswvrx),
     /*  76172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  76175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  76178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  76184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76188 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10437:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VDi, i32:{ *:[i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VINSWVRX:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VDi, i32:{ *:[i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  76188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSWVRX),
     /*  76191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  76193 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  76195 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  76197 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  76199 */     GIR_RootConstrainSelectedInstOperands,
     /*  76200 */     // GIR_Coverage, 1073,
     /*  76200 */     GIR_EraseRootFromParent_Done,
     /*  76201 */   // Label 1240: @76201
     /*  76201 */   GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(76243), // Rule ID 1074 //
     /*  76206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinsblx),
     /*  76214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  76217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76230 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10422:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)  =>  (VINSBLX:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)
     /*  76230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSBLX),
     /*  76233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  76235 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  76237 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  76239 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  76241 */     GIR_RootConstrainSelectedInstOperands,
     /*  76242 */     // GIR_Coverage, 1074,
     /*  76242 */     GIR_EraseRootFromParent_Done,
     /*  76243 */   // Label 1241: @76243
     /*  76243 */   GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(76285), // Rule ID 1075 //
     /*  76248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinsbrx),
     /*  76256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  76259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76272 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10423:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)  =>  (VINSBRX:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)
     /*  76272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSBRX),
     /*  76275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  76277 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  76279 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  76281 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  76283 */     GIR_RootConstrainSelectedInstOperands,
     /*  76284 */     // GIR_Coverage, 1075,
     /*  76284 */     GIR_EraseRootFromParent_Done,
     /*  76285 */   // Label 1242: @76285
     /*  76285 */   GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(76327), // Rule ID 1076 //
     /*  76290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinshlx),
     /*  76298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  76301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76314 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10429:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)  =>  (VINSHLX:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)
     /*  76314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSHLX),
     /*  76317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  76319 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  76321 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  76323 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  76325 */     GIR_RootConstrainSelectedInstOperands,
     /*  76326 */     // GIR_Coverage, 1076,
     /*  76326 */     GIR_EraseRootFromParent_Done,
     /*  76327 */   // Label 1243: @76327
     /*  76327 */   GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(76369), // Rule ID 1077 //
     /*  76332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinshrx),
     /*  76340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  76343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76356 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10430:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)  =>  (VINSHRX:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)
     /*  76356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSHRX),
     /*  76359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  76361 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  76363 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  76365 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  76367 */     GIR_RootConstrainSelectedInstOperands,
     /*  76368 */     // GIR_Coverage, 1077,
     /*  76368 */     GIR_EraseRootFromParent_Done,
     /*  76369 */   // Label 1244: @76369
     /*  76369 */   GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(76411), // Rule ID 1078 //
     /*  76374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinswlx),
     /*  76382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  76385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  76388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76398 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10434:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)  =>  (VINSWLX:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)
     /*  76398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSWLX),
     /*  76401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  76403 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  76405 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  76407 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  76409 */     GIR_RootConstrainSelectedInstOperands,
     /*  76410 */     // GIR_Coverage, 1078,
     /*  76410 */     GIR_EraseRootFromParent_Done,
     /*  76411 */   // Label 1245: @76411
     /*  76411 */   GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(76453), // Rule ID 1079 //
     /*  76416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinswrx),
     /*  76424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  76427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  76430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76440 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10435:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)  =>  (VINSWRX:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)
     /*  76440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSWRX),
     /*  76443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  76445 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  76447 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  76449 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  76451 */     GIR_RootConstrainSelectedInstOperands,
     /*  76452 */     // GIR_Coverage, 1079,
     /*  76452 */     GIR_EraseRootFromParent_Done,
     /*  76453 */   // Label 1246: @76453
     /*  76453 */   GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(76495), // Rule ID 1080 //
     /*  76458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinsdlx),
     /*  76466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  76469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  76472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  76475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  76478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76482 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10427:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VDi, i64:{ *:[i64] }:$VA, i64:{ *:[i64] }:$VB)  =>  (VINSDLX:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VDi, i64:{ *:[i64] }:$VA, i64:{ *:[i64] }:$VB)
     /*  76482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSDLX),
     /*  76485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  76487 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  76489 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  76491 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  76493 */     GIR_RootConstrainSelectedInstOperands,
     /*  76494 */     // GIR_Coverage, 1080,
     /*  76494 */     GIR_EraseRootFromParent_Done,
     /*  76495 */   // Label 1247: @76495
     /*  76495 */   GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(76537), // Rule ID 1081 //
     /*  76500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinsdrx),
     /*  76508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  76511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  76514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  76517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  76520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76524 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10428:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VDi, i64:{ *:[i64] }:$VA, i64:{ *:[i64] }:$VB)  =>  (VINSDRX:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VDi, i64:{ *:[i64] }:$VA, i64:{ *:[i64] }:$VB)
     /*  76524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSDRX),
     /*  76527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  76529 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  76531 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  76533 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  76535 */     GIR_RootConstrainSelectedInstOperands,
     /*  76536 */     // GIR_Coverage, 1081,
     /*  76536 */     GIR_EraseRootFromParent_Done,
     /*  76537 */   // Label 1248: @76537
     /*  76537 */   GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(76579), // Rule ID 1102 //
     /*  76542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextdubvlx),
     /*  76550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  76553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  76559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76566 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10403:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$RA, v16i8:{ *:[v16i8] }:$RB, i32:{ *:[i32] }:$RC)  =>  (VEXTDUBVLX:{ *:[v2i64] } v16i8:{ *:[v16i8] }:$RA, v16i8:{ *:[v16i8] }:$RB, i32:{ *:[i32] }:$RC)
     /*  76566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTDUBVLX),
     /*  76569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  76571 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  76573 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  76575 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  76577 */     GIR_RootConstrainSelectedInstOperands,
     /*  76578 */     // GIR_Coverage, 1102,
     /*  76578 */     GIR_EraseRootFromParent_Done,
     /*  76579 */   // Label 1249: @76579
     /*  76579 */   GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(76621), // Rule ID 1103 //
     /*  76584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextdubvrx),
     /*  76592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  76595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  76601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76608 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10404:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$RA, v16i8:{ *:[v16i8] }:$RB, i32:{ *:[i32] }:$RC)  =>  (VEXTDUBVRX:{ *:[v2i64] } v16i8:{ *:[v16i8] }:$RA, v16i8:{ *:[v16i8] }:$RB, i32:{ *:[i32] }:$RC)
     /*  76608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTDUBVRX),
     /*  76611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  76613 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  76615 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  76617 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  76619 */     GIR_RootConstrainSelectedInstOperands,
     /*  76620 */     // GIR_Coverage, 1103,
     /*  76620 */     GIR_EraseRootFromParent_Done,
     /*  76621 */   // Label 1250: @76621
     /*  76621 */   GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(76663), // Rule ID 1104 //
     /*  76626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextduhvlx),
     /*  76634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  76637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  76643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76650 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10405:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, i32:{ *:[i32] }:$RC)  =>  (VEXTDUHVLX:{ *:[v2i64] } v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, i32:{ *:[i32] }:$RC)
     /*  76650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTDUHVLX),
     /*  76653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  76655 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  76657 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  76659 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  76661 */     GIR_RootConstrainSelectedInstOperands,
     /*  76662 */     // GIR_Coverage, 1104,
     /*  76662 */     GIR_EraseRootFromParent_Done,
     /*  76663 */   // Label 1251: @76663
     /*  76663 */   GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(76705), // Rule ID 1105 //
     /*  76668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextduhvrx),
     /*  76676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  76679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  76685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76692 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10406:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, i32:{ *:[i32] }:$RC)  =>  (VEXTDUHVRX:{ *:[v2i64] } v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, i32:{ *:[i32] }:$RC)
     /*  76692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTDUHVRX),
     /*  76695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  76697 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  76699 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  76701 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  76703 */     GIR_RootConstrainSelectedInstOperands,
     /*  76704 */     // GIR_Coverage, 1105,
     /*  76704 */     GIR_EraseRootFromParent_Done,
     /*  76705 */   // Label 1252: @76705
     /*  76705 */   GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(76747), // Rule ID 1106 //
     /*  76710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextduwvlx),
     /*  76718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  76721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  76724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  76727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76734 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10407:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$RA, v4i32:{ *:[v4i32] }:$RB, i32:{ *:[i32] }:$RC)  =>  (VEXTDUWVLX:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$RA, v4i32:{ *:[v4i32] }:$RB, i32:{ *:[i32] }:$RC)
     /*  76734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTDUWVLX),
     /*  76737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  76739 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  76741 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  76743 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  76745 */     GIR_RootConstrainSelectedInstOperands,
     /*  76746 */     // GIR_Coverage, 1106,
     /*  76746 */     GIR_EraseRootFromParent_Done,
     /*  76747 */   // Label 1253: @76747
     /*  76747 */   GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(76789), // Rule ID 1107 //
     /*  76752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextduwvrx),
     /*  76760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  76763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  76766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  76769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76776 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10408:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$RA, v4i32:{ *:[v4i32] }:$RB, i32:{ *:[i32] }:$RC)  =>  (VEXTDUWVRX:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$RA, v4i32:{ *:[v4i32] }:$RB, i32:{ *:[i32] }:$RC)
     /*  76776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTDUWVRX),
     /*  76779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  76781 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  76783 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  76785 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  76787 */     GIR_RootConstrainSelectedInstOperands,
     /*  76788 */     // GIR_Coverage, 1107,
     /*  76788 */     GIR_EraseRootFromParent_Done,
     /*  76789 */   // Label 1254: @76789
     /*  76789 */   GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(76831), // Rule ID 1108 //
     /*  76794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextddvlx),
     /*  76802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  76805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  76808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  76811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76818 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10401:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$RA, v2i64:{ *:[v2i64] }:$RB, i32:{ *:[i32] }:$RC)  =>  (VEXTDDVLX:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$RA, v2i64:{ *:[v2i64] }:$RB, i32:{ *:[i32] }:$RC)
     /*  76818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTDDVLX),
     /*  76821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  76823 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  76825 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  76827 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  76829 */     GIR_RootConstrainSelectedInstOperands,
     /*  76830 */     // GIR_Coverage, 1108,
     /*  76830 */     GIR_EraseRootFromParent_Done,
     /*  76831 */   // Label 1255: @76831
     /*  76831 */   GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(76873), // Rule ID 1109 //
     /*  76836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextddvrx),
     /*  76844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  76847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  76850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  76853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76860 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10402:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$RA, v2i64:{ *:[v2i64] }:$RB, i32:{ *:[i32] }:$RC)  =>  (VEXTDDVRX:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$RA, v2i64:{ *:[v2i64] }:$RB, i32:{ *:[i32] }:$RC)
     /*  76860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTDDVRX),
     /*  76863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  76865 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  76867 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  76869 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  76871 */     GIR_RootConstrainSelectedInstOperands,
     /*  76872 */     // GIR_Coverage, 1109,
     /*  76872 */     GIR_EraseRootFromParent_Done,
     /*  76873 */   // Label 1256: @76873
     /*  76873 */   GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(76915), // Rule ID 1147 //
     /*  76878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmsumcud),
     /*  76886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  76889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  76892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  76895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s128,
     /*  76898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76902 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10461:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$RA, v2i64:{ *:[v2i64] }:$RB, v1i128:{ *:[v1i128] }:$RC)  =>  (VMSUMCUD:{ *:[v1i128] } v2i64:{ *:[v2i64] }:$RA, v2i64:{ *:[v2i64] }:$RB, v1i128:{ *:[v1i128] }:$RC)
     /*  76902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMSUMCUD),
     /*  76905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  76907 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  76909 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  76911 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  76913 */     GIR_RootConstrainSelectedInstOperands,
     /*  76914 */     // GIR_Coverage, 1147,
     /*  76914 */     GIR_EraseRootFromParent_Done,
     /*  76915 */   // Label 1257: @76915
     /*  76915 */   GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(76957), // Rule ID 1162 //
     /*  76920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrlqmi),
     /*  76928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  76931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  76934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  76937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s128,
     /*  76940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76944 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10516:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB, v1i128:{ *:[v1i128] }:$VDi)  =>  (VRLQMI:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB, v1i128:{ *:[v1i128] }:$VDi)
     /*  76944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRLQMI),
     /*  76947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  76949 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  76951 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  76953 */     GIR_RootToRootCopy, /*OpIdx*/4, // VDi
     /*  76955 */     GIR_RootConstrainSelectedInstOperands,
     /*  76956 */     // GIR_Coverage, 1162,
     /*  76956 */     GIR_EraseRootFromParent_Done,
     /*  76957 */   // Label 1258: @76957
     /*  76957 */   GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(76996), // Rule ID 1282 //
     /*  76962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fmsub),
     /*  76967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  76970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  76973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  76976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  76979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  76983 */     // (intrinsic_wo_chain:{ *:[f64] } 10641:{ *:[iPTR] }, f64:{ *:[f64] }:$A, f64:{ *:[f64] }:$B, f64:{ *:[f64] }:$C)  =>  (FMSUB:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B, ?:{ *:[f64] }:$C)
     /*  76983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FMSUB),
     /*  76986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /*  76988 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  76990 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  76992 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  76994 */     GIR_RootConstrainSelectedInstOperands,
     /*  76995 */     // GIR_Coverage, 1282,
     /*  76995 */     GIR_EraseRootFromParent_Done,
     /*  76996 */   // Label 1259: @76996
     /*  76996 */   GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(77035), // Rule ID 1283 //
     /*  77001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fmsubs),
     /*  77006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  77009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  77012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  77015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /*  77022 */     // (intrinsic_wo_chain:{ *:[f32] } 10642:{ *:[iPTR] }, f32:{ *:[f32] }:$A, f32:{ *:[f32] }:$B, f32:{ *:[f32] }:$C)  =>  (FMSUBS:{ *:[f32] } ?:{ *:[f32] }:$A, ?:{ *:[f32] }:$B, ?:{ *:[f32] }:$C)
     /*  77022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FMSUBS),
     /*  77025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /*  77027 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  77029 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  77031 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  77033 */     GIR_RootConstrainSelectedInstOperands,
     /*  77034 */     // GIR_Coverage, 1283,
     /*  77034 */     GIR_EraseRootFromParent_Done,
     /*  77035 */   // Label 1260: @77035
     /*  77035 */   GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(77074), // Rule ID 1284 //
     /*  77040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fnmadd),
     /*  77045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  77048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  77051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  77054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  77057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  77061 */     // (intrinsic_wo_chain:{ *:[f64] } 10645:{ *:[iPTR] }, f64:{ *:[f64] }:$A, f64:{ *:[f64] }:$B, f64:{ *:[f64] }:$C)  =>  (FNMADD:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B, ?:{ *:[f64] }:$C)
     /*  77061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNMADD),
     /*  77064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /*  77066 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  77068 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  77070 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  77072 */     GIR_RootConstrainSelectedInstOperands,
     /*  77073 */     // GIR_Coverage, 1284,
     /*  77073 */     GIR_EraseRootFromParent_Done,
     /*  77074 */   // Label 1261: @77074
     /*  77074 */   GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(77113), // Rule ID 1285 //
     /*  77079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fnmadds),
     /*  77084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  77087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  77090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  77093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /*  77100 */     // (intrinsic_wo_chain:{ *:[f32] } 10646:{ *:[iPTR] }, f32:{ *:[f32] }:$A, f32:{ *:[f32] }:$B, f32:{ *:[f32] }:$C)  =>  (FNMADDS:{ *:[f32] } ?:{ *:[f32] }:$A, ?:{ *:[f32] }:$B, ?:{ *:[f32] }:$C)
     /*  77100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNMADDS),
     /*  77103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /*  77105 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  77107 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  77109 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  77111 */     GIR_RootConstrainSelectedInstOperands,
     /*  77112 */     // GIR_Coverage, 1285,
     /*  77112 */     GIR_EraseRootFromParent_Done,
     /*  77113 */   // Label 1262: @77113
     /*  77113 */   GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(77155), // Rule ID 1387 //
     /*  77118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  77121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmaddfp),
     /*  77126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  77129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  77132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  77135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  77138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  77142 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10439:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$A, v4f32:{ *:[v4f32] }:$B, v4f32:{ *:[v4f32] }:$C)  =>  (VMADDFP:{ *:[v4f32] } ?:{ *:[v4f32] }:$A, ?:{ *:[v4f32] }:$B, ?:{ *:[v4f32] }:$C)
     /*  77142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMADDFP),
     /*  77145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  77147 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  77149 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  77151 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  77153 */     GIR_RootConstrainSelectedInstOperands,
     /*  77154 */     // GIR_Coverage, 1387,
     /*  77154 */     GIR_EraseRootFromParent_Done,
     /*  77155 */   // Label 1263: @77155
     /*  77155 */   GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(77197), // Rule ID 1388 //
     /*  77160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  77163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vnmsubfp),
     /*  77168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  77171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  77174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  77177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  77180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  77184 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10489:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$A, v4f32:{ *:[v4f32] }:$B, v4f32:{ *:[v4f32] }:$C)  =>  (VNMSUBFP:{ *:[v4f32] } ?:{ *:[v4f32] }:$A, ?:{ *:[v4f32] }:$B, ?:{ *:[v4f32] }:$C)
     /*  77184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VNMSUBFP),
     /*  77187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  77189 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  77191 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  77193 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  77195 */     GIR_RootConstrainSelectedInstOperands,
     /*  77196 */     // GIR_Coverage, 1388,
     /*  77196 */     GIR_EraseRootFromParent_Done,
     /*  77197 */   // Label 1264: @77197
     /*  77197 */   GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(77302), // Rule ID 1584 //
     /*  77202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec_HasVSX_IsLittleEndian),
     /*  77205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vpermxor),
     /*  77210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  77213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  77222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  77226 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10269:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$a, v16i8:{ *:[v16i8] }:$b, v16i8:{ *:[v16i8] }:$c)  =>  (VPERMXOR:{ *:[v16i8] } ?:{ *:[v16i8] }:$a, ?:{ *:[v16i8] }:$b, (XXLNOR:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$c, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$c, VSRC:{ *:[i32] })))
     /*  77226 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  77229 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77233 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77238 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/4, // c
     /*  77242 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77247 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  77250 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77254 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77259 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // c
     /*  77263 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77268 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77271 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXLNOR),
     /*  77275 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77280 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  77283 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  77286 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  77288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPERMXOR),
     /*  77291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  77293 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  77295 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  77297 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77300 */     GIR_RootConstrainSelectedInstOperands,
     /*  77301 */     // GIR_Coverage, 1584,
     /*  77301 */     GIR_EraseRootFromParent_Done,
     /*  77302 */   // Label 1265: @77302
     /*  77302 */   GIM_Try, /*On fail goto*//*Label 1266*/ GIMT_Encode4(77344), // Rule ID 1585 //
     /*  77307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec_HasVSX_IsBigEndian),
     /*  77310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vpermxor),
     /*  77315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  77318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  77327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  77331 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10269:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$a, v16i8:{ *:[v16i8] }:$b, v16i8:{ *:[v16i8] }:$c)  =>  (VPERMXOR:{ *:[v16i8] } ?:{ *:[v16i8] }:$a, ?:{ *:[v16i8] }:$b, ?:{ *:[v16i8] }:$c)
     /*  77331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPERMXOR),
     /*  77334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  77336 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  77338 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  77340 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  77342 */     GIR_RootConstrainSelectedInstOperands,
     /*  77343 */     // GIR_Coverage, 1585,
     /*  77343 */     GIR_EraseRootFromParent_Done,
     /*  77344 */   // Label 1266: @77344
     /*  77344 */   GIM_Try, /*On fail goto*//*Label 1267*/ GIMT_Encode4(77386), // Rule ID 1586 //
     /*  77349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec_HasVSX),
     /*  77352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vpermxor_be),
     /*  77357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  77360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  77369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  77373 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10270:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$a, v16i8:{ *:[v16i8] }:$b, v16i8:{ *:[v16i8] }:$c)  =>  (VPERMXOR:{ *:[v16i8] } ?:{ *:[v16i8] }:$a, ?:{ *:[v16i8] }:$b, ?:{ *:[v16i8] }:$c)
     /*  77373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPERMXOR),
     /*  77376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  77378 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  77380 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  77382 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  77384 */     GIR_RootConstrainSelectedInstOperands,
     /*  77385 */     // GIR_Coverage, 1586,
     /*  77385 */     GIR_EraseRootFromParent_Done,
     /*  77386 */   // Label 1267: @77386
     /*  77386 */   GIM_Try, /*On fail goto*//*Label 1268*/ GIMT_Encode4(77515), // Rule ID 3432 //
     /*  77391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  77394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxblendvb),
     /*  77399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  77402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  77411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77415 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10917:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$A, v16i8:{ *:[v16i8] }:$B, v16i8:{ *:[v16i8] }:$C)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (XXBLENDVB:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$A, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$B, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$C, VSRC:{ *:[i32] })), VSRC:{ *:[i32] })
     /*  77415 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /*  77418 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77422 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77427 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/4, // C
     /*  77431 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77436 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  77439 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77443 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77448 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // B
     /*  77452 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77457 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  77460 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77464 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77469 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  77473 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXBLENDVB),
     /*  77485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77490 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  77493 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  77496 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  77499 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  77501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  77506 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77509 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77514 */     // GIR_Coverage, 3432,
     /*  77514 */     GIR_EraseRootFromParent_Done,
     /*  77515 */   // Label 1268: @77515
     /*  77515 */   GIM_Try, /*On fail goto*//*Label 1269*/ GIMT_Encode4(77644), // Rule ID 3433 //
     /*  77520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  77523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxblendvh),
     /*  77528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  77531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  77534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  77537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  77540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77544 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10919:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$A, v8i16:{ *:[v8i16] }:$B, v8i16:{ *:[v8i16] }:$C)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } (XXBLENDVH:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v8i16] }:$A, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v8i16] }:$B, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v8i16] }:$C, VSRC:{ *:[i32] })), VSRC:{ *:[i32] })
     /*  77544 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /*  77547 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77551 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77556 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/4, // C
     /*  77560 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77565 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  77568 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77572 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77577 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // B
     /*  77581 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77586 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  77589 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77593 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77598 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  77602 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77607 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77610 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXBLENDVH),
     /*  77614 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77619 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  77622 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  77625 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  77628 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  77630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  77635 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77638 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77643 */     // GIR_Coverage, 3433,
     /*  77643 */     GIR_EraseRootFromParent_Done,
     /*  77644 */   // Label 1269: @77644
     /*  77644 */   GIM_Try, /*On fail goto*//*Label 1270*/ GIMT_Encode4(77686), // Rule ID 3434 //
     /*  77649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  77652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxblendvw),
     /*  77657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  77660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  77663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  77666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  77669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77673 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10920:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$A, v4i32:{ *:[v4i32] }:$B, v4i32:{ *:[v4i32] }:$C)  =>  (XXBLENDVW:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B, ?:{ *:[v4i32] }:$C)
     /*  77673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXBLENDVW),
     /*  77676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  77678 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  77680 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  77682 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  77684 */     GIR_RootConstrainSelectedInstOperands,
     /*  77685 */     // GIR_Coverage, 3434,
     /*  77685 */     GIR_EraseRootFromParent_Done,
     /*  77686 */   // Label 1270: @77686
     /*  77686 */   GIM_Try, /*On fail goto*//*Label 1271*/ GIMT_Encode4(77728), // Rule ID 3435 //
     /*  77691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  77694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxblendvd),
     /*  77699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  77702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  77705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  77708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  77711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77715 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10918:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$A, v2i64:{ *:[v2i64] }:$B, v2i64:{ *:[v2i64] }:$C)  =>  (XXBLENDVD:{ *:[v2i64] } ?:{ *:[v2i64] }:$A, ?:{ *:[v2i64] }:$B, ?:{ *:[v2i64] }:$C)
     /*  77715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXBLENDVD),
     /*  77718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  77720 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  77722 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  77724 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  77726 */     GIR_RootConstrainSelectedInstOperands,
     /*  77727 */     // GIR_Coverage, 3435,
     /*  77727 */     GIR_EraseRootFromParent_Done,
     /*  77728 */   // Label 1271: @77728
     /*  77728 */   GIM_Try, /*On fail goto*//*Label 1272*/ GIMT_Encode4(77792), // Rule ID 3517 //
     /*  77733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  77736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxvi8gerx4pp),
     /*  77741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  77744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  77747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  77750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  77753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  77757 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10703:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB)  =>  (DMXVI8GERX4PP:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  77757 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77760 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77764 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77769 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  77773 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXVI8GERX4PP),
     /*  77781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  77783 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  77785 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  77787 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77790 */     GIR_RootConstrainSelectedInstOperands,
     /*  77791 */     // GIR_Coverage, 3517,
     /*  77791 */     GIR_EraseRootFromParent_Done,
     /*  77792 */   // Label 1272: @77792
     /*  77792 */   GIM_Try, /*On fail goto*//*Label 1273*/ GIMT_Encode4(77856), // Rule ID 3518 //
     /*  77797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  77800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxvi8gerx4spp),
     /*  77805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  77808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  77811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  77814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  77817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  77821 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10704:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB)  =>  (DMXVI8GERX4SPP:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  77821 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77824 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77828 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77833 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  77837 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXVI8GERX4SPP),
     /*  77845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  77847 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  77849 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  77851 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77854 */     GIR_RootConstrainSelectedInstOperands,
     /*  77855 */     // GIR_Coverage, 3518,
     /*  77855 */     GIR_EraseRootFromParent_Done,
     /*  77856 */   // Label 1273: @77856
     /*  77856 */   GIM_Try, /*On fail goto*//*Label 1274*/ GIMT_Encode4(77920), // Rule ID 3520 //
     /*  77861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  77864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxvbf16gerx2pp),
     /*  77869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  77872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  77875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  77878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  77881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  77885 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10696:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB)  =>  (DMXVBF16GERX2PP:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  77885 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77888 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77892 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77897 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  77901 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXVBF16GERX2PP),
     /*  77909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  77911 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  77913 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  77915 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77918 */     GIR_RootConstrainSelectedInstOperands,
     /*  77919 */     // GIR_Coverage, 3520,
     /*  77919 */     GIR_EraseRootFromParent_Done,
     /*  77920 */   // Label 1274: @77920
     /*  77920 */   GIM_Try, /*On fail goto*//*Label 1275*/ GIMT_Encode4(77984), // Rule ID 3521 //
     /*  77925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  77928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxvbf16gerx2pn),
     /*  77933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  77936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  77939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  77942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  77945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  77949 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10695:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB)  =>  (DMXVBF16GERX2PN:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  77949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77961 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  77965 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXVBF16GERX2PN),
     /*  77973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  77975 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  77977 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  77979 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77982 */     GIR_RootConstrainSelectedInstOperands,
     /*  77983 */     // GIR_Coverage, 3521,
     /*  77983 */     GIR_EraseRootFromParent_Done,
     /*  77984 */   // Label 1275: @77984
     /*  77984 */   GIM_Try, /*On fail goto*//*Label 1276*/ GIMT_Encode4(78048), // Rule ID 3522 //
     /*  77989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  77992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxvbf16gerx2np),
     /*  77997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  78000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  78003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  78006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  78013 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10694:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB)  =>  (DMXVBF16GERX2NP:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78013 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78016 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78020 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78025 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78029 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXVBF16GERX2NP),
     /*  78037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78039 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78041 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  78043 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78046 */     GIR_RootConstrainSelectedInstOperands,
     /*  78047 */     // GIR_Coverage, 3522,
     /*  78047 */     GIR_EraseRootFromParent_Done,
     /*  78048 */   // Label 1276: @78048
     /*  78048 */   GIM_Try, /*On fail goto*//*Label 1277*/ GIMT_Encode4(78112), // Rule ID 3523 //
     /*  78053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  78056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxvbf16gerx2nn),
     /*  78061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  78064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  78067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  78070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  78077 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10693:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB)  =>  (DMXVBF16GERX2NN:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78077 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78080 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78084 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78089 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78093 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXVBF16GERX2NN),
     /*  78101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78103 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78105 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  78107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78110 */     GIR_RootConstrainSelectedInstOperands,
     /*  78111 */     // GIR_Coverage, 3523,
     /*  78111 */     GIR_EraseRootFromParent_Done,
     /*  78112 */   // Label 1277: @78112
     /*  78112 */   GIM_Try, /*On fail goto*//*Label 1278*/ GIMT_Encode4(78176), // Rule ID 3525 //
     /*  78117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  78120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxvf16gerx2pp),
     /*  78125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  78128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  78131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  78134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  78141 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10701:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB)  =>  (DMXVF16GERX2PP:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78141 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78144 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78148 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78153 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78157 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXVF16GERX2PP),
     /*  78165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78167 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78169 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  78171 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78174 */     GIR_RootConstrainSelectedInstOperands,
     /*  78175 */     // GIR_Coverage, 3525,
     /*  78175 */     GIR_EraseRootFromParent_Done,
     /*  78176 */   // Label 1278: @78176
     /*  78176 */   GIM_Try, /*On fail goto*//*Label 1279*/ GIMT_Encode4(78240), // Rule ID 3526 //
     /*  78181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  78184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxvf16gerx2pn),
     /*  78189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  78192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  78195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  78198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  78205 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10700:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB)  =>  (DMXVF16GERX2PN:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78205 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78208 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78212 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78217 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78221 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXVF16GERX2PN),
     /*  78229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78231 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78233 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  78235 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78238 */     GIR_RootConstrainSelectedInstOperands,
     /*  78239 */     // GIR_Coverage, 3526,
     /*  78239 */     GIR_EraseRootFromParent_Done,
     /*  78240 */   // Label 1279: @78240
     /*  78240 */   GIM_Try, /*On fail goto*//*Label 1280*/ GIMT_Encode4(78304), // Rule ID 3527 //
     /*  78245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  78248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxvf16gerx2np),
     /*  78253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  78256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  78259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  78262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  78269 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10699:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB)  =>  (DMXVF16GERX2NP:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78269 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78272 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78276 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78281 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78285 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXVF16GERX2NP),
     /*  78293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78295 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78297 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  78299 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78302 */     GIR_RootConstrainSelectedInstOperands,
     /*  78303 */     // GIR_Coverage, 3527,
     /*  78303 */     GIR_EraseRootFromParent_Done,
     /*  78304 */   // Label 1280: @78304
     /*  78304 */   GIM_Try, /*On fail goto*//*Label 1281*/ GIMT_Encode4(78368), // Rule ID 3528 //
     /*  78309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  78312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxvf16gerx2nn),
     /*  78317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  78320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  78323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  78326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  78333 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10698:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB)  =>  (DMXVF16GERX2NN:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78345 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78349 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXVF16GERX2NN),
     /*  78357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78359 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78361 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  78363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78366 */     GIR_RootConstrainSelectedInstOperands,
     /*  78367 */     // GIR_Coverage, 3528,
     /*  78367 */     GIR_EraseRootFromParent_Done,
     /*  78368 */   // Label 1281: @78368
     /*  78368 */   GIM_Try, /*On fail goto*//*Label 1282*/ GIMT_Encode4(78454), // Rule ID 3544 //
     /*  78373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  78376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi4ger8pp),
     /*  78381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  78384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  78387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  78397 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10777:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI4GER8PP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78397 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  78400 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78404 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78409 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78413 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78430 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  78434 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI4GER8PP),
     /*  78442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78444 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78446 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78449 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  78452 */     GIR_RootConstrainSelectedInstOperands,
     /*  78453 */     // GIR_Coverage, 3544,
     /*  78453 */     GIR_EraseRootFromParent_Done,
     /*  78454 */   // Label 1282: @78454
     /*  78454 */   GIM_Try, /*On fail goto*//*Label 1283*/ GIMT_Encode4(78540), // Rule ID 3546 //
     /*  78459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  78462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi8ger4pp),
     /*  78467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  78470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  78473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  78483 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10779:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI8GER4PP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78483 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  78486 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78490 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78495 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78499 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78516 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  78520 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI8GER4PP),
     /*  78528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78530 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78532 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78535 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  78538 */     GIR_RootConstrainSelectedInstOperands,
     /*  78539 */     // GIR_Coverage, 3546,
     /*  78539 */     GIR_EraseRootFromParent_Done,
     /*  78540 */   // Label 1283: @78540
     /*  78540 */   GIM_Try, /*On fail goto*//*Label 1284*/ GIMT_Encode4(78626), // Rule ID 3548 //
     /*  78545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  78548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi16ger2spp),
     /*  78553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  78556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  78559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  78569 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10775:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI16GER2SPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78569 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  78572 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78576 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78581 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78585 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78590 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78593 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78597 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78602 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  78606 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI16GER2SPP),
     /*  78614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78616 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78621 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  78624 */     GIR_RootConstrainSelectedInstOperands,
     /*  78625 */     // GIR_Coverage, 3548,
     /*  78625 */     GIR_EraseRootFromParent_Done,
     /*  78626 */   // Label 1284: @78626
     /*  78626 */   GIM_Try, /*On fail goto*//*Label 1285*/ GIMT_Encode4(78712), // Rule ID 3550 //
     /*  78631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  78634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi4ger8pp),
     /*  78639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  78642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  78645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  78655 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10777:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI4GER8WPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78655 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  78658 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78662 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78667 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78671 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78676 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78679 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78683 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78688 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  78692 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI4GER8WPP),
     /*  78700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78702 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78704 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78707 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  78710 */     GIR_RootConstrainSelectedInstOperands,
     /*  78711 */     // GIR_Coverage, 3550,
     /*  78711 */     GIR_EraseRootFromParent_Done,
     /*  78712 */   // Label 1285: @78712
     /*  78712 */   GIM_Try, /*On fail goto*//*Label 1286*/ GIMT_Encode4(78798), // Rule ID 3552 //
     /*  78717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  78720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi8ger4pp),
     /*  78725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  78728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  78731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  78741 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10779:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI8GER4WPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78741 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  78744 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78748 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78753 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78757 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78762 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78765 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78769 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78774 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  78778 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI8GER4WPP),
     /*  78786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78788 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78793 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  78796 */     GIR_RootConstrainSelectedInstOperands,
     /*  78797 */     // GIR_Coverage, 3552,
     /*  78797 */     GIR_EraseRootFromParent_Done,
     /*  78798 */   // Label 1286: @78798
     /*  78798 */   GIM_Try, /*On fail goto*//*Label 1287*/ GIMT_Encode4(78884), // Rule ID 3554 //
     /*  78803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  78806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi16ger2spp),
     /*  78811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  78814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  78817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  78827 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10775:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI16GER2SWPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78827 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  78830 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78834 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78839 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78843 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78848 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78851 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78855 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78860 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  78864 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI16GER2SWPP),
     /*  78872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78874 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78876 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  78882 */     GIR_RootConstrainSelectedInstOperands,
     /*  78883 */     // GIR_Coverage, 3554,
     /*  78883 */     GIR_EraseRootFromParent_Done,
     /*  78884 */   // Label 1287: @78884
     /*  78884 */   GIM_Try, /*On fail goto*//*Label 1288*/ GIMT_Encode4(78970), // Rule ID 3556 //
     /*  78889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  78892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf16ger2pp),
     /*  78897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  78900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  78903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  78913 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10761:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF16GER2PP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78913 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  78916 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78920 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78925 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78929 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78934 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78937 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78941 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78946 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  78950 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF16GER2PP),
     /*  78958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78960 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78962 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78965 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  78968 */     GIR_RootConstrainSelectedInstOperands,
     /*  78969 */     // GIR_Coverage, 3556,
     /*  78969 */     GIR_EraseRootFromParent_Done,
     /*  78970 */   // Label 1288: @78970
     /*  78970 */   GIM_Try, /*On fail goto*//*Label 1289*/ GIMT_Encode4(79056), // Rule ID 3557 //
     /*  78975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  78978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf16ger2pn),
     /*  78983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  78986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  78989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  78999 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10760:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF16GER2PN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78999 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  79002 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79006 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79011 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79015 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79020 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79023 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79027 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79032 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  79036 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF16GER2PN),
     /*  79044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79046 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79048 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79051 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  79054 */     GIR_RootConstrainSelectedInstOperands,
     /*  79055 */     // GIR_Coverage, 3557,
     /*  79055 */     GIR_EraseRootFromParent_Done,
     /*  79056 */   // Label 1289: @79056
     /*  79056 */   GIM_Try, /*On fail goto*//*Label 1290*/ GIMT_Encode4(79142), // Rule ID 3558 //
     /*  79061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  79064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf16ger2np),
     /*  79069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  79078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  79085 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10759:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF16GER2NP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79085 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  79088 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79092 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79097 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79101 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79106 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79109 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79113 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79118 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  79122 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF16GER2NP),
     /*  79130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79132 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79134 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79137 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  79140 */     GIR_RootConstrainSelectedInstOperands,
     /*  79141 */     // GIR_Coverage, 3558,
     /*  79141 */     GIR_EraseRootFromParent_Done,
     /*  79142 */   // Label 1290: @79142
     /*  79142 */   GIM_Try, /*On fail goto*//*Label 1291*/ GIMT_Encode4(79228), // Rule ID 3559 //
     /*  79147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  79150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf16ger2nn),
     /*  79155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  79164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  79171 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10758:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF16GER2NN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79171 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  79174 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79178 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79183 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79187 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79192 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79195 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79199 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79204 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  79208 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF16GER2NN),
     /*  79216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79218 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79220 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79223 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  79226 */     GIR_RootConstrainSelectedInstOperands,
     /*  79227 */     // GIR_Coverage, 3559,
     /*  79227 */     GIR_EraseRootFromParent_Done,
     /*  79228 */   // Label 1291: @79228
     /*  79228 */   GIM_Try, /*On fail goto*//*Label 1292*/ GIMT_Encode4(79314), // Rule ID 3561 //
     /*  79233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  79236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf16ger2pp),
     /*  79241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  79250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  79257 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10761:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF16GER2WPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79257 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  79260 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79264 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79269 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79273 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79278 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79281 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79285 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79290 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  79294 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF16GER2WPP),
     /*  79302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79304 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79306 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79309 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  79312 */     GIR_RootConstrainSelectedInstOperands,
     /*  79313 */     // GIR_Coverage, 3561,
     /*  79313 */     GIR_EraseRootFromParent_Done,
     /*  79314 */   // Label 1292: @79314
     /*  79314 */   GIM_Try, /*On fail goto*//*Label 1293*/ GIMT_Encode4(79400), // Rule ID 3562 //
     /*  79319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  79322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf16ger2pn),
     /*  79327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  79336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  79343 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10760:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF16GER2WPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79343 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  79346 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79350 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79355 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79359 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79364 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79367 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79371 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79376 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  79380 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF16GER2WPN),
     /*  79388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79390 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79392 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79395 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  79398 */     GIR_RootConstrainSelectedInstOperands,
     /*  79399 */     // GIR_Coverage, 3562,
     /*  79399 */     GIR_EraseRootFromParent_Done,
     /*  79400 */   // Label 1293: @79400
     /*  79400 */   GIM_Try, /*On fail goto*//*Label 1294*/ GIMT_Encode4(79486), // Rule ID 3563 //
     /*  79405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  79408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf16ger2np),
     /*  79413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  79422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  79429 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10759:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF16GER2WNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79429 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  79432 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79436 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79441 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79445 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79450 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79453 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79457 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79462 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  79466 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF16GER2WNP),
     /*  79474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79476 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  79484 */     GIR_RootConstrainSelectedInstOperands,
     /*  79485 */     // GIR_Coverage, 3563,
     /*  79485 */     GIR_EraseRootFromParent_Done,
     /*  79486 */   // Label 1294: @79486
     /*  79486 */   GIM_Try, /*On fail goto*//*Label 1295*/ GIMT_Encode4(79572), // Rule ID 3564 //
     /*  79491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  79494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf16ger2nn),
     /*  79499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  79508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  79515 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10758:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF16GER2WNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79515 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  79518 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79522 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79527 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79531 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79536 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79539 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79543 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79548 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  79552 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF16GER2WNN),
     /*  79560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79562 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79564 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79567 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  79570 */     GIR_RootConstrainSelectedInstOperands,
     /*  79571 */     // GIR_Coverage, 3564,
     /*  79571 */     GIR_EraseRootFromParent_Done,
     /*  79572 */   // Label 1295: @79572
     /*  79572 */   GIM_Try, /*On fail goto*//*Label 1296*/ GIMT_Encode4(79658), // Rule ID 3566 //
     /*  79577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  79580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf32gerpp),
     /*  79585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  79594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  79601 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10766:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF32GERPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79601 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  79604 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79608 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79613 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79617 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79622 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79625 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79629 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79634 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  79638 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF32GERPP),
     /*  79646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79648 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79650 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79653 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  79656 */     GIR_RootConstrainSelectedInstOperands,
     /*  79657 */     // GIR_Coverage, 3566,
     /*  79657 */     GIR_EraseRootFromParent_Done,
     /*  79658 */   // Label 1296: @79658
     /*  79658 */   GIM_Try, /*On fail goto*//*Label 1297*/ GIMT_Encode4(79744), // Rule ID 3567 //
     /*  79663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  79666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf32gerpn),
     /*  79671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  79680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  79687 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10765:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF32GERPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79687 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  79690 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79694 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79699 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79703 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79708 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79715 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79720 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  79724 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF32GERPN),
     /*  79732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79734 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79736 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  79742 */     GIR_RootConstrainSelectedInstOperands,
     /*  79743 */     // GIR_Coverage, 3567,
     /*  79743 */     GIR_EraseRootFromParent_Done,
     /*  79744 */   // Label 1297: @79744
     /*  79744 */   GIM_Try, /*On fail goto*//*Label 1298*/ GIMT_Encode4(79830), // Rule ID 3568 //
     /*  79749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  79752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf32gernp),
     /*  79757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  79766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  79773 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10764:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF32GERNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79773 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  79776 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79780 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79785 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79789 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79794 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79797 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79801 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79806 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  79810 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF32GERNP),
     /*  79818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79820 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79822 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  79828 */     GIR_RootConstrainSelectedInstOperands,
     /*  79829 */     // GIR_Coverage, 3568,
     /*  79829 */     GIR_EraseRootFromParent_Done,
     /*  79830 */   // Label 1298: @79830
     /*  79830 */   GIM_Try, /*On fail goto*//*Label 1299*/ GIMT_Encode4(79916), // Rule ID 3569 //
     /*  79835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  79838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf32gernn),
     /*  79843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  79852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  79859 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10763:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF32GERNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79859 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  79862 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79866 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79871 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79875 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79892 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  79896 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF32GERNN),
     /*  79904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79906 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79908 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79911 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  79914 */     GIR_RootConstrainSelectedInstOperands,
     /*  79915 */     // GIR_Coverage, 3569,
     /*  79915 */     GIR_EraseRootFromParent_Done,
     /*  79916 */   // Label 1299: @79916
     /*  79916 */   GIM_Try, /*On fail goto*//*Label 1300*/ GIMT_Encode4(79980), // Rule ID 3571 //
     /*  79921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  79924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf64gerpp),
     /*  79929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  79938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  79945 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10771:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF64GERPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79945 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79948 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79952 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79957 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79961 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF64GERPP),
     /*  79969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79971 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79973 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  79975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79978 */     GIR_RootConstrainSelectedInstOperands,
     /*  79979 */     // GIR_Coverage, 3571,
     /*  79979 */     GIR_EraseRootFromParent_Done,
     /*  79980 */   // Label 1300: @79980
     /*  79980 */   GIM_Try, /*On fail goto*//*Label 1301*/ GIMT_Encode4(80044), // Rule ID 3572 //
     /*  79985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  79988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf64gerpn),
     /*  79993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  80002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  80009 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10770:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF64GERPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80009 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80012 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80016 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80021 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80025 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF64GERPN),
     /*  80033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80035 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80037 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  80039 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80042 */     GIR_RootConstrainSelectedInstOperands,
     /*  80043 */     // GIR_Coverage, 3572,
     /*  80043 */     GIR_EraseRootFromParent_Done,
     /*  80044 */   // Label 1301: @80044
     /*  80044 */   GIM_Try, /*On fail goto*//*Label 1302*/ GIMT_Encode4(80108), // Rule ID 3573 //
     /*  80049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  80052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf64gernp),
     /*  80057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  80066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  80073 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10769:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF64GERNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80073 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80076 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80080 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80085 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80089 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF64GERNP),
     /*  80097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80099 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80101 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  80103 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80106 */     GIR_RootConstrainSelectedInstOperands,
     /*  80107 */     // GIR_Coverage, 3573,
     /*  80107 */     GIR_EraseRootFromParent_Done,
     /*  80108 */   // Label 1302: @80108
     /*  80108 */   GIM_Try, /*On fail goto*//*Label 1303*/ GIMT_Encode4(80172), // Rule ID 3574 //
     /*  80113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  80116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf64gernn),
     /*  80121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  80130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  80137 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10768:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF64GERNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80149 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80153 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF64GERNN),
     /*  80161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80163 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80165 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  80167 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80170 */     GIR_RootConstrainSelectedInstOperands,
     /*  80171 */     // GIR_Coverage, 3574,
     /*  80171 */     GIR_EraseRootFromParent_Done,
     /*  80172 */   // Label 1303: @80172
     /*  80172 */   GIM_Try, /*On fail goto*//*Label 1304*/ GIMT_Encode4(80258), // Rule ID 3576 //
     /*  80177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  80180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvbf16ger2pp),
     /*  80185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  80194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  80201 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10756:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVBF16GER2PP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80201 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  80204 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80208 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80213 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80217 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80234 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  80238 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVBF16GER2PP),
     /*  80246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80248 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80250 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80253 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  80256 */     GIR_RootConstrainSelectedInstOperands,
     /*  80257 */     // GIR_Coverage, 3576,
     /*  80257 */     GIR_EraseRootFromParent_Done,
     /*  80258 */   // Label 1304: @80258
     /*  80258 */   GIM_Try, /*On fail goto*//*Label 1305*/ GIMT_Encode4(80344), // Rule ID 3577 //
     /*  80263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  80266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvbf16ger2pn),
     /*  80271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  80280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  80287 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10755:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVBF16GER2PN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80287 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  80290 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80294 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80299 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80303 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80308 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80311 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80315 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80320 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  80324 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVBF16GER2PN),
     /*  80332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80334 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80339 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  80342 */     GIR_RootConstrainSelectedInstOperands,
     /*  80343 */     // GIR_Coverage, 3577,
     /*  80343 */     GIR_EraseRootFromParent_Done,
     /*  80344 */   // Label 1305: @80344
     /*  80344 */   GIM_Try, /*On fail goto*//*Label 1306*/ GIMT_Encode4(80430), // Rule ID 3578 //
     /*  80349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  80352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvbf16ger2np),
     /*  80357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  80366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  80373 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10754:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVBF16GER2NP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80373 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  80376 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80380 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80385 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80389 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80394 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80397 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80401 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80406 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  80410 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVBF16GER2NP),
     /*  80418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80420 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80422 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80425 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  80428 */     GIR_RootConstrainSelectedInstOperands,
     /*  80429 */     // GIR_Coverage, 3578,
     /*  80429 */     GIR_EraseRootFromParent_Done,
     /*  80430 */   // Label 1306: @80430
     /*  80430 */   GIM_Try, /*On fail goto*//*Label 1307*/ GIMT_Encode4(80516), // Rule ID 3579 //
     /*  80435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  80438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvbf16ger2nn),
     /*  80443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  80452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  80459 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10753:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVBF16GER2NN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80459 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  80462 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80466 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80471 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80475 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80480 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80483 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80487 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80492 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  80496 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVBF16GER2NN),
     /*  80504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80506 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80508 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80511 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  80514 */     GIR_RootConstrainSelectedInstOperands,
     /*  80515 */     // GIR_Coverage, 3579,
     /*  80515 */     GIR_EraseRootFromParent_Done,
     /*  80516 */   // Label 1307: @80516
     /*  80516 */   GIM_Try, /*On fail goto*//*Label 1308*/ GIMT_Encode4(80602), // Rule ID 3581 //
     /*  80521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  80524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi16ger2pp),
     /*  80529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  80538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  80545 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10773:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI16GER2PP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80545 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  80548 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80552 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80557 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80561 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80566 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80569 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80573 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80578 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  80582 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI16GER2PP),
     /*  80590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80592 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80594 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80597 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  80600 */     GIR_RootConstrainSelectedInstOperands,
     /*  80601 */     // GIR_Coverage, 3581,
     /*  80601 */     GIR_EraseRootFromParent_Done,
     /*  80602 */   // Label 1308: @80602
     /*  80602 */   GIM_Try, /*On fail goto*//*Label 1309*/ GIMT_Encode4(80688), // Rule ID 3582 //
     /*  80607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  80610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi8ger4spp),
     /*  80615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  80624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  80631 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10780:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI8GER4SPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80631 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  80634 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80638 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80643 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80647 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80652 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80655 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80659 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80664 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  80668 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI8GER4SPP),
     /*  80676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80678 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80680 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80683 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  80686 */     GIR_RootConstrainSelectedInstOperands,
     /*  80687 */     // GIR_Coverage, 3582,
     /*  80687 */     GIR_EraseRootFromParent_Done,
     /*  80688 */   // Label 1309: @80688
     /*  80688 */   GIM_Try, /*On fail goto*//*Label 1310*/ GIMT_Encode4(80774), // Rule ID 3584 //
     /*  80693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  80696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf32gerpp),
     /*  80701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  80710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  80717 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10766:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF32GERWPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80717 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  80720 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80724 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80729 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80733 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80738 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80741 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80745 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80750 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  80754 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF32GERWPP),
     /*  80762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80764 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80766 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80769 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  80772 */     GIR_RootConstrainSelectedInstOperands,
     /*  80773 */     // GIR_Coverage, 3584,
     /*  80773 */     GIR_EraseRootFromParent_Done,
     /*  80774 */   // Label 1310: @80774
     /*  80774 */   GIM_Try, /*On fail goto*//*Label 1311*/ GIMT_Encode4(80860), // Rule ID 3585 //
     /*  80779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  80782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf32gerpn),
     /*  80787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  80796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  80803 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10765:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF32GERWPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80803 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  80806 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80810 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80815 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80819 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80824 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80827 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80831 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80836 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  80840 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF32GERWPN),
     /*  80848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80850 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80852 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80855 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  80858 */     GIR_RootConstrainSelectedInstOperands,
     /*  80859 */     // GIR_Coverage, 3585,
     /*  80859 */     GIR_EraseRootFromParent_Done,
     /*  80860 */   // Label 1311: @80860
     /*  80860 */   GIM_Try, /*On fail goto*//*Label 1312*/ GIMT_Encode4(80946), // Rule ID 3586 //
     /*  80865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  80868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf32gernp),
     /*  80873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  80882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  80889 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10764:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF32GERWNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80889 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  80892 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80896 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80901 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80905 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80910 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80913 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80917 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80922 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  80926 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF32GERWNP),
     /*  80934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80936 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80938 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80941 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  80944 */     GIR_RootConstrainSelectedInstOperands,
     /*  80945 */     // GIR_Coverage, 3586,
     /*  80945 */     GIR_EraseRootFromParent_Done,
     /*  80946 */   // Label 1312: @80946
     /*  80946 */   GIM_Try, /*On fail goto*//*Label 1313*/ GIMT_Encode4(81032), // Rule ID 3587 //
     /*  80951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  80954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf32gernn),
     /*  80959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  80968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  80975 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10763:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF32GERWNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80975 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  80978 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80982 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80987 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80991 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80996 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80999 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81003 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81008 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  81012 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF32GERWNN),
     /*  81020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  81022 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  81024 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81027 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  81030 */     GIR_RootConstrainSelectedInstOperands,
     /*  81031 */     // GIR_Coverage, 3587,
     /*  81031 */     GIR_EraseRootFromParent_Done,
     /*  81032 */   // Label 1313: @81032
     /*  81032 */   GIM_Try, /*On fail goto*//*Label 1314*/ GIMT_Encode4(81096), // Rule ID 3589 //
     /*  81037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  81040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf64gerpp),
     /*  81045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  81048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  81051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  81054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  81057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  81061 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10771:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF64GERWPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  81061 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81064 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81068 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81073 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  81077 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF64GERWPP),
     /*  81085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  81087 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  81089 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  81091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81094 */     GIR_RootConstrainSelectedInstOperands,
     /*  81095 */     // GIR_Coverage, 3589,
     /*  81095 */     GIR_EraseRootFromParent_Done,
     /*  81096 */   // Label 1314: @81096
     /*  81096 */   GIM_Try, /*On fail goto*//*Label 1315*/ GIMT_Encode4(81160), // Rule ID 3590 //
     /*  81101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  81104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf64gerpn),
     /*  81109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  81112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  81115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  81118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  81121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  81125 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10770:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF64GERWPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  81125 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81128 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81132 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81137 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  81141 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF64GERWPN),
     /*  81149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  81151 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  81153 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  81155 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81158 */     GIR_RootConstrainSelectedInstOperands,
     /*  81159 */     // GIR_Coverage, 3590,
     /*  81159 */     GIR_EraseRootFromParent_Done,
     /*  81160 */   // Label 1315: @81160
     /*  81160 */   GIM_Try, /*On fail goto*//*Label 1316*/ GIMT_Encode4(81224), // Rule ID 3591 //
     /*  81165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  81168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf64gernp),
     /*  81173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  81176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  81179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  81182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  81185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  81189 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10769:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF64GERNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  81189 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81192 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81196 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81201 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  81205 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF64GERNP),
     /*  81213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  81215 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  81217 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  81219 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81222 */     GIR_RootConstrainSelectedInstOperands,
     /*  81223 */     // GIR_Coverage, 3591,
     /*  81223 */     GIR_EraseRootFromParent_Done,
     /*  81224 */   // Label 1316: @81224
     /*  81224 */   GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(81288), // Rule ID 3592 //
     /*  81229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  81232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf64gernn),
     /*  81237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  81240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  81243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  81246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  81249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  81253 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10768:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF64GERWNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  81253 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81256 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81260 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81265 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  81269 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF64GERWNN),
     /*  81277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  81279 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  81281 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  81283 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81286 */     GIR_RootConstrainSelectedInstOperands,
     /*  81287 */     // GIR_Coverage, 3592,
     /*  81287 */     GIR_EraseRootFromParent_Done,
     /*  81288 */   // Label 1317: @81288
     /*  81288 */   GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(81374), // Rule ID 3594 //
     /*  81293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  81296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvbf16ger2pp),
     /*  81301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  81304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  81307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  81310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  81313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  81317 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10756:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVBF16GER2WPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  81317 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  81320 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81324 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81329 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  81333 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81338 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81341 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81345 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81350 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  81354 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVBF16GER2WPP),
     /*  81362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  81364 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  81366 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81369 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  81372 */     GIR_RootConstrainSelectedInstOperands,
     /*  81373 */     // GIR_Coverage, 3594,
     /*  81373 */     GIR_EraseRootFromParent_Done,
     /*  81374 */   // Label 1318: @81374
     /*  81374 */   GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(81460), // Rule ID 3595 //
     /*  81379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  81382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvbf16ger2pn),
     /*  81387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  81390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  81393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  81396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  81399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  81403 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10755:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVBF16GER2WPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  81403 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  81406 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81410 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81415 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  81419 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81424 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81427 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81431 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81436 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  81440 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVBF16GER2WPN),
     /*  81448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  81450 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  81452 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81455 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  81458 */     GIR_RootConstrainSelectedInstOperands,
     /*  81459 */     // GIR_Coverage, 3595,
     /*  81459 */     GIR_EraseRootFromParent_Done,
     /*  81460 */   // Label 1319: @81460
     /*  81460 */   GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(81546), // Rule ID 3596 //
     /*  81465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  81468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvbf16ger2np),
     /*  81473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  81476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  81479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  81482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  81485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  81489 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10754:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVBF16GER2WNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  81489 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  81492 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81496 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81501 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  81505 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81522 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  81526 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVBF16GER2WNP),
     /*  81534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  81536 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  81538 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81541 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  81544 */     GIR_RootConstrainSelectedInstOperands,
     /*  81545 */     // GIR_Coverage, 3596,
     /*  81545 */     GIR_EraseRootFromParent_Done,
     /*  81546 */   // Label 1320: @81546
     /*  81546 */   GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(81632), // Rule ID 3597 //
     /*  81551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  81554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvbf16ger2nn),
     /*  81559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  81562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  81565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  81568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  81571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  81575 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10753:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVBF16GER2WNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  81575 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  81578 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81582 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81587 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  81591 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81608 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  81612 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVBF16GER2WNN),
     /*  81620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  81622 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  81624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81627 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  81630 */     GIR_RootConstrainSelectedInstOperands,
     /*  81631 */     // GIR_Coverage, 3597,
     /*  81631 */     GIR_EraseRootFromParent_Done,
     /*  81632 */   // Label 1321: @81632
     /*  81632 */   GIM_Try, /*On fail goto*//*Label 1322*/ GIMT_Encode4(81718), // Rule ID 3599 //
     /*  81637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  81640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi16ger2pp),
     /*  81645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  81648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  81651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  81654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  81657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  81661 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10773:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI16GER2WPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  81661 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  81664 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81668 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81673 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  81677 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81682 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81685 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81689 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81694 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  81698 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI16GER2WPP),
     /*  81706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  81708 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  81710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81713 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  81716 */     GIR_RootConstrainSelectedInstOperands,
     /*  81717 */     // GIR_Coverage, 3599,
     /*  81717 */     GIR_EraseRootFromParent_Done,
     /*  81718 */   // Label 1322: @81718
     /*  81718 */   GIM_Try, /*On fail goto*//*Label 1323*/ GIMT_Encode4(81804), // Rule ID 3600 //
     /*  81723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  81726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi8ger4spp),
     /*  81731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  81734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  81737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  81740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  81743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  81747 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10780:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI8GER4WSPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  81747 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  81750 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81754 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81759 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  81763 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81768 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81771 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81775 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81780 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  81784 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI8GER4WSPP),
     /*  81792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  81794 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  81796 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81799 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  81802 */     GIR_RootConstrainSelectedInstOperands,
     /*  81803 */     // GIR_Coverage, 3600,
     /*  81803 */     GIR_EraseRootFromParent_Done,
     /*  81804 */   // Label 1323: @81804
     /*  81804 */   GIM_Reject,
     /*  81805 */ // Label 1200: @81805
     /*  81805 */ GIM_Try, /*On fail goto*//*Label 1324*/ GIMT_Encode4(82429),
     /*  81810 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /*  81813 */   GIM_Try, /*On fail goto*//*Label 1325*/ GIMT_Encode4(81932), // Rule ID 3612 //
     /*  81818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  81821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf32ger),
     /*  81826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  81829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  81832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  81835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  81845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  81849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81853 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  81857 */     // MIs[1] Operand 1
     /*  81857 */     // No operand predicates
     /*  81857 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  81861 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81865 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  81869 */     // MIs[2] Operand 1
     /*  81869 */     // No operand predicates
     /*  81869 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  81871 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10733:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)  =>  (PMXVF32GER:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)
     /*  81871 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  81874 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81878 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81883 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  81887 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81892 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81895 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81899 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81904 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  81908 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF32GER),
     /*  81916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  81918 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81921 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  81924 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  81927 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  81930 */     GIR_RootConstrainSelectedInstOperands,
     /*  81931 */     // GIR_Coverage, 3612,
     /*  81931 */     GIR_EraseRootFromParent_Done,
     /*  81932 */   // Label 1325: @81932
     /*  81932 */   GIM_Try, /*On fail goto*//*Label 1326*/ GIMT_Encode4(82029), // Rule ID 3617 //
     /*  81937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  81940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf64ger),
     /*  81945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  81948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v256s1,
     /*  81951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  81954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  81964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  81968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81972 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  81976 */     // MIs[1] Operand 1
     /*  81976 */     // No operand predicates
     /*  81976 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  81980 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81984 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  81988 */     // MIs[2] Operand 1
     /*  81988 */     // No operand predicates
     /*  81988 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  81990 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10738:{ *:[iPTR] }, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)  =>  (PMXVF64GER:{ *:[v512i1] } ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)
     /*  81990 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81993 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81997 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82002 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  82006 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF64GER),
     /*  82014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  82016 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  82018 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82021 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  82024 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  82027 */     GIR_RootConstrainSelectedInstOperands,
     /*  82028 */     // GIR_Coverage, 3617,
     /*  82028 */     GIR_EraseRootFromParent_Done,
     /*  82029 */   // Label 1326: @82029
     /*  82029 */   GIM_Try, /*On fail goto*//*Label 1327*/ GIMT_Encode4(82148), // Rule ID 3641 //
     /*  82034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  82037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf32ger),
     /*  82042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  82045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  82048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  82051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  82061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  82065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82069 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82073 */     // MIs[1] Operand 1
     /*  82073 */     // No operand predicates
     /*  82073 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  82077 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82081 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82085 */     // MIs[2] Operand 1
     /*  82085 */     // No operand predicates
     /*  82085 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  82087 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10733:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)  =>  (PMXVF32GERW:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)
     /*  82087 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  82090 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82094 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82099 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  82103 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  82111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82120 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  82124 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF32GERW),
     /*  82132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  82134 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82137 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  82140 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  82143 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  82146 */     GIR_RootConstrainSelectedInstOperands,
     /*  82147 */     // GIR_Coverage, 3641,
     /*  82147 */     GIR_EraseRootFromParent_Done,
     /*  82148 */   // Label 1327: @82148
     /*  82148 */   GIM_Try, /*On fail goto*//*Label 1328*/ GIMT_Encode4(82245), // Rule ID 3646 //
     /*  82153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  82156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf64ger),
     /*  82161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  82164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v256s1,
     /*  82167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  82170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  82180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  82184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82188 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82192 */     // MIs[1] Operand 1
     /*  82192 */     // No operand predicates
     /*  82192 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  82196 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82200 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  82204 */     // MIs[2] Operand 1
     /*  82204 */     // No operand predicates
     /*  82204 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  82206 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10738:{ *:[iPTR] }, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)  =>  (PMXVF64GERW:{ *:[v512i1] } ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)
     /*  82206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  82209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82213 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82218 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  82222 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF64GERW),
     /*  82230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  82232 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  82234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  82240 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  82243 */     GIR_RootConstrainSelectedInstOperands,
     /*  82244 */     // GIR_Coverage, 3646,
     /*  82244 */     GIR_EraseRootFromParent_Done,
     /*  82245 */   // Label 1328: @82245
     /*  82245 */   GIM_Try, /*On fail goto*//*Label 1329*/ GIMT_Encode4(82292), // Rule ID 1117 //
     /*  82250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  82253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxeval),
     /*  82258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  82261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  82264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  82267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  82270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82274 */     // MIs[0] IMM
     /*  82274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  82277 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10921:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$XA, v2i64:{ *:[v2i64] }:$XB, v2i64:{ *:[v2i64] }:$XC, (timm:{ *:[i32] }):$IMM)  =>  (XXEVAL:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$XA, v2i64:{ *:[v2i64] }:$XB, v2i64:{ *:[v2i64] }:$XC, (timm:{ *:[i32] }):$IMM)
     /*  82277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  82280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  82282 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  82284 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  82286 */     GIR_RootToRootCopy, /*OpIdx*/4, // XC
     /*  82288 */     GIR_RootToRootCopy, /*OpIdx*/5, // IMM
     /*  82290 */     GIR_RootConstrainSelectedInstOperands,
     /*  82291 */     // GIR_Coverage, 1117,
     /*  82291 */     GIR_EraseRootFromParent_Done,
     /*  82292 */   // Label 1329: @82292
     /*  82292 */   GIM_Try, /*On fail goto*//*Label 1330*/ GIMT_Encode4(82428), // Rule ID 3431 //
     /*  82297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  82300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxpermx),
     /*  82305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  82308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  82311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  82314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  82317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82321 */     // MIs[0] D
     /*  82321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  82324 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10929:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$A, v16i8:{ *:[v16i8] }:$B, v16i8:{ *:[v16i8] }:$C, (timm:{ *:[i32] }):$D)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (XXPERMX:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$A, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$B, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$C, VSRC:{ *:[i32] }), ?:{ *:[i32] }:$D), VSRC:{ *:[i32] })
     /*  82324 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /*  82327 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82331 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82336 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/4, // C
     /*  82340 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82345 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  82348 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82352 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82357 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // B
     /*  82361 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82366 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  82369 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82373 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82378 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  82382 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82387 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  82390 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXPERMX),
     /*  82394 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82399 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82402 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  82405 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  82408 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // D
     /*  82412 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  82414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82419 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82422 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82427 */     // GIR_Coverage, 3431,
     /*  82427 */     GIR_EraseRootFromParent_Done,
     /*  82428 */   // Label 1330: @82428
     /*  82428 */   GIM_Reject,
     /*  82429 */ // Label 1324: @82429
     /*  82429 */ GIM_Try, /*On fail goto*//*Label 1331*/ GIMT_Encode4(86309),
     /*  82434 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/7,
     /*  82437 */   GIM_Try, /*On fail goto*//*Label 1332*/ GIMT_Encode4(82552), // Rule ID 3529 //
     /*  82442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  82445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmdmxvi8gerx4),
     /*  82450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  82453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v256s1,
     /*  82456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  82459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  82468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  82472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  82476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82480 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  82484 */     // MIs[1] Operand 1
     /*  82484 */     // No operand predicates
     /*  82484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  82488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82492 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82496 */     // MIs[2] Operand 1
     /*  82496 */     // No operand predicates
     /*  82496 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  82500 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82504 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82508 */     // MIs[3] Operand 1
     /*  82508 */     // No operand predicates
     /*  82508 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  82510 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10720:{ *:[iPTR] }, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)  =>  (PMDMXVI8GERX4:{ *:[v1024i1] } ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)
     /*  82510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  82513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82522 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  82526 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMDMXVI8GERX4),
     /*  82534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  82536 */     GIR_RootToRootCopy, /*OpIdx*/2, // XAp
     /*  82538 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  82544 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  82547 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  82550 */     GIR_RootConstrainSelectedInstOperands,
     /*  82551 */     // GIR_Coverage, 3529,
     /*  82551 */     GIR_EraseRootFromParent_Done,
     /*  82552 */   // Label 1332: @82552
     /*  82552 */   GIM_Try, /*On fail goto*//*Label 1333*/ GIMT_Encode4(82667), // Rule ID 3532 //
     /*  82557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  82560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmdmxvbf16gerx2),
     /*  82565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  82568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v256s1,
     /*  82571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  82574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  82583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  82587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  82591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82595 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  82599 */     // MIs[1] Operand 1
     /*  82599 */     // No operand predicates
     /*  82599 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  82603 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82607 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82611 */     // MIs[2] Operand 1
     /*  82611 */     // No operand predicates
     /*  82611 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  82615 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82619 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  82623 */     // MIs[3] Operand 1
     /*  82623 */     // No operand predicates
     /*  82623 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  82625 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10710:{ *:[iPTR] }, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMDMXVBF16GERX2:{ *:[v1024i1] } ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  82625 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  82628 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82632 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82637 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  82641 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMDMXVBF16GERX2),
     /*  82649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  82651 */     GIR_RootToRootCopy, /*OpIdx*/2, // XAp
     /*  82653 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82656 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  82659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  82662 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  82665 */     GIR_RootConstrainSelectedInstOperands,
     /*  82666 */     // GIR_Coverage, 3532,
     /*  82666 */     GIR_EraseRootFromParent_Done,
     /*  82667 */   // Label 1333: @82667
     /*  82667 */   GIM_Try, /*On fail goto*//*Label 1334*/ GIMT_Encode4(82782), // Rule ID 3537 //
     /*  82672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  82675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmdmxvf16gerx2),
     /*  82680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  82683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v256s1,
     /*  82686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  82689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  82698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  82702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  82706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82710 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  82714 */     // MIs[1] Operand 1
     /*  82714 */     // No operand predicates
     /*  82714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  82718 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82722 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82726 */     // MIs[2] Operand 1
     /*  82726 */     // No operand predicates
     /*  82726 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  82730 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82734 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  82738 */     // MIs[3] Operand 1
     /*  82738 */     // No operand predicates
     /*  82738 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  82740 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10715:{ *:[iPTR] }, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMDMXVF16GERX2:{ *:[v1024i1] } ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  82740 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  82743 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82747 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82752 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  82756 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMDMXVF16GERX2),
     /*  82764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  82766 */     GIR_RootToRootCopy, /*OpIdx*/2, // XAp
     /*  82768 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82771 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  82774 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  82777 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  82780 */     GIR_RootConstrainSelectedInstOperands,
     /*  82781 */     // GIR_Coverage, 3537,
     /*  82781 */     GIR_EraseRootFromParent_Done,
     /*  82782 */   // Label 1334: @82782
     /*  82782 */   GIM_Try, /*On fail goto*//*Label 1335*/ GIMT_Encode4(82919), // Rule ID 3601 //
     /*  82787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  82790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi4ger8),
     /*  82795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  82798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  82801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  82804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  82813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  82817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  82821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82825 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82829 */     // MIs[1] Operand 1
     /*  82829 */     // No operand predicates
     /*  82829 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  82833 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82837 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82841 */     // MIs[2] Operand 1
     /*  82841 */     // No operand predicates
     /*  82841 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  82845 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82849 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  82853 */     // MIs[3] Operand 1
     /*  82853 */     // No operand predicates
     /*  82853 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  82855 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10747:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$PMSK)  =>  (PMXVI4GER8:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$PMSK)
     /*  82855 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  82858 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82862 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82867 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  82871 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82876 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  82879 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82883 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82888 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  82892 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI4GER8),
     /*  82900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  82902 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82905 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  82908 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  82911 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  82914 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  82917 */     GIR_RootConstrainSelectedInstOperands,
     /*  82918 */     // GIR_Coverage, 3601,
     /*  82918 */     GIR_EraseRootFromParent_Done,
     /*  82919 */   // Label 1335: @82919
     /*  82919 */   GIM_Try, /*On fail goto*//*Label 1336*/ GIMT_Encode4(83056), // Rule ID 3603 //
     /*  82924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  82927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi8ger4),
     /*  82932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  82935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  82938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  82941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  82950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  82954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  82958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82962 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82966 */     // MIs[1] Operand 1
     /*  82966 */     // No operand predicates
     /*  82966 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  82970 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82974 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82978 */     // MIs[2] Operand 1
     /*  82978 */     // No operand predicates
     /*  82978 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  82982 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82986 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82990 */     // MIs[3] Operand 1
     /*  82990 */     // No operand predicates
     /*  82990 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  82992 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10749:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)  =>  (PMXVI8GER4:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)
     /*  82992 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  82995 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82999 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83004 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  83008 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83013 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  83016 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83020 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83025 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  83029 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI8GER4),
     /*  83037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  83039 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83042 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  83045 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  83048 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  83051 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  83054 */     GIR_RootConstrainSelectedInstOperands,
     /*  83055 */     // GIR_Coverage, 3603,
     /*  83055 */     GIR_EraseRootFromParent_Done,
     /*  83056 */   // Label 1336: @83056
     /*  83056 */   GIM_Try, /*On fail goto*//*Label 1337*/ GIMT_Encode4(83193), // Rule ID 3605 //
     /*  83061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  83064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi16ger2s),
     /*  83069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  83072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  83075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  83078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  83087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  83091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  83095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83099 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83103 */     // MIs[1] Operand 1
     /*  83103 */     // No operand predicates
     /*  83103 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  83107 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83111 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83115 */     // MIs[2] Operand 1
     /*  83115 */     // No operand predicates
     /*  83115 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  83119 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83123 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  83127 */     // MIs[3] Operand 1
     /*  83127 */     // No operand predicates
     /*  83127 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  83129 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10745:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVI16GER2S:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  83129 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  83132 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83136 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83141 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  83145 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83150 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  83153 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83157 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83162 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  83166 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI16GER2S),
     /*  83174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  83176 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83179 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  83182 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  83185 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  83188 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  83191 */     GIR_RootConstrainSelectedInstOperands,
     /*  83192 */     // GIR_Coverage, 3605,
     /*  83192 */     GIR_EraseRootFromParent_Done,
     /*  83193 */   // Label 1337: @83193
     /*  83193 */   GIM_Try, /*On fail goto*//*Label 1338*/ GIMT_Encode4(83330), // Rule ID 3607 //
     /*  83198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  83201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf16ger2),
     /*  83206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  83209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  83212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  83215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  83224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  83228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  83232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83236 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83240 */     // MIs[1] Operand 1
     /*  83240 */     // No operand predicates
     /*  83240 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  83244 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83248 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83252 */     // MIs[2] Operand 1
     /*  83252 */     // No operand predicates
     /*  83252 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  83256 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83260 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  83264 */     // MIs[3] Operand 1
     /*  83264 */     // No operand predicates
     /*  83264 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  83266 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10728:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVF16GER2:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  83266 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  83269 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83273 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83278 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  83282 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83287 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  83290 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83294 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83299 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  83303 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF16GER2),
     /*  83311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  83313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83316 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  83319 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  83322 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  83325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  83328 */     GIR_RootConstrainSelectedInstOperands,
     /*  83329 */     // GIR_Coverage, 3607,
     /*  83329 */     GIR_EraseRootFromParent_Done,
     /*  83330 */   // Label 1338: @83330
     /*  83330 */   GIM_Try, /*On fail goto*//*Label 1339*/ GIMT_Encode4(83467), // Rule ID 3622 //
     /*  83335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  83338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvbf16ger2),
     /*  83343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  83346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  83349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  83352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  83361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  83365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  83369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83373 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83377 */     // MIs[1] Operand 1
     /*  83377 */     // No operand predicates
     /*  83377 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  83381 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83385 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83389 */     // MIs[2] Operand 1
     /*  83389 */     // No operand predicates
     /*  83389 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  83393 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83397 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  83401 */     // MIs[3] Operand 1
     /*  83401 */     // No operand predicates
     /*  83401 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  83403 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10723:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVBF16GER2:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  83403 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  83406 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83410 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83415 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  83419 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83424 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  83427 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83431 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83436 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  83440 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVBF16GER2),
     /*  83448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  83450 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83453 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  83456 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  83459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  83462 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  83465 */     GIR_RootConstrainSelectedInstOperands,
     /*  83466 */     // GIR_Coverage, 3622,
     /*  83466 */     GIR_EraseRootFromParent_Done,
     /*  83467 */   // Label 1339: @83467
     /*  83467 */   GIM_Try, /*On fail goto*//*Label 1340*/ GIMT_Encode4(83604), // Rule ID 3627 //
     /*  83472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  83475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi16ger2),
     /*  83480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  83483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  83486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  83489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  83498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  83502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  83506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83510 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83514 */     // MIs[1] Operand 1
     /*  83514 */     // No operand predicates
     /*  83514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  83518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83522 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83526 */     // MIs[2] Operand 1
     /*  83526 */     // No operand predicates
     /*  83526 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  83530 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83534 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  83538 */     // MIs[3] Operand 1
     /*  83538 */     // No operand predicates
     /*  83538 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  83540 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10743:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVI16GER2:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  83540 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  83543 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83547 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83552 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  83556 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83561 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  83564 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83568 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83573 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  83577 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI16GER2),
     /*  83585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  83587 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83590 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  83593 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  83596 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  83599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  83602 */     GIR_RootConstrainSelectedInstOperands,
     /*  83603 */     // GIR_Coverage, 3627,
     /*  83603 */     GIR_EraseRootFromParent_Done,
     /*  83604 */   // Label 1340: @83604
     /*  83604 */   GIM_Try, /*On fail goto*//*Label 1341*/ GIMT_Encode4(83741), // Rule ID 3630 //
     /*  83609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  83612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi4ger8),
     /*  83617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  83620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  83623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  83626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  83635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  83639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  83643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83647 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83651 */     // MIs[1] Operand 1
     /*  83651 */     // No operand predicates
     /*  83651 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  83655 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83659 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83663 */     // MIs[2] Operand 1
     /*  83663 */     // No operand predicates
     /*  83663 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  83667 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83671 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  83675 */     // MIs[3] Operand 1
     /*  83675 */     // No operand predicates
     /*  83675 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  83677 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10747:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$PMSK)  =>  (PMXVI4GER8W:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$PMSK)
     /*  83677 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  83680 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83684 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83689 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  83693 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83698 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  83701 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83705 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83710 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  83714 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI4GER8W),
     /*  83722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  83724 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83727 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  83730 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  83733 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  83736 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  83739 */     GIR_RootConstrainSelectedInstOperands,
     /*  83740 */     // GIR_Coverage, 3630,
     /*  83740 */     GIR_EraseRootFromParent_Done,
     /*  83741 */   // Label 1341: @83741
     /*  83741 */   GIM_Try, /*On fail goto*//*Label 1342*/ GIMT_Encode4(83878), // Rule ID 3632 //
     /*  83746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  83749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi8ger4),
     /*  83754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  83757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  83760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  83763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  83772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  83776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  83780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83784 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83788 */     // MIs[1] Operand 1
     /*  83788 */     // No operand predicates
     /*  83788 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  83792 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83796 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83800 */     // MIs[2] Operand 1
     /*  83800 */     // No operand predicates
     /*  83800 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  83804 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83808 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83812 */     // MIs[3] Operand 1
     /*  83812 */     // No operand predicates
     /*  83812 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  83814 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10749:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)  =>  (PMXVI8GER4W:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)
     /*  83814 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  83817 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83821 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83826 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  83830 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83835 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  83838 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83842 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83847 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  83851 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI8GER4W),
     /*  83859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  83861 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  83867 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  83870 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  83873 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  83876 */     GIR_RootConstrainSelectedInstOperands,
     /*  83877 */     // GIR_Coverage, 3632,
     /*  83877 */     GIR_EraseRootFromParent_Done,
     /*  83878 */   // Label 1342: @83878
     /*  83878 */   GIM_Try, /*On fail goto*//*Label 1343*/ GIMT_Encode4(84015), // Rule ID 3634 //
     /*  83883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  83886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi16ger2s),
     /*  83891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  83894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  83897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  83900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  83909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  83913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  83917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83921 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83925 */     // MIs[1] Operand 1
     /*  83925 */     // No operand predicates
     /*  83925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  83929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83933 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83937 */     // MIs[2] Operand 1
     /*  83937 */     // No operand predicates
     /*  83937 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  83941 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83945 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  83949 */     // MIs[3] Operand 1
     /*  83949 */     // No operand predicates
     /*  83949 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  83951 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10745:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVI16GER2SW:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  83951 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  83954 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83958 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83963 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  83967 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  83975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83979 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83984 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  83988 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI16GER2SW),
     /*  83996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  83998 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84001 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  84004 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  84007 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  84010 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  84013 */     GIR_RootConstrainSelectedInstOperands,
     /*  84014 */     // GIR_Coverage, 3634,
     /*  84014 */     GIR_EraseRootFromParent_Done,
     /*  84015 */   // Label 1343: @84015
     /*  84015 */   GIM_Try, /*On fail goto*//*Label 1344*/ GIMT_Encode4(84152), // Rule ID 3636 //
     /*  84020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  84023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf16ger2),
     /*  84028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  84031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  84034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  84037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  84050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  84054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84058 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84062 */     // MIs[1] Operand 1
     /*  84062 */     // No operand predicates
     /*  84062 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  84066 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84070 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84074 */     // MIs[2] Operand 1
     /*  84074 */     // No operand predicates
     /*  84074 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  84078 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84082 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  84086 */     // MIs[3] Operand 1
     /*  84086 */     // No operand predicates
     /*  84086 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  84088 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10728:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVF16GER2W:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  84088 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  84091 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84095 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84100 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  84104 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84109 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  84112 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84116 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84121 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  84125 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF16GER2W),
     /*  84133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  84135 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84138 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  84141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  84144 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  84147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  84150 */     GIR_RootConstrainSelectedInstOperands,
     /*  84151 */     // GIR_Coverage, 3636,
     /*  84151 */     GIR_EraseRootFromParent_Done,
     /*  84152 */   // Label 1344: @84152
     /*  84152 */   GIM_Try, /*On fail goto*//*Label 1345*/ GIMT_Encode4(84289), // Rule ID 3651 //
     /*  84157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  84160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvbf16ger2),
     /*  84165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  84168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  84171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  84174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  84187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  84191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84195 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84199 */     // MIs[1] Operand 1
     /*  84199 */     // No operand predicates
     /*  84199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  84203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84207 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84211 */     // MIs[2] Operand 1
     /*  84211 */     // No operand predicates
     /*  84211 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  84215 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84219 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  84223 */     // MIs[3] Operand 1
     /*  84223 */     // No operand predicates
     /*  84223 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  84225 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10723:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVBF16GER2W:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  84225 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  84228 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84232 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84237 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  84241 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84246 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  84249 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84253 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84258 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  84262 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVBF16GER2W),
     /*  84270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  84272 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84275 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  84278 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  84281 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  84284 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  84287 */     GIR_RootConstrainSelectedInstOperands,
     /*  84288 */     // GIR_Coverage, 3651,
     /*  84288 */     GIR_EraseRootFromParent_Done,
     /*  84289 */   // Label 1345: @84289
     /*  84289 */   GIM_Try, /*On fail goto*//*Label 1346*/ GIMT_Encode4(84426), // Rule ID 3656 //
     /*  84294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  84297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi16ger2),
     /*  84302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  84305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  84308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  84311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  84324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  84328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84332 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84336 */     // MIs[1] Operand 1
     /*  84336 */     // No operand predicates
     /*  84336 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  84340 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84344 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84348 */     // MIs[2] Operand 1
     /*  84348 */     // No operand predicates
     /*  84348 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  84352 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84356 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  84360 */     // MIs[3] Operand 1
     /*  84360 */     // No operand predicates
     /*  84360 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  84362 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10743:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVI16GER2W:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  84362 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  84365 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84369 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84374 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  84378 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  84386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84395 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  84399 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI16GER2W),
     /*  84407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  84409 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84412 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  84415 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  84418 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  84421 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  84424 */     GIR_RootConstrainSelectedInstOperands,
     /*  84425 */     // GIR_Coverage, 3656,
     /*  84425 */     GIR_EraseRootFromParent_Done,
     /*  84426 */   // Label 1346: @84426
     /*  84426 */   GIM_Try, /*On fail goto*//*Label 1347*/ GIMT_Encode4(84500), // Rule ID 3542 //
     /*  84431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture),
     /*  84434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxxshapad),
     /*  84439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  84442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  84445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  84448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  84452 */     // MIs[0] ID
     /*  84452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  84455 */     // MIs[0] E
     /*  84455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  84458 */     // MIs[0] BL
     /*  84458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  84461 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10709:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v16i8:{ *:[v16i8] }:$XB, (timm:{ *:[i32] }):$ID, (timm:{ *:[i32] }):$E, (timm:{ *:[i32] }):$BL)  =>  (DMXXSHAPAD:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), ?:{ *:[i32] }:$ID, ?:{ *:[i32] }:$E, ?:{ *:[i32] }:$BL)
     /*  84461 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  84464 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84468 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84473 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  84477 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXXSHAPAD),
     /*  84485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  84487 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  84489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84492 */     GIR_RootToRootCopy, /*OpIdx*/4, // ID
     /*  84494 */     GIR_RootToRootCopy, /*OpIdx*/5, // E
     /*  84496 */     GIR_RootToRootCopy, /*OpIdx*/6, // BL
     /*  84498 */     GIR_RootConstrainSelectedInstOperands,
     /*  84499 */     // GIR_Coverage, 3542,
     /*  84499 */     GIR_EraseRootFromParent_Done,
     /*  84500 */   // Label 1347: @84500
     /*  84500 */   GIM_Try, /*On fail goto*//*Label 1348*/ GIMT_Encode4(84624), // Rule ID 3613 //
     /*  84505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  84508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf32gerpp),
     /*  84513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  84516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  84519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  84522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  84525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  84535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  84539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84543 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84547 */     // MIs[1] Operand 1
     /*  84547 */     // No operand predicates
     /*  84547 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  84551 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84555 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84559 */     // MIs[2] Operand 1
     /*  84559 */     // No operand predicates
     /*  84559 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  84561 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10737:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)  =>  (PMXVF32GERPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)
     /*  84561 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  84564 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84568 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84573 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  84577 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  84585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84594 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  84598 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF32GERPP),
     /*  84606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  84608 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  84610 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84613 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  84616 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  84619 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  84622 */     GIR_RootConstrainSelectedInstOperands,
     /*  84623 */     // GIR_Coverage, 3613,
     /*  84623 */     GIR_EraseRootFromParent_Done,
     /*  84624 */   // Label 1348: @84624
     /*  84624 */   GIM_Try, /*On fail goto*//*Label 1349*/ GIMT_Encode4(84748), // Rule ID 3614 //
     /*  84629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  84632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf32gerpn),
     /*  84637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  84640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  84643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  84646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  84649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  84659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  84663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84667 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84671 */     // MIs[1] Operand 1
     /*  84671 */     // No operand predicates
     /*  84671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  84675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84679 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84683 */     // MIs[2] Operand 1
     /*  84683 */     // No operand predicates
     /*  84683 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  84685 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10736:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)  =>  (PMXVF32GERPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)
     /*  84685 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  84688 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84692 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84697 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  84701 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84706 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  84709 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84713 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84718 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  84722 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF32GERPN),
     /*  84730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  84732 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  84734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84737 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  84740 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  84743 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  84746 */     GIR_RootConstrainSelectedInstOperands,
     /*  84747 */     // GIR_Coverage, 3614,
     /*  84747 */     GIR_EraseRootFromParent_Done,
     /*  84748 */   // Label 1349: @84748
     /*  84748 */   GIM_Try, /*On fail goto*//*Label 1350*/ GIMT_Encode4(84872), // Rule ID 3615 //
     /*  84753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  84756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf32gernp),
     /*  84761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  84764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  84767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  84770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  84773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  84783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  84787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84791 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84795 */     // MIs[1] Operand 1
     /*  84795 */     // No operand predicates
     /*  84795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  84799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84803 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84807 */     // MIs[2] Operand 1
     /*  84807 */     // No operand predicates
     /*  84807 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  84809 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10735:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)  =>  (PMXVF32GERNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)
     /*  84809 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  84812 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84816 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84821 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  84825 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84830 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  84833 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84837 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84842 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  84846 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF32GERNP),
     /*  84854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  84856 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  84858 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84861 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  84864 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  84867 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  84870 */     GIR_RootConstrainSelectedInstOperands,
     /*  84871 */     // GIR_Coverage, 3615,
     /*  84871 */     GIR_EraseRootFromParent_Done,
     /*  84872 */   // Label 1350: @84872
     /*  84872 */   GIM_Try, /*On fail goto*//*Label 1351*/ GIMT_Encode4(84996), // Rule ID 3616 //
     /*  84877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  84880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf32gernn),
     /*  84885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  84888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  84891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  84894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  84897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  84907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  84911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84915 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84919 */     // MIs[1] Operand 1
     /*  84919 */     // No operand predicates
     /*  84919 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  84923 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84927 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84931 */     // MIs[2] Operand 1
     /*  84931 */     // No operand predicates
     /*  84931 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  84933 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10734:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)  =>  (PMXVF32GERNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)
     /*  84933 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  84936 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84940 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84945 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  84949 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84954 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  84957 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84961 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84966 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  84970 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF32GERNN),
     /*  84978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  84980 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  84982 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84985 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  84988 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  84991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  84994 */     GIR_RootConstrainSelectedInstOperands,
     /*  84995 */     // GIR_Coverage, 3616,
     /*  84995 */     GIR_EraseRootFromParent_Done,
     /*  84996 */   // Label 1351: @84996
     /*  84996 */   GIM_Try, /*On fail goto*//*Label 1352*/ GIMT_Encode4(85098), // Rule ID 3618 //
     /*  85001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  85004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf64gerpp),
     /*  85009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  85012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  85015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  85018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  85031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  85035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85039 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85043 */     // MIs[1] Operand 1
     /*  85043 */     // No operand predicates
     /*  85043 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  85047 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85051 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  85055 */     // MIs[2] Operand 1
     /*  85055 */     // No operand predicates
     /*  85055 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  85057 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10742:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)  =>  (PMXVF64GERPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)
     /*  85057 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  85060 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85064 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85069 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  85073 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF64GERPP),
     /*  85081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  85083 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  85085 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  85087 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85090 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  85093 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  85096 */     GIR_RootConstrainSelectedInstOperands,
     /*  85097 */     // GIR_Coverage, 3618,
     /*  85097 */     GIR_EraseRootFromParent_Done,
     /*  85098 */   // Label 1352: @85098
     /*  85098 */   GIM_Try, /*On fail goto*//*Label 1353*/ GIMT_Encode4(85200), // Rule ID 3619 //
     /*  85103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  85106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf64gerpn),
     /*  85111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  85114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  85117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  85120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  85133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  85137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85141 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85145 */     // MIs[1] Operand 1
     /*  85145 */     // No operand predicates
     /*  85145 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  85149 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85153 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  85157 */     // MIs[2] Operand 1
     /*  85157 */     // No operand predicates
     /*  85157 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  85159 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10741:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)  =>  (PMXVF64GERPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)
     /*  85159 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  85162 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85166 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85171 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  85175 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF64GERPN),
     /*  85183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  85185 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  85187 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  85189 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85192 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  85195 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  85198 */     GIR_RootConstrainSelectedInstOperands,
     /*  85199 */     // GIR_Coverage, 3619,
     /*  85199 */     GIR_EraseRootFromParent_Done,
     /*  85200 */   // Label 1353: @85200
     /*  85200 */   GIM_Try, /*On fail goto*//*Label 1354*/ GIMT_Encode4(85302), // Rule ID 3620 //
     /*  85205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  85208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf64gernp),
     /*  85213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  85216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  85219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  85222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  85235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  85239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85243 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85247 */     // MIs[1] Operand 1
     /*  85247 */     // No operand predicates
     /*  85247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  85251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85255 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  85259 */     // MIs[2] Operand 1
     /*  85259 */     // No operand predicates
     /*  85259 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  85261 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10740:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)  =>  (PMXVF64GERNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)
     /*  85261 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  85264 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85268 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85273 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  85277 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF64GERNP),
     /*  85285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  85287 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  85289 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  85291 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85294 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  85297 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  85300 */     GIR_RootConstrainSelectedInstOperands,
     /*  85301 */     // GIR_Coverage, 3620,
     /*  85301 */     GIR_EraseRootFromParent_Done,
     /*  85302 */   // Label 1354: @85302
     /*  85302 */   GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(85404), // Rule ID 3621 //
     /*  85307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  85310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf64gernn),
     /*  85315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  85318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  85321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  85324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  85337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  85341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85345 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85349 */     // MIs[1] Operand 1
     /*  85349 */     // No operand predicates
     /*  85349 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  85353 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85357 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  85361 */     // MIs[2] Operand 1
     /*  85361 */     // No operand predicates
     /*  85361 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  85363 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10739:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)  =>  (PMXVF64GERNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)
     /*  85363 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  85366 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85370 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85375 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  85379 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF64GERNN),
     /*  85387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  85389 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  85391 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  85393 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85396 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  85399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  85402 */     GIR_RootConstrainSelectedInstOperands,
     /*  85403 */     // GIR_Coverage, 3621,
     /*  85403 */     GIR_EraseRootFromParent_Done,
     /*  85404 */   // Label 1355: @85404
     /*  85404 */   GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(85528), // Rule ID 3642 //
     /*  85409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  85412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf32gerpp),
     /*  85417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  85420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  85423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  85439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  85443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85447 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85451 */     // MIs[1] Operand 1
     /*  85451 */     // No operand predicates
     /*  85451 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  85455 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85459 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85463 */     // MIs[2] Operand 1
     /*  85463 */     // No operand predicates
     /*  85463 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  85465 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10737:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)  =>  (PMXVF32GERWPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)
     /*  85465 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  85468 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85472 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85477 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  85481 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85486 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  85489 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85493 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85498 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  85502 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF32GERWPP),
     /*  85510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  85512 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  85514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85517 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  85520 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  85523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  85526 */     GIR_RootConstrainSelectedInstOperands,
     /*  85527 */     // GIR_Coverage, 3642,
     /*  85527 */     GIR_EraseRootFromParent_Done,
     /*  85528 */   // Label 1356: @85528
     /*  85528 */   GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(85652), // Rule ID 3643 //
     /*  85533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  85536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf32gerpn),
     /*  85541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  85544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  85547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  85563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  85567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85571 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85575 */     // MIs[1] Operand 1
     /*  85575 */     // No operand predicates
     /*  85575 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  85579 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85583 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85587 */     // MIs[2] Operand 1
     /*  85587 */     // No operand predicates
     /*  85587 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  85589 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10736:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)  =>  (PMXVF32GERWPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)
     /*  85589 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  85592 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85596 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85601 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  85605 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  85613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85622 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  85626 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF32GERWPN),
     /*  85634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  85636 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  85638 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85641 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  85644 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  85647 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  85650 */     GIR_RootConstrainSelectedInstOperands,
     /*  85651 */     // GIR_Coverage, 3643,
     /*  85651 */     GIR_EraseRootFromParent_Done,
     /*  85652 */   // Label 1357: @85652
     /*  85652 */   GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(85776), // Rule ID 3644 //
     /*  85657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  85660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf32gernp),
     /*  85665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  85668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  85671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  85687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  85691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85695 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85699 */     // MIs[1] Operand 1
     /*  85699 */     // No operand predicates
     /*  85699 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  85703 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85707 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85711 */     // MIs[2] Operand 1
     /*  85711 */     // No operand predicates
     /*  85711 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  85713 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10735:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)  =>  (PMXVF32GERWNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)
     /*  85713 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  85716 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85720 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85725 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  85729 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85734 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  85737 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85741 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85746 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  85750 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF32GERWNP),
     /*  85758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  85760 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  85762 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85765 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  85768 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  85771 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  85774 */     GIR_RootConstrainSelectedInstOperands,
     /*  85775 */     // GIR_Coverage, 3644,
     /*  85775 */     GIR_EraseRootFromParent_Done,
     /*  85776 */   // Label 1358: @85776
     /*  85776 */   GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(85900), // Rule ID 3645 //
     /*  85781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  85784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf32gernn),
     /*  85789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  85792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  85795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  85811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  85815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85819 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85823 */     // MIs[1] Operand 1
     /*  85823 */     // No operand predicates
     /*  85823 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  85827 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85831 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85835 */     // MIs[2] Operand 1
     /*  85835 */     // No operand predicates
     /*  85835 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  85837 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10734:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)  =>  (PMXVF32GERWNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)
     /*  85837 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  85840 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85844 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85849 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  85853 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  85861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85870 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  85874 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF32GERWNN),
     /*  85882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  85884 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  85886 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85889 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  85892 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  85895 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  85898 */     GIR_RootConstrainSelectedInstOperands,
     /*  85899 */     // GIR_Coverage, 3645,
     /*  85899 */     GIR_EraseRootFromParent_Done,
     /*  85900 */   // Label 1359: @85900
     /*  85900 */   GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(86002), // Rule ID 3647 //
     /*  85905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  85908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf64gerpp),
     /*  85913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  85916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  85919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  85922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  85935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  85939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85943 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85947 */     // MIs[1] Operand 1
     /*  85947 */     // No operand predicates
     /*  85947 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  85951 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85955 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  85959 */     // MIs[2] Operand 1
     /*  85959 */     // No operand predicates
     /*  85959 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  85961 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10742:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)  =>  (PMXVF64GERWPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)
     /*  85961 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  85964 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85968 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85973 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  85977 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF64GERWPP),
     /*  85985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  85987 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  85989 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  85991 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85994 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  85997 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  86000 */     GIR_RootConstrainSelectedInstOperands,
     /*  86001 */     // GIR_Coverage, 3647,
     /*  86001 */     GIR_EraseRootFromParent_Done,
     /*  86002 */   // Label 1360: @86002
     /*  86002 */   GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(86104), // Rule ID 3648 //
     /*  86007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  86010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf64gerpn),
     /*  86015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  86018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  86021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  86024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  86037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  86041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86045 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  86049 */     // MIs[1] Operand 1
     /*  86049 */     // No operand predicates
     /*  86049 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  86053 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86057 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  86061 */     // MIs[2] Operand 1
     /*  86061 */     // No operand predicates
     /*  86061 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  86063 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10741:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)  =>  (PMXVF64GERWPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)
     /*  86063 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  86066 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86070 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86075 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  86079 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  86084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF64GERWPN),
     /*  86087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  86089 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  86091 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  86093 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86096 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  86099 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  86102 */     GIR_RootConstrainSelectedInstOperands,
     /*  86103 */     // GIR_Coverage, 3648,
     /*  86103 */     GIR_EraseRootFromParent_Done,
     /*  86104 */   // Label 1361: @86104
     /*  86104 */   GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(86206), // Rule ID 3649 //
     /*  86109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  86112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf64gernp),
     /*  86117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  86120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  86123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  86126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  86139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  86143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86147 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  86151 */     // MIs[1] Operand 1
     /*  86151 */     // No operand predicates
     /*  86151 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  86155 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86159 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  86163 */     // MIs[2] Operand 1
     /*  86163 */     // No operand predicates
     /*  86163 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  86165 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10740:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)  =>  (PMXVF64GERWNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)
     /*  86165 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  86168 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86172 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86177 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  86181 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  86186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF64GERWNP),
     /*  86189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  86191 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  86193 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  86195 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86198 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  86201 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  86204 */     GIR_RootConstrainSelectedInstOperands,
     /*  86205 */     // GIR_Coverage, 3649,
     /*  86205 */     GIR_EraseRootFromParent_Done,
     /*  86206 */   // Label 1362: @86206
     /*  86206 */   GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(86308), // Rule ID 3650 //
     /*  86211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  86214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf64gernn),
     /*  86219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  86222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  86225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  86228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  86241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  86245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86249 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  86253 */     // MIs[1] Operand 1
     /*  86253 */     // No operand predicates
     /*  86253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  86257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86261 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  86265 */     // MIs[2] Operand 1
     /*  86265 */     // No operand predicates
     /*  86265 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  86267 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10739:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)  =>  (PMXVF64GERWNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)
     /*  86267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  86270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86274 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86279 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  86283 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  86288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF64GERWNN),
     /*  86291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  86293 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  86295 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  86297 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86300 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  86303 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  86306 */     GIR_RootConstrainSelectedInstOperands,
     /*  86307 */     // GIR_Coverage, 3650,
     /*  86307 */     GIR_EraseRootFromParent_Done,
     /*  86308 */   // Label 1363: @86308
     /*  86308 */   GIM_Reject,
     /*  86309 */ // Label 1331: @86309
     /*  86309 */ GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(91210),
     /*  86314 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/8,
     /*  86317 */   GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(86437), // Rule ID 3530 //
     /*  86322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  86325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmdmxvi8gerx4pp),
     /*  86330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  86333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  86336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  86339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86348 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  86355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  86359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86363 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  86367 */     // MIs[1] Operand 1
     /*  86367 */     // No operand predicates
     /*  86367 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  86371 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86375 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  86379 */     // MIs[2] Operand 1
     /*  86379 */     // No operand predicates
     /*  86379 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  86383 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86387 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  86391 */     // MIs[3] Operand 1
     /*  86391 */     // No operand predicates
     /*  86391 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  86393 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10721:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)  =>  (PMDMXVI8GERX4PP:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)
     /*  86393 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  86396 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86400 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86405 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  86409 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  86414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMDMXVI8GERX4PP),
     /*  86417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  86419 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  86421 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  86423 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86426 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  86429 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  86432 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  86435 */     GIR_RootConstrainSelectedInstOperands,
     /*  86436 */     // GIR_Coverage, 3530,
     /*  86436 */     GIR_EraseRootFromParent_Done,
     /*  86437 */   // Label 1365: @86437
     /*  86437 */   GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(86557), // Rule ID 3531 //
     /*  86442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  86445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmdmxvi8gerx4spp),
     /*  86450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  86453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  86456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  86459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86468 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  86475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  86479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86483 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  86487 */     // MIs[1] Operand 1
     /*  86487 */     // No operand predicates
     /*  86487 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  86491 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86495 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  86499 */     // MIs[2] Operand 1
     /*  86499 */     // No operand predicates
     /*  86499 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  86503 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86507 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  86511 */     // MIs[3] Operand 1
     /*  86511 */     // No operand predicates
     /*  86511 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  86513 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10722:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)  =>  (PMDMXVI8GERX4SPP:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)
     /*  86513 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  86516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86520 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86525 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  86529 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  86534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMDMXVI8GERX4SPP),
     /*  86537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  86539 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  86541 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  86543 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86546 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  86549 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  86552 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  86555 */     GIR_RootConstrainSelectedInstOperands,
     /*  86556 */     // GIR_Coverage, 3531,
     /*  86556 */     GIR_EraseRootFromParent_Done,
     /*  86557 */   // Label 1366: @86557
     /*  86557 */   GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(86677), // Rule ID 3533 //
     /*  86562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  86565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmdmxvbf16gerx2pp),
     /*  86570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  86573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  86576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  86579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86588 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  86595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  86599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86603 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  86607 */     // MIs[1] Operand 1
     /*  86607 */     // No operand predicates
     /*  86607 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  86611 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86615 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  86619 */     // MIs[2] Operand 1
     /*  86619 */     // No operand predicates
     /*  86619 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  86623 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86627 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  86631 */     // MIs[3] Operand 1
     /*  86631 */     // No operand predicates
     /*  86631 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  86633 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10714:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMDMXVBF16GERX2PP:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  86633 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  86636 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86640 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86645 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  86649 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  86654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMDMXVBF16GERX2PP),
     /*  86657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  86659 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  86661 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  86663 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86666 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  86669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  86672 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  86675 */     GIR_RootConstrainSelectedInstOperands,
     /*  86676 */     // GIR_Coverage, 3533,
     /*  86676 */     GIR_EraseRootFromParent_Done,
     /*  86677 */   // Label 1367: @86677
     /*  86677 */   GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(86797), // Rule ID 3534 //
     /*  86682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  86685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmdmxvbf16gerx2pn),
     /*  86690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  86693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  86696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  86699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86708 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  86715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  86719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86723 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  86727 */     // MIs[1] Operand 1
     /*  86727 */     // No operand predicates
     /*  86727 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  86731 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86735 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  86739 */     // MIs[2] Operand 1
     /*  86739 */     // No operand predicates
     /*  86739 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  86743 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86747 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  86751 */     // MIs[3] Operand 1
     /*  86751 */     // No operand predicates
     /*  86751 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  86753 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10713:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMDMXVBF16GERX2PN:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  86753 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  86756 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86760 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86765 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  86769 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  86774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMDMXVBF16GERX2PN),
     /*  86777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  86779 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  86781 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  86783 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86786 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  86789 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  86792 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  86795 */     GIR_RootConstrainSelectedInstOperands,
     /*  86796 */     // GIR_Coverage, 3534,
     /*  86796 */     GIR_EraseRootFromParent_Done,
     /*  86797 */   // Label 1368: @86797
     /*  86797 */   GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(86917), // Rule ID 3535 //
     /*  86802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  86805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmdmxvbf16gerx2np),
     /*  86810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  86813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  86816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  86819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86828 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  86835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  86839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86843 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  86847 */     // MIs[1] Operand 1
     /*  86847 */     // No operand predicates
     /*  86847 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  86851 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86855 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  86859 */     // MIs[2] Operand 1
     /*  86859 */     // No operand predicates
     /*  86859 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  86863 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86867 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  86871 */     // MIs[3] Operand 1
     /*  86871 */     // No operand predicates
     /*  86871 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  86873 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10712:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMDMXVBF16GERX2NP:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  86873 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  86876 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86880 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86885 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  86889 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  86894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMDMXVBF16GERX2NP),
     /*  86897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  86899 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  86901 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  86903 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86906 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  86909 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  86912 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  86915 */     GIR_RootConstrainSelectedInstOperands,
     /*  86916 */     // GIR_Coverage, 3535,
     /*  86916 */     GIR_EraseRootFromParent_Done,
     /*  86917 */   // Label 1369: @86917
     /*  86917 */   GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(87037), // Rule ID 3536 //
     /*  86922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  86925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmdmxvbf16gerx2nn),
     /*  86930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  86933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  86936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  86939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86948 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  86955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  86959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86963 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  86967 */     // MIs[1] Operand 1
     /*  86967 */     // No operand predicates
     /*  86967 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  86971 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86975 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  86979 */     // MIs[2] Operand 1
     /*  86979 */     // No operand predicates
     /*  86979 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  86983 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86987 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  86991 */     // MIs[3] Operand 1
     /*  86991 */     // No operand predicates
     /*  86991 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  86993 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10711:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMDMXVBF16GERX2NN:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  86993 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  86996 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87000 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87005 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  87009 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMDMXVBF16GERX2NN),
     /*  87017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  87019 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  87021 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  87023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87026 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  87029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  87032 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  87035 */     GIR_RootConstrainSelectedInstOperands,
     /*  87036 */     // GIR_Coverage, 3536,
     /*  87036 */     GIR_EraseRootFromParent_Done,
     /*  87037 */   // Label 1370: @87037
     /*  87037 */   GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(87157), // Rule ID 3538 //
     /*  87042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  87045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmdmxvf16gerx2pp),
     /*  87050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  87053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  87056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  87059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  87062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87068 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  87075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  87079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87083 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  87087 */     // MIs[1] Operand 1
     /*  87087 */     // No operand predicates
     /*  87087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  87091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87095 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87099 */     // MIs[2] Operand 1
     /*  87099 */     // No operand predicates
     /*  87099 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  87103 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87107 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  87111 */     // MIs[3] Operand 1
     /*  87111 */     // No operand predicates
     /*  87111 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  87113 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10719:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMDMXVF16GERX2PP:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  87113 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  87116 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87120 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87125 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  87129 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMDMXVF16GERX2PP),
     /*  87137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  87139 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  87141 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  87143 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87146 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  87149 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  87152 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  87155 */     GIR_RootConstrainSelectedInstOperands,
     /*  87156 */     // GIR_Coverage, 3538,
     /*  87156 */     GIR_EraseRootFromParent_Done,
     /*  87157 */   // Label 1371: @87157
     /*  87157 */   GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(87277), // Rule ID 3539 //
     /*  87162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  87165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmdmxvf16gerx2pn),
     /*  87170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  87173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  87176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  87179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  87182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87188 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  87195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  87199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87203 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  87207 */     // MIs[1] Operand 1
     /*  87207 */     // No operand predicates
     /*  87207 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  87211 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87215 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87219 */     // MIs[2] Operand 1
     /*  87219 */     // No operand predicates
     /*  87219 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  87223 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87227 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  87231 */     // MIs[3] Operand 1
     /*  87231 */     // No operand predicates
     /*  87231 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  87233 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10718:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMDMXVF16GERX2PN:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  87233 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  87236 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87240 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87245 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  87249 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMDMXVF16GERX2PN),
     /*  87257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  87259 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  87261 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  87263 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87266 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  87269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  87272 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  87275 */     GIR_RootConstrainSelectedInstOperands,
     /*  87276 */     // GIR_Coverage, 3539,
     /*  87276 */     GIR_EraseRootFromParent_Done,
     /*  87277 */   // Label 1372: @87277
     /*  87277 */   GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(87397), // Rule ID 3540 //
     /*  87282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  87285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmdmxvf16gerx2np),
     /*  87290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  87293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  87296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  87299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  87302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87308 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  87315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  87319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87323 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  87327 */     // MIs[1] Operand 1
     /*  87327 */     // No operand predicates
     /*  87327 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  87331 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87335 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87339 */     // MIs[2] Operand 1
     /*  87339 */     // No operand predicates
     /*  87339 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  87343 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87347 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  87351 */     // MIs[3] Operand 1
     /*  87351 */     // No operand predicates
     /*  87351 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  87353 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10717:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMDMXVF16GERX2NP:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  87353 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  87356 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87360 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87365 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  87369 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMDMXVF16GERX2NP),
     /*  87377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  87379 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  87381 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  87383 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87386 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  87389 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  87392 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  87395 */     GIR_RootConstrainSelectedInstOperands,
     /*  87396 */     // GIR_Coverage, 3540,
     /*  87396 */     GIR_EraseRootFromParent_Done,
     /*  87397 */   // Label 1373: @87397
     /*  87397 */   GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(87517), // Rule ID 3541 //
     /*  87402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  87405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmdmxvf16gerx2nn),
     /*  87410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  87413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  87416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  87419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  87422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87428 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  87435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  87439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87443 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  87447 */     // MIs[1] Operand 1
     /*  87447 */     // No operand predicates
     /*  87447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  87451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87455 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87459 */     // MIs[2] Operand 1
     /*  87459 */     // No operand predicates
     /*  87459 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  87463 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87467 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  87471 */     // MIs[3] Operand 1
     /*  87471 */     // No operand predicates
     /*  87471 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  87473 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10716:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMDMXVF16GERX2NN:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  87473 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  87476 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87480 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87485 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  87489 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMDMXVF16GERX2NN),
     /*  87497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  87499 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  87501 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  87503 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87506 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  87509 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  87512 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  87515 */     GIR_RootConstrainSelectedInstOperands,
     /*  87516 */     // GIR_Coverage, 3541,
     /*  87516 */     GIR_EraseRootFromParent_Done,
     /*  87517 */   // Label 1374: @87517
     /*  87517 */   GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(87659), // Rule ID 3602 //
     /*  87522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  87525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi4ger8pp),
     /*  87530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  87533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  87536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  87539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  87542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87548 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  87555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  87559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87563 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87567 */     // MIs[1] Operand 1
     /*  87567 */     // No operand predicates
     /*  87567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  87571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87575 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87579 */     // MIs[2] Operand 1
     /*  87579 */     // No operand predicates
     /*  87579 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  87583 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87587 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  87591 */     // MIs[3] Operand 1
     /*  87591 */     // No operand predicates
     /*  87591 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  87593 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10748:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$PMSK)  =>  (PMXVI4GER8PP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$PMSK)
     /*  87593 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  87596 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87600 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87605 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  87609 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87614 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  87617 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87621 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87626 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  87630 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI4GER8PP),
     /*  87638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  87640 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  87642 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87645 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  87648 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  87651 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  87654 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  87657 */     GIR_RootConstrainSelectedInstOperands,
     /*  87658 */     // GIR_Coverage, 3602,
     /*  87658 */     GIR_EraseRootFromParent_Done,
     /*  87659 */   // Label 1375: @87659
     /*  87659 */   GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(87801), // Rule ID 3604 //
     /*  87664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  87667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi8ger4pp),
     /*  87672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  87675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  87678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  87681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  87684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87690 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  87697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  87701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87705 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87709 */     // MIs[1] Operand 1
     /*  87709 */     // No operand predicates
     /*  87709 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  87713 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87717 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87721 */     // MIs[2] Operand 1
     /*  87721 */     // No operand predicates
     /*  87721 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  87725 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87729 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87733 */     // MIs[3] Operand 1
     /*  87733 */     // No operand predicates
     /*  87733 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  87735 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10750:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)  =>  (PMXVI8GER4PP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)
     /*  87735 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  87738 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87742 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87747 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  87751 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  87759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87768 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  87772 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI8GER4PP),
     /*  87780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  87782 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  87784 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87787 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  87790 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  87793 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  87796 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  87799 */     GIR_RootConstrainSelectedInstOperands,
     /*  87800 */     // GIR_Coverage, 3604,
     /*  87800 */     GIR_EraseRootFromParent_Done,
     /*  87801 */   // Label 1376: @87801
     /*  87801 */   GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(87943), // Rule ID 3606 //
     /*  87806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  87809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi16ger2spp),
     /*  87814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  87817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  87820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  87823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  87826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87832 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  87839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  87843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87847 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87851 */     // MIs[1] Operand 1
     /*  87851 */     // No operand predicates
     /*  87851 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  87855 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87859 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87863 */     // MIs[2] Operand 1
     /*  87863 */     // No operand predicates
     /*  87863 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  87867 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87871 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  87875 */     // MIs[3] Operand 1
     /*  87875 */     // No operand predicates
     /*  87875 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  87877 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10746:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVI16GER2SPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  87877 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  87880 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87884 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87889 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  87893 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87898 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  87901 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87905 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87910 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  87914 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI16GER2SPP),
     /*  87922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  87924 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  87926 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87929 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  87932 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  87935 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  87938 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  87941 */     GIR_RootConstrainSelectedInstOperands,
     /*  87942 */     // GIR_Coverage, 3606,
     /*  87942 */     GIR_EraseRootFromParent_Done,
     /*  87943 */   // Label 1377: @87943
     /*  87943 */   GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(88085), // Rule ID 3608 //
     /*  87948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  87951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf16ger2pp),
     /*  87956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  87959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  87962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  87965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  87968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87974 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  87981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  87985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87989 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87993 */     // MIs[1] Operand 1
     /*  87993 */     // No operand predicates
     /*  87993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  87997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88001 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88005 */     // MIs[2] Operand 1
     /*  88005 */     // No operand predicates
     /*  88005 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  88009 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88013 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  88017 */     // MIs[3] Operand 1
     /*  88017 */     // No operand predicates
     /*  88017 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  88019 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10732:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVF16GER2PP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  88019 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  88022 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88026 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88031 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  88035 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88040 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  88043 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88047 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88052 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  88056 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF16GER2PP),
     /*  88064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  88066 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  88068 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88071 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  88074 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  88077 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  88080 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  88083 */     GIR_RootConstrainSelectedInstOperands,
     /*  88084 */     // GIR_Coverage, 3608,
     /*  88084 */     GIR_EraseRootFromParent_Done,
     /*  88085 */   // Label 1378: @88085
     /*  88085 */   GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(88227), // Rule ID 3609 //
     /*  88090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  88093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf16ger2pn),
     /*  88098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  88101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  88104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  88107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  88110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88116 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  88123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  88127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88131 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88135 */     // MIs[1] Operand 1
     /*  88135 */     // No operand predicates
     /*  88135 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  88139 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88143 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88147 */     // MIs[2] Operand 1
     /*  88147 */     // No operand predicates
     /*  88147 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  88151 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88155 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  88159 */     // MIs[3] Operand 1
     /*  88159 */     // No operand predicates
     /*  88159 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  88161 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10731:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVF16GER2PN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  88161 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  88164 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88168 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88173 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  88177 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88182 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  88185 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88189 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88194 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  88198 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF16GER2PN),
     /*  88206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  88208 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  88210 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88213 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  88216 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  88219 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  88222 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  88225 */     GIR_RootConstrainSelectedInstOperands,
     /*  88226 */     // GIR_Coverage, 3609,
     /*  88226 */     GIR_EraseRootFromParent_Done,
     /*  88227 */   // Label 1379: @88227
     /*  88227 */   GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(88369), // Rule ID 3610 //
     /*  88232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  88235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf16ger2np),
     /*  88240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  88243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  88246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  88249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  88252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88258 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  88265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  88269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88273 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88277 */     // MIs[1] Operand 1
     /*  88277 */     // No operand predicates
     /*  88277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  88281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88285 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88289 */     // MIs[2] Operand 1
     /*  88289 */     // No operand predicates
     /*  88289 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  88293 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88297 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  88301 */     // MIs[3] Operand 1
     /*  88301 */     // No operand predicates
     /*  88301 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  88303 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10730:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVF16GER2NP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  88303 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  88306 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88310 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88315 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  88319 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88324 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  88327 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88331 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88336 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  88340 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF16GER2NP),
     /*  88348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  88350 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  88352 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88355 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  88358 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  88361 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  88364 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  88367 */     GIR_RootConstrainSelectedInstOperands,
     /*  88368 */     // GIR_Coverage, 3610,
     /*  88368 */     GIR_EraseRootFromParent_Done,
     /*  88369 */   // Label 1380: @88369
     /*  88369 */   GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(88511), // Rule ID 3611 //
     /*  88374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  88377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf16ger2nn),
     /*  88382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  88385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  88388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  88391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  88394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88400 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  88407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  88411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88415 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88419 */     // MIs[1] Operand 1
     /*  88419 */     // No operand predicates
     /*  88419 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  88423 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88427 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88431 */     // MIs[2] Operand 1
     /*  88431 */     // No operand predicates
     /*  88431 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  88435 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88439 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  88443 */     // MIs[3] Operand 1
     /*  88443 */     // No operand predicates
     /*  88443 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  88445 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10729:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVF16GER2NN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  88445 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  88448 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88452 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88457 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  88461 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88466 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  88469 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88473 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88478 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  88482 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF16GER2NN),
     /*  88490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  88492 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  88494 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  88500 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  88503 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  88506 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  88509 */     GIR_RootConstrainSelectedInstOperands,
     /*  88510 */     // GIR_Coverage, 3611,
     /*  88510 */     GIR_EraseRootFromParent_Done,
     /*  88511 */   // Label 1381: @88511
     /*  88511 */   GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(88653), // Rule ID 3623 //
     /*  88516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  88519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvbf16ger2pp),
     /*  88524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  88527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  88530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  88533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  88536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88542 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  88549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  88553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88557 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88561 */     // MIs[1] Operand 1
     /*  88561 */     // No operand predicates
     /*  88561 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  88565 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88569 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88573 */     // MIs[2] Operand 1
     /*  88573 */     // No operand predicates
     /*  88573 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  88577 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88581 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  88585 */     // MIs[3] Operand 1
     /*  88585 */     // No operand predicates
     /*  88585 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  88587 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10727:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVBF16GER2PP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  88587 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  88590 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88594 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88599 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  88603 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88608 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  88611 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88615 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88620 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  88624 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVBF16GER2PP),
     /*  88632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  88634 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  88636 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  88642 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  88645 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  88648 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  88651 */     GIR_RootConstrainSelectedInstOperands,
     /*  88652 */     // GIR_Coverage, 3623,
     /*  88652 */     GIR_EraseRootFromParent_Done,
     /*  88653 */   // Label 1382: @88653
     /*  88653 */   GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(88795), // Rule ID 3624 //
     /*  88658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  88661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvbf16ger2pn),
     /*  88666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  88669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  88672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  88675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  88678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88684 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  88691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  88695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88699 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88703 */     // MIs[1] Operand 1
     /*  88703 */     // No operand predicates
     /*  88703 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  88707 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88711 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88715 */     // MIs[2] Operand 1
     /*  88715 */     // No operand predicates
     /*  88715 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  88719 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88723 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  88727 */     // MIs[3] Operand 1
     /*  88727 */     // No operand predicates
     /*  88727 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  88729 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10726:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVBF16GER2PN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  88729 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  88732 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88736 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88741 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  88745 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  88753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88762 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  88766 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVBF16GER2PN),
     /*  88774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  88776 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  88778 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88781 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  88784 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  88787 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  88790 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  88793 */     GIR_RootConstrainSelectedInstOperands,
     /*  88794 */     // GIR_Coverage, 3624,
     /*  88794 */     GIR_EraseRootFromParent_Done,
     /*  88795 */   // Label 1383: @88795
     /*  88795 */   GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(88937), // Rule ID 3625 //
     /*  88800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  88803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvbf16ger2np),
     /*  88808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  88811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  88814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  88817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  88820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88826 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  88833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  88837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88841 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88845 */     // MIs[1] Operand 1
     /*  88845 */     // No operand predicates
     /*  88845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  88849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88853 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88857 */     // MIs[2] Operand 1
     /*  88857 */     // No operand predicates
     /*  88857 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  88861 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88865 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  88869 */     // MIs[3] Operand 1
     /*  88869 */     // No operand predicates
     /*  88869 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  88871 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10725:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVBF16GER2NP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  88871 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  88874 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88878 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88883 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  88887 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88892 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  88895 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88899 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88904 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  88908 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVBF16GER2NP),
     /*  88916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  88918 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  88920 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88923 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  88926 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  88929 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  88932 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  88935 */     GIR_RootConstrainSelectedInstOperands,
     /*  88936 */     // GIR_Coverage, 3625,
     /*  88936 */     GIR_EraseRootFromParent_Done,
     /*  88937 */   // Label 1384: @88937
     /*  88937 */   GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(89079), // Rule ID 3626 //
     /*  88942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  88945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvbf16ger2nn),
     /*  88950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  88953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  88956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  88959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  88962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88968 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  88975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  88979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88983 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88987 */     // MIs[1] Operand 1
     /*  88987 */     // No operand predicates
     /*  88987 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  88991 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88995 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88999 */     // MIs[2] Operand 1
     /*  88999 */     // No operand predicates
     /*  88999 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  89003 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89007 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  89011 */     // MIs[3] Operand 1
     /*  89011 */     // No operand predicates
     /*  89011 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89013 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10724:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVBF16GER2NN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  89013 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  89016 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89020 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89025 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  89029 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  89034 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  89037 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89041 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89046 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  89050 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  89055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVBF16GER2NN),
     /*  89058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  89060 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  89062 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89065 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  89068 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  89071 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  89074 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  89077 */     GIR_RootConstrainSelectedInstOperands,
     /*  89078 */     // GIR_Coverage, 3626,
     /*  89078 */     GIR_EraseRootFromParent_Done,
     /*  89079 */   // Label 1385: @89079
     /*  89079 */   GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(89221), // Rule ID 3628 //
     /*  89084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  89087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi8ger4spp),
     /*  89092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  89095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  89098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  89101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  89104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89110 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  89117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  89121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89125 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89129 */     // MIs[1] Operand 1
     /*  89129 */     // No operand predicates
     /*  89129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  89133 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89137 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89141 */     // MIs[2] Operand 1
     /*  89141 */     // No operand predicates
     /*  89141 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  89145 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89149 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  89153 */     // MIs[3] Operand 1
     /*  89153 */     // No operand predicates
     /*  89153 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89155 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10751:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVI8GER4SPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  89155 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  89158 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89162 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89167 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  89171 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  89176 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  89179 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89183 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89188 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  89192 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  89197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI8GER4SPP),
     /*  89200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  89202 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  89204 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89207 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  89210 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  89213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  89216 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  89219 */     GIR_RootConstrainSelectedInstOperands,
     /*  89220 */     // GIR_Coverage, 3628,
     /*  89220 */     GIR_EraseRootFromParent_Done,
     /*  89221 */   // Label 1386: @89221
     /*  89221 */   GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(89363), // Rule ID 3629 //
     /*  89226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  89229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi16ger2pp),
     /*  89234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  89237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  89240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  89243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  89246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89252 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  89259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  89263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89267 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89271 */     // MIs[1] Operand 1
     /*  89271 */     // No operand predicates
     /*  89271 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  89275 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89279 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89283 */     // MIs[2] Operand 1
     /*  89283 */     // No operand predicates
     /*  89283 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  89287 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89291 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  89295 */     // MIs[3] Operand 1
     /*  89295 */     // No operand predicates
     /*  89295 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89297 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10744:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVI16GER2PP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  89297 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  89300 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89304 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89309 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  89313 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  89318 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  89321 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89325 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89330 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  89334 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  89339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI16GER2PP),
     /*  89342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  89344 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  89346 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89349 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  89352 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  89355 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  89358 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  89361 */     GIR_RootConstrainSelectedInstOperands,
     /*  89362 */     // GIR_Coverage, 3629,
     /*  89362 */     GIR_EraseRootFromParent_Done,
     /*  89363 */   // Label 1387: @89363
     /*  89363 */   GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(89505), // Rule ID 3631 //
     /*  89368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  89371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi4ger8pp),
     /*  89376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  89379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  89382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  89385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  89388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89394 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  89401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  89405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89409 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89413 */     // MIs[1] Operand 1
     /*  89413 */     // No operand predicates
     /*  89413 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  89417 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89421 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89425 */     // MIs[2] Operand 1
     /*  89425 */     // No operand predicates
     /*  89425 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  89429 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89433 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  89437 */     // MIs[3] Operand 1
     /*  89437 */     // No operand predicates
     /*  89437 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89439 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10748:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$PMSK)  =>  (PMXVI4GER8WPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$PMSK)
     /*  89439 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  89442 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89446 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89451 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  89455 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  89460 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  89463 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89467 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89472 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  89476 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  89481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI4GER8WPP),
     /*  89484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  89486 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  89488 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89491 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  89494 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  89497 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  89500 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  89503 */     GIR_RootConstrainSelectedInstOperands,
     /*  89504 */     // GIR_Coverage, 3631,
     /*  89504 */     GIR_EraseRootFromParent_Done,
     /*  89505 */   // Label 1388: @89505
     /*  89505 */   GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(89647), // Rule ID 3633 //
     /*  89510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  89513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi8ger4pp),
     /*  89518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  89521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  89524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  89527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  89530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89536 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  89543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  89547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89551 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89555 */     // MIs[1] Operand 1
     /*  89555 */     // No operand predicates
     /*  89555 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  89559 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89563 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89567 */     // MIs[2] Operand 1
     /*  89567 */     // No operand predicates
     /*  89567 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  89571 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89575 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89579 */     // MIs[3] Operand 1
     /*  89579 */     // No operand predicates
     /*  89579 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89581 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10750:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)  =>  (PMXVI8GER4WPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)
     /*  89581 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  89584 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89588 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89593 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  89597 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  89602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  89605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89614 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  89618 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  89623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI8GER4WPP),
     /*  89626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  89628 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  89630 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89633 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  89636 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  89639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  89642 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  89645 */     GIR_RootConstrainSelectedInstOperands,
     /*  89646 */     // GIR_Coverage, 3633,
     /*  89646 */     GIR_EraseRootFromParent_Done,
     /*  89647 */   // Label 1389: @89647
     /*  89647 */   GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(89789), // Rule ID 3635 //
     /*  89652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  89655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi16ger2spp),
     /*  89660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  89663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  89666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  89669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  89672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89678 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  89685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  89689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89693 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89697 */     // MIs[1] Operand 1
     /*  89697 */     // No operand predicates
     /*  89697 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  89701 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89705 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89709 */     // MIs[2] Operand 1
     /*  89709 */     // No operand predicates
     /*  89709 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  89713 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89717 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  89721 */     // MIs[3] Operand 1
     /*  89721 */     // No operand predicates
     /*  89721 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89723 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10746:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVI16GER2SWPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  89723 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  89726 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89730 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89735 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  89739 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  89744 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  89747 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89751 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89756 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  89760 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  89765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI16GER2SWPP),
     /*  89768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  89770 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  89772 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  89778 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  89781 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  89784 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  89787 */     GIR_RootConstrainSelectedInstOperands,
     /*  89788 */     // GIR_Coverage, 3635,
     /*  89788 */     GIR_EraseRootFromParent_Done,
     /*  89789 */   // Label 1390: @89789
     /*  89789 */   GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(89931), // Rule ID 3637 //
     /*  89794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  89797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf16ger2pp),
     /*  89802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  89805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  89808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  89811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  89814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89820 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  89827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  89831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89835 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89839 */     // MIs[1] Operand 1
     /*  89839 */     // No operand predicates
     /*  89839 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  89843 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89847 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89851 */     // MIs[2] Operand 1
     /*  89851 */     // No operand predicates
     /*  89851 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  89855 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89859 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  89863 */     // MIs[3] Operand 1
     /*  89863 */     // No operand predicates
     /*  89863 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89865 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10732:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVF16GER2WPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  89865 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  89868 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89872 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89877 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  89881 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  89886 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  89889 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89893 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89898 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  89902 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  89907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF16GER2WPP),
     /*  89910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  89912 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  89914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89917 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  89920 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  89923 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  89926 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  89929 */     GIR_RootConstrainSelectedInstOperands,
     /*  89930 */     // GIR_Coverage, 3637,
     /*  89930 */     GIR_EraseRootFromParent_Done,
     /*  89931 */   // Label 1391: @89931
     /*  89931 */   GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(90073), // Rule ID 3638 //
     /*  89936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  89939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf16ger2pn),
     /*  89944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  89947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  89950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  89953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  89956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89962 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  89969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  89973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89977 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89981 */     // MIs[1] Operand 1
     /*  89981 */     // No operand predicates
     /*  89981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  89985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89989 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89993 */     // MIs[2] Operand 1
     /*  89993 */     // No operand predicates
     /*  89993 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  89997 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90001 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  90005 */     // MIs[3] Operand 1
     /*  90005 */     // No operand predicates
     /*  90005 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90007 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10731:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVF16GER2WPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  90007 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  90010 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90014 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90019 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  90023 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  90028 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  90031 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90035 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90040 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  90044 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  90049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF16GER2WPN),
     /*  90052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  90054 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  90056 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90059 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  90062 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  90065 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  90068 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  90071 */     GIR_RootConstrainSelectedInstOperands,
     /*  90072 */     // GIR_Coverage, 3638,
     /*  90072 */     GIR_EraseRootFromParent_Done,
     /*  90073 */   // Label 1392: @90073
     /*  90073 */   GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(90215), // Rule ID 3639 //
     /*  90078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  90081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf16ger2np),
     /*  90086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  90089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  90092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  90095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  90098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90104 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  90111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  90115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90119 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  90123 */     // MIs[1] Operand 1
     /*  90123 */     // No operand predicates
     /*  90123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  90127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90131 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  90135 */     // MIs[2] Operand 1
     /*  90135 */     // No operand predicates
     /*  90135 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  90139 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90143 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  90147 */     // MIs[3] Operand 1
     /*  90147 */     // No operand predicates
     /*  90147 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90149 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10730:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVF16GER2WNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  90149 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  90152 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90156 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90161 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  90165 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  90170 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  90173 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90177 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90182 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  90186 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  90191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF16GER2WNP),
     /*  90194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  90196 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  90198 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90201 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  90204 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  90207 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  90210 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  90213 */     GIR_RootConstrainSelectedInstOperands,
     /*  90214 */     // GIR_Coverage, 3639,
     /*  90214 */     GIR_EraseRootFromParent_Done,
     /*  90215 */   // Label 1393: @90215
     /*  90215 */   GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(90357), // Rule ID 3640 //
     /*  90220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  90223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf16ger2nn),
     /*  90228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  90231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  90234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  90237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  90240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90246 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  90253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  90257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90261 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  90265 */     // MIs[1] Operand 1
     /*  90265 */     // No operand predicates
     /*  90265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  90269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90273 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  90277 */     // MIs[2] Operand 1
     /*  90277 */     // No operand predicates
     /*  90277 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  90281 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90285 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  90289 */     // MIs[3] Operand 1
     /*  90289 */     // No operand predicates
     /*  90289 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90291 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10729:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVF16GER2WNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  90291 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  90294 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90298 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90303 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  90307 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  90312 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  90315 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90319 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90324 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  90328 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  90333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF16GER2WNN),
     /*  90336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  90338 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  90340 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90343 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  90346 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  90349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  90352 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  90355 */     GIR_RootConstrainSelectedInstOperands,
     /*  90356 */     // GIR_Coverage, 3640,
     /*  90356 */     GIR_EraseRootFromParent_Done,
     /*  90357 */   // Label 1394: @90357
     /*  90357 */   GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(90499), // Rule ID 3652 //
     /*  90362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  90365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvbf16ger2pp),
     /*  90370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  90373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  90376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  90379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  90382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90388 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  90395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  90399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90403 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  90407 */     // MIs[1] Operand 1
     /*  90407 */     // No operand predicates
     /*  90407 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  90411 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90415 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  90419 */     // MIs[2] Operand 1
     /*  90419 */     // No operand predicates
     /*  90419 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  90423 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90427 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  90431 */     // MIs[3] Operand 1
     /*  90431 */     // No operand predicates
     /*  90431 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90433 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10727:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVBF16GER2WPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  90433 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  90436 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90440 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90445 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  90449 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  90454 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  90457 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90461 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90466 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  90470 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  90475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVBF16GER2WPP),
     /*  90478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  90480 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  90482 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90485 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  90488 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  90491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  90494 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  90497 */     GIR_RootConstrainSelectedInstOperands,
     /*  90498 */     // GIR_Coverage, 3652,
     /*  90498 */     GIR_EraseRootFromParent_Done,
     /*  90499 */   // Label 1395: @90499
     /*  90499 */   GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(90641), // Rule ID 3653 //
     /*  90504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  90507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvbf16ger2pn),
     /*  90512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  90515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  90518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  90521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  90524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90530 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  90537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  90541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90545 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  90549 */     // MIs[1] Operand 1
     /*  90549 */     // No operand predicates
     /*  90549 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  90553 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90557 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  90561 */     // MIs[2] Operand 1
     /*  90561 */     // No operand predicates
     /*  90561 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  90565 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90569 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  90573 */     // MIs[3] Operand 1
     /*  90573 */     // No operand predicates
     /*  90573 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90575 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10726:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVBF16GER2WPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  90575 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  90578 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90582 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90587 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  90591 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  90596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  90599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90608 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  90612 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  90617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVBF16GER2WPN),
     /*  90620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  90622 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  90624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90627 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  90630 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  90633 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  90636 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  90639 */     GIR_RootConstrainSelectedInstOperands,
     /*  90640 */     // GIR_Coverage, 3653,
     /*  90640 */     GIR_EraseRootFromParent_Done,
     /*  90641 */   // Label 1396: @90641
     /*  90641 */   GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(90783), // Rule ID 3654 //
     /*  90646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  90649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvbf16ger2np),
     /*  90654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  90657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  90660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  90663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  90666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90672 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  90679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  90683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90687 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  90691 */     // MIs[1] Operand 1
     /*  90691 */     // No operand predicates
     /*  90691 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  90695 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90699 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  90703 */     // MIs[2] Operand 1
     /*  90703 */     // No operand predicates
     /*  90703 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  90707 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90711 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  90715 */     // MIs[3] Operand 1
     /*  90715 */     // No operand predicates
     /*  90715 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90717 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10725:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVBF16GER2WNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  90717 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  90720 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90724 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90729 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  90733 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  90738 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  90741 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90745 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90750 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  90754 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  90759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVBF16GER2WNP),
     /*  90762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  90764 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  90766 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90769 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  90772 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  90775 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  90778 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  90781 */     GIR_RootConstrainSelectedInstOperands,
     /*  90782 */     // GIR_Coverage, 3654,
     /*  90782 */     GIR_EraseRootFromParent_Done,
     /*  90783 */   // Label 1397: @90783
     /*  90783 */   GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(90925), // Rule ID 3655 //
     /*  90788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  90791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvbf16ger2nn),
     /*  90796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  90799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  90802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  90805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  90808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90814 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  90821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  90825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90829 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  90833 */     // MIs[1] Operand 1
     /*  90833 */     // No operand predicates
     /*  90833 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  90837 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90841 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  90845 */     // MIs[2] Operand 1
     /*  90845 */     // No operand predicates
     /*  90845 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  90849 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90853 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  90857 */     // MIs[3] Operand 1
     /*  90857 */     // No operand predicates
     /*  90857 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90859 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10724:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVBF16GER2WNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  90859 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  90862 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90866 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90871 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  90875 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  90880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  90883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90892 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  90896 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  90901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVBF16GER2WNN),
     /*  90904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  90906 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  90908 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90911 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  90914 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  90917 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  90920 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  90923 */     GIR_RootConstrainSelectedInstOperands,
     /*  90924 */     // GIR_Coverage, 3655,
     /*  90924 */     GIR_EraseRootFromParent_Done,
     /*  90925 */   // Label 1398: @90925
     /*  90925 */   GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(91067), // Rule ID 3657 //
     /*  90930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  90933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi8ger4spp),
     /*  90938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  90941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  90944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  90947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  90950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90956 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  90963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  90967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90971 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  90975 */     // MIs[1] Operand 1
     /*  90975 */     // No operand predicates
     /*  90975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  90979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90983 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  90987 */     // MIs[2] Operand 1
     /*  90987 */     // No operand predicates
     /*  90987 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  90991 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90995 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  90999 */     // MIs[3] Operand 1
     /*  90999 */     // No operand predicates
     /*  90999 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  91001 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10751:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVI8GER4WSPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  91001 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  91004 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91008 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  91013 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  91017 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  91022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  91025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  91034 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  91038 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  91043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI8GER4WSPP),
     /*  91046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  91048 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  91050 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  91053 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  91056 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  91059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  91062 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  91065 */     GIR_RootConstrainSelectedInstOperands,
     /*  91066 */     // GIR_Coverage, 3657,
     /*  91066 */     GIR_EraseRootFromParent_Done,
     /*  91067 */   // Label 1399: @91067
     /*  91067 */   GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(91209), // Rule ID 3658 //
     /*  91072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  91075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi16ger2pp),
     /*  91080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  91083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  91086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  91089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  91092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  91095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  91098 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  91101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  91105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  91109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91113 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  91117 */     // MIs[1] Operand 1
     /*  91117 */     // No operand predicates
     /*  91117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  91121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91125 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  91129 */     // MIs[2] Operand 1
     /*  91129 */     // No operand predicates
     /*  91129 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  91133 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91137 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  91141 */     // MIs[3] Operand 1
     /*  91141 */     // No operand predicates
     /*  91141 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  91143 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10744:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVI16GER2WPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  91143 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  91146 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91150 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  91155 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  91159 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  91164 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  91167 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91171 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  91176 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  91180 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  91185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI16GER2WPP),
     /*  91188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  91190 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  91192 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  91195 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  91198 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  91201 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  91204 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  91207 */     GIR_RootConstrainSelectedInstOperands,
     /*  91208 */     // GIR_Coverage, 3658,
     /*  91208 */     GIR_EraseRootFromParent_Done,
     /*  91209 */   // Label 1400: @91209
     /*  91209 */   GIM_Reject,
     /*  91210 */ // Label 1364: @91210
     /*  91210 */ GIM_Reject,
     /*  91211 */ // Label 20: @91211
     /*  91211 */ GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(91550),
     /*  91216 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
     /*  91219 */   GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(91238), // Rule ID 106 //
     /*  91224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_eieio),
     /*  91229 */     // (intrinsic_void 10627:{ *:[iPTR] })  =>  (PseudoEIEIO)
     /*  91229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PseudoEIEIO),
     /*  91232 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91236 */     GIR_RootConstrainSelectedInstOperands,
     /*  91237 */     // GIR_Coverage, 106,
     /*  91237 */     GIR_EraseRootFromParent_Done,
     /*  91238 */   // Label 1402: @91238
     /*  91238 */   GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(91263), // Rule ID 1201 //
     /*  91243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSYNC),
     /*  91246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_sync),
     /*  91251 */     // (intrinsic_void 10825:{ *:[iPTR] })  =>  (SYNC 0:{ *:[i32] })
     /*  91251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SYNC),
     /*  91254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91257 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91261 */     GIR_RootConstrainSelectedInstOperands,
     /*  91262 */     // GIR_Coverage, 1201,
     /*  91262 */     GIR_EraseRootFromParent_Done,
     /*  91263 */   // Label 1403: @91263
     /*  91263 */   GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(91288), // Rule ID 1202 //
     /*  91268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSYNC),
     /*  91271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_iospace_sync),
     /*  91276 */     // (intrinsic_void 10662:{ *:[iPTR] })  =>  (SYNC 0:{ *:[i32] })
     /*  91276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SYNC),
     /*  91279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91282 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91286 */     GIR_RootConstrainSelectedInstOperands,
     /*  91287 */     // GIR_Coverage, 1202,
     /*  91287 */     GIR_EraseRootFromParent_Done,
     /*  91288 */   // Label 1404: @91288
     /*  91288 */   GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(91313), // Rule ID 1203 //
     /*  91293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSYNC),
     /*  91296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_lwsync),
     /*  91301 */     // (intrinsic_void 10671:{ *:[iPTR] })  =>  (SYNC 1:{ *:[i32] })
     /*  91301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SYNC),
     /*  91304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  91307 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91311 */     GIR_RootConstrainSelectedInstOperands,
     /*  91312 */     // GIR_Coverage, 1203,
     /*  91312 */     GIR_EraseRootFromParent_Done,
     /*  91313 */   // Label 1405: @91313
     /*  91313 */   GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(91338), // Rule ID 1204 //
     /*  91318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSYNC),
     /*  91321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_iospace_lwsync),
     /*  91326 */     // (intrinsic_void 10661:{ *:[iPTR] })  =>  (SYNC 1:{ *:[i32] })
     /*  91326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SYNC),
     /*  91329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  91332 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91336 */     GIR_RootConstrainSelectedInstOperands,
     /*  91337 */     // GIR_Coverage, 1204,
     /*  91337 */     GIR_EraseRootFromParent_Done,
     /*  91338 */   // Label 1406: @91338
     /*  91338 */   GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(91360), // Rule ID 1205 //
     /*  91343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasOnlyMSYNC),
     /*  91346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_sync),
     /*  91351 */     // (intrinsic_void 10825:{ *:[iPTR] })  =>  (MSYNC)
     /*  91351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MSYNC),
     /*  91354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91358 */     GIR_RootConstrainSelectedInstOperands,
     /*  91359 */     // GIR_Coverage, 1205,
     /*  91359 */     GIR_EraseRootFromParent_Done,
     /*  91360 */   // Label 1407: @91360
     /*  91360 */   GIM_Try, /*On fail goto*//*Label 1408*/ GIMT_Encode4(91382), // Rule ID 1206 //
     /*  91365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasOnlyMSYNC),
     /*  91368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_iospace_sync),
     /*  91373 */     // (intrinsic_void 10662:{ *:[iPTR] })  =>  (MSYNC)
     /*  91373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MSYNC),
     /*  91376 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91380 */     GIR_RootConstrainSelectedInstOperands,
     /*  91381 */     // GIR_Coverage, 1206,
     /*  91381 */     GIR_EraseRootFromParent_Done,
     /*  91382 */   // Label 1408: @91382
     /*  91382 */   GIM_Try, /*On fail goto*//*Label 1409*/ GIMT_Encode4(91404), // Rule ID 1207 //
     /*  91387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasOnlyMSYNC),
     /*  91390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_lwsync),
     /*  91395 */     // (intrinsic_void 10671:{ *:[iPTR] })  =>  (MSYNC)
     /*  91395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MSYNC),
     /*  91398 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91402 */     GIR_RootConstrainSelectedInstOperands,
     /*  91403 */     // GIR_Coverage, 1207,
     /*  91403 */     GIR_EraseRootFromParent_Done,
     /*  91404 */   // Label 1409: @91404
     /*  91404 */   GIM_Try, /*On fail goto*//*Label 1410*/ GIMT_Encode4(91426), // Rule ID 1208 //
     /*  91409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasOnlyMSYNC),
     /*  91412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_iospace_lwsync),
     /*  91417 */     // (intrinsic_void 10661:{ *:[iPTR] })  =>  (MSYNC)
     /*  91417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MSYNC),
     /*  91420 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91424 */     GIR_RootConstrainSelectedInstOperands,
     /*  91425 */     // GIR_Coverage, 1208,
     /*  91425 */     GIR_EraseRootFromParent_Done,
     /*  91426 */   // Label 1410: @91426
     /*  91426 */   GIM_Try, /*On fail goto*//*Label 1411*/ GIMT_Encode4(91445), // Rule ID 1209 //
     /*  91431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_eieio),
     /*  91436 */     // (intrinsic_void 10627:{ *:[iPTR] })  =>  (PseudoEIEIO)
     /*  91436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PseudoEIEIO),
     /*  91439 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91443 */     GIR_RootConstrainSelectedInstOperands,
     /*  91444 */     // GIR_Coverage, 1209,
     /*  91444 */     GIR_EraseRootFromParent_Done,
     /*  91445 */   // Label 1411: @91445
     /*  91445 */   GIM_Try, /*On fail goto*//*Label 1412*/ GIMT_Encode4(91464), // Rule ID 1210 //
     /*  91450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_iospace_eieio),
     /*  91455 */     // (intrinsic_void 10660:{ *:[iPTR] })  =>  (PseudoEIEIO)
     /*  91455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PseudoEIEIO),
     /*  91458 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91462 */     GIR_RootConstrainSelectedInstOperands,
     /*  91463 */     // GIR_Coverage, 1210,
     /*  91463 */     GIR_EraseRootFromParent_Done,
     /*  91464 */   // Label 1412: @91464
     /*  91464 */   GIM_Try, /*On fail goto*//*Label 1413*/ GIMT_Encode4(91486), // Rule ID 1236 //
     /*  91469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_fence),
     /*  91474 */     // (intrinsic_void 10638:{ *:[iPTR] })  =>  (FENCE)
     /*  91474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FENCE),
     /*  91477 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::RM*/0,
     /*  91480 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91484 */     GIR_RootConstrainSelectedInstOperands,
     /*  91485 */     // GIR_Coverage, 1236,
     /*  91485 */     GIR_EraseRootFromParent_Done,
     /*  91486 */   // Label 1413: @91486
     /*  91486 */   GIM_Try, /*On fail goto*//*Label 1414*/ GIMT_Encode4(91508), // Rule ID 1290 //
     /*  91491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsAIX),
     /*  91494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_dssall),
     /*  91499 */     // (intrinsic_void 10279:{ *:[iPTR] })  =>  (NOP)
     /*  91499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::NOP),
     /*  91502 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91506 */     GIR_RootConstrainSelectedInstOperands,
     /*  91507 */     // GIR_Coverage, 1290,
     /*  91507 */     GIR_EraseRootFromParent_Done,
     /*  91508 */   // Label 1414: @91508
     /*  91508 */   GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(91530), // Rule ID 1291 //
     /*  91513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotAIX),
     /*  91516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_dssall),
     /*  91521 */     // (intrinsic_void 10279:{ *:[iPTR] })  =>  (DSSALL)
     /*  91521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DSSALL),
     /*  91524 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91528 */     GIR_RootConstrainSelectedInstOperands,
     /*  91529 */     // GIR_Coverage, 1291,
     /*  91529 */     GIR_EraseRootFromParent_Done,
     /*  91530 */   // Label 1415: @91530
     /*  91530 */   GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(91549), // Rule ID 4860 //
     /*  91535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_isync),
     /*  91540 */     // (intrinsic_void 10663:{ *:[iPTR] })  =>  (ISYNC)
     /*  91540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ISYNC),
     /*  91543 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91547 */     GIR_RootConstrainSelectedInstOperands,
     /*  91548 */     // GIR_Coverage, 4860,
     /*  91548 */     GIR_EraseRootFromParent_Done,
     /*  91549 */   // Label 1416: @91549
     /*  91549 */   GIM_Reject,
     /*  91550 */ // Label 1401: @91550
     /*  91550 */ GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(92433),
     /*  91555 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /*  91558 */   GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(91597), // Rule ID 269 //
     /*  91563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  91566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_dss),
     /*  91571 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91582 */     // MIs[1] Operand 1
     /*  91582 */     // No operand predicates
     /*  91582 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91584 */     // (intrinsic_void 10278:{ *:[iPTR] }, (imm:{ *:[i32] }):$STRM)  =>  (DSS (imm:{ *:[i32] }):$STRM)
     /*  91584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DSS),
     /*  91587 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // STRM
     /*  91590 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91595 */     GIR_RootConstrainSelectedInstOperands,
     /*  91596 */     // GIR_Coverage, 269,
     /*  91596 */     GIR_EraseRootFromParent_Done,
     /*  91597 */   // Label 1418: @91597
     /*  91597 */   GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(91623), // Rule ID 193 //
     /*  91602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  91605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_mtfsb0),
     /*  91610 */     // MIs[0] FM
     /*  91610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  91613 */     // (intrinsic_void 10784:{ *:[iPTR] }, (timm:{ *:[i32] }):$FM)  =>  (MTFSB0 (timm:{ *:[i32] }):$FM)
     /*  91613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTFSB0),
     /*  91616 */     GIR_RootToRootCopy, /*OpIdx*/1, // FM
     /*  91618 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::RM*/0,
     /*  91621 */     GIR_RootConstrainSelectedInstOperands,
     /*  91622 */     // GIR_Coverage, 193,
     /*  91622 */     GIR_EraseRootFromParent_Done,
     /*  91623 */   // Label 1419: @91623
     /*  91623 */   GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(91649), // Rule ID 194 //
     /*  91628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  91631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_mtfsb1),
     /*  91636 */     // MIs[0] FM
     /*  91636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  91639 */     // (intrinsic_void 10785:{ *:[iPTR] }, (timm:{ *:[i32] }):$FM)  =>  (MTFSB1 (timm:{ *:[i32] }):$FM)
     /*  91639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTFSB1),
     /*  91642 */     GIR_RootToRootCopy, /*OpIdx*/1, // FM
     /*  91644 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::RM*/0,
     /*  91647 */     GIR_RootConstrainSelectedInstOperands,
     /*  91648 */     // GIR_Coverage, 194,
     /*  91648 */     GIR_EraseRootFromParent_Done,
     /*  91649 */   // Label 1420: @91649
     /*  91649 */   GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(91676), // Rule ID 278 //
     /*  91654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  91657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_mfvscr),
     /*  91662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  91665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  91669 */     // (intrinsic_w_chain:{ *:[v8i16] } 10291:{ *:[iPTR] })  =>  (MFVSCR:{ *:[v8i16] })
     /*  91669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSCR),
     /*  91672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  91674 */     GIR_RootConstrainSelectedInstOperands,
     /*  91675 */     // GIR_Coverage, 278,
     /*  91675 */     GIR_EraseRootFromParent_Done,
     /*  91676 */   // Label 1421: @91676
     /*  91676 */   GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(91700), // Rule ID 1237 //
     /*  91681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_readflm),
     /*  91686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  91689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  91693 */     // (intrinsic_w_chain:{ *:[f64] } 10802:{ *:[iPTR] })  =>  (MFFS:{ *:[f64] })
     /*  91693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFFS),
     /*  91696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  91698 */     GIR_RootConstrainSelectedInstOperands,
     /*  91699 */     // GIR_Coverage, 1237,
     /*  91699 */     GIR_EraseRootFromParent_Done,
     /*  91700 */   // Label 1422: @91700
     /*  91700 */   GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(91728), // Rule ID 1238 //
     /*  91705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mffsl),
     /*  91710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  91713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  91717 */     // (intrinsic_w_chain:{ *:[f64] } 10678:{ *:[iPTR] })  =>  (MFFSL:{ *:[f64] })
     /*  91717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFFSL),
     /*  91720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  91722 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91726 */     GIR_RootConstrainSelectedInstOperands,
     /*  91727 */     // GIR_Coverage, 1238,
     /*  91727 */     GIR_EraseRootFromParent_Done,
     /*  91728 */   // Label 1423: @91728
     /*  91728 */   GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(91792), // Rule ID 1574 //
     /*  91733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_0),
     /*  91736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_darn32),
     /*  91741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  91744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  91748 */     // (intrinsic_w_chain:{ *:[i32] } 10604:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[i32] } (DARN:{ *:[i64] } 0:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  91748 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  91751 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::DARN),
     /*  91755 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  91760 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  91763 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91767 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  91769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91774 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  91781 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  91786 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  91791 */     // GIR_Coverage, 1574,
     /*  91791 */     GIR_EraseRootFromParent_Done,
     /*  91792 */   // Label 1424: @91792
     /*  91792 */   GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(91826), // Rule ID 1575 //
     /*  91797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_0),
     /*  91800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_darn),
     /*  91805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  91808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  91812 */     // (intrinsic_w_chain:{ *:[i64] } 10603:{ *:[iPTR] })  =>  (DARN:{ *:[i64] } 1:{ *:[i32] })
     /*  91812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DARN),
     /*  91815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  91817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  91820 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91824 */     GIR_RootConstrainSelectedInstOperands,
     /*  91825 */     // GIR_Coverage, 1575,
     /*  91825 */     GIR_EraseRootFromParent_Done,
     /*  91826 */   // Label 1425: @91826
     /*  91826 */   GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(91860), // Rule ID 1576 //
     /*  91831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_0),
     /*  91834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_darnraw),
     /*  91839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  91842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  91846 */     // (intrinsic_w_chain:{ *:[i64] } 10605:{ *:[iPTR] })  =>  (DARN:{ *:[i64] } 2:{ *:[i32] })
     /*  91846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DARN),
     /*  91849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  91851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  91854 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91858 */     GIR_RootConstrainSelectedInstOperands,
     /*  91859 */     // GIR_Coverage, 1576,
     /*  91859 */     GIR_EraseRootFromParent_Done,
     /*  91860 */   // Label 1426: @91860
     /*  91860 */   GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(91891), // Rule ID 2893 //
     /*  91865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  91868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_tcheck),
     /*  91873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  91876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  91880 */     // (intrinsic_w_chain:{ *:[i32] } 10832:{ *:[iPTR] })  =>  (TCHECK_RET:{ *:[i32] })
     /*  91880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::TCHECK_RET),
     /*  91883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /*  91885 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91889 */     GIR_RootConstrainSelectedInstOperands,
     /*  91890 */     // GIR_Coverage, 2893,
     /*  91890 */     GIR_EraseRootFromParent_Done,
     /*  91891 */   // Label 1427: @91891
     /*  91891 */   GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(91932), // Rule ID 2897 //
     /*  91896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  91899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_get_texasr),
     /*  91904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  91907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  91911 */     // (intrinsic_w_chain:{ *:[i64] } 10654:{ *:[iPTR] })  =>  (MFSPR8:{ *:[i64] } 130:{ *:[i32] })
     /*  91911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFSPR8),
     /*  91914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  91916 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(130),
     /*  91926 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91930 */     GIR_RootConstrainSelectedInstOperands,
     /*  91931 */     // GIR_Coverage, 2897,
     /*  91931 */     GIR_EraseRootFromParent_Done,
     /*  91932 */   // Label 1428: @91932
     /*  91932 */   GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(91973), // Rule ID 2898 //
     /*  91937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  91940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_get_texasru),
     /*  91945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  91948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  91952 */     // (intrinsic_w_chain:{ *:[i64] } 10655:{ *:[iPTR] })  =>  (MFSPR8:{ *:[i64] } 131:{ *:[i32] })
     /*  91952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFSPR8),
     /*  91955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  91957 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(131),
     /*  91967 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91971 */     GIR_RootConstrainSelectedInstOperands,
     /*  91972 */     // GIR_Coverage, 2898,
     /*  91972 */     GIR_EraseRootFromParent_Done,
     /*  91973 */   // Label 1429: @91973
     /*  91973 */   GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(92014), // Rule ID 2899 //
     /*  91978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  91981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_get_tfhar),
     /*  91986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  91989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  91993 */     // (intrinsic_w_chain:{ *:[i64] } 10656:{ *:[iPTR] })  =>  (MFSPR8:{ *:[i64] } 128:{ *:[i32] })
     /*  91993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFSPR8),
     /*  91996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  91998 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /*  92008 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92012 */     GIR_RootConstrainSelectedInstOperands,
     /*  92013 */     // GIR_Coverage, 2899,
     /*  92013 */     GIR_EraseRootFromParent_Done,
     /*  92014 */   // Label 1430: @92014
     /*  92014 */   GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(92055), // Rule ID 2900 //
     /*  92019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  92022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_get_tfiar),
     /*  92027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  92030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  92034 */     // (intrinsic_w_chain:{ *:[i64] } 10657:{ *:[iPTR] })  =>  (MFSPR8:{ *:[i64] } 129:{ *:[i32] })
     /*  92034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFSPR8),
     /*  92037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  92039 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(129),
     /*  92049 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92053 */     GIR_RootConstrainSelectedInstOperands,
     /*  92054 */     // GIR_Coverage, 2900,
     /*  92054 */     GIR_EraseRootFromParent_Done,
     /*  92055 */   // Label 1431: @92055
     /*  92055 */   GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(92086), // Rule ID 4910 //
     /*  92060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_mtmsr),
     /*  92065 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  92068 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  92072 */     // (intrinsic_void 10788:{ *:[iPTR] }, gprc:{ *:[i32] }:$RS)  =>  (MTMSR ?:{ *:[i32] }:$RS, 0:{ *:[i32] })
     /*  92072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTMSR),
     /*  92075 */     GIR_RootToRootCopy, /*OpIdx*/1, // RS
     /*  92077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92080 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92084 */     GIR_RootConstrainSelectedInstOperands,
     /*  92085 */     // GIR_Coverage, 4910,
     /*  92085 */     GIR_EraseRootFromParent_Done,
     /*  92086 */   // Label 1432: @92086
     /*  92086 */   GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(92113), // Rule ID 189 //
     /*  92091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::set_loop_iterations),
     /*  92096 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  92099 */     // (intrinsic_void 326:{ *:[iPTR] }, i32:{ *:[i32] }:$RST)  =>  (MTCTRloop:{ *:[i32] } i32:{ *:[i32] }:$RST)
     /*  92099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTCTRloop),
     /*  92102 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /*  92104 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CTR*/0,
     /*  92107 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92111 */     GIR_RootConstrainSelectedInstOperands,
     /*  92112 */     // GIR_Coverage, 189,
     /*  92112 */     GIR_EraseRootFromParent_Done,
     /*  92113 */   // Label 1433: @92113
     /*  92113 */   GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(92136), // Rule ID 279 //
     /*  92118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  92121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_mtvscr),
     /*  92126 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  92129 */     // (intrinsic_void 10292:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB)  =>  (MTVSCR v4i32:{ *:[v4i32] }:$VB)
     /*  92129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTVSCR),
     /*  92132 */     GIR_RootToRootCopy, /*OpIdx*/1, // VB
     /*  92134 */     GIR_RootConstrainSelectedInstOperands,
     /*  92135 */     // GIR_Coverage, 279,
     /*  92135 */     GIR_EraseRootFromParent_Done,
     /*  92136 */   // Label 1434: @92136
     /*  92136 */   GIM_Try, /*On fail goto*//*Label 1435*/ GIMT_Encode4(92163), // Rule ID 637 //
     /*  92141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::set_loop_iterations),
     /*  92146 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92149 */     // (intrinsic_void 326:{ *:[iPTR] }, i64:{ *:[i64] }:$RST)  =>  (MTCTR8loop:{ *:[i64] } i64:{ *:[i64] }:$RST)
     /*  92149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTCTR8loop),
     /*  92152 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /*  92154 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CTR8*/0,
     /*  92157 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92161 */     GIR_RootConstrainSelectedInstOperands,
     /*  92162 */     // GIR_Coverage, 637,
     /*  92162 */     GIR_EraseRootFromParent_Done,
     /*  92163 */   // Label 1435: @92163
     /*  92163 */   GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(92200), // Rule ID 2901 //
     /*  92168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  92171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_set_texasr),
     /*  92176 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92179 */     // (intrinsic_void 10808:{ *:[iPTR] }, i64:{ *:[i64] }:$V)  =>  (MTSPR8 130:{ *:[i32] }, ?:{ *:[i64] }:$V)
     /*  92179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTSPR8),
     /*  92182 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(130),
     /*  92192 */     GIR_RootToRootCopy, /*OpIdx*/1, // V
     /*  92194 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92198 */     GIR_RootConstrainSelectedInstOperands,
     /*  92199 */     // GIR_Coverage, 2901,
     /*  92199 */     GIR_EraseRootFromParent_Done,
     /*  92200 */   // Label 1436: @92200
     /*  92200 */   GIM_Try, /*On fail goto*//*Label 1437*/ GIMT_Encode4(92237), // Rule ID 2902 //
     /*  92205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  92208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_set_texasru),
     /*  92213 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92216 */     // (intrinsic_void 10809:{ *:[iPTR] }, i64:{ *:[i64] }:$V)  =>  (MTSPR8 131:{ *:[i32] }, ?:{ *:[i64] }:$V)
     /*  92216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTSPR8),
     /*  92219 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(131),
     /*  92229 */     GIR_RootToRootCopy, /*OpIdx*/1, // V
     /*  92231 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92235 */     GIR_RootConstrainSelectedInstOperands,
     /*  92236 */     // GIR_Coverage, 2902,
     /*  92236 */     GIR_EraseRootFromParent_Done,
     /*  92237 */   // Label 1437: @92237
     /*  92237 */   GIM_Try, /*On fail goto*//*Label 1438*/ GIMT_Encode4(92274), // Rule ID 2903 //
     /*  92242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  92245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_set_tfhar),
     /*  92250 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92253 */     // (intrinsic_void 10810:{ *:[iPTR] }, i64:{ *:[i64] }:$V)  =>  (MTSPR8 128:{ *:[i32] }, ?:{ *:[i64] }:$V)
     /*  92253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTSPR8),
     /*  92256 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /*  92266 */     GIR_RootToRootCopy, /*OpIdx*/1, // V
     /*  92268 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92272 */     GIR_RootConstrainSelectedInstOperands,
     /*  92273 */     // GIR_Coverage, 2903,
     /*  92273 */     GIR_EraseRootFromParent_Done,
     /*  92274 */   // Label 1438: @92274
     /*  92274 */   GIM_Try, /*On fail goto*//*Label 1439*/ GIMT_Encode4(92311), // Rule ID 2904 //
     /*  92279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  92282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_set_tfiar),
     /*  92287 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92290 */     // (intrinsic_void 10811:{ *:[iPTR] }, i64:{ *:[i64] }:$V)  =>  (MTSPR8 129:{ *:[i32] }, ?:{ *:[i64] }:$V)
     /*  92290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTSPR8),
     /*  92293 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(129),
     /*  92303 */     GIR_RootToRootCopy, /*OpIdx*/1, // V
     /*  92305 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92309 */     GIR_RootConstrainSelectedInstOperands,
     /*  92310 */     // GIR_Coverage, 2904,
     /*  92310 */     GIR_EraseRootFromParent_Done,
     /*  92311 */   // Label 1439: @92311
     /*  92311 */   GIM_Try, /*On fail goto*//*Label 1440*/ GIMT_Encode4(92339), // Rule ID 2895 //
     /*  92316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  92319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_trechkpt),
     /*  92324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92327 */     // (intrinsic_w_chain:{ *:[i32] } 10839:{ *:[iPTR] })  =>  (TRECHKPT:{ *:[i32] })
     /*  92327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::TRECHKPT),
     /*  92330 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR0*/0,
     /*  92333 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92337 */     GIR_RootConstrainSelectedInstOperands,
     /*  92338 */     // GIR_Coverage, 2895,
     /*  92338 */     GIR_EraseRootFromParent_Done,
     /*  92339 */   // Label 1440: @92339
     /*  92339 */   GIM_Try, /*On fail goto*//*Label 1441*/ GIMT_Encode4(92370), // Rule ID 2905 //
     /*  92344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  92347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_tendall),
     /*  92352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92355 */     // (intrinsic_w_chain:{ *:[i32] } 10835:{ *:[iPTR] })  =>  (TEND:{ *:[i32] } 1:{ *:[i32] })
     /*  92355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::TEND),
     /*  92358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  92361 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR0*/0,
     /*  92364 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92368 */     GIR_RootConstrainSelectedInstOperands,
     /*  92369 */     // GIR_Coverage, 2905,
     /*  92369 */     GIR_EraseRootFromParent_Done,
     /*  92370 */   // Label 1441: @92370
     /*  92370 */   GIM_Try, /*On fail goto*//*Label 1442*/ GIMT_Encode4(92401), // Rule ID 2906 //
     /*  92375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  92378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_tresume),
     /*  92383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92386 */     // (intrinsic_w_chain:{ *:[i32] } 10841:{ *:[iPTR] })  =>  (TSR:{ *:[i32] } 1:{ *:[i32] })
     /*  92386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::TSR),
     /*  92389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  92392 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR0*/0,
     /*  92395 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92399 */     GIR_RootConstrainSelectedInstOperands,
     /*  92400 */     // GIR_Coverage, 2906,
     /*  92400 */     GIR_EraseRootFromParent_Done,
     /*  92401 */   // Label 1442: @92401
     /*  92401 */   GIM_Try, /*On fail goto*//*Label 1443*/ GIMT_Encode4(92432), // Rule ID 2907 //
     /*  92406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  92409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_tsuspend),
     /*  92414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92417 */     // (intrinsic_w_chain:{ *:[i32] } 10844:{ *:[iPTR] })  =>  (TSR:{ *:[i32] } 0:{ *:[i32] })
     /*  92417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::TSR),
     /*  92420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92423 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR0*/0,
     /*  92426 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92430 */     GIR_RootConstrainSelectedInstOperands,
     /*  92431 */     // GIR_Coverage, 2907,
     /*  92431 */     GIR_EraseRootFromParent_Done,
     /*  92432 */   // Label 1443: @92432
     /*  92432 */   GIM_Reject,
     /*  92433 */ // Label 1417: @92433
     /*  92433 */ GIM_Try, /*On fail goto*//*Label 1444*/ GIMT_Encode4(92959),
     /*  92438 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  92441 */   GIM_Try, /*On fail goto*//*Label 1445*/ GIMT_Encode4(92472), // Rule ID 1178 //
     /*  92446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  92449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_mtfsfi),
     /*  92454 */     // MIs[0] BF
     /*  92454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  92457 */     // MIs[0] U
     /*  92457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  92460 */     // (intrinsic_void 10787:{ *:[iPTR] }, (timm:{ *:[i32] }):$BF, (timm:{ *:[i32] }):$U)  =>  (MTFSFIb (timm:{ *:[i32] }):$BF, (timm:{ *:[i32] }):$U)
     /*  92460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTFSFIb),
     /*  92463 */     GIR_RootToRootCopy, /*OpIdx*/1, // BF
     /*  92465 */     GIR_RootToRootCopy, /*OpIdx*/2, // U
     /*  92467 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::RM*/0,
     /*  92470 */     GIR_RootConstrainSelectedInstOperands,
     /*  92471 */     // GIR_Coverage, 1178,
     /*  92471 */     GIR_EraseRootFromParent_Done,
     /*  92472 */   // Label 1445: @92472
     /*  92472 */   GIM_Try, /*On fail goto*//*Label 1446*/ GIMT_Encode4(92520), // Rule ID 12 //
     /*  92477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_setrnd),
     /*  92482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  92485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  92492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92500 */     // MIs[1] Operand 1
     /*  92500 */     // No operand predicates
     /*  92500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92502 */     // (intrinsic_w_chain:{ *:[f64] } 10814:{ *:[iPTR] }, (imm:{ *:[i32] }):$RND)  =>  (SETRNDi:{ *:[f64] } (imm:{ *:[i32] }):$RND)
     /*  92502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETRNDi),
     /*  92505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /*  92507 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // RND
     /*  92510 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::RM*/0,
     /*  92513 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92518 */     GIR_RootConstrainSelectedInstOperands,
     /*  92519 */     // GIR_Coverage, 12,
     /*  92519 */     GIR_EraseRootFromParent_Done,
     /*  92520 */   // Label 1446: @92520
     /*  92520 */   GIM_Try, /*On fail goto*//*Label 1447*/ GIMT_Encode4(92568), // Rule ID 190 //
     /*  92525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::loop_decrement),
     /*  92530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /*  92533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  92540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92548 */     // MIs[1] Operand 1
     /*  92548 */     // No operand predicates
     /*  92548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92550 */     // (intrinsic_w_chain:{ *:[i1] } 224:{ *:[iPTR] }, (imm:{ *:[i32] }):$stride)  =>  (DecreaseCTRloop:{ *:[i1] }:{ *:[i32] } (imm:{ *:[i32] }):$stride)
     /*  92550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DecreaseCTRloop),
     /*  92553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rT]
     /*  92555 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // stride
     /*  92558 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CTR*/0,
     /*  92561 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92566 */     GIR_RootConstrainSelectedInstOperands,
     /*  92567 */     // GIR_Coverage, 190,
     /*  92567 */     GIR_EraseRootFromParent_Done,
     /*  92568 */   // Label 1447: @92568
     /*  92568 */   GIM_Try, /*On fail goto*//*Label 1448*/ GIMT_Encode4(92616), // Rule ID 638 //
     /*  92573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::loop_decrement),
     /*  92578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /*  92581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  92584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  92588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92596 */     // MIs[1] Operand 1
     /*  92596 */     // No operand predicates
     /*  92596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92598 */     // (intrinsic_w_chain:{ *:[i1] } 224:{ *:[iPTR] }, (imm:{ *:[i64] }):$stride)  =>  (DecreaseCTR8loop:{ *:[i1] }:{ *:[i64] } (imm:{ *:[i64] }):$stride)
     /*  92598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DecreaseCTR8loop),
     /*  92601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rT]
     /*  92603 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // stride
     /*  92606 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CTR8*/0,
     /*  92609 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92614 */     GIR_RootConstrainSelectedInstOperands,
     /*  92615 */     // GIR_Coverage, 638,
     /*  92615 */     GIR_EraseRootFromParent_Done,
     /*  92616 */   // Label 1448: @92616
     /*  92616 */   GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(92649), // Rule ID 1179 //
     /*  92621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fixed_addr_ld),
     /*  92626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  92633 */     // MIs[0] imm
     /*  92633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  92636 */     // (intrinsic_w_chain:{ *:[i32] } 10639:{ *:[iPTR] }, (timm:{ *:[i32] }):$imm)  =>  (PPCLdFixedAddr:{ *:[i32] } (timm:{ *:[i32] }):$imm)
     /*  92636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PPCLdFixedAddr),
     /*  92639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rT]
     /*  92641 */     GIR_RootToRootCopy, /*OpIdx*/2, // imm
     /*  92643 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92647 */     GIR_RootConstrainSelectedInstOperands,
     /*  92648 */     // GIR_Coverage, 1179,
     /*  92648 */     GIR_EraseRootFromParent_Done,
     /*  92649 */   // Label 1449: @92649
     /*  92649 */   GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(92682), // Rule ID 1580 //
     /*  92654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mfspr),
     /*  92659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  92662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  92666 */     // MIs[0] SPR
     /*  92666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  92669 */     // (intrinsic_w_chain:{ *:[i64] } 10680:{ *:[iPTR] }, (timm:{ *:[i32] }):$SPR)  =>  (MFSPR8:{ *:[i64] } ?:{ *:[i32] }:$SPR)
     /*  92669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFSPR8),
     /*  92672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  92674 */     GIR_RootToRootCopy, /*OpIdx*/2, // SPR
     /*  92676 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92680 */     GIR_RootConstrainSelectedInstOperands,
     /*  92681 */     // GIR_Coverage, 1580,
     /*  92681 */     GIR_EraseRootFromParent_Done,
     /*  92682 */   // Label 1450: @92682
     /*  92682 */   GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(92715), // Rule ID 4908 //
     /*  92687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mfspr),
     /*  92692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  92699 */     // MIs[0] SPR
     /*  92699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  92702 */     // (intrinsic_w_chain:{ *:[i32] } 10680:{ *:[iPTR] }, (timm:{ *:[i32] }):$SPR)  =>  (MFSPR:{ *:[i32] } ?:{ *:[i32] }:$SPR)
     /*  92702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFSPR),
     /*  92705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  92707 */     GIR_RootToRootCopy, /*OpIdx*/2, // SPR
     /*  92709 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92713 */     GIR_RootConstrainSelectedInstOperands,
     /*  92714 */     // GIR_Coverage, 4908,
     /*  92714 */     GIR_EraseRootFromParent_Done,
     /*  92715 */   // Label 1451: @92715
     /*  92715 */   GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(92748), // Rule ID 1581 //
     /*  92720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_mtspr),
     /*  92725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  92728 */     // MIs[0] SPR
     /*  92728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  92731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  92735 */     // (intrinsic_void 10789:{ *:[iPTR] }, (timm:{ *:[i32] }):$SPR, g8rc:{ *:[i64] }:$RT)  =>  (MTSPR8 ?:{ *:[i32] }:$SPR, ?:{ *:[i64] }:$RT)
     /*  92735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTSPR8),
     /*  92738 */     GIR_RootToRootCopy, /*OpIdx*/1, // SPR
     /*  92740 */     GIR_RootToRootCopy, /*OpIdx*/2, // RT
     /*  92742 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92746 */     GIR_RootConstrainSelectedInstOperands,
     /*  92747 */     // GIR_Coverage, 1581,
     /*  92747 */     GIR_EraseRootFromParent_Done,
     /*  92748 */   // Label 1452: @92748
     /*  92748 */   GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(92781), // Rule ID 4909 //
     /*  92753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_mtspr),
     /*  92758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92761 */     // MIs[0] SPR
     /*  92761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  92764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  92768 */     // (intrinsic_void 10789:{ *:[iPTR] }, (timm:{ *:[i32] }):$SPR, gprc:{ *:[i32] }:$RT)  =>  (MTSPR ?:{ *:[i32] }:$SPR, ?:{ *:[i32] }:$RT)
     /*  92768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTSPR),
     /*  92771 */     GIR_RootToRootCopy, /*OpIdx*/1, // SPR
     /*  92773 */     GIR_RootToRootCopy, /*OpIdx*/2, // RT
     /*  92775 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92779 */     GIR_RootConstrainSelectedInstOperands,
     /*  92780 */     // GIR_Coverage, 4909,
     /*  92780 */     GIR_EraseRootFromParent_Done,
     /*  92781 */   // Label 1453: @92781
     /*  92781 */   GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(92812), // Rule ID 195 //
     /*  92786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  92789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_mtfsf),
     /*  92794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  92797 */     // MIs[0] FM
     /*  92797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  92800 */     // (intrinsic_void 10786:{ *:[iPTR] }, (timm:{ *:[i32] }):$FM, f64:{ *:[f64] }:$RT)  =>  (MTFSFb (timm:{ *:[i32] }):$FM, f64:{ *:[f64] }:$RT)
     /*  92800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTFSFb),
     /*  92803 */     GIR_RootToRootCopy, /*OpIdx*/1, // FM
     /*  92805 */     GIR_RootToRootCopy, /*OpIdx*/2, // RT
     /*  92807 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::RM*/0,
     /*  92810 */     GIR_RootConstrainSelectedInstOperands,
     /*  92811 */     // GIR_Coverage, 195,
     /*  92811 */     GIR_EraseRootFromParent_Done,
     /*  92812 */   // Label 1454: @92812
     /*  92812 */   GIM_Try, /*On fail goto*//*Label 1455*/ GIMT_Encode4(92852), // Rule ID 13 //
     /*  92817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_setrnd),
     /*  92822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  92825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  92832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  92836 */     // (intrinsic_w_chain:{ *:[f64] } 10814:{ *:[iPTR] }, gprc:{ *:[i32] }:$in)  =>  (SETRND:{ *:[f64] } gprc:{ *:[i32] }:$in)
     /*  92836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETRND),
     /*  92839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /*  92841 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  92843 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::RM*/0,
     /*  92846 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92850 */     GIR_RootConstrainSelectedInstOperands,
     /*  92851 */     // GIR_Coverage, 13,
     /*  92851 */     GIR_EraseRootFromParent_Done,
     /*  92852 */   // Label 1455: @92852
     /*  92852 */   GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(92892), // Rule ID 14 //
     /*  92857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_setflm),
     /*  92862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  92865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  92868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  92872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  92876 */     // (intrinsic_w_chain:{ *:[f64] } 10813:{ *:[iPTR] }, f8rc:{ *:[f64] }:$FLM)  =>  (SETFLM:{ *:[f64] } f8rc:{ *:[f64] }:$FLM)
     /*  92876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETFLM),
     /*  92879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /*  92881 */     GIR_RootToRootCopy, /*OpIdx*/2, // FLM
     /*  92883 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::RM*/0,
     /*  92886 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92890 */     GIR_RootConstrainSelectedInstOperands,
     /*  92891 */     // GIR_Coverage, 14,
     /*  92891 */     GIR_EraseRootFromParent_Done,
     /*  92892 */   // Label 1456: @92892
     /*  92892 */   GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(92925), // Rule ID 2888 //
     /*  92897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  92900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_tabort),
     /*  92905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92911 */     // (intrinsic_w_chain:{ *:[i32] } 10826:{ *:[iPTR] }, i32:{ *:[i32] }:$R)  =>  (TABORT:{ *:[i32] } ?:{ *:[i32] }:$R)
     /*  92911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::TABORT),
     /*  92914 */     GIR_RootToRootCopy, /*OpIdx*/2, // R
     /*  92916 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR0*/0,
     /*  92919 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92923 */     GIR_RootConstrainSelectedInstOperands,
     /*  92924 */     // GIR_Coverage, 2888,
     /*  92924 */     GIR_EraseRootFromParent_Done,
     /*  92925 */   // Label 1457: @92925
     /*  92925 */   GIM_Try, /*On fail goto*//*Label 1458*/ GIMT_Encode4(92958), // Rule ID 2894 //
     /*  92930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  92933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_treclaim),
     /*  92938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92944 */     // (intrinsic_w_chain:{ *:[i32] } 10840:{ *:[iPTR] }, i32:{ *:[i32] }:$RA)  =>  (TRECLAIM:{ *:[i32] } ?:{ *:[i32] }:$RA)
     /*  92944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::TRECLAIM),
     /*  92947 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  92949 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR0*/0,
     /*  92952 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92956 */     GIR_RootConstrainSelectedInstOperands,
     /*  92957 */     // GIR_Coverage, 2894,
     /*  92957 */     GIR_EraseRootFromParent_Done,
     /*  92958 */   // Label 1458: @92958
     /*  92958 */   GIM_Reject,
     /*  92959 */ // Label 1444: @92959
     /*  92959 */ GIM_Try, /*On fail goto*//*Label 1459*/ GIMT_Encode4(93886),
     /*  92964 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /*  92967 */   GIM_Try, /*On fail goto*//*Label 1460*/ GIMT_Encode4(93017), // Rule ID 270 //
     /*  92972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  92975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_dst),
     /*  92980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92986 */     // MIs[0] RA
     /*  92986 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  92990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92998 */     // MIs[1] Operand 1
     /*  92998 */     // No operand predicates
     /*  92998 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  93000 */     // (intrinsic_void 10280:{ *:[iPTR] }, i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB, (imm:{ *:[i32] }):$STRM)  =>  (DST (imm:{ *:[i32] }):$STRM, i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*  93000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DST),
     /*  93003 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // STRM
     /*  93006 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*  93008 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  93010 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  93015 */     GIR_RootConstrainSelectedInstOperands,
     /*  93016 */     // GIR_Coverage, 270,
     /*  93016 */     GIR_EraseRootFromParent_Done,
     /*  93017 */   // Label 1460: @93017
     /*  93017 */   GIM_Try, /*On fail goto*//*Label 1461*/ GIMT_Encode4(93067), // Rule ID 271 //
     /*  93022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_dstt),
     /*  93030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93036 */     // MIs[0] RA
     /*  93036 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  93040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  93044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  93048 */     // MIs[1] Operand 1
     /*  93048 */     // No operand predicates
     /*  93048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  93050 */     // (intrinsic_void 10283:{ *:[iPTR] }, i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB, (imm:{ *:[i32] }):$STRM)  =>  (DSTT (imm:{ *:[i32] }):$STRM, i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*  93050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DSTT),
     /*  93053 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // STRM
     /*  93056 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*  93058 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  93060 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  93065 */     GIR_RootConstrainSelectedInstOperands,
     /*  93066 */     // GIR_Coverage, 271,
     /*  93066 */     GIR_EraseRootFromParent_Done,
     /*  93067 */   // Label 1461: @93067
     /*  93067 */   GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(93117), // Rule ID 272 //
     /*  93072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_dstst),
     /*  93080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93086 */     // MIs[0] RA
     /*  93086 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  93090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  93094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  93098 */     // MIs[1] Operand 1
     /*  93098 */     // No operand predicates
     /*  93098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  93100 */     // (intrinsic_void 10281:{ *:[iPTR] }, i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB, (imm:{ *:[i32] }):$STRM)  =>  (DSTST (imm:{ *:[i32] }):$STRM, i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*  93100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DSTST),
     /*  93103 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // STRM
     /*  93106 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*  93108 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  93110 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  93115 */     GIR_RootConstrainSelectedInstOperands,
     /*  93116 */     // GIR_Coverage, 272,
     /*  93116 */     GIR_EraseRootFromParent_Done,
     /*  93117 */   // Label 1462: @93117
     /*  93117 */   GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(93167), // Rule ID 273 //
     /*  93122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_dststt),
     /*  93130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93136 */     // MIs[0] RA
     /*  93136 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  93140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  93144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  93148 */     // MIs[1] Operand 1
     /*  93148 */     // No operand predicates
     /*  93148 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  93150 */     // (intrinsic_void 10282:{ *:[iPTR] }, i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB, (imm:{ *:[i32] }):$STRM)  =>  (DSTSTT (imm:{ *:[i32] }):$STRM, i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*  93150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DSTSTT),
     /*  93153 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // STRM
     /*  93156 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*  93158 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  93160 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  93165 */     GIR_RootConstrainSelectedInstOperands,
     /*  93166 */     // GIR_Coverage, 273,
     /*  93166 */     GIR_EraseRootFromParent_Done,
     /*  93167 */   // Label 1463: @93167
     /*  93167 */   GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(93217), // Rule ID 274 //
     /*  93172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_dst),
     /*  93180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93186 */     // MIs[0] RA
     /*  93186 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  93190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  93194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  93198 */     // MIs[1] Operand 1
     /*  93198 */     // No operand predicates
     /*  93198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  93200 */     // (intrinsic_void 10280:{ *:[iPTR] }, i64:{ *:[i64] }:$RA, i32:{ *:[i32] }:$RB, (imm:{ *:[i32] }):$STRM)  =>  (DST64 (imm:{ *:[i32] }):$STRM, i64:{ *:[i64] }:$RA, i32:{ *:[i32] }:$RB)
     /*  93200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DST64),
     /*  93203 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // STRM
     /*  93206 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*  93208 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  93210 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  93215 */     GIR_RootConstrainSelectedInstOperands,
     /*  93216 */     // GIR_Coverage, 274,
     /*  93216 */     GIR_EraseRootFromParent_Done,
     /*  93217 */   // Label 1464: @93217
     /*  93217 */   GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(93267), // Rule ID 275 //
     /*  93222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_dstt),
     /*  93230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93236 */     // MIs[0] RA
     /*  93236 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  93240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  93244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  93248 */     // MIs[1] Operand 1
     /*  93248 */     // No operand predicates
     /*  93248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  93250 */     // (intrinsic_void 10283:{ *:[iPTR] }, i64:{ *:[i64] }:$RA, i32:{ *:[i32] }:$RB, (imm:{ *:[i32] }):$STRM)  =>  (DSTT64 (imm:{ *:[i32] }):$STRM, i64:{ *:[i64] }:$RA, i32:{ *:[i32] }:$RB)
     /*  93250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DSTT64),
     /*  93253 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // STRM
     /*  93256 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*  93258 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  93260 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  93265 */     GIR_RootConstrainSelectedInstOperands,
     /*  93266 */     // GIR_Coverage, 275,
     /*  93266 */     GIR_EraseRootFromParent_Done,
     /*  93267 */   // Label 1465: @93267
     /*  93267 */   GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(93317), // Rule ID 276 //
     /*  93272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_dstst),
     /*  93280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93286 */     // MIs[0] RA
     /*  93286 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  93290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  93294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  93298 */     // MIs[1] Operand 1
     /*  93298 */     // No operand predicates
     /*  93298 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  93300 */     // (intrinsic_void 10281:{ *:[iPTR] }, i64:{ *:[i64] }:$RA, i32:{ *:[i32] }:$RB, (imm:{ *:[i32] }):$STRM)  =>  (DSTST64 (imm:{ *:[i32] }):$STRM, i64:{ *:[i64] }:$RA, i32:{ *:[i32] }:$RB)
     /*  93300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DSTST64),
     /*  93303 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // STRM
     /*  93306 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*  93308 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  93310 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  93315 */     GIR_RootConstrainSelectedInstOperands,
     /*  93316 */     // GIR_Coverage, 276,
     /*  93316 */     GIR_EraseRootFromParent_Done,
     /*  93317 */   // Label 1466: @93317
     /*  93317 */   GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(93367), // Rule ID 277 //
     /*  93322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_dststt),
     /*  93330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93336 */     // MIs[0] RA
     /*  93336 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  93340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  93344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  93348 */     // MIs[1] Operand 1
     /*  93348 */     // No operand predicates
     /*  93348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  93350 */     // (intrinsic_void 10282:{ *:[iPTR] }, i64:{ *:[i64] }:$RA, i32:{ *:[i32] }:$RB, (imm:{ *:[i32] }):$STRM)  =>  (DSTSTT64 (imm:{ *:[i32] }):$STRM, i64:{ *:[i64] }:$RA, i32:{ *:[i32] }:$RB)
     /*  93350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DSTSTT64),
     /*  93353 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // STRM
     /*  93356 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*  93358 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  93360 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  93365 */     GIR_RootConstrainSelectedInstOperands,
     /*  93366 */     // GIR_Coverage, 277,
     /*  93366 */     GIR_EraseRootFromParent_Done,
     /*  93367 */   // Label 1467: @93367
     /*  93367 */   GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(93404), // Rule ID 380 //
     /*  93372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsumsws),
     /*  93380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  93386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  93389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93393 */     // (intrinsic_w_chain:{ *:[v4i32] } 10562:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSUMSWS:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  93393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUMSWS),
     /*  93396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  93398 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  93400 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  93402 */     GIR_RootConstrainSelectedInstOperands,
     /*  93403 */     // GIR_Coverage, 380,
     /*  93403 */     GIR_EraseRootFromParent_Done,
     /*  93404 */   // Label 1468: @93404
     /*  93404 */   GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(93441), // Rule ID 381 //
     /*  93409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsum2sws),
     /*  93417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  93423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  93426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93430 */     // (intrinsic_w_chain:{ *:[v4i32] } 10558:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSUM2SWS:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  93430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUM2SWS),
     /*  93433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  93435 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  93437 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  93439 */     GIR_RootConstrainSelectedInstOperands,
     /*  93440 */     // GIR_Coverage, 381,
     /*  93440 */     GIR_EraseRootFromParent_Done,
     /*  93441 */   // Label 1469: @93441
     /*  93441 */   GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(93478), // Rule ID 382 //
     /*  93446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsum4sbs),
     /*  93454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  93460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  93463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93467 */     // (intrinsic_w_chain:{ *:[v4i32] } 10559:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSUM4SBS:{ *:[v4i32] } v16i8:{ *:[v16i8] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  93467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUM4SBS),
     /*  93470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  93472 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  93474 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  93476 */     GIR_RootConstrainSelectedInstOperands,
     /*  93477 */     // GIR_Coverage, 382,
     /*  93477 */     GIR_EraseRootFromParent_Done,
     /*  93478 */   // Label 1470: @93478
     /*  93478 */   GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(93515), // Rule ID 383 //
     /*  93483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsum4shs),
     /*  93491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  93497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  93500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93504 */     // (intrinsic_w_chain:{ *:[v4i32] } 10560:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSUM4SHS:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  93504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUM4SHS),
     /*  93507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  93509 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  93511 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  93513 */     GIR_RootConstrainSelectedInstOperands,
     /*  93514 */     // GIR_Coverage, 383,
     /*  93514 */     GIR_EraseRootFromParent_Done,
     /*  93515 */   // Label 1471: @93515
     /*  93515 */   GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(93552), // Rule ID 384 //
     /*  93520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsum4ubs),
     /*  93528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  93534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  93537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93541 */     // (intrinsic_w_chain:{ *:[v4i32] } 10561:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSUM4UBS:{ *:[v4i32] } v16i8:{ *:[v16i8] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  93541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUM4UBS),
     /*  93544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  93546 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  93548 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  93550 */     GIR_RootConstrainSelectedInstOperands,
     /*  93551 */     // GIR_Coverage, 384,
     /*  93551 */     GIR_EraseRootFromParent_Done,
     /*  93552 */   // Label 1472: @93552
     /*  93552 */   GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(93589), // Rule ID 411 //
     /*  93557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpkshss),
     /*  93565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  93568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  93571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  93574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93578 */     // (intrinsic_w_chain:{ *:[v16i8] } 10496:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VPKSHSS:{ *:[v16i8] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  93578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPKSHSS),
     /*  93581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  93583 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  93585 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  93587 */     GIR_RootConstrainSelectedInstOperands,
     /*  93588 */     // GIR_Coverage, 411,
     /*  93588 */     GIR_EraseRootFromParent_Done,
     /*  93589 */   // Label 1473: @93589
     /*  93589 */   GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(93626), // Rule ID 412 //
     /*  93594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpkshus),
     /*  93602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  93605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  93608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  93611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93615 */     // (intrinsic_w_chain:{ *:[v16i8] } 10497:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VPKSHUS:{ *:[v16i8] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  93615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPKSHUS),
     /*  93618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  93620 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  93622 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  93624 */     GIR_RootConstrainSelectedInstOperands,
     /*  93625 */     // GIR_Coverage, 412,
     /*  93625 */     GIR_EraseRootFromParent_Done,
     /*  93626 */   // Label 1474: @93626
     /*  93626 */   GIM_Try, /*On fail goto*//*Label 1475*/ GIMT_Encode4(93663), // Rule ID 413 //
     /*  93631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpkswss),
     /*  93639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  93642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  93645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  93648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93652 */     // (intrinsic_w_chain:{ *:[v8i16] } 10498:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VPKSWSS:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  93652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPKSWSS),
     /*  93655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  93657 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  93659 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  93661 */     GIR_RootConstrainSelectedInstOperands,
     /*  93662 */     // GIR_Coverage, 413,
     /*  93662 */     GIR_EraseRootFromParent_Done,
     /*  93663 */   // Label 1475: @93663
     /*  93663 */   GIM_Try, /*On fail goto*//*Label 1476*/ GIMT_Encode4(93700), // Rule ID 414 //
     /*  93668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpkswus),
     /*  93676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  93679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  93682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  93685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93689 */     // (intrinsic_w_chain:{ *:[v8i16] } 10499:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VPKSWUS:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  93689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPKSWUS),
     /*  93692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  93694 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  93696 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  93698 */     GIR_RootConstrainSelectedInstOperands,
     /*  93699 */     // GIR_Coverage, 414,
     /*  93699 */     GIR_EraseRootFromParent_Done,
     /*  93700 */   // Label 1476: @93700
     /*  93700 */   GIM_Try, /*On fail goto*//*Label 1477*/ GIMT_Encode4(93737), // Rule ID 415 //
     /*  93705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpkuhus),
     /*  93713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  93716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  93719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  93722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93726 */     // (intrinsic_w_chain:{ *:[v16i8] } 10501:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VPKUHUS:{ *:[v16i8] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  93726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPKUHUS),
     /*  93729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  93731 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  93733 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  93735 */     GIR_RootConstrainSelectedInstOperands,
     /*  93736 */     // GIR_Coverage, 415,
     /*  93736 */     GIR_EraseRootFromParent_Done,
     /*  93737 */   // Label 1477: @93737
     /*  93737 */   GIM_Try, /*On fail goto*//*Label 1478*/ GIMT_Encode4(93774), // Rule ID 416 //
     /*  93742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpkuwus),
     /*  93750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  93753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  93756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  93759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93763 */     // (intrinsic_w_chain:{ *:[v8i16] } 10502:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VPKUWUS:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  93763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPKUWUS),
     /*  93766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  93768 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  93770 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  93772 */     GIR_RootConstrainSelectedInstOperands,
     /*  93773 */     // GIR_Coverage, 416,
     /*  93773 */     GIR_EraseRootFromParent_Done,
     /*  93774 */   // Label 1478: @93774
     /*  93774 */   GIM_Try, /*On fail goto*//*Label 1479*/ GIMT_Encode4(93811), // Rule ID 500 //
     /*  93779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  93782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpksdss),
     /*  93787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  93793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  93796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93800 */     // (intrinsic_w_chain:{ *:[v4i32] } 10494:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VPKSDSS:{ *:[v4i32] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  93800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPKSDSS),
     /*  93803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  93805 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  93807 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  93809 */     GIR_RootConstrainSelectedInstOperands,
     /*  93810 */     // GIR_Coverage, 500,
     /*  93810 */     GIR_EraseRootFromParent_Done,
     /*  93811 */   // Label 1479: @93811
     /*  93811 */   GIM_Try, /*On fail goto*//*Label 1480*/ GIMT_Encode4(93848), // Rule ID 501 //
     /*  93816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  93819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpksdus),
     /*  93824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  93830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  93833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93837 */     // (intrinsic_w_chain:{ *:[v4i32] } 10495:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VPKSDUS:{ *:[v4i32] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  93837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPKSDUS),
     /*  93840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  93842 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  93844 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  93846 */     GIR_RootConstrainSelectedInstOperands,
     /*  93847 */     // GIR_Coverage, 501,
     /*  93847 */     GIR_EraseRootFromParent_Done,
     /*  93848 */   // Label 1480: @93848
     /*  93848 */   GIM_Try, /*On fail goto*//*Label 1481*/ GIMT_Encode4(93885), // Rule ID 502 //
     /*  93853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  93856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpkudus),
     /*  93861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  93867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  93870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93874 */     // (intrinsic_w_chain:{ *:[v4i32] } 10500:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VPKUDUS:{ *:[v4i32] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  93874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPKUDUS),
     /*  93877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  93879 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  93881 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  93883 */     GIR_RootConstrainSelectedInstOperands,
     /*  93884 */     // GIR_Coverage, 502,
     /*  93884 */     GIR_EraseRootFromParent_Done,
     /*  93885 */   // Label 1481: @93885
     /*  93885 */   GIM_Reject,
     /*  93886 */ // Label 1459: @93886
     /*  93886 */ GIM_Try, /*On fail goto*//*Label 1482*/ GIMT_Encode4(94102),
     /*  93891 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /*  93894 */   GIM_Try, /*On fail goto*//*Label 1483*/ GIMT_Encode4(93933), // Rule ID 766 //
     /*  93899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_addex),
     /*  93904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  93907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  93910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  93913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  93917 */     // MIs[0] CY
     /*  93917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  93920 */     // (intrinsic_w_chain:{ *:[i64] } 10261:{ *:[iPTR] }, i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB, (timm:{ *:[i32] }):$CY)  =>  (ADDEX8:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB, (timm:{ *:[i32] }):$CY)
     /*  93920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ADDEX8),
     /*  93923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  93925 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  93927 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  93929 */     GIR_RootToRootCopy, /*OpIdx*/4, // CY
     /*  93931 */     GIR_RootConstrainSelectedInstOperands,
     /*  93932 */     // GIR_Coverage, 766,
     /*  93932 */     GIR_EraseRootFromParent_Done,
     /*  93933 */   // Label 1483: @93933
     /*  93933 */   GIM_Try, /*On fail goto*//*Label 1484*/ GIMT_Encode4(93975), // Rule ID 294 //
     /*  93938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmhaddshs),
     /*  93946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  93949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  93952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  93955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  93958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93962 */     // (intrinsic_w_chain:{ *:[v8i16] } 10449:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v8i16:{ *:[v8i16] }:$RC)  =>  (VMHADDSHS:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v8i16:{ *:[v8i16] }:$RC)
     /*  93962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMHADDSHS),
     /*  93965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  93967 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  93969 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  93971 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  93973 */     GIR_RootConstrainSelectedInstOperands,
     /*  93974 */     // GIR_Coverage, 294,
     /*  93974 */     GIR_EraseRootFromParent_Done,
     /*  93975 */   // Label 1484: @93975
     /*  93975 */   GIM_Try, /*On fail goto*//*Label 1485*/ GIMT_Encode4(94017), // Rule ID 295 //
     /*  93980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmhraddshs),
     /*  93988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  93991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  93994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  93997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  94000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  94004 */     // (intrinsic_w_chain:{ *:[v8i16] } 10450:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v8i16:{ *:[v8i16] }:$RC)  =>  (VMHRADDSHS:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v8i16:{ *:[v8i16] }:$RC)
     /*  94004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMHRADDSHS),
     /*  94007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  94009 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  94011 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  94013 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  94015 */     GIR_RootConstrainSelectedInstOperands,
     /*  94016 */     // GIR_Coverage, 295,
     /*  94016 */     GIR_EraseRootFromParent_Done,
     /*  94017 */   // Label 1485: @94017
     /*  94017 */   GIM_Try, /*On fail goto*//*Label 1486*/ GIMT_Encode4(94059), // Rule ID 353 //
     /*  94022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  94025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmsumshs),
     /*  94030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  94033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  94036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  94039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  94042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  94046 */     // (intrinsic_w_chain:{ *:[v4i32] } 10464:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v4i32:{ *:[v4i32] }:$RC)  =>  (VMSUMSHS:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v4i32:{ *:[v4i32] }:$RC)
     /*  94046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMSUMSHS),
     /*  94049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  94051 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  94053 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  94055 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  94057 */     GIR_RootConstrainSelectedInstOperands,
     /*  94058 */     // GIR_Coverage, 353,
     /*  94058 */     GIR_EraseRootFromParent_Done,
     /*  94059 */   // Label 1486: @94059
     /*  94059 */   GIM_Try, /*On fail goto*//*Label 1487*/ GIMT_Encode4(94101), // Rule ID 354 //
     /*  94064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  94067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmsumuhs),
     /*  94072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  94075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  94078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  94081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  94084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  94088 */     // (intrinsic_w_chain:{ *:[v4i32] } 10468:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v4i32:{ *:[v4i32] }:$RC)  =>  (VMSUMUHS:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v4i32:{ *:[v4i32] }:$RC)
     /*  94088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMSUMUHS),
     /*  94091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  94093 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  94095 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  94097 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  94099 */     GIR_RootConstrainSelectedInstOperands,
     /*  94100 */     // GIR_Coverage, 354,
     /*  94100 */     GIR_EraseRootFromParent_Done,
     /*  94101 */   // Label 1487: @94101
     /*  94101 */   GIM_Reject,
     /*  94102 */ // Label 1482: @94102
     /*  94102 */ GIM_Reject,
     /*  94103 */ // Label 21: @94103
     /*  94103 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1490*/ GIMT_Encode4(114858),
     /*  94114 */ /*GILLT_s32*//*Label 1488*/ GIMT_Encode4(94122),
     /*  94118 */ /*GILLT_s64*//*Label 1489*/ GIMT_Encode4(104343),
     /*  94122 */ // Label 1488: @94122
     /*  94122 */ GIM_Try, /*On fail goto*//*Label 1491*/ GIMT_Encode4(104342),
     /*  94127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*  94130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  94134 */   GIM_Try, /*On fail goto*//*Label 1492*/ GIMT_Encode4(94246), // Rule ID 5303 //
     /*  94139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  94147 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  94151 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  94155 */     // MIs[1] Operand 1
     /*  94155 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  94160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  94164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94168 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  94172 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  94176 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  94180 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  94184 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  94188 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  94192 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /*  94196 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  94200 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  94202 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa), i32:{ *:[i32] }:$s1), 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (RLWNM:{ *:[i32] } ?:{ *:[i32] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  94202 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  94205 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /*  94209 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94214 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /*  94218 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /*  94221 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for PPC::CARRY*/0,
     /*  94224 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /*  94229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  94231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /*  94235 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  94241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  94244 */     GIR_RootConstrainSelectedInstOperands,
     /*  94245 */     // GIR_Coverage, 5303,
     /*  94245 */     GIR_EraseRootFromParent_Done,
     /*  94246 */   // Label 1492: @94246
     /*  94246 */   GIM_Try, /*On fail goto*//*Label 1493*/ GIMT_Encode4(94385), // Rule ID 5306 //
     /*  94251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  94259 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  94263 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  94267 */     // MIs[1] Operand 1
     /*  94267 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  94272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  94276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94280 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  94284 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  94288 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  94292 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  94296 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  94300 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  94304 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /*  94308 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  94312 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  94314 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa), i64:{ *:[i64] }:$s1), 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDCL:{ *:[i64] } ?:{ *:[i64] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  94314 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  94317 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /*  94321 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94326 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /*  94330 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/64,
     /*  94333 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /*  94336 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  94338 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  94341 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /*  94345 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94350 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /*  94354 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  94357 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  94360 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94367 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  94374 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  94379 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  94384 */     // GIR_Coverage, 5306,
     /*  94384 */     GIR_EraseRootFromParent_Done,
     /*  94385 */   // Label 1493: @94385
     /*  94385 */   GIM_Try, /*On fail goto*//*Label 1494*/ GIMT_Encode4(94518), // Rule ID 5311 //
     /*  94390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  94398 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  94402 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  94406 */     // MIs[1] Operand 1
     /*  94406 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  94411 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  94415 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94419 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  94423 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  94427 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  94431 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  94435 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  94439 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  94443 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /*  94447 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  94451 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  94453 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa), i32:{ *:[i32] }:$s1), 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (RLWNM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  94453 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  94456 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /*  94460 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94465 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /*  94469 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/32,
     /*  94472 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /*  94475 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  94477 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  94480 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /*  94484 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94489 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /*  94493 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /*  94497 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /*  94502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  94504 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94507 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  94510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  94513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  94516 */     GIR_RootConstrainSelectedInstOperands,
     /*  94517 */     // GIR_Coverage, 5311,
     /*  94517 */     GIR_EraseRootFromParent_Done,
     /*  94518 */   // Label 1494: @94518
     /*  94518 */   GIM_Try, /*On fail goto*//*Label 1495*/ GIMT_Encode4(94678), // Rule ID 5314 //
     /*  94523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  94531 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  94535 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  94539 */     // MIs[1] Operand 1
     /*  94539 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  94544 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  94548 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94552 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  94556 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  94560 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  94564 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  94568 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  94572 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  94576 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /*  94580 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  94584 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  94586 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa), i64:{ *:[i64] }:$s1), 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDCL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  94586 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  94589 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /*  94593 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94598 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /*  94602 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/64,
     /*  94605 */     GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for PPC::CARRY*/0,
     /*  94608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  94610 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  94613 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /*  94617 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94622 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /*  94626 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /*  94630 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  94632 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  94635 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /*  94639 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94644 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  94647 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  94650 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  94653 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94660 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  94667 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  94672 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  94677 */     // GIR_Coverage, 5314,
     /*  94677 */     GIR_EraseRootFromParent_Done,
     /*  94678 */   // Label 1495: @94678
     /*  94678 */   GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(94790), // Rule ID 3781 //
     /*  94683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  94691 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  94695 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  94699 */     // MIs[1] Operand 1
     /*  94699 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  94704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  94708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94712 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  94716 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  94720 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  94724 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  94728 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  94732 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  94736 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /*  94740 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  94744 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  94746 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i32] } i32:{ *:[i32] }:$s1, (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (RLWNM:{ *:[i32] } ?:{ *:[i32] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  94746 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  94749 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /*  94753 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94758 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /*  94762 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /*  94765 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for PPC::CARRY*/0,
     /*  94768 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /*  94773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  94775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /*  94779 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  94785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  94788 */     GIR_RootConstrainSelectedInstOperands,
     /*  94789 */     // GIR_Coverage, 3781,
     /*  94789 */     GIR_EraseRootFromParent_Done,
     /*  94790 */   // Label 1496: @94790
     /*  94790 */   GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(94929), // Rule ID 3784 //
     /*  94795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  94803 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  94807 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  94811 */     // MIs[1] Operand 1
     /*  94811 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  94816 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  94820 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94824 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  94828 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  94832 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  94836 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  94840 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  94844 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  94848 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /*  94852 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  94856 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  94858 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i64] } i64:{ *:[i64] }:$s1, (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDCL:{ *:[i64] } ?:{ *:[i64] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  94858 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  94861 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /*  94865 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94870 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /*  94874 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/64,
     /*  94877 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /*  94880 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  94882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  94885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /*  94889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94894 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /*  94898 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  94901 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  94904 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94911 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  94918 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  94923 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  94928 */     // GIR_Coverage, 3784,
     /*  94928 */     GIR_EraseRootFromParent_Done,
     /*  94929 */   // Label 1497: @94929
     /*  94929 */   GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(95062), // Rule ID 3789 //
     /*  94934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  94942 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  94946 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  94950 */     // MIs[1] Operand 1
     /*  94950 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  94955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  94959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94963 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  94967 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  94971 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  94975 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  94979 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  94983 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  94987 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /*  94991 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  94995 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  94997 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i32] } i32:{ *:[i32] }:$s1, (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (RLWNM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  94997 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  95000 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /*  95004 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95009 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /*  95013 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/32,
     /*  95016 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /*  95019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  95021 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  95024 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /*  95028 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95033 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /*  95037 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /*  95041 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  95043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /*  95046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  95048 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  95051 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  95054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  95057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  95060 */     GIR_RootConstrainSelectedInstOperands,
     /*  95061 */     // GIR_Coverage, 3789,
     /*  95061 */     GIR_EraseRootFromParent_Done,
     /*  95062 */   // Label 1498: @95062
     /*  95062 */   GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(95222), // Rule ID 3792 //
     /*  95067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  95075 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  95079 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  95083 */     // MIs[1] Operand 1
     /*  95083 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  95088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  95092 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95096 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  95100 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  95104 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  95108 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  95112 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  95116 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  95120 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /*  95124 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  95128 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  95130 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i64] } i64:{ *:[i64] }:$s1, (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDCL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  95130 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  95133 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /*  95137 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95142 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /*  95146 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/64,
     /*  95149 */     GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for PPC::CARRY*/0,
     /*  95152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  95154 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  95157 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /*  95161 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95166 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /*  95170 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /*  95174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  95176 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  95179 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /*  95183 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95188 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  95191 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  95194 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  95197 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  95199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95204 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  95211 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  95216 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  95221 */     // GIR_Coverage, 3792,
     /*  95221 */     GIR_EraseRootFromParent_Done,
     /*  95222 */   // Label 1499: @95222
     /*  95222 */   GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(95291), // Rule ID 3701 //
     /*  95227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  95235 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  95239 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  95243 */     // MIs[1] Operand 1
     /*  95243 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  95248 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  95252 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95254 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1), 27:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  95254 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  95257 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /*  95261 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95266 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95270 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  95272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /*  95275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  95277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  95280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/27,
     /*  95283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  95286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  95289 */     GIR_RootConstrainSelectedInstOperands,
     /*  95290 */     // GIR_Coverage, 3701,
     /*  95290 */     GIR_EraseRootFromParent_Done,
     /*  95291 */   // Label 1500: @95291
     /*  95291 */   GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(95387), // Rule ID 3704 //
     /*  95296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  95304 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  95308 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  95312 */     // MIs[1] Operand 1
     /*  95312 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  95317 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  95321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95323 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1), 58:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  95323 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  95326 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /*  95330 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95335 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95339 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  95341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  95344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /*  95348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95353 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  95356 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/58,
     /*  95359 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  95362 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  95364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95369 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  95376 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  95381 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  95386 */     // GIR_Coverage, 3704,
     /*  95386 */     GIR_EraseRootFromParent_Done,
     /*  95387 */   // Label 1501: @95387
     /*  95387 */   GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(95494), // Rule ID 3709 //
     /*  95392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  95400 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  95404 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  95408 */     // MIs[1] Operand 1
     /*  95408 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  95413 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  95417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95419 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1), (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1)), 27:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  95419 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  95422 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /*  95426 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95431 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95435 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  95437 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  95440 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /*  95444 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95449 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  95455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  95458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /*  95462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95467 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  95470 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  95473 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  95475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /*  95478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  95480 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  95483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/27,
     /*  95486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  95489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  95492 */     GIR_RootConstrainSelectedInstOperands,
     /*  95493 */     // GIR_Coverage, 3709,
     /*  95493 */     GIR_EraseRootFromParent_Done,
     /*  95494 */   // Label 1502: @95494
     /*  95494 */   GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(95628), // Rule ID 3712 //
     /*  95499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  95507 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  95511 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  95515 */     // MIs[1] Operand 1
     /*  95515 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  95520 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  95524 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95526 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1), (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1)), 58:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  95526 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /*  95529 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /*  95533 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95538 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  95544 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  95547 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /*  95551 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95556 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95560 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  95562 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  95565 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /*  95569 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95574 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  95577 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  95580 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  95582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  95585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /*  95589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95594 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  95597 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/58,
     /*  95600 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  95603 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  95605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95610 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  95617 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  95622 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  95627 */     // GIR_Coverage, 3712,
     /*  95627 */     GIR_EraseRootFromParent_Done,
     /*  95628 */   // Label 1503: @95628
     /*  95628 */   GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(95680), // Rule ID 3717 //
     /*  95633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  95641 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  95645 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  95649 */     // MIs[1] Operand 1
     /*  95649 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /*  95654 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  95658 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95660 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETLT:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  95660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /*  95663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  95665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  95672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  95675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  95678 */     GIR_RootConstrainSelectedInstOperands,
     /*  95679 */     // GIR_Coverage, 3717,
     /*  95679 */     GIR_EraseRootFromParent_Done,
     /*  95680 */   // Label 1504: @95680
     /*  95680 */   GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(95759), // Rule ID 3720 //
     /*  95685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  95693 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  95697 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  95701 */     // MIs[1] Operand 1
     /*  95701 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /*  95706 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  95710 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95712 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETLT:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  95712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  95715 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /*  95719 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95724 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95728 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  95731 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  95734 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  95736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95741 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  95748 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  95753 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  95758 */     // GIR_Coverage, 3720,
     /*  95758 */     GIR_EraseRootFromParent_Done,
     /*  95759 */   // Label 1505: @95759
     /*  95759 */   GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(95832), // Rule ID 3725 //
     /*  95764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  95772 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  95776 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  95780 */     // MIs[1] Operand 1
     /*  95780 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  95785 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  95789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95791 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETGE:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  95791 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  95794 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /*  95798 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95803 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95807 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95811 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  95813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /*  95816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  95818 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  95821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  95824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  95827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  95830 */     GIR_RootConstrainSelectedInstOperands,
     /*  95831 */     // GIR_Coverage, 3725,
     /*  95831 */     GIR_EraseRootFromParent_Done,
     /*  95832 */   // Label 1506: @95832
     /*  95832 */   GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(95932), // Rule ID 3728 //
     /*  95837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  95845 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  95849 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  95853 */     // MIs[1] Operand 1
     /*  95853 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  95858 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  95862 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95864 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETGE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  95864 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  95867 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /*  95871 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95876 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95880 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95884 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  95886 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  95889 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /*  95893 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95898 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  95901 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  95904 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  95907 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  95909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95914 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  95921 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  95926 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  95931 */     // GIR_Coverage, 3728,
     /*  95931 */     GIR_EraseRootFromParent_Done,
     /*  95932 */   // Label 1507: @95932
     /*  95932 */   GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(96022), // Rule ID 3733 //
     /*  95937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  95945 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  95949 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  95953 */     // MIs[1] Operand 1
     /*  95953 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /*  95958 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  95962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95964 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETGT:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (ANDC:{ *:[i32] } (NEG:{ *:[i32] } ?:{ *:[i32] }:$s1), ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  95964 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  95967 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NEG),
     /*  95971 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95976 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95980 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  95982 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  95985 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::ANDC),
     /*  95989 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95994 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  95997 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96001 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  96003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /*  96006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  96008 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  96011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  96014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  96017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  96020 */     GIR_RootConstrainSelectedInstOperands,
     /*  96021 */     // GIR_Coverage, 3733,
     /*  96021 */     GIR_EraseRootFromParent_Done,
     /*  96022 */   // Label 1508: @96022
     /*  96022 */   GIM_Try, /*On fail goto*//*Label 1509*/ GIMT_Encode4(96139), // Rule ID 3736 //
     /*  96027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  96035 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  96039 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  96043 */     // MIs[1] Operand 1
     /*  96043 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /*  96048 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  96052 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96054 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETGT:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (ANDC8:{ *:[i64] } (NEG8:{ *:[i64] } ?:{ *:[i64] }:$s1), ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  96054 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  96057 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NEG8),
     /*  96061 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96066 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  96072 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  96075 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ANDC8),
     /*  96079 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96084 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  96087 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96091 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  96093 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  96096 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /*  96100 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96105 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  96108 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  96111 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  96114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  96116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96121 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  96128 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  96133 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  96138 */     // GIR_Coverage, 3736,
     /*  96138 */     GIR_EraseRootFromParent_Done,
     /*  96139 */   // Label 1509: @96139
     /*  96139 */   GIM_Try, /*On fail goto*//*Label 1510*/ GIMT_Encode4(96229), // Rule ID 3741 //
     /*  96144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  96152 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  96156 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  96160 */     // MIs[1] Operand 1
     /*  96160 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  96165 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  96169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96171 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETLE:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (ORC:{ *:[i32] } ?:{ *:[i32] }:$s1, (NEG:{ *:[i32] } ?:{ *:[i32] }:$s1)), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  96171 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  96174 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NEG),
     /*  96178 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96183 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96187 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  96189 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  96192 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::ORC),
     /*  96196 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96201 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96205 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  96208 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  96210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /*  96213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  96215 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  96218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  96221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  96224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  96227 */     GIR_RootConstrainSelectedInstOperands,
     /*  96228 */     // GIR_Coverage, 3741,
     /*  96228 */     GIR_EraseRootFromParent_Done,
     /*  96229 */   // Label 1510: @96229
     /*  96229 */   GIM_Try, /*On fail goto*//*Label 1511*/ GIMT_Encode4(96346), // Rule ID 3744 //
     /*  96234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  96242 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  96246 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  96250 */     // MIs[1] Operand 1
     /*  96250 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  96255 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  96259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96261 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETLE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (ORC8:{ *:[i64] } ?:{ *:[i64] }:$s1, (NEG8:{ *:[i64] } ?:{ *:[i64] }:$s1)), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  96261 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  96264 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NEG8),
     /*  96268 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96273 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96277 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  96279 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  96282 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ORC8),
     /*  96286 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96291 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96295 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  96298 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  96300 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  96303 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /*  96307 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96312 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  96315 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  96318 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  96321 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  96323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96328 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  96335 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  96340 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  96345 */     // GIR_Coverage, 3744,
     /*  96345 */     GIR_EraseRootFromParent_Done,
     /*  96346 */   // Label 1511: @96346
     /*  96346 */   GIM_Try, /*On fail goto*//*Label 1512*/ GIMT_Encode4(96439), // Rule ID 3749 //
     /*  96351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  96359 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  96363 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  96367 */     // MIs[1] Operand 1
     /*  96367 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /*  96372 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /*  96376 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96378 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETLT:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (AND:{ *:[i32] } ?:{ *:[i32] }:$s1, (ADDI:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] })), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  96378 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  96381 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ADDI),
     /*  96385 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96390 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96394 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /*  96397 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  96399 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  96402 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::AND),
     /*  96406 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96411 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96415 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  96418 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  96420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /*  96423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  96425 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  96428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  96431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  96434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  96437 */     GIR_RootConstrainSelectedInstOperands,
     /*  96438 */     // GIR_Coverage, 3749,
     /*  96438 */     GIR_EraseRootFromParent_Done,
     /*  96439 */   // Label 1512: @96439
     /*  96439 */   GIM_Try, /*On fail goto*//*Label 1513*/ GIMT_Encode4(96559), // Rule ID 3752 //
     /*  96444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  96452 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  96456 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  96460 */     // MIs[1] Operand 1
     /*  96460 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /*  96465 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /*  96469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96471 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETLT:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (AND8:{ *:[i64] } ?:{ *:[i64] }:$s1, (ADDI8:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i64] })), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  96471 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  96474 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::ADDI8),
     /*  96478 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96483 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96487 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /*  96490 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  96492 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  96495 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /*  96499 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96504 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96508 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  96511 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  96513 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  96516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /*  96520 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96525 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  96528 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  96531 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  96534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  96536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96541 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  96548 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  96553 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  96558 */     // GIR_Coverage, 3752,
     /*  96558 */     GIR_EraseRootFromParent_Done,
     /*  96559 */   // Label 1513: @96559
     /*  96559 */   GIM_Try, /*On fail goto*//*Label 1514*/ GIMT_Encode4(96652), // Rule ID 3757 //
     /*  96564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  96572 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  96576 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  96580 */     // MIs[1] Operand 1
     /*  96580 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  96585 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /*  96589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96591 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETGE:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (NAND:{ *:[i32] } ?:{ *:[i32] }:$s1, (ADDI:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] })), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  96591 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  96594 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ADDI),
     /*  96598 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96603 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96607 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /*  96610 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  96612 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  96615 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NAND),
     /*  96619 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96624 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96628 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  96631 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  96633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /*  96636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  96638 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  96641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  96644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  96647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  96650 */     GIR_RootConstrainSelectedInstOperands,
     /*  96651 */     // GIR_Coverage, 3757,
     /*  96651 */     GIR_EraseRootFromParent_Done,
     /*  96652 */   // Label 1514: @96652
     /*  96652 */   GIM_Try, /*On fail goto*//*Label 1515*/ GIMT_Encode4(96772), // Rule ID 3760 //
     /*  96657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  96665 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  96669 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  96673 */     // MIs[1] Operand 1
     /*  96673 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  96678 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /*  96682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96684 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETGE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (NAND8:{ *:[i64] } ?:{ *:[i64] }:$s1, (ADDI8:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i64] })), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  96684 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  96687 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::ADDI8),
     /*  96691 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96696 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96700 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /*  96703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  96705 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  96708 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NAND8),
     /*  96712 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96717 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96721 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  96724 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  96726 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  96729 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /*  96733 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96738 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  96741 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  96744 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  96747 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  96749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96754 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  96761 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  96766 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  96771 */     // GIR_Coverage, 3760,
     /*  96771 */     GIR_EraseRootFromParent_Done,
     /*  96772 */   // Label 1515: @96772
     /*  96772 */   GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(96845), // Rule ID 3765 //
     /*  96777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  96785 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  96789 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  96793 */     // MIs[1] Operand 1
     /*  96793 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /*  96798 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /*  96802 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96804 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETGT:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  96804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  96807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /*  96811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96816 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96820 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96824 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  96826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /*  96829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  96831 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  96834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  96837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  96840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  96843 */     GIR_RootConstrainSelectedInstOperands,
     /*  96844 */     // GIR_Coverage, 3765,
     /*  96844 */     GIR_EraseRootFromParent_Done,
     /*  96845 */   // Label 1516: @96845
     /*  96845 */   GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(96945), // Rule ID 3768 //
     /*  96850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  96858 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  96862 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  96866 */     // MIs[1] Operand 1
     /*  96866 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /*  96871 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /*  96875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96877 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETGT:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  96877 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  96880 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /*  96884 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96889 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96893 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96897 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  96899 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  96902 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /*  96906 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96911 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  96914 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  96917 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  96920 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  96922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96927 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  96934 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  96939 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  96944 */     // GIR_Coverage, 3768,
     /*  96944 */     GIR_EraseRootFromParent_Done,
     /*  96945 */   // Label 1517: @96945
     /*  96945 */   GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(96997), // Rule ID 3773 //
     /*  96950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  96958 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  96962 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  96966 */     // MIs[1] Operand 1
     /*  96966 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  96971 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /*  96975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96977 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETLE:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  96977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /*  96980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  96982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  96989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  96992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  96995 */     GIR_RootConstrainSelectedInstOperands,
     /*  96996 */     // GIR_Coverage, 3773,
     /*  96996 */     GIR_EraseRootFromParent_Done,
     /*  96997 */   // Label 1518: @96997
     /*  96997 */   GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(97076), // Rule ID 3776 //
     /*  97002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  97010 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  97014 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  97018 */     // MIs[1] Operand 1
     /*  97018 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  97023 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /*  97027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97029 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETLE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  97029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  97032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /*  97036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97041 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  97045 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  97048 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  97051 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  97053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97058 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  97065 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  97070 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  97075 */     // GIR_Coverage, 3776,
     /*  97075 */     GIR_EraseRootFromParent_Done,
     /*  97076 */   // Label 1519: @97076
     /*  97076 */   GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(97179), // Rule ID 3040 //
     /*  97081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  97084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  97092 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  97096 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  97100 */     // MIs[1] Operand 1
     /*  97100 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  97105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  97109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  97113 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  97117 */     // MIs[2] Operand 1
     /*  97117 */     // No operand predicates
     /*  97117 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  97119 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }))
     /*  97119 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  97122 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  97126 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97131 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  97135 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  97138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97140 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  97143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97147 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97152 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  97159 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  97164 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  97169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  97172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  97174 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97177 */     GIR_RootConstrainSelectedInstOperands,
     /*  97178 */     // GIR_Coverage, 3040,
     /*  97178 */     GIR_EraseRootFromParent_Done,
     /*  97179 */   // Label 1520: @97179
     /*  97179 */   GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(97282), // Rule ID 3056 //
     /*  97184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  97187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  97195 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  97199 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  97203 */     // MIs[1] Operand 1
     /*  97203 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  97208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  97212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  97216 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  97220 */     // MIs[2] Operand 1
     /*  97220 */     // No operand predicates
     /*  97220 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  97222 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }))
     /*  97222 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  97225 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  97229 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97234 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  97238 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  97241 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  97246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97255 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  97262 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  97267 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  97272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  97275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  97277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97280 */     GIR_RootConstrainSelectedInstOperands,
     /*  97281 */     // GIR_Coverage, 3056,
     /*  97281 */     GIR_EraseRootFromParent_Done,
     /*  97282 */   // Label 1521: @97282
     /*  97282 */   GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(97385), // Rule ID 3064 //
     /*  97287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  97290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  97298 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  97302 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  97306 */     // MIs[1] Operand 1
     /*  97306 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  97311 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  97315 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  97319 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  97323 */     // MIs[2] Operand 1
     /*  97323 */     // No operand predicates
     /*  97323 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  97325 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }))
     /*  97325 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  97328 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  97332 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97337 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  97341 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  97344 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97346 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  97349 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97353 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97358 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  97365 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  97370 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  97375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  97378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  97380 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97383 */     GIR_RootConstrainSelectedInstOperands,
     /*  97384 */     // GIR_Coverage, 3064,
     /*  97384 */     GIR_EraseRootFromParent_Done,
     /*  97385 */   // Label 1522: @97385
     /*  97385 */   GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(97488), // Rule ID 3136 //
     /*  97390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  97393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  97401 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  97405 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  97409 */     // MIs[1] Operand 1
     /*  97409 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  97414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  97418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  97422 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  97426 */     // MIs[2] Operand 1
     /*  97426 */     // No operand predicates
     /*  97426 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  97428 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }))
     /*  97428 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  97431 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  97435 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97440 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  97444 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  97447 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97449 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  97452 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97456 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97461 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  97468 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  97473 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  97478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  97481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  97483 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97486 */     GIR_RootConstrainSelectedInstOperands,
     /*  97487 */     // GIR_Coverage, 3136,
     /*  97487 */     GIR_EraseRootFromParent_Done,
     /*  97488 */   // Label 1523: @97488
     /*  97488 */   GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(97591), // Rule ID 3152 //
     /*  97493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  97496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  97504 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  97508 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  97512 */     // MIs[1] Operand 1
     /*  97512 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  97517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  97521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  97525 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  97529 */     // MIs[2] Operand 1
     /*  97529 */     // No operand predicates
     /*  97529 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  97531 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }))
     /*  97531 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  97534 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  97538 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97543 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  97547 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  97550 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97552 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  97555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97559 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97564 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  97571 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  97576 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  97581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  97584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  97586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97589 */     GIR_RootConstrainSelectedInstOperands,
     /*  97590 */     // GIR_Coverage, 3152,
     /*  97590 */     GIR_EraseRootFromParent_Done,
     /*  97591 */   // Label 1524: @97591
     /*  97591 */   GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(97694), // Rule ID 3160 //
     /*  97596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  97599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  97607 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  97611 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  97615 */     // MIs[1] Operand 1
     /*  97615 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  97620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  97624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  97628 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  97632 */     // MIs[2] Operand 1
     /*  97632 */     // No operand predicates
     /*  97632 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  97634 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }))
     /*  97634 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  97637 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  97641 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97646 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  97650 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  97653 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97655 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  97658 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97662 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97667 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  97674 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  97679 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  97684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  97687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  97689 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97692 */     GIR_RootConstrainSelectedInstOperands,
     /*  97693 */     // GIR_Coverage, 3160,
     /*  97693 */     GIR_EraseRootFromParent_Done,
     /*  97694 */   // Label 1525: @97694
     /*  97694 */   GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(97837), // Rule ID 3823 //
     /*  97699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  97702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  97710 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  97714 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  97718 */     // MIs[1] Operand 1
     /*  97718 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  97723 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  97727 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  97731 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  97735 */     // MIs[2] Operand 1
     /*  97735 */     // No operand predicates
     /*  97735 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  97737 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  97737 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  97740 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  97744 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97749 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  97753 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  97756 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97758 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  97761 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  97765 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97770 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  97773 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  97775 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  97778 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  97782 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97787 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  97790 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  97792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  97795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97804 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  97811 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  97816 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  97821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  97824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97826 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97829 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  97832 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  97835 */     GIR_RootConstrainSelectedInstOperands,
     /*  97836 */     // GIR_Coverage, 3823,
     /*  97836 */     GIR_EraseRootFromParent_Done,
     /*  97837 */   // Label 1526: @97837
     /*  97837 */   GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(97980), // Rule ID 3839 //
     /*  97842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  97845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  97853 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  97857 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  97861 */     // MIs[1] Operand 1
     /*  97861 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  97866 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  97870 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  97874 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  97878 */     // MIs[2] Operand 1
     /*  97878 */     // No operand predicates
     /*  97878 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  97880 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  97880 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  97883 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  97887 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97892 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  97896 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  97899 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97901 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  97904 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  97908 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97913 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  97916 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  97918 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  97921 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  97925 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97930 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  97933 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  97935 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  97938 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97942 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97947 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  97954 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  97959 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  97964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  97967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97972 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  97975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  97978 */     GIR_RootConstrainSelectedInstOperands,
     /*  97979 */     // GIR_Coverage, 3839,
     /*  97979 */     GIR_EraseRootFromParent_Done,
     /*  97980 */   // Label 1527: @97980
     /*  97980 */   GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(98123), // Rule ID 3847 //
     /*  97985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  97988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  97996 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  98000 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  98004 */     // MIs[1] Operand 1
     /*  98004 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  98009 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  98013 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  98017 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  98021 */     // MIs[2] Operand 1
     /*  98021 */     // No operand predicates
     /*  98021 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  98023 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  98023 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  98026 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  98030 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98035 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  98039 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  98042 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98044 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  98047 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  98051 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98056 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  98059 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  98061 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  98064 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  98068 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98073 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  98076 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  98078 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  98081 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  98085 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98090 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  98097 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  98102 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  98107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  98110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98112 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  98118 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  98121 */     GIR_RootConstrainSelectedInstOperands,
     /*  98122 */     // GIR_Coverage, 3847,
     /*  98122 */     GIR_EraseRootFromParent_Done,
     /*  98123 */   // Label 1528: @98123
     /*  98123 */   GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(98266), // Rule ID 3919 //
     /*  98128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  98131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  98139 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  98143 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  98147 */     // MIs[1] Operand 1
     /*  98147 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  98152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  98156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  98160 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  98164 */     // MIs[2] Operand 1
     /*  98164 */     // No operand predicates
     /*  98164 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  98166 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  98166 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  98169 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  98173 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98178 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  98182 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  98185 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98187 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  98190 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  98194 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98199 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  98202 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  98204 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  98207 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  98211 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98216 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  98219 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  98221 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  98224 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  98228 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98233 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  98240 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  98245 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  98250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  98253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98255 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98258 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  98261 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  98264 */     GIR_RootConstrainSelectedInstOperands,
     /*  98265 */     // GIR_Coverage, 3919,
     /*  98265 */     GIR_EraseRootFromParent_Done,
     /*  98266 */   // Label 1529: @98266
     /*  98266 */   GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(98409), // Rule ID 3935 //
     /*  98271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  98274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  98282 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  98286 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  98290 */     // MIs[1] Operand 1
     /*  98290 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  98295 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  98299 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  98303 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  98307 */     // MIs[2] Operand 1
     /*  98307 */     // No operand predicates
     /*  98307 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  98309 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  98309 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  98312 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  98316 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98321 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  98325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  98328 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98330 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  98333 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  98337 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98342 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  98345 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  98347 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  98350 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  98354 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98359 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  98362 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  98364 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  98367 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  98371 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98376 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  98383 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  98388 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  98393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  98396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98398 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98401 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  98404 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  98407 */     GIR_RootConstrainSelectedInstOperands,
     /*  98408 */     // GIR_Coverage, 3935,
     /*  98408 */     GIR_EraseRootFromParent_Done,
     /*  98409 */   // Label 1530: @98409
     /*  98409 */   GIM_Try, /*On fail goto*//*Label 1531*/ GIMT_Encode4(98552), // Rule ID 3943 //
     /*  98414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  98417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  98425 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  98429 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  98433 */     // MIs[1] Operand 1
     /*  98433 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  98438 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  98442 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  98446 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  98450 */     // MIs[2] Operand 1
     /*  98450 */     // No operand predicates
     /*  98450 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  98452 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  98452 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  98455 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  98459 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98464 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  98468 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  98471 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98473 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  98476 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  98480 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98485 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  98488 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  98490 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  98493 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  98497 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98502 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  98505 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  98507 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  98510 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  98514 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98519 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  98526 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  98531 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  98536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  98539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98541 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98544 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  98547 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  98550 */     GIR_RootConstrainSelectedInstOperands,
     /*  98551 */     // GIR_Coverage, 3943,
     /*  98551 */     GIR_EraseRootFromParent_Done,
     /*  98552 */   // Label 1531: @98552
     /*  98552 */   GIM_Try, /*On fail goto*//*Label 1532*/ GIMT_Encode4(98644), // Rule ID 3184 //
     /*  98557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  98560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  98568 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  98572 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  98576 */     // MIs[1] Operand 1
     /*  98576 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  98581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98583 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }))
     /*  98583 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  98586 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  98590 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98595 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  98599 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  98603 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  98608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  98612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98617 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  98624 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  98629 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  98634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  98637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  98639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98642 */     GIR_RootConstrainSelectedInstOperands,
     /*  98643 */     // GIR_Coverage, 3184,
     /*  98643 */     GIR_EraseRootFromParent_Done,
     /*  98644 */   // Label 1532: @98644
     /*  98644 */   GIM_Try, /*On fail goto*//*Label 1533*/ GIMT_Encode4(98736), // Rule ID 3200 //
     /*  98649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  98652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  98660 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  98664 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  98668 */     // MIs[1] Operand 1
     /*  98668 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  98673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98675 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }))
     /*  98675 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  98678 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  98682 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98687 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  98691 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  98695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98697 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  98700 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  98704 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98709 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  98716 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  98721 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  98726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  98729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  98731 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98734 */     GIR_RootConstrainSelectedInstOperands,
     /*  98735 */     // GIR_Coverage, 3200,
     /*  98735 */     GIR_EraseRootFromParent_Done,
     /*  98736 */   // Label 1533: @98736
     /*  98736 */   GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(98828), // Rule ID 3216 //
     /*  98741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  98744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  98752 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  98756 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  98760 */     // MIs[1] Operand 1
     /*  98760 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  98765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98767 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }))
     /*  98767 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  98770 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  98774 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98779 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  98783 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  98787 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98789 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  98792 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  98796 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98801 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  98808 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  98813 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  98818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  98821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  98823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98826 */     GIR_RootConstrainSelectedInstOperands,
     /*  98827 */     // GIR_Coverage, 3216,
     /*  98827 */     GIR_EraseRootFromParent_Done,
     /*  98828 */   // Label 1534: @98828
     /*  98828 */   GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(98920), // Rule ID 3232 //
     /*  98833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  98836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  98844 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  98848 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  98852 */     // MIs[1] Operand 1
     /*  98852 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /*  98857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98859 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }))
     /*  98859 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  98862 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  98866 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98871 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  98875 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  98879 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98881 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  98884 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  98888 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98893 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /*  98900 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  98905 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  98910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  98913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  98915 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98918 */     GIR_RootConstrainSelectedInstOperands,
     /*  98919 */     // GIR_Coverage, 3232,
     /*  98919 */     GIR_EraseRootFromParent_Done,
     /*  98920 */   // Label 1535: @98920
     /*  98920 */   GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(99012), // Rule ID 3240 //
     /*  98925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  98928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  98936 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  98940 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  98944 */     // MIs[1] Operand 1
     /*  98944 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  98949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98951 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }))
     /*  98951 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  98954 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  98958 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98963 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  98967 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  98971 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98973 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  98976 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  98980 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98985 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  98992 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  98997 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  99002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  99005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  99007 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99010 */     GIR_RootConstrainSelectedInstOperands,
     /*  99011 */     // GIR_Coverage, 3240,
     /*  99011 */     GIR_EraseRootFromParent_Done,
     /*  99012 */   // Label 1536: @99012
     /*  99012 */   GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(99104), // Rule ID 3256 //
     /*  99017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  99020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  99024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  99028 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  99032 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  99036 */     // MIs[1] Operand 1
     /*  99036 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  99041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99043 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }))
     /*  99043 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  99046 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  99050 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99055 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  99059 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  99063 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99065 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  99068 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  99072 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99077 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  99084 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  99089 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  99094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  99097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  99099 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99102 */     GIR_RootConstrainSelectedInstOperands,
     /*  99103 */     // GIR_Coverage, 3256,
     /*  99103 */     GIR_EraseRootFromParent_Done,
     /*  99104 */   // Label 1537: @99104
     /*  99104 */   GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(99196), // Rule ID 3272 //
     /*  99109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  99112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  99116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  99120 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  99124 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  99128 */     // MIs[1] Operand 1
     /*  99128 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  99133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99135 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }))
     /*  99135 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  99138 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  99142 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99147 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  99151 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  99155 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99157 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  99160 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  99164 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99169 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  99176 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  99181 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  99186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  99189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  99191 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99194 */     GIR_RootConstrainSelectedInstOperands,
     /*  99195 */     // GIR_Coverage, 3272,
     /*  99195 */     GIR_EraseRootFromParent_Done,
     /*  99196 */   // Label 1538: @99196
     /*  99196 */   GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(99288), // Rule ID 3288 //
     /*  99201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  99204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  99208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  99212 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  99216 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  99220 */     // MIs[1] Operand 1
     /*  99220 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /*  99225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99227 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }))
     /*  99227 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  99230 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  99234 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99239 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  99243 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  99247 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99249 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  99252 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  99256 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99261 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /*  99268 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  99273 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  99278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  99281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  99283 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99286 */     GIR_RootConstrainSelectedInstOperands,
     /*  99287 */     // GIR_Coverage, 3288,
     /*  99287 */     GIR_EraseRootFromParent_Done,
     /*  99288 */   // Label 1539: @99288
     /*  99288 */   GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(99380), // Rule ID 3296 //
     /*  99293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  99296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  99300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  99304 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  99308 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  99312 */     // MIs[1] Operand 1
     /*  99312 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  99317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99319 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }))
     /*  99319 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  99322 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  99326 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99331 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  99335 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  99339 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  99344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  99348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99353 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  99360 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  99365 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  99370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  99373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  99375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99378 */     GIR_RootConstrainSelectedInstOperands,
     /*  99379 */     // GIR_Coverage, 3296,
     /*  99379 */     GIR_EraseRootFromParent_Done,
     /*  99380 */   // Label 1540: @99380
     /*  99380 */   GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(99472), // Rule ID 3312 //
     /*  99385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  99388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  99392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  99396 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  99400 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  99404 */     // MIs[1] Operand 1
     /*  99404 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  99409 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99411 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }))
     /*  99411 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  99414 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  99418 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99423 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  99427 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  99431 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99433 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  99436 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  99440 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99445 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  99452 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  99457 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  99462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  99465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  99467 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99470 */     GIR_RootConstrainSelectedInstOperands,
     /*  99471 */     // GIR_Coverage, 3312,
     /*  99471 */     GIR_EraseRootFromParent_Done,
     /*  99472 */   // Label 1541: @99472
     /*  99472 */   GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(99564), // Rule ID 3328 //
     /*  99477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  99480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  99484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  99488 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  99492 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  99496 */     // MIs[1] Operand 1
     /*  99496 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  99501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99503 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }))
     /*  99503 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  99506 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  99510 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99515 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  99519 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  99523 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99525 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  99528 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  99532 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99537 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  99544 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  99549 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  99554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  99557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  99559 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99562 */     GIR_RootConstrainSelectedInstOperands,
     /*  99563 */     // GIR_Coverage, 3328,
     /*  99563 */     GIR_EraseRootFromParent_Done,
     /*  99564 */   // Label 1542: @99564
     /*  99564 */   GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(99656), // Rule ID 3344 //
     /*  99569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  99572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  99576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  99580 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  99584 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  99588 */     // MIs[1] Operand 1
     /*  99588 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /*  99593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99595 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }))
     /*  99595 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  99598 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  99602 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99607 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  99611 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  99615 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99617 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  99620 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  99624 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99629 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /*  99636 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  99641 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  99646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  99649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  99651 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99654 */     GIR_RootConstrainSelectedInstOperands,
     /*  99655 */     // GIR_Coverage, 3344,
     /*  99655 */     GIR_EraseRootFromParent_Done,
     /*  99656 */   // Label 1543: @99656
     /*  99656 */   GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(99788), // Rule ID 4028 //
     /*  99661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  99664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  99668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  99672 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  99676 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  99680 */     // MIs[1] Operand 1
     /*  99680 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  99685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99687 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  99687 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  99690 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  99694 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99699 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  99703 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  99707 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99709 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  99712 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  99716 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99721 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  99724 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  99726 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  99729 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  99733 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99738 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  99741 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  99743 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  99746 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  99750 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99755 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  99762 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  99767 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  99772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  99775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99777 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99780 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  99783 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  99786 */     GIR_RootConstrainSelectedInstOperands,
     /*  99787 */     // GIR_Coverage, 4028,
     /*  99787 */     GIR_EraseRootFromParent_Done,
     /*  99788 */   // Label 1544: @99788
     /*  99788 */   GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(99920), // Rule ID 4060 //
     /*  99793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  99796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  99800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  99804 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  99808 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  99812 */     // MIs[1] Operand 1
     /*  99812 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  99817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99819 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  99819 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  99822 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  99826 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99831 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  99835 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  99839 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99841 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  99844 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  99848 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99853 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  99856 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  99858 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  99861 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  99865 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99870 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  99873 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  99875 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  99878 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  99882 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99887 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  99894 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  99899 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  99904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  99907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99909 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99912 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  99915 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  99918 */     GIR_RootConstrainSelectedInstOperands,
     /*  99919 */     // GIR_Coverage, 4060,
     /*  99919 */     GIR_EraseRootFromParent_Done,
     /*  99920 */   // Label 1545: @99920
     /*  99920 */   GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(100052), // Rule ID 4092 //
     /*  99925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  99928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  99932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  99936 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  99940 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  99944 */     // MIs[1] Operand 1
     /*  99944 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  99949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99951 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  99951 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  99954 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  99958 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99963 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  99967 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  99971 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99973 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  99976 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  99980 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99985 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  99988 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  99990 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  99993 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  99997 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100002 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 100005 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 100007 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 100010 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 100014 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100019 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 100026 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 100031 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 100036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 100039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100041 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100044 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100047 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 100050 */     GIR_RootConstrainSelectedInstOperands,
     /* 100051 */     // GIR_Coverage, 4092,
     /* 100051 */     GIR_EraseRootFromParent_Done,
     /* 100052 */   // Label 1546: @100052
     /* 100052 */   GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(100184), // Rule ID 4124 //
     /* 100057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 100060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 100068 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 100072 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 100076 */     // MIs[1] Operand 1
     /* 100076 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 100081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100083 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 100083 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 100086 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 100090 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100095 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 100099 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 100103 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100105 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 100108 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100112 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100117 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 100120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 100122 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 100125 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100129 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100134 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 100137 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 100139 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 100142 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 100146 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100151 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 100158 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 100163 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 100168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 100171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100176 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100179 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 100182 */     GIR_RootConstrainSelectedInstOperands,
     /* 100183 */     // GIR_Coverage, 4124,
     /* 100183 */     GIR_EraseRootFromParent_Done,
     /* 100184 */   // Label 1547: @100184
     /* 100184 */   GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(100316), // Rule ID 4140 //
     /* 100189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 100192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 100200 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 100204 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 100208 */     // MIs[1] Operand 1
     /* 100208 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 100213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100215 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 100215 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 100218 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 100222 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100227 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 100231 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 100235 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100237 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 100240 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100244 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100249 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 100252 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 100254 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 100257 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100261 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100266 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 100269 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 100271 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 100274 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 100278 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100283 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 100290 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 100295 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 100300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 100303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100305 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100308 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100311 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 100314 */     GIR_RootConstrainSelectedInstOperands,
     /* 100315 */     // GIR_Coverage, 4140,
     /* 100315 */     GIR_EraseRootFromParent_Done,
     /* 100316 */   // Label 1548: @100316
     /* 100316 */   GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(100448), // Rule ID 4172 //
     /* 100321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 100324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 100332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 100336 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 100340 */     // MIs[1] Operand 1
     /* 100340 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 100345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100347 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 100347 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 100350 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 100354 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100359 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 100363 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 100367 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100369 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 100372 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100376 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100381 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 100384 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 100386 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 100389 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100393 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100398 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 100401 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 100403 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 100406 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 100410 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100415 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 100422 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 100427 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 100432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 100435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100437 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100440 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 100446 */     GIR_RootConstrainSelectedInstOperands,
     /* 100447 */     // GIR_Coverage, 4172,
     /* 100447 */     GIR_EraseRootFromParent_Done,
     /* 100448 */   // Label 1549: @100448
     /* 100448 */   GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(100580), // Rule ID 4204 //
     /* 100453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 100456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 100464 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 100468 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 100472 */     // MIs[1] Operand 1
     /* 100472 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 100477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100479 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 100479 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 100482 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 100486 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100491 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 100495 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 100499 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100501 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 100504 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100508 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100513 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 100516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 100518 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 100521 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100525 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100530 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 100533 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 100535 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 100538 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 100542 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100547 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 100554 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 100559 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 100564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 100567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100569 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100572 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 100578 */     GIR_RootConstrainSelectedInstOperands,
     /* 100579 */     // GIR_Coverage, 4204,
     /* 100579 */     GIR_EraseRootFromParent_Done,
     /* 100580 */   // Label 1550: @100580
     /* 100580 */   GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(100712), // Rule ID 4236 //
     /* 100585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 100588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 100596 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 100600 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 100604 */     // MIs[1] Operand 1
     /* 100604 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 100609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100611 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 100611 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 100614 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 100618 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100623 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 100627 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 100631 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100633 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 100636 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100640 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100645 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 100648 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 100650 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 100653 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100657 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100662 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 100665 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 100667 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 100670 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 100674 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100679 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 100686 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 100691 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 100696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 100699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100701 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100704 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100707 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 100710 */     GIR_RootConstrainSelectedInstOperands,
     /* 100711 */     // GIR_Coverage, 4236,
     /* 100711 */     GIR_EraseRootFromParent_Done,
     /* 100712 */   // Label 1551: @100712
     /* 100712 */   GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(100844), // Rule ID 4266 //
     /* 100717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 100720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 100728 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 100732 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 100736 */     // MIs[1] Operand 1
     /* 100736 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 100741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100743 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 100743 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 100746 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 100750 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100755 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 100759 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 100763 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100765 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 100768 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100772 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100777 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 100780 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 100782 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 100785 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100789 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100794 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 100797 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 100799 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 100802 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 100806 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100811 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 100818 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 100823 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 100828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 100831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100833 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100836 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100839 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 100842 */     GIR_RootConstrainSelectedInstOperands,
     /* 100843 */     // GIR_Coverage, 4266,
     /* 100843 */     GIR_EraseRootFromParent_Done,
     /* 100844 */   // Label 1552: @100844
     /* 100844 */   GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(100976), // Rule ID 4298 //
     /* 100849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 100852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 100860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 100864 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 100868 */     // MIs[1] Operand 1
     /* 100868 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 100873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100875 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 100875 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 100878 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 100882 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100887 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 100891 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 100895 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100897 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 100900 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100904 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100909 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 100912 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 100914 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 100917 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100921 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100926 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 100929 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 100931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 100934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 100938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100943 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 100950 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 100955 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 100960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 100963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100965 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100968 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100971 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 100974 */     GIR_RootConstrainSelectedInstOperands,
     /* 100975 */     // GIR_Coverage, 4298,
     /* 100975 */     GIR_EraseRootFromParent_Done,
     /* 100976 */   // Label 1553: @100976
     /* 100976 */   GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(101108), // Rule ID 4330 //
     /* 100981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 100984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 100992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 100996 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 101000 */     // MIs[1] Operand 1
     /* 101000 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 101005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101007 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 101007 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 101010 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 101014 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101019 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 101023 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 101027 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101029 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 101032 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101036 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101041 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 101044 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 101046 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 101049 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101053 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101058 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 101061 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 101063 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 101066 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 101070 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101075 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 101082 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 101087 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 101092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 101095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101097 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101100 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 101103 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 101106 */     GIR_RootConstrainSelectedInstOperands,
     /* 101107 */     // GIR_Coverage, 4330,
     /* 101107 */     GIR_EraseRootFromParent_Done,
     /* 101108 */   // Label 1554: @101108
     /* 101108 */   GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(101240), // Rule ID 4362 //
     /* 101113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 101116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 101124 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 101128 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 101132 */     // MIs[1] Operand 1
     /* 101132 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 101137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101139 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 101139 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 101142 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 101146 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101151 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 101155 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 101159 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101161 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 101164 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101168 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101173 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 101176 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 101178 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 101181 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101185 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101190 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 101193 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 101195 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 101198 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 101202 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101207 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 101214 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 101219 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 101224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 101227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101229 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101232 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 101235 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 101238 */     GIR_RootConstrainSelectedInstOperands,
     /* 101239 */     // GIR_Coverage, 4362,
     /* 101239 */     GIR_EraseRootFromParent_Done,
     /* 101240 */   // Label 1555: @101240
     /* 101240 */   GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(101372), // Rule ID 4593 //
     /* 101245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 101248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 101256 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 101260 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 101264 */     // MIs[1] Operand 1
     /* 101264 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 101269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101271 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPLT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 101271 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 101274 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPLT),
     /* 101278 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101283 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 101287 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 101291 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101293 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 101296 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101300 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101305 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 101308 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 101310 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 101313 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101317 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101322 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 101325 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 101327 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 101330 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 101334 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101339 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 101346 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 101351 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 101356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 101359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101361 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101364 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 101367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 101370 */     GIR_RootConstrainSelectedInstOperands,
     /* 101371 */     // GIR_Coverage, 4593,
     /* 101371 */     GIR_EraseRootFromParent_Done,
     /* 101372 */   // Label 1556: @101372
     /* 101372 */   GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(101504), // Rule ID 4625 //
     /* 101377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 101380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 101388 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 101392 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 101396 */     // MIs[1] Operand 1
     /* 101396 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 101401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101403 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPGT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 101403 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 101406 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPGT),
     /* 101410 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101415 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 101419 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 101423 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101425 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 101428 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101432 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101437 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 101440 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 101442 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 101445 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101449 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101454 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 101457 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 101459 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 101462 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 101466 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101471 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 101478 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 101483 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 101488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 101491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101493 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101496 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 101499 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 101502 */     GIR_RootConstrainSelectedInstOperands,
     /* 101503 */     // GIR_Coverage, 4625,
     /* 101503 */     GIR_EraseRootFromParent_Done,
     /* 101504 */   // Label 1557: @101504
     /* 101504 */   GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(101636), // Rule ID 4657 //
     /* 101509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 101512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 101520 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 101524 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 101528 */     // MIs[1] Operand 1
     /* 101528 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 101533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101535 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPEQ:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 101535 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 101538 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPEQ),
     /* 101542 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101547 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 101551 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 101555 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101557 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 101560 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101564 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101569 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 101572 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 101574 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 101577 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101581 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101586 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 101589 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 101591 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 101594 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 101598 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101603 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 101610 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 101615 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 101620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 101623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101625 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101628 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 101631 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 101634 */     GIR_RootConstrainSelectedInstOperands,
     /* 101635 */     // GIR_Coverage, 4657,
     /* 101635 */     GIR_EraseRootFromParent_Done,
     /* 101636 */   // Label 1558: @101636
     /* 101636 */   GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(101768), // Rule ID 4701 //
     /* 101641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 101644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 101652 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 101656 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 101660 */     // MIs[1] Operand 1
     /* 101660 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 101665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101667 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPLT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 101667 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 101670 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPLT),
     /* 101674 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101679 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 101683 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 101687 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101689 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 101692 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101696 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101701 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 101704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 101706 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 101709 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101713 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101718 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 101721 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 101723 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 101726 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 101730 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101735 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 101742 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 101747 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 101752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 101755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101757 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101760 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 101763 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 101766 */     GIR_RootConstrainSelectedInstOperands,
     /* 101767 */     // GIR_Coverage, 4701,
     /* 101767 */     GIR_EraseRootFromParent_Done,
     /* 101768 */   // Label 1559: @101768
     /* 101768 */   GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(101900), // Rule ID 4733 //
     /* 101773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 101776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 101784 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 101788 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 101792 */     // MIs[1] Operand 1
     /* 101792 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 101797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101799 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPGT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 101799 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 101802 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPGT),
     /* 101806 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101811 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 101815 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 101819 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101821 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 101824 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101828 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101833 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 101836 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 101838 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 101841 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101845 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101850 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 101853 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 101855 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 101858 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 101862 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101867 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 101874 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 101879 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 101884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 101887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101889 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101892 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 101895 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 101898 */     GIR_RootConstrainSelectedInstOperands,
     /* 101899 */     // GIR_Coverage, 4733,
     /* 101899 */     GIR_EraseRootFromParent_Done,
     /* 101900 */   // Label 1560: @101900
     /* 101900 */   GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(102032), // Rule ID 4765 //
     /* 101905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 101908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 101916 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 101920 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 101924 */     // MIs[1] Operand 1
     /* 101924 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 101929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101931 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPEQ:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 101931 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 101934 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPEQ),
     /* 101938 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101943 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 101947 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 101951 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101953 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 101956 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101960 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101965 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 101968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 101970 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 101973 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101977 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101982 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 101985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 101987 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 101990 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 101994 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101999 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 102006 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 102011 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 102016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 102019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102021 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102024 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 102027 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 102030 */     GIR_RootConstrainSelectedInstOperands,
     /* 102031 */     // GIR_Coverage, 4765,
     /* 102031 */     GIR_EraseRootFromParent_Done,
     /* 102032 */   // Label 1561: @102032
     /* 102032 */   GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(102124), // Rule ID 2986 //
     /* 102037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 102040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 102048 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 102052 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 102056 */     // MIs[1] Operand 1
     /* 102056 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 102061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102063 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 102063 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 102066 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 102070 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102075 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 102079 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 102083 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102085 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 102088 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 102092 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102097 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 102104 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 102109 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 102114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 102117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 102119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102122 */     GIR_RootConstrainSelectedInstOperands,
     /* 102123 */     // GIR_Coverage, 2986,
     /* 102123 */     GIR_EraseRootFromParent_Done,
     /* 102124 */   // Label 1562: @102124
     /* 102124 */   GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(102216), // Rule ID 3000 //
     /* 102129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 102132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 102140 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 102144 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 102148 */     // MIs[1] Operand 1
     /* 102148 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 102153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102155 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 102155 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 102158 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 102162 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102167 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 102171 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 102175 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102177 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 102180 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 102184 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102189 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 102196 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 102201 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 102206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 102209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 102211 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102214 */     GIR_RootConstrainSelectedInstOperands,
     /* 102215 */     // GIR_Coverage, 3000,
     /* 102215 */     GIR_EraseRootFromParent_Done,
     /* 102216 */   // Label 1563: @102216
     /* 102216 */   GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(102308), // Rule ID 3008 //
     /* 102221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 102224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 102232 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 102236 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 102240 */     // MIs[1] Operand 1
     /* 102240 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 102245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102247 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 102247 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 102250 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 102254 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102259 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 102263 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 102267 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102269 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 102272 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 102276 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102281 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 102288 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 102293 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 102298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 102301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 102303 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102306 */     GIR_RootConstrainSelectedInstOperands,
     /* 102307 */     // GIR_Coverage, 3008,
     /* 102307 */     GIR_EraseRootFromParent_Done,
     /* 102308 */   // Label 1564: @102308
     /* 102308 */   GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(102400), // Rule ID 3016 //
     /* 102313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 102316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 102324 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 102328 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 102332 */     // MIs[1] Operand 1
     /* 102332 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 102337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102339 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 102339 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 102342 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 102346 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102351 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 102355 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 102359 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 102364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 102368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102373 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 102380 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 102385 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 102390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 102393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 102395 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102398 */     GIR_RootConstrainSelectedInstOperands,
     /* 102399 */     // GIR_Coverage, 3016,
     /* 102399 */     GIR_EraseRootFromParent_Done,
     /* 102400 */   // Label 1565: @102400
     /* 102400 */   GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(102492), // Rule ID 3024 //
     /* 102405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 102408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 102416 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 102420 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 102424 */     // MIs[1] Operand 1
     /* 102424 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 102429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102431 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }))
     /* 102431 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 102434 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 102438 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102443 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 102447 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 102451 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102453 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 102456 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 102460 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102465 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 102472 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 102477 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 102482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 102485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 102487 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102490 */     GIR_RootConstrainSelectedInstOperands,
     /* 102491 */     // GIR_Coverage, 3024,
     /* 102491 */     GIR_EraseRootFromParent_Done,
     /* 102492 */   // Label 1566: @102492
     /* 102492 */   GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(102584), // Rule ID 3088 //
     /* 102497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 102500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 102508 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 102512 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 102516 */     // MIs[1] Operand 1
     /* 102516 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 102521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102523 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 102523 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 102526 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 102530 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102535 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 102539 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 102543 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102545 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 102548 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 102552 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102557 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 102564 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 102569 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 102574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 102577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 102579 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102582 */     GIR_RootConstrainSelectedInstOperands,
     /* 102583 */     // GIR_Coverage, 3088,
     /* 102583 */     GIR_EraseRootFromParent_Done,
     /* 102584 */   // Label 1567: @102584
     /* 102584 */   GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(102676), // Rule ID 3096 //
     /* 102589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 102592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 102600 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 102604 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 102608 */     // MIs[1] Operand 1
     /* 102608 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 102613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102615 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 102615 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 102618 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 102622 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102627 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 102631 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 102635 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102637 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 102640 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 102644 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102649 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 102656 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 102661 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 102666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 102669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 102671 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102674 */     GIR_RootConstrainSelectedInstOperands,
     /* 102675 */     // GIR_Coverage, 3096,
     /* 102675 */     GIR_EraseRootFromParent_Done,
     /* 102676 */   // Label 1568: @102676
     /* 102676 */   GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(102768), // Rule ID 3104 //
     /* 102681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 102684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 102692 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 102696 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 102700 */     // MIs[1] Operand 1
     /* 102700 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 102705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102707 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 102707 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 102710 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 102714 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102719 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 102723 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 102727 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102729 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 102732 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 102736 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102741 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 102748 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 102753 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 102758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 102761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 102763 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102766 */     GIR_RootConstrainSelectedInstOperands,
     /* 102767 */     // GIR_Coverage, 3104,
     /* 102767 */     GIR_EraseRootFromParent_Done,
     /* 102768 */   // Label 1569: @102768
     /* 102768 */   GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(102860), // Rule ID 3112 //
     /* 102773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 102776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 102784 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 102788 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 102792 */     // MIs[1] Operand 1
     /* 102792 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 102797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102799 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 102799 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 102802 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 102806 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102811 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 102815 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 102819 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102821 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 102824 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 102828 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102833 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 102840 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 102845 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 102850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 102853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 102855 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102858 */     GIR_RootConstrainSelectedInstOperands,
     /* 102859 */     // GIR_Coverage, 3112,
     /* 102859 */     GIR_EraseRootFromParent_Done,
     /* 102860 */   // Label 1570: @102860
     /* 102860 */   GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(102952), // Rule ID 3120 //
     /* 102865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 102868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 102876 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 102880 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 102884 */     // MIs[1] Operand 1
     /* 102884 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 102889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102891 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }))
     /* 102891 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 102894 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 102898 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102903 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 102907 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 102911 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102913 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 102916 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 102920 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102925 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 102932 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 102937 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 102942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 102945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 102947 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102950 */     GIR_RootConstrainSelectedInstOperands,
     /* 102951 */     // GIR_Coverage, 3120,
     /* 102951 */     GIR_EraseRootFromParent_Done,
     /* 102952 */   // Label 1571: @102952
     /* 102952 */   GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(103084), // Rule ID 3871 //
     /* 102957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 102960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 102968 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 102972 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 102976 */     // MIs[1] Operand 1
     /* 102976 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 102981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102983 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 102983 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 102986 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 102990 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102995 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 102999 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 103003 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103005 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 103008 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103012 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103017 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 103020 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 103022 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 103025 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103029 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103034 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 103037 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 103039 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 103042 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 103046 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103051 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 103058 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 103063 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 103068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 103071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103073 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103076 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 103079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 103082 */     GIR_RootConstrainSelectedInstOperands,
     /* 103083 */     // GIR_Coverage, 3871,
     /* 103083 */     GIR_EraseRootFromParent_Done,
     /* 103084 */   // Label 1572: @103084
     /* 103084 */   GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(103216), // Rule ID 3879 //
     /* 103089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 103092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 103100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 103104 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 103108 */     // MIs[1] Operand 1
     /* 103108 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 103113 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103115 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 103115 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 103118 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 103122 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103127 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 103131 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 103135 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103137 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 103140 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103144 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103149 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 103152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 103154 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 103157 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103161 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103166 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 103169 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 103171 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 103174 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 103178 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103183 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 103190 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 103195 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 103200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 103203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103205 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 103211 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 103214 */     GIR_RootConstrainSelectedInstOperands,
     /* 103215 */     // GIR_Coverage, 3879,
     /* 103215 */     GIR_EraseRootFromParent_Done,
     /* 103216 */   // Label 1573: @103216
     /* 103216 */   GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(103348), // Rule ID 3887 //
     /* 103221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 103224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 103232 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 103236 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 103240 */     // MIs[1] Operand 1
     /* 103240 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 103245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103247 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 103247 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 103250 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 103254 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103259 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 103263 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 103267 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103269 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 103272 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103276 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103281 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 103284 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 103286 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 103289 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103293 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103298 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 103301 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 103303 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 103306 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 103310 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103315 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 103322 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 103327 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 103332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 103335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103337 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103340 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 103343 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 103346 */     GIR_RootConstrainSelectedInstOperands,
     /* 103347 */     // GIR_Coverage, 3887,
     /* 103347 */     GIR_EraseRootFromParent_Done,
     /* 103348 */   // Label 1574: @103348
     /* 103348 */   GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(103480), // Rule ID 3895 //
     /* 103353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 103356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 103364 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 103368 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 103372 */     // MIs[1] Operand 1
     /* 103372 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 103377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103379 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 103379 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 103382 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 103386 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103391 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 103395 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 103399 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103401 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 103404 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103408 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103413 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 103416 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 103418 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 103421 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103425 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103430 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 103433 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 103435 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 103438 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 103442 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103447 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 103454 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 103459 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 103464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 103467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103472 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 103475 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 103478 */     GIR_RootConstrainSelectedInstOperands,
     /* 103479 */     // GIR_Coverage, 3895,
     /* 103479 */     GIR_EraseRootFromParent_Done,
     /* 103480 */   // Label 1575: @103480
     /* 103480 */   GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(103612), // Rule ID 3903 //
     /* 103485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 103488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 103496 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 103500 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 103504 */     // MIs[1] Operand 1
     /* 103504 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 103509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103511 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 103511 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 103514 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 103518 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103523 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 103527 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 103531 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103533 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 103536 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103540 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103545 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 103548 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 103550 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 103553 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103557 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103562 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 103565 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 103567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 103570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 103574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103579 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 103586 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 103591 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 103596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 103599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103604 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 103607 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 103610 */     GIR_RootConstrainSelectedInstOperands,
     /* 103611 */     // GIR_Coverage, 3903,
     /* 103611 */     GIR_EraseRootFromParent_Done,
     /* 103612 */   // Label 1576: @103612
     /* 103612 */   GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(103744), // Rule ID 3967 //
     /* 103617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 103620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 103628 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 103632 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 103636 */     // MIs[1] Operand 1
     /* 103636 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 103641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103643 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 103643 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 103646 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 103650 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103655 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 103659 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 103663 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103665 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 103668 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103672 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103677 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 103680 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 103682 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 103685 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103689 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103694 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 103697 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 103699 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 103702 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 103706 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103711 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 103718 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 103723 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 103728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 103731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103733 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103736 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 103739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 103742 */     GIR_RootConstrainSelectedInstOperands,
     /* 103743 */     // GIR_Coverage, 3967,
     /* 103743 */     GIR_EraseRootFromParent_Done,
     /* 103744 */   // Label 1577: @103744
     /* 103744 */   GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(103876), // Rule ID 3975 //
     /* 103749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 103752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 103760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 103764 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 103768 */     // MIs[1] Operand 1
     /* 103768 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 103773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103775 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 103775 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 103778 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 103782 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103787 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 103791 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 103795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103797 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 103800 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103804 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103809 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 103812 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 103814 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 103817 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103821 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103826 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 103829 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 103831 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 103834 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 103838 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103843 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 103850 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 103855 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 103860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 103863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103865 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103868 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 103871 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 103874 */     GIR_RootConstrainSelectedInstOperands,
     /* 103875 */     // GIR_Coverage, 3975,
     /* 103875 */     GIR_EraseRootFromParent_Done,
     /* 103876 */   // Label 1578: @103876
     /* 103876 */   GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(104008), // Rule ID 3983 //
     /* 103881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 103884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 103892 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 103896 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 103900 */     // MIs[1] Operand 1
     /* 103900 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 103905 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103907 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 103907 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 103910 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 103914 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103919 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 103923 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 103927 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103929 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 103932 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103936 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103941 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 103944 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 103946 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 103949 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103953 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103958 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 103961 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 103963 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 103966 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 103970 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103975 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 103982 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 103987 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 103992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 103995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103997 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104000 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 104003 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 104006 */     GIR_RootConstrainSelectedInstOperands,
     /* 104007 */     // GIR_Coverage, 3983,
     /* 104007 */     GIR_EraseRootFromParent_Done,
     /* 104008 */   // Label 1579: @104008
     /* 104008 */   GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(104140), // Rule ID 3991 //
     /* 104013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 104016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 104024 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 104028 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 104032 */     // MIs[1] Operand 1
     /* 104032 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 104037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104039 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 104039 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 104042 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 104046 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104051 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 104055 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 104059 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104061 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 104064 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 104068 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104073 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 104076 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 104078 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 104081 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 104085 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104090 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 104093 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 104095 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 104098 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 104102 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104107 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 104114 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 104119 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 104124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 104127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104129 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104132 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 104135 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 104138 */     GIR_RootConstrainSelectedInstOperands,
     /* 104139 */     // GIR_Coverage, 3991,
     /* 104139 */     GIR_EraseRootFromParent_Done,
     /* 104140 */   // Label 1580: @104140
     /* 104140 */   GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(104272), // Rule ID 3999 //
     /* 104145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 104148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 104156 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 104160 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 104164 */     // MIs[1] Operand 1
     /* 104164 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 104169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104171 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 104171 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 104174 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 104178 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104183 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 104187 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 104191 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104193 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 104196 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 104200 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104205 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 104208 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 104210 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 104213 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 104217 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104222 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 104225 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 104227 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 104230 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 104234 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104239 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 104246 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 104251 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 104256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 104259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104261 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104264 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 104267 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 104270 */     GIR_RootConstrainSelectedInstOperands,
     /* 104271 */     // GIR_Coverage, 3999,
     /* 104271 */     GIR_EraseRootFromParent_Done,
     /* 104272 */   // Label 1581: @104272
     /* 104272 */   GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(104287), // Rule ID 2992 //
     /* 104277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 104280 */     // (anyext:{ *:[i32] } i1:{ *:[i1] }:$in)  =>  (SETBC:{ *:[i32] } ?:{ *:[i1] }:$in)
     /* 104280 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SETBC),
     /* 104285 */     GIR_RootConstrainSelectedInstOperands,
     /* 104286 */     // GIR_Coverage, 2992,
     /* 104286 */     GIR_Done,
     /* 104287 */   // Label 1582: @104287
     /* 104287 */   GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(104341), // Rule ID 3677 //
     /* 104292 */     // (anyext:{ *:[i32] } i1:{ *:[i1] }:$in)  =>  (SELECT_I4:{ *:[i32] } ?:{ *:[i1] }:$in, (LI:{ *:[i32] } 1:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }))
     /* 104292 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 104295 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 104299 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104304 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 104307 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104309 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 104312 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 104316 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104321 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 104324 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 104329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104331 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 104333 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 104339 */     GIR_RootConstrainSelectedInstOperands,
     /* 104340 */     // GIR_Coverage, 3677,
     /* 104340 */     GIR_EraseRootFromParent_Done,
     /* 104341 */   // Label 1583: @104341
     /* 104341 */   GIM_Reject,
     /* 104342 */ // Label 1491: @104342
     /* 104342 */ GIM_Reject,
     /* 104343 */ // Label 1489: @104343
     /* 104343 */ GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(114857),
     /* 104348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 104351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 104355 */   GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(104464), // Rule ID 5304 //
     /* 104360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 104368 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 104372 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 104376 */     // MIs[1] Operand 1
     /* 104376 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 104381 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 104385 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 104389 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 104393 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 104397 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 104401 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 104405 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 104409 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 104413 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 104417 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 104421 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 104423 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa), i64:{ *:[i64] }:$s1), 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (RLDCL:{ *:[i64] } ?:{ *:[i64] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] })
     /* 104423 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 104426 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 104430 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104435 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 104439 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/64,
     /* 104442 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for PPC::CARRY*/0,
     /* 104445 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 104450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 104452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 104456 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 104462 */     GIR_RootConstrainSelectedInstOperands,
     /* 104463 */     // GIR_Coverage, 5304,
     /* 104463 */     GIR_EraseRootFromParent_Done,
     /* 104464 */   // Label 1585: @104464
     /* 104464 */   GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(104627), // Rule ID 5305 //
     /* 104469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 104477 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 104481 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 104485 */     // MIs[1] Operand 1
     /* 104485 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 104490 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 104494 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 104498 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 104502 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 104506 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 104510 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 104514 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 104518 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 104522 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 104526 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 104530 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 104532 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa), i32:{ *:[i32] }:$s1), 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWNM:{ *:[i32] } ?:{ *:[i32] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 104532 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 104535 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 104539 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104544 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 104548 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/32,
     /* 104551 */     GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for PPC::CARRY*/0,
     /* 104554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 104556 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 104559 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 104563 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104568 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 104572 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 104575 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 104578 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 104581 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104583 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 104586 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104590 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104595 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 104600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104602 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104605 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 104608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 104611 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 104616 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 104621 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 104626 */     // GIR_Coverage, 5305,
     /* 104626 */     GIR_EraseRootFromParent_Done,
     /* 104627 */   // Label 1586: @104627
     /* 104627 */   GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(104757), // Rule ID 5312 //
     /* 104632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 104640 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 104644 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 104648 */     // MIs[1] Operand 1
     /* 104648 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 104653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 104657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 104661 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 104665 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 104669 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 104673 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 104677 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 104681 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 104685 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 104689 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 104693 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 104695 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa), i64:{ *:[i64] }:$s1), 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (RLDCL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] })
     /* 104695 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 104698 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 104702 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104707 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 104711 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/64,
     /* 104714 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /* 104717 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104719 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 104722 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 104726 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104731 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 104735 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 104739 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 104744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 104746 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104749 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 104752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 104755 */     GIR_RootConstrainSelectedInstOperands,
     /* 104756 */     // GIR_Coverage, 5312,
     /* 104756 */     GIR_EraseRootFromParent_Done,
     /* 104757 */   // Label 1587: @104757
     /* 104757 */   GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(104941), // Rule ID 5313 //
     /* 104762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 104770 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 104774 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 104778 */     // MIs[1] Operand 1
     /* 104778 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 104783 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 104787 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 104791 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 104795 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 104799 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 104803 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 104807 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 104811 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 104815 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 104819 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 104823 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 104825 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa), i32:{ *:[i32] }:$s1), 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWNM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 104825 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 104828 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 104832 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104837 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 104841 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/32,
     /* 104844 */     GIR_SetImplicitDefDead, /*InsnID*/4, /*OpIdx for PPC::CARRY*/0,
     /* 104847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 104849 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 104852 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 104856 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104861 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 104865 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 104869 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 104871 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 104874 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 104878 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104883 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 104886 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 104889 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 104892 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 104895 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104897 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 104900 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104904 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104909 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 104914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104916 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104919 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 104922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 104925 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 104930 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 104935 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 104940 */     // GIR_Coverage, 5313,
     /* 104940 */     GIR_EraseRootFromParent_Done,
     /* 104941 */   // Label 1588: @104941
     /* 104941 */   GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(105050), // Rule ID 3782 //
     /* 104946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 104954 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 104958 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 104962 */     // MIs[1] Operand 1
     /* 104962 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 104967 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 104971 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 104975 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 104979 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 104983 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 104987 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 104991 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 104995 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 104999 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 105003 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 105007 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 105009 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i64] } i64:{ *:[i64] }:$s1, (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (RLDCL:{ *:[i64] } ?:{ *:[i64] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] })
     /* 105009 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 105012 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 105016 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105021 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 105025 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/64,
     /* 105028 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for PPC::CARRY*/0,
     /* 105031 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 105033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 105036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 105038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 105042 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 105048 */     GIR_RootConstrainSelectedInstOperands,
     /* 105049 */     // GIR_Coverage, 3782,
     /* 105049 */     GIR_EraseRootFromParent_Done,
     /* 105050 */   // Label 1589: @105050
     /* 105050 */   GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(105213), // Rule ID 3783 //
     /* 105055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 105063 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 105067 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 105071 */     // MIs[1] Operand 1
     /* 105071 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 105076 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 105080 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 105084 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 105088 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 105092 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 105096 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 105100 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 105104 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 105108 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 105112 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 105116 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 105118 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i32] } i32:{ *:[i32] }:$s1, (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWNM:{ *:[i32] } ?:{ *:[i32] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 105118 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 105121 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 105125 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105130 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 105134 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/32,
     /* 105137 */     GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for PPC::CARRY*/0,
     /* 105140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 105142 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 105145 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 105149 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105154 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 105158 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 105161 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 105164 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 105167 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105169 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 105172 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105176 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105181 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 105183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105188 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105191 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 105194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 105197 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 105202 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 105207 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 105212 */     // GIR_Coverage, 3783,
     /* 105212 */     GIR_EraseRootFromParent_Done,
     /* 105213 */   // Label 1590: @105213
     /* 105213 */   GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(105343), // Rule ID 3790 //
     /* 105218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 105226 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 105230 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 105234 */     // MIs[1] Operand 1
     /* 105234 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 105239 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 105243 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 105247 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 105251 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 105255 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 105259 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 105263 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 105267 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 105271 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 105275 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 105279 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 105281 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i64] } i64:{ *:[i64] }:$s1, (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (RLDCL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] })
     /* 105281 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 105284 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 105288 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105293 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 105297 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/64,
     /* 105300 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /* 105303 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 105308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 105312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105317 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 105321 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 105325 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 105327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 105330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 105332 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105335 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 105338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 105341 */     GIR_RootConstrainSelectedInstOperands,
     /* 105342 */     // GIR_Coverage, 3790,
     /* 105342 */     GIR_EraseRootFromParent_Done,
     /* 105343 */   // Label 1591: @105343
     /* 105343 */   GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(105527), // Rule ID 3791 //
     /* 105348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 105356 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 105360 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 105364 */     // MIs[1] Operand 1
     /* 105364 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 105369 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 105373 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 105377 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 105381 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 105385 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 105389 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 105393 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 105397 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 105401 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 105405 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 105409 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 105411 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i32] } i32:{ *:[i32] }:$s1, (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWNM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 105411 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 105414 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 105418 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105423 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 105427 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/32,
     /* 105430 */     GIR_SetImplicitDefDead, /*InsnID*/4, /*OpIdx for PPC::CARRY*/0,
     /* 105433 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 105435 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 105438 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 105442 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105447 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 105451 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 105455 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 105457 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 105460 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 105464 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105469 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 105472 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 105475 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 105478 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 105481 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105483 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 105486 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105490 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105495 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 105497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105502 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105505 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 105508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 105511 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 105516 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 105521 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 105526 */     // GIR_Coverage, 3791,
     /* 105526 */     GIR_EraseRootFromParent_Done,
     /* 105527 */   // Label 1592: @105527
     /* 105527 */   GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(105593), // Rule ID 3702 //
     /* 105532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 105540 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 105544 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 105548 */     // MIs[1] Operand 1
     /* 105548 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 105553 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 105557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105559 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1), 58:{ *:[i32] }, 63:{ *:[i32] })
     /* 105559 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 105562 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /* 105566 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105571 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 105575 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 105577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 105580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 105582 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/58,
     /* 105588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 105591 */     GIR_RootConstrainSelectedInstOperands,
     /* 105592 */     // GIR_Coverage, 3702,
     /* 105592 */     GIR_EraseRootFromParent_Done,
     /* 105593 */   // Label 1593: @105593
     /* 105593 */   GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(105713), // Rule ID 3703 //
     /* 105598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 105606 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 105610 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 105614 */     // MIs[1] Operand 1
     /* 105614 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 105619 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 105623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105625 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1), 27:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 105625 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 105628 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /* 105632 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105637 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 105641 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 105643 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 105646 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 105650 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105655 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 105658 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/27,
     /* 105661 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 105664 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 105667 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 105672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105681 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 105683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105691 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 105694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 105697 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 105702 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 105707 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 105712 */     // GIR_Coverage, 3703,
     /* 105712 */     GIR_EraseRootFromParent_Done,
     /* 105713 */   // Label 1594: @105713
     /* 105713 */   GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(105817), // Rule ID 3710 //
     /* 105718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 105726 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 105730 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 105734 */     // MIs[1] Operand 1
     /* 105734 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 105739 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 105743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105745 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1), (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1)), 58:{ *:[i32] }, 63:{ *:[i32] })
     /* 105745 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 105748 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /* 105752 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105757 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 105761 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 105763 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 105766 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /* 105770 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105775 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 105779 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105781 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 105784 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 105788 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105793 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 105796 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 105799 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 105801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 105804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 105806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/58,
     /* 105812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 105815 */     GIR_RootConstrainSelectedInstOperands,
     /* 105816 */     // GIR_Coverage, 3710,
     /* 105816 */     GIR_EraseRootFromParent_Done,
     /* 105817 */   // Label 1595: @105817
     /* 105817 */   GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(105975), // Rule ID 3711 //
     /* 105822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 105830 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 105834 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 105838 */     // MIs[1] Operand 1
     /* 105838 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 105843 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 105847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105849 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1), (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1)), 27:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 105849 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 105852 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /* 105856 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105861 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 105865 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 105867 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 105870 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /* 105874 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105879 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 105883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 105885 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 105888 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 105892 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105897 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 105900 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 105903 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 105905 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 105908 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 105912 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105917 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 105920 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/27,
     /* 105923 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 105926 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 105929 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 105934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105943 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 105945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105950 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105953 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 105956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 105959 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 105964 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 105969 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 105974 */     // GIR_Coverage, 3711,
     /* 105974 */     GIR_EraseRootFromParent_Done,
     /* 105975 */   // Label 1596: @105975
     /* 105975 */   GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(106024), // Rule ID 3718 //
     /* 105980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 105988 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 105992 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 105996 */     // MIs[1] Operand 1
     /* 105996 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 106001 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 106005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106007 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETLT:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 106007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 106010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 106012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 106019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 106022 */     GIR_RootConstrainSelectedInstOperands,
     /* 106023 */     // GIR_Coverage, 3718,
     /* 106023 */     GIR_EraseRootFromParent_Done,
     /* 106024 */   // Label 1597: @106024
     /* 106024 */   GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(106127), // Rule ID 3719 //
     /* 106029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 106037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 106041 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 106045 */     // MIs[1] Operand 1
     /* 106045 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 106050 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 106054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106056 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETLT:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 106056 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 106059 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 106063 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106068 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106072 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 106075 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 106078 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 106081 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 106086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106095 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106102 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106105 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 106108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 106111 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 106116 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 106121 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 106126 */     // GIR_Coverage, 3719,
     /* 106126 */     GIR_EraseRootFromParent_Done,
     /* 106127 */   // Label 1598: @106127
     /* 106127 */   GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(106197), // Rule ID 3726 //
     /* 106132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 106140 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 106144 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 106148 */     // MIs[1] Operand 1
     /* 106148 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 106153 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 106157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106159 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETGE:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 106159 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 106162 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 106166 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106171 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106175 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106179 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 106184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 106186 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 106192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 106195 */     GIR_RootConstrainSelectedInstOperands,
     /* 106196 */     // GIR_Coverage, 3726,
     /* 106196 */     GIR_EraseRootFromParent_Done,
     /* 106197 */   // Label 1599: @106197
     /* 106197 */   GIM_Try, /*On fail goto*//*Label 1600*/ GIMT_Encode4(106321), // Rule ID 3727 //
     /* 106202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 106210 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 106214 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 106218 */     // MIs[1] Operand 1
     /* 106218 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 106223 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 106227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106229 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETGE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 106229 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 106232 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 106236 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106241 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106245 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106249 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 106251 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 106254 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 106258 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106263 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 106266 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 106269 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 106272 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 106275 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106277 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 106280 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106284 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106289 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106296 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106299 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 106302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 106305 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 106310 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 106315 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 106320 */     // GIR_Coverage, 3727,
     /* 106320 */     GIR_EraseRootFromParent_Done,
     /* 106321 */   // Label 1600: @106321
     /* 106321 */   GIM_Try, /*On fail goto*//*Label 1601*/ GIMT_Encode4(106408), // Rule ID 3734 //
     /* 106326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 106334 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 106338 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 106342 */     // MIs[1] Operand 1
     /* 106342 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 106347 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 106351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106353 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETGT:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (ANDC8:{ *:[i64] } (NEG8:{ *:[i64] } ?:{ *:[i64] }:$s1), ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 106353 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 106356 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NEG8),
     /* 106360 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106365 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106369 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106371 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 106374 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::ANDC8),
     /* 106378 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106383 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 106386 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106390 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 106395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 106397 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 106403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 106406 */     GIR_RootConstrainSelectedInstOperands,
     /* 106407 */     // GIR_Coverage, 3734,
     /* 106407 */     GIR_EraseRootFromParent_Done,
     /* 106408 */   // Label 1601: @106408
     /* 106408 */   GIM_Try, /*On fail goto*//*Label 1602*/ GIMT_Encode4(106549), // Rule ID 3735 //
     /* 106413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 106421 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 106425 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 106429 */     // MIs[1] Operand 1
     /* 106429 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 106434 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 106438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106440 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETGT:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (ANDC:{ *:[i32] } (NEG:{ *:[i32] } ?:{ *:[i32] }:$s1), ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 106440 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 106443 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::NEG),
     /* 106447 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106452 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106456 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 106458 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 106461 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::ANDC),
     /* 106465 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106470 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 106473 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106477 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 106479 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 106482 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 106486 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106491 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 106494 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 106497 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 106500 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 106503 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106505 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 106508 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106512 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106517 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106524 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106527 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 106530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 106533 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 106538 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 106543 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 106548 */     // GIR_Coverage, 3735,
     /* 106548 */     GIR_EraseRootFromParent_Done,
     /* 106549 */   // Label 1602: @106549
     /* 106549 */   GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(106636), // Rule ID 3742 //
     /* 106554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 106562 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 106566 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 106570 */     // MIs[1] Operand 1
     /* 106570 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 106575 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 106579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106581 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETLE:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (ORC8:{ *:[i64] } ?:{ *:[i64] }:$s1, (NEG8:{ *:[i64] } ?:{ *:[i64] }:$s1)), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 106581 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 106584 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NEG8),
     /* 106588 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106593 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106597 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106599 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 106602 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::ORC8),
     /* 106606 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106611 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106615 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 106618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 106623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 106625 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 106631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 106634 */     GIR_RootConstrainSelectedInstOperands,
     /* 106635 */     // GIR_Coverage, 3742,
     /* 106635 */     GIR_EraseRootFromParent_Done,
     /* 106636 */   // Label 1603: @106636
     /* 106636 */   GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(106777), // Rule ID 3743 //
     /* 106641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 106649 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 106653 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 106657 */     // MIs[1] Operand 1
     /* 106657 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 106662 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 106666 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106668 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETLE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (ORC:{ *:[i32] } ?:{ *:[i32] }:$s1, (NEG:{ *:[i32] } ?:{ *:[i32] }:$s1)), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 106668 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 106671 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::NEG),
     /* 106675 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106680 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106684 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 106686 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 106689 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::ORC),
     /* 106693 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106698 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106702 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 106705 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 106707 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 106710 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 106714 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106719 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 106722 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 106725 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 106728 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 106731 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106733 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 106736 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106740 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106745 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106752 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106755 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 106758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 106761 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 106766 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 106771 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 106776 */     // GIR_Coverage, 3743,
     /* 106776 */     GIR_EraseRootFromParent_Done,
     /* 106777 */   // Label 1604: @106777
     /* 106777 */   GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(106867), // Rule ID 3750 //
     /* 106782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 106790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 106794 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 106798 */     // MIs[1] Operand 1
     /* 106798 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 106803 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 106807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106809 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETLT:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (AND8:{ *:[i64] } ?:{ *:[i64] }:$s1, (ADDI8:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i64] })), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 106809 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 106812 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ADDI8),
     /* 106816 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106821 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106825 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 106828 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106830 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 106833 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 106837 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106842 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106846 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 106849 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 106854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 106856 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 106862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 106865 */     GIR_RootConstrainSelectedInstOperands,
     /* 106866 */     // GIR_Coverage, 3750,
     /* 106866 */     GIR_EraseRootFromParent_Done,
     /* 106867 */   // Label 1605: @106867
     /* 106867 */   GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(107011), // Rule ID 3751 //
     /* 106872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 106880 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 106884 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 106888 */     // MIs[1] Operand 1
     /* 106888 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 106893 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 106897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106899 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETLT:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (AND:{ *:[i32] } ?:{ *:[i32] }:$s1, (ADDI:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] })), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 106899 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 106902 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::ADDI),
     /* 106906 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106911 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106915 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 106918 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 106920 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 106923 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 106927 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106932 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106936 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 106939 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 106941 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 106944 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 106948 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106953 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 106956 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 106959 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 106962 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 106965 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106967 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 106970 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106974 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106979 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106986 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106989 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 106992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 106995 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 107000 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 107005 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 107010 */     // GIR_Coverage, 3751,
     /* 107010 */     GIR_EraseRootFromParent_Done,
     /* 107011 */   // Label 1606: @107011
     /* 107011 */   GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(107101), // Rule ID 3758 //
     /* 107016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 107024 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 107028 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 107032 */     // MIs[1] Operand 1
     /* 107032 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 107037 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 107041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107043 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETGE:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (NAND8:{ *:[i64] } ?:{ *:[i64] }:$s1, (ADDI8:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i64] })), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 107043 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 107046 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ADDI8),
     /* 107050 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107055 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107059 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 107062 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107064 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 107067 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NAND8),
     /* 107071 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107076 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107080 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 107083 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 107088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 107090 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 107096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 107099 */     GIR_RootConstrainSelectedInstOperands,
     /* 107100 */     // GIR_Coverage, 3758,
     /* 107100 */     GIR_EraseRootFromParent_Done,
     /* 107101 */   // Label 1607: @107101
     /* 107101 */   GIM_Try, /*On fail goto*//*Label 1608*/ GIMT_Encode4(107245), // Rule ID 3759 //
     /* 107106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 107114 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 107118 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 107122 */     // MIs[1] Operand 1
     /* 107122 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 107127 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 107131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107133 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETGE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (NAND:{ *:[i32] } ?:{ *:[i32] }:$s1, (ADDI:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] })), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 107133 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 107136 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::ADDI),
     /* 107140 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107145 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107149 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 107152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 107154 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 107157 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NAND),
     /* 107161 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107166 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107170 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 107173 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 107175 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 107178 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 107182 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107187 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 107190 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 107193 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 107196 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 107199 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107201 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 107204 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107208 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107213 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107220 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107223 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 107226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 107229 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 107234 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 107239 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 107244 */     // GIR_Coverage, 3759,
     /* 107244 */     GIR_EraseRootFromParent_Done,
     /* 107245 */   // Label 1608: @107245
     /* 107245 */   GIM_Try, /*On fail goto*//*Label 1609*/ GIMT_Encode4(107315), // Rule ID 3766 //
     /* 107250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 107258 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 107262 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 107266 */     // MIs[1] Operand 1
     /* 107266 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 107271 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 107275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107277 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETGT:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 107277 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 107280 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 107284 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107289 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107293 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107297 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 107302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 107304 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 107310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 107313 */     GIR_RootConstrainSelectedInstOperands,
     /* 107314 */     // GIR_Coverage, 3766,
     /* 107314 */     GIR_EraseRootFromParent_Done,
     /* 107315 */   // Label 1609: @107315
     /* 107315 */   GIM_Try, /*On fail goto*//*Label 1610*/ GIMT_Encode4(107439), // Rule ID 3767 //
     /* 107320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 107328 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 107332 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 107336 */     // MIs[1] Operand 1
     /* 107336 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 107341 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 107345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107347 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETGT:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 107347 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 107350 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 107354 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107359 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107363 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107367 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 107369 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 107372 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 107376 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107381 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 107384 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 107387 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 107390 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 107393 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107395 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 107398 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107402 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107407 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107414 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107417 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 107420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 107423 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 107428 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 107433 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 107438 */     // GIR_Coverage, 3767,
     /* 107438 */     GIR_EraseRootFromParent_Done,
     /* 107439 */   // Label 1610: @107439
     /* 107439 */   GIM_Try, /*On fail goto*//*Label 1611*/ GIMT_Encode4(107488), // Rule ID 3774 //
     /* 107444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 107452 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 107456 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 107460 */     // MIs[1] Operand 1
     /* 107460 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 107465 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 107469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107471 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETLE:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 107471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 107474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 107476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 107483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 107486 */     GIR_RootConstrainSelectedInstOperands,
     /* 107487 */     // GIR_Coverage, 3774,
     /* 107487 */     GIR_EraseRootFromParent_Done,
     /* 107488 */   // Label 1611: @107488
     /* 107488 */   GIM_Try, /*On fail goto*//*Label 1612*/ GIMT_Encode4(107591), // Rule ID 3775 //
     /* 107493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 107501 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 107505 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 107509 */     // MIs[1] Operand 1
     /* 107509 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 107514 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 107518 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107520 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETLE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 107520 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 107523 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 107527 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107532 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107536 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 107539 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 107542 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 107545 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 107550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107559 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107566 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107569 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 107572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 107575 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 107580 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 107585 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 107590 */     // GIR_Coverage, 3775,
     /* 107590 */     GIR_EraseRootFromParent_Done,
     /* 107591 */   // Label 1612: @107591
     /* 107591 */   GIM_Try, /*On fail goto*//*Label 1613*/ GIMT_Encode4(107694), // Rule ID 3041 //
     /* 107596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 107599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 107607 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 107611 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 107615 */     // MIs[1] Operand 1
     /* 107615 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 107620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 107624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 107628 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 107632 */     // MIs[2] Operand 1
     /* 107632 */     // No operand predicates
     /* 107632 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 107634 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }))
     /* 107634 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 107637 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 107641 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107646 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107650 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 107653 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107655 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 107658 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107662 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107667 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 107674 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 107679 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 107684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 107687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 107689 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107692 */     GIR_RootConstrainSelectedInstOperands,
     /* 107693 */     // GIR_Coverage, 3041,
     /* 107693 */     GIR_EraseRootFromParent_Done,
     /* 107694 */   // Label 1613: @107694
     /* 107694 */   GIM_Try, /*On fail goto*//*Label 1614*/ GIMT_Encode4(107797), // Rule ID 3057 //
     /* 107699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 107702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 107710 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 107714 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 107718 */     // MIs[1] Operand 1
     /* 107718 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 107723 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 107727 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 107731 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 107735 */     // MIs[2] Operand 1
     /* 107735 */     // No operand predicates
     /* 107735 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 107737 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }))
     /* 107737 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 107740 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 107744 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107749 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107753 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 107756 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107758 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 107761 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107765 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107770 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 107777 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 107782 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 107787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 107790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 107792 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107795 */     GIR_RootConstrainSelectedInstOperands,
     /* 107796 */     // GIR_Coverage, 3057,
     /* 107796 */     GIR_EraseRootFromParent_Done,
     /* 107797 */   // Label 1614: @107797
     /* 107797 */   GIM_Try, /*On fail goto*//*Label 1615*/ GIMT_Encode4(107900), // Rule ID 3065 //
     /* 107802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 107805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 107813 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 107817 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 107821 */     // MIs[1] Operand 1
     /* 107821 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 107826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 107830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 107834 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 107838 */     // MIs[2] Operand 1
     /* 107838 */     // No operand predicates
     /* 107838 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 107840 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }))
     /* 107840 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 107843 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 107847 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107852 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107856 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 107859 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107861 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 107864 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107868 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107873 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 107880 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 107885 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 107890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 107893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 107895 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107898 */     GIR_RootConstrainSelectedInstOperands,
     /* 107899 */     // GIR_Coverage, 3065,
     /* 107899 */     GIR_EraseRootFromParent_Done,
     /* 107900 */   // Label 1615: @107900
     /* 107900 */   GIM_Try, /*On fail goto*//*Label 1616*/ GIMT_Encode4(108003), // Rule ID 3137 //
     /* 107905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 107908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 107916 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 107920 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 107924 */     // MIs[1] Operand 1
     /* 107924 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 107929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 107933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 107937 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 107941 */     // MIs[2] Operand 1
     /* 107941 */     // No operand predicates
     /* 107941 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 107943 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }))
     /* 107943 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 107946 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 107950 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107955 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107959 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 107962 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107964 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 107967 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107971 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107976 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 107983 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 107988 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 107993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 107996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 107998 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108001 */     GIR_RootConstrainSelectedInstOperands,
     /* 108002 */     // GIR_Coverage, 3137,
     /* 108002 */     GIR_EraseRootFromParent_Done,
     /* 108003 */   // Label 1616: @108003
     /* 108003 */   GIM_Try, /*On fail goto*//*Label 1617*/ GIMT_Encode4(108106), // Rule ID 3153 //
     /* 108008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 108011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 108015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 108019 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 108023 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 108027 */     // MIs[1] Operand 1
     /* 108027 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 108032 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 108036 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 108040 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 108044 */     // MIs[2] Operand 1
     /* 108044 */     // No operand predicates
     /* 108044 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 108046 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }))
     /* 108046 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 108049 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 108053 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108058 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 108062 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 108065 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 108067 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 108070 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108074 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108079 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 108086 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 108091 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 108096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 108099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 108101 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108104 */     GIR_RootConstrainSelectedInstOperands,
     /* 108105 */     // GIR_Coverage, 3153,
     /* 108105 */     GIR_EraseRootFromParent_Done,
     /* 108106 */   // Label 1617: @108106
     /* 108106 */   GIM_Try, /*On fail goto*//*Label 1618*/ GIMT_Encode4(108209), // Rule ID 3161 //
     /* 108111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 108114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 108118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 108122 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 108126 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 108130 */     // MIs[1] Operand 1
     /* 108130 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 108135 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 108139 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 108143 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 108147 */     // MIs[2] Operand 1
     /* 108147 */     // No operand predicates
     /* 108147 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 108149 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }))
     /* 108149 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 108152 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 108156 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108161 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 108165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 108168 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 108170 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 108173 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108177 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108182 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 108189 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 108194 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 108199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 108202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 108204 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108207 */     GIR_RootConstrainSelectedInstOperands,
     /* 108208 */     // GIR_Coverage, 3161,
     /* 108208 */     GIR_EraseRootFromParent_Done,
     /* 108209 */   // Label 1618: @108209
     /* 108209 */   GIM_Try, /*On fail goto*//*Label 1619*/ GIMT_Encode4(108352), // Rule ID 3824 //
     /* 108214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 108217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 108221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 108225 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 108229 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 108233 */     // MIs[1] Operand 1
     /* 108233 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 108238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 108242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 108246 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 108250 */     // MIs[2] Operand 1
     /* 108250 */     // No operand predicates
     /* 108250 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 108252 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 108252 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 108255 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 108259 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108264 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 108268 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 108271 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 108273 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 108276 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108280 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108285 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 108288 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 108290 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 108293 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108297 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108302 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 108305 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 108307 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 108310 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108314 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108319 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 108326 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 108331 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 108336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 108339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108341 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 108347 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 108350 */     GIR_RootConstrainSelectedInstOperands,
     /* 108351 */     // GIR_Coverage, 3824,
     /* 108351 */     GIR_EraseRootFromParent_Done,
     /* 108352 */   // Label 1619: @108352
     /* 108352 */   GIM_Try, /*On fail goto*//*Label 1620*/ GIMT_Encode4(108495), // Rule ID 3840 //
     /* 108357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 108360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 108364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 108368 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 108372 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 108376 */     // MIs[1] Operand 1
     /* 108376 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 108381 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 108385 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 108389 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 108393 */     // MIs[2] Operand 1
     /* 108393 */     // No operand predicates
     /* 108393 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 108395 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 108395 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 108398 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 108402 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108407 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 108411 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 108414 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 108416 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 108419 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108423 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108428 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 108431 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 108433 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 108436 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108440 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108445 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 108448 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 108450 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 108453 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108457 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108462 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 108469 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 108474 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 108479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 108482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108484 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108487 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 108490 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 108493 */     GIR_RootConstrainSelectedInstOperands,
     /* 108494 */     // GIR_Coverage, 3840,
     /* 108494 */     GIR_EraseRootFromParent_Done,
     /* 108495 */   // Label 1620: @108495
     /* 108495 */   GIM_Try, /*On fail goto*//*Label 1621*/ GIMT_Encode4(108638), // Rule ID 3848 //
     /* 108500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 108503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 108507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 108511 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 108515 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 108519 */     // MIs[1] Operand 1
     /* 108519 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 108524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 108528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 108532 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 108536 */     // MIs[2] Operand 1
     /* 108536 */     // No operand predicates
     /* 108536 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 108538 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 108538 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 108541 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 108545 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108550 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 108554 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 108557 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 108559 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 108562 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108566 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108571 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 108574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 108576 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 108579 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108583 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108588 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 108591 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 108593 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 108596 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108600 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108605 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 108612 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 108617 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 108622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 108625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108627 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108630 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 108633 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 108636 */     GIR_RootConstrainSelectedInstOperands,
     /* 108637 */     // GIR_Coverage, 3848,
     /* 108637 */     GIR_EraseRootFromParent_Done,
     /* 108638 */   // Label 1621: @108638
     /* 108638 */   GIM_Try, /*On fail goto*//*Label 1622*/ GIMT_Encode4(108781), // Rule ID 3920 //
     /* 108643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 108646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 108650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 108654 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 108658 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 108662 */     // MIs[1] Operand 1
     /* 108662 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 108667 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 108671 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 108675 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 108679 */     // MIs[2] Operand 1
     /* 108679 */     // No operand predicates
     /* 108679 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 108681 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 108681 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 108684 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 108688 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108693 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 108697 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 108700 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 108702 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 108705 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108709 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108714 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 108717 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 108719 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 108722 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108726 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108731 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 108734 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 108736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 108739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108748 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 108755 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 108760 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 108765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 108768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108770 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108773 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 108776 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 108779 */     GIR_RootConstrainSelectedInstOperands,
     /* 108780 */     // GIR_Coverage, 3920,
     /* 108780 */     GIR_EraseRootFromParent_Done,
     /* 108781 */   // Label 1622: @108781
     /* 108781 */   GIM_Try, /*On fail goto*//*Label 1623*/ GIMT_Encode4(108924), // Rule ID 3936 //
     /* 108786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 108789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 108793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 108797 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 108801 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 108805 */     // MIs[1] Operand 1
     /* 108805 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 108810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 108814 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 108818 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 108822 */     // MIs[2] Operand 1
     /* 108822 */     // No operand predicates
     /* 108822 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 108824 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 108824 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 108827 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 108831 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108836 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 108840 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 108843 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 108845 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 108848 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108852 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108857 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 108860 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 108862 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 108865 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108869 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108874 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 108877 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 108879 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 108882 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108886 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108891 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 108898 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 108903 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 108908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 108911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108913 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108916 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 108919 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 108922 */     GIR_RootConstrainSelectedInstOperands,
     /* 108923 */     // GIR_Coverage, 3936,
     /* 108923 */     GIR_EraseRootFromParent_Done,
     /* 108924 */   // Label 1623: @108924
     /* 108924 */   GIM_Try, /*On fail goto*//*Label 1624*/ GIMT_Encode4(109067), // Rule ID 3944 //
     /* 108929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 108932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 108936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 108940 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 108944 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 108948 */     // MIs[1] Operand 1
     /* 108948 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 108953 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 108957 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 108961 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 108965 */     // MIs[2] Operand 1
     /* 108965 */     // No operand predicates
     /* 108965 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 108967 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 108967 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 108970 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 108974 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108979 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 108983 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 108986 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 108988 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 108991 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108995 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109000 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 109003 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 109005 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 109008 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 109012 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109017 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 109020 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 109022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 109025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109034 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 109041 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 109046 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 109051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 109054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109056 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109059 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 109062 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 109065 */     GIR_RootConstrainSelectedInstOperands,
     /* 109066 */     // GIR_Coverage, 3944,
     /* 109066 */     GIR_EraseRootFromParent_Done,
     /* 109067 */   // Label 1624: @109067
     /* 109067 */   GIM_Try, /*On fail goto*//*Label 1625*/ GIMT_Encode4(109159), // Rule ID 3185 //
     /* 109072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 109075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 109083 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 109087 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 109091 */     // MIs[1] Operand 1
     /* 109091 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 109096 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109098 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }))
     /* 109098 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 109101 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 109105 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109110 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 109114 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 109118 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109120 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 109123 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109127 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109132 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 109139 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 109144 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 109149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 109152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 109154 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109157 */     GIR_RootConstrainSelectedInstOperands,
     /* 109158 */     // GIR_Coverage, 3185,
     /* 109158 */     GIR_EraseRootFromParent_Done,
     /* 109159 */   // Label 1625: @109159
     /* 109159 */   GIM_Try, /*On fail goto*//*Label 1626*/ GIMT_Encode4(109251), // Rule ID 3201 //
     /* 109164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 109167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 109175 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 109179 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 109183 */     // MIs[1] Operand 1
     /* 109183 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 109188 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109190 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }))
     /* 109190 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 109193 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 109197 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109202 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 109206 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 109210 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109212 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 109215 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109219 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109224 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 109231 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 109236 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 109241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 109244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 109246 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109249 */     GIR_RootConstrainSelectedInstOperands,
     /* 109250 */     // GIR_Coverage, 3201,
     /* 109250 */     GIR_EraseRootFromParent_Done,
     /* 109251 */   // Label 1626: @109251
     /* 109251 */   GIM_Try, /*On fail goto*//*Label 1627*/ GIMT_Encode4(109343), // Rule ID 3217 //
     /* 109256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 109259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 109267 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 109271 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 109275 */     // MIs[1] Operand 1
     /* 109275 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 109280 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109282 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }))
     /* 109282 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 109285 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 109289 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109294 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 109298 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 109302 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109304 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 109307 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109311 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109316 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 109323 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 109328 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 109333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 109336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 109338 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109341 */     GIR_RootConstrainSelectedInstOperands,
     /* 109342 */     // GIR_Coverage, 3217,
     /* 109342 */     GIR_EraseRootFromParent_Done,
     /* 109343 */   // Label 1627: @109343
     /* 109343 */   GIM_Try, /*On fail goto*//*Label 1628*/ GIMT_Encode4(109435), // Rule ID 3233 //
     /* 109348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 109351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 109359 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 109363 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 109367 */     // MIs[1] Operand 1
     /* 109367 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 109372 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109374 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }))
     /* 109374 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 109377 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 109381 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109386 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 109390 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 109394 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109396 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 109399 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109403 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109408 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 109415 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 109420 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 109425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 109428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 109430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109433 */     GIR_RootConstrainSelectedInstOperands,
     /* 109434 */     // GIR_Coverage, 3233,
     /* 109434 */     GIR_EraseRootFromParent_Done,
     /* 109435 */   // Label 1628: @109435
     /* 109435 */   GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(109527), // Rule ID 3241 //
     /* 109440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 109443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 109451 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 109455 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 109459 */     // MIs[1] Operand 1
     /* 109459 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 109464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109466 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }))
     /* 109466 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 109469 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 109473 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109478 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 109482 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 109486 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109488 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 109491 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109495 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109500 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 109507 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 109512 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 109517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 109520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 109522 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109525 */     GIR_RootConstrainSelectedInstOperands,
     /* 109526 */     // GIR_Coverage, 3241,
     /* 109526 */     GIR_EraseRootFromParent_Done,
     /* 109527 */   // Label 1629: @109527
     /* 109527 */   GIM_Try, /*On fail goto*//*Label 1630*/ GIMT_Encode4(109619), // Rule ID 3257 //
     /* 109532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 109535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 109543 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 109547 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 109551 */     // MIs[1] Operand 1
     /* 109551 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 109556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109558 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }))
     /* 109558 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 109561 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 109565 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109570 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 109574 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 109578 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109580 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 109583 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109587 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109592 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 109599 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 109604 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 109609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 109612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 109614 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109617 */     GIR_RootConstrainSelectedInstOperands,
     /* 109618 */     // GIR_Coverage, 3257,
     /* 109618 */     GIR_EraseRootFromParent_Done,
     /* 109619 */   // Label 1630: @109619
     /* 109619 */   GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(109711), // Rule ID 3273 //
     /* 109624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 109627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 109635 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 109639 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 109643 */     // MIs[1] Operand 1
     /* 109643 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 109648 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109650 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }))
     /* 109650 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 109653 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 109657 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109662 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 109666 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 109670 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109672 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 109675 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109679 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109684 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 109691 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 109696 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 109701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 109704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 109706 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109709 */     GIR_RootConstrainSelectedInstOperands,
     /* 109710 */     // GIR_Coverage, 3273,
     /* 109710 */     GIR_EraseRootFromParent_Done,
     /* 109711 */   // Label 1631: @109711
     /* 109711 */   GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(109803), // Rule ID 3289 //
     /* 109716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 109719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 109727 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 109731 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 109735 */     // MIs[1] Operand 1
     /* 109735 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 109740 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109742 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }))
     /* 109742 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 109745 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 109749 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109754 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 109758 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 109762 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109764 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 109767 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109771 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109776 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 109783 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 109788 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 109793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 109796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 109798 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109801 */     GIR_RootConstrainSelectedInstOperands,
     /* 109802 */     // GIR_Coverage, 3289,
     /* 109802 */     GIR_EraseRootFromParent_Done,
     /* 109803 */   // Label 1632: @109803
     /* 109803 */   GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(109895), // Rule ID 3297 //
     /* 109808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 109811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 109819 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 109823 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 109827 */     // MIs[1] Operand 1
     /* 109827 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 109832 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109834 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }))
     /* 109834 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 109837 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 109841 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109846 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 109850 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 109854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109856 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 109859 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109863 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109868 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 109875 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 109880 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 109885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 109888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 109890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109893 */     GIR_RootConstrainSelectedInstOperands,
     /* 109894 */     // GIR_Coverage, 3297,
     /* 109894 */     GIR_EraseRootFromParent_Done,
     /* 109895 */   // Label 1633: @109895
     /* 109895 */   GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(109987), // Rule ID 3313 //
     /* 109900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 109903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 109911 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 109915 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 109919 */     // MIs[1] Operand 1
     /* 109919 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 109924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109926 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }))
     /* 109926 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 109929 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 109933 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109938 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 109942 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 109946 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109948 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 109951 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109955 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109960 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 109967 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 109972 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 109977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 109980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 109982 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109985 */     GIR_RootConstrainSelectedInstOperands,
     /* 109986 */     // GIR_Coverage, 3313,
     /* 109986 */     GIR_EraseRootFromParent_Done,
     /* 109987 */   // Label 1634: @109987
     /* 109987 */   GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(110079), // Rule ID 3329 //
     /* 109992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 109995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 110003 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 110007 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 110011 */     // MIs[1] Operand 1
     /* 110011 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 110016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110018 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }))
     /* 110018 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 110021 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 110025 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110030 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 110034 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 110038 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 110040 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 110043 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110047 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110052 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 110059 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 110064 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 110069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 110072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 110074 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110077 */     GIR_RootConstrainSelectedInstOperands,
     /* 110078 */     // GIR_Coverage, 3329,
     /* 110078 */     GIR_EraseRootFromParent_Done,
     /* 110079 */   // Label 1635: @110079
     /* 110079 */   GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(110171), // Rule ID 3345 //
     /* 110084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 110087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 110095 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 110099 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 110103 */     // MIs[1] Operand 1
     /* 110103 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 110108 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110110 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }))
     /* 110110 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 110113 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 110117 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110122 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 110126 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 110130 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 110132 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 110135 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110139 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110144 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 110151 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 110156 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 110161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 110164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 110166 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110169 */     GIR_RootConstrainSelectedInstOperands,
     /* 110170 */     // GIR_Coverage, 3345,
     /* 110170 */     GIR_EraseRootFromParent_Done,
     /* 110171 */   // Label 1636: @110171
     /* 110171 */   GIM_Try, /*On fail goto*//*Label 1637*/ GIMT_Encode4(110303), // Rule ID 4030 //
     /* 110176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 110179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 110187 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 110191 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 110195 */     // MIs[1] Operand 1
     /* 110195 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 110200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110202 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 110202 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 110205 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 110209 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110214 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 110218 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 110222 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 110224 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 110227 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110231 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110236 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 110239 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 110241 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 110244 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110248 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110253 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 110256 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 110258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 110261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110270 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 110277 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 110282 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 110287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 110290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110292 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110295 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 110298 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 110301 */     GIR_RootConstrainSelectedInstOperands,
     /* 110302 */     // GIR_Coverage, 4030,
     /* 110302 */     GIR_EraseRootFromParent_Done,
     /* 110303 */   // Label 1637: @110303
     /* 110303 */   GIM_Try, /*On fail goto*//*Label 1638*/ GIMT_Encode4(110435), // Rule ID 4062 //
     /* 110308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 110311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 110319 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 110323 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 110327 */     // MIs[1] Operand 1
     /* 110327 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 110332 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110334 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 110334 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 110337 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 110341 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110346 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 110350 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 110354 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 110356 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 110359 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110363 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110368 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 110371 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 110373 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 110376 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110380 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110385 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 110388 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 110390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 110393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110402 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 110409 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 110414 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 110419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 110422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110424 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110427 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 110430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 110433 */     GIR_RootConstrainSelectedInstOperands,
     /* 110434 */     // GIR_Coverage, 4062,
     /* 110434 */     GIR_EraseRootFromParent_Done,
     /* 110435 */   // Label 1638: @110435
     /* 110435 */   GIM_Try, /*On fail goto*//*Label 1639*/ GIMT_Encode4(110567), // Rule ID 4094 //
     /* 110440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 110443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 110451 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 110455 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 110459 */     // MIs[1] Operand 1
     /* 110459 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 110464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110466 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 110466 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 110469 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 110473 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110478 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 110482 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 110486 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 110488 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 110491 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110495 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110500 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 110503 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 110505 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 110508 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110512 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110517 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 110520 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 110522 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 110525 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110529 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110534 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 110541 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 110546 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 110551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 110554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110556 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110559 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 110562 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 110565 */     GIR_RootConstrainSelectedInstOperands,
     /* 110566 */     // GIR_Coverage, 4094,
     /* 110566 */     GIR_EraseRootFromParent_Done,
     /* 110567 */   // Label 1639: @110567
     /* 110567 */   GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(110699), // Rule ID 4126 //
     /* 110572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 110575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 110583 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 110587 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 110591 */     // MIs[1] Operand 1
     /* 110591 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 110596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110598 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 110598 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 110601 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 110605 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110610 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 110614 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 110618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 110620 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 110623 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110627 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110632 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 110635 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 110637 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 110640 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110644 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110649 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 110652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 110654 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 110657 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110661 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110666 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 110673 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 110678 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 110683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 110686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110691 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 110694 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 110697 */     GIR_RootConstrainSelectedInstOperands,
     /* 110698 */     // GIR_Coverage, 4126,
     /* 110698 */     GIR_EraseRootFromParent_Done,
     /* 110699 */   // Label 1640: @110699
     /* 110699 */   GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(110831), // Rule ID 4142 //
     /* 110704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 110707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 110715 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110719 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 110723 */     // MIs[1] Operand 1
     /* 110723 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 110728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110730 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 110730 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 110733 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 110737 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110742 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 110746 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 110750 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 110752 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 110755 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110759 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110764 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 110767 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 110769 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 110772 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110776 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110781 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 110784 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 110786 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 110789 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110793 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110798 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 110805 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 110810 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 110815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 110818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110820 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 110826 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 110829 */     GIR_RootConstrainSelectedInstOperands,
     /* 110830 */     // GIR_Coverage, 4142,
     /* 110830 */     GIR_EraseRootFromParent_Done,
     /* 110831 */   // Label 1641: @110831
     /* 110831 */   GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(110963), // Rule ID 4174 //
     /* 110836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 110839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 110847 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110851 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 110855 */     // MIs[1] Operand 1
     /* 110855 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 110860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110862 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 110862 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 110865 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 110869 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110874 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 110878 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 110882 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 110884 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 110887 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110891 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110896 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 110899 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 110901 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 110904 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110908 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110913 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 110916 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 110918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 110921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110930 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 110937 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 110942 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 110947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 110950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110952 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110955 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 110958 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 110961 */     GIR_RootConstrainSelectedInstOperands,
     /* 110962 */     // GIR_Coverage, 4174,
     /* 110962 */     GIR_EraseRootFromParent_Done,
     /* 110963 */   // Label 1642: @110963
     /* 110963 */   GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(111095), // Rule ID 4206 //
     /* 110968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 110971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 110979 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110983 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 110987 */     // MIs[1] Operand 1
     /* 110987 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 110992 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110994 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 110994 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 110997 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 111001 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111006 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 111010 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 111014 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 111016 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 111019 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111023 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111028 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 111031 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 111033 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 111036 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111040 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111045 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 111048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 111050 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 111053 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111057 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111062 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 111069 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 111074 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 111079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 111082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111084 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111087 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 111090 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 111093 */     GIR_RootConstrainSelectedInstOperands,
     /* 111094 */     // GIR_Coverage, 4206,
     /* 111094 */     GIR_EraseRootFromParent_Done,
     /* 111095 */   // Label 1643: @111095
     /* 111095 */   GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(111227), // Rule ID 4238 //
     /* 111100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 111103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 111111 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111115 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 111119 */     // MIs[1] Operand 1
     /* 111119 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 111124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111126 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 111126 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 111129 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 111133 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111138 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 111142 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 111146 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 111148 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 111151 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111155 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111160 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 111163 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 111165 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 111168 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111172 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111177 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 111180 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 111182 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 111185 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111189 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111194 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 111201 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 111206 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 111211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 111214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111216 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111219 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 111222 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 111225 */     GIR_RootConstrainSelectedInstOperands,
     /* 111226 */     // GIR_Coverage, 4238,
     /* 111226 */     GIR_EraseRootFromParent_Done,
     /* 111227 */   // Label 1644: @111227
     /* 111227 */   GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(111359), // Rule ID 4268 //
     /* 111232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 111235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 111243 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 111247 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 111251 */     // MIs[1] Operand 1
     /* 111251 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 111256 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111258 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 111258 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 111261 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 111265 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111270 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 111274 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 111278 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 111280 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 111283 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111287 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111292 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 111295 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 111297 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 111300 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111304 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111309 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 111312 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 111314 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 111317 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111321 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111326 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 111333 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 111338 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 111343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 111346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111348 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111351 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 111354 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 111357 */     GIR_RootConstrainSelectedInstOperands,
     /* 111358 */     // GIR_Coverage, 4268,
     /* 111358 */     GIR_EraseRootFromParent_Done,
     /* 111359 */   // Label 1645: @111359
     /* 111359 */   GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(111491), // Rule ID 4300 //
     /* 111364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 111367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 111375 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 111379 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 111383 */     // MIs[1] Operand 1
     /* 111383 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 111388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111390 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 111390 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 111393 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 111397 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111402 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 111406 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 111410 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 111412 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 111415 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111419 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111424 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 111427 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 111429 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 111432 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111436 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111441 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 111444 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 111446 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 111449 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111453 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111458 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 111465 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 111470 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 111475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 111478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111480 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111483 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 111486 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 111489 */     GIR_RootConstrainSelectedInstOperands,
     /* 111490 */     // GIR_Coverage, 4300,
     /* 111490 */     GIR_EraseRootFromParent_Done,
     /* 111491 */   // Label 1646: @111491
     /* 111491 */   GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(111623), // Rule ID 4332 //
     /* 111496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 111499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 111507 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 111511 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 111515 */     // MIs[1] Operand 1
     /* 111515 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 111520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111522 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 111522 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 111525 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 111529 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111534 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 111538 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 111542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 111544 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 111547 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111551 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111556 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 111559 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 111561 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 111564 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111568 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111573 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 111576 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 111578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 111581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111590 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 111597 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 111602 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 111607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 111610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111612 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 111618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 111621 */     GIR_RootConstrainSelectedInstOperands,
     /* 111622 */     // GIR_Coverage, 4332,
     /* 111622 */     GIR_EraseRootFromParent_Done,
     /* 111623 */   // Label 1647: @111623
     /* 111623 */   GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(111755), // Rule ID 4364 //
     /* 111628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 111631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 111639 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 111643 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 111647 */     // MIs[1] Operand 1
     /* 111647 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 111652 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111654 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 111654 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 111657 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 111661 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111666 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 111670 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 111674 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 111676 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 111679 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111683 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111688 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 111691 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 111693 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 111696 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111700 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111705 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 111708 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 111710 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 111713 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111717 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111722 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 111729 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 111734 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 111739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 111742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111744 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111747 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 111750 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 111753 */     GIR_RootConstrainSelectedInstOperands,
     /* 111754 */     // GIR_Coverage, 4364,
     /* 111754 */     GIR_EraseRootFromParent_Done,
     /* 111755 */   // Label 1648: @111755
     /* 111755 */   GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(111887), // Rule ID 4595 //
     /* 111760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 111763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 111771 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 111775 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 111779 */     // MIs[1] Operand 1
     /* 111779 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 111784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111786 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPLT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 111786 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 111789 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPLT),
     /* 111793 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111798 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 111802 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 111806 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 111808 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 111811 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111815 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111820 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 111823 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 111825 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 111828 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111832 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111837 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 111840 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 111842 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 111845 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111849 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111854 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 111861 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 111866 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 111871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 111874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111876 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 111882 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 111885 */     GIR_RootConstrainSelectedInstOperands,
     /* 111886 */     // GIR_Coverage, 4595,
     /* 111886 */     GIR_EraseRootFromParent_Done,
     /* 111887 */   // Label 1649: @111887
     /* 111887 */   GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(112019), // Rule ID 4627 //
     /* 111892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 111895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 111903 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 111907 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 111911 */     // MIs[1] Operand 1
     /* 111911 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 111916 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111918 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPGT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 111918 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 111921 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPGT),
     /* 111925 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111930 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 111934 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 111938 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 111940 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 111943 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111947 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111952 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 111955 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 111957 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 111960 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111964 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111969 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 111972 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 111974 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 111977 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111981 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111986 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 111993 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 111998 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 112003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 112006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112008 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 112014 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 112017 */     GIR_RootConstrainSelectedInstOperands,
     /* 112018 */     // GIR_Coverage, 4627,
     /* 112018 */     GIR_EraseRootFromParent_Done,
     /* 112019 */   // Label 1650: @112019
     /* 112019 */   GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(112151), // Rule ID 4659 //
     /* 112024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 112027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 112035 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 112039 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 112043 */     // MIs[1] Operand 1
     /* 112043 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 112048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112050 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPEQ:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 112050 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 112053 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPEQ),
     /* 112057 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112062 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 112066 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 112070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112072 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 112075 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 112079 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112084 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 112087 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 112089 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 112092 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 112096 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112101 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 112104 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 112106 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 112109 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112113 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112118 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 112125 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 112130 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 112135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 112138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112140 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112143 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 112146 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 112149 */     GIR_RootConstrainSelectedInstOperands,
     /* 112150 */     // GIR_Coverage, 4659,
     /* 112150 */     GIR_EraseRootFromParent_Done,
     /* 112151 */   // Label 1651: @112151
     /* 112151 */   GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(112283), // Rule ID 4703 //
     /* 112156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 112159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 112167 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112171 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 112175 */     // MIs[1] Operand 1
     /* 112175 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 112180 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112182 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPLT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 112182 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 112185 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPLT),
     /* 112189 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112194 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 112198 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 112202 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112204 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 112207 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 112211 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112216 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 112219 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 112221 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 112224 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 112228 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112233 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 112236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 112238 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 112241 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112245 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112250 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 112257 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 112262 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 112267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 112270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112272 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112275 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 112278 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 112281 */     GIR_RootConstrainSelectedInstOperands,
     /* 112282 */     // GIR_Coverage, 4703,
     /* 112282 */     GIR_EraseRootFromParent_Done,
     /* 112283 */   // Label 1652: @112283
     /* 112283 */   GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(112415), // Rule ID 4735 //
     /* 112288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 112291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 112299 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112303 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 112307 */     // MIs[1] Operand 1
     /* 112307 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 112312 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112314 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPGT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 112314 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 112317 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPGT),
     /* 112321 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112326 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 112330 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 112334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112336 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 112339 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 112343 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112348 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 112351 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 112353 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 112356 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 112360 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112365 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 112368 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 112370 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 112373 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112377 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112382 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 112389 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 112394 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 112399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 112402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112404 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112407 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 112410 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 112413 */     GIR_RootConstrainSelectedInstOperands,
     /* 112414 */     // GIR_Coverage, 4735,
     /* 112414 */     GIR_EraseRootFromParent_Done,
     /* 112415 */   // Label 1653: @112415
     /* 112415 */   GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(112547), // Rule ID 4767 //
     /* 112420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 112423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 112431 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112435 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 112439 */     // MIs[1] Operand 1
     /* 112439 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 112444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112446 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPEQ:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 112446 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 112449 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPEQ),
     /* 112453 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112458 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 112462 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 112466 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112468 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 112471 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 112475 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112480 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 112483 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 112485 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 112488 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 112492 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112497 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 112500 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 112502 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 112505 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112509 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112514 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 112521 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 112526 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 112531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 112534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112536 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112539 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 112542 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 112545 */     GIR_RootConstrainSelectedInstOperands,
     /* 112546 */     // GIR_Coverage, 4767,
     /* 112546 */     GIR_EraseRootFromParent_Done,
     /* 112547 */   // Label 1654: @112547
     /* 112547 */   GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(112639), // Rule ID 2987 //
     /* 112552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 112555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 112563 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 112567 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 112571 */     // MIs[1] Operand 1
     /* 112571 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 112576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112578 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 112578 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 112581 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 112585 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112590 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 112594 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 112598 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112600 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 112603 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112607 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112612 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 112619 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 112624 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 112629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 112632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 112634 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112637 */     GIR_RootConstrainSelectedInstOperands,
     /* 112638 */     // GIR_Coverage, 2987,
     /* 112638 */     GIR_EraseRootFromParent_Done,
     /* 112639 */   // Label 1655: @112639
     /* 112639 */   GIM_Try, /*On fail goto*//*Label 1656*/ GIMT_Encode4(112731), // Rule ID 3001 //
     /* 112644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 112647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 112655 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 112659 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 112663 */     // MIs[1] Operand 1
     /* 112663 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 112668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112670 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 112670 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 112673 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 112677 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112682 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 112686 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 112690 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 112695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112704 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 112711 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 112716 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 112721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 112724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 112726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112729 */     GIR_RootConstrainSelectedInstOperands,
     /* 112730 */     // GIR_Coverage, 3001,
     /* 112730 */     GIR_EraseRootFromParent_Done,
     /* 112731 */   // Label 1656: @112731
     /* 112731 */   GIM_Try, /*On fail goto*//*Label 1657*/ GIMT_Encode4(112823), // Rule ID 3009 //
     /* 112736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 112739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 112747 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 112751 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 112755 */     // MIs[1] Operand 1
     /* 112755 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 112760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112762 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 112762 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 112765 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 112769 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112774 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 112778 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 112782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 112787 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112791 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112796 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 112803 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 112808 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 112813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 112816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 112818 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112821 */     GIR_RootConstrainSelectedInstOperands,
     /* 112822 */     // GIR_Coverage, 3009,
     /* 112822 */     GIR_EraseRootFromParent_Done,
     /* 112823 */   // Label 1657: @112823
     /* 112823 */   GIM_Try, /*On fail goto*//*Label 1658*/ GIMT_Encode4(112915), // Rule ID 3017 //
     /* 112828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 112831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 112839 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 112843 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 112847 */     // MIs[1] Operand 1
     /* 112847 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 112852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112854 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 112854 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 112857 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 112861 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112866 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 112870 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 112874 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112876 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 112879 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112883 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112888 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 112895 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 112900 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 112905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 112908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 112910 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112913 */     GIR_RootConstrainSelectedInstOperands,
     /* 112914 */     // GIR_Coverage, 3017,
     /* 112914 */     GIR_EraseRootFromParent_Done,
     /* 112915 */   // Label 1658: @112915
     /* 112915 */   GIM_Try, /*On fail goto*//*Label 1659*/ GIMT_Encode4(113007), // Rule ID 3025 //
     /* 112920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 112923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 112931 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 112935 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 112939 */     // MIs[1] Operand 1
     /* 112939 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 112944 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112946 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }))
     /* 112946 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 112949 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 112953 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112958 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 112962 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 112966 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112968 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 112971 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112975 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112980 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 112987 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 112992 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 112997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 113000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 113002 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113005 */     GIR_RootConstrainSelectedInstOperands,
     /* 113006 */     // GIR_Coverage, 3025,
     /* 113006 */     GIR_EraseRootFromParent_Done,
     /* 113007 */   // Label 1659: @113007
     /* 113007 */   GIM_Try, /*On fail goto*//*Label 1660*/ GIMT_Encode4(113099), // Rule ID 3089 //
     /* 113012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 113015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 113023 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113027 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 113031 */     // MIs[1] Operand 1
     /* 113031 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 113036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113038 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 113038 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 113041 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 113045 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113050 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 113054 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 113058 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 113060 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 113063 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113067 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113072 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 113079 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 113084 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 113089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 113092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 113094 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113097 */     GIR_RootConstrainSelectedInstOperands,
     /* 113098 */     // GIR_Coverage, 3089,
     /* 113098 */     GIR_EraseRootFromParent_Done,
     /* 113099 */   // Label 1660: @113099
     /* 113099 */   GIM_Try, /*On fail goto*//*Label 1661*/ GIMT_Encode4(113191), // Rule ID 3097 //
     /* 113104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 113107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 113115 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113119 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 113123 */     // MIs[1] Operand 1
     /* 113123 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 113128 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113130 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 113130 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 113133 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 113137 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113142 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 113146 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 113150 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 113152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 113155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113164 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 113171 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 113176 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 113181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 113184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 113186 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113189 */     GIR_RootConstrainSelectedInstOperands,
     /* 113190 */     // GIR_Coverage, 3097,
     /* 113190 */     GIR_EraseRootFromParent_Done,
     /* 113191 */   // Label 1661: @113191
     /* 113191 */   GIM_Try, /*On fail goto*//*Label 1662*/ GIMT_Encode4(113283), // Rule ID 3105 //
     /* 113196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 113199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 113207 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113211 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 113215 */     // MIs[1] Operand 1
     /* 113215 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 113220 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113222 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 113222 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 113225 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 113229 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113234 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 113238 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 113242 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 113244 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 113247 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113251 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113256 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 113263 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 113268 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 113273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 113276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 113278 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113281 */     GIR_RootConstrainSelectedInstOperands,
     /* 113282 */     // GIR_Coverage, 3105,
     /* 113282 */     GIR_EraseRootFromParent_Done,
     /* 113283 */   // Label 1662: @113283
     /* 113283 */   GIM_Try, /*On fail goto*//*Label 1663*/ GIMT_Encode4(113375), // Rule ID 3113 //
     /* 113288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 113291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 113299 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113303 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 113307 */     // MIs[1] Operand 1
     /* 113307 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 113312 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113314 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 113314 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 113317 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 113321 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113326 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 113330 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 113334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 113336 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 113339 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113343 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113348 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 113355 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 113360 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 113365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 113368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 113370 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113373 */     GIR_RootConstrainSelectedInstOperands,
     /* 113374 */     // GIR_Coverage, 3113,
     /* 113374 */     GIR_EraseRootFromParent_Done,
     /* 113375 */   // Label 1663: @113375
     /* 113375 */   GIM_Try, /*On fail goto*//*Label 1664*/ GIMT_Encode4(113467), // Rule ID 3121 //
     /* 113380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 113383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 113391 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113395 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 113399 */     // MIs[1] Operand 1
     /* 113399 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 113404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113406 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }))
     /* 113406 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 113409 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 113413 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113418 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 113422 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 113426 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 113428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 113431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113440 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 113447 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 113452 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 113457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 113460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 113462 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113465 */     GIR_RootConstrainSelectedInstOperands,
     /* 113466 */     // GIR_Coverage, 3121,
     /* 113466 */     GIR_EraseRootFromParent_Done,
     /* 113467 */   // Label 1664: @113467
     /* 113467 */   GIM_Try, /*On fail goto*//*Label 1665*/ GIMT_Encode4(113599), // Rule ID 3872 //
     /* 113472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 113475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 113483 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113487 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 113491 */     // MIs[1] Operand 1
     /* 113491 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 113496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113498 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 113498 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 113501 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 113505 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113510 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 113514 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 113518 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 113520 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 113523 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 113527 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113532 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 113535 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 113537 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 113540 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 113544 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113549 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 113552 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 113554 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 113557 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113561 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113566 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 113573 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 113578 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 113583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 113586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113588 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 113594 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 113597 */     GIR_RootConstrainSelectedInstOperands,
     /* 113598 */     // GIR_Coverage, 3872,
     /* 113598 */     GIR_EraseRootFromParent_Done,
     /* 113599 */   // Label 1665: @113599
     /* 113599 */   GIM_Try, /*On fail goto*//*Label 1666*/ GIMT_Encode4(113731), // Rule ID 3880 //
     /* 113604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 113607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 113615 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113619 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 113623 */     // MIs[1] Operand 1
     /* 113623 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 113628 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113630 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 113630 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 113633 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 113637 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113642 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 113646 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 113650 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 113652 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 113655 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 113659 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113664 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 113667 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 113669 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 113672 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 113676 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113681 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 113684 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 113686 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 113689 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113693 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113698 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 113705 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 113710 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 113715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 113718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113720 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113723 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 113726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 113729 */     GIR_RootConstrainSelectedInstOperands,
     /* 113730 */     // GIR_Coverage, 3880,
     /* 113730 */     GIR_EraseRootFromParent_Done,
     /* 113731 */   // Label 1666: @113731
     /* 113731 */   GIM_Try, /*On fail goto*//*Label 1667*/ GIMT_Encode4(113863), // Rule ID 3888 //
     /* 113736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 113739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 113747 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113751 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 113755 */     // MIs[1] Operand 1
     /* 113755 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 113760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113762 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 113762 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 113765 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 113769 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113774 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 113778 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 113782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 113784 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 113787 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 113791 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113796 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 113799 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 113801 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 113804 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 113808 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113813 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 113816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 113818 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 113821 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113825 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113830 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 113837 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 113842 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 113847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 113850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113852 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113855 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 113858 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 113861 */     GIR_RootConstrainSelectedInstOperands,
     /* 113862 */     // GIR_Coverage, 3888,
     /* 113862 */     GIR_EraseRootFromParent_Done,
     /* 113863 */   // Label 1667: @113863
     /* 113863 */   GIM_Try, /*On fail goto*//*Label 1668*/ GIMT_Encode4(113995), // Rule ID 3896 //
     /* 113868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 113871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 113879 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113883 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 113887 */     // MIs[1] Operand 1
     /* 113887 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 113892 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113894 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 113894 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 113897 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 113901 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113906 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 113910 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 113914 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 113916 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 113919 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 113923 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113928 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 113931 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 113933 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 113936 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 113940 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113945 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 113948 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 113950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 113953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113962 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 113969 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 113974 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 113979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 113982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113984 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113987 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 113990 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 113993 */     GIR_RootConstrainSelectedInstOperands,
     /* 113994 */     // GIR_Coverage, 3896,
     /* 113994 */     GIR_EraseRootFromParent_Done,
     /* 113995 */   // Label 1668: @113995
     /* 113995 */   GIM_Try, /*On fail goto*//*Label 1669*/ GIMT_Encode4(114127), // Rule ID 3904 //
     /* 114000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 114003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 114011 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 114015 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 114019 */     // MIs[1] Operand 1
     /* 114019 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 114024 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114026 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 114026 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 114029 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 114033 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114038 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 114042 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 114046 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114048 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 114051 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 114055 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114060 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 114063 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 114065 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 114068 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 114072 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114077 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 114080 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 114082 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 114085 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114089 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114094 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 114101 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 114106 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 114111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 114114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114116 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 114122 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 114125 */     GIR_RootConstrainSelectedInstOperands,
     /* 114126 */     // GIR_Coverage, 3904,
     /* 114126 */     GIR_EraseRootFromParent_Done,
     /* 114127 */   // Label 1669: @114127
     /* 114127 */   GIM_Try, /*On fail goto*//*Label 1670*/ GIMT_Encode4(114259), // Rule ID 3968 //
     /* 114132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 114135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 114143 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114147 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 114151 */     // MIs[1] Operand 1
     /* 114151 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 114156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114158 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 114158 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 114161 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 114165 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114170 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 114174 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 114178 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114180 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 114183 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 114187 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114192 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 114195 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 114197 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 114200 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 114204 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114209 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 114212 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 114214 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 114217 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114221 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114226 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 114233 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 114238 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 114243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 114246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114248 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114251 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 114254 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 114257 */     GIR_RootConstrainSelectedInstOperands,
     /* 114258 */     // GIR_Coverage, 3968,
     /* 114258 */     GIR_EraseRootFromParent_Done,
     /* 114259 */   // Label 1670: @114259
     /* 114259 */   GIM_Try, /*On fail goto*//*Label 1671*/ GIMT_Encode4(114391), // Rule ID 3976 //
     /* 114264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 114267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 114275 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114279 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 114283 */     // MIs[1] Operand 1
     /* 114283 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 114288 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114290 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 114290 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 114293 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 114297 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114302 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 114306 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 114310 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114312 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 114315 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 114319 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114324 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 114327 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 114329 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 114332 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 114336 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114341 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 114344 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 114346 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 114349 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114353 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114358 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 114365 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 114370 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 114375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 114378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114380 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114383 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 114386 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 114389 */     GIR_RootConstrainSelectedInstOperands,
     /* 114390 */     // GIR_Coverage, 3976,
     /* 114390 */     GIR_EraseRootFromParent_Done,
     /* 114391 */   // Label 1671: @114391
     /* 114391 */   GIM_Try, /*On fail goto*//*Label 1672*/ GIMT_Encode4(114523), // Rule ID 3984 //
     /* 114396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 114399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 114407 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114411 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 114415 */     // MIs[1] Operand 1
     /* 114415 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 114420 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114422 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 114422 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 114425 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 114429 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114434 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 114438 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 114442 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114444 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 114447 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 114451 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114456 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 114459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 114461 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 114464 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 114468 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114473 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 114476 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 114478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 114481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114490 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 114497 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 114502 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 114507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 114510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114512 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114515 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 114518 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 114521 */     GIR_RootConstrainSelectedInstOperands,
     /* 114522 */     // GIR_Coverage, 3984,
     /* 114522 */     GIR_EraseRootFromParent_Done,
     /* 114523 */   // Label 1672: @114523
     /* 114523 */   GIM_Try, /*On fail goto*//*Label 1673*/ GIMT_Encode4(114655), // Rule ID 3992 //
     /* 114528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 114531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 114539 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114543 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 114547 */     // MIs[1] Operand 1
     /* 114547 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 114552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114554 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 114554 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 114557 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 114561 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114566 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 114570 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 114574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114576 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 114579 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 114583 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114588 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 114591 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 114593 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 114596 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 114600 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114605 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 114608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 114610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 114613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114622 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 114629 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 114634 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 114639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 114642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114644 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114647 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 114650 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 114653 */     GIR_RootConstrainSelectedInstOperands,
     /* 114654 */     // GIR_Coverage, 3992,
     /* 114654 */     GIR_EraseRootFromParent_Done,
     /* 114655 */   // Label 1673: @114655
     /* 114655 */   GIM_Try, /*On fail goto*//*Label 1674*/ GIMT_Encode4(114787), // Rule ID 4000 //
     /* 114660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 114663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 114671 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114675 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 114679 */     // MIs[1] Operand 1
     /* 114679 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 114684 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114686 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 114686 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 114689 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 114693 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114698 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 114702 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 114706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114708 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 114711 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 114715 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114720 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 114723 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 114725 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 114728 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 114732 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114737 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 114740 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 114742 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 114745 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114749 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114754 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 114761 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 114766 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 114771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 114774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114776 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114779 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 114782 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 114785 */     GIR_RootConstrainSelectedInstOperands,
     /* 114786 */     // GIR_Coverage, 4000,
     /* 114786 */     GIR_EraseRootFromParent_Done,
     /* 114787 */   // Label 1674: @114787
     /* 114787 */   GIM_Try, /*On fail goto*//*Label 1675*/ GIMT_Encode4(114802), // Rule ID 2993 //
     /* 114792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 114795 */     // (anyext:{ *:[i64] } i1:{ *:[i1] }:$in)  =>  (SETBC8:{ *:[i64] } ?:{ *:[i1] }:$in)
     /* 114795 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SETBC8),
     /* 114800 */     GIR_RootConstrainSelectedInstOperands,
     /* 114801 */     // GIR_Coverage, 2993,
     /* 114801 */     GIR_Done,
     /* 114802 */   // Label 1675: @114802
     /* 114802 */   GIM_Try, /*On fail goto*//*Label 1676*/ GIMT_Encode4(114856), // Rule ID 3678 //
     /* 114807 */     // (anyext:{ *:[i64] } i1:{ *:[i1] }:$in)  =>  (SELECT_I8:{ *:[i64] } ?:{ *:[i1] }:$in, (LI8:{ *:[i64] } 1:{ *:[i64] }), (LI8:{ *:[i64] } 0:{ *:[i64] }))
     /* 114807 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 114810 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 114814 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114819 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 114822 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114824 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 114827 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 114831 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114836 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 114839 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 114844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114846 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 114848 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114851 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 114854 */     GIR_RootConstrainSelectedInstOperands,
     /* 114855 */     // GIR_Coverage, 3678,
     /* 114855 */     GIR_EraseRootFromParent_Done,
     /* 114856 */   // Label 1676: @114856
     /* 114856 */   GIM_Reject,
     /* 114857 */ // Label 1584: @114857
     /* 114857 */ GIM_Reject,
     /* 114858 */ // Label 1490: @114858
     /* 114858 */ GIM_Reject,
     /* 114859 */ // Label 22: @114859
     /* 114859 */ GIM_Try, /*On fail goto*//*Label 1677*/ GIMT_Encode4(115044),
     /* 114864 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 114867 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1680*/ GIMT_Encode4(114978),
     /* 114878 */   /*GILLT_s32*//*Label 1678*/ GIMT_Encode4(114886),
     /* 114882 */   /*GILLT_s64*//*Label 1679*/ GIMT_Encode4(114932),
     /* 114886 */   // Label 1678: @114886
     /* 114886 */   GIM_Try, /*On fail goto*//*Label 1681*/ GIMT_Encode4(114931), // Rule ID 1174 //
     /* 114891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 114895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 114903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 114907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 114911 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 114915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114917 */     // (trunc:{ *:[i1] } (xor:{ *:[i32] } i32:{ *:[i32] }:$in, -1:{ *:[i32] }))  =>  (ANDI_rec_1_EQ_BIT:{ *:[i1] }:{ *:[i32] } i32:{ *:[i32] }:$in)
     /* 114917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ANDI_rec_1_EQ_BIT),
     /* 114920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // in
     /* 114926 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR0*/0,
     /* 114929 */     GIR_RootConstrainSelectedInstOperands,
     /* 114930 */     // GIR_Coverage, 1174,
     /* 114930 */     GIR_EraseRootFromParent_Done,
     /* 114931 */   // Label 1681: @114931
     /* 114931 */   GIM_Reject,
     /* 114932 */   // Label 1679: @114932
     /* 114932 */   GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(114977), // Rule ID 1176 //
     /* 114937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 114941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 114949 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 114953 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114957 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 114961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114963 */     // (trunc:{ *:[i1] } (xor:{ *:[i64] } i64:{ *:[i64] }:$in, -1:{ *:[i64] }))  =>  (ANDI_rec_1_EQ_BIT8:{ *:[i1] }:{ *:[i32] } i64:{ *:[i64] }:$in)
     /* 114963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ANDI_rec_1_EQ_BIT8),
     /* 114966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // in
     /* 114972 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR0*/0,
     /* 114975 */     GIR_RootConstrainSelectedInstOperands,
     /* 114976 */     // GIR_Coverage, 1176,
     /* 114976 */     GIR_EraseRootFromParent_Done,
     /* 114977 */   // Label 1682: @114977
     /* 114977 */   GIM_Reject,
     /* 114978 */   // Label 1680: @114978
     /* 114978 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1685*/ GIMT_Encode4(115043),
     /* 114989 */   /*GILLT_s32*//*Label 1683*/ GIMT_Encode4(114997),
     /* 114993 */   /*GILLT_s64*//*Label 1684*/ GIMT_Encode4(115020),
     /* 114997 */   // Label 1683: @114997
     /* 114997 */   GIM_Try, /*On fail goto*//*Label 1686*/ GIMT_Encode4(115019), // Rule ID 1175 //
     /* 115002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 115006 */     // (trunc:{ *:[i1] } i32:{ *:[i32] }:$in)  =>  (ANDI_rec_1_GT_BIT:{ *:[i1] }:{ *:[i32] } i32:{ *:[i32] }:$in)
     /* 115006 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::ANDI_rec_1_GT_BIT),
     /* 115011 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(PPC::CR0), GIMT_Encode2(RegState::Dead),
     /* 115017 */     GIR_RootConstrainSelectedInstOperands,
     /* 115018 */     // GIR_Coverage, 1175,
     /* 115018 */     GIR_Done,
     /* 115019 */   // Label 1686: @115019
     /* 115019 */   GIM_Reject,
     /* 115020 */   // Label 1684: @115020
     /* 115020 */   GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(115042), // Rule ID 1177 //
     /* 115025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 115029 */     // (trunc:{ *:[i1] } i64:{ *:[i64] }:$in)  =>  (ANDI_rec_1_GT_BIT8:{ *:[i1] }:{ *:[i32] } i64:{ *:[i64] }:$in)
     /* 115029 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::ANDI_rec_1_GT_BIT8),
     /* 115034 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(PPC::CR0), GIMT_Encode2(RegState::Dead),
     /* 115040 */     GIR_RootConstrainSelectedInstOperands,
     /* 115041 */     // GIR_Coverage, 1177,
     /* 115041 */     GIR_Done,
     /* 115042 */   // Label 1687: @115042
     /* 115042 */   GIM_Reject,
     /* 115043 */   // Label 1685: @115043
     /* 115043 */   GIM_Reject,
     /* 115044 */ // Label 1677: @115044
     /* 115044 */ GIM_Reject,
     /* 115045 */ // Label 23: @115045
     /* 115045 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 1691*/ GIMT_Encode4(115196),
     /* 115056 */ /*GILLT_s1*//*Label 1688*/ GIMT_Encode4(115068),
     /* 115060 */ /*GILLT_s32*//*Label 1689*/ GIMT_Encode4(115148),
     /* 115064 */ /*GILLT_s64*//*Label 1690*/ GIMT_Encode4(115172),
     /* 115068 */ // Label 1688: @115068
     /* 115068 */ GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(115147),
     /* 115073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 115077 */   GIM_Try, /*On fail goto*//*Label 1693*/ GIMT_Encode4(115100), // Rule ID 184 //
     /* 115082 */     // MIs[0] Operand 1
     /* 115082 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(1),
     /* 115093 */     // 1:{ *:[i1] }  =>  (CRSET:{ *:[i1] })
     /* 115093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRSET),
     /* 115096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 115098 */     GIR_RootConstrainSelectedInstOperands,
     /* 115099 */     // GIR_Coverage, 184,
     /* 115099 */     GIR_EraseRootFromParent_Done,
     /* 115100 */   // Label 1693: @115100
     /* 115100 */   GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(115123), // Rule ID 185 //
     /* 115105 */     // MIs[0] Operand 1
     /* 115105 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(0),
     /* 115116 */     // 0:{ *:[i1] }  =>  (CRUNSET:{ *:[i1] })
     /* 115116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRUNSET),
     /* 115119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 115121 */     GIR_RootConstrainSelectedInstOperands,
     /* 115122 */     // GIR_Coverage, 185,
     /* 115122 */     GIR_EraseRootFromParent_Done,
     /* 115123 */   // Label 1694: @115123
     /* 115123 */   GIM_Try, /*On fail goto*//*Label 1695*/ GIMT_Encode4(115146), // Rule ID 3672 //
     /* 115128 */     // MIs[0] Operand 1
     /* 115128 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(-1),
     /* 115139 */     // -1:{ *:[i1] }  =>  (CRSET:{ *:[i1] })
     /* 115139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRSET),
     /* 115142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 115144 */     GIR_RootConstrainSelectedInstOperands,
     /* 115145 */     // GIR_Coverage, 3672,
     /* 115145 */     GIR_EraseRootFromParent_Done,
     /* 115146 */   // Label 1695: @115146
     /* 115146 */   GIM_Reject,
     /* 115147 */ // Label 1692: @115147
     /* 115147 */ GIM_Reject,
     /* 115148 */ // Label 1689: @115148
     /* 115148 */ GIM_Try, /*On fail goto*//*Label 1696*/ GIMT_Encode4(115171), // Rule ID 113 //
     /* 115153 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 115157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 115161 */   // MIs[0] Operand 1
     /* 115161 */   // No operand predicates
     /* 115161 */   // (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$D  =>  (LI:{ *:[i32] } (imm:{ *:[i32] }):$D)
     /* 115161 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 115164 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 115166 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // D
     /* 115169 */   GIR_RootConstrainSelectedInstOperands,
     /* 115170 */   // GIR_Coverage, 113,
     /* 115170 */   GIR_EraseRootFromParent_Done,
     /* 115171 */ // Label 1696: @115171
     /* 115171 */ GIM_Reject,
     /* 115172 */ // Label 1690: @115172
     /* 115172 */ GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(115195), // Rule ID 643 //
     /* 115177 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 115181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 115185 */   // MIs[0] Operand 1
     /* 115185 */   // No operand predicates
     /* 115185 */   // (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$D  =>  (LI8:{ *:[i64] } (imm:{ *:[i64] }):$D)
     /* 115185 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 115188 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 115190 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // D
     /* 115193 */   GIR_RootConstrainSelectedInstOperands,
     /* 115194 */   // GIR_Coverage, 643,
     /* 115194 */   GIR_EraseRootFromParent_Done,
     /* 115195 */ // Label 1697: @115195
     /* 115195 */ GIM_Reject,
     /* 115196 */ // Label 1691: @115196
     /* 115196 */ GIM_Reject,
     /* 115197 */ // Label 24: @115197
     /* 115197 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1700*/ GIMT_Encode4(130228),
     /* 115208 */ /*GILLT_s32*//*Label 1698*/ GIMT_Encode4(115216),
     /* 115212 */ /*GILLT_s64*//*Label 1699*/ GIMT_Encode4(122495),
     /* 115216 */ // Label 1698: @115216
     /* 115216 */ GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(122494),
     /* 115221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 115224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 115228 */   GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(115331), // Rule ID 3038 //
     /* 115233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 115236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 115244 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 115248 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 115252 */     // MIs[1] Operand 1
     /* 115252 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 115257 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 115261 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115265 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 115269 */     // MIs[2] Operand 1
     /* 115269 */     // No operand predicates
     /* 115269 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115271 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }))
     /* 115271 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 115274 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 115278 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115283 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 115287 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 115290 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 115295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115304 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 115311 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 115316 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 115321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 115324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 115326 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115329 */     GIR_RootConstrainSelectedInstOperands,
     /* 115330 */     // GIR_Coverage, 3038,
     /* 115330 */     GIR_EraseRootFromParent_Done,
     /* 115331 */   // Label 1702: @115331
     /* 115331 */   GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(115434), // Rule ID 3054 //
     /* 115336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 115339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 115347 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 115351 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 115355 */     // MIs[1] Operand 1
     /* 115355 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 115360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 115364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115368 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 115372 */     // MIs[2] Operand 1
     /* 115372 */     // No operand predicates
     /* 115372 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115374 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }))
     /* 115374 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 115377 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 115381 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115386 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 115390 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 115393 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115395 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 115398 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115402 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115407 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 115414 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 115419 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 115424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 115427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 115429 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115432 */     GIR_RootConstrainSelectedInstOperands,
     /* 115433 */     // GIR_Coverage, 3054,
     /* 115433 */     GIR_EraseRootFromParent_Done,
     /* 115434 */   // Label 1703: @115434
     /* 115434 */   GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(115537), // Rule ID 3062 //
     /* 115439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 115442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 115450 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 115454 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 115458 */     // MIs[1] Operand 1
     /* 115458 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 115463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 115467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115471 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 115475 */     // MIs[2] Operand 1
     /* 115475 */     // No operand predicates
     /* 115475 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115477 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }))
     /* 115477 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 115480 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 115484 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115489 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 115493 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 115496 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115498 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 115501 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115505 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115510 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 115517 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 115522 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 115527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 115530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 115532 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115535 */     GIR_RootConstrainSelectedInstOperands,
     /* 115536 */     // GIR_Coverage, 3062,
     /* 115536 */     GIR_EraseRootFromParent_Done,
     /* 115537 */   // Label 1704: @115537
     /* 115537 */   GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(115640), // Rule ID 3134 //
     /* 115542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 115545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 115553 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115557 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 115561 */     // MIs[1] Operand 1
     /* 115561 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 115566 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 115570 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115574 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 115578 */     // MIs[2] Operand 1
     /* 115578 */     // No operand predicates
     /* 115578 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115580 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }))
     /* 115580 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 115583 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 115587 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115592 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 115596 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 115599 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115601 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 115604 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115608 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115613 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 115620 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 115625 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 115630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 115633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 115635 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115638 */     GIR_RootConstrainSelectedInstOperands,
     /* 115639 */     // GIR_Coverage, 3134,
     /* 115639 */     GIR_EraseRootFromParent_Done,
     /* 115640 */   // Label 1705: @115640
     /* 115640 */   GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(115743), // Rule ID 3150 //
     /* 115645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 115648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 115656 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115660 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 115664 */     // MIs[1] Operand 1
     /* 115664 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 115669 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 115673 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115677 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 115681 */     // MIs[2] Operand 1
     /* 115681 */     // No operand predicates
     /* 115681 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115683 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }))
     /* 115683 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 115686 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 115690 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115695 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 115699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 115702 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115704 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 115707 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115711 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115716 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 115723 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 115728 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 115733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 115736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 115738 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115741 */     GIR_RootConstrainSelectedInstOperands,
     /* 115742 */     // GIR_Coverage, 3150,
     /* 115742 */     GIR_EraseRootFromParent_Done,
     /* 115743 */   // Label 1706: @115743
     /* 115743 */   GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(115846), // Rule ID 3158 //
     /* 115748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 115751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 115759 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115763 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 115767 */     // MIs[1] Operand 1
     /* 115767 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 115772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 115776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115780 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 115784 */     // MIs[2] Operand 1
     /* 115784 */     // No operand predicates
     /* 115784 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115786 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }))
     /* 115786 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 115789 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 115793 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115798 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 115802 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 115805 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115807 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 115810 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115814 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115819 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 115826 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 115831 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 115836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 115839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 115841 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115844 */     GIR_RootConstrainSelectedInstOperands,
     /* 115845 */     // GIR_Coverage, 3158,
     /* 115845 */     GIR_EraseRootFromParent_Done,
     /* 115846 */   // Label 1707: @115846
     /* 115846 */   GIM_Try, /*On fail goto*//*Label 1708*/ GIMT_Encode4(115989), // Rule ID 3820 //
     /* 115851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 115854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 115862 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 115866 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 115870 */     // MIs[1] Operand 1
     /* 115870 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 115875 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 115879 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115883 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 115887 */     // MIs[2] Operand 1
     /* 115887 */     // No operand predicates
     /* 115887 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115889 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 115889 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 115892 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 115896 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115901 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 115905 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 115908 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115910 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 115913 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 115917 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115922 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 115925 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 115927 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 115930 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 115934 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115939 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 115942 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 115944 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 115947 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115951 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115956 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 115963 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 115968 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 115973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 115976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115978 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115981 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 115984 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 115987 */     GIR_RootConstrainSelectedInstOperands,
     /* 115988 */     // GIR_Coverage, 3820,
     /* 115988 */     GIR_EraseRootFromParent_Done,
     /* 115989 */   // Label 1708: @115989
     /* 115989 */   GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(116132), // Rule ID 3836 //
     /* 115994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 115997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 116005 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 116009 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 116013 */     // MIs[1] Operand 1
     /* 116013 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 116018 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 116022 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116026 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 116030 */     // MIs[2] Operand 1
     /* 116030 */     // No operand predicates
     /* 116030 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 116032 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 116032 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 116035 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 116039 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116044 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 116048 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 116051 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 116053 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 116056 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 116060 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116065 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 116068 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 116070 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 116073 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 116077 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116082 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 116085 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 116087 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 116090 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116094 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116099 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 116106 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 116111 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 116116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 116119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116121 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116124 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 116127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 116130 */     GIR_RootConstrainSelectedInstOperands,
     /* 116131 */     // GIR_Coverage, 3836,
     /* 116131 */     GIR_EraseRootFromParent_Done,
     /* 116132 */   // Label 1709: @116132
     /* 116132 */   GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(116275), // Rule ID 3844 //
     /* 116137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 116140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 116148 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 116152 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 116156 */     // MIs[1] Operand 1
     /* 116156 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 116161 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 116165 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116169 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 116173 */     // MIs[2] Operand 1
     /* 116173 */     // No operand predicates
     /* 116173 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 116175 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 116175 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 116178 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 116182 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116187 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 116191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 116194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 116196 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 116199 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 116203 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116208 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 116211 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 116213 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 116216 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 116220 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116225 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 116228 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 116230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 116233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116242 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 116249 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 116254 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 116259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 116262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116264 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116267 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 116270 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 116273 */     GIR_RootConstrainSelectedInstOperands,
     /* 116274 */     // GIR_Coverage, 3844,
     /* 116274 */     GIR_EraseRootFromParent_Done,
     /* 116275 */   // Label 1710: @116275
     /* 116275 */   GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(116418), // Rule ID 3916 //
     /* 116280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 116283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 116291 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 116295 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 116299 */     // MIs[1] Operand 1
     /* 116299 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 116304 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 116308 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116312 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 116316 */     // MIs[2] Operand 1
     /* 116316 */     // No operand predicates
     /* 116316 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 116318 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 116318 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 116321 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 116325 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116330 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 116334 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 116337 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 116339 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 116342 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 116346 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116351 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 116354 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 116356 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 116359 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 116363 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116368 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 116371 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 116373 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 116376 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116380 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116385 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 116392 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 116397 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 116402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 116405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116407 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116410 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 116413 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 116416 */     GIR_RootConstrainSelectedInstOperands,
     /* 116417 */     // GIR_Coverage, 3916,
     /* 116417 */     GIR_EraseRootFromParent_Done,
     /* 116418 */   // Label 1711: @116418
     /* 116418 */   GIM_Try, /*On fail goto*//*Label 1712*/ GIMT_Encode4(116561), // Rule ID 3932 //
     /* 116423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 116426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 116434 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 116438 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 116442 */     // MIs[1] Operand 1
     /* 116442 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 116447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 116451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116455 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 116459 */     // MIs[2] Operand 1
     /* 116459 */     // No operand predicates
     /* 116459 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 116461 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 116461 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 116464 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 116468 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116473 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 116477 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 116480 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 116482 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 116485 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 116489 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116494 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 116497 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 116499 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 116502 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 116506 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116511 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 116514 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 116516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 116519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116528 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 116535 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 116540 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 116545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 116548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116550 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116553 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 116556 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 116559 */     GIR_RootConstrainSelectedInstOperands,
     /* 116560 */     // GIR_Coverage, 3932,
     /* 116560 */     GIR_EraseRootFromParent_Done,
     /* 116561 */   // Label 1712: @116561
     /* 116561 */   GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(116704), // Rule ID 3940 //
     /* 116566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 116569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 116577 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 116581 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 116585 */     // MIs[1] Operand 1
     /* 116585 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 116590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 116594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116598 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 116602 */     // MIs[2] Operand 1
     /* 116602 */     // No operand predicates
     /* 116602 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 116604 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 116604 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 116607 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 116611 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116616 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 116620 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 116623 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 116625 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 116628 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 116632 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116637 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 116640 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 116642 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 116645 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 116649 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116654 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 116657 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 116659 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 116662 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116666 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116671 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 116678 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 116683 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 116688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 116691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116693 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116696 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 116699 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 116702 */     GIR_RootConstrainSelectedInstOperands,
     /* 116703 */     // GIR_Coverage, 3940,
     /* 116703 */     GIR_EraseRootFromParent_Done,
     /* 116704 */   // Label 1713: @116704
     /* 116704 */   GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(116796), // Rule ID 3182 //
     /* 116709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 116712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 116720 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 116724 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 116728 */     // MIs[1] Operand 1
     /* 116728 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 116733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116735 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }))
     /* 116735 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 116738 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 116742 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116747 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 116751 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 116755 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 116757 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 116760 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116764 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116769 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 116776 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 116781 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 116786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 116789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 116791 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116794 */     GIR_RootConstrainSelectedInstOperands,
     /* 116795 */     // GIR_Coverage, 3182,
     /* 116795 */     GIR_EraseRootFromParent_Done,
     /* 116796 */   // Label 1714: @116796
     /* 116796 */   GIM_Try, /*On fail goto*//*Label 1715*/ GIMT_Encode4(116888), // Rule ID 3198 //
     /* 116801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 116804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 116812 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 116816 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 116820 */     // MIs[1] Operand 1
     /* 116820 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 116825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116827 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }))
     /* 116827 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 116830 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 116834 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116839 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 116843 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 116847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 116849 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 116852 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116856 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116861 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 116868 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 116873 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 116878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 116881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 116883 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116886 */     GIR_RootConstrainSelectedInstOperands,
     /* 116887 */     // GIR_Coverage, 3198,
     /* 116887 */     GIR_EraseRootFromParent_Done,
     /* 116888 */   // Label 1715: @116888
     /* 116888 */   GIM_Try, /*On fail goto*//*Label 1716*/ GIMT_Encode4(116980), // Rule ID 3214 //
     /* 116893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 116896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 116904 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 116908 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 116912 */     // MIs[1] Operand 1
     /* 116912 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 116917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116919 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }))
     /* 116919 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 116922 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 116926 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116931 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 116935 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 116939 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 116941 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 116944 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116948 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116953 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 116960 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 116965 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 116970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 116973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 116975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116978 */     GIR_RootConstrainSelectedInstOperands,
     /* 116979 */     // GIR_Coverage, 3214,
     /* 116979 */     GIR_EraseRootFromParent_Done,
     /* 116980 */   // Label 1716: @116980
     /* 116980 */   GIM_Try, /*On fail goto*//*Label 1717*/ GIMT_Encode4(117072), // Rule ID 3230 //
     /* 116985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 116988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 116996 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 117000 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 117004 */     // MIs[1] Operand 1
     /* 117004 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 117009 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117011 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }))
     /* 117011 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117014 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 117018 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117023 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 117027 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 117031 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117033 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 117036 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117040 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117045 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 117052 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 117057 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 117062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 117065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 117067 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117070 */     GIR_RootConstrainSelectedInstOperands,
     /* 117071 */     // GIR_Coverage, 3230,
     /* 117071 */     GIR_EraseRootFromParent_Done,
     /* 117072 */   // Label 1717: @117072
     /* 117072 */   GIM_Try, /*On fail goto*//*Label 1718*/ GIMT_Encode4(117164), // Rule ID 3238 //
     /* 117077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 117080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 117088 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 117092 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 117096 */     // MIs[1] Operand 1
     /* 117096 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 117101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117103 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }))
     /* 117103 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117106 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 117110 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117115 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 117119 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 117123 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117125 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 117128 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117132 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117137 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 117144 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 117149 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 117154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 117157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 117159 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117162 */     GIR_RootConstrainSelectedInstOperands,
     /* 117163 */     // GIR_Coverage, 3238,
     /* 117163 */     GIR_EraseRootFromParent_Done,
     /* 117164 */   // Label 1718: @117164
     /* 117164 */   GIM_Try, /*On fail goto*//*Label 1719*/ GIMT_Encode4(117256), // Rule ID 3254 //
     /* 117169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 117172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 117180 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 117184 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 117188 */     // MIs[1] Operand 1
     /* 117188 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 117193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117195 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }))
     /* 117195 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117198 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 117202 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117207 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 117211 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 117215 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117217 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 117220 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117224 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117229 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 117236 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 117241 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 117246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 117249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 117251 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117254 */     GIR_RootConstrainSelectedInstOperands,
     /* 117255 */     // GIR_Coverage, 3254,
     /* 117255 */     GIR_EraseRootFromParent_Done,
     /* 117256 */   // Label 1719: @117256
     /* 117256 */   GIM_Try, /*On fail goto*//*Label 1720*/ GIMT_Encode4(117348), // Rule ID 3270 //
     /* 117261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 117264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 117272 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 117276 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 117280 */     // MIs[1] Operand 1
     /* 117280 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 117285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117287 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }))
     /* 117287 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117290 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 117294 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117299 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 117303 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 117307 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117309 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 117312 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117316 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117321 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 117328 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 117333 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 117338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 117341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 117343 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117346 */     GIR_RootConstrainSelectedInstOperands,
     /* 117347 */     // GIR_Coverage, 3270,
     /* 117347 */     GIR_EraseRootFromParent_Done,
     /* 117348 */   // Label 1720: @117348
     /* 117348 */   GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(117440), // Rule ID 3286 //
     /* 117353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 117356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 117364 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 117368 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 117372 */     // MIs[1] Operand 1
     /* 117372 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 117377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117379 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }))
     /* 117379 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117382 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 117386 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117391 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 117395 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 117399 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117401 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 117404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117408 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117413 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 117420 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 117425 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 117430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 117433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 117435 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117438 */     GIR_RootConstrainSelectedInstOperands,
     /* 117439 */     // GIR_Coverage, 3286,
     /* 117439 */     GIR_EraseRootFromParent_Done,
     /* 117440 */   // Label 1721: @117440
     /* 117440 */   GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(117532), // Rule ID 3294 //
     /* 117445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 117448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 117456 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 117460 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 117464 */     // MIs[1] Operand 1
     /* 117464 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 117469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117471 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }))
     /* 117471 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117474 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 117478 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117483 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 117487 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 117491 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117493 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 117496 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117500 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117505 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 117512 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 117517 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 117522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 117525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 117527 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117530 */     GIR_RootConstrainSelectedInstOperands,
     /* 117531 */     // GIR_Coverage, 3294,
     /* 117531 */     GIR_EraseRootFromParent_Done,
     /* 117532 */   // Label 1722: @117532
     /* 117532 */   GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(117624), // Rule ID 3310 //
     /* 117537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 117540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 117548 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 117552 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 117556 */     // MIs[1] Operand 1
     /* 117556 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 117561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117563 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }))
     /* 117563 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117566 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 117570 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117575 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 117579 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 117583 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117585 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 117588 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117592 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117597 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 117604 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 117609 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 117614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 117617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 117619 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117622 */     GIR_RootConstrainSelectedInstOperands,
     /* 117623 */     // GIR_Coverage, 3310,
     /* 117623 */     GIR_EraseRootFromParent_Done,
     /* 117624 */   // Label 1723: @117624
     /* 117624 */   GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(117716), // Rule ID 3326 //
     /* 117629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 117632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 117640 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 117644 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 117648 */     // MIs[1] Operand 1
     /* 117648 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 117653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117655 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }))
     /* 117655 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117658 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 117662 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117667 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 117671 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 117675 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117677 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 117680 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117684 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117689 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 117696 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 117701 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 117706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 117709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 117711 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117714 */     GIR_RootConstrainSelectedInstOperands,
     /* 117715 */     // GIR_Coverage, 3326,
     /* 117715 */     GIR_EraseRootFromParent_Done,
     /* 117716 */   // Label 1724: @117716
     /* 117716 */   GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(117808), // Rule ID 3342 //
     /* 117721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 117724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 117732 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 117736 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 117740 */     // MIs[1] Operand 1
     /* 117740 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 117745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117747 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }))
     /* 117747 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117750 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 117754 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117759 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 117763 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 117767 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117769 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 117772 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117776 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117781 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 117788 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 117793 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 117798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 117801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 117803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117806 */     GIR_RootConstrainSelectedInstOperands,
     /* 117807 */     // GIR_Coverage, 3342,
     /* 117807 */     GIR_EraseRootFromParent_Done,
     /* 117808 */   // Label 1725: @117808
     /* 117808 */   GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(117940), // Rule ID 4022 //
     /* 117813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 117816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 117824 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 117828 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 117832 */     // MIs[1] Operand 1
     /* 117832 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 117837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117839 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 117839 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117842 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 117846 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117851 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 117855 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 117859 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117861 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 117864 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 117868 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117873 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 117876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 117878 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 117881 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 117885 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117890 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 117893 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 117895 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 117898 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117902 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117907 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 117914 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 117919 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 117924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 117927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117929 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117932 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 117935 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 117938 */     GIR_RootConstrainSelectedInstOperands,
     /* 117939 */     // GIR_Coverage, 4022,
     /* 117939 */     GIR_EraseRootFromParent_Done,
     /* 117940 */   // Label 1726: @117940
     /* 117940 */   GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(118072), // Rule ID 4054 //
     /* 117945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 117948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 117956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 117960 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 117964 */     // MIs[1] Operand 1
     /* 117964 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 117969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117971 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 117971 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117974 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 117978 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117983 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 117987 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 117991 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117993 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 117996 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118000 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118005 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 118008 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 118010 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 118013 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118017 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118022 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 118025 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 118027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 118030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118039 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 118046 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 118051 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 118056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 118059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118061 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118064 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 118067 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 118070 */     GIR_RootConstrainSelectedInstOperands,
     /* 118071 */     // GIR_Coverage, 4054,
     /* 118071 */     GIR_EraseRootFromParent_Done,
     /* 118072 */   // Label 1727: @118072
     /* 118072 */   GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(118204), // Rule ID 4086 //
     /* 118077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 118080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 118088 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 118092 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 118096 */     // MIs[1] Operand 1
     /* 118096 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 118101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118103 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 118103 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 118106 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 118110 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118115 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 118119 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 118123 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 118125 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 118128 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118132 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118137 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 118140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 118142 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 118145 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118149 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118154 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 118157 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 118159 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 118162 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118166 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118171 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 118178 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 118183 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 118188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 118191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118193 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118196 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 118199 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 118202 */     GIR_RootConstrainSelectedInstOperands,
     /* 118203 */     // GIR_Coverage, 4086,
     /* 118203 */     GIR_EraseRootFromParent_Done,
     /* 118204 */   // Label 1728: @118204
     /* 118204 */   GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(118336), // Rule ID 4118 //
     /* 118209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 118212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 118220 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 118224 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 118228 */     // MIs[1] Operand 1
     /* 118228 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 118233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118235 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 118235 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 118238 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 118242 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118247 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 118251 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 118255 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 118257 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 118260 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118264 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118269 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 118272 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 118274 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 118277 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118281 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118286 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 118289 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 118291 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 118294 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118298 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118303 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 118310 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 118315 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 118320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 118323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118325 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118328 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 118331 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 118334 */     GIR_RootConstrainSelectedInstOperands,
     /* 118335 */     // GIR_Coverage, 4118,
     /* 118335 */     GIR_EraseRootFromParent_Done,
     /* 118336 */   // Label 1729: @118336
     /* 118336 */   GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(118468), // Rule ID 4134 //
     /* 118341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 118344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 118352 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118356 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 118360 */     // MIs[1] Operand 1
     /* 118360 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 118365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118367 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 118367 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 118370 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 118374 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118379 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 118383 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 118387 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 118389 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 118392 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118396 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118401 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 118404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 118406 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 118409 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118413 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118418 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 118421 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 118423 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 118426 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118430 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118435 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 118442 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 118447 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 118452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 118455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118457 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 118463 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 118466 */     GIR_RootConstrainSelectedInstOperands,
     /* 118467 */     // GIR_Coverage, 4134,
     /* 118467 */     GIR_EraseRootFromParent_Done,
     /* 118468 */   // Label 1730: @118468
     /* 118468 */   GIM_Try, /*On fail goto*//*Label 1731*/ GIMT_Encode4(118600), // Rule ID 4166 //
     /* 118473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 118476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 118484 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118488 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 118492 */     // MIs[1] Operand 1
     /* 118492 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 118497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118499 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 118499 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 118502 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 118506 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118511 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 118515 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 118519 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 118521 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 118524 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118528 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118533 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 118536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 118538 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 118541 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118545 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118550 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 118553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 118555 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 118558 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118562 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118567 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 118574 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 118579 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 118584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 118587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118592 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 118595 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 118598 */     GIR_RootConstrainSelectedInstOperands,
     /* 118599 */     // GIR_Coverage, 4166,
     /* 118599 */     GIR_EraseRootFromParent_Done,
     /* 118600 */   // Label 1731: @118600
     /* 118600 */   GIM_Try, /*On fail goto*//*Label 1732*/ GIMT_Encode4(118732), // Rule ID 4198 //
     /* 118605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 118608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 118616 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118620 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 118624 */     // MIs[1] Operand 1
     /* 118624 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 118629 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118631 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 118631 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 118634 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 118638 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118643 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 118647 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 118651 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 118653 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 118656 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118660 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118665 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 118668 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 118670 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 118673 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118677 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118682 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 118685 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 118687 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 118690 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118694 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118699 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 118706 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 118711 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 118716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 118719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118721 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118724 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 118727 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 118730 */     GIR_RootConstrainSelectedInstOperands,
     /* 118731 */     // GIR_Coverage, 4198,
     /* 118731 */     GIR_EraseRootFromParent_Done,
     /* 118732 */   // Label 1732: @118732
     /* 118732 */   GIM_Try, /*On fail goto*//*Label 1733*/ GIMT_Encode4(118864), // Rule ID 4230 //
     /* 118737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 118740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 118748 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118752 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 118756 */     // MIs[1] Operand 1
     /* 118756 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 118761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118763 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 118763 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 118766 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 118770 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118775 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 118779 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 118783 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 118785 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 118788 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118792 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118797 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 118800 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 118802 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 118805 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118809 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118814 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 118817 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 118819 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 118822 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118826 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118831 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 118838 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 118843 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 118848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 118851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118856 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 118859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 118862 */     GIR_RootConstrainSelectedInstOperands,
     /* 118863 */     // GIR_Coverage, 4230,
     /* 118863 */     GIR_EraseRootFromParent_Done,
     /* 118864 */   // Label 1733: @118864
     /* 118864 */   GIM_Try, /*On fail goto*//*Label 1734*/ GIMT_Encode4(118996), // Rule ID 4260 //
     /* 118869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 118872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 118880 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 118884 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 118888 */     // MIs[1] Operand 1
     /* 118888 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 118893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118895 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 118895 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 118898 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 118902 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118907 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 118911 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 118915 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 118917 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 118920 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118924 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118929 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 118932 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 118934 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 118937 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118941 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118946 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 118949 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 118951 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 118954 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118958 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118963 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 118970 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 118975 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 118980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 118983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118985 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118988 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 118991 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 118994 */     GIR_RootConstrainSelectedInstOperands,
     /* 118995 */     // GIR_Coverage, 4260,
     /* 118995 */     GIR_EraseRootFromParent_Done,
     /* 118996 */   // Label 1734: @118996
     /* 118996 */   GIM_Try, /*On fail goto*//*Label 1735*/ GIMT_Encode4(119128), // Rule ID 4292 //
     /* 119001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 119004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 119012 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 119016 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 119020 */     // MIs[1] Operand 1
     /* 119020 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 119025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119027 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 119027 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119030 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 119034 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119039 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 119043 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 119047 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119049 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 119052 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119056 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119061 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 119064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 119066 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 119069 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119073 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119078 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 119081 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 119083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 119086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119095 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 119102 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 119107 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 119112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 119115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119117 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119120 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 119123 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 119126 */     GIR_RootConstrainSelectedInstOperands,
     /* 119127 */     // GIR_Coverage, 4292,
     /* 119127 */     GIR_EraseRootFromParent_Done,
     /* 119128 */   // Label 1735: @119128
     /* 119128 */   GIM_Try, /*On fail goto*//*Label 1736*/ GIMT_Encode4(119260), // Rule ID 4324 //
     /* 119133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 119136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 119144 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 119148 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 119152 */     // MIs[1] Operand 1
     /* 119152 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 119157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119159 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 119159 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119162 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 119166 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119171 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 119175 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 119179 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119181 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 119184 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119188 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119193 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 119196 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 119198 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 119201 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119205 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119210 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 119213 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 119215 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 119218 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119222 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119227 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 119234 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 119239 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 119244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 119247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119252 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 119255 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 119258 */     GIR_RootConstrainSelectedInstOperands,
     /* 119259 */     // GIR_Coverage, 4324,
     /* 119259 */     GIR_EraseRootFromParent_Done,
     /* 119260 */   // Label 1736: @119260
     /* 119260 */   GIM_Try, /*On fail goto*//*Label 1737*/ GIMT_Encode4(119392), // Rule ID 4356 //
     /* 119265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 119268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 119276 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 119280 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 119284 */     // MIs[1] Operand 1
     /* 119284 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 119289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119291 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 119291 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119294 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 119298 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119303 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 119307 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 119311 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119313 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 119316 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119320 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119325 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 119328 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 119330 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 119333 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119337 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119342 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 119345 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 119347 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 119350 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119354 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119359 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 119366 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 119371 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 119376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 119379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119381 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119384 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 119387 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 119390 */     GIR_RootConstrainSelectedInstOperands,
     /* 119391 */     // GIR_Coverage, 4356,
     /* 119391 */     GIR_EraseRootFromParent_Done,
     /* 119392 */   // Label 1737: @119392
     /* 119392 */   GIM_Try, /*On fail goto*//*Label 1738*/ GIMT_Encode4(119524), // Rule ID 4587 //
     /* 119397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 119400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 119408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 119412 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 119416 */     // MIs[1] Operand 1
     /* 119416 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 119421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119423 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPLT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 119423 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119426 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPLT),
     /* 119430 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119435 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 119439 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 119443 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119445 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 119448 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119452 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119457 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 119460 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 119462 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 119465 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119469 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119474 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 119477 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 119479 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 119482 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119486 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119491 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 119498 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 119503 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 119508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 119511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119513 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119516 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 119519 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 119522 */     GIR_RootConstrainSelectedInstOperands,
     /* 119523 */     // GIR_Coverage, 4587,
     /* 119523 */     GIR_EraseRootFromParent_Done,
     /* 119524 */   // Label 1738: @119524
     /* 119524 */   GIM_Try, /*On fail goto*//*Label 1739*/ GIMT_Encode4(119656), // Rule ID 4619 //
     /* 119529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 119532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 119540 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 119544 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 119548 */     // MIs[1] Operand 1
     /* 119548 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 119553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119555 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPGT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 119555 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119558 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPGT),
     /* 119562 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119567 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 119571 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 119575 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119577 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 119580 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119584 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119589 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 119592 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 119594 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 119597 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119601 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119606 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 119609 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 119611 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 119614 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119618 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119623 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 119630 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 119635 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 119640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 119643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119645 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119648 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 119651 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 119654 */     GIR_RootConstrainSelectedInstOperands,
     /* 119655 */     // GIR_Coverage, 4619,
     /* 119655 */     GIR_EraseRootFromParent_Done,
     /* 119656 */   // Label 1739: @119656
     /* 119656 */   GIM_Try, /*On fail goto*//*Label 1740*/ GIMT_Encode4(119788), // Rule ID 4651 //
     /* 119661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 119664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 119672 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 119676 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 119680 */     // MIs[1] Operand 1
     /* 119680 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 119685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119687 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPEQ:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 119687 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119690 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPEQ),
     /* 119694 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119699 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 119703 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 119707 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119709 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 119712 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119716 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119721 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 119724 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 119726 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 119729 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119733 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119738 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 119741 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 119743 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 119746 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119750 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119755 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 119762 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 119767 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 119772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 119775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119777 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119780 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 119783 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 119786 */     GIR_RootConstrainSelectedInstOperands,
     /* 119787 */     // GIR_Coverage, 4651,
     /* 119787 */     GIR_EraseRootFromParent_Done,
     /* 119788 */   // Label 1740: @119788
     /* 119788 */   GIM_Try, /*On fail goto*//*Label 1741*/ GIMT_Encode4(119920), // Rule ID 4695 //
     /* 119793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 119796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 119804 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 119808 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 119812 */     // MIs[1] Operand 1
     /* 119812 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 119817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119819 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPLT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 119819 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119822 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPLT),
     /* 119826 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119831 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 119835 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 119839 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119841 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 119844 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119848 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119853 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 119856 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 119858 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 119861 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119865 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119870 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 119873 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 119875 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 119878 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119882 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119887 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 119894 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 119899 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 119904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 119907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119909 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119912 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 119915 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 119918 */     GIR_RootConstrainSelectedInstOperands,
     /* 119919 */     // GIR_Coverage, 4695,
     /* 119919 */     GIR_EraseRootFromParent_Done,
     /* 119920 */   // Label 1741: @119920
     /* 119920 */   GIM_Try, /*On fail goto*//*Label 1742*/ GIMT_Encode4(120052), // Rule ID 4727 //
     /* 119925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 119928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 119936 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 119940 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 119944 */     // MIs[1] Operand 1
     /* 119944 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 119949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119951 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPGT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 119951 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119954 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPGT),
     /* 119958 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119963 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 119967 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 119971 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119973 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 119976 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119980 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119985 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 119988 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 119990 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 119993 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119997 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120002 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 120005 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 120007 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 120010 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120014 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120019 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 120026 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 120031 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 120036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 120039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120041 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120044 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 120047 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 120050 */     GIR_RootConstrainSelectedInstOperands,
     /* 120051 */     // GIR_Coverage, 4727,
     /* 120051 */     GIR_EraseRootFromParent_Done,
     /* 120052 */   // Label 1742: @120052
     /* 120052 */   GIM_Try, /*On fail goto*//*Label 1743*/ GIMT_Encode4(120184), // Rule ID 4759 //
     /* 120057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 120060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 120068 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 120072 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 120076 */     // MIs[1] Operand 1
     /* 120076 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 120081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120083 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPEQ:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 120083 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 120086 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPEQ),
     /* 120090 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120095 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 120099 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 120103 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120105 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 120108 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 120112 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120117 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 120120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 120122 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 120125 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 120129 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120134 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 120137 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 120139 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 120142 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120146 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120151 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 120158 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 120163 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 120168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 120171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120176 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 120179 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 120182 */     GIR_RootConstrainSelectedInstOperands,
     /* 120183 */     // GIR_Coverage, 4759,
     /* 120183 */     GIR_EraseRootFromParent_Done,
     /* 120184 */   // Label 1743: @120184
     /* 120184 */   GIM_Try, /*On fail goto*//*Label 1744*/ GIMT_Encode4(120276), // Rule ID 2984 //
     /* 120189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 120192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 120200 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 120204 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 120208 */     // MIs[1] Operand 1
     /* 120208 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 120213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120215 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 120215 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 120218 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 120222 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120227 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 120231 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 120235 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120237 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 120240 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120244 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120249 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 120256 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 120261 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 120266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 120269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 120271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120274 */     GIR_RootConstrainSelectedInstOperands,
     /* 120275 */     // GIR_Coverage, 2984,
     /* 120275 */     GIR_EraseRootFromParent_Done,
     /* 120276 */   // Label 1744: @120276
     /* 120276 */   GIM_Try, /*On fail goto*//*Label 1745*/ GIMT_Encode4(120368), // Rule ID 2998 //
     /* 120281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 120284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 120292 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 120296 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 120300 */     // MIs[1] Operand 1
     /* 120300 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 120305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120307 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 120307 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 120310 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 120314 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120319 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 120323 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 120327 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120329 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 120332 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120336 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120341 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 120348 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 120353 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 120358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 120361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 120363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120366 */     GIR_RootConstrainSelectedInstOperands,
     /* 120367 */     // GIR_Coverage, 2998,
     /* 120367 */     GIR_EraseRootFromParent_Done,
     /* 120368 */   // Label 1745: @120368
     /* 120368 */   GIM_Try, /*On fail goto*//*Label 1746*/ GIMT_Encode4(120460), // Rule ID 3006 //
     /* 120373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 120376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 120384 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 120388 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 120392 */     // MIs[1] Operand 1
     /* 120392 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 120397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120399 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 120399 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 120402 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 120406 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120411 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 120415 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 120419 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120421 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 120424 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120428 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120433 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 120440 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 120445 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 120450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 120453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 120455 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120458 */     GIR_RootConstrainSelectedInstOperands,
     /* 120459 */     // GIR_Coverage, 3006,
     /* 120459 */     GIR_EraseRootFromParent_Done,
     /* 120460 */   // Label 1746: @120460
     /* 120460 */   GIM_Try, /*On fail goto*//*Label 1747*/ GIMT_Encode4(120552), // Rule ID 3014 //
     /* 120465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 120468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 120476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 120480 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 120484 */     // MIs[1] Operand 1
     /* 120484 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 120489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120491 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 120491 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 120494 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 120498 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120503 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 120507 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 120511 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120513 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 120516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120520 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120525 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 120532 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 120537 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 120542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 120545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 120547 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120550 */     GIR_RootConstrainSelectedInstOperands,
     /* 120551 */     // GIR_Coverage, 3014,
     /* 120551 */     GIR_EraseRootFromParent_Done,
     /* 120552 */   // Label 1747: @120552
     /* 120552 */   GIM_Try, /*On fail goto*//*Label 1748*/ GIMT_Encode4(120644), // Rule ID 3022 //
     /* 120557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 120560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 120568 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 120572 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 120576 */     // MIs[1] Operand 1
     /* 120576 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 120581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120583 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }))
     /* 120583 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 120586 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 120590 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120595 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 120599 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 120603 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 120608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120617 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 120624 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 120629 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 120634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 120637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 120639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120642 */     GIR_RootConstrainSelectedInstOperands,
     /* 120643 */     // GIR_Coverage, 3022,
     /* 120643 */     GIR_EraseRootFromParent_Done,
     /* 120644 */   // Label 1748: @120644
     /* 120644 */   GIM_Try, /*On fail goto*//*Label 1749*/ GIMT_Encode4(120736), // Rule ID 3086 //
     /* 120649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 120652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 120660 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 120664 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 120668 */     // MIs[1] Operand 1
     /* 120668 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 120673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120675 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 120675 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 120678 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 120682 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120687 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 120691 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 120695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120697 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 120700 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120704 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120709 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 120716 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 120721 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 120726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 120729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 120731 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120734 */     GIR_RootConstrainSelectedInstOperands,
     /* 120735 */     // GIR_Coverage, 3086,
     /* 120735 */     GIR_EraseRootFromParent_Done,
     /* 120736 */   // Label 1749: @120736
     /* 120736 */   GIM_Try, /*On fail goto*//*Label 1750*/ GIMT_Encode4(120828), // Rule ID 3094 //
     /* 120741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 120744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 120752 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 120756 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 120760 */     // MIs[1] Operand 1
     /* 120760 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 120765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120767 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 120767 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 120770 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 120774 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120779 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 120783 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 120787 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120789 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 120792 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120796 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120801 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 120808 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 120813 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 120818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 120821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 120823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120826 */     GIR_RootConstrainSelectedInstOperands,
     /* 120827 */     // GIR_Coverage, 3094,
     /* 120827 */     GIR_EraseRootFromParent_Done,
     /* 120828 */   // Label 1750: @120828
     /* 120828 */   GIM_Try, /*On fail goto*//*Label 1751*/ GIMT_Encode4(120920), // Rule ID 3102 //
     /* 120833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 120836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 120844 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 120848 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 120852 */     // MIs[1] Operand 1
     /* 120852 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 120857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120859 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 120859 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 120862 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 120866 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120871 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 120875 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 120879 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120881 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 120884 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120888 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120893 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 120900 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 120905 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 120910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 120913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 120915 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120918 */     GIR_RootConstrainSelectedInstOperands,
     /* 120919 */     // GIR_Coverage, 3102,
     /* 120919 */     GIR_EraseRootFromParent_Done,
     /* 120920 */   // Label 1751: @120920
     /* 120920 */   GIM_Try, /*On fail goto*//*Label 1752*/ GIMT_Encode4(121012), // Rule ID 3110 //
     /* 120925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 120928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 120936 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 120940 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 120944 */     // MIs[1] Operand 1
     /* 120944 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 120949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120951 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 120951 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 120954 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 120958 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120963 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 120967 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 120971 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120973 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 120976 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120980 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120985 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 120992 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 120997 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 121002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 121005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 121007 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121010 */     GIR_RootConstrainSelectedInstOperands,
     /* 121011 */     // GIR_Coverage, 3110,
     /* 121011 */     GIR_EraseRootFromParent_Done,
     /* 121012 */   // Label 1752: @121012
     /* 121012 */   GIM_Try, /*On fail goto*//*Label 1753*/ GIMT_Encode4(121104), // Rule ID 3118 //
     /* 121017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 121020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 121028 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 121032 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 121036 */     // MIs[1] Operand 1
     /* 121036 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 121041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121043 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }))
     /* 121043 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121046 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 121050 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121055 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 121059 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 121063 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121065 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 121068 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121072 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121077 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 121084 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 121089 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 121094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 121097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 121099 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121102 */     GIR_RootConstrainSelectedInstOperands,
     /* 121103 */     // GIR_Coverage, 3118,
     /* 121103 */     GIR_EraseRootFromParent_Done,
     /* 121104 */   // Label 1753: @121104
     /* 121104 */   GIM_Try, /*On fail goto*//*Label 1754*/ GIMT_Encode4(121236), // Rule ID 3868 //
     /* 121109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 121112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 121120 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 121124 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 121128 */     // MIs[1] Operand 1
     /* 121128 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 121133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121135 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 121135 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121138 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 121142 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121147 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 121151 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 121155 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121157 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 121160 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 121164 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121169 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 121172 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 121174 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 121177 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 121181 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121186 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 121189 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 121191 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 121194 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121198 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121203 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 121210 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 121215 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 121220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 121223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121225 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121228 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 121231 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 121234 */     GIR_RootConstrainSelectedInstOperands,
     /* 121235 */     // GIR_Coverage, 3868,
     /* 121235 */     GIR_EraseRootFromParent_Done,
     /* 121236 */   // Label 1754: @121236
     /* 121236 */   GIM_Try, /*On fail goto*//*Label 1755*/ GIMT_Encode4(121368), // Rule ID 3876 //
     /* 121241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 121244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 121252 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 121256 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 121260 */     // MIs[1] Operand 1
     /* 121260 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 121265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121267 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 121267 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121270 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 121274 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121279 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 121283 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 121287 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121289 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 121292 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 121296 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121301 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 121304 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 121306 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 121309 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 121313 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121318 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 121321 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 121323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 121326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121335 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 121342 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 121347 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 121352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 121355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121357 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121360 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 121363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 121366 */     GIR_RootConstrainSelectedInstOperands,
     /* 121367 */     // GIR_Coverage, 3876,
     /* 121367 */     GIR_EraseRootFromParent_Done,
     /* 121368 */   // Label 1755: @121368
     /* 121368 */   GIM_Try, /*On fail goto*//*Label 1756*/ GIMT_Encode4(121500), // Rule ID 3884 //
     /* 121373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 121376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 121384 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 121388 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 121392 */     // MIs[1] Operand 1
     /* 121392 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 121397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121399 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 121399 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121402 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 121406 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121411 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 121415 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 121419 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121421 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 121424 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 121428 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121433 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 121436 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 121438 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 121441 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 121445 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121450 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 121453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 121455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 121458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121467 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 121474 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 121479 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 121484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 121487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121492 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 121495 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 121498 */     GIR_RootConstrainSelectedInstOperands,
     /* 121499 */     // GIR_Coverage, 3884,
     /* 121499 */     GIR_EraseRootFromParent_Done,
     /* 121500 */   // Label 1756: @121500
     /* 121500 */   GIM_Try, /*On fail goto*//*Label 1757*/ GIMT_Encode4(121632), // Rule ID 3892 //
     /* 121505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 121508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 121516 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 121520 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 121524 */     // MIs[1] Operand 1
     /* 121524 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 121529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121531 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 121531 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121534 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 121538 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121543 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 121547 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 121551 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121553 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 121556 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 121560 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121565 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 121568 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 121570 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 121573 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 121577 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121582 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 121585 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 121587 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 121590 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121594 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121599 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 121606 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 121611 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 121616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 121619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121621 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 121627 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 121630 */     GIR_RootConstrainSelectedInstOperands,
     /* 121631 */     // GIR_Coverage, 3892,
     /* 121631 */     GIR_EraseRootFromParent_Done,
     /* 121632 */   // Label 1757: @121632
     /* 121632 */   GIM_Try, /*On fail goto*//*Label 1758*/ GIMT_Encode4(121764), // Rule ID 3900 //
     /* 121637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 121640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 121648 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 121652 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 121656 */     // MIs[1] Operand 1
     /* 121656 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 121661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121663 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 121663 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121666 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 121670 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121675 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 121679 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 121683 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121685 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 121688 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 121692 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121697 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 121700 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 121702 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 121705 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 121709 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121714 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 121717 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 121719 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 121722 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121726 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121731 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 121738 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 121743 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 121748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 121751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121753 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121756 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 121759 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 121762 */     GIR_RootConstrainSelectedInstOperands,
     /* 121763 */     // GIR_Coverage, 3900,
     /* 121763 */     GIR_EraseRootFromParent_Done,
     /* 121764 */   // Label 1758: @121764
     /* 121764 */   GIM_Try, /*On fail goto*//*Label 1759*/ GIMT_Encode4(121896), // Rule ID 3964 //
     /* 121769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 121772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 121780 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 121784 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 121788 */     // MIs[1] Operand 1
     /* 121788 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 121793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121795 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 121795 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121798 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 121802 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121807 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 121811 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 121815 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121817 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 121820 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 121824 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121829 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 121832 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 121834 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 121837 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 121841 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121846 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 121849 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 121851 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 121854 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121858 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121863 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 121870 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 121875 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 121880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 121883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121885 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121888 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 121891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 121894 */     GIR_RootConstrainSelectedInstOperands,
     /* 121895 */     // GIR_Coverage, 3964,
     /* 121895 */     GIR_EraseRootFromParent_Done,
     /* 121896 */   // Label 1759: @121896
     /* 121896 */   GIM_Try, /*On fail goto*//*Label 1760*/ GIMT_Encode4(122028), // Rule ID 3972 //
     /* 121901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 121904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 121912 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 121916 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 121920 */     // MIs[1] Operand 1
     /* 121920 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 121925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121927 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 121927 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121930 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 121934 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121939 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 121943 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 121947 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121949 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 121952 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 121956 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121961 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 121964 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 121966 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 121969 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 121973 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121978 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 121981 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 121983 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 121986 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121990 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121995 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 122002 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 122007 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 122012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 122015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122017 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122020 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 122023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 122026 */     GIR_RootConstrainSelectedInstOperands,
     /* 122027 */     // GIR_Coverage, 3972,
     /* 122027 */     GIR_EraseRootFromParent_Done,
     /* 122028 */   // Label 1760: @122028
     /* 122028 */   GIM_Try, /*On fail goto*//*Label 1761*/ GIMT_Encode4(122160), // Rule ID 3980 //
     /* 122033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 122036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 122044 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 122048 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 122052 */     // MIs[1] Operand 1
     /* 122052 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 122057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122059 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 122059 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 122062 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 122066 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122071 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 122075 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 122079 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122081 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 122084 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 122088 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122093 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 122096 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 122098 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 122101 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 122105 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122110 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 122113 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 122115 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 122118 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122122 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122127 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 122134 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 122139 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 122144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 122147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122149 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122152 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 122155 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 122158 */     GIR_RootConstrainSelectedInstOperands,
     /* 122159 */     // GIR_Coverage, 3980,
     /* 122159 */     GIR_EraseRootFromParent_Done,
     /* 122160 */   // Label 1761: @122160
     /* 122160 */   GIM_Try, /*On fail goto*//*Label 1762*/ GIMT_Encode4(122292), // Rule ID 3988 //
     /* 122165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 122168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 122176 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 122180 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 122184 */     // MIs[1] Operand 1
     /* 122184 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 122189 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122191 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 122191 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 122194 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 122198 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122203 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 122207 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 122211 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122213 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 122216 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 122220 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122225 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 122228 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 122230 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 122233 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 122237 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122242 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 122245 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 122247 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 122250 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122254 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122259 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 122266 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 122271 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 122276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 122279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122281 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122284 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 122287 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 122290 */     GIR_RootConstrainSelectedInstOperands,
     /* 122291 */     // GIR_Coverage, 3988,
     /* 122291 */     GIR_EraseRootFromParent_Done,
     /* 122292 */   // Label 1762: @122292
     /* 122292 */   GIM_Try, /*On fail goto*//*Label 1763*/ GIMT_Encode4(122424), // Rule ID 3996 //
     /* 122297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 122300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 122308 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 122312 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 122316 */     // MIs[1] Operand 1
     /* 122316 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 122321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122323 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 122323 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 122326 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 122330 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122335 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 122339 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 122343 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122345 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 122348 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 122352 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122357 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 122360 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 122362 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 122365 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 122369 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122374 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 122377 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 122379 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 122382 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122386 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122391 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 122398 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 122403 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 122408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 122411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122413 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122416 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 122419 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 122422 */     GIR_RootConstrainSelectedInstOperands,
     /* 122423 */     // GIR_Coverage, 3996,
     /* 122423 */     GIR_EraseRootFromParent_Done,
     /* 122424 */   // Label 1763: @122424
     /* 122424 */   GIM_Try, /*On fail goto*//*Label 1764*/ GIMT_Encode4(122439), // Rule ID 2990 //
     /* 122429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 122432 */     // (sext:{ *:[i32] } i1:{ *:[i1] }:$in)  =>  (SETNBC:{ *:[i32] } ?:{ *:[i1] }:$in)
     /* 122432 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SETNBC),
     /* 122437 */     GIR_RootConstrainSelectedInstOperands,
     /* 122438 */     // GIR_Coverage, 2990,
     /* 122438 */     GIR_Done,
     /* 122439 */   // Label 1764: @122439
     /* 122439 */   GIM_Try, /*On fail goto*//*Label 1765*/ GIMT_Encode4(122493), // Rule ID 3674 //
     /* 122444 */     // (sext:{ *:[i32] } i1:{ *:[i1] }:$in)  =>  (SELECT_I4:{ *:[i32] } ?:{ *:[i1] }:$in, (LI:{ *:[i32] } -1:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }))
     /* 122444 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 122447 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 122451 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122456 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 122459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122461 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122464 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 122468 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122473 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/uint8_t(-1),
     /* 122476 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 122478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 122481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122483 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 122485 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122488 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 122491 */     GIR_RootConstrainSelectedInstOperands,
     /* 122492 */     // GIR_Coverage, 3674,
     /* 122492 */     GIR_EraseRootFromParent_Done,
     /* 122493 */   // Label 1765: @122493
     /* 122493 */   GIM_Reject,
     /* 122494 */ // Label 1701: @122494
     /* 122494 */ GIM_Reject,
     /* 122495 */ // Label 1699: @122495
     /* 122495 */ GIM_Try, /*On fail goto*//*Label 1766*/ GIMT_Encode4(122605), // Rule ID 3039 //
     /* 122500 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 122503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 122506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 122510 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122514 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 122518 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 122522 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 122526 */   // MIs[1] Operand 1
     /* 122526 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 122531 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 122535 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122539 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 122543 */   // MIs[2] Operand 1
     /* 122543 */   // No operand predicates
     /* 122543 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 122545 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }))
     /* 122545 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 122548 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 122552 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122557 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 122561 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 122564 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122566 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 122569 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122573 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122578 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 122585 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 122590 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 122595 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 122598 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 122600 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122603 */   GIR_RootConstrainSelectedInstOperands,
     /* 122604 */   // GIR_Coverage, 3039,
     /* 122604 */   GIR_EraseRootFromParent_Done,
     /* 122605 */ // Label 1766: @122605
     /* 122605 */ GIM_Try, /*On fail goto*//*Label 1767*/ GIMT_Encode4(122715), // Rule ID 3055 //
     /* 122610 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 122613 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 122616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 122620 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122624 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 122628 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 122632 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 122636 */   // MIs[1] Operand 1
     /* 122636 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 122641 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 122645 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122649 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 122653 */   // MIs[2] Operand 1
     /* 122653 */   // No operand predicates
     /* 122653 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 122655 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }))
     /* 122655 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 122658 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 122662 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122667 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 122671 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 122674 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122676 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 122679 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122683 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122688 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 122695 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 122700 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 122705 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 122708 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 122710 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122713 */   GIR_RootConstrainSelectedInstOperands,
     /* 122714 */   // GIR_Coverage, 3055,
     /* 122714 */   GIR_EraseRootFromParent_Done,
     /* 122715 */ // Label 1767: @122715
     /* 122715 */ GIM_Try, /*On fail goto*//*Label 1768*/ GIMT_Encode4(122825), // Rule ID 3063 //
     /* 122720 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 122723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 122726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 122730 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122734 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 122738 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 122742 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 122746 */   // MIs[1] Operand 1
     /* 122746 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 122751 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 122755 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122759 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 122763 */   // MIs[2] Operand 1
     /* 122763 */   // No operand predicates
     /* 122763 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 122765 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }))
     /* 122765 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 122768 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 122772 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122777 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 122781 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 122784 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122786 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 122789 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122793 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122798 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 122805 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 122810 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 122815 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 122818 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 122820 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122823 */   GIR_RootConstrainSelectedInstOperands,
     /* 122824 */   // GIR_Coverage, 3063,
     /* 122824 */   GIR_EraseRootFromParent_Done,
     /* 122825 */ // Label 1768: @122825
     /* 122825 */ GIM_Try, /*On fail goto*//*Label 1769*/ GIMT_Encode4(122935), // Rule ID 3135 //
     /* 122830 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 122833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 122836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 122840 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122844 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 122848 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 122852 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 122856 */   // MIs[1] Operand 1
     /* 122856 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 122861 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 122865 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122869 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 122873 */   // MIs[2] Operand 1
     /* 122873 */   // No operand predicates
     /* 122873 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 122875 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }))
     /* 122875 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 122878 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 122882 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122887 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 122891 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 122894 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122896 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 122899 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122903 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122908 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 122915 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 122920 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 122925 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 122928 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 122930 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122933 */   GIR_RootConstrainSelectedInstOperands,
     /* 122934 */   // GIR_Coverage, 3135,
     /* 122934 */   GIR_EraseRootFromParent_Done,
     /* 122935 */ // Label 1769: @122935
     /* 122935 */ GIM_Try, /*On fail goto*//*Label 1770*/ GIMT_Encode4(123045), // Rule ID 3151 //
     /* 122940 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 122943 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 122946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 122950 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122954 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 122958 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 122962 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 122966 */   // MIs[1] Operand 1
     /* 122966 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 122971 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 122975 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122979 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 122983 */   // MIs[2] Operand 1
     /* 122983 */   // No operand predicates
     /* 122983 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 122985 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }))
     /* 122985 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 122988 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 122992 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122997 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 123001 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 123004 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 123006 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 123009 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123013 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123018 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 123025 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 123030 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 123035 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 123038 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 123040 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123043 */   GIR_RootConstrainSelectedInstOperands,
     /* 123044 */   // GIR_Coverage, 3151,
     /* 123044 */   GIR_EraseRootFromParent_Done,
     /* 123045 */ // Label 1770: @123045
     /* 123045 */ GIM_Try, /*On fail goto*//*Label 1771*/ GIMT_Encode4(123155), // Rule ID 3159 //
     /* 123050 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 123053 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 123056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 123060 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 123064 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 123068 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 123072 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 123076 */   // MIs[1] Operand 1
     /* 123076 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 123081 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 123085 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123089 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 123093 */   // MIs[2] Operand 1
     /* 123093 */   // No operand predicates
     /* 123093 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 123095 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }))
     /* 123095 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 123098 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 123102 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123107 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 123111 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 123114 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 123116 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 123119 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123123 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123128 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 123135 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 123140 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 123145 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 123148 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 123150 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123153 */   GIR_RootConstrainSelectedInstOperands,
     /* 123154 */   // GIR_Coverage, 3159,
     /* 123154 */   GIR_EraseRootFromParent_Done,
     /* 123155 */ // Label 1771: @123155
     /* 123155 */ GIM_Try, /*On fail goto*//*Label 1772*/ GIMT_Encode4(123305), // Rule ID 3822 //
     /* 123160 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 123163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 123166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 123170 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 123174 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 123178 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 123182 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 123186 */   // MIs[1] Operand 1
     /* 123186 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 123191 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 123195 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123199 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 123203 */   // MIs[2] Operand 1
     /* 123203 */   // No operand predicates
     /* 123203 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 123205 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 123205 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 123208 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 123212 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123217 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 123221 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 123224 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 123226 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 123229 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 123233 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123238 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 123241 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 123243 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 123246 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 123250 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123255 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 123258 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 123260 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 123263 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123267 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123272 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 123279 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 123284 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 123289 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 123292 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123294 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123297 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 123300 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 123303 */   GIR_RootConstrainSelectedInstOperands,
     /* 123304 */   // GIR_Coverage, 3822,
     /* 123304 */   GIR_EraseRootFromParent_Done,
     /* 123305 */ // Label 1772: @123305
     /* 123305 */ GIM_Try, /*On fail goto*//*Label 1773*/ GIMT_Encode4(123455), // Rule ID 3838 //
     /* 123310 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 123313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 123316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 123320 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 123324 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 123328 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 123332 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 123336 */   // MIs[1] Operand 1
     /* 123336 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 123341 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 123345 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123349 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 123353 */   // MIs[2] Operand 1
     /* 123353 */   // No operand predicates
     /* 123353 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 123355 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 123355 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 123358 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 123362 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123367 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 123371 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 123374 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 123376 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 123379 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 123383 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123388 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 123391 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 123393 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 123396 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 123400 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123405 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 123408 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 123410 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 123413 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123417 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123422 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 123429 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 123434 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 123439 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 123442 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123444 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123447 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 123450 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 123453 */   GIR_RootConstrainSelectedInstOperands,
     /* 123454 */   // GIR_Coverage, 3838,
     /* 123454 */   GIR_EraseRootFromParent_Done,
     /* 123455 */ // Label 1773: @123455
     /* 123455 */ GIM_Try, /*On fail goto*//*Label 1774*/ GIMT_Encode4(123605), // Rule ID 3846 //
     /* 123460 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 123463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 123466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 123470 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 123474 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 123478 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 123482 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 123486 */   // MIs[1] Operand 1
     /* 123486 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 123491 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 123495 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123499 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 123503 */   // MIs[2] Operand 1
     /* 123503 */   // No operand predicates
     /* 123503 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 123505 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 123505 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 123508 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 123512 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123517 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 123521 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 123524 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 123526 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 123529 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 123533 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123538 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 123541 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 123543 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 123546 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 123550 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123555 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 123558 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 123560 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 123563 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123567 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123572 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 123579 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 123584 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 123589 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 123592 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123594 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123597 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 123600 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 123603 */   GIR_RootConstrainSelectedInstOperands,
     /* 123604 */   // GIR_Coverage, 3846,
     /* 123604 */   GIR_EraseRootFromParent_Done,
     /* 123605 */ // Label 1774: @123605
     /* 123605 */ GIM_Try, /*On fail goto*//*Label 1775*/ GIMT_Encode4(123755), // Rule ID 3918 //
     /* 123610 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 123613 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 123616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 123620 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 123624 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 123628 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 123632 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 123636 */   // MIs[1] Operand 1
     /* 123636 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 123641 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 123645 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123649 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 123653 */   // MIs[2] Operand 1
     /* 123653 */   // No operand predicates
     /* 123653 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 123655 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 123655 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 123658 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 123662 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123667 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 123671 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 123674 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 123676 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 123679 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 123683 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123688 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 123691 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 123693 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 123696 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 123700 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123705 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 123708 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 123710 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 123713 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123717 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123722 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 123729 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 123734 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 123739 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 123742 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123744 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123747 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 123750 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 123753 */   GIR_RootConstrainSelectedInstOperands,
     /* 123754 */   // GIR_Coverage, 3918,
     /* 123754 */   GIR_EraseRootFromParent_Done,
     /* 123755 */ // Label 1775: @123755
     /* 123755 */ GIM_Try, /*On fail goto*//*Label 1776*/ GIMT_Encode4(123905), // Rule ID 3934 //
     /* 123760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 123763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 123766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 123770 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 123774 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 123778 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 123782 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 123786 */   // MIs[1] Operand 1
     /* 123786 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 123791 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 123795 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123799 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 123803 */   // MIs[2] Operand 1
     /* 123803 */   // No operand predicates
     /* 123803 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 123805 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 123805 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 123808 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 123812 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123817 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 123821 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 123824 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 123826 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 123829 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 123833 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123838 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 123841 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 123843 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 123846 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 123850 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123855 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 123858 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 123860 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 123863 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123867 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123872 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 123879 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 123884 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 123889 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 123892 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123894 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123897 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 123900 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 123903 */   GIR_RootConstrainSelectedInstOperands,
     /* 123904 */   // GIR_Coverage, 3934,
     /* 123904 */   GIR_EraseRootFromParent_Done,
     /* 123905 */ // Label 1776: @123905
     /* 123905 */ GIM_Try, /*On fail goto*//*Label 1777*/ GIMT_Encode4(124055), // Rule ID 3942 //
     /* 123910 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 123913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 123916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 123920 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 123924 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 123928 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 123932 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 123936 */   // MIs[1] Operand 1
     /* 123936 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 123941 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 123945 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123949 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 123953 */   // MIs[2] Operand 1
     /* 123953 */   // No operand predicates
     /* 123953 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 123955 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 123955 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 123958 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 123962 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123967 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 123971 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 123974 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 123976 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 123979 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 123983 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123988 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 123991 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 123993 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 123996 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 124000 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124005 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 124008 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 124010 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 124013 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124017 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124022 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 124029 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 124034 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 124039 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 124042 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124044 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124047 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 124050 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 124053 */   GIR_RootConstrainSelectedInstOperands,
     /* 124054 */   // GIR_Coverage, 3942,
     /* 124054 */   GIR_EraseRootFromParent_Done,
     /* 124055 */ // Label 1777: @124055
     /* 124055 */ GIM_Try, /*On fail goto*//*Label 1778*/ GIMT_Encode4(124154), // Rule ID 3183 //
     /* 124060 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 124063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 124066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 124070 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124074 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 124078 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 124082 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 124086 */   // MIs[1] Operand 1
     /* 124086 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 124091 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124093 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }))
     /* 124093 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 124096 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 124100 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124105 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 124109 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 124113 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 124115 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 124118 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124122 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124127 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 124134 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 124139 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 124144 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 124147 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 124149 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124152 */   GIR_RootConstrainSelectedInstOperands,
     /* 124153 */   // GIR_Coverage, 3183,
     /* 124153 */   GIR_EraseRootFromParent_Done,
     /* 124154 */ // Label 1778: @124154
     /* 124154 */ GIM_Try, /*On fail goto*//*Label 1779*/ GIMT_Encode4(124253), // Rule ID 3199 //
     /* 124159 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 124162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 124165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 124169 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124173 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 124177 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 124181 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 124185 */   // MIs[1] Operand 1
     /* 124185 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 124190 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124192 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }))
     /* 124192 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 124195 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 124199 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124204 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 124208 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 124212 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 124214 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 124217 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124221 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124226 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 124233 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 124238 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 124243 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 124246 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 124248 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124251 */   GIR_RootConstrainSelectedInstOperands,
     /* 124252 */   // GIR_Coverage, 3199,
     /* 124252 */   GIR_EraseRootFromParent_Done,
     /* 124253 */ // Label 1779: @124253
     /* 124253 */ GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(124352), // Rule ID 3215 //
     /* 124258 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 124261 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 124264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 124268 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124272 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 124276 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 124280 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 124284 */   // MIs[1] Operand 1
     /* 124284 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 124289 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124291 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }))
     /* 124291 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 124294 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 124298 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124303 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 124307 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 124311 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 124313 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 124316 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124320 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124325 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 124332 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 124337 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 124342 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 124345 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 124347 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124350 */   GIR_RootConstrainSelectedInstOperands,
     /* 124351 */   // GIR_Coverage, 3215,
     /* 124351 */   GIR_EraseRootFromParent_Done,
     /* 124352 */ // Label 1780: @124352
     /* 124352 */ GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(124451), // Rule ID 3231 //
     /* 124357 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 124360 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 124363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 124367 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124371 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 124375 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 124379 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 124383 */   // MIs[1] Operand 1
     /* 124383 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 124388 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124390 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }))
     /* 124390 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 124393 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 124397 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124402 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 124406 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 124410 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 124412 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 124415 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124419 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124424 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 124431 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 124436 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 124441 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 124444 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 124446 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124449 */   GIR_RootConstrainSelectedInstOperands,
     /* 124450 */   // GIR_Coverage, 3231,
     /* 124450 */   GIR_EraseRootFromParent_Done,
     /* 124451 */ // Label 1781: @124451
     /* 124451 */ GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(124550), // Rule ID 3239 //
     /* 124456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 124459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 124462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 124466 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124470 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 124474 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 124478 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 124482 */   // MIs[1] Operand 1
     /* 124482 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 124487 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124489 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }))
     /* 124489 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 124492 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 124496 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124501 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 124505 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 124509 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 124511 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 124514 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124518 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124523 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 124530 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 124535 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 124540 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 124543 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 124545 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124548 */   GIR_RootConstrainSelectedInstOperands,
     /* 124549 */   // GIR_Coverage, 3239,
     /* 124549 */   GIR_EraseRootFromParent_Done,
     /* 124550 */ // Label 1782: @124550
     /* 124550 */ GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(124649), // Rule ID 3255 //
     /* 124555 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 124558 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 124561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 124565 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124569 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 124573 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 124577 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 124581 */   // MIs[1] Operand 1
     /* 124581 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 124586 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124588 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }))
     /* 124588 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 124591 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 124595 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124600 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 124604 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 124608 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 124610 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 124613 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124617 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124622 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 124629 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 124634 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 124639 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 124642 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 124644 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124647 */   GIR_RootConstrainSelectedInstOperands,
     /* 124648 */   // GIR_Coverage, 3255,
     /* 124648 */   GIR_EraseRootFromParent_Done,
     /* 124649 */ // Label 1783: @124649
     /* 124649 */ GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(124748), // Rule ID 3271 //
     /* 124654 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 124657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 124660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 124664 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124668 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 124672 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 124676 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 124680 */   // MIs[1] Operand 1
     /* 124680 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 124685 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124687 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }))
     /* 124687 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 124690 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 124694 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124699 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 124703 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 124707 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 124709 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 124712 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124716 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124721 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 124728 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 124733 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 124738 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 124741 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 124743 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124746 */   GIR_RootConstrainSelectedInstOperands,
     /* 124747 */   // GIR_Coverage, 3271,
     /* 124747 */   GIR_EraseRootFromParent_Done,
     /* 124748 */ // Label 1784: @124748
     /* 124748 */ GIM_Try, /*On fail goto*//*Label 1785*/ GIMT_Encode4(124847), // Rule ID 3287 //
     /* 124753 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 124756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 124759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 124763 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124767 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 124771 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 124775 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 124779 */   // MIs[1] Operand 1
     /* 124779 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 124784 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124786 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }))
     /* 124786 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 124789 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 124793 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124798 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 124802 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 124806 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 124808 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 124811 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124815 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124820 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 124827 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 124832 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 124837 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 124840 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 124842 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124845 */   GIR_RootConstrainSelectedInstOperands,
     /* 124846 */   // GIR_Coverage, 3287,
     /* 124846 */   GIR_EraseRootFromParent_Done,
     /* 124847 */ // Label 1785: @124847
     /* 124847 */ GIM_Try, /*On fail goto*//*Label 1786*/ GIMT_Encode4(124946), // Rule ID 3295 //
     /* 124852 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 124855 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 124858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 124862 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124866 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 124870 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 124874 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 124878 */   // MIs[1] Operand 1
     /* 124878 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 124883 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124885 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }))
     /* 124885 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 124888 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 124892 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124897 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 124901 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 124905 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 124907 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 124910 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124914 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124919 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 124926 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 124931 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 124936 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 124939 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 124941 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124944 */   GIR_RootConstrainSelectedInstOperands,
     /* 124945 */   // GIR_Coverage, 3295,
     /* 124945 */   GIR_EraseRootFromParent_Done,
     /* 124946 */ // Label 1786: @124946
     /* 124946 */ GIM_Try, /*On fail goto*//*Label 1787*/ GIMT_Encode4(125045), // Rule ID 3311 //
     /* 124951 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 124954 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 124957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 124961 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124965 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 124969 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 124973 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 124977 */   // MIs[1] Operand 1
     /* 124977 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 124982 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124984 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }))
     /* 124984 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 124987 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 124991 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124996 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 125000 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 125004 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 125006 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 125009 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125013 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125018 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 125025 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 125030 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 125035 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 125038 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 125040 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125043 */   GIR_RootConstrainSelectedInstOperands,
     /* 125044 */   // GIR_Coverage, 3311,
     /* 125044 */   GIR_EraseRootFromParent_Done,
     /* 125045 */ // Label 1787: @125045
     /* 125045 */ GIM_Try, /*On fail goto*//*Label 1788*/ GIMT_Encode4(125144), // Rule ID 3327 //
     /* 125050 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 125053 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 125056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 125060 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125064 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 125068 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 125072 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 125076 */   // MIs[1] Operand 1
     /* 125076 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 125081 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125083 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }))
     /* 125083 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 125086 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 125090 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125095 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 125099 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 125103 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 125105 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 125108 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125112 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125117 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 125124 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 125129 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 125134 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 125137 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 125139 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125142 */   GIR_RootConstrainSelectedInstOperands,
     /* 125143 */   // GIR_Coverage, 3327,
     /* 125143 */   GIR_EraseRootFromParent_Done,
     /* 125144 */ // Label 1788: @125144
     /* 125144 */ GIM_Try, /*On fail goto*//*Label 1789*/ GIMT_Encode4(125243), // Rule ID 3343 //
     /* 125149 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 125152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 125155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 125159 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125163 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 125167 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 125171 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 125175 */   // MIs[1] Operand 1
     /* 125175 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 125180 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125182 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }))
     /* 125182 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 125185 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 125189 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125194 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 125198 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 125202 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 125204 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 125207 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125211 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125216 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 125223 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 125228 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 125233 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 125236 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 125238 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125241 */   GIR_RootConstrainSelectedInstOperands,
     /* 125242 */   // GIR_Coverage, 3343,
     /* 125242 */   GIR_EraseRootFromParent_Done,
     /* 125243 */ // Label 1789: @125243
     /* 125243 */ GIM_Try, /*On fail goto*//*Label 1790*/ GIMT_Encode4(125382), // Rule ID 4026 //
     /* 125248 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 125251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 125254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 125258 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125262 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 125266 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 125270 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 125274 */   // MIs[1] Operand 1
     /* 125274 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 125279 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125281 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 125281 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 125284 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 125288 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125293 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 125297 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 125301 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 125303 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 125306 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 125310 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125315 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 125318 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 125320 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 125323 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 125327 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125332 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 125335 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 125337 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 125340 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125344 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125349 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 125356 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 125361 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 125366 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 125369 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125371 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125374 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 125377 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 125380 */   GIR_RootConstrainSelectedInstOperands,
     /* 125381 */   // GIR_Coverage, 4026,
     /* 125381 */   GIR_EraseRootFromParent_Done,
     /* 125382 */ // Label 1790: @125382
     /* 125382 */ GIM_Try, /*On fail goto*//*Label 1791*/ GIMT_Encode4(125521), // Rule ID 4058 //
     /* 125387 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 125390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 125393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 125397 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125401 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 125405 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 125409 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 125413 */   // MIs[1] Operand 1
     /* 125413 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 125418 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125420 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 125420 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 125423 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 125427 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125432 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 125436 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 125440 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 125442 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 125445 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 125449 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125454 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 125457 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 125459 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 125462 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 125466 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125471 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 125474 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 125476 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 125479 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125483 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125488 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 125495 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 125500 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 125505 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 125508 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125510 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125513 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 125516 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 125519 */   GIR_RootConstrainSelectedInstOperands,
     /* 125520 */   // GIR_Coverage, 4058,
     /* 125520 */   GIR_EraseRootFromParent_Done,
     /* 125521 */ // Label 1791: @125521
     /* 125521 */ GIM_Try, /*On fail goto*//*Label 1792*/ GIMT_Encode4(125660), // Rule ID 4090 //
     /* 125526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 125529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 125532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 125536 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125540 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 125544 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 125548 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 125552 */   // MIs[1] Operand 1
     /* 125552 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 125557 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125559 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 125559 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 125562 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 125566 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125571 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 125575 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 125579 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 125581 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 125584 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 125588 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125593 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 125596 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 125598 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 125601 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 125605 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125610 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 125613 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 125615 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 125618 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125622 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125627 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 125634 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 125639 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 125644 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 125647 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125649 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125652 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 125655 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 125658 */   GIR_RootConstrainSelectedInstOperands,
     /* 125659 */   // GIR_Coverage, 4090,
     /* 125659 */   GIR_EraseRootFromParent_Done,
     /* 125660 */ // Label 1792: @125660
     /* 125660 */ GIM_Try, /*On fail goto*//*Label 1793*/ GIMT_Encode4(125799), // Rule ID 4122 //
     /* 125665 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 125668 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 125671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 125675 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125679 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 125683 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 125687 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 125691 */   // MIs[1] Operand 1
     /* 125691 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 125696 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125698 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 125698 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 125701 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 125705 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125710 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 125714 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 125718 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 125720 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 125723 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 125727 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125732 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 125735 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 125737 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 125740 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 125744 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125749 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 125752 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 125754 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 125757 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125761 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125766 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 125773 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 125778 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 125783 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 125786 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125788 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125791 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 125794 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 125797 */   GIR_RootConstrainSelectedInstOperands,
     /* 125798 */   // GIR_Coverage, 4122,
     /* 125798 */   GIR_EraseRootFromParent_Done,
     /* 125799 */ // Label 1793: @125799
     /* 125799 */ GIM_Try, /*On fail goto*//*Label 1794*/ GIMT_Encode4(125938), // Rule ID 4138 //
     /* 125804 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 125807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 125810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 125814 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125818 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 125822 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 125826 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 125830 */   // MIs[1] Operand 1
     /* 125830 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 125835 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125837 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 125837 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 125840 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 125844 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125849 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 125853 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 125857 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 125859 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 125862 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 125866 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125871 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 125874 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 125876 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 125879 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 125883 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125888 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 125891 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 125893 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 125896 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125900 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125905 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 125912 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 125917 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 125922 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 125925 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125927 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125930 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 125933 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 125936 */   GIR_RootConstrainSelectedInstOperands,
     /* 125937 */   // GIR_Coverage, 4138,
     /* 125937 */   GIR_EraseRootFromParent_Done,
     /* 125938 */ // Label 1794: @125938
     /* 125938 */ GIM_Try, /*On fail goto*//*Label 1795*/ GIMT_Encode4(126077), // Rule ID 4170 //
     /* 125943 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 125946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 125949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 125953 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125957 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 125961 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 125965 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 125969 */   // MIs[1] Operand 1
     /* 125969 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 125974 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125976 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 125976 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 125979 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 125983 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125988 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 125992 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 125996 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 125998 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 126001 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126005 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126010 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 126013 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 126015 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 126018 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126022 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126027 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 126030 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 126032 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 126035 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126039 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126044 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 126051 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 126056 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 126061 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 126064 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126066 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126069 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 126072 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 126075 */   GIR_RootConstrainSelectedInstOperands,
     /* 126076 */   // GIR_Coverage, 4170,
     /* 126076 */   GIR_EraseRootFromParent_Done,
     /* 126077 */ // Label 1795: @126077
     /* 126077 */ GIM_Try, /*On fail goto*//*Label 1796*/ GIMT_Encode4(126216), // Rule ID 4202 //
     /* 126082 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 126085 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 126088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 126092 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 126096 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 126100 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 126104 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 126108 */   // MIs[1] Operand 1
     /* 126108 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 126113 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126115 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 126115 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 126118 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 126122 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126127 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 126131 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 126135 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 126137 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 126140 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126144 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126149 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 126152 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 126154 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 126157 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126161 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126166 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 126169 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 126171 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 126174 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126178 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126183 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 126190 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 126195 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 126200 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 126203 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126205 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126208 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 126211 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 126214 */   GIR_RootConstrainSelectedInstOperands,
     /* 126215 */   // GIR_Coverage, 4202,
     /* 126215 */   GIR_EraseRootFromParent_Done,
     /* 126216 */ // Label 1796: @126216
     /* 126216 */ GIM_Try, /*On fail goto*//*Label 1797*/ GIMT_Encode4(126355), // Rule ID 4234 //
     /* 126221 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 126224 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 126227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 126231 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 126235 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 126239 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 126243 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 126247 */   // MIs[1] Operand 1
     /* 126247 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 126252 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126254 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 126254 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 126257 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 126261 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126266 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 126270 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 126274 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 126276 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 126279 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126283 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126288 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 126291 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 126293 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 126296 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126300 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126305 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 126308 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 126310 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 126313 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126317 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126322 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 126329 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 126334 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 126339 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 126342 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126344 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126347 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 126350 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 126353 */   GIR_RootConstrainSelectedInstOperands,
     /* 126354 */   // GIR_Coverage, 4234,
     /* 126354 */   GIR_EraseRootFromParent_Done,
     /* 126355 */ // Label 1797: @126355
     /* 126355 */ GIM_Try, /*On fail goto*//*Label 1798*/ GIMT_Encode4(126494), // Rule ID 4264 //
     /* 126360 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 126363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 126366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 126370 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 126374 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 126378 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 126382 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 126386 */   // MIs[1] Operand 1
     /* 126386 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 126391 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126393 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 126393 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 126396 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 126400 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126405 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 126409 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 126413 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 126415 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 126418 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126422 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126427 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 126430 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 126432 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 126435 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126439 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126444 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 126447 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 126449 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 126452 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126456 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126461 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 126468 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 126473 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 126478 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 126481 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126483 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126486 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 126489 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 126492 */   GIR_RootConstrainSelectedInstOperands,
     /* 126493 */   // GIR_Coverage, 4264,
     /* 126493 */   GIR_EraseRootFromParent_Done,
     /* 126494 */ // Label 1798: @126494
     /* 126494 */ GIM_Try, /*On fail goto*//*Label 1799*/ GIMT_Encode4(126633), // Rule ID 4296 //
     /* 126499 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 126502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 126505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 126509 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 126513 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 126517 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 126521 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 126525 */   // MIs[1] Operand 1
     /* 126525 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 126530 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126532 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 126532 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 126535 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 126539 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126544 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 126548 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 126552 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 126554 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 126557 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126561 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126566 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 126569 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 126571 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 126574 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126578 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126583 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 126586 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 126588 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 126591 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126595 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126600 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 126607 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 126612 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 126617 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 126620 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126622 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126625 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 126628 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 126631 */   GIR_RootConstrainSelectedInstOperands,
     /* 126632 */   // GIR_Coverage, 4296,
     /* 126632 */   GIR_EraseRootFromParent_Done,
     /* 126633 */ // Label 1799: @126633
     /* 126633 */ GIM_Try, /*On fail goto*//*Label 1800*/ GIMT_Encode4(126772), // Rule ID 4328 //
     /* 126638 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 126641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 126644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 126648 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 126652 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 126656 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 126660 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 126664 */   // MIs[1] Operand 1
     /* 126664 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 126669 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126671 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 126671 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 126674 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 126678 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126683 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 126687 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 126691 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 126693 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 126696 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126700 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126705 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 126708 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 126710 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 126713 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126717 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126722 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 126725 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 126727 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 126730 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126734 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126739 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 126746 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 126751 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 126756 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 126759 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126761 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126764 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 126767 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 126770 */   GIR_RootConstrainSelectedInstOperands,
     /* 126771 */   // GIR_Coverage, 4328,
     /* 126771 */   GIR_EraseRootFromParent_Done,
     /* 126772 */ // Label 1800: @126772
     /* 126772 */ GIM_Try, /*On fail goto*//*Label 1801*/ GIMT_Encode4(126911), // Rule ID 4360 //
     /* 126777 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 126780 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 126783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 126787 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 126791 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 126795 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 126799 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 126803 */   // MIs[1] Operand 1
     /* 126803 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 126808 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126810 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 126810 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 126813 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 126817 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126822 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 126826 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 126830 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 126832 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 126835 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126839 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126844 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 126847 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 126849 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 126852 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126856 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126861 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 126864 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 126866 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 126869 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126873 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126878 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 126885 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 126890 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 126895 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 126898 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126900 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126903 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 126906 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 126909 */   GIR_RootConstrainSelectedInstOperands,
     /* 126910 */   // GIR_Coverage, 4360,
     /* 126910 */   GIR_EraseRootFromParent_Done,
     /* 126911 */ // Label 1801: @126911
     /* 126911 */ GIM_Try, /*On fail goto*//*Label 1802*/ GIMT_Encode4(127050), // Rule ID 4591 //
     /* 126916 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 126919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 126922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 126926 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 126930 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 126934 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 126938 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 126942 */   // MIs[1] Operand 1
     /* 126942 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 126947 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126949 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPLT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 126949 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 126952 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPLT),
     /* 126956 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126961 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 126965 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 126969 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 126971 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 126974 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126978 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126983 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 126986 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 126988 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 126991 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126995 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127000 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 127003 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 127005 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 127008 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127012 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127017 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 127024 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 127029 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 127034 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 127037 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127039 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127042 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 127045 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 127048 */   GIR_RootConstrainSelectedInstOperands,
     /* 127049 */   // GIR_Coverage, 4591,
     /* 127049 */   GIR_EraseRootFromParent_Done,
     /* 127050 */ // Label 1802: @127050
     /* 127050 */ GIM_Try, /*On fail goto*//*Label 1803*/ GIMT_Encode4(127189), // Rule ID 4623 //
     /* 127055 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 127058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 127061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 127065 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127069 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 127073 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 127077 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 127081 */   // MIs[1] Operand 1
     /* 127081 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 127086 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127088 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPGT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 127088 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 127091 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPGT),
     /* 127095 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127100 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 127104 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 127108 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 127110 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 127113 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 127117 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127122 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 127125 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 127127 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 127130 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 127134 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127139 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 127142 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 127144 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 127147 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127151 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127156 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 127163 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 127168 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 127173 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 127176 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127178 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127181 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 127184 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 127187 */   GIR_RootConstrainSelectedInstOperands,
     /* 127188 */   // GIR_Coverage, 4623,
     /* 127188 */   GIR_EraseRootFromParent_Done,
     /* 127189 */ // Label 1803: @127189
     /* 127189 */ GIM_Try, /*On fail goto*//*Label 1804*/ GIMT_Encode4(127328), // Rule ID 4655 //
     /* 127194 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 127197 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 127200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 127204 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127208 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 127212 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 127216 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 127220 */   // MIs[1] Operand 1
     /* 127220 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 127225 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127227 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPEQ:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 127227 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 127230 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPEQ),
     /* 127234 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127239 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 127243 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 127247 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 127249 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 127252 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 127256 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127261 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 127264 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 127266 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 127269 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 127273 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127278 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 127281 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 127283 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 127286 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127290 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127295 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 127302 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 127307 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 127312 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 127315 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127317 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127320 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 127323 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 127326 */   GIR_RootConstrainSelectedInstOperands,
     /* 127327 */   // GIR_Coverage, 4655,
     /* 127327 */   GIR_EraseRootFromParent_Done,
     /* 127328 */ // Label 1804: @127328
     /* 127328 */ GIM_Try, /*On fail goto*//*Label 1805*/ GIMT_Encode4(127467), // Rule ID 4699 //
     /* 127333 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 127336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 127339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 127343 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127347 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 127351 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 127355 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 127359 */   // MIs[1] Operand 1
     /* 127359 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 127364 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127366 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPLT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 127366 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 127369 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPLT),
     /* 127373 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127378 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 127382 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 127386 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 127388 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 127391 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 127395 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127400 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 127403 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 127405 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 127408 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 127412 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127417 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 127420 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 127422 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 127425 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127429 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127434 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 127441 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 127446 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 127451 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 127454 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127456 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127459 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 127462 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 127465 */   GIR_RootConstrainSelectedInstOperands,
     /* 127466 */   // GIR_Coverage, 4699,
     /* 127466 */   GIR_EraseRootFromParent_Done,
     /* 127467 */ // Label 1805: @127467
     /* 127467 */ GIM_Try, /*On fail goto*//*Label 1806*/ GIMT_Encode4(127606), // Rule ID 4731 //
     /* 127472 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 127475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 127478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 127482 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127486 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 127490 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 127494 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 127498 */   // MIs[1] Operand 1
     /* 127498 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 127503 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127505 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPGT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 127505 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 127508 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPGT),
     /* 127512 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127517 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 127521 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 127525 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 127527 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 127530 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 127534 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127539 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 127542 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 127544 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 127547 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 127551 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127556 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 127559 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 127561 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 127564 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127568 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127573 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 127580 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 127585 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 127590 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 127593 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127595 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127598 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 127601 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 127604 */   GIR_RootConstrainSelectedInstOperands,
     /* 127605 */   // GIR_Coverage, 4731,
     /* 127605 */   GIR_EraseRootFromParent_Done,
     /* 127606 */ // Label 1806: @127606
     /* 127606 */ GIM_Try, /*On fail goto*//*Label 1807*/ GIMT_Encode4(127745), // Rule ID 4763 //
     /* 127611 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 127614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 127617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 127621 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127625 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 127629 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 127633 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 127637 */   // MIs[1] Operand 1
     /* 127637 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 127642 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127644 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPEQ:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 127644 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 127647 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPEQ),
     /* 127651 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127656 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 127660 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 127664 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 127666 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 127669 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 127673 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127678 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 127681 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 127683 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 127686 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 127690 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127695 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 127698 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 127700 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 127703 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127707 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127712 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 127719 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 127724 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 127729 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 127732 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127734 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127737 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 127740 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 127743 */   GIR_RootConstrainSelectedInstOperands,
     /* 127744 */   // GIR_Coverage, 4763,
     /* 127744 */   GIR_EraseRootFromParent_Done,
     /* 127745 */ // Label 1807: @127745
     /* 127745 */ GIM_Try, /*On fail goto*//*Label 1808*/ GIMT_Encode4(127844), // Rule ID 2985 //
     /* 127750 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 127753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 127756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 127760 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127764 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 127768 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 127772 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 127776 */   // MIs[1] Operand 1
     /* 127776 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 127781 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127783 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 127783 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 127786 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 127790 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127795 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 127799 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 127803 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 127805 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 127808 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127812 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127817 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 127824 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 127829 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 127834 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 127837 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 127839 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127842 */   GIR_RootConstrainSelectedInstOperands,
     /* 127843 */   // GIR_Coverage, 2985,
     /* 127843 */   GIR_EraseRootFromParent_Done,
     /* 127844 */ // Label 1808: @127844
     /* 127844 */ GIM_Try, /*On fail goto*//*Label 1809*/ GIMT_Encode4(127943), // Rule ID 2999 //
     /* 127849 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 127852 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 127855 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 127859 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127863 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 127867 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 127871 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 127875 */   // MIs[1] Operand 1
     /* 127875 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 127880 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127882 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 127882 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 127885 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 127889 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127894 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 127898 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 127902 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 127904 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 127907 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127911 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127916 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 127923 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 127928 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 127933 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 127936 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 127938 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127941 */   GIR_RootConstrainSelectedInstOperands,
     /* 127942 */   // GIR_Coverage, 2999,
     /* 127942 */   GIR_EraseRootFromParent_Done,
     /* 127943 */ // Label 1809: @127943
     /* 127943 */ GIM_Try, /*On fail goto*//*Label 1810*/ GIMT_Encode4(128042), // Rule ID 3007 //
     /* 127948 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 127951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 127954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 127958 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127962 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 127966 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 127970 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 127974 */   // MIs[1] Operand 1
     /* 127974 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 127979 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127981 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 127981 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 127984 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 127988 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127993 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 127997 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 128001 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 128003 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 128006 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128010 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128015 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 128022 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 128027 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 128032 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 128035 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 128037 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128040 */   GIR_RootConstrainSelectedInstOperands,
     /* 128041 */   // GIR_Coverage, 3007,
     /* 128041 */   GIR_EraseRootFromParent_Done,
     /* 128042 */ // Label 1810: @128042
     /* 128042 */ GIM_Try, /*On fail goto*//*Label 1811*/ GIMT_Encode4(128141), // Rule ID 3015 //
     /* 128047 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 128050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 128053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 128057 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128061 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 128065 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 128069 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 128073 */   // MIs[1] Operand 1
     /* 128073 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 128078 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128080 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 128080 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 128083 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 128087 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128092 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 128096 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 128100 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 128102 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 128105 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128109 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128114 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 128121 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 128126 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 128131 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 128134 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 128136 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128139 */   GIR_RootConstrainSelectedInstOperands,
     /* 128140 */   // GIR_Coverage, 3015,
     /* 128140 */   GIR_EraseRootFromParent_Done,
     /* 128141 */ // Label 1811: @128141
     /* 128141 */ GIM_Try, /*On fail goto*//*Label 1812*/ GIMT_Encode4(128240), // Rule ID 3023 //
     /* 128146 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 128149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 128152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 128156 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128160 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 128164 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 128168 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 128172 */   // MIs[1] Operand 1
     /* 128172 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 128177 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128179 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }))
     /* 128179 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 128182 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 128186 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128191 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 128195 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 128199 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 128201 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 128204 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128208 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128213 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 128220 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 128225 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 128230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 128233 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 128235 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128238 */   GIR_RootConstrainSelectedInstOperands,
     /* 128239 */   // GIR_Coverage, 3023,
     /* 128239 */   GIR_EraseRootFromParent_Done,
     /* 128240 */ // Label 1812: @128240
     /* 128240 */ GIM_Try, /*On fail goto*//*Label 1813*/ GIMT_Encode4(128339), // Rule ID 3087 //
     /* 128245 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 128248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 128251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 128255 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128259 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 128263 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 128267 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 128271 */   // MIs[1] Operand 1
     /* 128271 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 128276 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128278 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 128278 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 128281 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 128285 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128290 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 128294 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 128298 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 128300 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 128303 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128307 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128312 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 128319 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 128324 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 128329 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 128332 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 128334 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128337 */   GIR_RootConstrainSelectedInstOperands,
     /* 128338 */   // GIR_Coverage, 3087,
     /* 128338 */   GIR_EraseRootFromParent_Done,
     /* 128339 */ // Label 1813: @128339
     /* 128339 */ GIM_Try, /*On fail goto*//*Label 1814*/ GIMT_Encode4(128438), // Rule ID 3095 //
     /* 128344 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 128347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 128350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 128354 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128358 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 128362 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 128366 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 128370 */   // MIs[1] Operand 1
     /* 128370 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 128375 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128377 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 128377 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 128380 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 128384 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128389 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 128393 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 128397 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 128399 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 128402 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128406 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128411 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 128418 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 128423 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 128428 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 128431 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 128433 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128436 */   GIR_RootConstrainSelectedInstOperands,
     /* 128437 */   // GIR_Coverage, 3095,
     /* 128437 */   GIR_EraseRootFromParent_Done,
     /* 128438 */ // Label 1814: @128438
     /* 128438 */ GIM_Try, /*On fail goto*//*Label 1815*/ GIMT_Encode4(128537), // Rule ID 3103 //
     /* 128443 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 128446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 128449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 128453 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128457 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 128461 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 128465 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 128469 */   // MIs[1] Operand 1
     /* 128469 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 128474 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128476 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 128476 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 128479 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 128483 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128488 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 128492 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 128496 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 128498 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 128501 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128505 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128510 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 128517 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 128522 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 128527 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 128530 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 128532 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128535 */   GIR_RootConstrainSelectedInstOperands,
     /* 128536 */   // GIR_Coverage, 3103,
     /* 128536 */   GIR_EraseRootFromParent_Done,
     /* 128537 */ // Label 1815: @128537
     /* 128537 */ GIM_Try, /*On fail goto*//*Label 1816*/ GIMT_Encode4(128636), // Rule ID 3111 //
     /* 128542 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 128545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 128548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 128552 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128556 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 128560 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 128564 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 128568 */   // MIs[1] Operand 1
     /* 128568 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 128573 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128575 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 128575 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 128578 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 128582 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128587 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 128591 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 128595 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 128597 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 128600 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128604 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128609 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 128616 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 128621 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 128626 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 128629 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 128631 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128634 */   GIR_RootConstrainSelectedInstOperands,
     /* 128635 */   // GIR_Coverage, 3111,
     /* 128635 */   GIR_EraseRootFromParent_Done,
     /* 128636 */ // Label 1816: @128636
     /* 128636 */ GIM_Try, /*On fail goto*//*Label 1817*/ GIMT_Encode4(128735), // Rule ID 3119 //
     /* 128641 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 128644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 128647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 128651 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128655 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 128659 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 128663 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 128667 */   // MIs[1] Operand 1
     /* 128667 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 128672 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128674 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }))
     /* 128674 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 128677 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 128681 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128686 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 128690 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 128694 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 128696 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 128699 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128703 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128708 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 128715 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 128720 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 128725 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 128728 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 128730 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128733 */   GIR_RootConstrainSelectedInstOperands,
     /* 128734 */   // GIR_Coverage, 3119,
     /* 128734 */   GIR_EraseRootFromParent_Done,
     /* 128735 */ // Label 1817: @128735
     /* 128735 */ GIM_Try, /*On fail goto*//*Label 1818*/ GIMT_Encode4(128874), // Rule ID 3870 //
     /* 128740 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 128743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 128746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 128750 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128754 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 128758 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 128762 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 128766 */   // MIs[1] Operand 1
     /* 128766 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 128771 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128773 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 128773 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 128776 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 128780 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128785 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 128789 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 128793 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 128795 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 128798 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 128802 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128807 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 128810 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 128812 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 128815 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 128819 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128824 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 128827 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 128829 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 128832 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128836 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128841 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 128848 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 128853 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 128858 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 128861 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128863 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128866 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 128869 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 128872 */   GIR_RootConstrainSelectedInstOperands,
     /* 128873 */   // GIR_Coverage, 3870,
     /* 128873 */   GIR_EraseRootFromParent_Done,
     /* 128874 */ // Label 1818: @128874
     /* 128874 */ GIM_Try, /*On fail goto*//*Label 1819*/ GIMT_Encode4(129013), // Rule ID 3878 //
     /* 128879 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 128882 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 128885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 128889 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128893 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 128897 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 128901 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 128905 */   // MIs[1] Operand 1
     /* 128905 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 128910 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128912 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 128912 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 128915 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 128919 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128924 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 128928 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 128932 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 128934 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 128937 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 128941 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128946 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 128949 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 128951 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 128954 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 128958 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128963 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 128966 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 128968 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 128971 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128975 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128980 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 128987 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 128992 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 128997 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 129000 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129002 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129005 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 129008 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 129011 */   GIR_RootConstrainSelectedInstOperands,
     /* 129012 */   // GIR_Coverage, 3878,
     /* 129012 */   GIR_EraseRootFromParent_Done,
     /* 129013 */ // Label 1819: @129013
     /* 129013 */ GIM_Try, /*On fail goto*//*Label 1820*/ GIMT_Encode4(129152), // Rule ID 3886 //
     /* 129018 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 129021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 129024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 129028 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129032 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 129036 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 129040 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 129044 */   // MIs[1] Operand 1
     /* 129044 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 129049 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129051 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 129051 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 129054 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 129058 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129063 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 129067 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 129071 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 129073 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 129076 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 129080 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129085 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 129088 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 129090 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 129093 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 129097 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129102 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 129105 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 129107 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 129110 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 129114 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129119 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 129126 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 129131 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 129136 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 129139 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129141 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129144 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 129147 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 129150 */   GIR_RootConstrainSelectedInstOperands,
     /* 129151 */   // GIR_Coverage, 3886,
     /* 129151 */   GIR_EraseRootFromParent_Done,
     /* 129152 */ // Label 1820: @129152
     /* 129152 */ GIM_Try, /*On fail goto*//*Label 1821*/ GIMT_Encode4(129291), // Rule ID 3894 //
     /* 129157 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 129160 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 129163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 129167 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129171 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 129175 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 129179 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 129183 */   // MIs[1] Operand 1
     /* 129183 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 129188 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129190 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 129190 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 129193 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 129197 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129202 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 129206 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 129210 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 129212 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 129215 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 129219 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129224 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 129227 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 129229 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 129232 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 129236 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129241 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 129244 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 129246 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 129249 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 129253 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129258 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 129265 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 129270 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 129275 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 129278 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129280 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129283 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 129286 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 129289 */   GIR_RootConstrainSelectedInstOperands,
     /* 129290 */   // GIR_Coverage, 3894,
     /* 129290 */   GIR_EraseRootFromParent_Done,
     /* 129291 */ // Label 1821: @129291
     /* 129291 */ GIM_Try, /*On fail goto*//*Label 1822*/ GIMT_Encode4(129430), // Rule ID 3902 //
     /* 129296 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 129299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 129302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 129306 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129310 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 129314 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 129318 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 129322 */   // MIs[1] Operand 1
     /* 129322 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 129327 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129329 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 129329 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 129332 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 129336 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129341 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 129345 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 129349 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 129351 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 129354 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 129358 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129363 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 129366 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 129368 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 129371 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 129375 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129380 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 129383 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 129385 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 129388 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 129392 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129397 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 129404 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 129409 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 129414 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 129417 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129419 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129422 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 129425 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 129428 */   GIR_RootConstrainSelectedInstOperands,
     /* 129429 */   // GIR_Coverage, 3902,
     /* 129429 */   GIR_EraseRootFromParent_Done,
     /* 129430 */ // Label 1822: @129430
     /* 129430 */ GIM_Try, /*On fail goto*//*Label 1823*/ GIMT_Encode4(129569), // Rule ID 3966 //
     /* 129435 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 129438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 129441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 129445 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129449 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 129453 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 129457 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 129461 */   // MIs[1] Operand 1
     /* 129461 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 129466 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129468 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 129468 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 129471 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 129475 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129480 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 129484 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 129488 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 129490 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 129493 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 129497 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129502 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 129505 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 129507 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 129510 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 129514 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129519 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 129522 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 129524 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 129527 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 129531 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129536 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 129543 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 129548 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 129553 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 129556 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129558 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129561 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 129564 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 129567 */   GIR_RootConstrainSelectedInstOperands,
     /* 129568 */   // GIR_Coverage, 3966,
     /* 129568 */   GIR_EraseRootFromParent_Done,
     /* 129569 */ // Label 1823: @129569
     /* 129569 */ GIM_Try, /*On fail goto*//*Label 1824*/ GIMT_Encode4(129708), // Rule ID 3974 //
     /* 129574 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 129577 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 129580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 129584 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129588 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 129592 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 129596 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 129600 */   // MIs[1] Operand 1
     /* 129600 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 129605 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129607 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 129607 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 129610 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 129614 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129619 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 129623 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 129627 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 129629 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 129632 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 129636 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129641 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 129644 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 129646 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 129649 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 129653 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129658 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 129661 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 129663 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 129666 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 129670 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129675 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 129682 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 129687 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 129692 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 129695 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129697 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129700 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 129703 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 129706 */   GIR_RootConstrainSelectedInstOperands,
     /* 129707 */   // GIR_Coverage, 3974,
     /* 129707 */   GIR_EraseRootFromParent_Done,
     /* 129708 */ // Label 1824: @129708
     /* 129708 */ GIM_Try, /*On fail goto*//*Label 1825*/ GIMT_Encode4(129847), // Rule ID 3982 //
     /* 129713 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 129716 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 129719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 129723 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129727 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 129731 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 129735 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 129739 */   // MIs[1] Operand 1
     /* 129739 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 129744 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129746 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 129746 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 129749 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 129753 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129758 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 129762 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 129766 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 129768 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 129771 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 129775 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129780 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 129783 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 129785 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 129788 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 129792 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129797 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 129800 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 129802 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 129805 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 129809 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129814 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 129821 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 129826 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 129831 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 129834 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129836 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129839 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 129842 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 129845 */   GIR_RootConstrainSelectedInstOperands,
     /* 129846 */   // GIR_Coverage, 3982,
     /* 129846 */   GIR_EraseRootFromParent_Done,
     /* 129847 */ // Label 1825: @129847
     /* 129847 */ GIM_Try, /*On fail goto*//*Label 1826*/ GIMT_Encode4(129986), // Rule ID 3990 //
     /* 129852 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 129855 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 129858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 129862 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129866 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 129870 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 129874 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 129878 */   // MIs[1] Operand 1
     /* 129878 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 129883 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129885 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 129885 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 129888 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 129892 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129897 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 129901 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 129905 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 129907 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 129910 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 129914 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129919 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 129922 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 129924 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 129927 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 129931 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129936 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 129939 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 129941 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 129944 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 129948 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129953 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 129960 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 129965 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 129970 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 129973 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129975 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129978 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 129981 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 129984 */   GIR_RootConstrainSelectedInstOperands,
     /* 129985 */   // GIR_Coverage, 3990,
     /* 129985 */   GIR_EraseRootFromParent_Done,
     /* 129986 */ // Label 1826: @129986
     /* 129986 */ GIM_Try, /*On fail goto*//*Label 1827*/ GIMT_Encode4(130125), // Rule ID 3998 //
     /* 129991 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 129994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 129997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 130001 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 130005 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 130009 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 130013 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 130017 */   // MIs[1] Operand 1
     /* 130017 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 130022 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130024 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 130024 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 130027 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 130031 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130036 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 130040 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 130044 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 130046 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 130049 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 130053 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130058 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 130061 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 130063 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 130066 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 130070 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130075 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 130078 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 130080 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 130083 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130087 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130092 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 130099 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 130104 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 130109 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 130112 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130114 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130117 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 130120 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 130123 */   GIR_RootConstrainSelectedInstOperands,
     /* 130124 */   // GIR_Coverage, 3998,
     /* 130124 */   GIR_EraseRootFromParent_Done,
     /* 130125 */ // Label 1827: @130125
     /* 130125 */ GIM_Try, /*On fail goto*//*Label 1828*/ GIMT_Encode4(130144), // Rule ID 684 //
     /* 130130 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 130133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 130137 */   // (sext:{ *:[i64] } i32:{ *:[i32] }:$RST)  =>  (EXTSW_32_64:{ *:[i64] } i32:{ *:[i32] }:$RST)
     /* 130137 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EXTSW_32_64),
     /* 130142 */   GIR_RootConstrainSelectedInstOperands,
     /* 130143 */   // GIR_Coverage, 684,
     /* 130143 */   GIR_Done,
     /* 130144 */ // Label 1828: @130144
     /* 130144 */ GIM_Try, /*On fail goto*//*Label 1829*/ GIMT_Encode4(130166), // Rule ID 2991 //
     /* 130149 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 130152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 130155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 130159 */   // (sext:{ *:[i64] } i1:{ *:[i1] }:$in)  =>  (SETNBC8:{ *:[i64] } ?:{ *:[i1] }:$in)
     /* 130159 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SETNBC8),
     /* 130164 */   GIR_RootConstrainSelectedInstOperands,
     /* 130165 */   // GIR_Coverage, 2991,
     /* 130165 */   GIR_Done,
     /* 130166 */ // Label 1829: @130166
     /* 130166 */ GIM_Try, /*On fail goto*//*Label 1830*/ GIMT_Encode4(130227), // Rule ID 3676 //
     /* 130171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 130174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 130178 */   // (sext:{ *:[i64] } i1:{ *:[i1] }:$in)  =>  (SELECT_I8:{ *:[i64] } ?:{ *:[i1] }:$in, (LI8:{ *:[i64] } -1:{ *:[i64] }), (LI8:{ *:[i64] } 0:{ *:[i64] }))
     /* 130178 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 130181 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 130185 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130190 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 130193 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 130195 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 130198 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 130202 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130207 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/uint8_t(-1),
     /* 130210 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130212 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 130215 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130217 */   GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 130219 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130222 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 130225 */   GIR_RootConstrainSelectedInstOperands,
     /* 130226 */   // GIR_Coverage, 3676,
     /* 130226 */   GIR_EraseRootFromParent_Done,
     /* 130227 */ // Label 1830: @130227
     /* 130227 */ GIM_Reject,
     /* 130228 */ // Label 1700: @130228
     /* 130228 */ GIM_Reject,
     /* 130229 */ // Label 25: @130229
     /* 130229 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 1835*/ GIMT_Encode4(130581),
     /* 130240 */ /*GILLT_s32*//*Label 1831*/ GIMT_Encode4(130260),
     /* 130244 */ /*GILLT_s64*//*Label 1832*/ GIMT_Encode4(130324), GIMT_Encode4(0),
     /* 130252 */ /*GILLT_v2s64*//*Label 1833*/ GIMT_Encode4(130413),
     /* 130256 */ /*GILLT_v4s32*//*Label 1834*/ GIMT_Encode4(130511),
     /* 130260 */ // Label 1831: @130260
     /* 130260 */ GIM_Try, /*On fail goto*//*Label 1836*/ GIMT_Encode4(130323),
     /* 130265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 130268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 130272 */   GIM_Try, /*On fail goto*//*Label 1837*/ GIMT_Encode4(130297), // Rule ID 135 //
     /* 130277 */     // MIs[0] Operand 2
     /* 130277 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 130288 */     // (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$RST, i8:{ *:[Other] })  =>  (EXTSB:{ *:[i32] } i32:{ *:[i32] }:$RST)
     /* 130288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EXTSB),
     /* 130291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 130293 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /* 130295 */     GIR_RootConstrainSelectedInstOperands,
     /* 130296 */     // GIR_Coverage, 135,
     /* 130296 */     GIR_EraseRootFromParent_Done,
     /* 130297 */   // Label 1837: @130297
     /* 130297 */   GIM_Try, /*On fail goto*//*Label 1838*/ GIMT_Encode4(130322), // Rule ID 136 //
     /* 130302 */     // MIs[0] Operand 2
     /* 130302 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 130313 */     // (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$RST, i16:{ *:[Other] })  =>  (EXTSH:{ *:[i32] } i32:{ *:[i32] }:$RST)
     /* 130313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EXTSH),
     /* 130316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 130318 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /* 130320 */     GIR_RootConstrainSelectedInstOperands,
     /* 130321 */     // GIR_Coverage, 136,
     /* 130321 */     GIR_EraseRootFromParent_Done,
     /* 130322 */   // Label 1838: @130322
     /* 130322 */   GIM_Reject,
     /* 130323 */ // Label 1836: @130323
     /* 130323 */ GIM_Reject,
     /* 130324 */ // Label 1832: @130324
     /* 130324 */ GIM_Try, /*On fail goto*//*Label 1839*/ GIMT_Encode4(130412),
     /* 130329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 130332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 130336 */   GIM_Try, /*On fail goto*//*Label 1840*/ GIMT_Encode4(130361), // Rule ID 681 //
     /* 130341 */     // MIs[0] Operand 2
     /* 130341 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 130352 */     // (sext_inreg:{ *:[i64] } i64:{ *:[i64] }:$RST, i8:{ *:[Other] })  =>  (EXTSB8:{ *:[i64] } i64:{ *:[i64] }:$RST)
     /* 130352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EXTSB8),
     /* 130355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 130357 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /* 130359 */     GIR_RootConstrainSelectedInstOperands,
     /* 130360 */     // GIR_Coverage, 681,
     /* 130360 */     GIR_EraseRootFromParent_Done,
     /* 130361 */   // Label 1840: @130361
     /* 130361 */   GIM_Try, /*On fail goto*//*Label 1841*/ GIMT_Encode4(130386), // Rule ID 682 //
     /* 130366 */     // MIs[0] Operand 2
     /* 130366 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 130377 */     // (sext_inreg:{ *:[i64] } i64:{ *:[i64] }:$RST, i16:{ *:[Other] })  =>  (EXTSH8:{ *:[i64] } i64:{ *:[i64] }:$RST)
     /* 130377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EXTSH8),
     /* 130380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 130382 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /* 130384 */     GIR_RootConstrainSelectedInstOperands,
     /* 130385 */     // GIR_Coverage, 682,
     /* 130385 */     GIR_EraseRootFromParent_Done,
     /* 130386 */   // Label 1841: @130386
     /* 130386 */   GIM_Try, /*On fail goto*//*Label 1842*/ GIMT_Encode4(130411), // Rule ID 683 //
     /* 130391 */     // MIs[0] Operand 2
     /* 130391 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 130402 */     // (sext_inreg:{ *:[i64] } i64:{ *:[i64] }:$RST, i32:{ *:[Other] })  =>  (EXTSW:{ *:[i64] } i64:{ *:[i64] }:$RST)
     /* 130402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EXTSW),
     /* 130405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 130407 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /* 130409 */     GIR_RootConstrainSelectedInstOperands,
     /* 130410 */     // GIR_Coverage, 683,
     /* 130410 */     GIR_EraseRootFromParent_Done,
     /* 130411 */   // Label 1842: @130411
     /* 130411 */   GIM_Reject,
     /* 130412 */ // Label 1839: @130412
     /* 130412 */ GIM_Reject,
     /* 130413 */ // Label 1833: @130413
     /* 130413 */ GIM_Try, /*On fail goto*//*Label 1843*/ GIMT_Encode4(130510),
     /* 130418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 130421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 130425 */   GIM_Try, /*On fail goto*//*Label 1844*/ GIMT_Encode4(130453), // Rule ID 1456 //
     /* 130430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /* 130433 */     // MIs[0] Operand 2
     /* 130433 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 130444 */     // (sext_inreg:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VRB, v2i8:{ *:[Other] })  =>  (VEXTSB2D:{ *:[v2i64] } ?:{ *:[v2i64] }:$VRB)
     /* 130444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTSB2D),
     /* 130447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 130449 */     GIR_RootToRootCopy, /*OpIdx*/1, // VRB
     /* 130451 */     GIR_RootConstrainSelectedInstOperands,
     /* 130452 */     // GIR_Coverage, 1456,
     /* 130452 */     GIR_EraseRootFromParent_Done,
     /* 130453 */   // Label 1844: @130453
     /* 130453 */   GIM_Try, /*On fail goto*//*Label 1845*/ GIMT_Encode4(130481), // Rule ID 1457 //
     /* 130458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /* 130461 */     // MIs[0] Operand 2
     /* 130461 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 130472 */     // (sext_inreg:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VRB, v2i16:{ *:[Other] })  =>  (VEXTSH2D:{ *:[v2i64] } ?:{ *:[v2i64] }:$VRB)
     /* 130472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTSH2D),
     /* 130475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 130477 */     GIR_RootToRootCopy, /*OpIdx*/1, // VRB
     /* 130479 */     GIR_RootConstrainSelectedInstOperands,
     /* 130480 */     // GIR_Coverage, 1457,
     /* 130480 */     GIR_EraseRootFromParent_Done,
     /* 130481 */   // Label 1845: @130481
     /* 130481 */   GIM_Try, /*On fail goto*//*Label 1846*/ GIMT_Encode4(130509), // Rule ID 1458 //
     /* 130486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /* 130489 */     // MIs[0] Operand 2
     /* 130489 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 130500 */     // (sext_inreg:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VRB, v2i32:{ *:[Other] })  =>  (VEXTSW2D:{ *:[v2i64] } ?:{ *:[v2i64] }:$VRB)
     /* 130500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTSW2D),
     /* 130503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 130505 */     GIR_RootToRootCopy, /*OpIdx*/1, // VRB
     /* 130507 */     GIR_RootConstrainSelectedInstOperands,
     /* 130508 */     // GIR_Coverage, 1458,
     /* 130508 */     GIR_EraseRootFromParent_Done,
     /* 130509 */   // Label 1846: @130509
     /* 130509 */   GIM_Reject,
     /* 130510 */ // Label 1843: @130510
     /* 130510 */ GIM_Reject,
     /* 130511 */ // Label 1834: @130511
     /* 130511 */ GIM_Try, /*On fail goto*//*Label 1847*/ GIMT_Encode4(130580),
     /* 130516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 130519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 130523 */   GIM_Try, /*On fail goto*//*Label 1848*/ GIMT_Encode4(130551), // Rule ID 1454 //
     /* 130528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /* 130531 */     // MIs[0] Operand 2
     /* 130531 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 130542 */     // (sext_inreg:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VRB, v4i8:{ *:[Other] })  =>  (VEXTSB2W:{ *:[v4i32] } ?:{ *:[v4i32] }:$VRB)
     /* 130542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTSB2W),
     /* 130545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 130547 */     GIR_RootToRootCopy, /*OpIdx*/1, // VRB
     /* 130549 */     GIR_RootConstrainSelectedInstOperands,
     /* 130550 */     // GIR_Coverage, 1454,
     /* 130550 */     GIR_EraseRootFromParent_Done,
     /* 130551 */   // Label 1848: @130551
     /* 130551 */   GIM_Try, /*On fail goto*//*Label 1849*/ GIMT_Encode4(130579), // Rule ID 1455 //
     /* 130556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /* 130559 */     // MIs[0] Operand 2
     /* 130559 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 130570 */     // (sext_inreg:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VRB, v4i16:{ *:[Other] })  =>  (VEXTSH2W:{ *:[v4i32] } ?:{ *:[v4i32] }:$VRB)
     /* 130570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTSH2W),
     /* 130573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 130575 */     GIR_RootToRootCopy, /*OpIdx*/1, // VRB
     /* 130577 */     GIR_RootConstrainSelectedInstOperands,
     /* 130578 */     // GIR_Coverage, 1455,
     /* 130578 */     GIR_EraseRootFromParent_Done,
     /* 130579 */   // Label 1849: @130579
     /* 130579 */   GIM_Reject,
     /* 130580 */ // Label 1847: @130580
     /* 130580 */ GIM_Reject,
     /* 130581 */ // Label 1835: @130581
     /* 130581 */ GIM_Reject,
     /* 130582 */ // Label 26: @130582
     /* 130582 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1852*/ GIMT_Encode4(152051),
     /* 130593 */ /*GILLT_s32*//*Label 1850*/ GIMT_Encode4(130601),
     /* 130597 */ /*GILLT_s64*//*Label 1851*/ GIMT_Encode4(140822),
     /* 130601 */ // Label 1850: @130601
     /* 130601 */ GIM_Try, /*On fail goto*//*Label 1853*/ GIMT_Encode4(140821),
     /* 130606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 130609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 130613 */   GIM_Try, /*On fail goto*//*Label 1854*/ GIMT_Encode4(130725), // Rule ID 5299 //
     /* 130618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 130622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 130626 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 130630 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 130634 */     // MIs[1] Operand 1
     /* 130634 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 130639 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 130643 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 130647 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 130651 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 130655 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 130659 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 130663 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 130667 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 130671 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 130675 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 130679 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 130681 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa), i32:{ *:[i32] }:$s1), 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (RLWNM:{ *:[i32] } ?:{ *:[i32] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 130681 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130684 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 130688 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130693 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 130697 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 130700 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for PPC::CARRY*/0,
     /* 130703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 130708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 130710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 130714 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 130720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 130723 */     GIR_RootConstrainSelectedInstOperands,
     /* 130724 */     // GIR_Coverage, 5299,
     /* 130724 */     GIR_EraseRootFromParent_Done,
     /* 130725 */   // Label 1854: @130725
     /* 130725 */   GIM_Try, /*On fail goto*//*Label 1855*/ GIMT_Encode4(130864), // Rule ID 5302 //
     /* 130730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 130734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 130738 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 130742 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 130746 */     // MIs[1] Operand 1
     /* 130746 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 130751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 130755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 130759 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 130763 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 130767 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 130771 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 130775 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 130779 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 130783 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 130787 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 130791 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 130793 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa), i64:{ *:[i64] }:$s1), 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDCL:{ *:[i64] } ?:{ *:[i64] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 130793 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 130796 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 130800 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130805 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 130809 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/64,
     /* 130812 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /* 130815 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 130817 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 130820 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 130824 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130829 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 130833 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 130836 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 130839 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130846 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 130853 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 130858 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 130863 */     // GIR_Coverage, 5302,
     /* 130863 */     GIR_EraseRootFromParent_Done,
     /* 130864 */   // Label 1855: @130864
     /* 130864 */   GIM_Try, /*On fail goto*//*Label 1856*/ GIMT_Encode4(130997), // Rule ID 5307 //
     /* 130869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 130873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 130877 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 130881 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 130885 */     // MIs[1] Operand 1
     /* 130885 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 130890 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 130894 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 130898 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 130902 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 130906 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 130910 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 130914 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 130918 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 130922 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 130926 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 130930 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 130932 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa), i32:{ *:[i32] }:$s1), 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (RLWNM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 130932 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 130935 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 130939 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130944 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 130948 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/32,
     /* 130951 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /* 130954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 130956 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130959 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 130963 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130968 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 130972 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 130976 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 130981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 130983 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130986 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 130989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 130992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 130995 */     GIR_RootConstrainSelectedInstOperands,
     /* 130996 */     // GIR_Coverage, 5307,
     /* 130996 */     GIR_EraseRootFromParent_Done,
     /* 130997 */   // Label 1856: @130997
     /* 130997 */   GIM_Try, /*On fail goto*//*Label 1857*/ GIMT_Encode4(131157), // Rule ID 5310 //
     /* 131002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 131006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 131010 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131014 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 131018 */     // MIs[1] Operand 1
     /* 131018 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 131023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 131027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 131031 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 131035 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 131039 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 131043 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 131047 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 131051 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 131055 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 131059 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 131063 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 131065 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa), i64:{ *:[i64] }:$s1), 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDCL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 131065 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 131068 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 131072 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131077 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 131081 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/64,
     /* 131084 */     GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for PPC::CARRY*/0,
     /* 131087 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 131089 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 131092 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 131096 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131101 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 131105 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 131109 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 131111 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 131114 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 131118 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131123 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 131126 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 131129 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 131132 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131139 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 131146 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 131151 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 131156 */     // GIR_Coverage, 5310,
     /* 131156 */     GIR_EraseRootFromParent_Done,
     /* 131157 */   // Label 1857: @131157
     /* 131157 */   GIM_Try, /*On fail goto*//*Label 1858*/ GIMT_Encode4(131269), // Rule ID 3777 //
     /* 131162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 131166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 131170 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 131174 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 131178 */     // MIs[1] Operand 1
     /* 131178 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 131183 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 131187 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 131191 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 131195 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 131199 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 131203 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 131207 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 131211 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 131215 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 131219 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 131223 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 131225 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i32] } i32:{ *:[i32] }:$s1, (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (RLWNM:{ *:[i32] } ?:{ *:[i32] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 131225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 131232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131237 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 131241 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 131244 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for PPC::CARRY*/0,
     /* 131247 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 131252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 131254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 131258 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 131264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 131267 */     GIR_RootConstrainSelectedInstOperands,
     /* 131268 */     // GIR_Coverage, 3777,
     /* 131268 */     GIR_EraseRootFromParent_Done,
     /* 131269 */   // Label 1858: @131269
     /* 131269 */   GIM_Try, /*On fail goto*//*Label 1859*/ GIMT_Encode4(131408), // Rule ID 3780 //
     /* 131274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 131278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 131282 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131286 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 131290 */     // MIs[1] Operand 1
     /* 131290 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 131295 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 131299 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 131303 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 131307 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 131311 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 131315 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 131319 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 131323 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 131327 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 131331 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 131335 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 131337 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i64] } i64:{ *:[i64] }:$s1, (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDCL:{ *:[i64] } ?:{ *:[i64] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 131337 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 131340 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 131344 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131349 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 131353 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/64,
     /* 131356 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /* 131359 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 131361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 131364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 131368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131373 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 131377 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 131380 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 131383 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131390 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 131397 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 131402 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 131407 */     // GIR_Coverage, 3780,
     /* 131407 */     GIR_EraseRootFromParent_Done,
     /* 131408 */   // Label 1859: @131408
     /* 131408 */   GIM_Try, /*On fail goto*//*Label 1860*/ GIMT_Encode4(131541), // Rule ID 3785 //
     /* 131413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 131417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 131421 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 131425 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 131429 */     // MIs[1] Operand 1
     /* 131429 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 131434 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 131438 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 131442 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 131446 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 131450 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 131454 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 131458 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 131462 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 131466 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 131470 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 131474 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 131476 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i32] } i32:{ *:[i32] }:$s1, (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (RLWNM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 131476 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 131479 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 131483 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131488 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 131492 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/32,
     /* 131495 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /* 131498 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 131500 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131503 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 131507 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131512 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 131516 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 131520 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 131525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 131527 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131530 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 131533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 131536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 131539 */     GIR_RootConstrainSelectedInstOperands,
     /* 131540 */     // GIR_Coverage, 3785,
     /* 131540 */     GIR_EraseRootFromParent_Done,
     /* 131541 */   // Label 1860: @131541
     /* 131541 */   GIM_Try, /*On fail goto*//*Label 1861*/ GIMT_Encode4(131701), // Rule ID 3788 //
     /* 131546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 131550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 131554 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131558 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 131562 */     // MIs[1] Operand 1
     /* 131562 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 131567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 131571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 131575 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 131579 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 131583 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 131587 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 131591 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 131595 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 131599 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 131603 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 131607 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 131609 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i64] } i64:{ *:[i64] }:$s1, (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDCL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 131609 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 131612 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 131616 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131621 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 131625 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/64,
     /* 131628 */     GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for PPC::CARRY*/0,
     /* 131631 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 131633 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 131636 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 131640 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131645 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 131649 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 131653 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 131655 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 131658 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 131662 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131667 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 131670 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 131673 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 131676 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131683 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 131690 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 131695 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 131700 */     // GIR_Coverage, 3788,
     /* 131700 */     GIR_EraseRootFromParent_Done,
     /* 131701 */   // Label 1861: @131701
     /* 131701 */   GIM_Try, /*On fail goto*//*Label 1862*/ GIMT_Encode4(131770), // Rule ID 3697 //
     /* 131706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 131710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 131714 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 131718 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 131722 */     // MIs[1] Operand 1
     /* 131722 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 131727 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 131731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131733 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1), 27:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 131733 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131736 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /* 131740 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131745 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 131749 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 131754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 131756 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/27,
     /* 131762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 131765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 131768 */     GIR_RootConstrainSelectedInstOperands,
     /* 131769 */     // GIR_Coverage, 3697,
     /* 131769 */     GIR_EraseRootFromParent_Done,
     /* 131770 */   // Label 1862: @131770
     /* 131770 */   GIM_Try, /*On fail goto*//*Label 1863*/ GIMT_Encode4(131866), // Rule ID 3700 //
     /* 131775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 131779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 131783 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131787 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 131791 */     // MIs[1] Operand 1
     /* 131791 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 131796 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 131800 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131802 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1), 58:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 131802 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 131805 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /* 131809 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131814 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 131818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 131820 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 131823 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 131827 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131832 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 131835 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/58,
     /* 131838 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 131841 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131848 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 131855 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 131860 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 131865 */     // GIR_Coverage, 3700,
     /* 131865 */     GIR_EraseRootFromParent_Done,
     /* 131866 */   // Label 1863: @131866
     /* 131866 */   GIM_Try, /*On fail goto*//*Label 1864*/ GIMT_Encode4(131973), // Rule ID 3705 //
     /* 131871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 131875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 131879 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 131883 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 131887 */     // MIs[1] Operand 1
     /* 131887 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 131892 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 131896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131898 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1), (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1)), 27:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 131898 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 131901 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /* 131905 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131910 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 131914 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 131916 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 131919 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /* 131923 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131928 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 131932 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 131934 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131937 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 131941 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131946 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 131949 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 131952 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 131957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 131959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/27,
     /* 131965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 131968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 131971 */     GIR_RootConstrainSelectedInstOperands,
     /* 131972 */     // GIR_Coverage, 3705,
     /* 131972 */     GIR_EraseRootFromParent_Done,
     /* 131973 */   // Label 1864: @131973
     /* 131973 */   GIM_Try, /*On fail goto*//*Label 1865*/ GIMT_Encode4(132107), // Rule ID 3708 //
     /* 131978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 131982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 131986 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131990 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 131994 */     // MIs[1] Operand 1
     /* 131994 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 131999 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 132003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132005 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1), (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1)), 58:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 132005 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 132008 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /* 132012 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132017 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132021 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 132023 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 132026 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /* 132030 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132035 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132039 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 132041 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 132044 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 132048 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132053 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 132056 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 132059 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 132061 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 132064 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 132068 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132073 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132076 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/58,
     /* 132079 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 132082 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132089 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 132096 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 132101 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 132106 */     // GIR_Coverage, 3708,
     /* 132106 */     GIR_EraseRootFromParent_Done,
     /* 132107 */   // Label 1865: @132107
     /* 132107 */   GIM_Try, /*On fail goto*//*Label 1866*/ GIMT_Encode4(132159), // Rule ID 3713 //
     /* 132112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 132116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 132120 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 132124 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 132128 */     // MIs[1] Operand 1
     /* 132128 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 132133 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 132137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132139 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETLT:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 132139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 132142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 132144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 132151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 132154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 132157 */     GIR_RootConstrainSelectedInstOperands,
     /* 132158 */     // GIR_Coverage, 3713,
     /* 132158 */     GIR_EraseRootFromParent_Done,
     /* 132159 */   // Label 1866: @132159
     /* 132159 */   GIM_Try, /*On fail goto*//*Label 1867*/ GIMT_Encode4(132238), // Rule ID 3716 //
     /* 132164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 132168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 132172 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132176 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 132180 */     // MIs[1] Operand 1
     /* 132180 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 132185 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 132189 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132191 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETLT:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 132191 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 132194 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 132198 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132203 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132207 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 132210 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 132213 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132220 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 132227 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 132232 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 132237 */     // GIR_Coverage, 3716,
     /* 132237 */     GIR_EraseRootFromParent_Done,
     /* 132238 */   // Label 1867: @132238
     /* 132238 */   GIM_Try, /*On fail goto*//*Label 1868*/ GIMT_Encode4(132311), // Rule ID 3721 //
     /* 132243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 132247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 132251 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 132255 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 132259 */     // MIs[1] Operand 1
     /* 132259 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 132264 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 132268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132270 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETGE:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 132270 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 132273 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 132277 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132282 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132286 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132290 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 132295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 132297 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 132303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 132306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 132309 */     GIR_RootConstrainSelectedInstOperands,
     /* 132310 */     // GIR_Coverage, 3721,
     /* 132310 */     GIR_EraseRootFromParent_Done,
     /* 132311 */   // Label 1868: @132311
     /* 132311 */   GIM_Try, /*On fail goto*//*Label 1869*/ GIMT_Encode4(132411), // Rule ID 3724 //
     /* 132316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 132320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 132324 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132328 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 132332 */     // MIs[1] Operand 1
     /* 132332 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 132337 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 132341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132343 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETGE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 132343 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 132346 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 132350 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132355 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132359 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132363 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 132365 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 132368 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 132372 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132377 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132380 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 132383 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 132386 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132393 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 132400 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 132405 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 132410 */     // GIR_Coverage, 3724,
     /* 132410 */     GIR_EraseRootFromParent_Done,
     /* 132411 */   // Label 1869: @132411
     /* 132411 */   GIM_Try, /*On fail goto*//*Label 1870*/ GIMT_Encode4(132501), // Rule ID 3729 //
     /* 132416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 132420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 132424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 132428 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 132432 */     // MIs[1] Operand 1
     /* 132432 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 132437 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 132441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132443 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETGT:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (ANDC:{ *:[i32] } (NEG:{ *:[i32] } ?:{ *:[i32] }:$s1), ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 132443 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 132446 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NEG),
     /* 132450 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132455 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 132461 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 132464 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::ANDC),
     /* 132468 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132473 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132476 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132480 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 132485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 132487 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 132493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 132496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 132499 */     GIR_RootConstrainSelectedInstOperands,
     /* 132500 */     // GIR_Coverage, 3729,
     /* 132500 */     GIR_EraseRootFromParent_Done,
     /* 132501 */   // Label 1870: @132501
     /* 132501 */   GIM_Try, /*On fail goto*//*Label 1871*/ GIMT_Encode4(132618), // Rule ID 3732 //
     /* 132506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 132510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 132514 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132518 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 132522 */     // MIs[1] Operand 1
     /* 132522 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 132527 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 132531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132533 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETGT:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (ANDC8:{ *:[i64] } (NEG8:{ *:[i64] } ?:{ *:[i64] }:$s1), ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 132533 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 132536 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NEG8),
     /* 132540 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132545 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132549 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 132551 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 132554 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ANDC8),
     /* 132558 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132563 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 132566 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132570 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 132572 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 132575 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 132579 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132584 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132587 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 132590 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 132593 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132600 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 132607 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 132612 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 132617 */     // GIR_Coverage, 3732,
     /* 132617 */     GIR_EraseRootFromParent_Done,
     /* 132618 */   // Label 1871: @132618
     /* 132618 */   GIM_Try, /*On fail goto*//*Label 1872*/ GIMT_Encode4(132708), // Rule ID 3737 //
     /* 132623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 132627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 132631 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 132635 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 132639 */     // MIs[1] Operand 1
     /* 132639 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 132644 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 132648 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132650 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETLE:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (ORC:{ *:[i32] } ?:{ *:[i32] }:$s1, (NEG:{ *:[i32] } ?:{ *:[i32] }:$s1)), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 132650 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 132653 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NEG),
     /* 132657 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132662 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132666 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 132668 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 132671 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::ORC),
     /* 132675 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132680 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132684 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132687 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 132692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 132694 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 132700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 132703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 132706 */     GIR_RootConstrainSelectedInstOperands,
     /* 132707 */     // GIR_Coverage, 3737,
     /* 132707 */     GIR_EraseRootFromParent_Done,
     /* 132708 */   // Label 1872: @132708
     /* 132708 */   GIM_Try, /*On fail goto*//*Label 1873*/ GIMT_Encode4(132825), // Rule ID 3740 //
     /* 132713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 132717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 132721 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132725 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 132729 */     // MIs[1] Operand 1
     /* 132729 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 132734 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 132738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132740 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETLE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (ORC8:{ *:[i64] } ?:{ *:[i64] }:$s1, (NEG8:{ *:[i64] } ?:{ *:[i64] }:$s1)), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 132740 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 132743 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NEG8),
     /* 132747 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132752 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132756 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 132758 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 132761 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ORC8),
     /* 132765 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132770 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132774 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 132777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 132779 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 132782 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 132786 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132791 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132794 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 132797 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 132800 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132807 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 132814 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 132819 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 132824 */     // GIR_Coverage, 3740,
     /* 132824 */     GIR_EraseRootFromParent_Done,
     /* 132825 */   // Label 1873: @132825
     /* 132825 */   GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(132918), // Rule ID 3745 //
     /* 132830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 132834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 132838 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 132842 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 132846 */     // MIs[1] Operand 1
     /* 132846 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 132851 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 132855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132857 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETLT:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (AND:{ *:[i32] } ?:{ *:[i32] }:$s1, (ADDI:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] })), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 132857 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 132860 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ADDI),
     /* 132864 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132869 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132873 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 132876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 132878 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 132881 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 132885 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132890 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132894 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132897 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 132902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 132904 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 132910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 132913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 132916 */     GIR_RootConstrainSelectedInstOperands,
     /* 132917 */     // GIR_Coverage, 3745,
     /* 132917 */     GIR_EraseRootFromParent_Done,
     /* 132918 */   // Label 1874: @132918
     /* 132918 */   GIM_Try, /*On fail goto*//*Label 1875*/ GIMT_Encode4(133038), // Rule ID 3748 //
     /* 132923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 132927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 132931 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132935 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 132939 */     // MIs[1] Operand 1
     /* 132939 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 132944 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 132948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132950 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETLT:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (AND8:{ *:[i64] } ?:{ *:[i64] }:$s1, (ADDI8:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i64] })), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 132950 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 132953 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::ADDI8),
     /* 132957 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132962 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132966 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 132969 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 132971 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 132974 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 132978 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132983 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132987 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 132990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 132992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 132995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 132999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133004 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 133007 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 133010 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 133013 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 133015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133020 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 133027 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 133032 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 133037 */     // GIR_Coverage, 3748,
     /* 133037 */     GIR_EraseRootFromParent_Done,
     /* 133038 */   // Label 1875: @133038
     /* 133038 */   GIM_Try, /*On fail goto*//*Label 1876*/ GIMT_Encode4(133131), // Rule ID 3753 //
     /* 133043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 133047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 133051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 133055 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 133059 */     // MIs[1] Operand 1
     /* 133059 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 133064 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 133068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133070 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETGE:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (NAND:{ *:[i32] } ?:{ *:[i32] }:$s1, (ADDI:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] })), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 133070 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 133073 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ADDI),
     /* 133077 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133082 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133086 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 133089 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 133091 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 133094 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NAND),
     /* 133098 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133103 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133107 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 133110 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 133112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 133115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 133117 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 133123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 133126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 133129 */     GIR_RootConstrainSelectedInstOperands,
     /* 133130 */     // GIR_Coverage, 3753,
     /* 133130 */     GIR_EraseRootFromParent_Done,
     /* 133131 */   // Label 1876: @133131
     /* 133131 */   GIM_Try, /*On fail goto*//*Label 1877*/ GIMT_Encode4(133251), // Rule ID 3756 //
     /* 133136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 133140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 133144 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133148 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 133152 */     // MIs[1] Operand 1
     /* 133152 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 133157 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 133161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133163 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETGE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (NAND8:{ *:[i64] } ?:{ *:[i64] }:$s1, (ADDI8:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i64] })), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 133163 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 133166 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::ADDI8),
     /* 133170 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133175 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133179 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 133182 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 133184 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 133187 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NAND8),
     /* 133191 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133196 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133200 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 133203 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 133205 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 133208 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 133212 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133217 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 133220 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 133223 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 133226 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 133228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133233 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 133240 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 133245 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 133250 */     // GIR_Coverage, 3756,
     /* 133250 */     GIR_EraseRootFromParent_Done,
     /* 133251 */   // Label 1877: @133251
     /* 133251 */   GIM_Try, /*On fail goto*//*Label 1878*/ GIMT_Encode4(133324), // Rule ID 3761 //
     /* 133256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 133260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 133264 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 133268 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 133272 */     // MIs[1] Operand 1
     /* 133272 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 133277 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 133281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133283 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETGT:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 133283 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 133286 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 133290 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133295 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133299 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133303 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 133305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 133308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 133310 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 133316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 133319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 133322 */     GIR_RootConstrainSelectedInstOperands,
     /* 133323 */     // GIR_Coverage, 3761,
     /* 133323 */     GIR_EraseRootFromParent_Done,
     /* 133324 */   // Label 1878: @133324
     /* 133324 */   GIM_Try, /*On fail goto*//*Label 1879*/ GIMT_Encode4(133424), // Rule ID 3764 //
     /* 133329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 133333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 133337 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133341 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 133345 */     // MIs[1] Operand 1
     /* 133345 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 133350 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 133354 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133356 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETGT:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 133356 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 133359 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 133363 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133368 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133372 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133376 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 133378 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 133381 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 133385 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133390 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 133393 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 133396 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 133399 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 133401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133406 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 133413 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 133418 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 133423 */     // GIR_Coverage, 3764,
     /* 133423 */     GIR_EraseRootFromParent_Done,
     /* 133424 */   // Label 1879: @133424
     /* 133424 */   GIM_Try, /*On fail goto*//*Label 1880*/ GIMT_Encode4(133476), // Rule ID 3769 //
     /* 133429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 133433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 133437 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 133441 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 133445 */     // MIs[1] Operand 1
     /* 133445 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 133450 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 133454 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133456 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETLE:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 133456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 133459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 133461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 133468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 133471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 133474 */     GIR_RootConstrainSelectedInstOperands,
     /* 133475 */     // GIR_Coverage, 3769,
     /* 133475 */     GIR_EraseRootFromParent_Done,
     /* 133476 */   // Label 1880: @133476
     /* 133476 */   GIM_Try, /*On fail goto*//*Label 1881*/ GIMT_Encode4(133555), // Rule ID 3772 //
     /* 133481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 133485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 133489 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133493 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 133497 */     // MIs[1] Operand 1
     /* 133497 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 133502 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 133506 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133508 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETLE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 133508 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 133511 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 133515 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133520 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133524 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 133527 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 133530 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 133532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133537 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 133544 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 133549 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 133554 */     // GIR_Coverage, 3772,
     /* 133554 */     GIR_EraseRootFromParent_Done,
     /* 133555 */   // Label 1881: @133555
     /* 133555 */   GIM_Try, /*On fail goto*//*Label 1882*/ GIMT_Encode4(133658), // Rule ID 3036 //
     /* 133560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 133563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 133567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 133571 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 133575 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 133579 */     // MIs[1] Operand 1
     /* 133579 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 133584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 133588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 133592 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 133596 */     // MIs[2] Operand 1
     /* 133596 */     // No operand predicates
     /* 133596 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 133598 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }))
     /* 133598 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 133601 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 133605 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133610 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133614 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 133617 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 133619 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 133622 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133626 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133631 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 133638 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 133643 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 133648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 133651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 133653 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133656 */     GIR_RootConstrainSelectedInstOperands,
     /* 133657 */     // GIR_Coverage, 3036,
     /* 133657 */     GIR_EraseRootFromParent_Done,
     /* 133658 */   // Label 1882: @133658
     /* 133658 */   GIM_Try, /*On fail goto*//*Label 1883*/ GIMT_Encode4(133761), // Rule ID 3052 //
     /* 133663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 133666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 133670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 133674 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 133678 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 133682 */     // MIs[1] Operand 1
     /* 133682 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 133687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 133691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 133695 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 133699 */     // MIs[2] Operand 1
     /* 133699 */     // No operand predicates
     /* 133699 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 133701 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }))
     /* 133701 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 133704 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 133708 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133713 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 133720 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 133722 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 133725 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133729 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133734 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 133741 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 133746 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 133751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 133754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 133756 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133759 */     GIR_RootConstrainSelectedInstOperands,
     /* 133760 */     // GIR_Coverage, 3052,
     /* 133760 */     GIR_EraseRootFromParent_Done,
     /* 133761 */   // Label 1883: @133761
     /* 133761 */   GIM_Try, /*On fail goto*//*Label 1884*/ GIMT_Encode4(133864), // Rule ID 3060 //
     /* 133766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 133769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 133773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 133777 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 133781 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 133785 */     // MIs[1] Operand 1
     /* 133785 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 133790 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 133794 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 133798 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 133802 */     // MIs[2] Operand 1
     /* 133802 */     // No operand predicates
     /* 133802 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 133804 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }))
     /* 133804 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 133807 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 133811 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133816 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133820 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 133823 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 133825 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 133828 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133832 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133837 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 133844 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 133849 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 133854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 133857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 133859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133862 */     GIR_RootConstrainSelectedInstOperands,
     /* 133863 */     // GIR_Coverage, 3060,
     /* 133863 */     GIR_EraseRootFromParent_Done,
     /* 133864 */   // Label 1884: @133864
     /* 133864 */   GIM_Try, /*On fail goto*//*Label 1885*/ GIMT_Encode4(133967), // Rule ID 3132 //
     /* 133869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 133872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 133876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 133880 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133884 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 133888 */     // MIs[1] Operand 1
     /* 133888 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 133893 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 133897 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 133901 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 133905 */     // MIs[2] Operand 1
     /* 133905 */     // No operand predicates
     /* 133905 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 133907 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }))
     /* 133907 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 133910 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 133914 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133919 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133923 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 133926 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 133928 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 133931 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133935 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133940 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 133947 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 133952 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 133957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 133960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 133962 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133965 */     GIR_RootConstrainSelectedInstOperands,
     /* 133966 */     // GIR_Coverage, 3132,
     /* 133966 */     GIR_EraseRootFromParent_Done,
     /* 133967 */   // Label 1885: @133967
     /* 133967 */   GIM_Try, /*On fail goto*//*Label 1886*/ GIMT_Encode4(134070), // Rule ID 3148 //
     /* 133972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 133975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 133979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 133983 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133987 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 133991 */     // MIs[1] Operand 1
     /* 133991 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 133996 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 134000 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 134004 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 134008 */     // MIs[2] Operand 1
     /* 134008 */     // No operand predicates
     /* 134008 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 134010 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }))
     /* 134010 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 134013 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 134017 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134022 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 134026 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 134029 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 134031 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 134034 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134038 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134043 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 134050 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 134055 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 134060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 134063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 134065 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134068 */     GIR_RootConstrainSelectedInstOperands,
     /* 134069 */     // GIR_Coverage, 3148,
     /* 134069 */     GIR_EraseRootFromParent_Done,
     /* 134070 */   // Label 1886: @134070
     /* 134070 */   GIM_Try, /*On fail goto*//*Label 1887*/ GIMT_Encode4(134173), // Rule ID 3156 //
     /* 134075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 134078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 134082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 134086 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134090 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 134094 */     // MIs[1] Operand 1
     /* 134094 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 134099 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 134103 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 134107 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 134111 */     // MIs[2] Operand 1
     /* 134111 */     // No operand predicates
     /* 134111 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 134113 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }))
     /* 134113 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 134116 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 134120 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134125 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 134129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 134132 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 134134 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 134137 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134141 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134146 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 134153 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 134158 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 134163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 134166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 134168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134171 */     GIR_RootConstrainSelectedInstOperands,
     /* 134172 */     // GIR_Coverage, 3156,
     /* 134172 */     GIR_EraseRootFromParent_Done,
     /* 134173 */   // Label 1887: @134173
     /* 134173 */   GIM_Try, /*On fail goto*//*Label 1888*/ GIMT_Encode4(134316), // Rule ID 3819 //
     /* 134178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 134181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 134185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 134189 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 134193 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 134197 */     // MIs[1] Operand 1
     /* 134197 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 134202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 134206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 134210 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 134214 */     // MIs[2] Operand 1
     /* 134214 */     // No operand predicates
     /* 134214 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 134216 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 134216 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 134219 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 134223 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134228 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 134232 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 134235 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 134237 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 134240 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134244 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134249 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 134252 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 134254 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 134257 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134261 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134266 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 134269 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 134271 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 134274 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134278 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134283 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 134290 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 134295 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 134300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 134303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134305 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134308 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 134311 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 134314 */     GIR_RootConstrainSelectedInstOperands,
     /* 134315 */     // GIR_Coverage, 3819,
     /* 134315 */     GIR_EraseRootFromParent_Done,
     /* 134316 */   // Label 1888: @134316
     /* 134316 */   GIM_Try, /*On fail goto*//*Label 1889*/ GIMT_Encode4(134459), // Rule ID 3835 //
     /* 134321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 134324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 134328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 134332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 134336 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 134340 */     // MIs[1] Operand 1
     /* 134340 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 134345 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 134349 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 134353 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 134357 */     // MIs[2] Operand 1
     /* 134357 */     // No operand predicates
     /* 134357 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 134359 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 134359 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 134362 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 134366 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134371 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 134375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 134378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 134380 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 134383 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134387 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134392 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 134395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 134397 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 134400 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134404 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134409 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 134412 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 134414 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 134417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134421 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134426 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 134433 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 134438 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 134443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 134446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134448 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134451 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 134454 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 134457 */     GIR_RootConstrainSelectedInstOperands,
     /* 134458 */     // GIR_Coverage, 3835,
     /* 134458 */     GIR_EraseRootFromParent_Done,
     /* 134459 */   // Label 1889: @134459
     /* 134459 */   GIM_Try, /*On fail goto*//*Label 1890*/ GIMT_Encode4(134602), // Rule ID 3843 //
     /* 134464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 134467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 134471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 134475 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 134479 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 134483 */     // MIs[1] Operand 1
     /* 134483 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 134488 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 134492 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 134496 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 134500 */     // MIs[2] Operand 1
     /* 134500 */     // No operand predicates
     /* 134500 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 134502 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 134502 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 134505 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 134509 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134514 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 134518 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 134521 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 134523 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 134526 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134530 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134535 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 134538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 134540 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 134543 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134547 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134552 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 134555 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 134557 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 134560 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134564 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134569 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 134576 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 134581 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 134586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 134589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134594 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 134597 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 134600 */     GIR_RootConstrainSelectedInstOperands,
     /* 134601 */     // GIR_Coverage, 3843,
     /* 134601 */     GIR_EraseRootFromParent_Done,
     /* 134602 */   // Label 1890: @134602
     /* 134602 */   GIM_Try, /*On fail goto*//*Label 1891*/ GIMT_Encode4(134745), // Rule ID 3915 //
     /* 134607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 134610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 134614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 134618 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134622 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 134626 */     // MIs[1] Operand 1
     /* 134626 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 134631 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 134635 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 134639 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 134643 */     // MIs[2] Operand 1
     /* 134643 */     // No operand predicates
     /* 134643 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 134645 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 134645 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 134648 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 134652 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134657 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 134661 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 134664 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 134666 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 134669 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134673 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134678 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 134681 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 134683 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 134686 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134690 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134695 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 134698 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 134700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 134703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134712 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 134719 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 134724 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 134729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 134732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134737 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 134740 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 134743 */     GIR_RootConstrainSelectedInstOperands,
     /* 134744 */     // GIR_Coverage, 3915,
     /* 134744 */     GIR_EraseRootFromParent_Done,
     /* 134745 */   // Label 1891: @134745
     /* 134745 */   GIM_Try, /*On fail goto*//*Label 1892*/ GIMT_Encode4(134888), // Rule ID 3931 //
     /* 134750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 134753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 134757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 134761 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134765 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 134769 */     // MIs[1] Operand 1
     /* 134769 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 134774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 134778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 134782 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 134786 */     // MIs[2] Operand 1
     /* 134786 */     // No operand predicates
     /* 134786 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 134788 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 134788 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 134791 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 134795 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134800 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 134804 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 134807 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 134809 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 134812 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134816 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134821 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 134824 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 134826 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 134829 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134833 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134838 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 134841 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 134843 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 134846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134850 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134855 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 134862 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 134867 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 134872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 134875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134877 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134880 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 134883 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 134886 */     GIR_RootConstrainSelectedInstOperands,
     /* 134887 */     // GIR_Coverage, 3931,
     /* 134887 */     GIR_EraseRootFromParent_Done,
     /* 134888 */   // Label 1892: @134888
     /* 134888 */   GIM_Try, /*On fail goto*//*Label 1893*/ GIMT_Encode4(135031), // Rule ID 3939 //
     /* 134893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 134896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 134900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 134904 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134908 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 134912 */     // MIs[1] Operand 1
     /* 134912 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 134917 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 134921 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 134925 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 134929 */     // MIs[2] Operand 1
     /* 134929 */     // No operand predicates
     /* 134929 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 134931 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 134931 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 134934 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 134938 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134943 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 134947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 134950 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 134952 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 134955 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134959 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134964 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 134967 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 134969 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 134972 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134976 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134981 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 134984 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 134986 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 134989 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134993 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134998 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 135005 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 135010 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 135015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 135018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135020 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 135026 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 135029 */     GIR_RootConstrainSelectedInstOperands,
     /* 135030 */     // GIR_Coverage, 3939,
     /* 135030 */     GIR_EraseRootFromParent_Done,
     /* 135031 */   // Label 1893: @135031
     /* 135031 */   GIM_Try, /*On fail goto*//*Label 1894*/ GIMT_Encode4(135123), // Rule ID 3180 //
     /* 135036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 135039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 135043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 135047 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 135051 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 135055 */     // MIs[1] Operand 1
     /* 135055 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 135060 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135062 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }))
     /* 135062 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 135065 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 135069 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135074 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 135078 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 135082 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 135084 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 135087 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135091 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135096 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 135103 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 135108 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 135113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 135116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 135118 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135121 */     GIR_RootConstrainSelectedInstOperands,
     /* 135122 */     // GIR_Coverage, 3180,
     /* 135122 */     GIR_EraseRootFromParent_Done,
     /* 135123 */   // Label 1894: @135123
     /* 135123 */   GIM_Try, /*On fail goto*//*Label 1895*/ GIMT_Encode4(135215), // Rule ID 3196 //
     /* 135128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 135131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 135135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 135139 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 135143 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 135147 */     // MIs[1] Operand 1
     /* 135147 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 135152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135154 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }))
     /* 135154 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 135157 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 135161 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135166 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 135170 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 135174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 135176 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 135179 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135183 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135188 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 135195 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 135200 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 135205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 135208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 135210 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135213 */     GIR_RootConstrainSelectedInstOperands,
     /* 135214 */     // GIR_Coverage, 3196,
     /* 135214 */     GIR_EraseRootFromParent_Done,
     /* 135215 */   // Label 1895: @135215
     /* 135215 */   GIM_Try, /*On fail goto*//*Label 1896*/ GIMT_Encode4(135307), // Rule ID 3212 //
     /* 135220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 135223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 135227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 135231 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 135235 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 135239 */     // MIs[1] Operand 1
     /* 135239 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 135244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135246 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }))
     /* 135246 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 135249 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 135253 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135258 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 135262 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 135266 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 135268 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 135271 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135275 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135280 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 135287 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 135292 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 135297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 135300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 135302 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135305 */     GIR_RootConstrainSelectedInstOperands,
     /* 135306 */     // GIR_Coverage, 3212,
     /* 135306 */     GIR_EraseRootFromParent_Done,
     /* 135307 */   // Label 1896: @135307
     /* 135307 */   GIM_Try, /*On fail goto*//*Label 1897*/ GIMT_Encode4(135399), // Rule ID 3228 //
     /* 135312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 135315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 135319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 135323 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 135327 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 135331 */     // MIs[1] Operand 1
     /* 135331 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 135336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135338 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }))
     /* 135338 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 135341 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 135345 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135350 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 135354 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 135358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 135360 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 135363 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135367 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135372 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 135379 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 135384 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 135389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 135392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 135394 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135397 */     GIR_RootConstrainSelectedInstOperands,
     /* 135398 */     // GIR_Coverage, 3228,
     /* 135398 */     GIR_EraseRootFromParent_Done,
     /* 135399 */   // Label 1897: @135399
     /* 135399 */   GIM_Try, /*On fail goto*//*Label 1898*/ GIMT_Encode4(135491), // Rule ID 3236 //
     /* 135404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 135407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 135411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 135415 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 135419 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 135423 */     // MIs[1] Operand 1
     /* 135423 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 135428 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135430 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }))
     /* 135430 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 135433 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 135437 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135442 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 135446 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 135450 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 135452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 135455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135464 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 135471 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 135476 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 135481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 135484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 135486 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135489 */     GIR_RootConstrainSelectedInstOperands,
     /* 135490 */     // GIR_Coverage, 3236,
     /* 135490 */     GIR_EraseRootFromParent_Done,
     /* 135491 */   // Label 1898: @135491
     /* 135491 */   GIM_Try, /*On fail goto*//*Label 1899*/ GIMT_Encode4(135583), // Rule ID 3252 //
     /* 135496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 135499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 135503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 135507 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 135511 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 135515 */     // MIs[1] Operand 1
     /* 135515 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 135520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135522 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }))
     /* 135522 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 135525 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 135529 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135534 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 135538 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 135542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 135544 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 135547 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135551 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135556 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 135563 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 135568 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 135573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 135576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 135578 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135581 */     GIR_RootConstrainSelectedInstOperands,
     /* 135582 */     // GIR_Coverage, 3252,
     /* 135582 */     GIR_EraseRootFromParent_Done,
     /* 135583 */   // Label 1899: @135583
     /* 135583 */   GIM_Try, /*On fail goto*//*Label 1900*/ GIMT_Encode4(135675), // Rule ID 3268 //
     /* 135588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 135591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 135595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 135599 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 135603 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 135607 */     // MIs[1] Operand 1
     /* 135607 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 135612 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135614 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }))
     /* 135614 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 135617 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 135621 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135626 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 135630 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 135634 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 135636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 135639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135648 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 135655 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 135660 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 135665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 135668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 135670 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135673 */     GIR_RootConstrainSelectedInstOperands,
     /* 135674 */     // GIR_Coverage, 3268,
     /* 135674 */     GIR_EraseRootFromParent_Done,
     /* 135675 */   // Label 1900: @135675
     /* 135675 */   GIM_Try, /*On fail goto*//*Label 1901*/ GIMT_Encode4(135767), // Rule ID 3284 //
     /* 135680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 135683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 135687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 135691 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 135695 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 135699 */     // MIs[1] Operand 1
     /* 135699 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 135704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135706 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }))
     /* 135706 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 135709 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 135713 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135718 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 135722 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 135726 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 135728 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 135731 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135735 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135740 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 135747 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 135752 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 135757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 135760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 135762 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135765 */     GIR_RootConstrainSelectedInstOperands,
     /* 135766 */     // GIR_Coverage, 3284,
     /* 135766 */     GIR_EraseRootFromParent_Done,
     /* 135767 */   // Label 1901: @135767
     /* 135767 */   GIM_Try, /*On fail goto*//*Label 1902*/ GIMT_Encode4(135859), // Rule ID 3292 //
     /* 135772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 135775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 135779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 135783 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 135787 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 135791 */     // MIs[1] Operand 1
     /* 135791 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 135796 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135798 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }))
     /* 135798 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 135801 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 135805 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135810 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 135814 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 135818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 135820 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 135823 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135827 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135832 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 135839 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 135844 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 135849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 135852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 135854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135857 */     GIR_RootConstrainSelectedInstOperands,
     /* 135858 */     // GIR_Coverage, 3292,
     /* 135858 */     GIR_EraseRootFromParent_Done,
     /* 135859 */   // Label 1902: @135859
     /* 135859 */   GIM_Try, /*On fail goto*//*Label 1903*/ GIMT_Encode4(135951), // Rule ID 3308 //
     /* 135864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 135867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 135871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 135875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 135879 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 135883 */     // MIs[1] Operand 1
     /* 135883 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 135888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135890 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }))
     /* 135890 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 135893 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 135897 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135902 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 135906 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 135910 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 135912 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 135915 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135919 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135924 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 135931 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 135936 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 135941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 135944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 135946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135949 */     GIR_RootConstrainSelectedInstOperands,
     /* 135950 */     // GIR_Coverage, 3308,
     /* 135950 */     GIR_EraseRootFromParent_Done,
     /* 135951 */   // Label 1903: @135951
     /* 135951 */   GIM_Try, /*On fail goto*//*Label 1904*/ GIMT_Encode4(136043), // Rule ID 3324 //
     /* 135956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 135959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 135963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 135967 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 135971 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 135975 */     // MIs[1] Operand 1
     /* 135975 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 135980 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135982 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }))
     /* 135982 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 135985 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 135989 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135994 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 135998 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 136002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 136004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 136007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136016 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 136023 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 136028 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 136033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 136036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 136038 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136041 */     GIR_RootConstrainSelectedInstOperands,
     /* 136042 */     // GIR_Coverage, 3324,
     /* 136042 */     GIR_EraseRootFromParent_Done,
     /* 136043 */   // Label 1904: @136043
     /* 136043 */   GIM_Try, /*On fail goto*//*Label 1905*/ GIMT_Encode4(136135), // Rule ID 3340 //
     /* 136048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 136051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 136055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 136059 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 136063 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 136067 */     // MIs[1] Operand 1
     /* 136067 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 136072 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136074 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }))
     /* 136074 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 136077 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 136081 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136086 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 136090 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 136094 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 136096 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 136099 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136103 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136108 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 136115 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 136120 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 136125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 136128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 136130 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136133 */     GIR_RootConstrainSelectedInstOperands,
     /* 136134 */     // GIR_Coverage, 3340,
     /* 136134 */     GIR_EraseRootFromParent_Done,
     /* 136135 */   // Label 1905: @136135
     /* 136135 */   GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(136267), // Rule ID 4020 //
     /* 136140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 136143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 136147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 136151 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 136155 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 136159 */     // MIs[1] Operand 1
     /* 136159 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 136164 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136166 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 136166 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 136169 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 136173 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136178 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 136182 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 136186 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 136188 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 136191 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136195 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136200 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 136203 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 136205 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 136208 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136212 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136217 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 136220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 136222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 136225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136234 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 136241 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 136246 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 136251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 136254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136256 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136259 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 136262 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 136265 */     GIR_RootConstrainSelectedInstOperands,
     /* 136266 */     // GIR_Coverage, 4020,
     /* 136266 */     GIR_EraseRootFromParent_Done,
     /* 136267 */   // Label 1906: @136267
     /* 136267 */   GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(136399), // Rule ID 4052 //
     /* 136272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 136275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 136279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 136283 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 136287 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 136291 */     // MIs[1] Operand 1
     /* 136291 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 136296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136298 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 136298 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 136301 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 136305 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136310 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 136314 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 136318 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 136320 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 136323 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136327 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136332 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 136335 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 136337 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 136340 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136344 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136349 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 136352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 136354 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 136357 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136361 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136366 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 136373 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 136378 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 136383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 136386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136388 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136391 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 136394 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 136397 */     GIR_RootConstrainSelectedInstOperands,
     /* 136398 */     // GIR_Coverage, 4052,
     /* 136398 */     GIR_EraseRootFromParent_Done,
     /* 136399 */   // Label 1907: @136399
     /* 136399 */   GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(136531), // Rule ID 4084 //
     /* 136404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 136407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 136411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 136415 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 136419 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 136423 */     // MIs[1] Operand 1
     /* 136423 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 136428 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136430 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 136430 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 136433 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 136437 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136442 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 136446 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 136450 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 136452 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 136455 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136459 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136464 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 136467 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 136469 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 136472 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136476 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136481 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 136484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 136486 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 136489 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136493 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136498 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 136505 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 136510 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 136515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 136518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136520 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 136526 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 136529 */     GIR_RootConstrainSelectedInstOperands,
     /* 136530 */     // GIR_Coverage, 4084,
     /* 136530 */     GIR_EraseRootFromParent_Done,
     /* 136531 */   // Label 1908: @136531
     /* 136531 */   GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(136663), // Rule ID 4116 //
     /* 136536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 136539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 136543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 136547 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 136551 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 136555 */     // MIs[1] Operand 1
     /* 136555 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 136560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136562 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 136562 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 136565 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 136569 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136574 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 136578 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 136582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 136584 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 136587 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136591 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136596 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 136599 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 136601 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 136604 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136608 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136613 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 136616 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 136618 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 136621 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136625 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136630 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 136637 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 136642 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 136647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 136650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136652 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136655 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 136658 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 136661 */     GIR_RootConstrainSelectedInstOperands,
     /* 136662 */     // GIR_Coverage, 4116,
     /* 136662 */     GIR_EraseRootFromParent_Done,
     /* 136663 */   // Label 1909: @136663
     /* 136663 */   GIM_Try, /*On fail goto*//*Label 1910*/ GIMT_Encode4(136795), // Rule ID 4132 //
     /* 136668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 136671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 136675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 136679 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 136683 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 136687 */     // MIs[1] Operand 1
     /* 136687 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 136692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136694 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 136694 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 136697 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 136701 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136706 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 136710 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 136714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 136716 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 136719 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136723 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136728 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 136731 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 136733 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 136736 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136740 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136745 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 136748 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 136750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 136753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136762 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 136769 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 136774 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 136779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 136782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136784 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136787 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 136790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 136793 */     GIR_RootConstrainSelectedInstOperands,
     /* 136794 */     // GIR_Coverage, 4132,
     /* 136794 */     GIR_EraseRootFromParent_Done,
     /* 136795 */   // Label 1910: @136795
     /* 136795 */   GIM_Try, /*On fail goto*//*Label 1911*/ GIMT_Encode4(136927), // Rule ID 4164 //
     /* 136800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 136803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 136807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 136811 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 136815 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 136819 */     // MIs[1] Operand 1
     /* 136819 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 136824 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136826 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 136826 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 136829 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 136833 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136838 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 136842 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 136846 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 136848 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 136851 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136855 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136860 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 136863 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 136865 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 136868 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136872 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136877 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 136880 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 136882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 136885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136894 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 136901 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 136906 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 136911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 136914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136916 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136919 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 136922 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 136925 */     GIR_RootConstrainSelectedInstOperands,
     /* 136926 */     // GIR_Coverage, 4164,
     /* 136926 */     GIR_EraseRootFromParent_Done,
     /* 136927 */   // Label 1911: @136927
     /* 136927 */   GIM_Try, /*On fail goto*//*Label 1912*/ GIMT_Encode4(137059), // Rule ID 4196 //
     /* 136932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 136935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 136939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 136943 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 136947 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 136951 */     // MIs[1] Operand 1
     /* 136951 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 136956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136958 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 136958 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 136961 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 136965 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136970 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 136974 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 136978 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 136980 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 136983 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136987 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136992 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 136995 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 136997 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 137000 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137004 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137009 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 137012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 137014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 137017 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137021 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137026 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 137033 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 137038 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 137043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 137046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137048 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137051 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 137054 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 137057 */     GIR_RootConstrainSelectedInstOperands,
     /* 137058 */     // GIR_Coverage, 4196,
     /* 137058 */     GIR_EraseRootFromParent_Done,
     /* 137059 */   // Label 1912: @137059
     /* 137059 */   GIM_Try, /*On fail goto*//*Label 1913*/ GIMT_Encode4(137191), // Rule ID 4228 //
     /* 137064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 137067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 137071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 137075 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 137079 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 137083 */     // MIs[1] Operand 1
     /* 137083 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 137088 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137090 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 137090 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 137093 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 137097 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137102 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 137106 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 137110 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 137112 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 137115 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137119 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137124 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 137127 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 137129 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 137132 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137136 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137141 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 137144 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 137146 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 137149 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137153 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137158 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 137165 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 137170 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 137175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 137178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137180 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137183 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 137186 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 137189 */     GIR_RootConstrainSelectedInstOperands,
     /* 137190 */     // GIR_Coverage, 4228,
     /* 137190 */     GIR_EraseRootFromParent_Done,
     /* 137191 */   // Label 1913: @137191
     /* 137191 */   GIM_Try, /*On fail goto*//*Label 1914*/ GIMT_Encode4(137323), // Rule ID 4258 //
     /* 137196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 137199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 137203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 137207 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 137211 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 137215 */     // MIs[1] Operand 1
     /* 137215 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 137220 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137222 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 137222 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 137225 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 137229 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137234 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 137238 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 137242 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 137244 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 137247 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137251 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137256 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 137259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 137261 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 137264 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137268 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137273 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 137276 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 137278 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 137281 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137285 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137290 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 137297 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 137302 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 137307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 137310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137312 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137315 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 137318 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 137321 */     GIR_RootConstrainSelectedInstOperands,
     /* 137322 */     // GIR_Coverage, 4258,
     /* 137322 */     GIR_EraseRootFromParent_Done,
     /* 137323 */   // Label 1914: @137323
     /* 137323 */   GIM_Try, /*On fail goto*//*Label 1915*/ GIMT_Encode4(137455), // Rule ID 4290 //
     /* 137328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 137331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 137335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 137339 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 137343 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 137347 */     // MIs[1] Operand 1
     /* 137347 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 137352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137354 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 137354 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 137357 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 137361 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137366 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 137370 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 137374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 137376 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 137379 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137383 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137388 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 137391 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 137393 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 137396 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137400 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137405 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 137408 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 137410 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 137413 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137417 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137422 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 137429 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 137434 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 137439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 137442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137444 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137447 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 137450 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 137453 */     GIR_RootConstrainSelectedInstOperands,
     /* 137454 */     // GIR_Coverage, 4290,
     /* 137454 */     GIR_EraseRootFromParent_Done,
     /* 137455 */   // Label 1915: @137455
     /* 137455 */   GIM_Try, /*On fail goto*//*Label 1916*/ GIMT_Encode4(137587), // Rule ID 4322 //
     /* 137460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 137463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 137467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 137471 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 137475 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 137479 */     // MIs[1] Operand 1
     /* 137479 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 137484 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137486 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 137486 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 137489 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 137493 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137498 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 137502 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 137506 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 137508 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 137511 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137515 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137520 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 137523 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 137525 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 137528 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137532 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137537 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 137540 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 137542 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 137545 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137549 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137554 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 137561 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 137566 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 137571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 137574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137576 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137579 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 137582 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 137585 */     GIR_RootConstrainSelectedInstOperands,
     /* 137586 */     // GIR_Coverage, 4322,
     /* 137586 */     GIR_EraseRootFromParent_Done,
     /* 137587 */   // Label 1916: @137587
     /* 137587 */   GIM_Try, /*On fail goto*//*Label 1917*/ GIMT_Encode4(137719), // Rule ID 4354 //
     /* 137592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 137595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 137599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 137603 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 137607 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 137611 */     // MIs[1] Operand 1
     /* 137611 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 137616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137618 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 137618 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 137621 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 137625 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137630 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 137634 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 137638 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 137640 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 137643 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137647 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137652 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 137655 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 137657 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 137660 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137664 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137669 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 137672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 137674 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 137677 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137681 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137686 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 137693 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 137698 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 137703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 137706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137708 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137711 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 137714 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 137717 */     GIR_RootConstrainSelectedInstOperands,
     /* 137718 */     // GIR_Coverage, 4354,
     /* 137718 */     GIR_EraseRootFromParent_Done,
     /* 137719 */   // Label 1917: @137719
     /* 137719 */   GIM_Try, /*On fail goto*//*Label 1918*/ GIMT_Encode4(137851), // Rule ID 4585 //
     /* 137724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 137727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 137731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 137735 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 137739 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 137743 */     // MIs[1] Operand 1
     /* 137743 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 137748 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137750 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPLT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 137750 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 137753 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPLT),
     /* 137757 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137762 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 137766 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 137770 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 137772 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 137775 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137779 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137784 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 137787 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 137789 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 137792 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137796 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137801 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 137804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 137806 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 137809 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137813 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137818 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 137825 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 137830 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 137835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 137838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137840 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137843 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 137846 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 137849 */     GIR_RootConstrainSelectedInstOperands,
     /* 137850 */     // GIR_Coverage, 4585,
     /* 137850 */     GIR_EraseRootFromParent_Done,
     /* 137851 */   // Label 1918: @137851
     /* 137851 */   GIM_Try, /*On fail goto*//*Label 1919*/ GIMT_Encode4(137983), // Rule ID 4617 //
     /* 137856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 137859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 137863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 137867 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 137871 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 137875 */     // MIs[1] Operand 1
     /* 137875 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 137880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137882 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPGT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 137882 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 137885 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPGT),
     /* 137889 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137894 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 137898 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 137902 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 137904 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 137907 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137911 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137916 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 137919 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 137921 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 137924 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137928 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137933 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 137936 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 137938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 137941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137950 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 137957 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 137962 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 137967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 137970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137972 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 137978 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 137981 */     GIR_RootConstrainSelectedInstOperands,
     /* 137982 */     // GIR_Coverage, 4617,
     /* 137982 */     GIR_EraseRootFromParent_Done,
     /* 137983 */   // Label 1919: @137983
     /* 137983 */   GIM_Try, /*On fail goto*//*Label 1920*/ GIMT_Encode4(138115), // Rule ID 4649 //
     /* 137988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 137991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 137995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 137999 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 138003 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 138007 */     // MIs[1] Operand 1
     /* 138007 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 138012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138014 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPEQ:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 138014 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 138017 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPEQ),
     /* 138021 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138026 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 138030 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 138034 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 138036 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 138039 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 138043 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138048 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 138051 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 138053 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 138056 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 138060 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138065 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 138068 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 138070 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 138073 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138077 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138082 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 138089 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 138094 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 138099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 138102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138104 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 138110 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 138113 */     GIR_RootConstrainSelectedInstOperands,
     /* 138114 */     // GIR_Coverage, 4649,
     /* 138114 */     GIR_EraseRootFromParent_Done,
     /* 138115 */   // Label 1920: @138115
     /* 138115 */   GIM_Try, /*On fail goto*//*Label 1921*/ GIMT_Encode4(138247), // Rule ID 4693 //
     /* 138120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 138123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 138127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 138131 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 138135 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 138139 */     // MIs[1] Operand 1
     /* 138139 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 138144 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138146 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPLT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 138146 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 138149 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPLT),
     /* 138153 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138158 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 138162 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 138166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 138168 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 138171 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 138175 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138180 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 138183 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 138185 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 138188 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 138192 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138197 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 138200 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 138202 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 138205 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138209 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138214 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 138221 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 138226 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 138231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 138234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138236 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138239 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 138242 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 138245 */     GIR_RootConstrainSelectedInstOperands,
     /* 138246 */     // GIR_Coverage, 4693,
     /* 138246 */     GIR_EraseRootFromParent_Done,
     /* 138247 */   // Label 1921: @138247
     /* 138247 */   GIM_Try, /*On fail goto*//*Label 1922*/ GIMT_Encode4(138379), // Rule ID 4725 //
     /* 138252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 138255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 138259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 138263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 138267 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 138271 */     // MIs[1] Operand 1
     /* 138271 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 138276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138278 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPGT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 138278 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 138281 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPGT),
     /* 138285 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138290 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 138294 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 138298 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 138300 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 138303 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 138307 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138312 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 138315 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 138317 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 138320 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 138324 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138329 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 138332 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 138334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 138337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138346 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 138353 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 138358 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 138363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 138366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138368 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 138374 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 138377 */     GIR_RootConstrainSelectedInstOperands,
     /* 138378 */     // GIR_Coverage, 4725,
     /* 138378 */     GIR_EraseRootFromParent_Done,
     /* 138379 */   // Label 1922: @138379
     /* 138379 */   GIM_Try, /*On fail goto*//*Label 1923*/ GIMT_Encode4(138511), // Rule ID 4757 //
     /* 138384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 138387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 138391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 138395 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 138399 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 138403 */     // MIs[1] Operand 1
     /* 138403 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 138408 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138410 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPEQ:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 138410 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 138413 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPEQ),
     /* 138417 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138422 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 138426 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 138430 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 138432 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 138435 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 138439 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138444 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 138447 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 138449 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 138452 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 138456 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138461 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 138464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 138466 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 138469 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138473 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138478 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 138485 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 138490 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 138495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 138498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138503 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 138506 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 138509 */     GIR_RootConstrainSelectedInstOperands,
     /* 138510 */     // GIR_Coverage, 4757,
     /* 138510 */     GIR_EraseRootFromParent_Done,
     /* 138511 */   // Label 1923: @138511
     /* 138511 */   GIM_Try, /*On fail goto*//*Label 1924*/ GIMT_Encode4(138603), // Rule ID 2982 //
     /* 138516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 138519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 138523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 138527 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 138531 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 138535 */     // MIs[1] Operand 1
     /* 138535 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 138540 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138542 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 138542 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 138545 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 138549 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138554 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 138558 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 138562 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 138564 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 138567 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138571 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138576 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 138583 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 138588 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 138593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 138596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 138598 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138601 */     GIR_RootConstrainSelectedInstOperands,
     /* 138602 */     // GIR_Coverage, 2982,
     /* 138602 */     GIR_EraseRootFromParent_Done,
     /* 138603 */   // Label 1924: @138603
     /* 138603 */   GIM_Try, /*On fail goto*//*Label 1925*/ GIMT_Encode4(138695), // Rule ID 2996 //
     /* 138608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 138611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 138615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 138619 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 138623 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 138627 */     // MIs[1] Operand 1
     /* 138627 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 138632 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138634 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 138634 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 138637 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 138641 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138646 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 138650 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 138654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 138656 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 138659 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138663 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138668 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 138675 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 138680 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 138685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 138688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 138690 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138693 */     GIR_RootConstrainSelectedInstOperands,
     /* 138694 */     // GIR_Coverage, 2996,
     /* 138694 */     GIR_EraseRootFromParent_Done,
     /* 138695 */   // Label 1925: @138695
     /* 138695 */   GIM_Try, /*On fail goto*//*Label 1926*/ GIMT_Encode4(138787), // Rule ID 3004 //
     /* 138700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 138703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 138707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 138711 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 138715 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 138719 */     // MIs[1] Operand 1
     /* 138719 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 138724 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138726 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 138726 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 138729 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 138733 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138738 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 138742 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 138746 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 138748 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 138751 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138755 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138760 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 138767 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 138772 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 138777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 138780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 138782 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138785 */     GIR_RootConstrainSelectedInstOperands,
     /* 138786 */     // GIR_Coverage, 3004,
     /* 138786 */     GIR_EraseRootFromParent_Done,
     /* 138787 */   // Label 1926: @138787
     /* 138787 */   GIM_Try, /*On fail goto*//*Label 1927*/ GIMT_Encode4(138879), // Rule ID 3012 //
     /* 138792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 138795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 138799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 138803 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 138807 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 138811 */     // MIs[1] Operand 1
     /* 138811 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 138816 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138818 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 138818 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 138821 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 138825 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138830 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 138834 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 138838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 138840 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 138843 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138847 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138852 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 138859 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 138864 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 138869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 138872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 138874 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138877 */     GIR_RootConstrainSelectedInstOperands,
     /* 138878 */     // GIR_Coverage, 3012,
     /* 138878 */     GIR_EraseRootFromParent_Done,
     /* 138879 */   // Label 1927: @138879
     /* 138879 */   GIM_Try, /*On fail goto*//*Label 1928*/ GIMT_Encode4(138971), // Rule ID 3020 //
     /* 138884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 138887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 138891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 138895 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 138899 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 138903 */     // MIs[1] Operand 1
     /* 138903 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 138908 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138910 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }))
     /* 138910 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 138913 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 138917 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138922 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 138926 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 138930 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 138932 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 138935 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138939 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138944 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 138951 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 138956 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 138961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 138964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 138966 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138969 */     GIR_RootConstrainSelectedInstOperands,
     /* 138970 */     // GIR_Coverage, 3020,
     /* 138970 */     GIR_EraseRootFromParent_Done,
     /* 138971 */   // Label 1928: @138971
     /* 138971 */   GIM_Try, /*On fail goto*//*Label 1929*/ GIMT_Encode4(139063), // Rule ID 3084 //
     /* 138976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 138979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 138983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 138987 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 138991 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 138995 */     // MIs[1] Operand 1
     /* 138995 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 139000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139002 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 139002 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 139005 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 139009 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139014 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 139018 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 139022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 139024 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 139027 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139031 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139036 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 139043 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 139048 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 139053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 139056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 139058 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139061 */     GIR_RootConstrainSelectedInstOperands,
     /* 139062 */     // GIR_Coverage, 3084,
     /* 139062 */     GIR_EraseRootFromParent_Done,
     /* 139063 */   // Label 1929: @139063
     /* 139063 */   GIM_Try, /*On fail goto*//*Label 1930*/ GIMT_Encode4(139155), // Rule ID 3092 //
     /* 139068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 139071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 139075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 139079 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 139083 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 139087 */     // MIs[1] Operand 1
     /* 139087 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 139092 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139094 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 139094 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 139097 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 139101 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139106 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 139110 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 139114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 139116 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 139119 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139123 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139128 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 139135 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 139140 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 139145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 139148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 139150 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139153 */     GIR_RootConstrainSelectedInstOperands,
     /* 139154 */     // GIR_Coverage, 3092,
     /* 139154 */     GIR_EraseRootFromParent_Done,
     /* 139155 */   // Label 1930: @139155
     /* 139155 */   GIM_Try, /*On fail goto*//*Label 1931*/ GIMT_Encode4(139247), // Rule ID 3100 //
     /* 139160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 139163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 139167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 139171 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 139175 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 139179 */     // MIs[1] Operand 1
     /* 139179 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 139184 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139186 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 139186 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 139189 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 139193 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139198 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 139202 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 139206 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 139208 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 139211 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139215 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139220 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 139227 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 139232 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 139237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 139240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 139242 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139245 */     GIR_RootConstrainSelectedInstOperands,
     /* 139246 */     // GIR_Coverage, 3100,
     /* 139246 */     GIR_EraseRootFromParent_Done,
     /* 139247 */   // Label 1931: @139247
     /* 139247 */   GIM_Try, /*On fail goto*//*Label 1932*/ GIMT_Encode4(139339), // Rule ID 3108 //
     /* 139252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 139255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 139259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 139263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 139267 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 139271 */     // MIs[1] Operand 1
     /* 139271 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 139276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139278 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 139278 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 139281 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 139285 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139290 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 139294 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 139298 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 139300 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 139303 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139307 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139312 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 139319 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 139324 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 139329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 139332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 139334 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139337 */     GIR_RootConstrainSelectedInstOperands,
     /* 139338 */     // GIR_Coverage, 3108,
     /* 139338 */     GIR_EraseRootFromParent_Done,
     /* 139339 */   // Label 1932: @139339
     /* 139339 */   GIM_Try, /*On fail goto*//*Label 1933*/ GIMT_Encode4(139431), // Rule ID 3116 //
     /* 139344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 139347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 139351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 139355 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 139359 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 139363 */     // MIs[1] Operand 1
     /* 139363 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 139368 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139370 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }))
     /* 139370 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 139373 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 139377 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139382 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 139386 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 139390 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 139392 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 139395 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139399 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139404 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 139411 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 139416 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 139421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 139424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 139426 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139429 */     GIR_RootConstrainSelectedInstOperands,
     /* 139430 */     // GIR_Coverage, 3116,
     /* 139430 */     GIR_EraseRootFromParent_Done,
     /* 139431 */   // Label 1933: @139431
     /* 139431 */   GIM_Try, /*On fail goto*//*Label 1934*/ GIMT_Encode4(139563), // Rule ID 3867 //
     /* 139436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 139439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 139443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 139447 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 139451 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 139455 */     // MIs[1] Operand 1
     /* 139455 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 139460 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139462 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 139462 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 139465 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 139469 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139474 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 139478 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 139482 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 139484 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 139487 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 139491 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139496 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 139499 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 139501 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 139504 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 139508 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139513 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 139516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 139518 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 139521 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139525 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139530 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 139537 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 139542 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 139547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 139550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139552 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139555 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 139558 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 139561 */     GIR_RootConstrainSelectedInstOperands,
     /* 139562 */     // GIR_Coverage, 3867,
     /* 139562 */     GIR_EraseRootFromParent_Done,
     /* 139563 */   // Label 1934: @139563
     /* 139563 */   GIM_Try, /*On fail goto*//*Label 1935*/ GIMT_Encode4(139695), // Rule ID 3875 //
     /* 139568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 139571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 139575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 139579 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 139583 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 139587 */     // MIs[1] Operand 1
     /* 139587 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 139592 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139594 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 139594 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 139597 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 139601 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139606 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 139610 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 139614 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 139616 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 139619 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 139623 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139628 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 139631 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 139633 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 139636 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 139640 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139645 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 139648 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 139650 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 139653 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139657 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139662 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 139669 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 139674 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 139679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 139682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139684 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139687 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 139690 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 139693 */     GIR_RootConstrainSelectedInstOperands,
     /* 139694 */     // GIR_Coverage, 3875,
     /* 139694 */     GIR_EraseRootFromParent_Done,
     /* 139695 */   // Label 1935: @139695
     /* 139695 */   GIM_Try, /*On fail goto*//*Label 1936*/ GIMT_Encode4(139827), // Rule ID 3883 //
     /* 139700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 139703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 139707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 139711 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 139715 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 139719 */     // MIs[1] Operand 1
     /* 139719 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 139724 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139726 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 139726 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 139729 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 139733 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139738 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 139742 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 139746 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 139748 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 139751 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 139755 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139760 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 139763 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 139765 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 139768 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 139772 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139777 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 139780 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 139782 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 139785 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139789 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139794 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 139801 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 139806 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 139811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 139814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139816 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139819 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 139822 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 139825 */     GIR_RootConstrainSelectedInstOperands,
     /* 139826 */     // GIR_Coverage, 3883,
     /* 139826 */     GIR_EraseRootFromParent_Done,
     /* 139827 */   // Label 1936: @139827
     /* 139827 */   GIM_Try, /*On fail goto*//*Label 1937*/ GIMT_Encode4(139959), // Rule ID 3891 //
     /* 139832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 139835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 139839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 139843 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 139847 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 139851 */     // MIs[1] Operand 1
     /* 139851 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 139856 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139858 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 139858 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 139861 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 139865 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139870 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 139874 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 139878 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 139880 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 139883 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 139887 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139892 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 139895 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 139897 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 139900 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 139904 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139909 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 139912 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 139914 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 139917 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139921 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139926 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 139933 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 139938 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 139943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 139946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139948 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139951 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 139954 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 139957 */     GIR_RootConstrainSelectedInstOperands,
     /* 139958 */     // GIR_Coverage, 3891,
     /* 139958 */     GIR_EraseRootFromParent_Done,
     /* 139959 */   // Label 1937: @139959
     /* 139959 */   GIM_Try, /*On fail goto*//*Label 1938*/ GIMT_Encode4(140091), // Rule ID 3899 //
     /* 139964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 139967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 139971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 139975 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 139979 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 139983 */     // MIs[1] Operand 1
     /* 139983 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 139988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139990 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 139990 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 139993 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 139997 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140002 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 140006 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 140010 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 140012 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 140015 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 140019 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140024 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 140027 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 140029 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 140032 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 140036 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140041 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 140044 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 140046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 140049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 140053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140058 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 140065 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 140070 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 140075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 140078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140080 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140083 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 140086 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 140089 */     GIR_RootConstrainSelectedInstOperands,
     /* 140090 */     // GIR_Coverage, 3899,
     /* 140090 */     GIR_EraseRootFromParent_Done,
     /* 140091 */   // Label 1938: @140091
     /* 140091 */   GIM_Try, /*On fail goto*//*Label 1939*/ GIMT_Encode4(140223), // Rule ID 3963 //
     /* 140096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 140099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 140107 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 140111 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 140115 */     // MIs[1] Operand 1
     /* 140115 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 140120 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140122 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 140122 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 140125 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 140129 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140134 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 140138 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 140142 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 140144 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 140147 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 140151 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140156 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 140159 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 140161 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 140164 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 140168 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140173 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 140176 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 140178 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 140181 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 140185 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140190 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 140197 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 140202 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 140207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 140210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140212 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140215 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 140218 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 140221 */     GIR_RootConstrainSelectedInstOperands,
     /* 140222 */     // GIR_Coverage, 3963,
     /* 140222 */     GIR_EraseRootFromParent_Done,
     /* 140223 */   // Label 1939: @140223
     /* 140223 */   GIM_Try, /*On fail goto*//*Label 1940*/ GIMT_Encode4(140355), // Rule ID 3971 //
     /* 140228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 140231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 140239 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 140243 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 140247 */     // MIs[1] Operand 1
     /* 140247 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 140252 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140254 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 140254 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 140257 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 140261 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140266 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 140270 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 140274 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 140276 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 140279 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 140283 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140288 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 140291 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 140293 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 140296 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 140300 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140305 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 140308 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 140310 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 140313 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 140317 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140322 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 140329 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 140334 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 140339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 140342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140347 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 140350 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 140353 */     GIR_RootConstrainSelectedInstOperands,
     /* 140354 */     // GIR_Coverage, 3971,
     /* 140354 */     GIR_EraseRootFromParent_Done,
     /* 140355 */   // Label 1940: @140355
     /* 140355 */   GIM_Try, /*On fail goto*//*Label 1941*/ GIMT_Encode4(140487), // Rule ID 3979 //
     /* 140360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 140363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 140371 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 140375 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 140379 */     // MIs[1] Operand 1
     /* 140379 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 140384 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140386 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 140386 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 140389 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 140393 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140398 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 140402 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 140406 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 140408 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 140411 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 140415 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140420 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 140423 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 140425 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 140428 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 140432 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140437 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 140440 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 140442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 140445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 140449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140454 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 140461 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 140466 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 140471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 140474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140476 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140479 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 140482 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 140485 */     GIR_RootConstrainSelectedInstOperands,
     /* 140486 */     // GIR_Coverage, 3979,
     /* 140486 */     GIR_EraseRootFromParent_Done,
     /* 140487 */   // Label 1941: @140487
     /* 140487 */   GIM_Try, /*On fail goto*//*Label 1942*/ GIMT_Encode4(140619), // Rule ID 3987 //
     /* 140492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 140495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 140503 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 140507 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 140511 */     // MIs[1] Operand 1
     /* 140511 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 140516 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140518 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 140518 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 140521 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 140525 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140530 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 140534 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 140538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 140540 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 140543 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 140547 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140552 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 140555 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 140557 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 140560 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 140564 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140569 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 140572 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 140574 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 140577 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 140581 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140586 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 140593 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 140598 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 140603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 140606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140608 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 140614 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 140617 */     GIR_RootConstrainSelectedInstOperands,
     /* 140618 */     // GIR_Coverage, 3987,
     /* 140618 */     GIR_EraseRootFromParent_Done,
     /* 140619 */   // Label 1942: @140619
     /* 140619 */   GIM_Try, /*On fail goto*//*Label 1943*/ GIMT_Encode4(140751), // Rule ID 3995 //
     /* 140624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 140627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 140635 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 140639 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 140643 */     // MIs[1] Operand 1
     /* 140643 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 140648 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140650 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 140650 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 140653 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 140657 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140662 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 140666 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 140670 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 140672 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 140675 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 140679 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140684 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 140687 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 140689 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 140692 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 140696 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140701 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 140704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 140706 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 140709 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 140713 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140718 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 140725 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 140730 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 140735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 140738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140740 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140743 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 140746 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 140749 */     GIR_RootConstrainSelectedInstOperands,
     /* 140750 */     // GIR_Coverage, 3995,
     /* 140750 */     GIR_EraseRootFromParent_Done,
     /* 140751 */   // Label 1943: @140751
     /* 140751 */   GIM_Try, /*On fail goto*//*Label 1944*/ GIMT_Encode4(140766), // Rule ID 2988 //
     /* 140756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 140759 */     // (zext:{ *:[i32] } i1:{ *:[i1] }:$in)  =>  (SETBC:{ *:[i32] } ?:{ *:[i1] }:$in)
     /* 140759 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SETBC),
     /* 140764 */     GIR_RootConstrainSelectedInstOperands,
     /* 140765 */     // GIR_Coverage, 2988,
     /* 140765 */     GIR_Done,
     /* 140766 */   // Label 1944: @140766
     /* 140766 */   GIM_Try, /*On fail goto*//*Label 1945*/ GIMT_Encode4(140820), // Rule ID 3673 //
     /* 140771 */     // (zext:{ *:[i32] } i1:{ *:[i1] }:$in)  =>  (SELECT_I4:{ *:[i32] } ?:{ *:[i1] }:$in, (LI:{ *:[i32] } 1:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }))
     /* 140771 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 140774 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 140778 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140783 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 140786 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 140788 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 140791 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 140795 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140800 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 140803 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 140805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 140808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140810 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 140812 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140815 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 140818 */     GIR_RootConstrainSelectedInstOperands,
     /* 140819 */     // GIR_Coverage, 3673,
     /* 140819 */     GIR_EraseRootFromParent_Done,
     /* 140820 */   // Label 1945: @140820
     /* 140820 */   GIM_Reject,
     /* 140821 */ // Label 1853: @140821
     /* 140821 */ GIM_Reject,
     /* 140822 */ // Label 1851: @140822
     /* 140822 */ GIM_Try, /*On fail goto*//*Label 1946*/ GIMT_Encode4(140938), // Rule ID 5300 //
     /* 140827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 140830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 140834 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140838 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 140842 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 140846 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 140850 */   // MIs[1] Operand 1
     /* 140850 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 140855 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 140859 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 140863 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 140867 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 140871 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 140875 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 140879 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 140883 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 140887 */   GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 140891 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 140895 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 140897 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa), i64:{ *:[i64] }:$s1), 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (RLDCL:{ *:[i64] } ?:{ *:[i64] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] })
     /* 140897 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 140900 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 140904 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140909 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 140913 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/64,
     /* 140916 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for PPC::CARRY*/0,
     /* 140919 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 140921 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 140924 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 140926 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 140930 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140933 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 140936 */   GIR_RootConstrainSelectedInstOperands,
     /* 140937 */   // GIR_Coverage, 5300,
     /* 140937 */   GIR_EraseRootFromParent_Done,
     /* 140938 */ // Label 1946: @140938
     /* 140938 */ GIM_Try, /*On fail goto*//*Label 1947*/ GIMT_Encode4(141108), // Rule ID 5301 //
     /* 140943 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 140946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 140950 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140954 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 140958 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 140962 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 140966 */   // MIs[1] Operand 1
     /* 140966 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 140971 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 140975 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 140979 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 140983 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 140987 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 140991 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 140995 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 140999 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 141003 */   GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 141007 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 141011 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 141013 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa), i32:{ *:[i32] }:$s1), 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWNM:{ *:[i32] } ?:{ *:[i32] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 141013 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 141016 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 141020 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141025 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 141029 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/32,
     /* 141032 */   GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for PPC::CARRY*/0,
     /* 141035 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 141037 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 141040 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 141044 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141049 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 141053 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 141056 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 141059 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 141062 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 141064 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 141067 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 141071 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141076 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 141078 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 141081 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141083 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 141086 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 141089 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 141092 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141097 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141102 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 141107 */   // GIR_Coverage, 5301,
     /* 141107 */   GIR_EraseRootFromParent_Done,
     /* 141108 */ // Label 1947: @141108
     /* 141108 */ GIM_Try, /*On fail goto*//*Label 1948*/ GIMT_Encode4(141245), // Rule ID 5308 //
     /* 141113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 141116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141120 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141124 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 141128 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 141132 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 141136 */   // MIs[1] Operand 1
     /* 141136 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 141141 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 141145 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 141149 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 141153 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 141157 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 141161 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 141165 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 141169 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 141173 */   GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 141177 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 141181 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 141183 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa), i64:{ *:[i64] }:$s1), 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (RLDCL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] })
     /* 141183 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 141186 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 141190 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141195 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 141199 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/64,
     /* 141202 */   GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /* 141205 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 141207 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 141210 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 141214 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141219 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 141223 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 141227 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 141229 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 141232 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 141234 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 141237 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 141240 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 141243 */   GIR_RootConstrainSelectedInstOperands,
     /* 141244 */   // GIR_Coverage, 5308,
     /* 141244 */   GIR_EraseRootFromParent_Done,
     /* 141245 */ // Label 1948: @141245
     /* 141245 */ GIM_Try, /*On fail goto*//*Label 1949*/ GIMT_Encode4(141436), // Rule ID 5309 //
     /* 141250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 141253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141257 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141261 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 141265 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 141269 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 141273 */   // MIs[1] Operand 1
     /* 141273 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 141278 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 141282 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 141286 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 141290 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 141294 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 141298 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 141302 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 141306 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 141310 */   GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 141314 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 141318 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 141320 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa), i32:{ *:[i32] }:$s1), 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWNM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 141320 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 141323 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 141327 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141332 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 141336 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/32,
     /* 141339 */   GIR_SetImplicitDefDead, /*InsnID*/4, /*OpIdx for PPC::CARRY*/0,
     /* 141342 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 141344 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 141347 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 141351 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141356 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 141360 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 141364 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 141366 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 141369 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 141373 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141378 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 141381 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 141384 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 141387 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 141390 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 141392 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 141395 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 141399 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141404 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 141406 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 141409 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141411 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 141414 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 141417 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 141420 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141425 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141430 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 141435 */   // GIR_Coverage, 5309,
     /* 141435 */   GIR_EraseRootFromParent_Done,
     /* 141436 */ // Label 1949: @141436
     /* 141436 */ GIM_Try, /*On fail goto*//*Label 1950*/ GIMT_Encode4(141552), // Rule ID 3778 //
     /* 141441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 141444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141448 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141452 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 141456 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 141460 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 141464 */   // MIs[1] Operand 1
     /* 141464 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 141469 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 141473 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 141477 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 141481 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 141485 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 141489 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 141493 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 141497 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 141501 */   GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 141505 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 141509 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 141511 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i64] } i64:{ *:[i64] }:$s1, (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (RLDCL:{ *:[i64] } ?:{ *:[i64] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] })
     /* 141511 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 141514 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 141518 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141523 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 141527 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/64,
     /* 141530 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for PPC::CARRY*/0,
     /* 141533 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 141535 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 141538 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 141540 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 141544 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 141547 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 141550 */   GIR_RootConstrainSelectedInstOperands,
     /* 141551 */   // GIR_Coverage, 3778,
     /* 141551 */   GIR_EraseRootFromParent_Done,
     /* 141552 */ // Label 1950: @141552
     /* 141552 */ GIM_Try, /*On fail goto*//*Label 1951*/ GIMT_Encode4(141722), // Rule ID 3779 //
     /* 141557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 141560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141564 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141568 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 141572 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 141576 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 141580 */   // MIs[1] Operand 1
     /* 141580 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 141585 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 141589 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 141593 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 141597 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 141601 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 141605 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 141609 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 141613 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 141617 */   GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 141621 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 141625 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 141627 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i32] } i32:{ *:[i32] }:$s1, (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWNM:{ *:[i32] } ?:{ *:[i32] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 141627 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 141630 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 141634 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141639 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 141643 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/32,
     /* 141646 */   GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for PPC::CARRY*/0,
     /* 141649 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 141651 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 141654 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 141658 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141663 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 141667 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 141670 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 141673 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 141676 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 141678 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 141681 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 141685 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141690 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 141692 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 141695 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141697 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 141700 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 141703 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 141706 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141711 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141716 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 141721 */   // GIR_Coverage, 3779,
     /* 141721 */   GIR_EraseRootFromParent_Done,
     /* 141722 */ // Label 1951: @141722
     /* 141722 */ GIM_Try, /*On fail goto*//*Label 1952*/ GIMT_Encode4(141859), // Rule ID 3786 //
     /* 141727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 141730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141734 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141738 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 141742 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 141746 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 141750 */   // MIs[1] Operand 1
     /* 141750 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 141755 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 141759 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 141763 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 141767 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 141771 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 141775 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 141779 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 141783 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 141787 */   GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 141791 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 141795 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 141797 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i64] } i64:{ *:[i64] }:$s1, (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (RLDCL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] })
     /* 141797 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 141800 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 141804 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141809 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 141813 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/64,
     /* 141816 */   GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /* 141819 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 141821 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 141824 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 141828 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141833 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 141837 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 141841 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 141843 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 141846 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 141848 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 141851 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 141854 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 141857 */   GIR_RootConstrainSelectedInstOperands,
     /* 141858 */   // GIR_Coverage, 3786,
     /* 141858 */   GIR_EraseRootFromParent_Done,
     /* 141859 */ // Label 1952: @141859
     /* 141859 */ GIM_Try, /*On fail goto*//*Label 1953*/ GIMT_Encode4(142050), // Rule ID 3787 //
     /* 141864 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 141867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141871 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141875 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 141879 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 141883 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 141887 */   // MIs[1] Operand 1
     /* 141887 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 141892 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 141896 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 141900 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 141904 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 141908 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 141912 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 141916 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 141920 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 141924 */   GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 141928 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 141932 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 141934 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i32] } i32:{ *:[i32] }:$s1, (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWNM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 141934 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 141937 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 141941 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141946 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 141950 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/32,
     /* 141953 */   GIR_SetImplicitDefDead, /*InsnID*/4, /*OpIdx for PPC::CARRY*/0,
     /* 141956 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 141958 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 141961 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 141965 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141970 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 141974 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 141978 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 141980 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 141983 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 141987 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141992 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 141995 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 141998 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 142001 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 142004 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 142006 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 142009 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 142013 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142018 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 142023 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142025 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142028 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 142031 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 142034 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142039 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142044 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 142049 */   // GIR_Coverage, 3787,
     /* 142049 */   GIR_EraseRootFromParent_Done,
     /* 142050 */ // Label 1953: @142050
     /* 142050 */ GIM_Try, /*On fail goto*//*Label 1954*/ GIMT_Encode4(142133), // Rule ID 3357 //
     /* 142055 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 142058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 142061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142065 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142069 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 142073 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 142077 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 142081 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 142085 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 142089 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 142093 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 142097 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 142099 */   // (zext:{ *:[i64] } (srl:{ *:[i32] } (bswap:{ *:[i32] } i32:{ *:[i32] }:$RS), 16:{ *:[i32] }))  =>  (RLDICL_32_64:{ *:[i64] } (BRH:{ *:[i32] } ?:{ *:[i32] }:$RS), 0:{ *:[i32] }, 48:{ *:[i32] })
     /* 142099 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 142102 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::BRH),
     /* 142106 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142111 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // RS
     /* 142115 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142117 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL_32_64),
     /* 142120 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 142122 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142125 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142128 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 142131 */   GIR_RootConstrainSelectedInstOperands,
     /* 142132 */   // GIR_Coverage, 3357,
     /* 142132 */   GIR_EraseRootFromParent_Done,
     /* 142133 */ // Label 1954: @142133
     /* 142133 */ GIM_Try, /*On fail goto*//*Label 1955*/ GIMT_Encode4(142206), // Rule ID 3698 //
     /* 142138 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 142141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142145 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142149 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 142153 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 142157 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 142161 */   // MIs[1] Operand 1
     /* 142161 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 142166 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 142170 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142172 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1), 58:{ *:[i32] }, 63:{ *:[i32] })
     /* 142172 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 142175 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /* 142179 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142184 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142188 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142190 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 142193 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 142195 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142198 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/58,
     /* 142201 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 142204 */   GIR_RootConstrainSelectedInstOperands,
     /* 142205 */   // GIR_Coverage, 3698,
     /* 142205 */   GIR_EraseRootFromParent_Done,
     /* 142206 */ // Label 1955: @142206
     /* 142206 */ GIM_Try, /*On fail goto*//*Label 1956*/ GIMT_Encode4(142333), // Rule ID 3699 //
     /* 142211 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 142214 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142218 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142222 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 142226 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 142230 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 142234 */   // MIs[1] Operand 1
     /* 142234 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 142239 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 142243 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142245 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1), 27:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 142245 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 142248 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /* 142252 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142257 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142261 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 142263 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 142266 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 142270 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142275 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 142278 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/27,
     /* 142281 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 142284 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 142287 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 142289 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 142292 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 142296 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142301 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142303 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 142306 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142308 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142311 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 142314 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 142317 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142322 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142327 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 142332 */   // GIR_Coverage, 3699,
     /* 142332 */   GIR_EraseRootFromParent_Done,
     /* 142333 */ // Label 1956: @142333
     /* 142333 */ GIM_Try, /*On fail goto*//*Label 1957*/ GIMT_Encode4(142444), // Rule ID 3706 //
     /* 142338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 142341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142345 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142349 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 142353 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 142357 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 142361 */   // MIs[1] Operand 1
     /* 142361 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 142366 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 142370 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142372 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1), (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1)), 58:{ *:[i32] }, 63:{ *:[i32] })
     /* 142372 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 142375 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /* 142379 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142384 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142388 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 142390 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 142393 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /* 142397 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142402 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142406 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 142408 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 142411 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 142415 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142420 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 142423 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 142426 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142428 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 142431 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 142433 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142436 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/58,
     /* 142439 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 142442 */   GIR_RootConstrainSelectedInstOperands,
     /* 142443 */   // GIR_Coverage, 3706,
     /* 142443 */   GIR_EraseRootFromParent_Done,
     /* 142444 */ // Label 1957: @142444
     /* 142444 */ GIM_Try, /*On fail goto*//*Label 1958*/ GIMT_Encode4(142609), // Rule ID 3707 //
     /* 142449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 142452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142456 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142460 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 142464 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 142468 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 142472 */   // MIs[1] Operand 1
     /* 142472 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 142477 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 142481 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142483 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1), (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1)), 27:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 142483 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 142486 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /* 142490 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142495 */   GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142499 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 142501 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 142504 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /* 142508 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142513 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142517 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 142519 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 142522 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 142526 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142531 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 142534 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 142537 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 142539 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 142542 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 142546 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142551 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 142554 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/27,
     /* 142557 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 142560 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 142563 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 142565 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 142568 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 142572 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142577 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142579 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 142582 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142584 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142587 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 142590 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 142593 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142598 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142603 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 142608 */   // GIR_Coverage, 3707,
     /* 142608 */   GIR_EraseRootFromParent_Done,
     /* 142609 */ // Label 1958: @142609
     /* 142609 */ GIM_Try, /*On fail goto*//*Label 1959*/ GIMT_Encode4(142665), // Rule ID 3714 //
     /* 142614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 142617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142621 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142625 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 142629 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 142633 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 142637 */   // MIs[1] Operand 1
     /* 142637 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 142642 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 142646 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142648 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETLT:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 142648 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 142651 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 142653 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142657 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 142660 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 142663 */   GIR_RootConstrainSelectedInstOperands,
     /* 142664 */   // GIR_Coverage, 3714,
     /* 142664 */   GIR_EraseRootFromParent_Done,
     /* 142665 */ // Label 1959: @142665
     /* 142665 */ GIM_Try, /*On fail goto*//*Label 1960*/ GIMT_Encode4(142775), // Rule ID 3715 //
     /* 142670 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 142673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142677 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142681 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 142685 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 142689 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 142693 */   // MIs[1] Operand 1
     /* 142693 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 142698 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 142702 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142704 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETLT:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 142704 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 142707 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 142711 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142716 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142720 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 142723 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 142726 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 142729 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 142731 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 142734 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 142738 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142743 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142745 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 142748 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142750 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142753 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 142756 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 142759 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142764 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142769 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 142774 */   // GIR_Coverage, 3715,
     /* 142774 */   GIR_EraseRootFromParent_Done,
     /* 142775 */ // Label 1960: @142775
     /* 142775 */ GIM_Try, /*On fail goto*//*Label 1961*/ GIMT_Encode4(142852), // Rule ID 3722 //
     /* 142780 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 142783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142787 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142791 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 142795 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 142799 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 142803 */   // MIs[1] Operand 1
     /* 142803 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 142808 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 142812 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142814 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETGE:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 142814 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 142817 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 142821 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142826 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142830 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142834 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142836 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 142839 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 142841 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142844 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 142847 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 142850 */   GIR_RootConstrainSelectedInstOperands,
     /* 142851 */   // GIR_Coverage, 3722,
     /* 142851 */   GIR_EraseRootFromParent_Done,
     /* 142852 */ // Label 1961: @142852
     /* 142852 */ GIM_Try, /*On fail goto*//*Label 1962*/ GIMT_Encode4(142983), // Rule ID 3723 //
     /* 142857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 142860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142864 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142868 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 142872 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 142876 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 142880 */   // MIs[1] Operand 1
     /* 142880 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 142885 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 142889 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142891 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETGE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 142891 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 142894 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 142898 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142903 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142907 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142911 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 142913 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 142916 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 142920 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142925 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 142928 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 142931 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 142934 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 142937 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 142939 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 142942 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 142946 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142951 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142953 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 142956 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142958 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142961 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 142964 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 142967 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142972 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142977 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 142982 */   // GIR_Coverage, 3723,
     /* 142982 */   GIR_EraseRootFromParent_Done,
     /* 142983 */ // Label 1962: @142983
     /* 142983 */ GIM_Try, /*On fail goto*//*Label 1963*/ GIMT_Encode4(143077), // Rule ID 3730 //
     /* 142988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 142991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142995 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142999 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 143003 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 143007 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 143011 */   // MIs[1] Operand 1
     /* 143011 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 143016 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 143020 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143022 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETGT:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (ANDC8:{ *:[i64] } (NEG8:{ *:[i64] } ?:{ *:[i64] }:$s1), ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 143022 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 143025 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NEG8),
     /* 143029 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143034 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143038 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 143040 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 143043 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::ANDC8),
     /* 143047 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143052 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 143055 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143059 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 143061 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 143064 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 143066 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143069 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 143072 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 143075 */   GIR_RootConstrainSelectedInstOperands,
     /* 143076 */   // GIR_Coverage, 3730,
     /* 143076 */   GIR_EraseRootFromParent_Done,
     /* 143077 */ // Label 1963: @143077
     /* 143077 */ GIM_Try, /*On fail goto*//*Label 1964*/ GIMT_Encode4(143225), // Rule ID 3731 //
     /* 143082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 143085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143089 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143093 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 143097 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 143101 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 143105 */   // MIs[1] Operand 1
     /* 143105 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 143110 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 143114 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143116 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETGT:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (ANDC:{ *:[i32] } (NEG:{ *:[i32] } ?:{ *:[i32] }:$s1), ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 143116 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 143119 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::NEG),
     /* 143123 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143128 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143132 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 143134 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 143137 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::ANDC),
     /* 143141 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143146 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 143149 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143153 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 143155 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 143158 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 143162 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143167 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 143170 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 143173 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 143176 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 143179 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 143181 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 143184 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 143188 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143193 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 143195 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 143198 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143200 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143203 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 143206 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 143209 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143214 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143219 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 143224 */   // GIR_Coverage, 3731,
     /* 143224 */   GIR_EraseRootFromParent_Done,
     /* 143225 */ // Label 1964: @143225
     /* 143225 */ GIM_Try, /*On fail goto*//*Label 1965*/ GIMT_Encode4(143319), // Rule ID 3738 //
     /* 143230 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 143233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143237 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143241 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 143245 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 143249 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 143253 */   // MIs[1] Operand 1
     /* 143253 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 143258 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 143262 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143264 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETLE:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (ORC8:{ *:[i64] } ?:{ *:[i64] }:$s1, (NEG8:{ *:[i64] } ?:{ *:[i64] }:$s1)), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 143264 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 143267 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NEG8),
     /* 143271 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143276 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143280 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 143282 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 143285 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::ORC8),
     /* 143289 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143294 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143298 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 143301 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 143303 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 143306 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 143308 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143311 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 143314 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 143317 */   GIR_RootConstrainSelectedInstOperands,
     /* 143318 */   // GIR_Coverage, 3738,
     /* 143318 */   GIR_EraseRootFromParent_Done,
     /* 143319 */ // Label 1965: @143319
     /* 143319 */ GIM_Try, /*On fail goto*//*Label 1966*/ GIMT_Encode4(143467), // Rule ID 3739 //
     /* 143324 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 143327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143331 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143335 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 143339 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 143343 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 143347 */   // MIs[1] Operand 1
     /* 143347 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 143352 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 143356 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143358 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETLE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (ORC:{ *:[i32] } ?:{ *:[i32] }:$s1, (NEG:{ *:[i32] } ?:{ *:[i32] }:$s1)), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 143358 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 143361 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::NEG),
     /* 143365 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143370 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143374 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 143376 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 143379 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::ORC),
     /* 143383 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143388 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143392 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 143395 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 143397 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 143400 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 143404 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143409 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 143412 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 143415 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 143418 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 143421 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 143423 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 143426 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 143430 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143435 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 143437 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 143440 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143442 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143445 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 143448 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 143451 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143456 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143461 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 143466 */   // GIR_Coverage, 3739,
     /* 143466 */   GIR_EraseRootFromParent_Done,
     /* 143467 */ // Label 1966: @143467
     /* 143467 */ GIM_Try, /*On fail goto*//*Label 1967*/ GIMT_Encode4(143564), // Rule ID 3746 //
     /* 143472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 143475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143479 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143483 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 143487 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 143491 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 143495 */   // MIs[1] Operand 1
     /* 143495 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 143500 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 143504 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143506 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETLT:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (AND8:{ *:[i64] } ?:{ *:[i64] }:$s1, (ADDI8:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i64] })), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 143506 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 143509 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ADDI8),
     /* 143513 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143518 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143522 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 143525 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 143527 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 143530 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 143534 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143539 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143543 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 143546 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 143548 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 143551 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 143553 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143556 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 143559 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 143562 */   GIR_RootConstrainSelectedInstOperands,
     /* 143563 */   // GIR_Coverage, 3746,
     /* 143563 */   GIR_EraseRootFromParent_Done,
     /* 143564 */ // Label 1967: @143564
     /* 143564 */ GIM_Try, /*On fail goto*//*Label 1968*/ GIMT_Encode4(143715), // Rule ID 3747 //
     /* 143569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 143572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143576 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143580 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 143584 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 143588 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 143592 */   // MIs[1] Operand 1
     /* 143592 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 143597 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 143601 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143603 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETLT:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (AND:{ *:[i32] } ?:{ *:[i32] }:$s1, (ADDI:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] })), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 143603 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 143606 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::ADDI),
     /* 143610 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143615 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143619 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 143622 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 143624 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 143627 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 143631 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143636 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143640 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 143643 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 143645 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 143648 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 143652 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143657 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 143660 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 143663 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 143666 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 143669 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 143671 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 143674 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 143678 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143683 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 143685 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 143688 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143690 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143693 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 143696 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 143699 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143704 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143709 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 143714 */   // GIR_Coverage, 3747,
     /* 143714 */   GIR_EraseRootFromParent_Done,
     /* 143715 */ // Label 1968: @143715
     /* 143715 */ GIM_Try, /*On fail goto*//*Label 1969*/ GIMT_Encode4(143812), // Rule ID 3754 //
     /* 143720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 143723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143727 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143731 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 143735 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 143739 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 143743 */   // MIs[1] Operand 1
     /* 143743 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 143748 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 143752 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143754 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETGE:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (NAND8:{ *:[i64] } ?:{ *:[i64] }:$s1, (ADDI8:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i64] })), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 143754 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 143757 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ADDI8),
     /* 143761 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143766 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143770 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 143773 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 143775 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 143778 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NAND8),
     /* 143782 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143787 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143791 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 143794 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 143796 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 143799 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 143801 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143804 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 143807 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 143810 */   GIR_RootConstrainSelectedInstOperands,
     /* 143811 */   // GIR_Coverage, 3754,
     /* 143811 */   GIR_EraseRootFromParent_Done,
     /* 143812 */ // Label 1969: @143812
     /* 143812 */ GIM_Try, /*On fail goto*//*Label 1970*/ GIMT_Encode4(143963), // Rule ID 3755 //
     /* 143817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 143820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143824 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143828 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 143832 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 143836 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 143840 */   // MIs[1] Operand 1
     /* 143840 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 143845 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 143849 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143851 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETGE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (NAND:{ *:[i32] } ?:{ *:[i32] }:$s1, (ADDI:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] })), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 143851 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 143854 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::ADDI),
     /* 143858 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143863 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143867 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 143870 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 143872 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 143875 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NAND),
     /* 143879 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143884 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143888 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 143891 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 143893 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 143896 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 143900 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143905 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 143908 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 143911 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 143914 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 143917 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 143919 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 143922 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 143926 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143931 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 143933 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 143936 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143938 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143941 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 143944 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 143947 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143952 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143957 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 143962 */   // GIR_Coverage, 3755,
     /* 143962 */   GIR_EraseRootFromParent_Done,
     /* 143963 */ // Label 1970: @143963
     /* 143963 */ GIM_Try, /*On fail goto*//*Label 1971*/ GIMT_Encode4(144040), // Rule ID 3762 //
     /* 143968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 143971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143975 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143979 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 143983 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 143987 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 143991 */   // MIs[1] Operand 1
     /* 143991 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 143996 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 144000 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144002 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETGT:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 144002 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 144005 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 144009 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144014 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 144018 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 144022 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 144024 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 144027 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 144029 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144032 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 144035 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 144038 */   GIR_RootConstrainSelectedInstOperands,
     /* 144039 */   // GIR_Coverage, 3762,
     /* 144039 */   GIR_EraseRootFromParent_Done,
     /* 144040 */ // Label 1971: @144040
     /* 144040 */ GIM_Try, /*On fail goto*//*Label 1972*/ GIMT_Encode4(144171), // Rule ID 3763 //
     /* 144045 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 144048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 144052 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144056 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 144060 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 144064 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 144068 */   // MIs[1] Operand 1
     /* 144068 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 144073 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 144077 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144079 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETGT:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 144079 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 144082 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 144086 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144091 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 144095 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 144099 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 144101 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 144104 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 144108 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144113 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 144116 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 144119 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 144122 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 144125 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 144127 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 144130 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 144134 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144139 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 144141 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 144144 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144146 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144149 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 144152 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 144155 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 144160 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 144165 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 144170 */   // GIR_Coverage, 3763,
     /* 144170 */   GIR_EraseRootFromParent_Done,
     /* 144171 */ // Label 1972: @144171
     /* 144171 */ GIM_Try, /*On fail goto*//*Label 1973*/ GIMT_Encode4(144227), // Rule ID 3770 //
     /* 144176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 144179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 144183 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144187 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 144191 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 144195 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 144199 */   // MIs[1] Operand 1
     /* 144199 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 144204 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 144208 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144210 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETLE:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 144210 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 144213 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 144215 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 144219 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 144222 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 144225 */   GIR_RootConstrainSelectedInstOperands,
     /* 144226 */   // GIR_Coverage, 3770,
     /* 144226 */   GIR_EraseRootFromParent_Done,
     /* 144227 */ // Label 1973: @144227
     /* 144227 */ GIM_Try, /*On fail goto*//*Label 1974*/ GIMT_Encode4(144337), // Rule ID 3771 //
     /* 144232 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 144235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 144239 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144243 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 144247 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 144251 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 144255 */   // MIs[1] Operand 1
     /* 144255 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 144260 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 144264 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144266 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETLE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 144266 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 144269 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 144273 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144278 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 144282 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 144285 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 144288 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 144291 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 144293 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 144296 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 144300 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144305 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 144307 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 144310 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144312 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144315 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 144318 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 144321 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 144326 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 144331 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 144336 */   // GIR_Coverage, 3771,
     /* 144336 */   GIR_EraseRootFromParent_Done,
     /* 144337 */ // Label 1974: @144337
     /* 144337 */ GIM_Try, /*On fail goto*//*Label 1975*/ GIMT_Encode4(144447), // Rule ID 3037 //
     /* 144342 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 144345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 144348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 144352 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144356 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 144360 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 144364 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 144368 */   // MIs[1] Operand 1
     /* 144368 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 144373 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 144377 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 144381 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 144385 */   // MIs[2] Operand 1
     /* 144385 */   // No operand predicates
     /* 144385 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 144387 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }))
     /* 144387 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 144390 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 144394 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144399 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 144403 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 144406 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 144408 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 144411 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 144415 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144420 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 144427 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 144432 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 144437 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 144440 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 144442 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144445 */   GIR_RootConstrainSelectedInstOperands,
     /* 144446 */   // GIR_Coverage, 3037,
     /* 144446 */   GIR_EraseRootFromParent_Done,
     /* 144447 */ // Label 1975: @144447
     /* 144447 */ GIM_Try, /*On fail goto*//*Label 1976*/ GIMT_Encode4(144557), // Rule ID 3053 //
     /* 144452 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 144455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 144458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 144462 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144466 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 144470 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 144474 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 144478 */   // MIs[1] Operand 1
     /* 144478 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 144483 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 144487 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 144491 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 144495 */   // MIs[2] Operand 1
     /* 144495 */   // No operand predicates
     /* 144495 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 144497 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }))
     /* 144497 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 144500 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 144504 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144509 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 144513 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 144516 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 144518 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 144521 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 144525 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144530 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 144537 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 144542 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 144547 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 144550 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 144552 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144555 */   GIR_RootConstrainSelectedInstOperands,
     /* 144556 */   // GIR_Coverage, 3053,
     /* 144556 */   GIR_EraseRootFromParent_Done,
     /* 144557 */ // Label 1976: @144557
     /* 144557 */ GIM_Try, /*On fail goto*//*Label 1977*/ GIMT_Encode4(144667), // Rule ID 3061 //
     /* 144562 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 144565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 144568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 144572 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144576 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 144580 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 144584 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 144588 */   // MIs[1] Operand 1
     /* 144588 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 144593 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 144597 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 144601 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 144605 */   // MIs[2] Operand 1
     /* 144605 */   // No operand predicates
     /* 144605 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 144607 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }))
     /* 144607 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 144610 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 144614 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144619 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 144623 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 144626 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 144628 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 144631 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 144635 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144640 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 144647 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 144652 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 144657 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 144660 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 144662 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144665 */   GIR_RootConstrainSelectedInstOperands,
     /* 144666 */   // GIR_Coverage, 3061,
     /* 144666 */   GIR_EraseRootFromParent_Done,
     /* 144667 */ // Label 1977: @144667
     /* 144667 */ GIM_Try, /*On fail goto*//*Label 1978*/ GIMT_Encode4(144777), // Rule ID 3133 //
     /* 144672 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 144675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 144678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 144682 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144686 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 144690 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 144694 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 144698 */   // MIs[1] Operand 1
     /* 144698 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 144703 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 144707 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 144711 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 144715 */   // MIs[2] Operand 1
     /* 144715 */   // No operand predicates
     /* 144715 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 144717 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }))
     /* 144717 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 144720 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 144724 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144729 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 144733 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 144736 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 144738 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 144741 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 144745 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144750 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 144757 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 144762 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 144767 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 144770 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 144772 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144775 */   GIR_RootConstrainSelectedInstOperands,
     /* 144776 */   // GIR_Coverage, 3133,
     /* 144776 */   GIR_EraseRootFromParent_Done,
     /* 144777 */ // Label 1978: @144777
     /* 144777 */ GIM_Try, /*On fail goto*//*Label 1979*/ GIMT_Encode4(144887), // Rule ID 3149 //
     /* 144782 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 144785 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 144788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 144792 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144796 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 144800 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 144804 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 144808 */   // MIs[1] Operand 1
     /* 144808 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 144813 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 144817 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 144821 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 144825 */   // MIs[2] Operand 1
     /* 144825 */   // No operand predicates
     /* 144825 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 144827 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }))
     /* 144827 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 144830 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 144834 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144839 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 144843 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 144846 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 144848 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 144851 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 144855 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144860 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 144867 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 144872 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 144877 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 144880 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 144882 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144885 */   GIR_RootConstrainSelectedInstOperands,
     /* 144886 */   // GIR_Coverage, 3149,
     /* 144886 */   GIR_EraseRootFromParent_Done,
     /* 144887 */ // Label 1979: @144887
     /* 144887 */ GIM_Try, /*On fail goto*//*Label 1980*/ GIMT_Encode4(144997), // Rule ID 3157 //
     /* 144892 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 144895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 144898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 144902 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144906 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 144910 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 144914 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 144918 */   // MIs[1] Operand 1
     /* 144918 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 144923 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 144927 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 144931 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 144935 */   // MIs[2] Operand 1
     /* 144935 */   // No operand predicates
     /* 144935 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 144937 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }))
     /* 144937 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 144940 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 144944 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144949 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 144953 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 144956 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 144958 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 144961 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 144965 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144970 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 144977 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 144982 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 144987 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 144990 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 144992 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144995 */   GIR_RootConstrainSelectedInstOperands,
     /* 144996 */   // GIR_Coverage, 3157,
     /* 144996 */   GIR_EraseRootFromParent_Done,
     /* 144997 */ // Label 1980: @144997
     /* 144997 */ GIM_Try, /*On fail goto*//*Label 1981*/ GIMT_Encode4(145147), // Rule ID 3821 //
     /* 145002 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 145005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 145008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 145012 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 145016 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 145020 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 145024 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 145028 */   // MIs[1] Operand 1
     /* 145028 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 145033 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 145037 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 145041 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 145045 */   // MIs[2] Operand 1
     /* 145045 */   // No operand predicates
     /* 145045 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 145047 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 145047 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 145050 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 145054 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145059 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 145063 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 145066 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 145068 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 145071 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 145075 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145080 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 145083 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 145085 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 145088 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 145092 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145097 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 145100 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 145102 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 145105 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 145109 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145114 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 145121 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 145126 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 145131 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 145134 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145136 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 145139 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 145142 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 145145 */   GIR_RootConstrainSelectedInstOperands,
     /* 145146 */   // GIR_Coverage, 3821,
     /* 145146 */   GIR_EraseRootFromParent_Done,
     /* 145147 */ // Label 1981: @145147
     /* 145147 */ GIM_Try, /*On fail goto*//*Label 1982*/ GIMT_Encode4(145297), // Rule ID 3837 //
     /* 145152 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 145155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 145158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 145162 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 145166 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 145170 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 145174 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 145178 */   // MIs[1] Operand 1
     /* 145178 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 145183 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 145187 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 145191 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 145195 */   // MIs[2] Operand 1
     /* 145195 */   // No operand predicates
     /* 145195 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 145197 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 145197 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 145200 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 145204 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145209 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 145213 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 145216 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 145218 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 145221 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 145225 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145230 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 145233 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 145235 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 145238 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 145242 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145247 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 145250 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 145252 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 145255 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 145259 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145264 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 145271 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 145276 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 145281 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 145284 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145286 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 145289 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 145292 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 145295 */   GIR_RootConstrainSelectedInstOperands,
     /* 145296 */   // GIR_Coverage, 3837,
     /* 145296 */   GIR_EraseRootFromParent_Done,
     /* 145297 */ // Label 1982: @145297
     /* 145297 */ GIM_Try, /*On fail goto*//*Label 1983*/ GIMT_Encode4(145447), // Rule ID 3845 //
     /* 145302 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 145305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 145308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 145312 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 145316 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 145320 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 145324 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 145328 */   // MIs[1] Operand 1
     /* 145328 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 145333 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 145337 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 145341 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 145345 */   // MIs[2] Operand 1
     /* 145345 */   // No operand predicates
     /* 145345 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 145347 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 145347 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 145350 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 145354 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145359 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 145363 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 145366 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 145368 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 145371 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 145375 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145380 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 145383 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 145385 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 145388 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 145392 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145397 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 145400 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 145402 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 145405 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 145409 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145414 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 145421 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 145426 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 145431 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 145434 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145436 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 145439 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 145442 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 145445 */   GIR_RootConstrainSelectedInstOperands,
     /* 145446 */   // GIR_Coverage, 3845,
     /* 145446 */   GIR_EraseRootFromParent_Done,
     /* 145447 */ // Label 1983: @145447
     /* 145447 */ GIM_Try, /*On fail goto*//*Label 1984*/ GIMT_Encode4(145597), // Rule ID 3917 //
     /* 145452 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 145455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 145458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 145462 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 145466 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 145470 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 145474 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 145478 */   // MIs[1] Operand 1
     /* 145478 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 145483 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 145487 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 145491 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 145495 */   // MIs[2] Operand 1
     /* 145495 */   // No operand predicates
     /* 145495 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 145497 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 145497 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 145500 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 145504 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145509 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 145513 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 145516 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 145518 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 145521 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 145525 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145530 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 145533 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 145535 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 145538 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 145542 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145547 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 145550 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 145552 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 145555 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 145559 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145564 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 145571 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 145576 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 145581 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 145584 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145586 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 145589 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 145592 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 145595 */   GIR_RootConstrainSelectedInstOperands,
     /* 145596 */   // GIR_Coverage, 3917,
     /* 145596 */   GIR_EraseRootFromParent_Done,
     /* 145597 */ // Label 1984: @145597
     /* 145597 */ GIM_Try, /*On fail goto*//*Label 1985*/ GIMT_Encode4(145747), // Rule ID 3933 //
     /* 145602 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 145605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 145608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 145612 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 145616 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 145620 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 145624 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 145628 */   // MIs[1] Operand 1
     /* 145628 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 145633 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 145637 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 145641 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 145645 */   // MIs[2] Operand 1
     /* 145645 */   // No operand predicates
     /* 145645 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 145647 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 145647 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 145650 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 145654 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145659 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 145663 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 145666 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 145668 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 145671 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 145675 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145680 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 145683 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 145685 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 145688 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 145692 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145697 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 145700 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 145702 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 145705 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 145709 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145714 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 145721 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 145726 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 145731 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 145734 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145736 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 145739 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 145742 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 145745 */   GIR_RootConstrainSelectedInstOperands,
     /* 145746 */   // GIR_Coverage, 3933,
     /* 145746 */   GIR_EraseRootFromParent_Done,
     /* 145747 */ // Label 1985: @145747
     /* 145747 */ GIM_Try, /*On fail goto*//*Label 1986*/ GIMT_Encode4(145897), // Rule ID 3941 //
     /* 145752 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 145755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 145758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 145762 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 145766 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 145770 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 145774 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 145778 */   // MIs[1] Operand 1
     /* 145778 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 145783 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 145787 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 145791 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 145795 */   // MIs[2] Operand 1
     /* 145795 */   // No operand predicates
     /* 145795 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 145797 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 145797 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 145800 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 145804 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145809 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 145813 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 145816 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 145818 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 145821 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 145825 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145830 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 145833 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 145835 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 145838 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 145842 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145847 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 145850 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 145852 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 145855 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 145859 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145864 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 145871 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 145876 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 145881 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 145884 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145886 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 145889 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 145892 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 145895 */   GIR_RootConstrainSelectedInstOperands,
     /* 145896 */   // GIR_Coverage, 3941,
     /* 145896 */   GIR_EraseRootFromParent_Done,
     /* 145897 */ // Label 1986: @145897
     /* 145897 */ GIM_Try, /*On fail goto*//*Label 1987*/ GIMT_Encode4(145996), // Rule ID 3181 //
     /* 145902 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 145905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 145908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 145912 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 145916 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 145920 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 145924 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 145928 */   // MIs[1] Operand 1
     /* 145928 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 145933 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145935 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }))
     /* 145935 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 145938 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 145942 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145947 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 145951 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 145955 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 145957 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 145960 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 145964 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145969 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 145976 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 145981 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 145986 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 145989 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 145991 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 145994 */   GIR_RootConstrainSelectedInstOperands,
     /* 145995 */   // GIR_Coverage, 3181,
     /* 145995 */   GIR_EraseRootFromParent_Done,
     /* 145996 */ // Label 1987: @145996
     /* 145996 */ GIM_Try, /*On fail goto*//*Label 1988*/ GIMT_Encode4(146095), // Rule ID 3197 //
     /* 146001 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 146004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 146007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 146011 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 146015 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 146019 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 146023 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 146027 */   // MIs[1] Operand 1
     /* 146027 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 146032 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146034 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }))
     /* 146034 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 146037 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 146041 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146046 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 146050 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 146054 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 146056 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 146059 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146063 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146068 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 146075 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 146080 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 146085 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 146088 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 146090 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146093 */   GIR_RootConstrainSelectedInstOperands,
     /* 146094 */   // GIR_Coverage, 3197,
     /* 146094 */   GIR_EraseRootFromParent_Done,
     /* 146095 */ // Label 1988: @146095
     /* 146095 */ GIM_Try, /*On fail goto*//*Label 1989*/ GIMT_Encode4(146194), // Rule ID 3213 //
     /* 146100 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 146103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 146106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 146110 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 146114 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 146118 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 146122 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 146126 */   // MIs[1] Operand 1
     /* 146126 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 146131 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146133 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }))
     /* 146133 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 146136 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 146140 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146145 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 146149 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 146153 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 146155 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 146158 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146162 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146167 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 146174 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 146179 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 146184 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 146187 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 146189 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146192 */   GIR_RootConstrainSelectedInstOperands,
     /* 146193 */   // GIR_Coverage, 3213,
     /* 146193 */   GIR_EraseRootFromParent_Done,
     /* 146194 */ // Label 1989: @146194
     /* 146194 */ GIM_Try, /*On fail goto*//*Label 1990*/ GIMT_Encode4(146293), // Rule ID 3229 //
     /* 146199 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 146202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 146205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 146209 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 146213 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 146217 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 146221 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 146225 */   // MIs[1] Operand 1
     /* 146225 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 146230 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146232 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }))
     /* 146232 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 146235 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 146239 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146244 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 146248 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 146252 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 146254 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 146257 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146261 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146266 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 146273 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 146278 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 146283 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 146286 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 146288 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146291 */   GIR_RootConstrainSelectedInstOperands,
     /* 146292 */   // GIR_Coverage, 3229,
     /* 146292 */   GIR_EraseRootFromParent_Done,
     /* 146293 */ // Label 1990: @146293
     /* 146293 */ GIM_Try, /*On fail goto*//*Label 1991*/ GIMT_Encode4(146392), // Rule ID 3237 //
     /* 146298 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 146301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 146304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 146308 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 146312 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 146316 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 146320 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 146324 */   // MIs[1] Operand 1
     /* 146324 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 146329 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146331 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }))
     /* 146331 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 146334 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 146338 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146343 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 146347 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 146351 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 146353 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 146356 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146360 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146365 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 146372 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 146377 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 146382 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 146385 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 146387 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146390 */   GIR_RootConstrainSelectedInstOperands,
     /* 146391 */   // GIR_Coverage, 3237,
     /* 146391 */   GIR_EraseRootFromParent_Done,
     /* 146392 */ // Label 1991: @146392
     /* 146392 */ GIM_Try, /*On fail goto*//*Label 1992*/ GIMT_Encode4(146491), // Rule ID 3253 //
     /* 146397 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 146400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 146403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 146407 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 146411 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 146415 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 146419 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 146423 */   // MIs[1] Operand 1
     /* 146423 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 146428 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146430 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }))
     /* 146430 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 146433 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 146437 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146442 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 146446 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 146450 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 146452 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 146455 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146459 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146464 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 146471 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 146476 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 146481 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 146484 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 146486 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146489 */   GIR_RootConstrainSelectedInstOperands,
     /* 146490 */   // GIR_Coverage, 3253,
     /* 146490 */   GIR_EraseRootFromParent_Done,
     /* 146491 */ // Label 1992: @146491
     /* 146491 */ GIM_Try, /*On fail goto*//*Label 1993*/ GIMT_Encode4(146590), // Rule ID 3269 //
     /* 146496 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 146499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 146502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 146506 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 146510 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 146514 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 146518 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 146522 */   // MIs[1] Operand 1
     /* 146522 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 146527 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146529 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }))
     /* 146529 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 146532 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 146536 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146541 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 146545 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 146549 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 146551 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 146554 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146558 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146563 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 146570 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 146575 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 146580 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 146583 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 146585 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146588 */   GIR_RootConstrainSelectedInstOperands,
     /* 146589 */   // GIR_Coverage, 3269,
     /* 146589 */   GIR_EraseRootFromParent_Done,
     /* 146590 */ // Label 1993: @146590
     /* 146590 */ GIM_Try, /*On fail goto*//*Label 1994*/ GIMT_Encode4(146689), // Rule ID 3285 //
     /* 146595 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 146598 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 146601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 146605 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 146609 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 146613 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 146617 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 146621 */   // MIs[1] Operand 1
     /* 146621 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 146626 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146628 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }))
     /* 146628 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 146631 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 146635 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146640 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 146644 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 146648 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 146650 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 146653 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146657 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146662 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 146669 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 146674 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 146679 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 146682 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 146684 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146687 */   GIR_RootConstrainSelectedInstOperands,
     /* 146688 */   // GIR_Coverage, 3285,
     /* 146688 */   GIR_EraseRootFromParent_Done,
     /* 146689 */ // Label 1994: @146689
     /* 146689 */ GIM_Try, /*On fail goto*//*Label 1995*/ GIMT_Encode4(146788), // Rule ID 3293 //
     /* 146694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 146697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 146700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 146704 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 146708 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 146712 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 146716 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 146720 */   // MIs[1] Operand 1
     /* 146720 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 146725 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146727 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }))
     /* 146727 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 146730 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 146734 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146739 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 146743 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 146747 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 146749 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 146752 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146756 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146761 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 146768 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 146773 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 146778 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 146781 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 146783 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146786 */   GIR_RootConstrainSelectedInstOperands,
     /* 146787 */   // GIR_Coverage, 3293,
     /* 146787 */   GIR_EraseRootFromParent_Done,
     /* 146788 */ // Label 1995: @146788
     /* 146788 */ GIM_Try, /*On fail goto*//*Label 1996*/ GIMT_Encode4(146887), // Rule ID 3309 //
     /* 146793 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 146796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 146799 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 146803 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 146807 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 146811 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 146815 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 146819 */   // MIs[1] Operand 1
     /* 146819 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 146824 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146826 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }))
     /* 146826 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 146829 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 146833 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146838 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 146842 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 146846 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 146848 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 146851 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146855 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146860 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 146867 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 146872 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 146877 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 146880 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 146882 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146885 */   GIR_RootConstrainSelectedInstOperands,
     /* 146886 */   // GIR_Coverage, 3309,
     /* 146886 */   GIR_EraseRootFromParent_Done,
     /* 146887 */ // Label 1996: @146887
     /* 146887 */ GIM_Try, /*On fail goto*//*Label 1997*/ GIMT_Encode4(146986), // Rule ID 3325 //
     /* 146892 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 146895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 146898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 146902 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 146906 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 146910 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 146914 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 146918 */   // MIs[1] Operand 1
     /* 146918 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 146923 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146925 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }))
     /* 146925 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 146928 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 146932 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146937 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 146941 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 146945 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 146947 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 146950 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146954 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146959 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 146966 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 146971 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 146976 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 146979 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 146981 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146984 */   GIR_RootConstrainSelectedInstOperands,
     /* 146985 */   // GIR_Coverage, 3325,
     /* 146985 */   GIR_EraseRootFromParent_Done,
     /* 146986 */ // Label 1997: @146986
     /* 146986 */ GIM_Try, /*On fail goto*//*Label 1998*/ GIMT_Encode4(147085), // Rule ID 3341 //
     /* 146991 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 146994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 146997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 147001 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147005 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 147009 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 147013 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 147017 */   // MIs[1] Operand 1
     /* 147017 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 147022 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147024 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }))
     /* 147024 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 147027 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 147031 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147036 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 147040 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 147044 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 147046 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 147049 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 147053 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147058 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 147065 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 147070 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 147075 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 147078 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 147080 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147083 */   GIR_RootConstrainSelectedInstOperands,
     /* 147084 */   // GIR_Coverage, 3341,
     /* 147084 */   GIR_EraseRootFromParent_Done,
     /* 147085 */ // Label 1998: @147085
     /* 147085 */ GIM_Try, /*On fail goto*//*Label 1999*/ GIMT_Encode4(147224), // Rule ID 4024 //
     /* 147090 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 147093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 147096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 147100 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147104 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 147108 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 147112 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 147116 */   // MIs[1] Operand 1
     /* 147116 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 147121 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147123 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 147123 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 147126 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 147130 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147135 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 147139 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 147143 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 147145 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 147148 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 147152 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147157 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 147160 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 147162 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 147165 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 147169 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147174 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 147177 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 147179 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 147182 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 147186 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147191 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 147198 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 147203 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 147208 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 147211 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147213 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147216 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 147219 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 147222 */   GIR_RootConstrainSelectedInstOperands,
     /* 147223 */   // GIR_Coverage, 4024,
     /* 147223 */   GIR_EraseRootFromParent_Done,
     /* 147224 */ // Label 1999: @147224
     /* 147224 */ GIM_Try, /*On fail goto*//*Label 2000*/ GIMT_Encode4(147363), // Rule ID 4056 //
     /* 147229 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 147232 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 147235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 147239 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147243 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 147247 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 147251 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 147255 */   // MIs[1] Operand 1
     /* 147255 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 147260 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147262 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 147262 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 147265 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 147269 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147274 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 147278 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 147282 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 147284 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 147287 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 147291 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147296 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 147299 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 147301 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 147304 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 147308 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147313 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 147316 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 147318 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 147321 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 147325 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147330 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 147337 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 147342 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 147347 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 147350 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147352 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147355 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 147358 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 147361 */   GIR_RootConstrainSelectedInstOperands,
     /* 147362 */   // GIR_Coverage, 4056,
     /* 147362 */   GIR_EraseRootFromParent_Done,
     /* 147363 */ // Label 2000: @147363
     /* 147363 */ GIM_Try, /*On fail goto*//*Label 2001*/ GIMT_Encode4(147502), // Rule ID 4088 //
     /* 147368 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 147371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 147374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 147378 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147382 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 147386 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 147390 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 147394 */   // MIs[1] Operand 1
     /* 147394 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 147399 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147401 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 147401 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 147404 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 147408 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147413 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 147417 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 147421 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 147423 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 147426 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 147430 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147435 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 147438 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 147440 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 147443 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 147447 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147452 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 147455 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 147457 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 147460 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 147464 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147469 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 147476 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 147481 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 147486 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 147489 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147491 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147494 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 147497 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 147500 */   GIR_RootConstrainSelectedInstOperands,
     /* 147501 */   // GIR_Coverage, 4088,
     /* 147501 */   GIR_EraseRootFromParent_Done,
     /* 147502 */ // Label 2001: @147502
     /* 147502 */ GIM_Try, /*On fail goto*//*Label 2002*/ GIMT_Encode4(147641), // Rule ID 4120 //
     /* 147507 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 147510 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 147513 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 147517 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147521 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 147525 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 147529 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 147533 */   // MIs[1] Operand 1
     /* 147533 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 147538 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147540 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 147540 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 147543 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 147547 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147552 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 147556 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 147560 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 147562 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 147565 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 147569 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147574 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 147577 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 147579 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 147582 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 147586 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147591 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 147594 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 147596 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 147599 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 147603 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147608 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 147615 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 147620 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 147625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 147628 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147630 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147633 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 147636 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 147639 */   GIR_RootConstrainSelectedInstOperands,
     /* 147640 */   // GIR_Coverage, 4120,
     /* 147640 */   GIR_EraseRootFromParent_Done,
     /* 147641 */ // Label 2002: @147641
     /* 147641 */ GIM_Try, /*On fail goto*//*Label 2003*/ GIMT_Encode4(147780), // Rule ID 4136 //
     /* 147646 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 147649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 147652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 147656 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147660 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 147664 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 147668 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 147672 */   // MIs[1] Operand 1
     /* 147672 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 147677 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147679 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 147679 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 147682 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 147686 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147691 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 147695 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 147699 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 147701 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 147704 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 147708 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147713 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 147716 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 147718 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 147721 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 147725 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147730 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 147733 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 147735 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 147738 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 147742 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147747 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 147754 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 147759 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 147764 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 147767 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147769 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147772 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 147775 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 147778 */   GIR_RootConstrainSelectedInstOperands,
     /* 147779 */   // GIR_Coverage, 4136,
     /* 147779 */   GIR_EraseRootFromParent_Done,
     /* 147780 */ // Label 2003: @147780
     /* 147780 */ GIM_Try, /*On fail goto*//*Label 2004*/ GIMT_Encode4(147919), // Rule ID 4168 //
     /* 147785 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 147788 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 147791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 147795 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147799 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 147803 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 147807 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 147811 */   // MIs[1] Operand 1
     /* 147811 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 147816 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147818 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 147818 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 147821 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 147825 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147830 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 147834 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 147838 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 147840 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 147843 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 147847 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147852 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 147855 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 147857 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 147860 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 147864 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147869 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 147872 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 147874 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 147877 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 147881 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147886 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 147893 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 147898 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 147903 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 147906 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147908 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147911 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 147914 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 147917 */   GIR_RootConstrainSelectedInstOperands,
     /* 147918 */   // GIR_Coverage, 4168,
     /* 147918 */   GIR_EraseRootFromParent_Done,
     /* 147919 */ // Label 2004: @147919
     /* 147919 */ GIM_Try, /*On fail goto*//*Label 2005*/ GIMT_Encode4(148058), // Rule ID 4200 //
     /* 147924 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 147927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 147930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 147934 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147938 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 147942 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 147946 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 147950 */   // MIs[1] Operand 1
     /* 147950 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 147955 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147957 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 147957 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 147960 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 147964 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147969 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 147973 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 147977 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 147979 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 147982 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 147986 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147991 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 147994 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 147996 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 147999 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148003 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148008 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 148011 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148013 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 148016 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148020 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148025 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 148032 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 148037 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 148042 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 148045 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148047 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148050 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 148053 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 148056 */   GIR_RootConstrainSelectedInstOperands,
     /* 148057 */   // GIR_Coverage, 4200,
     /* 148057 */   GIR_EraseRootFromParent_Done,
     /* 148058 */ // Label 2005: @148058
     /* 148058 */ GIM_Try, /*On fail goto*//*Label 2006*/ GIMT_Encode4(148197), // Rule ID 4232 //
     /* 148063 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 148066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 148069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 148073 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148077 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 148081 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 148085 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 148089 */   // MIs[1] Operand 1
     /* 148089 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 148094 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148096 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 148096 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 148099 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 148103 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148108 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 148112 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 148116 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148118 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 148121 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148125 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148130 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 148133 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 148135 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 148138 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148142 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148147 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 148150 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148152 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 148155 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148159 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148164 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 148171 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 148176 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 148181 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 148184 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148186 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148189 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 148192 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 148195 */   GIR_RootConstrainSelectedInstOperands,
     /* 148196 */   // GIR_Coverage, 4232,
     /* 148196 */   GIR_EraseRootFromParent_Done,
     /* 148197 */ // Label 2006: @148197
     /* 148197 */ GIM_Try, /*On fail goto*//*Label 2007*/ GIMT_Encode4(148336), // Rule ID 4262 //
     /* 148202 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 148205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 148208 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 148212 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148216 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 148220 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 148224 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 148228 */   // MIs[1] Operand 1
     /* 148228 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 148233 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148235 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 148235 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 148238 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 148242 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148247 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 148251 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 148255 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148257 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 148260 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148264 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148269 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 148272 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 148274 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 148277 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148281 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148286 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 148289 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148291 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 148294 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148298 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148303 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 148310 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 148315 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 148320 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 148323 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148325 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148328 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 148331 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 148334 */   GIR_RootConstrainSelectedInstOperands,
     /* 148335 */   // GIR_Coverage, 4262,
     /* 148335 */   GIR_EraseRootFromParent_Done,
     /* 148336 */ // Label 2007: @148336
     /* 148336 */ GIM_Try, /*On fail goto*//*Label 2008*/ GIMT_Encode4(148475), // Rule ID 4294 //
     /* 148341 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 148344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 148347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 148351 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148355 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 148359 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 148363 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 148367 */   // MIs[1] Operand 1
     /* 148367 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 148372 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148374 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 148374 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 148377 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 148381 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148386 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 148390 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 148394 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148396 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 148399 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148403 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148408 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 148411 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 148413 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 148416 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148420 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148425 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 148428 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148430 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 148433 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148437 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148442 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 148449 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 148454 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 148459 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 148462 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148464 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148467 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 148470 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 148473 */   GIR_RootConstrainSelectedInstOperands,
     /* 148474 */   // GIR_Coverage, 4294,
     /* 148474 */   GIR_EraseRootFromParent_Done,
     /* 148475 */ // Label 2008: @148475
     /* 148475 */ GIM_Try, /*On fail goto*//*Label 2009*/ GIMT_Encode4(148614), // Rule ID 4326 //
     /* 148480 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 148483 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 148486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 148490 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148494 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 148498 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 148502 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 148506 */   // MIs[1] Operand 1
     /* 148506 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 148511 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148513 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 148513 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 148516 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 148520 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148525 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 148529 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 148533 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148535 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 148538 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148542 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148547 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 148550 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 148552 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 148555 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148559 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148564 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 148567 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148569 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 148572 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148576 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148581 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 148588 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 148593 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 148598 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 148601 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148603 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148606 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 148609 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 148612 */   GIR_RootConstrainSelectedInstOperands,
     /* 148613 */   // GIR_Coverage, 4326,
     /* 148613 */   GIR_EraseRootFromParent_Done,
     /* 148614 */ // Label 2009: @148614
     /* 148614 */ GIM_Try, /*On fail goto*//*Label 2010*/ GIMT_Encode4(148753), // Rule ID 4358 //
     /* 148619 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 148622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 148625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 148629 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148633 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 148637 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 148641 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 148645 */   // MIs[1] Operand 1
     /* 148645 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 148650 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148652 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 148652 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 148655 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 148659 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148664 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 148668 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 148672 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148674 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 148677 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148681 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148686 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 148689 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 148691 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 148694 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148698 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148703 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 148706 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148708 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 148711 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148715 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148720 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 148727 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 148732 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 148737 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 148740 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148742 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148745 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 148748 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 148751 */   GIR_RootConstrainSelectedInstOperands,
     /* 148752 */   // GIR_Coverage, 4358,
     /* 148752 */   GIR_EraseRootFromParent_Done,
     /* 148753 */ // Label 2010: @148753
     /* 148753 */ GIM_Try, /*On fail goto*//*Label 2011*/ GIMT_Encode4(148892), // Rule ID 4589 //
     /* 148758 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 148761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 148764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 148768 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148772 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 148776 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 148780 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 148784 */   // MIs[1] Operand 1
     /* 148784 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 148789 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148791 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPLT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 148791 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 148794 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPLT),
     /* 148798 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148803 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 148807 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 148811 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148813 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 148816 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148820 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148825 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 148828 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 148830 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 148833 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148837 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148842 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 148845 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148847 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 148850 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148854 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148859 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 148866 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 148871 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 148876 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 148879 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148881 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148884 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 148887 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 148890 */   GIR_RootConstrainSelectedInstOperands,
     /* 148891 */   // GIR_Coverage, 4589,
     /* 148891 */   GIR_EraseRootFromParent_Done,
     /* 148892 */ // Label 2011: @148892
     /* 148892 */ GIM_Try, /*On fail goto*//*Label 2012*/ GIMT_Encode4(149031), // Rule ID 4621 //
     /* 148897 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 148900 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 148903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 148907 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148911 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 148915 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 148919 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 148923 */   // MIs[1] Operand 1
     /* 148923 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 148928 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148930 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPGT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 148930 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 148933 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPGT),
     /* 148937 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148942 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 148946 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 148950 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148952 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 148955 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148959 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148964 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 148967 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 148969 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 148972 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148976 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148981 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 148984 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148986 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 148989 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148993 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148998 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 149005 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 149010 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 149015 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 149018 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149020 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149023 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 149026 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 149029 */   GIR_RootConstrainSelectedInstOperands,
     /* 149030 */   // GIR_Coverage, 4621,
     /* 149030 */   GIR_EraseRootFromParent_Done,
     /* 149031 */ // Label 2012: @149031
     /* 149031 */ GIM_Try, /*On fail goto*//*Label 2013*/ GIMT_Encode4(149170), // Rule ID 4653 //
     /* 149036 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 149039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 149042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 149046 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149050 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 149054 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 149058 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 149062 */   // MIs[1] Operand 1
     /* 149062 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 149067 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149069 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPEQ:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 149069 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 149072 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPEQ),
     /* 149076 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149081 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 149085 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 149089 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149091 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 149094 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 149098 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149103 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 149106 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 149108 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 149111 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 149115 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149120 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 149123 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 149125 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 149128 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149132 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149137 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 149144 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 149149 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 149154 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 149157 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149159 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149162 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 149165 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 149168 */   GIR_RootConstrainSelectedInstOperands,
     /* 149169 */   // GIR_Coverage, 4653,
     /* 149169 */   GIR_EraseRootFromParent_Done,
     /* 149170 */ // Label 2013: @149170
     /* 149170 */ GIM_Try, /*On fail goto*//*Label 2014*/ GIMT_Encode4(149309), // Rule ID 4697 //
     /* 149175 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 149178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 149181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 149185 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149189 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 149193 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 149197 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 149201 */   // MIs[1] Operand 1
     /* 149201 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 149206 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149208 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPLT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 149208 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 149211 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPLT),
     /* 149215 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149220 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 149224 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 149228 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149230 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 149233 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 149237 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149242 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 149245 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 149247 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 149250 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 149254 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149259 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 149262 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 149264 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 149267 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149271 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149276 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 149283 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 149288 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 149293 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 149296 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149298 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149301 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 149304 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 149307 */   GIR_RootConstrainSelectedInstOperands,
     /* 149308 */   // GIR_Coverage, 4697,
     /* 149308 */   GIR_EraseRootFromParent_Done,
     /* 149309 */ // Label 2014: @149309
     /* 149309 */ GIM_Try, /*On fail goto*//*Label 2015*/ GIMT_Encode4(149448), // Rule ID 4729 //
     /* 149314 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 149317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 149320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 149324 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149328 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 149332 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 149336 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 149340 */   // MIs[1] Operand 1
     /* 149340 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 149345 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149347 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPGT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 149347 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 149350 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPGT),
     /* 149354 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149359 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 149363 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 149367 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149369 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 149372 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 149376 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149381 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 149384 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 149386 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 149389 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 149393 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149398 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 149401 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 149403 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 149406 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149410 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149415 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 149422 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 149427 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 149432 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 149435 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149437 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149440 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 149443 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 149446 */   GIR_RootConstrainSelectedInstOperands,
     /* 149447 */   // GIR_Coverage, 4729,
     /* 149447 */   GIR_EraseRootFromParent_Done,
     /* 149448 */ // Label 2015: @149448
     /* 149448 */ GIM_Try, /*On fail goto*//*Label 2016*/ GIMT_Encode4(149587), // Rule ID 4761 //
     /* 149453 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 149456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 149459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 149463 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149467 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 149471 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 149475 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 149479 */   // MIs[1] Operand 1
     /* 149479 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 149484 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149486 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPEQ:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 149486 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 149489 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPEQ),
     /* 149493 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149498 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 149502 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 149506 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149508 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 149511 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 149515 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149520 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 149523 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 149525 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 149528 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 149532 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149537 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 149540 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 149542 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 149545 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149549 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149554 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 149561 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 149566 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 149571 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 149574 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149576 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149579 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 149582 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 149585 */   GIR_RootConstrainSelectedInstOperands,
     /* 149586 */   // GIR_Coverage, 4761,
     /* 149586 */   GIR_EraseRootFromParent_Done,
     /* 149587 */ // Label 2016: @149587
     /* 149587 */ GIM_Try, /*On fail goto*//*Label 2017*/ GIMT_Encode4(149686), // Rule ID 2983 //
     /* 149592 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 149595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 149598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 149602 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149606 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 149610 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 149614 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 149618 */   // MIs[1] Operand 1
     /* 149618 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 149623 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149625 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 149625 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 149628 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 149632 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149637 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 149641 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 149645 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149647 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 149650 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149654 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149659 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 149666 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 149671 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 149676 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 149679 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 149681 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149684 */   GIR_RootConstrainSelectedInstOperands,
     /* 149685 */   // GIR_Coverage, 2983,
     /* 149685 */   GIR_EraseRootFromParent_Done,
     /* 149686 */ // Label 2017: @149686
     /* 149686 */ GIM_Try, /*On fail goto*//*Label 2018*/ GIMT_Encode4(149785), // Rule ID 2997 //
     /* 149691 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 149694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 149697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 149701 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149705 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 149709 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 149713 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 149717 */   // MIs[1] Operand 1
     /* 149717 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 149722 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149724 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 149724 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 149727 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 149731 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149736 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 149740 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 149744 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149746 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 149749 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149753 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149758 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 149765 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 149770 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 149775 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 149778 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 149780 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149783 */   GIR_RootConstrainSelectedInstOperands,
     /* 149784 */   // GIR_Coverage, 2997,
     /* 149784 */   GIR_EraseRootFromParent_Done,
     /* 149785 */ // Label 2018: @149785
     /* 149785 */ GIM_Try, /*On fail goto*//*Label 2019*/ GIMT_Encode4(149884), // Rule ID 3005 //
     /* 149790 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 149793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 149796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 149800 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149804 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 149808 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 149812 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 149816 */   // MIs[1] Operand 1
     /* 149816 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 149821 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149823 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 149823 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 149826 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 149830 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149835 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 149839 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 149843 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149845 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 149848 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149852 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149857 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 149864 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 149869 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 149874 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 149877 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 149879 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149882 */   GIR_RootConstrainSelectedInstOperands,
     /* 149883 */   // GIR_Coverage, 3005,
     /* 149883 */   GIR_EraseRootFromParent_Done,
     /* 149884 */ // Label 2019: @149884
     /* 149884 */ GIM_Try, /*On fail goto*//*Label 2020*/ GIMT_Encode4(149983), // Rule ID 3013 //
     /* 149889 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 149892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 149895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 149899 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149903 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 149907 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 149911 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 149915 */   // MIs[1] Operand 1
     /* 149915 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 149920 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149922 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 149922 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 149925 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 149929 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149934 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 149938 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 149942 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149944 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 149947 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149951 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149956 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 149963 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 149968 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 149973 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 149976 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 149978 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149981 */   GIR_RootConstrainSelectedInstOperands,
     /* 149982 */   // GIR_Coverage, 3013,
     /* 149982 */   GIR_EraseRootFromParent_Done,
     /* 149983 */ // Label 2020: @149983
     /* 149983 */ GIM_Try, /*On fail goto*//*Label 2021*/ GIMT_Encode4(150082), // Rule ID 3021 //
     /* 149988 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 149991 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 149994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 149998 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150002 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 150006 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 150010 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 150014 */   // MIs[1] Operand 1
     /* 150014 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 150019 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150021 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }))
     /* 150021 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 150024 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 150028 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150033 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 150037 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 150041 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150043 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 150046 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150050 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150055 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 150062 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 150067 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 150072 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 150075 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 150077 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150080 */   GIR_RootConstrainSelectedInstOperands,
     /* 150081 */   // GIR_Coverage, 3021,
     /* 150081 */   GIR_EraseRootFromParent_Done,
     /* 150082 */ // Label 2021: @150082
     /* 150082 */ GIM_Try, /*On fail goto*//*Label 2022*/ GIMT_Encode4(150181), // Rule ID 3085 //
     /* 150087 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 150090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 150093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 150097 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150101 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 150105 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 150109 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 150113 */   // MIs[1] Operand 1
     /* 150113 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 150118 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150120 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 150120 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 150123 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 150127 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150132 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 150136 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 150140 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150142 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 150145 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150149 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150154 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 150161 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 150166 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 150171 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 150174 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 150176 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150179 */   GIR_RootConstrainSelectedInstOperands,
     /* 150180 */   // GIR_Coverage, 3085,
     /* 150180 */   GIR_EraseRootFromParent_Done,
     /* 150181 */ // Label 2022: @150181
     /* 150181 */ GIM_Try, /*On fail goto*//*Label 2023*/ GIMT_Encode4(150280), // Rule ID 3093 //
     /* 150186 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 150189 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 150192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 150196 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150200 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 150204 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 150208 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 150212 */   // MIs[1] Operand 1
     /* 150212 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 150217 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150219 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 150219 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 150222 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 150226 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150231 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 150235 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 150239 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150241 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 150244 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150248 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150253 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 150260 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 150265 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 150270 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 150273 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 150275 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150278 */   GIR_RootConstrainSelectedInstOperands,
     /* 150279 */   // GIR_Coverage, 3093,
     /* 150279 */   GIR_EraseRootFromParent_Done,
     /* 150280 */ // Label 2023: @150280
     /* 150280 */ GIM_Try, /*On fail goto*//*Label 2024*/ GIMT_Encode4(150379), // Rule ID 3101 //
     /* 150285 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 150288 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 150291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 150295 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150299 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 150303 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 150307 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 150311 */   // MIs[1] Operand 1
     /* 150311 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 150316 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150318 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 150318 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 150321 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 150325 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150330 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 150334 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 150338 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150340 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 150343 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150347 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150352 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 150359 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 150364 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 150369 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 150372 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 150374 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150377 */   GIR_RootConstrainSelectedInstOperands,
     /* 150378 */   // GIR_Coverage, 3101,
     /* 150378 */   GIR_EraseRootFromParent_Done,
     /* 150379 */ // Label 2024: @150379
     /* 150379 */ GIM_Try, /*On fail goto*//*Label 2025*/ GIMT_Encode4(150478), // Rule ID 3109 //
     /* 150384 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 150387 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 150390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 150394 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150398 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 150402 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 150406 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 150410 */   // MIs[1] Operand 1
     /* 150410 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 150415 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150417 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 150417 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 150420 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 150424 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150429 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 150433 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 150437 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150439 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 150442 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150446 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150451 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 150458 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 150463 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 150468 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 150471 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 150473 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150476 */   GIR_RootConstrainSelectedInstOperands,
     /* 150477 */   // GIR_Coverage, 3109,
     /* 150477 */   GIR_EraseRootFromParent_Done,
     /* 150478 */ // Label 2025: @150478
     /* 150478 */ GIM_Try, /*On fail goto*//*Label 2026*/ GIMT_Encode4(150577), // Rule ID 3117 //
     /* 150483 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 150486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 150489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 150493 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150497 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 150501 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 150505 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 150509 */   // MIs[1] Operand 1
     /* 150509 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 150514 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150516 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }))
     /* 150516 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 150519 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 150523 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150528 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 150532 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 150536 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150538 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 150541 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150545 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150550 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 150557 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 150562 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 150567 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 150570 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 150572 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150575 */   GIR_RootConstrainSelectedInstOperands,
     /* 150576 */   // GIR_Coverage, 3117,
     /* 150576 */   GIR_EraseRootFromParent_Done,
     /* 150577 */ // Label 2026: @150577
     /* 150577 */ GIM_Try, /*On fail goto*//*Label 2027*/ GIMT_Encode4(150716), // Rule ID 3869 //
     /* 150582 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 150585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 150588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 150592 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150596 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 150600 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 150604 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 150608 */   // MIs[1] Operand 1
     /* 150608 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 150613 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150615 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 150615 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 150618 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 150622 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150627 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 150631 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 150635 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150637 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 150640 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 150644 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150649 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 150652 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 150654 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 150657 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 150661 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150666 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 150669 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 150671 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 150674 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150678 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150683 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 150690 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 150695 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 150700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 150703 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150705 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150708 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 150711 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 150714 */   GIR_RootConstrainSelectedInstOperands,
     /* 150715 */   // GIR_Coverage, 3869,
     /* 150715 */   GIR_EraseRootFromParent_Done,
     /* 150716 */ // Label 2027: @150716
     /* 150716 */ GIM_Try, /*On fail goto*//*Label 2028*/ GIMT_Encode4(150855), // Rule ID 3877 //
     /* 150721 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 150724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 150727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 150731 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150735 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 150739 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 150743 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 150747 */   // MIs[1] Operand 1
     /* 150747 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 150752 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150754 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 150754 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 150757 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 150761 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150766 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 150770 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 150774 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150776 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 150779 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 150783 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150788 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 150791 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 150793 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 150796 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 150800 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150805 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 150808 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 150810 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 150813 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150817 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150822 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 150829 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 150834 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 150839 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 150842 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150844 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150847 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 150850 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 150853 */   GIR_RootConstrainSelectedInstOperands,
     /* 150854 */   // GIR_Coverage, 3877,
     /* 150854 */   GIR_EraseRootFromParent_Done,
     /* 150855 */ // Label 2028: @150855
     /* 150855 */ GIM_Try, /*On fail goto*//*Label 2029*/ GIMT_Encode4(150994), // Rule ID 3885 //
     /* 150860 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 150863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 150866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 150870 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150874 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 150878 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 150882 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 150886 */   // MIs[1] Operand 1
     /* 150886 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 150891 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150893 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 150893 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 150896 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 150900 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150905 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 150909 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 150913 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150915 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 150918 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 150922 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150927 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 150930 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 150932 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 150935 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 150939 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150944 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 150947 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 150949 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 150952 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150956 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150961 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 150968 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 150973 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 150978 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 150981 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150983 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150986 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 150989 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 150992 */   GIR_RootConstrainSelectedInstOperands,
     /* 150993 */   // GIR_Coverage, 3885,
     /* 150993 */   GIR_EraseRootFromParent_Done,
     /* 150994 */ // Label 2029: @150994
     /* 150994 */ GIM_Try, /*On fail goto*//*Label 2030*/ GIMT_Encode4(151133), // Rule ID 3893 //
     /* 150999 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 151002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 151005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 151009 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 151013 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 151017 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 151021 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 151025 */   // MIs[1] Operand 1
     /* 151025 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 151030 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151032 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 151032 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 151035 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 151039 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151044 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 151048 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 151052 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 151054 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 151057 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 151061 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151066 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 151069 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 151071 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 151074 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 151078 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151083 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 151086 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 151088 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 151091 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151095 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151100 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 151107 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 151112 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 151117 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 151120 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151122 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 151125 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 151128 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 151131 */   GIR_RootConstrainSelectedInstOperands,
     /* 151132 */   // GIR_Coverage, 3893,
     /* 151132 */   GIR_EraseRootFromParent_Done,
     /* 151133 */ // Label 2030: @151133
     /* 151133 */ GIM_Try, /*On fail goto*//*Label 2031*/ GIMT_Encode4(151272), // Rule ID 3901 //
     /* 151138 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 151141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 151144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 151148 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 151152 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 151156 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 151160 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 151164 */   // MIs[1] Operand 1
     /* 151164 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 151169 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151171 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 151171 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 151174 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 151178 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151183 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 151187 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 151191 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 151193 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 151196 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 151200 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151205 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 151208 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 151210 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 151213 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 151217 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151222 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 151225 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 151227 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 151230 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151234 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151239 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 151246 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 151251 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 151256 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 151259 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151261 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 151264 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 151267 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 151270 */   GIR_RootConstrainSelectedInstOperands,
     /* 151271 */   // GIR_Coverage, 3901,
     /* 151271 */   GIR_EraseRootFromParent_Done,
     /* 151272 */ // Label 2031: @151272
     /* 151272 */ GIM_Try, /*On fail goto*//*Label 2032*/ GIMT_Encode4(151411), // Rule ID 3965 //
     /* 151277 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 151280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 151283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 151287 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 151291 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 151295 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 151299 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 151303 */   // MIs[1] Operand 1
     /* 151303 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 151308 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151310 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 151310 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 151313 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 151317 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151322 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 151326 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 151330 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 151332 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 151335 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 151339 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151344 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 151347 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 151349 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 151352 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 151356 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151361 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 151364 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 151366 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 151369 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151373 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151378 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 151385 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 151390 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 151395 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 151398 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151400 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 151403 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 151406 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 151409 */   GIR_RootConstrainSelectedInstOperands,
     /* 151410 */   // GIR_Coverage, 3965,
     /* 151410 */   GIR_EraseRootFromParent_Done,
     /* 151411 */ // Label 2032: @151411
     /* 151411 */ GIM_Try, /*On fail goto*//*Label 2033*/ GIMT_Encode4(151550), // Rule ID 3973 //
     /* 151416 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 151419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 151422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 151426 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 151430 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 151434 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 151438 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 151442 */   // MIs[1] Operand 1
     /* 151442 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 151447 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151449 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 151449 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 151452 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 151456 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151461 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 151465 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 151469 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 151471 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 151474 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 151478 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151483 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 151486 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 151488 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 151491 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 151495 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151500 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 151503 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 151505 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 151508 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151512 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151517 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 151524 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 151529 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 151534 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 151537 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151539 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 151542 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 151545 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 151548 */   GIR_RootConstrainSelectedInstOperands,
     /* 151549 */   // GIR_Coverage, 3973,
     /* 151549 */   GIR_EraseRootFromParent_Done,
     /* 151550 */ // Label 2033: @151550
     /* 151550 */ GIM_Try, /*On fail goto*//*Label 2034*/ GIMT_Encode4(151689), // Rule ID 3981 //
     /* 151555 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 151558 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 151561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 151565 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 151569 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 151573 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 151577 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 151581 */   // MIs[1] Operand 1
     /* 151581 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 151586 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151588 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 151588 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 151591 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 151595 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151600 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 151604 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 151608 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 151610 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 151613 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 151617 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151622 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 151625 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 151627 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 151630 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 151634 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151639 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 151642 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 151644 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 151647 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151651 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151656 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 151663 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 151668 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 151673 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 151676 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151678 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 151681 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 151684 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 151687 */   GIR_RootConstrainSelectedInstOperands,
     /* 151688 */   // GIR_Coverage, 3981,
     /* 151688 */   GIR_EraseRootFromParent_Done,
     /* 151689 */ // Label 2034: @151689
     /* 151689 */ GIM_Try, /*On fail goto*//*Label 2035*/ GIMT_Encode4(151828), // Rule ID 3989 //
     /* 151694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 151697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 151700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 151704 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 151708 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 151712 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 151716 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 151720 */   // MIs[1] Operand 1
     /* 151720 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 151725 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151727 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 151727 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 151730 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 151734 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151739 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 151743 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 151747 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 151749 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 151752 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 151756 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151761 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 151764 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 151766 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 151769 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 151773 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151778 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 151781 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 151783 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 151786 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151790 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151795 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 151802 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 151807 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 151812 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 151815 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151817 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 151820 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 151823 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 151826 */   GIR_RootConstrainSelectedInstOperands,
     /* 151827 */   // GIR_Coverage, 3989,
     /* 151827 */   GIR_EraseRootFromParent_Done,
     /* 151828 */ // Label 2035: @151828
     /* 151828 */ GIM_Try, /*On fail goto*//*Label 2036*/ GIMT_Encode4(151967), // Rule ID 3997 //
     /* 151833 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 151836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 151839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 151843 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 151847 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 151851 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 151855 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 151859 */   // MIs[1] Operand 1
     /* 151859 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 151864 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151866 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 151866 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 151869 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 151873 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151878 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 151882 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 151886 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 151888 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 151891 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 151895 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151900 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 151903 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 151905 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 151908 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 151912 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151917 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 151920 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 151922 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 151925 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151929 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151934 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 151941 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 151946 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 151951 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 151954 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151956 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 151959 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 151962 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 151965 */   GIR_RootConstrainSelectedInstOperands,
     /* 151966 */   // GIR_Coverage, 3997,
     /* 151966 */   GIR_EraseRootFromParent_Done,
     /* 151967 */ // Label 2036: @151967
     /* 151967 */ GIM_Try, /*On fail goto*//*Label 2037*/ GIMT_Encode4(151989), // Rule ID 2989 //
     /* 151972 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 151975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 151978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 151982 */   // (zext:{ *:[i64] } i1:{ *:[i1] }:$in)  =>  (SETBC8:{ *:[i64] } ?:{ *:[i1] }:$in)
     /* 151982 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SETBC8),
     /* 151987 */   GIR_RootConstrainSelectedInstOperands,
     /* 151988 */   // GIR_Coverage, 2989,
     /* 151988 */   GIR_Done,
     /* 151989 */ // Label 2037: @151989
     /* 151989 */ GIM_Try, /*On fail goto*//*Label 2038*/ GIMT_Encode4(152050), // Rule ID 3675 //
     /* 151994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 151997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 152001 */   // (zext:{ *:[i64] } i1:{ *:[i1] }:$in)  =>  (SELECT_I8:{ *:[i64] } ?:{ *:[i1] }:$in, (LI8:{ *:[i64] } 1:{ *:[i64] }), (LI8:{ *:[i64] } 0:{ *:[i64] }))
     /* 152001 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 152004 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 152008 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152013 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 152016 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 152018 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 152021 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 152025 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152030 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 152033 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 152035 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 152038 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152040 */   GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 152042 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152045 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 152048 */   GIR_RootConstrainSelectedInstOperands,
     /* 152049 */   // GIR_Coverage, 3675,
     /* 152049 */   GIR_EraseRootFromParent_Done,
     /* 152050 */ // Label 2038: @152050
     /* 152050 */ GIM_Reject,
     /* 152051 */ // Label 1852: @152051
     /* 152051 */ GIM_Reject,
     /* 152052 */ // Label 27: @152052
     /* 152052 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 2046*/ GIMT_Encode4(152407),
     /* 152063 */ /*GILLT_s32*//*Label 2039*/ GIMT_Encode4(152091),
     /* 152067 */ /*GILLT_s64*//*Label 2040*/ GIMT_Encode4(152114),
     /* 152071 */ /*GILLT_s128*//*Label 2041*/ GIMT_Encode4(152137),
     /* 152075 */ /*GILLT_v2s64*//*Label 2042*/ GIMT_Encode4(152303),
     /* 152079 */ /*GILLT_v4s32*//*Label 2043*/ GIMT_Encode4(152329),
     /* 152083 */ /*GILLT_v8s16*//*Label 2044*/ GIMT_Encode4(152355),
     /* 152087 */ /*GILLT_v16s8*//*Label 2045*/ GIMT_Encode4(152381),
     /* 152091 */ // Label 2039: @152091
     /* 152091 */ GIM_Try, /*On fail goto*//*Label 2047*/ GIMT_Encode4(152113), // Rule ID 1257 //
     /* 152096 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 152099 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 152102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 152106 */   // (shl:{ *:[i32] } i32:{ *:[i32] }:$rS, i32:{ *:[i32] }:$rB)  =>  (SLW:{ *:[i32] } ?:{ *:[i32] }:$rS, ?:{ *:[i32] }:$rB)
     /* 152106 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SLW),
     /* 152111 */   GIR_RootConstrainSelectedInstOperands,
     /* 152112 */   // GIR_Coverage, 1257,
     /* 152112 */   GIR_Done,
     /* 152113 */ // Label 2047: @152113
     /* 152113 */ GIM_Reject,
     /* 152114 */ // Label 2040: @152114
     /* 152114 */ GIM_Try, /*On fail goto*//*Label 2048*/ GIMT_Encode4(152136), // Rule ID 1538 //
     /* 152119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 152122 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 152125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 152129 */   // (shl:{ *:[i64] } i64:{ *:[i64] }:$rS, i32:{ *:[i32] }:$rB)  =>  (SLD:{ *:[i64] } ?:{ *:[i64] }:$rS, ?:{ *:[i32] }:$rB)
     /* 152129 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SLD),
     /* 152134 */   GIR_RootConstrainSelectedInstOperands,
     /* 152135 */   // GIR_Coverage, 1538,
     /* 152135 */   GIR_Done,
     /* 152136 */ // Label 2048: @152136
     /* 152136 */ GIM_Reject,
     /* 152137 */ // Label 2041: @152137
     /* 152137 */ GIM_Try, /*On fail goto*//*Label 2049*/ GIMT_Encode4(152302),
     /* 152142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 152145 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 152148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 152152 */   GIM_Try, /*On fail goto*//*Label 2050*/ GIMT_Encode4(152237), // Rule ID 3376 //
     /* 152157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX_IsISA3_1),
     /* 152160 */     // (shl:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VRA, v1i128:{ *:[v1i128] }:$VRB)  =>  (VSLQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VRA, (XXPERMDI:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v1i128] }:$VRB, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v1i128] }:$VRB, VSRC:{ *:[i32] }), 2:{ *:[i32] }))
     /* 152160 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 152163 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152167 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152172 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // VRB
     /* 152176 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 152181 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 152184 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152188 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152193 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // VRB
     /* 152197 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 152202 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 152205 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXPERMDI),
     /* 152209 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152214 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 152217 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 152220 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /* 152223 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 152225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSLQ),
     /* 152228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 152230 */     GIR_RootToRootCopy, /*OpIdx*/1, // VRA
     /* 152232 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152235 */     GIR_RootConstrainSelectedInstOperands,
     /* 152236 */     // GIR_Coverage, 3376,
     /* 152236 */     GIR_EraseRootFromParent_Done,
     /* 152237 */   // Label 2050: @152237
     /* 152237 */   GIM_Try, /*On fail goto*//*Label 2051*/ GIMT_Encode4(152301), // Rule ID 1396 //
     /* 152242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 152245 */     // (shl:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$vA, v1i128:{ *:[v1i128] }:$vB)  =>  (VSL:{ *:[v1i128] } (VSLO:{ *:[v16i8] } ?:{ *:[v1i128] }:$vA, ?:{ *:[v1i128] }:$vB), (VSPLTB:{ *:[v16i8] } 15:{ *:[i32] }, ?:{ *:[v1i128] }:$vB))
     /* 152245 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 152248 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::VSPLTB),
     /* 152252 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152257 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/15,
     /* 152260 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // vB
     /* 152264 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 152266 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 152269 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::VSLO),
     /* 152273 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152278 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vA
     /* 152282 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vB
     /* 152286 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 152288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSL),
     /* 152291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 152293 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152296 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 152299 */     GIR_RootConstrainSelectedInstOperands,
     /* 152300 */     // GIR_Coverage, 1396,
     /* 152300 */     GIR_EraseRootFromParent_Done,
     /* 152301 */   // Label 2051: @152301
     /* 152301 */   GIM_Reject,
     /* 152302 */ // Label 2049: @152302
     /* 152302 */ GIM_Reject,
     /* 152303 */ // Label 2042: @152303
     /* 152303 */ GIM_Try, /*On fail goto*//*Label 2052*/ GIMT_Encode4(152328), // Rule ID 1444 //
     /* 152308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 152311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 152314 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 152317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 152321 */   // (shl:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$vA, v2i64:{ *:[v2i64] }:$vB)  =>  (VSLD:{ *:[v2i64] } ?:{ *:[v2i64] }:$vA, ?:{ *:[v2i64] }:$vB)
     /* 152321 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSLD),
     /* 152326 */   GIR_RootConstrainSelectedInstOperands,
     /* 152327 */   // GIR_Coverage, 1444,
     /* 152327 */   GIR_Done,
     /* 152328 */ // Label 2052: @152328
     /* 152328 */ GIM_Reject,
     /* 152329 */ // Label 2043: @152329
     /* 152329 */ GIM_Try, /*On fail goto*//*Label 2053*/ GIMT_Encode4(152354), // Rule ID 1395 //
     /* 152334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 152337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 152340 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 152343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 152347 */   // (shl:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)  =>  (VSLW:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB)
     /* 152347 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSLW),
     /* 152352 */   GIR_RootConstrainSelectedInstOperands,
     /* 152353 */   // GIR_Coverage, 1395,
     /* 152353 */   GIR_Done,
     /* 152354 */ // Label 2053: @152354
     /* 152354 */ GIM_Reject,
     /* 152355 */ // Label 2044: @152355
     /* 152355 */ GIM_Try, /*On fail goto*//*Label 2054*/ GIMT_Encode4(152380), // Rule ID 1394 //
     /* 152360 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 152363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152366 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 152369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 152373 */   // (shl:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB)  =>  (VSLH:{ *:[v8i16] } ?:{ *:[v8i16] }:$vA, ?:{ *:[v8i16] }:$vB)
     /* 152373 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSLH),
     /* 152378 */   GIR_RootConstrainSelectedInstOperands,
     /* 152379 */   // GIR_Coverage, 1394,
     /* 152379 */   GIR_Done,
     /* 152380 */ // Label 2054: @152380
     /* 152380 */ GIM_Reject,
     /* 152381 */ // Label 2045: @152381
     /* 152381 */ GIM_Try, /*On fail goto*//*Label 2055*/ GIMT_Encode4(152406), // Rule ID 1393 //
     /* 152386 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 152389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 152392 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 152395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 152399 */   // (shl:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB)  =>  (VSLB:{ *:[v16i8] } ?:{ *:[v16i8] }:$vA, ?:{ *:[v16i8] }:$vB)
     /* 152399 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSLB),
     /* 152404 */   GIR_RootConstrainSelectedInstOperands,
     /* 152405 */   // GIR_Coverage, 1393,
     /* 152405 */   GIR_Done,
     /* 152406 */ // Label 2055: @152406
     /* 152406 */ GIM_Reject,
     /* 152407 */ // Label 2046: @152407
     /* 152407 */ GIM_Reject,
     /* 152408 */ // Label 28: @152408
     /* 152408 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 2063*/ GIMT_Encode4(152829),
     /* 152419 */ /*GILLT_s32*//*Label 2056*/ GIMT_Encode4(152447),
     /* 152423 */ /*GILLT_s64*//*Label 2057*/ GIMT_Encode4(152536),
     /* 152427 */ /*GILLT_s128*//*Label 2058*/ GIMT_Encode4(152559),
     /* 152431 */ /*GILLT_v2s64*//*Label 2059*/ GIMT_Encode4(152725),
     /* 152435 */ /*GILLT_v4s32*//*Label 2060*/ GIMT_Encode4(152751),
     /* 152439 */ /*GILLT_v8s16*//*Label 2061*/ GIMT_Encode4(152777),
     /* 152443 */ /*GILLT_v16s8*//*Label 2062*/ GIMT_Encode4(152803),
     /* 152447 */ // Label 2056: @152447
     /* 152447 */ GIM_Try, /*On fail goto*//*Label 2064*/ GIMT_Encode4(152535),
     /* 152452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 152455 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 152458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 152462 */   GIM_Try, /*On fail goto*//*Label 2065*/ GIMT_Encode4(152522), // Rule ID 3356 //
     /* 152467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 152470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 152474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 152478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 152482 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 152486 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152488 */     // (srl:{ *:[i32] } (bswap:{ *:[i32] } i32:{ *:[i32] }:$RS), 16:{ *:[i32] })  =>  (RLDICL_32:{ *:[i32] } (BRH:{ *:[i32] } ?:{ *:[i32] }:$RS), 0:{ *:[i32] }, 48:{ *:[i32] })
     /* 152488 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 152491 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::BRH),
     /* 152495 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152500 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // RS
     /* 152504 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 152506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL_32),
     /* 152509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 152511 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 152520 */     GIR_RootConstrainSelectedInstOperands,
     /* 152521 */     // GIR_Coverage, 3356,
     /* 152521 */     GIR_EraseRootFromParent_Done,
     /* 152522 */   // Label 2065: @152522
     /* 152522 */   GIM_Try, /*On fail goto*//*Label 2066*/ GIMT_Encode4(152534), // Rule ID 1256 //
     /* 152527 */     // (srl:{ *:[i32] } i32:{ *:[i32] }:$rS, i32:{ *:[i32] }:$rB)  =>  (SRW:{ *:[i32] } ?:{ *:[i32] }:$rS, ?:{ *:[i32] }:$rB)
     /* 152527 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SRW),
     /* 152532 */     GIR_RootConstrainSelectedInstOperands,
     /* 152533 */     // GIR_Coverage, 1256,
     /* 152533 */     GIR_Done,
     /* 152534 */   // Label 2066: @152534
     /* 152534 */   GIM_Reject,
     /* 152535 */ // Label 2064: @152535
     /* 152535 */ GIM_Reject,
     /* 152536 */ // Label 2057: @152536
     /* 152536 */ GIM_Try, /*On fail goto*//*Label 2067*/ GIMT_Encode4(152558), // Rule ID 1537 //
     /* 152541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 152544 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 152547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 152551 */   // (srl:{ *:[i64] } i64:{ *:[i64] }:$rS, i32:{ *:[i32] }:$rB)  =>  (SRD:{ *:[i64] } ?:{ *:[i64] }:$rS, ?:{ *:[i32] }:$rB)
     /* 152551 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SRD),
     /* 152556 */   GIR_RootConstrainSelectedInstOperands,
     /* 152557 */   // GIR_Coverage, 1537,
     /* 152557 */   GIR_Done,
     /* 152558 */ // Label 2067: @152558
     /* 152558 */ GIM_Reject,
     /* 152559 */ // Label 2058: @152559
     /* 152559 */ GIM_Try, /*On fail goto*//*Label 2068*/ GIMT_Encode4(152724),
     /* 152564 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 152567 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 152570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 152574 */   GIM_Try, /*On fail goto*//*Label 2069*/ GIMT_Encode4(152659), // Rule ID 3378 //
     /* 152579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX_IsISA3_1),
     /* 152582 */     // (srl:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VRA, v1i128:{ *:[v1i128] }:$VRB)  =>  (VSRQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VRA, (XXPERMDI:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v1i128] }:$VRB, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v1i128] }:$VRB, VSRC:{ *:[i32] }), 2:{ *:[i32] }))
     /* 152582 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 152585 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152589 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152594 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // VRB
     /* 152598 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 152603 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 152606 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152610 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152615 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // VRB
     /* 152619 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 152624 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 152627 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXPERMDI),
     /* 152631 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152636 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 152639 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 152642 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /* 152645 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 152647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSRQ),
     /* 152650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 152652 */     GIR_RootToRootCopy, /*OpIdx*/1, // VRA
     /* 152654 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152657 */     GIR_RootConstrainSelectedInstOperands,
     /* 152658 */     // GIR_Coverage, 3378,
     /* 152658 */     GIR_EraseRootFromParent_Done,
     /* 152659 */   // Label 2069: @152659
     /* 152659 */   GIM_Try, /*On fail goto*//*Label 2070*/ GIMT_Encode4(152723), // Rule ID 1404 //
     /* 152664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 152667 */     // (srl:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$vA, v1i128:{ *:[v1i128] }:$vB)  =>  (VSR:{ *:[v1i128] } (VSRO:{ *:[v16i8] } ?:{ *:[v1i128] }:$vA, ?:{ *:[v1i128] }:$vB), (VSPLTB:{ *:[v16i8] } 15:{ *:[i32] }, ?:{ *:[v1i128] }:$vB))
     /* 152667 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 152670 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::VSPLTB),
     /* 152674 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152679 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/15,
     /* 152682 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // vB
     /* 152686 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 152688 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 152691 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::VSRO),
     /* 152695 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152700 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vA
     /* 152704 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vB
     /* 152708 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 152710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSR),
     /* 152713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 152715 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152718 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 152721 */     GIR_RootConstrainSelectedInstOperands,
     /* 152722 */     // GIR_Coverage, 1404,
     /* 152722 */     GIR_EraseRootFromParent_Done,
     /* 152723 */   // Label 2070: @152723
     /* 152723 */   GIM_Reject,
     /* 152724 */ // Label 2068: @152724
     /* 152724 */ GIM_Reject,
     /* 152725 */ // Label 2059: @152725
     /* 152725 */ GIM_Try, /*On fail goto*//*Label 2071*/ GIMT_Encode4(152750), // Rule ID 1446 //
     /* 152730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 152733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 152736 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 152739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 152743 */   // (srl:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$vA, v2i64:{ *:[v2i64] }:$vB)  =>  (VSRD:{ *:[v2i64] } ?:{ *:[v2i64] }:$vA, ?:{ *:[v2i64] }:$vB)
     /* 152743 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSRD),
     /* 152748 */   GIR_RootConstrainSelectedInstOperands,
     /* 152749 */   // GIR_Coverage, 1446,
     /* 152749 */   GIR_Done,
     /* 152750 */ // Label 2071: @152750
     /* 152750 */ GIM_Reject,
     /* 152751 */ // Label 2060: @152751
     /* 152751 */ GIM_Try, /*On fail goto*//*Label 2072*/ GIMT_Encode4(152776), // Rule ID 1403 //
     /* 152756 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 152759 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 152762 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 152765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 152769 */   // (srl:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)  =>  (VSRW:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB)
     /* 152769 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSRW),
     /* 152774 */   GIR_RootConstrainSelectedInstOperands,
     /* 152775 */   // GIR_Coverage, 1403,
     /* 152775 */   GIR_Done,
     /* 152776 */ // Label 2072: @152776
     /* 152776 */ GIM_Reject,
     /* 152777 */ // Label 2061: @152777
     /* 152777 */ GIM_Try, /*On fail goto*//*Label 2073*/ GIMT_Encode4(152802), // Rule ID 1402 //
     /* 152782 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 152785 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152788 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 152791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 152795 */   // (srl:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB)  =>  (VSRH:{ *:[v8i16] } ?:{ *:[v8i16] }:$vA, ?:{ *:[v8i16] }:$vB)
     /* 152795 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSRH),
     /* 152800 */   GIR_RootConstrainSelectedInstOperands,
     /* 152801 */   // GIR_Coverage, 1402,
     /* 152801 */   GIR_Done,
     /* 152802 */ // Label 2073: @152802
     /* 152802 */ GIM_Reject,
     /* 152803 */ // Label 2062: @152803
     /* 152803 */ GIM_Try, /*On fail goto*//*Label 2074*/ GIMT_Encode4(152828), // Rule ID 1401 //
     /* 152808 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 152811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 152814 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 152817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 152821 */   // (srl:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB)  =>  (VSRB:{ *:[v16i8] } ?:{ *:[v16i8] }:$vA, ?:{ *:[v16i8] }:$vB)
     /* 152821 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSRB),
     /* 152826 */   GIR_RootConstrainSelectedInstOperands,
     /* 152827 */   // GIR_Coverage, 1401,
     /* 152827 */   GIR_Done,
     /* 152828 */ // Label 2074: @152828
     /* 152828 */ GIM_Reject,
     /* 152829 */ // Label 2063: @152829
     /* 152829 */ GIM_Reject,
     /* 152830 */ // Label 29: @152830
     /* 152830 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 2082*/ GIMT_Encode4(153199),
     /* 152841 */ /*GILLT_s32*//*Label 2075*/ GIMT_Encode4(152869),
     /* 152845 */ /*GILLT_s64*//*Label 2076*/ GIMT_Encode4(152934),
     /* 152849 */ /*GILLT_s128*//*Label 2077*/ GIMT_Encode4(152999),
     /* 152853 */ /*GILLT_v2s64*//*Label 2078*/ GIMT_Encode4(153095),
     /* 152857 */ /*GILLT_v4s32*//*Label 2079*/ GIMT_Encode4(153121),
     /* 152861 */ /*GILLT_v8s16*//*Label 2080*/ GIMT_Encode4(153147),
     /* 152865 */ /*GILLT_v16s8*//*Label 2081*/ GIMT_Encode4(153173),
     /* 152869 */ // Label 2075: @152869
     /* 152869 */ GIM_Try, /*On fail goto*//*Label 2083*/ GIMT_Encode4(152933),
     /* 152874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 152877 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 152880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 152884 */   GIM_Try, /*On fail goto*//*Label 2084*/ GIMT_Encode4(152914), // Rule ID 132 //
     /* 152889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 152897 */     // MIs[1] Operand 1
     /* 152897 */     // No operand predicates
     /* 152897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152899 */     // (sra:{ *:[i32] } i32:{ *:[i32] }:$RST, (imm:{ *:[i32] }):$RB)  =>  (SRAWI:{ *:[i32] }:{ *:[i32] } i32:{ *:[i32] }:$RST, (imm:{ *:[i32] }):$RB)
     /* 152899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SRAWI),
     /* 152902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 152904 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /* 152906 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // RB
     /* 152909 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CARRY*/0,
     /* 152912 */     GIR_RootConstrainSelectedInstOperands,
     /* 152913 */     // GIR_Coverage, 132,
     /* 152913 */     GIR_EraseRootFromParent_Done,
     /* 152914 */   // Label 2084: @152914
     /* 152914 */   GIM_Try, /*On fail goto*//*Label 2085*/ GIMT_Encode4(152932), // Rule ID 1255 //
     /* 152919 */     // (sra:{ *:[i32] } i32:{ *:[i32] }:$rS, i32:{ *:[i32] }:$rB)  =>  (SRAW:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$rS, ?:{ *:[i32] }:$rB)
     /* 152919 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SRAW),
     /* 152924 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(PPC::CARRY), GIMT_Encode2(RegState::Dead),
     /* 152930 */     GIR_RootConstrainSelectedInstOperands,
     /* 152931 */     // GIR_Coverage, 1255,
     /* 152931 */     GIR_Done,
     /* 152932 */   // Label 2085: @152932
     /* 152932 */   GIM_Reject,
     /* 152933 */ // Label 2083: @152933
     /* 152933 */ GIM_Reject,
     /* 152934 */ // Label 2076: @152934
     /* 152934 */ GIM_Try, /*On fail goto*//*Label 2086*/ GIMT_Encode4(152998),
     /* 152939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 152942 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 152945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 152949 */   GIM_Try, /*On fail goto*//*Label 2087*/ GIMT_Encode4(152979), // Rule ID 685 //
     /* 152954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 152962 */     // MIs[1] Operand 1
     /* 152962 */     // No operand predicates
     /* 152962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152964 */     // (sra:{ *:[i64] } i64:{ *:[i64] }:$RS, (imm:{ *:[i32] }):$SH)  =>  (SRADI:{ *:[i64] }:{ *:[i32] } i64:{ *:[i64] }:$RS, (imm:{ *:[i32] }):$SH)
     /* 152964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SRADI),
     /* 152967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 152969 */     GIR_RootToRootCopy, /*OpIdx*/1, // RS
     /* 152971 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SH
     /* 152974 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CARRY*/0,
     /* 152977 */     GIR_RootConstrainSelectedInstOperands,
     /* 152978 */     // GIR_Coverage, 685,
     /* 152978 */     GIR_EraseRootFromParent_Done,
     /* 152979 */   // Label 2087: @152979
     /* 152979 */   GIM_Try, /*On fail goto*//*Label 2088*/ GIMT_Encode4(152997), // Rule ID 1536 //
     /* 152984 */     // (sra:{ *:[i64] } i64:{ *:[i64] }:$rS, i32:{ *:[i32] }:$rB)  =>  (SRAD:{ *:[i64] }:{ *:[i32] } ?:{ *:[i64] }:$rS, ?:{ *:[i32] }:$rB)
     /* 152984 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SRAD),
     /* 152989 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(PPC::CARRY), GIMT_Encode2(RegState::Dead),
     /* 152995 */     GIR_RootConstrainSelectedInstOperands,
     /* 152996 */     // GIR_Coverage, 1536,
     /* 152996 */     GIR_Done,
     /* 152997 */   // Label 2088: @152997
     /* 152997 */   GIM_Reject,
     /* 152998 */ // Label 2086: @152998
     /* 152998 */ GIM_Reject,
     /* 152999 */ // Label 2077: @152999
     /* 152999 */ GIM_Try, /*On fail goto*//*Label 2089*/ GIMT_Encode4(153094), // Rule ID 3380 //
     /* 153004 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX_IsISA3_1),
     /* 153007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 153010 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 153013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 153017 */   // (sra:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VRA, v1i128:{ *:[v1i128] }:$VRB)  =>  (VSRAQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VRA, (XXPERMDI:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v1i128] }:$VRB, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v1i128] }:$VRB, VSRC:{ *:[i32] }), 2:{ *:[i32] }))
     /* 153017 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 153020 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153024 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153029 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // VRB
     /* 153033 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 153038 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 153041 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153045 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153050 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // VRB
     /* 153054 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 153059 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 153062 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXPERMDI),
     /* 153066 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153071 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 153074 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 153077 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /* 153080 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 153082 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSRAQ),
     /* 153085 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 153087 */   GIR_RootToRootCopy, /*OpIdx*/1, // VRA
     /* 153089 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 153092 */   GIR_RootConstrainSelectedInstOperands,
     /* 153093 */   // GIR_Coverage, 3380,
     /* 153093 */   GIR_EraseRootFromParent_Done,
     /* 153094 */ // Label 2089: @153094
     /* 153094 */ GIM_Reject,
     /* 153095 */ // Label 2078: @153095
     /* 153095 */ GIM_Try, /*On fail goto*//*Label 2090*/ GIMT_Encode4(153120), // Rule ID 1448 //
     /* 153100 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 153103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 153106 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 153109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 153113 */   // (sra:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$vA, v2i64:{ *:[v2i64] }:$vB)  =>  (VSRAD:{ *:[v2i64] } ?:{ *:[v2i64] }:$vA, ?:{ *:[v2i64] }:$vB)
     /* 153113 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSRAD),
     /* 153118 */   GIR_RootConstrainSelectedInstOperands,
     /* 153119 */   // GIR_Coverage, 1448,
     /* 153119 */   GIR_Done,
     /* 153120 */ // Label 2090: @153120
     /* 153120 */ GIM_Reject,
     /* 153121 */ // Label 2079: @153121
     /* 153121 */ GIM_Try, /*On fail goto*//*Label 2091*/ GIMT_Encode4(153146), // Rule ID 1411 //
     /* 153126 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 153129 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153132 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 153135 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 153139 */   // (sra:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)  =>  (VSRAW:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB)
     /* 153139 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSRAW),
     /* 153144 */   GIR_RootConstrainSelectedInstOperands,
     /* 153145 */   // GIR_Coverage, 1411,
     /* 153145 */   GIR_Done,
     /* 153146 */ // Label 2091: @153146
     /* 153146 */ GIM_Reject,
     /* 153147 */ // Label 2080: @153147
     /* 153147 */ GIM_Try, /*On fail goto*//*Label 2092*/ GIMT_Encode4(153172), // Rule ID 1410 //
     /* 153152 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 153155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153158 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 153161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 153165 */   // (sra:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB)  =>  (VSRAH:{ *:[v8i16] } ?:{ *:[v8i16] }:$vA, ?:{ *:[v8i16] }:$vB)
     /* 153165 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSRAH),
     /* 153170 */   GIR_RootConstrainSelectedInstOperands,
     /* 153171 */   // GIR_Coverage, 1410,
     /* 153171 */   GIR_Done,
     /* 153172 */ // Label 2092: @153172
     /* 153172 */ GIM_Reject,
     /* 153173 */ // Label 2081: @153173
     /* 153173 */ GIM_Try, /*On fail goto*//*Label 2093*/ GIMT_Encode4(153198), // Rule ID 1409 //
     /* 153178 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 153181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 153184 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 153187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 153191 */   // (sra:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB)  =>  (VSRAB:{ *:[v16i8] } ?:{ *:[v16i8] }:$vA, ?:{ *:[v16i8] }:$vB)
     /* 153191 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSRAB),
     /* 153196 */   GIR_RootConstrainSelectedInstOperands,
     /* 153197 */   // GIR_Coverage, 1409,
     /* 153197 */   GIR_Done,
     /* 153198 */ // Label 2093: @153198
     /* 153198 */ GIM_Reject,
     /* 153199 */ // Label 2082: @153199
     /* 153199 */ GIM_Reject,
     /* 153200 */ // Label 30: @153200
     /* 153200 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 2101*/ GIMT_Encode4(153507),
     /* 153211 */ /*GILLT_s32*//*Label 2094*/ GIMT_Encode4(153239),
     /* 153215 */ /*GILLT_s64*//*Label 2095*/ GIMT_Encode4(153311),
     /* 153219 */ /*GILLT_s128*//*Label 2096*/ GIMT_Encode4(153377),
     /* 153223 */ /*GILLT_v2s64*//*Label 2097*/ GIMT_Encode4(153403),
     /* 153227 */ /*GILLT_v4s32*//*Label 2098*/ GIMT_Encode4(153429),
     /* 153231 */ /*GILLT_v8s16*//*Label 2099*/ GIMT_Encode4(153455),
     /* 153235 */ /*GILLT_v16s8*//*Label 2100*/ GIMT_Encode4(153481),
     /* 153239 */ // Label 2094: @153239
     /* 153239 */ GIM_Try, /*On fail goto*//*Label 2102*/ GIMT_Encode4(153310),
     /* 153244 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 153247 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 153250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 153254 */   GIM_Try, /*On fail goto*//*Label 2103*/ GIMT_Encode4(153287), // Rule ID 1221 //
     /* 153259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153267 */     // MIs[1] Operand 1
     /* 153267 */     // No operand predicates
     /* 153267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153269 */     // (rotl:{ *:[i32] } i32:{ *:[i32] }:$in, (imm:{ *:[i32] }):$imm)  =>  (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$in, (imm:{ *:[i32] }):$imm, 0:{ *:[i32] }, 31:{ *:[i32] })
     /* 153269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 153272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 153274 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 153276 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 153279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 153285 */     GIR_RootConstrainSelectedInstOperands,
     /* 153286 */     // GIR_Coverage, 1221,
     /* 153286 */     GIR_EraseRootFromParent_Done,
     /* 153287 */   // Label 2103: @153287
     /* 153287 */   GIM_Try, /*On fail goto*//*Label 2104*/ GIMT_Encode4(153309), // Rule ID 1220 //
     /* 153292 */     // (rotl:{ *:[i32] } i32:{ *:[i32] }:$in, i32:{ *:[i32] }:$sh)  =>  (RLWNM:{ *:[i32] } ?:{ *:[i32] }:$in, ?:{ *:[i32] }:$sh, 0:{ *:[i32] }, 31:{ *:[i32] })
     /* 153292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 153295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 153297 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 153299 */     GIR_RootToRootCopy, /*OpIdx*/2, // sh
     /* 153301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 153307 */     GIR_RootConstrainSelectedInstOperands,
     /* 153308 */     // GIR_Coverage, 1220,
     /* 153308 */     GIR_EraseRootFromParent_Done,
     /* 153309 */   // Label 2104: @153309
     /* 153309 */   GIM_Reject,
     /* 153310 */ // Label 2102: @153310
     /* 153310 */ GIM_Reject,
     /* 153311 */ // Label 2095: @153311
     /* 153311 */ GIM_Try, /*On fail goto*//*Label 2105*/ GIMT_Encode4(153376),
     /* 153316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 153319 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 153322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 153326 */   GIM_Try, /*On fail goto*//*Label 2106*/ GIMT_Encode4(153356), // Rule ID 1543 //
     /* 153331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153339 */     // MIs[1] Operand 1
     /* 153339 */     // No operand predicates
     /* 153339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153341 */     // (rotl:{ *:[i64] } i64:{ *:[i64] }:$in, (imm:{ *:[i32] }):$imm)  =>  (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$in, (imm:{ *:[i32] }):$imm, 0:{ *:[i32] })
     /* 153341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 153344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 153346 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 153348 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 153351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153354 */     GIR_RootConstrainSelectedInstOperands,
     /* 153355 */     // GIR_Coverage, 1543,
     /* 153355 */     GIR_EraseRootFromParent_Done,
     /* 153356 */   // Label 2106: @153356
     /* 153356 */   GIM_Try, /*On fail goto*//*Label 2107*/ GIMT_Encode4(153375), // Rule ID 1542 //
     /* 153361 */     // (rotl:{ *:[i64] } i64:{ *:[i64] }:$in, i32:{ *:[i32] }:$sh)  =>  (RLDCL:{ *:[i64] } ?:{ *:[i64] }:$in, ?:{ *:[i32] }:$sh, 0:{ *:[i32] })
     /* 153361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 153364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 153366 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 153368 */     GIR_RootToRootCopy, /*OpIdx*/2, // sh
     /* 153370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153373 */     GIR_RootConstrainSelectedInstOperands,
     /* 153374 */     // GIR_Coverage, 1542,
     /* 153374 */     GIR_EraseRootFromParent_Done,
     /* 153375 */   // Label 2107: @153375
     /* 153375 */   GIM_Reject,
     /* 153376 */ // Label 2105: @153376
     /* 153376 */ GIM_Reject,
     /* 153377 */ // Label 2096: @153377
     /* 153377 */ GIM_Try, /*On fail goto*//*Label 2108*/ GIMT_Encode4(153402), // Rule ID 3362 //
     /* 153382 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 153385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 153388 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 153391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 153395 */   // (rotl:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$vA, v1i128:{ *:[v1i128] }:$vB)  =>  (VRLQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$vA, v1i128:{ *:[v1i128] }:$vB)
     /* 153395 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VRLQ),
     /* 153400 */   GIR_RootConstrainSelectedInstOperands,
     /* 153401 */   // GIR_Coverage, 3362,
     /* 153401 */   GIR_Done,
     /* 153402 */ // Label 2108: @153402
     /* 153402 */ GIM_Reject,
     /* 153403 */ // Label 2097: @153403
     /* 153403 */ GIM_Try, /*On fail goto*//*Label 2109*/ GIMT_Encode4(153428), // Rule ID 1443 //
     /* 153408 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 153411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 153414 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 153417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 153421 */   // (rotl:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$vA, v2i64:{ *:[v2i64] }:$vB)  =>  (VRLD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$vA, v2i64:{ *:[v2i64] }:$vB)
     /* 153421 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VRLD),
     /* 153426 */   GIR_RootConstrainSelectedInstOperands,
     /* 153427 */   // GIR_Coverage, 1443,
     /* 153427 */   GIR_Done,
     /* 153428 */ // Label 2109: @153428
     /* 153428 */ GIM_Reject,
     /* 153429 */ // Label 2098: @153429
     /* 153429 */ GIM_Try, /*On fail goto*//*Label 2110*/ GIMT_Encode4(153454), // Rule ID 1294 //
     /* 153434 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 153437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153440 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 153443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 153447 */   // (rotl:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)  =>  (VRLW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)
     /* 153447 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VRLW),
     /* 153452 */   GIR_RootConstrainSelectedInstOperands,
     /* 153453 */   // GIR_Coverage, 1294,
     /* 153453 */   GIR_Done,
     /* 153454 */ // Label 2110: @153454
     /* 153454 */ GIM_Reject,
     /* 153455 */ // Label 2099: @153455
     /* 153455 */ GIM_Try, /*On fail goto*//*Label 2111*/ GIMT_Encode4(153480), // Rule ID 1293 //
     /* 153460 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 153463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153466 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 153469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 153473 */   // (rotl:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB)  =>  (VRLH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB)
     /* 153473 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VRLH),
     /* 153478 */   GIR_RootConstrainSelectedInstOperands,
     /* 153479 */   // GIR_Coverage, 1293,
     /* 153479 */   GIR_Done,
     /* 153480 */ // Label 2111: @153480
     /* 153480 */ GIM_Reject,
     /* 153481 */ // Label 2100: @153481
     /* 153481 */ GIM_Try, /*On fail goto*//*Label 2112*/ GIMT_Encode4(153506), // Rule ID 1292 //
     /* 153486 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 153489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 153492 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 153495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 153499 */   // (rotl:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB)  =>  (VRLB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB)
     /* 153499 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VRLB),
     /* 153504 */   GIR_RootConstrainSelectedInstOperands,
     /* 153505 */   // GIR_Coverage, 1292,
     /* 153505 */   GIR_Done,
     /* 153506 */ // Label 2112: @153506
     /* 153506 */ GIM_Reject,
     /* 153507 */ // Label 2101: @153507
     /* 153507 */ GIM_Reject,
     /* 153508 */ // Label 31: @153508
     /* 153508 */ GIM_Try, /*On fail goto*//*Label 2113*/ GIMT_Encode4(157509),
     /* 153513 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 153516 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2116*/ GIMT_Encode4(154085),
     /* 153527 */   /*GILLT_s32*//*Label 2114*/ GIMT_Encode4(153535),
     /* 153531 */   /*GILLT_s64*//*Label 2115*/ GIMT_Encode4(153810),
     /* 153535 */   // Label 2114: @153535
     /* 153535 */   GIM_Try, /*On fail goto*//*Label 2117*/ GIMT_Encode4(153809),
     /* 153540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 153543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 153547 */     GIM_Try, /*On fail goto*//*Label 2118*/ GIMT_Encode4(153634), // Rule ID 3034 //
     /* 153552 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 153555 */       // MIs[0] Operand 1
     /* 153555 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 153560 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153564 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153568 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 153572 */       // MIs[1] Operand 1
     /* 153572 */       // No operand predicates
     /* 153572 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153574 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }))
     /* 153574 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 153577 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 153581 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153586 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 153590 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 153593 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 153595 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 153598 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153602 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153607 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 153614 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 153619 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 153624 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 153627 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 153629 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 153632 */       GIR_RootConstrainSelectedInstOperands,
     /* 153633 */       // GIR_Coverage, 3034,
     /* 153633 */       GIR_EraseRootFromParent_Done,
     /* 153634 */     // Label 2118: @153634
     /* 153634 */     GIM_Try, /*On fail goto*//*Label 2119*/ GIMT_Encode4(153721), // Rule ID 3050 //
     /* 153639 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 153642 */       // MIs[0] Operand 1
     /* 153642 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 153647 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153651 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153655 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 153659 */       // MIs[1] Operand 1
     /* 153659 */       // No operand predicates
     /* 153659 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153661 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }))
     /* 153661 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 153664 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 153668 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153673 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 153677 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 153680 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 153682 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 153685 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153689 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153694 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 153701 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 153706 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 153711 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 153714 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 153716 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 153719 */       GIR_RootConstrainSelectedInstOperands,
     /* 153720 */       // GIR_Coverage, 3050,
     /* 153720 */       GIR_EraseRootFromParent_Done,
     /* 153721 */     // Label 2119: @153721
     /* 153721 */     GIM_Try, /*On fail goto*//*Label 2120*/ GIMT_Encode4(153808), // Rule ID 3058 //
     /* 153726 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 153729 */       // MIs[0] Operand 1
     /* 153729 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 153734 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153738 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153742 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 153746 */       // MIs[1] Operand 1
     /* 153746 */       // No operand predicates
     /* 153746 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153748 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }))
     /* 153748 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 153751 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 153755 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153760 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 153764 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 153767 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 153769 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 153772 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153776 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153781 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 153788 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 153793 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 153798 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 153801 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 153803 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 153806 */       GIR_RootConstrainSelectedInstOperands,
     /* 153807 */       // GIR_Coverage, 3058,
     /* 153807 */       GIR_EraseRootFromParent_Done,
     /* 153808 */     // Label 2120: @153808
     /* 153808 */     GIM_Reject,
     /* 153809 */   // Label 2117: @153809
     /* 153809 */   GIM_Reject,
     /* 153810 */   // Label 2115: @153810
     /* 153810 */   GIM_Try, /*On fail goto*//*Label 2121*/ GIMT_Encode4(154084),
     /* 153815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 153818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 153822 */     GIM_Try, /*On fail goto*//*Label 2122*/ GIMT_Encode4(153909), // Rule ID 3130 //
     /* 153827 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 153830 */       // MIs[0] Operand 1
     /* 153830 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 153835 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153839 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153843 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 153847 */       // MIs[1] Operand 1
     /* 153847 */       // No operand predicates
     /* 153847 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153849 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }))
     /* 153849 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 153852 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 153856 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153861 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 153865 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 153868 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 153870 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 153873 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153877 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153882 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 153889 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 153894 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 153899 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 153902 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 153904 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 153907 */       GIR_RootConstrainSelectedInstOperands,
     /* 153908 */       // GIR_Coverage, 3130,
     /* 153908 */       GIR_EraseRootFromParent_Done,
     /* 153909 */     // Label 2122: @153909
     /* 153909 */     GIM_Try, /*On fail goto*//*Label 2123*/ GIMT_Encode4(153996), // Rule ID 3146 //
     /* 153914 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 153917 */       // MIs[0] Operand 1
     /* 153917 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 153922 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153926 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153930 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 153934 */       // MIs[1] Operand 1
     /* 153934 */       // No operand predicates
     /* 153934 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153936 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }))
     /* 153936 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 153939 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 153943 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153948 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 153952 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 153955 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 153957 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 153960 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153964 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153969 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 153976 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 153981 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 153986 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 153989 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 153991 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 153994 */       GIR_RootConstrainSelectedInstOperands,
     /* 153995 */       // GIR_Coverage, 3146,
     /* 153995 */       GIR_EraseRootFromParent_Done,
     /* 153996 */     // Label 2123: @153996
     /* 153996 */     GIM_Try, /*On fail goto*//*Label 2124*/ GIMT_Encode4(154083), // Rule ID 3154 //
     /* 154001 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 154004 */       // MIs[0] Operand 1
     /* 154004 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 154009 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154013 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154017 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 154021 */       // MIs[1] Operand 1
     /* 154021 */       // No operand predicates
     /* 154021 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154023 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }))
     /* 154023 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 154026 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 154030 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154035 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 154039 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 154042 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 154044 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 154047 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154051 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154056 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 154063 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154068 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 154073 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 154076 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 154078 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 154081 */       GIR_RootConstrainSelectedInstOperands,
     /* 154082 */       // GIR_Coverage, 3154,
     /* 154082 */       GIR_EraseRootFromParent_Done,
     /* 154083 */     // Label 2124: @154083
     /* 154083 */     GIM_Reject,
     /* 154084 */   // Label 2121: @154084
     /* 154084 */   GIM_Reject,
     /* 154085 */   // Label 2116: @154085
     /* 154085 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2127*/ GIMT_Encode4(154540),
     /* 154096 */   /*GILLT_s32*//*Label 2125*/ GIMT_Encode4(154104),
     /* 154100 */   /*GILLT_s64*//*Label 2126*/ GIMT_Encode4(154322),
     /* 154104 */   // Label 2125: @154104
     /* 154104 */   GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(154321),
     /* 154109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 154112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154116 */     GIM_Try, /*On fail goto*//*Label 2129*/ GIMT_Encode4(154184), // Rule ID 3794 //
     /* 154121 */       // MIs[0] Operand 1
     /* 154121 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 154126 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154130 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154134 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 154138 */       // MIs[1] Operand 1
     /* 154138 */       // No operand predicates
     /* 154138 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154140 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] })
     /* 154140 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 154143 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 154147 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154152 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 154156 */       GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 154159 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 154161 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154164 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154166 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 154173 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154178 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 154183 */       // GIR_Coverage, 3794,
     /* 154183 */       GIR_EraseRootFromParent_Done,
     /* 154184 */     // Label 2129: @154184
     /* 154184 */     GIM_Try, /*On fail goto*//*Label 2130*/ GIMT_Encode4(154252), // Rule ID 3796 //
     /* 154189 */       // MIs[0] Operand 1
     /* 154189 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 154194 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154198 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154202 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 154206 */       // MIs[1] Operand 1
     /* 154206 */       // No operand predicates
     /* 154206 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154208 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] })
     /* 154208 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 154211 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 154215 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154220 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 154224 */       GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 154227 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 154229 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154232 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154234 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 154241 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154246 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 154251 */       // GIR_Coverage, 3796,
     /* 154251 */       GIR_EraseRootFromParent_Done,
     /* 154252 */     // Label 2130: @154252
     /* 154252 */     GIM_Try, /*On fail goto*//*Label 2131*/ GIMT_Encode4(154320), // Rule ID 3797 //
     /* 154257 */       // MIs[0] Operand 1
     /* 154257 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 154262 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154266 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154270 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 154274 */       // MIs[1] Operand 1
     /* 154274 */       // No operand predicates
     /* 154274 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154276 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETEQ:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] })
     /* 154276 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 154279 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 154283 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154288 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 154292 */       GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 154295 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 154297 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154300 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154302 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 154309 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154314 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 154319 */       // GIR_Coverage, 3797,
     /* 154319 */       GIR_EraseRootFromParent_Done,
     /* 154320 */     // Label 2131: @154320
     /* 154320 */     GIM_Reject,
     /* 154321 */   // Label 2128: @154321
     /* 154321 */   GIM_Reject,
     /* 154322 */   // Label 2126: @154322
     /* 154322 */   GIM_Try, /*On fail goto*//*Label 2132*/ GIMT_Encode4(154539),
     /* 154327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 154330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154334 */     GIM_Try, /*On fail goto*//*Label 2133*/ GIMT_Encode4(154402), // Rule ID 3806 //
     /* 154339 */       // MIs[0] Operand 1
     /* 154339 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 154344 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154348 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154352 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 154356 */       // MIs[1] Operand 1
     /* 154356 */       // No operand predicates
     /* 154356 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154358 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] })
     /* 154358 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 154361 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 154365 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154370 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 154374 */       GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 154377 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 154379 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154382 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154384 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 154391 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154396 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 154401 */       // GIR_Coverage, 3806,
     /* 154401 */       GIR_EraseRootFromParent_Done,
     /* 154402 */     // Label 2133: @154402
     /* 154402 */     GIM_Try, /*On fail goto*//*Label 2134*/ GIMT_Encode4(154470), // Rule ID 3808 //
     /* 154407 */       // MIs[0] Operand 1
     /* 154407 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 154412 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154416 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154420 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 154424 */       // MIs[1] Operand 1
     /* 154424 */       // No operand predicates
     /* 154424 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154426 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] })
     /* 154426 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 154429 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 154433 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154438 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 154442 */       GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 154445 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 154447 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154450 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154452 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 154459 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154464 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 154469 */       // GIR_Coverage, 3808,
     /* 154469 */       GIR_EraseRootFromParent_Done,
     /* 154470 */     // Label 2134: @154470
     /* 154470 */     GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(154538), // Rule ID 3809 //
     /* 154475 */       // MIs[0] Operand 1
     /* 154475 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 154480 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154484 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154488 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 154492 */       // MIs[1] Operand 1
     /* 154492 */       // No operand predicates
     /* 154492 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154494 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETEQ:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] })
     /* 154494 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 154497 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 154501 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154506 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 154510 */       GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 154513 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 154515 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154518 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154520 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 154527 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154532 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 154537 */       // GIR_Coverage, 3809,
     /* 154537 */       GIR_EraseRootFromParent_Done,
     /* 154538 */     // Label 2135: @154538
     /* 154538 */     GIM_Reject,
     /* 154539 */   // Label 2132: @154539
     /* 154539 */   GIM_Reject,
     /* 154540 */   // Label 2127: @154540
     /* 154540 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2138*/ GIMT_Encode4(155109),
     /* 154551 */   /*GILLT_s32*//*Label 2136*/ GIMT_Encode4(154559),
     /* 154555 */   /*GILLT_s64*//*Label 2137*/ GIMT_Encode4(154834),
     /* 154559 */   // Label 2136: @154559
     /* 154559 */   GIM_Try, /*On fail goto*//*Label 2139*/ GIMT_Encode4(154833),
     /* 154564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 154567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154571 */     GIM_Try, /*On fail goto*//*Label 2140*/ GIMT_Encode4(154658), // Rule ID 3817 //
     /* 154576 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 154579 */       // MIs[0] Operand 1
     /* 154579 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 154584 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154588 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154592 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 154596 */       // MIs[1] Operand 1
     /* 154596 */       // No operand predicates
     /* 154596 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154598 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }))
     /* 154598 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 154601 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 154605 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154610 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 154614 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 154617 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 154619 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 154622 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154626 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154631 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 154638 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154643 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 154648 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 154651 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 154653 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 154656 */       GIR_RootConstrainSelectedInstOperands,
     /* 154657 */       // GIR_Coverage, 3817,
     /* 154657 */       GIR_EraseRootFromParent_Done,
     /* 154658 */     // Label 2140: @154658
     /* 154658 */     GIM_Try, /*On fail goto*//*Label 2141*/ GIMT_Encode4(154745), // Rule ID 3833 //
     /* 154663 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 154666 */       // MIs[0] Operand 1
     /* 154666 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 154671 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154675 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154679 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 154683 */       // MIs[1] Operand 1
     /* 154683 */       // No operand predicates
     /* 154683 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154685 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }))
     /* 154685 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 154688 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 154692 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154697 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 154701 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 154704 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 154706 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 154709 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154713 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154718 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 154725 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154730 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 154735 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 154738 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 154740 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 154743 */       GIR_RootConstrainSelectedInstOperands,
     /* 154744 */       // GIR_Coverage, 3833,
     /* 154744 */       GIR_EraseRootFromParent_Done,
     /* 154745 */     // Label 2141: @154745
     /* 154745 */     GIM_Try, /*On fail goto*//*Label 2142*/ GIMT_Encode4(154832), // Rule ID 3841 //
     /* 154750 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 154753 */       // MIs[0] Operand 1
     /* 154753 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 154758 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154762 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154766 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 154770 */       // MIs[1] Operand 1
     /* 154770 */       // No operand predicates
     /* 154770 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154772 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }))
     /* 154772 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 154775 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 154779 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154784 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 154788 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 154791 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 154793 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 154796 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154800 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154805 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 154812 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154817 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 154822 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 154825 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 154827 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 154830 */       GIR_RootConstrainSelectedInstOperands,
     /* 154831 */       // GIR_Coverage, 3841,
     /* 154831 */       GIR_EraseRootFromParent_Done,
     /* 154832 */     // Label 2142: @154832
     /* 154832 */     GIM_Reject,
     /* 154833 */   // Label 2139: @154833
     /* 154833 */   GIM_Reject,
     /* 154834 */   // Label 2137: @154834
     /* 154834 */   GIM_Try, /*On fail goto*//*Label 2143*/ GIMT_Encode4(155108),
     /* 154839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 154842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154846 */     GIM_Try, /*On fail goto*//*Label 2144*/ GIMT_Encode4(154933), // Rule ID 3913 //
     /* 154851 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 154854 */       // MIs[0] Operand 1
     /* 154854 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 154859 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154863 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154867 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 154871 */       // MIs[1] Operand 1
     /* 154871 */       // No operand predicates
     /* 154871 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154873 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }))
     /* 154873 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 154876 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 154880 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154885 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 154889 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 154892 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 154894 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 154897 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154901 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154906 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 154913 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154918 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 154923 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 154926 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 154928 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 154931 */       GIR_RootConstrainSelectedInstOperands,
     /* 154932 */       // GIR_Coverage, 3913,
     /* 154932 */       GIR_EraseRootFromParent_Done,
     /* 154933 */     // Label 2144: @154933
     /* 154933 */     GIM_Try, /*On fail goto*//*Label 2145*/ GIMT_Encode4(155020), // Rule ID 3929 //
     /* 154938 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 154941 */       // MIs[0] Operand 1
     /* 154941 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 154946 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154950 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154954 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 154958 */       // MIs[1] Operand 1
     /* 154958 */       // No operand predicates
     /* 154958 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154960 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }))
     /* 154960 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 154963 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 154967 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154972 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 154976 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 154979 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 154981 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 154984 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154988 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154993 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 155000 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155005 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155010 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 155013 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155015 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155018 */       GIR_RootConstrainSelectedInstOperands,
     /* 155019 */       // GIR_Coverage, 3929,
     /* 155019 */       GIR_EraseRootFromParent_Done,
     /* 155020 */     // Label 2145: @155020
     /* 155020 */     GIM_Try, /*On fail goto*//*Label 2146*/ GIMT_Encode4(155107), // Rule ID 3937 //
     /* 155025 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 155028 */       // MIs[0] Operand 1
     /* 155028 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 155033 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155037 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155041 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 155045 */       // MIs[1] Operand 1
     /* 155045 */       // No operand predicates
     /* 155045 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155047 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }))
     /* 155047 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 155050 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 155054 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155059 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155063 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 155066 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 155068 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 155071 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155075 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155080 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 155087 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155092 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155097 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 155100 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155102 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155105 */       GIR_RootConstrainSelectedInstOperands,
     /* 155106 */       // GIR_Coverage, 3937,
     /* 155106 */       GIR_EraseRootFromParent_Done,
     /* 155107 */     // Label 2146: @155107
     /* 155107 */     GIM_Reject,
     /* 155108 */   // Label 2143: @155108
     /* 155108 */   GIM_Reject,
     /* 155109 */   // Label 2138: @155109
     /* 155109 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 2150*/ GIMT_Encode4(156124),
     /* 155120 */   /*GILLT_s1*//*Label 2147*/ GIMT_Encode4(155132),
     /* 155124 */   /*GILLT_s32*//*Label 2148*/ GIMT_Encode4(155356),
     /* 155128 */   /*GILLT_s64*//*Label 2149*/ GIMT_Encode4(155740),
     /* 155132 */   // Label 2147: @155132
     /* 155132 */   GIM_Try, /*On fail goto*//*Label 2151*/ GIMT_Encode4(155355),
     /* 155137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s1,
     /* 155140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155144 */     GIM_Try, /*On fail goto*//*Label 2152*/ GIMT_Encode4(155165), // Rule ID 3679 //
     /* 155149 */       // MIs[0] Operand 1
     /* 155149 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 155154 */       // (setcc:{ *:[i1] } i1:{ *:[i1] }:$s1, i1:{ *:[i1] }:$s2, SETLT:{ *:[Other] })  =>  (CRANDC:{ *:[i1] } ?:{ *:[i1] }:$s1, ?:{ *:[i1] }:$s2)
     /* 155154 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRANDC),
     /* 155157 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155159 */       GIR_RootToRootCopy, /*OpIdx*/2, // s1
     /* 155161 */       GIR_RootToRootCopy, /*OpIdx*/3, // s2
     /* 155163 */       GIR_RootConstrainSelectedInstOperands,
     /* 155164 */       // GIR_Coverage, 3679,
     /* 155164 */       GIR_EraseRootFromParent_Done,
     /* 155165 */     // Label 2152: @155165
     /* 155165 */     GIM_Try, /*On fail goto*//*Label 2153*/ GIMT_Encode4(155186), // Rule ID 3680 //
     /* 155170 */       // MIs[0] Operand 1
     /* 155170 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 155175 */       // (setcc:{ *:[i1] } i1:{ *:[i1] }:$s1, i1:{ *:[i1] }:$s2, SETULT:{ *:[Other] })  =>  (CRANDC:{ *:[i1] } ?:{ *:[i1] }:$s2, ?:{ *:[i1] }:$s1)
     /* 155175 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRANDC),
     /* 155178 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155180 */       GIR_RootToRootCopy, /*OpIdx*/3, // s2
     /* 155182 */       GIR_RootToRootCopy, /*OpIdx*/2, // s1
     /* 155184 */       GIR_RootConstrainSelectedInstOperands,
     /* 155185 */       // GIR_Coverage, 3680,
     /* 155185 */       GIR_EraseRootFromParent_Done,
     /* 155186 */     // Label 2153: @155186
     /* 155186 */     GIM_Try, /*On fail goto*//*Label 2154*/ GIMT_Encode4(155207), // Rule ID 3681 //
     /* 155191 */       // MIs[0] Operand 1
     /* 155191 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 155196 */       // (setcc:{ *:[i1] } i1:{ *:[i1] }:$s1, i1:{ *:[i1] }:$s2, SETLE:{ *:[Other] })  =>  (CRORC:{ *:[i1] } ?:{ *:[i1] }:$s1, ?:{ *:[i1] }:$s2)
     /* 155196 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRORC),
     /* 155199 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155201 */       GIR_RootToRootCopy, /*OpIdx*/2, // s1
     /* 155203 */       GIR_RootToRootCopy, /*OpIdx*/3, // s2
     /* 155205 */       GIR_RootConstrainSelectedInstOperands,
     /* 155206 */       // GIR_Coverage, 3681,
     /* 155206 */       GIR_EraseRootFromParent_Done,
     /* 155207 */     // Label 2154: @155207
     /* 155207 */     GIM_Try, /*On fail goto*//*Label 2155*/ GIMT_Encode4(155228), // Rule ID 3682 //
     /* 155212 */       // MIs[0] Operand 1
     /* 155212 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 155217 */       // (setcc:{ *:[i1] } i1:{ *:[i1] }:$s1, i1:{ *:[i1] }:$s2, SETULE:{ *:[Other] })  =>  (CRORC:{ *:[i1] } ?:{ *:[i1] }:$s2, ?:{ *:[i1] }:$s1)
     /* 155217 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRORC),
     /* 155220 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155222 */       GIR_RootToRootCopy, /*OpIdx*/3, // s2
     /* 155224 */       GIR_RootToRootCopy, /*OpIdx*/2, // s1
     /* 155226 */       GIR_RootConstrainSelectedInstOperands,
     /* 155227 */       // GIR_Coverage, 3682,
     /* 155227 */       GIR_EraseRootFromParent_Done,
     /* 155228 */     // Label 2155: @155228
     /* 155228 */     GIM_Try, /*On fail goto*//*Label 2156*/ GIMT_Encode4(155249), // Rule ID 3683 //
     /* 155233 */       // MIs[0] Operand 1
     /* 155233 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 155238 */       // (setcc:{ *:[i1] } i1:{ *:[i1] }:$s1, i1:{ *:[i1] }:$s2, SETEQ:{ *:[Other] })  =>  (CREQV:{ *:[i1] } ?:{ *:[i1] }:$s1, ?:{ *:[i1] }:$s2)
     /* 155238 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CREQV),
     /* 155241 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155243 */       GIR_RootToRootCopy, /*OpIdx*/2, // s1
     /* 155245 */       GIR_RootToRootCopy, /*OpIdx*/3, // s2
     /* 155247 */       GIR_RootConstrainSelectedInstOperands,
     /* 155248 */       // GIR_Coverage, 3683,
     /* 155248 */       GIR_EraseRootFromParent_Done,
     /* 155249 */     // Label 2156: @155249
     /* 155249 */     GIM_Try, /*On fail goto*//*Label 2157*/ GIMT_Encode4(155270), // Rule ID 3684 //
     /* 155254 */       // MIs[0] Operand 1
     /* 155254 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 155259 */       // (setcc:{ *:[i1] } i1:{ *:[i1] }:$s1, i1:{ *:[i1] }:$s2, SETGE:{ *:[Other] })  =>  (CRORC:{ *:[i1] } ?:{ *:[i1] }:$s2, ?:{ *:[i1] }:$s1)
     /* 155259 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRORC),
     /* 155262 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155264 */       GIR_RootToRootCopy, /*OpIdx*/3, // s2
     /* 155266 */       GIR_RootToRootCopy, /*OpIdx*/2, // s1
     /* 155268 */       GIR_RootConstrainSelectedInstOperands,
     /* 155269 */       // GIR_Coverage, 3684,
     /* 155269 */       GIR_EraseRootFromParent_Done,
     /* 155270 */     // Label 2157: @155270
     /* 155270 */     GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(155291), // Rule ID 3685 //
     /* 155275 */       // MIs[0] Operand 1
     /* 155275 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 155280 */       // (setcc:{ *:[i1] } i1:{ *:[i1] }:$s1, i1:{ *:[i1] }:$s2, SETUGE:{ *:[Other] })  =>  (CRORC:{ *:[i1] } ?:{ *:[i1] }:$s1, ?:{ *:[i1] }:$s2)
     /* 155280 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRORC),
     /* 155283 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155285 */       GIR_RootToRootCopy, /*OpIdx*/2, // s1
     /* 155287 */       GIR_RootToRootCopy, /*OpIdx*/3, // s2
     /* 155289 */       GIR_RootConstrainSelectedInstOperands,
     /* 155290 */       // GIR_Coverage, 3685,
     /* 155290 */       GIR_EraseRootFromParent_Done,
     /* 155291 */     // Label 2158: @155291
     /* 155291 */     GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(155312), // Rule ID 3686 //
     /* 155296 */       // MIs[0] Operand 1
     /* 155296 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 155301 */       // (setcc:{ *:[i1] } i1:{ *:[i1] }:$s1, i1:{ *:[i1] }:$s2, SETGT:{ *:[Other] })  =>  (CRANDC:{ *:[i1] } ?:{ *:[i1] }:$s2, ?:{ *:[i1] }:$s1)
     /* 155301 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRANDC),
     /* 155304 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155306 */       GIR_RootToRootCopy, /*OpIdx*/3, // s2
     /* 155308 */       GIR_RootToRootCopy, /*OpIdx*/2, // s1
     /* 155310 */       GIR_RootConstrainSelectedInstOperands,
     /* 155311 */       // GIR_Coverage, 3686,
     /* 155311 */       GIR_EraseRootFromParent_Done,
     /* 155312 */     // Label 2159: @155312
     /* 155312 */     GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(155333), // Rule ID 3687 //
     /* 155317 */       // MIs[0] Operand 1
     /* 155317 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 155322 */       // (setcc:{ *:[i1] } i1:{ *:[i1] }:$s1, i1:{ *:[i1] }:$s2, SETUGT:{ *:[Other] })  =>  (CRANDC:{ *:[i1] } ?:{ *:[i1] }:$s1, ?:{ *:[i1] }:$s2)
     /* 155322 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRANDC),
     /* 155325 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155327 */       GIR_RootToRootCopy, /*OpIdx*/2, // s1
     /* 155329 */       GIR_RootToRootCopy, /*OpIdx*/3, // s2
     /* 155331 */       GIR_RootConstrainSelectedInstOperands,
     /* 155332 */       // GIR_Coverage, 3687,
     /* 155332 */       GIR_EraseRootFromParent_Done,
     /* 155333 */     // Label 2160: @155333
     /* 155333 */     GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(155354), // Rule ID 3688 //
     /* 155338 */       // MIs[0] Operand 1
     /* 155338 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 155343 */       // (setcc:{ *:[i1] } i1:{ *:[i1] }:$s1, i1:{ *:[i1] }:$s2, SETNE:{ *:[Other] })  =>  (CRXOR:{ *:[i1] } ?:{ *:[i1] }:$s1, ?:{ *:[i1] }:$s2)
     /* 155343 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRXOR),
     /* 155346 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155348 */       GIR_RootToRootCopy, /*OpIdx*/2, // s1
     /* 155350 */       GIR_RootToRootCopy, /*OpIdx*/3, // s2
     /* 155352 */       GIR_RootConstrainSelectedInstOperands,
     /* 155353 */       // GIR_Coverage, 3688,
     /* 155353 */       GIR_EraseRootFromParent_Done,
     /* 155354 */     // Label 2161: @155354
     /* 155354 */     GIM_Reject,
     /* 155355 */   // Label 2151: @155355
     /* 155355 */   GIM_Reject,
     /* 155356 */   // Label 2148: @155356
     /* 155356 */   GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(155739),
     /* 155361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 155364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155368 */     GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(155442), // Rule ID 2980 //
     /* 155373 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 155376 */       // MIs[0] Operand 1
     /* 155376 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 155381 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 155381 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 155384 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 155388 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155393 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155397 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 155401 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 155403 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 155406 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155410 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155415 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 155422 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155427 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155432 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 155435 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155437 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155440 */       GIR_RootConstrainSelectedInstOperands,
     /* 155441 */       // GIR_Coverage, 2980,
     /* 155441 */       GIR_EraseRootFromParent_Done,
     /* 155442 */     // Label 2163: @155442
     /* 155442 */     GIM_Try, /*On fail goto*//*Label 2164*/ GIMT_Encode4(155516), // Rule ID 2994 //
     /* 155447 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 155450 */       // MIs[0] Operand 1
     /* 155450 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 155455 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 155455 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 155458 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 155462 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155467 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155471 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 155475 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 155477 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 155480 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155484 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155489 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 155496 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155501 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155506 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 155509 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155511 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155514 */       GIR_RootConstrainSelectedInstOperands,
     /* 155515 */       // GIR_Coverage, 2994,
     /* 155515 */       GIR_EraseRootFromParent_Done,
     /* 155516 */     // Label 2164: @155516
     /* 155516 */     GIM_Try, /*On fail goto*//*Label 2165*/ GIMT_Encode4(155590), // Rule ID 3002 //
     /* 155521 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 155524 */       // MIs[0] Operand 1
     /* 155524 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 155529 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 155529 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 155532 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 155536 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155541 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155545 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 155549 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 155551 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 155554 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155558 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155563 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 155570 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155575 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155580 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 155583 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155585 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155588 */       GIR_RootConstrainSelectedInstOperands,
     /* 155589 */       // GIR_Coverage, 3002,
     /* 155589 */       GIR_EraseRootFromParent_Done,
     /* 155590 */     // Label 2165: @155590
     /* 155590 */     GIM_Try, /*On fail goto*//*Label 2166*/ GIMT_Encode4(155664), // Rule ID 3010 //
     /* 155595 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 155598 */       // MIs[0] Operand 1
     /* 155598 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 155603 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 155603 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 155606 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 155610 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155615 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155619 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 155623 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 155625 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 155628 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155632 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155637 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 155644 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155649 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155654 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 155657 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155659 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155662 */       GIR_RootConstrainSelectedInstOperands,
     /* 155663 */       // GIR_Coverage, 3010,
     /* 155663 */       GIR_EraseRootFromParent_Done,
     /* 155664 */     // Label 2166: @155664
     /* 155664 */     GIM_Try, /*On fail goto*//*Label 2167*/ GIMT_Encode4(155738), // Rule ID 3018 //
     /* 155669 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 155672 */       // MIs[0] Operand 1
     /* 155672 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 155677 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }))
     /* 155677 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 155680 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 155684 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155689 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155693 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 155697 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 155699 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 155702 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155706 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155711 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 155718 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155723 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155728 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 155731 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155733 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155736 */       GIR_RootConstrainSelectedInstOperands,
     /* 155737 */       // GIR_Coverage, 3018,
     /* 155737 */       GIR_EraseRootFromParent_Done,
     /* 155738 */     // Label 2167: @155738
     /* 155738 */     GIM_Reject,
     /* 155739 */   // Label 2162: @155739
     /* 155739 */   GIM_Reject,
     /* 155740 */   // Label 2149: @155740
     /* 155740 */   GIM_Try, /*On fail goto*//*Label 2168*/ GIMT_Encode4(156123),
     /* 155745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 155748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155752 */     GIM_Try, /*On fail goto*//*Label 2169*/ GIMT_Encode4(155826), // Rule ID 3082 //
     /* 155757 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 155760 */       // MIs[0] Operand 1
     /* 155760 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 155765 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 155765 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 155768 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 155772 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155777 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155781 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 155785 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 155787 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 155790 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155794 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155799 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 155806 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155811 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155816 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 155819 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155821 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155824 */       GIR_RootConstrainSelectedInstOperands,
     /* 155825 */       // GIR_Coverage, 3082,
     /* 155825 */       GIR_EraseRootFromParent_Done,
     /* 155826 */     // Label 2169: @155826
     /* 155826 */     GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(155900), // Rule ID 3090 //
     /* 155831 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 155834 */       // MIs[0] Operand 1
     /* 155834 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 155839 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 155839 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 155842 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 155846 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155851 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155855 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 155859 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 155861 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 155864 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155868 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155873 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 155880 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155885 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155890 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 155893 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155895 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155898 */       GIR_RootConstrainSelectedInstOperands,
     /* 155899 */       // GIR_Coverage, 3090,
     /* 155899 */       GIR_EraseRootFromParent_Done,
     /* 155900 */     // Label 2170: @155900
     /* 155900 */     GIM_Try, /*On fail goto*//*Label 2171*/ GIMT_Encode4(155974), // Rule ID 3098 //
     /* 155905 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 155908 */       // MIs[0] Operand 1
     /* 155908 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 155913 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 155913 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 155916 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 155920 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155925 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155929 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 155933 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 155935 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 155938 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155942 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155947 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 155954 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155959 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155964 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 155967 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155969 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155972 */       GIR_RootConstrainSelectedInstOperands,
     /* 155973 */       // GIR_Coverage, 3098,
     /* 155973 */       GIR_EraseRootFromParent_Done,
     /* 155974 */     // Label 2171: @155974
     /* 155974 */     GIM_Try, /*On fail goto*//*Label 2172*/ GIMT_Encode4(156048), // Rule ID 3106 //
     /* 155979 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 155982 */       // MIs[0] Operand 1
     /* 155982 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 155987 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 155987 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 155990 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 155994 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155999 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156003 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156007 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 156009 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 156012 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156016 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156021 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 156028 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156033 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156038 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 156041 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 156043 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156046 */       GIR_RootConstrainSelectedInstOperands,
     /* 156047 */       // GIR_Coverage, 3106,
     /* 156047 */       GIR_EraseRootFromParent_Done,
     /* 156048 */     // Label 2172: @156048
     /* 156048 */     GIM_Try, /*On fail goto*//*Label 2173*/ GIMT_Encode4(156122), // Rule ID 3114 //
     /* 156053 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 156056 */       // MIs[0] Operand 1
     /* 156056 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 156061 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }))
     /* 156061 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 156064 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 156068 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156073 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156077 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156081 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 156083 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 156086 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156090 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156095 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 156102 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156107 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156112 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 156115 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 156117 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156120 */       GIR_RootConstrainSelectedInstOperands,
     /* 156121 */       // GIR_Coverage, 3114,
     /* 156121 */       GIR_EraseRootFromParent_Done,
     /* 156122 */     // Label 2173: @156122
     /* 156122 */     GIM_Reject,
     /* 156123 */   // Label 2168: @156123
     /* 156123 */   GIM_Reject,
     /* 156124 */   // Label 2150: @156124
     /* 156124 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2176*/ GIMT_Encode4(156721),
     /* 156135 */   /*GILLT_s32*//*Label 2174*/ GIMT_Encode4(156143),
     /* 156139 */   /*GILLT_s64*//*Label 2175*/ GIMT_Encode4(156432),
     /* 156143 */   // Label 2174: @156143
     /* 156143 */   GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(156431),
     /* 156148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156155 */     GIM_Try, /*On fail goto*//*Label 2178*/ GIMT_Encode4(156210), // Rule ID 3800 //
     /* 156160 */       // MIs[0] Operand 1
     /* 156160 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 156165 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] })
     /* 156165 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 156168 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 156172 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156177 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156181 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156185 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 156187 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156190 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156192 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 156199 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156204 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156209 */       // GIR_Coverage, 3800,
     /* 156209 */       GIR_EraseRootFromParent_Done,
     /* 156210 */     // Label 2178: @156210
     /* 156210 */     GIM_Try, /*On fail goto*//*Label 2179*/ GIMT_Encode4(156265), // Rule ID 3801 //
     /* 156215 */       // MIs[0] Operand 1
     /* 156215 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 156220 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] })
     /* 156220 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 156223 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 156227 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156232 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156236 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156240 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 156242 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156245 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156247 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 156254 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156259 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156264 */       // GIR_Coverage, 3801,
     /* 156264 */       GIR_EraseRootFromParent_Done,
     /* 156265 */     // Label 2179: @156265
     /* 156265 */     GIM_Try, /*On fail goto*//*Label 2180*/ GIMT_Encode4(156320), // Rule ID 3802 //
     /* 156270 */       // MIs[0] Operand 1
     /* 156270 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 156275 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] })
     /* 156275 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 156278 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 156282 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156287 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156291 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156295 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 156297 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156300 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156302 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 156309 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156314 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156319 */       // GIR_Coverage, 3802,
     /* 156319 */       GIR_EraseRootFromParent_Done,
     /* 156320 */     // Label 2180: @156320
     /* 156320 */     GIM_Try, /*On fail goto*//*Label 2181*/ GIMT_Encode4(156375), // Rule ID 3803 //
     /* 156325 */       // MIs[0] Operand 1
     /* 156325 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 156330 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] })
     /* 156330 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 156333 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 156337 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156342 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156346 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156350 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 156352 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156355 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156357 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 156364 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156369 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156374 */       // GIR_Coverage, 3803,
     /* 156374 */       GIR_EraseRootFromParent_Done,
     /* 156375 */     // Label 2181: @156375
     /* 156375 */     GIM_Try, /*On fail goto*//*Label 2182*/ GIMT_Encode4(156430), // Rule ID 3804 //
     /* 156380 */       // MIs[0] Operand 1
     /* 156380 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 156385 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETEQ:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] })
     /* 156385 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 156388 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 156392 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156397 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156401 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156405 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 156407 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156410 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156412 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 156419 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156424 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156429 */       // GIR_Coverage, 3804,
     /* 156429 */       GIR_EraseRootFromParent_Done,
     /* 156430 */     // Label 2182: @156430
     /* 156430 */     GIM_Reject,
     /* 156431 */   // Label 2177: @156431
     /* 156431 */   GIM_Reject,
     /* 156432 */   // Label 2175: @156432
     /* 156432 */   GIM_Try, /*On fail goto*//*Label 2183*/ GIMT_Encode4(156720),
     /* 156437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 156440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156444 */     GIM_Try, /*On fail goto*//*Label 2184*/ GIMT_Encode4(156499), // Rule ID 3812 //
     /* 156449 */       // MIs[0] Operand 1
     /* 156449 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 156454 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] })
     /* 156454 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 156457 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 156461 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156466 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156470 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156474 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 156476 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156479 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156481 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 156488 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156493 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156498 */       // GIR_Coverage, 3812,
     /* 156498 */       GIR_EraseRootFromParent_Done,
     /* 156499 */     // Label 2184: @156499
     /* 156499 */     GIM_Try, /*On fail goto*//*Label 2185*/ GIMT_Encode4(156554), // Rule ID 3813 //
     /* 156504 */       // MIs[0] Operand 1
     /* 156504 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 156509 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] })
     /* 156509 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 156512 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 156516 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156521 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156525 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156529 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 156531 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156534 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156536 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 156543 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156548 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156553 */       // GIR_Coverage, 3813,
     /* 156553 */       GIR_EraseRootFromParent_Done,
     /* 156554 */     // Label 2185: @156554
     /* 156554 */     GIM_Try, /*On fail goto*//*Label 2186*/ GIMT_Encode4(156609), // Rule ID 3814 //
     /* 156559 */       // MIs[0] Operand 1
     /* 156559 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 156564 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] })
     /* 156564 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 156567 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 156571 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156576 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156580 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156584 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 156586 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156589 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156591 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 156598 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156603 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156608 */       // GIR_Coverage, 3814,
     /* 156608 */       GIR_EraseRootFromParent_Done,
     /* 156609 */     // Label 2186: @156609
     /* 156609 */     GIM_Try, /*On fail goto*//*Label 2187*/ GIMT_Encode4(156664), // Rule ID 3815 //
     /* 156614 */       // MIs[0] Operand 1
     /* 156614 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 156619 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] })
     /* 156619 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 156622 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 156626 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156631 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156635 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156639 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 156641 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156644 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156646 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 156653 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156658 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156663 */       // GIR_Coverage, 3815,
     /* 156663 */       GIR_EraseRootFromParent_Done,
     /* 156664 */     // Label 2187: @156664
     /* 156664 */     GIM_Try, /*On fail goto*//*Label 2188*/ GIMT_Encode4(156719), // Rule ID 3816 //
     /* 156669 */       // MIs[0] Operand 1
     /* 156669 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 156674 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETEQ:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] })
     /* 156674 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 156677 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 156681 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156686 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156690 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156694 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 156696 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156699 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156701 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 156708 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156713 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156718 */       // GIR_Coverage, 3816,
     /* 156718 */       GIR_EraseRootFromParent_Done,
     /* 156719 */     // Label 2188: @156719
     /* 156719 */     GIM_Reject,
     /* 156720 */   // Label 2183: @156720
     /* 156720 */   GIM_Reject,
     /* 156721 */   // Label 2176: @156721
     /* 156721 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2191*/ GIMT_Encode4(157508),
     /* 156732 */   /*GILLT_s32*//*Label 2189*/ GIMT_Encode4(156740),
     /* 156736 */   /*GILLT_s64*//*Label 2190*/ GIMT_Encode4(157124),
     /* 156740 */   // Label 2189: @156740
     /* 156740 */   GIM_Try, /*On fail goto*//*Label 2192*/ GIMT_Encode4(157123),
     /* 156745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156752 */     GIM_Try, /*On fail goto*//*Label 2193*/ GIMT_Encode4(156826), // Rule ID 3865 //
     /* 156757 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 156760 */       // MIs[0] Operand 1
     /* 156760 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 156765 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 156765 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 156768 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 156772 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156777 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156781 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156785 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 156787 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 156790 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156794 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156799 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 156806 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156811 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156816 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 156819 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 156821 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156824 */       GIR_RootConstrainSelectedInstOperands,
     /* 156825 */       // GIR_Coverage, 3865,
     /* 156825 */       GIR_EraseRootFromParent_Done,
     /* 156826 */     // Label 2193: @156826
     /* 156826 */     GIM_Try, /*On fail goto*//*Label 2194*/ GIMT_Encode4(156900), // Rule ID 3873 //
     /* 156831 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 156834 */       // MIs[0] Operand 1
     /* 156834 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 156839 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 156839 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 156842 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 156846 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156851 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156855 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156859 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 156861 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 156864 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156868 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156873 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 156880 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156885 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156890 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 156893 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 156895 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156898 */       GIR_RootConstrainSelectedInstOperands,
     /* 156899 */       // GIR_Coverage, 3873,
     /* 156899 */       GIR_EraseRootFromParent_Done,
     /* 156900 */     // Label 2194: @156900
     /* 156900 */     GIM_Try, /*On fail goto*//*Label 2195*/ GIMT_Encode4(156974), // Rule ID 3881 //
     /* 156905 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 156908 */       // MIs[0] Operand 1
     /* 156908 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 156913 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 156913 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 156916 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 156920 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156925 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156929 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156933 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 156935 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 156938 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156942 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156947 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 156954 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156959 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156964 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 156967 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 156969 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156972 */       GIR_RootConstrainSelectedInstOperands,
     /* 156973 */       // GIR_Coverage, 3881,
     /* 156973 */       GIR_EraseRootFromParent_Done,
     /* 156974 */     // Label 2195: @156974
     /* 156974 */     GIM_Try, /*On fail goto*//*Label 2196*/ GIMT_Encode4(157048), // Rule ID 3889 //
     /* 156979 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 156982 */       // MIs[0] Operand 1
     /* 156982 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 156987 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 156987 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 156990 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 156994 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156999 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157003 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157007 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157009 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 157012 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157016 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157021 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 157028 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157033 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157038 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 157041 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 157043 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157046 */       GIR_RootConstrainSelectedInstOperands,
     /* 157047 */       // GIR_Coverage, 3889,
     /* 157047 */       GIR_EraseRootFromParent_Done,
     /* 157048 */     // Label 2196: @157048
     /* 157048 */     GIM_Try, /*On fail goto*//*Label 2197*/ GIMT_Encode4(157122), // Rule ID 3897 //
     /* 157053 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 157056 */       // MIs[0] Operand 1
     /* 157056 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 157061 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }))
     /* 157061 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 157064 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 157068 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157073 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157077 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157081 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157083 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 157086 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157090 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157095 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 157102 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157107 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157112 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 157115 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 157117 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157120 */       GIR_RootConstrainSelectedInstOperands,
     /* 157121 */       // GIR_Coverage, 3897,
     /* 157121 */       GIR_EraseRootFromParent_Done,
     /* 157122 */     // Label 2197: @157122
     /* 157122 */     GIM_Reject,
     /* 157123 */   // Label 2192: @157123
     /* 157123 */   GIM_Reject,
     /* 157124 */   // Label 2190: @157124
     /* 157124 */   GIM_Try, /*On fail goto*//*Label 2198*/ GIMT_Encode4(157507),
     /* 157129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 157132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157136 */     GIM_Try, /*On fail goto*//*Label 2199*/ GIMT_Encode4(157210), // Rule ID 3961 //
     /* 157141 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 157144 */       // MIs[0] Operand 1
     /* 157144 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 157149 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 157149 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 157152 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 157156 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157161 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157165 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157169 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157171 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 157174 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157178 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157183 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 157190 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157195 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157200 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 157203 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 157205 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157208 */       GIR_RootConstrainSelectedInstOperands,
     /* 157209 */       // GIR_Coverage, 3961,
     /* 157209 */       GIR_EraseRootFromParent_Done,
     /* 157210 */     // Label 2199: @157210
     /* 157210 */     GIM_Try, /*On fail goto*//*Label 2200*/ GIMT_Encode4(157284), // Rule ID 3969 //
     /* 157215 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 157218 */       // MIs[0] Operand 1
     /* 157218 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 157223 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 157223 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 157226 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 157230 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157235 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157239 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157243 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157245 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 157248 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157252 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157257 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 157264 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157269 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157274 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 157277 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 157279 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157282 */       GIR_RootConstrainSelectedInstOperands,
     /* 157283 */       // GIR_Coverage, 3969,
     /* 157283 */       GIR_EraseRootFromParent_Done,
     /* 157284 */     // Label 2200: @157284
     /* 157284 */     GIM_Try, /*On fail goto*//*Label 2201*/ GIMT_Encode4(157358), // Rule ID 3977 //
     /* 157289 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 157292 */       // MIs[0] Operand 1
     /* 157292 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 157297 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 157297 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 157300 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 157304 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157309 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157313 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157317 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157319 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 157322 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157326 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157331 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 157338 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157343 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157348 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 157351 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 157353 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157356 */       GIR_RootConstrainSelectedInstOperands,
     /* 157357 */       // GIR_Coverage, 3977,
     /* 157357 */       GIR_EraseRootFromParent_Done,
     /* 157358 */     // Label 2201: @157358
     /* 157358 */     GIM_Try, /*On fail goto*//*Label 2202*/ GIMT_Encode4(157432), // Rule ID 3985 //
     /* 157363 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 157366 */       // MIs[0] Operand 1
     /* 157366 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 157371 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 157371 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 157374 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 157378 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157383 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157387 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157391 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157393 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 157396 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157400 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157405 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 157412 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157417 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157422 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 157425 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 157427 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157430 */       GIR_RootConstrainSelectedInstOperands,
     /* 157431 */       // GIR_Coverage, 3985,
     /* 157431 */       GIR_EraseRootFromParent_Done,
     /* 157432 */     // Label 2202: @157432
     /* 157432 */     GIM_Try, /*On fail goto*//*Label 2203*/ GIMT_Encode4(157506), // Rule ID 3993 //
     /* 157437 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 157440 */       // MIs[0] Operand 1
     /* 157440 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 157445 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }))
     /* 157445 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 157448 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 157452 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157457 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157461 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157465 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157467 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 157470 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157474 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157479 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 157486 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157491 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157496 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 157499 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 157501 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157504 */       GIR_RootConstrainSelectedInstOperands,
     /* 157505 */       // GIR_Coverage, 3993,
     /* 157505 */       GIR_EraseRootFromParent_Done,
     /* 157506 */     // Label 2203: @157506
     /* 157506 */     GIM_Reject,
     /* 157507 */   // Label 2198: @157507
     /* 157507 */   GIM_Reject,
     /* 157508 */   // Label 2191: @157508
     /* 157508 */   GIM_Reject,
     /* 157509 */ // Label 2113: @157509
     /* 157509 */ GIM_Reject,
     /* 157510 */ // Label 32: @157510
     /* 157510 */ GIM_Try, /*On fail goto*//*Label 2204*/ GIMT_Encode4(160960),
     /* 157515 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 157518 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2208*/ GIMT_Encode4(158471),
     /* 157529 */   /*GILLT_s32*//*Label 2205*/ GIMT_Encode4(157541),
     /* 157533 */   /*GILLT_s64*//*Label 2206*/ GIMT_Encode4(157851),
     /* 157537 */   /*GILLT_s128*//*Label 2207*/ GIMT_Encode4(158161),
     /* 157541 */   // Label 2205: @157541
     /* 157541 */   GIM_Try, /*On fail goto*//*Label 2209*/ GIMT_Encode4(157850),
     /* 157546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 157549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157553 */     GIM_Try, /*On fail goto*//*Label 2210*/ GIMT_Encode4(157627), // Rule ID 3178 //
     /* 157558 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 157561 */       // MIs[0] Operand 1
     /* 157561 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 157566 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }))
     /* 157566 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 157569 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 157573 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157578 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157582 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157586 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157588 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 157591 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157595 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157600 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 157607 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157612 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157617 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 157620 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 157622 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157625 */       GIR_RootConstrainSelectedInstOperands,
     /* 157626 */       // GIR_Coverage, 3178,
     /* 157626 */       GIR_EraseRootFromParent_Done,
     /* 157627 */     // Label 2210: @157627
     /* 157627 */     GIM_Try, /*On fail goto*//*Label 2211*/ GIMT_Encode4(157701), // Rule ID 3194 //
     /* 157632 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 157635 */       // MIs[0] Operand 1
     /* 157635 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 157640 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }))
     /* 157640 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 157643 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 157647 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157652 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157656 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157660 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157662 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 157665 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157669 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157674 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 157681 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157686 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157691 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 157694 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 157696 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157699 */       GIR_RootConstrainSelectedInstOperands,
     /* 157700 */       // GIR_Coverage, 3194,
     /* 157700 */       GIR_EraseRootFromParent_Done,
     /* 157701 */     // Label 2211: @157701
     /* 157701 */     GIM_Try, /*On fail goto*//*Label 2212*/ GIMT_Encode4(157775), // Rule ID 3210 //
     /* 157706 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 157709 */       // MIs[0] Operand 1
     /* 157709 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 157714 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }))
     /* 157714 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 157717 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 157721 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157726 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157730 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157734 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157736 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 157739 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157743 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157748 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 157755 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157760 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157765 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 157768 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 157770 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157773 */       GIR_RootConstrainSelectedInstOperands,
     /* 157774 */       // GIR_Coverage, 3210,
     /* 157774 */       GIR_EraseRootFromParent_Done,
     /* 157775 */     // Label 2212: @157775
     /* 157775 */     GIM_Try, /*On fail goto*//*Label 2213*/ GIMT_Encode4(157849), // Rule ID 3226 //
     /* 157780 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 157783 */       // MIs[0] Operand 1
     /* 157783 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 157788 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }))
     /* 157788 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 157791 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 157795 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157800 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157804 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157808 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157810 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 157813 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157817 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157822 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 157829 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157834 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157839 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 157842 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 157844 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157847 */       GIR_RootConstrainSelectedInstOperands,
     /* 157848 */       // GIR_Coverage, 3226,
     /* 157848 */       GIR_EraseRootFromParent_Done,
     /* 157849 */     // Label 2213: @157849
     /* 157849 */     GIM_Reject,
     /* 157850 */   // Label 2209: @157850
     /* 157850 */   GIM_Reject,
     /* 157851 */   // Label 2206: @157851
     /* 157851 */   GIM_Try, /*On fail goto*//*Label 2214*/ GIMT_Encode4(158160),
     /* 157856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 157859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157863 */     GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(157937), // Rule ID 3234 //
     /* 157868 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 157871 */       // MIs[0] Operand 1
     /* 157871 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 157876 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }))
     /* 157876 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 157879 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 157883 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157888 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157892 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157896 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157898 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 157901 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157905 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157910 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 157917 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157922 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157927 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 157930 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 157932 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157935 */       GIR_RootConstrainSelectedInstOperands,
     /* 157936 */       // GIR_Coverage, 3234,
     /* 157936 */       GIR_EraseRootFromParent_Done,
     /* 157937 */     // Label 2215: @157937
     /* 157937 */     GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(158011), // Rule ID 3250 //
     /* 157942 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 157945 */       // MIs[0] Operand 1
     /* 157945 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 157950 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }))
     /* 157950 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 157953 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 157957 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157962 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157966 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157970 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157972 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 157975 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157979 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157984 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 157991 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157996 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 158001 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 158004 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 158006 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158009 */       GIR_RootConstrainSelectedInstOperands,
     /* 158010 */       // GIR_Coverage, 3250,
     /* 158010 */       GIR_EraseRootFromParent_Done,
     /* 158011 */     // Label 2216: @158011
     /* 158011 */     GIM_Try, /*On fail goto*//*Label 2217*/ GIMT_Encode4(158085), // Rule ID 3266 //
     /* 158016 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 158019 */       // MIs[0] Operand 1
     /* 158019 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 158024 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }))
     /* 158024 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 158027 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 158031 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158036 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158040 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158044 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 158046 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 158049 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158053 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158058 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 158065 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158070 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 158075 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 158078 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 158080 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158083 */       GIR_RootConstrainSelectedInstOperands,
     /* 158084 */       // GIR_Coverage, 3266,
     /* 158084 */       GIR_EraseRootFromParent_Done,
     /* 158085 */     // Label 2217: @158085
     /* 158085 */     GIM_Try, /*On fail goto*//*Label 2218*/ GIMT_Encode4(158159), // Rule ID 3282 //
     /* 158090 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 158093 */       // MIs[0] Operand 1
     /* 158093 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 158098 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }))
     /* 158098 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 158101 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 158105 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158110 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158114 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158118 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 158120 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 158123 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158127 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158132 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 158139 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158144 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 158149 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 158152 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 158154 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158157 */       GIR_RootConstrainSelectedInstOperands,
     /* 158158 */       // GIR_Coverage, 3282,
     /* 158158 */       GIR_EraseRootFromParent_Done,
     /* 158159 */     // Label 2218: @158159
     /* 158159 */     GIM_Reject,
     /* 158160 */   // Label 2214: @158160
     /* 158160 */   GIM_Reject,
     /* 158161 */   // Label 2207: @158161
     /* 158161 */   GIM_Try, /*On fail goto*//*Label 2219*/ GIMT_Encode4(158470),
     /* 158166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /* 158169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158173 */     GIM_Try, /*On fail goto*//*Label 2220*/ GIMT_Encode4(158247), // Rule ID 3290 //
     /* 158178 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 158181 */       // MIs[0] Operand 1
     /* 158181 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 158186 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }))
     /* 158186 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 158189 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 158193 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158198 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158202 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158206 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 158208 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 158211 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158215 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158220 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 158227 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158232 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 158237 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 158240 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 158242 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158245 */       GIR_RootConstrainSelectedInstOperands,
     /* 158246 */       // GIR_Coverage, 3290,
     /* 158246 */       GIR_EraseRootFromParent_Done,
     /* 158247 */     // Label 2220: @158247
     /* 158247 */     GIM_Try, /*On fail goto*//*Label 2221*/ GIMT_Encode4(158321), // Rule ID 3306 //
     /* 158252 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 158255 */       // MIs[0] Operand 1
     /* 158255 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 158260 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }))
     /* 158260 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 158263 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 158267 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158272 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158276 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158280 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 158282 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 158285 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158289 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158294 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 158301 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158306 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 158311 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 158314 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 158316 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158319 */       GIR_RootConstrainSelectedInstOperands,
     /* 158320 */       // GIR_Coverage, 3306,
     /* 158320 */       GIR_EraseRootFromParent_Done,
     /* 158321 */     // Label 2221: @158321
     /* 158321 */     GIM_Try, /*On fail goto*//*Label 2222*/ GIMT_Encode4(158395), // Rule ID 3322 //
     /* 158326 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 158329 */       // MIs[0] Operand 1
     /* 158329 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 158334 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }))
     /* 158334 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 158337 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 158341 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158346 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158350 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158354 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 158356 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 158359 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158363 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158368 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 158375 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158380 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 158385 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 158388 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 158390 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158393 */       GIR_RootConstrainSelectedInstOperands,
     /* 158394 */       // GIR_Coverage, 3322,
     /* 158394 */       GIR_EraseRootFromParent_Done,
     /* 158395 */     // Label 2222: @158395
     /* 158395 */     GIM_Try, /*On fail goto*//*Label 2223*/ GIMT_Encode4(158469), // Rule ID 3338 //
     /* 158400 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 158403 */       // MIs[0] Operand 1
     /* 158403 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 158408 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }))
     /* 158408 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 158411 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 158415 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158420 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158424 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158428 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 158430 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 158433 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158437 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158442 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 158449 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158454 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 158459 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 158462 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 158464 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158467 */       GIR_RootConstrainSelectedInstOperands,
     /* 158468 */       // GIR_Coverage, 3338,
     /* 158468 */       GIR_EraseRootFromParent_Done,
     /* 158469 */     // Label 2223: @158469
     /* 158469 */     GIM_Reject,
     /* 158470 */   // Label 2219: @158470
     /* 158470 */   GIM_Reject,
     /* 158471 */   // Label 2208: @158471
     /* 158471 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2227*/ GIMT_Encode4(160120),
     /* 158482 */   /*GILLT_s32*//*Label 2224*/ GIMT_Encode4(158494),
     /* 158486 */   /*GILLT_s64*//*Label 2225*/ GIMT_Encode4(159036),
     /* 158490 */   /*GILLT_s128*//*Label 2226*/ GIMT_Encode4(159578),
     /* 158494 */   // Label 2224: @158494
     /* 158494 */   GIM_Try, /*On fail goto*//*Label 2228*/ GIMT_Encode4(159035),
     /* 158499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 158502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158506 */     GIM_Try, /*On fail goto*//*Label 2229*/ GIMT_Encode4(158564), // Rule ID 4002 //
     /* 158511 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 158514 */       // MIs[0] Operand 1
     /* 158514 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 158519 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETOLT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] })
     /* 158519 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 158522 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 158526 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158531 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158535 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158539 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 158541 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158544 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158546 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 158553 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158558 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 158563 */       // GIR_Coverage, 4002,
     /* 158563 */       GIR_EraseRootFromParent_Done,
     /* 158564 */     // Label 2229: @158564
     /* 158564 */     GIM_Try, /*On fail goto*//*Label 2230*/ GIMT_Encode4(158622), // Rule ID 4006 //
     /* 158569 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 158572 */       // MIs[0] Operand 1
     /* 158572 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGT),
     /* 158577 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETOGT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] })
     /* 158577 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 158580 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 158584 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158589 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158593 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158597 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 158599 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158602 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158604 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 158611 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158616 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 158621 */       // GIR_Coverage, 4006,
     /* 158621 */       GIR_EraseRootFromParent_Done,
     /* 158622 */     // Label 2230: @158622
     /* 158622 */     GIM_Try, /*On fail goto*//*Label 2231*/ GIMT_Encode4(158680), // Rule ID 4010 //
     /* 158627 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 158630 */       // MIs[0] Operand 1
     /* 158630 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 158635 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETOEQ:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] })
     /* 158635 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 158638 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 158642 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158647 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158651 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158655 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 158657 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158660 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158662 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 158669 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158674 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 158679 */       // GIR_Coverage, 4010,
     /* 158679 */       GIR_EraseRootFromParent_Done,
     /* 158680 */     // Label 2231: @158680
     /* 158680 */     GIM_Try, /*On fail goto*//*Label 2232*/ GIMT_Encode4(158738), // Rule ID 4014 //
     /* 158685 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 158688 */       // MIs[0] Operand 1
     /* 158688 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNO),
     /* 158693 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUO:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] })
     /* 158693 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 158696 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 158700 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158705 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158709 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158713 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 158715 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158718 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158720 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 158727 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158732 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 158737 */       // GIR_Coverage, 4014,
     /* 158737 */       GIR_EraseRootFromParent_Done,
     /* 158738 */     // Label 2232: @158738
     /* 158738 */     GIM_Try, /*On fail goto*//*Label 2233*/ GIMT_Encode4(158812), // Rule ID 4016 //
     /* 158743 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 158746 */       // MIs[0] Operand 1
     /* 158746 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 158751 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }))
     /* 158751 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 158754 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 158758 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158763 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158767 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158771 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 158773 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 158776 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158780 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158785 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 158792 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158797 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 158802 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 158805 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 158807 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158810 */       GIR_RootConstrainSelectedInstOperands,
     /* 158811 */       // GIR_Coverage, 4016,
     /* 158811 */       GIR_EraseRootFromParent_Done,
     /* 158812 */     // Label 2233: @158812
     /* 158812 */     GIM_Try, /*On fail goto*//*Label 2234*/ GIMT_Encode4(158886), // Rule ID 4048 //
     /* 158817 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 158820 */       // MIs[0] Operand 1
     /* 158820 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 158825 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }))
     /* 158825 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 158828 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 158832 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158837 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158841 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158845 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 158847 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 158850 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158854 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158859 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 158866 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158871 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 158876 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 158879 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 158881 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158884 */       GIR_RootConstrainSelectedInstOperands,
     /* 158885 */       // GIR_Coverage, 4048,
     /* 158885 */       GIR_EraseRootFromParent_Done,
     /* 158886 */     // Label 2234: @158886
     /* 158886 */     GIM_Try, /*On fail goto*//*Label 2235*/ GIMT_Encode4(158960), // Rule ID 4080 //
     /* 158891 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 158894 */       // MIs[0] Operand 1
     /* 158894 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 158899 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }))
     /* 158899 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 158902 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 158906 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158911 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158915 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158919 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 158921 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 158924 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158928 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158933 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 158940 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158945 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 158950 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 158953 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 158955 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158958 */       GIR_RootConstrainSelectedInstOperands,
     /* 158959 */       // GIR_Coverage, 4080,
     /* 158959 */       GIR_EraseRootFromParent_Done,
     /* 158960 */     // Label 2235: @158960
     /* 158960 */     GIM_Try, /*On fail goto*//*Label 2236*/ GIMT_Encode4(159034), // Rule ID 4112 //
     /* 158965 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 158968 */       // MIs[0] Operand 1
     /* 158968 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 158973 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }))
     /* 158973 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 158976 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 158980 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158985 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158989 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158993 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 158995 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 158998 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159002 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159007 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 159014 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159019 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159024 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 159027 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 159029 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159032 */       GIR_RootConstrainSelectedInstOperands,
     /* 159033 */       // GIR_Coverage, 4112,
     /* 159033 */       GIR_EraseRootFromParent_Done,
     /* 159034 */     // Label 2236: @159034
     /* 159034 */     GIM_Reject,
     /* 159035 */   // Label 2228: @159035
     /* 159035 */   GIM_Reject,
     /* 159036 */   // Label 2225: @159036
     /* 159036 */   GIM_Try, /*On fail goto*//*Label 2237*/ GIMT_Encode4(159577),
     /* 159041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 159044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159048 */     GIM_Try, /*On fail goto*//*Label 2238*/ GIMT_Encode4(159122), // Rule ID 4128 //
     /* 159053 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 159056 */       // MIs[0] Operand 1
     /* 159056 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 159061 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }))
     /* 159061 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 159064 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 159068 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159073 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159077 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159081 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 159083 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 159086 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159090 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159095 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 159102 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159107 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159112 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 159115 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 159117 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159120 */       GIR_RootConstrainSelectedInstOperands,
     /* 159121 */       // GIR_Coverage, 4128,
     /* 159121 */       GIR_EraseRootFromParent_Done,
     /* 159122 */     // Label 2238: @159122
     /* 159122 */     GIM_Try, /*On fail goto*//*Label 2239*/ GIMT_Encode4(159196), // Rule ID 4160 //
     /* 159127 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 159130 */       // MIs[0] Operand 1
     /* 159130 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 159135 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }))
     /* 159135 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 159138 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 159142 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159147 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159151 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159155 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 159157 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 159160 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159164 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159169 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 159176 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159181 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159186 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 159189 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 159191 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159194 */       GIR_RootConstrainSelectedInstOperands,
     /* 159195 */       // GIR_Coverage, 4160,
     /* 159195 */       GIR_EraseRootFromParent_Done,
     /* 159196 */     // Label 2239: @159196
     /* 159196 */     GIM_Try, /*On fail goto*//*Label 2240*/ GIMT_Encode4(159270), // Rule ID 4192 //
     /* 159201 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 159204 */       // MIs[0] Operand 1
     /* 159204 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 159209 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }))
     /* 159209 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 159212 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 159216 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159221 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159225 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159229 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 159231 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 159234 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159238 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159243 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 159250 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159255 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159260 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 159263 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 159265 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159268 */       GIR_RootConstrainSelectedInstOperands,
     /* 159269 */       // GIR_Coverage, 4192,
     /* 159269 */       GIR_EraseRootFromParent_Done,
     /* 159270 */     // Label 2240: @159270
     /* 159270 */     GIM_Try, /*On fail goto*//*Label 2241*/ GIMT_Encode4(159344), // Rule ID 4224 //
     /* 159275 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 159278 */       // MIs[0] Operand 1
     /* 159278 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 159283 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }))
     /* 159283 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 159286 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 159290 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159295 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159299 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159303 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 159305 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 159308 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159312 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159317 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 159324 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159329 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159334 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 159337 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 159339 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159342 */       GIR_RootConstrainSelectedInstOperands,
     /* 159343 */       // GIR_Coverage, 4224,
     /* 159343 */       GIR_EraseRootFromParent_Done,
     /* 159344 */     // Label 2241: @159344
     /* 159344 */     GIM_Try, /*On fail goto*//*Label 2242*/ GIMT_Encode4(159402), // Rule ID 4240 //
     /* 159349 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 159352 */       // MIs[0] Operand 1
     /* 159352 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 159357 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETOLT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] })
     /* 159357 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 159360 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 159364 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159369 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159373 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159377 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 159379 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159382 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159384 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 159391 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159396 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159401 */       // GIR_Coverage, 4240,
     /* 159401 */       GIR_EraseRootFromParent_Done,
     /* 159402 */     // Label 2242: @159402
     /* 159402 */     GIM_Try, /*On fail goto*//*Label 2243*/ GIMT_Encode4(159460), // Rule ID 4244 //
     /* 159407 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 159410 */       // MIs[0] Operand 1
     /* 159410 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGT),
     /* 159415 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETOGT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] })
     /* 159415 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 159418 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 159422 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159427 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159431 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159435 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 159437 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159440 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159442 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 159449 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159454 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159459 */       // GIR_Coverage, 4244,
     /* 159459 */       GIR_EraseRootFromParent_Done,
     /* 159460 */     // Label 2243: @159460
     /* 159460 */     GIM_Try, /*On fail goto*//*Label 2244*/ GIMT_Encode4(159518), // Rule ID 4248 //
     /* 159465 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 159468 */       // MIs[0] Operand 1
     /* 159468 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 159473 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETOEQ:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] })
     /* 159473 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 159476 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 159480 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159485 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159489 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159493 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 159495 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159498 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159500 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 159507 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159512 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159517 */       // GIR_Coverage, 4248,
     /* 159517 */       GIR_EraseRootFromParent_Done,
     /* 159518 */     // Label 2244: @159518
     /* 159518 */     GIM_Try, /*On fail goto*//*Label 2245*/ GIMT_Encode4(159576), // Rule ID 4252 //
     /* 159523 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 159526 */       // MIs[0] Operand 1
     /* 159526 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNO),
     /* 159531 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUO:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] })
     /* 159531 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 159534 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 159538 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159543 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159547 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159551 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 159553 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159556 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159558 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 159565 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159570 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159575 */       // GIR_Coverage, 4252,
     /* 159575 */       GIR_EraseRootFromParent_Done,
     /* 159576 */     // Label 2245: @159576
     /* 159576 */     GIM_Reject,
     /* 159577 */   // Label 2237: @159577
     /* 159577 */   GIM_Reject,
     /* 159578 */   // Label 2226: @159578
     /* 159578 */   GIM_Try, /*On fail goto*//*Label 2246*/ GIMT_Encode4(160119),
     /* 159583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /* 159586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159590 */     GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(159664), // Rule ID 4254 //
     /* 159595 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 159598 */       // MIs[0] Operand 1
     /* 159598 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 159603 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }))
     /* 159603 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 159606 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 159610 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159615 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159619 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159623 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 159625 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 159628 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159632 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159637 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 159644 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159649 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159654 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 159657 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 159659 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159662 */       GIR_RootConstrainSelectedInstOperands,
     /* 159663 */       // GIR_Coverage, 4254,
     /* 159663 */       GIR_EraseRootFromParent_Done,
     /* 159664 */     // Label 2247: @159664
     /* 159664 */     GIM_Try, /*On fail goto*//*Label 2248*/ GIMT_Encode4(159738), // Rule ID 4286 //
     /* 159669 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 159672 */       // MIs[0] Operand 1
     /* 159672 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 159677 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }))
     /* 159677 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 159680 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 159684 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159689 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159693 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159697 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 159699 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 159702 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159706 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159711 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 159718 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159723 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159728 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 159731 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 159733 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159736 */       GIR_RootConstrainSelectedInstOperands,
     /* 159737 */       // GIR_Coverage, 4286,
     /* 159737 */       GIR_EraseRootFromParent_Done,
     /* 159738 */     // Label 2248: @159738
     /* 159738 */     GIM_Try, /*On fail goto*//*Label 2249*/ GIMT_Encode4(159812), // Rule ID 4318 //
     /* 159743 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 159746 */       // MIs[0] Operand 1
     /* 159746 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 159751 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }))
     /* 159751 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 159754 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 159758 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159763 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159767 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159771 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 159773 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 159776 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159780 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159785 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 159792 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159797 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159802 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 159805 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 159807 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159810 */       GIR_RootConstrainSelectedInstOperands,
     /* 159811 */       // GIR_Coverage, 4318,
     /* 159811 */       GIR_EraseRootFromParent_Done,
     /* 159812 */     // Label 2249: @159812
     /* 159812 */     GIM_Try, /*On fail goto*//*Label 2250*/ GIMT_Encode4(159886), // Rule ID 4350 //
     /* 159817 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 159820 */       // MIs[0] Operand 1
     /* 159820 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 159825 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }))
     /* 159825 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 159828 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 159832 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159837 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159841 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159845 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 159847 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 159850 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159854 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159859 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 159866 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159871 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159876 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 159879 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 159881 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159884 */       GIR_RootConstrainSelectedInstOperands,
     /* 159885 */       // GIR_Coverage, 4350,
     /* 159885 */       GIR_EraseRootFromParent_Done,
     /* 159886 */     // Label 2250: @159886
     /* 159886 */     GIM_Try, /*On fail goto*//*Label 2251*/ GIMT_Encode4(159944), // Rule ID 4366 //
     /* 159891 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 159894 */       // MIs[0] Operand 1
     /* 159894 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 159899 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETOLT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] })
     /* 159899 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 159902 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 159906 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159911 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159915 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159919 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 159921 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159924 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159926 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 159933 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159938 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159943 */       // GIR_Coverage, 4366,
     /* 159943 */       GIR_EraseRootFromParent_Done,
     /* 159944 */     // Label 2251: @159944
     /* 159944 */     GIM_Try, /*On fail goto*//*Label 2252*/ GIMT_Encode4(160002), // Rule ID 4370 //
     /* 159949 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 159952 */       // MIs[0] Operand 1
     /* 159952 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGT),
     /* 159957 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETOGT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] })
     /* 159957 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 159960 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 159964 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159969 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159973 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159977 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 159979 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159982 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159984 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 159991 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159996 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 160001 */       // GIR_Coverage, 4370,
     /* 160001 */       GIR_EraseRootFromParent_Done,
     /* 160002 */     // Label 2252: @160002
     /* 160002 */     GIM_Try, /*On fail goto*//*Label 2253*/ GIMT_Encode4(160060), // Rule ID 4374 //
     /* 160007 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 160010 */       // MIs[0] Operand 1
     /* 160010 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 160015 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETOEQ:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] })
     /* 160015 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 160018 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 160022 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160027 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 160031 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 160035 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 160037 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160040 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160042 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 160049 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 160054 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 160059 */       // GIR_Coverage, 4374,
     /* 160059 */       GIR_EraseRootFromParent_Done,
     /* 160060 */     // Label 2253: @160060
     /* 160060 */     GIM_Try, /*On fail goto*//*Label 2254*/ GIMT_Encode4(160118), // Rule ID 4378 //
     /* 160065 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 160068 */       // MIs[0] Operand 1
     /* 160068 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNO),
     /* 160073 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUO:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] })
     /* 160073 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 160076 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 160080 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160085 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 160089 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 160093 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 160095 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160098 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160100 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 160107 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 160112 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 160117 */       // GIR_Coverage, 4378,
     /* 160117 */       GIR_EraseRootFromParent_Done,
     /* 160118 */     // Label 2254: @160118
     /* 160118 */     GIM_Reject,
     /* 160119 */   // Label 2246: @160119
     /* 160119 */   GIM_Reject,
     /* 160120 */   // Label 2227: @160120
     /* 160120 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2257*/ GIMT_Encode4(160959),
     /* 160131 */   /*GILLT_s32*//*Label 2255*/ GIMT_Encode4(160139),
     /* 160135 */   /*GILLT_s64*//*Label 2256*/ GIMT_Encode4(160549),
     /* 160139 */   // Label 2255: @160139
     /* 160139 */   GIM_Try, /*On fail goto*//*Label 2258*/ GIMT_Encode4(160548),
     /* 160144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 160151 */     GIM_Try, /*On fail goto*//*Label 2259*/ GIMT_Encode4(160209), // Rule ID 4569 //
     /* 160156 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 160159 */       // MIs[0] Operand 1
     /* 160159 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 160164 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETOLT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPLT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] })
     /* 160164 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 160167 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFSCMPLT),
     /* 160171 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160176 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 160180 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 160184 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 160186 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160189 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160191 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 160198 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 160203 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 160208 */       // GIR_Coverage, 4569,
     /* 160208 */       GIR_EraseRootFromParent_Done,
     /* 160209 */     // Label 2259: @160209
     /* 160209 */     GIM_Try, /*On fail goto*//*Label 2260*/ GIMT_Encode4(160267), // Rule ID 4573 //
     /* 160214 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 160217 */       // MIs[0] Operand 1
     /* 160217 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGT),
     /* 160222 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETOGT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPGT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] })
     /* 160222 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 160225 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFSCMPGT),
     /* 160229 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160234 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 160238 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 160242 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 160244 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160247 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160249 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 160256 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 160261 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 160266 */       // GIR_Coverage, 4573,
     /* 160266 */       GIR_EraseRootFromParent_Done,
     /* 160267 */     // Label 2260: @160267
     /* 160267 */     GIM_Try, /*On fail goto*//*Label 2261*/ GIMT_Encode4(160325), // Rule ID 4577 //
     /* 160272 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 160275 */       // MIs[0] Operand 1
     /* 160275 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 160280 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETOEQ:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPEQ:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] })
     /* 160280 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 160283 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFSCMPEQ),
     /* 160287 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160292 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 160296 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 160300 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 160302 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160305 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160307 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 160314 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 160319 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 160324 */       // GIR_Coverage, 4577,
     /* 160324 */       GIR_EraseRootFromParent_Done,
     /* 160325 */     // Label 2261: @160325
     /* 160325 */     GIM_Try, /*On fail goto*//*Label 2262*/ GIMT_Encode4(160399), // Rule ID 4581 //
     /* 160330 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 160333 */       // MIs[0] Operand 1
     /* 160333 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 160338 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPLT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }))
     /* 160338 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 160341 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPLT),
     /* 160345 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160350 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 160354 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 160358 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 160360 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 160363 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160367 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160372 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 160379 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 160384 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 160389 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 160392 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 160394 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 160397 */       GIR_RootConstrainSelectedInstOperands,
     /* 160398 */       // GIR_Coverage, 4581,
     /* 160398 */       GIR_EraseRootFromParent_Done,
     /* 160399 */     // Label 2262: @160399
     /* 160399 */     GIM_Try, /*On fail goto*//*Label 2263*/ GIMT_Encode4(160473), // Rule ID 4613 //
     /* 160404 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 160407 */       // MIs[0] Operand 1
     /* 160407 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 160412 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPGT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }))
     /* 160412 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 160415 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPGT),
     /* 160419 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160424 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 160428 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 160432 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 160434 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 160437 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160441 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160446 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 160453 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 160458 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 160463 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 160466 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 160468 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 160471 */       GIR_RootConstrainSelectedInstOperands,
     /* 160472 */       // GIR_Coverage, 4613,
     /* 160472 */       GIR_EraseRootFromParent_Done,
     /* 160473 */     // Label 2263: @160473
     /* 160473 */     GIM_Try, /*On fail goto*//*Label 2264*/ GIMT_Encode4(160547), // Rule ID 4645 //
     /* 160478 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 160481 */       // MIs[0] Operand 1
     /* 160481 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 160486 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPEQ:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }))
     /* 160486 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 160489 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPEQ),
     /* 160493 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160498 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 160502 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 160506 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 160508 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 160511 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160515 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160520 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 160527 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 160532 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 160537 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 160540 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 160542 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 160545 */       GIR_RootConstrainSelectedInstOperands,
     /* 160546 */       // GIR_Coverage, 4645,
     /* 160546 */       GIR_EraseRootFromParent_Done,
     /* 160547 */     // Label 2264: @160547
     /* 160547 */     GIM_Reject,
     /* 160548 */   // Label 2258: @160548
     /* 160548 */   GIM_Reject,
     /* 160549 */   // Label 2256: @160549
     /* 160549 */   GIM_Try, /*On fail goto*//*Label 2265*/ GIMT_Encode4(160958),
     /* 160554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 160557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 160561 */     GIM_Try, /*On fail goto*//*Label 2266*/ GIMT_Encode4(160619), // Rule ID 4677 //
     /* 160566 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 160569 */       // MIs[0] Operand 1
     /* 160569 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 160574 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETOLT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPLT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] })
     /* 160574 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 160577 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFDCMPLT),
     /* 160581 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160586 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 160590 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 160594 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 160596 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160599 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160601 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 160608 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 160613 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 160618 */       // GIR_Coverage, 4677,
     /* 160618 */       GIR_EraseRootFromParent_Done,
     /* 160619 */     // Label 2266: @160619
     /* 160619 */     GIM_Try, /*On fail goto*//*Label 2267*/ GIMT_Encode4(160677), // Rule ID 4681 //
     /* 160624 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 160627 */       // MIs[0] Operand 1
     /* 160627 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGT),
     /* 160632 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETOGT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPGT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] })
     /* 160632 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 160635 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFDCMPGT),
     /* 160639 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160644 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 160648 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 160652 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 160654 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160657 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160659 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 160666 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 160671 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 160676 */       // GIR_Coverage, 4681,
     /* 160676 */       GIR_EraseRootFromParent_Done,
     /* 160677 */     // Label 2267: @160677
     /* 160677 */     GIM_Try, /*On fail goto*//*Label 2268*/ GIMT_Encode4(160735), // Rule ID 4685 //
     /* 160682 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 160685 */       // MIs[0] Operand 1
     /* 160685 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 160690 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETOEQ:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPEQ:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] })
     /* 160690 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 160693 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFDCMPEQ),
     /* 160697 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160702 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 160706 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 160710 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 160712 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160715 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160717 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 160724 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 160729 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 160734 */       // GIR_Coverage, 4685,
     /* 160734 */       GIR_EraseRootFromParent_Done,
     /* 160735 */     // Label 2268: @160735
     /* 160735 */     GIM_Try, /*On fail goto*//*Label 2269*/ GIMT_Encode4(160809), // Rule ID 4689 //
     /* 160740 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 160743 */       // MIs[0] Operand 1
     /* 160743 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 160748 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPLT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }))
     /* 160748 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 160751 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPLT),
     /* 160755 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160760 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 160764 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 160768 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 160770 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 160773 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160777 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160782 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 160789 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 160794 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 160799 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 160802 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 160804 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 160807 */       GIR_RootConstrainSelectedInstOperands,
     /* 160808 */       // GIR_Coverage, 4689,
     /* 160808 */       GIR_EraseRootFromParent_Done,
     /* 160809 */     // Label 2269: @160809
     /* 160809 */     GIM_Try, /*On fail goto*//*Label 2270*/ GIMT_Encode4(160883), // Rule ID 4721 //
     /* 160814 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 160817 */       // MIs[0] Operand 1
     /* 160817 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 160822 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPGT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }))
     /* 160822 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 160825 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPGT),
     /* 160829 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160834 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 160838 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 160842 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 160844 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 160847 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160851 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160856 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 160863 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 160868 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 160873 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 160876 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 160878 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 160881 */       GIR_RootConstrainSelectedInstOperands,
     /* 160882 */       // GIR_Coverage, 4721,
     /* 160882 */       GIR_EraseRootFromParent_Done,
     /* 160883 */     // Label 2270: @160883
     /* 160883 */     GIM_Try, /*On fail goto*//*Label 2271*/ GIMT_Encode4(160957), // Rule ID 4753 //
     /* 160888 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 160891 */       // MIs[0] Operand 1
     /* 160891 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 160896 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPEQ:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }))
     /* 160896 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 160899 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPEQ),
     /* 160903 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160908 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 160912 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 160916 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 160918 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 160921 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160925 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160930 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 160937 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 160942 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 160947 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 160950 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 160952 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 160955 */       GIR_RootConstrainSelectedInstOperands,
     /* 160956 */       // GIR_Coverage, 4753,
     /* 160956 */       GIR_EraseRootFromParent_Done,
     /* 160957 */     // Label 2271: @160957
     /* 160957 */     GIM_Reject,
     /* 160958 */   // Label 2265: @160958
     /* 160958 */   GIM_Reject,
     /* 160959 */   // Label 2257: @160959
     /* 160959 */   GIM_Reject,
     /* 160960 */ // Label 2204: @160960
     /* 160960 */ GIM_Reject,
     /* 160961 */ // Label 33: @160961
     /* 160961 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(8), /*)*//*default:*//*Label 2280*/ GIMT_Encode4(162084),
     /* 160972 */ /*GILLT_s1*//*Label 2272*/ GIMT_Encode4(161004),
     /* 160976 */ /*GILLT_s32*//*Label 2273*/ GIMT_Encode4(161097),
     /* 160980 */ /*GILLT_s64*//*Label 2274*/ GIMT_Encode4(161186),
     /* 160984 */ /*GILLT_s128*//*Label 2275*/ GIMT_Encode4(161275),
     /* 160988 */ /*GILLT_v2s64*//*Label 2276*/ GIMT_Encode4(161459),
     /* 160992 */ /*GILLT_v4s32*//*Label 2277*/ GIMT_Encode4(161624),
     /* 160996 */ /*GILLT_v8s16*//*Label 2278*/ GIMT_Encode4(161786),
     /* 161000 */ /*GILLT_v16s8*//*Label 2279*/ GIMT_Encode4(161935),
     /* 161004 */ // Label 2272: @161004
     /* 161004 */ GIM_Try, /*On fail goto*//*Label 2281*/ GIMT_Encode4(161096), // Rule ID 4784 //
     /* 161009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 161012 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /* 161015 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s1,
     /* 161018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 161022 */   // (select:{ *:[i1] } i1:{ *:[i1] }:$cond, i1:{ *:[i1] }:$tval, i1:{ *:[i1] }:$fval)  =>  (CROR:{ *:[i1] } (CRAND:{ *:[i1] } ?:{ *:[i1] }:$cond, ?:{ *:[i1] }:$tval), (CRAND:{ *:[i1] } (CRNOT:{ *:[i1] } ?:{ *:[i1] }:$cond), ?:{ *:[i1] }:$fval))
     /* 161022 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s1,
     /* 161025 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 161029 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161034 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // cond
     /* 161038 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 161040 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
     /* 161043 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CRAND),
     /* 161047 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161052 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 161055 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // fval
     /* 161059 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 161061 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 161064 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CRAND),
     /* 161068 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161073 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // cond
     /* 161077 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // tval
     /* 161081 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 161083 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CROR),
     /* 161086 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 161088 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 161091 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 161094 */   GIR_RootConstrainSelectedInstOperands,
     /* 161095 */   // GIR_Coverage, 4784,
     /* 161095 */   GIR_EraseRootFromParent_Done,
     /* 161096 */ // Label 2281: @161096
     /* 161096 */ GIM_Reject,
     /* 161097 */ // Label 2273: @161097
     /* 161097 */ GIM_Try, /*On fail goto*//*Label 2282*/ GIMT_Encode4(161185),
     /* 161102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 161105 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161108 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161111 */   GIM_Try, /*On fail goto*//*Label 2283*/ GIMT_Encode4(161130), // Rule ID 1055 //
     /* 161116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 161119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 161123 */     // (select:{ *:[f32] } i1:{ *:[i1] }:$cond, f32:{ *:[f32] }:$T, f32:{ *:[f32] }:$F)  =>  (SELECT_VSSRC:{ *:[f32] } i1:{ *:[i1] }:$cond, f32:{ *:[f32] }:$T, f32:{ *:[f32] }:$F)
     /* 161123 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SELECT_VSSRC),
     /* 161128 */     GIR_RootConstrainSelectedInstOperands,
     /* 161129 */     // GIR_Coverage, 1055,
     /* 161129 */     GIR_Done,
     /* 161130 */   // Label 2283: @161130
     /* 161130 */   GIM_Try, /*On fail goto*//*Label 2284*/ GIMT_Encode4(161146), // Rule ID 5 //
     /* 161135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 161139 */     // (select:{ *:[i32] } i1:{ *:[i1] }:$cond, i32:{ *:[i32] }:$T, i32:{ *:[i32] }:$F)  =>  (SELECT_I4:{ *:[i32] } i1:{ *:[i1] }:$cond, i32:{ *:[i32] }:$T, i32:{ *:[i32] }:$F)
     /* 161139 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 161144 */     GIR_RootConstrainSelectedInstOperands,
     /* 161145 */     // GIR_Coverage, 5,
     /* 161145 */     GIR_Done,
     /* 161146 */   // Label 2284: @161146
     /* 161146 */   GIM_Try, /*On fail goto*//*Label 2285*/ GIMT_Encode4(161165), // Rule ID 7 //
     /* 161151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 161154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 161158 */     // (select:{ *:[f32] } i1:{ *:[i1] }:$cond, f32:{ *:[f32] }:$T, f32:{ *:[f32] }:$F)  =>  (SELECT_F4:{ *:[f32] } i1:{ *:[i1] }:$cond, f32:{ *:[f32] }:$T, f32:{ *:[f32] }:$F)
     /* 161158 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SELECT_F4),
     /* 161163 */     GIR_RootConstrainSelectedInstOperands,
     /* 161164 */     // GIR_Coverage, 7,
     /* 161164 */     GIR_Done,
     /* 161165 */   // Label 2285: @161165
     /* 161165 */   GIM_Try, /*On fail goto*//*Label 2286*/ GIMT_Encode4(161184), // Rule ID 610 //
     /* 161170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 161173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 161177 */     // (select:{ *:[f32] } i1:{ *:[i1] }:$cond, f32:{ *:[f32] }:$T, f32:{ *:[f32] }:$F)  =>  (SELECT_SPE4:{ *:[f32] } i1:{ *:[i1] }:$cond, f32:{ *:[f32] }:$T, f32:{ *:[f32] }:$F)
     /* 161177 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SELECT_SPE4),
     /* 161182 */     GIR_RootConstrainSelectedInstOperands,
     /* 161183 */     // GIR_Coverage, 610,
     /* 161183 */     GIR_Done,
     /* 161184 */   // Label 2286: @161184
     /* 161184 */   GIM_Reject,
     /* 161185 */ // Label 2282: @161185
     /* 161185 */ GIM_Reject,
     /* 161186 */ // Label 2274: @161186
     /* 161186 */ GIM_Try, /*On fail goto*//*Label 2287*/ GIMT_Encode4(161274),
     /* 161191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 161194 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161197 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 161200 */   GIM_Try, /*On fail goto*//*Label 2288*/ GIMT_Encode4(161219), // Rule ID 1054 //
     /* 161205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 161208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 161212 */     // (select:{ *:[f64] } i1:{ *:[i1] }:$cond, f64:{ *:[f64] }:$T, f64:{ *:[f64] }:$F)  =>  (SELECT_VSFRC:{ *:[f64] } i1:{ *:[i1] }:$cond, f64:{ *:[f64] }:$T, f64:{ *:[f64] }:$F)
     /* 161212 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SELECT_VSFRC),
     /* 161217 */     GIR_RootConstrainSelectedInstOperands,
     /* 161218 */     // GIR_Coverage, 1054,
     /* 161218 */     GIR_Done,
     /* 161219 */   // Label 2288: @161219
     /* 161219 */   GIM_Try, /*On fail goto*//*Label 2289*/ GIMT_Encode4(161235), // Rule ID 6 //
     /* 161224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 161228 */     // (select:{ *:[i64] } i1:{ *:[i1] }:$cond, i64:{ *:[i64] }:$T, i64:{ *:[i64] }:$F)  =>  (SELECT_I8:{ *:[i64] } i1:{ *:[i1] }:$cond, i64:{ *:[i64] }:$T, i64:{ *:[i64] }:$F)
     /* 161228 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 161233 */     GIR_RootConstrainSelectedInstOperands,
     /* 161234 */     // GIR_Coverage, 6,
     /* 161234 */     GIR_Done,
     /* 161235 */   // Label 2289: @161235
     /* 161235 */   GIM_Try, /*On fail goto*//*Label 2290*/ GIMT_Encode4(161254), // Rule ID 8 //
     /* 161240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 161243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 161247 */     // (select:{ *:[f64] } i1:{ *:[i1] }:$cond, f64:{ *:[f64] }:$T, f64:{ *:[f64] }:$F)  =>  (SELECT_F8:{ *:[f64] } i1:{ *:[i1] }:$cond, f64:{ *:[f64] }:$T, f64:{ *:[f64] }:$F)
     /* 161247 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SELECT_F8),
     /* 161252 */     GIR_RootConstrainSelectedInstOperands,
     /* 161253 */     // GIR_Coverage, 8,
     /* 161253 */     GIR_Done,
     /* 161254 */   // Label 2290: @161254
     /* 161254 */   GIM_Try, /*On fail goto*//*Label 2291*/ GIMT_Encode4(161273), // Rule ID 611 //
     /* 161259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 161262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 161266 */     // (select:{ *:[f64] } i1:{ *:[i1] }:$cond, f64:{ *:[f64] }:$T, f64:{ *:[f64] }:$F)  =>  (SELECT_SPE:{ *:[f64] } i1:{ *:[i1] }:$cond, f64:{ *:[f64] }:$T, f64:{ *:[f64] }:$F)
     /* 161266 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SELECT_SPE),
     /* 161271 */     GIR_RootConstrainSelectedInstOperands,
     /* 161272 */     // GIR_Coverage, 611,
     /* 161272 */     GIR_Done,
     /* 161273 */   // Label 2291: @161273
     /* 161273 */   GIM_Reject,
     /* 161274 */ // Label 2287: @161274
     /* 161274 */ GIM_Reject,
     /* 161275 */ // Label 2275: @161275
     /* 161275 */ GIM_Try, /*On fail goto*//*Label 2292*/ GIMT_Encode4(161396), // Rule ID 1675 //
     /* 161280 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 161283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 161286 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 161289 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /* 161292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 161296 */   // (vselect:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$vA, v1i128:{ *:[v1i128] }:$vB, v1i128:{ *:[v1i128] }:$vC)  =>  (COPY_TO_REGCLASS:{ *:[v1i128] } (XXSEL:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v1i128] }:$vC, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v1i128] }:$vB, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v1i128] }:$vA, VSRC:{ *:[i32] })), VRRC:{ *:[i32] })
     /* 161296 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 161299 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 161303 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161308 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // vA
     /* 161312 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 161317 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 161320 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 161324 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161329 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // vB
     /* 161333 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 161338 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 161341 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 161345 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161350 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // vC
     /* 161354 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 161359 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 161362 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /* 161366 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161371 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 161374 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 161377 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 161380 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 161382 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 161385 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161387 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 161390 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 161395 */   // GIR_Coverage, 1675,
     /* 161395 */   GIR_EraseRootFromParent_Done,
     /* 161396 */ // Label 2292: @161396
     /* 161396 */ GIM_Try, /*On fail goto*//*Label 2293*/ GIMT_Encode4(161424), // Rule ID 9 //
     /* 161401 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 161404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 161407 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 161410 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /* 161413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 161417 */   // (select:{ *:[f128] } i1:{ *:[i1] }:$cond, f128:{ *:[f128] }:$T, f128:{ *:[f128] }:$F)  =>  (SELECT_F16:{ *:[f128] } i1:{ *:[i1] }:$cond, f128:{ *:[f128] }:$T, f128:{ *:[f128] }:$F)
     /* 161417 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SELECT_F16),
     /* 161422 */   GIR_RootConstrainSelectedInstOperands,
     /* 161423 */   // GIR_Coverage, 9,
     /* 161423 */   GIR_Done,
     /* 161424 */ // Label 2293: @161424
     /* 161424 */ GIM_Try, /*On fail goto*//*Label 2294*/ GIMT_Encode4(161458), // Rule ID 1429 //
     /* 161429 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 161432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 161435 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 161438 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /* 161441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 161445 */   // (vselect:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$vA, v1i128:{ *:[v1i128] }:$vB, v1i128:{ *:[v1i128] }:$vC)  =>  (VSEL:{ *:[v1i128] } ?:{ *:[v1i128] }:$vC, ?:{ *:[v1i128] }:$vB, ?:{ *:[v1i128] }:$vA)
     /* 161445 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSEL),
     /* 161448 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /* 161450 */   GIR_RootToRootCopy, /*OpIdx*/3, // vC
     /* 161452 */   GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 161454 */   GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 161456 */   GIR_RootConstrainSelectedInstOperands,
     /* 161457 */   // GIR_Coverage, 1429,
     /* 161457 */   GIR_EraseRootFromParent_Done,
     /* 161458 */ // Label 2294: @161458
     /* 161458 */ GIM_Reject,
     /* 161459 */ // Label 2276: @161459
     /* 161459 */ GIM_Try, /*On fail goto*//*Label 2295*/ GIMT_Encode4(161487), // Rule ID 1053 //
     /* 161464 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 161467 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 161470 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 161473 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 161476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 161480 */   // (select:{ *:[v2f64] } i1:{ *:[i1] }:$cond, v2f64:{ *:[v2f64] }:$T, v2f64:{ *:[v2f64] }:$F)  =>  (SELECT_VSRC:{ *:[v2f64] } i1:{ *:[i1] }:$cond, v2f64:{ *:[v2f64] }:$T, v2f64:{ *:[v2f64] }:$F)
     /* 161480 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SELECT_VSRC),
     /* 161485 */   GIR_RootConstrainSelectedInstOperands,
     /* 161486 */   // GIR_Coverage, 1053,
     /* 161486 */   GIR_Done,
     /* 161487 */ // Label 2295: @161487
     /* 161487 */ GIM_Try, /*On fail goto*//*Label 2296*/ GIMT_Encode4(161521), // Rule ID 1672 //
     /* 161492 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 161495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 161498 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 161501 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 161504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 161508 */   // (vselect:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$vA, v2i64:{ *:[v2i64] }:$vB, v2i64:{ *:[v2i64] }:$vC)  =>  (XXSEL:{ *:[v2i64] } ?:{ *:[v2i64] }:$vC, ?:{ *:[v2i64] }:$vB, ?:{ *:[v2i64] }:$vA)
     /* 161508 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /* 161511 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 161513 */   GIR_RootToRootCopy, /*OpIdx*/3, // vC
     /* 161515 */   GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 161517 */   GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 161519 */   GIR_RootConstrainSelectedInstOperands,
     /* 161520 */   // GIR_Coverage, 1672,
     /* 161520 */   GIR_EraseRootFromParent_Done,
     /* 161521 */ // Label 2296: @161521
     /* 161521 */ GIM_Try, /*On fail goto*//*Label 2297*/ GIMT_Encode4(161555), // Rule ID 1674 //
     /* 161526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 161529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 161532 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 161535 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 161538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 161542 */   // (vselect:{ *:[v2f64] } v2i64:{ *:[v2i64] }:$vA, v2f64:{ *:[v2f64] }:$vB, v2f64:{ *:[v2f64] }:$vC)  =>  (XXSEL:{ *:[v2f64] } ?:{ *:[v2f64] }:$vC, ?:{ *:[v2f64] }:$vB, ?:{ *:[v2i64] }:$vA)
     /* 161542 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /* 161545 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 161547 */   GIR_RootToRootCopy, /*OpIdx*/3, // vC
     /* 161549 */   GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 161551 */   GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 161553 */   GIR_RootConstrainSelectedInstOperands,
     /* 161554 */   // GIR_Coverage, 1674,
     /* 161554 */   GIR_EraseRootFromParent_Done,
     /* 161555 */ // Label 2297: @161555
     /* 161555 */ GIM_Try, /*On fail goto*//*Label 2298*/ GIMT_Encode4(161589), // Rule ID 1426 //
     /* 161560 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 161563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 161566 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 161569 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 161572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 161576 */   // (vselect:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$vA, v2i64:{ *:[v2i64] }:$vB, v2i64:{ *:[v2i64] }:$vC)  =>  (VSEL:{ *:[v2i64] } ?:{ *:[v2i64] }:$vC, ?:{ *:[v2i64] }:$vB, ?:{ *:[v2i64] }:$vA)
     /* 161576 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSEL),
     /* 161579 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /* 161581 */   GIR_RootToRootCopy, /*OpIdx*/3, // vC
     /* 161583 */   GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 161585 */   GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 161587 */   GIR_RootConstrainSelectedInstOperands,
     /* 161588 */   // GIR_Coverage, 1426,
     /* 161588 */   GIR_EraseRootFromParent_Done,
     /* 161589 */ // Label 2298: @161589
     /* 161589 */ GIM_Try, /*On fail goto*//*Label 2299*/ GIMT_Encode4(161623), // Rule ID 1428 //
     /* 161594 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 161597 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 161600 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 161603 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 161606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 161610 */   // (vselect:{ *:[v2f64] } v2i64:{ *:[v2i64] }:$vA, v2f64:{ *:[v2f64] }:$vB, v2f64:{ *:[v2f64] }:$vC)  =>  (VSEL:{ *:[v2f64] } ?:{ *:[v2f64] }:$vC, ?:{ *:[v2f64] }:$vB, ?:{ *:[v2i64] }:$vA)
     /* 161610 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSEL),
     /* 161613 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /* 161615 */   GIR_RootToRootCopy, /*OpIdx*/3, // vC
     /* 161617 */   GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 161619 */   GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 161621 */   GIR_RootConstrainSelectedInstOperands,
     /* 161622 */   // GIR_Coverage, 1428,
     /* 161622 */   GIR_EraseRootFromParent_Done,
     /* 161623 */ // Label 2299: @161623
     /* 161623 */ GIM_Reject,
     /* 161624 */ // Label 2277: @161624
     /* 161624 */ GIM_Try, /*On fail goto*//*Label 2300*/ GIMT_Encode4(161658), // Rule ID 1671 //
     /* 161629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 161632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161635 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 161638 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 161641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 161645 */   // (vselect:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)  =>  (XXSEL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vC, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vA)
     /* 161645 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /* 161648 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 161650 */   GIR_RootToRootCopy, /*OpIdx*/3, // vC
     /* 161652 */   GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 161654 */   GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 161656 */   GIR_RootConstrainSelectedInstOperands,
     /* 161657 */   // GIR_Coverage, 1671,
     /* 161657 */   GIR_EraseRootFromParent_Done,
     /* 161658 */ // Label 2300: @161658
     /* 161658 */ GIM_Try, /*On fail goto*//*Label 2301*/ GIMT_Encode4(161692), // Rule ID 1673 //
     /* 161663 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 161666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161669 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 161672 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 161675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 161679 */   // (vselect:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$vA, v4f32:{ *:[v4f32] }:$vB, v4f32:{ *:[v4f32] }:$vC)  =>  (XXSEL:{ *:[v4f32] } ?:{ *:[v4f32] }:$vC, ?:{ *:[v4f32] }:$vB, ?:{ *:[v4i32] }:$vA)
     /* 161679 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /* 161682 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 161684 */   GIR_RootToRootCopy, /*OpIdx*/3, // vC
     /* 161686 */   GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 161688 */   GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 161690 */   GIR_RootConstrainSelectedInstOperands,
     /* 161691 */   // GIR_Coverage, 1673,
     /* 161691 */   GIR_EraseRootFromParent_Done,
     /* 161692 */ // Label 2301: @161692
     /* 161692 */ GIM_Try, /*On fail goto*//*Label 2302*/ GIMT_Encode4(161717), // Rule ID 10 //
     /* 161697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 161700 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 161703 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 161706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 161710 */   // (select:{ *:[v4i32] } i1:{ *:[i1] }:$cond, v4i32:{ *:[v4i32] }:$T, v4i32:{ *:[v4i32] }:$F)  =>  (SELECT_VRRC:{ *:[v4i32] } i1:{ *:[i1] }:$cond, v4i32:{ *:[v4i32] }:$T, v4i32:{ *:[v4i32] }:$F)
     /* 161710 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SELECT_VRRC),
     /* 161715 */   GIR_RootConstrainSelectedInstOperands,
     /* 161716 */   // GIR_Coverage, 10,
     /* 161716 */   GIR_Done,
     /* 161717 */ // Label 2302: @161717
     /* 161717 */ GIM_Try, /*On fail goto*//*Label 2303*/ GIMT_Encode4(161751), // Rule ID 1425 //
     /* 161722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 161725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161728 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 161731 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 161734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 161738 */   // (vselect:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)  =>  (VSEL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vC, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vA)
     /* 161738 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSEL),
     /* 161741 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /* 161743 */   GIR_RootToRootCopy, /*OpIdx*/3, // vC
     /* 161745 */   GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 161747 */   GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 161749 */   GIR_RootConstrainSelectedInstOperands,
     /* 161750 */   // GIR_Coverage, 1425,
     /* 161750 */   GIR_EraseRootFromParent_Done,
     /* 161751 */ // Label 2303: @161751
     /* 161751 */ GIM_Try, /*On fail goto*//*Label 2304*/ GIMT_Encode4(161785), // Rule ID 1427 //
     /* 161756 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 161759 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161762 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 161765 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 161768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 161772 */   // (vselect:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$vA, v4f32:{ *:[v4f32] }:$vB, v4f32:{ *:[v4f32] }:$vC)  =>  (VSEL:{ *:[v4f32] } ?:{ *:[v4f32] }:$vC, ?:{ *:[v4f32] }:$vB, ?:{ *:[v4i32] }:$vA)
     /* 161772 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSEL),
     /* 161775 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /* 161777 */   GIR_RootToRootCopy, /*OpIdx*/3, // vC
     /* 161779 */   GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 161781 */   GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 161783 */   GIR_RootConstrainSelectedInstOperands,
     /* 161784 */   // GIR_Coverage, 1427,
     /* 161784 */   GIR_EraseRootFromParent_Done,
     /* 161785 */ // Label 2304: @161785
     /* 161785 */ GIM_Reject,
     /* 161786 */ // Label 2278: @161786
     /* 161786 */ GIM_Try, /*On fail goto*//*Label 2305*/ GIMT_Encode4(161934),
     /* 161791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 161794 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 161797 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 161800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 161804 */   GIM_Try, /*On fail goto*//*Label 2306*/ GIMT_Encode4(161912), // Rule ID 1670 //
     /* 161809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 161812 */     // (vselect:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB, v8i16:{ *:[v8i16] }:$vC)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } (XXSEL:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v8i16] }:$vC, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v8i16] }:$vB, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v8i16] }:$vA, VSRC:{ *:[i32] })), VRRC:{ *:[i32] })
     /* 161812 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 161815 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 161819 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161824 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // vA
     /* 161828 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 161833 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 161836 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 161840 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161845 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // vB
     /* 161849 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 161854 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 161857 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 161861 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161866 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // vC
     /* 161870 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 161875 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 161878 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /* 161882 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161887 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 161890 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 161893 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 161896 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 161898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 161901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161903 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 161906 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 161911 */     // GIR_Coverage, 1670,
     /* 161911 */     GIR_EraseRootFromParent_Done,
     /* 161912 */   // Label 2306: @161912
     /* 161912 */   GIM_Try, /*On fail goto*//*Label 2307*/ GIMT_Encode4(161933), // Rule ID 1424 //
     /* 161917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 161920 */     // (vselect:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB, v8i16:{ *:[v8i16] }:$vC)  =>  (VSEL:{ *:[v8i16] } ?:{ *:[v8i16] }:$vC, ?:{ *:[v8i16] }:$vB, ?:{ *:[v8i16] }:$vA)
     /* 161920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSEL),
     /* 161923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /* 161925 */     GIR_RootToRootCopy, /*OpIdx*/3, // vC
     /* 161927 */     GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 161929 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 161931 */     GIR_RootConstrainSelectedInstOperands,
     /* 161932 */     // GIR_Coverage, 1424,
     /* 161932 */     GIR_EraseRootFromParent_Done,
     /* 161933 */   // Label 2307: @161933
     /* 161933 */   GIM_Reject,
     /* 161934 */ // Label 2305: @161934
     /* 161934 */ GIM_Reject,
     /* 161935 */ // Label 2279: @161935
     /* 161935 */ GIM_Try, /*On fail goto*//*Label 2308*/ GIMT_Encode4(162083),
     /* 161940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 161943 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 161946 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 161949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 161953 */   GIM_Try, /*On fail goto*//*Label 2309*/ GIMT_Encode4(162061), // Rule ID 1669 //
     /* 161958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 161961 */     // (vselect:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB, v16i8:{ *:[v16i8] }:$vC)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (XXSEL:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$vC, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$vB, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$vA, VSRC:{ *:[i32] })), VRRC:{ *:[i32] })
     /* 161961 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 161964 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 161968 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161973 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // vA
     /* 161977 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 161982 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 161985 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 161989 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161994 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // vB
     /* 161998 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 162003 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 162006 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 162010 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 162015 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // vC
     /* 162019 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 162024 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 162027 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /* 162031 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 162036 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 162039 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 162042 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 162045 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 162047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 162050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162052 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 162055 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162060 */     // GIR_Coverage, 1669,
     /* 162060 */     GIR_EraseRootFromParent_Done,
     /* 162061 */   // Label 2309: @162061
     /* 162061 */   GIM_Try, /*On fail goto*//*Label 2310*/ GIMT_Encode4(162082), // Rule ID 1423 //
     /* 162066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 162069 */     // (vselect:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB, v16i8:{ *:[v16i8] }:$vC)  =>  (VSEL:{ *:[v16i8] } ?:{ *:[v16i8] }:$vC, ?:{ *:[v16i8] }:$vB, ?:{ *:[v16i8] }:$vA)
     /* 162069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSEL),
     /* 162072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /* 162074 */     GIR_RootToRootCopy, /*OpIdx*/3, // vC
     /* 162076 */     GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 162078 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 162080 */     GIR_RootConstrainSelectedInstOperands,
     /* 162081 */     // GIR_Coverage, 1423,
     /* 162081 */     GIR_EraseRootFromParent_Done,
     /* 162082 */   // Label 2310: @162082
     /* 162082 */   GIM_Reject,
     /* 162083 */ // Label 2308: @162083
     /* 162083 */ GIM_Reject,
     /* 162084 */ // Label 2280: @162084
     /* 162084 */ GIM_Reject,
     /* 162085 */ // Label 34: @162085
     /* 162085 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2315*/ GIMT_Encode4(162214),
     /* 162096 */ /*GILLT_s32*//*Label 2311*/ GIMT_Encode4(162116),
     /* 162100 */ /*GILLT_s64*//*Label 2312*/ GIMT_Encode4(162139), GIMT_Encode4(0),
     /* 162108 */ /*GILLT_v2s64*//*Label 2313*/ GIMT_Encode4(162162),
     /* 162112 */ /*GILLT_v4s32*//*Label 2314*/ GIMT_Encode4(162188),
     /* 162116 */ // Label 2311: @162116
     /* 162116 */ GIM_Try, /*On fail goto*//*Label 2316*/ GIMT_Encode4(162138), // Rule ID 207 //
     /* 162121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 162124 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 162131 */   // (mulhu:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)  =>  (MULHWU:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /* 162131 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MULHWU),
     /* 162136 */   GIR_RootConstrainSelectedInstOperands,
     /* 162137 */   // GIR_Coverage, 207,
     /* 162137 */   GIR_Done,
     /* 162138 */ // Label 2316: @162138
     /* 162138 */ GIM_Reject,
     /* 162139 */ // Label 2312: @162139
     /* 162139 */ GIM_Try, /*On fail goto*//*Label 2317*/ GIMT_Encode4(162161), // Rule ID 677 //
     /* 162144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 162147 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 162154 */   // (mulhu:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)  =>  (MULHDU:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)
     /* 162154 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MULHDU),
     /* 162159 */   GIR_RootConstrainSelectedInstOperands,
     /* 162160 */   // GIR_Coverage, 677,
     /* 162160 */   GIR_Done,
     /* 162161 */ // Label 2317: @162161
     /* 162161 */ GIM_Reject,
     /* 162162 */ // Label 2313: @162162
     /* 162162 */ GIM_Try, /*On fail goto*//*Label 2318*/ GIMT_Encode4(162187), // Rule ID 1128 //
     /* 162167 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 162170 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 162173 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 162176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162180 */   // (mulhu:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMULHUD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /* 162180 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMULHUD),
     /* 162185 */   GIR_RootConstrainSelectedInstOperands,
     /* 162186 */   // GIR_Coverage, 1128,
     /* 162186 */   GIR_Done,
     /* 162187 */ // Label 2318: @162187
     /* 162187 */ GIM_Reject,
     /* 162188 */ // Label 2314: @162188
     /* 162188 */ GIM_Try, /*On fail goto*//*Label 2319*/ GIMT_Encode4(162213), // Rule ID 1126 //
     /* 162193 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 162196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 162199 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162206 */   // (mulhu:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMULHUW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /* 162206 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMULHUW),
     /* 162211 */   GIR_RootConstrainSelectedInstOperands,
     /* 162212 */   // GIR_Coverage, 1126,
     /* 162212 */   GIR_Done,
     /* 162213 */ // Label 2319: @162213
     /* 162213 */ GIM_Reject,
     /* 162214 */ // Label 2315: @162214
     /* 162214 */ GIM_Reject,
     /* 162215 */ // Label 35: @162215
     /* 162215 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2324*/ GIMT_Encode4(162344),
     /* 162226 */ /*GILLT_s32*//*Label 2320*/ GIMT_Encode4(162246),
     /* 162230 */ /*GILLT_s64*//*Label 2321*/ GIMT_Encode4(162269), GIMT_Encode4(0),
     /* 162238 */ /*GILLT_v2s64*//*Label 2322*/ GIMT_Encode4(162292),
     /* 162242 */ /*GILLT_v4s32*//*Label 2323*/ GIMT_Encode4(162318),
     /* 162246 */ // Label 2320: @162246
     /* 162246 */ GIM_Try, /*On fail goto*//*Label 2325*/ GIMT_Encode4(162268), // Rule ID 206 //
     /* 162251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 162254 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 162261 */   // (mulhs:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)  =>  (MULHW:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /* 162261 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MULHW),
     /* 162266 */   GIR_RootConstrainSelectedInstOperands,
     /* 162267 */   // GIR_Coverage, 206,
     /* 162267 */   GIR_Done,
     /* 162268 */ // Label 2325: @162268
     /* 162268 */ GIM_Reject,
     /* 162269 */ // Label 2321: @162269
     /* 162269 */ GIM_Try, /*On fail goto*//*Label 2326*/ GIMT_Encode4(162291), // Rule ID 676 //
     /* 162274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 162277 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 162284 */   // (mulhs:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)  =>  (MULHD:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)
     /* 162284 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MULHD),
     /* 162289 */   GIR_RootConstrainSelectedInstOperands,
     /* 162290 */   // GIR_Coverage, 676,
     /* 162290 */   GIR_Done,
     /* 162291 */ // Label 2326: @162291
     /* 162291 */ GIM_Reject,
     /* 162292 */ // Label 2322: @162292
     /* 162292 */ GIM_Try, /*On fail goto*//*Label 2327*/ GIMT_Encode4(162317), // Rule ID 1127 //
     /* 162297 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 162300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 162303 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 162306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162310 */   // (mulhs:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMULHSD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /* 162310 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMULHSD),
     /* 162315 */   GIR_RootConstrainSelectedInstOperands,
     /* 162316 */   // GIR_Coverage, 1127,
     /* 162316 */   GIR_Done,
     /* 162317 */ // Label 2327: @162317
     /* 162317 */ GIM_Reject,
     /* 162318 */ // Label 2323: @162318
     /* 162318 */ GIM_Try, /*On fail goto*//*Label 2328*/ GIMT_Encode4(162343), // Rule ID 1125 //
     /* 162323 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 162326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 162329 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162336 */   // (mulhs:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMULHSW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /* 162336 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMULHSW),
     /* 162341 */   GIR_RootConstrainSelectedInstOperands,
     /* 162342 */   // GIR_Coverage, 1125,
     /* 162342 */   GIR_Done,
     /* 162343 */ // Label 2328: @162343
     /* 162343 */ GIM_Reject,
     /* 162344 */ // Label 2324: @162344
     /* 162344 */ GIM_Reject,
     /* 162345 */ // Label 36: @162345
     /* 162345 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(8), /*)*//*default:*//*Label 2332*/ GIMT_Encode4(162446),
     /* 162356 */ /*GILLT_v4s32*//*Label 2329*/ GIMT_Encode4(162368),
     /* 162360 */ /*GILLT_v8s16*//*Label 2330*/ GIMT_Encode4(162394),
     /* 162364 */ /*GILLT_v16s8*//*Label 2331*/ GIMT_Encode4(162420),
     /* 162368 */ // Label 2329: @162368
     /* 162368 */ GIM_Try, /*On fail goto*//*Label 2333*/ GIMT_Encode4(162393), // Rule ID 1302 //
     /* 162373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 162376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 162379 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162386 */   // (uaddsat:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)  =>  (VADDUWS:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB)
     /* 162386 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDUWS),
     /* 162391 */   GIR_RootConstrainSelectedInstOperands,
     /* 162392 */   // GIR_Coverage, 1302,
     /* 162392 */   GIR_Done,
     /* 162393 */ // Label 2333: @162393
     /* 162393 */ GIM_Reject,
     /* 162394 */ // Label 2330: @162394
     /* 162394 */ GIM_Try, /*On fail goto*//*Label 2334*/ GIMT_Encode4(162419), // Rule ID 1300 //
     /* 162399 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 162402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 162405 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162412 */   // (uaddsat:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB)  =>  (VADDUHS:{ *:[v8i16] } ?:{ *:[v8i16] }:$vA, ?:{ *:[v8i16] }:$vB)
     /* 162412 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDUHS),
     /* 162417 */   GIR_RootConstrainSelectedInstOperands,
     /* 162418 */   // GIR_Coverage, 1300,
     /* 162418 */   GIR_Done,
     /* 162419 */ // Label 2334: @162419
     /* 162419 */ GIM_Reject,
     /* 162420 */ // Label 2331: @162420
     /* 162420 */ GIM_Try, /*On fail goto*//*Label 2335*/ GIMT_Encode4(162445), // Rule ID 1298 //
     /* 162425 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 162428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 162431 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 162434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162438 */   // (uaddsat:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB)  =>  (VADDUBS:{ *:[v16i8] } ?:{ *:[v16i8] }:$vA, ?:{ *:[v16i8] }:$vB)
     /* 162438 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDUBS),
     /* 162443 */   GIR_RootConstrainSelectedInstOperands,
     /* 162444 */   // GIR_Coverage, 1298,
     /* 162444 */   GIR_Done,
     /* 162445 */ // Label 2335: @162445
     /* 162445 */ GIM_Reject,
     /* 162446 */ // Label 2332: @162446
     /* 162446 */ GIM_Reject,
     /* 162447 */ // Label 37: @162447
     /* 162447 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(8), /*)*//*default:*//*Label 2339*/ GIMT_Encode4(162548),
     /* 162458 */ /*GILLT_v4s32*//*Label 2336*/ GIMT_Encode4(162470),
     /* 162462 */ /*GILLT_v8s16*//*Label 2337*/ GIMT_Encode4(162496),
     /* 162466 */ /*GILLT_v16s8*//*Label 2338*/ GIMT_Encode4(162522),
     /* 162470 */ // Label 2336: @162470
     /* 162470 */ GIM_Try, /*On fail goto*//*Label 2340*/ GIMT_Encode4(162495), // Rule ID 1301 //
     /* 162475 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 162478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 162481 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162488 */   // (saddsat:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)  =>  (VADDSWS:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB)
     /* 162488 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDSWS),
     /* 162493 */   GIR_RootConstrainSelectedInstOperands,
     /* 162494 */   // GIR_Coverage, 1301,
     /* 162494 */   GIR_Done,
     /* 162495 */ // Label 2340: @162495
     /* 162495 */ GIM_Reject,
     /* 162496 */ // Label 2337: @162496
     /* 162496 */ GIM_Try, /*On fail goto*//*Label 2341*/ GIMT_Encode4(162521), // Rule ID 1299 //
     /* 162501 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 162504 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 162507 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162514 */   // (saddsat:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB)  =>  (VADDSHS:{ *:[v8i16] } ?:{ *:[v8i16] }:$vA, ?:{ *:[v8i16] }:$vB)
     /* 162514 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDSHS),
     /* 162519 */   GIR_RootConstrainSelectedInstOperands,
     /* 162520 */   // GIR_Coverage, 1299,
     /* 162520 */   GIR_Done,
     /* 162521 */ // Label 2341: @162521
     /* 162521 */ GIM_Reject,
     /* 162522 */ // Label 2338: @162522
     /* 162522 */ GIM_Try, /*On fail goto*//*Label 2342*/ GIMT_Encode4(162547), // Rule ID 1297 //
     /* 162527 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 162530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 162533 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 162536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162540 */   // (saddsat:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB)  =>  (VADDSBS:{ *:[v16i8] } ?:{ *:[v16i8] }:$vA, ?:{ *:[v16i8] }:$vB)
     /* 162540 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDSBS),
     /* 162545 */   GIR_RootConstrainSelectedInstOperands,
     /* 162546 */   // GIR_Coverage, 1297,
     /* 162546 */   GIR_Done,
     /* 162547 */ // Label 2342: @162547
     /* 162547 */ GIM_Reject,
     /* 162548 */ // Label 2339: @162548
     /* 162548 */ GIM_Reject,
     /* 162549 */ // Label 38: @162549
     /* 162549 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(8), /*)*//*default:*//*Label 2346*/ GIMT_Encode4(162650),
     /* 162560 */ /*GILLT_v4s32*//*Label 2343*/ GIMT_Encode4(162572),
     /* 162564 */ /*GILLT_v8s16*//*Label 2344*/ GIMT_Encode4(162598),
     /* 162568 */ /*GILLT_v16s8*//*Label 2345*/ GIMT_Encode4(162624),
     /* 162572 */ // Label 2343: @162572
     /* 162572 */ GIM_Try, /*On fail goto*//*Label 2347*/ GIMT_Encode4(162597), // Rule ID 1308 //
     /* 162577 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 162580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 162583 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162590 */   // (usubsat:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)  =>  (VSUBUWS:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB)
     /* 162590 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBUWS),
     /* 162595 */   GIR_RootConstrainSelectedInstOperands,
     /* 162596 */   // GIR_Coverage, 1308,
     /* 162596 */   GIR_Done,
     /* 162597 */ // Label 2347: @162597
     /* 162597 */ GIM_Reject,
     /* 162598 */ // Label 2344: @162598
     /* 162598 */ GIM_Try, /*On fail goto*//*Label 2348*/ GIMT_Encode4(162623), // Rule ID 1306 //
     /* 162603 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 162606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 162609 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162616 */   // (usubsat:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB)  =>  (VSUBUHS:{ *:[v8i16] } ?:{ *:[v8i16] }:$vA, ?:{ *:[v8i16] }:$vB)
     /* 162616 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBUHS),
     /* 162621 */   GIR_RootConstrainSelectedInstOperands,
     /* 162622 */   // GIR_Coverage, 1306,
     /* 162622 */   GIR_Done,
     /* 162623 */ // Label 2348: @162623
     /* 162623 */ GIM_Reject,
     /* 162624 */ // Label 2345: @162624
     /* 162624 */ GIM_Try, /*On fail goto*//*Label 2349*/ GIMT_Encode4(162649), // Rule ID 1304 //
     /* 162629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 162632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 162635 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 162638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162642 */   // (usubsat:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB)  =>  (VSUBUBS:{ *:[v16i8] } ?:{ *:[v16i8] }:$vA, ?:{ *:[v16i8] }:$vB)
     /* 162642 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBUBS),
     /* 162647 */   GIR_RootConstrainSelectedInstOperands,
     /* 162648 */   // GIR_Coverage, 1304,
     /* 162648 */   GIR_Done,
     /* 162649 */ // Label 2349: @162649
     /* 162649 */ GIM_Reject,
     /* 162650 */ // Label 2346: @162650
     /* 162650 */ GIM_Reject,
     /* 162651 */ // Label 39: @162651
     /* 162651 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(8), /*)*//*default:*//*Label 2353*/ GIMT_Encode4(162752),
     /* 162662 */ /*GILLT_v4s32*//*Label 2350*/ GIMT_Encode4(162674),
     /* 162666 */ /*GILLT_v8s16*//*Label 2351*/ GIMT_Encode4(162700),
     /* 162670 */ /*GILLT_v16s8*//*Label 2352*/ GIMT_Encode4(162726),
     /* 162674 */ // Label 2350: @162674
     /* 162674 */ GIM_Try, /*On fail goto*//*Label 2354*/ GIMT_Encode4(162699), // Rule ID 1307 //
     /* 162679 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 162682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 162685 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162692 */   // (ssubsat:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)  =>  (VSUBSWS:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB)
     /* 162692 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBSWS),
     /* 162697 */   GIR_RootConstrainSelectedInstOperands,
     /* 162698 */   // GIR_Coverage, 1307,
     /* 162698 */   GIR_Done,
     /* 162699 */ // Label 2354: @162699
     /* 162699 */ GIM_Reject,
     /* 162700 */ // Label 2351: @162700
     /* 162700 */ GIM_Try, /*On fail goto*//*Label 2355*/ GIMT_Encode4(162725), // Rule ID 1305 //
     /* 162705 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 162708 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 162711 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162718 */   // (ssubsat:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB)  =>  (VSUBSHS:{ *:[v8i16] } ?:{ *:[v8i16] }:$vA, ?:{ *:[v8i16] }:$vB)
     /* 162718 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBSHS),
     /* 162723 */   GIR_RootConstrainSelectedInstOperands,
     /* 162724 */   // GIR_Coverage, 1305,
     /* 162724 */   GIR_Done,
     /* 162725 */ // Label 2355: @162725
     /* 162725 */ GIM_Reject,
     /* 162726 */ // Label 2352: @162726
     /* 162726 */ GIM_Try, /*On fail goto*//*Label 2356*/ GIMT_Encode4(162751), // Rule ID 1303 //
     /* 162731 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 162734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 162737 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 162740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162744 */   // (ssubsat:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB)  =>  (VSUBSBS:{ *:[v16i8] } ?:{ *:[v16i8] }:$vA, ?:{ *:[v16i8] }:$vB)
     /* 162744 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBSBS),
     /* 162749 */   GIR_RootConstrainSelectedInstOperands,
     /* 162750 */   // GIR_Coverage, 1303,
     /* 162750 */   GIR_Done,
     /* 162751 */ // Label 2356: @162751
     /* 162751 */ GIM_Reject,
     /* 162752 */ // Label 2353: @162752
     /* 162752 */ GIM_Reject,
     /* 162753 */ // Label 40: @162753
     /* 162753 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2362*/ GIMT_Encode4(163047),
     /* 162764 */ /*GILLT_s32*//*Label 2357*/ GIMT_Encode4(162784),
     /* 162768 */ /*GILLT_s64*//*Label 2358*/ GIMT_Encode4(162858),
     /* 162772 */ /*GILLT_s128*//*Label 2359*/ GIMT_Encode4(162936),
     /* 162776 */ /*GILLT_v2s64*//*Label 2360*/ GIMT_Encode4(162962),
     /* 162780 */ /*GILLT_v4s32*//*Label 2361*/ GIMT_Encode4(162992),
     /* 162784 */ // Label 2357: @162784
     /* 162784 */ GIM_Try, /*On fail goto*//*Label 2363*/ GIMT_Encode4(162857),
     /* 162789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 162792 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162795 */   GIM_Try, /*On fail goto*//*Label 2364*/ GIMT_Encode4(162814), // Rule ID 953 //
     /* 162800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 162803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 162807 */     // (fadd:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)  =>  (XSADDSP:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 162807 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSADDSP),
     /* 162812 */     GIR_RootConstrainSelectedInstOperands,
     /* 162813 */     // GIR_Coverage, 953,
     /* 162813 */     GIR_Done,
     /* 162814 */   // Label 2364: @162814
     /* 162814 */   GIM_Try, /*On fail goto*//*Label 2365*/ GIMT_Encode4(162837), // Rule ID 239 //
     /* 162819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 162822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 162826 */     // (fadd:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)  =>  (FADDS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)
     /* 162826 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FADDS),
     /* 162831 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 162835 */     GIR_RootConstrainSelectedInstOperands,
     /* 162836 */     // GIR_Coverage, 239,
     /* 162836 */     GIR_Done,
     /* 162837 */   // Label 2365: @162837
     /* 162837 */   GIM_Try, /*On fail goto*//*Label 2366*/ GIMT_Encode4(162856), // Rule ID 583 //
     /* 162842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 162845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 162849 */     // (fadd:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)  =>  (EFSADD:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)
     /* 162849 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSADD),
     /* 162854 */     GIR_RootConstrainSelectedInstOperands,
     /* 162855 */     // GIR_Coverage, 583,
     /* 162855 */     GIR_Done,
     /* 162856 */   // Label 2366: @162856
     /* 162856 */   GIM_Reject,
     /* 162857 */ // Label 2363: @162857
     /* 162857 */ GIM_Reject,
     /* 162858 */ // Label 2358: @162858
     /* 162858 */ GIM_Try, /*On fail goto*//*Label 2367*/ GIMT_Encode4(162935),
     /* 162863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 162866 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162869 */   GIM_Try, /*On fail goto*//*Label 2368*/ GIMT_Encode4(162892), // Rule ID 770 //
     /* 162874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 162877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 162881 */     // (fadd:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)  =>  (XSADDDP:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 162881 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSADDDP),
     /* 162886 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 162890 */     GIR_RootConstrainSelectedInstOperands,
     /* 162891 */     // GIR_Coverage, 770,
     /* 162891 */     GIR_Done,
     /* 162892 */   // Label 2368: @162892
     /* 162892 */   GIM_Try, /*On fail goto*//*Label 2369*/ GIMT_Encode4(162915), // Rule ID 237 //
     /* 162897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 162900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 162904 */     // (fadd:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)  =>  (FADD:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)
     /* 162904 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FADD),
     /* 162909 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 162913 */     GIR_RootConstrainSelectedInstOperands,
     /* 162914 */     // GIR_Coverage, 237,
     /* 162914 */     GIR_Done,
     /* 162915 */   // Label 2369: @162915
     /* 162915 */   GIM_Try, /*On fail goto*//*Label 2370*/ GIMT_Encode4(162934), // Rule ID 562 //
     /* 162920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 162923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 162927 */     // (fadd:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)  =>  (EFDADD:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)
     /* 162927 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDADD),
     /* 162932 */     GIR_RootConstrainSelectedInstOperands,
     /* 162933 */     // GIR_Coverage, 562,
     /* 162933 */     GIR_Done,
     /* 162934 */   // Label 2370: @162934
     /* 162934 */   GIM_Reject,
     /* 162935 */ // Label 2367: @162935
     /* 162935 */ GIM_Reject,
     /* 162936 */ // Label 2359: @162936
     /* 162936 */ GIM_Try, /*On fail goto*//*Label 2371*/ GIMT_Encode4(162961), // Rule ID 988 //
     /* 162941 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 162944 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 162947 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 162950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162954 */   // (fadd:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSADDQP:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 162954 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSADDQP),
     /* 162959 */   GIR_RootConstrainSelectedInstOperands,
     /* 162960 */   // GIR_Coverage, 988,
     /* 162960 */   GIR_Done,
     /* 162961 */ // Label 2371: @162961
     /* 162961 */ GIM_Reject,
     /* 162962 */ // Label 2360: @162962
     /* 162962 */ GIM_Try, /*On fail goto*//*Label 2372*/ GIMT_Encode4(162991), // Rule ID 774 //
     /* 162967 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 162970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 162973 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 162976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 162980 */   // (fadd:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)  =>  (XVADDDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 162980 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVADDDP),
     /* 162985 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 162989 */   GIR_RootConstrainSelectedInstOperands,
     /* 162990 */   // GIR_Coverage, 774,
     /* 162990 */   GIR_Done,
     /* 162991 */ // Label 2372: @162991
     /* 162991 */ GIM_Reject,
     /* 162992 */ // Label 2361: @162992
     /* 162992 */ GIM_Try, /*On fail goto*//*Label 2373*/ GIMT_Encode4(163046),
     /* 162997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 163000 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163003 */   GIM_Try, /*On fail goto*//*Label 2374*/ GIMT_Encode4(163026), // Rule ID 776 //
     /* 163008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 163011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 163015 */     // (fadd:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)  =>  (XVADDSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 163015 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVADDSP),
     /* 163020 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 163024 */     GIR_RootConstrainSelectedInstOperands,
     /* 163025 */     // GIR_Coverage, 776,
     /* 163025 */     GIR_Done,
     /* 163026 */   // Label 2374: @163026
     /* 163026 */   GIM_Try, /*On fail goto*//*Label 2375*/ GIMT_Encode4(163045), // Rule ID 300 //
     /* 163031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 163034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 163038 */     // (fadd:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VA, v4f32:{ *:[v4f32] }:$VB)  =>  (VADDFP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VA, v4f32:{ *:[v4f32] }:$VB)
     /* 163038 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDFP),
     /* 163043 */     GIR_RootConstrainSelectedInstOperands,
     /* 163044 */     // GIR_Coverage, 300,
     /* 163044 */     GIR_Done,
     /* 163045 */   // Label 2375: @163045
     /* 163045 */   GIM_Reject,
     /* 163046 */ // Label 2373: @163046
     /* 163046 */ GIM_Reject,
     /* 163047 */ // Label 2362: @163047
     /* 163047 */ GIM_Reject,
     /* 163048 */ // Label 41: @163048
     /* 163048 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2381*/ GIMT_Encode4(163342),
     /* 163059 */ /*GILLT_s32*//*Label 2376*/ GIMT_Encode4(163079),
     /* 163063 */ /*GILLT_s64*//*Label 2377*/ GIMT_Encode4(163153),
     /* 163067 */ /*GILLT_s128*//*Label 2378*/ GIMT_Encode4(163231),
     /* 163071 */ /*GILLT_v2s64*//*Label 2379*/ GIMT_Encode4(163257),
     /* 163075 */ /*GILLT_v4s32*//*Label 2380*/ GIMT_Encode4(163287),
     /* 163079 */ // Label 2376: @163079
     /* 163079 */ GIM_Try, /*On fail goto*//*Label 2382*/ GIMT_Encode4(163152),
     /* 163084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 163087 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 163090 */   GIM_Try, /*On fail goto*//*Label 2383*/ GIMT_Encode4(163109), // Rule ID 957 //
     /* 163095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 163098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 163102 */     // (fsub:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)  =>  (XSSUBSP:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 163102 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSUBSP),
     /* 163107 */     GIR_RootConstrainSelectedInstOperands,
     /* 163108 */     // GIR_Coverage, 957,
     /* 163108 */     GIR_Done,
     /* 163109 */   // Label 2383: @163109
     /* 163109 */   GIM_Try, /*On fail goto*//*Label 2384*/ GIMT_Encode4(163132), // Rule ID 251 //
     /* 163114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 163117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 163121 */     // (fsub:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)  =>  (FSUBS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)
     /* 163121 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FSUBS),
     /* 163126 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 163130 */     GIR_RootConstrainSelectedInstOperands,
     /* 163131 */     // GIR_Coverage, 251,
     /* 163131 */     GIR_Done,
     /* 163132 */   // Label 2384: @163132
     /* 163132 */   GIM_Try, /*On fail goto*//*Label 2385*/ GIMT_Encode4(163151), // Rule ID 601 //
     /* 163137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 163140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 163144 */     // (fsub:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)  =>  (EFSSUB:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)
     /* 163144 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSSUB),
     /* 163149 */     GIR_RootConstrainSelectedInstOperands,
     /* 163150 */     // GIR_Coverage, 601,
     /* 163150 */     GIR_Done,
     /* 163151 */   // Label 2385: @163151
     /* 163151 */   GIM_Reject,
     /* 163152 */ // Label 2382: @163152
     /* 163152 */ GIM_Reject,
     /* 163153 */ // Label 2377: @163153
     /* 163153 */ GIM_Try, /*On fail goto*//*Label 2386*/ GIMT_Encode4(163230),
     /* 163158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 163161 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163164 */   GIM_Try, /*On fail goto*//*Label 2387*/ GIMT_Encode4(163187), // Rule ID 782 //
     /* 163169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 163172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 163176 */     // (fsub:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)  =>  (XSSUBDP:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 163176 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSUBDP),
     /* 163181 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 163185 */     GIR_RootConstrainSelectedInstOperands,
     /* 163186 */     // GIR_Coverage, 782,
     /* 163186 */     GIR_Done,
     /* 163187 */   // Label 2387: @163187
     /* 163187 */   GIM_Try, /*On fail goto*//*Label 2388*/ GIMT_Encode4(163210), // Rule ID 249 //
     /* 163192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 163195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 163199 */     // (fsub:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)  =>  (FSUB:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)
     /* 163199 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FSUB),
     /* 163204 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 163208 */     GIR_RootConstrainSelectedInstOperands,
     /* 163209 */     // GIR_Coverage, 249,
     /* 163209 */     GIR_Done,
     /* 163210 */   // Label 2388: @163210
     /* 163210 */   GIM_Try, /*On fail goto*//*Label 2389*/ GIMT_Encode4(163229), // Rule ID 580 //
     /* 163215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 163218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 163222 */     // (fsub:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)  =>  (EFDSUB:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)
     /* 163222 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDSUB),
     /* 163227 */     GIR_RootConstrainSelectedInstOperands,
     /* 163228 */     // GIR_Coverage, 580,
     /* 163228 */     GIR_Done,
     /* 163229 */   // Label 2389: @163229
     /* 163229 */   GIM_Reject,
     /* 163230 */ // Label 2386: @163230
     /* 163230 */ GIM_Reject,
     /* 163231 */ // Label 2378: @163231
     /* 163231 */ GIM_Try, /*On fail goto*//*Label 2390*/ GIMT_Encode4(163256), // Rule ID 992 //
     /* 163236 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 163239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 163242 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 163245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 163249 */   // (fsub:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSSUBQP:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 163249 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSUBQP),
     /* 163254 */   GIR_RootConstrainSelectedInstOperands,
     /* 163255 */   // GIR_Coverage, 992,
     /* 163255 */   GIR_Done,
     /* 163256 */ // Label 2390: @163256
     /* 163256 */ GIM_Reject,
     /* 163257 */ // Label 2379: @163257
     /* 163257 */ GIM_Try, /*On fail goto*//*Label 2391*/ GIMT_Encode4(163286), // Rule ID 784 //
     /* 163262 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 163265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 163268 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 163275 */   // (fsub:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)  =>  (XVSUBDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 163275 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVSUBDP),
     /* 163280 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 163284 */   GIR_RootConstrainSelectedInstOperands,
     /* 163285 */   // GIR_Coverage, 784,
     /* 163285 */   GIR_Done,
     /* 163286 */ // Label 2391: @163286
     /* 163286 */ GIM_Reject,
     /* 163287 */ // Label 2380: @163287
     /* 163287 */ GIM_Try, /*On fail goto*//*Label 2392*/ GIMT_Encode4(163341),
     /* 163292 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 163295 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163298 */   GIM_Try, /*On fail goto*//*Label 2393*/ GIMT_Encode4(163321), // Rule ID 786 //
     /* 163303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 163306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 163310 */     // (fsub:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)  =>  (XVSUBSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 163310 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVSUBSP),
     /* 163315 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 163319 */     GIR_RootConstrainSelectedInstOperands,
     /* 163320 */     // GIR_Coverage, 786,
     /* 163320 */     GIR_Done,
     /* 163321 */   // Label 2393: @163321
     /* 163321 */   GIM_Try, /*On fail goto*//*Label 2394*/ GIMT_Encode4(163340), // Rule ID 370 //
     /* 163326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 163329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 163333 */     // (fsub:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VA, v4f32:{ *:[v4f32] }:$VB)  =>  (VSUBFP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VA, v4f32:{ *:[v4f32] }:$VB)
     /* 163333 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBFP),
     /* 163338 */     GIR_RootConstrainSelectedInstOperands,
     /* 163339 */     // GIR_Coverage, 370,
     /* 163339 */     GIR_Done,
     /* 163340 */   // Label 2394: @163340
     /* 163340 */   GIM_Reject,
     /* 163341 */ // Label 2392: @163341
     /* 163341 */ GIM_Reject,
     /* 163342 */ // Label 2381: @163342
     /* 163342 */ GIM_Reject,
     /* 163343 */ // Label 42: @163343
     /* 163343 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2400*/ GIMT_Encode4(163692),
     /* 163354 */ /*GILLT_s32*//*Label 2395*/ GIMT_Encode4(163374),
     /* 163358 */ /*GILLT_s64*//*Label 2396*/ GIMT_Encode4(163448),
     /* 163362 */ /*GILLT_s128*//*Label 2397*/ GIMT_Encode4(163526),
     /* 163366 */ /*GILLT_v2s64*//*Label 2398*/ GIMT_Encode4(163552),
     /* 163370 */ /*GILLT_v4s32*//*Label 2399*/ GIMT_Encode4(163582),
     /* 163374 */ // Label 2395: @163374
     /* 163374 */ GIM_Try, /*On fail goto*//*Label 2401*/ GIMT_Encode4(163447),
     /* 163379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 163382 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 163385 */   GIM_Try, /*On fail goto*//*Label 2402*/ GIMT_Encode4(163404), // Rule ID 955 //
     /* 163390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 163393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 163397 */     // (fmul:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)  =>  (XSMULSP:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 163397 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSMULSP),
     /* 163402 */     GIR_RootConstrainSelectedInstOperands,
     /* 163403 */     // GIR_Coverage, 955,
     /* 163403 */     GIR_Done,
     /* 163404 */   // Label 2402: @163404
     /* 163404 */   GIM_Try, /*On fail goto*//*Label 2403*/ GIMT_Encode4(163427), // Rule ID 247 //
     /* 163409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 163412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 163416 */     // (fmul:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC)  =>  (FMULS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC)
     /* 163416 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FMULS),
     /* 163421 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 163425 */     GIR_RootConstrainSelectedInstOperands,
     /* 163426 */     // GIR_Coverage, 247,
     /* 163426 */     GIR_Done,
     /* 163427 */   // Label 2403: @163427
     /* 163427 */   GIM_Try, /*On fail goto*//*Label 2404*/ GIMT_Encode4(163446), // Rule ID 597 //
     /* 163432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 163435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 163439 */     // (fmul:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)  =>  (EFSMUL:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)
     /* 163439 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSMUL),
     /* 163444 */     GIR_RootConstrainSelectedInstOperands,
     /* 163445 */     // GIR_Coverage, 597,
     /* 163445 */     GIR_Done,
     /* 163446 */   // Label 2404: @163446
     /* 163446 */   GIM_Reject,
     /* 163447 */ // Label 2401: @163447
     /* 163447 */ GIM_Reject,
     /* 163448 */ // Label 2396: @163448
     /* 163448 */ GIM_Try, /*On fail goto*//*Label 2405*/ GIMT_Encode4(163525),
     /* 163453 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 163456 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163459 */   GIM_Try, /*On fail goto*//*Label 2406*/ GIMT_Encode4(163482), // Rule ID 772 //
     /* 163464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 163467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 163471 */     // (fmul:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)  =>  (XSMULDP:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 163471 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSMULDP),
     /* 163476 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 163480 */     GIR_RootConstrainSelectedInstOperands,
     /* 163481 */     // GIR_Coverage, 772,
     /* 163481 */     GIR_Done,
     /* 163482 */   // Label 2406: @163482
     /* 163482 */   GIM_Try, /*On fail goto*//*Label 2407*/ GIMT_Encode4(163505), // Rule ID 245 //
     /* 163487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 163490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 163494 */     // (fmul:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC)  =>  (FMUL:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC)
     /* 163494 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FMUL),
     /* 163499 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 163503 */     GIR_RootConstrainSelectedInstOperands,
     /* 163504 */     // GIR_Coverage, 245,
     /* 163504 */     GIR_Done,
     /* 163505 */   // Label 2407: @163505
     /* 163505 */   GIM_Try, /*On fail goto*//*Label 2408*/ GIMT_Encode4(163524), // Rule ID 576 //
     /* 163510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 163513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 163517 */     // (fmul:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)  =>  (EFDMUL:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)
     /* 163517 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDMUL),
     /* 163522 */     GIR_RootConstrainSelectedInstOperands,
     /* 163523 */     // GIR_Coverage, 576,
     /* 163523 */     GIR_Done,
     /* 163524 */   // Label 2408: @163524
     /* 163524 */   GIM_Reject,
     /* 163525 */ // Label 2405: @163525
     /* 163525 */ GIM_Reject,
     /* 163526 */ // Label 2397: @163526
     /* 163526 */ GIM_Try, /*On fail goto*//*Label 2409*/ GIMT_Encode4(163551), // Rule ID 990 //
     /* 163531 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 163534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 163537 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 163540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 163544 */   // (fmul:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSMULQP:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 163544 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSMULQP),
     /* 163549 */   GIR_RootConstrainSelectedInstOperands,
     /* 163550 */   // GIR_Coverage, 990,
     /* 163550 */   GIR_Done,
     /* 163551 */ // Label 2409: @163551
     /* 163551 */ GIM_Reject,
     /* 163552 */ // Label 2398: @163552
     /* 163552 */ GIM_Try, /*On fail goto*//*Label 2410*/ GIMT_Encode4(163581), // Rule ID 778 //
     /* 163557 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 163560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 163563 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 163570 */   // (fmul:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)  =>  (XVMULDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 163570 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVMULDP),
     /* 163575 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 163579 */   GIR_RootConstrainSelectedInstOperands,
     /* 163580 */   // GIR_Coverage, 778,
     /* 163580 */   GIR_Done,
     /* 163581 */ // Label 2410: @163581
     /* 163581 */ GIM_Reject,
     /* 163582 */ // Label 2399: @163582
     /* 163582 */ GIM_Try, /*On fail goto*//*Label 2411*/ GIMT_Encode4(163691),
     /* 163587 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 163590 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163593 */   GIM_Try, /*On fail goto*//*Label 2412*/ GIMT_Encode4(163616), // Rule ID 780 //
     /* 163598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 163601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 163605 */     // (fmul:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)  =>  (XVMULSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 163605 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVMULSP),
     /* 163610 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 163614 */     GIR_RootConstrainSelectedInstOperands,
     /* 163615 */     // GIR_Coverage, 780,
     /* 163615 */     GIR_Done,
     /* 163616 */   // Label 2412: @163616
     /* 163616 */   GIM_Try, /*On fail goto*//*Label 2413*/ GIMT_Encode4(163690), // Rule ID 1385 //
     /* 163621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 163624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 163628 */     // (fmul:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$vA, v4f32:{ *:[v4f32] }:$vB)  =>  (VMADDFP:{ *:[v4f32] } ?:{ *:[v4f32] }:$vA, ?:{ *:[v4f32] }:$vB, (VSLW:{ *:[v4i32] } (V_SETALLONES:{ *:[v4i32] }), (V_SETALLONES:{ *:[v4i32] })))
     /* 163628 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 163631 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::V_SETALLONES),
     /* 163635 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 163640 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 163642 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 163645 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::V_SETALLONES),
     /* 163649 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 163654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 163656 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 163659 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::VSLW),
     /* 163663 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 163668 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 163671 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 163674 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 163676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMADDFP),
     /* 163679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /* 163681 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 163683 */     GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 163685 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 163688 */     GIR_RootConstrainSelectedInstOperands,
     /* 163689 */     // GIR_Coverage, 1385,
     /* 163689 */     GIR_EraseRootFromParent_Done,
     /* 163690 */   // Label 2413: @163690
     /* 163690 */   GIM_Reject,
     /* 163691 */ // Label 2411: @163691
     /* 163691 */ GIM_Reject,
     /* 163692 */ // Label 2400: @163692
     /* 163692 */ GIM_Reject,
     /* 163693 */ // Label 43: @163693
     /* 163693 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2419*/ GIMT_Encode4(164273),
     /* 163704 */ /*GILLT_s32*//*Label 2414*/ GIMT_Encode4(163724),
     /* 163708 */ /*GILLT_s64*//*Label 2415*/ GIMT_Encode4(163870),
     /* 163712 */ /*GILLT_s128*//*Label 2416*/ GIMT_Encode4(164016),
     /* 163716 */ /*GILLT_v2s64*//*Label 2417*/ GIMT_Encode4(164094),
     /* 163720 */ /*GILLT_v4s32*//*Label 2418*/ GIMT_Encode4(164172),
     /* 163724 */ // Label 2414: @163724
     /* 163724 */ GIM_Try, /*On fail goto*//*Label 2420*/ GIMT_Encode4(163869),
     /* 163729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 163732 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 163735 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163738 */   GIM_Try, /*On fail goto*//*Label 2421*/ GIMT_Encode4(163779), // Rule ID 969 //
     /* 163743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 163746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 163750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 163758 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 163762 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163764 */     // (fma:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB, (fneg:{ *:[f32] } f32:{ *:[f32] }:$XTi))  =>  (XSMSUBASP:{ *:[f32] } f32:{ *:[f32] }:$XTi, f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 163764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMSUBASP),
     /* 163767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 163769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XTi
     /* 163773 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 163775 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 163777 */     GIR_RootConstrainSelectedInstOperands,
     /* 163778 */     // GIR_Coverage, 969,
     /* 163778 */     GIR_EraseRootFromParent_Done,
     /* 163779 */   // Label 2421: @163779
     /* 163779 */   GIM_Try, /*On fail goto*//*Label 2422*/ GIMT_Encode4(163804), // Rule ID 967 //
     /* 163784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 163787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 163791 */     // (fma:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB, f32:{ *:[f32] }:$XTi)  =>  (XSMADDASP:{ *:[f32] } f32:{ *:[f32] }:$XTi, f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 163791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMADDASP),
     /* 163794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 163796 */     GIR_RootToRootCopy, /*OpIdx*/3, // XTi
     /* 163798 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 163800 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 163802 */     GIR_RootConstrainSelectedInstOperands,
     /* 163803 */     // GIR_Coverage, 967,
     /* 163803 */     GIR_EraseRootFromParent_Done,
     /* 163804 */   // Label 2422: @163804
     /* 163804 */   GIM_Try, /*On fail goto*//*Label 2423*/ GIMT_Encode4(163845), // Rule ID 225 //
     /* 163809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 163812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 163816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 163824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 163828 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163830 */     // (fma:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, (fneg:{ *:[f32] } f32:{ *:[f32] }:$FRB))  =>  (FMSUBS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB)
     /* 163830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FMSUBS),
     /* 163833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 163835 */     GIR_RootToRootCopy, /*OpIdx*/1, // FRA
     /* 163837 */     GIR_RootToRootCopy, /*OpIdx*/2, // FRC
     /* 163839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRB
     /* 163843 */     GIR_RootConstrainSelectedInstOperands,
     /* 163844 */     // GIR_Coverage, 225,
     /* 163844 */     GIR_EraseRootFromParent_Done,
     /* 163845 */   // Label 2423: @163845
     /* 163845 */   GIM_Try, /*On fail goto*//*Label 2424*/ GIMT_Encode4(163868), // Rule ID 221 //
     /* 163850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 163853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 163857 */     // (fma:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB)  =>  (FMADDS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB)
     /* 163857 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FMADDS),
     /* 163862 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 163866 */     GIR_RootConstrainSelectedInstOperands,
     /* 163867 */     // GIR_Coverage, 221,
     /* 163867 */     GIR_Done,
     /* 163868 */   // Label 2424: @163868
     /* 163868 */   GIM_Reject,
     /* 163869 */ // Label 2420: @163869
     /* 163869 */ GIM_Reject,
     /* 163870 */ // Label 2415: @163870
     /* 163870 */ GIM_Try, /*On fail goto*//*Label 2425*/ GIMT_Encode4(164015),
     /* 163875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 163878 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163881 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 163884 */   GIM_Try, /*On fail goto*//*Label 2426*/ GIMT_Encode4(163925), // Rule ID 790 //
     /* 163889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 163892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 163896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 163904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 163908 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163910 */     // (fma:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB, (fneg:{ *:[f64] } f64:{ *:[f64] }:$XTi))  =>  (XSMSUBADP:{ *:[f64] } f64:{ *:[f64] }:$XTi, f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 163910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMSUBADP),
     /* 163913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 163915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XTi
     /* 163919 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 163921 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 163923 */     GIR_RootConstrainSelectedInstOperands,
     /* 163924 */     // GIR_Coverage, 790,
     /* 163924 */     GIR_EraseRootFromParent_Done,
     /* 163925 */   // Label 2426: @163925
     /* 163925 */   GIM_Try, /*On fail goto*//*Label 2427*/ GIMT_Encode4(163950), // Rule ID 788 //
     /* 163930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 163933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 163937 */     // (fma:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB, f64:{ *:[f64] }:$XTi)  =>  (XSMADDADP:{ *:[f64] } f64:{ *:[f64] }:$XTi, f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 163937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMADDADP),
     /* 163940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 163942 */     GIR_RootToRootCopy, /*OpIdx*/3, // XTi
     /* 163944 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 163946 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 163948 */     GIR_RootConstrainSelectedInstOperands,
     /* 163949 */     // GIR_Coverage, 788,
     /* 163949 */     GIR_EraseRootFromParent_Done,
     /* 163950 */   // Label 2427: @163950
     /* 163950 */   GIM_Try, /*On fail goto*//*Label 2428*/ GIMT_Encode4(163991), // Rule ID 223 //
     /* 163955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 163958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 163962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 163970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 163974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163976 */     // (fma:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, (fneg:{ *:[f64] } f64:{ *:[f64] }:$FRB))  =>  (FMSUB:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB)
     /* 163976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FMSUB),
     /* 163979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 163981 */     GIR_RootToRootCopy, /*OpIdx*/1, // FRA
     /* 163983 */     GIR_RootToRootCopy, /*OpIdx*/2, // FRC
     /* 163985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRB
     /* 163989 */     GIR_RootConstrainSelectedInstOperands,
     /* 163990 */     // GIR_Coverage, 223,
     /* 163990 */     GIR_EraseRootFromParent_Done,
     /* 163991 */   // Label 2428: @163991
     /* 163991 */   GIM_Try, /*On fail goto*//*Label 2429*/ GIMT_Encode4(164014), // Rule ID 219 //
     /* 163996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 163999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 164003 */     // (fma:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB)  =>  (FMADD:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB)
     /* 164003 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FMADD),
     /* 164008 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 164012 */     GIR_RootConstrainSelectedInstOperands,
     /* 164013 */     // GIR_Coverage, 219,
     /* 164013 */     GIR_Done,
     /* 164014 */   // Label 2429: @164014
     /* 164014 */   GIM_Reject,
     /* 164015 */ // Label 2425: @164015
     /* 164015 */ GIM_Reject,
     /* 164016 */ // Label 2416: @164016
     /* 164016 */ GIM_Try, /*On fail goto*//*Label 2430*/ GIMT_Encode4(164093),
     /* 164021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 164024 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 164027 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /* 164030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 164034 */   GIM_Try, /*On fail goto*//*Label 2431*/ GIMT_Encode4(164071), // Rule ID 1000 //
     /* 164039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 164042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 164050 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s128,
     /* 164054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164056 */     // (fma:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, (fneg:{ *:[f128] } f128:{ *:[f128] }:$RSTi))  =>  (XSMSUBQP:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 164056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMSUBQP),
     /* 164059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 164061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RSTi
     /* 164065 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /* 164067 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /* 164069 */     GIR_RootConstrainSelectedInstOperands,
     /* 164070 */     // GIR_Coverage, 1000,
     /* 164070 */     GIR_EraseRootFromParent_Done,
     /* 164071 */   // Label 2431: @164071
     /* 164071 */   GIM_Try, /*On fail goto*//*Label 2432*/ GIMT_Encode4(164092), // Rule ID 998 //
     /* 164076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 164079 */     // (fma:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, f128:{ *:[f128] }:$RSTi)  =>  (XSMADDQP:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 164079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMADDQP),
     /* 164082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 164084 */     GIR_RootToRootCopy, /*OpIdx*/3, // RSTi
     /* 164086 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /* 164088 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /* 164090 */     GIR_RootConstrainSelectedInstOperands,
     /* 164091 */     // GIR_Coverage, 998,
     /* 164091 */     GIR_EraseRootFromParent_Done,
     /* 164092 */   // Label 2432: @164092
     /* 164092 */   GIM_Reject,
     /* 164093 */ // Label 2430: @164093
     /* 164093 */ GIM_Reject,
     /* 164094 */ // Label 2417: @164094
     /* 164094 */ GIM_Try, /*On fail goto*//*Label 2433*/ GIMT_Encode4(164171),
     /* 164099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 164102 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164105 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 164108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 164112 */   GIM_Try, /*On fail goto*//*Label 2434*/ GIMT_Encode4(164149), // Rule ID 800 //
     /* 164117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 164120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 164128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 164132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164134 */     // (fma:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB, (fneg:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi))  =>  (XVMSUBADP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi, v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 164134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMSUBADP),
     /* 164137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 164139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XTi
     /* 164143 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 164145 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 164147 */     GIR_RootConstrainSelectedInstOperands,
     /* 164148 */     // GIR_Coverage, 800,
     /* 164148 */     GIR_EraseRootFromParent_Done,
     /* 164149 */   // Label 2434: @164149
     /* 164149 */   GIM_Try, /*On fail goto*//*Label 2435*/ GIMT_Encode4(164170), // Rule ID 796 //
     /* 164154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 164157 */     // (fma:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB, v2f64:{ *:[v2f64] }:$XTi)  =>  (XVMADDADP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi, v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 164157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMADDADP),
     /* 164160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 164162 */     GIR_RootToRootCopy, /*OpIdx*/3, // XTi
     /* 164164 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 164166 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 164168 */     GIR_RootConstrainSelectedInstOperands,
     /* 164169 */     // GIR_Coverage, 796,
     /* 164169 */     GIR_EraseRootFromParent_Done,
     /* 164170 */   // Label 2435: @164170
     /* 164170 */   GIM_Reject,
     /* 164171 */ // Label 2433: @164171
     /* 164171 */ GIM_Reject,
     /* 164172 */ // Label 2418: @164172
     /* 164172 */ GIM_Try, /*On fail goto*//*Label 2436*/ GIMT_Encode4(164272),
     /* 164177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 164180 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164183 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 164186 */   GIM_Try, /*On fail goto*//*Label 2437*/ GIMT_Encode4(164227), // Rule ID 802 //
     /* 164191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 164194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 164198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 164206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 164210 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164212 */     // (fma:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB, (fneg:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XTi))  =>  (XVMSUBASP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XTi, v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 164212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMSUBASP),
     /* 164215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 164217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XTi
     /* 164221 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 164223 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 164225 */     GIR_RootConstrainSelectedInstOperands,
     /* 164226 */     // GIR_Coverage, 802,
     /* 164226 */     GIR_EraseRootFromParent_Done,
     /* 164227 */   // Label 2437: @164227
     /* 164227 */   GIM_Try, /*On fail goto*//*Label 2438*/ GIMT_Encode4(164252), // Rule ID 798 //
     /* 164232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 164235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 164239 */     // (fma:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB, v4f32:{ *:[v4f32] }:$XTi)  =>  (XVMADDASP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XTi, v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 164239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMADDASP),
     /* 164242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 164244 */     GIR_RootToRootCopy, /*OpIdx*/3, // XTi
     /* 164246 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 164248 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 164250 */     GIR_RootConstrainSelectedInstOperands,
     /* 164251 */     // GIR_Coverage, 798,
     /* 164251 */     GIR_EraseRootFromParent_Done,
     /* 164252 */   // Label 2438: @164252
     /* 164252 */   GIM_Try, /*On fail goto*//*Label 2439*/ GIMT_Encode4(164271), // Rule ID 292 //
     /* 164257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 164260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 164264 */     // (fma:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$RA, v4f32:{ *:[v4f32] }:$RC, v4f32:{ *:[v4f32] }:$RB)  =>  (VMADDFP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$RA, v4f32:{ *:[v4f32] }:$RC, v4f32:{ *:[v4f32] }:$RB)
     /* 164264 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMADDFP),
     /* 164269 */     GIR_RootConstrainSelectedInstOperands,
     /* 164270 */     // GIR_Coverage, 292,
     /* 164270 */     GIR_Done,
     /* 164271 */   // Label 2439: @164271
     /* 164271 */   GIM_Reject,
     /* 164272 */ // Label 2436: @164272
     /* 164272 */ GIM_Reject,
     /* 164273 */ // Label 2419: @164273
     /* 164273 */ GIM_Reject,
     /* 164274 */ // Label 44: @164274
     /* 164274 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2445*/ GIMT_Encode4(164543),
     /* 164285 */ /*GILLT_s32*//*Label 2440*/ GIMT_Encode4(164305),
     /* 164289 */ /*GILLT_s64*//*Label 2441*/ GIMT_Encode4(164379),
     /* 164293 */ /*GILLT_s128*//*Label 2442*/ GIMT_Encode4(164457),
     /* 164297 */ /*GILLT_v2s64*//*Label 2443*/ GIMT_Encode4(164483),
     /* 164301 */ /*GILLT_v4s32*//*Label 2444*/ GIMT_Encode4(164513),
     /* 164305 */ // Label 2440: @164305
     /* 164305 */ GIM_Try, /*On fail goto*//*Label 2446*/ GIMT_Encode4(164378),
     /* 164310 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 164313 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 164316 */   GIM_Try, /*On fail goto*//*Label 2447*/ GIMT_Encode4(164335), // Rule ID 959 //
     /* 164321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 164324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 164328 */     // (fdiv:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)  =>  (XSDIVSP:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 164328 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSDIVSP),
     /* 164333 */     GIR_RootConstrainSelectedInstOperands,
     /* 164334 */     // GIR_Coverage, 959,
     /* 164334 */     GIR_Done,
     /* 164335 */   // Label 2447: @164335
     /* 164335 */   GIM_Try, /*On fail goto*//*Label 2448*/ GIMT_Encode4(164358), // Rule ID 243 //
     /* 164340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 164343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 164347 */     // (fdiv:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)  =>  (FDIVS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)
     /* 164347 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FDIVS),
     /* 164352 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 164356 */     GIR_RootConstrainSelectedInstOperands,
     /* 164357 */     // GIR_Coverage, 243,
     /* 164357 */     GIR_Done,
     /* 164358 */   // Label 2448: @164358
     /* 164358 */   GIM_Try, /*On fail goto*//*Label 2449*/ GIMT_Encode4(164377), // Rule ID 595 //
     /* 164363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 164366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 164370 */     // (fdiv:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)  =>  (EFSDIV:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)
     /* 164370 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSDIV),
     /* 164375 */     GIR_RootConstrainSelectedInstOperands,
     /* 164376 */     // GIR_Coverage, 595,
     /* 164376 */     GIR_Done,
     /* 164377 */   // Label 2449: @164377
     /* 164377 */   GIM_Reject,
     /* 164378 */ // Label 2446: @164378
     /* 164378 */ GIM_Reject,
     /* 164379 */ // Label 2441: @164379
     /* 164379 */ GIM_Try, /*On fail goto*//*Label 2450*/ GIMT_Encode4(164456),
     /* 164384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 164387 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 164390 */   GIM_Try, /*On fail goto*//*Label 2451*/ GIMT_Encode4(164413), // Rule ID 811 //
     /* 164395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 164398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 164402 */     // (fdiv:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)  =>  (XSDIVDP:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 164402 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSDIVDP),
     /* 164407 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 164411 */     GIR_RootConstrainSelectedInstOperands,
     /* 164412 */     // GIR_Coverage, 811,
     /* 164412 */     GIR_Done,
     /* 164413 */   // Label 2451: @164413
     /* 164413 */   GIM_Try, /*On fail goto*//*Label 2452*/ GIMT_Encode4(164436), // Rule ID 241 //
     /* 164418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 164421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 164425 */     // (fdiv:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)  =>  (FDIV:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)
     /* 164425 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FDIV),
     /* 164430 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 164434 */     GIR_RootConstrainSelectedInstOperands,
     /* 164435 */     // GIR_Coverage, 241,
     /* 164435 */     GIR_Done,
     /* 164436 */   // Label 2452: @164436
     /* 164436 */   GIM_Try, /*On fail goto*//*Label 2453*/ GIMT_Encode4(164455), // Rule ID 574 //
     /* 164441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 164444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 164448 */     // (fdiv:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)  =>  (EFDDIV:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)
     /* 164448 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDDIV),
     /* 164453 */     GIR_RootConstrainSelectedInstOperands,
     /* 164454 */     // GIR_Coverage, 574,
     /* 164454 */     GIR_Done,
     /* 164455 */   // Label 2453: @164455
     /* 164455 */   GIM_Reject,
     /* 164456 */ // Label 2450: @164456
     /* 164456 */ GIM_Reject,
     /* 164457 */ // Label 2442: @164457
     /* 164457 */ GIM_Try, /*On fail goto*//*Label 2454*/ GIMT_Encode4(164482), // Rule ID 994 //
     /* 164462 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 164465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 164468 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 164471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 164475 */   // (fdiv:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSDIVQP:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 164475 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSDIVQP),
     /* 164480 */   GIR_RootConstrainSelectedInstOperands,
     /* 164481 */   // GIR_Coverage, 994,
     /* 164481 */   GIR_Done,
     /* 164482 */ // Label 2454: @164482
     /* 164482 */ GIM_Reject,
     /* 164483 */ // Label 2443: @164483
     /* 164483 */ GIM_Try, /*On fail goto*//*Label 2455*/ GIMT_Encode4(164512), // Rule ID 820 //
     /* 164488 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 164491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 164494 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164497 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 164501 */   // (fdiv:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)  =>  (XVDIVDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 164501 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVDIVDP),
     /* 164506 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 164510 */   GIR_RootConstrainSelectedInstOperands,
     /* 164511 */   // GIR_Coverage, 820,
     /* 164511 */   GIR_Done,
     /* 164512 */ // Label 2455: @164512
     /* 164512 */ GIM_Reject,
     /* 164513 */ // Label 2444: @164513
     /* 164513 */ GIM_Try, /*On fail goto*//*Label 2456*/ GIMT_Encode4(164542), // Rule ID 822 //
     /* 164518 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 164521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 164524 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 164531 */   // (fdiv:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)  =>  (XVDIVSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 164531 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVDIVSP),
     /* 164536 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 164540 */   GIR_RootConstrainSelectedInstOperands,
     /* 164541 */   // GIR_Coverage, 822,
     /* 164541 */   GIR_Done,
     /* 164542 */ // Label 2456: @164542
     /* 164542 */ GIM_Reject,
     /* 164543 */ // Label 2445: @164543
     /* 164543 */ GIM_Reject,
     /* 164544 */ // Label 45: @164544
     /* 164544 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2462*/ GIMT_Encode4(167014),
     /* 164555 */ /*GILLT_s32*//*Label 2457*/ GIMT_Encode4(164575),
     /* 164559 */ /*GILLT_s64*//*Label 2458*/ GIMT_Encode4(165348),
     /* 164563 */ /*GILLT_s128*//*Label 2459*/ GIMT_Encode4(166002),
     /* 164567 */ /*GILLT_v2s64*//*Label 2460*/ GIMT_Encode4(166410),
     /* 164571 */ /*GILLT_v4s32*//*Label 2461*/ GIMT_Encode4(166696),
     /* 164575 */ // Label 2457: @164575
     /* 164575 */ GIM_Try, /*On fail goto*//*Label 2463*/ GIMT_Encode4(165347),
     /* 164580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 164583 */   GIM_Try, /*On fail goto*//*Label 2464*/ GIMT_Encode4(164648), // Rule ID 973 //
     /* 164588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 164591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 164595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 164603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 164607 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 164611 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 164615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 164619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 164623 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 164627 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 164629 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB, (fneg:{ *:[f32] } f32:{ *:[f32] }:$XTi)))  =>  (XSNMSUBASP:{ *:[f32] } f32:{ *:[f32] }:$XTi, f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 164629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMSUBASP),
     /* 164632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 164634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // XTi
     /* 164638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 164642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 164646 */     GIR_RootConstrainSelectedInstOperands,
     /* 164647 */     // GIR_Coverage, 973,
     /* 164647 */     GIR_EraseRootFromParent_Done,
     /* 164648 */   // Label 2464: @164648
     /* 164648 */   GIM_Try, /*On fail goto*//*Label 2465*/ GIMT_Encode4(164713), // Rule ID 972 //
     /* 164653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 164656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 164660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 164668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 164672 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 164676 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 164680 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 164684 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 164688 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 164692 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 164694 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB, (fneg:{ *:[f32] } f32:{ *:[f32] }:$XTi)))  =>  (XSNMSUBASP:{ *:[f32] } f32:{ *:[f32] }:$XTi, f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 164694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMSUBASP),
     /* 164697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 164699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // XTi
     /* 164703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 164707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 164711 */     GIR_RootConstrainSelectedInstOperands,
     /* 164712 */     // GIR_Coverage, 972,
     /* 164712 */     GIR_EraseRootFromParent_Done,
     /* 164713 */   // Label 2465: @164713
     /* 164713 */   GIM_Try, /*On fail goto*//*Label 2466*/ GIMT_Encode4(164766), // Rule ID 971 //
     /* 164718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 164721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 164725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 164733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 164737 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 164741 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 164745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164747 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB, f32:{ *:[f32] }:$XTi))  =>  (XSNMADDASP:{ *:[f32] } f32:{ *:[f32] }:$XTi, f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 164747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMADDASP),
     /* 164750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 164752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // XTi
     /* 164756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 164760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 164764 */     GIR_RootConstrainSelectedInstOperands,
     /* 164765 */     // GIR_Coverage, 971,
     /* 164765 */     GIR_EraseRootFromParent_Done,
     /* 164766 */   // Label 2466: @164766
     /* 164766 */   GIM_Try, /*On fail goto*//*Label 2467*/ GIMT_Encode4(164819), // Rule ID 970 //
     /* 164771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 164774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 164778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 164786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 164790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 164794 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 164798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164800 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB, f32:{ *:[f32] }:$XTi))  =>  (XSNMADDASP:{ *:[f32] } f32:{ *:[f32] }:$XTi, f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 164800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMADDASP),
     /* 164803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 164805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // XTi
     /* 164809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 164813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 164817 */     GIR_RootConstrainSelectedInstOperands,
     /* 164818 */     // GIR_Coverage, 970,
     /* 164818 */     GIR_EraseRootFromParent_Done,
     /* 164819 */   // Label 2467: @164819
     /* 164819 */   GIM_Try, /*On fail goto*//*Label 2468*/ GIMT_Encode4(164856), // Rule ID 845 //
     /* 164824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 164827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 164831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 164839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 164843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164845 */     // (fneg:{ *:[f32] } (fabs:{ *:[f32] } f32:{ *:[f32] }:$XB))  =>  (XSNABSDPs:{ *:[f32] } f32:{ *:[f32] }:$XB)
     /* 164845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNABSDPs),
     /* 164848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 164850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XB
     /* 164854 */     GIR_RootConstrainSelectedInstOperands,
     /* 164855 */     // GIR_Coverage, 845,
     /* 164855 */     GIR_EraseRootFromParent_Done,
     /* 164856 */   // Label 2468: @164856
     /* 164856 */   GIM_Try, /*On fail goto*//*Label 2469*/ GIMT_Encode4(164934), // Rule ID 1685 //
     /* 164861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 164864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 164868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 164876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 164880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164882 */     // (fneg:{ *:[f32] } (fabs:{ *:[f32] } f32:{ *:[f32] }:$S))  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSNABSDP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 164882 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 164885 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 164889 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 164894 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // S
     /* 164898 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 164903 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 164906 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSNABSDP),
     /* 164910 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 164915 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 164918 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 164920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 164923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164925 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 164928 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 164933 */     // GIR_Coverage, 1685,
     /* 164933 */     GIR_EraseRootFromParent_Done,
     /* 164934 */   // Label 2469: @164934
     /* 164934 */   GIM_Try, /*On fail goto*//*Label 2470*/ GIMT_Encode4(164998), // Rule ID 1926 //
     /* 164939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 164942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 164946 */     // (fneg:{ *:[f32] } f32:{ *:[f32] }:$S)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSNEGDP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 164946 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 164949 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 164953 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 164958 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 164962 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 164967 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 164970 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSNEGDP),
     /* 164974 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 164979 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 164982 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 164984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 164987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164989 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 164992 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 164997 */     // GIR_Coverage, 1926,
     /* 164997 */     GIR_EraseRootFromParent_Done,
     /* 164998 */   // Label 2470: @164998
     /* 164998 */   GIM_Try, /*On fail goto*//*Label 2471*/ GIMT_Encode4(165063), // Rule ID 233 //
     /* 165003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 165006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 165010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 165018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 165022 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 165026 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 165030 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 165034 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 165038 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 165042 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 165044 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, (fneg:{ *:[f32] } f32:{ *:[f32] }:$FRB)))  =>  (FNMSUBS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB)
     /* 165044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNMSUBS),
     /* 165047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 165049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRA
     /* 165053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // FRC
     /* 165057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // FRB
     /* 165061 */     GIR_RootConstrainSelectedInstOperands,
     /* 165062 */     // GIR_Coverage, 233,
     /* 165062 */     GIR_EraseRootFromParent_Done,
     /* 165063 */   // Label 2471: @165063
     /* 165063 */   GIM_Try, /*On fail goto*//*Label 2472*/ GIMT_Encode4(165128), // Rule ID 232 //
     /* 165068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 165071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 165075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 165083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 165087 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 165091 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 165095 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 165099 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 165103 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 165107 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 165109 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, (fneg:{ *:[f32] } f32:{ *:[f32] }:$FRB)))  =>  (FNMSUBS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB)
     /* 165109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNMSUBS),
     /* 165112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 165114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRA
     /* 165118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // FRC
     /* 165122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // FRB
     /* 165126 */     GIR_RootConstrainSelectedInstOperands,
     /* 165127 */     // GIR_Coverage, 232,
     /* 165127 */     GIR_EraseRootFromParent_Done,
     /* 165128 */   // Label 2472: @165128
     /* 165128 */   GIM_Try, /*On fail goto*//*Label 2473*/ GIMT_Encode4(165181), // Rule ID 229 //
     /* 165133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 165136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 165140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 165148 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 165152 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 165156 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 165160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165162 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB))  =>  (FNMADDS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB)
     /* 165162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNMADDS),
     /* 165165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 165167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRA
     /* 165171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // FRC
     /* 165175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // FRB
     /* 165179 */     GIR_RootConstrainSelectedInstOperands,
     /* 165180 */     // GIR_Coverage, 229,
     /* 165180 */     GIR_EraseRootFromParent_Done,
     /* 165181 */   // Label 2473: @165181
     /* 165181 */   GIM_Try, /*On fail goto*//*Label 2474*/ GIMT_Encode4(165234), // Rule ID 228 //
     /* 165186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 165189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 165193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 165201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 165205 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 165209 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 165213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165215 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB))  =>  (FNMADDS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB)
     /* 165215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNMADDS),
     /* 165218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 165220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRA
     /* 165224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // FRC
     /* 165228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // FRB
     /* 165232 */     GIR_RootConstrainSelectedInstOperands,
     /* 165233 */     // GIR_Coverage, 228,
     /* 165233 */     GIR_EraseRootFromParent_Done,
     /* 165234 */   // Label 2474: @165234
     /* 165234 */   GIM_Try, /*On fail goto*//*Label 2475*/ GIMT_Encode4(165271), // Rule ID 165 //
     /* 165239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 165242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 165246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 165254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 165258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165260 */     // (fneg:{ *:[f32] } (fabs:{ *:[f32] } f32:{ *:[f32] }:$RB))  =>  (FNABSS:{ *:[f32] } f32:{ *:[f32] }:$RB)
     /* 165260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNABSS),
     /* 165263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 165265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RB
     /* 165269 */     GIR_RootConstrainSelectedInstOperands,
     /* 165270 */     // GIR_Coverage, 165,
     /* 165270 */     GIR_EraseRootFromParent_Done,
     /* 165271 */   // Label 2475: @165271
     /* 165271 */   GIM_Try, /*On fail goto*//*Label 2476*/ GIMT_Encode4(165308), // Rule ID 598 //
     /* 165276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 165279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 165283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 165291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 165295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165297 */     // (fneg:{ *:[f32] } (fabs:{ *:[f32] } f32:{ *:[f32] }:$RA))  =>  (EFSNABS:{ *:[f32] } f32:{ *:[f32] }:$RA)
     /* 165297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EFSNABS),
     /* 165300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /* 165302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RA
     /* 165306 */     GIR_RootConstrainSelectedInstOperands,
     /* 165307 */     // GIR_Coverage, 598,
     /* 165307 */     GIR_EraseRootFromParent_Done,
     /* 165308 */   // Label 2476: @165308
     /* 165308 */   GIM_Try, /*On fail goto*//*Label 2477*/ GIMT_Encode4(165327), // Rule ID 167 //
     /* 165313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 165316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 165320 */     // (fneg:{ *:[f32] } f32:{ *:[f32] }:$RB)  =>  (FNEGS:{ *:[f32] } f32:{ *:[f32] }:$RB)
     /* 165320 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FNEGS),
     /* 165325 */     GIR_RootConstrainSelectedInstOperands,
     /* 165326 */     // GIR_Coverage, 167,
     /* 165326 */     GIR_Done,
     /* 165327 */   // Label 2477: @165327
     /* 165327 */   GIM_Try, /*On fail goto*//*Label 2478*/ GIMT_Encode4(165346), // Rule ID 599 //
     /* 165332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 165335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 165339 */     // (fneg:{ *:[f32] } f32:{ *:[f32] }:$RA)  =>  (EFSNEG:{ *:[f32] } f32:{ *:[f32] }:$RA)
     /* 165339 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSNEG),
     /* 165344 */     GIR_RootConstrainSelectedInstOperands,
     /* 165345 */     // GIR_Coverage, 599,
     /* 165345 */     GIR_Done,
     /* 165346 */   // Label 2478: @165346
     /* 165346 */   GIM_Reject,
     /* 165347 */ // Label 2463: @165347
     /* 165347 */ GIM_Reject,
     /* 165348 */ // Label 2458: @165348
     /* 165348 */ GIM_Try, /*On fail goto*//*Label 2479*/ GIMT_Encode4(166001),
     /* 165353 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 165356 */   GIM_Try, /*On fail goto*//*Label 2480*/ GIMT_Encode4(165421), // Rule ID 794 //
     /* 165361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 165364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 165368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 165376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 165380 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 165384 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 165388 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 165392 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 165396 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 165400 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 165402 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB, (fneg:{ *:[f64] } f64:{ *:[f64] }:$XTi)))  =>  (XSNMSUBADP:{ *:[f64] } f64:{ *:[f64] }:$XTi, f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 165402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMSUBADP),
     /* 165405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 165407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // XTi
     /* 165411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 165415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 165419 */     GIR_RootConstrainSelectedInstOperands,
     /* 165420 */     // GIR_Coverage, 794,
     /* 165420 */     GIR_EraseRootFromParent_Done,
     /* 165421 */   // Label 2480: @165421
     /* 165421 */   GIM_Try, /*On fail goto*//*Label 2481*/ GIMT_Encode4(165486), // Rule ID 793 //
     /* 165426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 165429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 165433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 165441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 165445 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 165449 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 165453 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 165457 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 165461 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 165465 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 165467 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB, (fneg:{ *:[f64] } f64:{ *:[f64] }:$XTi)))  =>  (XSNMSUBADP:{ *:[f64] } f64:{ *:[f64] }:$XTi, f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 165467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMSUBADP),
     /* 165470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 165472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // XTi
     /* 165476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 165480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 165484 */     GIR_RootConstrainSelectedInstOperands,
     /* 165485 */     // GIR_Coverage, 793,
     /* 165485 */     GIR_EraseRootFromParent_Done,
     /* 165486 */   // Label 2481: @165486
     /* 165486 */   GIM_Try, /*On fail goto*//*Label 2482*/ GIMT_Encode4(165539), // Rule ID 792 //
     /* 165491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 165494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 165498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 165506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 165510 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 165514 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 165518 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165520 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB, f64:{ *:[f64] }:$XTi))  =>  (XSNMADDADP:{ *:[f64] } f64:{ *:[f64] }:$XTi, f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 165520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMADDADP),
     /* 165523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 165525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // XTi
     /* 165529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 165533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 165537 */     GIR_RootConstrainSelectedInstOperands,
     /* 165538 */     // GIR_Coverage, 792,
     /* 165538 */     GIR_EraseRootFromParent_Done,
     /* 165539 */   // Label 2482: @165539
     /* 165539 */   GIM_Try, /*On fail goto*//*Label 2483*/ GIMT_Encode4(165592), // Rule ID 791 //
     /* 165544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 165547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 165551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 165559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 165563 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 165567 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 165571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165573 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB, f64:{ *:[f64] }:$XTi))  =>  (XSNMADDADP:{ *:[f64] } f64:{ *:[f64] }:$XTi, f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 165573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMADDADP),
     /* 165576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 165578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // XTi
     /* 165582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 165586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 165590 */     GIR_RootConstrainSelectedInstOperands,
     /* 165591 */     // GIR_Coverage, 791,
     /* 165591 */     GIR_EraseRootFromParent_Done,
     /* 165592 */   // Label 2483: @165592
     /* 165592 */   GIM_Try, /*On fail goto*//*Label 2484*/ GIMT_Encode4(165629), // Rule ID 844 //
     /* 165597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 165600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 165604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 165612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 165616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165618 */     // (fneg:{ *:[f64] } (fabs:{ *:[f64] } f64:{ *:[f64] }:$XB))  =>  (XSNABSDP:{ *:[f64] } f64:{ *:[f64] }:$XB)
     /* 165618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNABSDP),
     /* 165621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 165623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XB
     /* 165627 */     GIR_RootConstrainSelectedInstOperands,
     /* 165628 */     // GIR_Coverage, 844,
     /* 165628 */     GIR_EraseRootFromParent_Done,
     /* 165629 */   // Label 2484: @165629
     /* 165629 */   GIM_Try, /*On fail goto*//*Label 2485*/ GIMT_Encode4(165652), // Rule ID 846 //
     /* 165634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 165637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 165641 */     // (fneg:{ *:[f64] } f64:{ *:[f64] }:$XB)  =>  (XSNEGDP:{ *:[f64] } f64:{ *:[f64] }:$XB)
     /* 165641 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSNEGDP),
     /* 165646 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 165650 */     GIR_RootConstrainSelectedInstOperands,
     /* 165651 */     // GIR_Coverage, 846,
     /* 165651 */     GIR_Done,
     /* 165652 */   // Label 2485: @165652
     /* 165652 */   GIM_Try, /*On fail goto*//*Label 2486*/ GIMT_Encode4(165717), // Rule ID 231 //
     /* 165657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 165660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 165664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 165672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 165676 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 165680 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 165684 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 165688 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 165692 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 165696 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 165698 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, (fneg:{ *:[f64] } f64:{ *:[f64] }:$FRB)))  =>  (FNMSUB:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB)
     /* 165698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNMSUB),
     /* 165701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 165703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRA
     /* 165707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // FRC
     /* 165711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // FRB
     /* 165715 */     GIR_RootConstrainSelectedInstOperands,
     /* 165716 */     // GIR_Coverage, 231,
     /* 165716 */     GIR_EraseRootFromParent_Done,
     /* 165717 */   // Label 2486: @165717
     /* 165717 */   GIM_Try, /*On fail goto*//*Label 2487*/ GIMT_Encode4(165782), // Rule ID 230 //
     /* 165722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 165725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 165729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 165737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 165741 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 165745 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 165749 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 165753 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 165757 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 165761 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 165763 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, (fneg:{ *:[f64] } f64:{ *:[f64] }:$FRB)))  =>  (FNMSUB:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB)
     /* 165763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNMSUB),
     /* 165766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 165768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRA
     /* 165772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // FRC
     /* 165776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // FRB
     /* 165780 */     GIR_RootConstrainSelectedInstOperands,
     /* 165781 */     // GIR_Coverage, 230,
     /* 165781 */     GIR_EraseRootFromParent_Done,
     /* 165782 */   // Label 2487: @165782
     /* 165782 */   GIM_Try, /*On fail goto*//*Label 2488*/ GIMT_Encode4(165835), // Rule ID 227 //
     /* 165787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 165790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 165794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 165802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 165806 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 165810 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 165814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165816 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB))  =>  (FNMADD:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB)
     /* 165816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNMADD),
     /* 165819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 165821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRA
     /* 165825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // FRC
     /* 165829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // FRB
     /* 165833 */     GIR_RootConstrainSelectedInstOperands,
     /* 165834 */     // GIR_Coverage, 227,
     /* 165834 */     GIR_EraseRootFromParent_Done,
     /* 165835 */   // Label 2488: @165835
     /* 165835 */   GIM_Try, /*On fail goto*//*Label 2489*/ GIMT_Encode4(165888), // Rule ID 226 //
     /* 165840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 165843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 165847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 165855 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 165859 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 165863 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 165867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165869 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB))  =>  (FNMADD:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB)
     /* 165869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNMADD),
     /* 165872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 165874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRA
     /* 165878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // FRC
     /* 165882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // FRB
     /* 165886 */     GIR_RootConstrainSelectedInstOperands,
     /* 165887 */     // GIR_Coverage, 226,
     /* 165887 */     GIR_EraseRootFromParent_Done,
     /* 165888 */   // Label 2489: @165888
     /* 165888 */   GIM_Try, /*On fail goto*//*Label 2490*/ GIMT_Encode4(165925), // Rule ID 166 //
     /* 165893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 165896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 165900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 165908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 165912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165914 */     // (fneg:{ *:[f64] } (fabs:{ *:[f64] } f64:{ *:[f64] }:$RB))  =>  (FNABSD:{ *:[f64] } f64:{ *:[f64] }:$RB)
     /* 165914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNABSD),
     /* 165917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 165919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RB
     /* 165923 */     GIR_RootConstrainSelectedInstOperands,
     /* 165924 */     // GIR_Coverage, 166,
     /* 165924 */     GIR_EraseRootFromParent_Done,
     /* 165925 */   // Label 2490: @165925
     /* 165925 */   GIM_Try, /*On fail goto*//*Label 2491*/ GIMT_Encode4(165962), // Rule ID 577 //
     /* 165930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 165933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 165937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 165945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 165949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165951 */     // (fneg:{ *:[f64] } (fabs:{ *:[f64] } f64:{ *:[f64] }:$RA))  =>  (EFDNABS:{ *:[f64] } f64:{ *:[f64] }:$RA)
     /* 165951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EFDNABS),
     /* 165954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /* 165956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RA
     /* 165960 */     GIR_RootConstrainSelectedInstOperands,
     /* 165961 */     // GIR_Coverage, 577,
     /* 165961 */     GIR_EraseRootFromParent_Done,
     /* 165962 */   // Label 2491: @165962
     /* 165962 */   GIM_Try, /*On fail goto*//*Label 2492*/ GIMT_Encode4(165981), // Rule ID 168 //
     /* 165967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 165970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 165974 */     // (fneg:{ *:[f64] } f64:{ *:[f64] }:$RB)  =>  (FNEGD:{ *:[f64] } f64:{ *:[f64] }:$RB)
     /* 165974 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FNEGD),
     /* 165979 */     GIR_RootConstrainSelectedInstOperands,
     /* 165980 */     // GIR_Coverage, 168,
     /* 165980 */     GIR_Done,
     /* 165981 */   // Label 2492: @165981
     /* 165981 */   GIM_Try, /*On fail goto*//*Label 2493*/ GIMT_Encode4(166000), // Rule ID 578 //
     /* 165986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 165989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 165993 */     // (fneg:{ *:[f64] } f64:{ *:[f64] }:$RA)  =>  (EFDNEG:{ *:[f64] } f64:{ *:[f64] }:$RA)
     /* 165993 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDNEG),
     /* 165998 */     GIR_RootConstrainSelectedInstOperands,
     /* 165999 */     // GIR_Coverage, 578,
     /* 165999 */     GIR_Done,
     /* 166000 */   // Label 2493: @166000
     /* 166000 */   GIM_Reject,
     /* 166001 */ // Label 2479: @166001
     /* 166001 */ GIM_Reject,
     /* 166002 */ // Label 2459: @166002
     /* 166002 */ GIM_Try, /*On fail goto*//*Label 2494*/ GIMT_Encode4(166409),
     /* 166007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 166010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 166014 */   GIM_Try, /*On fail goto*//*Label 2495*/ GIMT_Encode4(166083), // Rule ID 1013 //
     /* 166019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 166022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 166030 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/5,
     /* 166033 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fmaf128_round_to_odd),
     /* 166038 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 166042 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 166046 */     GIM_CheckType, /*MI*/1, /*Op*/4, /*Type*/GILLT_s128,
     /* 166050 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/4, // MIs[2]
     /* 166054 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 166058 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s128,
     /* 166062 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 166064 */     // (fneg:{ *:[f128] } (intrinsic_wo_chain:{ *:[f128] } 10640:{ *:[iPTR] }, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, (fneg:{ *:[f128] } f128:{ *:[f128] }:$RSTi)))  =>  (XSNMSUBQPO:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 166064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMSUBQPO),
     /* 166067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 166069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RSTi
     /* 166073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RA
     /* 166077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // RB
     /* 166081 */     GIR_RootConstrainSelectedInstOperands,
     /* 166082 */     // GIR_Coverage, 1013,
     /* 166082 */     GIR_EraseRootFromParent_Done,
     /* 166083 */   // Label 2495: @166083
     /* 166083 */   GIM_Try, /*On fail goto*//*Label 2496*/ GIMT_Encode4(166140), // Rule ID 1012 //
     /* 166088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 166091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 166099 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/5,
     /* 166102 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fmaf128_round_to_odd),
     /* 166107 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 166111 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 166115 */     GIM_CheckType, /*MI*/1, /*Op*/4, /*Type*/GILLT_s128,
     /* 166119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166121 */     // (fneg:{ *:[f128] } (intrinsic_wo_chain:{ *:[f128] } 10640:{ *:[iPTR] }, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, f128:{ *:[f128] }:$RSTi))  =>  (XSNMADDQPO:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 166121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMADDQPO),
     /* 166124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 166126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/4, // RSTi
     /* 166130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RA
     /* 166134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // RB
     /* 166138 */     GIR_RootConstrainSelectedInstOperands,
     /* 166139 */     // GIR_Coverage, 1012,
     /* 166139 */     GIR_EraseRootFromParent_Done,
     /* 166140 */   // Label 2496: @166140
     /* 166140 */   GIM_Try, /*On fail goto*//*Label 2497*/ GIMT_Encode4(166201), // Rule ID 1004 //
     /* 166145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 166148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 166156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s128,
     /* 166160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 166164 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 166168 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 166172 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 166176 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s128,
     /* 166180 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 166182 */     // (fneg:{ *:[f128] } (fma:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, (fneg:{ *:[f128] } f128:{ *:[f128] }:$RSTi)))  =>  (XSNMSUBQP:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 166182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMSUBQP),
     /* 166185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 166187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RSTi
     /* 166191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RA
     /* 166195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RB
     /* 166199 */     GIR_RootConstrainSelectedInstOperands,
     /* 166200 */     // GIR_Coverage, 1004,
     /* 166200 */     GIR_EraseRootFromParent_Done,
     /* 166201 */   // Label 2497: @166201
     /* 166201 */   GIM_Try, /*On fail goto*//*Label 2498*/ GIMT_Encode4(166262), // Rule ID 1003 //
     /* 166206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 166209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 166217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s128,
     /* 166221 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 166225 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 166229 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 166233 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 166237 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s128,
     /* 166241 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 166243 */     // (fneg:{ *:[f128] } (strict_fma:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, (fneg:{ *:[f128] } f128:{ *:[f128] }:$RSTi)))  =>  (XSNMSUBQP:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 166243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMSUBQP),
     /* 166246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 166248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RSTi
     /* 166252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RA
     /* 166256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RB
     /* 166260 */     GIR_RootConstrainSelectedInstOperands,
     /* 166261 */     // GIR_Coverage, 1003,
     /* 166261 */     GIR_EraseRootFromParent_Done,
     /* 166262 */   // Label 2498: @166262
     /* 166262 */   GIM_Try, /*On fail goto*//*Label 2499*/ GIMT_Encode4(166311), // Rule ID 1002 //
     /* 166267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 166270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 166278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s128,
     /* 166282 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 166286 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 166290 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166292 */     // (fneg:{ *:[f128] } (fma:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, f128:{ *:[f128] }:$RSTi))  =>  (XSNMADDQP:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 166292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMADDQP),
     /* 166295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 166297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // RSTi
     /* 166301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RA
     /* 166305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RB
     /* 166309 */     GIR_RootConstrainSelectedInstOperands,
     /* 166310 */     // GIR_Coverage, 1002,
     /* 166310 */     GIR_EraseRootFromParent_Done,
     /* 166311 */   // Label 2499: @166311
     /* 166311 */   GIM_Try, /*On fail goto*//*Label 2500*/ GIMT_Encode4(166360), // Rule ID 1001 //
     /* 166316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 166319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 166327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s128,
     /* 166331 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 166335 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 166339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166341 */     // (fneg:{ *:[f128] } (strict_fma:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, f128:{ *:[f128] }:$RSTi))  =>  (XSNMADDQP:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 166341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMADDQP),
     /* 166344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 166346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // RSTi
     /* 166350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RA
     /* 166354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RB
     /* 166358 */     GIR_RootConstrainSelectedInstOperands,
     /* 166359 */     // GIR_Coverage, 1001,
     /* 166359 */     GIR_EraseRootFromParent_Done,
     /* 166360 */   // Label 2500: @166360
     /* 166360 */   GIM_Try, /*On fail goto*//*Label 2501*/ GIMT_Encode4(166393), // Rule ID 985 //
     /* 166365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 166368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 166376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s128,
     /* 166380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166382 */     // (fneg:{ *:[f128] } (fabs:{ *:[f128] } f128:{ *:[f128] }:$RB))  =>  (XSNABSQP:{ *:[f128] } f128:{ *:[f128] }:$RB)
     /* 166382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNABSQP),
     /* 166385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 166387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RB
     /* 166391 */     GIR_RootConstrainSelectedInstOperands,
     /* 166392 */     // GIR_Coverage, 985,
     /* 166392 */     GIR_EraseRootFromParent_Done,
     /* 166393 */   // Label 2501: @166393
     /* 166393 */   GIM_Try, /*On fail goto*//*Label 2502*/ GIMT_Encode4(166408), // Rule ID 986 //
     /* 166398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 166401 */     // (fneg:{ *:[f128] } f128:{ *:[f128] }:$RB)  =>  (XSNEGQP:{ *:[f128] } f128:{ *:[f128] }:$RB)
     /* 166401 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSNEGQP),
     /* 166406 */     GIR_RootConstrainSelectedInstOperands,
     /* 166407 */     // GIR_Coverage, 986,
     /* 166407 */     GIR_Done,
     /* 166408 */   // Label 2502: @166408
     /* 166408 */   GIM_Reject,
     /* 166409 */ // Label 2494: @166409
     /* 166409 */ GIM_Reject,
     /* 166410 */ // Label 2460: @166410
     /* 166410 */ GIM_Try, /*On fail goto*//*Label 2503*/ GIMT_Encode4(166695),
     /* 166415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 166418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 166422 */   GIM_Try, /*On fail goto*//*Label 2504*/ GIMT_Encode4(166483), // Rule ID 807 //
     /* 166427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 166438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 166442 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 166446 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 166450 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 166454 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 166458 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 166462 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 166464 */     // (fneg:{ *:[v2f64] } (fma:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB, (fneg:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi)))  =>  (XVNMSUBADP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi, v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 166464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVNMSUBADP),
     /* 166467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 166469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // XTi
     /* 166473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 166477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 166481 */     GIR_RootConstrainSelectedInstOperands,
     /* 166482 */     // GIR_Coverage, 807,
     /* 166482 */     GIR_EraseRootFromParent_Done,
     /* 166483 */   // Label 2504: @166483
     /* 166483 */   GIM_Try, /*On fail goto*//*Label 2505*/ GIMT_Encode4(166544), // Rule ID 806 //
     /* 166488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 166499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 166503 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 166507 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 166511 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 166515 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 166519 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 166523 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 166525 */     // (fneg:{ *:[v2f64] } (strict_fma:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB, (fneg:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi)))  =>  (XVNMSUBADP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi, v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 166525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVNMSUBADP),
     /* 166528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 166530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // XTi
     /* 166534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 166538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 166542 */     GIR_RootConstrainSelectedInstOperands,
     /* 166543 */     // GIR_Coverage, 806,
     /* 166543 */     GIR_EraseRootFromParent_Done,
     /* 166544 */   // Label 2505: @166544
     /* 166544 */   GIM_Try, /*On fail goto*//*Label 2506*/ GIMT_Encode4(166593), // Rule ID 804 //
     /* 166549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 166560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 166564 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 166568 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 166572 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166574 */     // (fneg:{ *:[v2f64] } (fma:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB, v2f64:{ *:[v2f64] }:$XTi))  =>  (XVNMADDADP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi, v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 166574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVNMADDADP),
     /* 166577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 166579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // XTi
     /* 166583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 166587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 166591 */     GIR_RootConstrainSelectedInstOperands,
     /* 166592 */     // GIR_Coverage, 804,
     /* 166592 */     GIR_EraseRootFromParent_Done,
     /* 166593 */   // Label 2506: @166593
     /* 166593 */   GIM_Try, /*On fail goto*//*Label 2507*/ GIMT_Encode4(166642), // Rule ID 803 //
     /* 166598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 166609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 166613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 166617 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 166621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166623 */     // (fneg:{ *:[v2f64] } (strict_fma:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB, v2f64:{ *:[v2f64] }:$XTi))  =>  (XVNMADDADP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi, v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 166623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVNMADDADP),
     /* 166626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 166628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // XTi
     /* 166632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 166636 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 166640 */     GIR_RootConstrainSelectedInstOperands,
     /* 166641 */     // GIR_Coverage, 803,
     /* 166641 */     GIR_EraseRootFromParent_Done,
     /* 166642 */   // Label 2507: @166642
     /* 166642 */   GIM_Try, /*On fail goto*//*Label 2508*/ GIMT_Encode4(166675), // Rule ID 852 //
     /* 166647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 166658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 166662 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166664 */     // (fneg:{ *:[v2f64] } (fabs:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB))  =>  (XVNABSDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)
     /* 166664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVNABSDP),
     /* 166667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 166669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XB
     /* 166673 */     GIR_RootConstrainSelectedInstOperands,
     /* 166674 */     // GIR_Coverage, 852,
     /* 166674 */     GIR_EraseRootFromParent_Done,
     /* 166675 */   // Label 2508: @166675
     /* 166675 */   GIM_Try, /*On fail goto*//*Label 2509*/ GIMT_Encode4(166694), // Rule ID 854 //
     /* 166680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166683 */     // (fneg:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)  =>  (XVNEGDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)
     /* 166683 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVNEGDP),
     /* 166688 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 166692 */     GIR_RootConstrainSelectedInstOperands,
     /* 166693 */     // GIR_Coverage, 854,
     /* 166693 */     GIR_Done,
     /* 166694 */   // Label 2509: @166694
     /* 166694 */   GIM_Reject,
     /* 166695 */ // Label 2503: @166695
     /* 166695 */ GIM_Reject,
     /* 166696 */ // Label 2461: @166696
     /* 166696 */ GIM_Try, /*On fail goto*//*Label 2510*/ GIMT_Encode4(167013),
     /* 166701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 166704 */   GIM_Try, /*On fail goto*//*Label 2511*/ GIMT_Encode4(166769), // Rule ID 809 //
     /* 166709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 166716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 166724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 166728 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166732 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 166736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 166740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 166744 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 166748 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 166750 */     // (fneg:{ *:[v4f32] } (fma:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB, (fneg:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XTi)))  =>  (XVNMSUBASP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XTi, v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 166750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVNMSUBASP),
     /* 166753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 166755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // XTi
     /* 166759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 166763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 166767 */     GIR_RootConstrainSelectedInstOperands,
     /* 166768 */     // GIR_Coverage, 809,
     /* 166768 */     GIR_EraseRootFromParent_Done,
     /* 166769 */   // Label 2511: @166769
     /* 166769 */   GIM_Try, /*On fail goto*//*Label 2512*/ GIMT_Encode4(166834), // Rule ID 808 //
     /* 166774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 166781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 166789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 166793 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166797 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 166801 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 166805 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 166809 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 166813 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 166815 */     // (fneg:{ *:[v4f32] } (strict_fma:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB, (fneg:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XTi)))  =>  (XVNMSUBASP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XTi, v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 166815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVNMSUBASP),
     /* 166818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 166820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // XTi
     /* 166824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 166828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 166832 */     GIR_RootConstrainSelectedInstOperands,
     /* 166833 */     // GIR_Coverage, 808,
     /* 166833 */     GIR_EraseRootFromParent_Done,
     /* 166834 */   // Label 2512: @166834
     /* 166834 */   GIM_Try, /*On fail goto*//*Label 2513*/ GIMT_Encode4(166887), // Rule ID 805 //
     /* 166839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 166846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 166854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 166858 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166862 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 166866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166868 */     // (fneg:{ *:[v4f32] } (fma:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB, v4f32:{ *:[v4f32] }:$XTi))  =>  (XVNMADDASP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XTi, v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 166868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVNMADDASP),
     /* 166871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 166873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // XTi
     /* 166877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 166881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 166885 */     GIR_RootConstrainSelectedInstOperands,
     /* 166886 */     // GIR_Coverage, 805,
     /* 166886 */     GIR_EraseRootFromParent_Done,
     /* 166887 */   // Label 2513: @166887
     /* 166887 */   GIM_Try, /*On fail goto*//*Label 2514*/ GIMT_Encode4(166924), // Rule ID 853 //
     /* 166892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 166899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 166907 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 166911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166913 */     // (fneg:{ *:[v4f32] } (fabs:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB))  =>  (XVNABSSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)
     /* 166913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVNABSSP),
     /* 166916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 166918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XB
     /* 166922 */     GIR_RootConstrainSelectedInstOperands,
     /* 166923 */     // GIR_Coverage, 853,
     /* 166923 */     GIR_EraseRootFromParent_Done,
     /* 166924 */   // Label 2514: @166924
     /* 166924 */   GIM_Try, /*On fail goto*//*Label 2515*/ GIMT_Encode4(166947), // Rule ID 855 //
     /* 166929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 166936 */     // (fneg:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)  =>  (XVNEGSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)
     /* 166936 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVNEGSP),
     /* 166941 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 166945 */     GIR_RootConstrainSelectedInstOperands,
     /* 166946 */     // GIR_Coverage, 855,
     /* 166946 */     GIR_Done,
     /* 166947 */   // Label 2515: @166947
     /* 166947 */   GIM_Try, /*On fail goto*//*Label 2516*/ GIMT_Encode4(167012), // Rule ID 293 //
     /* 166952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 166955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 166959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 166967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 166971 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166975 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 166979 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 166983 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 166987 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 166991 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 166993 */     // (fneg:{ *:[v4f32] } (fma:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$RA, v4f32:{ *:[v4f32] }:$RC, (fneg:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$RB)))  =>  (VNMSUBFP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$RA, v4f32:{ *:[v4f32] }:$RC, v4f32:{ *:[v4f32] }:$RB)
     /* 166993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VNMSUBFP),
     /* 166996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /* 166998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RA
     /* 167002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RC
     /* 167006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RB
     /* 167010 */     GIR_RootConstrainSelectedInstOperands,
     /* 167011 */     // GIR_Coverage, 293,
     /* 167011 */     GIR_EraseRootFromParent_Done,
     /* 167012 */   // Label 2516: @167012
     /* 167012 */   GIM_Reject,
     /* 167013 */ // Label 2510: @167013
     /* 167013 */ GIM_Reject,
     /* 167014 */ // Label 2462: @167014
     /* 167014 */ GIM_Reject,
     /* 167015 */ // Label 46: @167015
     /* 167015 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2519*/ GIMT_Encode4(167178),
     /* 167026 */ /*GILLT_s64*//*Label 2517*/ GIMT_Encode4(167034),
     /* 167030 */ /*GILLT_s128*//*Label 2518*/ GIMT_Encode4(167109),
     /* 167034 */ // Label 2517: @167034
     /* 167034 */ GIM_Try, /*On fail goto*//*Label 2520*/ GIMT_Encode4(167108),
     /* 167039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 167042 */   GIM_Try, /*On fail goto*//*Label 2521*/ GIMT_Encode4(167065), // Rule ID 1910 //
     /* 167047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 167050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 167054 */     // (fpextend:{ *:[f64] } f32:{ *:[f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$src, VSFRC:{ *:[i32] })
     /* 167054 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 167059 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 167064 */     // GIR_Coverage, 1910,
     /* 167064 */     GIR_Done,
     /* 167065 */   // Label 2521: @167065
     /* 167065 */   GIM_Try, /*On fail goto*//*Label 2522*/ GIMT_Encode4(167084), // Rule ID 564 //
     /* 167070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 167073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 167077 */     // (fpextend:{ *:[f64] } f32:{ *:[f32] }:$RB)  =>  (EFDCFS:{ *:[f64] } f32:{ *:[f32] }:$RB)
     /* 167077 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDCFS),
     /* 167082 */     GIR_RootConstrainSelectedInstOperands,
     /* 167083 */     // GIR_Coverage, 564,
     /* 167083 */     GIR_Done,
     /* 167084 */   // Label 2522: @167084
     /* 167084 */   GIM_Try, /*On fail goto*//*Label 2523*/ GIMT_Encode4(167107), // Rule ID 1269 //
     /* 167089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 167092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 167096 */     // (fpextend:{ *:[f64] } f32:{ *:[f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$src, F8RC:{ *:[i32] })
     /* 167096 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 167101 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::F8RCRegClassID),
     /* 167106 */     // GIR_Coverage, 1269,
     /* 167106 */     GIR_Done,
     /* 167107 */   // Label 2523: @167107
     /* 167107 */   GIM_Reject,
     /* 167108 */ // Label 2520: @167108
     /* 167108 */ GIM_Reject,
     /* 167109 */ // Label 2518: @167109
     /* 167109 */ GIM_Try, /*On fail goto*//*Label 2524*/ GIMT_Encode4(167131), // Rule ID 1015 //
     /* 167114 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 167117 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 167120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 167124 */   // (fpextend:{ *:[f128] } f64:{ *:[f64] }:$RB)  =>  (XSCVDPQP:{ *:[f128] } f64:{ *:[f64] }:$RB)
     /* 167124 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSCVDPQP),
     /* 167129 */   GIR_RootConstrainSelectedInstOperands,
     /* 167130 */   // GIR_Coverage, 1015,
     /* 167130 */   GIR_Done,
     /* 167131 */ // Label 2524: @167131
     /* 167131 */ GIM_Try, /*On fail goto*//*Label 2525*/ GIMT_Encode4(167177), // Rule ID 2264 //
     /* 167136 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 167139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 167142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 167146 */   // (fpextend:{ *:[f128] } f32:{ *:[f32] }:$src)  =>  (XSCVDPQP:{ *:[f128] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$src, VFRC:{ *:[i32] }))
     /* 167146 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 167149 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 167153 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167158 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 167162 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VFRCRegClassID),
     /* 167167 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVDPQP),
     /* 167170 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 167172 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 167175 */   GIR_RootConstrainSelectedInstOperands,
     /* 167176 */   // GIR_Coverage, 2264,
     /* 167176 */   GIR_EraseRootFromParent_Done,
     /* 167177 */ // Label 2525: @167177
     /* 167177 */ GIM_Reject,
     /* 167178 */ // Label 2519: @167178
     /* 167178 */ GIM_Reject,
     /* 167179 */ // Label 47: @167179
     /* 167179 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2528*/ GIMT_Encode4(167335),
     /* 167190 */ /*GILLT_s32*//*Label 2526*/ GIMT_Encode4(167198),
     /* 167194 */ /*GILLT_s64*//*Label 2527*/ GIMT_Encode4(167312),
     /* 167198 */ // Label 2526: @167198
     /* 167198 */ GIM_Try, /*On fail goto*//*Label 2529*/ GIMT_Encode4(167220), // Rule ID 962 //
     /* 167203 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 167206 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 167209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 167213 */   // (fpround:{ *:[f32] } f64:{ *:[f64] }:$XB)  =>  (XSRSP:{ *:[f32] } f64:{ *:[f64] }:$XB)
     /* 167213 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSRSP),
     /* 167218 */   GIR_RootConstrainSelectedInstOperands,
     /* 167219 */   // GIR_Coverage, 962,
     /* 167219 */   GIR_Done,
     /* 167220 */ // Label 2529: @167220
     /* 167220 */ GIM_Try, /*On fail goto*//*Label 2530*/ GIMT_Encode4(167263), // Rule ID 2262 //
     /* 167225 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 167228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 167231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 167235 */   // (fpround:{ *:[f32] } f128:{ *:[f128] }:$src)  =>  (XSRSP:{ *:[f32] } (XSCVQPDPO:{ *:[f64] } ?:{ *:[f128] }:$src))
     /* 167235 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 167238 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCVQPDPO),
     /* 167242 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167247 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 167251 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 167253 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSRSP),
     /* 167256 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 167258 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 167261 */   GIR_RootConstrainSelectedInstOperands,
     /* 167262 */   // GIR_Coverage, 2262,
     /* 167262 */   GIR_EraseRootFromParent_Done,
     /* 167263 */ // Label 2530: @167263
     /* 167263 */ GIM_Try, /*On fail goto*//*Label 2531*/ GIMT_Encode4(167289), // Rule ID 158 //
     /* 167268 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 167271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 167274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 167278 */   // (fpround:{ *:[f32] } f64:{ *:[f64] }:$RB)  =>  (FRSP:{ *:[f32] } f64:{ *:[f64] }:$RB)
     /* 167278 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FRSP),
     /* 167283 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 167287 */   GIR_RootConstrainSelectedInstOperands,
     /* 167288 */   // GIR_Coverage, 158,
     /* 167288 */   GIR_Done,
     /* 167289 */ // Label 2531: @167289
     /* 167289 */ GIM_Try, /*On fail goto*//*Label 2532*/ GIMT_Encode4(167311), // Rule ID 585 //
     /* 167294 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 167297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 167300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 167304 */   // (fpround:{ *:[f32] } f64:{ *:[f64] }:$RB)  =>  (EFSCFD:{ *:[f32] } f64:{ *:[f64] }:$RB)
     /* 167304 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSCFD),
     /* 167309 */   GIR_RootConstrainSelectedInstOperands,
     /* 167310 */   // GIR_Coverage, 585,
     /* 167310 */   GIR_Done,
     /* 167311 */ // Label 2532: @167311
     /* 167311 */ GIM_Reject,
     /* 167312 */ // Label 2527: @167312
     /* 167312 */ GIM_Try, /*On fail goto*//*Label 2533*/ GIMT_Encode4(167334), // Rule ID 2260 //
     /* 167317 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 167320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 167323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VFRCRegClassID),
     /* 167327 */   // (fpround:{ *:[f64] } f128:{ *:[f128] }:$src)  =>  (XSCVQPDP:{ *:[f64] } ?:{ *:[f128] }:$src)
     /* 167327 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSCVQPDP),
     /* 167332 */   GIR_RootConstrainSelectedInstOperands,
     /* 167333 */   // GIR_Coverage, 2260,
     /* 167333 */   GIR_Done,
     /* 167334 */ // Label 2533: @167334
     /* 167334 */ GIM_Reject,
     /* 167335 */ // Label 2528: @167335
     /* 167335 */ GIM_Reject,
     /* 167336 */ // Label 48: @167336
     /* 167336 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2538*/ GIMT_Encode4(167598),
     /* 167347 */ /*GILLT_s32*//*Label 2534*/ GIMT_Encode4(167367),
     /* 167351 */ /*GILLT_s64*//*Label 2535*/ GIMT_Encode4(167475), GIMT_Encode4(0),
     /* 167359 */ /*GILLT_v2s64*//*Label 2536*/ GIMT_Encode4(167519),
     /* 167363 */ /*GILLT_v4s32*//*Label 2537*/ GIMT_Encode4(167546),
     /* 167367 */ // Label 2534: @167367
     /* 167367 */ GIM_Try, /*On fail goto*//*Label 2539*/ GIMT_Encode4(167430), // Rule ID 2250 //
     /* 167372 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 167375 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 167378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 167382 */   // (fp_to_sint:{ *:[i32] } f128:{ *:[f128] }:$src)  =>  (MFVSRWZ:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[f64] } (XSCVQPSWZ:{ *:[f128] } ?:{ *:[f128] }:$src), VFRC:{ *:[i32] }))
     /* 167382 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 167385 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCVQPSWZ),
     /* 167389 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167394 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 167398 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 167400 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 167403 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 167407 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167412 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 167415 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VFRCRegClassID),
     /* 167420 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRWZ),
     /* 167423 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 167425 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 167428 */   GIR_RootConstrainSelectedInstOperands,
     /* 167429 */   // GIR_Coverage, 2250,
     /* 167429 */   GIR_EraseRootFromParent_Done,
     /* 167430 */ // Label 2539: @167430
     /* 167430 */ GIM_Try, /*On fail goto*//*Label 2540*/ GIMT_Encode4(167452), // Rule ID 570 //
     /* 167435 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 167438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 167441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 167445 */   // (fp_to_sint:{ *:[i32] } f64:{ *:[f64] }:$RB)  =>  (EFDCTSIZ:{ *:[i32] } f64:{ *:[f64] }:$RB)
     /* 167445 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDCTSIZ),
     /* 167450 */   GIR_RootConstrainSelectedInstOperands,
     /* 167451 */   // GIR_Coverage, 570,
     /* 167451 */   GIR_Done,
     /* 167452 */ // Label 2540: @167452
     /* 167452 */ GIM_Try, /*On fail goto*//*Label 2541*/ GIMT_Encode4(167474), // Rule ID 591 //
     /* 167457 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 167460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 167463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 167467 */   // (fp_to_sint:{ *:[i32] } f32:{ *:[f32] }:$RB)  =>  (EFSCTSIZ:{ *:[i32] } f32:{ *:[f32] }:$RB)
     /* 167467 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSCTSIZ),
     /* 167472 */   GIR_RootConstrainSelectedInstOperands,
     /* 167473 */   // GIR_Coverage, 591,
     /* 167473 */   GIR_Done,
     /* 167474 */ // Label 2541: @167474
     /* 167474 */ GIM_Reject,
     /* 167475 */ // Label 2535: @167475
     /* 167475 */ GIM_Try, /*On fail goto*//*Label 2542*/ GIMT_Encode4(167518), // Rule ID 2246 //
     /* 167480 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 167483 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 167486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 167490 */   // (fp_to_sint:{ *:[i64] } f128:{ *:[f128] }:$src)  =>  (MFVRD:{ *:[i64] } (XSCVQPSDZ:{ *:[v4i32] } ?:{ *:[f128] }:$src))
     /* 167490 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 167493 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCVQPSDZ),
     /* 167497 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167502 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 167506 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 167508 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVRD),
     /* 167511 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 167513 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 167516 */   GIR_RootConstrainSelectedInstOperands,
     /* 167517 */   // GIR_Coverage, 2246,
     /* 167517 */   GIR_EraseRootFromParent_Done,
     /* 167518 */ // Label 2542: @167518
     /* 167518 */ GIM_Reject,
     /* 167519 */ // Label 2536: @167519
     /* 167519 */ GIM_Try, /*On fail goto*//*Label 2543*/ GIMT_Encode4(167545), // Rule ID 878 //
     /* 167524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 167527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 167530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 167534 */   // (fp_to_sint:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$XB)  =>  (XVCVDPSXDS:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$XB)
     /* 167534 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVCVDPSXDS),
     /* 167539 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 167543 */   GIR_RootConstrainSelectedInstOperands,
     /* 167544 */   // GIR_Coverage, 878,
     /* 167544 */   GIR_Done,
     /* 167545 */ // Label 2543: @167545
     /* 167545 */ GIM_Reject,
     /* 167546 */ // Label 2537: @167546
     /* 167546 */ GIM_Try, /*On fail goto*//*Label 2544*/ GIMT_Encode4(167597),
     /* 167551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 167554 */   GIM_Try, /*On fail goto*//*Label 2545*/ GIMT_Encode4(167577), // Rule ID 886 //
     /* 167559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 167562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 167566 */     // (fp_to_sint:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$XB)  =>  (XVCVSPSXWS:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$XB)
     /* 167566 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVCVSPSXWS),
     /* 167571 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 167575 */     GIR_RootConstrainSelectedInstOperands,
     /* 167576 */     // GIR_Coverage, 886,
     /* 167576 */     GIR_Done,
     /* 167577 */   // Label 2545: @167577
     /* 167577 */   GIM_Try, /*On fail goto*//*Label 2546*/ GIMT_Encode4(167596), // Rule ID 1415 //
     /* 167582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 167585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 167589 */     // (fp_to_sint:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$vA)  =>  (VCTSXS_0:{ *:[v4i32] } ?:{ *:[v4f32] }:$vA)
     /* 167589 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCTSXS_0),
     /* 167594 */     GIR_RootConstrainSelectedInstOperands,
     /* 167595 */     // GIR_Coverage, 1415,
     /* 167595 */     GIR_Done,
     /* 167596 */   // Label 2546: @167596
     /* 167596 */   GIM_Reject,
     /* 167597 */ // Label 2544: @167597
     /* 167597 */ GIM_Reject,
     /* 167598 */ // Label 2538: @167598
     /* 167598 */ GIM_Reject,
     /* 167599 */ // Label 49: @167599
     /* 167599 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2551*/ GIMT_Encode4(167861),
     /* 167610 */ /*GILLT_s32*//*Label 2547*/ GIMT_Encode4(167630),
     /* 167614 */ /*GILLT_s64*//*Label 2548*/ GIMT_Encode4(167738), GIMT_Encode4(0),
     /* 167622 */ /*GILLT_v2s64*//*Label 2549*/ GIMT_Encode4(167782),
     /* 167626 */ /*GILLT_v4s32*//*Label 2550*/ GIMT_Encode4(167809),
     /* 167630 */ // Label 2547: @167630
     /* 167630 */ GIM_Try, /*On fail goto*//*Label 2552*/ GIMT_Encode4(167693), // Rule ID 2252 //
     /* 167635 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 167638 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 167641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 167645 */   // (fp_to_uint:{ *:[i32] } f128:{ *:[f128] }:$src)  =>  (MFVSRWZ:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[f64] } (XSCVQPUWZ:{ *:[f128] } ?:{ *:[f128] }:$src), VFRC:{ *:[i32] }))
     /* 167645 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 167648 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCVQPUWZ),
     /* 167652 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167657 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 167661 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 167663 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 167666 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 167670 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167675 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 167678 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VFRCRegClassID),
     /* 167683 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRWZ),
     /* 167686 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 167688 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 167691 */   GIR_RootConstrainSelectedInstOperands,
     /* 167692 */   // GIR_Coverage, 2252,
     /* 167692 */   GIR_EraseRootFromParent_Done,
     /* 167693 */ // Label 2552: @167693
     /* 167693 */ GIM_Try, /*On fail goto*//*Label 2553*/ GIMT_Encode4(167715), // Rule ID 572 //
     /* 167698 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 167701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 167704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 167708 */   // (fp_to_uint:{ *:[i32] } f64:{ *:[f64] }:$RB)  =>  (EFDCTUIZ:{ *:[i32] } f64:{ *:[f64] }:$RB)
     /* 167708 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDCTUIZ),
     /* 167713 */   GIR_RootConstrainSelectedInstOperands,
     /* 167714 */   // GIR_Coverage, 572,
     /* 167714 */   GIR_Done,
     /* 167715 */ // Label 2553: @167715
     /* 167715 */ GIM_Try, /*On fail goto*//*Label 2554*/ GIMT_Encode4(167737), // Rule ID 593 //
     /* 167720 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 167723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 167726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 167730 */   // (fp_to_uint:{ *:[i32] } f32:{ *:[f32] }:$RB)  =>  (EFSCTUIZ:{ *:[i32] } f32:{ *:[f32] }:$RB)
     /* 167730 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSCTUIZ),
     /* 167735 */   GIR_RootConstrainSelectedInstOperands,
     /* 167736 */   // GIR_Coverage, 593,
     /* 167736 */   GIR_Done,
     /* 167737 */ // Label 2554: @167737
     /* 167737 */ GIM_Reject,
     /* 167738 */ // Label 2548: @167738
     /* 167738 */ GIM_Try, /*On fail goto*//*Label 2555*/ GIMT_Encode4(167781), // Rule ID 2248 //
     /* 167743 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 167746 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 167749 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 167753 */   // (fp_to_uint:{ *:[i64] } f128:{ *:[f128] }:$src)  =>  (MFVRD:{ *:[i64] } (XSCVQPUDZ:{ *:[v4i32] } ?:{ *:[f128] }:$src))
     /* 167753 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 167756 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCVQPUDZ),
     /* 167760 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167765 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 167769 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 167771 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVRD),
     /* 167774 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 167776 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 167779 */   GIR_RootConstrainSelectedInstOperands,
     /* 167780 */   // GIR_Coverage, 2248,
     /* 167780 */   GIR_EraseRootFromParent_Done,
     /* 167781 */ // Label 2555: @167781
     /* 167781 */ GIM_Reject,
     /* 167782 */ // Label 2549: @167782
     /* 167782 */ GIM_Try, /*On fail goto*//*Label 2556*/ GIMT_Encode4(167808), // Rule ID 881 //
     /* 167787 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 167790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 167793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 167797 */   // (fp_to_uint:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$XB)  =>  (XVCVDPUXDS:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$XB)
     /* 167797 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVCVDPUXDS),
     /* 167802 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 167806 */   GIR_RootConstrainSelectedInstOperands,
     /* 167807 */   // GIR_Coverage, 881,
     /* 167807 */   GIR_Done,
     /* 167808 */ // Label 2556: @167808
     /* 167808 */ GIM_Reject,
     /* 167809 */ // Label 2550: @167809
     /* 167809 */ GIM_Try, /*On fail goto*//*Label 2557*/ GIMT_Encode4(167860),
     /* 167814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 167817 */   GIM_Try, /*On fail goto*//*Label 2558*/ GIMT_Encode4(167840), // Rule ID 889 //
     /* 167822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 167825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 167829 */     // (fp_to_uint:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$XB)  =>  (XVCVSPUXWS:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$XB)
     /* 167829 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVCVSPUXWS),
     /* 167834 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 167838 */     GIR_RootConstrainSelectedInstOperands,
     /* 167839 */     // GIR_Coverage, 889,
     /* 167839 */     GIR_Done,
     /* 167840 */   // Label 2558: @167840
     /* 167840 */   GIM_Try, /*On fail goto*//*Label 2559*/ GIMT_Encode4(167859), // Rule ID 1416 //
     /* 167845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 167848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 167852 */     // (fp_to_uint:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$vA)  =>  (VCTUXS_0:{ *:[v4i32] } ?:{ *:[v4f32] }:$vA)
     /* 167852 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCTUXS_0),
     /* 167857 */     GIR_RootConstrainSelectedInstOperands,
     /* 167858 */     // GIR_Coverage, 1416,
     /* 167858 */     GIR_Done,
     /* 167859 */   // Label 2559: @167859
     /* 167859 */   GIM_Reject,
     /* 167860 */ // Label 2557: @167860
     /* 167860 */ GIM_Reject,
     /* 167861 */ // Label 2551: @167861
     /* 167861 */ GIM_Reject,
     /* 167862 */ // Label 50: @167862
     /* 167862 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2565*/ GIMT_Encode4(168108),
     /* 167873 */ /*GILLT_s32*//*Label 2560*/ GIMT_Encode4(167893),
     /* 167877 */ /*GILLT_s64*//*Label 2561*/ GIMT_Encode4(167916),
     /* 167881 */ /*GILLT_s128*//*Label 2562*/ GIMT_Encode4(167939),
     /* 167885 */ /*GILLT_v2s64*//*Label 2563*/ GIMT_Encode4(168029),
     /* 167889 */ /*GILLT_v4s32*//*Label 2564*/ GIMT_Encode4(168056),
     /* 167893 */ // Label 2560: @167893
     /* 167893 */ GIM_Try, /*On fail goto*//*Label 2566*/ GIMT_Encode4(167915), // Rule ID 587 //
     /* 167898 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 167901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 167904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 167908 */   // (sint_to_fp:{ *:[f32] } i32:{ *:[i32] }:$RB)  =>  (EFSCFSI:{ *:[f32] } i32:{ *:[i32] }:$RB)
     /* 167908 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSCFSI),
     /* 167913 */   GIR_RootConstrainSelectedInstOperands,
     /* 167914 */   // GIR_Coverage, 587,
     /* 167914 */   GIR_Done,
     /* 167915 */ // Label 2566: @167915
     /* 167915 */ GIM_Reject,
     /* 167916 */ // Label 2561: @167916
     /* 167916 */ GIM_Try, /*On fail goto*//*Label 2567*/ GIMT_Encode4(167938), // Rule ID 566 //
     /* 167921 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 167924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 167927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 167931 */   // (sint_to_fp:{ *:[f64] } i32:{ *:[i32] }:$RB)  =>  (EFDCFSI:{ *:[f64] } i32:{ *:[i32] }:$RB)
     /* 167931 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDCFSI),
     /* 167936 */   GIR_RootConstrainSelectedInstOperands,
     /* 167937 */   // GIR_Coverage, 566,
     /* 167937 */   GIR_Done,
     /* 167938 */ // Label 2567: @167938
     /* 167938 */ GIM_Reject,
     /* 167939 */ // Label 2562: @167939
     /* 167939 */ GIM_Try, /*On fail goto*//*Label 2568*/ GIMT_Encode4(167985), // Rule ID 2141 //
     /* 167944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 167947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 167950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 167954 */   // (sint_to_fp:{ *:[f128] } i64:{ *:[i64] }:$src)  =>  (XSCVSDQP:{ *:[f128] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[i64] }:$src, VFRC:{ *:[i32] }))
     /* 167954 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 167957 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 167961 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167966 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 167970 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VFRCRegClassID),
     /* 167975 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVSDQP),
     /* 167978 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 167980 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 167983 */   GIR_RootConstrainSelectedInstOperands,
     /* 167984 */   // GIR_Coverage, 2141,
     /* 167984 */   GIR_EraseRootFromParent_Done,
     /* 167985 */ // Label 2568: @167985
     /* 167985 */ GIM_Try, /*On fail goto*//*Label 2569*/ GIMT_Encode4(168028), // Rule ID 2151 //
     /* 167990 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 167993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 167996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 168000 */   // (sint_to_fp:{ *:[f128] } i32:{ *:[i32] }:$src)  =>  (XSCVSDQP:{ *:[f128] } (MTVSRWA:{ *:[f64] } ?:{ *:[i32] }:$src))
     /* 168000 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 168003 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::MTVSRWA),
     /* 168007 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168012 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 168016 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 168018 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVSDQP),
     /* 168021 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 168023 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 168026 */   GIR_RootConstrainSelectedInstOperands,
     /* 168027 */   // GIR_Coverage, 2151,
     /* 168027 */   GIR_EraseRootFromParent_Done,
     /* 168028 */ // Label 2569: @168028
     /* 168028 */ GIM_Reject,
     /* 168029 */ // Label 2563: @168029
     /* 168029 */ GIM_Try, /*On fail goto*//*Label 2570*/ GIMT_Encode4(168055), // Rule ID 891 //
     /* 168034 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 168037 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 168040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 168044 */   // (sint_to_fp:{ *:[v2f64] } v2i64:{ *:[v2i64] }:$XB)  =>  (XVCVSXDDP:{ *:[v2f64] } v2i64:{ *:[v2i64] }:$XB)
     /* 168044 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVCVSXDDP),
     /* 168049 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 168053 */   GIR_RootConstrainSelectedInstOperands,
     /* 168054 */   // GIR_Coverage, 891,
     /* 168054 */   GIR_Done,
     /* 168055 */ // Label 2570: @168055
     /* 168055 */ GIM_Reject,
     /* 168056 */ // Label 2564: @168056
     /* 168056 */ GIM_Try, /*On fail goto*//*Label 2571*/ GIMT_Encode4(168107),
     /* 168061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 168064 */   GIM_Try, /*On fail goto*//*Label 2572*/ GIMT_Encode4(168087), // Rule ID 894 //
     /* 168069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 168072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 168076 */     // (sint_to_fp:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$XB)  =>  (XVCVSXWSP:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$XB)
     /* 168076 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVCVSXWSP),
     /* 168081 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 168085 */     GIR_RootConstrainSelectedInstOperands,
     /* 168086 */     // GIR_Coverage, 894,
     /* 168086 */     GIR_Done,
     /* 168087 */   // Label 2572: @168087
     /* 168087 */   GIM_Try, /*On fail goto*//*Label 2573*/ GIMT_Encode4(168106), // Rule ID 1417 //
     /* 168092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 168095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 168099 */     // (sint_to_fp:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$vA)  =>  (VCFSX_0:{ *:[v4f32] } ?:{ *:[v4i32] }:$vA)
     /* 168099 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCFSX_0),
     /* 168104 */     GIR_RootConstrainSelectedInstOperands,
     /* 168105 */     // GIR_Coverage, 1417,
     /* 168105 */     GIR_Done,
     /* 168106 */   // Label 2573: @168106
     /* 168106 */   GIM_Reject,
     /* 168107 */ // Label 2571: @168107
     /* 168107 */ GIM_Reject,
     /* 168108 */ // Label 2565: @168108
     /* 168108 */ GIM_Reject,
     /* 168109 */ // Label 51: @168109
     /* 168109 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2579*/ GIMT_Encode4(168355),
     /* 168120 */ /*GILLT_s32*//*Label 2574*/ GIMT_Encode4(168140),
     /* 168124 */ /*GILLT_s64*//*Label 2575*/ GIMT_Encode4(168163),
     /* 168128 */ /*GILLT_s128*//*Label 2576*/ GIMT_Encode4(168186),
     /* 168132 */ /*GILLT_v2s64*//*Label 2577*/ GIMT_Encode4(168276),
     /* 168136 */ /*GILLT_v4s32*//*Label 2578*/ GIMT_Encode4(168303),
     /* 168140 */ // Label 2574: @168140
     /* 168140 */ GIM_Try, /*On fail goto*//*Label 2580*/ GIMT_Encode4(168162), // Rule ID 589 //
     /* 168145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 168148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 168151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 168155 */   // (uint_to_fp:{ *:[f32] } i32:{ *:[i32] }:$RB)  =>  (EFSCFUI:{ *:[f32] } i32:{ *:[i32] }:$RB)
     /* 168155 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSCFUI),
     /* 168160 */   GIR_RootConstrainSelectedInstOperands,
     /* 168161 */   // GIR_Coverage, 589,
     /* 168161 */   GIR_Done,
     /* 168162 */ // Label 2580: @168162
     /* 168162 */ GIM_Reject,
     /* 168163 */ // Label 2575: @168163
     /* 168163 */ GIM_Try, /*On fail goto*//*Label 2581*/ GIMT_Encode4(168185), // Rule ID 568 //
     /* 168168 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 168171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 168174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 168178 */   // (uint_to_fp:{ *:[f64] } i32:{ *:[i32] }:$RB)  =>  (EFDCFUI:{ *:[f64] } i32:{ *:[i32] }:$RB)
     /* 168178 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDCFUI),
     /* 168183 */   GIR_RootConstrainSelectedInstOperands,
     /* 168184 */   // GIR_Coverage, 568,
     /* 168184 */   GIR_Done,
     /* 168185 */ // Label 2581: @168185
     /* 168185 */ GIM_Reject,
     /* 168186 */ // Label 2576: @168186
     /* 168186 */ GIM_Try, /*On fail goto*//*Label 2582*/ GIMT_Encode4(168232), // Rule ID 2147 //
     /* 168191 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 168194 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 168197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 168201 */   // (uint_to_fp:{ *:[f128] } i64:{ *:[i64] }:$src)  =>  (XSCVUDQP:{ *:[f128] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[i64] }:$src, VFRC:{ *:[i32] }))
     /* 168201 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 168204 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168208 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168213 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 168217 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VFRCRegClassID),
     /* 168222 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVUDQP),
     /* 168225 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 168227 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 168230 */   GIR_RootConstrainSelectedInstOperands,
     /* 168231 */   // GIR_Coverage, 2147,
     /* 168231 */   GIR_EraseRootFromParent_Done,
     /* 168232 */ // Label 2582: @168232
     /* 168232 */ GIM_Try, /*On fail goto*//*Label 2583*/ GIMT_Encode4(168275), // Rule ID 2155 //
     /* 168237 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 168240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 168243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 168247 */   // (uint_to_fp:{ *:[f128] } i32:{ *:[i32] }:$src)  =>  (XSCVUDQP:{ *:[f128] } (MTVSRWZ:{ *:[f64] } ?:{ *:[i32] }:$src))
     /* 168247 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 168250 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::MTVSRWZ),
     /* 168254 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168259 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 168263 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 168265 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVUDQP),
     /* 168268 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 168270 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 168273 */   GIR_RootConstrainSelectedInstOperands,
     /* 168274 */   // GIR_Coverage, 2155,
     /* 168274 */   GIR_EraseRootFromParent_Done,
     /* 168275 */ // Label 2583: @168275
     /* 168275 */ GIM_Reject,
     /* 168276 */ // Label 2577: @168276
     /* 168276 */ GIM_Try, /*On fail goto*//*Label 2584*/ GIMT_Encode4(168302), // Rule ID 896 //
     /* 168281 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 168284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 168287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 168291 */   // (uint_to_fp:{ *:[v2f64] } v2i64:{ *:[v2i64] }:$XB)  =>  (XVCVUXDDP:{ *:[v2f64] } v2i64:{ *:[v2i64] }:$XB)
     /* 168291 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVCVUXDDP),
     /* 168296 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 168300 */   GIR_RootConstrainSelectedInstOperands,
     /* 168301 */   // GIR_Coverage, 896,
     /* 168301 */   GIR_Done,
     /* 168302 */ // Label 2584: @168302
     /* 168302 */ GIM_Reject,
     /* 168303 */ // Label 2578: @168303
     /* 168303 */ GIM_Try, /*On fail goto*//*Label 2585*/ GIMT_Encode4(168354),
     /* 168308 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 168311 */   GIM_Try, /*On fail goto*//*Label 2586*/ GIMT_Encode4(168334), // Rule ID 899 //
     /* 168316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 168319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 168323 */     // (uint_to_fp:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$XB)  =>  (XVCVUXWSP:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$XB)
     /* 168323 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVCVUXWSP),
     /* 168328 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 168332 */     GIR_RootConstrainSelectedInstOperands,
     /* 168333 */     // GIR_Coverage, 899,
     /* 168333 */     GIR_Done,
     /* 168334 */   // Label 2586: @168334
     /* 168334 */   GIM_Try, /*On fail goto*//*Label 2587*/ GIMT_Encode4(168353), // Rule ID 1418 //
     /* 168339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 168342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 168346 */     // (uint_to_fp:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$vA)  =>  (VCFUX_0:{ *:[v4f32] } ?:{ *:[v4i32] }:$vA)
     /* 168346 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCFUX_0),
     /* 168351 */     GIR_RootConstrainSelectedInstOperands,
     /* 168352 */     // GIR_Coverage, 1418,
     /* 168352 */     GIR_Done,
     /* 168353 */   // Label 2587: @168353
     /* 168353 */   GIM_Reject,
     /* 168354 */ // Label 2585: @168354
     /* 168354 */ GIM_Reject,
     /* 168355 */ // Label 2579: @168355
     /* 168355 */ GIM_Reject,
     /* 168356 */ // Label 52: @168356
     /* 168356 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2593*/ GIMT_Encode4(168647),
     /* 168367 */ /*GILLT_s32*//*Label 2588*/ GIMT_Encode4(168387),
     /* 168371 */ /*GILLT_s64*//*Label 2589*/ GIMT_Encode4(168499),
     /* 168375 */ /*GILLT_s128*//*Label 2590*/ GIMT_Encode4(168570),
     /* 168379 */ /*GILLT_v2s64*//*Label 2591*/ GIMT_Encode4(168593),
     /* 168383 */ /*GILLT_v4s32*//*Label 2592*/ GIMT_Encode4(168620),
     /* 168387 */ // Label 2588: @168387
     /* 168387 */ GIM_Try, /*On fail goto*//*Label 2594*/ GIMT_Encode4(168498),
     /* 168392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 168395 */   GIM_Try, /*On fail goto*//*Label 2595*/ GIMT_Encode4(168459), // Rule ID 1684 //
     /* 168400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 168403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 168407 */     // (fabs:{ *:[f32] } f32:{ *:[f32] }:$S)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSABSDP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 168407 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 168410 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168414 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168419 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 168423 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 168428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 168431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSABSDP),
     /* 168435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168440 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 168443 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 168445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168450 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 168453 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 168458 */     // GIR_Coverage, 1684,
     /* 168458 */     GIR_EraseRootFromParent_Done,
     /* 168459 */   // Label 2595: @168459
     /* 168459 */   GIM_Try, /*On fail goto*//*Label 2596*/ GIMT_Encode4(168478), // Rule ID 163 //
     /* 168464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 168467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 168471 */     // (fabs:{ *:[f32] } f32:{ *:[f32] }:$RB)  =>  (FABSS:{ *:[f32] } f32:{ *:[f32] }:$RB)
     /* 168471 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FABSS),
     /* 168476 */     GIR_RootConstrainSelectedInstOperands,
     /* 168477 */     // GIR_Coverage, 163,
     /* 168477 */     GIR_Done,
     /* 168478 */   // Label 2596: @168478
     /* 168478 */   GIM_Try, /*On fail goto*//*Label 2597*/ GIMT_Encode4(168497), // Rule ID 581 //
     /* 168483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 168486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 168490 */     // (fabs:{ *:[f32] } f32:{ *:[f32] }:$RA)  =>  (EFSABS:{ *:[f32] } f32:{ *:[f32] }:$RA)
     /* 168490 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSABS),
     /* 168495 */     GIR_RootConstrainSelectedInstOperands,
     /* 168496 */     // GIR_Coverage, 581,
     /* 168496 */     GIR_Done,
     /* 168497 */   // Label 2597: @168497
     /* 168497 */   GIM_Reject,
     /* 168498 */ // Label 2594: @168498
     /* 168498 */ GIM_Reject,
     /* 168499 */ // Label 2589: @168499
     /* 168499 */ GIM_Try, /*On fail goto*//*Label 2598*/ GIMT_Encode4(168569),
     /* 168504 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 168507 */   GIM_Try, /*On fail goto*//*Label 2599*/ GIMT_Encode4(168530), // Rule ID 843 //
     /* 168512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 168515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 168519 */     // (fabs:{ *:[f64] } f64:{ *:[f64] }:$XB)  =>  (XSABSDP:{ *:[f64] } f64:{ *:[f64] }:$XB)
     /* 168519 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSABSDP),
     /* 168524 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 168528 */     GIR_RootConstrainSelectedInstOperands,
     /* 168529 */     // GIR_Coverage, 843,
     /* 168529 */     GIR_Done,
     /* 168530 */   // Label 2599: @168530
     /* 168530 */   GIM_Try, /*On fail goto*//*Label 2600*/ GIMT_Encode4(168549), // Rule ID 164 //
     /* 168535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 168538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 168542 */     // (fabs:{ *:[f64] } f64:{ *:[f64] }:$RB)  =>  (FABSD:{ *:[f64] } f64:{ *:[f64] }:$RB)
     /* 168542 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FABSD),
     /* 168547 */     GIR_RootConstrainSelectedInstOperands,
     /* 168548 */     // GIR_Coverage, 164,
     /* 168548 */     GIR_Done,
     /* 168549 */   // Label 2600: @168549
     /* 168549 */   GIM_Try, /*On fail goto*//*Label 2601*/ GIMT_Encode4(168568), // Rule ID 560 //
     /* 168554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 168557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 168561 */     // (fabs:{ *:[f64] } f64:{ *:[f64] }:$RA)  =>  (EFDABS:{ *:[f64] } f64:{ *:[f64] }:$RA)
     /* 168561 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDABS),
     /* 168566 */     GIR_RootConstrainSelectedInstOperands,
     /* 168567 */     // GIR_Coverage, 560,
     /* 168567 */     GIR_Done,
     /* 168568 */   // Label 2601: @168568
     /* 168568 */   GIM_Reject,
     /* 168569 */ // Label 2598: @168569
     /* 168569 */ GIM_Reject,
     /* 168570 */ // Label 2590: @168570
     /* 168570 */ GIM_Try, /*On fail goto*//*Label 2602*/ GIMT_Encode4(168592), // Rule ID 984 //
     /* 168575 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 168578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 168581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 168585 */   // (fabs:{ *:[f128] } f128:{ *:[f128] }:$RB)  =>  (XSABSQP:{ *:[f128] } f128:{ *:[f128] }:$RB)
     /* 168585 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSABSQP),
     /* 168590 */   GIR_RootConstrainSelectedInstOperands,
     /* 168591 */   // GIR_Coverage, 984,
     /* 168591 */   GIR_Done,
     /* 168592 */ // Label 2602: @168592
     /* 168592 */ GIM_Reject,
     /* 168593 */ // Label 2591: @168593
     /* 168593 */ GIM_Try, /*On fail goto*//*Label 2603*/ GIMT_Encode4(168619), // Rule ID 848 //
     /* 168598 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 168601 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 168604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 168608 */   // (fabs:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)  =>  (XVABSDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)
     /* 168608 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVABSDP),
     /* 168613 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 168617 */   GIR_RootConstrainSelectedInstOperands,
     /* 168618 */   // GIR_Coverage, 848,
     /* 168618 */   GIR_Done,
     /* 168619 */ // Label 2603: @168619
     /* 168619 */ GIM_Reject,
     /* 168620 */ // Label 2592: @168620
     /* 168620 */ GIM_Try, /*On fail goto*//*Label 2604*/ GIMT_Encode4(168646), // Rule ID 849 //
     /* 168625 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 168628 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 168631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 168635 */   // (fabs:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)  =>  (XVABSSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)
     /* 168635 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVABSSP),
     /* 168640 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 168644 */   GIR_RootConstrainSelectedInstOperands,
     /* 168645 */   // GIR_Coverage, 849,
     /* 168645 */   GIR_Done,
     /* 168646 */ // Label 2604: @168646
     /* 168646 */ GIM_Reject,
     /* 168647 */ // Label 2593: @168647
     /* 168647 */ GIM_Reject,
     /* 168648 */ // Label 53: @168648
     /* 168648 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2610*/ GIMT_Encode4(168963),
     /* 168659 */ /*GILLT_s32*//*Label 2605*/ GIMT_Encode4(168679),
     /* 168663 */ /*GILLT_s64*//*Label 2606*/ GIMT_Encode4(168763),
     /* 168667 */ /*GILLT_s128*//*Label 2607*/ GIMT_Encode4(168873),
     /* 168671 */ /*GILLT_v2s64*//*Label 2608*/ GIMT_Encode4(168903),
     /* 168675 */ /*GILLT_v4s32*//*Label 2609*/ GIMT_Encode4(168933),
     /* 168679 */ // Label 2605: @168679
     /* 168679 */ GIM_Try, /*On fail goto*//*Label 2611*/ GIMT_Encode4(168762),
     /* 168684 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 168687 */   GIM_Try, /*On fail goto*//*Label 2612*/ GIMT_Encode4(168713), // Rule ID 169 //
     /* 168692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 168695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 168698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 168702 */     // (fcopysign:{ *:[f32] } f32:{ *:[f32] }:$RB, f32:{ *:[f32] }:$RA)  =>  (FCPSGNS:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)
     /* 168702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FCPSGNS),
     /* 168705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 168707 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /* 168709 */     GIR_RootToRootCopy, /*OpIdx*/1, // RB
     /* 168711 */     GIR_RootConstrainSelectedInstOperands,
     /* 168712 */     // GIR_Coverage, 169,
     /* 168712 */     GIR_EraseRootFromParent_Done,
     /* 168713 */   // Label 2612: @168713
     /* 168713 */   GIM_Try, /*On fail goto*//*Label 2613*/ GIMT_Encode4(168761), // Rule ID 1281 //
     /* 168718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 168721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 168728 */     // (fcopysign:{ *:[f32] } f32:{ *:[f32] }:$frB, f64:{ *:[f64] }:$frA)  =>  (FCPSGNS:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[f32] } ?:{ *:[f64] }:$frA, F4RC:{ *:[i32] }), ?:{ *:[f32] }:$frB)
     /* 168728 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 168731 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168735 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168740 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // frA
     /* 168744 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::F4RCRegClassID),
     /* 168749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FCPSGNS),
     /* 168752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 168754 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 168757 */     GIR_RootToRootCopy, /*OpIdx*/1, // frB
     /* 168759 */     GIR_RootConstrainSelectedInstOperands,
     /* 168760 */     // GIR_Coverage, 1281,
     /* 168760 */     GIR_EraseRootFromParent_Done,
     /* 168761 */   // Label 2613: @168761
     /* 168761 */   GIM_Reject,
     /* 168762 */ // Label 2611: @168762
     /* 168762 */ GIM_Reject,
     /* 168763 */ // Label 2606: @168763
     /* 168763 */ GIM_Try, /*On fail goto*//*Label 2614*/ GIMT_Encode4(168872),
     /* 168768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 168771 */   GIM_Try, /*On fail goto*//*Label 2615*/ GIMT_Encode4(168797), // Rule ID 847 //
     /* 168776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 168779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 168786 */     // (fcopysign:{ *:[f64] } f64:{ *:[f64] }:$XB, f64:{ *:[f64] }:$XA)  =>  (XSCPSGNDP:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 168786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCPSGNDP),
     /* 168789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 168791 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /* 168793 */     GIR_RootToRootCopy, /*OpIdx*/1, // XB
     /* 168795 */     GIR_RootConstrainSelectedInstOperands,
     /* 168796 */     // GIR_Coverage, 847,
     /* 168796 */     GIR_EraseRootFromParent_Done,
     /* 168797 */   // Label 2615: @168797
     /* 168797 */   GIM_Try, /*On fail goto*//*Label 2616*/ GIMT_Encode4(168823), // Rule ID 170 //
     /* 168802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 168805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 168812 */     // (fcopysign:{ *:[f64] } f64:{ *:[f64] }:$RB, f64:{ *:[f64] }:$RA)  =>  (FCPSGND:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)
     /* 168812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FCPSGND),
     /* 168815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 168817 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /* 168819 */     GIR_RootToRootCopy, /*OpIdx*/1, // RB
     /* 168821 */     GIR_RootConstrainSelectedInstOperands,
     /* 168822 */     // GIR_Coverage, 170,
     /* 168822 */     GIR_EraseRootFromParent_Done,
     /* 168823 */   // Label 2616: @168823
     /* 168823 */   GIM_Try, /*On fail goto*//*Label 2617*/ GIMT_Encode4(168871), // Rule ID 1280 //
     /* 168828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 168831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 168834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 168838 */     // (fcopysign:{ *:[f64] } f64:{ *:[f64] }:$frB, f32:{ *:[f32] }:$frA)  =>  (FCPSGND:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$frA, F8RC:{ *:[i32] }), ?:{ *:[f64] }:$frB)
     /* 168838 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 168841 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168845 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168850 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // frA
     /* 168854 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::F8RCRegClassID),
     /* 168859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FCPSGND),
     /* 168862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 168864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 168867 */     GIR_RootToRootCopy, /*OpIdx*/1, // frB
     /* 168869 */     GIR_RootConstrainSelectedInstOperands,
     /* 168870 */     // GIR_Coverage, 1280,
     /* 168870 */     GIR_EraseRootFromParent_Done,
     /* 168871 */   // Label 2617: @168871
     /* 168871 */   GIM_Reject,
     /* 168872 */ // Label 2614: @168872
     /* 168872 */ GIM_Reject,
     /* 168873 */ // Label 2607: @168873
     /* 168873 */ GIM_Try, /*On fail goto*//*Label 2618*/ GIMT_Encode4(168902), // Rule ID 983 //
     /* 168878 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 168881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 168884 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 168887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 168891 */   // (fcopysign:{ *:[f128] } f128:{ *:[f128] }:$RB, f128:{ *:[f128] }:$RA)  =>  (XSCPSGNQP:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 168891 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCPSGNQP),
     /* 168894 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 168896 */   GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /* 168898 */   GIR_RootToRootCopy, /*OpIdx*/1, // RB
     /* 168900 */   GIR_RootConstrainSelectedInstOperands,
     /* 168901 */   // GIR_Coverage, 983,
     /* 168901 */   GIR_EraseRootFromParent_Done,
     /* 168902 */ // Label 2618: @168902
     /* 168902 */ GIM_Reject,
     /* 168903 */ // Label 2608: @168903
     /* 168903 */ GIM_Try, /*On fail goto*//*Label 2619*/ GIMT_Encode4(168932), // Rule ID 850 //
     /* 168908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 168911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 168914 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 168917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 168921 */   // (fcopysign:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB, v2f64:{ *:[v2f64] }:$XA)  =>  (XVCPSGNDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 168921 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCPSGNDP),
     /* 168924 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 168926 */   GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /* 168928 */   GIR_RootToRootCopy, /*OpIdx*/1, // XB
     /* 168930 */   GIR_RootConstrainSelectedInstOperands,
     /* 168931 */   // GIR_Coverage, 850,
     /* 168931 */   GIR_EraseRootFromParent_Done,
     /* 168932 */ // Label 2619: @168932
     /* 168932 */ GIM_Reject,
     /* 168933 */ // Label 2609: @168933
     /* 168933 */ GIM_Try, /*On fail goto*//*Label 2620*/ GIMT_Encode4(168962), // Rule ID 851 //
     /* 168938 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 168941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 168944 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 168951 */   // (fcopysign:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB, v4f32:{ *:[v4f32] }:$XA)  =>  (XVCPSGNSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 168951 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCPSGNSP),
     /* 168954 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 168956 */   GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /* 168958 */   GIR_RootToRootCopy, /*OpIdx*/1, // XB
     /* 168960 */   GIR_RootConstrainSelectedInstOperands,
     /* 168961 */   // GIR_Coverage, 851,
     /* 168961 */   GIR_EraseRootFromParent_Done,
     /* 168962 */ // Label 2620: @168962
     /* 168962 */ GIM_Reject,
     /* 168963 */ // Label 2610: @168963
     /* 168963 */ GIM_Reject,
     /* 168964 */ // Label 54: @168964
     /* 168964 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(6), /*)*//*default:*//*Label 2623*/ GIMT_Encode4(169043),
     /* 168975 */ /*GILLT_v2s64*//*Label 2621*/ GIMT_Encode4(168983),
     /* 168979 */ /*GILLT_v4s32*//*Label 2622*/ GIMT_Encode4(169013),
     /* 168983 */ // Label 2621: @168983
     /* 168983 */ GIM_Try, /*On fail goto*//*Label 2624*/ GIMT_Encode4(169012), // Rule ID 1683 //
     /* 168988 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 168991 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 168994 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 168997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 169001 */   // (fminnum:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$src1, v2f64:{ *:[v2f64] }:$src2)  =>  (XVMINDP:{ *:[v2f64] } ?:{ *:[v2f64] }:$src1, ?:{ *:[v2f64] }:$src2)
     /* 169001 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVMINDP),
     /* 169006 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 169010 */   GIR_RootConstrainSelectedInstOperands,
     /* 169011 */   // GIR_Coverage, 1683,
     /* 169011 */   GIR_Done,
     /* 169012 */ // Label 2624: @169012
     /* 169012 */ GIM_Reject,
     /* 169013 */ // Label 2622: @169013
     /* 169013 */ GIM_Try, /*On fail goto*//*Label 2625*/ GIMT_Encode4(169042), // Rule ID 1679 //
     /* 169018 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 169021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 169024 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 169031 */   // (fminnum:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src1, v4f32:{ *:[v4f32] }:$src2)  =>  (XVMINSP:{ *:[v4f32] } ?:{ *:[v4f32] }:$src1, ?:{ *:[v4f32] }:$src2)
     /* 169031 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVMINSP),
     /* 169036 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 169040 */   GIR_RootConstrainSelectedInstOperands,
     /* 169041 */   // GIR_Coverage, 1679,
     /* 169041 */   GIR_Done,
     /* 169042 */ // Label 2625: @169042
     /* 169042 */ GIM_Reject,
     /* 169043 */ // Label 2623: @169043
     /* 169043 */ GIM_Reject,
     /* 169044 */ // Label 55: @169044
     /* 169044 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(6), /*)*//*default:*//*Label 2628*/ GIMT_Encode4(169123),
     /* 169055 */ /*GILLT_v2s64*//*Label 2626*/ GIMT_Encode4(169063),
     /* 169059 */ /*GILLT_v4s32*//*Label 2627*/ GIMT_Encode4(169093),
     /* 169063 */ // Label 2626: @169063
     /* 169063 */ GIM_Try, /*On fail goto*//*Label 2629*/ GIMT_Encode4(169092), // Rule ID 1681 //
     /* 169068 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 169071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 169074 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 169081 */   // (fmaxnum:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$src1, v2f64:{ *:[v2f64] }:$src2)  =>  (XVMAXDP:{ *:[v2f64] } ?:{ *:[v2f64] }:$src1, ?:{ *:[v2f64] }:$src2)
     /* 169081 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVMAXDP),
     /* 169086 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 169090 */   GIR_RootConstrainSelectedInstOperands,
     /* 169091 */   // GIR_Coverage, 1681,
     /* 169091 */   GIR_Done,
     /* 169092 */ // Label 2629: @169092
     /* 169092 */ GIM_Reject,
     /* 169093 */ // Label 2627: @169093
     /* 169093 */ GIM_Try, /*On fail goto*//*Label 2630*/ GIMT_Encode4(169122), // Rule ID 1677 //
     /* 169098 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 169101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 169104 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 169111 */   // (fmaxnum:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src1, v4f32:{ *:[v4f32] }:$src2)  =>  (XVMAXSP:{ *:[v4f32] } ?:{ *:[v4f32] }:$src1, ?:{ *:[v4f32] }:$src2)
     /* 169111 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVMAXSP),
     /* 169116 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 169120 */   GIR_RootConstrainSelectedInstOperands,
     /* 169121 */   // GIR_Coverage, 1677,
     /* 169121 */   GIR_Done,
     /* 169122 */ // Label 2630: @169122
     /* 169122 */ GIM_Reject,
     /* 169123 */ // Label 2628: @169123
     /* 169123 */ GIM_Reject,
     /* 169124 */ // Label 56: @169124
     /* 169124 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2633*/ GIMT_Encode4(169705),
     /* 169135 */ /*GILLT_s32*//*Label 2631*/ GIMT_Encode4(169143),
     /* 169139 */ /*GILLT_s64*//*Label 2632*/ GIMT_Encode4(169550),
     /* 169143 */ // Label 2631: @169143
     /* 169143 */ GIM_Try, /*On fail goto*//*Label 2634*/ GIMT_Encode4(169549),
     /* 169148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 169151 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 169154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 169158 */   GIM_Try, /*On fail goto*//*Label 2635*/ GIMT_Encode4(169268), // Rule ID 1689 //
     /* 169163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 169166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 169170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 169174 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 169178 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 169182 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 169186 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 169190 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 169192 */     // (fminnum_ieee:{ *:[f32] } (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$A), (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$B))  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSMINDP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$A, VSFRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$B, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 169192 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 169195 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169199 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169204 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // B
     /* 169208 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169213 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 169216 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169220 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169225 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // A
     /* 169229 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 169237 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSMINDP),
     /* 169241 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169246 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169249 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169252 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 169254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169259 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 169262 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 169267 */     // GIR_Coverage, 1689,
     /* 169267 */     GIR_EraseRootFromParent_Done,
     /* 169268 */   // Label 2635: @169268
     /* 169268 */   GIM_Try, /*On fail goto*//*Label 2636*/ GIMT_Encode4(169366), // Rule ID 1687 //
     /* 169273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 169276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 169280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 169284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 169288 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169290 */     // (fminnum_ieee:{ *:[f32] } (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$A), f32:{ *:[f32] }:$B)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSMINDP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$A, VSFRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$B, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 169290 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 169293 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169297 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169302 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // B
     /* 169306 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169311 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 169314 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169318 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169323 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // A
     /* 169327 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169332 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 169335 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSMINDP),
     /* 169339 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169344 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169347 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169350 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 169352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169357 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 169360 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 169365 */     // GIR_Coverage, 1687,
     /* 169365 */     GIR_EraseRootFromParent_Done,
     /* 169366 */   // Label 2636: @169366
     /* 169366 */   GIM_Try, /*On fail goto*//*Label 2637*/ GIMT_Encode4(169464), // Rule ID 1688 //
     /* 169371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 169374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 169378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 169382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 169386 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169388 */     // (fminnum_ieee:{ *:[f32] } f32:{ *:[f32] }:$A, (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$B))  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSMINDP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$A, VSFRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$B, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 169388 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 169391 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169395 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169400 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // B
     /* 169404 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169409 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 169412 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169416 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169421 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 169425 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169430 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 169433 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSMINDP),
     /* 169437 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169442 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169445 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169448 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 169450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169455 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 169458 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 169463 */     // GIR_Coverage, 1688,
     /* 169463 */     GIR_EraseRootFromParent_Done,
     /* 169464 */   // Label 2637: @169464
     /* 169464 */   GIM_Try, /*On fail goto*//*Label 2638*/ GIMT_Encode4(169548), // Rule ID 1686 //
     /* 169469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 169472 */     // (fminnum_ieee:{ *:[f32] } f32:{ *:[f32] }:$A, f32:{ *:[f32] }:$B)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSMINDP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$A, VSFRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$B, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 169472 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 169475 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169479 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169484 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // B
     /* 169488 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169493 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 169496 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169500 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169505 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 169509 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169514 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 169517 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSMINDP),
     /* 169521 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169526 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169529 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169532 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 169534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169539 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 169542 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 169547 */     // GIR_Coverage, 1686,
     /* 169547 */     GIR_EraseRootFromParent_Done,
     /* 169548 */   // Label 2638: @169548
     /* 169548 */   GIM_Reject,
     /* 169549 */ // Label 2634: @169549
     /* 169549 */ GIM_Reject,
     /* 169550 */ // Label 2632: @169550
     /* 169550 */ GIM_Try, /*On fail goto*//*Label 2639*/ GIMT_Encode4(169704),
     /* 169555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 169558 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 169561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169565 */   GIM_Try, /*On fail goto*//*Label 2640*/ GIMT_Encode4(169614), // Rule ID 1697 //
     /* 169570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 169573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 169577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 169581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 169585 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 169589 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 169593 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 169597 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 169599 */     // (fminnum_ieee:{ *:[f64] } (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$A), (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$B))  =>  (XSMINDP:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B)
     /* 169599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMINDP),
     /* 169602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 169604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // A
     /* 169608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // B
     /* 169612 */     GIR_RootConstrainSelectedInstOperands,
     /* 169613 */     // GIR_Coverage, 1697,
     /* 169613 */     GIR_EraseRootFromParent_Done,
     /* 169614 */   // Label 2640: @169614
     /* 169614 */   GIM_Try, /*On fail goto*//*Label 2641*/ GIMT_Encode4(169649), // Rule ID 1695 //
     /* 169619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 169622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 169626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 169630 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 169634 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169636 */     // (fminnum_ieee:{ *:[f64] } (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$A), f64:{ *:[f64] }:$B)  =>  (XSMINDP:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B)
     /* 169636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMINDP),
     /* 169639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 169641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // A
     /* 169645 */     GIR_RootToRootCopy, /*OpIdx*/2, // B
     /* 169647 */     GIR_RootConstrainSelectedInstOperands,
     /* 169648 */     // GIR_Coverage, 1695,
     /* 169648 */     GIR_EraseRootFromParent_Done,
     /* 169649 */   // Label 2641: @169649
     /* 169649 */   GIM_Try, /*On fail goto*//*Label 2642*/ GIMT_Encode4(169684), // Rule ID 1696 //
     /* 169654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 169657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 169661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 169665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 169669 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169671 */     // (fminnum_ieee:{ *:[f64] } f64:{ *:[f64] }:$A, (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$B))  =>  (XSMINDP:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B)
     /* 169671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMINDP),
     /* 169674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 169676 */     GIR_RootToRootCopy, /*OpIdx*/1, // A
     /* 169678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // B
     /* 169682 */     GIR_RootConstrainSelectedInstOperands,
     /* 169683 */     // GIR_Coverage, 1696,
     /* 169683 */     GIR_EraseRootFromParent_Done,
     /* 169684 */   // Label 2642: @169684
     /* 169684 */   GIM_Try, /*On fail goto*//*Label 2643*/ GIMT_Encode4(169703), // Rule ID 1694 //
     /* 169689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 169692 */     // (fminnum_ieee:{ *:[f64] } f64:{ *:[f64] }:$A, f64:{ *:[f64] }:$B)  =>  (XSMINDP:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B)
     /* 169692 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSMINDP),
     /* 169697 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 169701 */     GIR_RootConstrainSelectedInstOperands,
     /* 169702 */     // GIR_Coverage, 1694,
     /* 169702 */     GIR_Done,
     /* 169703 */   // Label 2643: @169703
     /* 169703 */   GIM_Reject,
     /* 169704 */ // Label 2639: @169704
     /* 169704 */ GIM_Reject,
     /* 169705 */ // Label 2633: @169705
     /* 169705 */ GIM_Reject,
     /* 169706 */ // Label 57: @169706
     /* 169706 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2646*/ GIMT_Encode4(170287),
     /* 169717 */ /*GILLT_s32*//*Label 2644*/ GIMT_Encode4(169725),
     /* 169721 */ /*GILLT_s64*//*Label 2645*/ GIMT_Encode4(170132),
     /* 169725 */ // Label 2644: @169725
     /* 169725 */ GIM_Try, /*On fail goto*//*Label 2647*/ GIMT_Encode4(170131),
     /* 169730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 169733 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 169736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 169740 */   GIM_Try, /*On fail goto*//*Label 2648*/ GIMT_Encode4(169850), // Rule ID 1693 //
     /* 169745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 169748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 169752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 169756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 169760 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 169764 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 169768 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 169772 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 169774 */     // (fmaxnum_ieee:{ *:[f32] } (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$A), (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$B))  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSMAXDP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$A, VSFRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$B, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 169774 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 169777 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169781 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169786 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // B
     /* 169790 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169795 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 169798 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169802 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169807 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // A
     /* 169811 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 169819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSMAXDP),
     /* 169823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169828 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169831 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169834 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 169836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169841 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 169844 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 169849 */     // GIR_Coverage, 1693,
     /* 169849 */     GIR_EraseRootFromParent_Done,
     /* 169850 */   // Label 2648: @169850
     /* 169850 */   GIM_Try, /*On fail goto*//*Label 2649*/ GIMT_Encode4(169948), // Rule ID 1691 //
     /* 169855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 169858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 169862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 169866 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 169870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169872 */     // (fmaxnum_ieee:{ *:[f32] } (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$A), f32:{ *:[f32] }:$B)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSMAXDP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$A, VSFRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$B, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 169872 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 169875 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169879 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169884 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // B
     /* 169888 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169893 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 169896 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169900 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169905 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // A
     /* 169909 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169914 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 169917 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSMAXDP),
     /* 169921 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169926 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169929 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169932 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 169934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169939 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 169942 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 169947 */     // GIR_Coverage, 1691,
     /* 169947 */     GIR_EraseRootFromParent_Done,
     /* 169948 */   // Label 2649: @169948
     /* 169948 */   GIM_Try, /*On fail goto*//*Label 2650*/ GIMT_Encode4(170046), // Rule ID 1692 //
     /* 169953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 169956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 169960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 169964 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 169968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169970 */     // (fmaxnum_ieee:{ *:[f32] } f32:{ *:[f32] }:$A, (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$B))  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSMAXDP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$A, VSFRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$B, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 169970 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 169973 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169977 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169982 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // B
     /* 169986 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169991 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 169994 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169998 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170003 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 170007 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 170012 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 170015 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSMAXDP),
     /* 170019 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170024 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 170027 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 170030 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 170032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170037 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 170040 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 170045 */     // GIR_Coverage, 1692,
     /* 170045 */     GIR_EraseRootFromParent_Done,
     /* 170046 */   // Label 2650: @170046
     /* 170046 */   GIM_Try, /*On fail goto*//*Label 2651*/ GIMT_Encode4(170130), // Rule ID 1690 //
     /* 170051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 170054 */     // (fmaxnum_ieee:{ *:[f32] } f32:{ *:[f32] }:$A, f32:{ *:[f32] }:$B)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSMAXDP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$A, VSFRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$B, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 170054 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 170057 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170061 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170066 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // B
     /* 170070 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 170075 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 170078 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170082 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170087 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 170091 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 170096 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 170099 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSMAXDP),
     /* 170103 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170108 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 170111 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 170114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 170116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170121 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 170124 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 170129 */     // GIR_Coverage, 1690,
     /* 170129 */     GIR_EraseRootFromParent_Done,
     /* 170130 */   // Label 2651: @170130
     /* 170130 */   GIM_Reject,
     /* 170131 */ // Label 2647: @170131
     /* 170131 */ GIM_Reject,
     /* 170132 */ // Label 2645: @170132
     /* 170132 */ GIM_Try, /*On fail goto*//*Label 2652*/ GIMT_Encode4(170286),
     /* 170137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 170140 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 170143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 170147 */   GIM_Try, /*On fail goto*//*Label 2653*/ GIMT_Encode4(170196), // Rule ID 1701 //
     /* 170152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 170155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 170159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 170163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 170167 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 170171 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 170175 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 170179 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 170181 */     // (fmaxnum_ieee:{ *:[f64] } (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$A), (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$B))  =>  (XSMAXDP:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B)
     /* 170181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMAXDP),
     /* 170184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 170186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // A
     /* 170190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // B
     /* 170194 */     GIR_RootConstrainSelectedInstOperands,
     /* 170195 */     // GIR_Coverage, 1701,
     /* 170195 */     GIR_EraseRootFromParent_Done,
     /* 170196 */   // Label 2653: @170196
     /* 170196 */   GIM_Try, /*On fail goto*//*Label 2654*/ GIMT_Encode4(170231), // Rule ID 1699 //
     /* 170201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 170204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 170208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 170212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 170216 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 170218 */     // (fmaxnum_ieee:{ *:[f64] } (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$A), f64:{ *:[f64] }:$B)  =>  (XSMAXDP:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B)
     /* 170218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMAXDP),
     /* 170221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 170223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // A
     /* 170227 */     GIR_RootToRootCopy, /*OpIdx*/2, // B
     /* 170229 */     GIR_RootConstrainSelectedInstOperands,
     /* 170230 */     // GIR_Coverage, 1699,
     /* 170230 */     GIR_EraseRootFromParent_Done,
     /* 170231 */   // Label 2654: @170231
     /* 170231 */   GIM_Try, /*On fail goto*//*Label 2655*/ GIMT_Encode4(170266), // Rule ID 1700 //
     /* 170236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 170239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 170243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 170247 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 170251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 170253 */     // (fmaxnum_ieee:{ *:[f64] } f64:{ *:[f64] }:$A, (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$B))  =>  (XSMAXDP:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B)
     /* 170253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMAXDP),
     /* 170256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 170258 */     GIR_RootToRootCopy, /*OpIdx*/1, // A
     /* 170260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // B
     /* 170264 */     GIR_RootConstrainSelectedInstOperands,
     /* 170265 */     // GIR_Coverage, 1700,
     /* 170265 */     GIR_EraseRootFromParent_Done,
     /* 170266 */   // Label 2655: @170266
     /* 170266 */   GIM_Try, /*On fail goto*//*Label 2656*/ GIMT_Encode4(170285), // Rule ID 1698 //
     /* 170271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 170274 */     // (fmaxnum_ieee:{ *:[f64] } f64:{ *:[f64] }:$A, f64:{ *:[f64] }:$B)  =>  (XSMAXDP:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B)
     /* 170274 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSMAXDP),
     /* 170279 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 170283 */     GIR_RootConstrainSelectedInstOperands,
     /* 170284 */     // GIR_Coverage, 1698,
     /* 170284 */     GIR_Done,
     /* 170285 */   // Label 2656: @170285
     /* 170285 */   GIM_Reject,
     /* 170286 */ // Label 2652: @170286
     /* 170286 */ GIM_Reject,
     /* 170287 */ // Label 2646: @170287
     /* 170287 */ GIM_Reject,
     /* 170288 */ // Label 58: @170288
     /* 170288 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(8), /*)*//*default:*//*Label 2661*/ GIMT_Encode4(170467),
     /* 170299 */ /*GILLT_v2s64*//*Label 2657*/ GIMT_Encode4(170315),
     /* 170303 */ /*GILLT_v4s32*//*Label 2658*/ GIMT_Encode4(170389),
     /* 170307 */ /*GILLT_v8s16*//*Label 2659*/ GIMT_Encode4(170415),
     /* 170311 */ /*GILLT_v16s8*//*Label 2660*/ GIMT_Encode4(170441),
     /* 170315 */ // Label 2657: @170315
     /* 170315 */ GIM_Try, /*On fail goto*//*Label 2662*/ GIMT_Encode4(170388), // Rule ID 1933 //
     /* 170320 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 170323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 170326 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170329 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170333 */   // (smin:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$src1, v2i64:{ *:[v2i64] }:$src2)  =>  (VMINSD:{ *:[v2i64] } (COPY_TO_REGCLASS:{ *:[f128] } ?:{ *:[v2i64] }:$src1, VRRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f128] } ?:{ *:[v2i64] }:$src2, VRRC:{ *:[i32] }))
     /* 170333 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 170336 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170340 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170345 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 170349 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170354 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 170357 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170361 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170366 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 170370 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170375 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMINSD),
     /* 170378 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 170380 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 170383 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 170386 */   GIR_RootConstrainSelectedInstOperands,
     /* 170387 */   // GIR_Coverage, 1933,
     /* 170387 */   GIR_EraseRootFromParent_Done,
     /* 170388 */ // Label 2662: @170388
     /* 170388 */ GIM_Reject,
     /* 170389 */ // Label 2658: @170389
     /* 170389 */ GIM_Try, /*On fail goto*//*Label 2663*/ GIMT_Encode4(170414), // Rule ID 1362 //
     /* 170394 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 170397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 170400 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170407 */   // (smin:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src1, v4i32:{ *:[v4i32] }:$src2)  =>  (VMINSW:{ *:[v4i32] } ?:{ *:[v4i32] }:$src1, ?:{ *:[v4i32] }:$src2)
     /* 170407 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMINSW),
     /* 170412 */   GIR_RootConstrainSelectedInstOperands,
     /* 170413 */   // GIR_Coverage, 1362,
     /* 170413 */   GIR_Done,
     /* 170414 */ // Label 2663: @170414
     /* 170414 */ GIM_Reject,
     /* 170415 */ // Label 2659: @170415
     /* 170415 */ GIM_Try, /*On fail goto*//*Label 2664*/ GIMT_Encode4(170440), // Rule ID 1360 //
     /* 170420 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 170423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 170426 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170433 */   // (smin:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$src1, v8i16:{ *:[v8i16] }:$src2)  =>  (VMINSH:{ *:[v8i16] } ?:{ *:[v8i16] }:$src1, ?:{ *:[v8i16] }:$src2)
     /* 170433 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMINSH),
     /* 170438 */   GIR_RootConstrainSelectedInstOperands,
     /* 170439 */   // GIR_Coverage, 1360,
     /* 170439 */   GIR_Done,
     /* 170440 */ // Label 2664: @170440
     /* 170440 */ GIM_Reject,
     /* 170441 */ // Label 2660: @170441
     /* 170441 */ GIM_Try, /*On fail goto*//*Label 2665*/ GIMT_Encode4(170466), // Rule ID 1358 //
     /* 170446 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 170449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 170452 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 170455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170459 */   // (smin:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$src1, v16i8:{ *:[v16i8] }:$src2)  =>  (VMINSB:{ *:[v16i8] } ?:{ *:[v16i8] }:$src1, ?:{ *:[v16i8] }:$src2)
     /* 170459 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMINSB),
     /* 170464 */   GIR_RootConstrainSelectedInstOperands,
     /* 170465 */   // GIR_Coverage, 1358,
     /* 170465 */   GIR_Done,
     /* 170466 */ // Label 2665: @170466
     /* 170466 */ GIM_Reject,
     /* 170467 */ // Label 2661: @170467
     /* 170467 */ GIM_Reject,
     /* 170468 */ // Label 59: @170468
     /* 170468 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(8), /*)*//*default:*//*Label 2670*/ GIMT_Encode4(170647),
     /* 170479 */ /*GILLT_v2s64*//*Label 2666*/ GIMT_Encode4(170495),
     /* 170483 */ /*GILLT_v4s32*//*Label 2667*/ GIMT_Encode4(170569),
     /* 170487 */ /*GILLT_v8s16*//*Label 2668*/ GIMT_Encode4(170595),
     /* 170491 */ /*GILLT_v16s8*//*Label 2669*/ GIMT_Encode4(170621),
     /* 170495 */ // Label 2666: @170495
     /* 170495 */ GIM_Try, /*On fail goto*//*Label 2671*/ GIMT_Encode4(170568), // Rule ID 1931 //
     /* 170500 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 170503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 170506 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170513 */   // (smax:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$src1, v2i64:{ *:[v2i64] }:$src2)  =>  (VMAXSD:{ *:[v2i64] } (COPY_TO_REGCLASS:{ *:[f128] } ?:{ *:[v2i64] }:$src1, VRRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f128] } ?:{ *:[v2i64] }:$src2, VRRC:{ *:[i32] }))
     /* 170513 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 170516 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170520 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170525 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 170529 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170534 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 170537 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170541 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170546 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 170550 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170555 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMAXSD),
     /* 170558 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 170560 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 170563 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 170566 */   GIR_RootConstrainSelectedInstOperands,
     /* 170567 */   // GIR_Coverage, 1931,
     /* 170567 */   GIR_EraseRootFromParent_Done,
     /* 170568 */ // Label 2671: @170568
     /* 170568 */ GIM_Reject,
     /* 170569 */ // Label 2667: @170569
     /* 170569 */ GIM_Try, /*On fail goto*//*Label 2672*/ GIMT_Encode4(170594), // Rule ID 1356 //
     /* 170574 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 170577 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 170580 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170587 */   // (smax:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src1, v4i32:{ *:[v4i32] }:$src2)  =>  (VMAXSW:{ *:[v4i32] } ?:{ *:[v4i32] }:$src1, ?:{ *:[v4i32] }:$src2)
     /* 170587 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMAXSW),
     /* 170592 */   GIR_RootConstrainSelectedInstOperands,
     /* 170593 */   // GIR_Coverage, 1356,
     /* 170593 */   GIR_Done,
     /* 170594 */ // Label 2672: @170594
     /* 170594 */ GIM_Reject,
     /* 170595 */ // Label 2668: @170595
     /* 170595 */ GIM_Try, /*On fail goto*//*Label 2673*/ GIMT_Encode4(170620), // Rule ID 1354 //
     /* 170600 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 170603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 170606 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170613 */   // (smax:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$src1, v8i16:{ *:[v8i16] }:$src2)  =>  (VMAXSH:{ *:[v8i16] } ?:{ *:[v8i16] }:$src1, ?:{ *:[v8i16] }:$src2)
     /* 170613 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMAXSH),
     /* 170618 */   GIR_RootConstrainSelectedInstOperands,
     /* 170619 */   // GIR_Coverage, 1354,
     /* 170619 */   GIR_Done,
     /* 170620 */ // Label 2673: @170620
     /* 170620 */ GIM_Reject,
     /* 170621 */ // Label 2669: @170621
     /* 170621 */ GIM_Try, /*On fail goto*//*Label 2674*/ GIMT_Encode4(170646), // Rule ID 1352 //
     /* 170626 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 170629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 170632 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 170635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170639 */   // (smax:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$src1, v16i8:{ *:[v16i8] }:$src2)  =>  (VMAXSB:{ *:[v16i8] } ?:{ *:[v16i8] }:$src1, ?:{ *:[v16i8] }:$src2)
     /* 170639 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMAXSB),
     /* 170644 */   GIR_RootConstrainSelectedInstOperands,
     /* 170645 */   // GIR_Coverage, 1352,
     /* 170645 */   GIR_Done,
     /* 170646 */ // Label 2674: @170646
     /* 170646 */ GIM_Reject,
     /* 170647 */ // Label 2670: @170647
     /* 170647 */ GIM_Reject,
     /* 170648 */ // Label 60: @170648
     /* 170648 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(8), /*)*//*default:*//*Label 2679*/ GIMT_Encode4(170827),
     /* 170659 */ /*GILLT_v2s64*//*Label 2675*/ GIMT_Encode4(170675),
     /* 170663 */ /*GILLT_v4s32*//*Label 2676*/ GIMT_Encode4(170749),
     /* 170667 */ /*GILLT_v8s16*//*Label 2677*/ GIMT_Encode4(170775),
     /* 170671 */ /*GILLT_v16s8*//*Label 2678*/ GIMT_Encode4(170801),
     /* 170675 */ // Label 2675: @170675
     /* 170675 */ GIM_Try, /*On fail goto*//*Label 2680*/ GIMT_Encode4(170748), // Rule ID 1934 //
     /* 170680 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 170683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 170686 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170693 */   // (umin:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$src1, v2i64:{ *:[v2i64] }:$src2)  =>  (VMINUD:{ *:[v2i64] } (COPY_TO_REGCLASS:{ *:[f128] } ?:{ *:[v2i64] }:$src1, VRRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f128] } ?:{ *:[v2i64] }:$src2, VRRC:{ *:[i32] }))
     /* 170693 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 170696 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170700 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170705 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 170709 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170714 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 170717 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170721 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170726 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 170730 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170735 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMINUD),
     /* 170738 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 170740 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 170743 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 170746 */   GIR_RootConstrainSelectedInstOperands,
     /* 170747 */   // GIR_Coverage, 1934,
     /* 170747 */   GIR_EraseRootFromParent_Done,
     /* 170748 */ // Label 2680: @170748
     /* 170748 */ GIM_Reject,
     /* 170749 */ // Label 2676: @170749
     /* 170749 */ GIM_Try, /*On fail goto*//*Label 2681*/ GIMT_Encode4(170774), // Rule ID 1361 //
     /* 170754 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 170757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 170760 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170767 */   // (umin:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src1, v4i32:{ *:[v4i32] }:$src2)  =>  (VMINUW:{ *:[v4i32] } ?:{ *:[v4i32] }:$src1, ?:{ *:[v4i32] }:$src2)
     /* 170767 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMINUW),
     /* 170772 */   GIR_RootConstrainSelectedInstOperands,
     /* 170773 */   // GIR_Coverage, 1361,
     /* 170773 */   GIR_Done,
     /* 170774 */ // Label 2681: @170774
     /* 170774 */ GIM_Reject,
     /* 170775 */ // Label 2677: @170775
     /* 170775 */ GIM_Try, /*On fail goto*//*Label 2682*/ GIMT_Encode4(170800), // Rule ID 1359 //
     /* 170780 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 170783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 170786 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170793 */   // (umin:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$src1, v8i16:{ *:[v8i16] }:$src2)  =>  (VMINUH:{ *:[v8i16] } ?:{ *:[v8i16] }:$src1, ?:{ *:[v8i16] }:$src2)
     /* 170793 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMINUH),
     /* 170798 */   GIR_RootConstrainSelectedInstOperands,
     /* 170799 */   // GIR_Coverage, 1359,
     /* 170799 */   GIR_Done,
     /* 170800 */ // Label 2682: @170800
     /* 170800 */ GIM_Reject,
     /* 170801 */ // Label 2678: @170801
     /* 170801 */ GIM_Try, /*On fail goto*//*Label 2683*/ GIMT_Encode4(170826), // Rule ID 1357 //
     /* 170806 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 170809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 170812 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 170815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170819 */   // (umin:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$src1, v16i8:{ *:[v16i8] }:$src2)  =>  (VMINUB:{ *:[v16i8] } ?:{ *:[v16i8] }:$src1, ?:{ *:[v16i8] }:$src2)
     /* 170819 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMINUB),
     /* 170824 */   GIR_RootConstrainSelectedInstOperands,
     /* 170825 */   // GIR_Coverage, 1357,
     /* 170825 */   GIR_Done,
     /* 170826 */ // Label 2683: @170826
     /* 170826 */ GIM_Reject,
     /* 170827 */ // Label 2679: @170827
     /* 170827 */ GIM_Reject,
     /* 170828 */ // Label 61: @170828
     /* 170828 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(8), /*)*//*default:*//*Label 2688*/ GIMT_Encode4(171007),
     /* 170839 */ /*GILLT_v2s64*//*Label 2684*/ GIMT_Encode4(170855),
     /* 170843 */ /*GILLT_v4s32*//*Label 2685*/ GIMT_Encode4(170929),
     /* 170847 */ /*GILLT_v8s16*//*Label 2686*/ GIMT_Encode4(170955),
     /* 170851 */ /*GILLT_v16s8*//*Label 2687*/ GIMT_Encode4(170981),
     /* 170855 */ // Label 2684: @170855
     /* 170855 */ GIM_Try, /*On fail goto*//*Label 2689*/ GIMT_Encode4(170928), // Rule ID 1932 //
     /* 170860 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 170863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 170866 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170873 */   // (umax:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$src1, v2i64:{ *:[v2i64] }:$src2)  =>  (VMAXUD:{ *:[v2i64] } (COPY_TO_REGCLASS:{ *:[f128] } ?:{ *:[v2i64] }:$src1, VRRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f128] } ?:{ *:[v2i64] }:$src2, VRRC:{ *:[i32] }))
     /* 170873 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 170876 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170880 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170885 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 170889 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170894 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 170897 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170901 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170906 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 170910 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170915 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMAXUD),
     /* 170918 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 170920 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 170923 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 170926 */   GIR_RootConstrainSelectedInstOperands,
     /* 170927 */   // GIR_Coverage, 1932,
     /* 170927 */   GIR_EraseRootFromParent_Done,
     /* 170928 */ // Label 2689: @170928
     /* 170928 */ GIM_Reject,
     /* 170929 */ // Label 2685: @170929
     /* 170929 */ GIM_Try, /*On fail goto*//*Label 2690*/ GIMT_Encode4(170954), // Rule ID 1355 //
     /* 170934 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 170937 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 170940 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170947 */   // (umax:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src1, v4i32:{ *:[v4i32] }:$src2)  =>  (VMAXUW:{ *:[v4i32] } ?:{ *:[v4i32] }:$src1, ?:{ *:[v4i32] }:$src2)
     /* 170947 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMAXUW),
     /* 170952 */   GIR_RootConstrainSelectedInstOperands,
     /* 170953 */   // GIR_Coverage, 1355,
     /* 170953 */   GIR_Done,
     /* 170954 */ // Label 2690: @170954
     /* 170954 */ GIM_Reject,
     /* 170955 */ // Label 2686: @170955
     /* 170955 */ GIM_Try, /*On fail goto*//*Label 2691*/ GIMT_Encode4(170980), // Rule ID 1353 //
     /* 170960 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 170963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 170966 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170973 */   // (umax:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$src1, v8i16:{ *:[v8i16] }:$src2)  =>  (VMAXUH:{ *:[v8i16] } ?:{ *:[v8i16] }:$src1, ?:{ *:[v8i16] }:$src2)
     /* 170973 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMAXUH),
     /* 170978 */   GIR_RootConstrainSelectedInstOperands,
     /* 170979 */   // GIR_Coverage, 1353,
     /* 170979 */   GIR_Done,
     /* 170980 */ // Label 2691: @170980
     /* 170980 */ GIM_Reject,
     /* 170981 */ // Label 2687: @170981
     /* 170981 */ GIM_Try, /*On fail goto*//*Label 2692*/ GIMT_Encode4(171006), // Rule ID 1351 //
     /* 170986 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 170989 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 170992 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 170995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170999 */   // (umax:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$src1, v16i8:{ *:[v16i8] }:$src2)  =>  (VMAXUB:{ *:[v16i8] } ?:{ *:[v16i8] }:$src1, ?:{ *:[v16i8] }:$src2)
     /* 170999 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMAXUB),
     /* 171004 */   GIR_RootConstrainSelectedInstOperands,
     /* 171005 */   // GIR_Coverage, 1351,
     /* 171005 */   GIR_Done,
     /* 171006 */ // Label 2692: @171006
     /* 171006 */ GIM_Reject,
     /* 171007 */ // Label 2688: @171007
     /* 171007 */ GIM_Reject,
     /* 171008 */ // Label 62: @171008
     /* 171008 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2695*/ GIMT_Encode4(171309),
     /* 171019 */ /*GILLT_s32*//*Label 2693*/ GIMT_Encode4(171027),
     /* 171023 */ /*GILLT_s64*//*Label 2694*/ GIMT_Encode4(171168),
     /* 171027 */ // Label 2693: @171027
     /* 171027 */ GIM_Try, /*On fail goto*//*Label 2696*/ GIMT_Encode4(171087), // Rule ID 2039 //
     /* 171032 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /* 171035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 171038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 171042 */   // (lround:{ *:[i32] } f64:{ *:[f64] }:$S)  =>  (MFVSRWZ:{ *:[i32] } (FCTIW:{ *:[f64] } (XSRDPI:{ *:[f64] } ?:{ *:[f64] }:$S)))
     /* 171042 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 171045 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSRDPI),
     /* 171049 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171054 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 171058 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 171060 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 171063 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCTIW),
     /* 171067 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171072 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 171075 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 171077 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRWZ),
     /* 171080 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 171082 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 171085 */   GIR_RootConstrainSelectedInstOperands,
     /* 171086 */   // GIR_Coverage, 2039,
     /* 171086 */   GIR_EraseRootFromParent_Done,
     /* 171087 */ // Label 2696: @171087
     /* 171087 */ GIM_Try, /*On fail goto*//*Label 2697*/ GIMT_Encode4(171167), // Rule ID 2040 //
     /* 171092 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /* 171095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 171098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 171102 */   // (lround:{ *:[i32] } f32:{ *:[f32] }:$S)  =>  (MFVSRWZ:{ *:[i32] } (FCTIW:{ *:[f64] } (XSRDPI:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] }))))
     /* 171102 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 171105 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 171109 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171114 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 171118 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 171123 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 171126 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSRDPI),
     /* 171130 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171135 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 171138 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 171140 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 171143 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCTIW),
     /* 171147 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171152 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 171155 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 171157 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRWZ),
     /* 171160 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 171162 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 171165 */   GIR_RootConstrainSelectedInstOperands,
     /* 171166 */   // GIR_Coverage, 2040,
     /* 171166 */   GIR_EraseRootFromParent_Done,
     /* 171167 */ // Label 2697: @171167
     /* 171167 */ GIM_Reject,
     /* 171168 */ // Label 2694: @171168
     /* 171168 */ GIM_Try, /*On fail goto*//*Label 2698*/ GIMT_Encode4(171228), // Rule ID 2037 //
     /* 171173 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /* 171176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 171179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 171183 */   // (lround:{ *:[i64] } f64:{ *:[f64] }:$S)  =>  (MFVSRD:{ *:[i64] } (FCTID:{ *:[f64] } (XSRDPI:{ *:[f64] } ?:{ *:[f64] }:$S)))
     /* 171183 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 171186 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSRDPI),
     /* 171190 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171195 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 171199 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 171201 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 171204 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCTID),
     /* 171208 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171213 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 171216 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 171218 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRD),
     /* 171221 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 171223 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 171226 */   GIR_RootConstrainSelectedInstOperands,
     /* 171227 */   // GIR_Coverage, 2037,
     /* 171227 */   GIR_EraseRootFromParent_Done,
     /* 171228 */ // Label 2698: @171228
     /* 171228 */ GIM_Try, /*On fail goto*//*Label 2699*/ GIMT_Encode4(171308), // Rule ID 2038 //
     /* 171233 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /* 171236 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 171239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 171243 */   // (lround:{ *:[i64] } f32:{ *:[f32] }:$S)  =>  (MFVSRD:{ *:[i64] } (FCTID:{ *:[f64] } (XSRDPI:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] }))))
     /* 171243 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 171246 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 171250 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171255 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 171259 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 171264 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 171267 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSRDPI),
     /* 171271 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171276 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 171279 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 171281 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 171284 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCTID),
     /* 171288 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171293 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 171296 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 171298 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRD),
     /* 171301 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 171303 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 171306 */   GIR_RootConstrainSelectedInstOperands,
     /* 171307 */   // GIR_Coverage, 2038,
     /* 171307 */   GIR_EraseRootFromParent_Done,
     /* 171308 */ // Label 2699: @171308
     /* 171308 */ GIM_Reject,
     /* 171309 */ // Label 2695: @171309
     /* 171309 */ GIM_Reject,
     /* 171310 */ // Label 63: @171310
     /* 171310 */ GIM_Try, /*On fail goto*//*Label 2700*/ GIMT_Encode4(171474),
     /* 171315 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 171318 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2703*/ GIMT_Encode4(171473),
     /* 171329 */   /*GILLT_s32*//*Label 2701*/ GIMT_Encode4(171337),
     /* 171333 */   /*GILLT_s64*//*Label 2702*/ GIMT_Encode4(171415),
     /* 171337 */   // Label 2701: @171337
     /* 171337 */   GIM_Try, /*On fail goto*//*Label 2704*/ GIMT_Encode4(171414), // Rule ID 2042 //
     /* 171342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /* 171345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 171349 */     // (llround:{ *:[i64] } f32:{ *:[f32] }:$S)  =>  (MFVSRD:{ *:[i64] } (FCTID:{ *:[f64] } (XSRDPI:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] }))))
     /* 171349 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 171352 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 171356 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171361 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 171365 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 171370 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 171373 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSRDPI),
     /* 171377 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171382 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 171385 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 171387 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 171390 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCTID),
     /* 171394 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171399 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 171402 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 171404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRD),
     /* 171407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 171409 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 171412 */     GIR_RootConstrainSelectedInstOperands,
     /* 171413 */     // GIR_Coverage, 2042,
     /* 171413 */     GIR_EraseRootFromParent_Done,
     /* 171414 */   // Label 2704: @171414
     /* 171414 */   GIM_Reject,
     /* 171415 */   // Label 2702: @171415
     /* 171415 */   GIM_Try, /*On fail goto*//*Label 2705*/ GIMT_Encode4(171472), // Rule ID 2041 //
     /* 171420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /* 171423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 171427 */     // (llround:{ *:[i64] } f64:{ *:[f64] }:$S)  =>  (MFVSRD:{ *:[i64] } (FCTID:{ *:[f64] } (XSRDPI:{ *:[f64] } ?:{ *:[f64] }:$S)))
     /* 171427 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 171430 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSRDPI),
     /* 171434 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171439 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 171443 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 171445 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 171448 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCTID),
     /* 171452 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171457 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 171460 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 171462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRD),
     /* 171465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 171467 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 171470 */     GIR_RootConstrainSelectedInstOperands,
     /* 171471 */     // GIR_Coverage, 2041,
     /* 171471 */     GIR_EraseRootFromParent_Done,
     /* 171472 */   // Label 2705: @171472
     /* 171472 */   GIM_Reject,
     /* 171473 */   // Label 2703: @171473
     /* 171473 */   GIM_Reject,
     /* 171474 */ // Label 2700: @171474
     /* 171474 */ GIM_Reject,
     /* 171475 */ // Label 64: @171475
     /* 171475 */ GIM_Try, /*On fail goto*//*Label 2706*/ GIMT_Encode4(171490), // Rule ID 15 //
     /* 171480 */   // MIs[0] LI
     /* 171480 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 171483 */   // (br (bb:{ *:[Other] }):$LI)  =>  (B (bb:{ *:[Other] }):$LI)
     /* 171483 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::B),
     /* 171488 */   GIR_RootConstrainSelectedInstOperands,
     /* 171489 */   // GIR_Coverage, 15,
     /* 171489 */   GIR_Done,
     /* 171490 */ // Label 2706: @171490
     /* 171490 */ GIM_Reject,
     /* 171491 */ // Label 65: @171491
     /* 171491 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(8), /*)*//*default:*//*Label 2709*/ GIMT_Encode4(171608),
     /* 171502 */ /*GILLT_v8s16*//*Label 2707*/ GIMT_Encode4(171510),
     /* 171506 */ /*GILLT_v16s8*//*Label 2708*/ GIMT_Encode4(171573),
     /* 171510 */ // Label 2707: @171510
     /* 171510 */ GIM_Try, /*On fail goto*//*Label 2710*/ GIMT_Encode4(171572), // Rule ID 3494 //
     /* 171515 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX_IsBigEndian_IsISA3_1_IsPPC32),
     /* 171518 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 171521 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 171524 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 171527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 171531 */   // (vector_insert:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vDi, i32:{ *:[i32] }:$rA, i32:{ *:[i32] }:$rB)  =>  (VINSHLX:{ *:[v8i16] } ?:{ *:[v8i16] }:$vDi, (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$rB, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), ?:{ *:[i32] }:$rA)
     /* 171531 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 171534 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 171538 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171543 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rB
     /* 171547 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 171550 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 171553 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/30,
     /* 171556 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 171558 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSHLX),
     /* 171561 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 171563 */   GIR_RootToRootCopy, /*OpIdx*/1, // vDi
     /* 171565 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 171568 */   GIR_RootToRootCopy, /*OpIdx*/2, // rA
     /* 171570 */   GIR_RootConstrainSelectedInstOperands,
     /* 171571 */   // GIR_Coverage, 3494,
     /* 171571 */   GIR_EraseRootFromParent_Done,
     /* 171572 */ // Label 2710: @171572
     /* 171572 */ GIM_Reject,
     /* 171573 */ // Label 2708: @171573
     /* 171573 */ GIM_Try, /*On fail goto*//*Label 2711*/ GIMT_Encode4(171607), // Rule ID 3493 //
     /* 171578 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX_IsBigEndian_IsISA3_1_IsPPC32),
     /* 171581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 171584 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 171587 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 171590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 171594 */   // (vector_insert:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vDi, i32:{ *:[i32] }:$rA, i32:{ *:[i32] }:$rB)  =>  (VINSBLX:{ *:[v16i8] } ?:{ *:[v16i8] }:$vDi, ?:{ *:[i32] }:$rB, ?:{ *:[i32] }:$rA)
     /* 171594 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSBLX),
     /* 171597 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 171599 */   GIR_RootToRootCopy, /*OpIdx*/1, // vDi
     /* 171601 */   GIR_RootToRootCopy, /*OpIdx*/3, // rB
     /* 171603 */   GIR_RootToRootCopy, /*OpIdx*/2, // rA
     /* 171605 */   GIR_RootConstrainSelectedInstOperands,
     /* 171606 */   // GIR_Coverage, 3493,
     /* 171606 */   GIR_EraseRootFromParent_Done,
     /* 171607 */ // Label 2711: @171607
     /* 171607 */ GIM_Reject,
     /* 171608 */ // Label 2709: @171608
     /* 171608 */ GIM_Reject,
     /* 171609 */ // Label 66: @171609
     /* 171609 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 2718*/ GIMT_Encode4(171786),
     /* 171620 */ /*GILLT_s32*//*Label 2712*/ GIMT_Encode4(171648),
     /* 171624 */ /*GILLT_s64*//*Label 2713*/ GIMT_Encode4(171671), GIMT_Encode4(0),
     /* 171632 */ /*GILLT_v2s64*//*Label 2714*/ GIMT_Encode4(171694),
     /* 171636 */ /*GILLT_v4s32*//*Label 2715*/ GIMT_Encode4(171717),
     /* 171640 */ /*GILLT_v8s16*//*Label 2716*/ GIMT_Encode4(171740),
     /* 171644 */ /*GILLT_v16s8*//*Label 2717*/ GIMT_Encode4(171763),
     /* 171648 */ // Label 2712: @171648
     /* 171648 */ GIM_Try, /*On fail goto*//*Label 2719*/ GIMT_Encode4(171670), // Rule ID 134 //
     /* 171653 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_0),
     /* 171656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 171659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 171663 */   // (cttz:{ *:[i32] } i32:{ *:[i32] }:$RST)  =>  (CNTTZW:{ *:[i32] } i32:{ *:[i32] }:$RST)
     /* 171663 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::CNTTZW),
     /* 171668 */   GIR_RootConstrainSelectedInstOperands,
     /* 171669 */   // GIR_Coverage, 134,
     /* 171669 */   GIR_Done,
     /* 171670 */ // Label 2719: @171670
     /* 171670 */ GIM_Reject,
     /* 171671 */ // Label 2713: @171671
     /* 171671 */ GIM_Try, /*On fail goto*//*Label 2720*/ GIMT_Encode4(171693), // Rule ID 688 //
     /* 171676 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_0),
     /* 171679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 171682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 171686 */   // (cttz:{ *:[i64] } i64:{ *:[i64] }:$RST)  =>  (CNTTZD:{ *:[i64] } i64:{ *:[i64] }:$RST)
     /* 171686 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::CNTTZD),
     /* 171691 */   GIR_RootConstrainSelectedInstOperands,
     /* 171692 */   // GIR_Coverage, 688,
     /* 171692 */   GIR_Done,
     /* 171693 */ // Label 2720: @171693
     /* 171693 */ GIM_Reject,
     /* 171694 */ // Label 2714: @171694
     /* 171694 */ GIM_Try, /*On fail goto*//*Label 2721*/ GIMT_Encode4(171716), // Rule ID 535 //
     /* 171699 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /* 171702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 171705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 171709 */   // (cttz:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VB)  =>  (VCTZD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VB)
     /* 171709 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCTZD),
     /* 171714 */   GIR_RootConstrainSelectedInstOperands,
     /* 171715 */   // GIR_Coverage, 535,
     /* 171715 */   GIR_Done,
     /* 171716 */ // Label 2721: @171716
     /* 171716 */ GIM_Reject,
     /* 171717 */ // Label 2715: @171717
     /* 171717 */ GIM_Try, /*On fail goto*//*Label 2722*/ GIMT_Encode4(171739), // Rule ID 534 //
     /* 171722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /* 171725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 171728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 171732 */   // (cttz:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB)  =>  (VCTZW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB)
     /* 171732 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCTZW),
     /* 171737 */   GIR_RootConstrainSelectedInstOperands,
     /* 171738 */   // GIR_Coverage, 534,
     /* 171738 */   GIR_Done,
     /* 171739 */ // Label 2722: @171739
     /* 171739 */ GIM_Reject,
     /* 171740 */ // Label 2716: @171740
     /* 171740 */ GIM_Try, /*On fail goto*//*Label 2723*/ GIMT_Encode4(171762), // Rule ID 533 //
     /* 171745 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /* 171748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 171751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 171755 */   // (cttz:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VB)  =>  (VCTZH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VB)
     /* 171755 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCTZH),
     /* 171760 */   GIR_RootConstrainSelectedInstOperands,
     /* 171761 */   // GIR_Coverage, 533,
     /* 171761 */   GIR_Done,
     /* 171762 */ // Label 2723: @171762
     /* 171762 */ GIM_Reject,
     /* 171763 */ // Label 2717: @171763
     /* 171763 */ GIM_Try, /*On fail goto*//*Label 2724*/ GIMT_Encode4(171785), // Rule ID 532 //
     /* 171768 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /* 171771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 171774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 171778 */   // (cttz:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VB)  =>  (VCTZB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VB)
     /* 171778 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCTZB),
     /* 171783 */   GIR_RootConstrainSelectedInstOperands,
     /* 171784 */   // GIR_Coverage, 532,
     /* 171784 */   GIR_Done,
     /* 171785 */ // Label 2724: @171785
     /* 171785 */ GIM_Reject,
     /* 171786 */ // Label 2718: @171786
     /* 171786 */ GIM_Reject,
     /* 171787 */ // Label 67: @171787
     /* 171787 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 2731*/ GIMT_Encode4(171958),
     /* 171798 */ /*GILLT_s32*//*Label 2725*/ GIMT_Encode4(171826),
     /* 171802 */ /*GILLT_s64*//*Label 2726*/ GIMT_Encode4(171846), GIMT_Encode4(0),
     /* 171810 */ /*GILLT_v2s64*//*Label 2727*/ GIMT_Encode4(171866),
     /* 171814 */ /*GILLT_v4s32*//*Label 2728*/ GIMT_Encode4(171889),
     /* 171818 */ /*GILLT_v8s16*//*Label 2729*/ GIMT_Encode4(171912),
     /* 171822 */ /*GILLT_v16s8*//*Label 2730*/ GIMT_Encode4(171935),
     /* 171826 */ // Label 2725: @171826
     /* 171826 */ GIM_Try, /*On fail goto*//*Label 2732*/ GIMT_Encode4(171845), // Rule ID 133 //
     /* 171831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 171834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 171838 */   // (ctlz:{ *:[i32] } i32:{ *:[i32] }:$RST)  =>  (CNTLZW:{ *:[i32] } i32:{ *:[i32] }:$RST)
     /* 171838 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /* 171843 */   GIR_RootConstrainSelectedInstOperands,
     /* 171844 */   // GIR_Coverage, 133,
     /* 171844 */   GIR_Done,
     /* 171845 */ // Label 2732: @171845
     /* 171845 */ GIM_Reject,
     /* 171846 */ // Label 2726: @171846
     /* 171846 */ GIM_Try, /*On fail goto*//*Label 2733*/ GIMT_Encode4(171865), // Rule ID 687 //
     /* 171851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 171854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 171858 */   // (ctlz:{ *:[i64] } i64:{ *:[i64] }:$RST)  =>  (CNTLZD:{ *:[i64] } i64:{ *:[i64] }:$RST)
     /* 171858 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /* 171863 */   GIR_RootConstrainSelectedInstOperands,
     /* 171864 */   // GIR_Coverage, 687,
     /* 171864 */   GIR_Done,
     /* 171865 */ // Label 2733: @171865
     /* 171865 */ GIM_Reject,
     /* 171866 */ // Label 2727: @171866
     /* 171866 */ GIM_Try, /*On fail goto*//*Label 2734*/ GIMT_Encode4(171888), // Rule ID 482 //
     /* 171871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 171874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 171877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 171881 */   // (ctlz:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VB)  =>  (VCLZD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VB)
     /* 171881 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCLZD),
     /* 171886 */   GIR_RootConstrainSelectedInstOperands,
     /* 171887 */   // GIR_Coverage, 482,
     /* 171887 */   GIR_Done,
     /* 171888 */ // Label 2734: @171888
     /* 171888 */ GIM_Reject,
     /* 171889 */ // Label 2728: @171889
     /* 171889 */ GIM_Try, /*On fail goto*//*Label 2735*/ GIMT_Encode4(171911), // Rule ID 481 //
     /* 171894 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 171897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 171900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 171904 */   // (ctlz:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB)  =>  (VCLZW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB)
     /* 171904 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCLZW),
     /* 171909 */   GIR_RootConstrainSelectedInstOperands,
     /* 171910 */   // GIR_Coverage, 481,
     /* 171910 */   GIR_Done,
     /* 171911 */ // Label 2735: @171911
     /* 171911 */ GIM_Reject,
     /* 171912 */ // Label 2729: @171912
     /* 171912 */ GIM_Try, /*On fail goto*//*Label 2736*/ GIMT_Encode4(171934), // Rule ID 480 //
     /* 171917 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 171920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 171923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 171927 */   // (ctlz:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VB)  =>  (VCLZH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VB)
     /* 171927 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCLZH),
     /* 171932 */   GIR_RootConstrainSelectedInstOperands,
     /* 171933 */   // GIR_Coverage, 480,
     /* 171933 */   GIR_Done,
     /* 171934 */ // Label 2736: @171934
     /* 171934 */ GIM_Reject,
     /* 171935 */ // Label 2730: @171935
     /* 171935 */ GIM_Try, /*On fail goto*//*Label 2737*/ GIMT_Encode4(171957), // Rule ID 479 //
     /* 171940 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 171943 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 171946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 171950 */   // (ctlz:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VB)  =>  (VCLZB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VB)
     /* 171950 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCLZB),
     /* 171955 */   GIR_RootConstrainSelectedInstOperands,
     /* 171956 */   // GIR_Coverage, 479,
     /* 171956 */   GIR_Done,
     /* 171957 */ // Label 2737: @171957
     /* 171957 */ GIM_Reject,
     /* 171958 */ // Label 2731: @171958
     /* 171958 */ GIM_Reject,
     /* 171959 */ // Label 68: @171959
     /* 171959 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 2744*/ GIMT_Encode4(172130),
     /* 171970 */ /*GILLT_s32*//*Label 2738*/ GIMT_Encode4(171998),
     /* 171974 */ /*GILLT_s64*//*Label 2739*/ GIMT_Encode4(172018), GIMT_Encode4(0),
     /* 171982 */ /*GILLT_v2s64*//*Label 2740*/ GIMT_Encode4(172038),
     /* 171986 */ /*GILLT_v4s32*//*Label 2741*/ GIMT_Encode4(172061),
     /* 171990 */ /*GILLT_v8s16*//*Label 2742*/ GIMT_Encode4(172084),
     /* 171994 */ /*GILLT_v16s8*//*Label 2743*/ GIMT_Encode4(172107),
     /* 171998 */ // Label 2738: @171998
     /* 171998 */ GIM_Try, /*On fail goto*//*Label 2745*/ GIMT_Encode4(172017), // Rule ID 692 //
     /* 172003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 172006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 172010 */   // (ctpop:{ *:[i32] } i32:{ *:[i32] }:$RST)  =>  (POPCNTW:{ *:[i32] } i32:{ *:[i32] }:$RST)
     /* 172010 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::POPCNTW),
     /* 172015 */   GIR_RootConstrainSelectedInstOperands,
     /* 172016 */   // GIR_Coverage, 692,
     /* 172016 */   GIR_Done,
     /* 172017 */ // Label 2745: @172017
     /* 172017 */ GIM_Reject,
     /* 172018 */ // Label 2739: @172018
     /* 172018 */ GIM_Try, /*On fail goto*//*Label 2746*/ GIMT_Encode4(172037), // Rule ID 689 //
     /* 172023 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 172026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 172030 */   // (ctpop:{ *:[i64] } i64:{ *:[i64] }:$RST)  =>  (POPCNTD:{ *:[i64] } i64:{ *:[i64] }:$RST)
     /* 172030 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::POPCNTD),
     /* 172035 */   GIR_RootConstrainSelectedInstOperands,
     /* 172036 */   // GIR_Coverage, 689,
     /* 172036 */   GIR_Done,
     /* 172037 */ // Label 2746: @172037
     /* 172037 */ GIM_Reject,
     /* 172038 */ // Label 2740: @172038
     /* 172038 */ GIM_Try, /*On fail goto*//*Label 2747*/ GIMT_Encode4(172060), // Rule ID 486 //
     /* 172043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 172046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 172049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 172053 */   // (ctpop:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VB)  =>  (VPOPCNTD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VB)
     /* 172053 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VPOPCNTD),
     /* 172058 */   GIR_RootConstrainSelectedInstOperands,
     /* 172059 */   // GIR_Coverage, 486,
     /* 172059 */   GIR_Done,
     /* 172060 */ // Label 2747: @172060
     /* 172060 */ GIM_Reject,
     /* 172061 */ // Label 2741: @172061
     /* 172061 */ GIM_Try, /*On fail goto*//*Label 2748*/ GIMT_Encode4(172083), // Rule ID 485 //
     /* 172066 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 172069 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 172072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 172076 */   // (ctpop:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB)  =>  (VPOPCNTW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB)
     /* 172076 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VPOPCNTW),
     /* 172081 */   GIR_RootConstrainSelectedInstOperands,
     /* 172082 */   // GIR_Coverage, 485,
     /* 172082 */   GIR_Done,
     /* 172083 */ // Label 2748: @172083
     /* 172083 */ GIM_Reject,
     /* 172084 */ // Label 2742: @172084
     /* 172084 */ GIM_Try, /*On fail goto*//*Label 2749*/ GIMT_Encode4(172106), // Rule ID 484 //
     /* 172089 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 172092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 172095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 172099 */   // (ctpop:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VB)  =>  (VPOPCNTH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VB)
     /* 172099 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VPOPCNTH),
     /* 172104 */   GIR_RootConstrainSelectedInstOperands,
     /* 172105 */   // GIR_Coverage, 484,
     /* 172105 */   GIR_Done,
     /* 172106 */ // Label 2749: @172106
     /* 172106 */ GIM_Reject,
     /* 172107 */ // Label 2743: @172107
     /* 172107 */ GIM_Try, /*On fail goto*//*Label 2750*/ GIMT_Encode4(172129), // Rule ID 483 //
     /* 172112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 172115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 172118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 172122 */   // (ctpop:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VB)  =>  (VPOPCNTB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VB)
     /* 172122 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VPOPCNTB),
     /* 172127 */   GIR_RootConstrainSelectedInstOperands,
     /* 172128 */   // GIR_Coverage, 483,
     /* 172128 */   GIR_Done,
     /* 172129 */ // Label 2750: @172129
     /* 172129 */ GIM_Reject,
     /* 172130 */ // Label 2744: @172130
     /* 172130 */ GIM_Reject,
     /* 172131 */ // Label 69: @172131
     /* 172131 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(7), /*)*//*default:*//*Label 2757*/ GIMT_Encode4(172394),
     /* 172142 */ /*GILLT_s32*//*Label 2751*/ GIMT_Encode4(172166),
     /* 172146 */ /*GILLT_s64*//*Label 2752*/ GIMT_Encode4(172189),
     /* 172150 */ /*GILLT_s128*//*Label 2753*/ GIMT_Encode4(172212),
     /* 172154 */ /*GILLT_v2s64*//*Label 2754*/ GIMT_Encode4(172280),
     /* 172158 */ /*GILLT_v4s32*//*Label 2755*/ GIMT_Encode4(172303),
     /* 172162 */ /*GILLT_v8s16*//*Label 2756*/ GIMT_Encode4(172326),
     /* 172166 */ // Label 2751: @172166
     /* 172166 */ GIM_Try, /*On fail goto*//*Label 2758*/ GIMT_Encode4(172188), // Rule ID 1141 //
     /* 172171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 172174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 172177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 172181 */   // (bswap:{ *:[i32] } i32:{ *:[i32] }:$RST)  =>  (BRW:{ *:[i32] } i32:{ *:[i32] }:$RST)
     /* 172181 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::BRW),
     /* 172186 */   GIR_RootConstrainSelectedInstOperands,
     /* 172187 */   // GIR_Coverage, 1141,
     /* 172187 */   GIR_Done,
     /* 172188 */ // Label 2758: @172188
     /* 172188 */ GIM_Reject,
     /* 172189 */ // Label 2752: @172189
     /* 172189 */ GIM_Try, /*On fail goto*//*Label 2759*/ GIMT_Encode4(172211), // Rule ID 1142 //
     /* 172194 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 172197 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 172200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 172204 */   // (bswap:{ *:[i64] } i64:{ *:[i64] }:$RST)  =>  (BRD:{ *:[i64] } i64:{ *:[i64] }:$RST)
     /* 172204 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::BRD),
     /* 172209 */   GIR_RootConstrainSelectedInstOperands,
     /* 172210 */   // GIR_Coverage, 1142,
     /* 172210 */   GIR_Done,
     /* 172211 */ // Label 2759: @172211
     /* 172211 */ GIM_Reject,
     /* 172212 */ // Label 2753: @172212
     /* 172212 */ GIM_Try, /*On fail goto*//*Label 2760*/ GIMT_Encode4(172279), // Rule ID 2176 //
     /* 172217 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 172220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 172223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 172227 */   // (bswap:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v1i128] } (XXBRQ:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v1i128] }:$A, VSRC:{ *:[i32] })), VRRC:{ *:[i32] })
     /* 172227 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 172230 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 172234 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172239 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 172243 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 172248 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 172251 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXBRQ),
     /* 172255 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172260 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 172263 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 172265 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 172268 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172270 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 172273 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 172278 */   // GIR_Coverage, 2176,
     /* 172278 */   GIR_EraseRootFromParent_Done,
     /* 172279 */ // Label 2760: @172279
     /* 172279 */ GIM_Reject,
     /* 172280 */ // Label 2754: @172280
     /* 172280 */ GIM_Try, /*On fail goto*//*Label 2761*/ GIMT_Encode4(172302), // Rule ID 1038 //
     /* 172285 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 172288 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 172291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 172295 */   // (bswap:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$XB)  =>  (XXBRD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$XB)
     /* 172295 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XXBRD),
     /* 172300 */   GIR_RootConstrainSelectedInstOperands,
     /* 172301 */   // GIR_Coverage, 1038,
     /* 172301 */   GIR_Done,
     /* 172302 */ // Label 2761: @172302
     /* 172302 */ GIM_Reject,
     /* 172303 */ // Label 2755: @172303
     /* 172303 */ GIM_Try, /*On fail goto*//*Label 2762*/ GIMT_Encode4(172325), // Rule ID 1037 //
     /* 172308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 172311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 172314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 172318 */   // (bswap:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XB)  =>  (XXBRW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XB)
     /* 172318 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XXBRW),
     /* 172323 */   GIR_RootConstrainSelectedInstOperands,
     /* 172324 */   // GIR_Coverage, 1037,
     /* 172324 */   GIR_Done,
     /* 172325 */ // Label 2762: @172325
     /* 172325 */ GIM_Reject,
     /* 172326 */ // Label 2756: @172326
     /* 172326 */ GIM_Try, /*On fail goto*//*Label 2763*/ GIMT_Encode4(172393), // Rule ID 2175 //
     /* 172331 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 172334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 172337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 172341 */   // (bswap:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } (XXBRH:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v8i16] }:$A, VSRC:{ *:[i32] })), VRRC:{ *:[i32] })
     /* 172341 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 172344 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 172348 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172353 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 172357 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 172362 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 172365 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXBRH),
     /* 172369 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172374 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 172377 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 172379 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 172382 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172384 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 172387 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 172392 */   // GIR_Coverage, 2175,
     /* 172392 */   GIR_EraseRootFromParent_Done,
     /* 172393 */ // Label 2763: @172393
     /* 172393 */ GIM_Reject,
     /* 172394 */ // Label 2757: @172394
     /* 172394 */ GIM_Reject,
     /* 172395 */ // Label 70: @172395
     /* 172395 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2766*/ GIMT_Encode4(208400),
     /* 172406 */ /*GILLT_s32*//*Label 2764*/ GIMT_Encode4(172414),
     /* 172410 */ /*GILLT_s64*//*Label 2765*/ GIMT_Encode4(182709),
     /* 172414 */ // Label 2764: @172414
     /* 172414 */ GIM_Try, /*On fail goto*//*Label 2767*/ GIMT_Encode4(182708),
     /* 172419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 172422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 172426 */   GIM_Try, /*On fail goto*//*Label 2768*/ GIMT_Encode4(177582), // Rule ID 4889 //
     /* 172431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /* 172434 */     // (bitreverse:{ *:[i32] } i32:{ *:[i32] }:$A)  =>  (RLDICL_32:{ *:[i32] } (RLWIMI:{ *:[i32] } (RLWIMI:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 28:{ *:[i32] }, 4:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 4:{ *:[i32] }, 0:{ *:[i32] }, 27:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }))), 24:{ *:[i32] }, 0:{ *:[i32] }, 31:{ *:[i32] }), (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 28:{ *:[i32] }, 4:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 4:{ *:[i32] }, 0:{ *:[i32] }, 27:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }))), 8:{ *:[i32] }, 8:{ *:[i32] }, 15:{ *:[i32] }), (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 28:{ *:[i32] }, 4:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 4:{ *:[i32] }, 0:{ *:[i32] }, 27:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }))), 8:{ *:[i32] }, 24:{ *:[i32] }, 31:{ *:[i32] }), 0:{ *:[i32] }, 32:{ *:[i32] })
     /* 172434 */     GIR_MakeTempReg, /*TempRegID*//* 191(*/0xBF, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172438 */     GIR_BuildMI, /*InsnID*//* 192(*/0xC0, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 172443 */     GIR_AddTempRegister, /*InsnID*//* 192(*/0xC0, 0x01/*)*/, /*TempRegID*//* 191(*/0xBF, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172450 */     GIR_AddImm, /*InsnID*//* 192(*/0xC0, 0x01/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 172461 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 192(*/0xC0, 0x01/*)*/,
     /* 172464 */     GIR_MakeTempReg, /*TempRegID*//* 190(*/0xBE, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172468 */     GIR_BuildMI, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 172473 */     GIR_AddTempRegister, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*TempRegID*//* 190(*/0xBE, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172480 */     GIR_AddSimpleTempRegister, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*TempRegID*//* 191(*/0xBF, 0x01/*)*/,
     /* 172485 */     GIR_AddImm, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 172496 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 191(*/0xBF, 0x01/*)*/,
     /* 172499 */     GIR_MakeTempReg, /*TempRegID*//* 189(*/0xBD, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172503 */     GIR_BuildMI, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 172508 */     GIR_AddTempRegister, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*TempRegID*//* 189(*/0xBD, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172515 */     GIR_AddImm, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 172526 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 190(*/0xBE, 0x01/*)*/,
     /* 172529 */     GIR_MakeTempReg, /*TempRegID*//* 188(*/0xBC, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172533 */     GIR_BuildMI, /*InsnID*//* 189(*/0xBD, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 172538 */     GIR_AddTempRegister, /*InsnID*//* 189(*/0xBD, 0x01/*)*/, /*TempRegID*//* 188(*/0xBC, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172545 */     GIR_AddSimpleTempRegister, /*InsnID*//* 189(*/0xBD, 0x01/*)*/, /*TempRegID*//* 189(*/0xBD, 0x01/*)*/,
     /* 172550 */     GIR_AddImm, /*InsnID*//* 189(*/0xBD, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 172561 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 189(*/0xBD, 0x01/*)*/,
     /* 172564 */     GIR_MakeTempReg, /*TempRegID*//* 187(*/0xBB, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172568 */     GIR_BuildMI, /*InsnID*//* 188(*/0xBC, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 172573 */     GIR_AddTempRegister, /*InsnID*//* 188(*/0xBC, 0x01/*)*/, /*TempRegID*//* 187(*/0xBB, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172580 */     GIR_AddImm, /*InsnID*//* 188(*/0xBC, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 172591 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 188(*/0xBC, 0x01/*)*/,
     /* 172594 */     GIR_MakeTempReg, /*TempRegID*//* 186(*/0xBA, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172598 */     GIR_BuildMI, /*InsnID*//* 187(*/0xBB, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 172603 */     GIR_AddTempRegister, /*InsnID*//* 187(*/0xBB, 0x01/*)*/, /*TempRegID*//* 186(*/0xBA, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172610 */     GIR_AddSimpleTempRegister, /*InsnID*//* 187(*/0xBB, 0x01/*)*/, /*TempRegID*//* 187(*/0xBB, 0x01/*)*/,
     /* 172615 */     GIR_AddImm, /*InsnID*//* 187(*/0xBB, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 172626 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 187(*/0xBB, 0x01/*)*/,
     /* 172629 */     GIR_MakeTempReg, /*TempRegID*//* 185(*/0xB9, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172633 */     GIR_BuildMI, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 172638 */     GIR_AddTempRegister, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*TempRegID*//* 185(*/0xB9, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172645 */     GIR_Copy, /*NewInsnID*//* 186(*/0xBA, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 172650 */     GIR_AddImm8, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*Imm*/1,
     /* 172654 */     GIR_AddImm8, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*Imm*/0,
     /* 172658 */     GIR_AddImm8, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*Imm*/30,
     /* 172662 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 186(*/0xBA, 0x01/*)*/,
     /* 172665 */     GIR_MakeTempReg, /*TempRegID*//* 184(*/0xB8, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172669 */     GIR_BuildMI, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 172674 */     GIR_AddTempRegister, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*TempRegID*//* 184(*/0xB8, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172681 */     GIR_AddSimpleTempRegister, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*TempRegID*//* 185(*/0xB9, 0x01/*)*/,
     /* 172686 */     GIR_AddSimpleTempRegister, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*TempRegID*//* 186(*/0xBA, 0x01/*)*/,
     /* 172691 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 185(*/0xB9, 0x01/*)*/,
     /* 172694 */     GIR_MakeTempReg, /*TempRegID*//* 183(*/0xB7, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172698 */     GIR_BuildMI, /*InsnID*//* 184(*/0xB8, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 172703 */     GIR_AddTempRegister, /*InsnID*//* 184(*/0xB8, 0x01/*)*/, /*TempRegID*//* 183(*/0xB7, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172710 */     GIR_AddImm, /*InsnID*//* 184(*/0xB8, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 172721 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 184(*/0xB8, 0x01/*)*/,
     /* 172724 */     GIR_MakeTempReg, /*TempRegID*//* 182(*/0xB6, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172728 */     GIR_BuildMI, /*InsnID*//* 183(*/0xB7, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 172733 */     GIR_AddTempRegister, /*InsnID*//* 183(*/0xB7, 0x01/*)*/, /*TempRegID*//* 182(*/0xB6, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172740 */     GIR_AddSimpleTempRegister, /*InsnID*//* 183(*/0xB7, 0x01/*)*/, /*TempRegID*//* 183(*/0xB7, 0x01/*)*/,
     /* 172745 */     GIR_AddImm, /*InsnID*//* 183(*/0xB7, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 172756 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 183(*/0xB7, 0x01/*)*/,
     /* 172759 */     GIR_MakeTempReg, /*TempRegID*//* 181(*/0xB5, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172763 */     GIR_BuildMI, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 172768 */     GIR_AddTempRegister, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*TempRegID*//* 181(*/0xB5, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172775 */     GIR_Copy, /*NewInsnID*//* 182(*/0xB6, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 172780 */     GIR_AddImm8, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*Imm*/31,
     /* 172784 */     GIR_AddImm8, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*Imm*/1,
     /* 172788 */     GIR_AddImm8, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*Imm*/31,
     /* 172792 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 182(*/0xB6, 0x01/*)*/,
     /* 172795 */     GIR_MakeTempReg, /*TempRegID*//* 180(*/0xB4, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172799 */     GIR_BuildMI, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 172804 */     GIR_AddTempRegister, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*TempRegID*//* 180(*/0xB4, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172811 */     GIR_AddSimpleTempRegister, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*TempRegID*//* 181(*/0xB5, 0x01/*)*/,
     /* 172816 */     GIR_AddSimpleTempRegister, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*TempRegID*//* 182(*/0xB6, 0x01/*)*/,
     /* 172821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 181(*/0xB5, 0x01/*)*/,
     /* 172824 */     GIR_MakeTempReg, /*TempRegID*//* 179(*/0xB3, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172828 */     GIR_BuildMI, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 172833 */     GIR_AddTempRegister, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*TempRegID*//* 179(*/0xB3, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172840 */     GIR_AddSimpleTempRegister, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*TempRegID*//* 180(*/0xB4, 0x01/*)*/,
     /* 172845 */     GIR_AddSimpleTempRegister, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*TempRegID*//* 184(*/0xB8, 0x01/*)*/,
     /* 172850 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 180(*/0xB4, 0x01/*)*/,
     /* 172853 */     GIR_MakeTempReg, /*TempRegID*//* 178(*/0xB2, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172857 */     GIR_BuildMI, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 172862 */     GIR_AddTempRegister, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*TempRegID*//* 178(*/0xB2, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172869 */     GIR_AddSimpleTempRegister, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*TempRegID*//* 179(*/0xB3, 0x01/*)*/,
     /* 172874 */     GIR_AddImm8, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*Imm*/2,
     /* 172878 */     GIR_AddImm8, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*Imm*/0,
     /* 172882 */     GIR_AddImm8, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*Imm*/29,
     /* 172886 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 179(*/0xB3, 0x01/*)*/,
     /* 172889 */     GIR_MakeTempReg, /*TempRegID*//* 177(*/0xB1, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172893 */     GIR_BuildMI, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 172898 */     GIR_AddTempRegister, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*TempRegID*//* 177(*/0xB1, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172905 */     GIR_AddSimpleTempRegister, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*TempRegID*//* 178(*/0xB2, 0x01/*)*/,
     /* 172910 */     GIR_AddSimpleTempRegister, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*TempRegID*//* 188(*/0xBC, 0x01/*)*/,
     /* 172915 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 178(*/0xB2, 0x01/*)*/,
     /* 172918 */     GIR_MakeTempReg, /*TempRegID*//* 176(*/0xB0, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172922 */     GIR_BuildMI, /*InsnID*//* 177(*/0xB1, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 172927 */     GIR_AddTempRegister, /*InsnID*//* 177(*/0xB1, 0x01/*)*/, /*TempRegID*//* 176(*/0xB0, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172934 */     GIR_AddImm, /*InsnID*//* 177(*/0xB1, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 172945 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 177(*/0xB1, 0x01/*)*/,
     /* 172948 */     GIR_MakeTempReg, /*TempRegID*//* 175(*/0xAF, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172952 */     GIR_BuildMI, /*InsnID*//* 176(*/0xB0, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 172957 */     GIR_AddTempRegister, /*InsnID*//* 176(*/0xB0, 0x01/*)*/, /*TempRegID*//* 175(*/0xAF, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172964 */     GIR_AddSimpleTempRegister, /*InsnID*//* 176(*/0xB0, 0x01/*)*/, /*TempRegID*//* 176(*/0xB0, 0x01/*)*/,
     /* 172969 */     GIR_AddImm, /*InsnID*//* 176(*/0xB0, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 172980 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 176(*/0xB0, 0x01/*)*/,
     /* 172983 */     GIR_MakeTempReg, /*TempRegID*//* 174(*/0xAE, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172987 */     GIR_BuildMI, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 172992 */     GIR_AddTempRegister, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*TempRegID*//* 174(*/0xAE, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172999 */     GIR_AddImm, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 173010 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 175(*/0xAF, 0x01/*)*/,
     /* 173013 */     GIR_MakeTempReg, /*TempRegID*//* 173(*/0xAD, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173017 */     GIR_BuildMI, /*InsnID*//* 174(*/0xAE, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 173022 */     GIR_AddTempRegister, /*InsnID*//* 174(*/0xAE, 0x01/*)*/, /*TempRegID*//* 173(*/0xAD, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173029 */     GIR_AddSimpleTempRegister, /*InsnID*//* 174(*/0xAE, 0x01/*)*/, /*TempRegID*//* 174(*/0xAE, 0x01/*)*/,
     /* 173034 */     GIR_AddImm, /*InsnID*//* 174(*/0xAE, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 173045 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 174(*/0xAE, 0x01/*)*/,
     /* 173048 */     GIR_MakeTempReg, /*TempRegID*//* 172(*/0xAC, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173052 */     GIR_BuildMI, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 173057 */     GIR_AddTempRegister, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*TempRegID*//* 172(*/0xAC, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173064 */     GIR_Copy, /*NewInsnID*//* 173(*/0xAD, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 173069 */     GIR_AddImm8, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*Imm*/1,
     /* 173073 */     GIR_AddImm8, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*Imm*/0,
     /* 173077 */     GIR_AddImm8, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*Imm*/30,
     /* 173081 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 173(*/0xAD, 0x01/*)*/,
     /* 173084 */     GIR_MakeTempReg, /*TempRegID*//* 171(*/0xAB, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173088 */     GIR_BuildMI, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 173093 */     GIR_AddTempRegister, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*TempRegID*//* 171(*/0xAB, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173100 */     GIR_AddSimpleTempRegister, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*TempRegID*//* 172(*/0xAC, 0x01/*)*/,
     /* 173105 */     GIR_AddSimpleTempRegister, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*TempRegID*//* 173(*/0xAD, 0x01/*)*/,
     /* 173110 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 172(*/0xAC, 0x01/*)*/,
     /* 173113 */     GIR_MakeTempReg, /*TempRegID*//* 170(*/0xAA, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173117 */     GIR_BuildMI, /*InsnID*//* 171(*/0xAB, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 173122 */     GIR_AddTempRegister, /*InsnID*//* 171(*/0xAB, 0x01/*)*/, /*TempRegID*//* 170(*/0xAA, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173129 */     GIR_AddImm, /*InsnID*//* 171(*/0xAB, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 173140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 171(*/0xAB, 0x01/*)*/,
     /* 173143 */     GIR_MakeTempReg, /*TempRegID*//* 169(*/0xA9, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173147 */     GIR_BuildMI, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 173152 */     GIR_AddTempRegister, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*TempRegID*//* 169(*/0xA9, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173159 */     GIR_AddSimpleTempRegister, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*TempRegID*//* 170(*/0xAA, 0x01/*)*/,
     /* 173164 */     GIR_AddImm, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 173175 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 170(*/0xAA, 0x01/*)*/,
     /* 173178 */     GIR_MakeTempReg, /*TempRegID*//* 168(*/0xA8, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173182 */     GIR_BuildMI, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 173187 */     GIR_AddTempRegister, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*TempRegID*//* 168(*/0xA8, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173194 */     GIR_Copy, /*NewInsnID*//* 169(*/0xA9, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 173199 */     GIR_AddImm8, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*Imm*/31,
     /* 173203 */     GIR_AddImm8, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*Imm*/1,
     /* 173207 */     GIR_AddImm8, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*Imm*/31,
     /* 173211 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 169(*/0xA9, 0x01/*)*/,
     /* 173214 */     GIR_MakeTempReg, /*TempRegID*//* 167(*/0xA7, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173218 */     GIR_BuildMI, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 173223 */     GIR_AddTempRegister, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*TempRegID*//* 167(*/0xA7, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173230 */     GIR_AddSimpleTempRegister, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*TempRegID*//* 168(*/0xA8, 0x01/*)*/,
     /* 173235 */     GIR_AddSimpleTempRegister, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*TempRegID*//* 169(*/0xA9, 0x01/*)*/,
     /* 173240 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 168(*/0xA8, 0x01/*)*/,
     /* 173243 */     GIR_MakeTempReg, /*TempRegID*//* 166(*/0xA6, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173247 */     GIR_BuildMI, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 173252 */     GIR_AddTempRegister, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*TempRegID*//* 166(*/0xA6, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173259 */     GIR_AddSimpleTempRegister, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*TempRegID*//* 167(*/0xA7, 0x01/*)*/,
     /* 173264 */     GIR_AddSimpleTempRegister, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*TempRegID*//* 171(*/0xAB, 0x01/*)*/,
     /* 173269 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 167(*/0xA7, 0x01/*)*/,
     /* 173272 */     GIR_MakeTempReg, /*TempRegID*//* 165(*/0xA5, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173276 */     GIR_BuildMI, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 173281 */     GIR_AddTempRegister, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*TempRegID*//* 165(*/0xA5, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173288 */     GIR_AddSimpleTempRegister, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*TempRegID*//* 166(*/0xA6, 0x01/*)*/,
     /* 173293 */     GIR_AddImm8, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*Imm*/30,
     /* 173297 */     GIR_AddImm8, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*Imm*/2,
     /* 173301 */     GIR_AddImm8, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*Imm*/31,
     /* 173305 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 166(*/0xA6, 0x01/*)*/,
     /* 173308 */     GIR_MakeTempReg, /*TempRegID*//* 164(*/0xA4, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173312 */     GIR_BuildMI, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 173317 */     GIR_AddTempRegister, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*TempRegID*//* 164(*/0xA4, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173324 */     GIR_AddSimpleTempRegister, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*TempRegID*//* 165(*/0xA5, 0x01/*)*/,
     /* 173329 */     GIR_AddSimpleTempRegister, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*TempRegID*//* 175(*/0xAF, 0x01/*)*/,
     /* 173334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 165(*/0xA5, 0x01/*)*/,
     /* 173337 */     GIR_MakeTempReg, /*TempRegID*//* 163(*/0xA3, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173341 */     GIR_BuildMI, /*InsnID*//* 164(*/0xA4, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 173346 */     GIR_AddTempRegister, /*InsnID*//* 164(*/0xA4, 0x01/*)*/, /*TempRegID*//* 163(*/0xA3, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173353 */     GIR_AddSimpleTempRegister, /*InsnID*//* 164(*/0xA4, 0x01/*)*/, /*TempRegID*//* 164(*/0xA4, 0x01/*)*/,
     /* 173358 */     GIR_AddSimpleTempRegister, /*InsnID*//* 164(*/0xA4, 0x01/*)*/, /*TempRegID*//* 177(*/0xB1, 0x01/*)*/,
     /* 173363 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 164(*/0xA4, 0x01/*)*/,
     /* 173366 */     GIR_MakeTempReg, /*TempRegID*//* 162(*/0xA2, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173370 */     GIR_BuildMI, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 173375 */     GIR_AddTempRegister, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*TempRegID*//* 162(*/0xA2, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173382 */     GIR_AddSimpleTempRegister, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*TempRegID*//* 163(*/0xA3, 0x01/*)*/,
     /* 173387 */     GIR_AddImm8, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*Imm*/4,
     /* 173391 */     GIR_AddImm8, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*Imm*/0,
     /* 173395 */     GIR_AddImm8, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*Imm*/27,
     /* 173399 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 163(*/0xA3, 0x01/*)*/,
     /* 173402 */     GIR_MakeTempReg, /*TempRegID*//* 161(*/0xA1, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173406 */     GIR_BuildMI, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 173411 */     GIR_AddTempRegister, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*TempRegID*//* 161(*/0xA1, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173418 */     GIR_AddSimpleTempRegister, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*TempRegID*//* 162(*/0xA2, 0x01/*)*/,
     /* 173423 */     GIR_AddSimpleTempRegister, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*TempRegID*//* 190(*/0xBE, 0x01/*)*/,
     /* 173428 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 162(*/0xA2, 0x01/*)*/,
     /* 173431 */     GIR_MakeTempReg, /*TempRegID*//* 160(*/0xA0, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173435 */     GIR_BuildMI, /*InsnID*//* 161(*/0xA1, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 173440 */     GIR_AddTempRegister, /*InsnID*//* 161(*/0xA1, 0x01/*)*/, /*TempRegID*//* 160(*/0xA0, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173447 */     GIR_AddImm, /*InsnID*//* 161(*/0xA1, 0x01/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 173458 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 161(*/0xA1, 0x01/*)*/,
     /* 173461 */     GIR_MakeTempReg, /*TempRegID*//* 159(*/0x9F, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173465 */     GIR_BuildMI, /*InsnID*//* 160(*/0xA0, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 173470 */     GIR_AddTempRegister, /*InsnID*//* 160(*/0xA0, 0x01/*)*/, /*TempRegID*//* 159(*/0x9F, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173477 */     GIR_AddSimpleTempRegister, /*InsnID*//* 160(*/0xA0, 0x01/*)*/, /*TempRegID*//* 160(*/0xA0, 0x01/*)*/,
     /* 173482 */     GIR_AddImm, /*InsnID*//* 160(*/0xA0, 0x01/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 173493 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 160(*/0xA0, 0x01/*)*/,
     /* 173496 */     GIR_MakeTempReg, /*TempRegID*//* 158(*/0x9E, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173500 */     GIR_BuildMI, /*InsnID*//* 159(*/0x9F, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 173505 */     GIR_AddTempRegister, /*InsnID*//* 159(*/0x9F, 0x01/*)*/, /*TempRegID*//* 158(*/0x9E, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173512 */     GIR_AddImm, /*InsnID*//* 159(*/0x9F, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 173523 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 159(*/0x9F, 0x01/*)*/,
     /* 173526 */     GIR_MakeTempReg, /*TempRegID*//* 157(*/0x9D, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173530 */     GIR_BuildMI, /*InsnID*//* 158(*/0x9E, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 173535 */     GIR_AddTempRegister, /*InsnID*//* 158(*/0x9E, 0x01/*)*/, /*TempRegID*//* 157(*/0x9D, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173542 */     GIR_AddSimpleTempRegister, /*InsnID*//* 158(*/0x9E, 0x01/*)*/, /*TempRegID*//* 158(*/0x9E, 0x01/*)*/,
     /* 173547 */     GIR_AddImm, /*InsnID*//* 158(*/0x9E, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 173558 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 158(*/0x9E, 0x01/*)*/,
     /* 173561 */     GIR_MakeTempReg, /*TempRegID*//* 156(*/0x9C, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173565 */     GIR_BuildMI, /*InsnID*//* 157(*/0x9D, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 173570 */     GIR_AddTempRegister, /*InsnID*//* 157(*/0x9D, 0x01/*)*/, /*TempRegID*//* 156(*/0x9C, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173577 */     GIR_AddImm, /*InsnID*//* 157(*/0x9D, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 173588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 157(*/0x9D, 0x01/*)*/,
     /* 173591 */     GIR_MakeTempReg, /*TempRegID*//* 155(*/0x9B, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173595 */     GIR_BuildMI, /*InsnID*//* 156(*/0x9C, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 173600 */     GIR_AddTempRegister, /*InsnID*//* 156(*/0x9C, 0x01/*)*/, /*TempRegID*//* 155(*/0x9B, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173607 */     GIR_AddSimpleTempRegister, /*InsnID*//* 156(*/0x9C, 0x01/*)*/, /*TempRegID*//* 156(*/0x9C, 0x01/*)*/,
     /* 173612 */     GIR_AddImm, /*InsnID*//* 156(*/0x9C, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 173623 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 156(*/0x9C, 0x01/*)*/,
     /* 173626 */     GIR_MakeTempReg, /*TempRegID*//* 154(*/0x9A, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173630 */     GIR_BuildMI, /*InsnID*//* 155(*/0x9B, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 173635 */     GIR_AddTempRegister, /*InsnID*//* 155(*/0x9B, 0x01/*)*/, /*TempRegID*//* 154(*/0x9A, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173642 */     GIR_Copy, /*NewInsnID*//* 155(*/0x9B, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 173647 */     GIR_AddImm8, /*InsnID*//* 155(*/0x9B, 0x01/*)*/, /*Imm*/1,
     /* 173651 */     GIR_AddImm8, /*InsnID*//* 155(*/0x9B, 0x01/*)*/, /*Imm*/0,
     /* 173655 */     GIR_AddImm8, /*InsnID*//* 155(*/0x9B, 0x01/*)*/, /*Imm*/30,
     /* 173659 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 155(*/0x9B, 0x01/*)*/,
     /* 173662 */     GIR_MakeTempReg, /*TempRegID*//* 153(*/0x99, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173666 */     GIR_BuildMI, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 173671 */     GIR_AddTempRegister, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*TempRegID*//* 153(*/0x99, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173678 */     GIR_AddSimpleTempRegister, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*TempRegID*//* 154(*/0x9A, 0x01/*)*/,
     /* 173683 */     GIR_AddSimpleTempRegister, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*TempRegID*//* 155(*/0x9B, 0x01/*)*/,
     /* 173688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 154(*/0x9A, 0x01/*)*/,
     /* 173691 */     GIR_MakeTempReg, /*TempRegID*//* 152(*/0x98, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173695 */     GIR_BuildMI, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 173700 */     GIR_AddTempRegister, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*TempRegID*//* 152(*/0x98, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173707 */     GIR_AddImm, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 173718 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 153(*/0x99, 0x01/*)*/,
     /* 173721 */     GIR_MakeTempReg, /*TempRegID*//* 151(*/0x97, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173725 */     GIR_BuildMI, /*InsnID*//* 152(*/0x98, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 173730 */     GIR_AddTempRegister, /*InsnID*//* 152(*/0x98, 0x01/*)*/, /*TempRegID*//* 151(*/0x97, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173737 */     GIR_AddSimpleTempRegister, /*InsnID*//* 152(*/0x98, 0x01/*)*/, /*TempRegID*//* 152(*/0x98, 0x01/*)*/,
     /* 173742 */     GIR_AddImm, /*InsnID*//* 152(*/0x98, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 173753 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 152(*/0x98, 0x01/*)*/,
     /* 173756 */     GIR_MakeTempReg, /*TempRegID*//* 150(*/0x96, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173760 */     GIR_BuildMI, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 173765 */     GIR_AddTempRegister, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*TempRegID*//* 150(*/0x96, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173772 */     GIR_Copy, /*NewInsnID*//* 151(*/0x97, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 173777 */     GIR_AddImm8, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*Imm*/31,
     /* 173781 */     GIR_AddImm8, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*Imm*/1,
     /* 173785 */     GIR_AddImm8, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*Imm*/31,
     /* 173789 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 151(*/0x97, 0x01/*)*/,
     /* 173792 */     GIR_MakeTempReg, /*TempRegID*//* 149(*/0x95, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173796 */     GIR_BuildMI, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 173801 */     GIR_AddTempRegister, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*TempRegID*//* 149(*/0x95, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173808 */     GIR_AddSimpleTempRegister, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*TempRegID*//* 150(*/0x96, 0x01/*)*/,
     /* 173813 */     GIR_AddSimpleTempRegister, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*TempRegID*//* 151(*/0x97, 0x01/*)*/,
     /* 173818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 150(*/0x96, 0x01/*)*/,
     /* 173821 */     GIR_MakeTempReg, /*TempRegID*//* 148(*/0x94, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173825 */     GIR_BuildMI, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 173830 */     GIR_AddTempRegister, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*TempRegID*//* 148(*/0x94, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173837 */     GIR_AddSimpleTempRegister, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*TempRegID*//* 149(*/0x95, 0x01/*)*/,
     /* 173842 */     GIR_AddSimpleTempRegister, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*TempRegID*//* 153(*/0x99, 0x01/*)*/,
     /* 173847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 149(*/0x95, 0x01/*)*/,
     /* 173850 */     GIR_MakeTempReg, /*TempRegID*//* 147(*/0x93, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173854 */     GIR_BuildMI, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 173859 */     GIR_AddTempRegister, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*TempRegID*//* 147(*/0x93, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173866 */     GIR_AddSimpleTempRegister, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*TempRegID*//* 148(*/0x94, 0x01/*)*/,
     /* 173871 */     GIR_AddImm8, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*Imm*/2,
     /* 173875 */     GIR_AddImm8, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*Imm*/0,
     /* 173879 */     GIR_AddImm8, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*Imm*/29,
     /* 173883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 148(*/0x94, 0x01/*)*/,
     /* 173886 */     GIR_MakeTempReg, /*TempRegID*//* 146(*/0x92, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173890 */     GIR_BuildMI, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 173895 */     GIR_AddTempRegister, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*TempRegID*//* 146(*/0x92, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173902 */     GIR_AddSimpleTempRegister, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*TempRegID*//* 147(*/0x93, 0x01/*)*/,
     /* 173907 */     GIR_AddSimpleTempRegister, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*TempRegID*//* 157(*/0x9D, 0x01/*)*/,
     /* 173912 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 147(*/0x93, 0x01/*)*/,
     /* 173915 */     GIR_MakeTempReg, /*TempRegID*//* 145(*/0x91, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173919 */     GIR_BuildMI, /*InsnID*//* 146(*/0x92, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 173924 */     GIR_AddTempRegister, /*InsnID*//* 146(*/0x92, 0x01/*)*/, /*TempRegID*//* 145(*/0x91, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173931 */     GIR_AddImm, /*InsnID*//* 146(*/0x92, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 173942 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 146(*/0x92, 0x01/*)*/,
     /* 173945 */     GIR_MakeTempReg, /*TempRegID*//* 144(*/0x90, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173949 */     GIR_BuildMI, /*InsnID*//* 145(*/0x91, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 173954 */     GIR_AddTempRegister, /*InsnID*//* 145(*/0x91, 0x01/*)*/, /*TempRegID*//* 144(*/0x90, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173961 */     GIR_AddSimpleTempRegister, /*InsnID*//* 145(*/0x91, 0x01/*)*/, /*TempRegID*//* 145(*/0x91, 0x01/*)*/,
     /* 173966 */     GIR_AddImm, /*InsnID*//* 145(*/0x91, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 173977 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 145(*/0x91, 0x01/*)*/,
     /* 173980 */     GIR_MakeTempReg, /*TempRegID*//* 143(*/0x8F, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173984 */     GIR_BuildMI, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 173989 */     GIR_AddTempRegister, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*TempRegID*//* 143(*/0x8F, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173996 */     GIR_AddImm, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 174007 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 144(*/0x90, 0x01/*)*/,
     /* 174010 */     GIR_MakeTempReg, /*TempRegID*//* 142(*/0x8E, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 174014 */     GIR_BuildMI, /*InsnID*//* 143(*/0x8F, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 174019 */     GIR_AddTempRegister, /*InsnID*//* 143(*/0x8F, 0x01/*)*/, /*TempRegID*//* 142(*/0x8E, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174026 */     GIR_AddSimpleTempRegister, /*InsnID*//* 143(*/0x8F, 0x01/*)*/, /*TempRegID*//* 143(*/0x8F, 0x01/*)*/,
     /* 174031 */     GIR_AddImm, /*InsnID*//* 143(*/0x8F, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 174042 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 143(*/0x8F, 0x01/*)*/,
     /* 174045 */     GIR_MakeTempReg, /*TempRegID*//* 141(*/0x8D, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 174049 */     GIR_BuildMI, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 174054 */     GIR_AddTempRegister, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*TempRegID*//* 141(*/0x8D, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174061 */     GIR_Copy, /*NewInsnID*//* 142(*/0x8E, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 174066 */     GIR_AddImm8, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*Imm*/1,
     /* 174070 */     GIR_AddImm8, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*Imm*/0,
     /* 174074 */     GIR_AddImm8, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*Imm*/30,
     /* 174078 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 142(*/0x8E, 0x01/*)*/,
     /* 174081 */     GIR_MakeTempReg, /*TempRegID*//* 140(*/0x8C, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 174085 */     GIR_BuildMI, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 174090 */     GIR_AddTempRegister, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*TempRegID*//* 140(*/0x8C, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174097 */     GIR_AddSimpleTempRegister, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*TempRegID*//* 141(*/0x8D, 0x01/*)*/,
     /* 174102 */     GIR_AddSimpleTempRegister, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*TempRegID*//* 142(*/0x8E, 0x01/*)*/,
     /* 174107 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 141(*/0x8D, 0x01/*)*/,
     /* 174110 */     GIR_MakeTempReg, /*TempRegID*//* 139(*/0x8B, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 174114 */     GIR_BuildMI, /*InsnID*//* 140(*/0x8C, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 174119 */     GIR_AddTempRegister, /*InsnID*//* 140(*/0x8C, 0x01/*)*/, /*TempRegID*//* 139(*/0x8B, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174126 */     GIR_AddImm, /*InsnID*//* 140(*/0x8C, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 174137 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 140(*/0x8C, 0x01/*)*/,
     /* 174140 */     GIR_MakeTempReg, /*TempRegID*//* 138(*/0x8A, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 174144 */     GIR_BuildMI, /*InsnID*//* 139(*/0x8B, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 174149 */     GIR_AddTempRegister, /*InsnID*//* 139(*/0x8B, 0x01/*)*/, /*TempRegID*//* 138(*/0x8A, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174156 */     GIR_AddSimpleTempRegister, /*InsnID*//* 139(*/0x8B, 0x01/*)*/, /*TempRegID*//* 139(*/0x8B, 0x01/*)*/,
     /* 174161 */     GIR_AddImm, /*InsnID*//* 139(*/0x8B, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 174172 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 139(*/0x8B, 0x01/*)*/,
     /* 174175 */     GIR_MakeTempReg, /*TempRegID*//* 137(*/0x89, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 174179 */     GIR_BuildMI, /*InsnID*//* 138(*/0x8A, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 174184 */     GIR_AddTempRegister, /*InsnID*//* 138(*/0x8A, 0x01/*)*/, /*TempRegID*//* 137(*/0x89, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174191 */     GIR_Copy, /*NewInsnID*//* 138(*/0x8A, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 174196 */     GIR_AddImm8, /*InsnID*//* 138(*/0x8A, 0x01/*)*/, /*Imm*/31,
     /* 174200 */     GIR_AddImm8, /*InsnID*//* 138(*/0x8A, 0x01/*)*/, /*Imm*/1,
     /* 174204 */     GIR_AddImm8, /*InsnID*//* 138(*/0x8A, 0x01/*)*/, /*Imm*/31,
     /* 174208 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 138(*/0x8A, 0x01/*)*/,
     /* 174211 */     GIR_MakeTempReg, /*TempRegID*//* 136(*/0x88, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 174215 */     GIR_BuildMI, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 174220 */     GIR_AddTempRegister, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*TempRegID*//* 136(*/0x88, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174227 */     GIR_AddSimpleTempRegister, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*TempRegID*//* 137(*/0x89, 0x01/*)*/,
     /* 174232 */     GIR_AddSimpleTempRegister, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*TempRegID*//* 138(*/0x8A, 0x01/*)*/,
     /* 174237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 137(*/0x89, 0x01/*)*/,
     /* 174240 */     GIR_MakeTempReg, /*TempRegID*//* 135(*/0x87, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 174244 */     GIR_BuildMI, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 174249 */     GIR_AddTempRegister, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*TempRegID*//* 135(*/0x87, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174256 */     GIR_AddSimpleTempRegister, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*TempRegID*//* 136(*/0x88, 0x01/*)*/,
     /* 174261 */     GIR_AddSimpleTempRegister, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*TempRegID*//* 140(*/0x8C, 0x01/*)*/,
     /* 174266 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 136(*/0x88, 0x01/*)*/,
     /* 174269 */     GIR_MakeTempReg, /*TempRegID*//* 134(*/0x86, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 174273 */     GIR_BuildMI, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 174278 */     GIR_AddTempRegister, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*TempRegID*//* 134(*/0x86, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174285 */     GIR_AddSimpleTempRegister, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*TempRegID*//* 135(*/0x87, 0x01/*)*/,
     /* 174290 */     GIR_AddImm8, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*Imm*/30,
     /* 174294 */     GIR_AddImm8, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*Imm*/2,
     /* 174298 */     GIR_AddImm8, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*Imm*/31,
     /* 174302 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 135(*/0x87, 0x01/*)*/,
     /* 174305 */     GIR_MakeTempReg, /*TempRegID*//* 133(*/0x85, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 174309 */     GIR_BuildMI, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 174314 */     GIR_AddTempRegister, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*TempRegID*//* 133(*/0x85, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174321 */     GIR_AddSimpleTempRegister, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*TempRegID*//* 134(*/0x86, 0x01/*)*/,
     /* 174326 */     GIR_AddSimpleTempRegister, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*TempRegID*//* 144(*/0x90, 0x01/*)*/,
     /* 174331 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 134(*/0x86, 0x01/*)*/,
     /* 174334 */     GIR_MakeTempReg, /*TempRegID*//* 132(*/0x84, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 174338 */     GIR_BuildMI, /*InsnID*//* 133(*/0x85, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 174343 */     GIR_AddTempRegister, /*InsnID*//* 133(*/0x85, 0x01/*)*/, /*TempRegID*//* 132(*/0x84, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174350 */     GIR_AddSimpleTempRegister, /*InsnID*//* 133(*/0x85, 0x01/*)*/, /*TempRegID*//* 133(*/0x85, 0x01/*)*/,
     /* 174355 */     GIR_AddSimpleTempRegister, /*InsnID*//* 133(*/0x85, 0x01/*)*/, /*TempRegID*//* 146(*/0x92, 0x01/*)*/,
     /* 174360 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 133(*/0x85, 0x01/*)*/,
     /* 174363 */     GIR_MakeTempReg, /*TempRegID*//* 131(*/0x83, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 174367 */     GIR_BuildMI, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 174372 */     GIR_AddTempRegister, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*TempRegID*//* 131(*/0x83, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174379 */     GIR_AddSimpleTempRegister, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*TempRegID*//* 132(*/0x84, 0x01/*)*/,
     /* 174384 */     GIR_AddImm8, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*Imm*/28,
     /* 174388 */     GIR_AddImm8, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*Imm*/4,
     /* 174392 */     GIR_AddImm8, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*Imm*/31,
     /* 174396 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 132(*/0x84, 0x01/*)*/,
     /* 174399 */     GIR_MakeTempReg, /*TempRegID*//* 130(*/0x82, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 174403 */     GIR_BuildMI, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 174408 */     GIR_AddTempRegister, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*TempRegID*//* 130(*/0x82, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174415 */     GIR_AddSimpleTempRegister, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*TempRegID*//* 131(*/0x83, 0x01/*)*/,
     /* 174420 */     GIR_AddSimpleTempRegister, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*TempRegID*//* 159(*/0x9F, 0x01/*)*/,
     /* 174425 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 131(*/0x83, 0x01/*)*/,
     /* 174428 */     GIR_MakeTempReg, /*TempRegID*//* 129(*/0x81, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 174432 */     GIR_BuildMI, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 174437 */     GIR_AddTempRegister, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*TempRegID*//* 129(*/0x81, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174444 */     GIR_AddSimpleTempRegister, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*TempRegID*//* 130(*/0x82, 0x01/*)*/,
     /* 174449 */     GIR_AddSimpleTempRegister, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*TempRegID*//* 161(*/0xA1, 0x01/*)*/,
     /* 174454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 130(*/0x82, 0x01/*)*/,
     /* 174457 */     GIR_MakeTempReg, /*TempRegID*//* 128(*/0x80, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 174461 */     GIR_BuildMI, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 174466 */     GIR_AddTempRegister, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*TempRegID*//* 128(*/0x80, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174473 */     GIR_AddImm, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 174484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 129(*/0x81, 0x01/*)*/,
     /* 174487 */     GIR_MakeTempReg, /*TempRegID*/127, /*TypeID*/GILLT_s32,
     /* 174490 */     GIR_BuildMI, /*InsnID*//* 128(*/0x80, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 174495 */     GIR_AddTempRegister, /*InsnID*//* 128(*/0x80, 0x01/*)*/, /*TempRegID*/127, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174501 */     GIR_AddSimpleTempRegister, /*InsnID*//* 128(*/0x80, 0x01/*)*/, /*TempRegID*//* 128(*/0x80, 0x01/*)*/,
     /* 174506 */     GIR_AddImm, /*InsnID*//* 128(*/0x80, 0x01/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 174517 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 128(*/0x80, 0x01/*)*/,
     /* 174520 */     GIR_MakeTempReg, /*TempRegID*/126, /*TypeID*/GILLT_s32,
     /* 174523 */     GIR_BuildMI, /*InsnID*/127, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 174527 */     GIR_AddTempRegister, /*InsnID*/127, /*TempRegID*/126, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174532 */     GIR_AddImm, /*InsnID*/127, /*Imm*/GIMT_Encode8(52428),
     /* 174542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/127,
     /* 174544 */     GIR_MakeTempReg, /*TempRegID*/125, /*TypeID*/GILLT_s32,
     /* 174547 */     GIR_BuildMI, /*InsnID*/126, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 174551 */     GIR_AddTempRegister, /*InsnID*/126, /*TempRegID*/125, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174556 */     GIR_AddSimpleTempRegister, /*InsnID*/126, /*TempRegID*/126,
     /* 174559 */     GIR_AddImm, /*InsnID*/126, /*Imm*/GIMT_Encode8(52428),
     /* 174569 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/126,
     /* 174571 */     GIR_MakeTempReg, /*TempRegID*/124, /*TypeID*/GILLT_s32,
     /* 174574 */     GIR_BuildMI, /*InsnID*/125, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 174578 */     GIR_AddTempRegister, /*InsnID*/125, /*TempRegID*/124, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174583 */     GIR_AddImm, /*InsnID*/125, /*Imm*/GIMT_Encode8(43690),
     /* 174593 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/125,
     /* 174595 */     GIR_MakeTempReg, /*TempRegID*/123, /*TypeID*/GILLT_s32,
     /* 174598 */     GIR_BuildMI, /*InsnID*/124, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 174602 */     GIR_AddTempRegister, /*InsnID*/124, /*TempRegID*/123, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174607 */     GIR_AddSimpleTempRegister, /*InsnID*/124, /*TempRegID*/124,
     /* 174610 */     GIR_AddImm, /*InsnID*/124, /*Imm*/GIMT_Encode8(43690),
     /* 174620 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/124,
     /* 174622 */     GIR_MakeTempReg, /*TempRegID*/122, /*TypeID*/GILLT_s32,
     /* 174625 */     GIR_BuildMI, /*InsnID*/123, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 174629 */     GIR_AddTempRegister, /*InsnID*/123, /*TempRegID*/122, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174634 */     GIR_Copy, /*NewInsnID*/123, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 174638 */     GIR_AddImm8, /*InsnID*/123, /*Imm*/1,
     /* 174641 */     GIR_AddImm8, /*InsnID*/123, /*Imm*/0,
     /* 174644 */     GIR_AddImm8, /*InsnID*/123, /*Imm*/30,
     /* 174647 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/123,
     /* 174649 */     GIR_MakeTempReg, /*TempRegID*/121, /*TypeID*/GILLT_s32,
     /* 174652 */     GIR_BuildMI, /*InsnID*/122, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 174656 */     GIR_AddTempRegister, /*InsnID*/122, /*TempRegID*/121, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174661 */     GIR_AddSimpleTempRegister, /*InsnID*/122, /*TempRegID*/122,
     /* 174664 */     GIR_AddSimpleTempRegister, /*InsnID*/122, /*TempRegID*/123,
     /* 174667 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/122,
     /* 174669 */     GIR_MakeTempReg, /*TempRegID*/120, /*TypeID*/GILLT_s32,
     /* 174672 */     GIR_BuildMI, /*InsnID*/121, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 174676 */     GIR_AddTempRegister, /*InsnID*/121, /*TempRegID*/120, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174681 */     GIR_AddImm, /*InsnID*/121, /*Imm*/GIMT_Encode8(21845),
     /* 174691 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/121,
     /* 174693 */     GIR_MakeTempReg, /*TempRegID*/119, /*TypeID*/GILLT_s32,
     /* 174696 */     GIR_BuildMI, /*InsnID*/120, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 174700 */     GIR_AddTempRegister, /*InsnID*/120, /*TempRegID*/119, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174705 */     GIR_AddSimpleTempRegister, /*InsnID*/120, /*TempRegID*/120,
     /* 174708 */     GIR_AddImm, /*InsnID*/120, /*Imm*/GIMT_Encode8(21845),
     /* 174718 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/120,
     /* 174720 */     GIR_MakeTempReg, /*TempRegID*/118, /*TypeID*/GILLT_s32,
     /* 174723 */     GIR_BuildMI, /*InsnID*/119, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 174727 */     GIR_AddTempRegister, /*InsnID*/119, /*TempRegID*/118, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174732 */     GIR_Copy, /*NewInsnID*/119, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 174736 */     GIR_AddImm8, /*InsnID*/119, /*Imm*/31,
     /* 174739 */     GIR_AddImm8, /*InsnID*/119, /*Imm*/1,
     /* 174742 */     GIR_AddImm8, /*InsnID*/119, /*Imm*/31,
     /* 174745 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/119,
     /* 174747 */     GIR_MakeTempReg, /*TempRegID*/117, /*TypeID*/GILLT_s32,
     /* 174750 */     GIR_BuildMI, /*InsnID*/118, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 174754 */     GIR_AddTempRegister, /*InsnID*/118, /*TempRegID*/117, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174759 */     GIR_AddSimpleTempRegister, /*InsnID*/118, /*TempRegID*/118,
     /* 174762 */     GIR_AddSimpleTempRegister, /*InsnID*/118, /*TempRegID*/119,
     /* 174765 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/118,
     /* 174767 */     GIR_MakeTempReg, /*TempRegID*/116, /*TypeID*/GILLT_s32,
     /* 174770 */     GIR_BuildMI, /*InsnID*/117, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 174774 */     GIR_AddTempRegister, /*InsnID*/117, /*TempRegID*/116, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174779 */     GIR_AddSimpleTempRegister, /*InsnID*/117, /*TempRegID*/117,
     /* 174782 */     GIR_AddSimpleTempRegister, /*InsnID*/117, /*TempRegID*/121,
     /* 174785 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/117,
     /* 174787 */     GIR_MakeTempReg, /*TempRegID*/115, /*TypeID*/GILLT_s32,
     /* 174790 */     GIR_BuildMI, /*InsnID*/116, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 174794 */     GIR_AddTempRegister, /*InsnID*/116, /*TempRegID*/115, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174799 */     GIR_AddSimpleTempRegister, /*InsnID*/116, /*TempRegID*/116,
     /* 174802 */     GIR_AddImm8, /*InsnID*/116, /*Imm*/2,
     /* 174805 */     GIR_AddImm8, /*InsnID*/116, /*Imm*/0,
     /* 174808 */     GIR_AddImm8, /*InsnID*/116, /*Imm*/29,
     /* 174811 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/116,
     /* 174813 */     GIR_MakeTempReg, /*TempRegID*/114, /*TypeID*/GILLT_s32,
     /* 174816 */     GIR_BuildMI, /*InsnID*/115, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 174820 */     GIR_AddTempRegister, /*InsnID*/115, /*TempRegID*/114, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174825 */     GIR_AddSimpleTempRegister, /*InsnID*/115, /*TempRegID*/115,
     /* 174828 */     GIR_AddSimpleTempRegister, /*InsnID*/115, /*TempRegID*/125,
     /* 174831 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/115,
     /* 174833 */     GIR_MakeTempReg, /*TempRegID*/113, /*TypeID*/GILLT_s32,
     /* 174836 */     GIR_BuildMI, /*InsnID*/114, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 174840 */     GIR_AddTempRegister, /*InsnID*/114, /*TempRegID*/113, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174845 */     GIR_AddImm, /*InsnID*/114, /*Imm*/GIMT_Encode8(13107),
     /* 174855 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/114,
     /* 174857 */     GIR_MakeTempReg, /*TempRegID*/112, /*TypeID*/GILLT_s32,
     /* 174860 */     GIR_BuildMI, /*InsnID*/113, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 174864 */     GIR_AddTempRegister, /*InsnID*/113, /*TempRegID*/112, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174869 */     GIR_AddSimpleTempRegister, /*InsnID*/113, /*TempRegID*/113,
     /* 174872 */     GIR_AddImm, /*InsnID*/113, /*Imm*/GIMT_Encode8(13107),
     /* 174882 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/113,
     /* 174884 */     GIR_MakeTempReg, /*TempRegID*/111, /*TypeID*/GILLT_s32,
     /* 174887 */     GIR_BuildMI, /*InsnID*/112, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 174891 */     GIR_AddTempRegister, /*InsnID*/112, /*TempRegID*/111, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174896 */     GIR_AddImm, /*InsnID*/112, /*Imm*/GIMT_Encode8(43690),
     /* 174906 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/112,
     /* 174908 */     GIR_MakeTempReg, /*TempRegID*/110, /*TypeID*/GILLT_s32,
     /* 174911 */     GIR_BuildMI, /*InsnID*/111, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 174915 */     GIR_AddTempRegister, /*InsnID*/111, /*TempRegID*/110, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174920 */     GIR_AddSimpleTempRegister, /*InsnID*/111, /*TempRegID*/111,
     /* 174923 */     GIR_AddImm, /*InsnID*/111, /*Imm*/GIMT_Encode8(43690),
     /* 174933 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/111,
     /* 174935 */     GIR_MakeTempReg, /*TempRegID*/109, /*TypeID*/GILLT_s32,
     /* 174938 */     GIR_BuildMI, /*InsnID*/110, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 174942 */     GIR_AddTempRegister, /*InsnID*/110, /*TempRegID*/109, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174947 */     GIR_Copy, /*NewInsnID*/110, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 174951 */     GIR_AddImm8, /*InsnID*/110, /*Imm*/1,
     /* 174954 */     GIR_AddImm8, /*InsnID*/110, /*Imm*/0,
     /* 174957 */     GIR_AddImm8, /*InsnID*/110, /*Imm*/30,
     /* 174960 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/110,
     /* 174962 */     GIR_MakeTempReg, /*TempRegID*/108, /*TypeID*/GILLT_s32,
     /* 174965 */     GIR_BuildMI, /*InsnID*/109, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 174969 */     GIR_AddTempRegister, /*InsnID*/109, /*TempRegID*/108, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174974 */     GIR_AddSimpleTempRegister, /*InsnID*/109, /*TempRegID*/109,
     /* 174977 */     GIR_AddSimpleTempRegister, /*InsnID*/109, /*TempRegID*/110,
     /* 174980 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/109,
     /* 174982 */     GIR_MakeTempReg, /*TempRegID*/107, /*TypeID*/GILLT_s32,
     /* 174985 */     GIR_BuildMI, /*InsnID*/108, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 174989 */     GIR_AddTempRegister, /*InsnID*/108, /*TempRegID*/107, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174994 */     GIR_AddImm, /*InsnID*/108, /*Imm*/GIMT_Encode8(21845),
     /* 175004 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/108,
     /* 175006 */     GIR_MakeTempReg, /*TempRegID*/106, /*TypeID*/GILLT_s32,
     /* 175009 */     GIR_BuildMI, /*InsnID*/107, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 175013 */     GIR_AddTempRegister, /*InsnID*/107, /*TempRegID*/106, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175018 */     GIR_AddSimpleTempRegister, /*InsnID*/107, /*TempRegID*/107,
     /* 175021 */     GIR_AddImm, /*InsnID*/107, /*Imm*/GIMT_Encode8(21845),
     /* 175031 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/107,
     /* 175033 */     GIR_MakeTempReg, /*TempRegID*/105, /*TypeID*/GILLT_s32,
     /* 175036 */     GIR_BuildMI, /*InsnID*/106, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 175040 */     GIR_AddTempRegister, /*InsnID*/106, /*TempRegID*/105, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175045 */     GIR_Copy, /*NewInsnID*/106, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 175049 */     GIR_AddImm8, /*InsnID*/106, /*Imm*/31,
     /* 175052 */     GIR_AddImm8, /*InsnID*/106, /*Imm*/1,
     /* 175055 */     GIR_AddImm8, /*InsnID*/106, /*Imm*/31,
     /* 175058 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/106,
     /* 175060 */     GIR_MakeTempReg, /*TempRegID*/104, /*TypeID*/GILLT_s32,
     /* 175063 */     GIR_BuildMI, /*InsnID*/105, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 175067 */     GIR_AddTempRegister, /*InsnID*/105, /*TempRegID*/104, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175072 */     GIR_AddSimpleTempRegister, /*InsnID*/105, /*TempRegID*/105,
     /* 175075 */     GIR_AddSimpleTempRegister, /*InsnID*/105, /*TempRegID*/106,
     /* 175078 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/105,
     /* 175080 */     GIR_MakeTempReg, /*TempRegID*/103, /*TypeID*/GILLT_s32,
     /* 175083 */     GIR_BuildMI, /*InsnID*/104, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 175087 */     GIR_AddTempRegister, /*InsnID*/104, /*TempRegID*/103, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175092 */     GIR_AddSimpleTempRegister, /*InsnID*/104, /*TempRegID*/104,
     /* 175095 */     GIR_AddSimpleTempRegister, /*InsnID*/104, /*TempRegID*/108,
     /* 175098 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/104,
     /* 175100 */     GIR_MakeTempReg, /*TempRegID*/102, /*TypeID*/GILLT_s32,
     /* 175103 */     GIR_BuildMI, /*InsnID*/103, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 175107 */     GIR_AddTempRegister, /*InsnID*/103, /*TempRegID*/102, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175112 */     GIR_AddSimpleTempRegister, /*InsnID*/103, /*TempRegID*/103,
     /* 175115 */     GIR_AddImm8, /*InsnID*/103, /*Imm*/30,
     /* 175118 */     GIR_AddImm8, /*InsnID*/103, /*Imm*/2,
     /* 175121 */     GIR_AddImm8, /*InsnID*/103, /*Imm*/31,
     /* 175124 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/103,
     /* 175126 */     GIR_MakeTempReg, /*TempRegID*/101, /*TypeID*/GILLT_s32,
     /* 175129 */     GIR_BuildMI, /*InsnID*/102, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 175133 */     GIR_AddTempRegister, /*InsnID*/102, /*TempRegID*/101, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175138 */     GIR_AddSimpleTempRegister, /*InsnID*/102, /*TempRegID*/102,
     /* 175141 */     GIR_AddSimpleTempRegister, /*InsnID*/102, /*TempRegID*/112,
     /* 175144 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/102,
     /* 175146 */     GIR_MakeTempReg, /*TempRegID*/100, /*TypeID*/GILLT_s32,
     /* 175149 */     GIR_BuildMI, /*InsnID*/101, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 175153 */     GIR_AddTempRegister, /*InsnID*/101, /*TempRegID*/100, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175158 */     GIR_AddSimpleTempRegister, /*InsnID*/101, /*TempRegID*/101,
     /* 175161 */     GIR_AddSimpleTempRegister, /*InsnID*/101, /*TempRegID*/114,
     /* 175164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/101,
     /* 175166 */     GIR_MakeTempReg, /*TempRegID*/99, /*TypeID*/GILLT_s32,
     /* 175169 */     GIR_BuildMI, /*InsnID*/100, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 175173 */     GIR_AddTempRegister, /*InsnID*/100, /*TempRegID*/99, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175178 */     GIR_AddSimpleTempRegister, /*InsnID*/100, /*TempRegID*/100,
     /* 175181 */     GIR_AddImm8, /*InsnID*/100, /*Imm*/4,
     /* 175184 */     GIR_AddImm8, /*InsnID*/100, /*Imm*/0,
     /* 175187 */     GIR_AddImm8, /*InsnID*/100, /*Imm*/27,
     /* 175190 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/100,
     /* 175192 */     GIR_MakeTempReg, /*TempRegID*/98, /*TypeID*/GILLT_s32,
     /* 175195 */     GIR_BuildMI, /*InsnID*/99, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 175199 */     GIR_AddTempRegister, /*InsnID*/99, /*TempRegID*/98, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175204 */     GIR_AddSimpleTempRegister, /*InsnID*/99, /*TempRegID*/99,
     /* 175207 */     GIR_AddSimpleTempRegister, /*InsnID*/99, /*TempRegID*/127,
     /* 175210 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/99,
     /* 175212 */     GIR_MakeTempReg, /*TempRegID*/97, /*TypeID*/GILLT_s32,
     /* 175215 */     GIR_BuildMI, /*InsnID*/98, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 175219 */     GIR_AddTempRegister, /*InsnID*/98, /*TempRegID*/97, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175224 */     GIR_AddImm, /*InsnID*/98, /*Imm*/GIMT_Encode8(3855),
     /* 175234 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/98,
     /* 175236 */     GIR_MakeTempReg, /*TempRegID*/96, /*TypeID*/GILLT_s32,
     /* 175239 */     GIR_BuildMI, /*InsnID*/97, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 175243 */     GIR_AddTempRegister, /*InsnID*/97, /*TempRegID*/96, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175248 */     GIR_AddSimpleTempRegister, /*InsnID*/97, /*TempRegID*/97,
     /* 175251 */     GIR_AddImm, /*InsnID*/97, /*Imm*/GIMT_Encode8(3855),
     /* 175261 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/97,
     /* 175263 */     GIR_MakeTempReg, /*TempRegID*/95, /*TypeID*/GILLT_s32,
     /* 175266 */     GIR_BuildMI, /*InsnID*/96, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 175270 */     GIR_AddTempRegister, /*InsnID*/96, /*TempRegID*/95, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175275 */     GIR_AddImm, /*InsnID*/96, /*Imm*/GIMT_Encode8(52428),
     /* 175285 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/96,
     /* 175287 */     GIR_MakeTempReg, /*TempRegID*/94, /*TypeID*/GILLT_s32,
     /* 175290 */     GIR_BuildMI, /*InsnID*/95, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 175294 */     GIR_AddTempRegister, /*InsnID*/95, /*TempRegID*/94, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175299 */     GIR_AddSimpleTempRegister, /*InsnID*/95, /*TempRegID*/95,
     /* 175302 */     GIR_AddImm, /*InsnID*/95, /*Imm*/GIMT_Encode8(52428),
     /* 175312 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/95,
     /* 175314 */     GIR_MakeTempReg, /*TempRegID*/93, /*TypeID*/GILLT_s32,
     /* 175317 */     GIR_BuildMI, /*InsnID*/94, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 175321 */     GIR_AddTempRegister, /*InsnID*/94, /*TempRegID*/93, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175326 */     GIR_AddImm, /*InsnID*/94, /*Imm*/GIMT_Encode8(43690),
     /* 175336 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/94,
     /* 175338 */     GIR_MakeTempReg, /*TempRegID*/92, /*TypeID*/GILLT_s32,
     /* 175341 */     GIR_BuildMI, /*InsnID*/93, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 175345 */     GIR_AddTempRegister, /*InsnID*/93, /*TempRegID*/92, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175350 */     GIR_AddSimpleTempRegister, /*InsnID*/93, /*TempRegID*/93,
     /* 175353 */     GIR_AddImm, /*InsnID*/93, /*Imm*/GIMT_Encode8(43690),
     /* 175363 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/93,
     /* 175365 */     GIR_MakeTempReg, /*TempRegID*/91, /*TypeID*/GILLT_s32,
     /* 175368 */     GIR_BuildMI, /*InsnID*/92, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 175372 */     GIR_AddTempRegister, /*InsnID*/92, /*TempRegID*/91, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175377 */     GIR_Copy, /*NewInsnID*/92, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 175381 */     GIR_AddImm8, /*InsnID*/92, /*Imm*/1,
     /* 175384 */     GIR_AddImm8, /*InsnID*/92, /*Imm*/0,
     /* 175387 */     GIR_AddImm8, /*InsnID*/92, /*Imm*/30,
     /* 175390 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/92,
     /* 175392 */     GIR_MakeTempReg, /*TempRegID*/90, /*TypeID*/GILLT_s32,
     /* 175395 */     GIR_BuildMI, /*InsnID*/91, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 175399 */     GIR_AddTempRegister, /*InsnID*/91, /*TempRegID*/90, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175404 */     GIR_AddSimpleTempRegister, /*InsnID*/91, /*TempRegID*/91,
     /* 175407 */     GIR_AddSimpleTempRegister, /*InsnID*/91, /*TempRegID*/92,
     /* 175410 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/91,
     /* 175412 */     GIR_MakeTempReg, /*TempRegID*/89, /*TypeID*/GILLT_s32,
     /* 175415 */     GIR_BuildMI, /*InsnID*/90, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 175419 */     GIR_AddTempRegister, /*InsnID*/90, /*TempRegID*/89, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175424 */     GIR_AddImm, /*InsnID*/90, /*Imm*/GIMT_Encode8(21845),
     /* 175434 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/90,
     /* 175436 */     GIR_MakeTempReg, /*TempRegID*/88, /*TypeID*/GILLT_s32,
     /* 175439 */     GIR_BuildMI, /*InsnID*/89, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 175443 */     GIR_AddTempRegister, /*InsnID*/89, /*TempRegID*/88, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175448 */     GIR_AddSimpleTempRegister, /*InsnID*/89, /*TempRegID*/89,
     /* 175451 */     GIR_AddImm, /*InsnID*/89, /*Imm*/GIMT_Encode8(21845),
     /* 175461 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/89,
     /* 175463 */     GIR_MakeTempReg, /*TempRegID*/87, /*TypeID*/GILLT_s32,
     /* 175466 */     GIR_BuildMI, /*InsnID*/88, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 175470 */     GIR_AddTempRegister, /*InsnID*/88, /*TempRegID*/87, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175475 */     GIR_Copy, /*NewInsnID*/88, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 175479 */     GIR_AddImm8, /*InsnID*/88, /*Imm*/31,
     /* 175482 */     GIR_AddImm8, /*InsnID*/88, /*Imm*/1,
     /* 175485 */     GIR_AddImm8, /*InsnID*/88, /*Imm*/31,
     /* 175488 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/88,
     /* 175490 */     GIR_MakeTempReg, /*TempRegID*/86, /*TypeID*/GILLT_s32,
     /* 175493 */     GIR_BuildMI, /*InsnID*/87, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 175497 */     GIR_AddTempRegister, /*InsnID*/87, /*TempRegID*/86, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175502 */     GIR_AddSimpleTempRegister, /*InsnID*/87, /*TempRegID*/87,
     /* 175505 */     GIR_AddSimpleTempRegister, /*InsnID*/87, /*TempRegID*/88,
     /* 175508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/87,
     /* 175510 */     GIR_MakeTempReg, /*TempRegID*/85, /*TypeID*/GILLT_s32,
     /* 175513 */     GIR_BuildMI, /*InsnID*/86, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 175517 */     GIR_AddTempRegister, /*InsnID*/86, /*TempRegID*/85, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175522 */     GIR_AddSimpleTempRegister, /*InsnID*/86, /*TempRegID*/86,
     /* 175525 */     GIR_AddSimpleTempRegister, /*InsnID*/86, /*TempRegID*/90,
     /* 175528 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/86,
     /* 175530 */     GIR_MakeTempReg, /*TempRegID*/84, /*TypeID*/GILLT_s32,
     /* 175533 */     GIR_BuildMI, /*InsnID*/85, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 175537 */     GIR_AddTempRegister, /*InsnID*/85, /*TempRegID*/84, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175542 */     GIR_AddSimpleTempRegister, /*InsnID*/85, /*TempRegID*/85,
     /* 175545 */     GIR_AddImm8, /*InsnID*/85, /*Imm*/2,
     /* 175548 */     GIR_AddImm8, /*InsnID*/85, /*Imm*/0,
     /* 175551 */     GIR_AddImm8, /*InsnID*/85, /*Imm*/29,
     /* 175554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/85,
     /* 175556 */     GIR_MakeTempReg, /*TempRegID*/83, /*TypeID*/GILLT_s32,
     /* 175559 */     GIR_BuildMI, /*InsnID*/84, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 175563 */     GIR_AddTempRegister, /*InsnID*/84, /*TempRegID*/83, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175568 */     GIR_AddSimpleTempRegister, /*InsnID*/84, /*TempRegID*/84,
     /* 175571 */     GIR_AddSimpleTempRegister, /*InsnID*/84, /*TempRegID*/94,
     /* 175574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/84,
     /* 175576 */     GIR_MakeTempReg, /*TempRegID*/82, /*TypeID*/GILLT_s32,
     /* 175579 */     GIR_BuildMI, /*InsnID*/83, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 175583 */     GIR_AddTempRegister, /*InsnID*/83, /*TempRegID*/82, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175588 */     GIR_AddImm, /*InsnID*/83, /*Imm*/GIMT_Encode8(13107),
     /* 175598 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/83,
     /* 175600 */     GIR_MakeTempReg, /*TempRegID*/81, /*TypeID*/GILLT_s32,
     /* 175603 */     GIR_BuildMI, /*InsnID*/82, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 175607 */     GIR_AddTempRegister, /*InsnID*/82, /*TempRegID*/81, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175612 */     GIR_AddSimpleTempRegister, /*InsnID*/82, /*TempRegID*/82,
     /* 175615 */     GIR_AddImm, /*InsnID*/82, /*Imm*/GIMT_Encode8(13107),
     /* 175625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/82,
     /* 175627 */     GIR_MakeTempReg, /*TempRegID*/80, /*TypeID*/GILLT_s32,
     /* 175630 */     GIR_BuildMI, /*InsnID*/81, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 175634 */     GIR_AddTempRegister, /*InsnID*/81, /*TempRegID*/80, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175639 */     GIR_AddImm, /*InsnID*/81, /*Imm*/GIMT_Encode8(43690),
     /* 175649 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/81,
     /* 175651 */     GIR_MakeTempReg, /*TempRegID*/79, /*TypeID*/GILLT_s32,
     /* 175654 */     GIR_BuildMI, /*InsnID*/80, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 175658 */     GIR_AddTempRegister, /*InsnID*/80, /*TempRegID*/79, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175663 */     GIR_AddSimpleTempRegister, /*InsnID*/80, /*TempRegID*/80,
     /* 175666 */     GIR_AddImm, /*InsnID*/80, /*Imm*/GIMT_Encode8(43690),
     /* 175676 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/80,
     /* 175678 */     GIR_MakeTempReg, /*TempRegID*/78, /*TypeID*/GILLT_s32,
     /* 175681 */     GIR_BuildMI, /*InsnID*/79, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 175685 */     GIR_AddTempRegister, /*InsnID*/79, /*TempRegID*/78, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175690 */     GIR_Copy, /*NewInsnID*/79, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 175694 */     GIR_AddImm8, /*InsnID*/79, /*Imm*/1,
     /* 175697 */     GIR_AddImm8, /*InsnID*/79, /*Imm*/0,
     /* 175700 */     GIR_AddImm8, /*InsnID*/79, /*Imm*/30,
     /* 175703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/79,
     /* 175705 */     GIR_MakeTempReg, /*TempRegID*/77, /*TypeID*/GILLT_s32,
     /* 175708 */     GIR_BuildMI, /*InsnID*/78, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 175712 */     GIR_AddTempRegister, /*InsnID*/78, /*TempRegID*/77, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175717 */     GIR_AddSimpleTempRegister, /*InsnID*/78, /*TempRegID*/78,
     /* 175720 */     GIR_AddSimpleTempRegister, /*InsnID*/78, /*TempRegID*/79,
     /* 175723 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/78,
     /* 175725 */     GIR_MakeTempReg, /*TempRegID*/76, /*TypeID*/GILLT_s32,
     /* 175728 */     GIR_BuildMI, /*InsnID*/77, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 175732 */     GIR_AddTempRegister, /*InsnID*/77, /*TempRegID*/76, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175737 */     GIR_AddImm, /*InsnID*/77, /*Imm*/GIMT_Encode8(21845),
     /* 175747 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/77,
     /* 175749 */     GIR_MakeTempReg, /*TempRegID*/75, /*TypeID*/GILLT_s32,
     /* 175752 */     GIR_BuildMI, /*InsnID*/76, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 175756 */     GIR_AddTempRegister, /*InsnID*/76, /*TempRegID*/75, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175761 */     GIR_AddSimpleTempRegister, /*InsnID*/76, /*TempRegID*/76,
     /* 175764 */     GIR_AddImm, /*InsnID*/76, /*Imm*/GIMT_Encode8(21845),
     /* 175774 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/76,
     /* 175776 */     GIR_MakeTempReg, /*TempRegID*/74, /*TypeID*/GILLT_s32,
     /* 175779 */     GIR_BuildMI, /*InsnID*/75, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 175783 */     GIR_AddTempRegister, /*InsnID*/75, /*TempRegID*/74, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175788 */     GIR_Copy, /*NewInsnID*/75, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 175792 */     GIR_AddImm8, /*InsnID*/75, /*Imm*/31,
     /* 175795 */     GIR_AddImm8, /*InsnID*/75, /*Imm*/1,
     /* 175798 */     GIR_AddImm8, /*InsnID*/75, /*Imm*/31,
     /* 175801 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/75,
     /* 175803 */     GIR_MakeTempReg, /*TempRegID*/73, /*TypeID*/GILLT_s32,
     /* 175806 */     GIR_BuildMI, /*InsnID*/74, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 175810 */     GIR_AddTempRegister, /*InsnID*/74, /*TempRegID*/73, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175815 */     GIR_AddSimpleTempRegister, /*InsnID*/74, /*TempRegID*/74,
     /* 175818 */     GIR_AddSimpleTempRegister, /*InsnID*/74, /*TempRegID*/75,
     /* 175821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/74,
     /* 175823 */     GIR_MakeTempReg, /*TempRegID*/72, /*TypeID*/GILLT_s32,
     /* 175826 */     GIR_BuildMI, /*InsnID*/73, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 175830 */     GIR_AddTempRegister, /*InsnID*/73, /*TempRegID*/72, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175835 */     GIR_AddSimpleTempRegister, /*InsnID*/73, /*TempRegID*/73,
     /* 175838 */     GIR_AddSimpleTempRegister, /*InsnID*/73, /*TempRegID*/77,
     /* 175841 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/73,
     /* 175843 */     GIR_MakeTempReg, /*TempRegID*/71, /*TypeID*/GILLT_s32,
     /* 175846 */     GIR_BuildMI, /*InsnID*/72, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 175850 */     GIR_AddTempRegister, /*InsnID*/72, /*TempRegID*/71, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175855 */     GIR_AddSimpleTempRegister, /*InsnID*/72, /*TempRegID*/72,
     /* 175858 */     GIR_AddImm8, /*InsnID*/72, /*Imm*/30,
     /* 175861 */     GIR_AddImm8, /*InsnID*/72, /*Imm*/2,
     /* 175864 */     GIR_AddImm8, /*InsnID*/72, /*Imm*/31,
     /* 175867 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/72,
     /* 175869 */     GIR_MakeTempReg, /*TempRegID*/70, /*TypeID*/GILLT_s32,
     /* 175872 */     GIR_BuildMI, /*InsnID*/71, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 175876 */     GIR_AddTempRegister, /*InsnID*/71, /*TempRegID*/70, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175881 */     GIR_AddSimpleTempRegister, /*InsnID*/71, /*TempRegID*/71,
     /* 175884 */     GIR_AddSimpleTempRegister, /*InsnID*/71, /*TempRegID*/81,
     /* 175887 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/71,
     /* 175889 */     GIR_MakeTempReg, /*TempRegID*/69, /*TypeID*/GILLT_s32,
     /* 175892 */     GIR_BuildMI, /*InsnID*/70, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 175896 */     GIR_AddTempRegister, /*InsnID*/70, /*TempRegID*/69, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175901 */     GIR_AddSimpleTempRegister, /*InsnID*/70, /*TempRegID*/70,
     /* 175904 */     GIR_AddSimpleTempRegister, /*InsnID*/70, /*TempRegID*/83,
     /* 175907 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/70,
     /* 175909 */     GIR_MakeTempReg, /*TempRegID*/68, /*TypeID*/GILLT_s32,
     /* 175912 */     GIR_BuildMI, /*InsnID*/69, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 175916 */     GIR_AddTempRegister, /*InsnID*/69, /*TempRegID*/68, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175921 */     GIR_AddSimpleTempRegister, /*InsnID*/69, /*TempRegID*/69,
     /* 175924 */     GIR_AddImm8, /*InsnID*/69, /*Imm*/28,
     /* 175927 */     GIR_AddImm8, /*InsnID*/69, /*Imm*/4,
     /* 175930 */     GIR_AddImm8, /*InsnID*/69, /*Imm*/31,
     /* 175933 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/69,
     /* 175935 */     GIR_MakeTempReg, /*TempRegID*/67, /*TypeID*/GILLT_s32,
     /* 175938 */     GIR_BuildMI, /*InsnID*/68, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 175942 */     GIR_AddTempRegister, /*InsnID*/68, /*TempRegID*/67, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175947 */     GIR_AddSimpleTempRegister, /*InsnID*/68, /*TempRegID*/68,
     /* 175950 */     GIR_AddSimpleTempRegister, /*InsnID*/68, /*TempRegID*/96,
     /* 175953 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/68,
     /* 175955 */     GIR_MakeTempReg, /*TempRegID*/66, /*TypeID*/GILLT_s32,
     /* 175958 */     GIR_BuildMI, /*InsnID*/67, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 175962 */     GIR_AddTempRegister, /*InsnID*/67, /*TempRegID*/66, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175967 */     GIR_AddSimpleTempRegister, /*InsnID*/67, /*TempRegID*/67,
     /* 175970 */     GIR_AddSimpleTempRegister, /*InsnID*/67, /*TempRegID*/98,
     /* 175973 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/67,
     /* 175975 */     GIR_MakeTempReg, /*TempRegID*/65, /*TypeID*/GILLT_s32,
     /* 175978 */     GIR_BuildMI, /*InsnID*/66, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 175982 */     GIR_AddTempRegister, /*InsnID*/66, /*TempRegID*/65, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175987 */     GIR_AddImm, /*InsnID*/66, /*Imm*/GIMT_Encode8(61680),
     /* 175997 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/66,
     /* 175999 */     GIR_MakeTempReg, /*TempRegID*/64, /*TypeID*/GILLT_s32,
     /* 176002 */     GIR_BuildMI, /*InsnID*/65, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 176006 */     GIR_AddTempRegister, /*InsnID*/65, /*TempRegID*/64, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176011 */     GIR_AddSimpleTempRegister, /*InsnID*/65, /*TempRegID*/65,
     /* 176014 */     GIR_AddImm, /*InsnID*/65, /*Imm*/GIMT_Encode8(61680),
     /* 176024 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/65,
     /* 176026 */     GIR_MakeTempReg, /*TempRegID*/63, /*TypeID*/GILLT_s32,
     /* 176029 */     GIR_BuildMI, /*InsnID*/64, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 176033 */     GIR_AddTempRegister, /*InsnID*/64, /*TempRegID*/63, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176038 */     GIR_AddImm, /*InsnID*/64, /*Imm*/GIMT_Encode8(52428),
     /* 176048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/64,
     /* 176050 */     GIR_MakeTempReg, /*TempRegID*/62, /*TypeID*/GILLT_s32,
     /* 176053 */     GIR_BuildMI, /*InsnID*/63, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 176057 */     GIR_AddTempRegister, /*InsnID*/63, /*TempRegID*/62, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176062 */     GIR_AddSimpleTempRegister, /*InsnID*/63, /*TempRegID*/63,
     /* 176065 */     GIR_AddImm, /*InsnID*/63, /*Imm*/GIMT_Encode8(52428),
     /* 176075 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/63,
     /* 176077 */     GIR_MakeTempReg, /*TempRegID*/61, /*TypeID*/GILLT_s32,
     /* 176080 */     GIR_BuildMI, /*InsnID*/62, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 176084 */     GIR_AddTempRegister, /*InsnID*/62, /*TempRegID*/61, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176089 */     GIR_AddImm, /*InsnID*/62, /*Imm*/GIMT_Encode8(43690),
     /* 176099 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/62,
     /* 176101 */     GIR_MakeTempReg, /*TempRegID*/60, /*TypeID*/GILLT_s32,
     /* 176104 */     GIR_BuildMI, /*InsnID*/61, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 176108 */     GIR_AddTempRegister, /*InsnID*/61, /*TempRegID*/60, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176113 */     GIR_AddSimpleTempRegister, /*InsnID*/61, /*TempRegID*/61,
     /* 176116 */     GIR_AddImm, /*InsnID*/61, /*Imm*/GIMT_Encode8(43690),
     /* 176126 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/61,
     /* 176128 */     GIR_MakeTempReg, /*TempRegID*/59, /*TypeID*/GILLT_s32,
     /* 176131 */     GIR_BuildMI, /*InsnID*/60, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 176135 */     GIR_AddTempRegister, /*InsnID*/60, /*TempRegID*/59, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176140 */     GIR_Copy, /*NewInsnID*/60, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 176144 */     GIR_AddImm8, /*InsnID*/60, /*Imm*/1,
     /* 176147 */     GIR_AddImm8, /*InsnID*/60, /*Imm*/0,
     /* 176150 */     GIR_AddImm8, /*InsnID*/60, /*Imm*/30,
     /* 176153 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/60,
     /* 176155 */     GIR_MakeTempReg, /*TempRegID*/58, /*TypeID*/GILLT_s32,
     /* 176158 */     GIR_BuildMI, /*InsnID*/59, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 176162 */     GIR_AddTempRegister, /*InsnID*/59, /*TempRegID*/58, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176167 */     GIR_AddSimpleTempRegister, /*InsnID*/59, /*TempRegID*/59,
     /* 176170 */     GIR_AddSimpleTempRegister, /*InsnID*/59, /*TempRegID*/60,
     /* 176173 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/59,
     /* 176175 */     GIR_MakeTempReg, /*TempRegID*/57, /*TypeID*/GILLT_s32,
     /* 176178 */     GIR_BuildMI, /*InsnID*/58, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 176182 */     GIR_AddTempRegister, /*InsnID*/58, /*TempRegID*/57, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176187 */     GIR_AddImm, /*InsnID*/58, /*Imm*/GIMT_Encode8(21845),
     /* 176197 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/58,
     /* 176199 */     GIR_MakeTempReg, /*TempRegID*/56, /*TypeID*/GILLT_s32,
     /* 176202 */     GIR_BuildMI, /*InsnID*/57, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 176206 */     GIR_AddTempRegister, /*InsnID*/57, /*TempRegID*/56, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176211 */     GIR_AddSimpleTempRegister, /*InsnID*/57, /*TempRegID*/57,
     /* 176214 */     GIR_AddImm, /*InsnID*/57, /*Imm*/GIMT_Encode8(21845),
     /* 176224 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/57,
     /* 176226 */     GIR_MakeTempReg, /*TempRegID*/55, /*TypeID*/GILLT_s32,
     /* 176229 */     GIR_BuildMI, /*InsnID*/56, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 176233 */     GIR_AddTempRegister, /*InsnID*/56, /*TempRegID*/55, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176238 */     GIR_Copy, /*NewInsnID*/56, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 176242 */     GIR_AddImm8, /*InsnID*/56, /*Imm*/31,
     /* 176245 */     GIR_AddImm8, /*InsnID*/56, /*Imm*/1,
     /* 176248 */     GIR_AddImm8, /*InsnID*/56, /*Imm*/31,
     /* 176251 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/56,
     /* 176253 */     GIR_MakeTempReg, /*TempRegID*/54, /*TypeID*/GILLT_s32,
     /* 176256 */     GIR_BuildMI, /*InsnID*/55, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 176260 */     GIR_AddTempRegister, /*InsnID*/55, /*TempRegID*/54, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176265 */     GIR_AddSimpleTempRegister, /*InsnID*/55, /*TempRegID*/55,
     /* 176268 */     GIR_AddSimpleTempRegister, /*InsnID*/55, /*TempRegID*/56,
     /* 176271 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/55,
     /* 176273 */     GIR_MakeTempReg, /*TempRegID*/53, /*TypeID*/GILLT_s32,
     /* 176276 */     GIR_BuildMI, /*InsnID*/54, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 176280 */     GIR_AddTempRegister, /*InsnID*/54, /*TempRegID*/53, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176285 */     GIR_AddSimpleTempRegister, /*InsnID*/54, /*TempRegID*/54,
     /* 176288 */     GIR_AddSimpleTempRegister, /*InsnID*/54, /*TempRegID*/58,
     /* 176291 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/54,
     /* 176293 */     GIR_MakeTempReg, /*TempRegID*/52, /*TypeID*/GILLT_s32,
     /* 176296 */     GIR_BuildMI, /*InsnID*/53, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 176300 */     GIR_AddTempRegister, /*InsnID*/53, /*TempRegID*/52, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176305 */     GIR_AddSimpleTempRegister, /*InsnID*/53, /*TempRegID*/53,
     /* 176308 */     GIR_AddImm8, /*InsnID*/53, /*Imm*/2,
     /* 176311 */     GIR_AddImm8, /*InsnID*/53, /*Imm*/0,
     /* 176314 */     GIR_AddImm8, /*InsnID*/53, /*Imm*/29,
     /* 176317 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/53,
     /* 176319 */     GIR_MakeTempReg, /*TempRegID*/51, /*TypeID*/GILLT_s32,
     /* 176322 */     GIR_BuildMI, /*InsnID*/52, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 176326 */     GIR_AddTempRegister, /*InsnID*/52, /*TempRegID*/51, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176331 */     GIR_AddSimpleTempRegister, /*InsnID*/52, /*TempRegID*/52,
     /* 176334 */     GIR_AddSimpleTempRegister, /*InsnID*/52, /*TempRegID*/62,
     /* 176337 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/52,
     /* 176339 */     GIR_MakeTempReg, /*TempRegID*/50, /*TypeID*/GILLT_s32,
     /* 176342 */     GIR_BuildMI, /*InsnID*/51, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 176346 */     GIR_AddTempRegister, /*InsnID*/51, /*TempRegID*/50, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176351 */     GIR_AddImm, /*InsnID*/51, /*Imm*/GIMT_Encode8(13107),
     /* 176361 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/51,
     /* 176363 */     GIR_MakeTempReg, /*TempRegID*/49, /*TypeID*/GILLT_s32,
     /* 176366 */     GIR_BuildMI, /*InsnID*/50, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 176370 */     GIR_AddTempRegister, /*InsnID*/50, /*TempRegID*/49, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176375 */     GIR_AddSimpleTempRegister, /*InsnID*/50, /*TempRegID*/50,
     /* 176378 */     GIR_AddImm, /*InsnID*/50, /*Imm*/GIMT_Encode8(13107),
     /* 176388 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/50,
     /* 176390 */     GIR_MakeTempReg, /*TempRegID*/48, /*TypeID*/GILLT_s32,
     /* 176393 */     GIR_BuildMI, /*InsnID*/49, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 176397 */     GIR_AddTempRegister, /*InsnID*/49, /*TempRegID*/48, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176402 */     GIR_AddImm, /*InsnID*/49, /*Imm*/GIMT_Encode8(43690),
     /* 176412 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/49,
     /* 176414 */     GIR_MakeTempReg, /*TempRegID*/47, /*TypeID*/GILLT_s32,
     /* 176417 */     GIR_BuildMI, /*InsnID*/48, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 176421 */     GIR_AddTempRegister, /*InsnID*/48, /*TempRegID*/47, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176426 */     GIR_AddSimpleTempRegister, /*InsnID*/48, /*TempRegID*/48,
     /* 176429 */     GIR_AddImm, /*InsnID*/48, /*Imm*/GIMT_Encode8(43690),
     /* 176439 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/48,
     /* 176441 */     GIR_MakeTempReg, /*TempRegID*/46, /*TypeID*/GILLT_s32,
     /* 176444 */     GIR_BuildMI, /*InsnID*/47, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 176448 */     GIR_AddTempRegister, /*InsnID*/47, /*TempRegID*/46, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176453 */     GIR_Copy, /*NewInsnID*/47, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 176457 */     GIR_AddImm8, /*InsnID*/47, /*Imm*/1,
     /* 176460 */     GIR_AddImm8, /*InsnID*/47, /*Imm*/0,
     /* 176463 */     GIR_AddImm8, /*InsnID*/47, /*Imm*/30,
     /* 176466 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/47,
     /* 176468 */     GIR_MakeTempReg, /*TempRegID*/45, /*TypeID*/GILLT_s32,
     /* 176471 */     GIR_BuildMI, /*InsnID*/46, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 176475 */     GIR_AddTempRegister, /*InsnID*/46, /*TempRegID*/45, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176480 */     GIR_AddSimpleTempRegister, /*InsnID*/46, /*TempRegID*/46,
     /* 176483 */     GIR_AddSimpleTempRegister, /*InsnID*/46, /*TempRegID*/47,
     /* 176486 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/46,
     /* 176488 */     GIR_MakeTempReg, /*TempRegID*/44, /*TypeID*/GILLT_s32,
     /* 176491 */     GIR_BuildMI, /*InsnID*/45, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 176495 */     GIR_AddTempRegister, /*InsnID*/45, /*TempRegID*/44, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176500 */     GIR_AddImm, /*InsnID*/45, /*Imm*/GIMT_Encode8(21845),
     /* 176510 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/45,
     /* 176512 */     GIR_MakeTempReg, /*TempRegID*/43, /*TypeID*/GILLT_s32,
     /* 176515 */     GIR_BuildMI, /*InsnID*/44, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 176519 */     GIR_AddTempRegister, /*InsnID*/44, /*TempRegID*/43, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176524 */     GIR_AddSimpleTempRegister, /*InsnID*/44, /*TempRegID*/44,
     /* 176527 */     GIR_AddImm, /*InsnID*/44, /*Imm*/GIMT_Encode8(21845),
     /* 176537 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/44,
     /* 176539 */     GIR_MakeTempReg, /*TempRegID*/42, /*TypeID*/GILLT_s32,
     /* 176542 */     GIR_BuildMI, /*InsnID*/43, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 176546 */     GIR_AddTempRegister, /*InsnID*/43, /*TempRegID*/42, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176551 */     GIR_Copy, /*NewInsnID*/43, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 176555 */     GIR_AddImm8, /*InsnID*/43, /*Imm*/31,
     /* 176558 */     GIR_AddImm8, /*InsnID*/43, /*Imm*/1,
     /* 176561 */     GIR_AddImm8, /*InsnID*/43, /*Imm*/31,
     /* 176564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/43,
     /* 176566 */     GIR_MakeTempReg, /*TempRegID*/41, /*TypeID*/GILLT_s32,
     /* 176569 */     GIR_BuildMI, /*InsnID*/42, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 176573 */     GIR_AddTempRegister, /*InsnID*/42, /*TempRegID*/41, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176578 */     GIR_AddSimpleTempRegister, /*InsnID*/42, /*TempRegID*/42,
     /* 176581 */     GIR_AddSimpleTempRegister, /*InsnID*/42, /*TempRegID*/43,
     /* 176584 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/42,
     /* 176586 */     GIR_MakeTempReg, /*TempRegID*/40, /*TypeID*/GILLT_s32,
     /* 176589 */     GIR_BuildMI, /*InsnID*/41, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 176593 */     GIR_AddTempRegister, /*InsnID*/41, /*TempRegID*/40, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176598 */     GIR_AddSimpleTempRegister, /*InsnID*/41, /*TempRegID*/41,
     /* 176601 */     GIR_AddSimpleTempRegister, /*InsnID*/41, /*TempRegID*/45,
     /* 176604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/41,
     /* 176606 */     GIR_MakeTempReg, /*TempRegID*/39, /*TypeID*/GILLT_s32,
     /* 176609 */     GIR_BuildMI, /*InsnID*/40, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 176613 */     GIR_AddTempRegister, /*InsnID*/40, /*TempRegID*/39, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176618 */     GIR_AddSimpleTempRegister, /*InsnID*/40, /*TempRegID*/40,
     /* 176621 */     GIR_AddImm8, /*InsnID*/40, /*Imm*/30,
     /* 176624 */     GIR_AddImm8, /*InsnID*/40, /*Imm*/2,
     /* 176627 */     GIR_AddImm8, /*InsnID*/40, /*Imm*/31,
     /* 176630 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/40,
     /* 176632 */     GIR_MakeTempReg, /*TempRegID*/38, /*TypeID*/GILLT_s32,
     /* 176635 */     GIR_BuildMI, /*InsnID*/39, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 176639 */     GIR_AddTempRegister, /*InsnID*/39, /*TempRegID*/38, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176644 */     GIR_AddSimpleTempRegister, /*InsnID*/39, /*TempRegID*/39,
     /* 176647 */     GIR_AddSimpleTempRegister, /*InsnID*/39, /*TempRegID*/49,
     /* 176650 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/39,
     /* 176652 */     GIR_MakeTempReg, /*TempRegID*/37, /*TypeID*/GILLT_s32,
     /* 176655 */     GIR_BuildMI, /*InsnID*/38, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 176659 */     GIR_AddTempRegister, /*InsnID*/38, /*TempRegID*/37, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176664 */     GIR_AddSimpleTempRegister, /*InsnID*/38, /*TempRegID*/38,
     /* 176667 */     GIR_AddSimpleTempRegister, /*InsnID*/38, /*TempRegID*/51,
     /* 176670 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/38,
     /* 176672 */     GIR_MakeTempReg, /*TempRegID*/36, /*TypeID*/GILLT_s32,
     /* 176675 */     GIR_BuildMI, /*InsnID*/37, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 176679 */     GIR_AddTempRegister, /*InsnID*/37, /*TempRegID*/36, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176684 */     GIR_AddSimpleTempRegister, /*InsnID*/37, /*TempRegID*/37,
     /* 176687 */     GIR_AddImm8, /*InsnID*/37, /*Imm*/4,
     /* 176690 */     GIR_AddImm8, /*InsnID*/37, /*Imm*/0,
     /* 176693 */     GIR_AddImm8, /*InsnID*/37, /*Imm*/27,
     /* 176696 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/37,
     /* 176698 */     GIR_MakeTempReg, /*TempRegID*/35, /*TypeID*/GILLT_s32,
     /* 176701 */     GIR_BuildMI, /*InsnID*/36, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 176705 */     GIR_AddTempRegister, /*InsnID*/36, /*TempRegID*/35, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176710 */     GIR_AddSimpleTempRegister, /*InsnID*/36, /*TempRegID*/36,
     /* 176713 */     GIR_AddSimpleTempRegister, /*InsnID*/36, /*TempRegID*/64,
     /* 176716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/36,
     /* 176718 */     GIR_MakeTempReg, /*TempRegID*/34, /*TypeID*/GILLT_s32,
     /* 176721 */     GIR_BuildMI, /*InsnID*/35, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 176725 */     GIR_AddTempRegister, /*InsnID*/35, /*TempRegID*/34, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176730 */     GIR_AddImm, /*InsnID*/35, /*Imm*/GIMT_Encode8(3855),
     /* 176740 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/35,
     /* 176742 */     GIR_MakeTempReg, /*TempRegID*/33, /*TypeID*/GILLT_s32,
     /* 176745 */     GIR_BuildMI, /*InsnID*/34, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 176749 */     GIR_AddTempRegister, /*InsnID*/34, /*TempRegID*/33, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176754 */     GIR_AddSimpleTempRegister, /*InsnID*/34, /*TempRegID*/34,
     /* 176757 */     GIR_AddImm, /*InsnID*/34, /*Imm*/GIMT_Encode8(3855),
     /* 176767 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/34,
     /* 176769 */     GIR_MakeTempReg, /*TempRegID*/32, /*TypeID*/GILLT_s32,
     /* 176772 */     GIR_BuildMI, /*InsnID*/33, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 176776 */     GIR_AddTempRegister, /*InsnID*/33, /*TempRegID*/32, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176781 */     GIR_AddImm, /*InsnID*/33, /*Imm*/GIMT_Encode8(52428),
     /* 176791 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/33,
     /* 176793 */     GIR_MakeTempReg, /*TempRegID*/31, /*TypeID*/GILLT_s32,
     /* 176796 */     GIR_BuildMI, /*InsnID*/32, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 176800 */     GIR_AddTempRegister, /*InsnID*/32, /*TempRegID*/31, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176805 */     GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/32,
     /* 176808 */     GIR_AddImm, /*InsnID*/32, /*Imm*/GIMT_Encode8(52428),
     /* 176818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/32,
     /* 176820 */     GIR_MakeTempReg, /*TempRegID*/30, /*TypeID*/GILLT_s32,
     /* 176823 */     GIR_BuildMI, /*InsnID*/31, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 176827 */     GIR_AddTempRegister, /*InsnID*/31, /*TempRegID*/30, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176832 */     GIR_AddImm, /*InsnID*/31, /*Imm*/GIMT_Encode8(43690),
     /* 176842 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/31,
     /* 176844 */     GIR_MakeTempReg, /*TempRegID*/29, /*TypeID*/GILLT_s32,
     /* 176847 */     GIR_BuildMI, /*InsnID*/30, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 176851 */     GIR_AddTempRegister, /*InsnID*/30, /*TempRegID*/29, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176856 */     GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/30,
     /* 176859 */     GIR_AddImm, /*InsnID*/30, /*Imm*/GIMT_Encode8(43690),
     /* 176869 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/30,
     /* 176871 */     GIR_MakeTempReg, /*TempRegID*/28, /*TypeID*/GILLT_s32,
     /* 176874 */     GIR_BuildMI, /*InsnID*/29, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 176878 */     GIR_AddTempRegister, /*InsnID*/29, /*TempRegID*/28, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176883 */     GIR_Copy, /*NewInsnID*/29, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 176887 */     GIR_AddImm8, /*InsnID*/29, /*Imm*/1,
     /* 176890 */     GIR_AddImm8, /*InsnID*/29, /*Imm*/0,
     /* 176893 */     GIR_AddImm8, /*InsnID*/29, /*Imm*/30,
     /* 176896 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/29,
     /* 176898 */     GIR_MakeTempReg, /*TempRegID*/27, /*TypeID*/GILLT_s32,
     /* 176901 */     GIR_BuildMI, /*InsnID*/28, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 176905 */     GIR_AddTempRegister, /*InsnID*/28, /*TempRegID*/27, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176910 */     GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/28,
     /* 176913 */     GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/29,
     /* 176916 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/28,
     /* 176918 */     GIR_MakeTempReg, /*TempRegID*/26, /*TypeID*/GILLT_s32,
     /* 176921 */     GIR_BuildMI, /*InsnID*/27, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 176925 */     GIR_AddTempRegister, /*InsnID*/27, /*TempRegID*/26, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176930 */     GIR_AddImm, /*InsnID*/27, /*Imm*/GIMT_Encode8(21845),
     /* 176940 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/27,
     /* 176942 */     GIR_MakeTempReg, /*TempRegID*/25, /*TypeID*/GILLT_s32,
     /* 176945 */     GIR_BuildMI, /*InsnID*/26, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 176949 */     GIR_AddTempRegister, /*InsnID*/26, /*TempRegID*/25, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176954 */     GIR_AddSimpleTempRegister, /*InsnID*/26, /*TempRegID*/26,
     /* 176957 */     GIR_AddImm, /*InsnID*/26, /*Imm*/GIMT_Encode8(21845),
     /* 176967 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/26,
     /* 176969 */     GIR_MakeTempReg, /*TempRegID*/24, /*TypeID*/GILLT_s32,
     /* 176972 */     GIR_BuildMI, /*InsnID*/25, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 176976 */     GIR_AddTempRegister, /*InsnID*/25, /*TempRegID*/24, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176981 */     GIR_Copy, /*NewInsnID*/25, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 176985 */     GIR_AddImm8, /*InsnID*/25, /*Imm*/31,
     /* 176988 */     GIR_AddImm8, /*InsnID*/25, /*Imm*/1,
     /* 176991 */     GIR_AddImm8, /*InsnID*/25, /*Imm*/31,
     /* 176994 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/25,
     /* 176996 */     GIR_MakeTempReg, /*TempRegID*/23, /*TypeID*/GILLT_s32,
     /* 176999 */     GIR_BuildMI, /*InsnID*/24, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 177003 */     GIR_AddTempRegister, /*InsnID*/24, /*TempRegID*/23, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177008 */     GIR_AddSimpleTempRegister, /*InsnID*/24, /*TempRegID*/24,
     /* 177011 */     GIR_AddSimpleTempRegister, /*InsnID*/24, /*TempRegID*/25,
     /* 177014 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/24,
     /* 177016 */     GIR_MakeTempReg, /*TempRegID*/22, /*TypeID*/GILLT_s32,
     /* 177019 */     GIR_BuildMI, /*InsnID*/23, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 177023 */     GIR_AddTempRegister, /*InsnID*/23, /*TempRegID*/22, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177028 */     GIR_AddSimpleTempRegister, /*InsnID*/23, /*TempRegID*/23,
     /* 177031 */     GIR_AddSimpleTempRegister, /*InsnID*/23, /*TempRegID*/27,
     /* 177034 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/23,
     /* 177036 */     GIR_MakeTempReg, /*TempRegID*/21, /*TypeID*/GILLT_s32,
     /* 177039 */     GIR_BuildMI, /*InsnID*/22, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 177043 */     GIR_AddTempRegister, /*InsnID*/22, /*TempRegID*/21, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177048 */     GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/22,
     /* 177051 */     GIR_AddImm8, /*InsnID*/22, /*Imm*/2,
     /* 177054 */     GIR_AddImm8, /*InsnID*/22, /*Imm*/0,
     /* 177057 */     GIR_AddImm8, /*InsnID*/22, /*Imm*/29,
     /* 177060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/22,
     /* 177062 */     GIR_MakeTempReg, /*TempRegID*/20, /*TypeID*/GILLT_s32,
     /* 177065 */     GIR_BuildMI, /*InsnID*/21, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 177069 */     GIR_AddTempRegister, /*InsnID*/21, /*TempRegID*/20, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177074 */     GIR_AddSimpleTempRegister, /*InsnID*/21, /*TempRegID*/21,
     /* 177077 */     GIR_AddSimpleTempRegister, /*InsnID*/21, /*TempRegID*/31,
     /* 177080 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/21,
     /* 177082 */     GIR_MakeTempReg, /*TempRegID*/19, /*TypeID*/GILLT_s32,
     /* 177085 */     GIR_BuildMI, /*InsnID*/20, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 177089 */     GIR_AddTempRegister, /*InsnID*/20, /*TempRegID*/19, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177094 */     GIR_AddImm, /*InsnID*/20, /*Imm*/GIMT_Encode8(13107),
     /* 177104 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/20,
     /* 177106 */     GIR_MakeTempReg, /*TempRegID*/18, /*TypeID*/GILLT_s32,
     /* 177109 */     GIR_BuildMI, /*InsnID*/19, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 177113 */     GIR_AddTempRegister, /*InsnID*/19, /*TempRegID*/18, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177118 */     GIR_AddSimpleTempRegister, /*InsnID*/19, /*TempRegID*/19,
     /* 177121 */     GIR_AddImm, /*InsnID*/19, /*Imm*/GIMT_Encode8(13107),
     /* 177131 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/19,
     /* 177133 */     GIR_MakeTempReg, /*TempRegID*/17, /*TypeID*/GILLT_s32,
     /* 177136 */     GIR_BuildMI, /*InsnID*/18, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 177140 */     GIR_AddTempRegister, /*InsnID*/18, /*TempRegID*/17, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177145 */     GIR_AddImm, /*InsnID*/18, /*Imm*/GIMT_Encode8(43690),
     /* 177155 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/18,
     /* 177157 */     GIR_MakeTempReg, /*TempRegID*/16, /*TypeID*/GILLT_s32,
     /* 177160 */     GIR_BuildMI, /*InsnID*/17, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 177164 */     GIR_AddTempRegister, /*InsnID*/17, /*TempRegID*/16, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177169 */     GIR_AddSimpleTempRegister, /*InsnID*/17, /*TempRegID*/17,
     /* 177172 */     GIR_AddImm, /*InsnID*/17, /*Imm*/GIMT_Encode8(43690),
     /* 177182 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/17,
     /* 177184 */     GIR_MakeTempReg, /*TempRegID*/15, /*TypeID*/GILLT_s32,
     /* 177187 */     GIR_BuildMI, /*InsnID*/16, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 177191 */     GIR_AddTempRegister, /*InsnID*/16, /*TempRegID*/15, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177196 */     GIR_Copy, /*NewInsnID*/16, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 177200 */     GIR_AddImm8, /*InsnID*/16, /*Imm*/1,
     /* 177203 */     GIR_AddImm8, /*InsnID*/16, /*Imm*/0,
     /* 177206 */     GIR_AddImm8, /*InsnID*/16, /*Imm*/30,
     /* 177209 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/16,
     /* 177211 */     GIR_MakeTempReg, /*TempRegID*/14, /*TypeID*/GILLT_s32,
     /* 177214 */     GIR_BuildMI, /*InsnID*/15, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 177218 */     GIR_AddTempRegister, /*InsnID*/15, /*TempRegID*/14, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177223 */     GIR_AddSimpleTempRegister, /*InsnID*/15, /*TempRegID*/15,
     /* 177226 */     GIR_AddSimpleTempRegister, /*InsnID*/15, /*TempRegID*/16,
     /* 177229 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/15,
     /* 177231 */     GIR_MakeTempReg, /*TempRegID*/13, /*TypeID*/GILLT_s32,
     /* 177234 */     GIR_BuildMI, /*InsnID*/14, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 177238 */     GIR_AddTempRegister, /*InsnID*/14, /*TempRegID*/13, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177243 */     GIR_AddImm, /*InsnID*/14, /*Imm*/GIMT_Encode8(21845),
     /* 177253 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/14,
     /* 177255 */     GIR_MakeTempReg, /*TempRegID*/12, /*TypeID*/GILLT_s32,
     /* 177258 */     GIR_BuildMI, /*InsnID*/13, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 177262 */     GIR_AddTempRegister, /*InsnID*/13, /*TempRegID*/12, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177267 */     GIR_AddSimpleTempRegister, /*InsnID*/13, /*TempRegID*/13,
     /* 177270 */     GIR_AddImm, /*InsnID*/13, /*Imm*/GIMT_Encode8(21845),
     /* 177280 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/13,
     /* 177282 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /* 177285 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 177289 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177294 */     GIR_Copy, /*NewInsnID*/12, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 177298 */     GIR_AddImm8, /*InsnID*/12, /*Imm*/31,
     /* 177301 */     GIR_AddImm8, /*InsnID*/12, /*Imm*/1,
     /* 177304 */     GIR_AddImm8, /*InsnID*/12, /*Imm*/31,
     /* 177307 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/12,
     /* 177309 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /* 177312 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 177316 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177321 */     GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/11,
     /* 177324 */     GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/12,
     /* 177327 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 177329 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /* 177332 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 177336 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177341 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 177344 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/14,
     /* 177347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 177349 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /* 177352 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 177356 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177361 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 177364 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/30,
     /* 177367 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/2,
     /* 177370 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/31,
     /* 177373 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 177375 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /* 177378 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 177382 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177387 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /* 177390 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/18,
     /* 177393 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 177395 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /* 177398 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 177402 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177407 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 177410 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/20,
     /* 177413 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 177415 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /* 177418 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 177422 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177427 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 177430 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/28,
     /* 177433 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/4,
     /* 177436 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/31,
     /* 177439 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 177441 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 177444 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 177448 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177453 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 177456 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/33,
     /* 177459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 177461 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 177464 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 177468 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177473 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 177476 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/35,
     /* 177479 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 177481 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 177484 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 177488 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177493 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 177496 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/24,
     /* 177499 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 177502 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/31,
     /* 177505 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 177507 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 177510 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWIMI),
     /* 177514 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177519 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 177522 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/66,
     /* 177525 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/8,
     /* 177528 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/8,
     /* 177531 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/15,
     /* 177534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 177536 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 177539 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLWIMI),
     /* 177543 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177548 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 177551 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*//* 129(*/0x81, 0x01/*)*/,
     /* 177555 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 177558 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/24,
     /* 177561 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 177564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 177566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL_32),
     /* 177569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 177571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/32,
     /* 177580 */     GIR_RootConstrainSelectedInstOperands,
     /* 177581 */     // GIR_Coverage, 4889,
     /* 177581 */     GIR_EraseRootFromParent_Done,
     /* 177582 */   // Label 2768: @177582
     /* 177582 */   GIM_Try, /*On fail goto*//*Label 2769*/ GIMT_Encode4(182707), // Rule ID 4890 //
     /* 177587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In32BitMode),
     /* 177590 */     // (bitreverse:{ *:[i32] } i32:{ *:[i32] }:$A)  =>  (RLWIMI:{ *:[i32] } (RLWIMI:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 28:{ *:[i32] }, 4:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 4:{ *:[i32] }, 0:{ *:[i32] }, 27:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }))), 24:{ *:[i32] }, 0:{ *:[i32] }, 31:{ *:[i32] }), (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 28:{ *:[i32] }, 4:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 4:{ *:[i32] }, 0:{ *:[i32] }, 27:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }))), 8:{ *:[i32] }, 8:{ *:[i32] }, 15:{ *:[i32] }), (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 28:{ *:[i32] }, 4:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 4:{ *:[i32] }, 0:{ *:[i32] }, 27:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }))), 8:{ *:[i32] }, 24:{ *:[i32] }, 31:{ *:[i32] })
     /* 177590 */     GIR_MakeTempReg, /*TempRegID*//* 190(*/0xBE, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177594 */     GIR_BuildMI, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 177599 */     GIR_AddTempRegister, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*TempRegID*//* 190(*/0xBE, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177606 */     GIR_AddImm, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 177617 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 191(*/0xBF, 0x01/*)*/,
     /* 177620 */     GIR_MakeTempReg, /*TempRegID*//* 189(*/0xBD, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177624 */     GIR_BuildMI, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 177629 */     GIR_AddTempRegister, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*TempRegID*//* 189(*/0xBD, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177636 */     GIR_AddSimpleTempRegister, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*TempRegID*//* 190(*/0xBE, 0x01/*)*/,
     /* 177641 */     GIR_AddImm, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 177652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 190(*/0xBE, 0x01/*)*/,
     /* 177655 */     GIR_MakeTempReg, /*TempRegID*//* 188(*/0xBC, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177659 */     GIR_BuildMI, /*InsnID*//* 189(*/0xBD, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 177664 */     GIR_AddTempRegister, /*InsnID*//* 189(*/0xBD, 0x01/*)*/, /*TempRegID*//* 188(*/0xBC, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177671 */     GIR_AddImm, /*InsnID*//* 189(*/0xBD, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 177682 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 189(*/0xBD, 0x01/*)*/,
     /* 177685 */     GIR_MakeTempReg, /*TempRegID*//* 187(*/0xBB, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177689 */     GIR_BuildMI, /*InsnID*//* 188(*/0xBC, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 177694 */     GIR_AddTempRegister, /*InsnID*//* 188(*/0xBC, 0x01/*)*/, /*TempRegID*//* 187(*/0xBB, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177701 */     GIR_AddSimpleTempRegister, /*InsnID*//* 188(*/0xBC, 0x01/*)*/, /*TempRegID*//* 188(*/0xBC, 0x01/*)*/,
     /* 177706 */     GIR_AddImm, /*InsnID*//* 188(*/0xBC, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 177717 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 188(*/0xBC, 0x01/*)*/,
     /* 177720 */     GIR_MakeTempReg, /*TempRegID*//* 186(*/0xBA, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177724 */     GIR_BuildMI, /*InsnID*//* 187(*/0xBB, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 177729 */     GIR_AddTempRegister, /*InsnID*//* 187(*/0xBB, 0x01/*)*/, /*TempRegID*//* 186(*/0xBA, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177736 */     GIR_AddImm, /*InsnID*//* 187(*/0xBB, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 177747 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 187(*/0xBB, 0x01/*)*/,
     /* 177750 */     GIR_MakeTempReg, /*TempRegID*//* 185(*/0xB9, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177754 */     GIR_BuildMI, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 177759 */     GIR_AddTempRegister, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*TempRegID*//* 185(*/0xB9, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177766 */     GIR_AddSimpleTempRegister, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*TempRegID*//* 186(*/0xBA, 0x01/*)*/,
     /* 177771 */     GIR_AddImm, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 177782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 186(*/0xBA, 0x01/*)*/,
     /* 177785 */     GIR_MakeTempReg, /*TempRegID*//* 184(*/0xB8, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177789 */     GIR_BuildMI, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 177794 */     GIR_AddTempRegister, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*TempRegID*//* 184(*/0xB8, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177801 */     GIR_Copy, /*NewInsnID*//* 185(*/0xB9, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 177806 */     GIR_AddImm8, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*Imm*/1,
     /* 177810 */     GIR_AddImm8, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*Imm*/0,
     /* 177814 */     GIR_AddImm8, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*Imm*/30,
     /* 177818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 185(*/0xB9, 0x01/*)*/,
     /* 177821 */     GIR_MakeTempReg, /*TempRegID*//* 183(*/0xB7, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177825 */     GIR_BuildMI, /*InsnID*//* 184(*/0xB8, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 177830 */     GIR_AddTempRegister, /*InsnID*//* 184(*/0xB8, 0x01/*)*/, /*TempRegID*//* 183(*/0xB7, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177837 */     GIR_AddSimpleTempRegister, /*InsnID*//* 184(*/0xB8, 0x01/*)*/, /*TempRegID*//* 184(*/0xB8, 0x01/*)*/,
     /* 177842 */     GIR_AddSimpleTempRegister, /*InsnID*//* 184(*/0xB8, 0x01/*)*/, /*TempRegID*//* 185(*/0xB9, 0x01/*)*/,
     /* 177847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 184(*/0xB8, 0x01/*)*/,
     /* 177850 */     GIR_MakeTempReg, /*TempRegID*//* 182(*/0xB6, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177854 */     GIR_BuildMI, /*InsnID*//* 183(*/0xB7, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 177859 */     GIR_AddTempRegister, /*InsnID*//* 183(*/0xB7, 0x01/*)*/, /*TempRegID*//* 182(*/0xB6, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177866 */     GIR_AddImm, /*InsnID*//* 183(*/0xB7, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 177877 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 183(*/0xB7, 0x01/*)*/,
     /* 177880 */     GIR_MakeTempReg, /*TempRegID*//* 181(*/0xB5, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177884 */     GIR_BuildMI, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 177889 */     GIR_AddTempRegister, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*TempRegID*//* 181(*/0xB5, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177896 */     GIR_AddSimpleTempRegister, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*TempRegID*//* 182(*/0xB6, 0x01/*)*/,
     /* 177901 */     GIR_AddImm, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 177912 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 182(*/0xB6, 0x01/*)*/,
     /* 177915 */     GIR_MakeTempReg, /*TempRegID*//* 180(*/0xB4, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177919 */     GIR_BuildMI, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 177924 */     GIR_AddTempRegister, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*TempRegID*//* 180(*/0xB4, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177931 */     GIR_Copy, /*NewInsnID*//* 181(*/0xB5, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 177936 */     GIR_AddImm8, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*Imm*/31,
     /* 177940 */     GIR_AddImm8, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*Imm*/1,
     /* 177944 */     GIR_AddImm8, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*Imm*/31,
     /* 177948 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 181(*/0xB5, 0x01/*)*/,
     /* 177951 */     GIR_MakeTempReg, /*TempRegID*//* 179(*/0xB3, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177955 */     GIR_BuildMI, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 177960 */     GIR_AddTempRegister, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*TempRegID*//* 179(*/0xB3, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177967 */     GIR_AddSimpleTempRegister, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*TempRegID*//* 180(*/0xB4, 0x01/*)*/,
     /* 177972 */     GIR_AddSimpleTempRegister, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*TempRegID*//* 181(*/0xB5, 0x01/*)*/,
     /* 177977 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 180(*/0xB4, 0x01/*)*/,
     /* 177980 */     GIR_MakeTempReg, /*TempRegID*//* 178(*/0xB2, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177984 */     GIR_BuildMI, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 177989 */     GIR_AddTempRegister, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*TempRegID*//* 178(*/0xB2, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177996 */     GIR_AddSimpleTempRegister, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*TempRegID*//* 179(*/0xB3, 0x01/*)*/,
     /* 178001 */     GIR_AddSimpleTempRegister, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*TempRegID*//* 183(*/0xB7, 0x01/*)*/,
     /* 178006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 179(*/0xB3, 0x01/*)*/,
     /* 178009 */     GIR_MakeTempReg, /*TempRegID*//* 177(*/0xB1, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178013 */     GIR_BuildMI, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 178018 */     GIR_AddTempRegister, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*TempRegID*//* 177(*/0xB1, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178025 */     GIR_AddSimpleTempRegister, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*TempRegID*//* 178(*/0xB2, 0x01/*)*/,
     /* 178030 */     GIR_AddImm8, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*Imm*/2,
     /* 178034 */     GIR_AddImm8, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*Imm*/0,
     /* 178038 */     GIR_AddImm8, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*Imm*/29,
     /* 178042 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 178(*/0xB2, 0x01/*)*/,
     /* 178045 */     GIR_MakeTempReg, /*TempRegID*//* 176(*/0xB0, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178049 */     GIR_BuildMI, /*InsnID*//* 177(*/0xB1, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 178054 */     GIR_AddTempRegister, /*InsnID*//* 177(*/0xB1, 0x01/*)*/, /*TempRegID*//* 176(*/0xB0, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178061 */     GIR_AddSimpleTempRegister, /*InsnID*//* 177(*/0xB1, 0x01/*)*/, /*TempRegID*//* 177(*/0xB1, 0x01/*)*/,
     /* 178066 */     GIR_AddSimpleTempRegister, /*InsnID*//* 177(*/0xB1, 0x01/*)*/, /*TempRegID*//* 187(*/0xBB, 0x01/*)*/,
     /* 178071 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 177(*/0xB1, 0x01/*)*/,
     /* 178074 */     GIR_MakeTempReg, /*TempRegID*//* 175(*/0xAF, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178078 */     GIR_BuildMI, /*InsnID*//* 176(*/0xB0, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 178083 */     GIR_AddTempRegister, /*InsnID*//* 176(*/0xB0, 0x01/*)*/, /*TempRegID*//* 175(*/0xAF, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178090 */     GIR_AddImm, /*InsnID*//* 176(*/0xB0, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 178101 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 176(*/0xB0, 0x01/*)*/,
     /* 178104 */     GIR_MakeTempReg, /*TempRegID*//* 174(*/0xAE, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178108 */     GIR_BuildMI, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 178113 */     GIR_AddTempRegister, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*TempRegID*//* 174(*/0xAE, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178120 */     GIR_AddSimpleTempRegister, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*TempRegID*//* 175(*/0xAF, 0x01/*)*/,
     /* 178125 */     GIR_AddImm, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 178136 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 175(*/0xAF, 0x01/*)*/,
     /* 178139 */     GIR_MakeTempReg, /*TempRegID*//* 173(*/0xAD, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178143 */     GIR_BuildMI, /*InsnID*//* 174(*/0xAE, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 178148 */     GIR_AddTempRegister, /*InsnID*//* 174(*/0xAE, 0x01/*)*/, /*TempRegID*//* 173(*/0xAD, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178155 */     GIR_AddImm, /*InsnID*//* 174(*/0xAE, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 178166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 174(*/0xAE, 0x01/*)*/,
     /* 178169 */     GIR_MakeTempReg, /*TempRegID*//* 172(*/0xAC, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178173 */     GIR_BuildMI, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 178178 */     GIR_AddTempRegister, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*TempRegID*//* 172(*/0xAC, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178185 */     GIR_AddSimpleTempRegister, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*TempRegID*//* 173(*/0xAD, 0x01/*)*/,
     /* 178190 */     GIR_AddImm, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 178201 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 173(*/0xAD, 0x01/*)*/,
     /* 178204 */     GIR_MakeTempReg, /*TempRegID*//* 171(*/0xAB, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178208 */     GIR_BuildMI, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 178213 */     GIR_AddTempRegister, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*TempRegID*//* 171(*/0xAB, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178220 */     GIR_Copy, /*NewInsnID*//* 172(*/0xAC, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 178225 */     GIR_AddImm8, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*Imm*/1,
     /* 178229 */     GIR_AddImm8, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*Imm*/0,
     /* 178233 */     GIR_AddImm8, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*Imm*/30,
     /* 178237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 172(*/0xAC, 0x01/*)*/,
     /* 178240 */     GIR_MakeTempReg, /*TempRegID*//* 170(*/0xAA, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178244 */     GIR_BuildMI, /*InsnID*//* 171(*/0xAB, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 178249 */     GIR_AddTempRegister, /*InsnID*//* 171(*/0xAB, 0x01/*)*/, /*TempRegID*//* 170(*/0xAA, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178256 */     GIR_AddSimpleTempRegister, /*InsnID*//* 171(*/0xAB, 0x01/*)*/, /*TempRegID*//* 171(*/0xAB, 0x01/*)*/,
     /* 178261 */     GIR_AddSimpleTempRegister, /*InsnID*//* 171(*/0xAB, 0x01/*)*/, /*TempRegID*//* 172(*/0xAC, 0x01/*)*/,
     /* 178266 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 171(*/0xAB, 0x01/*)*/,
     /* 178269 */     GIR_MakeTempReg, /*TempRegID*//* 169(*/0xA9, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178273 */     GIR_BuildMI, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 178278 */     GIR_AddTempRegister, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*TempRegID*//* 169(*/0xA9, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178285 */     GIR_AddImm, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 178296 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 170(*/0xAA, 0x01/*)*/,
     /* 178299 */     GIR_MakeTempReg, /*TempRegID*//* 168(*/0xA8, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178303 */     GIR_BuildMI, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 178308 */     GIR_AddTempRegister, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*TempRegID*//* 168(*/0xA8, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178315 */     GIR_AddSimpleTempRegister, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*TempRegID*//* 169(*/0xA9, 0x01/*)*/,
     /* 178320 */     GIR_AddImm, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 178331 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 169(*/0xA9, 0x01/*)*/,
     /* 178334 */     GIR_MakeTempReg, /*TempRegID*//* 167(*/0xA7, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178338 */     GIR_BuildMI, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 178343 */     GIR_AddTempRegister, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*TempRegID*//* 167(*/0xA7, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178350 */     GIR_Copy, /*NewInsnID*//* 168(*/0xA8, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 178355 */     GIR_AddImm8, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*Imm*/31,
     /* 178359 */     GIR_AddImm8, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*Imm*/1,
     /* 178363 */     GIR_AddImm8, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*Imm*/31,
     /* 178367 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 168(*/0xA8, 0x01/*)*/,
     /* 178370 */     GIR_MakeTempReg, /*TempRegID*//* 166(*/0xA6, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178374 */     GIR_BuildMI, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 178379 */     GIR_AddTempRegister, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*TempRegID*//* 166(*/0xA6, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178386 */     GIR_AddSimpleTempRegister, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*TempRegID*//* 167(*/0xA7, 0x01/*)*/,
     /* 178391 */     GIR_AddSimpleTempRegister, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*TempRegID*//* 168(*/0xA8, 0x01/*)*/,
     /* 178396 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 167(*/0xA7, 0x01/*)*/,
     /* 178399 */     GIR_MakeTempReg, /*TempRegID*//* 165(*/0xA5, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178403 */     GIR_BuildMI, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 178408 */     GIR_AddTempRegister, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*TempRegID*//* 165(*/0xA5, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178415 */     GIR_AddSimpleTempRegister, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*TempRegID*//* 166(*/0xA6, 0x01/*)*/,
     /* 178420 */     GIR_AddSimpleTempRegister, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*TempRegID*//* 170(*/0xAA, 0x01/*)*/,
     /* 178425 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 166(*/0xA6, 0x01/*)*/,
     /* 178428 */     GIR_MakeTempReg, /*TempRegID*//* 164(*/0xA4, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178432 */     GIR_BuildMI, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 178437 */     GIR_AddTempRegister, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*TempRegID*//* 164(*/0xA4, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178444 */     GIR_AddSimpleTempRegister, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*TempRegID*//* 165(*/0xA5, 0x01/*)*/,
     /* 178449 */     GIR_AddImm8, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*Imm*/30,
     /* 178453 */     GIR_AddImm8, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*Imm*/2,
     /* 178457 */     GIR_AddImm8, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*Imm*/31,
     /* 178461 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 165(*/0xA5, 0x01/*)*/,
     /* 178464 */     GIR_MakeTempReg, /*TempRegID*//* 163(*/0xA3, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178468 */     GIR_BuildMI, /*InsnID*//* 164(*/0xA4, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 178473 */     GIR_AddTempRegister, /*InsnID*//* 164(*/0xA4, 0x01/*)*/, /*TempRegID*//* 163(*/0xA3, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178480 */     GIR_AddSimpleTempRegister, /*InsnID*//* 164(*/0xA4, 0x01/*)*/, /*TempRegID*//* 164(*/0xA4, 0x01/*)*/,
     /* 178485 */     GIR_AddSimpleTempRegister, /*InsnID*//* 164(*/0xA4, 0x01/*)*/, /*TempRegID*//* 174(*/0xAE, 0x01/*)*/,
     /* 178490 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 164(*/0xA4, 0x01/*)*/,
     /* 178493 */     GIR_MakeTempReg, /*TempRegID*//* 162(*/0xA2, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178497 */     GIR_BuildMI, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 178502 */     GIR_AddTempRegister, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*TempRegID*//* 162(*/0xA2, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178509 */     GIR_AddSimpleTempRegister, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*TempRegID*//* 163(*/0xA3, 0x01/*)*/,
     /* 178514 */     GIR_AddSimpleTempRegister, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*TempRegID*//* 176(*/0xB0, 0x01/*)*/,
     /* 178519 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 163(*/0xA3, 0x01/*)*/,
     /* 178522 */     GIR_MakeTempReg, /*TempRegID*//* 161(*/0xA1, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178526 */     GIR_BuildMI, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 178531 */     GIR_AddTempRegister, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*TempRegID*//* 161(*/0xA1, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178538 */     GIR_AddSimpleTempRegister, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*TempRegID*//* 162(*/0xA2, 0x01/*)*/,
     /* 178543 */     GIR_AddImm8, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*Imm*/4,
     /* 178547 */     GIR_AddImm8, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*Imm*/0,
     /* 178551 */     GIR_AddImm8, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*Imm*/27,
     /* 178555 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 162(*/0xA2, 0x01/*)*/,
     /* 178558 */     GIR_MakeTempReg, /*TempRegID*//* 160(*/0xA0, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178562 */     GIR_BuildMI, /*InsnID*//* 161(*/0xA1, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 178567 */     GIR_AddTempRegister, /*InsnID*//* 161(*/0xA1, 0x01/*)*/, /*TempRegID*//* 160(*/0xA0, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178574 */     GIR_AddSimpleTempRegister, /*InsnID*//* 161(*/0xA1, 0x01/*)*/, /*TempRegID*//* 161(*/0xA1, 0x01/*)*/,
     /* 178579 */     GIR_AddSimpleTempRegister, /*InsnID*//* 161(*/0xA1, 0x01/*)*/, /*TempRegID*//* 189(*/0xBD, 0x01/*)*/,
     /* 178584 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 161(*/0xA1, 0x01/*)*/,
     /* 178587 */     GIR_MakeTempReg, /*TempRegID*//* 159(*/0x9F, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178591 */     GIR_BuildMI, /*InsnID*//* 160(*/0xA0, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 178596 */     GIR_AddTempRegister, /*InsnID*//* 160(*/0xA0, 0x01/*)*/, /*TempRegID*//* 159(*/0x9F, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178603 */     GIR_AddImm, /*InsnID*//* 160(*/0xA0, 0x01/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 178614 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 160(*/0xA0, 0x01/*)*/,
     /* 178617 */     GIR_MakeTempReg, /*TempRegID*//* 158(*/0x9E, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178621 */     GIR_BuildMI, /*InsnID*//* 159(*/0x9F, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 178626 */     GIR_AddTempRegister, /*InsnID*//* 159(*/0x9F, 0x01/*)*/, /*TempRegID*//* 158(*/0x9E, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178633 */     GIR_AddSimpleTempRegister, /*InsnID*//* 159(*/0x9F, 0x01/*)*/, /*TempRegID*//* 159(*/0x9F, 0x01/*)*/,
     /* 178638 */     GIR_AddImm, /*InsnID*//* 159(*/0x9F, 0x01/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 178649 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 159(*/0x9F, 0x01/*)*/,
     /* 178652 */     GIR_MakeTempReg, /*TempRegID*//* 157(*/0x9D, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178656 */     GIR_BuildMI, /*InsnID*//* 158(*/0x9E, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 178661 */     GIR_AddTempRegister, /*InsnID*//* 158(*/0x9E, 0x01/*)*/, /*TempRegID*//* 157(*/0x9D, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178668 */     GIR_AddImm, /*InsnID*//* 158(*/0x9E, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 178679 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 158(*/0x9E, 0x01/*)*/,
     /* 178682 */     GIR_MakeTempReg, /*TempRegID*//* 156(*/0x9C, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178686 */     GIR_BuildMI, /*InsnID*//* 157(*/0x9D, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 178691 */     GIR_AddTempRegister, /*InsnID*//* 157(*/0x9D, 0x01/*)*/, /*TempRegID*//* 156(*/0x9C, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178698 */     GIR_AddSimpleTempRegister, /*InsnID*//* 157(*/0x9D, 0x01/*)*/, /*TempRegID*//* 157(*/0x9D, 0x01/*)*/,
     /* 178703 */     GIR_AddImm, /*InsnID*//* 157(*/0x9D, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 178714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 157(*/0x9D, 0x01/*)*/,
     /* 178717 */     GIR_MakeTempReg, /*TempRegID*//* 155(*/0x9B, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178721 */     GIR_BuildMI, /*InsnID*//* 156(*/0x9C, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 178726 */     GIR_AddTempRegister, /*InsnID*//* 156(*/0x9C, 0x01/*)*/, /*TempRegID*//* 155(*/0x9B, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178733 */     GIR_AddImm, /*InsnID*//* 156(*/0x9C, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 178744 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 156(*/0x9C, 0x01/*)*/,
     /* 178747 */     GIR_MakeTempReg, /*TempRegID*//* 154(*/0x9A, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178751 */     GIR_BuildMI, /*InsnID*//* 155(*/0x9B, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 178756 */     GIR_AddTempRegister, /*InsnID*//* 155(*/0x9B, 0x01/*)*/, /*TempRegID*//* 154(*/0x9A, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178763 */     GIR_AddSimpleTempRegister, /*InsnID*//* 155(*/0x9B, 0x01/*)*/, /*TempRegID*//* 155(*/0x9B, 0x01/*)*/,
     /* 178768 */     GIR_AddImm, /*InsnID*//* 155(*/0x9B, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 178779 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 155(*/0x9B, 0x01/*)*/,
     /* 178782 */     GIR_MakeTempReg, /*TempRegID*//* 153(*/0x99, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178786 */     GIR_BuildMI, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 178791 */     GIR_AddTempRegister, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*TempRegID*//* 153(*/0x99, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178798 */     GIR_Copy, /*NewInsnID*//* 154(*/0x9A, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 178803 */     GIR_AddImm8, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*Imm*/1,
     /* 178807 */     GIR_AddImm8, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*Imm*/0,
     /* 178811 */     GIR_AddImm8, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*Imm*/30,
     /* 178815 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 154(*/0x9A, 0x01/*)*/,
     /* 178818 */     GIR_MakeTempReg, /*TempRegID*//* 152(*/0x98, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178822 */     GIR_BuildMI, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 178827 */     GIR_AddTempRegister, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*TempRegID*//* 152(*/0x98, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178834 */     GIR_AddSimpleTempRegister, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*TempRegID*//* 153(*/0x99, 0x01/*)*/,
     /* 178839 */     GIR_AddSimpleTempRegister, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*TempRegID*//* 154(*/0x9A, 0x01/*)*/,
     /* 178844 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 153(*/0x99, 0x01/*)*/,
     /* 178847 */     GIR_MakeTempReg, /*TempRegID*//* 151(*/0x97, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178851 */     GIR_BuildMI, /*InsnID*//* 152(*/0x98, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 178856 */     GIR_AddTempRegister, /*InsnID*//* 152(*/0x98, 0x01/*)*/, /*TempRegID*//* 151(*/0x97, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178863 */     GIR_AddImm, /*InsnID*//* 152(*/0x98, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 178874 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 152(*/0x98, 0x01/*)*/,
     /* 178877 */     GIR_MakeTempReg, /*TempRegID*//* 150(*/0x96, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178881 */     GIR_BuildMI, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 178886 */     GIR_AddTempRegister, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*TempRegID*//* 150(*/0x96, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178893 */     GIR_AddSimpleTempRegister, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*TempRegID*//* 151(*/0x97, 0x01/*)*/,
     /* 178898 */     GIR_AddImm, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 178909 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 151(*/0x97, 0x01/*)*/,
     /* 178912 */     GIR_MakeTempReg, /*TempRegID*//* 149(*/0x95, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178916 */     GIR_BuildMI, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 178921 */     GIR_AddTempRegister, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*TempRegID*//* 149(*/0x95, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178928 */     GIR_Copy, /*NewInsnID*//* 150(*/0x96, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 178933 */     GIR_AddImm8, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*Imm*/31,
     /* 178937 */     GIR_AddImm8, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*Imm*/1,
     /* 178941 */     GIR_AddImm8, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*Imm*/31,
     /* 178945 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 150(*/0x96, 0x01/*)*/,
     /* 178948 */     GIR_MakeTempReg, /*TempRegID*//* 148(*/0x94, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178952 */     GIR_BuildMI, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 178957 */     GIR_AddTempRegister, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*TempRegID*//* 148(*/0x94, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178964 */     GIR_AddSimpleTempRegister, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*TempRegID*//* 149(*/0x95, 0x01/*)*/,
     /* 178969 */     GIR_AddSimpleTempRegister, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*TempRegID*//* 150(*/0x96, 0x01/*)*/,
     /* 178974 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 149(*/0x95, 0x01/*)*/,
     /* 178977 */     GIR_MakeTempReg, /*TempRegID*//* 147(*/0x93, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178981 */     GIR_BuildMI, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 178986 */     GIR_AddTempRegister, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*TempRegID*//* 147(*/0x93, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178993 */     GIR_AddSimpleTempRegister, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*TempRegID*//* 148(*/0x94, 0x01/*)*/,
     /* 178998 */     GIR_AddSimpleTempRegister, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*TempRegID*//* 152(*/0x98, 0x01/*)*/,
     /* 179003 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 148(*/0x94, 0x01/*)*/,
     /* 179006 */     GIR_MakeTempReg, /*TempRegID*//* 146(*/0x92, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 179010 */     GIR_BuildMI, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 179015 */     GIR_AddTempRegister, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*TempRegID*//* 146(*/0x92, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179022 */     GIR_AddSimpleTempRegister, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*TempRegID*//* 147(*/0x93, 0x01/*)*/,
     /* 179027 */     GIR_AddImm8, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*Imm*/2,
     /* 179031 */     GIR_AddImm8, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*Imm*/0,
     /* 179035 */     GIR_AddImm8, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*Imm*/29,
     /* 179039 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 147(*/0x93, 0x01/*)*/,
     /* 179042 */     GIR_MakeTempReg, /*TempRegID*//* 145(*/0x91, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 179046 */     GIR_BuildMI, /*InsnID*//* 146(*/0x92, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 179051 */     GIR_AddTempRegister, /*InsnID*//* 146(*/0x92, 0x01/*)*/, /*TempRegID*//* 145(*/0x91, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179058 */     GIR_AddSimpleTempRegister, /*InsnID*//* 146(*/0x92, 0x01/*)*/, /*TempRegID*//* 146(*/0x92, 0x01/*)*/,
     /* 179063 */     GIR_AddSimpleTempRegister, /*InsnID*//* 146(*/0x92, 0x01/*)*/, /*TempRegID*//* 156(*/0x9C, 0x01/*)*/,
     /* 179068 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 146(*/0x92, 0x01/*)*/,
     /* 179071 */     GIR_MakeTempReg, /*TempRegID*//* 144(*/0x90, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 179075 */     GIR_BuildMI, /*InsnID*//* 145(*/0x91, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 179080 */     GIR_AddTempRegister, /*InsnID*//* 145(*/0x91, 0x01/*)*/, /*TempRegID*//* 144(*/0x90, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179087 */     GIR_AddImm, /*InsnID*//* 145(*/0x91, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 179098 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 145(*/0x91, 0x01/*)*/,
     /* 179101 */     GIR_MakeTempReg, /*TempRegID*//* 143(*/0x8F, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 179105 */     GIR_BuildMI, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 179110 */     GIR_AddTempRegister, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*TempRegID*//* 143(*/0x8F, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179117 */     GIR_AddSimpleTempRegister, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*TempRegID*//* 144(*/0x90, 0x01/*)*/,
     /* 179122 */     GIR_AddImm, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 179133 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 144(*/0x90, 0x01/*)*/,
     /* 179136 */     GIR_MakeTempReg, /*TempRegID*//* 142(*/0x8E, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 179140 */     GIR_BuildMI, /*InsnID*//* 143(*/0x8F, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 179145 */     GIR_AddTempRegister, /*InsnID*//* 143(*/0x8F, 0x01/*)*/, /*TempRegID*//* 142(*/0x8E, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179152 */     GIR_AddImm, /*InsnID*//* 143(*/0x8F, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 179163 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 143(*/0x8F, 0x01/*)*/,
     /* 179166 */     GIR_MakeTempReg, /*TempRegID*//* 141(*/0x8D, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 179170 */     GIR_BuildMI, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 179175 */     GIR_AddTempRegister, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*TempRegID*//* 141(*/0x8D, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179182 */     GIR_AddSimpleTempRegister, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*TempRegID*//* 142(*/0x8E, 0x01/*)*/,
     /* 179187 */     GIR_AddImm, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 179198 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 142(*/0x8E, 0x01/*)*/,
     /* 179201 */     GIR_MakeTempReg, /*TempRegID*//* 140(*/0x8C, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 179205 */     GIR_BuildMI, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 179210 */     GIR_AddTempRegister, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*TempRegID*//* 140(*/0x8C, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179217 */     GIR_Copy, /*NewInsnID*//* 141(*/0x8D, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 179222 */     GIR_AddImm8, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*Imm*/1,
     /* 179226 */     GIR_AddImm8, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*Imm*/0,
     /* 179230 */     GIR_AddImm8, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*Imm*/30,
     /* 179234 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 141(*/0x8D, 0x01/*)*/,
     /* 179237 */     GIR_MakeTempReg, /*TempRegID*//* 139(*/0x8B, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 179241 */     GIR_BuildMI, /*InsnID*//* 140(*/0x8C, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 179246 */     GIR_AddTempRegister, /*InsnID*//* 140(*/0x8C, 0x01/*)*/, /*TempRegID*//* 139(*/0x8B, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179253 */     GIR_AddSimpleTempRegister, /*InsnID*//* 140(*/0x8C, 0x01/*)*/, /*TempRegID*//* 140(*/0x8C, 0x01/*)*/,
     /* 179258 */     GIR_AddSimpleTempRegister, /*InsnID*//* 140(*/0x8C, 0x01/*)*/, /*TempRegID*//* 141(*/0x8D, 0x01/*)*/,
     /* 179263 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 140(*/0x8C, 0x01/*)*/,
     /* 179266 */     GIR_MakeTempReg, /*TempRegID*//* 138(*/0x8A, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 179270 */     GIR_BuildMI, /*InsnID*//* 139(*/0x8B, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 179275 */     GIR_AddTempRegister, /*InsnID*//* 139(*/0x8B, 0x01/*)*/, /*TempRegID*//* 138(*/0x8A, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179282 */     GIR_AddImm, /*InsnID*//* 139(*/0x8B, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 179293 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 139(*/0x8B, 0x01/*)*/,
     /* 179296 */     GIR_MakeTempReg, /*TempRegID*//* 137(*/0x89, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 179300 */     GIR_BuildMI, /*InsnID*//* 138(*/0x8A, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 179305 */     GIR_AddTempRegister, /*InsnID*//* 138(*/0x8A, 0x01/*)*/, /*TempRegID*//* 137(*/0x89, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179312 */     GIR_AddSimpleTempRegister, /*InsnID*//* 138(*/0x8A, 0x01/*)*/, /*TempRegID*//* 138(*/0x8A, 0x01/*)*/,
     /* 179317 */     GIR_AddImm, /*InsnID*//* 138(*/0x8A, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 179328 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 138(*/0x8A, 0x01/*)*/,
     /* 179331 */     GIR_MakeTempReg, /*TempRegID*//* 136(*/0x88, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 179335 */     GIR_BuildMI, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 179340 */     GIR_AddTempRegister, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*TempRegID*//* 136(*/0x88, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179347 */     GIR_Copy, /*NewInsnID*//* 137(*/0x89, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 179352 */     GIR_AddImm8, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*Imm*/31,
     /* 179356 */     GIR_AddImm8, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*Imm*/1,
     /* 179360 */     GIR_AddImm8, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*Imm*/31,
     /* 179364 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 137(*/0x89, 0x01/*)*/,
     /* 179367 */     GIR_MakeTempReg, /*TempRegID*//* 135(*/0x87, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 179371 */     GIR_BuildMI, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 179376 */     GIR_AddTempRegister, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*TempRegID*//* 135(*/0x87, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179383 */     GIR_AddSimpleTempRegister, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*TempRegID*//* 136(*/0x88, 0x01/*)*/,
     /* 179388 */     GIR_AddSimpleTempRegister, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*TempRegID*//* 137(*/0x89, 0x01/*)*/,
     /* 179393 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 136(*/0x88, 0x01/*)*/,
     /* 179396 */     GIR_MakeTempReg, /*TempRegID*//* 134(*/0x86, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 179400 */     GIR_BuildMI, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 179405 */     GIR_AddTempRegister, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*TempRegID*//* 134(*/0x86, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179412 */     GIR_AddSimpleTempRegister, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*TempRegID*//* 135(*/0x87, 0x01/*)*/,
     /* 179417 */     GIR_AddSimpleTempRegister, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*TempRegID*//* 139(*/0x8B, 0x01/*)*/,
     /* 179422 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 135(*/0x87, 0x01/*)*/,
     /* 179425 */     GIR_MakeTempReg, /*TempRegID*//* 133(*/0x85, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 179429 */     GIR_BuildMI, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 179434 */     GIR_AddTempRegister, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*TempRegID*//* 133(*/0x85, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179441 */     GIR_AddSimpleTempRegister, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*TempRegID*//* 134(*/0x86, 0x01/*)*/,
     /* 179446 */     GIR_AddImm8, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*Imm*/30,
     /* 179450 */     GIR_AddImm8, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*Imm*/2,
     /* 179454 */     GIR_AddImm8, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*Imm*/31,
     /* 179458 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 134(*/0x86, 0x01/*)*/,
     /* 179461 */     GIR_MakeTempReg, /*TempRegID*//* 132(*/0x84, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 179465 */     GIR_BuildMI, /*InsnID*//* 133(*/0x85, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 179470 */     GIR_AddTempRegister, /*InsnID*//* 133(*/0x85, 0x01/*)*/, /*TempRegID*//* 132(*/0x84, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179477 */     GIR_AddSimpleTempRegister, /*InsnID*//* 133(*/0x85, 0x01/*)*/, /*TempRegID*//* 133(*/0x85, 0x01/*)*/,
     /* 179482 */     GIR_AddSimpleTempRegister, /*InsnID*//* 133(*/0x85, 0x01/*)*/, /*TempRegID*//* 143(*/0x8F, 0x01/*)*/,
     /* 179487 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 133(*/0x85, 0x01/*)*/,
     /* 179490 */     GIR_MakeTempReg, /*TempRegID*//* 131(*/0x83, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 179494 */     GIR_BuildMI, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 179499 */     GIR_AddTempRegister, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*TempRegID*//* 131(*/0x83, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179506 */     GIR_AddSimpleTempRegister, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*TempRegID*//* 132(*/0x84, 0x01/*)*/,
     /* 179511 */     GIR_AddSimpleTempRegister, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*TempRegID*//* 145(*/0x91, 0x01/*)*/,
     /* 179516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 132(*/0x84, 0x01/*)*/,
     /* 179519 */     GIR_MakeTempReg, /*TempRegID*//* 130(*/0x82, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 179523 */     GIR_BuildMI, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 179528 */     GIR_AddTempRegister, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*TempRegID*//* 130(*/0x82, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179535 */     GIR_AddSimpleTempRegister, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*TempRegID*//* 131(*/0x83, 0x01/*)*/,
     /* 179540 */     GIR_AddImm8, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*Imm*/28,
     /* 179544 */     GIR_AddImm8, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*Imm*/4,
     /* 179548 */     GIR_AddImm8, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*Imm*/31,
     /* 179552 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 131(*/0x83, 0x01/*)*/,
     /* 179555 */     GIR_MakeTempReg, /*TempRegID*//* 129(*/0x81, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 179559 */     GIR_BuildMI, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 179564 */     GIR_AddTempRegister, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*TempRegID*//* 129(*/0x81, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179571 */     GIR_AddSimpleTempRegister, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*TempRegID*//* 130(*/0x82, 0x01/*)*/,
     /* 179576 */     GIR_AddSimpleTempRegister, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*TempRegID*//* 158(*/0x9E, 0x01/*)*/,
     /* 179581 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 130(*/0x82, 0x01/*)*/,
     /* 179584 */     GIR_MakeTempReg, /*TempRegID*//* 128(*/0x80, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 179588 */     GIR_BuildMI, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 179593 */     GIR_AddTempRegister, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*TempRegID*//* 128(*/0x80, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179600 */     GIR_AddSimpleTempRegister, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*TempRegID*//* 129(*/0x81, 0x01/*)*/,
     /* 179605 */     GIR_AddSimpleTempRegister, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*TempRegID*//* 160(*/0xA0, 0x01/*)*/,
     /* 179610 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 129(*/0x81, 0x01/*)*/,
     /* 179613 */     GIR_MakeTempReg, /*TempRegID*/127, /*TypeID*/GILLT_s32,
     /* 179616 */     GIR_BuildMI, /*InsnID*//* 128(*/0x80, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 179621 */     GIR_AddTempRegister, /*InsnID*//* 128(*/0x80, 0x01/*)*/, /*TempRegID*/127, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179627 */     GIR_AddImm, /*InsnID*//* 128(*/0x80, 0x01/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 179638 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 128(*/0x80, 0x01/*)*/,
     /* 179641 */     GIR_MakeTempReg, /*TempRegID*/126, /*TypeID*/GILLT_s32,
     /* 179644 */     GIR_BuildMI, /*InsnID*/127, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 179648 */     GIR_AddTempRegister, /*InsnID*/127, /*TempRegID*/126, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179653 */     GIR_AddSimpleTempRegister, /*InsnID*/127, /*TempRegID*/127,
     /* 179656 */     GIR_AddImm, /*InsnID*/127, /*Imm*/GIMT_Encode8(61680),
     /* 179666 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/127,
     /* 179668 */     GIR_MakeTempReg, /*TempRegID*/125, /*TypeID*/GILLT_s32,
     /* 179671 */     GIR_BuildMI, /*InsnID*/126, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 179675 */     GIR_AddTempRegister, /*InsnID*/126, /*TempRegID*/125, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179680 */     GIR_AddImm, /*InsnID*/126, /*Imm*/GIMT_Encode8(52428),
     /* 179690 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/126,
     /* 179692 */     GIR_MakeTempReg, /*TempRegID*/124, /*TypeID*/GILLT_s32,
     /* 179695 */     GIR_BuildMI, /*InsnID*/125, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 179699 */     GIR_AddTempRegister, /*InsnID*/125, /*TempRegID*/124, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179704 */     GIR_AddSimpleTempRegister, /*InsnID*/125, /*TempRegID*/125,
     /* 179707 */     GIR_AddImm, /*InsnID*/125, /*Imm*/GIMT_Encode8(52428),
     /* 179717 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/125,
     /* 179719 */     GIR_MakeTempReg, /*TempRegID*/123, /*TypeID*/GILLT_s32,
     /* 179722 */     GIR_BuildMI, /*InsnID*/124, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 179726 */     GIR_AddTempRegister, /*InsnID*/124, /*TempRegID*/123, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179731 */     GIR_AddImm, /*InsnID*/124, /*Imm*/GIMT_Encode8(43690),
     /* 179741 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/124,
     /* 179743 */     GIR_MakeTempReg, /*TempRegID*/122, /*TypeID*/GILLT_s32,
     /* 179746 */     GIR_BuildMI, /*InsnID*/123, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 179750 */     GIR_AddTempRegister, /*InsnID*/123, /*TempRegID*/122, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179755 */     GIR_AddSimpleTempRegister, /*InsnID*/123, /*TempRegID*/123,
     /* 179758 */     GIR_AddImm, /*InsnID*/123, /*Imm*/GIMT_Encode8(43690),
     /* 179768 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/123,
     /* 179770 */     GIR_MakeTempReg, /*TempRegID*/121, /*TypeID*/GILLT_s32,
     /* 179773 */     GIR_BuildMI, /*InsnID*/122, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 179777 */     GIR_AddTempRegister, /*InsnID*/122, /*TempRegID*/121, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179782 */     GIR_Copy, /*NewInsnID*/122, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 179786 */     GIR_AddImm8, /*InsnID*/122, /*Imm*/1,
     /* 179789 */     GIR_AddImm8, /*InsnID*/122, /*Imm*/0,
     /* 179792 */     GIR_AddImm8, /*InsnID*/122, /*Imm*/30,
     /* 179795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/122,
     /* 179797 */     GIR_MakeTempReg, /*TempRegID*/120, /*TypeID*/GILLT_s32,
     /* 179800 */     GIR_BuildMI, /*InsnID*/121, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 179804 */     GIR_AddTempRegister, /*InsnID*/121, /*TempRegID*/120, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179809 */     GIR_AddSimpleTempRegister, /*InsnID*/121, /*TempRegID*/121,
     /* 179812 */     GIR_AddSimpleTempRegister, /*InsnID*/121, /*TempRegID*/122,
     /* 179815 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/121,
     /* 179817 */     GIR_MakeTempReg, /*TempRegID*/119, /*TypeID*/GILLT_s32,
     /* 179820 */     GIR_BuildMI, /*InsnID*/120, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 179824 */     GIR_AddTempRegister, /*InsnID*/120, /*TempRegID*/119, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179829 */     GIR_AddImm, /*InsnID*/120, /*Imm*/GIMT_Encode8(21845),
     /* 179839 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/120,
     /* 179841 */     GIR_MakeTempReg, /*TempRegID*/118, /*TypeID*/GILLT_s32,
     /* 179844 */     GIR_BuildMI, /*InsnID*/119, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 179848 */     GIR_AddTempRegister, /*InsnID*/119, /*TempRegID*/118, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179853 */     GIR_AddSimpleTempRegister, /*InsnID*/119, /*TempRegID*/119,
     /* 179856 */     GIR_AddImm, /*InsnID*/119, /*Imm*/GIMT_Encode8(21845),
     /* 179866 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/119,
     /* 179868 */     GIR_MakeTempReg, /*TempRegID*/117, /*TypeID*/GILLT_s32,
     /* 179871 */     GIR_BuildMI, /*InsnID*/118, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 179875 */     GIR_AddTempRegister, /*InsnID*/118, /*TempRegID*/117, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179880 */     GIR_Copy, /*NewInsnID*/118, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 179884 */     GIR_AddImm8, /*InsnID*/118, /*Imm*/31,
     /* 179887 */     GIR_AddImm8, /*InsnID*/118, /*Imm*/1,
     /* 179890 */     GIR_AddImm8, /*InsnID*/118, /*Imm*/31,
     /* 179893 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/118,
     /* 179895 */     GIR_MakeTempReg, /*TempRegID*/116, /*TypeID*/GILLT_s32,
     /* 179898 */     GIR_BuildMI, /*InsnID*/117, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 179902 */     GIR_AddTempRegister, /*InsnID*/117, /*TempRegID*/116, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179907 */     GIR_AddSimpleTempRegister, /*InsnID*/117, /*TempRegID*/117,
     /* 179910 */     GIR_AddSimpleTempRegister, /*InsnID*/117, /*TempRegID*/118,
     /* 179913 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/117,
     /* 179915 */     GIR_MakeTempReg, /*TempRegID*/115, /*TypeID*/GILLT_s32,
     /* 179918 */     GIR_BuildMI, /*InsnID*/116, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 179922 */     GIR_AddTempRegister, /*InsnID*/116, /*TempRegID*/115, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179927 */     GIR_AddSimpleTempRegister, /*InsnID*/116, /*TempRegID*/116,
     /* 179930 */     GIR_AddSimpleTempRegister, /*InsnID*/116, /*TempRegID*/120,
     /* 179933 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/116,
     /* 179935 */     GIR_MakeTempReg, /*TempRegID*/114, /*TypeID*/GILLT_s32,
     /* 179938 */     GIR_BuildMI, /*InsnID*/115, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 179942 */     GIR_AddTempRegister, /*InsnID*/115, /*TempRegID*/114, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179947 */     GIR_AddSimpleTempRegister, /*InsnID*/115, /*TempRegID*/115,
     /* 179950 */     GIR_AddImm8, /*InsnID*/115, /*Imm*/2,
     /* 179953 */     GIR_AddImm8, /*InsnID*/115, /*Imm*/0,
     /* 179956 */     GIR_AddImm8, /*InsnID*/115, /*Imm*/29,
     /* 179959 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/115,
     /* 179961 */     GIR_MakeTempReg, /*TempRegID*/113, /*TypeID*/GILLT_s32,
     /* 179964 */     GIR_BuildMI, /*InsnID*/114, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 179968 */     GIR_AddTempRegister, /*InsnID*/114, /*TempRegID*/113, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179973 */     GIR_AddSimpleTempRegister, /*InsnID*/114, /*TempRegID*/114,
     /* 179976 */     GIR_AddSimpleTempRegister, /*InsnID*/114, /*TempRegID*/124,
     /* 179979 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/114,
     /* 179981 */     GIR_MakeTempReg, /*TempRegID*/112, /*TypeID*/GILLT_s32,
     /* 179984 */     GIR_BuildMI, /*InsnID*/113, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 179988 */     GIR_AddTempRegister, /*InsnID*/113, /*TempRegID*/112, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179993 */     GIR_AddImm, /*InsnID*/113, /*Imm*/GIMT_Encode8(13107),
     /* 180003 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/113,
     /* 180005 */     GIR_MakeTempReg, /*TempRegID*/111, /*TypeID*/GILLT_s32,
     /* 180008 */     GIR_BuildMI, /*InsnID*/112, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 180012 */     GIR_AddTempRegister, /*InsnID*/112, /*TempRegID*/111, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180017 */     GIR_AddSimpleTempRegister, /*InsnID*/112, /*TempRegID*/112,
     /* 180020 */     GIR_AddImm, /*InsnID*/112, /*Imm*/GIMT_Encode8(13107),
     /* 180030 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/112,
     /* 180032 */     GIR_MakeTempReg, /*TempRegID*/110, /*TypeID*/GILLT_s32,
     /* 180035 */     GIR_BuildMI, /*InsnID*/111, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 180039 */     GIR_AddTempRegister, /*InsnID*/111, /*TempRegID*/110, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180044 */     GIR_AddImm, /*InsnID*/111, /*Imm*/GIMT_Encode8(43690),
     /* 180054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/111,
     /* 180056 */     GIR_MakeTempReg, /*TempRegID*/109, /*TypeID*/GILLT_s32,
     /* 180059 */     GIR_BuildMI, /*InsnID*/110, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 180063 */     GIR_AddTempRegister, /*InsnID*/110, /*TempRegID*/109, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180068 */     GIR_AddSimpleTempRegister, /*InsnID*/110, /*TempRegID*/110,
     /* 180071 */     GIR_AddImm, /*InsnID*/110, /*Imm*/GIMT_Encode8(43690),
     /* 180081 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/110,
     /* 180083 */     GIR_MakeTempReg, /*TempRegID*/108, /*TypeID*/GILLT_s32,
     /* 180086 */     GIR_BuildMI, /*InsnID*/109, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 180090 */     GIR_AddTempRegister, /*InsnID*/109, /*TempRegID*/108, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180095 */     GIR_Copy, /*NewInsnID*/109, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 180099 */     GIR_AddImm8, /*InsnID*/109, /*Imm*/1,
     /* 180102 */     GIR_AddImm8, /*InsnID*/109, /*Imm*/0,
     /* 180105 */     GIR_AddImm8, /*InsnID*/109, /*Imm*/30,
     /* 180108 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/109,
     /* 180110 */     GIR_MakeTempReg, /*TempRegID*/107, /*TypeID*/GILLT_s32,
     /* 180113 */     GIR_BuildMI, /*InsnID*/108, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 180117 */     GIR_AddTempRegister, /*InsnID*/108, /*TempRegID*/107, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180122 */     GIR_AddSimpleTempRegister, /*InsnID*/108, /*TempRegID*/108,
     /* 180125 */     GIR_AddSimpleTempRegister, /*InsnID*/108, /*TempRegID*/109,
     /* 180128 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/108,
     /* 180130 */     GIR_MakeTempReg, /*TempRegID*/106, /*TypeID*/GILLT_s32,
     /* 180133 */     GIR_BuildMI, /*InsnID*/107, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 180137 */     GIR_AddTempRegister, /*InsnID*/107, /*TempRegID*/106, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180142 */     GIR_AddImm, /*InsnID*/107, /*Imm*/GIMT_Encode8(21845),
     /* 180152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/107,
     /* 180154 */     GIR_MakeTempReg, /*TempRegID*/105, /*TypeID*/GILLT_s32,
     /* 180157 */     GIR_BuildMI, /*InsnID*/106, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 180161 */     GIR_AddTempRegister, /*InsnID*/106, /*TempRegID*/105, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180166 */     GIR_AddSimpleTempRegister, /*InsnID*/106, /*TempRegID*/106,
     /* 180169 */     GIR_AddImm, /*InsnID*/106, /*Imm*/GIMT_Encode8(21845),
     /* 180179 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/106,
     /* 180181 */     GIR_MakeTempReg, /*TempRegID*/104, /*TypeID*/GILLT_s32,
     /* 180184 */     GIR_BuildMI, /*InsnID*/105, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 180188 */     GIR_AddTempRegister, /*InsnID*/105, /*TempRegID*/104, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180193 */     GIR_Copy, /*NewInsnID*/105, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 180197 */     GIR_AddImm8, /*InsnID*/105, /*Imm*/31,
     /* 180200 */     GIR_AddImm8, /*InsnID*/105, /*Imm*/1,
     /* 180203 */     GIR_AddImm8, /*InsnID*/105, /*Imm*/31,
     /* 180206 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/105,
     /* 180208 */     GIR_MakeTempReg, /*TempRegID*/103, /*TypeID*/GILLT_s32,
     /* 180211 */     GIR_BuildMI, /*InsnID*/104, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 180215 */     GIR_AddTempRegister, /*InsnID*/104, /*TempRegID*/103, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180220 */     GIR_AddSimpleTempRegister, /*InsnID*/104, /*TempRegID*/104,
     /* 180223 */     GIR_AddSimpleTempRegister, /*InsnID*/104, /*TempRegID*/105,
     /* 180226 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/104,
     /* 180228 */     GIR_MakeTempReg, /*TempRegID*/102, /*TypeID*/GILLT_s32,
     /* 180231 */     GIR_BuildMI, /*InsnID*/103, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 180235 */     GIR_AddTempRegister, /*InsnID*/103, /*TempRegID*/102, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180240 */     GIR_AddSimpleTempRegister, /*InsnID*/103, /*TempRegID*/103,
     /* 180243 */     GIR_AddSimpleTempRegister, /*InsnID*/103, /*TempRegID*/107,
     /* 180246 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/103,
     /* 180248 */     GIR_MakeTempReg, /*TempRegID*/101, /*TypeID*/GILLT_s32,
     /* 180251 */     GIR_BuildMI, /*InsnID*/102, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 180255 */     GIR_AddTempRegister, /*InsnID*/102, /*TempRegID*/101, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180260 */     GIR_AddSimpleTempRegister, /*InsnID*/102, /*TempRegID*/102,
     /* 180263 */     GIR_AddImm8, /*InsnID*/102, /*Imm*/30,
     /* 180266 */     GIR_AddImm8, /*InsnID*/102, /*Imm*/2,
     /* 180269 */     GIR_AddImm8, /*InsnID*/102, /*Imm*/31,
     /* 180272 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/102,
     /* 180274 */     GIR_MakeTempReg, /*TempRegID*/100, /*TypeID*/GILLT_s32,
     /* 180277 */     GIR_BuildMI, /*InsnID*/101, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 180281 */     GIR_AddTempRegister, /*InsnID*/101, /*TempRegID*/100, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180286 */     GIR_AddSimpleTempRegister, /*InsnID*/101, /*TempRegID*/101,
     /* 180289 */     GIR_AddSimpleTempRegister, /*InsnID*/101, /*TempRegID*/111,
     /* 180292 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/101,
     /* 180294 */     GIR_MakeTempReg, /*TempRegID*/99, /*TypeID*/GILLT_s32,
     /* 180297 */     GIR_BuildMI, /*InsnID*/100, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 180301 */     GIR_AddTempRegister, /*InsnID*/100, /*TempRegID*/99, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180306 */     GIR_AddSimpleTempRegister, /*InsnID*/100, /*TempRegID*/100,
     /* 180309 */     GIR_AddSimpleTempRegister, /*InsnID*/100, /*TempRegID*/113,
     /* 180312 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/100,
     /* 180314 */     GIR_MakeTempReg, /*TempRegID*/98, /*TypeID*/GILLT_s32,
     /* 180317 */     GIR_BuildMI, /*InsnID*/99, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 180321 */     GIR_AddTempRegister, /*InsnID*/99, /*TempRegID*/98, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180326 */     GIR_AddSimpleTempRegister, /*InsnID*/99, /*TempRegID*/99,
     /* 180329 */     GIR_AddImm8, /*InsnID*/99, /*Imm*/4,
     /* 180332 */     GIR_AddImm8, /*InsnID*/99, /*Imm*/0,
     /* 180335 */     GIR_AddImm8, /*InsnID*/99, /*Imm*/27,
     /* 180338 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/99,
     /* 180340 */     GIR_MakeTempReg, /*TempRegID*/97, /*TypeID*/GILLT_s32,
     /* 180343 */     GIR_BuildMI, /*InsnID*/98, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 180347 */     GIR_AddTempRegister, /*InsnID*/98, /*TempRegID*/97, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180352 */     GIR_AddSimpleTempRegister, /*InsnID*/98, /*TempRegID*/98,
     /* 180355 */     GIR_AddSimpleTempRegister, /*InsnID*/98, /*TempRegID*/126,
     /* 180358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/98,
     /* 180360 */     GIR_MakeTempReg, /*TempRegID*/96, /*TypeID*/GILLT_s32,
     /* 180363 */     GIR_BuildMI, /*InsnID*/97, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 180367 */     GIR_AddTempRegister, /*InsnID*/97, /*TempRegID*/96, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180372 */     GIR_AddImm, /*InsnID*/97, /*Imm*/GIMT_Encode8(3855),
     /* 180382 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/97,
     /* 180384 */     GIR_MakeTempReg, /*TempRegID*/95, /*TypeID*/GILLT_s32,
     /* 180387 */     GIR_BuildMI, /*InsnID*/96, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 180391 */     GIR_AddTempRegister, /*InsnID*/96, /*TempRegID*/95, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180396 */     GIR_AddSimpleTempRegister, /*InsnID*/96, /*TempRegID*/96,
     /* 180399 */     GIR_AddImm, /*InsnID*/96, /*Imm*/GIMT_Encode8(3855),
     /* 180409 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/96,
     /* 180411 */     GIR_MakeTempReg, /*TempRegID*/94, /*TypeID*/GILLT_s32,
     /* 180414 */     GIR_BuildMI, /*InsnID*/95, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 180418 */     GIR_AddTempRegister, /*InsnID*/95, /*TempRegID*/94, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180423 */     GIR_AddImm, /*InsnID*/95, /*Imm*/GIMT_Encode8(52428),
     /* 180433 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/95,
     /* 180435 */     GIR_MakeTempReg, /*TempRegID*/93, /*TypeID*/GILLT_s32,
     /* 180438 */     GIR_BuildMI, /*InsnID*/94, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 180442 */     GIR_AddTempRegister, /*InsnID*/94, /*TempRegID*/93, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180447 */     GIR_AddSimpleTempRegister, /*InsnID*/94, /*TempRegID*/94,
     /* 180450 */     GIR_AddImm, /*InsnID*/94, /*Imm*/GIMT_Encode8(52428),
     /* 180460 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/94,
     /* 180462 */     GIR_MakeTempReg, /*TempRegID*/92, /*TypeID*/GILLT_s32,
     /* 180465 */     GIR_BuildMI, /*InsnID*/93, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 180469 */     GIR_AddTempRegister, /*InsnID*/93, /*TempRegID*/92, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180474 */     GIR_AddImm, /*InsnID*/93, /*Imm*/GIMT_Encode8(43690),
     /* 180484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/93,
     /* 180486 */     GIR_MakeTempReg, /*TempRegID*/91, /*TypeID*/GILLT_s32,
     /* 180489 */     GIR_BuildMI, /*InsnID*/92, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 180493 */     GIR_AddTempRegister, /*InsnID*/92, /*TempRegID*/91, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180498 */     GIR_AddSimpleTempRegister, /*InsnID*/92, /*TempRegID*/92,
     /* 180501 */     GIR_AddImm, /*InsnID*/92, /*Imm*/GIMT_Encode8(43690),
     /* 180511 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/92,
     /* 180513 */     GIR_MakeTempReg, /*TempRegID*/90, /*TypeID*/GILLT_s32,
     /* 180516 */     GIR_BuildMI, /*InsnID*/91, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 180520 */     GIR_AddTempRegister, /*InsnID*/91, /*TempRegID*/90, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180525 */     GIR_Copy, /*NewInsnID*/91, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 180529 */     GIR_AddImm8, /*InsnID*/91, /*Imm*/1,
     /* 180532 */     GIR_AddImm8, /*InsnID*/91, /*Imm*/0,
     /* 180535 */     GIR_AddImm8, /*InsnID*/91, /*Imm*/30,
     /* 180538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/91,
     /* 180540 */     GIR_MakeTempReg, /*TempRegID*/89, /*TypeID*/GILLT_s32,
     /* 180543 */     GIR_BuildMI, /*InsnID*/90, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 180547 */     GIR_AddTempRegister, /*InsnID*/90, /*TempRegID*/89, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180552 */     GIR_AddSimpleTempRegister, /*InsnID*/90, /*TempRegID*/90,
     /* 180555 */     GIR_AddSimpleTempRegister, /*InsnID*/90, /*TempRegID*/91,
     /* 180558 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/90,
     /* 180560 */     GIR_MakeTempReg, /*TempRegID*/88, /*TypeID*/GILLT_s32,
     /* 180563 */     GIR_BuildMI, /*InsnID*/89, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 180567 */     GIR_AddTempRegister, /*InsnID*/89, /*TempRegID*/88, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180572 */     GIR_AddImm, /*InsnID*/89, /*Imm*/GIMT_Encode8(21845),
     /* 180582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/89,
     /* 180584 */     GIR_MakeTempReg, /*TempRegID*/87, /*TypeID*/GILLT_s32,
     /* 180587 */     GIR_BuildMI, /*InsnID*/88, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 180591 */     GIR_AddTempRegister, /*InsnID*/88, /*TempRegID*/87, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180596 */     GIR_AddSimpleTempRegister, /*InsnID*/88, /*TempRegID*/88,
     /* 180599 */     GIR_AddImm, /*InsnID*/88, /*Imm*/GIMT_Encode8(21845),
     /* 180609 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/88,
     /* 180611 */     GIR_MakeTempReg, /*TempRegID*/86, /*TypeID*/GILLT_s32,
     /* 180614 */     GIR_BuildMI, /*InsnID*/87, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 180618 */     GIR_AddTempRegister, /*InsnID*/87, /*TempRegID*/86, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180623 */     GIR_Copy, /*NewInsnID*/87, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 180627 */     GIR_AddImm8, /*InsnID*/87, /*Imm*/31,
     /* 180630 */     GIR_AddImm8, /*InsnID*/87, /*Imm*/1,
     /* 180633 */     GIR_AddImm8, /*InsnID*/87, /*Imm*/31,
     /* 180636 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/87,
     /* 180638 */     GIR_MakeTempReg, /*TempRegID*/85, /*TypeID*/GILLT_s32,
     /* 180641 */     GIR_BuildMI, /*InsnID*/86, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 180645 */     GIR_AddTempRegister, /*InsnID*/86, /*TempRegID*/85, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180650 */     GIR_AddSimpleTempRegister, /*InsnID*/86, /*TempRegID*/86,
     /* 180653 */     GIR_AddSimpleTempRegister, /*InsnID*/86, /*TempRegID*/87,
     /* 180656 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/86,
     /* 180658 */     GIR_MakeTempReg, /*TempRegID*/84, /*TypeID*/GILLT_s32,
     /* 180661 */     GIR_BuildMI, /*InsnID*/85, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 180665 */     GIR_AddTempRegister, /*InsnID*/85, /*TempRegID*/84, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180670 */     GIR_AddSimpleTempRegister, /*InsnID*/85, /*TempRegID*/85,
     /* 180673 */     GIR_AddSimpleTempRegister, /*InsnID*/85, /*TempRegID*/89,
     /* 180676 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/85,
     /* 180678 */     GIR_MakeTempReg, /*TempRegID*/83, /*TypeID*/GILLT_s32,
     /* 180681 */     GIR_BuildMI, /*InsnID*/84, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 180685 */     GIR_AddTempRegister, /*InsnID*/84, /*TempRegID*/83, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180690 */     GIR_AddSimpleTempRegister, /*InsnID*/84, /*TempRegID*/84,
     /* 180693 */     GIR_AddImm8, /*InsnID*/84, /*Imm*/2,
     /* 180696 */     GIR_AddImm8, /*InsnID*/84, /*Imm*/0,
     /* 180699 */     GIR_AddImm8, /*InsnID*/84, /*Imm*/29,
     /* 180702 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/84,
     /* 180704 */     GIR_MakeTempReg, /*TempRegID*/82, /*TypeID*/GILLT_s32,
     /* 180707 */     GIR_BuildMI, /*InsnID*/83, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 180711 */     GIR_AddTempRegister, /*InsnID*/83, /*TempRegID*/82, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180716 */     GIR_AddSimpleTempRegister, /*InsnID*/83, /*TempRegID*/83,
     /* 180719 */     GIR_AddSimpleTempRegister, /*InsnID*/83, /*TempRegID*/93,
     /* 180722 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/83,
     /* 180724 */     GIR_MakeTempReg, /*TempRegID*/81, /*TypeID*/GILLT_s32,
     /* 180727 */     GIR_BuildMI, /*InsnID*/82, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 180731 */     GIR_AddTempRegister, /*InsnID*/82, /*TempRegID*/81, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180736 */     GIR_AddImm, /*InsnID*/82, /*Imm*/GIMT_Encode8(13107),
     /* 180746 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/82,
     /* 180748 */     GIR_MakeTempReg, /*TempRegID*/80, /*TypeID*/GILLT_s32,
     /* 180751 */     GIR_BuildMI, /*InsnID*/81, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 180755 */     GIR_AddTempRegister, /*InsnID*/81, /*TempRegID*/80, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180760 */     GIR_AddSimpleTempRegister, /*InsnID*/81, /*TempRegID*/81,
     /* 180763 */     GIR_AddImm, /*InsnID*/81, /*Imm*/GIMT_Encode8(13107),
     /* 180773 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/81,
     /* 180775 */     GIR_MakeTempReg, /*TempRegID*/79, /*TypeID*/GILLT_s32,
     /* 180778 */     GIR_BuildMI, /*InsnID*/80, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 180782 */     GIR_AddTempRegister, /*InsnID*/80, /*TempRegID*/79, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180787 */     GIR_AddImm, /*InsnID*/80, /*Imm*/GIMT_Encode8(43690),
     /* 180797 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/80,
     /* 180799 */     GIR_MakeTempReg, /*TempRegID*/78, /*TypeID*/GILLT_s32,
     /* 180802 */     GIR_BuildMI, /*InsnID*/79, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 180806 */     GIR_AddTempRegister, /*InsnID*/79, /*TempRegID*/78, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180811 */     GIR_AddSimpleTempRegister, /*InsnID*/79, /*TempRegID*/79,
     /* 180814 */     GIR_AddImm, /*InsnID*/79, /*Imm*/GIMT_Encode8(43690),
     /* 180824 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/79,
     /* 180826 */     GIR_MakeTempReg, /*TempRegID*/77, /*TypeID*/GILLT_s32,
     /* 180829 */     GIR_BuildMI, /*InsnID*/78, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 180833 */     GIR_AddTempRegister, /*InsnID*/78, /*TempRegID*/77, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180838 */     GIR_Copy, /*NewInsnID*/78, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 180842 */     GIR_AddImm8, /*InsnID*/78, /*Imm*/1,
     /* 180845 */     GIR_AddImm8, /*InsnID*/78, /*Imm*/0,
     /* 180848 */     GIR_AddImm8, /*InsnID*/78, /*Imm*/30,
     /* 180851 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/78,
     /* 180853 */     GIR_MakeTempReg, /*TempRegID*/76, /*TypeID*/GILLT_s32,
     /* 180856 */     GIR_BuildMI, /*InsnID*/77, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 180860 */     GIR_AddTempRegister, /*InsnID*/77, /*TempRegID*/76, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180865 */     GIR_AddSimpleTempRegister, /*InsnID*/77, /*TempRegID*/77,
     /* 180868 */     GIR_AddSimpleTempRegister, /*InsnID*/77, /*TempRegID*/78,
     /* 180871 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/77,
     /* 180873 */     GIR_MakeTempReg, /*TempRegID*/75, /*TypeID*/GILLT_s32,
     /* 180876 */     GIR_BuildMI, /*InsnID*/76, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 180880 */     GIR_AddTempRegister, /*InsnID*/76, /*TempRegID*/75, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180885 */     GIR_AddImm, /*InsnID*/76, /*Imm*/GIMT_Encode8(21845),
     /* 180895 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/76,
     /* 180897 */     GIR_MakeTempReg, /*TempRegID*/74, /*TypeID*/GILLT_s32,
     /* 180900 */     GIR_BuildMI, /*InsnID*/75, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 180904 */     GIR_AddTempRegister, /*InsnID*/75, /*TempRegID*/74, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180909 */     GIR_AddSimpleTempRegister, /*InsnID*/75, /*TempRegID*/75,
     /* 180912 */     GIR_AddImm, /*InsnID*/75, /*Imm*/GIMT_Encode8(21845),
     /* 180922 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/75,
     /* 180924 */     GIR_MakeTempReg, /*TempRegID*/73, /*TypeID*/GILLT_s32,
     /* 180927 */     GIR_BuildMI, /*InsnID*/74, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 180931 */     GIR_AddTempRegister, /*InsnID*/74, /*TempRegID*/73, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180936 */     GIR_Copy, /*NewInsnID*/74, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 180940 */     GIR_AddImm8, /*InsnID*/74, /*Imm*/31,
     /* 180943 */     GIR_AddImm8, /*InsnID*/74, /*Imm*/1,
     /* 180946 */     GIR_AddImm8, /*InsnID*/74, /*Imm*/31,
     /* 180949 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/74,
     /* 180951 */     GIR_MakeTempReg, /*TempRegID*/72, /*TypeID*/GILLT_s32,
     /* 180954 */     GIR_BuildMI, /*InsnID*/73, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 180958 */     GIR_AddTempRegister, /*InsnID*/73, /*TempRegID*/72, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180963 */     GIR_AddSimpleTempRegister, /*InsnID*/73, /*TempRegID*/73,
     /* 180966 */     GIR_AddSimpleTempRegister, /*InsnID*/73, /*TempRegID*/74,
     /* 180969 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/73,
     /* 180971 */     GIR_MakeTempReg, /*TempRegID*/71, /*TypeID*/GILLT_s32,
     /* 180974 */     GIR_BuildMI, /*InsnID*/72, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 180978 */     GIR_AddTempRegister, /*InsnID*/72, /*TempRegID*/71, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180983 */     GIR_AddSimpleTempRegister, /*InsnID*/72, /*TempRegID*/72,
     /* 180986 */     GIR_AddSimpleTempRegister, /*InsnID*/72, /*TempRegID*/76,
     /* 180989 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/72,
     /* 180991 */     GIR_MakeTempReg, /*TempRegID*/70, /*TypeID*/GILLT_s32,
     /* 180994 */     GIR_BuildMI, /*InsnID*/71, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 180998 */     GIR_AddTempRegister, /*InsnID*/71, /*TempRegID*/70, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181003 */     GIR_AddSimpleTempRegister, /*InsnID*/71, /*TempRegID*/71,
     /* 181006 */     GIR_AddImm8, /*InsnID*/71, /*Imm*/30,
     /* 181009 */     GIR_AddImm8, /*InsnID*/71, /*Imm*/2,
     /* 181012 */     GIR_AddImm8, /*InsnID*/71, /*Imm*/31,
     /* 181015 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/71,
     /* 181017 */     GIR_MakeTempReg, /*TempRegID*/69, /*TypeID*/GILLT_s32,
     /* 181020 */     GIR_BuildMI, /*InsnID*/70, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 181024 */     GIR_AddTempRegister, /*InsnID*/70, /*TempRegID*/69, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181029 */     GIR_AddSimpleTempRegister, /*InsnID*/70, /*TempRegID*/70,
     /* 181032 */     GIR_AddSimpleTempRegister, /*InsnID*/70, /*TempRegID*/80,
     /* 181035 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/70,
     /* 181037 */     GIR_MakeTempReg, /*TempRegID*/68, /*TypeID*/GILLT_s32,
     /* 181040 */     GIR_BuildMI, /*InsnID*/69, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 181044 */     GIR_AddTempRegister, /*InsnID*/69, /*TempRegID*/68, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181049 */     GIR_AddSimpleTempRegister, /*InsnID*/69, /*TempRegID*/69,
     /* 181052 */     GIR_AddSimpleTempRegister, /*InsnID*/69, /*TempRegID*/82,
     /* 181055 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/69,
     /* 181057 */     GIR_MakeTempReg, /*TempRegID*/67, /*TypeID*/GILLT_s32,
     /* 181060 */     GIR_BuildMI, /*InsnID*/68, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 181064 */     GIR_AddTempRegister, /*InsnID*/68, /*TempRegID*/67, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181069 */     GIR_AddSimpleTempRegister, /*InsnID*/68, /*TempRegID*/68,
     /* 181072 */     GIR_AddImm8, /*InsnID*/68, /*Imm*/28,
     /* 181075 */     GIR_AddImm8, /*InsnID*/68, /*Imm*/4,
     /* 181078 */     GIR_AddImm8, /*InsnID*/68, /*Imm*/31,
     /* 181081 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/68,
     /* 181083 */     GIR_MakeTempReg, /*TempRegID*/66, /*TypeID*/GILLT_s32,
     /* 181086 */     GIR_BuildMI, /*InsnID*/67, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 181090 */     GIR_AddTempRegister, /*InsnID*/67, /*TempRegID*/66, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181095 */     GIR_AddSimpleTempRegister, /*InsnID*/67, /*TempRegID*/67,
     /* 181098 */     GIR_AddSimpleTempRegister, /*InsnID*/67, /*TempRegID*/95,
     /* 181101 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/67,
     /* 181103 */     GIR_MakeTempReg, /*TempRegID*/65, /*TypeID*/GILLT_s32,
     /* 181106 */     GIR_BuildMI, /*InsnID*/66, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 181110 */     GIR_AddTempRegister, /*InsnID*/66, /*TempRegID*/65, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181115 */     GIR_AddSimpleTempRegister, /*InsnID*/66, /*TempRegID*/66,
     /* 181118 */     GIR_AddSimpleTempRegister, /*InsnID*/66, /*TempRegID*/97,
     /* 181121 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/66,
     /* 181123 */     GIR_MakeTempReg, /*TempRegID*/64, /*TypeID*/GILLT_s32,
     /* 181126 */     GIR_BuildMI, /*InsnID*/65, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 181130 */     GIR_AddTempRegister, /*InsnID*/65, /*TempRegID*/64, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181135 */     GIR_AddImm, /*InsnID*/65, /*Imm*/GIMT_Encode8(61680),
     /* 181145 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/65,
     /* 181147 */     GIR_MakeTempReg, /*TempRegID*/63, /*TypeID*/GILLT_s32,
     /* 181150 */     GIR_BuildMI, /*InsnID*/64, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 181154 */     GIR_AddTempRegister, /*InsnID*/64, /*TempRegID*/63, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181159 */     GIR_AddSimpleTempRegister, /*InsnID*/64, /*TempRegID*/64,
     /* 181162 */     GIR_AddImm, /*InsnID*/64, /*Imm*/GIMT_Encode8(61680),
     /* 181172 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/64,
     /* 181174 */     GIR_MakeTempReg, /*TempRegID*/62, /*TypeID*/GILLT_s32,
     /* 181177 */     GIR_BuildMI, /*InsnID*/63, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 181181 */     GIR_AddTempRegister, /*InsnID*/63, /*TempRegID*/62, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181186 */     GIR_AddImm, /*InsnID*/63, /*Imm*/GIMT_Encode8(52428),
     /* 181196 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/63,
     /* 181198 */     GIR_MakeTempReg, /*TempRegID*/61, /*TypeID*/GILLT_s32,
     /* 181201 */     GIR_BuildMI, /*InsnID*/62, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 181205 */     GIR_AddTempRegister, /*InsnID*/62, /*TempRegID*/61, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181210 */     GIR_AddSimpleTempRegister, /*InsnID*/62, /*TempRegID*/62,
     /* 181213 */     GIR_AddImm, /*InsnID*/62, /*Imm*/GIMT_Encode8(52428),
     /* 181223 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/62,
     /* 181225 */     GIR_MakeTempReg, /*TempRegID*/60, /*TypeID*/GILLT_s32,
     /* 181228 */     GIR_BuildMI, /*InsnID*/61, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 181232 */     GIR_AddTempRegister, /*InsnID*/61, /*TempRegID*/60, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181237 */     GIR_AddImm, /*InsnID*/61, /*Imm*/GIMT_Encode8(43690),
     /* 181247 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/61,
     /* 181249 */     GIR_MakeTempReg, /*TempRegID*/59, /*TypeID*/GILLT_s32,
     /* 181252 */     GIR_BuildMI, /*InsnID*/60, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 181256 */     GIR_AddTempRegister, /*InsnID*/60, /*TempRegID*/59, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181261 */     GIR_AddSimpleTempRegister, /*InsnID*/60, /*TempRegID*/60,
     /* 181264 */     GIR_AddImm, /*InsnID*/60, /*Imm*/GIMT_Encode8(43690),
     /* 181274 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/60,
     /* 181276 */     GIR_MakeTempReg, /*TempRegID*/58, /*TypeID*/GILLT_s32,
     /* 181279 */     GIR_BuildMI, /*InsnID*/59, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 181283 */     GIR_AddTempRegister, /*InsnID*/59, /*TempRegID*/58, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181288 */     GIR_Copy, /*NewInsnID*/59, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 181292 */     GIR_AddImm8, /*InsnID*/59, /*Imm*/1,
     /* 181295 */     GIR_AddImm8, /*InsnID*/59, /*Imm*/0,
     /* 181298 */     GIR_AddImm8, /*InsnID*/59, /*Imm*/30,
     /* 181301 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/59,
     /* 181303 */     GIR_MakeTempReg, /*TempRegID*/57, /*TypeID*/GILLT_s32,
     /* 181306 */     GIR_BuildMI, /*InsnID*/58, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 181310 */     GIR_AddTempRegister, /*InsnID*/58, /*TempRegID*/57, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181315 */     GIR_AddSimpleTempRegister, /*InsnID*/58, /*TempRegID*/58,
     /* 181318 */     GIR_AddSimpleTempRegister, /*InsnID*/58, /*TempRegID*/59,
     /* 181321 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/58,
     /* 181323 */     GIR_MakeTempReg, /*TempRegID*/56, /*TypeID*/GILLT_s32,
     /* 181326 */     GIR_BuildMI, /*InsnID*/57, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 181330 */     GIR_AddTempRegister, /*InsnID*/57, /*TempRegID*/56, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181335 */     GIR_AddImm, /*InsnID*/57, /*Imm*/GIMT_Encode8(21845),
     /* 181345 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/57,
     /* 181347 */     GIR_MakeTempReg, /*TempRegID*/55, /*TypeID*/GILLT_s32,
     /* 181350 */     GIR_BuildMI, /*InsnID*/56, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 181354 */     GIR_AddTempRegister, /*InsnID*/56, /*TempRegID*/55, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181359 */     GIR_AddSimpleTempRegister, /*InsnID*/56, /*TempRegID*/56,
     /* 181362 */     GIR_AddImm, /*InsnID*/56, /*Imm*/GIMT_Encode8(21845),
     /* 181372 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/56,
     /* 181374 */     GIR_MakeTempReg, /*TempRegID*/54, /*TypeID*/GILLT_s32,
     /* 181377 */     GIR_BuildMI, /*InsnID*/55, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 181381 */     GIR_AddTempRegister, /*InsnID*/55, /*TempRegID*/54, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181386 */     GIR_Copy, /*NewInsnID*/55, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 181390 */     GIR_AddImm8, /*InsnID*/55, /*Imm*/31,
     /* 181393 */     GIR_AddImm8, /*InsnID*/55, /*Imm*/1,
     /* 181396 */     GIR_AddImm8, /*InsnID*/55, /*Imm*/31,
     /* 181399 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/55,
     /* 181401 */     GIR_MakeTempReg, /*TempRegID*/53, /*TypeID*/GILLT_s32,
     /* 181404 */     GIR_BuildMI, /*InsnID*/54, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 181408 */     GIR_AddTempRegister, /*InsnID*/54, /*TempRegID*/53, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181413 */     GIR_AddSimpleTempRegister, /*InsnID*/54, /*TempRegID*/54,
     /* 181416 */     GIR_AddSimpleTempRegister, /*InsnID*/54, /*TempRegID*/55,
     /* 181419 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/54,
     /* 181421 */     GIR_MakeTempReg, /*TempRegID*/52, /*TypeID*/GILLT_s32,
     /* 181424 */     GIR_BuildMI, /*InsnID*/53, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 181428 */     GIR_AddTempRegister, /*InsnID*/53, /*TempRegID*/52, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181433 */     GIR_AddSimpleTempRegister, /*InsnID*/53, /*TempRegID*/53,
     /* 181436 */     GIR_AddSimpleTempRegister, /*InsnID*/53, /*TempRegID*/57,
     /* 181439 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/53,
     /* 181441 */     GIR_MakeTempReg, /*TempRegID*/51, /*TypeID*/GILLT_s32,
     /* 181444 */     GIR_BuildMI, /*InsnID*/52, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 181448 */     GIR_AddTempRegister, /*InsnID*/52, /*TempRegID*/51, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181453 */     GIR_AddSimpleTempRegister, /*InsnID*/52, /*TempRegID*/52,
     /* 181456 */     GIR_AddImm8, /*InsnID*/52, /*Imm*/2,
     /* 181459 */     GIR_AddImm8, /*InsnID*/52, /*Imm*/0,
     /* 181462 */     GIR_AddImm8, /*InsnID*/52, /*Imm*/29,
     /* 181465 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/52,
     /* 181467 */     GIR_MakeTempReg, /*TempRegID*/50, /*TypeID*/GILLT_s32,
     /* 181470 */     GIR_BuildMI, /*InsnID*/51, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 181474 */     GIR_AddTempRegister, /*InsnID*/51, /*TempRegID*/50, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181479 */     GIR_AddSimpleTempRegister, /*InsnID*/51, /*TempRegID*/51,
     /* 181482 */     GIR_AddSimpleTempRegister, /*InsnID*/51, /*TempRegID*/61,
     /* 181485 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/51,
     /* 181487 */     GIR_MakeTempReg, /*TempRegID*/49, /*TypeID*/GILLT_s32,
     /* 181490 */     GIR_BuildMI, /*InsnID*/50, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 181494 */     GIR_AddTempRegister, /*InsnID*/50, /*TempRegID*/49, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181499 */     GIR_AddImm, /*InsnID*/50, /*Imm*/GIMT_Encode8(13107),
     /* 181509 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/50,
     /* 181511 */     GIR_MakeTempReg, /*TempRegID*/48, /*TypeID*/GILLT_s32,
     /* 181514 */     GIR_BuildMI, /*InsnID*/49, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 181518 */     GIR_AddTempRegister, /*InsnID*/49, /*TempRegID*/48, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181523 */     GIR_AddSimpleTempRegister, /*InsnID*/49, /*TempRegID*/49,
     /* 181526 */     GIR_AddImm, /*InsnID*/49, /*Imm*/GIMT_Encode8(13107),
     /* 181536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/49,
     /* 181538 */     GIR_MakeTempReg, /*TempRegID*/47, /*TypeID*/GILLT_s32,
     /* 181541 */     GIR_BuildMI, /*InsnID*/48, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 181545 */     GIR_AddTempRegister, /*InsnID*/48, /*TempRegID*/47, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181550 */     GIR_AddImm, /*InsnID*/48, /*Imm*/GIMT_Encode8(43690),
     /* 181560 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/48,
     /* 181562 */     GIR_MakeTempReg, /*TempRegID*/46, /*TypeID*/GILLT_s32,
     /* 181565 */     GIR_BuildMI, /*InsnID*/47, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 181569 */     GIR_AddTempRegister, /*InsnID*/47, /*TempRegID*/46, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181574 */     GIR_AddSimpleTempRegister, /*InsnID*/47, /*TempRegID*/47,
     /* 181577 */     GIR_AddImm, /*InsnID*/47, /*Imm*/GIMT_Encode8(43690),
     /* 181587 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/47,
     /* 181589 */     GIR_MakeTempReg, /*TempRegID*/45, /*TypeID*/GILLT_s32,
     /* 181592 */     GIR_BuildMI, /*InsnID*/46, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 181596 */     GIR_AddTempRegister, /*InsnID*/46, /*TempRegID*/45, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181601 */     GIR_Copy, /*NewInsnID*/46, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 181605 */     GIR_AddImm8, /*InsnID*/46, /*Imm*/1,
     /* 181608 */     GIR_AddImm8, /*InsnID*/46, /*Imm*/0,
     /* 181611 */     GIR_AddImm8, /*InsnID*/46, /*Imm*/30,
     /* 181614 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/46,
     /* 181616 */     GIR_MakeTempReg, /*TempRegID*/44, /*TypeID*/GILLT_s32,
     /* 181619 */     GIR_BuildMI, /*InsnID*/45, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 181623 */     GIR_AddTempRegister, /*InsnID*/45, /*TempRegID*/44, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181628 */     GIR_AddSimpleTempRegister, /*InsnID*/45, /*TempRegID*/45,
     /* 181631 */     GIR_AddSimpleTempRegister, /*InsnID*/45, /*TempRegID*/46,
     /* 181634 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/45,
     /* 181636 */     GIR_MakeTempReg, /*TempRegID*/43, /*TypeID*/GILLT_s32,
     /* 181639 */     GIR_BuildMI, /*InsnID*/44, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 181643 */     GIR_AddTempRegister, /*InsnID*/44, /*TempRegID*/43, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181648 */     GIR_AddImm, /*InsnID*/44, /*Imm*/GIMT_Encode8(21845),
     /* 181658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/44,
     /* 181660 */     GIR_MakeTempReg, /*TempRegID*/42, /*TypeID*/GILLT_s32,
     /* 181663 */     GIR_BuildMI, /*InsnID*/43, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 181667 */     GIR_AddTempRegister, /*InsnID*/43, /*TempRegID*/42, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181672 */     GIR_AddSimpleTempRegister, /*InsnID*/43, /*TempRegID*/43,
     /* 181675 */     GIR_AddImm, /*InsnID*/43, /*Imm*/GIMT_Encode8(21845),
     /* 181685 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/43,
     /* 181687 */     GIR_MakeTempReg, /*TempRegID*/41, /*TypeID*/GILLT_s32,
     /* 181690 */     GIR_BuildMI, /*InsnID*/42, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 181694 */     GIR_AddTempRegister, /*InsnID*/42, /*TempRegID*/41, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181699 */     GIR_Copy, /*NewInsnID*/42, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 181703 */     GIR_AddImm8, /*InsnID*/42, /*Imm*/31,
     /* 181706 */     GIR_AddImm8, /*InsnID*/42, /*Imm*/1,
     /* 181709 */     GIR_AddImm8, /*InsnID*/42, /*Imm*/31,
     /* 181712 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/42,
     /* 181714 */     GIR_MakeTempReg, /*TempRegID*/40, /*TypeID*/GILLT_s32,
     /* 181717 */     GIR_BuildMI, /*InsnID*/41, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 181721 */     GIR_AddTempRegister, /*InsnID*/41, /*TempRegID*/40, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181726 */     GIR_AddSimpleTempRegister, /*InsnID*/41, /*TempRegID*/41,
     /* 181729 */     GIR_AddSimpleTempRegister, /*InsnID*/41, /*TempRegID*/42,
     /* 181732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/41,
     /* 181734 */     GIR_MakeTempReg, /*TempRegID*/39, /*TypeID*/GILLT_s32,
     /* 181737 */     GIR_BuildMI, /*InsnID*/40, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 181741 */     GIR_AddTempRegister, /*InsnID*/40, /*TempRegID*/39, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181746 */     GIR_AddSimpleTempRegister, /*InsnID*/40, /*TempRegID*/40,
     /* 181749 */     GIR_AddSimpleTempRegister, /*InsnID*/40, /*TempRegID*/44,
     /* 181752 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/40,
     /* 181754 */     GIR_MakeTempReg, /*TempRegID*/38, /*TypeID*/GILLT_s32,
     /* 181757 */     GIR_BuildMI, /*InsnID*/39, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 181761 */     GIR_AddTempRegister, /*InsnID*/39, /*TempRegID*/38, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181766 */     GIR_AddSimpleTempRegister, /*InsnID*/39, /*TempRegID*/39,
     /* 181769 */     GIR_AddImm8, /*InsnID*/39, /*Imm*/30,
     /* 181772 */     GIR_AddImm8, /*InsnID*/39, /*Imm*/2,
     /* 181775 */     GIR_AddImm8, /*InsnID*/39, /*Imm*/31,
     /* 181778 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/39,
     /* 181780 */     GIR_MakeTempReg, /*TempRegID*/37, /*TypeID*/GILLT_s32,
     /* 181783 */     GIR_BuildMI, /*InsnID*/38, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 181787 */     GIR_AddTempRegister, /*InsnID*/38, /*TempRegID*/37, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181792 */     GIR_AddSimpleTempRegister, /*InsnID*/38, /*TempRegID*/38,
     /* 181795 */     GIR_AddSimpleTempRegister, /*InsnID*/38, /*TempRegID*/48,
     /* 181798 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/38,
     /* 181800 */     GIR_MakeTempReg, /*TempRegID*/36, /*TypeID*/GILLT_s32,
     /* 181803 */     GIR_BuildMI, /*InsnID*/37, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 181807 */     GIR_AddTempRegister, /*InsnID*/37, /*TempRegID*/36, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181812 */     GIR_AddSimpleTempRegister, /*InsnID*/37, /*TempRegID*/37,
     /* 181815 */     GIR_AddSimpleTempRegister, /*InsnID*/37, /*TempRegID*/50,
     /* 181818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/37,
     /* 181820 */     GIR_MakeTempReg, /*TempRegID*/35, /*TypeID*/GILLT_s32,
     /* 181823 */     GIR_BuildMI, /*InsnID*/36, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 181827 */     GIR_AddTempRegister, /*InsnID*/36, /*TempRegID*/35, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181832 */     GIR_AddSimpleTempRegister, /*InsnID*/36, /*TempRegID*/36,
     /* 181835 */     GIR_AddImm8, /*InsnID*/36, /*Imm*/4,
     /* 181838 */     GIR_AddImm8, /*InsnID*/36, /*Imm*/0,
     /* 181841 */     GIR_AddImm8, /*InsnID*/36, /*Imm*/27,
     /* 181844 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/36,
     /* 181846 */     GIR_MakeTempReg, /*TempRegID*/34, /*TypeID*/GILLT_s32,
     /* 181849 */     GIR_BuildMI, /*InsnID*/35, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 181853 */     GIR_AddTempRegister, /*InsnID*/35, /*TempRegID*/34, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181858 */     GIR_AddSimpleTempRegister, /*InsnID*/35, /*TempRegID*/35,
     /* 181861 */     GIR_AddSimpleTempRegister, /*InsnID*/35, /*TempRegID*/63,
     /* 181864 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/35,
     /* 181866 */     GIR_MakeTempReg, /*TempRegID*/33, /*TypeID*/GILLT_s32,
     /* 181869 */     GIR_BuildMI, /*InsnID*/34, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 181873 */     GIR_AddTempRegister, /*InsnID*/34, /*TempRegID*/33, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181878 */     GIR_AddImm, /*InsnID*/34, /*Imm*/GIMT_Encode8(3855),
     /* 181888 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/34,
     /* 181890 */     GIR_MakeTempReg, /*TempRegID*/32, /*TypeID*/GILLT_s32,
     /* 181893 */     GIR_BuildMI, /*InsnID*/33, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 181897 */     GIR_AddTempRegister, /*InsnID*/33, /*TempRegID*/32, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181902 */     GIR_AddSimpleTempRegister, /*InsnID*/33, /*TempRegID*/33,
     /* 181905 */     GIR_AddImm, /*InsnID*/33, /*Imm*/GIMT_Encode8(3855),
     /* 181915 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/33,
     /* 181917 */     GIR_MakeTempReg, /*TempRegID*/31, /*TypeID*/GILLT_s32,
     /* 181920 */     GIR_BuildMI, /*InsnID*/32, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 181924 */     GIR_AddTempRegister, /*InsnID*/32, /*TempRegID*/31, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181929 */     GIR_AddImm, /*InsnID*/32, /*Imm*/GIMT_Encode8(52428),
     /* 181939 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/32,
     /* 181941 */     GIR_MakeTempReg, /*TempRegID*/30, /*TypeID*/GILLT_s32,
     /* 181944 */     GIR_BuildMI, /*InsnID*/31, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 181948 */     GIR_AddTempRegister, /*InsnID*/31, /*TempRegID*/30, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181953 */     GIR_AddSimpleTempRegister, /*InsnID*/31, /*TempRegID*/31,
     /* 181956 */     GIR_AddImm, /*InsnID*/31, /*Imm*/GIMT_Encode8(52428),
     /* 181966 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/31,
     /* 181968 */     GIR_MakeTempReg, /*TempRegID*/29, /*TypeID*/GILLT_s32,
     /* 181971 */     GIR_BuildMI, /*InsnID*/30, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 181975 */     GIR_AddTempRegister, /*InsnID*/30, /*TempRegID*/29, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181980 */     GIR_AddImm, /*InsnID*/30, /*Imm*/GIMT_Encode8(43690),
     /* 181990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/30,
     /* 181992 */     GIR_MakeTempReg, /*TempRegID*/28, /*TypeID*/GILLT_s32,
     /* 181995 */     GIR_BuildMI, /*InsnID*/29, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 181999 */     GIR_AddTempRegister, /*InsnID*/29, /*TempRegID*/28, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182004 */     GIR_AddSimpleTempRegister, /*InsnID*/29, /*TempRegID*/29,
     /* 182007 */     GIR_AddImm, /*InsnID*/29, /*Imm*/GIMT_Encode8(43690),
     /* 182017 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/29,
     /* 182019 */     GIR_MakeTempReg, /*TempRegID*/27, /*TypeID*/GILLT_s32,
     /* 182022 */     GIR_BuildMI, /*InsnID*/28, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 182026 */     GIR_AddTempRegister, /*InsnID*/28, /*TempRegID*/27, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182031 */     GIR_Copy, /*NewInsnID*/28, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 182035 */     GIR_AddImm8, /*InsnID*/28, /*Imm*/1,
     /* 182038 */     GIR_AddImm8, /*InsnID*/28, /*Imm*/0,
     /* 182041 */     GIR_AddImm8, /*InsnID*/28, /*Imm*/30,
     /* 182044 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/28,
     /* 182046 */     GIR_MakeTempReg, /*TempRegID*/26, /*TypeID*/GILLT_s32,
     /* 182049 */     GIR_BuildMI, /*InsnID*/27, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 182053 */     GIR_AddTempRegister, /*InsnID*/27, /*TempRegID*/26, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182058 */     GIR_AddSimpleTempRegister, /*InsnID*/27, /*TempRegID*/27,
     /* 182061 */     GIR_AddSimpleTempRegister, /*InsnID*/27, /*TempRegID*/28,
     /* 182064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/27,
     /* 182066 */     GIR_MakeTempReg, /*TempRegID*/25, /*TypeID*/GILLT_s32,
     /* 182069 */     GIR_BuildMI, /*InsnID*/26, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 182073 */     GIR_AddTempRegister, /*InsnID*/26, /*TempRegID*/25, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182078 */     GIR_AddImm, /*InsnID*/26, /*Imm*/GIMT_Encode8(21845),
     /* 182088 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/26,
     /* 182090 */     GIR_MakeTempReg, /*TempRegID*/24, /*TypeID*/GILLT_s32,
     /* 182093 */     GIR_BuildMI, /*InsnID*/25, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 182097 */     GIR_AddTempRegister, /*InsnID*/25, /*TempRegID*/24, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182102 */     GIR_AddSimpleTempRegister, /*InsnID*/25, /*TempRegID*/25,
     /* 182105 */     GIR_AddImm, /*InsnID*/25, /*Imm*/GIMT_Encode8(21845),
     /* 182115 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/25,
     /* 182117 */     GIR_MakeTempReg, /*TempRegID*/23, /*TypeID*/GILLT_s32,
     /* 182120 */     GIR_BuildMI, /*InsnID*/24, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 182124 */     GIR_AddTempRegister, /*InsnID*/24, /*TempRegID*/23, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182129 */     GIR_Copy, /*NewInsnID*/24, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 182133 */     GIR_AddImm8, /*InsnID*/24, /*Imm*/31,
     /* 182136 */     GIR_AddImm8, /*InsnID*/24, /*Imm*/1,
     /* 182139 */     GIR_AddImm8, /*InsnID*/24, /*Imm*/31,
     /* 182142 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/24,
     /* 182144 */     GIR_MakeTempReg, /*TempRegID*/22, /*TypeID*/GILLT_s32,
     /* 182147 */     GIR_BuildMI, /*InsnID*/23, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 182151 */     GIR_AddTempRegister, /*InsnID*/23, /*TempRegID*/22, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182156 */     GIR_AddSimpleTempRegister, /*InsnID*/23, /*TempRegID*/23,
     /* 182159 */     GIR_AddSimpleTempRegister, /*InsnID*/23, /*TempRegID*/24,
     /* 182162 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/23,
     /* 182164 */     GIR_MakeTempReg, /*TempRegID*/21, /*TypeID*/GILLT_s32,
     /* 182167 */     GIR_BuildMI, /*InsnID*/22, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 182171 */     GIR_AddTempRegister, /*InsnID*/22, /*TempRegID*/21, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182176 */     GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/22,
     /* 182179 */     GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/26,
     /* 182182 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/22,
     /* 182184 */     GIR_MakeTempReg, /*TempRegID*/20, /*TypeID*/GILLT_s32,
     /* 182187 */     GIR_BuildMI, /*InsnID*/21, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 182191 */     GIR_AddTempRegister, /*InsnID*/21, /*TempRegID*/20, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182196 */     GIR_AddSimpleTempRegister, /*InsnID*/21, /*TempRegID*/21,
     /* 182199 */     GIR_AddImm8, /*InsnID*/21, /*Imm*/2,
     /* 182202 */     GIR_AddImm8, /*InsnID*/21, /*Imm*/0,
     /* 182205 */     GIR_AddImm8, /*InsnID*/21, /*Imm*/29,
     /* 182208 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/21,
     /* 182210 */     GIR_MakeTempReg, /*TempRegID*/19, /*TypeID*/GILLT_s32,
     /* 182213 */     GIR_BuildMI, /*InsnID*/20, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 182217 */     GIR_AddTempRegister, /*InsnID*/20, /*TempRegID*/19, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182222 */     GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/20,
     /* 182225 */     GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/30,
     /* 182228 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/20,
     /* 182230 */     GIR_MakeTempReg, /*TempRegID*/18, /*TypeID*/GILLT_s32,
     /* 182233 */     GIR_BuildMI, /*InsnID*/19, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 182237 */     GIR_AddTempRegister, /*InsnID*/19, /*TempRegID*/18, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182242 */     GIR_AddImm, /*InsnID*/19, /*Imm*/GIMT_Encode8(13107),
     /* 182252 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/19,
     /* 182254 */     GIR_MakeTempReg, /*TempRegID*/17, /*TypeID*/GILLT_s32,
     /* 182257 */     GIR_BuildMI, /*InsnID*/18, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 182261 */     GIR_AddTempRegister, /*InsnID*/18, /*TempRegID*/17, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182266 */     GIR_AddSimpleTempRegister, /*InsnID*/18, /*TempRegID*/18,
     /* 182269 */     GIR_AddImm, /*InsnID*/18, /*Imm*/GIMT_Encode8(13107),
     /* 182279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/18,
     /* 182281 */     GIR_MakeTempReg, /*TempRegID*/16, /*TypeID*/GILLT_s32,
     /* 182284 */     GIR_BuildMI, /*InsnID*/17, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 182288 */     GIR_AddTempRegister, /*InsnID*/17, /*TempRegID*/16, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182293 */     GIR_AddImm, /*InsnID*/17, /*Imm*/GIMT_Encode8(43690),
     /* 182303 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/17,
     /* 182305 */     GIR_MakeTempReg, /*TempRegID*/15, /*TypeID*/GILLT_s32,
     /* 182308 */     GIR_BuildMI, /*InsnID*/16, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 182312 */     GIR_AddTempRegister, /*InsnID*/16, /*TempRegID*/15, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182317 */     GIR_AddSimpleTempRegister, /*InsnID*/16, /*TempRegID*/16,
     /* 182320 */     GIR_AddImm, /*InsnID*/16, /*Imm*/GIMT_Encode8(43690),
     /* 182330 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/16,
     /* 182332 */     GIR_MakeTempReg, /*TempRegID*/14, /*TypeID*/GILLT_s32,
     /* 182335 */     GIR_BuildMI, /*InsnID*/15, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 182339 */     GIR_AddTempRegister, /*InsnID*/15, /*TempRegID*/14, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182344 */     GIR_Copy, /*NewInsnID*/15, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 182348 */     GIR_AddImm8, /*InsnID*/15, /*Imm*/1,
     /* 182351 */     GIR_AddImm8, /*InsnID*/15, /*Imm*/0,
     /* 182354 */     GIR_AddImm8, /*InsnID*/15, /*Imm*/30,
     /* 182357 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/15,
     /* 182359 */     GIR_MakeTempReg, /*TempRegID*/13, /*TypeID*/GILLT_s32,
     /* 182362 */     GIR_BuildMI, /*InsnID*/14, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 182366 */     GIR_AddTempRegister, /*InsnID*/14, /*TempRegID*/13, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182371 */     GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/14,
     /* 182374 */     GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/15,
     /* 182377 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/14,
     /* 182379 */     GIR_MakeTempReg, /*TempRegID*/12, /*TypeID*/GILLT_s32,
     /* 182382 */     GIR_BuildMI, /*InsnID*/13, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 182386 */     GIR_AddTempRegister, /*InsnID*/13, /*TempRegID*/12, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182391 */     GIR_AddImm, /*InsnID*/13, /*Imm*/GIMT_Encode8(21845),
     /* 182401 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/13,
     /* 182403 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /* 182406 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 182410 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182415 */     GIR_AddSimpleTempRegister, /*InsnID*/12, /*TempRegID*/12,
     /* 182418 */     GIR_AddImm, /*InsnID*/12, /*Imm*/GIMT_Encode8(21845),
     /* 182428 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/12,
     /* 182430 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /* 182433 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 182437 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182442 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 182446 */     GIR_AddImm8, /*InsnID*/11, /*Imm*/31,
     /* 182449 */     GIR_AddImm8, /*InsnID*/11, /*Imm*/1,
     /* 182452 */     GIR_AddImm8, /*InsnID*/11, /*Imm*/31,
     /* 182455 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 182457 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /* 182460 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 182464 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182469 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 182472 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/11,
     /* 182475 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 182477 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /* 182480 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 182484 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182489 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 182492 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/13,
     /* 182495 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 182497 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /* 182500 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 182504 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182509 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /* 182512 */     GIR_AddImm8, /*InsnID*/8, /*Imm*/30,
     /* 182515 */     GIR_AddImm8, /*InsnID*/8, /*Imm*/2,
     /* 182518 */     GIR_AddImm8, /*InsnID*/8, /*Imm*/31,
     /* 182521 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 182523 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /* 182526 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 182530 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182535 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 182538 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/17,
     /* 182541 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 182543 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /* 182546 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 182550 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182555 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 182558 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/19,
     /* 182561 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 182563 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 182566 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 182570 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182575 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 182578 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/28,
     /* 182581 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/4,
     /* 182584 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/31,
     /* 182587 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 182589 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 182592 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 182596 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182601 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 182604 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/32,
     /* 182607 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 182609 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 182612 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 182616 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182621 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 182624 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/34,
     /* 182627 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 182629 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 182632 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 182636 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182641 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 182644 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/24,
     /* 182647 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 182650 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 182653 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 182655 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 182658 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLWIMI),
     /* 182662 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182667 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 182670 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/65,
     /* 182673 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 182676 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 182679 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /* 182682 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 182684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWIMI),
     /* 182687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 182689 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 182692 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*//* 128(*/0x80, 0x01/*)*/,
     /* 182696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 182699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/24,
     /* 182702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 182705 */     GIR_RootConstrainSelectedInstOperands,
     /* 182706 */     // GIR_Coverage, 4890,
     /* 182706 */     GIR_EraseRootFromParent_Done,
     /* 182707 */   // Label 2769: @182707
     /* 182707 */   GIM_Reject,
     /* 182708 */ // Label 2767: @182708
     /* 182708 */ GIM_Reject,
     /* 182709 */ // Label 2765: @182709
     /* 182709 */ GIM_Try, /*On fail goto*//*Label 2770*/ GIMT_Encode4(208399), // Rule ID 4891 //
     /* 182714 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 182717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 182721 */   // (bitreverse:{ *:[i64] } i64:{ *:[i64] }:$A)  =>  (OR8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWIMI:{ *:[i32] } (RLWIMI:{ *:[i32] } (RLWINM:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 60:{ *:[i32] }, 4:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 3855:{ *:[i64] }), 3855:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 4:{ *:[i32] }, 59:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 61680:{ *:[i64] }), 61680:{ *:[i64] }))), sub_32:{ *:[i32] }), 24:{ *:[i32] }, 0:{ *:[i32] }, 31:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 60:{ *:[i32] }, 4:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 3855:{ *:[i64] }), 3855:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 4:{ *:[i32] }, 59:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 61680:{ *:[i64] }), 61680:{ *:[i64] }))), sub_32:{ *:[i32] }), 8:{ *:[i32] }, 8:{ *:[i32] }, 15:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 60:{ *:[i32] }, 4:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 3855:{ *:[i64] }), 3855:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 4:{ *:[i32] }, 59:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 61680:{ *:[i64] }), 61680:{ *:[i64] }))), sub_32:{ *:[i32] }), 8:{ *:[i32] }, 24:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWIMI:{ *:[i32] } (RLWIMI:{ *:[i32] } (RLWINM:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 60:{ *:[i32] }, 4:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 3855:{ *:[i64] }), 3855:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 4:{ *:[i32] }, 59:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 61680:{ *:[i64] }), 61680:{ *:[i64] }))), 32:{ *:[i32] }, 32:{ *:[i32] }), sub_32:{ *:[i32] }), 24:{ *:[i32] }, 0:{ *:[i32] }, 31:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 60:{ *:[i32] }, 4:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 3855:{ *:[i64] }), 3855:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 4:{ *:[i32] }, 59:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 61680:{ *:[i64] }), 61680:{ *:[i64] }))), 32:{ *:[i32] }, 32:{ *:[i32] }), sub_32:{ *:[i32] }), 8:{ *:[i32] }, 8:{ *:[i32] }, 15:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 60:{ *:[i32] }, 4:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 3855:{ *:[i64] }), 3855:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 4:{ *:[i32] }, 59:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 61680:{ *:[i64] }), 61680:{ *:[i64] }))), 32:{ *:[i32] }, 32:{ *:[i32] }), sub_32:{ *:[i32] }), 8:{ *:[i32] }, 24:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] }))
     /* 182721 */   GIR_MakeTempReg, /*TempRegID*//* 139(*/0x8B, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 182725 */   GIR_BuildMI, /*InsnID*//* 140(*/0x8C, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 182730 */   GIR_AddTempRegister, /*InsnID*//* 140(*/0x8C, 0x01/*)*/, /*TempRegID*//* 139(*/0x8B, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182737 */   GIR_AddImm, /*InsnID*//* 140(*/0x8C, 0x01/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 182748 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 140(*/0x8C, 0x01/*)*/,
     /* 182751 */   GIR_MakeTempReg, /*TempRegID*//* 138(*/0x8A, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 182755 */   GIR_BuildMI, /*InsnID*//* 139(*/0x8B, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 182760 */   GIR_AddTempRegister, /*InsnID*//* 139(*/0x8B, 0x01/*)*/, /*TempRegID*//* 138(*/0x8A, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182767 */   GIR_AddSimpleTempRegister, /*InsnID*//* 139(*/0x8B, 0x01/*)*/, /*TempRegID*//* 139(*/0x8B, 0x01/*)*/,
     /* 182772 */   GIR_AddImm, /*InsnID*//* 139(*/0x8B, 0x01/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 182783 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 139(*/0x8B, 0x01/*)*/,
     /* 182786 */   GIR_MakeTempReg, /*TempRegID*//* 137(*/0x89, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 182790 */   GIR_BuildMI, /*InsnID*//* 138(*/0x8A, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 182795 */   GIR_AddTempRegister, /*InsnID*//* 138(*/0x8A, 0x01/*)*/, /*TempRegID*//* 137(*/0x89, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182802 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 138(*/0x8A, 0x01/*)*/,
     /* 182805 */   GIR_MakeTempReg, /*TempRegID*//* 136(*/0x88, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 182809 */   GIR_BuildMI, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 182814 */   GIR_AddTempRegister, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*TempRegID*//* 136(*/0x88, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182821 */   GIR_AddSimpleTempRegister, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*TempRegID*//* 137(*/0x89, 0x01/*)*/,
     /* 182826 */   GIR_AddSimpleTempRegister, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*TempRegID*//* 138(*/0x8A, 0x01/*)*/,
     /* 182831 */   GIR_AddImm8, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*Imm*/1,
     /* 182835 */   GIR_ConstrainOperandRC, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 182841 */   GIR_ConstrainOperandRC, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 182847 */   GIR_ConstrainOperandRC, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 182853 */   GIR_MakeTempReg, /*TempRegID*//* 135(*/0x87, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 182857 */   GIR_BuildMI, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 182862 */   GIR_AddTempRegister, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*TempRegID*//* 135(*/0x87, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182869 */   GIR_AddSimpleTempRegister, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*TempRegID*//* 136(*/0x88, 0x01/*)*/,
     /* 182874 */   GIR_AddImm8, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*Imm*/32,
     /* 182878 */   GIR_AddImm8, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*Imm*/31,
     /* 182882 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 136(*/0x88, 0x01/*)*/,
     /* 182885 */   GIR_MakeTempReg, /*TempRegID*//* 134(*/0x86, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 182889 */   GIR_BuildMI, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 182894 */   GIR_AddTempRegister, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*TempRegID*//* 134(*/0x86, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182901 */   GIR_AddSimpleTempRegister, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*TempRegID*//* 135(*/0x87, 0x01/*)*/,
     /* 182906 */   GIR_AddImm, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 182917 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 135(*/0x87, 0x01/*)*/,
     /* 182920 */   GIR_MakeTempReg, /*TempRegID*//* 133(*/0x85, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 182924 */   GIR_BuildMI, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 182929 */   GIR_AddTempRegister, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*TempRegID*//* 133(*/0x85, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182936 */   GIR_AddSimpleTempRegister, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*TempRegID*//* 134(*/0x86, 0x01/*)*/,
     /* 182941 */   GIR_AddImm, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 182952 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 134(*/0x86, 0x01/*)*/,
     /* 182955 */   GIR_MakeTempReg, /*TempRegID*//* 132(*/0x84, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 182959 */   GIR_BuildMI, /*InsnID*//* 133(*/0x85, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 182964 */   GIR_AddTempRegister, /*InsnID*//* 133(*/0x85, 0x01/*)*/, /*TempRegID*//* 132(*/0x84, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182971 */   GIR_AddImm, /*InsnID*//* 133(*/0x85, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 182982 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 133(*/0x85, 0x01/*)*/,
     /* 182985 */   GIR_MakeTempReg, /*TempRegID*//* 131(*/0x83, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 182989 */   GIR_BuildMI, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 182994 */   GIR_AddTempRegister, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*TempRegID*//* 131(*/0x83, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183001 */   GIR_AddSimpleTempRegister, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*TempRegID*//* 132(*/0x84, 0x01/*)*/,
     /* 183006 */   GIR_AddImm, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 183017 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 132(*/0x84, 0x01/*)*/,
     /* 183020 */   GIR_MakeTempReg, /*TempRegID*//* 130(*/0x82, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 183024 */   GIR_BuildMI, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 183029 */   GIR_AddTempRegister, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*TempRegID*//* 130(*/0x82, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183036 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 131(*/0x83, 0x01/*)*/,
     /* 183039 */   GIR_MakeTempReg, /*TempRegID*//* 129(*/0x81, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 183043 */   GIR_BuildMI, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 183048 */   GIR_AddTempRegister, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*TempRegID*//* 129(*/0x81, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183055 */   GIR_AddSimpleTempRegister, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*TempRegID*//* 130(*/0x82, 0x01/*)*/,
     /* 183060 */   GIR_AddSimpleTempRegister, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*TempRegID*//* 131(*/0x83, 0x01/*)*/,
     /* 183065 */   GIR_AddImm8, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*Imm*/1,
     /* 183069 */   GIR_ConstrainOperandRC, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 183075 */   GIR_ConstrainOperandRC, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 183081 */   GIR_ConstrainOperandRC, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 183087 */   GIR_MakeTempReg, /*TempRegID*//* 128(*/0x80, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 183091 */   GIR_BuildMI, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 183096 */   GIR_AddTempRegister, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*TempRegID*//* 128(*/0x80, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183103 */   GIR_AddSimpleTempRegister, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*TempRegID*//* 129(*/0x81, 0x01/*)*/,
     /* 183108 */   GIR_AddImm8, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*Imm*/32,
     /* 183112 */   GIR_AddImm8, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*Imm*/31,
     /* 183116 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 129(*/0x81, 0x01/*)*/,
     /* 183119 */   GIR_MakeTempReg, /*TempRegID*/127, /*TypeID*/GILLT_s64,
     /* 183122 */   GIR_BuildMI, /*InsnID*//* 128(*/0x80, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 183127 */   GIR_AddTempRegister, /*InsnID*//* 128(*/0x80, 0x01/*)*/, /*TempRegID*/127, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183133 */   GIR_AddSimpleTempRegister, /*InsnID*//* 128(*/0x80, 0x01/*)*/, /*TempRegID*//* 128(*/0x80, 0x01/*)*/,
     /* 183138 */   GIR_AddImm, /*InsnID*//* 128(*/0x80, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 183149 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 128(*/0x80, 0x01/*)*/,
     /* 183152 */   GIR_MakeTempReg, /*TempRegID*/126, /*TypeID*/GILLT_s64,
     /* 183155 */   GIR_BuildMI, /*InsnID*/127, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 183159 */   GIR_AddTempRegister, /*InsnID*/127, /*TempRegID*/126, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183164 */   GIR_AddSimpleTempRegister, /*InsnID*/127, /*TempRegID*/127,
     /* 183167 */   GIR_AddImm, /*InsnID*/127, /*Imm*/GIMT_Encode8(52428),
     /* 183177 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/127,
     /* 183179 */   GIR_MakeTempReg, /*TempRegID*/125, /*TypeID*/GILLT_s32,
     /* 183182 */   GIR_BuildMI, /*InsnID*/126, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 183186 */   GIR_AddTempRegister, /*InsnID*/126, /*TempRegID*/125, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183191 */   GIR_AddImm, /*InsnID*/126, /*Imm*/GIMT_Encode8(43690),
     /* 183201 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/126,
     /* 183203 */   GIR_MakeTempReg, /*TempRegID*/124, /*TypeID*/GILLT_s32,
     /* 183206 */   GIR_BuildMI, /*InsnID*/125, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 183210 */   GIR_AddTempRegister, /*InsnID*/125, /*TempRegID*/124, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183215 */   GIR_AddSimpleTempRegister, /*InsnID*/125, /*TempRegID*/125,
     /* 183218 */   GIR_AddImm, /*InsnID*/125, /*Imm*/GIMT_Encode8(43690),
     /* 183228 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/125,
     /* 183230 */   GIR_MakeTempReg, /*TempRegID*/123, /*TypeID*/GILLT_s64,
     /* 183233 */   GIR_BuildMI, /*InsnID*/124, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 183237 */   GIR_AddTempRegister, /*InsnID*/124, /*TempRegID*/123, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183242 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/124,
     /* 183244 */   GIR_MakeTempReg, /*TempRegID*/122, /*TypeID*/GILLT_s64,
     /* 183247 */   GIR_BuildMI, /*InsnID*/123, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 183251 */   GIR_AddTempRegister, /*InsnID*/123, /*TempRegID*/122, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183256 */   GIR_AddSimpleTempRegister, /*InsnID*/123, /*TempRegID*/123,
     /* 183259 */   GIR_AddSimpleTempRegister, /*InsnID*/123, /*TempRegID*/124,
     /* 183262 */   GIR_AddImm8, /*InsnID*/123, /*Imm*/1,
     /* 183265 */   GIR_ConstrainOperandRC, /*InsnID*/123, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 183270 */   GIR_ConstrainOperandRC, /*InsnID*/123, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 183275 */   GIR_ConstrainOperandRC, /*InsnID*/123, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 183280 */   GIR_MakeTempReg, /*TempRegID*/121, /*TypeID*/GILLT_s64,
     /* 183283 */   GIR_BuildMI, /*InsnID*/122, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 183287 */   GIR_AddTempRegister, /*InsnID*/122, /*TempRegID*/121, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183292 */   GIR_AddSimpleTempRegister, /*InsnID*/122, /*TempRegID*/122,
     /* 183295 */   GIR_AddImm8, /*InsnID*/122, /*Imm*/32,
     /* 183298 */   GIR_AddImm8, /*InsnID*/122, /*Imm*/31,
     /* 183301 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/122,
     /* 183303 */   GIR_MakeTempReg, /*TempRegID*/120, /*TypeID*/GILLT_s64,
     /* 183306 */   GIR_BuildMI, /*InsnID*/121, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 183310 */   GIR_AddTempRegister, /*InsnID*/121, /*TempRegID*/120, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183315 */   GIR_AddSimpleTempRegister, /*InsnID*/121, /*TempRegID*/121,
     /* 183318 */   GIR_AddImm, /*InsnID*/121, /*Imm*/GIMT_Encode8(43690),
     /* 183328 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/121,
     /* 183330 */   GIR_MakeTempReg, /*TempRegID*/119, /*TypeID*/GILLT_s64,
     /* 183333 */   GIR_BuildMI, /*InsnID*/120, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 183337 */   GIR_AddTempRegister, /*InsnID*/120, /*TempRegID*/119, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183342 */   GIR_AddSimpleTempRegister, /*InsnID*/120, /*TempRegID*/120,
     /* 183345 */   GIR_AddImm, /*InsnID*/120, /*Imm*/GIMT_Encode8(43690),
     /* 183355 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/120,
     /* 183357 */   GIR_MakeTempReg, /*TempRegID*/118, /*TypeID*/GILLT_s64,
     /* 183360 */   GIR_BuildMI, /*InsnID*/119, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 183364 */   GIR_AddTempRegister, /*InsnID*/119, /*TempRegID*/118, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183369 */   GIR_Copy, /*NewInsnID*/119, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 183373 */   GIR_AddImm8, /*InsnID*/119, /*Imm*/1,
     /* 183376 */   GIR_AddImm8, /*InsnID*/119, /*Imm*/62,
     /* 183379 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/119,
     /* 183381 */   GIR_MakeTempReg, /*TempRegID*/117, /*TypeID*/GILLT_s64,
     /* 183384 */   GIR_BuildMI, /*InsnID*/118, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 183388 */   GIR_AddTempRegister, /*InsnID*/118, /*TempRegID*/117, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183393 */   GIR_AddSimpleTempRegister, /*InsnID*/118, /*TempRegID*/118,
     /* 183396 */   GIR_AddSimpleTempRegister, /*InsnID*/118, /*TempRegID*/119,
     /* 183399 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/118,
     /* 183401 */   GIR_MakeTempReg, /*TempRegID*/116, /*TypeID*/GILLT_s32,
     /* 183404 */   GIR_BuildMI, /*InsnID*/117, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 183408 */   GIR_AddTempRegister, /*InsnID*/117, /*TempRegID*/116, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183413 */   GIR_AddImm, /*InsnID*/117, /*Imm*/GIMT_Encode8(21845),
     /* 183423 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/117,
     /* 183425 */   GIR_MakeTempReg, /*TempRegID*/115, /*TypeID*/GILLT_s32,
     /* 183428 */   GIR_BuildMI, /*InsnID*/116, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 183432 */   GIR_AddTempRegister, /*InsnID*/116, /*TempRegID*/115, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183437 */   GIR_AddSimpleTempRegister, /*InsnID*/116, /*TempRegID*/116,
     /* 183440 */   GIR_AddImm, /*InsnID*/116, /*Imm*/GIMT_Encode8(21845),
     /* 183450 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/116,
     /* 183452 */   GIR_MakeTempReg, /*TempRegID*/114, /*TypeID*/GILLT_s64,
     /* 183455 */   GIR_BuildMI, /*InsnID*/115, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 183459 */   GIR_AddTempRegister, /*InsnID*/115, /*TempRegID*/114, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183464 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/115,
     /* 183466 */   GIR_MakeTempReg, /*TempRegID*/113, /*TypeID*/GILLT_s64,
     /* 183469 */   GIR_BuildMI, /*InsnID*/114, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 183473 */   GIR_AddTempRegister, /*InsnID*/114, /*TempRegID*/113, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183478 */   GIR_AddSimpleTempRegister, /*InsnID*/114, /*TempRegID*/114,
     /* 183481 */   GIR_AddSimpleTempRegister, /*InsnID*/114, /*TempRegID*/115,
     /* 183484 */   GIR_AddImm8, /*InsnID*/114, /*Imm*/1,
     /* 183487 */   GIR_ConstrainOperandRC, /*InsnID*/114, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 183492 */   GIR_ConstrainOperandRC, /*InsnID*/114, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 183497 */   GIR_ConstrainOperandRC, /*InsnID*/114, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 183502 */   GIR_MakeTempReg, /*TempRegID*/112, /*TypeID*/GILLT_s64,
     /* 183505 */   GIR_BuildMI, /*InsnID*/113, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 183509 */   GIR_AddTempRegister, /*InsnID*/113, /*TempRegID*/112, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183514 */   GIR_AddSimpleTempRegister, /*InsnID*/113, /*TempRegID*/113,
     /* 183517 */   GIR_AddImm8, /*InsnID*/113, /*Imm*/32,
     /* 183520 */   GIR_AddImm8, /*InsnID*/113, /*Imm*/31,
     /* 183523 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/113,
     /* 183525 */   GIR_MakeTempReg, /*TempRegID*/111, /*TypeID*/GILLT_s64,
     /* 183528 */   GIR_BuildMI, /*InsnID*/112, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 183532 */   GIR_AddTempRegister, /*InsnID*/112, /*TempRegID*/111, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183537 */   GIR_AddSimpleTempRegister, /*InsnID*/112, /*TempRegID*/112,
     /* 183540 */   GIR_AddImm, /*InsnID*/112, /*Imm*/GIMT_Encode8(21845),
     /* 183550 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/112,
     /* 183552 */   GIR_MakeTempReg, /*TempRegID*/110, /*TypeID*/GILLT_s64,
     /* 183555 */   GIR_BuildMI, /*InsnID*/111, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 183559 */   GIR_AddTempRegister, /*InsnID*/111, /*TempRegID*/110, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183564 */   GIR_AddSimpleTempRegister, /*InsnID*/111, /*TempRegID*/111,
     /* 183567 */   GIR_AddImm, /*InsnID*/111, /*Imm*/GIMT_Encode8(21845),
     /* 183577 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/111,
     /* 183579 */   GIR_MakeTempReg, /*TempRegID*/109, /*TypeID*/GILLT_s64,
     /* 183582 */   GIR_BuildMI, /*InsnID*/110, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 183586 */   GIR_AddTempRegister, /*InsnID*/110, /*TempRegID*/109, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183591 */   GIR_Copy, /*NewInsnID*/110, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 183595 */   GIR_AddImm8, /*InsnID*/110, /*Imm*/63,
     /* 183598 */   GIR_AddImm8, /*InsnID*/110, /*Imm*/1,
     /* 183601 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/110,
     /* 183603 */   GIR_MakeTempReg, /*TempRegID*/108, /*TypeID*/GILLT_s64,
     /* 183606 */   GIR_BuildMI, /*InsnID*/109, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 183610 */   GIR_AddTempRegister, /*InsnID*/109, /*TempRegID*/108, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183615 */   GIR_AddSimpleTempRegister, /*InsnID*/109, /*TempRegID*/109,
     /* 183618 */   GIR_AddSimpleTempRegister, /*InsnID*/109, /*TempRegID*/110,
     /* 183621 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/109,
     /* 183623 */   GIR_MakeTempReg, /*TempRegID*/107, /*TypeID*/GILLT_s64,
     /* 183626 */   GIR_BuildMI, /*InsnID*/108, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 183630 */   GIR_AddTempRegister, /*InsnID*/108, /*TempRegID*/107, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183635 */   GIR_AddSimpleTempRegister, /*InsnID*/108, /*TempRegID*/108,
     /* 183638 */   GIR_AddSimpleTempRegister, /*InsnID*/108, /*TempRegID*/117,
     /* 183641 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/108,
     /* 183643 */   GIR_MakeTempReg, /*TempRegID*/106, /*TypeID*/GILLT_s64,
     /* 183646 */   GIR_BuildMI, /*InsnID*/107, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 183650 */   GIR_AddTempRegister, /*InsnID*/107, /*TempRegID*/106, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183655 */   GIR_AddSimpleTempRegister, /*InsnID*/107, /*TempRegID*/107,
     /* 183658 */   GIR_AddImm8, /*InsnID*/107, /*Imm*/2,
     /* 183661 */   GIR_AddImm8, /*InsnID*/107, /*Imm*/61,
     /* 183664 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/107,
     /* 183666 */   GIR_MakeTempReg, /*TempRegID*/105, /*TypeID*/GILLT_s64,
     /* 183669 */   GIR_BuildMI, /*InsnID*/106, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 183673 */   GIR_AddTempRegister, /*InsnID*/106, /*TempRegID*/105, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183678 */   GIR_AddSimpleTempRegister, /*InsnID*/106, /*TempRegID*/106,
     /* 183681 */   GIR_AddSimpleTempRegister, /*InsnID*/106, /*TempRegID*/126,
     /* 183684 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/106,
     /* 183686 */   GIR_MakeTempReg, /*TempRegID*/104, /*TypeID*/GILLT_s32,
     /* 183689 */   GIR_BuildMI, /*InsnID*/105, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 183693 */   GIR_AddTempRegister, /*InsnID*/105, /*TempRegID*/104, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183698 */   GIR_AddImm, /*InsnID*/105, /*Imm*/GIMT_Encode8(13107),
     /* 183708 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/105,
     /* 183710 */   GIR_MakeTempReg, /*TempRegID*/103, /*TypeID*/GILLT_s32,
     /* 183713 */   GIR_BuildMI, /*InsnID*/104, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 183717 */   GIR_AddTempRegister, /*InsnID*/104, /*TempRegID*/103, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183722 */   GIR_AddSimpleTempRegister, /*InsnID*/104, /*TempRegID*/104,
     /* 183725 */   GIR_AddImm, /*InsnID*/104, /*Imm*/GIMT_Encode8(13107),
     /* 183735 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/104,
     /* 183737 */   GIR_MakeTempReg, /*TempRegID*/102, /*TypeID*/GILLT_s64,
     /* 183740 */   GIR_BuildMI, /*InsnID*/103, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 183744 */   GIR_AddTempRegister, /*InsnID*/103, /*TempRegID*/102, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183749 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/103,
     /* 183751 */   GIR_MakeTempReg, /*TempRegID*/101, /*TypeID*/GILLT_s64,
     /* 183754 */   GIR_BuildMI, /*InsnID*/102, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 183758 */   GIR_AddTempRegister, /*InsnID*/102, /*TempRegID*/101, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183763 */   GIR_AddSimpleTempRegister, /*InsnID*/102, /*TempRegID*/102,
     /* 183766 */   GIR_AddSimpleTempRegister, /*InsnID*/102, /*TempRegID*/103,
     /* 183769 */   GIR_AddImm8, /*InsnID*/102, /*Imm*/1,
     /* 183772 */   GIR_ConstrainOperandRC, /*InsnID*/102, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 183777 */   GIR_ConstrainOperandRC, /*InsnID*/102, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 183782 */   GIR_ConstrainOperandRC, /*InsnID*/102, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 183787 */   GIR_MakeTempReg, /*TempRegID*/100, /*TypeID*/GILLT_s64,
     /* 183790 */   GIR_BuildMI, /*InsnID*/101, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 183794 */   GIR_AddTempRegister, /*InsnID*/101, /*TempRegID*/100, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183799 */   GIR_AddSimpleTempRegister, /*InsnID*/101, /*TempRegID*/101,
     /* 183802 */   GIR_AddImm8, /*InsnID*/101, /*Imm*/32,
     /* 183805 */   GIR_AddImm8, /*InsnID*/101, /*Imm*/31,
     /* 183808 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/101,
     /* 183810 */   GIR_MakeTempReg, /*TempRegID*/99, /*TypeID*/GILLT_s64,
     /* 183813 */   GIR_BuildMI, /*InsnID*/100, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 183817 */   GIR_AddTempRegister, /*InsnID*/100, /*TempRegID*/99, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183822 */   GIR_AddSimpleTempRegister, /*InsnID*/100, /*TempRegID*/100,
     /* 183825 */   GIR_AddImm, /*InsnID*/100, /*Imm*/GIMT_Encode8(13107),
     /* 183835 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/100,
     /* 183837 */   GIR_MakeTempReg, /*TempRegID*/98, /*TypeID*/GILLT_s64,
     /* 183840 */   GIR_BuildMI, /*InsnID*/99, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 183844 */   GIR_AddTempRegister, /*InsnID*/99, /*TempRegID*/98, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183849 */   GIR_AddSimpleTempRegister, /*InsnID*/99, /*TempRegID*/99,
     /* 183852 */   GIR_AddImm, /*InsnID*/99, /*Imm*/GIMT_Encode8(13107),
     /* 183862 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/99,
     /* 183864 */   GIR_MakeTempReg, /*TempRegID*/97, /*TypeID*/GILLT_s32,
     /* 183867 */   GIR_BuildMI, /*InsnID*/98, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 183871 */   GIR_AddTempRegister, /*InsnID*/98, /*TempRegID*/97, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183876 */   GIR_AddImm, /*InsnID*/98, /*Imm*/GIMT_Encode8(43690),
     /* 183886 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/98,
     /* 183888 */   GIR_MakeTempReg, /*TempRegID*/96, /*TypeID*/GILLT_s32,
     /* 183891 */   GIR_BuildMI, /*InsnID*/97, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 183895 */   GIR_AddTempRegister, /*InsnID*/97, /*TempRegID*/96, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183900 */   GIR_AddSimpleTempRegister, /*InsnID*/97, /*TempRegID*/97,
     /* 183903 */   GIR_AddImm, /*InsnID*/97, /*Imm*/GIMT_Encode8(43690),
     /* 183913 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/97,
     /* 183915 */   GIR_MakeTempReg, /*TempRegID*/95, /*TypeID*/GILLT_s64,
     /* 183918 */   GIR_BuildMI, /*InsnID*/96, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 183922 */   GIR_AddTempRegister, /*InsnID*/96, /*TempRegID*/95, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183927 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/96,
     /* 183929 */   GIR_MakeTempReg, /*TempRegID*/94, /*TypeID*/GILLT_s64,
     /* 183932 */   GIR_BuildMI, /*InsnID*/95, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 183936 */   GIR_AddTempRegister, /*InsnID*/95, /*TempRegID*/94, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183941 */   GIR_AddSimpleTempRegister, /*InsnID*/95, /*TempRegID*/95,
     /* 183944 */   GIR_AddSimpleTempRegister, /*InsnID*/95, /*TempRegID*/96,
     /* 183947 */   GIR_AddImm8, /*InsnID*/95, /*Imm*/1,
     /* 183950 */   GIR_ConstrainOperandRC, /*InsnID*/95, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 183955 */   GIR_ConstrainOperandRC, /*InsnID*/95, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 183960 */   GIR_ConstrainOperandRC, /*InsnID*/95, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 183965 */   GIR_MakeTempReg, /*TempRegID*/93, /*TypeID*/GILLT_s64,
     /* 183968 */   GIR_BuildMI, /*InsnID*/94, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 183972 */   GIR_AddTempRegister, /*InsnID*/94, /*TempRegID*/93, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183977 */   GIR_AddSimpleTempRegister, /*InsnID*/94, /*TempRegID*/94,
     /* 183980 */   GIR_AddImm8, /*InsnID*/94, /*Imm*/32,
     /* 183983 */   GIR_AddImm8, /*InsnID*/94, /*Imm*/31,
     /* 183986 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/94,
     /* 183988 */   GIR_MakeTempReg, /*TempRegID*/92, /*TypeID*/GILLT_s64,
     /* 183991 */   GIR_BuildMI, /*InsnID*/93, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 183995 */   GIR_AddTempRegister, /*InsnID*/93, /*TempRegID*/92, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184000 */   GIR_AddSimpleTempRegister, /*InsnID*/93, /*TempRegID*/93,
     /* 184003 */   GIR_AddImm, /*InsnID*/93, /*Imm*/GIMT_Encode8(43690),
     /* 184013 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/93,
     /* 184015 */   GIR_MakeTempReg, /*TempRegID*/91, /*TypeID*/GILLT_s64,
     /* 184018 */   GIR_BuildMI, /*InsnID*/92, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 184022 */   GIR_AddTempRegister, /*InsnID*/92, /*TempRegID*/91, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184027 */   GIR_AddSimpleTempRegister, /*InsnID*/92, /*TempRegID*/92,
     /* 184030 */   GIR_AddImm, /*InsnID*/92, /*Imm*/GIMT_Encode8(43690),
     /* 184040 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/92,
     /* 184042 */   GIR_MakeTempReg, /*TempRegID*/90, /*TypeID*/GILLT_s64,
     /* 184045 */   GIR_BuildMI, /*InsnID*/91, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 184049 */   GIR_AddTempRegister, /*InsnID*/91, /*TempRegID*/90, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184054 */   GIR_Copy, /*NewInsnID*/91, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 184058 */   GIR_AddImm8, /*InsnID*/91, /*Imm*/1,
     /* 184061 */   GIR_AddImm8, /*InsnID*/91, /*Imm*/62,
     /* 184064 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/91,
     /* 184066 */   GIR_MakeTempReg, /*TempRegID*/89, /*TypeID*/GILLT_s64,
     /* 184069 */   GIR_BuildMI, /*InsnID*/90, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 184073 */   GIR_AddTempRegister, /*InsnID*/90, /*TempRegID*/89, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184078 */   GIR_AddSimpleTempRegister, /*InsnID*/90, /*TempRegID*/90,
     /* 184081 */   GIR_AddSimpleTempRegister, /*InsnID*/90, /*TempRegID*/91,
     /* 184084 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/90,
     /* 184086 */   GIR_MakeTempReg, /*TempRegID*/88, /*TypeID*/GILLT_s32,
     /* 184089 */   GIR_BuildMI, /*InsnID*/89, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 184093 */   GIR_AddTempRegister, /*InsnID*/89, /*TempRegID*/88, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184098 */   GIR_AddImm, /*InsnID*/89, /*Imm*/GIMT_Encode8(21845),
     /* 184108 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/89,
     /* 184110 */   GIR_MakeTempReg, /*TempRegID*/87, /*TypeID*/GILLT_s32,
     /* 184113 */   GIR_BuildMI, /*InsnID*/88, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 184117 */   GIR_AddTempRegister, /*InsnID*/88, /*TempRegID*/87, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184122 */   GIR_AddSimpleTempRegister, /*InsnID*/88, /*TempRegID*/88,
     /* 184125 */   GIR_AddImm, /*InsnID*/88, /*Imm*/GIMT_Encode8(21845),
     /* 184135 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/88,
     /* 184137 */   GIR_MakeTempReg, /*TempRegID*/86, /*TypeID*/GILLT_s64,
     /* 184140 */   GIR_BuildMI, /*InsnID*/87, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 184144 */   GIR_AddTempRegister, /*InsnID*/87, /*TempRegID*/86, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184149 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/87,
     /* 184151 */   GIR_MakeTempReg, /*TempRegID*/85, /*TypeID*/GILLT_s64,
     /* 184154 */   GIR_BuildMI, /*InsnID*/86, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 184158 */   GIR_AddTempRegister, /*InsnID*/86, /*TempRegID*/85, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184163 */   GIR_AddSimpleTempRegister, /*InsnID*/86, /*TempRegID*/86,
     /* 184166 */   GIR_AddSimpleTempRegister, /*InsnID*/86, /*TempRegID*/87,
     /* 184169 */   GIR_AddImm8, /*InsnID*/86, /*Imm*/1,
     /* 184172 */   GIR_ConstrainOperandRC, /*InsnID*/86, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 184177 */   GIR_ConstrainOperandRC, /*InsnID*/86, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 184182 */   GIR_ConstrainOperandRC, /*InsnID*/86, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 184187 */   GIR_MakeTempReg, /*TempRegID*/84, /*TypeID*/GILLT_s64,
     /* 184190 */   GIR_BuildMI, /*InsnID*/85, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 184194 */   GIR_AddTempRegister, /*InsnID*/85, /*TempRegID*/84, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184199 */   GIR_AddSimpleTempRegister, /*InsnID*/85, /*TempRegID*/85,
     /* 184202 */   GIR_AddImm8, /*InsnID*/85, /*Imm*/32,
     /* 184205 */   GIR_AddImm8, /*InsnID*/85, /*Imm*/31,
     /* 184208 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/85,
     /* 184210 */   GIR_MakeTempReg, /*TempRegID*/83, /*TypeID*/GILLT_s64,
     /* 184213 */   GIR_BuildMI, /*InsnID*/84, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 184217 */   GIR_AddTempRegister, /*InsnID*/84, /*TempRegID*/83, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184222 */   GIR_AddSimpleTempRegister, /*InsnID*/84, /*TempRegID*/84,
     /* 184225 */   GIR_AddImm, /*InsnID*/84, /*Imm*/GIMT_Encode8(21845),
     /* 184235 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/84,
     /* 184237 */   GIR_MakeTempReg, /*TempRegID*/82, /*TypeID*/GILLT_s64,
     /* 184240 */   GIR_BuildMI, /*InsnID*/83, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 184244 */   GIR_AddTempRegister, /*InsnID*/83, /*TempRegID*/82, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184249 */   GIR_AddSimpleTempRegister, /*InsnID*/83, /*TempRegID*/83,
     /* 184252 */   GIR_AddImm, /*InsnID*/83, /*Imm*/GIMT_Encode8(21845),
     /* 184262 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/83,
     /* 184264 */   GIR_MakeTempReg, /*TempRegID*/81, /*TypeID*/GILLT_s64,
     /* 184267 */   GIR_BuildMI, /*InsnID*/82, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 184271 */   GIR_AddTempRegister, /*InsnID*/82, /*TempRegID*/81, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184276 */   GIR_Copy, /*NewInsnID*/82, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 184280 */   GIR_AddImm8, /*InsnID*/82, /*Imm*/63,
     /* 184283 */   GIR_AddImm8, /*InsnID*/82, /*Imm*/1,
     /* 184286 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/82,
     /* 184288 */   GIR_MakeTempReg, /*TempRegID*/80, /*TypeID*/GILLT_s64,
     /* 184291 */   GIR_BuildMI, /*InsnID*/81, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 184295 */   GIR_AddTempRegister, /*InsnID*/81, /*TempRegID*/80, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184300 */   GIR_AddSimpleTempRegister, /*InsnID*/81, /*TempRegID*/81,
     /* 184303 */   GIR_AddSimpleTempRegister, /*InsnID*/81, /*TempRegID*/82,
     /* 184306 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/81,
     /* 184308 */   GIR_MakeTempReg, /*TempRegID*/79, /*TypeID*/GILLT_s64,
     /* 184311 */   GIR_BuildMI, /*InsnID*/80, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 184315 */   GIR_AddTempRegister, /*InsnID*/80, /*TempRegID*/79, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184320 */   GIR_AddSimpleTempRegister, /*InsnID*/80, /*TempRegID*/80,
     /* 184323 */   GIR_AddSimpleTempRegister, /*InsnID*/80, /*TempRegID*/89,
     /* 184326 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/80,
     /* 184328 */   GIR_MakeTempReg, /*TempRegID*/78, /*TypeID*/GILLT_s64,
     /* 184331 */   GIR_BuildMI, /*InsnID*/79, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 184335 */   GIR_AddTempRegister, /*InsnID*/79, /*TempRegID*/78, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184340 */   GIR_AddSimpleTempRegister, /*InsnID*/79, /*TempRegID*/79,
     /* 184343 */   GIR_AddImm8, /*InsnID*/79, /*Imm*/62,
     /* 184346 */   GIR_AddImm8, /*InsnID*/79, /*Imm*/2,
     /* 184349 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/79,
     /* 184351 */   GIR_MakeTempReg, /*TempRegID*/77, /*TypeID*/GILLT_s64,
     /* 184354 */   GIR_BuildMI, /*InsnID*/78, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 184358 */   GIR_AddTempRegister, /*InsnID*/78, /*TempRegID*/77, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184363 */   GIR_AddSimpleTempRegister, /*InsnID*/78, /*TempRegID*/78,
     /* 184366 */   GIR_AddSimpleTempRegister, /*InsnID*/78, /*TempRegID*/98,
     /* 184369 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/78,
     /* 184371 */   GIR_MakeTempReg, /*TempRegID*/76, /*TypeID*/GILLT_s64,
     /* 184374 */   GIR_BuildMI, /*InsnID*/77, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 184378 */   GIR_AddTempRegister, /*InsnID*/77, /*TempRegID*/76, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184383 */   GIR_AddSimpleTempRegister, /*InsnID*/77, /*TempRegID*/77,
     /* 184386 */   GIR_AddSimpleTempRegister, /*InsnID*/77, /*TempRegID*/105,
     /* 184389 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/77,
     /* 184391 */   GIR_MakeTempReg, /*TempRegID*/75, /*TypeID*/GILLT_s64,
     /* 184394 */   GIR_BuildMI, /*InsnID*/76, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 184398 */   GIR_AddTempRegister, /*InsnID*/76, /*TempRegID*/75, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184403 */   GIR_AddSimpleTempRegister, /*InsnID*/76, /*TempRegID*/76,
     /* 184406 */   GIR_AddImm8, /*InsnID*/76, /*Imm*/4,
     /* 184409 */   GIR_AddImm8, /*InsnID*/76, /*Imm*/59,
     /* 184412 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/76,
     /* 184414 */   GIR_MakeTempReg, /*TempRegID*/74, /*TypeID*/GILLT_s64,
     /* 184417 */   GIR_BuildMI, /*InsnID*/75, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 184421 */   GIR_AddTempRegister, /*InsnID*/75, /*TempRegID*/74, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184426 */   GIR_AddSimpleTempRegister, /*InsnID*/75, /*TempRegID*/75,
     /* 184429 */   GIR_AddSimpleTempRegister, /*InsnID*/75, /*TempRegID*//* 133(*/0x85, 0x01/*)*/,
     /* 184433 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/75,
     /* 184435 */   GIR_MakeTempReg, /*TempRegID*/73, /*TypeID*/GILLT_s32,
     /* 184438 */   GIR_BuildMI, /*InsnID*/74, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 184442 */   GIR_AddTempRegister, /*InsnID*/74, /*TempRegID*/73, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184447 */   GIR_AddImm, /*InsnID*/74, /*Imm*/GIMT_Encode8(3855),
     /* 184457 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/74,
     /* 184459 */   GIR_MakeTempReg, /*TempRegID*/72, /*TypeID*/GILLT_s32,
     /* 184462 */   GIR_BuildMI, /*InsnID*/73, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 184466 */   GIR_AddTempRegister, /*InsnID*/73, /*TempRegID*/72, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184471 */   GIR_AddSimpleTempRegister, /*InsnID*/73, /*TempRegID*/73,
     /* 184474 */   GIR_AddImm, /*InsnID*/73, /*Imm*/GIMT_Encode8(3855),
     /* 184484 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/73,
     /* 184486 */   GIR_MakeTempReg, /*TempRegID*/71, /*TypeID*/GILLT_s64,
     /* 184489 */   GIR_BuildMI, /*InsnID*/72, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 184493 */   GIR_AddTempRegister, /*InsnID*/72, /*TempRegID*/71, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184498 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/72,
     /* 184500 */   GIR_MakeTempReg, /*TempRegID*/70, /*TypeID*/GILLT_s64,
     /* 184503 */   GIR_BuildMI, /*InsnID*/71, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 184507 */   GIR_AddTempRegister, /*InsnID*/71, /*TempRegID*/70, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184512 */   GIR_AddSimpleTempRegister, /*InsnID*/71, /*TempRegID*/71,
     /* 184515 */   GIR_AddSimpleTempRegister, /*InsnID*/71, /*TempRegID*/72,
     /* 184518 */   GIR_AddImm8, /*InsnID*/71, /*Imm*/1,
     /* 184521 */   GIR_ConstrainOperandRC, /*InsnID*/71, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 184526 */   GIR_ConstrainOperandRC, /*InsnID*/71, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 184531 */   GIR_ConstrainOperandRC, /*InsnID*/71, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 184536 */   GIR_MakeTempReg, /*TempRegID*/69, /*TypeID*/GILLT_s64,
     /* 184539 */   GIR_BuildMI, /*InsnID*/70, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 184543 */   GIR_AddTempRegister, /*InsnID*/70, /*TempRegID*/69, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184548 */   GIR_AddSimpleTempRegister, /*InsnID*/70, /*TempRegID*/70,
     /* 184551 */   GIR_AddImm8, /*InsnID*/70, /*Imm*/32,
     /* 184554 */   GIR_AddImm8, /*InsnID*/70, /*Imm*/31,
     /* 184557 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/70,
     /* 184559 */   GIR_MakeTempReg, /*TempRegID*/68, /*TypeID*/GILLT_s64,
     /* 184562 */   GIR_BuildMI, /*InsnID*/69, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 184566 */   GIR_AddTempRegister, /*InsnID*/69, /*TempRegID*/68, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184571 */   GIR_AddSimpleTempRegister, /*InsnID*/69, /*TempRegID*/69,
     /* 184574 */   GIR_AddImm, /*InsnID*/69, /*Imm*/GIMT_Encode8(3855),
     /* 184584 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/69,
     /* 184586 */   GIR_MakeTempReg, /*TempRegID*/67, /*TypeID*/GILLT_s64,
     /* 184589 */   GIR_BuildMI, /*InsnID*/68, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 184593 */   GIR_AddTempRegister, /*InsnID*/68, /*TempRegID*/67, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184598 */   GIR_AddSimpleTempRegister, /*InsnID*/68, /*TempRegID*/68,
     /* 184601 */   GIR_AddImm, /*InsnID*/68, /*Imm*/GIMT_Encode8(3855),
     /* 184611 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/68,
     /* 184613 */   GIR_MakeTempReg, /*TempRegID*/66, /*TypeID*/GILLT_s32,
     /* 184616 */   GIR_BuildMI, /*InsnID*/67, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 184620 */   GIR_AddTempRegister, /*InsnID*/67, /*TempRegID*/66, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184625 */   GIR_AddImm, /*InsnID*/67, /*Imm*/GIMT_Encode8(52428),
     /* 184635 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/67,
     /* 184637 */   GIR_MakeTempReg, /*TempRegID*/65, /*TypeID*/GILLT_s32,
     /* 184640 */   GIR_BuildMI, /*InsnID*/66, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 184644 */   GIR_AddTempRegister, /*InsnID*/66, /*TempRegID*/65, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184649 */   GIR_AddSimpleTempRegister, /*InsnID*/66, /*TempRegID*/66,
     /* 184652 */   GIR_AddImm, /*InsnID*/66, /*Imm*/GIMT_Encode8(52428),
     /* 184662 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/66,
     /* 184664 */   GIR_MakeTempReg, /*TempRegID*/64, /*TypeID*/GILLT_s64,
     /* 184667 */   GIR_BuildMI, /*InsnID*/65, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 184671 */   GIR_AddTempRegister, /*InsnID*/65, /*TempRegID*/64, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184676 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/65,
     /* 184678 */   GIR_MakeTempReg, /*TempRegID*/63, /*TypeID*/GILLT_s64,
     /* 184681 */   GIR_BuildMI, /*InsnID*/64, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 184685 */   GIR_AddTempRegister, /*InsnID*/64, /*TempRegID*/63, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184690 */   GIR_AddSimpleTempRegister, /*InsnID*/64, /*TempRegID*/64,
     /* 184693 */   GIR_AddSimpleTempRegister, /*InsnID*/64, /*TempRegID*/65,
     /* 184696 */   GIR_AddImm8, /*InsnID*/64, /*Imm*/1,
     /* 184699 */   GIR_ConstrainOperandRC, /*InsnID*/64, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 184704 */   GIR_ConstrainOperandRC, /*InsnID*/64, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 184709 */   GIR_ConstrainOperandRC, /*InsnID*/64, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 184714 */   GIR_MakeTempReg, /*TempRegID*/62, /*TypeID*/GILLT_s64,
     /* 184717 */   GIR_BuildMI, /*InsnID*/63, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 184721 */   GIR_AddTempRegister, /*InsnID*/63, /*TempRegID*/62, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184726 */   GIR_AddSimpleTempRegister, /*InsnID*/63, /*TempRegID*/63,
     /* 184729 */   GIR_AddImm8, /*InsnID*/63, /*Imm*/32,
     /* 184732 */   GIR_AddImm8, /*InsnID*/63, /*Imm*/31,
     /* 184735 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/63,
     /* 184737 */   GIR_MakeTempReg, /*TempRegID*/61, /*TypeID*/GILLT_s64,
     /* 184740 */   GIR_BuildMI, /*InsnID*/62, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 184744 */   GIR_AddTempRegister, /*InsnID*/62, /*TempRegID*/61, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184749 */   GIR_AddSimpleTempRegister, /*InsnID*/62, /*TempRegID*/62,
     /* 184752 */   GIR_AddImm, /*InsnID*/62, /*Imm*/GIMT_Encode8(52428),
     /* 184762 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/62,
     /* 184764 */   GIR_MakeTempReg, /*TempRegID*/60, /*TypeID*/GILLT_s64,
     /* 184767 */   GIR_BuildMI, /*InsnID*/61, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 184771 */   GIR_AddTempRegister, /*InsnID*/61, /*TempRegID*/60, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184776 */   GIR_AddSimpleTempRegister, /*InsnID*/61, /*TempRegID*/61,
     /* 184779 */   GIR_AddImm, /*InsnID*/61, /*Imm*/GIMT_Encode8(52428),
     /* 184789 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/61,
     /* 184791 */   GIR_MakeTempReg, /*TempRegID*/59, /*TypeID*/GILLT_s32,
     /* 184794 */   GIR_BuildMI, /*InsnID*/60, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 184798 */   GIR_AddTempRegister, /*InsnID*/60, /*TempRegID*/59, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184803 */   GIR_AddImm, /*InsnID*/60, /*Imm*/GIMT_Encode8(43690),
     /* 184813 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/60,
     /* 184815 */   GIR_MakeTempReg, /*TempRegID*/58, /*TypeID*/GILLT_s32,
     /* 184818 */   GIR_BuildMI, /*InsnID*/59, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 184822 */   GIR_AddTempRegister, /*InsnID*/59, /*TempRegID*/58, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184827 */   GIR_AddSimpleTempRegister, /*InsnID*/59, /*TempRegID*/59,
     /* 184830 */   GIR_AddImm, /*InsnID*/59, /*Imm*/GIMT_Encode8(43690),
     /* 184840 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/59,
     /* 184842 */   GIR_MakeTempReg, /*TempRegID*/57, /*TypeID*/GILLT_s64,
     /* 184845 */   GIR_BuildMI, /*InsnID*/58, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 184849 */   GIR_AddTempRegister, /*InsnID*/58, /*TempRegID*/57, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184854 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/58,
     /* 184856 */   GIR_MakeTempReg, /*TempRegID*/56, /*TypeID*/GILLT_s64,
     /* 184859 */   GIR_BuildMI, /*InsnID*/57, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 184863 */   GIR_AddTempRegister, /*InsnID*/57, /*TempRegID*/56, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184868 */   GIR_AddSimpleTempRegister, /*InsnID*/57, /*TempRegID*/57,
     /* 184871 */   GIR_AddSimpleTempRegister, /*InsnID*/57, /*TempRegID*/58,
     /* 184874 */   GIR_AddImm8, /*InsnID*/57, /*Imm*/1,
     /* 184877 */   GIR_ConstrainOperandRC, /*InsnID*/57, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 184882 */   GIR_ConstrainOperandRC, /*InsnID*/57, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 184887 */   GIR_ConstrainOperandRC, /*InsnID*/57, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 184892 */   GIR_MakeTempReg, /*TempRegID*/55, /*TypeID*/GILLT_s64,
     /* 184895 */   GIR_BuildMI, /*InsnID*/56, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 184899 */   GIR_AddTempRegister, /*InsnID*/56, /*TempRegID*/55, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184904 */   GIR_AddSimpleTempRegister, /*InsnID*/56, /*TempRegID*/56,
     /* 184907 */   GIR_AddImm8, /*InsnID*/56, /*Imm*/32,
     /* 184910 */   GIR_AddImm8, /*InsnID*/56, /*Imm*/31,
     /* 184913 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/56,
     /* 184915 */   GIR_MakeTempReg, /*TempRegID*/54, /*TypeID*/GILLT_s64,
     /* 184918 */   GIR_BuildMI, /*InsnID*/55, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 184922 */   GIR_AddTempRegister, /*InsnID*/55, /*TempRegID*/54, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184927 */   GIR_AddSimpleTempRegister, /*InsnID*/55, /*TempRegID*/55,
     /* 184930 */   GIR_AddImm, /*InsnID*/55, /*Imm*/GIMT_Encode8(43690),
     /* 184940 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/55,
     /* 184942 */   GIR_MakeTempReg, /*TempRegID*/53, /*TypeID*/GILLT_s64,
     /* 184945 */   GIR_BuildMI, /*InsnID*/54, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 184949 */   GIR_AddTempRegister, /*InsnID*/54, /*TempRegID*/53, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184954 */   GIR_AddSimpleTempRegister, /*InsnID*/54, /*TempRegID*/54,
     /* 184957 */   GIR_AddImm, /*InsnID*/54, /*Imm*/GIMT_Encode8(43690),
     /* 184967 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/54,
     /* 184969 */   GIR_MakeTempReg, /*TempRegID*/52, /*TypeID*/GILLT_s64,
     /* 184972 */   GIR_BuildMI, /*InsnID*/53, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 184976 */   GIR_AddTempRegister, /*InsnID*/53, /*TempRegID*/52, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184981 */   GIR_Copy, /*NewInsnID*/53, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 184985 */   GIR_AddImm8, /*InsnID*/53, /*Imm*/1,
     /* 184988 */   GIR_AddImm8, /*InsnID*/53, /*Imm*/62,
     /* 184991 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/53,
     /* 184993 */   GIR_MakeTempReg, /*TempRegID*/51, /*TypeID*/GILLT_s64,
     /* 184996 */   GIR_BuildMI, /*InsnID*/52, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 185000 */   GIR_AddTempRegister, /*InsnID*/52, /*TempRegID*/51, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185005 */   GIR_AddSimpleTempRegister, /*InsnID*/52, /*TempRegID*/52,
     /* 185008 */   GIR_AddSimpleTempRegister, /*InsnID*/52, /*TempRegID*/53,
     /* 185011 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/52,
     /* 185013 */   GIR_MakeTempReg, /*TempRegID*/50, /*TypeID*/GILLT_s32,
     /* 185016 */   GIR_BuildMI, /*InsnID*/51, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 185020 */   GIR_AddTempRegister, /*InsnID*/51, /*TempRegID*/50, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185025 */   GIR_AddImm, /*InsnID*/51, /*Imm*/GIMT_Encode8(21845),
     /* 185035 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/51,
     /* 185037 */   GIR_MakeTempReg, /*TempRegID*/49, /*TypeID*/GILLT_s32,
     /* 185040 */   GIR_BuildMI, /*InsnID*/50, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 185044 */   GIR_AddTempRegister, /*InsnID*/50, /*TempRegID*/49, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185049 */   GIR_AddSimpleTempRegister, /*InsnID*/50, /*TempRegID*/50,
     /* 185052 */   GIR_AddImm, /*InsnID*/50, /*Imm*/GIMT_Encode8(21845),
     /* 185062 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/50,
     /* 185064 */   GIR_MakeTempReg, /*TempRegID*/48, /*TypeID*/GILLT_s64,
     /* 185067 */   GIR_BuildMI, /*InsnID*/49, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 185071 */   GIR_AddTempRegister, /*InsnID*/49, /*TempRegID*/48, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185076 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/49,
     /* 185078 */   GIR_MakeTempReg, /*TempRegID*/47, /*TypeID*/GILLT_s64,
     /* 185081 */   GIR_BuildMI, /*InsnID*/48, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 185085 */   GIR_AddTempRegister, /*InsnID*/48, /*TempRegID*/47, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185090 */   GIR_AddSimpleTempRegister, /*InsnID*/48, /*TempRegID*/48,
     /* 185093 */   GIR_AddSimpleTempRegister, /*InsnID*/48, /*TempRegID*/49,
     /* 185096 */   GIR_AddImm8, /*InsnID*/48, /*Imm*/1,
     /* 185099 */   GIR_ConstrainOperandRC, /*InsnID*/48, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 185104 */   GIR_ConstrainOperandRC, /*InsnID*/48, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 185109 */   GIR_ConstrainOperandRC, /*InsnID*/48, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 185114 */   GIR_MakeTempReg, /*TempRegID*/46, /*TypeID*/GILLT_s64,
     /* 185117 */   GIR_BuildMI, /*InsnID*/47, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 185121 */   GIR_AddTempRegister, /*InsnID*/47, /*TempRegID*/46, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185126 */   GIR_AddSimpleTempRegister, /*InsnID*/47, /*TempRegID*/47,
     /* 185129 */   GIR_AddImm8, /*InsnID*/47, /*Imm*/32,
     /* 185132 */   GIR_AddImm8, /*InsnID*/47, /*Imm*/31,
     /* 185135 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/47,
     /* 185137 */   GIR_MakeTempReg, /*TempRegID*/45, /*TypeID*/GILLT_s64,
     /* 185140 */   GIR_BuildMI, /*InsnID*/46, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 185144 */   GIR_AddTempRegister, /*InsnID*/46, /*TempRegID*/45, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185149 */   GIR_AddSimpleTempRegister, /*InsnID*/46, /*TempRegID*/46,
     /* 185152 */   GIR_AddImm, /*InsnID*/46, /*Imm*/GIMT_Encode8(21845),
     /* 185162 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/46,
     /* 185164 */   GIR_MakeTempReg, /*TempRegID*/44, /*TypeID*/GILLT_s64,
     /* 185167 */   GIR_BuildMI, /*InsnID*/45, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 185171 */   GIR_AddTempRegister, /*InsnID*/45, /*TempRegID*/44, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185176 */   GIR_AddSimpleTempRegister, /*InsnID*/45, /*TempRegID*/45,
     /* 185179 */   GIR_AddImm, /*InsnID*/45, /*Imm*/GIMT_Encode8(21845),
     /* 185189 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/45,
     /* 185191 */   GIR_MakeTempReg, /*TempRegID*/43, /*TypeID*/GILLT_s64,
     /* 185194 */   GIR_BuildMI, /*InsnID*/44, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 185198 */   GIR_AddTempRegister, /*InsnID*/44, /*TempRegID*/43, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185203 */   GIR_Copy, /*NewInsnID*/44, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 185207 */   GIR_AddImm8, /*InsnID*/44, /*Imm*/63,
     /* 185210 */   GIR_AddImm8, /*InsnID*/44, /*Imm*/1,
     /* 185213 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/44,
     /* 185215 */   GIR_MakeTempReg, /*TempRegID*/42, /*TypeID*/GILLT_s64,
     /* 185218 */   GIR_BuildMI, /*InsnID*/43, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 185222 */   GIR_AddTempRegister, /*InsnID*/43, /*TempRegID*/42, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185227 */   GIR_AddSimpleTempRegister, /*InsnID*/43, /*TempRegID*/43,
     /* 185230 */   GIR_AddSimpleTempRegister, /*InsnID*/43, /*TempRegID*/44,
     /* 185233 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/43,
     /* 185235 */   GIR_MakeTempReg, /*TempRegID*/41, /*TypeID*/GILLT_s64,
     /* 185238 */   GIR_BuildMI, /*InsnID*/42, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 185242 */   GIR_AddTempRegister, /*InsnID*/42, /*TempRegID*/41, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185247 */   GIR_AddSimpleTempRegister, /*InsnID*/42, /*TempRegID*/42,
     /* 185250 */   GIR_AddSimpleTempRegister, /*InsnID*/42, /*TempRegID*/51,
     /* 185253 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/42,
     /* 185255 */   GIR_MakeTempReg, /*TempRegID*/40, /*TypeID*/GILLT_s64,
     /* 185258 */   GIR_BuildMI, /*InsnID*/41, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 185262 */   GIR_AddTempRegister, /*InsnID*/41, /*TempRegID*/40, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185267 */   GIR_AddSimpleTempRegister, /*InsnID*/41, /*TempRegID*/41,
     /* 185270 */   GIR_AddImm8, /*InsnID*/41, /*Imm*/2,
     /* 185273 */   GIR_AddImm8, /*InsnID*/41, /*Imm*/61,
     /* 185276 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/41,
     /* 185278 */   GIR_MakeTempReg, /*TempRegID*/39, /*TypeID*/GILLT_s64,
     /* 185281 */   GIR_BuildMI, /*InsnID*/40, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 185285 */   GIR_AddTempRegister, /*InsnID*/40, /*TempRegID*/39, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185290 */   GIR_AddSimpleTempRegister, /*InsnID*/40, /*TempRegID*/40,
     /* 185293 */   GIR_AddSimpleTempRegister, /*InsnID*/40, /*TempRegID*/60,
     /* 185296 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/40,
     /* 185298 */   GIR_MakeTempReg, /*TempRegID*/38, /*TypeID*/GILLT_s32,
     /* 185301 */   GIR_BuildMI, /*InsnID*/39, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 185305 */   GIR_AddTempRegister, /*InsnID*/39, /*TempRegID*/38, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185310 */   GIR_AddImm, /*InsnID*/39, /*Imm*/GIMT_Encode8(13107),
     /* 185320 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/39,
     /* 185322 */   GIR_MakeTempReg, /*TempRegID*/37, /*TypeID*/GILLT_s32,
     /* 185325 */   GIR_BuildMI, /*InsnID*/38, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 185329 */   GIR_AddTempRegister, /*InsnID*/38, /*TempRegID*/37, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185334 */   GIR_AddSimpleTempRegister, /*InsnID*/38, /*TempRegID*/38,
     /* 185337 */   GIR_AddImm, /*InsnID*/38, /*Imm*/GIMT_Encode8(13107),
     /* 185347 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/38,
     /* 185349 */   GIR_MakeTempReg, /*TempRegID*/36, /*TypeID*/GILLT_s64,
     /* 185352 */   GIR_BuildMI, /*InsnID*/37, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 185356 */   GIR_AddTempRegister, /*InsnID*/37, /*TempRegID*/36, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185361 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/37,
     /* 185363 */   GIR_MakeTempReg, /*TempRegID*/35, /*TypeID*/GILLT_s64,
     /* 185366 */   GIR_BuildMI, /*InsnID*/36, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 185370 */   GIR_AddTempRegister, /*InsnID*/36, /*TempRegID*/35, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185375 */   GIR_AddSimpleTempRegister, /*InsnID*/36, /*TempRegID*/36,
     /* 185378 */   GIR_AddSimpleTempRegister, /*InsnID*/36, /*TempRegID*/37,
     /* 185381 */   GIR_AddImm8, /*InsnID*/36, /*Imm*/1,
     /* 185384 */   GIR_ConstrainOperandRC, /*InsnID*/36, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 185389 */   GIR_ConstrainOperandRC, /*InsnID*/36, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 185394 */   GIR_ConstrainOperandRC, /*InsnID*/36, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 185399 */   GIR_MakeTempReg, /*TempRegID*/34, /*TypeID*/GILLT_s64,
     /* 185402 */   GIR_BuildMI, /*InsnID*/35, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 185406 */   GIR_AddTempRegister, /*InsnID*/35, /*TempRegID*/34, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185411 */   GIR_AddSimpleTempRegister, /*InsnID*/35, /*TempRegID*/35,
     /* 185414 */   GIR_AddImm8, /*InsnID*/35, /*Imm*/32,
     /* 185417 */   GIR_AddImm8, /*InsnID*/35, /*Imm*/31,
     /* 185420 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/35,
     /* 185422 */   GIR_MakeTempReg, /*TempRegID*/33, /*TypeID*/GILLT_s64,
     /* 185425 */   GIR_BuildMI, /*InsnID*/34, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 185429 */   GIR_AddTempRegister, /*InsnID*/34, /*TempRegID*/33, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185434 */   GIR_AddSimpleTempRegister, /*InsnID*/34, /*TempRegID*/34,
     /* 185437 */   GIR_AddImm, /*InsnID*/34, /*Imm*/GIMT_Encode8(13107),
     /* 185447 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/34,
     /* 185449 */   GIR_MakeTempReg, /*TempRegID*/32, /*TypeID*/GILLT_s64,
     /* 185452 */   GIR_BuildMI, /*InsnID*/33, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 185456 */   GIR_AddTempRegister, /*InsnID*/33, /*TempRegID*/32, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185461 */   GIR_AddSimpleTempRegister, /*InsnID*/33, /*TempRegID*/33,
     /* 185464 */   GIR_AddImm, /*InsnID*/33, /*Imm*/GIMT_Encode8(13107),
     /* 185474 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/33,
     /* 185476 */   GIR_MakeTempReg, /*TempRegID*/31, /*TypeID*/GILLT_s32,
     /* 185479 */   GIR_BuildMI, /*InsnID*/32, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 185483 */   GIR_AddTempRegister, /*InsnID*/32, /*TempRegID*/31, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185488 */   GIR_AddImm, /*InsnID*/32, /*Imm*/GIMT_Encode8(43690),
     /* 185498 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/32,
     /* 185500 */   GIR_MakeTempReg, /*TempRegID*/30, /*TypeID*/GILLT_s32,
     /* 185503 */   GIR_BuildMI, /*InsnID*/31, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 185507 */   GIR_AddTempRegister, /*InsnID*/31, /*TempRegID*/30, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185512 */   GIR_AddSimpleTempRegister, /*InsnID*/31, /*TempRegID*/31,
     /* 185515 */   GIR_AddImm, /*InsnID*/31, /*Imm*/GIMT_Encode8(43690),
     /* 185525 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/31,
     /* 185527 */   GIR_MakeTempReg, /*TempRegID*/29, /*TypeID*/GILLT_s64,
     /* 185530 */   GIR_BuildMI, /*InsnID*/30, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 185534 */   GIR_AddTempRegister, /*InsnID*/30, /*TempRegID*/29, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185539 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/30,
     /* 185541 */   GIR_MakeTempReg, /*TempRegID*/28, /*TypeID*/GILLT_s64,
     /* 185544 */   GIR_BuildMI, /*InsnID*/29, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 185548 */   GIR_AddTempRegister, /*InsnID*/29, /*TempRegID*/28, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185553 */   GIR_AddSimpleTempRegister, /*InsnID*/29, /*TempRegID*/29,
     /* 185556 */   GIR_AddSimpleTempRegister, /*InsnID*/29, /*TempRegID*/30,
     /* 185559 */   GIR_AddImm8, /*InsnID*/29, /*Imm*/1,
     /* 185562 */   GIR_ConstrainOperandRC, /*InsnID*/29, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 185567 */   GIR_ConstrainOperandRC, /*InsnID*/29, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 185572 */   GIR_ConstrainOperandRC, /*InsnID*/29, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 185577 */   GIR_MakeTempReg, /*TempRegID*/27, /*TypeID*/GILLT_s64,
     /* 185580 */   GIR_BuildMI, /*InsnID*/28, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 185584 */   GIR_AddTempRegister, /*InsnID*/28, /*TempRegID*/27, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185589 */   GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/28,
     /* 185592 */   GIR_AddImm8, /*InsnID*/28, /*Imm*/32,
     /* 185595 */   GIR_AddImm8, /*InsnID*/28, /*Imm*/31,
     /* 185598 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/28,
     /* 185600 */   GIR_MakeTempReg, /*TempRegID*/26, /*TypeID*/GILLT_s64,
     /* 185603 */   GIR_BuildMI, /*InsnID*/27, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 185607 */   GIR_AddTempRegister, /*InsnID*/27, /*TempRegID*/26, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185612 */   GIR_AddSimpleTempRegister, /*InsnID*/27, /*TempRegID*/27,
     /* 185615 */   GIR_AddImm, /*InsnID*/27, /*Imm*/GIMT_Encode8(43690),
     /* 185625 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/27,
     /* 185627 */   GIR_MakeTempReg, /*TempRegID*/25, /*TypeID*/GILLT_s64,
     /* 185630 */   GIR_BuildMI, /*InsnID*/26, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 185634 */   GIR_AddTempRegister, /*InsnID*/26, /*TempRegID*/25, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185639 */   GIR_AddSimpleTempRegister, /*InsnID*/26, /*TempRegID*/26,
     /* 185642 */   GIR_AddImm, /*InsnID*/26, /*Imm*/GIMT_Encode8(43690),
     /* 185652 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/26,
     /* 185654 */   GIR_MakeTempReg, /*TempRegID*/24, /*TypeID*/GILLT_s64,
     /* 185657 */   GIR_BuildMI, /*InsnID*/25, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 185661 */   GIR_AddTempRegister, /*InsnID*/25, /*TempRegID*/24, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185666 */   GIR_Copy, /*NewInsnID*/25, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 185670 */   GIR_AddImm8, /*InsnID*/25, /*Imm*/1,
     /* 185673 */   GIR_AddImm8, /*InsnID*/25, /*Imm*/62,
     /* 185676 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/25,
     /* 185678 */   GIR_MakeTempReg, /*TempRegID*/23, /*TypeID*/GILLT_s64,
     /* 185681 */   GIR_BuildMI, /*InsnID*/24, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 185685 */   GIR_AddTempRegister, /*InsnID*/24, /*TempRegID*/23, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185690 */   GIR_AddSimpleTempRegister, /*InsnID*/24, /*TempRegID*/24,
     /* 185693 */   GIR_AddSimpleTempRegister, /*InsnID*/24, /*TempRegID*/25,
     /* 185696 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/24,
     /* 185698 */   GIR_MakeTempReg, /*TempRegID*/22, /*TypeID*/GILLT_s32,
     /* 185701 */   GIR_BuildMI, /*InsnID*/23, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 185705 */   GIR_AddTempRegister, /*InsnID*/23, /*TempRegID*/22, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185710 */   GIR_AddImm, /*InsnID*/23, /*Imm*/GIMT_Encode8(21845),
     /* 185720 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/23,
     /* 185722 */   GIR_MakeTempReg, /*TempRegID*/21, /*TypeID*/GILLT_s32,
     /* 185725 */   GIR_BuildMI, /*InsnID*/22, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 185729 */   GIR_AddTempRegister, /*InsnID*/22, /*TempRegID*/21, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185734 */   GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/22,
     /* 185737 */   GIR_AddImm, /*InsnID*/22, /*Imm*/GIMT_Encode8(21845),
     /* 185747 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/22,
     /* 185749 */   GIR_MakeTempReg, /*TempRegID*/20, /*TypeID*/GILLT_s64,
     /* 185752 */   GIR_BuildMI, /*InsnID*/21, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 185756 */   GIR_AddTempRegister, /*InsnID*/21, /*TempRegID*/20, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185761 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/21,
     /* 185763 */   GIR_MakeTempReg, /*TempRegID*/19, /*TypeID*/GILLT_s64,
     /* 185766 */   GIR_BuildMI, /*InsnID*/20, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 185770 */   GIR_AddTempRegister, /*InsnID*/20, /*TempRegID*/19, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185775 */   GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/20,
     /* 185778 */   GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/21,
     /* 185781 */   GIR_AddImm8, /*InsnID*/20, /*Imm*/1,
     /* 185784 */   GIR_ConstrainOperandRC, /*InsnID*/20, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 185789 */   GIR_ConstrainOperandRC, /*InsnID*/20, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 185794 */   GIR_ConstrainOperandRC, /*InsnID*/20, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 185799 */   GIR_MakeTempReg, /*TempRegID*/18, /*TypeID*/GILLT_s64,
     /* 185802 */   GIR_BuildMI, /*InsnID*/19, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 185806 */   GIR_AddTempRegister, /*InsnID*/19, /*TempRegID*/18, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185811 */   GIR_AddSimpleTempRegister, /*InsnID*/19, /*TempRegID*/19,
     /* 185814 */   GIR_AddImm8, /*InsnID*/19, /*Imm*/32,
     /* 185817 */   GIR_AddImm8, /*InsnID*/19, /*Imm*/31,
     /* 185820 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/19,
     /* 185822 */   GIR_MakeTempReg, /*TempRegID*/17, /*TypeID*/GILLT_s64,
     /* 185825 */   GIR_BuildMI, /*InsnID*/18, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 185829 */   GIR_AddTempRegister, /*InsnID*/18, /*TempRegID*/17, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185834 */   GIR_AddSimpleTempRegister, /*InsnID*/18, /*TempRegID*/18,
     /* 185837 */   GIR_AddImm, /*InsnID*/18, /*Imm*/GIMT_Encode8(21845),
     /* 185847 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/18,
     /* 185849 */   GIR_MakeTempReg, /*TempRegID*/16, /*TypeID*/GILLT_s64,
     /* 185852 */   GIR_BuildMI, /*InsnID*/17, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 185856 */   GIR_AddTempRegister, /*InsnID*/17, /*TempRegID*/16, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185861 */   GIR_AddSimpleTempRegister, /*InsnID*/17, /*TempRegID*/17,
     /* 185864 */   GIR_AddImm, /*InsnID*/17, /*Imm*/GIMT_Encode8(21845),
     /* 185874 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/17,
     /* 185876 */   GIR_MakeTempReg, /*TempRegID*/15, /*TypeID*/GILLT_s64,
     /* 185879 */   GIR_BuildMI, /*InsnID*/16, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 185883 */   GIR_AddTempRegister, /*InsnID*/16, /*TempRegID*/15, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185888 */   GIR_Copy, /*NewInsnID*/16, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 185892 */   GIR_AddImm8, /*InsnID*/16, /*Imm*/63,
     /* 185895 */   GIR_AddImm8, /*InsnID*/16, /*Imm*/1,
     /* 185898 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/16,
     /* 185900 */   GIR_MakeTempReg, /*TempRegID*/14, /*TypeID*/GILLT_s64,
     /* 185903 */   GIR_BuildMI, /*InsnID*/15, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 185907 */   GIR_AddTempRegister, /*InsnID*/15, /*TempRegID*/14, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185912 */   GIR_AddSimpleTempRegister, /*InsnID*/15, /*TempRegID*/15,
     /* 185915 */   GIR_AddSimpleTempRegister, /*InsnID*/15, /*TempRegID*/16,
     /* 185918 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/15,
     /* 185920 */   GIR_MakeTempReg, /*TempRegID*/13, /*TypeID*/GILLT_s64,
     /* 185923 */   GIR_BuildMI, /*InsnID*/14, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 185927 */   GIR_AddTempRegister, /*InsnID*/14, /*TempRegID*/13, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185932 */   GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/14,
     /* 185935 */   GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/23,
     /* 185938 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/14,
     /* 185940 */   GIR_MakeTempReg, /*TempRegID*/12, /*TypeID*/GILLT_s64,
     /* 185943 */   GIR_BuildMI, /*InsnID*/13, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 185947 */   GIR_AddTempRegister, /*InsnID*/13, /*TempRegID*/12, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185952 */   GIR_AddSimpleTempRegister, /*InsnID*/13, /*TempRegID*/13,
     /* 185955 */   GIR_AddImm8, /*InsnID*/13, /*Imm*/62,
     /* 185958 */   GIR_AddImm8, /*InsnID*/13, /*Imm*/2,
     /* 185961 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/13,
     /* 185963 */   GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s64,
     /* 185966 */   GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 185970 */   GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185975 */   GIR_AddSimpleTempRegister, /*InsnID*/12, /*TempRegID*/12,
     /* 185978 */   GIR_AddSimpleTempRegister, /*InsnID*/12, /*TempRegID*/32,
     /* 185981 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/12,
     /* 185983 */   GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s64,
     /* 185986 */   GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 185990 */   GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185995 */   GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/11,
     /* 185998 */   GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/39,
     /* 186001 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 186003 */   GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s64,
     /* 186006 */   GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 186010 */   GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186015 */   GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 186018 */   GIR_AddImm8, /*InsnID*/10, /*Imm*/60,
     /* 186021 */   GIR_AddImm8, /*InsnID*/10, /*Imm*/4,
     /* 186024 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 186026 */   GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s64,
     /* 186029 */   GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 186033 */   GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186038 */   GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 186041 */   GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/67,
     /* 186044 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 186046 */   GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s64,
     /* 186049 */   GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 186053 */   GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186058 */   GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /* 186061 */   GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/74,
     /* 186064 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 186066 */   GIR_MakeTempReg, /*TempRegID*//* 273(*/0x91, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 186070 */   GIR_BuildMI, /*InsnID*//* 274(*/0x92, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 186075 */   GIR_AddTempRegister, /*InsnID*//* 274(*/0x92, 0x02/*)*/, /*TempRegID*//* 273(*/0x91, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186082 */   GIR_AddImm, /*InsnID*//* 274(*/0x92, 0x02/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 186093 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 274(*/0x92, 0x02/*)*/,
     /* 186096 */   GIR_MakeTempReg, /*TempRegID*//* 272(*/0x90, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 186100 */   GIR_BuildMI, /*InsnID*//* 273(*/0x91, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 186105 */   GIR_AddTempRegister, /*InsnID*//* 273(*/0x91, 0x02/*)*/, /*TempRegID*//* 272(*/0x90, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186112 */   GIR_AddSimpleTempRegister, /*InsnID*//* 273(*/0x91, 0x02/*)*/, /*TempRegID*//* 273(*/0x91, 0x02/*)*/,
     /* 186117 */   GIR_AddImm, /*InsnID*//* 273(*/0x91, 0x02/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 186128 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 273(*/0x91, 0x02/*)*/,
     /* 186131 */   GIR_MakeTempReg, /*TempRegID*//* 271(*/0x8F, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 186135 */   GIR_BuildMI, /*InsnID*//* 272(*/0x90, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 186140 */   GIR_AddTempRegister, /*InsnID*//* 272(*/0x90, 0x02/*)*/, /*TempRegID*//* 271(*/0x8F, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186147 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 272(*/0x90, 0x02/*)*/,
     /* 186150 */   GIR_MakeTempReg, /*TempRegID*//* 270(*/0x8E, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 186154 */   GIR_BuildMI, /*InsnID*//* 271(*/0x8F, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 186159 */   GIR_AddTempRegister, /*InsnID*//* 271(*/0x8F, 0x02/*)*/, /*TempRegID*//* 270(*/0x8E, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186166 */   GIR_AddSimpleTempRegister, /*InsnID*//* 271(*/0x8F, 0x02/*)*/, /*TempRegID*//* 271(*/0x8F, 0x02/*)*/,
     /* 186171 */   GIR_AddSimpleTempRegister, /*InsnID*//* 271(*/0x8F, 0x02/*)*/, /*TempRegID*//* 272(*/0x90, 0x02/*)*/,
     /* 186176 */   GIR_AddImm8, /*InsnID*//* 271(*/0x8F, 0x02/*)*/, /*Imm*/1,
     /* 186180 */   GIR_ConstrainOperandRC, /*InsnID*//* 271(*/0x8F, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 186186 */   GIR_ConstrainOperandRC, /*InsnID*//* 271(*/0x8F, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 186192 */   GIR_ConstrainOperandRC, /*InsnID*//* 271(*/0x8F, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 186198 */   GIR_MakeTempReg, /*TempRegID*//* 269(*/0x8D, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 186202 */   GIR_BuildMI, /*InsnID*//* 270(*/0x8E, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 186207 */   GIR_AddTempRegister, /*InsnID*//* 270(*/0x8E, 0x02/*)*/, /*TempRegID*//* 269(*/0x8D, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186214 */   GIR_AddSimpleTempRegister, /*InsnID*//* 270(*/0x8E, 0x02/*)*/, /*TempRegID*//* 270(*/0x8E, 0x02/*)*/,
     /* 186219 */   GIR_AddImm8, /*InsnID*//* 270(*/0x8E, 0x02/*)*/, /*Imm*/32,
     /* 186223 */   GIR_AddImm8, /*InsnID*//* 270(*/0x8E, 0x02/*)*/, /*Imm*/31,
     /* 186227 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 270(*/0x8E, 0x02/*)*/,
     /* 186230 */   GIR_MakeTempReg, /*TempRegID*//* 268(*/0x8C, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 186234 */   GIR_BuildMI, /*InsnID*//* 269(*/0x8D, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 186239 */   GIR_AddTempRegister, /*InsnID*//* 269(*/0x8D, 0x02/*)*/, /*TempRegID*//* 268(*/0x8C, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186246 */   GIR_AddSimpleTempRegister, /*InsnID*//* 269(*/0x8D, 0x02/*)*/, /*TempRegID*//* 269(*/0x8D, 0x02/*)*/,
     /* 186251 */   GIR_AddImm, /*InsnID*//* 269(*/0x8D, 0x02/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 186262 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 269(*/0x8D, 0x02/*)*/,
     /* 186265 */   GIR_MakeTempReg, /*TempRegID*//* 267(*/0x8B, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 186269 */   GIR_BuildMI, /*InsnID*//* 268(*/0x8C, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 186274 */   GIR_AddTempRegister, /*InsnID*//* 268(*/0x8C, 0x02/*)*/, /*TempRegID*//* 267(*/0x8B, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186281 */   GIR_AddSimpleTempRegister, /*InsnID*//* 268(*/0x8C, 0x02/*)*/, /*TempRegID*//* 268(*/0x8C, 0x02/*)*/,
     /* 186286 */   GIR_AddImm, /*InsnID*//* 268(*/0x8C, 0x02/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 186297 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 268(*/0x8C, 0x02/*)*/,
     /* 186300 */   GIR_MakeTempReg, /*TempRegID*//* 266(*/0x8A, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 186304 */   GIR_BuildMI, /*InsnID*//* 267(*/0x8B, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 186309 */   GIR_AddTempRegister, /*InsnID*//* 267(*/0x8B, 0x02/*)*/, /*TempRegID*//* 266(*/0x8A, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186316 */   GIR_AddImm, /*InsnID*//* 267(*/0x8B, 0x02/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 186327 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 267(*/0x8B, 0x02/*)*/,
     /* 186330 */   GIR_MakeTempReg, /*TempRegID*//* 265(*/0x89, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 186334 */   GIR_BuildMI, /*InsnID*//* 266(*/0x8A, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 186339 */   GIR_AddTempRegister, /*InsnID*//* 266(*/0x8A, 0x02/*)*/, /*TempRegID*//* 265(*/0x89, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186346 */   GIR_AddSimpleTempRegister, /*InsnID*//* 266(*/0x8A, 0x02/*)*/, /*TempRegID*//* 266(*/0x8A, 0x02/*)*/,
     /* 186351 */   GIR_AddImm, /*InsnID*//* 266(*/0x8A, 0x02/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 186362 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 266(*/0x8A, 0x02/*)*/,
     /* 186365 */   GIR_MakeTempReg, /*TempRegID*//* 264(*/0x88, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 186369 */   GIR_BuildMI, /*InsnID*//* 265(*/0x89, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 186374 */   GIR_AddTempRegister, /*InsnID*//* 265(*/0x89, 0x02/*)*/, /*TempRegID*//* 264(*/0x88, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186381 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 265(*/0x89, 0x02/*)*/,
     /* 186384 */   GIR_MakeTempReg, /*TempRegID*//* 263(*/0x87, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 186388 */   GIR_BuildMI, /*InsnID*//* 264(*/0x88, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 186393 */   GIR_AddTempRegister, /*InsnID*//* 264(*/0x88, 0x02/*)*/, /*TempRegID*//* 263(*/0x87, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186400 */   GIR_AddSimpleTempRegister, /*InsnID*//* 264(*/0x88, 0x02/*)*/, /*TempRegID*//* 264(*/0x88, 0x02/*)*/,
     /* 186405 */   GIR_AddSimpleTempRegister, /*InsnID*//* 264(*/0x88, 0x02/*)*/, /*TempRegID*//* 265(*/0x89, 0x02/*)*/,
     /* 186410 */   GIR_AddImm8, /*InsnID*//* 264(*/0x88, 0x02/*)*/, /*Imm*/1,
     /* 186414 */   GIR_ConstrainOperandRC, /*InsnID*//* 264(*/0x88, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 186420 */   GIR_ConstrainOperandRC, /*InsnID*//* 264(*/0x88, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 186426 */   GIR_ConstrainOperandRC, /*InsnID*//* 264(*/0x88, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 186432 */   GIR_MakeTempReg, /*TempRegID*//* 262(*/0x86, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 186436 */   GIR_BuildMI, /*InsnID*//* 263(*/0x87, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 186441 */   GIR_AddTempRegister, /*InsnID*//* 263(*/0x87, 0x02/*)*/, /*TempRegID*//* 262(*/0x86, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186448 */   GIR_AddSimpleTempRegister, /*InsnID*//* 263(*/0x87, 0x02/*)*/, /*TempRegID*//* 263(*/0x87, 0x02/*)*/,
     /* 186453 */   GIR_AddImm8, /*InsnID*//* 263(*/0x87, 0x02/*)*/, /*Imm*/32,
     /* 186457 */   GIR_AddImm8, /*InsnID*//* 263(*/0x87, 0x02/*)*/, /*Imm*/31,
     /* 186461 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 263(*/0x87, 0x02/*)*/,
     /* 186464 */   GIR_MakeTempReg, /*TempRegID*//* 261(*/0x85, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 186468 */   GIR_BuildMI, /*InsnID*//* 262(*/0x86, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 186473 */   GIR_AddTempRegister, /*InsnID*//* 262(*/0x86, 0x02/*)*/, /*TempRegID*//* 261(*/0x85, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186480 */   GIR_AddSimpleTempRegister, /*InsnID*//* 262(*/0x86, 0x02/*)*/, /*TempRegID*//* 262(*/0x86, 0x02/*)*/,
     /* 186485 */   GIR_AddImm, /*InsnID*//* 262(*/0x86, 0x02/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 186496 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 262(*/0x86, 0x02/*)*/,
     /* 186499 */   GIR_MakeTempReg, /*TempRegID*//* 260(*/0x84, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 186503 */   GIR_BuildMI, /*InsnID*//* 261(*/0x85, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 186508 */   GIR_AddTempRegister, /*InsnID*//* 261(*/0x85, 0x02/*)*/, /*TempRegID*//* 260(*/0x84, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186515 */   GIR_AddSimpleTempRegister, /*InsnID*//* 261(*/0x85, 0x02/*)*/, /*TempRegID*//* 261(*/0x85, 0x02/*)*/,
     /* 186520 */   GIR_AddImm, /*InsnID*//* 261(*/0x85, 0x02/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 186531 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 261(*/0x85, 0x02/*)*/,
     /* 186534 */   GIR_MakeTempReg, /*TempRegID*//* 259(*/0x83, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 186538 */   GIR_BuildMI, /*InsnID*//* 260(*/0x84, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 186543 */   GIR_AddTempRegister, /*InsnID*//* 260(*/0x84, 0x02/*)*/, /*TempRegID*//* 259(*/0x83, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186550 */   GIR_AddImm, /*InsnID*//* 260(*/0x84, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 186561 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 260(*/0x84, 0x02/*)*/,
     /* 186564 */   GIR_MakeTempReg, /*TempRegID*//* 258(*/0x82, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 186568 */   GIR_BuildMI, /*InsnID*//* 259(*/0x83, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 186573 */   GIR_AddTempRegister, /*InsnID*//* 259(*/0x83, 0x02/*)*/, /*TempRegID*//* 258(*/0x82, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186580 */   GIR_AddSimpleTempRegister, /*InsnID*//* 259(*/0x83, 0x02/*)*/, /*TempRegID*//* 259(*/0x83, 0x02/*)*/,
     /* 186585 */   GIR_AddImm, /*InsnID*//* 259(*/0x83, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 186596 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 259(*/0x83, 0x02/*)*/,
     /* 186599 */   GIR_MakeTempReg, /*TempRegID*//* 257(*/0x81, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 186603 */   GIR_BuildMI, /*InsnID*//* 258(*/0x82, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 186608 */   GIR_AddTempRegister, /*InsnID*//* 258(*/0x82, 0x02/*)*/, /*TempRegID*//* 257(*/0x81, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186615 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 258(*/0x82, 0x02/*)*/,
     /* 186618 */   GIR_MakeTempReg, /*TempRegID*//* 256(*/0x80, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 186622 */   GIR_BuildMI, /*InsnID*//* 257(*/0x81, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 186627 */   GIR_AddTempRegister, /*InsnID*//* 257(*/0x81, 0x02/*)*/, /*TempRegID*//* 256(*/0x80, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186634 */   GIR_AddSimpleTempRegister, /*InsnID*//* 257(*/0x81, 0x02/*)*/, /*TempRegID*//* 257(*/0x81, 0x02/*)*/,
     /* 186639 */   GIR_AddSimpleTempRegister, /*InsnID*//* 257(*/0x81, 0x02/*)*/, /*TempRegID*//* 258(*/0x82, 0x02/*)*/,
     /* 186644 */   GIR_AddImm8, /*InsnID*//* 257(*/0x81, 0x02/*)*/, /*Imm*/1,
     /* 186648 */   GIR_ConstrainOperandRC, /*InsnID*//* 257(*/0x81, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 186654 */   GIR_ConstrainOperandRC, /*InsnID*//* 257(*/0x81, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 186660 */   GIR_ConstrainOperandRC, /*InsnID*//* 257(*/0x81, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 186666 */   GIR_MakeTempReg, /*TempRegID*//* 255(*/0xFF, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186670 */   GIR_BuildMI, /*InsnID*//* 256(*/0x80, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 186675 */   GIR_AddTempRegister, /*InsnID*//* 256(*/0x80, 0x02/*)*/, /*TempRegID*//* 255(*/0xFF, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186682 */   GIR_AddSimpleTempRegister, /*InsnID*//* 256(*/0x80, 0x02/*)*/, /*TempRegID*//* 256(*/0x80, 0x02/*)*/,
     /* 186687 */   GIR_AddImm8, /*InsnID*//* 256(*/0x80, 0x02/*)*/, /*Imm*/32,
     /* 186691 */   GIR_AddImm8, /*InsnID*//* 256(*/0x80, 0x02/*)*/, /*Imm*/31,
     /* 186695 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 256(*/0x80, 0x02/*)*/,
     /* 186698 */   GIR_MakeTempReg, /*TempRegID*//* 254(*/0xFE, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186702 */   GIR_BuildMI, /*InsnID*//* 255(*/0xFF, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 186707 */   GIR_AddTempRegister, /*InsnID*//* 255(*/0xFF, 0x01/*)*/, /*TempRegID*//* 254(*/0xFE, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186714 */   GIR_AddSimpleTempRegister, /*InsnID*//* 255(*/0xFF, 0x01/*)*/, /*TempRegID*//* 255(*/0xFF, 0x01/*)*/,
     /* 186719 */   GIR_AddImm, /*InsnID*//* 255(*/0xFF, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 186730 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 255(*/0xFF, 0x01/*)*/,
     /* 186733 */   GIR_MakeTempReg, /*TempRegID*//* 253(*/0xFD, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186737 */   GIR_BuildMI, /*InsnID*//* 254(*/0xFE, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 186742 */   GIR_AddTempRegister, /*InsnID*//* 254(*/0xFE, 0x01/*)*/, /*TempRegID*//* 253(*/0xFD, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186749 */   GIR_AddSimpleTempRegister, /*InsnID*//* 254(*/0xFE, 0x01/*)*/, /*TempRegID*//* 254(*/0xFE, 0x01/*)*/,
     /* 186754 */   GIR_AddImm, /*InsnID*//* 254(*/0xFE, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 186765 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 254(*/0xFE, 0x01/*)*/,
     /* 186768 */   GIR_MakeTempReg, /*TempRegID*//* 252(*/0xFC, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186772 */   GIR_BuildMI, /*InsnID*//* 253(*/0xFD, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 186777 */   GIR_AddTempRegister, /*InsnID*//* 253(*/0xFD, 0x01/*)*/, /*TempRegID*//* 252(*/0xFC, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186784 */   GIR_Copy, /*NewInsnID*//* 253(*/0xFD, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 186789 */   GIR_AddImm8, /*InsnID*//* 253(*/0xFD, 0x01/*)*/, /*Imm*/1,
     /* 186793 */   GIR_AddImm8, /*InsnID*//* 253(*/0xFD, 0x01/*)*/, /*Imm*/62,
     /* 186797 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 253(*/0xFD, 0x01/*)*/,
     /* 186800 */   GIR_MakeTempReg, /*TempRegID*//* 251(*/0xFB, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186804 */   GIR_BuildMI, /*InsnID*//* 252(*/0xFC, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 186809 */   GIR_AddTempRegister, /*InsnID*//* 252(*/0xFC, 0x01/*)*/, /*TempRegID*//* 251(*/0xFB, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186816 */   GIR_AddSimpleTempRegister, /*InsnID*//* 252(*/0xFC, 0x01/*)*/, /*TempRegID*//* 252(*/0xFC, 0x01/*)*/,
     /* 186821 */   GIR_AddSimpleTempRegister, /*InsnID*//* 252(*/0xFC, 0x01/*)*/, /*TempRegID*//* 253(*/0xFD, 0x01/*)*/,
     /* 186826 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 252(*/0xFC, 0x01/*)*/,
     /* 186829 */   GIR_MakeTempReg, /*TempRegID*//* 250(*/0xFA, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 186833 */   GIR_BuildMI, /*InsnID*//* 251(*/0xFB, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 186838 */   GIR_AddTempRegister, /*InsnID*//* 251(*/0xFB, 0x01/*)*/, /*TempRegID*//* 250(*/0xFA, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186845 */   GIR_AddImm, /*InsnID*//* 251(*/0xFB, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 186856 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 251(*/0xFB, 0x01/*)*/,
     /* 186859 */   GIR_MakeTempReg, /*TempRegID*//* 249(*/0xF9, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 186863 */   GIR_BuildMI, /*InsnID*//* 250(*/0xFA, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 186868 */   GIR_AddTempRegister, /*InsnID*//* 250(*/0xFA, 0x01/*)*/, /*TempRegID*//* 249(*/0xF9, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186875 */   GIR_AddSimpleTempRegister, /*InsnID*//* 250(*/0xFA, 0x01/*)*/, /*TempRegID*//* 250(*/0xFA, 0x01/*)*/,
     /* 186880 */   GIR_AddImm, /*InsnID*//* 250(*/0xFA, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 186891 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 250(*/0xFA, 0x01/*)*/,
     /* 186894 */   GIR_MakeTempReg, /*TempRegID*//* 248(*/0xF8, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186898 */   GIR_BuildMI, /*InsnID*//* 249(*/0xF9, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 186903 */   GIR_AddTempRegister, /*InsnID*//* 249(*/0xF9, 0x01/*)*/, /*TempRegID*//* 248(*/0xF8, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186910 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 249(*/0xF9, 0x01/*)*/,
     /* 186913 */   GIR_MakeTempReg, /*TempRegID*//* 247(*/0xF7, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186917 */   GIR_BuildMI, /*InsnID*//* 248(*/0xF8, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 186922 */   GIR_AddTempRegister, /*InsnID*//* 248(*/0xF8, 0x01/*)*/, /*TempRegID*//* 247(*/0xF7, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186929 */   GIR_AddSimpleTempRegister, /*InsnID*//* 248(*/0xF8, 0x01/*)*/, /*TempRegID*//* 248(*/0xF8, 0x01/*)*/,
     /* 186934 */   GIR_AddSimpleTempRegister, /*InsnID*//* 248(*/0xF8, 0x01/*)*/, /*TempRegID*//* 249(*/0xF9, 0x01/*)*/,
     /* 186939 */   GIR_AddImm8, /*InsnID*//* 248(*/0xF8, 0x01/*)*/, /*Imm*/1,
     /* 186943 */   GIR_ConstrainOperandRC, /*InsnID*//* 248(*/0xF8, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 186949 */   GIR_ConstrainOperandRC, /*InsnID*//* 248(*/0xF8, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 186955 */   GIR_ConstrainOperandRC, /*InsnID*//* 248(*/0xF8, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 186961 */   GIR_MakeTempReg, /*TempRegID*//* 246(*/0xF6, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186965 */   GIR_BuildMI, /*InsnID*//* 247(*/0xF7, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 186970 */   GIR_AddTempRegister, /*InsnID*//* 247(*/0xF7, 0x01/*)*/, /*TempRegID*//* 246(*/0xF6, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186977 */   GIR_AddSimpleTempRegister, /*InsnID*//* 247(*/0xF7, 0x01/*)*/, /*TempRegID*//* 247(*/0xF7, 0x01/*)*/,
     /* 186982 */   GIR_AddImm8, /*InsnID*//* 247(*/0xF7, 0x01/*)*/, /*Imm*/32,
     /* 186986 */   GIR_AddImm8, /*InsnID*//* 247(*/0xF7, 0x01/*)*/, /*Imm*/31,
     /* 186990 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 247(*/0xF7, 0x01/*)*/,
     /* 186993 */   GIR_MakeTempReg, /*TempRegID*//* 245(*/0xF5, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186997 */   GIR_BuildMI, /*InsnID*//* 246(*/0xF6, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 187002 */   GIR_AddTempRegister, /*InsnID*//* 246(*/0xF6, 0x01/*)*/, /*TempRegID*//* 245(*/0xF5, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187009 */   GIR_AddSimpleTempRegister, /*InsnID*//* 246(*/0xF6, 0x01/*)*/, /*TempRegID*//* 246(*/0xF6, 0x01/*)*/,
     /* 187014 */   GIR_AddImm, /*InsnID*//* 246(*/0xF6, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 187025 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 246(*/0xF6, 0x01/*)*/,
     /* 187028 */   GIR_MakeTempReg, /*TempRegID*//* 244(*/0xF4, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187032 */   GIR_BuildMI, /*InsnID*//* 245(*/0xF5, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 187037 */   GIR_AddTempRegister, /*InsnID*//* 245(*/0xF5, 0x01/*)*/, /*TempRegID*//* 244(*/0xF4, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187044 */   GIR_AddSimpleTempRegister, /*InsnID*//* 245(*/0xF5, 0x01/*)*/, /*TempRegID*//* 245(*/0xF5, 0x01/*)*/,
     /* 187049 */   GIR_AddImm, /*InsnID*//* 245(*/0xF5, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 187060 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 245(*/0xF5, 0x01/*)*/,
     /* 187063 */   GIR_MakeTempReg, /*TempRegID*//* 243(*/0xF3, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187067 */   GIR_BuildMI, /*InsnID*//* 244(*/0xF4, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 187072 */   GIR_AddTempRegister, /*InsnID*//* 244(*/0xF4, 0x01/*)*/, /*TempRegID*//* 243(*/0xF3, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187079 */   GIR_Copy, /*NewInsnID*//* 244(*/0xF4, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 187084 */   GIR_AddImm8, /*InsnID*//* 244(*/0xF4, 0x01/*)*/, /*Imm*/63,
     /* 187088 */   GIR_AddImm8, /*InsnID*//* 244(*/0xF4, 0x01/*)*/, /*Imm*/1,
     /* 187092 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 244(*/0xF4, 0x01/*)*/,
     /* 187095 */   GIR_MakeTempReg, /*TempRegID*//* 242(*/0xF2, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187099 */   GIR_BuildMI, /*InsnID*//* 243(*/0xF3, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 187104 */   GIR_AddTempRegister, /*InsnID*//* 243(*/0xF3, 0x01/*)*/, /*TempRegID*//* 242(*/0xF2, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187111 */   GIR_AddSimpleTempRegister, /*InsnID*//* 243(*/0xF3, 0x01/*)*/, /*TempRegID*//* 243(*/0xF3, 0x01/*)*/,
     /* 187116 */   GIR_AddSimpleTempRegister, /*InsnID*//* 243(*/0xF3, 0x01/*)*/, /*TempRegID*//* 244(*/0xF4, 0x01/*)*/,
     /* 187121 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 243(*/0xF3, 0x01/*)*/,
     /* 187124 */   GIR_MakeTempReg, /*TempRegID*//* 241(*/0xF1, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187128 */   GIR_BuildMI, /*InsnID*//* 242(*/0xF2, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 187133 */   GIR_AddTempRegister, /*InsnID*//* 242(*/0xF2, 0x01/*)*/, /*TempRegID*//* 241(*/0xF1, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187140 */   GIR_AddSimpleTempRegister, /*InsnID*//* 242(*/0xF2, 0x01/*)*/, /*TempRegID*//* 242(*/0xF2, 0x01/*)*/,
     /* 187145 */   GIR_AddSimpleTempRegister, /*InsnID*//* 242(*/0xF2, 0x01/*)*/, /*TempRegID*//* 251(*/0xFB, 0x01/*)*/,
     /* 187150 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 242(*/0xF2, 0x01/*)*/,
     /* 187153 */   GIR_MakeTempReg, /*TempRegID*//* 240(*/0xF0, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187157 */   GIR_BuildMI, /*InsnID*//* 241(*/0xF1, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 187162 */   GIR_AddTempRegister, /*InsnID*//* 241(*/0xF1, 0x01/*)*/, /*TempRegID*//* 240(*/0xF0, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187169 */   GIR_AddSimpleTempRegister, /*InsnID*//* 241(*/0xF1, 0x01/*)*/, /*TempRegID*//* 241(*/0xF1, 0x01/*)*/,
     /* 187174 */   GIR_AddImm8, /*InsnID*//* 241(*/0xF1, 0x01/*)*/, /*Imm*/2,
     /* 187178 */   GIR_AddImm8, /*InsnID*//* 241(*/0xF1, 0x01/*)*/, /*Imm*/61,
     /* 187182 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 241(*/0xF1, 0x01/*)*/,
     /* 187185 */   GIR_MakeTempReg, /*TempRegID*//* 239(*/0xEF, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187189 */   GIR_BuildMI, /*InsnID*//* 240(*/0xF0, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 187194 */   GIR_AddTempRegister, /*InsnID*//* 240(*/0xF0, 0x01/*)*/, /*TempRegID*//* 239(*/0xEF, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187201 */   GIR_AddSimpleTempRegister, /*InsnID*//* 240(*/0xF0, 0x01/*)*/, /*TempRegID*//* 240(*/0xF0, 0x01/*)*/,
     /* 187206 */   GIR_AddSimpleTempRegister, /*InsnID*//* 240(*/0xF0, 0x01/*)*/, /*TempRegID*//* 260(*/0x84, 0x02/*)*/,
     /* 187211 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 240(*/0xF0, 0x01/*)*/,
     /* 187214 */   GIR_MakeTempReg, /*TempRegID*//* 238(*/0xEE, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 187218 */   GIR_BuildMI, /*InsnID*//* 239(*/0xEF, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 187223 */   GIR_AddTempRegister, /*InsnID*//* 239(*/0xEF, 0x01/*)*/, /*TempRegID*//* 238(*/0xEE, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187230 */   GIR_AddImm, /*InsnID*//* 239(*/0xEF, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 187241 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 239(*/0xEF, 0x01/*)*/,
     /* 187244 */   GIR_MakeTempReg, /*TempRegID*//* 237(*/0xED, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 187248 */   GIR_BuildMI, /*InsnID*//* 238(*/0xEE, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 187253 */   GIR_AddTempRegister, /*InsnID*//* 238(*/0xEE, 0x01/*)*/, /*TempRegID*//* 237(*/0xED, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187260 */   GIR_AddSimpleTempRegister, /*InsnID*//* 238(*/0xEE, 0x01/*)*/, /*TempRegID*//* 238(*/0xEE, 0x01/*)*/,
     /* 187265 */   GIR_AddImm, /*InsnID*//* 238(*/0xEE, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 187276 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 238(*/0xEE, 0x01/*)*/,
     /* 187279 */   GIR_MakeTempReg, /*TempRegID*//* 236(*/0xEC, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187283 */   GIR_BuildMI, /*InsnID*//* 237(*/0xED, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 187288 */   GIR_AddTempRegister, /*InsnID*//* 237(*/0xED, 0x01/*)*/, /*TempRegID*//* 236(*/0xEC, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187295 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 237(*/0xED, 0x01/*)*/,
     /* 187298 */   GIR_MakeTempReg, /*TempRegID*//* 235(*/0xEB, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187302 */   GIR_BuildMI, /*InsnID*//* 236(*/0xEC, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 187307 */   GIR_AddTempRegister, /*InsnID*//* 236(*/0xEC, 0x01/*)*/, /*TempRegID*//* 235(*/0xEB, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187314 */   GIR_AddSimpleTempRegister, /*InsnID*//* 236(*/0xEC, 0x01/*)*/, /*TempRegID*//* 236(*/0xEC, 0x01/*)*/,
     /* 187319 */   GIR_AddSimpleTempRegister, /*InsnID*//* 236(*/0xEC, 0x01/*)*/, /*TempRegID*//* 237(*/0xED, 0x01/*)*/,
     /* 187324 */   GIR_AddImm8, /*InsnID*//* 236(*/0xEC, 0x01/*)*/, /*Imm*/1,
     /* 187328 */   GIR_ConstrainOperandRC, /*InsnID*//* 236(*/0xEC, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 187334 */   GIR_ConstrainOperandRC, /*InsnID*//* 236(*/0xEC, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 187340 */   GIR_ConstrainOperandRC, /*InsnID*//* 236(*/0xEC, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 187346 */   GIR_MakeTempReg, /*TempRegID*//* 234(*/0xEA, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187350 */   GIR_BuildMI, /*InsnID*//* 235(*/0xEB, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 187355 */   GIR_AddTempRegister, /*InsnID*//* 235(*/0xEB, 0x01/*)*/, /*TempRegID*//* 234(*/0xEA, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187362 */   GIR_AddSimpleTempRegister, /*InsnID*//* 235(*/0xEB, 0x01/*)*/, /*TempRegID*//* 235(*/0xEB, 0x01/*)*/,
     /* 187367 */   GIR_AddImm8, /*InsnID*//* 235(*/0xEB, 0x01/*)*/, /*Imm*/32,
     /* 187371 */   GIR_AddImm8, /*InsnID*//* 235(*/0xEB, 0x01/*)*/, /*Imm*/31,
     /* 187375 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 235(*/0xEB, 0x01/*)*/,
     /* 187378 */   GIR_MakeTempReg, /*TempRegID*//* 233(*/0xE9, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187382 */   GIR_BuildMI, /*InsnID*//* 234(*/0xEA, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 187387 */   GIR_AddTempRegister, /*InsnID*//* 234(*/0xEA, 0x01/*)*/, /*TempRegID*//* 233(*/0xE9, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187394 */   GIR_AddSimpleTempRegister, /*InsnID*//* 234(*/0xEA, 0x01/*)*/, /*TempRegID*//* 234(*/0xEA, 0x01/*)*/,
     /* 187399 */   GIR_AddImm, /*InsnID*//* 234(*/0xEA, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 187410 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 234(*/0xEA, 0x01/*)*/,
     /* 187413 */   GIR_MakeTempReg, /*TempRegID*//* 232(*/0xE8, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187417 */   GIR_BuildMI, /*InsnID*//* 233(*/0xE9, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 187422 */   GIR_AddTempRegister, /*InsnID*//* 233(*/0xE9, 0x01/*)*/, /*TempRegID*//* 232(*/0xE8, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187429 */   GIR_AddSimpleTempRegister, /*InsnID*//* 233(*/0xE9, 0x01/*)*/, /*TempRegID*//* 233(*/0xE9, 0x01/*)*/,
     /* 187434 */   GIR_AddImm, /*InsnID*//* 233(*/0xE9, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 187445 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 233(*/0xE9, 0x01/*)*/,
     /* 187448 */   GIR_MakeTempReg, /*TempRegID*//* 231(*/0xE7, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 187452 */   GIR_BuildMI, /*InsnID*//* 232(*/0xE8, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 187457 */   GIR_AddTempRegister, /*InsnID*//* 232(*/0xE8, 0x01/*)*/, /*TempRegID*//* 231(*/0xE7, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187464 */   GIR_AddImm, /*InsnID*//* 232(*/0xE8, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 187475 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 232(*/0xE8, 0x01/*)*/,
     /* 187478 */   GIR_MakeTempReg, /*TempRegID*//* 230(*/0xE6, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 187482 */   GIR_BuildMI, /*InsnID*//* 231(*/0xE7, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 187487 */   GIR_AddTempRegister, /*InsnID*//* 231(*/0xE7, 0x01/*)*/, /*TempRegID*//* 230(*/0xE6, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187494 */   GIR_AddSimpleTempRegister, /*InsnID*//* 231(*/0xE7, 0x01/*)*/, /*TempRegID*//* 231(*/0xE7, 0x01/*)*/,
     /* 187499 */   GIR_AddImm, /*InsnID*//* 231(*/0xE7, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 187510 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 231(*/0xE7, 0x01/*)*/,
     /* 187513 */   GIR_MakeTempReg, /*TempRegID*//* 229(*/0xE5, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187517 */   GIR_BuildMI, /*InsnID*//* 230(*/0xE6, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 187522 */   GIR_AddTempRegister, /*InsnID*//* 230(*/0xE6, 0x01/*)*/, /*TempRegID*//* 229(*/0xE5, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187529 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 230(*/0xE6, 0x01/*)*/,
     /* 187532 */   GIR_MakeTempReg, /*TempRegID*//* 228(*/0xE4, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187536 */   GIR_BuildMI, /*InsnID*//* 229(*/0xE5, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 187541 */   GIR_AddTempRegister, /*InsnID*//* 229(*/0xE5, 0x01/*)*/, /*TempRegID*//* 228(*/0xE4, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187548 */   GIR_AddSimpleTempRegister, /*InsnID*//* 229(*/0xE5, 0x01/*)*/, /*TempRegID*//* 229(*/0xE5, 0x01/*)*/,
     /* 187553 */   GIR_AddSimpleTempRegister, /*InsnID*//* 229(*/0xE5, 0x01/*)*/, /*TempRegID*//* 230(*/0xE6, 0x01/*)*/,
     /* 187558 */   GIR_AddImm8, /*InsnID*//* 229(*/0xE5, 0x01/*)*/, /*Imm*/1,
     /* 187562 */   GIR_ConstrainOperandRC, /*InsnID*//* 229(*/0xE5, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 187568 */   GIR_ConstrainOperandRC, /*InsnID*//* 229(*/0xE5, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 187574 */   GIR_ConstrainOperandRC, /*InsnID*//* 229(*/0xE5, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 187580 */   GIR_MakeTempReg, /*TempRegID*//* 227(*/0xE3, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187584 */   GIR_BuildMI, /*InsnID*//* 228(*/0xE4, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 187589 */   GIR_AddTempRegister, /*InsnID*//* 228(*/0xE4, 0x01/*)*/, /*TempRegID*//* 227(*/0xE3, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187596 */   GIR_AddSimpleTempRegister, /*InsnID*//* 228(*/0xE4, 0x01/*)*/, /*TempRegID*//* 228(*/0xE4, 0x01/*)*/,
     /* 187601 */   GIR_AddImm8, /*InsnID*//* 228(*/0xE4, 0x01/*)*/, /*Imm*/32,
     /* 187605 */   GIR_AddImm8, /*InsnID*//* 228(*/0xE4, 0x01/*)*/, /*Imm*/31,
     /* 187609 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 228(*/0xE4, 0x01/*)*/,
     /* 187612 */   GIR_MakeTempReg, /*TempRegID*//* 226(*/0xE2, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187616 */   GIR_BuildMI, /*InsnID*//* 227(*/0xE3, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 187621 */   GIR_AddTempRegister, /*InsnID*//* 227(*/0xE3, 0x01/*)*/, /*TempRegID*//* 226(*/0xE2, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187628 */   GIR_AddSimpleTempRegister, /*InsnID*//* 227(*/0xE3, 0x01/*)*/, /*TempRegID*//* 227(*/0xE3, 0x01/*)*/,
     /* 187633 */   GIR_AddImm, /*InsnID*//* 227(*/0xE3, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 187644 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 227(*/0xE3, 0x01/*)*/,
     /* 187647 */   GIR_MakeTempReg, /*TempRegID*//* 225(*/0xE1, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187651 */   GIR_BuildMI, /*InsnID*//* 226(*/0xE2, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 187656 */   GIR_AddTempRegister, /*InsnID*//* 226(*/0xE2, 0x01/*)*/, /*TempRegID*//* 225(*/0xE1, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187663 */   GIR_AddSimpleTempRegister, /*InsnID*//* 226(*/0xE2, 0x01/*)*/, /*TempRegID*//* 226(*/0xE2, 0x01/*)*/,
     /* 187668 */   GIR_AddImm, /*InsnID*//* 226(*/0xE2, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 187679 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 226(*/0xE2, 0x01/*)*/,
     /* 187682 */   GIR_MakeTempReg, /*TempRegID*//* 224(*/0xE0, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187686 */   GIR_BuildMI, /*InsnID*//* 225(*/0xE1, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 187691 */   GIR_AddTempRegister, /*InsnID*//* 225(*/0xE1, 0x01/*)*/, /*TempRegID*//* 224(*/0xE0, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187698 */   GIR_Copy, /*NewInsnID*//* 225(*/0xE1, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 187703 */   GIR_AddImm8, /*InsnID*//* 225(*/0xE1, 0x01/*)*/, /*Imm*/1,
     /* 187707 */   GIR_AddImm8, /*InsnID*//* 225(*/0xE1, 0x01/*)*/, /*Imm*/62,
     /* 187711 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 225(*/0xE1, 0x01/*)*/,
     /* 187714 */   GIR_MakeTempReg, /*TempRegID*//* 223(*/0xDF, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187718 */   GIR_BuildMI, /*InsnID*//* 224(*/0xE0, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 187723 */   GIR_AddTempRegister, /*InsnID*//* 224(*/0xE0, 0x01/*)*/, /*TempRegID*//* 223(*/0xDF, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187730 */   GIR_AddSimpleTempRegister, /*InsnID*//* 224(*/0xE0, 0x01/*)*/, /*TempRegID*//* 224(*/0xE0, 0x01/*)*/,
     /* 187735 */   GIR_AddSimpleTempRegister, /*InsnID*//* 224(*/0xE0, 0x01/*)*/, /*TempRegID*//* 225(*/0xE1, 0x01/*)*/,
     /* 187740 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 224(*/0xE0, 0x01/*)*/,
     /* 187743 */   GIR_MakeTempReg, /*TempRegID*//* 222(*/0xDE, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 187747 */   GIR_BuildMI, /*InsnID*//* 223(*/0xDF, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 187752 */   GIR_AddTempRegister, /*InsnID*//* 223(*/0xDF, 0x01/*)*/, /*TempRegID*//* 222(*/0xDE, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187759 */   GIR_AddImm, /*InsnID*//* 223(*/0xDF, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 187770 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 223(*/0xDF, 0x01/*)*/,
     /* 187773 */   GIR_MakeTempReg, /*TempRegID*//* 221(*/0xDD, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 187777 */   GIR_BuildMI, /*InsnID*//* 222(*/0xDE, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 187782 */   GIR_AddTempRegister, /*InsnID*//* 222(*/0xDE, 0x01/*)*/, /*TempRegID*//* 221(*/0xDD, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187789 */   GIR_AddSimpleTempRegister, /*InsnID*//* 222(*/0xDE, 0x01/*)*/, /*TempRegID*//* 222(*/0xDE, 0x01/*)*/,
     /* 187794 */   GIR_AddImm, /*InsnID*//* 222(*/0xDE, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 187805 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 222(*/0xDE, 0x01/*)*/,
     /* 187808 */   GIR_MakeTempReg, /*TempRegID*//* 220(*/0xDC, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187812 */   GIR_BuildMI, /*InsnID*//* 221(*/0xDD, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 187817 */   GIR_AddTempRegister, /*InsnID*//* 221(*/0xDD, 0x01/*)*/, /*TempRegID*//* 220(*/0xDC, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187824 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 221(*/0xDD, 0x01/*)*/,
     /* 187827 */   GIR_MakeTempReg, /*TempRegID*//* 219(*/0xDB, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187831 */   GIR_BuildMI, /*InsnID*//* 220(*/0xDC, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 187836 */   GIR_AddTempRegister, /*InsnID*//* 220(*/0xDC, 0x01/*)*/, /*TempRegID*//* 219(*/0xDB, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187843 */   GIR_AddSimpleTempRegister, /*InsnID*//* 220(*/0xDC, 0x01/*)*/, /*TempRegID*//* 220(*/0xDC, 0x01/*)*/,
     /* 187848 */   GIR_AddSimpleTempRegister, /*InsnID*//* 220(*/0xDC, 0x01/*)*/, /*TempRegID*//* 221(*/0xDD, 0x01/*)*/,
     /* 187853 */   GIR_AddImm8, /*InsnID*//* 220(*/0xDC, 0x01/*)*/, /*Imm*/1,
     /* 187857 */   GIR_ConstrainOperandRC, /*InsnID*//* 220(*/0xDC, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 187863 */   GIR_ConstrainOperandRC, /*InsnID*//* 220(*/0xDC, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 187869 */   GIR_ConstrainOperandRC, /*InsnID*//* 220(*/0xDC, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 187875 */   GIR_MakeTempReg, /*TempRegID*//* 218(*/0xDA, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187879 */   GIR_BuildMI, /*InsnID*//* 219(*/0xDB, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 187884 */   GIR_AddTempRegister, /*InsnID*//* 219(*/0xDB, 0x01/*)*/, /*TempRegID*//* 218(*/0xDA, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187891 */   GIR_AddSimpleTempRegister, /*InsnID*//* 219(*/0xDB, 0x01/*)*/, /*TempRegID*//* 219(*/0xDB, 0x01/*)*/,
     /* 187896 */   GIR_AddImm8, /*InsnID*//* 219(*/0xDB, 0x01/*)*/, /*Imm*/32,
     /* 187900 */   GIR_AddImm8, /*InsnID*//* 219(*/0xDB, 0x01/*)*/, /*Imm*/31,
     /* 187904 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 219(*/0xDB, 0x01/*)*/,
     /* 187907 */   GIR_MakeTempReg, /*TempRegID*//* 217(*/0xD9, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187911 */   GIR_BuildMI, /*InsnID*//* 218(*/0xDA, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 187916 */   GIR_AddTempRegister, /*InsnID*//* 218(*/0xDA, 0x01/*)*/, /*TempRegID*//* 217(*/0xD9, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187923 */   GIR_AddSimpleTempRegister, /*InsnID*//* 218(*/0xDA, 0x01/*)*/, /*TempRegID*//* 218(*/0xDA, 0x01/*)*/,
     /* 187928 */   GIR_AddImm, /*InsnID*//* 218(*/0xDA, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 187939 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 218(*/0xDA, 0x01/*)*/,
     /* 187942 */   GIR_MakeTempReg, /*TempRegID*//* 216(*/0xD8, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187946 */   GIR_BuildMI, /*InsnID*//* 217(*/0xD9, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 187951 */   GIR_AddTempRegister, /*InsnID*//* 217(*/0xD9, 0x01/*)*/, /*TempRegID*//* 216(*/0xD8, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187958 */   GIR_AddSimpleTempRegister, /*InsnID*//* 217(*/0xD9, 0x01/*)*/, /*TempRegID*//* 217(*/0xD9, 0x01/*)*/,
     /* 187963 */   GIR_AddImm, /*InsnID*//* 217(*/0xD9, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 187974 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 217(*/0xD9, 0x01/*)*/,
     /* 187977 */   GIR_MakeTempReg, /*TempRegID*//* 215(*/0xD7, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187981 */   GIR_BuildMI, /*InsnID*//* 216(*/0xD8, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 187986 */   GIR_AddTempRegister, /*InsnID*//* 216(*/0xD8, 0x01/*)*/, /*TempRegID*//* 215(*/0xD7, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187993 */   GIR_Copy, /*NewInsnID*//* 216(*/0xD8, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 187998 */   GIR_AddImm8, /*InsnID*//* 216(*/0xD8, 0x01/*)*/, /*Imm*/63,
     /* 188002 */   GIR_AddImm8, /*InsnID*//* 216(*/0xD8, 0x01/*)*/, /*Imm*/1,
     /* 188006 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 216(*/0xD8, 0x01/*)*/,
     /* 188009 */   GIR_MakeTempReg, /*TempRegID*//* 214(*/0xD6, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188013 */   GIR_BuildMI, /*InsnID*//* 215(*/0xD7, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 188018 */   GIR_AddTempRegister, /*InsnID*//* 215(*/0xD7, 0x01/*)*/, /*TempRegID*//* 214(*/0xD6, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188025 */   GIR_AddSimpleTempRegister, /*InsnID*//* 215(*/0xD7, 0x01/*)*/, /*TempRegID*//* 215(*/0xD7, 0x01/*)*/,
     /* 188030 */   GIR_AddSimpleTempRegister, /*InsnID*//* 215(*/0xD7, 0x01/*)*/, /*TempRegID*//* 216(*/0xD8, 0x01/*)*/,
     /* 188035 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 215(*/0xD7, 0x01/*)*/,
     /* 188038 */   GIR_MakeTempReg, /*TempRegID*//* 213(*/0xD5, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188042 */   GIR_BuildMI, /*InsnID*//* 214(*/0xD6, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 188047 */   GIR_AddTempRegister, /*InsnID*//* 214(*/0xD6, 0x01/*)*/, /*TempRegID*//* 213(*/0xD5, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188054 */   GIR_AddSimpleTempRegister, /*InsnID*//* 214(*/0xD6, 0x01/*)*/, /*TempRegID*//* 214(*/0xD6, 0x01/*)*/,
     /* 188059 */   GIR_AddSimpleTempRegister, /*InsnID*//* 214(*/0xD6, 0x01/*)*/, /*TempRegID*//* 223(*/0xDF, 0x01/*)*/,
     /* 188064 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 214(*/0xD6, 0x01/*)*/,
     /* 188067 */   GIR_MakeTempReg, /*TempRegID*//* 212(*/0xD4, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188071 */   GIR_BuildMI, /*InsnID*//* 213(*/0xD5, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 188076 */   GIR_AddTempRegister, /*InsnID*//* 213(*/0xD5, 0x01/*)*/, /*TempRegID*//* 212(*/0xD4, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188083 */   GIR_AddSimpleTempRegister, /*InsnID*//* 213(*/0xD5, 0x01/*)*/, /*TempRegID*//* 213(*/0xD5, 0x01/*)*/,
     /* 188088 */   GIR_AddImm8, /*InsnID*//* 213(*/0xD5, 0x01/*)*/, /*Imm*/62,
     /* 188092 */   GIR_AddImm8, /*InsnID*//* 213(*/0xD5, 0x01/*)*/, /*Imm*/2,
     /* 188096 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 213(*/0xD5, 0x01/*)*/,
     /* 188099 */   GIR_MakeTempReg, /*TempRegID*//* 211(*/0xD3, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188103 */   GIR_BuildMI, /*InsnID*//* 212(*/0xD4, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 188108 */   GIR_AddTempRegister, /*InsnID*//* 212(*/0xD4, 0x01/*)*/, /*TempRegID*//* 211(*/0xD3, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188115 */   GIR_AddSimpleTempRegister, /*InsnID*//* 212(*/0xD4, 0x01/*)*/, /*TempRegID*//* 212(*/0xD4, 0x01/*)*/,
     /* 188120 */   GIR_AddSimpleTempRegister, /*InsnID*//* 212(*/0xD4, 0x01/*)*/, /*TempRegID*//* 232(*/0xE8, 0x01/*)*/,
     /* 188125 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 212(*/0xD4, 0x01/*)*/,
     /* 188128 */   GIR_MakeTempReg, /*TempRegID*//* 210(*/0xD2, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188132 */   GIR_BuildMI, /*InsnID*//* 211(*/0xD3, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 188137 */   GIR_AddTempRegister, /*InsnID*//* 211(*/0xD3, 0x01/*)*/, /*TempRegID*//* 210(*/0xD2, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188144 */   GIR_AddSimpleTempRegister, /*InsnID*//* 211(*/0xD3, 0x01/*)*/, /*TempRegID*//* 211(*/0xD3, 0x01/*)*/,
     /* 188149 */   GIR_AddSimpleTempRegister, /*InsnID*//* 211(*/0xD3, 0x01/*)*/, /*TempRegID*//* 239(*/0xEF, 0x01/*)*/,
     /* 188154 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 211(*/0xD3, 0x01/*)*/,
     /* 188157 */   GIR_MakeTempReg, /*TempRegID*//* 209(*/0xD1, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188161 */   GIR_BuildMI, /*InsnID*//* 210(*/0xD2, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 188166 */   GIR_AddTempRegister, /*InsnID*//* 210(*/0xD2, 0x01/*)*/, /*TempRegID*//* 209(*/0xD1, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188173 */   GIR_AddSimpleTempRegister, /*InsnID*//* 210(*/0xD2, 0x01/*)*/, /*TempRegID*//* 210(*/0xD2, 0x01/*)*/,
     /* 188178 */   GIR_AddImm8, /*InsnID*//* 210(*/0xD2, 0x01/*)*/, /*Imm*/4,
     /* 188182 */   GIR_AddImm8, /*InsnID*//* 210(*/0xD2, 0x01/*)*/, /*Imm*/59,
     /* 188186 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 210(*/0xD2, 0x01/*)*/,
     /* 188189 */   GIR_MakeTempReg, /*TempRegID*//* 208(*/0xD0, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188193 */   GIR_BuildMI, /*InsnID*//* 209(*/0xD1, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 188198 */   GIR_AddTempRegister, /*InsnID*//* 209(*/0xD1, 0x01/*)*/, /*TempRegID*//* 208(*/0xD0, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188205 */   GIR_AddSimpleTempRegister, /*InsnID*//* 209(*/0xD1, 0x01/*)*/, /*TempRegID*//* 209(*/0xD1, 0x01/*)*/,
     /* 188210 */   GIR_AddSimpleTempRegister, /*InsnID*//* 209(*/0xD1, 0x01/*)*/, /*TempRegID*//* 267(*/0x8B, 0x02/*)*/,
     /* 188215 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 209(*/0xD1, 0x01/*)*/,
     /* 188218 */   GIR_MakeTempReg, /*TempRegID*//* 207(*/0xCF, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 188222 */   GIR_BuildMI, /*InsnID*//* 208(*/0xD0, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 188227 */   GIR_AddTempRegister, /*InsnID*//* 208(*/0xD0, 0x01/*)*/, /*TempRegID*//* 207(*/0xCF, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188234 */   GIR_AddImm, /*InsnID*//* 208(*/0xD0, 0x01/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 188245 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 208(*/0xD0, 0x01/*)*/,
     /* 188248 */   GIR_MakeTempReg, /*TempRegID*//* 206(*/0xCE, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 188252 */   GIR_BuildMI, /*InsnID*//* 207(*/0xCF, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 188257 */   GIR_AddTempRegister, /*InsnID*//* 207(*/0xCF, 0x01/*)*/, /*TempRegID*//* 206(*/0xCE, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188264 */   GIR_AddSimpleTempRegister, /*InsnID*//* 207(*/0xCF, 0x01/*)*/, /*TempRegID*//* 207(*/0xCF, 0x01/*)*/,
     /* 188269 */   GIR_AddImm, /*InsnID*//* 207(*/0xCF, 0x01/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 188280 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 207(*/0xCF, 0x01/*)*/,
     /* 188283 */   GIR_MakeTempReg, /*TempRegID*//* 205(*/0xCD, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188287 */   GIR_BuildMI, /*InsnID*//* 206(*/0xCE, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 188292 */   GIR_AddTempRegister, /*InsnID*//* 206(*/0xCE, 0x01/*)*/, /*TempRegID*//* 205(*/0xCD, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188299 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 206(*/0xCE, 0x01/*)*/,
     /* 188302 */   GIR_MakeTempReg, /*TempRegID*//* 204(*/0xCC, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188306 */   GIR_BuildMI, /*InsnID*//* 205(*/0xCD, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 188311 */   GIR_AddTempRegister, /*InsnID*//* 205(*/0xCD, 0x01/*)*/, /*TempRegID*//* 204(*/0xCC, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188318 */   GIR_AddSimpleTempRegister, /*InsnID*//* 205(*/0xCD, 0x01/*)*/, /*TempRegID*//* 205(*/0xCD, 0x01/*)*/,
     /* 188323 */   GIR_AddSimpleTempRegister, /*InsnID*//* 205(*/0xCD, 0x01/*)*/, /*TempRegID*//* 206(*/0xCE, 0x01/*)*/,
     /* 188328 */   GIR_AddImm8, /*InsnID*//* 205(*/0xCD, 0x01/*)*/, /*Imm*/1,
     /* 188332 */   GIR_ConstrainOperandRC, /*InsnID*//* 205(*/0xCD, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 188338 */   GIR_ConstrainOperandRC, /*InsnID*//* 205(*/0xCD, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 188344 */   GIR_ConstrainOperandRC, /*InsnID*//* 205(*/0xCD, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 188350 */   GIR_MakeTempReg, /*TempRegID*//* 203(*/0xCB, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188354 */   GIR_BuildMI, /*InsnID*//* 204(*/0xCC, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 188359 */   GIR_AddTempRegister, /*InsnID*//* 204(*/0xCC, 0x01/*)*/, /*TempRegID*//* 203(*/0xCB, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188366 */   GIR_AddSimpleTempRegister, /*InsnID*//* 204(*/0xCC, 0x01/*)*/, /*TempRegID*//* 204(*/0xCC, 0x01/*)*/,
     /* 188371 */   GIR_AddImm8, /*InsnID*//* 204(*/0xCC, 0x01/*)*/, /*Imm*/32,
     /* 188375 */   GIR_AddImm8, /*InsnID*//* 204(*/0xCC, 0x01/*)*/, /*Imm*/31,
     /* 188379 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 204(*/0xCC, 0x01/*)*/,
     /* 188382 */   GIR_MakeTempReg, /*TempRegID*//* 202(*/0xCA, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188386 */   GIR_BuildMI, /*InsnID*//* 203(*/0xCB, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 188391 */   GIR_AddTempRegister, /*InsnID*//* 203(*/0xCB, 0x01/*)*/, /*TempRegID*//* 202(*/0xCA, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188398 */   GIR_AddSimpleTempRegister, /*InsnID*//* 203(*/0xCB, 0x01/*)*/, /*TempRegID*//* 203(*/0xCB, 0x01/*)*/,
     /* 188403 */   GIR_AddImm, /*InsnID*//* 203(*/0xCB, 0x01/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 188414 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 203(*/0xCB, 0x01/*)*/,
     /* 188417 */   GIR_MakeTempReg, /*TempRegID*//* 201(*/0xC9, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188421 */   GIR_BuildMI, /*InsnID*//* 202(*/0xCA, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 188426 */   GIR_AddTempRegister, /*InsnID*//* 202(*/0xCA, 0x01/*)*/, /*TempRegID*//* 201(*/0xC9, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188433 */   GIR_AddSimpleTempRegister, /*InsnID*//* 202(*/0xCA, 0x01/*)*/, /*TempRegID*//* 202(*/0xCA, 0x01/*)*/,
     /* 188438 */   GIR_AddImm, /*InsnID*//* 202(*/0xCA, 0x01/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 188449 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 202(*/0xCA, 0x01/*)*/,
     /* 188452 */   GIR_MakeTempReg, /*TempRegID*//* 200(*/0xC8, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 188456 */   GIR_BuildMI, /*InsnID*//* 201(*/0xC9, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 188461 */   GIR_AddTempRegister, /*InsnID*//* 201(*/0xC9, 0x01/*)*/, /*TempRegID*//* 200(*/0xC8, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188468 */   GIR_AddImm, /*InsnID*//* 201(*/0xC9, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 188479 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 201(*/0xC9, 0x01/*)*/,
     /* 188482 */   GIR_MakeTempReg, /*TempRegID*//* 199(*/0xC7, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 188486 */   GIR_BuildMI, /*InsnID*//* 200(*/0xC8, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 188491 */   GIR_AddTempRegister, /*InsnID*//* 200(*/0xC8, 0x01/*)*/, /*TempRegID*//* 199(*/0xC7, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188498 */   GIR_AddSimpleTempRegister, /*InsnID*//* 200(*/0xC8, 0x01/*)*/, /*TempRegID*//* 200(*/0xC8, 0x01/*)*/,
     /* 188503 */   GIR_AddImm, /*InsnID*//* 200(*/0xC8, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 188514 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 200(*/0xC8, 0x01/*)*/,
     /* 188517 */   GIR_MakeTempReg, /*TempRegID*//* 198(*/0xC6, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188521 */   GIR_BuildMI, /*InsnID*//* 199(*/0xC7, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 188526 */   GIR_AddTempRegister, /*InsnID*//* 199(*/0xC7, 0x01/*)*/, /*TempRegID*//* 198(*/0xC6, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188533 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 199(*/0xC7, 0x01/*)*/,
     /* 188536 */   GIR_MakeTempReg, /*TempRegID*//* 197(*/0xC5, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188540 */   GIR_BuildMI, /*InsnID*//* 198(*/0xC6, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 188545 */   GIR_AddTempRegister, /*InsnID*//* 198(*/0xC6, 0x01/*)*/, /*TempRegID*//* 197(*/0xC5, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188552 */   GIR_AddSimpleTempRegister, /*InsnID*//* 198(*/0xC6, 0x01/*)*/, /*TempRegID*//* 198(*/0xC6, 0x01/*)*/,
     /* 188557 */   GIR_AddSimpleTempRegister, /*InsnID*//* 198(*/0xC6, 0x01/*)*/, /*TempRegID*//* 199(*/0xC7, 0x01/*)*/,
     /* 188562 */   GIR_AddImm8, /*InsnID*//* 198(*/0xC6, 0x01/*)*/, /*Imm*/1,
     /* 188566 */   GIR_ConstrainOperandRC, /*InsnID*//* 198(*/0xC6, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 188572 */   GIR_ConstrainOperandRC, /*InsnID*//* 198(*/0xC6, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 188578 */   GIR_ConstrainOperandRC, /*InsnID*//* 198(*/0xC6, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 188584 */   GIR_MakeTempReg, /*TempRegID*//* 196(*/0xC4, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188588 */   GIR_BuildMI, /*InsnID*//* 197(*/0xC5, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 188593 */   GIR_AddTempRegister, /*InsnID*//* 197(*/0xC5, 0x01/*)*/, /*TempRegID*//* 196(*/0xC4, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188600 */   GIR_AddSimpleTempRegister, /*InsnID*//* 197(*/0xC5, 0x01/*)*/, /*TempRegID*//* 197(*/0xC5, 0x01/*)*/,
     /* 188605 */   GIR_AddImm8, /*InsnID*//* 197(*/0xC5, 0x01/*)*/, /*Imm*/32,
     /* 188609 */   GIR_AddImm8, /*InsnID*//* 197(*/0xC5, 0x01/*)*/, /*Imm*/31,
     /* 188613 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 197(*/0xC5, 0x01/*)*/,
     /* 188616 */   GIR_MakeTempReg, /*TempRegID*//* 195(*/0xC3, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188620 */   GIR_BuildMI, /*InsnID*//* 196(*/0xC4, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 188625 */   GIR_AddTempRegister, /*InsnID*//* 196(*/0xC4, 0x01/*)*/, /*TempRegID*//* 195(*/0xC3, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188632 */   GIR_AddSimpleTempRegister, /*InsnID*//* 196(*/0xC4, 0x01/*)*/, /*TempRegID*//* 196(*/0xC4, 0x01/*)*/,
     /* 188637 */   GIR_AddImm, /*InsnID*//* 196(*/0xC4, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 188648 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 196(*/0xC4, 0x01/*)*/,
     /* 188651 */   GIR_MakeTempReg, /*TempRegID*//* 194(*/0xC2, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188655 */   GIR_BuildMI, /*InsnID*//* 195(*/0xC3, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 188660 */   GIR_AddTempRegister, /*InsnID*//* 195(*/0xC3, 0x01/*)*/, /*TempRegID*//* 194(*/0xC2, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188667 */   GIR_AddSimpleTempRegister, /*InsnID*//* 195(*/0xC3, 0x01/*)*/, /*TempRegID*//* 195(*/0xC3, 0x01/*)*/,
     /* 188672 */   GIR_AddImm, /*InsnID*//* 195(*/0xC3, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 188683 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 195(*/0xC3, 0x01/*)*/,
     /* 188686 */   GIR_MakeTempReg, /*TempRegID*//* 193(*/0xC1, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 188690 */   GIR_BuildMI, /*InsnID*//* 194(*/0xC2, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 188695 */   GIR_AddTempRegister, /*InsnID*//* 194(*/0xC2, 0x01/*)*/, /*TempRegID*//* 193(*/0xC1, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188702 */   GIR_AddImm, /*InsnID*//* 194(*/0xC2, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 188713 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 194(*/0xC2, 0x01/*)*/,
     /* 188716 */   GIR_MakeTempReg, /*TempRegID*//* 192(*/0xC0, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 188720 */   GIR_BuildMI, /*InsnID*//* 193(*/0xC1, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 188725 */   GIR_AddTempRegister, /*InsnID*//* 193(*/0xC1, 0x01/*)*/, /*TempRegID*//* 192(*/0xC0, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188732 */   GIR_AddSimpleTempRegister, /*InsnID*//* 193(*/0xC1, 0x01/*)*/, /*TempRegID*//* 193(*/0xC1, 0x01/*)*/,
     /* 188737 */   GIR_AddImm, /*InsnID*//* 193(*/0xC1, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 188748 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 193(*/0xC1, 0x01/*)*/,
     /* 188751 */   GIR_MakeTempReg, /*TempRegID*//* 191(*/0xBF, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188755 */   GIR_BuildMI, /*InsnID*//* 192(*/0xC0, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 188760 */   GIR_AddTempRegister, /*InsnID*//* 192(*/0xC0, 0x01/*)*/, /*TempRegID*//* 191(*/0xBF, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188767 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 192(*/0xC0, 0x01/*)*/,
     /* 188770 */   GIR_MakeTempReg, /*TempRegID*//* 190(*/0xBE, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188774 */   GIR_BuildMI, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 188779 */   GIR_AddTempRegister, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*TempRegID*//* 190(*/0xBE, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188786 */   GIR_AddSimpleTempRegister, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*TempRegID*//* 191(*/0xBF, 0x01/*)*/,
     /* 188791 */   GIR_AddSimpleTempRegister, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*TempRegID*//* 192(*/0xC0, 0x01/*)*/,
     /* 188796 */   GIR_AddImm8, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*Imm*/1,
     /* 188800 */   GIR_ConstrainOperandRC, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 188806 */   GIR_ConstrainOperandRC, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 188812 */   GIR_ConstrainOperandRC, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 188818 */   GIR_MakeTempReg, /*TempRegID*//* 189(*/0xBD, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188822 */   GIR_BuildMI, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 188827 */   GIR_AddTempRegister, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*TempRegID*//* 189(*/0xBD, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188834 */   GIR_AddSimpleTempRegister, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*TempRegID*//* 190(*/0xBE, 0x01/*)*/,
     /* 188839 */   GIR_AddImm8, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*Imm*/32,
     /* 188843 */   GIR_AddImm8, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*Imm*/31,
     /* 188847 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 190(*/0xBE, 0x01/*)*/,
     /* 188850 */   GIR_MakeTempReg, /*TempRegID*//* 188(*/0xBC, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188854 */   GIR_BuildMI, /*InsnID*//* 189(*/0xBD, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 188859 */   GIR_AddTempRegister, /*InsnID*//* 189(*/0xBD, 0x01/*)*/, /*TempRegID*//* 188(*/0xBC, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188866 */   GIR_AddSimpleTempRegister, /*InsnID*//* 189(*/0xBD, 0x01/*)*/, /*TempRegID*//* 189(*/0xBD, 0x01/*)*/,
     /* 188871 */   GIR_AddImm, /*InsnID*//* 189(*/0xBD, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 188882 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 189(*/0xBD, 0x01/*)*/,
     /* 188885 */   GIR_MakeTempReg, /*TempRegID*//* 187(*/0xBB, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188889 */   GIR_BuildMI, /*InsnID*//* 188(*/0xBC, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 188894 */   GIR_AddTempRegister, /*InsnID*//* 188(*/0xBC, 0x01/*)*/, /*TempRegID*//* 187(*/0xBB, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188901 */   GIR_AddSimpleTempRegister, /*InsnID*//* 188(*/0xBC, 0x01/*)*/, /*TempRegID*//* 188(*/0xBC, 0x01/*)*/,
     /* 188906 */   GIR_AddImm, /*InsnID*//* 188(*/0xBC, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 188917 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 188(*/0xBC, 0x01/*)*/,
     /* 188920 */   GIR_MakeTempReg, /*TempRegID*//* 186(*/0xBA, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188924 */   GIR_BuildMI, /*InsnID*//* 187(*/0xBB, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 188929 */   GIR_AddTempRegister, /*InsnID*//* 187(*/0xBB, 0x01/*)*/, /*TempRegID*//* 186(*/0xBA, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188936 */   GIR_Copy, /*NewInsnID*//* 187(*/0xBB, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 188941 */   GIR_AddImm8, /*InsnID*//* 187(*/0xBB, 0x01/*)*/, /*Imm*/1,
     /* 188945 */   GIR_AddImm8, /*InsnID*//* 187(*/0xBB, 0x01/*)*/, /*Imm*/62,
     /* 188949 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 187(*/0xBB, 0x01/*)*/,
     /* 188952 */   GIR_MakeTempReg, /*TempRegID*//* 185(*/0xB9, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188956 */   GIR_BuildMI, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 188961 */   GIR_AddTempRegister, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*TempRegID*//* 185(*/0xB9, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188968 */   GIR_AddSimpleTempRegister, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*TempRegID*//* 186(*/0xBA, 0x01/*)*/,
     /* 188973 */   GIR_AddSimpleTempRegister, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*TempRegID*//* 187(*/0xBB, 0x01/*)*/,
     /* 188978 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 186(*/0xBA, 0x01/*)*/,
     /* 188981 */   GIR_MakeTempReg, /*TempRegID*//* 184(*/0xB8, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 188985 */   GIR_BuildMI, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 188990 */   GIR_AddTempRegister, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*TempRegID*//* 184(*/0xB8, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188997 */   GIR_AddImm, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 189008 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 185(*/0xB9, 0x01/*)*/,
     /* 189011 */   GIR_MakeTempReg, /*TempRegID*//* 183(*/0xB7, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 189015 */   GIR_BuildMI, /*InsnID*//* 184(*/0xB8, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 189020 */   GIR_AddTempRegister, /*InsnID*//* 184(*/0xB8, 0x01/*)*/, /*TempRegID*//* 183(*/0xB7, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189027 */   GIR_AddSimpleTempRegister, /*InsnID*//* 184(*/0xB8, 0x01/*)*/, /*TempRegID*//* 184(*/0xB8, 0x01/*)*/,
     /* 189032 */   GIR_AddImm, /*InsnID*//* 184(*/0xB8, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 189043 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 184(*/0xB8, 0x01/*)*/,
     /* 189046 */   GIR_MakeTempReg, /*TempRegID*//* 182(*/0xB6, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189050 */   GIR_BuildMI, /*InsnID*//* 183(*/0xB7, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 189055 */   GIR_AddTempRegister, /*InsnID*//* 183(*/0xB7, 0x01/*)*/, /*TempRegID*//* 182(*/0xB6, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189062 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 183(*/0xB7, 0x01/*)*/,
     /* 189065 */   GIR_MakeTempReg, /*TempRegID*//* 181(*/0xB5, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189069 */   GIR_BuildMI, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 189074 */   GIR_AddTempRegister, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*TempRegID*//* 181(*/0xB5, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189081 */   GIR_AddSimpleTempRegister, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*TempRegID*//* 182(*/0xB6, 0x01/*)*/,
     /* 189086 */   GIR_AddSimpleTempRegister, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*TempRegID*//* 183(*/0xB7, 0x01/*)*/,
     /* 189091 */   GIR_AddImm8, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*Imm*/1,
     /* 189095 */   GIR_ConstrainOperandRC, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 189101 */   GIR_ConstrainOperandRC, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 189107 */   GIR_ConstrainOperandRC, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 189113 */   GIR_MakeTempReg, /*TempRegID*//* 180(*/0xB4, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189117 */   GIR_BuildMI, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 189122 */   GIR_AddTempRegister, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*TempRegID*//* 180(*/0xB4, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189129 */   GIR_AddSimpleTempRegister, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*TempRegID*//* 181(*/0xB5, 0x01/*)*/,
     /* 189134 */   GIR_AddImm8, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*Imm*/32,
     /* 189138 */   GIR_AddImm8, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*Imm*/31,
     /* 189142 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 181(*/0xB5, 0x01/*)*/,
     /* 189145 */   GIR_MakeTempReg, /*TempRegID*//* 179(*/0xB3, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189149 */   GIR_BuildMI, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 189154 */   GIR_AddTempRegister, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*TempRegID*//* 179(*/0xB3, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189161 */   GIR_AddSimpleTempRegister, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*TempRegID*//* 180(*/0xB4, 0x01/*)*/,
     /* 189166 */   GIR_AddImm, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 189177 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 180(*/0xB4, 0x01/*)*/,
     /* 189180 */   GIR_MakeTempReg, /*TempRegID*//* 178(*/0xB2, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189184 */   GIR_BuildMI, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 189189 */   GIR_AddTempRegister, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*TempRegID*//* 178(*/0xB2, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189196 */   GIR_AddSimpleTempRegister, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*TempRegID*//* 179(*/0xB3, 0x01/*)*/,
     /* 189201 */   GIR_AddImm, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 189212 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 179(*/0xB3, 0x01/*)*/,
     /* 189215 */   GIR_MakeTempReg, /*TempRegID*//* 177(*/0xB1, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189219 */   GIR_BuildMI, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 189224 */   GIR_AddTempRegister, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*TempRegID*//* 177(*/0xB1, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189231 */   GIR_Copy, /*NewInsnID*//* 178(*/0xB2, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 189236 */   GIR_AddImm8, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*Imm*/63,
     /* 189240 */   GIR_AddImm8, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*Imm*/1,
     /* 189244 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 178(*/0xB2, 0x01/*)*/,
     /* 189247 */   GIR_MakeTempReg, /*TempRegID*//* 176(*/0xB0, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189251 */   GIR_BuildMI, /*InsnID*//* 177(*/0xB1, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 189256 */   GIR_AddTempRegister, /*InsnID*//* 177(*/0xB1, 0x01/*)*/, /*TempRegID*//* 176(*/0xB0, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189263 */   GIR_AddSimpleTempRegister, /*InsnID*//* 177(*/0xB1, 0x01/*)*/, /*TempRegID*//* 177(*/0xB1, 0x01/*)*/,
     /* 189268 */   GIR_AddSimpleTempRegister, /*InsnID*//* 177(*/0xB1, 0x01/*)*/, /*TempRegID*//* 178(*/0xB2, 0x01/*)*/,
     /* 189273 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 177(*/0xB1, 0x01/*)*/,
     /* 189276 */   GIR_MakeTempReg, /*TempRegID*//* 175(*/0xAF, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189280 */   GIR_BuildMI, /*InsnID*//* 176(*/0xB0, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 189285 */   GIR_AddTempRegister, /*InsnID*//* 176(*/0xB0, 0x01/*)*/, /*TempRegID*//* 175(*/0xAF, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189292 */   GIR_AddSimpleTempRegister, /*InsnID*//* 176(*/0xB0, 0x01/*)*/, /*TempRegID*//* 176(*/0xB0, 0x01/*)*/,
     /* 189297 */   GIR_AddSimpleTempRegister, /*InsnID*//* 176(*/0xB0, 0x01/*)*/, /*TempRegID*//* 185(*/0xB9, 0x01/*)*/,
     /* 189302 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 176(*/0xB0, 0x01/*)*/,
     /* 189305 */   GIR_MakeTempReg, /*TempRegID*//* 174(*/0xAE, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189309 */   GIR_BuildMI, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 189314 */   GIR_AddTempRegister, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*TempRegID*//* 174(*/0xAE, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189321 */   GIR_AddSimpleTempRegister, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*TempRegID*//* 175(*/0xAF, 0x01/*)*/,
     /* 189326 */   GIR_AddImm8, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*Imm*/2,
     /* 189330 */   GIR_AddImm8, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*Imm*/61,
     /* 189334 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 175(*/0xAF, 0x01/*)*/,
     /* 189337 */   GIR_MakeTempReg, /*TempRegID*//* 173(*/0xAD, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189341 */   GIR_BuildMI, /*InsnID*//* 174(*/0xAE, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 189346 */   GIR_AddTempRegister, /*InsnID*//* 174(*/0xAE, 0x01/*)*/, /*TempRegID*//* 173(*/0xAD, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189353 */   GIR_AddSimpleTempRegister, /*InsnID*//* 174(*/0xAE, 0x01/*)*/, /*TempRegID*//* 174(*/0xAE, 0x01/*)*/,
     /* 189358 */   GIR_AddSimpleTempRegister, /*InsnID*//* 174(*/0xAE, 0x01/*)*/, /*TempRegID*//* 194(*/0xC2, 0x01/*)*/,
     /* 189363 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 174(*/0xAE, 0x01/*)*/,
     /* 189366 */   GIR_MakeTempReg, /*TempRegID*//* 172(*/0xAC, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 189370 */   GIR_BuildMI, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 189375 */   GIR_AddTempRegister, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*TempRegID*//* 172(*/0xAC, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189382 */   GIR_AddImm, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 189393 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 173(*/0xAD, 0x01/*)*/,
     /* 189396 */   GIR_MakeTempReg, /*TempRegID*//* 171(*/0xAB, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 189400 */   GIR_BuildMI, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 189405 */   GIR_AddTempRegister, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*TempRegID*//* 171(*/0xAB, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189412 */   GIR_AddSimpleTempRegister, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*TempRegID*//* 172(*/0xAC, 0x01/*)*/,
     /* 189417 */   GIR_AddImm, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 189428 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 172(*/0xAC, 0x01/*)*/,
     /* 189431 */   GIR_MakeTempReg, /*TempRegID*//* 170(*/0xAA, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189435 */   GIR_BuildMI, /*InsnID*//* 171(*/0xAB, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 189440 */   GIR_AddTempRegister, /*InsnID*//* 171(*/0xAB, 0x01/*)*/, /*TempRegID*//* 170(*/0xAA, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189447 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 171(*/0xAB, 0x01/*)*/,
     /* 189450 */   GIR_MakeTempReg, /*TempRegID*//* 169(*/0xA9, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189454 */   GIR_BuildMI, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 189459 */   GIR_AddTempRegister, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*TempRegID*//* 169(*/0xA9, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189466 */   GIR_AddSimpleTempRegister, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*TempRegID*//* 170(*/0xAA, 0x01/*)*/,
     /* 189471 */   GIR_AddSimpleTempRegister, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*TempRegID*//* 171(*/0xAB, 0x01/*)*/,
     /* 189476 */   GIR_AddImm8, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*Imm*/1,
     /* 189480 */   GIR_ConstrainOperandRC, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 189486 */   GIR_ConstrainOperandRC, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 189492 */   GIR_ConstrainOperandRC, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 189498 */   GIR_MakeTempReg, /*TempRegID*//* 168(*/0xA8, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189502 */   GIR_BuildMI, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 189507 */   GIR_AddTempRegister, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*TempRegID*//* 168(*/0xA8, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189514 */   GIR_AddSimpleTempRegister, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*TempRegID*//* 169(*/0xA9, 0x01/*)*/,
     /* 189519 */   GIR_AddImm8, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*Imm*/32,
     /* 189523 */   GIR_AddImm8, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*Imm*/31,
     /* 189527 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 169(*/0xA9, 0x01/*)*/,
     /* 189530 */   GIR_MakeTempReg, /*TempRegID*//* 167(*/0xA7, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189534 */   GIR_BuildMI, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 189539 */   GIR_AddTempRegister, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*TempRegID*//* 167(*/0xA7, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189546 */   GIR_AddSimpleTempRegister, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*TempRegID*//* 168(*/0xA8, 0x01/*)*/,
     /* 189551 */   GIR_AddImm, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 189562 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 168(*/0xA8, 0x01/*)*/,
     /* 189565 */   GIR_MakeTempReg, /*TempRegID*//* 166(*/0xA6, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189569 */   GIR_BuildMI, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 189574 */   GIR_AddTempRegister, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*TempRegID*//* 166(*/0xA6, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189581 */   GIR_AddSimpleTempRegister, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*TempRegID*//* 167(*/0xA7, 0x01/*)*/,
     /* 189586 */   GIR_AddImm, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 189597 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 167(*/0xA7, 0x01/*)*/,
     /* 189600 */   GIR_MakeTempReg, /*TempRegID*//* 165(*/0xA5, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 189604 */   GIR_BuildMI, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 189609 */   GIR_AddTempRegister, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*TempRegID*//* 165(*/0xA5, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189616 */   GIR_AddImm, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 189627 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 166(*/0xA6, 0x01/*)*/,
     /* 189630 */   GIR_MakeTempReg, /*TempRegID*//* 164(*/0xA4, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 189634 */   GIR_BuildMI, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 189639 */   GIR_AddTempRegister, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*TempRegID*//* 164(*/0xA4, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189646 */   GIR_AddSimpleTempRegister, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*TempRegID*//* 165(*/0xA5, 0x01/*)*/,
     /* 189651 */   GIR_AddImm, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 189662 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 165(*/0xA5, 0x01/*)*/,
     /* 189665 */   GIR_MakeTempReg, /*TempRegID*//* 163(*/0xA3, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189669 */   GIR_BuildMI, /*InsnID*//* 164(*/0xA4, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 189674 */   GIR_AddTempRegister, /*InsnID*//* 164(*/0xA4, 0x01/*)*/, /*TempRegID*//* 163(*/0xA3, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189681 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 164(*/0xA4, 0x01/*)*/,
     /* 189684 */   GIR_MakeTempReg, /*TempRegID*//* 162(*/0xA2, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189688 */   GIR_BuildMI, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 189693 */   GIR_AddTempRegister, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*TempRegID*//* 162(*/0xA2, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189700 */   GIR_AddSimpleTempRegister, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*TempRegID*//* 163(*/0xA3, 0x01/*)*/,
     /* 189705 */   GIR_AddSimpleTempRegister, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*TempRegID*//* 164(*/0xA4, 0x01/*)*/,
     /* 189710 */   GIR_AddImm8, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*Imm*/1,
     /* 189714 */   GIR_ConstrainOperandRC, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 189720 */   GIR_ConstrainOperandRC, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 189726 */   GIR_ConstrainOperandRC, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 189732 */   GIR_MakeTempReg, /*TempRegID*//* 161(*/0xA1, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189736 */   GIR_BuildMI, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 189741 */   GIR_AddTempRegister, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*TempRegID*//* 161(*/0xA1, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189748 */   GIR_AddSimpleTempRegister, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*TempRegID*//* 162(*/0xA2, 0x01/*)*/,
     /* 189753 */   GIR_AddImm8, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*Imm*/32,
     /* 189757 */   GIR_AddImm8, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*Imm*/31,
     /* 189761 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 162(*/0xA2, 0x01/*)*/,
     /* 189764 */   GIR_MakeTempReg, /*TempRegID*//* 160(*/0xA0, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189768 */   GIR_BuildMI, /*InsnID*//* 161(*/0xA1, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 189773 */   GIR_AddTempRegister, /*InsnID*//* 161(*/0xA1, 0x01/*)*/, /*TempRegID*//* 160(*/0xA0, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189780 */   GIR_AddSimpleTempRegister, /*InsnID*//* 161(*/0xA1, 0x01/*)*/, /*TempRegID*//* 161(*/0xA1, 0x01/*)*/,
     /* 189785 */   GIR_AddImm, /*InsnID*//* 161(*/0xA1, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 189796 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 161(*/0xA1, 0x01/*)*/,
     /* 189799 */   GIR_MakeTempReg, /*TempRegID*//* 159(*/0x9F, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189803 */   GIR_BuildMI, /*InsnID*//* 160(*/0xA0, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 189808 */   GIR_AddTempRegister, /*InsnID*//* 160(*/0xA0, 0x01/*)*/, /*TempRegID*//* 159(*/0x9F, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189815 */   GIR_AddSimpleTempRegister, /*InsnID*//* 160(*/0xA0, 0x01/*)*/, /*TempRegID*//* 160(*/0xA0, 0x01/*)*/,
     /* 189820 */   GIR_AddImm, /*InsnID*//* 160(*/0xA0, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 189831 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 160(*/0xA0, 0x01/*)*/,
     /* 189834 */   GIR_MakeTempReg, /*TempRegID*//* 158(*/0x9E, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189838 */   GIR_BuildMI, /*InsnID*//* 159(*/0x9F, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 189843 */   GIR_AddTempRegister, /*InsnID*//* 159(*/0x9F, 0x01/*)*/, /*TempRegID*//* 158(*/0x9E, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189850 */   GIR_Copy, /*NewInsnID*//* 159(*/0x9F, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 189855 */   GIR_AddImm8, /*InsnID*//* 159(*/0x9F, 0x01/*)*/, /*Imm*/1,
     /* 189859 */   GIR_AddImm8, /*InsnID*//* 159(*/0x9F, 0x01/*)*/, /*Imm*/62,
     /* 189863 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 159(*/0x9F, 0x01/*)*/,
     /* 189866 */   GIR_MakeTempReg, /*TempRegID*//* 157(*/0x9D, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189870 */   GIR_BuildMI, /*InsnID*//* 158(*/0x9E, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 189875 */   GIR_AddTempRegister, /*InsnID*//* 158(*/0x9E, 0x01/*)*/, /*TempRegID*//* 157(*/0x9D, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189882 */   GIR_AddSimpleTempRegister, /*InsnID*//* 158(*/0x9E, 0x01/*)*/, /*TempRegID*//* 158(*/0x9E, 0x01/*)*/,
     /* 189887 */   GIR_AddSimpleTempRegister, /*InsnID*//* 158(*/0x9E, 0x01/*)*/, /*TempRegID*//* 159(*/0x9F, 0x01/*)*/,
     /* 189892 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 158(*/0x9E, 0x01/*)*/,
     /* 189895 */   GIR_MakeTempReg, /*TempRegID*//* 156(*/0x9C, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 189899 */   GIR_BuildMI, /*InsnID*//* 157(*/0x9D, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 189904 */   GIR_AddTempRegister, /*InsnID*//* 157(*/0x9D, 0x01/*)*/, /*TempRegID*//* 156(*/0x9C, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189911 */   GIR_AddImm, /*InsnID*//* 157(*/0x9D, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 189922 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 157(*/0x9D, 0x01/*)*/,
     /* 189925 */   GIR_MakeTempReg, /*TempRegID*//* 155(*/0x9B, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 189929 */   GIR_BuildMI, /*InsnID*//* 156(*/0x9C, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 189934 */   GIR_AddTempRegister, /*InsnID*//* 156(*/0x9C, 0x01/*)*/, /*TempRegID*//* 155(*/0x9B, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189941 */   GIR_AddSimpleTempRegister, /*InsnID*//* 156(*/0x9C, 0x01/*)*/, /*TempRegID*//* 156(*/0x9C, 0x01/*)*/,
     /* 189946 */   GIR_AddImm, /*InsnID*//* 156(*/0x9C, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 189957 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 156(*/0x9C, 0x01/*)*/,
     /* 189960 */   GIR_MakeTempReg, /*TempRegID*//* 154(*/0x9A, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189964 */   GIR_BuildMI, /*InsnID*//* 155(*/0x9B, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 189969 */   GIR_AddTempRegister, /*InsnID*//* 155(*/0x9B, 0x01/*)*/, /*TempRegID*//* 154(*/0x9A, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189976 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 155(*/0x9B, 0x01/*)*/,
     /* 189979 */   GIR_MakeTempReg, /*TempRegID*//* 153(*/0x99, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189983 */   GIR_BuildMI, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 189988 */   GIR_AddTempRegister, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*TempRegID*//* 153(*/0x99, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189995 */   GIR_AddSimpleTempRegister, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*TempRegID*//* 154(*/0x9A, 0x01/*)*/,
     /* 190000 */   GIR_AddSimpleTempRegister, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*TempRegID*//* 155(*/0x9B, 0x01/*)*/,
     /* 190005 */   GIR_AddImm8, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*Imm*/1,
     /* 190009 */   GIR_ConstrainOperandRC, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 190015 */   GIR_ConstrainOperandRC, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 190021 */   GIR_ConstrainOperandRC, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 190027 */   GIR_MakeTempReg, /*TempRegID*//* 152(*/0x98, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 190031 */   GIR_BuildMI, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 190036 */   GIR_AddTempRegister, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*TempRegID*//* 152(*/0x98, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190043 */   GIR_AddSimpleTempRegister, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*TempRegID*//* 153(*/0x99, 0x01/*)*/,
     /* 190048 */   GIR_AddImm8, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*Imm*/32,
     /* 190052 */   GIR_AddImm8, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*Imm*/31,
     /* 190056 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 153(*/0x99, 0x01/*)*/,
     /* 190059 */   GIR_MakeTempReg, /*TempRegID*//* 151(*/0x97, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 190063 */   GIR_BuildMI, /*InsnID*//* 152(*/0x98, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 190068 */   GIR_AddTempRegister, /*InsnID*//* 152(*/0x98, 0x01/*)*/, /*TempRegID*//* 151(*/0x97, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190075 */   GIR_AddSimpleTempRegister, /*InsnID*//* 152(*/0x98, 0x01/*)*/, /*TempRegID*//* 152(*/0x98, 0x01/*)*/,
     /* 190080 */   GIR_AddImm, /*InsnID*//* 152(*/0x98, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 190091 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 152(*/0x98, 0x01/*)*/,
     /* 190094 */   GIR_MakeTempReg, /*TempRegID*//* 150(*/0x96, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 190098 */   GIR_BuildMI, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 190103 */   GIR_AddTempRegister, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*TempRegID*//* 150(*/0x96, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190110 */   GIR_AddSimpleTempRegister, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*TempRegID*//* 151(*/0x97, 0x01/*)*/,
     /* 190115 */   GIR_AddImm, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 190126 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 151(*/0x97, 0x01/*)*/,
     /* 190129 */   GIR_MakeTempReg, /*TempRegID*//* 149(*/0x95, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 190133 */   GIR_BuildMI, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 190138 */   GIR_AddTempRegister, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*TempRegID*//* 149(*/0x95, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190145 */   GIR_Copy, /*NewInsnID*//* 150(*/0x96, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 190150 */   GIR_AddImm8, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*Imm*/63,
     /* 190154 */   GIR_AddImm8, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*Imm*/1,
     /* 190158 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 150(*/0x96, 0x01/*)*/,
     /* 190161 */   GIR_MakeTempReg, /*TempRegID*//* 148(*/0x94, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 190165 */   GIR_BuildMI, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 190170 */   GIR_AddTempRegister, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*TempRegID*//* 148(*/0x94, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190177 */   GIR_AddSimpleTempRegister, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*TempRegID*//* 149(*/0x95, 0x01/*)*/,
     /* 190182 */   GIR_AddSimpleTempRegister, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*TempRegID*//* 150(*/0x96, 0x01/*)*/,
     /* 190187 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 149(*/0x95, 0x01/*)*/,
     /* 190190 */   GIR_MakeTempReg, /*TempRegID*//* 147(*/0x93, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 190194 */   GIR_BuildMI, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 190199 */   GIR_AddTempRegister, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*TempRegID*//* 147(*/0x93, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190206 */   GIR_AddSimpleTempRegister, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*TempRegID*//* 148(*/0x94, 0x01/*)*/,
     /* 190211 */   GIR_AddSimpleTempRegister, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*TempRegID*//* 157(*/0x9D, 0x01/*)*/,
     /* 190216 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 148(*/0x94, 0x01/*)*/,
     /* 190219 */   GIR_MakeTempReg, /*TempRegID*//* 146(*/0x92, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 190223 */   GIR_BuildMI, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 190228 */   GIR_AddTempRegister, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*TempRegID*//* 146(*/0x92, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190235 */   GIR_AddSimpleTempRegister, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*TempRegID*//* 147(*/0x93, 0x01/*)*/,
     /* 190240 */   GIR_AddImm8, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*Imm*/62,
     /* 190244 */   GIR_AddImm8, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*Imm*/2,
     /* 190248 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 147(*/0x93, 0x01/*)*/,
     /* 190251 */   GIR_MakeTempReg, /*TempRegID*//* 145(*/0x91, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 190255 */   GIR_BuildMI, /*InsnID*//* 146(*/0x92, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 190260 */   GIR_AddTempRegister, /*InsnID*//* 146(*/0x92, 0x01/*)*/, /*TempRegID*//* 145(*/0x91, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190267 */   GIR_AddSimpleTempRegister, /*InsnID*//* 146(*/0x92, 0x01/*)*/, /*TempRegID*//* 146(*/0x92, 0x01/*)*/,
     /* 190272 */   GIR_AddSimpleTempRegister, /*InsnID*//* 146(*/0x92, 0x01/*)*/, /*TempRegID*//* 166(*/0xA6, 0x01/*)*/,
     /* 190277 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 146(*/0x92, 0x01/*)*/,
     /* 190280 */   GIR_MakeTempReg, /*TempRegID*//* 144(*/0x90, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 190284 */   GIR_BuildMI, /*InsnID*//* 145(*/0x91, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 190289 */   GIR_AddTempRegister, /*InsnID*//* 145(*/0x91, 0x01/*)*/, /*TempRegID*//* 144(*/0x90, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190296 */   GIR_AddSimpleTempRegister, /*InsnID*//* 145(*/0x91, 0x01/*)*/, /*TempRegID*//* 145(*/0x91, 0x01/*)*/,
     /* 190301 */   GIR_AddSimpleTempRegister, /*InsnID*//* 145(*/0x91, 0x01/*)*/, /*TempRegID*//* 173(*/0xAD, 0x01/*)*/,
     /* 190306 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 145(*/0x91, 0x01/*)*/,
     /* 190309 */   GIR_MakeTempReg, /*TempRegID*//* 143(*/0x8F, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 190313 */   GIR_BuildMI, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 190318 */   GIR_AddTempRegister, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*TempRegID*//* 143(*/0x8F, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190325 */   GIR_AddSimpleTempRegister, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*TempRegID*//* 144(*/0x90, 0x01/*)*/,
     /* 190330 */   GIR_AddImm8, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*Imm*/60,
     /* 190334 */   GIR_AddImm8, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*Imm*/4,
     /* 190338 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 144(*/0x90, 0x01/*)*/,
     /* 190341 */   GIR_MakeTempReg, /*TempRegID*//* 142(*/0x8E, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 190345 */   GIR_BuildMI, /*InsnID*//* 143(*/0x8F, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 190350 */   GIR_AddTempRegister, /*InsnID*//* 143(*/0x8F, 0x01/*)*/, /*TempRegID*//* 142(*/0x8E, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190357 */   GIR_AddSimpleTempRegister, /*InsnID*//* 143(*/0x8F, 0x01/*)*/, /*TempRegID*//* 143(*/0x8F, 0x01/*)*/,
     /* 190362 */   GIR_AddSimpleTempRegister, /*InsnID*//* 143(*/0x8F, 0x01/*)*/, /*TempRegID*//* 201(*/0xC9, 0x01/*)*/,
     /* 190367 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 143(*/0x8F, 0x01/*)*/,
     /* 190370 */   GIR_MakeTempReg, /*TempRegID*//* 141(*/0x8D, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 190374 */   GIR_BuildMI, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 190379 */   GIR_AddTempRegister, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*TempRegID*//* 141(*/0x8D, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190386 */   GIR_AddSimpleTempRegister, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*TempRegID*//* 142(*/0x8E, 0x01/*)*/,
     /* 190391 */   GIR_AddSimpleTempRegister, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*TempRegID*//* 208(*/0xD0, 0x01/*)*/,
     /* 190396 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 142(*/0x8E, 0x01/*)*/,
     /* 190399 */   GIR_MakeTempReg, /*TempRegID*//* 407(*/0x97, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 190403 */   GIR_BuildMI, /*InsnID*//* 408(*/0x98, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 190408 */   GIR_AddTempRegister, /*InsnID*//* 408(*/0x98, 0x03/*)*/, /*TempRegID*//* 407(*/0x97, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190415 */   GIR_AddImm, /*InsnID*//* 408(*/0x98, 0x03/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 190426 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 408(*/0x98, 0x03/*)*/,
     /* 190429 */   GIR_MakeTempReg, /*TempRegID*//* 406(*/0x96, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 190433 */   GIR_BuildMI, /*InsnID*//* 407(*/0x97, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 190438 */   GIR_AddTempRegister, /*InsnID*//* 407(*/0x97, 0x03/*)*/, /*TempRegID*//* 406(*/0x96, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190445 */   GIR_AddSimpleTempRegister, /*InsnID*//* 407(*/0x97, 0x03/*)*/, /*TempRegID*//* 407(*/0x97, 0x03/*)*/,
     /* 190450 */   GIR_AddImm, /*InsnID*//* 407(*/0x97, 0x03/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 190461 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 407(*/0x97, 0x03/*)*/,
     /* 190464 */   GIR_MakeTempReg, /*TempRegID*//* 405(*/0x95, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190468 */   GIR_BuildMI, /*InsnID*//* 406(*/0x96, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 190473 */   GIR_AddTempRegister, /*InsnID*//* 406(*/0x96, 0x03/*)*/, /*TempRegID*//* 405(*/0x95, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190480 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 406(*/0x96, 0x03/*)*/,
     /* 190483 */   GIR_MakeTempReg, /*TempRegID*//* 404(*/0x94, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190487 */   GIR_BuildMI, /*InsnID*//* 405(*/0x95, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 190492 */   GIR_AddTempRegister, /*InsnID*//* 405(*/0x95, 0x03/*)*/, /*TempRegID*//* 404(*/0x94, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190499 */   GIR_AddSimpleTempRegister, /*InsnID*//* 405(*/0x95, 0x03/*)*/, /*TempRegID*//* 405(*/0x95, 0x03/*)*/,
     /* 190504 */   GIR_AddSimpleTempRegister, /*InsnID*//* 405(*/0x95, 0x03/*)*/, /*TempRegID*//* 406(*/0x96, 0x03/*)*/,
     /* 190509 */   GIR_AddImm8, /*InsnID*//* 405(*/0x95, 0x03/*)*/, /*Imm*/1,
     /* 190513 */   GIR_ConstrainOperandRC, /*InsnID*//* 405(*/0x95, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 190519 */   GIR_ConstrainOperandRC, /*InsnID*//* 405(*/0x95, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 190525 */   GIR_ConstrainOperandRC, /*InsnID*//* 405(*/0x95, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 190531 */   GIR_MakeTempReg, /*TempRegID*//* 403(*/0x93, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190535 */   GIR_BuildMI, /*InsnID*//* 404(*/0x94, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 190540 */   GIR_AddTempRegister, /*InsnID*//* 404(*/0x94, 0x03/*)*/, /*TempRegID*//* 403(*/0x93, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190547 */   GIR_AddSimpleTempRegister, /*InsnID*//* 404(*/0x94, 0x03/*)*/, /*TempRegID*//* 404(*/0x94, 0x03/*)*/,
     /* 190552 */   GIR_AddImm8, /*InsnID*//* 404(*/0x94, 0x03/*)*/, /*Imm*/32,
     /* 190556 */   GIR_AddImm8, /*InsnID*//* 404(*/0x94, 0x03/*)*/, /*Imm*/31,
     /* 190560 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 404(*/0x94, 0x03/*)*/,
     /* 190563 */   GIR_MakeTempReg, /*TempRegID*//* 402(*/0x92, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190567 */   GIR_BuildMI, /*InsnID*//* 403(*/0x93, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 190572 */   GIR_AddTempRegister, /*InsnID*//* 403(*/0x93, 0x03/*)*/, /*TempRegID*//* 402(*/0x92, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190579 */   GIR_AddSimpleTempRegister, /*InsnID*//* 403(*/0x93, 0x03/*)*/, /*TempRegID*//* 403(*/0x93, 0x03/*)*/,
     /* 190584 */   GIR_AddImm, /*InsnID*//* 403(*/0x93, 0x03/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 190595 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 403(*/0x93, 0x03/*)*/,
     /* 190598 */   GIR_MakeTempReg, /*TempRegID*//* 401(*/0x91, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190602 */   GIR_BuildMI, /*InsnID*//* 402(*/0x92, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 190607 */   GIR_AddTempRegister, /*InsnID*//* 402(*/0x92, 0x03/*)*/, /*TempRegID*//* 401(*/0x91, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190614 */   GIR_AddSimpleTempRegister, /*InsnID*//* 402(*/0x92, 0x03/*)*/, /*TempRegID*//* 402(*/0x92, 0x03/*)*/,
     /* 190619 */   GIR_AddImm, /*InsnID*//* 402(*/0x92, 0x03/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 190630 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 402(*/0x92, 0x03/*)*/,
     /* 190633 */   GIR_MakeTempReg, /*TempRegID*//* 400(*/0x90, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 190637 */   GIR_BuildMI, /*InsnID*//* 401(*/0x91, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 190642 */   GIR_AddTempRegister, /*InsnID*//* 401(*/0x91, 0x03/*)*/, /*TempRegID*//* 400(*/0x90, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190649 */   GIR_AddImm, /*InsnID*//* 401(*/0x91, 0x03/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 190660 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 401(*/0x91, 0x03/*)*/,
     /* 190663 */   GIR_MakeTempReg, /*TempRegID*//* 399(*/0x8F, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 190667 */   GIR_BuildMI, /*InsnID*//* 400(*/0x90, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 190672 */   GIR_AddTempRegister, /*InsnID*//* 400(*/0x90, 0x03/*)*/, /*TempRegID*//* 399(*/0x8F, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190679 */   GIR_AddSimpleTempRegister, /*InsnID*//* 400(*/0x90, 0x03/*)*/, /*TempRegID*//* 400(*/0x90, 0x03/*)*/,
     /* 190684 */   GIR_AddImm, /*InsnID*//* 400(*/0x90, 0x03/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 190695 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 400(*/0x90, 0x03/*)*/,
     /* 190698 */   GIR_MakeTempReg, /*TempRegID*//* 398(*/0x8E, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190702 */   GIR_BuildMI, /*InsnID*//* 399(*/0x8F, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 190707 */   GIR_AddTempRegister, /*InsnID*//* 399(*/0x8F, 0x03/*)*/, /*TempRegID*//* 398(*/0x8E, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190714 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 399(*/0x8F, 0x03/*)*/,
     /* 190717 */   GIR_MakeTempReg, /*TempRegID*//* 397(*/0x8D, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190721 */   GIR_BuildMI, /*InsnID*//* 398(*/0x8E, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 190726 */   GIR_AddTempRegister, /*InsnID*//* 398(*/0x8E, 0x03/*)*/, /*TempRegID*//* 397(*/0x8D, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190733 */   GIR_AddSimpleTempRegister, /*InsnID*//* 398(*/0x8E, 0x03/*)*/, /*TempRegID*//* 398(*/0x8E, 0x03/*)*/,
     /* 190738 */   GIR_AddSimpleTempRegister, /*InsnID*//* 398(*/0x8E, 0x03/*)*/, /*TempRegID*//* 399(*/0x8F, 0x03/*)*/,
     /* 190743 */   GIR_AddImm8, /*InsnID*//* 398(*/0x8E, 0x03/*)*/, /*Imm*/1,
     /* 190747 */   GIR_ConstrainOperandRC, /*InsnID*//* 398(*/0x8E, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 190753 */   GIR_ConstrainOperandRC, /*InsnID*//* 398(*/0x8E, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 190759 */   GIR_ConstrainOperandRC, /*InsnID*//* 398(*/0x8E, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 190765 */   GIR_MakeTempReg, /*TempRegID*//* 396(*/0x8C, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190769 */   GIR_BuildMI, /*InsnID*//* 397(*/0x8D, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 190774 */   GIR_AddTempRegister, /*InsnID*//* 397(*/0x8D, 0x03/*)*/, /*TempRegID*//* 396(*/0x8C, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190781 */   GIR_AddSimpleTempRegister, /*InsnID*//* 397(*/0x8D, 0x03/*)*/, /*TempRegID*//* 397(*/0x8D, 0x03/*)*/,
     /* 190786 */   GIR_AddImm8, /*InsnID*//* 397(*/0x8D, 0x03/*)*/, /*Imm*/32,
     /* 190790 */   GIR_AddImm8, /*InsnID*//* 397(*/0x8D, 0x03/*)*/, /*Imm*/31,
     /* 190794 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 397(*/0x8D, 0x03/*)*/,
     /* 190797 */   GIR_MakeTempReg, /*TempRegID*//* 395(*/0x8B, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190801 */   GIR_BuildMI, /*InsnID*//* 396(*/0x8C, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 190806 */   GIR_AddTempRegister, /*InsnID*//* 396(*/0x8C, 0x03/*)*/, /*TempRegID*//* 395(*/0x8B, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190813 */   GIR_AddSimpleTempRegister, /*InsnID*//* 396(*/0x8C, 0x03/*)*/, /*TempRegID*//* 396(*/0x8C, 0x03/*)*/,
     /* 190818 */   GIR_AddImm, /*InsnID*//* 396(*/0x8C, 0x03/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 190829 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 396(*/0x8C, 0x03/*)*/,
     /* 190832 */   GIR_MakeTempReg, /*TempRegID*//* 394(*/0x8A, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190836 */   GIR_BuildMI, /*InsnID*//* 395(*/0x8B, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 190841 */   GIR_AddTempRegister, /*InsnID*//* 395(*/0x8B, 0x03/*)*/, /*TempRegID*//* 394(*/0x8A, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190848 */   GIR_AddSimpleTempRegister, /*InsnID*//* 395(*/0x8B, 0x03/*)*/, /*TempRegID*//* 395(*/0x8B, 0x03/*)*/,
     /* 190853 */   GIR_AddImm, /*InsnID*//* 395(*/0x8B, 0x03/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 190864 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 395(*/0x8B, 0x03/*)*/,
     /* 190867 */   GIR_MakeTempReg, /*TempRegID*//* 393(*/0x89, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 190871 */   GIR_BuildMI, /*InsnID*//* 394(*/0x8A, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 190876 */   GIR_AddTempRegister, /*InsnID*//* 394(*/0x8A, 0x03/*)*/, /*TempRegID*//* 393(*/0x89, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190883 */   GIR_AddImm, /*InsnID*//* 394(*/0x8A, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 190894 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 394(*/0x8A, 0x03/*)*/,
     /* 190897 */   GIR_MakeTempReg, /*TempRegID*//* 392(*/0x88, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 190901 */   GIR_BuildMI, /*InsnID*//* 393(*/0x89, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 190906 */   GIR_AddTempRegister, /*InsnID*//* 393(*/0x89, 0x03/*)*/, /*TempRegID*//* 392(*/0x88, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190913 */   GIR_AddSimpleTempRegister, /*InsnID*//* 393(*/0x89, 0x03/*)*/, /*TempRegID*//* 393(*/0x89, 0x03/*)*/,
     /* 190918 */   GIR_AddImm, /*InsnID*//* 393(*/0x89, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 190929 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 393(*/0x89, 0x03/*)*/,
     /* 190932 */   GIR_MakeTempReg, /*TempRegID*//* 391(*/0x87, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190936 */   GIR_BuildMI, /*InsnID*//* 392(*/0x88, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 190941 */   GIR_AddTempRegister, /*InsnID*//* 392(*/0x88, 0x03/*)*/, /*TempRegID*//* 391(*/0x87, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190948 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 392(*/0x88, 0x03/*)*/,
     /* 190951 */   GIR_MakeTempReg, /*TempRegID*//* 390(*/0x86, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190955 */   GIR_BuildMI, /*InsnID*//* 391(*/0x87, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 190960 */   GIR_AddTempRegister, /*InsnID*//* 391(*/0x87, 0x03/*)*/, /*TempRegID*//* 390(*/0x86, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190967 */   GIR_AddSimpleTempRegister, /*InsnID*//* 391(*/0x87, 0x03/*)*/, /*TempRegID*//* 391(*/0x87, 0x03/*)*/,
     /* 190972 */   GIR_AddSimpleTempRegister, /*InsnID*//* 391(*/0x87, 0x03/*)*/, /*TempRegID*//* 392(*/0x88, 0x03/*)*/,
     /* 190977 */   GIR_AddImm8, /*InsnID*//* 391(*/0x87, 0x03/*)*/, /*Imm*/1,
     /* 190981 */   GIR_ConstrainOperandRC, /*InsnID*//* 391(*/0x87, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 190987 */   GIR_ConstrainOperandRC, /*InsnID*//* 391(*/0x87, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 190993 */   GIR_ConstrainOperandRC, /*InsnID*//* 391(*/0x87, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 190999 */   GIR_MakeTempReg, /*TempRegID*//* 389(*/0x85, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 191003 */   GIR_BuildMI, /*InsnID*//* 390(*/0x86, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 191008 */   GIR_AddTempRegister, /*InsnID*//* 390(*/0x86, 0x03/*)*/, /*TempRegID*//* 389(*/0x85, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191015 */   GIR_AddSimpleTempRegister, /*InsnID*//* 390(*/0x86, 0x03/*)*/, /*TempRegID*//* 390(*/0x86, 0x03/*)*/,
     /* 191020 */   GIR_AddImm8, /*InsnID*//* 390(*/0x86, 0x03/*)*/, /*Imm*/32,
     /* 191024 */   GIR_AddImm8, /*InsnID*//* 390(*/0x86, 0x03/*)*/, /*Imm*/31,
     /* 191028 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 390(*/0x86, 0x03/*)*/,
     /* 191031 */   GIR_MakeTempReg, /*TempRegID*//* 388(*/0x84, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 191035 */   GIR_BuildMI, /*InsnID*//* 389(*/0x85, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 191040 */   GIR_AddTempRegister, /*InsnID*//* 389(*/0x85, 0x03/*)*/, /*TempRegID*//* 388(*/0x84, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191047 */   GIR_AddSimpleTempRegister, /*InsnID*//* 389(*/0x85, 0x03/*)*/, /*TempRegID*//* 389(*/0x85, 0x03/*)*/,
     /* 191052 */   GIR_AddImm, /*InsnID*//* 389(*/0x85, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 191063 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 389(*/0x85, 0x03/*)*/,
     /* 191066 */   GIR_MakeTempReg, /*TempRegID*//* 387(*/0x83, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 191070 */   GIR_BuildMI, /*InsnID*//* 388(*/0x84, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 191075 */   GIR_AddTempRegister, /*InsnID*//* 388(*/0x84, 0x03/*)*/, /*TempRegID*//* 387(*/0x83, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191082 */   GIR_AddSimpleTempRegister, /*InsnID*//* 388(*/0x84, 0x03/*)*/, /*TempRegID*//* 388(*/0x84, 0x03/*)*/,
     /* 191087 */   GIR_AddImm, /*InsnID*//* 388(*/0x84, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 191098 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 388(*/0x84, 0x03/*)*/,
     /* 191101 */   GIR_MakeTempReg, /*TempRegID*//* 386(*/0x82, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 191105 */   GIR_BuildMI, /*InsnID*//* 387(*/0x83, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 191110 */   GIR_AddTempRegister, /*InsnID*//* 387(*/0x83, 0x03/*)*/, /*TempRegID*//* 386(*/0x82, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191117 */   GIR_Copy, /*NewInsnID*//* 387(*/0x83, 0x03/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 191122 */   GIR_AddImm8, /*InsnID*//* 387(*/0x83, 0x03/*)*/, /*Imm*/1,
     /* 191126 */   GIR_AddImm8, /*InsnID*//* 387(*/0x83, 0x03/*)*/, /*Imm*/62,
     /* 191130 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 387(*/0x83, 0x03/*)*/,
     /* 191133 */   GIR_MakeTempReg, /*TempRegID*//* 385(*/0x81, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 191137 */   GIR_BuildMI, /*InsnID*//* 386(*/0x82, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 191142 */   GIR_AddTempRegister, /*InsnID*//* 386(*/0x82, 0x03/*)*/, /*TempRegID*//* 385(*/0x81, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191149 */   GIR_AddSimpleTempRegister, /*InsnID*//* 386(*/0x82, 0x03/*)*/, /*TempRegID*//* 386(*/0x82, 0x03/*)*/,
     /* 191154 */   GIR_AddSimpleTempRegister, /*InsnID*//* 386(*/0x82, 0x03/*)*/, /*TempRegID*//* 387(*/0x83, 0x03/*)*/,
     /* 191159 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 386(*/0x82, 0x03/*)*/,
     /* 191162 */   GIR_MakeTempReg, /*TempRegID*//* 384(*/0x80, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 191166 */   GIR_BuildMI, /*InsnID*//* 385(*/0x81, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 191171 */   GIR_AddTempRegister, /*InsnID*//* 385(*/0x81, 0x03/*)*/, /*TempRegID*//* 384(*/0x80, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191178 */   GIR_AddImm, /*InsnID*//* 385(*/0x81, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 191189 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 385(*/0x81, 0x03/*)*/,
     /* 191192 */   GIR_MakeTempReg, /*TempRegID*//* 383(*/0xFF, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 191196 */   GIR_BuildMI, /*InsnID*//* 384(*/0x80, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 191201 */   GIR_AddTempRegister, /*InsnID*//* 384(*/0x80, 0x03/*)*/, /*TempRegID*//* 383(*/0xFF, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191208 */   GIR_AddSimpleTempRegister, /*InsnID*//* 384(*/0x80, 0x03/*)*/, /*TempRegID*//* 384(*/0x80, 0x03/*)*/,
     /* 191213 */   GIR_AddImm, /*InsnID*//* 384(*/0x80, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 191224 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 384(*/0x80, 0x03/*)*/,
     /* 191227 */   GIR_MakeTempReg, /*TempRegID*//* 382(*/0xFE, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191231 */   GIR_BuildMI, /*InsnID*//* 383(*/0xFF, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 191236 */   GIR_AddTempRegister, /*InsnID*//* 383(*/0xFF, 0x02/*)*/, /*TempRegID*//* 382(*/0xFE, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191243 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 383(*/0xFF, 0x02/*)*/,
     /* 191246 */   GIR_MakeTempReg, /*TempRegID*//* 381(*/0xFD, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191250 */   GIR_BuildMI, /*InsnID*//* 382(*/0xFE, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 191255 */   GIR_AddTempRegister, /*InsnID*//* 382(*/0xFE, 0x02/*)*/, /*TempRegID*//* 381(*/0xFD, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191262 */   GIR_AddSimpleTempRegister, /*InsnID*//* 382(*/0xFE, 0x02/*)*/, /*TempRegID*//* 382(*/0xFE, 0x02/*)*/,
     /* 191267 */   GIR_AddSimpleTempRegister, /*InsnID*//* 382(*/0xFE, 0x02/*)*/, /*TempRegID*//* 383(*/0xFF, 0x02/*)*/,
     /* 191272 */   GIR_AddImm8, /*InsnID*//* 382(*/0xFE, 0x02/*)*/, /*Imm*/1,
     /* 191276 */   GIR_ConstrainOperandRC, /*InsnID*//* 382(*/0xFE, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 191282 */   GIR_ConstrainOperandRC, /*InsnID*//* 382(*/0xFE, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 191288 */   GIR_ConstrainOperandRC, /*InsnID*//* 382(*/0xFE, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 191294 */   GIR_MakeTempReg, /*TempRegID*//* 380(*/0xFC, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191298 */   GIR_BuildMI, /*InsnID*//* 381(*/0xFD, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 191303 */   GIR_AddTempRegister, /*InsnID*//* 381(*/0xFD, 0x02/*)*/, /*TempRegID*//* 380(*/0xFC, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191310 */   GIR_AddSimpleTempRegister, /*InsnID*//* 381(*/0xFD, 0x02/*)*/, /*TempRegID*//* 381(*/0xFD, 0x02/*)*/,
     /* 191315 */   GIR_AddImm8, /*InsnID*//* 381(*/0xFD, 0x02/*)*/, /*Imm*/32,
     /* 191319 */   GIR_AddImm8, /*InsnID*//* 381(*/0xFD, 0x02/*)*/, /*Imm*/31,
     /* 191323 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 381(*/0xFD, 0x02/*)*/,
     /* 191326 */   GIR_MakeTempReg, /*TempRegID*//* 379(*/0xFB, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191330 */   GIR_BuildMI, /*InsnID*//* 380(*/0xFC, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 191335 */   GIR_AddTempRegister, /*InsnID*//* 380(*/0xFC, 0x02/*)*/, /*TempRegID*//* 379(*/0xFB, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191342 */   GIR_AddSimpleTempRegister, /*InsnID*//* 380(*/0xFC, 0x02/*)*/, /*TempRegID*//* 380(*/0xFC, 0x02/*)*/,
     /* 191347 */   GIR_AddImm, /*InsnID*//* 380(*/0xFC, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 191358 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 380(*/0xFC, 0x02/*)*/,
     /* 191361 */   GIR_MakeTempReg, /*TempRegID*//* 378(*/0xFA, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191365 */   GIR_BuildMI, /*InsnID*//* 379(*/0xFB, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 191370 */   GIR_AddTempRegister, /*InsnID*//* 379(*/0xFB, 0x02/*)*/, /*TempRegID*//* 378(*/0xFA, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191377 */   GIR_AddSimpleTempRegister, /*InsnID*//* 379(*/0xFB, 0x02/*)*/, /*TempRegID*//* 379(*/0xFB, 0x02/*)*/,
     /* 191382 */   GIR_AddImm, /*InsnID*//* 379(*/0xFB, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 191393 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 379(*/0xFB, 0x02/*)*/,
     /* 191396 */   GIR_MakeTempReg, /*TempRegID*//* 377(*/0xF9, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191400 */   GIR_BuildMI, /*InsnID*//* 378(*/0xFA, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 191405 */   GIR_AddTempRegister, /*InsnID*//* 378(*/0xFA, 0x02/*)*/, /*TempRegID*//* 377(*/0xF9, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191412 */   GIR_Copy, /*NewInsnID*//* 378(*/0xFA, 0x02/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 191417 */   GIR_AddImm8, /*InsnID*//* 378(*/0xFA, 0x02/*)*/, /*Imm*/63,
     /* 191421 */   GIR_AddImm8, /*InsnID*//* 378(*/0xFA, 0x02/*)*/, /*Imm*/1,
     /* 191425 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 378(*/0xFA, 0x02/*)*/,
     /* 191428 */   GIR_MakeTempReg, /*TempRegID*//* 376(*/0xF8, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191432 */   GIR_BuildMI, /*InsnID*//* 377(*/0xF9, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 191437 */   GIR_AddTempRegister, /*InsnID*//* 377(*/0xF9, 0x02/*)*/, /*TempRegID*//* 376(*/0xF8, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191444 */   GIR_AddSimpleTempRegister, /*InsnID*//* 377(*/0xF9, 0x02/*)*/, /*TempRegID*//* 377(*/0xF9, 0x02/*)*/,
     /* 191449 */   GIR_AddSimpleTempRegister, /*InsnID*//* 377(*/0xF9, 0x02/*)*/, /*TempRegID*//* 378(*/0xFA, 0x02/*)*/,
     /* 191454 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 377(*/0xF9, 0x02/*)*/,
     /* 191457 */   GIR_MakeTempReg, /*TempRegID*//* 375(*/0xF7, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191461 */   GIR_BuildMI, /*InsnID*//* 376(*/0xF8, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 191466 */   GIR_AddTempRegister, /*InsnID*//* 376(*/0xF8, 0x02/*)*/, /*TempRegID*//* 375(*/0xF7, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191473 */   GIR_AddSimpleTempRegister, /*InsnID*//* 376(*/0xF8, 0x02/*)*/, /*TempRegID*//* 376(*/0xF8, 0x02/*)*/,
     /* 191478 */   GIR_AddSimpleTempRegister, /*InsnID*//* 376(*/0xF8, 0x02/*)*/, /*TempRegID*//* 385(*/0x81, 0x03/*)*/,
     /* 191483 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 376(*/0xF8, 0x02/*)*/,
     /* 191486 */   GIR_MakeTempReg, /*TempRegID*//* 374(*/0xF6, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191490 */   GIR_BuildMI, /*InsnID*//* 375(*/0xF7, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 191495 */   GIR_AddTempRegister, /*InsnID*//* 375(*/0xF7, 0x02/*)*/, /*TempRegID*//* 374(*/0xF6, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191502 */   GIR_AddSimpleTempRegister, /*InsnID*//* 375(*/0xF7, 0x02/*)*/, /*TempRegID*//* 375(*/0xF7, 0x02/*)*/,
     /* 191507 */   GIR_AddImm8, /*InsnID*//* 375(*/0xF7, 0x02/*)*/, /*Imm*/2,
     /* 191511 */   GIR_AddImm8, /*InsnID*//* 375(*/0xF7, 0x02/*)*/, /*Imm*/61,
     /* 191515 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 375(*/0xF7, 0x02/*)*/,
     /* 191518 */   GIR_MakeTempReg, /*TempRegID*//* 373(*/0xF5, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191522 */   GIR_BuildMI, /*InsnID*//* 374(*/0xF6, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 191527 */   GIR_AddTempRegister, /*InsnID*//* 374(*/0xF6, 0x02/*)*/, /*TempRegID*//* 373(*/0xF5, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191534 */   GIR_AddSimpleTempRegister, /*InsnID*//* 374(*/0xF6, 0x02/*)*/, /*TempRegID*//* 374(*/0xF6, 0x02/*)*/,
     /* 191539 */   GIR_AddSimpleTempRegister, /*InsnID*//* 374(*/0xF6, 0x02/*)*/, /*TempRegID*//* 394(*/0x8A, 0x03/*)*/,
     /* 191544 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 374(*/0xF6, 0x02/*)*/,
     /* 191547 */   GIR_MakeTempReg, /*TempRegID*//* 372(*/0xF4, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 191551 */   GIR_BuildMI, /*InsnID*//* 373(*/0xF5, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 191556 */   GIR_AddTempRegister, /*InsnID*//* 373(*/0xF5, 0x02/*)*/, /*TempRegID*//* 372(*/0xF4, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191563 */   GIR_AddImm, /*InsnID*//* 373(*/0xF5, 0x02/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 191574 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 373(*/0xF5, 0x02/*)*/,
     /* 191577 */   GIR_MakeTempReg, /*TempRegID*//* 371(*/0xF3, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 191581 */   GIR_BuildMI, /*InsnID*//* 372(*/0xF4, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 191586 */   GIR_AddTempRegister, /*InsnID*//* 372(*/0xF4, 0x02/*)*/, /*TempRegID*//* 371(*/0xF3, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191593 */   GIR_AddSimpleTempRegister, /*InsnID*//* 372(*/0xF4, 0x02/*)*/, /*TempRegID*//* 372(*/0xF4, 0x02/*)*/,
     /* 191598 */   GIR_AddImm, /*InsnID*//* 372(*/0xF4, 0x02/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 191609 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 372(*/0xF4, 0x02/*)*/,
     /* 191612 */   GIR_MakeTempReg, /*TempRegID*//* 370(*/0xF2, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191616 */   GIR_BuildMI, /*InsnID*//* 371(*/0xF3, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 191621 */   GIR_AddTempRegister, /*InsnID*//* 371(*/0xF3, 0x02/*)*/, /*TempRegID*//* 370(*/0xF2, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191628 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 371(*/0xF3, 0x02/*)*/,
     /* 191631 */   GIR_MakeTempReg, /*TempRegID*//* 369(*/0xF1, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191635 */   GIR_BuildMI, /*InsnID*//* 370(*/0xF2, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 191640 */   GIR_AddTempRegister, /*InsnID*//* 370(*/0xF2, 0x02/*)*/, /*TempRegID*//* 369(*/0xF1, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191647 */   GIR_AddSimpleTempRegister, /*InsnID*//* 370(*/0xF2, 0x02/*)*/, /*TempRegID*//* 370(*/0xF2, 0x02/*)*/,
     /* 191652 */   GIR_AddSimpleTempRegister, /*InsnID*//* 370(*/0xF2, 0x02/*)*/, /*TempRegID*//* 371(*/0xF3, 0x02/*)*/,
     /* 191657 */   GIR_AddImm8, /*InsnID*//* 370(*/0xF2, 0x02/*)*/, /*Imm*/1,
     /* 191661 */   GIR_ConstrainOperandRC, /*InsnID*//* 370(*/0xF2, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 191667 */   GIR_ConstrainOperandRC, /*InsnID*//* 370(*/0xF2, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 191673 */   GIR_ConstrainOperandRC, /*InsnID*//* 370(*/0xF2, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 191679 */   GIR_MakeTempReg, /*TempRegID*//* 368(*/0xF0, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191683 */   GIR_BuildMI, /*InsnID*//* 369(*/0xF1, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 191688 */   GIR_AddTempRegister, /*InsnID*//* 369(*/0xF1, 0x02/*)*/, /*TempRegID*//* 368(*/0xF0, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191695 */   GIR_AddSimpleTempRegister, /*InsnID*//* 369(*/0xF1, 0x02/*)*/, /*TempRegID*//* 369(*/0xF1, 0x02/*)*/,
     /* 191700 */   GIR_AddImm8, /*InsnID*//* 369(*/0xF1, 0x02/*)*/, /*Imm*/32,
     /* 191704 */   GIR_AddImm8, /*InsnID*//* 369(*/0xF1, 0x02/*)*/, /*Imm*/31,
     /* 191708 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 369(*/0xF1, 0x02/*)*/,
     /* 191711 */   GIR_MakeTempReg, /*TempRegID*//* 367(*/0xEF, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191715 */   GIR_BuildMI, /*InsnID*//* 368(*/0xF0, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 191720 */   GIR_AddTempRegister, /*InsnID*//* 368(*/0xF0, 0x02/*)*/, /*TempRegID*//* 367(*/0xEF, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191727 */   GIR_AddSimpleTempRegister, /*InsnID*//* 368(*/0xF0, 0x02/*)*/, /*TempRegID*//* 368(*/0xF0, 0x02/*)*/,
     /* 191732 */   GIR_AddImm, /*InsnID*//* 368(*/0xF0, 0x02/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 191743 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 368(*/0xF0, 0x02/*)*/,
     /* 191746 */   GIR_MakeTempReg, /*TempRegID*//* 366(*/0xEE, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191750 */   GIR_BuildMI, /*InsnID*//* 367(*/0xEF, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 191755 */   GIR_AddTempRegister, /*InsnID*//* 367(*/0xEF, 0x02/*)*/, /*TempRegID*//* 366(*/0xEE, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191762 */   GIR_AddSimpleTempRegister, /*InsnID*//* 367(*/0xEF, 0x02/*)*/, /*TempRegID*//* 367(*/0xEF, 0x02/*)*/,
     /* 191767 */   GIR_AddImm, /*InsnID*//* 367(*/0xEF, 0x02/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 191778 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 367(*/0xEF, 0x02/*)*/,
     /* 191781 */   GIR_MakeTempReg, /*TempRegID*//* 365(*/0xED, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 191785 */   GIR_BuildMI, /*InsnID*//* 366(*/0xEE, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 191790 */   GIR_AddTempRegister, /*InsnID*//* 366(*/0xEE, 0x02/*)*/, /*TempRegID*//* 365(*/0xED, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191797 */   GIR_AddImm, /*InsnID*//* 366(*/0xEE, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 191808 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 366(*/0xEE, 0x02/*)*/,
     /* 191811 */   GIR_MakeTempReg, /*TempRegID*//* 364(*/0xEC, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 191815 */   GIR_BuildMI, /*InsnID*//* 365(*/0xED, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 191820 */   GIR_AddTempRegister, /*InsnID*//* 365(*/0xED, 0x02/*)*/, /*TempRegID*//* 364(*/0xEC, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191827 */   GIR_AddSimpleTempRegister, /*InsnID*//* 365(*/0xED, 0x02/*)*/, /*TempRegID*//* 365(*/0xED, 0x02/*)*/,
     /* 191832 */   GIR_AddImm, /*InsnID*//* 365(*/0xED, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 191843 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 365(*/0xED, 0x02/*)*/,
     /* 191846 */   GIR_MakeTempReg, /*TempRegID*//* 363(*/0xEB, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191850 */   GIR_BuildMI, /*InsnID*//* 364(*/0xEC, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 191855 */   GIR_AddTempRegister, /*InsnID*//* 364(*/0xEC, 0x02/*)*/, /*TempRegID*//* 363(*/0xEB, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191862 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 364(*/0xEC, 0x02/*)*/,
     /* 191865 */   GIR_MakeTempReg, /*TempRegID*//* 362(*/0xEA, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191869 */   GIR_BuildMI, /*InsnID*//* 363(*/0xEB, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 191874 */   GIR_AddTempRegister, /*InsnID*//* 363(*/0xEB, 0x02/*)*/, /*TempRegID*//* 362(*/0xEA, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191881 */   GIR_AddSimpleTempRegister, /*InsnID*//* 363(*/0xEB, 0x02/*)*/, /*TempRegID*//* 363(*/0xEB, 0x02/*)*/,
     /* 191886 */   GIR_AddSimpleTempRegister, /*InsnID*//* 363(*/0xEB, 0x02/*)*/, /*TempRegID*//* 364(*/0xEC, 0x02/*)*/,
     /* 191891 */   GIR_AddImm8, /*InsnID*//* 363(*/0xEB, 0x02/*)*/, /*Imm*/1,
     /* 191895 */   GIR_ConstrainOperandRC, /*InsnID*//* 363(*/0xEB, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 191901 */   GIR_ConstrainOperandRC, /*InsnID*//* 363(*/0xEB, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 191907 */   GIR_ConstrainOperandRC, /*InsnID*//* 363(*/0xEB, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 191913 */   GIR_MakeTempReg, /*TempRegID*//* 361(*/0xE9, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191917 */   GIR_BuildMI, /*InsnID*//* 362(*/0xEA, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 191922 */   GIR_AddTempRegister, /*InsnID*//* 362(*/0xEA, 0x02/*)*/, /*TempRegID*//* 361(*/0xE9, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191929 */   GIR_AddSimpleTempRegister, /*InsnID*//* 362(*/0xEA, 0x02/*)*/, /*TempRegID*//* 362(*/0xEA, 0x02/*)*/,
     /* 191934 */   GIR_AddImm8, /*InsnID*//* 362(*/0xEA, 0x02/*)*/, /*Imm*/32,
     /* 191938 */   GIR_AddImm8, /*InsnID*//* 362(*/0xEA, 0x02/*)*/, /*Imm*/31,
     /* 191942 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 362(*/0xEA, 0x02/*)*/,
     /* 191945 */   GIR_MakeTempReg, /*TempRegID*//* 360(*/0xE8, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191949 */   GIR_BuildMI, /*InsnID*//* 361(*/0xE9, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 191954 */   GIR_AddTempRegister, /*InsnID*//* 361(*/0xE9, 0x02/*)*/, /*TempRegID*//* 360(*/0xE8, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191961 */   GIR_AddSimpleTempRegister, /*InsnID*//* 361(*/0xE9, 0x02/*)*/, /*TempRegID*//* 361(*/0xE9, 0x02/*)*/,
     /* 191966 */   GIR_AddImm, /*InsnID*//* 361(*/0xE9, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 191977 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 361(*/0xE9, 0x02/*)*/,
     /* 191980 */   GIR_MakeTempReg, /*TempRegID*//* 359(*/0xE7, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191984 */   GIR_BuildMI, /*InsnID*//* 360(*/0xE8, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 191989 */   GIR_AddTempRegister, /*InsnID*//* 360(*/0xE8, 0x02/*)*/, /*TempRegID*//* 359(*/0xE7, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191996 */   GIR_AddSimpleTempRegister, /*InsnID*//* 360(*/0xE8, 0x02/*)*/, /*TempRegID*//* 360(*/0xE8, 0x02/*)*/,
     /* 192001 */   GIR_AddImm, /*InsnID*//* 360(*/0xE8, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 192012 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 360(*/0xE8, 0x02/*)*/,
     /* 192015 */   GIR_MakeTempReg, /*TempRegID*//* 358(*/0xE6, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192019 */   GIR_BuildMI, /*InsnID*//* 359(*/0xE7, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 192024 */   GIR_AddTempRegister, /*InsnID*//* 359(*/0xE7, 0x02/*)*/, /*TempRegID*//* 358(*/0xE6, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192031 */   GIR_Copy, /*NewInsnID*//* 359(*/0xE7, 0x02/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 192036 */   GIR_AddImm8, /*InsnID*//* 359(*/0xE7, 0x02/*)*/, /*Imm*/1,
     /* 192040 */   GIR_AddImm8, /*InsnID*//* 359(*/0xE7, 0x02/*)*/, /*Imm*/62,
     /* 192044 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 359(*/0xE7, 0x02/*)*/,
     /* 192047 */   GIR_MakeTempReg, /*TempRegID*//* 357(*/0xE5, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192051 */   GIR_BuildMI, /*InsnID*//* 358(*/0xE6, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 192056 */   GIR_AddTempRegister, /*InsnID*//* 358(*/0xE6, 0x02/*)*/, /*TempRegID*//* 357(*/0xE5, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192063 */   GIR_AddSimpleTempRegister, /*InsnID*//* 358(*/0xE6, 0x02/*)*/, /*TempRegID*//* 358(*/0xE6, 0x02/*)*/,
     /* 192068 */   GIR_AddSimpleTempRegister, /*InsnID*//* 358(*/0xE6, 0x02/*)*/, /*TempRegID*//* 359(*/0xE7, 0x02/*)*/,
     /* 192073 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 358(*/0xE6, 0x02/*)*/,
     /* 192076 */   GIR_MakeTempReg, /*TempRegID*//* 356(*/0xE4, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 192080 */   GIR_BuildMI, /*InsnID*//* 357(*/0xE5, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 192085 */   GIR_AddTempRegister, /*InsnID*//* 357(*/0xE5, 0x02/*)*/, /*TempRegID*//* 356(*/0xE4, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192092 */   GIR_AddImm, /*InsnID*//* 357(*/0xE5, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 192103 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 357(*/0xE5, 0x02/*)*/,
     /* 192106 */   GIR_MakeTempReg, /*TempRegID*//* 355(*/0xE3, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 192110 */   GIR_BuildMI, /*InsnID*//* 356(*/0xE4, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 192115 */   GIR_AddTempRegister, /*InsnID*//* 356(*/0xE4, 0x02/*)*/, /*TempRegID*//* 355(*/0xE3, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192122 */   GIR_AddSimpleTempRegister, /*InsnID*//* 356(*/0xE4, 0x02/*)*/, /*TempRegID*//* 356(*/0xE4, 0x02/*)*/,
     /* 192127 */   GIR_AddImm, /*InsnID*//* 356(*/0xE4, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 192138 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 356(*/0xE4, 0x02/*)*/,
     /* 192141 */   GIR_MakeTempReg, /*TempRegID*//* 354(*/0xE2, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192145 */   GIR_BuildMI, /*InsnID*//* 355(*/0xE3, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 192150 */   GIR_AddTempRegister, /*InsnID*//* 355(*/0xE3, 0x02/*)*/, /*TempRegID*//* 354(*/0xE2, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192157 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 355(*/0xE3, 0x02/*)*/,
     /* 192160 */   GIR_MakeTempReg, /*TempRegID*//* 353(*/0xE1, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192164 */   GIR_BuildMI, /*InsnID*//* 354(*/0xE2, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 192169 */   GIR_AddTempRegister, /*InsnID*//* 354(*/0xE2, 0x02/*)*/, /*TempRegID*//* 353(*/0xE1, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192176 */   GIR_AddSimpleTempRegister, /*InsnID*//* 354(*/0xE2, 0x02/*)*/, /*TempRegID*//* 354(*/0xE2, 0x02/*)*/,
     /* 192181 */   GIR_AddSimpleTempRegister, /*InsnID*//* 354(*/0xE2, 0x02/*)*/, /*TempRegID*//* 355(*/0xE3, 0x02/*)*/,
     /* 192186 */   GIR_AddImm8, /*InsnID*//* 354(*/0xE2, 0x02/*)*/, /*Imm*/1,
     /* 192190 */   GIR_ConstrainOperandRC, /*InsnID*//* 354(*/0xE2, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 192196 */   GIR_ConstrainOperandRC, /*InsnID*//* 354(*/0xE2, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 192202 */   GIR_ConstrainOperandRC, /*InsnID*//* 354(*/0xE2, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 192208 */   GIR_MakeTempReg, /*TempRegID*//* 352(*/0xE0, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192212 */   GIR_BuildMI, /*InsnID*//* 353(*/0xE1, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 192217 */   GIR_AddTempRegister, /*InsnID*//* 353(*/0xE1, 0x02/*)*/, /*TempRegID*//* 352(*/0xE0, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192224 */   GIR_AddSimpleTempRegister, /*InsnID*//* 353(*/0xE1, 0x02/*)*/, /*TempRegID*//* 353(*/0xE1, 0x02/*)*/,
     /* 192229 */   GIR_AddImm8, /*InsnID*//* 353(*/0xE1, 0x02/*)*/, /*Imm*/32,
     /* 192233 */   GIR_AddImm8, /*InsnID*//* 353(*/0xE1, 0x02/*)*/, /*Imm*/31,
     /* 192237 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 353(*/0xE1, 0x02/*)*/,
     /* 192240 */   GIR_MakeTempReg, /*TempRegID*//* 351(*/0xDF, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192244 */   GIR_BuildMI, /*InsnID*//* 352(*/0xE0, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 192249 */   GIR_AddTempRegister, /*InsnID*//* 352(*/0xE0, 0x02/*)*/, /*TempRegID*//* 351(*/0xDF, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192256 */   GIR_AddSimpleTempRegister, /*InsnID*//* 352(*/0xE0, 0x02/*)*/, /*TempRegID*//* 352(*/0xE0, 0x02/*)*/,
     /* 192261 */   GIR_AddImm, /*InsnID*//* 352(*/0xE0, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 192272 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 352(*/0xE0, 0x02/*)*/,
     /* 192275 */   GIR_MakeTempReg, /*TempRegID*//* 350(*/0xDE, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192279 */   GIR_BuildMI, /*InsnID*//* 351(*/0xDF, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 192284 */   GIR_AddTempRegister, /*InsnID*//* 351(*/0xDF, 0x02/*)*/, /*TempRegID*//* 350(*/0xDE, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192291 */   GIR_AddSimpleTempRegister, /*InsnID*//* 351(*/0xDF, 0x02/*)*/, /*TempRegID*//* 351(*/0xDF, 0x02/*)*/,
     /* 192296 */   GIR_AddImm, /*InsnID*//* 351(*/0xDF, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 192307 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 351(*/0xDF, 0x02/*)*/,
     /* 192310 */   GIR_MakeTempReg, /*TempRegID*//* 349(*/0xDD, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192314 */   GIR_BuildMI, /*InsnID*//* 350(*/0xDE, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 192319 */   GIR_AddTempRegister, /*InsnID*//* 350(*/0xDE, 0x02/*)*/, /*TempRegID*//* 349(*/0xDD, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192326 */   GIR_Copy, /*NewInsnID*//* 350(*/0xDE, 0x02/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 192331 */   GIR_AddImm8, /*InsnID*//* 350(*/0xDE, 0x02/*)*/, /*Imm*/63,
     /* 192335 */   GIR_AddImm8, /*InsnID*//* 350(*/0xDE, 0x02/*)*/, /*Imm*/1,
     /* 192339 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 350(*/0xDE, 0x02/*)*/,
     /* 192342 */   GIR_MakeTempReg, /*TempRegID*//* 348(*/0xDC, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192346 */   GIR_BuildMI, /*InsnID*//* 349(*/0xDD, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 192351 */   GIR_AddTempRegister, /*InsnID*//* 349(*/0xDD, 0x02/*)*/, /*TempRegID*//* 348(*/0xDC, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192358 */   GIR_AddSimpleTempRegister, /*InsnID*//* 349(*/0xDD, 0x02/*)*/, /*TempRegID*//* 349(*/0xDD, 0x02/*)*/,
     /* 192363 */   GIR_AddSimpleTempRegister, /*InsnID*//* 349(*/0xDD, 0x02/*)*/, /*TempRegID*//* 350(*/0xDE, 0x02/*)*/,
     /* 192368 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 349(*/0xDD, 0x02/*)*/,
     /* 192371 */   GIR_MakeTempReg, /*TempRegID*//* 347(*/0xDB, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192375 */   GIR_BuildMI, /*InsnID*//* 348(*/0xDC, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 192380 */   GIR_AddTempRegister, /*InsnID*//* 348(*/0xDC, 0x02/*)*/, /*TempRegID*//* 347(*/0xDB, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192387 */   GIR_AddSimpleTempRegister, /*InsnID*//* 348(*/0xDC, 0x02/*)*/, /*TempRegID*//* 348(*/0xDC, 0x02/*)*/,
     /* 192392 */   GIR_AddSimpleTempRegister, /*InsnID*//* 348(*/0xDC, 0x02/*)*/, /*TempRegID*//* 357(*/0xE5, 0x02/*)*/,
     /* 192397 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 348(*/0xDC, 0x02/*)*/,
     /* 192400 */   GIR_MakeTempReg, /*TempRegID*//* 346(*/0xDA, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192404 */   GIR_BuildMI, /*InsnID*//* 347(*/0xDB, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 192409 */   GIR_AddTempRegister, /*InsnID*//* 347(*/0xDB, 0x02/*)*/, /*TempRegID*//* 346(*/0xDA, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192416 */   GIR_AddSimpleTempRegister, /*InsnID*//* 347(*/0xDB, 0x02/*)*/, /*TempRegID*//* 347(*/0xDB, 0x02/*)*/,
     /* 192421 */   GIR_AddImm8, /*InsnID*//* 347(*/0xDB, 0x02/*)*/, /*Imm*/62,
     /* 192425 */   GIR_AddImm8, /*InsnID*//* 347(*/0xDB, 0x02/*)*/, /*Imm*/2,
     /* 192429 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 347(*/0xDB, 0x02/*)*/,
     /* 192432 */   GIR_MakeTempReg, /*TempRegID*//* 345(*/0xD9, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192436 */   GIR_BuildMI, /*InsnID*//* 346(*/0xDA, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 192441 */   GIR_AddTempRegister, /*InsnID*//* 346(*/0xDA, 0x02/*)*/, /*TempRegID*//* 345(*/0xD9, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192448 */   GIR_AddSimpleTempRegister, /*InsnID*//* 346(*/0xDA, 0x02/*)*/, /*TempRegID*//* 346(*/0xDA, 0x02/*)*/,
     /* 192453 */   GIR_AddSimpleTempRegister, /*InsnID*//* 346(*/0xDA, 0x02/*)*/, /*TempRegID*//* 366(*/0xEE, 0x02/*)*/,
     /* 192458 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 346(*/0xDA, 0x02/*)*/,
     /* 192461 */   GIR_MakeTempReg, /*TempRegID*//* 344(*/0xD8, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192465 */   GIR_BuildMI, /*InsnID*//* 345(*/0xD9, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 192470 */   GIR_AddTempRegister, /*InsnID*//* 345(*/0xD9, 0x02/*)*/, /*TempRegID*//* 344(*/0xD8, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192477 */   GIR_AddSimpleTempRegister, /*InsnID*//* 345(*/0xD9, 0x02/*)*/, /*TempRegID*//* 345(*/0xD9, 0x02/*)*/,
     /* 192482 */   GIR_AddSimpleTempRegister, /*InsnID*//* 345(*/0xD9, 0x02/*)*/, /*TempRegID*//* 373(*/0xF5, 0x02/*)*/,
     /* 192487 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 345(*/0xD9, 0x02/*)*/,
     /* 192490 */   GIR_MakeTempReg, /*TempRegID*//* 343(*/0xD7, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192494 */   GIR_BuildMI, /*InsnID*//* 344(*/0xD8, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 192499 */   GIR_AddTempRegister, /*InsnID*//* 344(*/0xD8, 0x02/*)*/, /*TempRegID*//* 343(*/0xD7, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192506 */   GIR_AddSimpleTempRegister, /*InsnID*//* 344(*/0xD8, 0x02/*)*/, /*TempRegID*//* 344(*/0xD8, 0x02/*)*/,
     /* 192511 */   GIR_AddImm8, /*InsnID*//* 344(*/0xD8, 0x02/*)*/, /*Imm*/4,
     /* 192515 */   GIR_AddImm8, /*InsnID*//* 344(*/0xD8, 0x02/*)*/, /*Imm*/59,
     /* 192519 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 344(*/0xD8, 0x02/*)*/,
     /* 192522 */   GIR_MakeTempReg, /*TempRegID*//* 342(*/0xD6, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192526 */   GIR_BuildMI, /*InsnID*//* 343(*/0xD7, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 192531 */   GIR_AddTempRegister, /*InsnID*//* 343(*/0xD7, 0x02/*)*/, /*TempRegID*//* 342(*/0xD6, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192538 */   GIR_AddSimpleTempRegister, /*InsnID*//* 343(*/0xD7, 0x02/*)*/, /*TempRegID*//* 343(*/0xD7, 0x02/*)*/,
     /* 192543 */   GIR_AddSimpleTempRegister, /*InsnID*//* 343(*/0xD7, 0x02/*)*/, /*TempRegID*//* 401(*/0x91, 0x03/*)*/,
     /* 192548 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 343(*/0xD7, 0x02/*)*/,
     /* 192551 */   GIR_MakeTempReg, /*TempRegID*//* 341(*/0xD5, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 192555 */   GIR_BuildMI, /*InsnID*//* 342(*/0xD6, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 192560 */   GIR_AddTempRegister, /*InsnID*//* 342(*/0xD6, 0x02/*)*/, /*TempRegID*//* 341(*/0xD5, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192567 */   GIR_AddImm, /*InsnID*//* 342(*/0xD6, 0x02/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 192578 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 342(*/0xD6, 0x02/*)*/,
     /* 192581 */   GIR_MakeTempReg, /*TempRegID*//* 340(*/0xD4, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 192585 */   GIR_BuildMI, /*InsnID*//* 341(*/0xD5, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 192590 */   GIR_AddTempRegister, /*InsnID*//* 341(*/0xD5, 0x02/*)*/, /*TempRegID*//* 340(*/0xD4, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192597 */   GIR_AddSimpleTempRegister, /*InsnID*//* 341(*/0xD5, 0x02/*)*/, /*TempRegID*//* 341(*/0xD5, 0x02/*)*/,
     /* 192602 */   GIR_AddImm, /*InsnID*//* 341(*/0xD5, 0x02/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 192613 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 341(*/0xD5, 0x02/*)*/,
     /* 192616 */   GIR_MakeTempReg, /*TempRegID*//* 339(*/0xD3, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192620 */   GIR_BuildMI, /*InsnID*//* 340(*/0xD4, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 192625 */   GIR_AddTempRegister, /*InsnID*//* 340(*/0xD4, 0x02/*)*/, /*TempRegID*//* 339(*/0xD3, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192632 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 340(*/0xD4, 0x02/*)*/,
     /* 192635 */   GIR_MakeTempReg, /*TempRegID*//* 338(*/0xD2, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192639 */   GIR_BuildMI, /*InsnID*//* 339(*/0xD3, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 192644 */   GIR_AddTempRegister, /*InsnID*//* 339(*/0xD3, 0x02/*)*/, /*TempRegID*//* 338(*/0xD2, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192651 */   GIR_AddSimpleTempRegister, /*InsnID*//* 339(*/0xD3, 0x02/*)*/, /*TempRegID*//* 339(*/0xD3, 0x02/*)*/,
     /* 192656 */   GIR_AddSimpleTempRegister, /*InsnID*//* 339(*/0xD3, 0x02/*)*/, /*TempRegID*//* 340(*/0xD4, 0x02/*)*/,
     /* 192661 */   GIR_AddImm8, /*InsnID*//* 339(*/0xD3, 0x02/*)*/, /*Imm*/1,
     /* 192665 */   GIR_ConstrainOperandRC, /*InsnID*//* 339(*/0xD3, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 192671 */   GIR_ConstrainOperandRC, /*InsnID*//* 339(*/0xD3, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 192677 */   GIR_ConstrainOperandRC, /*InsnID*//* 339(*/0xD3, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 192683 */   GIR_MakeTempReg, /*TempRegID*//* 337(*/0xD1, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192687 */   GIR_BuildMI, /*InsnID*//* 338(*/0xD2, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 192692 */   GIR_AddTempRegister, /*InsnID*//* 338(*/0xD2, 0x02/*)*/, /*TempRegID*//* 337(*/0xD1, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192699 */   GIR_AddSimpleTempRegister, /*InsnID*//* 338(*/0xD2, 0x02/*)*/, /*TempRegID*//* 338(*/0xD2, 0x02/*)*/,
     /* 192704 */   GIR_AddImm8, /*InsnID*//* 338(*/0xD2, 0x02/*)*/, /*Imm*/32,
     /* 192708 */   GIR_AddImm8, /*InsnID*//* 338(*/0xD2, 0x02/*)*/, /*Imm*/31,
     /* 192712 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 338(*/0xD2, 0x02/*)*/,
     /* 192715 */   GIR_MakeTempReg, /*TempRegID*//* 336(*/0xD0, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192719 */   GIR_BuildMI, /*InsnID*//* 337(*/0xD1, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 192724 */   GIR_AddTempRegister, /*InsnID*//* 337(*/0xD1, 0x02/*)*/, /*TempRegID*//* 336(*/0xD0, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192731 */   GIR_AddSimpleTempRegister, /*InsnID*//* 337(*/0xD1, 0x02/*)*/, /*TempRegID*//* 337(*/0xD1, 0x02/*)*/,
     /* 192736 */   GIR_AddImm, /*InsnID*//* 337(*/0xD1, 0x02/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 192747 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 337(*/0xD1, 0x02/*)*/,
     /* 192750 */   GIR_MakeTempReg, /*TempRegID*//* 335(*/0xCF, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192754 */   GIR_BuildMI, /*InsnID*//* 336(*/0xD0, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 192759 */   GIR_AddTempRegister, /*InsnID*//* 336(*/0xD0, 0x02/*)*/, /*TempRegID*//* 335(*/0xCF, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192766 */   GIR_AddSimpleTempRegister, /*InsnID*//* 336(*/0xD0, 0x02/*)*/, /*TempRegID*//* 336(*/0xD0, 0x02/*)*/,
     /* 192771 */   GIR_AddImm, /*InsnID*//* 336(*/0xD0, 0x02/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 192782 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 336(*/0xD0, 0x02/*)*/,
     /* 192785 */   GIR_MakeTempReg, /*TempRegID*//* 334(*/0xCE, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 192789 */   GIR_BuildMI, /*InsnID*//* 335(*/0xCF, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 192794 */   GIR_AddTempRegister, /*InsnID*//* 335(*/0xCF, 0x02/*)*/, /*TempRegID*//* 334(*/0xCE, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192801 */   GIR_AddImm, /*InsnID*//* 335(*/0xCF, 0x02/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 192812 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 335(*/0xCF, 0x02/*)*/,
     /* 192815 */   GIR_MakeTempReg, /*TempRegID*//* 333(*/0xCD, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 192819 */   GIR_BuildMI, /*InsnID*//* 334(*/0xCE, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 192824 */   GIR_AddTempRegister, /*InsnID*//* 334(*/0xCE, 0x02/*)*/, /*TempRegID*//* 333(*/0xCD, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192831 */   GIR_AddSimpleTempRegister, /*InsnID*//* 334(*/0xCE, 0x02/*)*/, /*TempRegID*//* 334(*/0xCE, 0x02/*)*/,
     /* 192836 */   GIR_AddImm, /*InsnID*//* 334(*/0xCE, 0x02/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 192847 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 334(*/0xCE, 0x02/*)*/,
     /* 192850 */   GIR_MakeTempReg, /*TempRegID*//* 332(*/0xCC, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192854 */   GIR_BuildMI, /*InsnID*//* 333(*/0xCD, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 192859 */   GIR_AddTempRegister, /*InsnID*//* 333(*/0xCD, 0x02/*)*/, /*TempRegID*//* 332(*/0xCC, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192866 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 333(*/0xCD, 0x02/*)*/,
     /* 192869 */   GIR_MakeTempReg, /*TempRegID*//* 331(*/0xCB, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192873 */   GIR_BuildMI, /*InsnID*//* 332(*/0xCC, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 192878 */   GIR_AddTempRegister, /*InsnID*//* 332(*/0xCC, 0x02/*)*/, /*TempRegID*//* 331(*/0xCB, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192885 */   GIR_AddSimpleTempRegister, /*InsnID*//* 332(*/0xCC, 0x02/*)*/, /*TempRegID*//* 332(*/0xCC, 0x02/*)*/,
     /* 192890 */   GIR_AddSimpleTempRegister, /*InsnID*//* 332(*/0xCC, 0x02/*)*/, /*TempRegID*//* 333(*/0xCD, 0x02/*)*/,
     /* 192895 */   GIR_AddImm8, /*InsnID*//* 332(*/0xCC, 0x02/*)*/, /*Imm*/1,
     /* 192899 */   GIR_ConstrainOperandRC, /*InsnID*//* 332(*/0xCC, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 192905 */   GIR_ConstrainOperandRC, /*InsnID*//* 332(*/0xCC, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 192911 */   GIR_ConstrainOperandRC, /*InsnID*//* 332(*/0xCC, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 192917 */   GIR_MakeTempReg, /*TempRegID*//* 330(*/0xCA, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192921 */   GIR_BuildMI, /*InsnID*//* 331(*/0xCB, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 192926 */   GIR_AddTempRegister, /*InsnID*//* 331(*/0xCB, 0x02/*)*/, /*TempRegID*//* 330(*/0xCA, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192933 */   GIR_AddSimpleTempRegister, /*InsnID*//* 331(*/0xCB, 0x02/*)*/, /*TempRegID*//* 331(*/0xCB, 0x02/*)*/,
     /* 192938 */   GIR_AddImm8, /*InsnID*//* 331(*/0xCB, 0x02/*)*/, /*Imm*/32,
     /* 192942 */   GIR_AddImm8, /*InsnID*//* 331(*/0xCB, 0x02/*)*/, /*Imm*/31,
     /* 192946 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 331(*/0xCB, 0x02/*)*/,
     /* 192949 */   GIR_MakeTempReg, /*TempRegID*//* 329(*/0xC9, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192953 */   GIR_BuildMI, /*InsnID*//* 330(*/0xCA, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 192958 */   GIR_AddTempRegister, /*InsnID*//* 330(*/0xCA, 0x02/*)*/, /*TempRegID*//* 329(*/0xC9, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192965 */   GIR_AddSimpleTempRegister, /*InsnID*//* 330(*/0xCA, 0x02/*)*/, /*TempRegID*//* 330(*/0xCA, 0x02/*)*/,
     /* 192970 */   GIR_AddImm, /*InsnID*//* 330(*/0xCA, 0x02/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 192981 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 330(*/0xCA, 0x02/*)*/,
     /* 192984 */   GIR_MakeTempReg, /*TempRegID*//* 328(*/0xC8, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192988 */   GIR_BuildMI, /*InsnID*//* 329(*/0xC9, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 192993 */   GIR_AddTempRegister, /*InsnID*//* 329(*/0xC9, 0x02/*)*/, /*TempRegID*//* 328(*/0xC8, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193000 */   GIR_AddSimpleTempRegister, /*InsnID*//* 329(*/0xC9, 0x02/*)*/, /*TempRegID*//* 329(*/0xC9, 0x02/*)*/,
     /* 193005 */   GIR_AddImm, /*InsnID*//* 329(*/0xC9, 0x02/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 193016 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 329(*/0xC9, 0x02/*)*/,
     /* 193019 */   GIR_MakeTempReg, /*TempRegID*//* 327(*/0xC7, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 193023 */   GIR_BuildMI, /*InsnID*//* 328(*/0xC8, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 193028 */   GIR_AddTempRegister, /*InsnID*//* 328(*/0xC8, 0x02/*)*/, /*TempRegID*//* 327(*/0xC7, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193035 */   GIR_AddImm, /*InsnID*//* 328(*/0xC8, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 193046 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 328(*/0xC8, 0x02/*)*/,
     /* 193049 */   GIR_MakeTempReg, /*TempRegID*//* 326(*/0xC6, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 193053 */   GIR_BuildMI, /*InsnID*//* 327(*/0xC7, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 193058 */   GIR_AddTempRegister, /*InsnID*//* 327(*/0xC7, 0x02/*)*/, /*TempRegID*//* 326(*/0xC6, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193065 */   GIR_AddSimpleTempRegister, /*InsnID*//* 327(*/0xC7, 0x02/*)*/, /*TempRegID*//* 327(*/0xC7, 0x02/*)*/,
     /* 193070 */   GIR_AddImm, /*InsnID*//* 327(*/0xC7, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 193081 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 327(*/0xC7, 0x02/*)*/,
     /* 193084 */   GIR_MakeTempReg, /*TempRegID*//* 325(*/0xC5, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193088 */   GIR_BuildMI, /*InsnID*//* 326(*/0xC6, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 193093 */   GIR_AddTempRegister, /*InsnID*//* 326(*/0xC6, 0x02/*)*/, /*TempRegID*//* 325(*/0xC5, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193100 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 326(*/0xC6, 0x02/*)*/,
     /* 193103 */   GIR_MakeTempReg, /*TempRegID*//* 324(*/0xC4, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193107 */   GIR_BuildMI, /*InsnID*//* 325(*/0xC5, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 193112 */   GIR_AddTempRegister, /*InsnID*//* 325(*/0xC5, 0x02/*)*/, /*TempRegID*//* 324(*/0xC4, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193119 */   GIR_AddSimpleTempRegister, /*InsnID*//* 325(*/0xC5, 0x02/*)*/, /*TempRegID*//* 325(*/0xC5, 0x02/*)*/,
     /* 193124 */   GIR_AddSimpleTempRegister, /*InsnID*//* 325(*/0xC5, 0x02/*)*/, /*TempRegID*//* 326(*/0xC6, 0x02/*)*/,
     /* 193129 */   GIR_AddImm8, /*InsnID*//* 325(*/0xC5, 0x02/*)*/, /*Imm*/1,
     /* 193133 */   GIR_ConstrainOperandRC, /*InsnID*//* 325(*/0xC5, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 193139 */   GIR_ConstrainOperandRC, /*InsnID*//* 325(*/0xC5, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 193145 */   GIR_ConstrainOperandRC, /*InsnID*//* 325(*/0xC5, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 193151 */   GIR_MakeTempReg, /*TempRegID*//* 323(*/0xC3, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193155 */   GIR_BuildMI, /*InsnID*//* 324(*/0xC4, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 193160 */   GIR_AddTempRegister, /*InsnID*//* 324(*/0xC4, 0x02/*)*/, /*TempRegID*//* 323(*/0xC3, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193167 */   GIR_AddSimpleTempRegister, /*InsnID*//* 324(*/0xC4, 0x02/*)*/, /*TempRegID*//* 324(*/0xC4, 0x02/*)*/,
     /* 193172 */   GIR_AddImm8, /*InsnID*//* 324(*/0xC4, 0x02/*)*/, /*Imm*/32,
     /* 193176 */   GIR_AddImm8, /*InsnID*//* 324(*/0xC4, 0x02/*)*/, /*Imm*/31,
     /* 193180 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 324(*/0xC4, 0x02/*)*/,
     /* 193183 */   GIR_MakeTempReg, /*TempRegID*//* 322(*/0xC2, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193187 */   GIR_BuildMI, /*InsnID*//* 323(*/0xC3, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 193192 */   GIR_AddTempRegister, /*InsnID*//* 323(*/0xC3, 0x02/*)*/, /*TempRegID*//* 322(*/0xC2, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193199 */   GIR_AddSimpleTempRegister, /*InsnID*//* 323(*/0xC3, 0x02/*)*/, /*TempRegID*//* 323(*/0xC3, 0x02/*)*/,
     /* 193204 */   GIR_AddImm, /*InsnID*//* 323(*/0xC3, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 193215 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 323(*/0xC3, 0x02/*)*/,
     /* 193218 */   GIR_MakeTempReg, /*TempRegID*//* 321(*/0xC1, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193222 */   GIR_BuildMI, /*InsnID*//* 322(*/0xC2, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 193227 */   GIR_AddTempRegister, /*InsnID*//* 322(*/0xC2, 0x02/*)*/, /*TempRegID*//* 321(*/0xC1, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193234 */   GIR_AddSimpleTempRegister, /*InsnID*//* 322(*/0xC2, 0x02/*)*/, /*TempRegID*//* 322(*/0xC2, 0x02/*)*/,
     /* 193239 */   GIR_AddImm, /*InsnID*//* 322(*/0xC2, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 193250 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 322(*/0xC2, 0x02/*)*/,
     /* 193253 */   GIR_MakeTempReg, /*TempRegID*//* 320(*/0xC0, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193257 */   GIR_BuildMI, /*InsnID*//* 321(*/0xC1, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 193262 */   GIR_AddTempRegister, /*InsnID*//* 321(*/0xC1, 0x02/*)*/, /*TempRegID*//* 320(*/0xC0, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193269 */   GIR_Copy, /*NewInsnID*//* 321(*/0xC1, 0x02/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 193274 */   GIR_AddImm8, /*InsnID*//* 321(*/0xC1, 0x02/*)*/, /*Imm*/1,
     /* 193278 */   GIR_AddImm8, /*InsnID*//* 321(*/0xC1, 0x02/*)*/, /*Imm*/62,
     /* 193282 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 321(*/0xC1, 0x02/*)*/,
     /* 193285 */   GIR_MakeTempReg, /*TempRegID*//* 319(*/0xBF, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193289 */   GIR_BuildMI, /*InsnID*//* 320(*/0xC0, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 193294 */   GIR_AddTempRegister, /*InsnID*//* 320(*/0xC0, 0x02/*)*/, /*TempRegID*//* 319(*/0xBF, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193301 */   GIR_AddSimpleTempRegister, /*InsnID*//* 320(*/0xC0, 0x02/*)*/, /*TempRegID*//* 320(*/0xC0, 0x02/*)*/,
     /* 193306 */   GIR_AddSimpleTempRegister, /*InsnID*//* 320(*/0xC0, 0x02/*)*/, /*TempRegID*//* 321(*/0xC1, 0x02/*)*/,
     /* 193311 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 320(*/0xC0, 0x02/*)*/,
     /* 193314 */   GIR_MakeTempReg, /*TempRegID*//* 318(*/0xBE, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 193318 */   GIR_BuildMI, /*InsnID*//* 319(*/0xBF, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 193323 */   GIR_AddTempRegister, /*InsnID*//* 319(*/0xBF, 0x02/*)*/, /*TempRegID*//* 318(*/0xBE, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193330 */   GIR_AddImm, /*InsnID*//* 319(*/0xBF, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 193341 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 319(*/0xBF, 0x02/*)*/,
     /* 193344 */   GIR_MakeTempReg, /*TempRegID*//* 317(*/0xBD, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 193348 */   GIR_BuildMI, /*InsnID*//* 318(*/0xBE, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 193353 */   GIR_AddTempRegister, /*InsnID*//* 318(*/0xBE, 0x02/*)*/, /*TempRegID*//* 317(*/0xBD, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193360 */   GIR_AddSimpleTempRegister, /*InsnID*//* 318(*/0xBE, 0x02/*)*/, /*TempRegID*//* 318(*/0xBE, 0x02/*)*/,
     /* 193365 */   GIR_AddImm, /*InsnID*//* 318(*/0xBE, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 193376 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 318(*/0xBE, 0x02/*)*/,
     /* 193379 */   GIR_MakeTempReg, /*TempRegID*//* 316(*/0xBC, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193383 */   GIR_BuildMI, /*InsnID*//* 317(*/0xBD, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 193388 */   GIR_AddTempRegister, /*InsnID*//* 317(*/0xBD, 0x02/*)*/, /*TempRegID*//* 316(*/0xBC, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193395 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 317(*/0xBD, 0x02/*)*/,
     /* 193398 */   GIR_MakeTempReg, /*TempRegID*//* 315(*/0xBB, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193402 */   GIR_BuildMI, /*InsnID*//* 316(*/0xBC, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 193407 */   GIR_AddTempRegister, /*InsnID*//* 316(*/0xBC, 0x02/*)*/, /*TempRegID*//* 315(*/0xBB, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193414 */   GIR_AddSimpleTempRegister, /*InsnID*//* 316(*/0xBC, 0x02/*)*/, /*TempRegID*//* 316(*/0xBC, 0x02/*)*/,
     /* 193419 */   GIR_AddSimpleTempRegister, /*InsnID*//* 316(*/0xBC, 0x02/*)*/, /*TempRegID*//* 317(*/0xBD, 0x02/*)*/,
     /* 193424 */   GIR_AddImm8, /*InsnID*//* 316(*/0xBC, 0x02/*)*/, /*Imm*/1,
     /* 193428 */   GIR_ConstrainOperandRC, /*InsnID*//* 316(*/0xBC, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 193434 */   GIR_ConstrainOperandRC, /*InsnID*//* 316(*/0xBC, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 193440 */   GIR_ConstrainOperandRC, /*InsnID*//* 316(*/0xBC, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 193446 */   GIR_MakeTempReg, /*TempRegID*//* 314(*/0xBA, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193450 */   GIR_BuildMI, /*InsnID*//* 315(*/0xBB, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 193455 */   GIR_AddTempRegister, /*InsnID*//* 315(*/0xBB, 0x02/*)*/, /*TempRegID*//* 314(*/0xBA, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193462 */   GIR_AddSimpleTempRegister, /*InsnID*//* 315(*/0xBB, 0x02/*)*/, /*TempRegID*//* 315(*/0xBB, 0x02/*)*/,
     /* 193467 */   GIR_AddImm8, /*InsnID*//* 315(*/0xBB, 0x02/*)*/, /*Imm*/32,
     /* 193471 */   GIR_AddImm8, /*InsnID*//* 315(*/0xBB, 0x02/*)*/, /*Imm*/31,
     /* 193475 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 315(*/0xBB, 0x02/*)*/,
     /* 193478 */   GIR_MakeTempReg, /*TempRegID*//* 313(*/0xB9, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193482 */   GIR_BuildMI, /*InsnID*//* 314(*/0xBA, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 193487 */   GIR_AddTempRegister, /*InsnID*//* 314(*/0xBA, 0x02/*)*/, /*TempRegID*//* 313(*/0xB9, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193494 */   GIR_AddSimpleTempRegister, /*InsnID*//* 314(*/0xBA, 0x02/*)*/, /*TempRegID*//* 314(*/0xBA, 0x02/*)*/,
     /* 193499 */   GIR_AddImm, /*InsnID*//* 314(*/0xBA, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 193510 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 314(*/0xBA, 0x02/*)*/,
     /* 193513 */   GIR_MakeTempReg, /*TempRegID*//* 312(*/0xB8, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193517 */   GIR_BuildMI, /*InsnID*//* 313(*/0xB9, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 193522 */   GIR_AddTempRegister, /*InsnID*//* 313(*/0xB9, 0x02/*)*/, /*TempRegID*//* 312(*/0xB8, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193529 */   GIR_AddSimpleTempRegister, /*InsnID*//* 313(*/0xB9, 0x02/*)*/, /*TempRegID*//* 313(*/0xB9, 0x02/*)*/,
     /* 193534 */   GIR_AddImm, /*InsnID*//* 313(*/0xB9, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 193545 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 313(*/0xB9, 0x02/*)*/,
     /* 193548 */   GIR_MakeTempReg, /*TempRegID*//* 311(*/0xB7, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193552 */   GIR_BuildMI, /*InsnID*//* 312(*/0xB8, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 193557 */   GIR_AddTempRegister, /*InsnID*//* 312(*/0xB8, 0x02/*)*/, /*TempRegID*//* 311(*/0xB7, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193564 */   GIR_Copy, /*NewInsnID*//* 312(*/0xB8, 0x02/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 193569 */   GIR_AddImm8, /*InsnID*//* 312(*/0xB8, 0x02/*)*/, /*Imm*/63,
     /* 193573 */   GIR_AddImm8, /*InsnID*//* 312(*/0xB8, 0x02/*)*/, /*Imm*/1,
     /* 193577 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 312(*/0xB8, 0x02/*)*/,
     /* 193580 */   GIR_MakeTempReg, /*TempRegID*//* 310(*/0xB6, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193584 */   GIR_BuildMI, /*InsnID*//* 311(*/0xB7, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 193589 */   GIR_AddTempRegister, /*InsnID*//* 311(*/0xB7, 0x02/*)*/, /*TempRegID*//* 310(*/0xB6, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193596 */   GIR_AddSimpleTempRegister, /*InsnID*//* 311(*/0xB7, 0x02/*)*/, /*TempRegID*//* 311(*/0xB7, 0x02/*)*/,
     /* 193601 */   GIR_AddSimpleTempRegister, /*InsnID*//* 311(*/0xB7, 0x02/*)*/, /*TempRegID*//* 312(*/0xB8, 0x02/*)*/,
     /* 193606 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 311(*/0xB7, 0x02/*)*/,
     /* 193609 */   GIR_MakeTempReg, /*TempRegID*//* 309(*/0xB5, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193613 */   GIR_BuildMI, /*InsnID*//* 310(*/0xB6, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 193618 */   GIR_AddTempRegister, /*InsnID*//* 310(*/0xB6, 0x02/*)*/, /*TempRegID*//* 309(*/0xB5, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193625 */   GIR_AddSimpleTempRegister, /*InsnID*//* 310(*/0xB6, 0x02/*)*/, /*TempRegID*//* 310(*/0xB6, 0x02/*)*/,
     /* 193630 */   GIR_AddSimpleTempRegister, /*InsnID*//* 310(*/0xB6, 0x02/*)*/, /*TempRegID*//* 319(*/0xBF, 0x02/*)*/,
     /* 193635 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 310(*/0xB6, 0x02/*)*/,
     /* 193638 */   GIR_MakeTempReg, /*TempRegID*//* 308(*/0xB4, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193642 */   GIR_BuildMI, /*InsnID*//* 309(*/0xB5, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 193647 */   GIR_AddTempRegister, /*InsnID*//* 309(*/0xB5, 0x02/*)*/, /*TempRegID*//* 308(*/0xB4, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193654 */   GIR_AddSimpleTempRegister, /*InsnID*//* 309(*/0xB5, 0x02/*)*/, /*TempRegID*//* 309(*/0xB5, 0x02/*)*/,
     /* 193659 */   GIR_AddImm8, /*InsnID*//* 309(*/0xB5, 0x02/*)*/, /*Imm*/2,
     /* 193663 */   GIR_AddImm8, /*InsnID*//* 309(*/0xB5, 0x02/*)*/, /*Imm*/61,
     /* 193667 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 309(*/0xB5, 0x02/*)*/,
     /* 193670 */   GIR_MakeTempReg, /*TempRegID*//* 307(*/0xB3, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193674 */   GIR_BuildMI, /*InsnID*//* 308(*/0xB4, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 193679 */   GIR_AddTempRegister, /*InsnID*//* 308(*/0xB4, 0x02/*)*/, /*TempRegID*//* 307(*/0xB3, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193686 */   GIR_AddSimpleTempRegister, /*InsnID*//* 308(*/0xB4, 0x02/*)*/, /*TempRegID*//* 308(*/0xB4, 0x02/*)*/,
     /* 193691 */   GIR_AddSimpleTempRegister, /*InsnID*//* 308(*/0xB4, 0x02/*)*/, /*TempRegID*//* 328(*/0xC8, 0x02/*)*/,
     /* 193696 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 308(*/0xB4, 0x02/*)*/,
     /* 193699 */   GIR_MakeTempReg, /*TempRegID*//* 306(*/0xB2, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 193703 */   GIR_BuildMI, /*InsnID*//* 307(*/0xB3, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 193708 */   GIR_AddTempRegister, /*InsnID*//* 307(*/0xB3, 0x02/*)*/, /*TempRegID*//* 306(*/0xB2, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193715 */   GIR_AddImm, /*InsnID*//* 307(*/0xB3, 0x02/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 193726 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 307(*/0xB3, 0x02/*)*/,
     /* 193729 */   GIR_MakeTempReg, /*TempRegID*//* 305(*/0xB1, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 193733 */   GIR_BuildMI, /*InsnID*//* 306(*/0xB2, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 193738 */   GIR_AddTempRegister, /*InsnID*//* 306(*/0xB2, 0x02/*)*/, /*TempRegID*//* 305(*/0xB1, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193745 */   GIR_AddSimpleTempRegister, /*InsnID*//* 306(*/0xB2, 0x02/*)*/, /*TempRegID*//* 306(*/0xB2, 0x02/*)*/,
     /* 193750 */   GIR_AddImm, /*InsnID*//* 306(*/0xB2, 0x02/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 193761 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 306(*/0xB2, 0x02/*)*/,
     /* 193764 */   GIR_MakeTempReg, /*TempRegID*//* 304(*/0xB0, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193768 */   GIR_BuildMI, /*InsnID*//* 305(*/0xB1, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 193773 */   GIR_AddTempRegister, /*InsnID*//* 305(*/0xB1, 0x02/*)*/, /*TempRegID*//* 304(*/0xB0, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193780 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 305(*/0xB1, 0x02/*)*/,
     /* 193783 */   GIR_MakeTempReg, /*TempRegID*//* 303(*/0xAF, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193787 */   GIR_BuildMI, /*InsnID*//* 304(*/0xB0, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 193792 */   GIR_AddTempRegister, /*InsnID*//* 304(*/0xB0, 0x02/*)*/, /*TempRegID*//* 303(*/0xAF, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193799 */   GIR_AddSimpleTempRegister, /*InsnID*//* 304(*/0xB0, 0x02/*)*/, /*TempRegID*//* 304(*/0xB0, 0x02/*)*/,
     /* 193804 */   GIR_AddSimpleTempRegister, /*InsnID*//* 304(*/0xB0, 0x02/*)*/, /*TempRegID*//* 305(*/0xB1, 0x02/*)*/,
     /* 193809 */   GIR_AddImm8, /*InsnID*//* 304(*/0xB0, 0x02/*)*/, /*Imm*/1,
     /* 193813 */   GIR_ConstrainOperandRC, /*InsnID*//* 304(*/0xB0, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 193819 */   GIR_ConstrainOperandRC, /*InsnID*//* 304(*/0xB0, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 193825 */   GIR_ConstrainOperandRC, /*InsnID*//* 304(*/0xB0, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 193831 */   GIR_MakeTempReg, /*TempRegID*//* 302(*/0xAE, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193835 */   GIR_BuildMI, /*InsnID*//* 303(*/0xAF, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 193840 */   GIR_AddTempRegister, /*InsnID*//* 303(*/0xAF, 0x02/*)*/, /*TempRegID*//* 302(*/0xAE, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193847 */   GIR_AddSimpleTempRegister, /*InsnID*//* 303(*/0xAF, 0x02/*)*/, /*TempRegID*//* 303(*/0xAF, 0x02/*)*/,
     /* 193852 */   GIR_AddImm8, /*InsnID*//* 303(*/0xAF, 0x02/*)*/, /*Imm*/32,
     /* 193856 */   GIR_AddImm8, /*InsnID*//* 303(*/0xAF, 0x02/*)*/, /*Imm*/31,
     /* 193860 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 303(*/0xAF, 0x02/*)*/,
     /* 193863 */   GIR_MakeTempReg, /*TempRegID*//* 301(*/0xAD, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193867 */   GIR_BuildMI, /*InsnID*//* 302(*/0xAE, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 193872 */   GIR_AddTempRegister, /*InsnID*//* 302(*/0xAE, 0x02/*)*/, /*TempRegID*//* 301(*/0xAD, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193879 */   GIR_AddSimpleTempRegister, /*InsnID*//* 302(*/0xAE, 0x02/*)*/, /*TempRegID*//* 302(*/0xAE, 0x02/*)*/,
     /* 193884 */   GIR_AddImm, /*InsnID*//* 302(*/0xAE, 0x02/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 193895 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 302(*/0xAE, 0x02/*)*/,
     /* 193898 */   GIR_MakeTempReg, /*TempRegID*//* 300(*/0xAC, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193902 */   GIR_BuildMI, /*InsnID*//* 301(*/0xAD, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 193907 */   GIR_AddTempRegister, /*InsnID*//* 301(*/0xAD, 0x02/*)*/, /*TempRegID*//* 300(*/0xAC, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193914 */   GIR_AddSimpleTempRegister, /*InsnID*//* 301(*/0xAD, 0x02/*)*/, /*TempRegID*//* 301(*/0xAD, 0x02/*)*/,
     /* 193919 */   GIR_AddImm, /*InsnID*//* 301(*/0xAD, 0x02/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 193930 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 301(*/0xAD, 0x02/*)*/,
     /* 193933 */   GIR_MakeTempReg, /*TempRegID*//* 299(*/0xAB, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 193937 */   GIR_BuildMI, /*InsnID*//* 300(*/0xAC, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 193942 */   GIR_AddTempRegister, /*InsnID*//* 300(*/0xAC, 0x02/*)*/, /*TempRegID*//* 299(*/0xAB, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193949 */   GIR_AddImm, /*InsnID*//* 300(*/0xAC, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 193960 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 300(*/0xAC, 0x02/*)*/,
     /* 193963 */   GIR_MakeTempReg, /*TempRegID*//* 298(*/0xAA, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 193967 */   GIR_BuildMI, /*InsnID*//* 299(*/0xAB, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 193972 */   GIR_AddTempRegister, /*InsnID*//* 299(*/0xAB, 0x02/*)*/, /*TempRegID*//* 298(*/0xAA, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193979 */   GIR_AddSimpleTempRegister, /*InsnID*//* 299(*/0xAB, 0x02/*)*/, /*TempRegID*//* 299(*/0xAB, 0x02/*)*/,
     /* 193984 */   GIR_AddImm, /*InsnID*//* 299(*/0xAB, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 193995 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 299(*/0xAB, 0x02/*)*/,
     /* 193998 */   GIR_MakeTempReg, /*TempRegID*//* 297(*/0xA9, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194002 */   GIR_BuildMI, /*InsnID*//* 298(*/0xAA, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 194007 */   GIR_AddTempRegister, /*InsnID*//* 298(*/0xAA, 0x02/*)*/, /*TempRegID*//* 297(*/0xA9, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194014 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 298(*/0xAA, 0x02/*)*/,
     /* 194017 */   GIR_MakeTempReg, /*TempRegID*//* 296(*/0xA8, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194021 */   GIR_BuildMI, /*InsnID*//* 297(*/0xA9, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 194026 */   GIR_AddTempRegister, /*InsnID*//* 297(*/0xA9, 0x02/*)*/, /*TempRegID*//* 296(*/0xA8, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194033 */   GIR_AddSimpleTempRegister, /*InsnID*//* 297(*/0xA9, 0x02/*)*/, /*TempRegID*//* 297(*/0xA9, 0x02/*)*/,
     /* 194038 */   GIR_AddSimpleTempRegister, /*InsnID*//* 297(*/0xA9, 0x02/*)*/, /*TempRegID*//* 298(*/0xAA, 0x02/*)*/,
     /* 194043 */   GIR_AddImm8, /*InsnID*//* 297(*/0xA9, 0x02/*)*/, /*Imm*/1,
     /* 194047 */   GIR_ConstrainOperandRC, /*InsnID*//* 297(*/0xA9, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 194053 */   GIR_ConstrainOperandRC, /*InsnID*//* 297(*/0xA9, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 194059 */   GIR_ConstrainOperandRC, /*InsnID*//* 297(*/0xA9, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 194065 */   GIR_MakeTempReg, /*TempRegID*//* 295(*/0xA7, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194069 */   GIR_BuildMI, /*InsnID*//* 296(*/0xA8, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 194074 */   GIR_AddTempRegister, /*InsnID*//* 296(*/0xA8, 0x02/*)*/, /*TempRegID*//* 295(*/0xA7, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194081 */   GIR_AddSimpleTempRegister, /*InsnID*//* 296(*/0xA8, 0x02/*)*/, /*TempRegID*//* 296(*/0xA8, 0x02/*)*/,
     /* 194086 */   GIR_AddImm8, /*InsnID*//* 296(*/0xA8, 0x02/*)*/, /*Imm*/32,
     /* 194090 */   GIR_AddImm8, /*InsnID*//* 296(*/0xA8, 0x02/*)*/, /*Imm*/31,
     /* 194094 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 296(*/0xA8, 0x02/*)*/,
     /* 194097 */   GIR_MakeTempReg, /*TempRegID*//* 294(*/0xA6, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194101 */   GIR_BuildMI, /*InsnID*//* 295(*/0xA7, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 194106 */   GIR_AddTempRegister, /*InsnID*//* 295(*/0xA7, 0x02/*)*/, /*TempRegID*//* 294(*/0xA6, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194113 */   GIR_AddSimpleTempRegister, /*InsnID*//* 295(*/0xA7, 0x02/*)*/, /*TempRegID*//* 295(*/0xA7, 0x02/*)*/,
     /* 194118 */   GIR_AddImm, /*InsnID*//* 295(*/0xA7, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 194129 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 295(*/0xA7, 0x02/*)*/,
     /* 194132 */   GIR_MakeTempReg, /*TempRegID*//* 293(*/0xA5, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194136 */   GIR_BuildMI, /*InsnID*//* 294(*/0xA6, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 194141 */   GIR_AddTempRegister, /*InsnID*//* 294(*/0xA6, 0x02/*)*/, /*TempRegID*//* 293(*/0xA5, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194148 */   GIR_AddSimpleTempRegister, /*InsnID*//* 294(*/0xA6, 0x02/*)*/, /*TempRegID*//* 294(*/0xA6, 0x02/*)*/,
     /* 194153 */   GIR_AddImm, /*InsnID*//* 294(*/0xA6, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 194164 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 294(*/0xA6, 0x02/*)*/,
     /* 194167 */   GIR_MakeTempReg, /*TempRegID*//* 292(*/0xA4, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194171 */   GIR_BuildMI, /*InsnID*//* 293(*/0xA5, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 194176 */   GIR_AddTempRegister, /*InsnID*//* 293(*/0xA5, 0x02/*)*/, /*TempRegID*//* 292(*/0xA4, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194183 */   GIR_Copy, /*NewInsnID*//* 293(*/0xA5, 0x02/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 194188 */   GIR_AddImm8, /*InsnID*//* 293(*/0xA5, 0x02/*)*/, /*Imm*/1,
     /* 194192 */   GIR_AddImm8, /*InsnID*//* 293(*/0xA5, 0x02/*)*/, /*Imm*/62,
     /* 194196 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 293(*/0xA5, 0x02/*)*/,
     /* 194199 */   GIR_MakeTempReg, /*TempRegID*//* 291(*/0xA3, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194203 */   GIR_BuildMI, /*InsnID*//* 292(*/0xA4, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 194208 */   GIR_AddTempRegister, /*InsnID*//* 292(*/0xA4, 0x02/*)*/, /*TempRegID*//* 291(*/0xA3, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194215 */   GIR_AddSimpleTempRegister, /*InsnID*//* 292(*/0xA4, 0x02/*)*/, /*TempRegID*//* 292(*/0xA4, 0x02/*)*/,
     /* 194220 */   GIR_AddSimpleTempRegister, /*InsnID*//* 292(*/0xA4, 0x02/*)*/, /*TempRegID*//* 293(*/0xA5, 0x02/*)*/,
     /* 194225 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 292(*/0xA4, 0x02/*)*/,
     /* 194228 */   GIR_MakeTempReg, /*TempRegID*//* 290(*/0xA2, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 194232 */   GIR_BuildMI, /*InsnID*//* 291(*/0xA3, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 194237 */   GIR_AddTempRegister, /*InsnID*//* 291(*/0xA3, 0x02/*)*/, /*TempRegID*//* 290(*/0xA2, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194244 */   GIR_AddImm, /*InsnID*//* 291(*/0xA3, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 194255 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 291(*/0xA3, 0x02/*)*/,
     /* 194258 */   GIR_MakeTempReg, /*TempRegID*//* 289(*/0xA1, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 194262 */   GIR_BuildMI, /*InsnID*//* 290(*/0xA2, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 194267 */   GIR_AddTempRegister, /*InsnID*//* 290(*/0xA2, 0x02/*)*/, /*TempRegID*//* 289(*/0xA1, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194274 */   GIR_AddSimpleTempRegister, /*InsnID*//* 290(*/0xA2, 0x02/*)*/, /*TempRegID*//* 290(*/0xA2, 0x02/*)*/,
     /* 194279 */   GIR_AddImm, /*InsnID*//* 290(*/0xA2, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 194290 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 290(*/0xA2, 0x02/*)*/,
     /* 194293 */   GIR_MakeTempReg, /*TempRegID*//* 288(*/0xA0, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194297 */   GIR_BuildMI, /*InsnID*//* 289(*/0xA1, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 194302 */   GIR_AddTempRegister, /*InsnID*//* 289(*/0xA1, 0x02/*)*/, /*TempRegID*//* 288(*/0xA0, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194309 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 289(*/0xA1, 0x02/*)*/,
     /* 194312 */   GIR_MakeTempReg, /*TempRegID*//* 287(*/0x9F, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194316 */   GIR_BuildMI, /*InsnID*//* 288(*/0xA0, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 194321 */   GIR_AddTempRegister, /*InsnID*//* 288(*/0xA0, 0x02/*)*/, /*TempRegID*//* 287(*/0x9F, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194328 */   GIR_AddSimpleTempRegister, /*InsnID*//* 288(*/0xA0, 0x02/*)*/, /*TempRegID*//* 288(*/0xA0, 0x02/*)*/,
     /* 194333 */   GIR_AddSimpleTempRegister, /*InsnID*//* 288(*/0xA0, 0x02/*)*/, /*TempRegID*//* 289(*/0xA1, 0x02/*)*/,
     /* 194338 */   GIR_AddImm8, /*InsnID*//* 288(*/0xA0, 0x02/*)*/, /*Imm*/1,
     /* 194342 */   GIR_ConstrainOperandRC, /*InsnID*//* 288(*/0xA0, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 194348 */   GIR_ConstrainOperandRC, /*InsnID*//* 288(*/0xA0, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 194354 */   GIR_ConstrainOperandRC, /*InsnID*//* 288(*/0xA0, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 194360 */   GIR_MakeTempReg, /*TempRegID*//* 286(*/0x9E, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194364 */   GIR_BuildMI, /*InsnID*//* 287(*/0x9F, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 194369 */   GIR_AddTempRegister, /*InsnID*//* 287(*/0x9F, 0x02/*)*/, /*TempRegID*//* 286(*/0x9E, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194376 */   GIR_AddSimpleTempRegister, /*InsnID*//* 287(*/0x9F, 0x02/*)*/, /*TempRegID*//* 287(*/0x9F, 0x02/*)*/,
     /* 194381 */   GIR_AddImm8, /*InsnID*//* 287(*/0x9F, 0x02/*)*/, /*Imm*/32,
     /* 194385 */   GIR_AddImm8, /*InsnID*//* 287(*/0x9F, 0x02/*)*/, /*Imm*/31,
     /* 194389 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 287(*/0x9F, 0x02/*)*/,
     /* 194392 */   GIR_MakeTempReg, /*TempRegID*//* 285(*/0x9D, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194396 */   GIR_BuildMI, /*InsnID*//* 286(*/0x9E, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 194401 */   GIR_AddTempRegister, /*InsnID*//* 286(*/0x9E, 0x02/*)*/, /*TempRegID*//* 285(*/0x9D, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194408 */   GIR_AddSimpleTempRegister, /*InsnID*//* 286(*/0x9E, 0x02/*)*/, /*TempRegID*//* 286(*/0x9E, 0x02/*)*/,
     /* 194413 */   GIR_AddImm, /*InsnID*//* 286(*/0x9E, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 194424 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 286(*/0x9E, 0x02/*)*/,
     /* 194427 */   GIR_MakeTempReg, /*TempRegID*//* 284(*/0x9C, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194431 */   GIR_BuildMI, /*InsnID*//* 285(*/0x9D, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 194436 */   GIR_AddTempRegister, /*InsnID*//* 285(*/0x9D, 0x02/*)*/, /*TempRegID*//* 284(*/0x9C, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194443 */   GIR_AddSimpleTempRegister, /*InsnID*//* 285(*/0x9D, 0x02/*)*/, /*TempRegID*//* 285(*/0x9D, 0x02/*)*/,
     /* 194448 */   GIR_AddImm, /*InsnID*//* 285(*/0x9D, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 194459 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 285(*/0x9D, 0x02/*)*/,
     /* 194462 */   GIR_MakeTempReg, /*TempRegID*//* 283(*/0x9B, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194466 */   GIR_BuildMI, /*InsnID*//* 284(*/0x9C, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 194471 */   GIR_AddTempRegister, /*InsnID*//* 284(*/0x9C, 0x02/*)*/, /*TempRegID*//* 283(*/0x9B, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194478 */   GIR_Copy, /*NewInsnID*//* 284(*/0x9C, 0x02/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 194483 */   GIR_AddImm8, /*InsnID*//* 284(*/0x9C, 0x02/*)*/, /*Imm*/63,
     /* 194487 */   GIR_AddImm8, /*InsnID*//* 284(*/0x9C, 0x02/*)*/, /*Imm*/1,
     /* 194491 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 284(*/0x9C, 0x02/*)*/,
     /* 194494 */   GIR_MakeTempReg, /*TempRegID*//* 282(*/0x9A, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194498 */   GIR_BuildMI, /*InsnID*//* 283(*/0x9B, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 194503 */   GIR_AddTempRegister, /*InsnID*//* 283(*/0x9B, 0x02/*)*/, /*TempRegID*//* 282(*/0x9A, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194510 */   GIR_AddSimpleTempRegister, /*InsnID*//* 283(*/0x9B, 0x02/*)*/, /*TempRegID*//* 283(*/0x9B, 0x02/*)*/,
     /* 194515 */   GIR_AddSimpleTempRegister, /*InsnID*//* 283(*/0x9B, 0x02/*)*/, /*TempRegID*//* 284(*/0x9C, 0x02/*)*/,
     /* 194520 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 283(*/0x9B, 0x02/*)*/,
     /* 194523 */   GIR_MakeTempReg, /*TempRegID*//* 281(*/0x99, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194527 */   GIR_BuildMI, /*InsnID*//* 282(*/0x9A, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 194532 */   GIR_AddTempRegister, /*InsnID*//* 282(*/0x9A, 0x02/*)*/, /*TempRegID*//* 281(*/0x99, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194539 */   GIR_AddSimpleTempRegister, /*InsnID*//* 282(*/0x9A, 0x02/*)*/, /*TempRegID*//* 282(*/0x9A, 0x02/*)*/,
     /* 194544 */   GIR_AddSimpleTempRegister, /*InsnID*//* 282(*/0x9A, 0x02/*)*/, /*TempRegID*//* 291(*/0xA3, 0x02/*)*/,
     /* 194549 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 282(*/0x9A, 0x02/*)*/,
     /* 194552 */   GIR_MakeTempReg, /*TempRegID*//* 280(*/0x98, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194556 */   GIR_BuildMI, /*InsnID*//* 281(*/0x99, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 194561 */   GIR_AddTempRegister, /*InsnID*//* 281(*/0x99, 0x02/*)*/, /*TempRegID*//* 280(*/0x98, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194568 */   GIR_AddSimpleTempRegister, /*InsnID*//* 281(*/0x99, 0x02/*)*/, /*TempRegID*//* 281(*/0x99, 0x02/*)*/,
     /* 194573 */   GIR_AddImm8, /*InsnID*//* 281(*/0x99, 0x02/*)*/, /*Imm*/62,
     /* 194577 */   GIR_AddImm8, /*InsnID*//* 281(*/0x99, 0x02/*)*/, /*Imm*/2,
     /* 194581 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 281(*/0x99, 0x02/*)*/,
     /* 194584 */   GIR_MakeTempReg, /*TempRegID*//* 279(*/0x97, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194588 */   GIR_BuildMI, /*InsnID*//* 280(*/0x98, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 194593 */   GIR_AddTempRegister, /*InsnID*//* 280(*/0x98, 0x02/*)*/, /*TempRegID*//* 279(*/0x97, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194600 */   GIR_AddSimpleTempRegister, /*InsnID*//* 280(*/0x98, 0x02/*)*/, /*TempRegID*//* 280(*/0x98, 0x02/*)*/,
     /* 194605 */   GIR_AddSimpleTempRegister, /*InsnID*//* 280(*/0x98, 0x02/*)*/, /*TempRegID*//* 300(*/0xAC, 0x02/*)*/,
     /* 194610 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 280(*/0x98, 0x02/*)*/,
     /* 194613 */   GIR_MakeTempReg, /*TempRegID*//* 278(*/0x96, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194617 */   GIR_BuildMI, /*InsnID*//* 279(*/0x97, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 194622 */   GIR_AddTempRegister, /*InsnID*//* 279(*/0x97, 0x02/*)*/, /*TempRegID*//* 278(*/0x96, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194629 */   GIR_AddSimpleTempRegister, /*InsnID*//* 279(*/0x97, 0x02/*)*/, /*TempRegID*//* 279(*/0x97, 0x02/*)*/,
     /* 194634 */   GIR_AddSimpleTempRegister, /*InsnID*//* 279(*/0x97, 0x02/*)*/, /*TempRegID*//* 307(*/0xB3, 0x02/*)*/,
     /* 194639 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 279(*/0x97, 0x02/*)*/,
     /* 194642 */   GIR_MakeTempReg, /*TempRegID*//* 277(*/0x95, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194646 */   GIR_BuildMI, /*InsnID*//* 278(*/0x96, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 194651 */   GIR_AddTempRegister, /*InsnID*//* 278(*/0x96, 0x02/*)*/, /*TempRegID*//* 277(*/0x95, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194658 */   GIR_AddSimpleTempRegister, /*InsnID*//* 278(*/0x96, 0x02/*)*/, /*TempRegID*//* 278(*/0x96, 0x02/*)*/,
     /* 194663 */   GIR_AddImm8, /*InsnID*//* 278(*/0x96, 0x02/*)*/, /*Imm*/60,
     /* 194667 */   GIR_AddImm8, /*InsnID*//* 278(*/0x96, 0x02/*)*/, /*Imm*/4,
     /* 194671 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 278(*/0x96, 0x02/*)*/,
     /* 194674 */   GIR_MakeTempReg, /*TempRegID*//* 276(*/0x94, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194678 */   GIR_BuildMI, /*InsnID*//* 277(*/0x95, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 194683 */   GIR_AddTempRegister, /*InsnID*//* 277(*/0x95, 0x02/*)*/, /*TempRegID*//* 276(*/0x94, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194690 */   GIR_AddSimpleTempRegister, /*InsnID*//* 277(*/0x95, 0x02/*)*/, /*TempRegID*//* 277(*/0x95, 0x02/*)*/,
     /* 194695 */   GIR_AddSimpleTempRegister, /*InsnID*//* 277(*/0x95, 0x02/*)*/, /*TempRegID*//* 335(*/0xCF, 0x02/*)*/,
     /* 194700 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 277(*/0x95, 0x02/*)*/,
     /* 194703 */   GIR_MakeTempReg, /*TempRegID*//* 275(*/0x93, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194707 */   GIR_BuildMI, /*InsnID*//* 276(*/0x94, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 194712 */   GIR_AddTempRegister, /*InsnID*//* 276(*/0x94, 0x02/*)*/, /*TempRegID*//* 275(*/0x93, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194719 */   GIR_AddSimpleTempRegister, /*InsnID*//* 276(*/0x94, 0x02/*)*/, /*TempRegID*//* 276(*/0x94, 0x02/*)*/,
     /* 194724 */   GIR_AddSimpleTempRegister, /*InsnID*//* 276(*/0x94, 0x02/*)*/, /*TempRegID*//* 342(*/0xD6, 0x02/*)*/,
     /* 194729 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 276(*/0x94, 0x02/*)*/,
     /* 194732 */   GIR_MakeTempReg, /*TempRegID*//* 547(*/0xA3, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 194736 */   GIR_BuildMI, /*InsnID*//* 548(*/0xA4, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 194741 */   GIR_AddTempRegister, /*InsnID*//* 548(*/0xA4, 0x04/*)*/, /*TempRegID*//* 547(*/0xA3, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194748 */   GIR_AddImm, /*InsnID*//* 548(*/0xA4, 0x04/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 194759 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 548(*/0xA4, 0x04/*)*/,
     /* 194762 */   GIR_MakeTempReg, /*TempRegID*//* 546(*/0xA2, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 194766 */   GIR_BuildMI, /*InsnID*//* 547(*/0xA3, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 194771 */   GIR_AddTempRegister, /*InsnID*//* 547(*/0xA3, 0x04/*)*/, /*TempRegID*//* 546(*/0xA2, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194778 */   GIR_AddSimpleTempRegister, /*InsnID*//* 547(*/0xA3, 0x04/*)*/, /*TempRegID*//* 547(*/0xA3, 0x04/*)*/,
     /* 194783 */   GIR_AddImm, /*InsnID*//* 547(*/0xA3, 0x04/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 194794 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 547(*/0xA3, 0x04/*)*/,
     /* 194797 */   GIR_MakeTempReg, /*TempRegID*//* 545(*/0xA1, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 194801 */   GIR_BuildMI, /*InsnID*//* 546(*/0xA2, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 194806 */   GIR_AddTempRegister, /*InsnID*//* 546(*/0xA2, 0x04/*)*/, /*TempRegID*//* 545(*/0xA1, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194813 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 546(*/0xA2, 0x04/*)*/,
     /* 194816 */   GIR_MakeTempReg, /*TempRegID*//* 544(*/0xA0, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 194820 */   GIR_BuildMI, /*InsnID*//* 545(*/0xA1, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 194825 */   GIR_AddTempRegister, /*InsnID*//* 545(*/0xA1, 0x04/*)*/, /*TempRegID*//* 544(*/0xA0, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194832 */   GIR_AddSimpleTempRegister, /*InsnID*//* 545(*/0xA1, 0x04/*)*/, /*TempRegID*//* 545(*/0xA1, 0x04/*)*/,
     /* 194837 */   GIR_AddSimpleTempRegister, /*InsnID*//* 545(*/0xA1, 0x04/*)*/, /*TempRegID*//* 546(*/0xA2, 0x04/*)*/,
     /* 194842 */   GIR_AddImm8, /*InsnID*//* 545(*/0xA1, 0x04/*)*/, /*Imm*/1,
     /* 194846 */   GIR_ConstrainOperandRC, /*InsnID*//* 545(*/0xA1, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 194852 */   GIR_ConstrainOperandRC, /*InsnID*//* 545(*/0xA1, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 194858 */   GIR_ConstrainOperandRC, /*InsnID*//* 545(*/0xA1, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 194864 */   GIR_MakeTempReg, /*TempRegID*//* 543(*/0x9F, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 194868 */   GIR_BuildMI, /*InsnID*//* 544(*/0xA0, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 194873 */   GIR_AddTempRegister, /*InsnID*//* 544(*/0xA0, 0x04/*)*/, /*TempRegID*//* 543(*/0x9F, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194880 */   GIR_AddSimpleTempRegister, /*InsnID*//* 544(*/0xA0, 0x04/*)*/, /*TempRegID*//* 544(*/0xA0, 0x04/*)*/,
     /* 194885 */   GIR_AddImm8, /*InsnID*//* 544(*/0xA0, 0x04/*)*/, /*Imm*/32,
     /* 194889 */   GIR_AddImm8, /*InsnID*//* 544(*/0xA0, 0x04/*)*/, /*Imm*/31,
     /* 194893 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 544(*/0xA0, 0x04/*)*/,
     /* 194896 */   GIR_MakeTempReg, /*TempRegID*//* 542(*/0x9E, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 194900 */   GIR_BuildMI, /*InsnID*//* 543(*/0x9F, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 194905 */   GIR_AddTempRegister, /*InsnID*//* 543(*/0x9F, 0x04/*)*/, /*TempRegID*//* 542(*/0x9E, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194912 */   GIR_AddSimpleTempRegister, /*InsnID*//* 543(*/0x9F, 0x04/*)*/, /*TempRegID*//* 543(*/0x9F, 0x04/*)*/,
     /* 194917 */   GIR_AddImm, /*InsnID*//* 543(*/0x9F, 0x04/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 194928 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 543(*/0x9F, 0x04/*)*/,
     /* 194931 */   GIR_MakeTempReg, /*TempRegID*//* 541(*/0x9D, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 194935 */   GIR_BuildMI, /*InsnID*//* 542(*/0x9E, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 194940 */   GIR_AddTempRegister, /*InsnID*//* 542(*/0x9E, 0x04/*)*/, /*TempRegID*//* 541(*/0x9D, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194947 */   GIR_AddSimpleTempRegister, /*InsnID*//* 542(*/0x9E, 0x04/*)*/, /*TempRegID*//* 542(*/0x9E, 0x04/*)*/,
     /* 194952 */   GIR_AddImm, /*InsnID*//* 542(*/0x9E, 0x04/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 194963 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 542(*/0x9E, 0x04/*)*/,
     /* 194966 */   GIR_MakeTempReg, /*TempRegID*//* 540(*/0x9C, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 194970 */   GIR_BuildMI, /*InsnID*//* 541(*/0x9D, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 194975 */   GIR_AddTempRegister, /*InsnID*//* 541(*/0x9D, 0x04/*)*/, /*TempRegID*//* 540(*/0x9C, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194982 */   GIR_AddImm, /*InsnID*//* 541(*/0x9D, 0x04/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 194993 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 541(*/0x9D, 0x04/*)*/,
     /* 194996 */   GIR_MakeTempReg, /*TempRegID*//* 539(*/0x9B, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 195000 */   GIR_BuildMI, /*InsnID*//* 540(*/0x9C, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 195005 */   GIR_AddTempRegister, /*InsnID*//* 540(*/0x9C, 0x04/*)*/, /*TempRegID*//* 539(*/0x9B, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195012 */   GIR_AddSimpleTempRegister, /*InsnID*//* 540(*/0x9C, 0x04/*)*/, /*TempRegID*//* 540(*/0x9C, 0x04/*)*/,
     /* 195017 */   GIR_AddImm, /*InsnID*//* 540(*/0x9C, 0x04/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 195028 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 540(*/0x9C, 0x04/*)*/,
     /* 195031 */   GIR_MakeTempReg, /*TempRegID*//* 538(*/0x9A, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195035 */   GIR_BuildMI, /*InsnID*//* 539(*/0x9B, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 195040 */   GIR_AddTempRegister, /*InsnID*//* 539(*/0x9B, 0x04/*)*/, /*TempRegID*//* 538(*/0x9A, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195047 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 539(*/0x9B, 0x04/*)*/,
     /* 195050 */   GIR_MakeTempReg, /*TempRegID*//* 537(*/0x99, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195054 */   GIR_BuildMI, /*InsnID*//* 538(*/0x9A, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 195059 */   GIR_AddTempRegister, /*InsnID*//* 538(*/0x9A, 0x04/*)*/, /*TempRegID*//* 537(*/0x99, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195066 */   GIR_AddSimpleTempRegister, /*InsnID*//* 538(*/0x9A, 0x04/*)*/, /*TempRegID*//* 538(*/0x9A, 0x04/*)*/,
     /* 195071 */   GIR_AddSimpleTempRegister, /*InsnID*//* 538(*/0x9A, 0x04/*)*/, /*TempRegID*//* 539(*/0x9B, 0x04/*)*/,
     /* 195076 */   GIR_AddImm8, /*InsnID*//* 538(*/0x9A, 0x04/*)*/, /*Imm*/1,
     /* 195080 */   GIR_ConstrainOperandRC, /*InsnID*//* 538(*/0x9A, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 195086 */   GIR_ConstrainOperandRC, /*InsnID*//* 538(*/0x9A, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 195092 */   GIR_ConstrainOperandRC, /*InsnID*//* 538(*/0x9A, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 195098 */   GIR_MakeTempReg, /*TempRegID*//* 536(*/0x98, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195102 */   GIR_BuildMI, /*InsnID*//* 537(*/0x99, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 195107 */   GIR_AddTempRegister, /*InsnID*//* 537(*/0x99, 0x04/*)*/, /*TempRegID*//* 536(*/0x98, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195114 */   GIR_AddSimpleTempRegister, /*InsnID*//* 537(*/0x99, 0x04/*)*/, /*TempRegID*//* 537(*/0x99, 0x04/*)*/,
     /* 195119 */   GIR_AddImm8, /*InsnID*//* 537(*/0x99, 0x04/*)*/, /*Imm*/32,
     /* 195123 */   GIR_AddImm8, /*InsnID*//* 537(*/0x99, 0x04/*)*/, /*Imm*/31,
     /* 195127 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 537(*/0x99, 0x04/*)*/,
     /* 195130 */   GIR_MakeTempReg, /*TempRegID*//* 535(*/0x97, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195134 */   GIR_BuildMI, /*InsnID*//* 536(*/0x98, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 195139 */   GIR_AddTempRegister, /*InsnID*//* 536(*/0x98, 0x04/*)*/, /*TempRegID*//* 535(*/0x97, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195146 */   GIR_AddSimpleTempRegister, /*InsnID*//* 536(*/0x98, 0x04/*)*/, /*TempRegID*//* 536(*/0x98, 0x04/*)*/,
     /* 195151 */   GIR_AddImm, /*InsnID*//* 536(*/0x98, 0x04/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 195162 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 536(*/0x98, 0x04/*)*/,
     /* 195165 */   GIR_MakeTempReg, /*TempRegID*//* 534(*/0x96, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195169 */   GIR_BuildMI, /*InsnID*//* 535(*/0x97, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 195174 */   GIR_AddTempRegister, /*InsnID*//* 535(*/0x97, 0x04/*)*/, /*TempRegID*//* 534(*/0x96, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195181 */   GIR_AddSimpleTempRegister, /*InsnID*//* 535(*/0x97, 0x04/*)*/, /*TempRegID*//* 535(*/0x97, 0x04/*)*/,
     /* 195186 */   GIR_AddImm, /*InsnID*//* 535(*/0x97, 0x04/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 195197 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 535(*/0x97, 0x04/*)*/,
     /* 195200 */   GIR_MakeTempReg, /*TempRegID*//* 533(*/0x95, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 195204 */   GIR_BuildMI, /*InsnID*//* 534(*/0x96, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 195209 */   GIR_AddTempRegister, /*InsnID*//* 534(*/0x96, 0x04/*)*/, /*TempRegID*//* 533(*/0x95, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195216 */   GIR_AddImm, /*InsnID*//* 534(*/0x96, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 195227 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 534(*/0x96, 0x04/*)*/,
     /* 195230 */   GIR_MakeTempReg, /*TempRegID*//* 532(*/0x94, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 195234 */   GIR_BuildMI, /*InsnID*//* 533(*/0x95, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 195239 */   GIR_AddTempRegister, /*InsnID*//* 533(*/0x95, 0x04/*)*/, /*TempRegID*//* 532(*/0x94, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195246 */   GIR_AddSimpleTempRegister, /*InsnID*//* 533(*/0x95, 0x04/*)*/, /*TempRegID*//* 533(*/0x95, 0x04/*)*/,
     /* 195251 */   GIR_AddImm, /*InsnID*//* 533(*/0x95, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 195262 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 533(*/0x95, 0x04/*)*/,
     /* 195265 */   GIR_MakeTempReg, /*TempRegID*//* 531(*/0x93, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195269 */   GIR_BuildMI, /*InsnID*//* 532(*/0x94, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 195274 */   GIR_AddTempRegister, /*InsnID*//* 532(*/0x94, 0x04/*)*/, /*TempRegID*//* 531(*/0x93, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195281 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 532(*/0x94, 0x04/*)*/,
     /* 195284 */   GIR_MakeTempReg, /*TempRegID*//* 530(*/0x92, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195288 */   GIR_BuildMI, /*InsnID*//* 531(*/0x93, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 195293 */   GIR_AddTempRegister, /*InsnID*//* 531(*/0x93, 0x04/*)*/, /*TempRegID*//* 530(*/0x92, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195300 */   GIR_AddSimpleTempRegister, /*InsnID*//* 531(*/0x93, 0x04/*)*/, /*TempRegID*//* 531(*/0x93, 0x04/*)*/,
     /* 195305 */   GIR_AddSimpleTempRegister, /*InsnID*//* 531(*/0x93, 0x04/*)*/, /*TempRegID*//* 532(*/0x94, 0x04/*)*/,
     /* 195310 */   GIR_AddImm8, /*InsnID*//* 531(*/0x93, 0x04/*)*/, /*Imm*/1,
     /* 195314 */   GIR_ConstrainOperandRC, /*InsnID*//* 531(*/0x93, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 195320 */   GIR_ConstrainOperandRC, /*InsnID*//* 531(*/0x93, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 195326 */   GIR_ConstrainOperandRC, /*InsnID*//* 531(*/0x93, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 195332 */   GIR_MakeTempReg, /*TempRegID*//* 529(*/0x91, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195336 */   GIR_BuildMI, /*InsnID*//* 530(*/0x92, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 195341 */   GIR_AddTempRegister, /*InsnID*//* 530(*/0x92, 0x04/*)*/, /*TempRegID*//* 529(*/0x91, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195348 */   GIR_AddSimpleTempRegister, /*InsnID*//* 530(*/0x92, 0x04/*)*/, /*TempRegID*//* 530(*/0x92, 0x04/*)*/,
     /* 195353 */   GIR_AddImm8, /*InsnID*//* 530(*/0x92, 0x04/*)*/, /*Imm*/32,
     /* 195357 */   GIR_AddImm8, /*InsnID*//* 530(*/0x92, 0x04/*)*/, /*Imm*/31,
     /* 195361 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 530(*/0x92, 0x04/*)*/,
     /* 195364 */   GIR_MakeTempReg, /*TempRegID*//* 528(*/0x90, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195368 */   GIR_BuildMI, /*InsnID*//* 529(*/0x91, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 195373 */   GIR_AddTempRegister, /*InsnID*//* 529(*/0x91, 0x04/*)*/, /*TempRegID*//* 528(*/0x90, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195380 */   GIR_AddSimpleTempRegister, /*InsnID*//* 529(*/0x91, 0x04/*)*/, /*TempRegID*//* 529(*/0x91, 0x04/*)*/,
     /* 195385 */   GIR_AddImm, /*InsnID*//* 529(*/0x91, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 195396 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 529(*/0x91, 0x04/*)*/,
     /* 195399 */   GIR_MakeTempReg, /*TempRegID*//* 527(*/0x8F, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195403 */   GIR_BuildMI, /*InsnID*//* 528(*/0x90, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 195408 */   GIR_AddTempRegister, /*InsnID*//* 528(*/0x90, 0x04/*)*/, /*TempRegID*//* 527(*/0x8F, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195415 */   GIR_AddSimpleTempRegister, /*InsnID*//* 528(*/0x90, 0x04/*)*/, /*TempRegID*//* 528(*/0x90, 0x04/*)*/,
     /* 195420 */   GIR_AddImm, /*InsnID*//* 528(*/0x90, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 195431 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 528(*/0x90, 0x04/*)*/,
     /* 195434 */   GIR_MakeTempReg, /*TempRegID*//* 526(*/0x8E, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195438 */   GIR_BuildMI, /*InsnID*//* 527(*/0x8F, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 195443 */   GIR_AddTempRegister, /*InsnID*//* 527(*/0x8F, 0x04/*)*/, /*TempRegID*//* 526(*/0x8E, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195450 */   GIR_Copy, /*NewInsnID*//* 527(*/0x8F, 0x04/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 195455 */   GIR_AddImm8, /*InsnID*//* 527(*/0x8F, 0x04/*)*/, /*Imm*/1,
     /* 195459 */   GIR_AddImm8, /*InsnID*//* 527(*/0x8F, 0x04/*)*/, /*Imm*/62,
     /* 195463 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 527(*/0x8F, 0x04/*)*/,
     /* 195466 */   GIR_MakeTempReg, /*TempRegID*//* 525(*/0x8D, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195470 */   GIR_BuildMI, /*InsnID*//* 526(*/0x8E, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 195475 */   GIR_AddTempRegister, /*InsnID*//* 526(*/0x8E, 0x04/*)*/, /*TempRegID*//* 525(*/0x8D, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195482 */   GIR_AddSimpleTempRegister, /*InsnID*//* 526(*/0x8E, 0x04/*)*/, /*TempRegID*//* 526(*/0x8E, 0x04/*)*/,
     /* 195487 */   GIR_AddSimpleTempRegister, /*InsnID*//* 526(*/0x8E, 0x04/*)*/, /*TempRegID*//* 527(*/0x8F, 0x04/*)*/,
     /* 195492 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 526(*/0x8E, 0x04/*)*/,
     /* 195495 */   GIR_MakeTempReg, /*TempRegID*//* 524(*/0x8C, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 195499 */   GIR_BuildMI, /*InsnID*//* 525(*/0x8D, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 195504 */   GIR_AddTempRegister, /*InsnID*//* 525(*/0x8D, 0x04/*)*/, /*TempRegID*//* 524(*/0x8C, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195511 */   GIR_AddImm, /*InsnID*//* 525(*/0x8D, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 195522 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 525(*/0x8D, 0x04/*)*/,
     /* 195525 */   GIR_MakeTempReg, /*TempRegID*//* 523(*/0x8B, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 195529 */   GIR_BuildMI, /*InsnID*//* 524(*/0x8C, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 195534 */   GIR_AddTempRegister, /*InsnID*//* 524(*/0x8C, 0x04/*)*/, /*TempRegID*//* 523(*/0x8B, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195541 */   GIR_AddSimpleTempRegister, /*InsnID*//* 524(*/0x8C, 0x04/*)*/, /*TempRegID*//* 524(*/0x8C, 0x04/*)*/,
     /* 195546 */   GIR_AddImm, /*InsnID*//* 524(*/0x8C, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 195557 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 524(*/0x8C, 0x04/*)*/,
     /* 195560 */   GIR_MakeTempReg, /*TempRegID*//* 522(*/0x8A, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195564 */   GIR_BuildMI, /*InsnID*//* 523(*/0x8B, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 195569 */   GIR_AddTempRegister, /*InsnID*//* 523(*/0x8B, 0x04/*)*/, /*TempRegID*//* 522(*/0x8A, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195576 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 523(*/0x8B, 0x04/*)*/,
     /* 195579 */   GIR_MakeTempReg, /*TempRegID*//* 521(*/0x89, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195583 */   GIR_BuildMI, /*InsnID*//* 522(*/0x8A, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 195588 */   GIR_AddTempRegister, /*InsnID*//* 522(*/0x8A, 0x04/*)*/, /*TempRegID*//* 521(*/0x89, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195595 */   GIR_AddSimpleTempRegister, /*InsnID*//* 522(*/0x8A, 0x04/*)*/, /*TempRegID*//* 522(*/0x8A, 0x04/*)*/,
     /* 195600 */   GIR_AddSimpleTempRegister, /*InsnID*//* 522(*/0x8A, 0x04/*)*/, /*TempRegID*//* 523(*/0x8B, 0x04/*)*/,
     /* 195605 */   GIR_AddImm8, /*InsnID*//* 522(*/0x8A, 0x04/*)*/, /*Imm*/1,
     /* 195609 */   GIR_ConstrainOperandRC, /*InsnID*//* 522(*/0x8A, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 195615 */   GIR_ConstrainOperandRC, /*InsnID*//* 522(*/0x8A, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 195621 */   GIR_ConstrainOperandRC, /*InsnID*//* 522(*/0x8A, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 195627 */   GIR_MakeTempReg, /*TempRegID*//* 520(*/0x88, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195631 */   GIR_BuildMI, /*InsnID*//* 521(*/0x89, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 195636 */   GIR_AddTempRegister, /*InsnID*//* 521(*/0x89, 0x04/*)*/, /*TempRegID*//* 520(*/0x88, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195643 */   GIR_AddSimpleTempRegister, /*InsnID*//* 521(*/0x89, 0x04/*)*/, /*TempRegID*//* 521(*/0x89, 0x04/*)*/,
     /* 195648 */   GIR_AddImm8, /*InsnID*//* 521(*/0x89, 0x04/*)*/, /*Imm*/32,
     /* 195652 */   GIR_AddImm8, /*InsnID*//* 521(*/0x89, 0x04/*)*/, /*Imm*/31,
     /* 195656 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 521(*/0x89, 0x04/*)*/,
     /* 195659 */   GIR_MakeTempReg, /*TempRegID*//* 519(*/0x87, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195663 */   GIR_BuildMI, /*InsnID*//* 520(*/0x88, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 195668 */   GIR_AddTempRegister, /*InsnID*//* 520(*/0x88, 0x04/*)*/, /*TempRegID*//* 519(*/0x87, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195675 */   GIR_AddSimpleTempRegister, /*InsnID*//* 520(*/0x88, 0x04/*)*/, /*TempRegID*//* 520(*/0x88, 0x04/*)*/,
     /* 195680 */   GIR_AddImm, /*InsnID*//* 520(*/0x88, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 195691 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 520(*/0x88, 0x04/*)*/,
     /* 195694 */   GIR_MakeTempReg, /*TempRegID*//* 518(*/0x86, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195698 */   GIR_BuildMI, /*InsnID*//* 519(*/0x87, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 195703 */   GIR_AddTempRegister, /*InsnID*//* 519(*/0x87, 0x04/*)*/, /*TempRegID*//* 518(*/0x86, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195710 */   GIR_AddSimpleTempRegister, /*InsnID*//* 519(*/0x87, 0x04/*)*/, /*TempRegID*//* 519(*/0x87, 0x04/*)*/,
     /* 195715 */   GIR_AddImm, /*InsnID*//* 519(*/0x87, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 195726 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 519(*/0x87, 0x04/*)*/,
     /* 195729 */   GIR_MakeTempReg, /*TempRegID*//* 517(*/0x85, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195733 */   GIR_BuildMI, /*InsnID*//* 518(*/0x86, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 195738 */   GIR_AddTempRegister, /*InsnID*//* 518(*/0x86, 0x04/*)*/, /*TempRegID*//* 517(*/0x85, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195745 */   GIR_Copy, /*NewInsnID*//* 518(*/0x86, 0x04/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 195750 */   GIR_AddImm8, /*InsnID*//* 518(*/0x86, 0x04/*)*/, /*Imm*/63,
     /* 195754 */   GIR_AddImm8, /*InsnID*//* 518(*/0x86, 0x04/*)*/, /*Imm*/1,
     /* 195758 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 518(*/0x86, 0x04/*)*/,
     /* 195761 */   GIR_MakeTempReg, /*TempRegID*//* 516(*/0x84, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195765 */   GIR_BuildMI, /*InsnID*//* 517(*/0x85, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 195770 */   GIR_AddTempRegister, /*InsnID*//* 517(*/0x85, 0x04/*)*/, /*TempRegID*//* 516(*/0x84, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195777 */   GIR_AddSimpleTempRegister, /*InsnID*//* 517(*/0x85, 0x04/*)*/, /*TempRegID*//* 517(*/0x85, 0x04/*)*/,
     /* 195782 */   GIR_AddSimpleTempRegister, /*InsnID*//* 517(*/0x85, 0x04/*)*/, /*TempRegID*//* 518(*/0x86, 0x04/*)*/,
     /* 195787 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 517(*/0x85, 0x04/*)*/,
     /* 195790 */   GIR_MakeTempReg, /*TempRegID*//* 515(*/0x83, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195794 */   GIR_BuildMI, /*InsnID*//* 516(*/0x84, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 195799 */   GIR_AddTempRegister, /*InsnID*//* 516(*/0x84, 0x04/*)*/, /*TempRegID*//* 515(*/0x83, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195806 */   GIR_AddSimpleTempRegister, /*InsnID*//* 516(*/0x84, 0x04/*)*/, /*TempRegID*//* 516(*/0x84, 0x04/*)*/,
     /* 195811 */   GIR_AddSimpleTempRegister, /*InsnID*//* 516(*/0x84, 0x04/*)*/, /*TempRegID*//* 525(*/0x8D, 0x04/*)*/,
     /* 195816 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 516(*/0x84, 0x04/*)*/,
     /* 195819 */   GIR_MakeTempReg, /*TempRegID*//* 514(*/0x82, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195823 */   GIR_BuildMI, /*InsnID*//* 515(*/0x83, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 195828 */   GIR_AddTempRegister, /*InsnID*//* 515(*/0x83, 0x04/*)*/, /*TempRegID*//* 514(*/0x82, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195835 */   GIR_AddSimpleTempRegister, /*InsnID*//* 515(*/0x83, 0x04/*)*/, /*TempRegID*//* 515(*/0x83, 0x04/*)*/,
     /* 195840 */   GIR_AddImm8, /*InsnID*//* 515(*/0x83, 0x04/*)*/, /*Imm*/2,
     /* 195844 */   GIR_AddImm8, /*InsnID*//* 515(*/0x83, 0x04/*)*/, /*Imm*/61,
     /* 195848 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 515(*/0x83, 0x04/*)*/,
     /* 195851 */   GIR_MakeTempReg, /*TempRegID*//* 513(*/0x81, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195855 */   GIR_BuildMI, /*InsnID*//* 514(*/0x82, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 195860 */   GIR_AddTempRegister, /*InsnID*//* 514(*/0x82, 0x04/*)*/, /*TempRegID*//* 513(*/0x81, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195867 */   GIR_AddSimpleTempRegister, /*InsnID*//* 514(*/0x82, 0x04/*)*/, /*TempRegID*//* 514(*/0x82, 0x04/*)*/,
     /* 195872 */   GIR_AddSimpleTempRegister, /*InsnID*//* 514(*/0x82, 0x04/*)*/, /*TempRegID*//* 534(*/0x96, 0x04/*)*/,
     /* 195877 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 514(*/0x82, 0x04/*)*/,
     /* 195880 */   GIR_MakeTempReg, /*TempRegID*//* 512(*/0x80, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 195884 */   GIR_BuildMI, /*InsnID*//* 513(*/0x81, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 195889 */   GIR_AddTempRegister, /*InsnID*//* 513(*/0x81, 0x04/*)*/, /*TempRegID*//* 512(*/0x80, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195896 */   GIR_AddImm, /*InsnID*//* 513(*/0x81, 0x04/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 195907 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 513(*/0x81, 0x04/*)*/,
     /* 195910 */   GIR_MakeTempReg, /*TempRegID*//* 511(*/0xFF, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 195914 */   GIR_BuildMI, /*InsnID*//* 512(*/0x80, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 195919 */   GIR_AddTempRegister, /*InsnID*//* 512(*/0x80, 0x04/*)*/, /*TempRegID*//* 511(*/0xFF, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195926 */   GIR_AddSimpleTempRegister, /*InsnID*//* 512(*/0x80, 0x04/*)*/, /*TempRegID*//* 512(*/0x80, 0x04/*)*/,
     /* 195931 */   GIR_AddImm, /*InsnID*//* 512(*/0x80, 0x04/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 195942 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 512(*/0x80, 0x04/*)*/,
     /* 195945 */   GIR_MakeTempReg, /*TempRegID*//* 510(*/0xFE, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 195949 */   GIR_BuildMI, /*InsnID*//* 511(*/0xFF, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 195954 */   GIR_AddTempRegister, /*InsnID*//* 511(*/0xFF, 0x03/*)*/, /*TempRegID*//* 510(*/0xFE, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195961 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 511(*/0xFF, 0x03/*)*/,
     /* 195964 */   GIR_MakeTempReg, /*TempRegID*//* 509(*/0xFD, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 195968 */   GIR_BuildMI, /*InsnID*//* 510(*/0xFE, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 195973 */   GIR_AddTempRegister, /*InsnID*//* 510(*/0xFE, 0x03/*)*/, /*TempRegID*//* 509(*/0xFD, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195980 */   GIR_AddSimpleTempRegister, /*InsnID*//* 510(*/0xFE, 0x03/*)*/, /*TempRegID*//* 510(*/0xFE, 0x03/*)*/,
     /* 195985 */   GIR_AddSimpleTempRegister, /*InsnID*//* 510(*/0xFE, 0x03/*)*/, /*TempRegID*//* 511(*/0xFF, 0x03/*)*/,
     /* 195990 */   GIR_AddImm8, /*InsnID*//* 510(*/0xFE, 0x03/*)*/, /*Imm*/1,
     /* 195994 */   GIR_ConstrainOperandRC, /*InsnID*//* 510(*/0xFE, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 196000 */   GIR_ConstrainOperandRC, /*InsnID*//* 510(*/0xFE, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 196006 */   GIR_ConstrainOperandRC, /*InsnID*//* 510(*/0xFE, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 196012 */   GIR_MakeTempReg, /*TempRegID*//* 508(*/0xFC, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196016 */   GIR_BuildMI, /*InsnID*//* 509(*/0xFD, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 196021 */   GIR_AddTempRegister, /*InsnID*//* 509(*/0xFD, 0x03/*)*/, /*TempRegID*//* 508(*/0xFC, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196028 */   GIR_AddSimpleTempRegister, /*InsnID*//* 509(*/0xFD, 0x03/*)*/, /*TempRegID*//* 509(*/0xFD, 0x03/*)*/,
     /* 196033 */   GIR_AddImm8, /*InsnID*//* 509(*/0xFD, 0x03/*)*/, /*Imm*/32,
     /* 196037 */   GIR_AddImm8, /*InsnID*//* 509(*/0xFD, 0x03/*)*/, /*Imm*/31,
     /* 196041 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 509(*/0xFD, 0x03/*)*/,
     /* 196044 */   GIR_MakeTempReg, /*TempRegID*//* 507(*/0xFB, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196048 */   GIR_BuildMI, /*InsnID*//* 508(*/0xFC, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 196053 */   GIR_AddTempRegister, /*InsnID*//* 508(*/0xFC, 0x03/*)*/, /*TempRegID*//* 507(*/0xFB, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196060 */   GIR_AddSimpleTempRegister, /*InsnID*//* 508(*/0xFC, 0x03/*)*/, /*TempRegID*//* 508(*/0xFC, 0x03/*)*/,
     /* 196065 */   GIR_AddImm, /*InsnID*//* 508(*/0xFC, 0x03/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 196076 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 508(*/0xFC, 0x03/*)*/,
     /* 196079 */   GIR_MakeTempReg, /*TempRegID*//* 506(*/0xFA, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196083 */   GIR_BuildMI, /*InsnID*//* 507(*/0xFB, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 196088 */   GIR_AddTempRegister, /*InsnID*//* 507(*/0xFB, 0x03/*)*/, /*TempRegID*//* 506(*/0xFA, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196095 */   GIR_AddSimpleTempRegister, /*InsnID*//* 507(*/0xFB, 0x03/*)*/, /*TempRegID*//* 507(*/0xFB, 0x03/*)*/,
     /* 196100 */   GIR_AddImm, /*InsnID*//* 507(*/0xFB, 0x03/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 196111 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 507(*/0xFB, 0x03/*)*/,
     /* 196114 */   GIR_MakeTempReg, /*TempRegID*//* 505(*/0xF9, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 196118 */   GIR_BuildMI, /*InsnID*//* 506(*/0xFA, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 196123 */   GIR_AddTempRegister, /*InsnID*//* 506(*/0xFA, 0x03/*)*/, /*TempRegID*//* 505(*/0xF9, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196130 */   GIR_AddImm, /*InsnID*//* 506(*/0xFA, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 196141 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 506(*/0xFA, 0x03/*)*/,
     /* 196144 */   GIR_MakeTempReg, /*TempRegID*//* 504(*/0xF8, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 196148 */   GIR_BuildMI, /*InsnID*//* 505(*/0xF9, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 196153 */   GIR_AddTempRegister, /*InsnID*//* 505(*/0xF9, 0x03/*)*/, /*TempRegID*//* 504(*/0xF8, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196160 */   GIR_AddSimpleTempRegister, /*InsnID*//* 505(*/0xF9, 0x03/*)*/, /*TempRegID*//* 505(*/0xF9, 0x03/*)*/,
     /* 196165 */   GIR_AddImm, /*InsnID*//* 505(*/0xF9, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 196176 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 505(*/0xF9, 0x03/*)*/,
     /* 196179 */   GIR_MakeTempReg, /*TempRegID*//* 503(*/0xF7, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196183 */   GIR_BuildMI, /*InsnID*//* 504(*/0xF8, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 196188 */   GIR_AddTempRegister, /*InsnID*//* 504(*/0xF8, 0x03/*)*/, /*TempRegID*//* 503(*/0xF7, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196195 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 504(*/0xF8, 0x03/*)*/,
     /* 196198 */   GIR_MakeTempReg, /*TempRegID*//* 502(*/0xF6, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196202 */   GIR_BuildMI, /*InsnID*//* 503(*/0xF7, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 196207 */   GIR_AddTempRegister, /*InsnID*//* 503(*/0xF7, 0x03/*)*/, /*TempRegID*//* 502(*/0xF6, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196214 */   GIR_AddSimpleTempRegister, /*InsnID*//* 503(*/0xF7, 0x03/*)*/, /*TempRegID*//* 503(*/0xF7, 0x03/*)*/,
     /* 196219 */   GIR_AddSimpleTempRegister, /*InsnID*//* 503(*/0xF7, 0x03/*)*/, /*TempRegID*//* 504(*/0xF8, 0x03/*)*/,
     /* 196224 */   GIR_AddImm8, /*InsnID*//* 503(*/0xF7, 0x03/*)*/, /*Imm*/1,
     /* 196228 */   GIR_ConstrainOperandRC, /*InsnID*//* 503(*/0xF7, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 196234 */   GIR_ConstrainOperandRC, /*InsnID*//* 503(*/0xF7, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 196240 */   GIR_ConstrainOperandRC, /*InsnID*//* 503(*/0xF7, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 196246 */   GIR_MakeTempReg, /*TempRegID*//* 501(*/0xF5, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196250 */   GIR_BuildMI, /*InsnID*//* 502(*/0xF6, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 196255 */   GIR_AddTempRegister, /*InsnID*//* 502(*/0xF6, 0x03/*)*/, /*TempRegID*//* 501(*/0xF5, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196262 */   GIR_AddSimpleTempRegister, /*InsnID*//* 502(*/0xF6, 0x03/*)*/, /*TempRegID*//* 502(*/0xF6, 0x03/*)*/,
     /* 196267 */   GIR_AddImm8, /*InsnID*//* 502(*/0xF6, 0x03/*)*/, /*Imm*/32,
     /* 196271 */   GIR_AddImm8, /*InsnID*//* 502(*/0xF6, 0x03/*)*/, /*Imm*/31,
     /* 196275 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 502(*/0xF6, 0x03/*)*/,
     /* 196278 */   GIR_MakeTempReg, /*TempRegID*//* 500(*/0xF4, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196282 */   GIR_BuildMI, /*InsnID*//* 501(*/0xF5, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 196287 */   GIR_AddTempRegister, /*InsnID*//* 501(*/0xF5, 0x03/*)*/, /*TempRegID*//* 500(*/0xF4, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196294 */   GIR_AddSimpleTempRegister, /*InsnID*//* 501(*/0xF5, 0x03/*)*/, /*TempRegID*//* 501(*/0xF5, 0x03/*)*/,
     /* 196299 */   GIR_AddImm, /*InsnID*//* 501(*/0xF5, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 196310 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 501(*/0xF5, 0x03/*)*/,
     /* 196313 */   GIR_MakeTempReg, /*TempRegID*//* 499(*/0xF3, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196317 */   GIR_BuildMI, /*InsnID*//* 500(*/0xF4, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 196322 */   GIR_AddTempRegister, /*InsnID*//* 500(*/0xF4, 0x03/*)*/, /*TempRegID*//* 499(*/0xF3, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196329 */   GIR_AddSimpleTempRegister, /*InsnID*//* 500(*/0xF4, 0x03/*)*/, /*TempRegID*//* 500(*/0xF4, 0x03/*)*/,
     /* 196334 */   GIR_AddImm, /*InsnID*//* 500(*/0xF4, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 196345 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 500(*/0xF4, 0x03/*)*/,
     /* 196348 */   GIR_MakeTempReg, /*TempRegID*//* 498(*/0xF2, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196352 */   GIR_BuildMI, /*InsnID*//* 499(*/0xF3, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 196357 */   GIR_AddTempRegister, /*InsnID*//* 499(*/0xF3, 0x03/*)*/, /*TempRegID*//* 498(*/0xF2, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196364 */   GIR_Copy, /*NewInsnID*//* 499(*/0xF3, 0x03/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 196369 */   GIR_AddImm8, /*InsnID*//* 499(*/0xF3, 0x03/*)*/, /*Imm*/1,
     /* 196373 */   GIR_AddImm8, /*InsnID*//* 499(*/0xF3, 0x03/*)*/, /*Imm*/62,
     /* 196377 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 499(*/0xF3, 0x03/*)*/,
     /* 196380 */   GIR_MakeTempReg, /*TempRegID*//* 497(*/0xF1, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196384 */   GIR_BuildMI, /*InsnID*//* 498(*/0xF2, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 196389 */   GIR_AddTempRegister, /*InsnID*//* 498(*/0xF2, 0x03/*)*/, /*TempRegID*//* 497(*/0xF1, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196396 */   GIR_AddSimpleTempRegister, /*InsnID*//* 498(*/0xF2, 0x03/*)*/, /*TempRegID*//* 498(*/0xF2, 0x03/*)*/,
     /* 196401 */   GIR_AddSimpleTempRegister, /*InsnID*//* 498(*/0xF2, 0x03/*)*/, /*TempRegID*//* 499(*/0xF3, 0x03/*)*/,
     /* 196406 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 498(*/0xF2, 0x03/*)*/,
     /* 196409 */   GIR_MakeTempReg, /*TempRegID*//* 496(*/0xF0, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 196413 */   GIR_BuildMI, /*InsnID*//* 497(*/0xF1, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 196418 */   GIR_AddTempRegister, /*InsnID*//* 497(*/0xF1, 0x03/*)*/, /*TempRegID*//* 496(*/0xF0, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196425 */   GIR_AddImm, /*InsnID*//* 497(*/0xF1, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 196436 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 497(*/0xF1, 0x03/*)*/,
     /* 196439 */   GIR_MakeTempReg, /*TempRegID*//* 495(*/0xEF, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 196443 */   GIR_BuildMI, /*InsnID*//* 496(*/0xF0, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 196448 */   GIR_AddTempRegister, /*InsnID*//* 496(*/0xF0, 0x03/*)*/, /*TempRegID*//* 495(*/0xEF, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196455 */   GIR_AddSimpleTempRegister, /*InsnID*//* 496(*/0xF0, 0x03/*)*/, /*TempRegID*//* 496(*/0xF0, 0x03/*)*/,
     /* 196460 */   GIR_AddImm, /*InsnID*//* 496(*/0xF0, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 196471 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 496(*/0xF0, 0x03/*)*/,
     /* 196474 */   GIR_MakeTempReg, /*TempRegID*//* 494(*/0xEE, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196478 */   GIR_BuildMI, /*InsnID*//* 495(*/0xEF, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 196483 */   GIR_AddTempRegister, /*InsnID*//* 495(*/0xEF, 0x03/*)*/, /*TempRegID*//* 494(*/0xEE, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196490 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 495(*/0xEF, 0x03/*)*/,
     /* 196493 */   GIR_MakeTempReg, /*TempRegID*//* 493(*/0xED, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196497 */   GIR_BuildMI, /*InsnID*//* 494(*/0xEE, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 196502 */   GIR_AddTempRegister, /*InsnID*//* 494(*/0xEE, 0x03/*)*/, /*TempRegID*//* 493(*/0xED, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196509 */   GIR_AddSimpleTempRegister, /*InsnID*//* 494(*/0xEE, 0x03/*)*/, /*TempRegID*//* 494(*/0xEE, 0x03/*)*/,
     /* 196514 */   GIR_AddSimpleTempRegister, /*InsnID*//* 494(*/0xEE, 0x03/*)*/, /*TempRegID*//* 495(*/0xEF, 0x03/*)*/,
     /* 196519 */   GIR_AddImm8, /*InsnID*//* 494(*/0xEE, 0x03/*)*/, /*Imm*/1,
     /* 196523 */   GIR_ConstrainOperandRC, /*InsnID*//* 494(*/0xEE, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 196529 */   GIR_ConstrainOperandRC, /*InsnID*//* 494(*/0xEE, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 196535 */   GIR_ConstrainOperandRC, /*InsnID*//* 494(*/0xEE, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 196541 */   GIR_MakeTempReg, /*TempRegID*//* 492(*/0xEC, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196545 */   GIR_BuildMI, /*InsnID*//* 493(*/0xED, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 196550 */   GIR_AddTempRegister, /*InsnID*//* 493(*/0xED, 0x03/*)*/, /*TempRegID*//* 492(*/0xEC, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196557 */   GIR_AddSimpleTempRegister, /*InsnID*//* 493(*/0xED, 0x03/*)*/, /*TempRegID*//* 493(*/0xED, 0x03/*)*/,
     /* 196562 */   GIR_AddImm8, /*InsnID*//* 493(*/0xED, 0x03/*)*/, /*Imm*/32,
     /* 196566 */   GIR_AddImm8, /*InsnID*//* 493(*/0xED, 0x03/*)*/, /*Imm*/31,
     /* 196570 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 493(*/0xED, 0x03/*)*/,
     /* 196573 */   GIR_MakeTempReg, /*TempRegID*//* 491(*/0xEB, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196577 */   GIR_BuildMI, /*InsnID*//* 492(*/0xEC, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 196582 */   GIR_AddTempRegister, /*InsnID*//* 492(*/0xEC, 0x03/*)*/, /*TempRegID*//* 491(*/0xEB, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196589 */   GIR_AddSimpleTempRegister, /*InsnID*//* 492(*/0xEC, 0x03/*)*/, /*TempRegID*//* 492(*/0xEC, 0x03/*)*/,
     /* 196594 */   GIR_AddImm, /*InsnID*//* 492(*/0xEC, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 196605 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 492(*/0xEC, 0x03/*)*/,
     /* 196608 */   GIR_MakeTempReg, /*TempRegID*//* 490(*/0xEA, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196612 */   GIR_BuildMI, /*InsnID*//* 491(*/0xEB, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 196617 */   GIR_AddTempRegister, /*InsnID*//* 491(*/0xEB, 0x03/*)*/, /*TempRegID*//* 490(*/0xEA, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196624 */   GIR_AddSimpleTempRegister, /*InsnID*//* 491(*/0xEB, 0x03/*)*/, /*TempRegID*//* 491(*/0xEB, 0x03/*)*/,
     /* 196629 */   GIR_AddImm, /*InsnID*//* 491(*/0xEB, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 196640 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 491(*/0xEB, 0x03/*)*/,
     /* 196643 */   GIR_MakeTempReg, /*TempRegID*//* 489(*/0xE9, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196647 */   GIR_BuildMI, /*InsnID*//* 490(*/0xEA, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 196652 */   GIR_AddTempRegister, /*InsnID*//* 490(*/0xEA, 0x03/*)*/, /*TempRegID*//* 489(*/0xE9, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196659 */   GIR_Copy, /*NewInsnID*//* 490(*/0xEA, 0x03/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 196664 */   GIR_AddImm8, /*InsnID*//* 490(*/0xEA, 0x03/*)*/, /*Imm*/63,
     /* 196668 */   GIR_AddImm8, /*InsnID*//* 490(*/0xEA, 0x03/*)*/, /*Imm*/1,
     /* 196672 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 490(*/0xEA, 0x03/*)*/,
     /* 196675 */   GIR_MakeTempReg, /*TempRegID*//* 488(*/0xE8, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196679 */   GIR_BuildMI, /*InsnID*//* 489(*/0xE9, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 196684 */   GIR_AddTempRegister, /*InsnID*//* 489(*/0xE9, 0x03/*)*/, /*TempRegID*//* 488(*/0xE8, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196691 */   GIR_AddSimpleTempRegister, /*InsnID*//* 489(*/0xE9, 0x03/*)*/, /*TempRegID*//* 489(*/0xE9, 0x03/*)*/,
     /* 196696 */   GIR_AddSimpleTempRegister, /*InsnID*//* 489(*/0xE9, 0x03/*)*/, /*TempRegID*//* 490(*/0xEA, 0x03/*)*/,
     /* 196701 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 489(*/0xE9, 0x03/*)*/,
     /* 196704 */   GIR_MakeTempReg, /*TempRegID*//* 487(*/0xE7, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196708 */   GIR_BuildMI, /*InsnID*//* 488(*/0xE8, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 196713 */   GIR_AddTempRegister, /*InsnID*//* 488(*/0xE8, 0x03/*)*/, /*TempRegID*//* 487(*/0xE7, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196720 */   GIR_AddSimpleTempRegister, /*InsnID*//* 488(*/0xE8, 0x03/*)*/, /*TempRegID*//* 488(*/0xE8, 0x03/*)*/,
     /* 196725 */   GIR_AddSimpleTempRegister, /*InsnID*//* 488(*/0xE8, 0x03/*)*/, /*TempRegID*//* 497(*/0xF1, 0x03/*)*/,
     /* 196730 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 488(*/0xE8, 0x03/*)*/,
     /* 196733 */   GIR_MakeTempReg, /*TempRegID*//* 486(*/0xE6, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196737 */   GIR_BuildMI, /*InsnID*//* 487(*/0xE7, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 196742 */   GIR_AddTempRegister, /*InsnID*//* 487(*/0xE7, 0x03/*)*/, /*TempRegID*//* 486(*/0xE6, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196749 */   GIR_AddSimpleTempRegister, /*InsnID*//* 487(*/0xE7, 0x03/*)*/, /*TempRegID*//* 487(*/0xE7, 0x03/*)*/,
     /* 196754 */   GIR_AddImm8, /*InsnID*//* 487(*/0xE7, 0x03/*)*/, /*Imm*/62,
     /* 196758 */   GIR_AddImm8, /*InsnID*//* 487(*/0xE7, 0x03/*)*/, /*Imm*/2,
     /* 196762 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 487(*/0xE7, 0x03/*)*/,
     /* 196765 */   GIR_MakeTempReg, /*TempRegID*//* 485(*/0xE5, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196769 */   GIR_BuildMI, /*InsnID*//* 486(*/0xE6, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 196774 */   GIR_AddTempRegister, /*InsnID*//* 486(*/0xE6, 0x03/*)*/, /*TempRegID*//* 485(*/0xE5, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196781 */   GIR_AddSimpleTempRegister, /*InsnID*//* 486(*/0xE6, 0x03/*)*/, /*TempRegID*//* 486(*/0xE6, 0x03/*)*/,
     /* 196786 */   GIR_AddSimpleTempRegister, /*InsnID*//* 486(*/0xE6, 0x03/*)*/, /*TempRegID*//* 506(*/0xFA, 0x03/*)*/,
     /* 196791 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 486(*/0xE6, 0x03/*)*/,
     /* 196794 */   GIR_MakeTempReg, /*TempRegID*//* 484(*/0xE4, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196798 */   GIR_BuildMI, /*InsnID*//* 485(*/0xE5, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 196803 */   GIR_AddTempRegister, /*InsnID*//* 485(*/0xE5, 0x03/*)*/, /*TempRegID*//* 484(*/0xE4, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196810 */   GIR_AddSimpleTempRegister, /*InsnID*//* 485(*/0xE5, 0x03/*)*/, /*TempRegID*//* 485(*/0xE5, 0x03/*)*/,
     /* 196815 */   GIR_AddSimpleTempRegister, /*InsnID*//* 485(*/0xE5, 0x03/*)*/, /*TempRegID*//* 513(*/0x81, 0x04/*)*/,
     /* 196820 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 485(*/0xE5, 0x03/*)*/,
     /* 196823 */   GIR_MakeTempReg, /*TempRegID*//* 483(*/0xE3, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196827 */   GIR_BuildMI, /*InsnID*//* 484(*/0xE4, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 196832 */   GIR_AddTempRegister, /*InsnID*//* 484(*/0xE4, 0x03/*)*/, /*TempRegID*//* 483(*/0xE3, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196839 */   GIR_AddSimpleTempRegister, /*InsnID*//* 484(*/0xE4, 0x03/*)*/, /*TempRegID*//* 484(*/0xE4, 0x03/*)*/,
     /* 196844 */   GIR_AddImm8, /*InsnID*//* 484(*/0xE4, 0x03/*)*/, /*Imm*/4,
     /* 196848 */   GIR_AddImm8, /*InsnID*//* 484(*/0xE4, 0x03/*)*/, /*Imm*/59,
     /* 196852 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 484(*/0xE4, 0x03/*)*/,
     /* 196855 */   GIR_MakeTempReg, /*TempRegID*//* 482(*/0xE2, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196859 */   GIR_BuildMI, /*InsnID*//* 483(*/0xE3, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 196864 */   GIR_AddTempRegister, /*InsnID*//* 483(*/0xE3, 0x03/*)*/, /*TempRegID*//* 482(*/0xE2, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196871 */   GIR_AddSimpleTempRegister, /*InsnID*//* 483(*/0xE3, 0x03/*)*/, /*TempRegID*//* 483(*/0xE3, 0x03/*)*/,
     /* 196876 */   GIR_AddSimpleTempRegister, /*InsnID*//* 483(*/0xE3, 0x03/*)*/, /*TempRegID*//* 541(*/0x9D, 0x04/*)*/,
     /* 196881 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 483(*/0xE3, 0x03/*)*/,
     /* 196884 */   GIR_MakeTempReg, /*TempRegID*//* 481(*/0xE1, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 196888 */   GIR_BuildMI, /*InsnID*//* 482(*/0xE2, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 196893 */   GIR_AddTempRegister, /*InsnID*//* 482(*/0xE2, 0x03/*)*/, /*TempRegID*//* 481(*/0xE1, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196900 */   GIR_AddImm, /*InsnID*//* 482(*/0xE2, 0x03/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 196911 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 482(*/0xE2, 0x03/*)*/,
     /* 196914 */   GIR_MakeTempReg, /*TempRegID*//* 480(*/0xE0, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 196918 */   GIR_BuildMI, /*InsnID*//* 481(*/0xE1, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 196923 */   GIR_AddTempRegister, /*InsnID*//* 481(*/0xE1, 0x03/*)*/, /*TempRegID*//* 480(*/0xE0, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196930 */   GIR_AddSimpleTempRegister, /*InsnID*//* 481(*/0xE1, 0x03/*)*/, /*TempRegID*//* 481(*/0xE1, 0x03/*)*/,
     /* 196935 */   GIR_AddImm, /*InsnID*//* 481(*/0xE1, 0x03/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 196946 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 481(*/0xE1, 0x03/*)*/,
     /* 196949 */   GIR_MakeTempReg, /*TempRegID*//* 479(*/0xDF, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196953 */   GIR_BuildMI, /*InsnID*//* 480(*/0xE0, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 196958 */   GIR_AddTempRegister, /*InsnID*//* 480(*/0xE0, 0x03/*)*/, /*TempRegID*//* 479(*/0xDF, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196965 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 480(*/0xE0, 0x03/*)*/,
     /* 196968 */   GIR_MakeTempReg, /*TempRegID*//* 478(*/0xDE, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196972 */   GIR_BuildMI, /*InsnID*//* 479(*/0xDF, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 196977 */   GIR_AddTempRegister, /*InsnID*//* 479(*/0xDF, 0x03/*)*/, /*TempRegID*//* 478(*/0xDE, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196984 */   GIR_AddSimpleTempRegister, /*InsnID*//* 479(*/0xDF, 0x03/*)*/, /*TempRegID*//* 479(*/0xDF, 0x03/*)*/,
     /* 196989 */   GIR_AddSimpleTempRegister, /*InsnID*//* 479(*/0xDF, 0x03/*)*/, /*TempRegID*//* 480(*/0xE0, 0x03/*)*/,
     /* 196994 */   GIR_AddImm8, /*InsnID*//* 479(*/0xDF, 0x03/*)*/, /*Imm*/1,
     /* 196998 */   GIR_ConstrainOperandRC, /*InsnID*//* 479(*/0xDF, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 197004 */   GIR_ConstrainOperandRC, /*InsnID*//* 479(*/0xDF, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 197010 */   GIR_ConstrainOperandRC, /*InsnID*//* 479(*/0xDF, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 197016 */   GIR_MakeTempReg, /*TempRegID*//* 477(*/0xDD, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197020 */   GIR_BuildMI, /*InsnID*//* 478(*/0xDE, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 197025 */   GIR_AddTempRegister, /*InsnID*//* 478(*/0xDE, 0x03/*)*/, /*TempRegID*//* 477(*/0xDD, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197032 */   GIR_AddSimpleTempRegister, /*InsnID*//* 478(*/0xDE, 0x03/*)*/, /*TempRegID*//* 478(*/0xDE, 0x03/*)*/,
     /* 197037 */   GIR_AddImm8, /*InsnID*//* 478(*/0xDE, 0x03/*)*/, /*Imm*/32,
     /* 197041 */   GIR_AddImm8, /*InsnID*//* 478(*/0xDE, 0x03/*)*/, /*Imm*/31,
     /* 197045 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 478(*/0xDE, 0x03/*)*/,
     /* 197048 */   GIR_MakeTempReg, /*TempRegID*//* 476(*/0xDC, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197052 */   GIR_BuildMI, /*InsnID*//* 477(*/0xDD, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 197057 */   GIR_AddTempRegister, /*InsnID*//* 477(*/0xDD, 0x03/*)*/, /*TempRegID*//* 476(*/0xDC, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197064 */   GIR_AddSimpleTempRegister, /*InsnID*//* 477(*/0xDD, 0x03/*)*/, /*TempRegID*//* 477(*/0xDD, 0x03/*)*/,
     /* 197069 */   GIR_AddImm, /*InsnID*//* 477(*/0xDD, 0x03/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 197080 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 477(*/0xDD, 0x03/*)*/,
     /* 197083 */   GIR_MakeTempReg, /*TempRegID*//* 475(*/0xDB, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197087 */   GIR_BuildMI, /*InsnID*//* 476(*/0xDC, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 197092 */   GIR_AddTempRegister, /*InsnID*//* 476(*/0xDC, 0x03/*)*/, /*TempRegID*//* 475(*/0xDB, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197099 */   GIR_AddSimpleTempRegister, /*InsnID*//* 476(*/0xDC, 0x03/*)*/, /*TempRegID*//* 476(*/0xDC, 0x03/*)*/,
     /* 197104 */   GIR_AddImm, /*InsnID*//* 476(*/0xDC, 0x03/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 197115 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 476(*/0xDC, 0x03/*)*/,
     /* 197118 */   GIR_MakeTempReg, /*TempRegID*//* 474(*/0xDA, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 197122 */   GIR_BuildMI, /*InsnID*//* 475(*/0xDB, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 197127 */   GIR_AddTempRegister, /*InsnID*//* 475(*/0xDB, 0x03/*)*/, /*TempRegID*//* 474(*/0xDA, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197134 */   GIR_AddImm, /*InsnID*//* 475(*/0xDB, 0x03/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 197145 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 475(*/0xDB, 0x03/*)*/,
     /* 197148 */   GIR_MakeTempReg, /*TempRegID*//* 473(*/0xD9, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 197152 */   GIR_BuildMI, /*InsnID*//* 474(*/0xDA, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 197157 */   GIR_AddTempRegister, /*InsnID*//* 474(*/0xDA, 0x03/*)*/, /*TempRegID*//* 473(*/0xD9, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197164 */   GIR_AddSimpleTempRegister, /*InsnID*//* 474(*/0xDA, 0x03/*)*/, /*TempRegID*//* 474(*/0xDA, 0x03/*)*/,
     /* 197169 */   GIR_AddImm, /*InsnID*//* 474(*/0xDA, 0x03/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 197180 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 474(*/0xDA, 0x03/*)*/,
     /* 197183 */   GIR_MakeTempReg, /*TempRegID*//* 472(*/0xD8, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197187 */   GIR_BuildMI, /*InsnID*//* 473(*/0xD9, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 197192 */   GIR_AddTempRegister, /*InsnID*//* 473(*/0xD9, 0x03/*)*/, /*TempRegID*//* 472(*/0xD8, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197199 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 473(*/0xD9, 0x03/*)*/,
     /* 197202 */   GIR_MakeTempReg, /*TempRegID*//* 471(*/0xD7, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197206 */   GIR_BuildMI, /*InsnID*//* 472(*/0xD8, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 197211 */   GIR_AddTempRegister, /*InsnID*//* 472(*/0xD8, 0x03/*)*/, /*TempRegID*//* 471(*/0xD7, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197218 */   GIR_AddSimpleTempRegister, /*InsnID*//* 472(*/0xD8, 0x03/*)*/, /*TempRegID*//* 472(*/0xD8, 0x03/*)*/,
     /* 197223 */   GIR_AddSimpleTempRegister, /*InsnID*//* 472(*/0xD8, 0x03/*)*/, /*TempRegID*//* 473(*/0xD9, 0x03/*)*/,
     /* 197228 */   GIR_AddImm8, /*InsnID*//* 472(*/0xD8, 0x03/*)*/, /*Imm*/1,
     /* 197232 */   GIR_ConstrainOperandRC, /*InsnID*//* 472(*/0xD8, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 197238 */   GIR_ConstrainOperandRC, /*InsnID*//* 472(*/0xD8, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 197244 */   GIR_ConstrainOperandRC, /*InsnID*//* 472(*/0xD8, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 197250 */   GIR_MakeTempReg, /*TempRegID*//* 470(*/0xD6, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197254 */   GIR_BuildMI, /*InsnID*//* 471(*/0xD7, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 197259 */   GIR_AddTempRegister, /*InsnID*//* 471(*/0xD7, 0x03/*)*/, /*TempRegID*//* 470(*/0xD6, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197266 */   GIR_AddSimpleTempRegister, /*InsnID*//* 471(*/0xD7, 0x03/*)*/, /*TempRegID*//* 471(*/0xD7, 0x03/*)*/,
     /* 197271 */   GIR_AddImm8, /*InsnID*//* 471(*/0xD7, 0x03/*)*/, /*Imm*/32,
     /* 197275 */   GIR_AddImm8, /*InsnID*//* 471(*/0xD7, 0x03/*)*/, /*Imm*/31,
     /* 197279 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 471(*/0xD7, 0x03/*)*/,
     /* 197282 */   GIR_MakeTempReg, /*TempRegID*//* 469(*/0xD5, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197286 */   GIR_BuildMI, /*InsnID*//* 470(*/0xD6, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 197291 */   GIR_AddTempRegister, /*InsnID*//* 470(*/0xD6, 0x03/*)*/, /*TempRegID*//* 469(*/0xD5, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197298 */   GIR_AddSimpleTempRegister, /*InsnID*//* 470(*/0xD6, 0x03/*)*/, /*TempRegID*//* 470(*/0xD6, 0x03/*)*/,
     /* 197303 */   GIR_AddImm, /*InsnID*//* 470(*/0xD6, 0x03/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 197314 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 470(*/0xD6, 0x03/*)*/,
     /* 197317 */   GIR_MakeTempReg, /*TempRegID*//* 468(*/0xD4, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197321 */   GIR_BuildMI, /*InsnID*//* 469(*/0xD5, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 197326 */   GIR_AddTempRegister, /*InsnID*//* 469(*/0xD5, 0x03/*)*/, /*TempRegID*//* 468(*/0xD4, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197333 */   GIR_AddSimpleTempRegister, /*InsnID*//* 469(*/0xD5, 0x03/*)*/, /*TempRegID*//* 469(*/0xD5, 0x03/*)*/,
     /* 197338 */   GIR_AddImm, /*InsnID*//* 469(*/0xD5, 0x03/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 197349 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 469(*/0xD5, 0x03/*)*/,
     /* 197352 */   GIR_MakeTempReg, /*TempRegID*//* 467(*/0xD3, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 197356 */   GIR_BuildMI, /*InsnID*//* 468(*/0xD4, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 197361 */   GIR_AddTempRegister, /*InsnID*//* 468(*/0xD4, 0x03/*)*/, /*TempRegID*//* 467(*/0xD3, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197368 */   GIR_AddImm, /*InsnID*//* 468(*/0xD4, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 197379 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 468(*/0xD4, 0x03/*)*/,
     /* 197382 */   GIR_MakeTempReg, /*TempRegID*//* 466(*/0xD2, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 197386 */   GIR_BuildMI, /*InsnID*//* 467(*/0xD3, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 197391 */   GIR_AddTempRegister, /*InsnID*//* 467(*/0xD3, 0x03/*)*/, /*TempRegID*//* 466(*/0xD2, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197398 */   GIR_AddSimpleTempRegister, /*InsnID*//* 467(*/0xD3, 0x03/*)*/, /*TempRegID*//* 467(*/0xD3, 0x03/*)*/,
     /* 197403 */   GIR_AddImm, /*InsnID*//* 467(*/0xD3, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 197414 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 467(*/0xD3, 0x03/*)*/,
     /* 197417 */   GIR_MakeTempReg, /*TempRegID*//* 465(*/0xD1, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197421 */   GIR_BuildMI, /*InsnID*//* 466(*/0xD2, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 197426 */   GIR_AddTempRegister, /*InsnID*//* 466(*/0xD2, 0x03/*)*/, /*TempRegID*//* 465(*/0xD1, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197433 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 466(*/0xD2, 0x03/*)*/,
     /* 197436 */   GIR_MakeTempReg, /*TempRegID*//* 464(*/0xD0, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197440 */   GIR_BuildMI, /*InsnID*//* 465(*/0xD1, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 197445 */   GIR_AddTempRegister, /*InsnID*//* 465(*/0xD1, 0x03/*)*/, /*TempRegID*//* 464(*/0xD0, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197452 */   GIR_AddSimpleTempRegister, /*InsnID*//* 465(*/0xD1, 0x03/*)*/, /*TempRegID*//* 465(*/0xD1, 0x03/*)*/,
     /* 197457 */   GIR_AddSimpleTempRegister, /*InsnID*//* 465(*/0xD1, 0x03/*)*/, /*TempRegID*//* 466(*/0xD2, 0x03/*)*/,
     /* 197462 */   GIR_AddImm8, /*InsnID*//* 465(*/0xD1, 0x03/*)*/, /*Imm*/1,
     /* 197466 */   GIR_ConstrainOperandRC, /*InsnID*//* 465(*/0xD1, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 197472 */   GIR_ConstrainOperandRC, /*InsnID*//* 465(*/0xD1, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 197478 */   GIR_ConstrainOperandRC, /*InsnID*//* 465(*/0xD1, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 197484 */   GIR_MakeTempReg, /*TempRegID*//* 463(*/0xCF, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197488 */   GIR_BuildMI, /*InsnID*//* 464(*/0xD0, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 197493 */   GIR_AddTempRegister, /*InsnID*//* 464(*/0xD0, 0x03/*)*/, /*TempRegID*//* 463(*/0xCF, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197500 */   GIR_AddSimpleTempRegister, /*InsnID*//* 464(*/0xD0, 0x03/*)*/, /*TempRegID*//* 464(*/0xD0, 0x03/*)*/,
     /* 197505 */   GIR_AddImm8, /*InsnID*//* 464(*/0xD0, 0x03/*)*/, /*Imm*/32,
     /* 197509 */   GIR_AddImm8, /*InsnID*//* 464(*/0xD0, 0x03/*)*/, /*Imm*/31,
     /* 197513 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 464(*/0xD0, 0x03/*)*/,
     /* 197516 */   GIR_MakeTempReg, /*TempRegID*//* 462(*/0xCE, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197520 */   GIR_BuildMI, /*InsnID*//* 463(*/0xCF, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 197525 */   GIR_AddTempRegister, /*InsnID*//* 463(*/0xCF, 0x03/*)*/, /*TempRegID*//* 462(*/0xCE, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197532 */   GIR_AddSimpleTempRegister, /*InsnID*//* 463(*/0xCF, 0x03/*)*/, /*TempRegID*//* 463(*/0xCF, 0x03/*)*/,
     /* 197537 */   GIR_AddImm, /*InsnID*//* 463(*/0xCF, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 197548 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 463(*/0xCF, 0x03/*)*/,
     /* 197551 */   GIR_MakeTempReg, /*TempRegID*//* 461(*/0xCD, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197555 */   GIR_BuildMI, /*InsnID*//* 462(*/0xCE, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 197560 */   GIR_AddTempRegister, /*InsnID*//* 462(*/0xCE, 0x03/*)*/, /*TempRegID*//* 461(*/0xCD, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197567 */   GIR_AddSimpleTempRegister, /*InsnID*//* 462(*/0xCE, 0x03/*)*/, /*TempRegID*//* 462(*/0xCE, 0x03/*)*/,
     /* 197572 */   GIR_AddImm, /*InsnID*//* 462(*/0xCE, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 197583 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 462(*/0xCE, 0x03/*)*/,
     /* 197586 */   GIR_MakeTempReg, /*TempRegID*//* 460(*/0xCC, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197590 */   GIR_BuildMI, /*InsnID*//* 461(*/0xCD, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 197595 */   GIR_AddTempRegister, /*InsnID*//* 461(*/0xCD, 0x03/*)*/, /*TempRegID*//* 460(*/0xCC, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197602 */   GIR_Copy, /*NewInsnID*//* 461(*/0xCD, 0x03/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 197607 */   GIR_AddImm8, /*InsnID*//* 461(*/0xCD, 0x03/*)*/, /*Imm*/1,
     /* 197611 */   GIR_AddImm8, /*InsnID*//* 461(*/0xCD, 0x03/*)*/, /*Imm*/62,
     /* 197615 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 461(*/0xCD, 0x03/*)*/,
     /* 197618 */   GIR_MakeTempReg, /*TempRegID*//* 459(*/0xCB, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197622 */   GIR_BuildMI, /*InsnID*//* 460(*/0xCC, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 197627 */   GIR_AddTempRegister, /*InsnID*//* 460(*/0xCC, 0x03/*)*/, /*TempRegID*//* 459(*/0xCB, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197634 */   GIR_AddSimpleTempRegister, /*InsnID*//* 460(*/0xCC, 0x03/*)*/, /*TempRegID*//* 460(*/0xCC, 0x03/*)*/,
     /* 197639 */   GIR_AddSimpleTempRegister, /*InsnID*//* 460(*/0xCC, 0x03/*)*/, /*TempRegID*//* 461(*/0xCD, 0x03/*)*/,
     /* 197644 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 460(*/0xCC, 0x03/*)*/,
     /* 197647 */   GIR_MakeTempReg, /*TempRegID*//* 458(*/0xCA, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 197651 */   GIR_BuildMI, /*InsnID*//* 459(*/0xCB, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 197656 */   GIR_AddTempRegister, /*InsnID*//* 459(*/0xCB, 0x03/*)*/, /*TempRegID*//* 458(*/0xCA, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197663 */   GIR_AddImm, /*InsnID*//* 459(*/0xCB, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 197674 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 459(*/0xCB, 0x03/*)*/,
     /* 197677 */   GIR_MakeTempReg, /*TempRegID*//* 457(*/0xC9, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 197681 */   GIR_BuildMI, /*InsnID*//* 458(*/0xCA, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 197686 */   GIR_AddTempRegister, /*InsnID*//* 458(*/0xCA, 0x03/*)*/, /*TempRegID*//* 457(*/0xC9, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197693 */   GIR_AddSimpleTempRegister, /*InsnID*//* 458(*/0xCA, 0x03/*)*/, /*TempRegID*//* 458(*/0xCA, 0x03/*)*/,
     /* 197698 */   GIR_AddImm, /*InsnID*//* 458(*/0xCA, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 197709 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 458(*/0xCA, 0x03/*)*/,
     /* 197712 */   GIR_MakeTempReg, /*TempRegID*//* 456(*/0xC8, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197716 */   GIR_BuildMI, /*InsnID*//* 457(*/0xC9, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 197721 */   GIR_AddTempRegister, /*InsnID*//* 457(*/0xC9, 0x03/*)*/, /*TempRegID*//* 456(*/0xC8, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197728 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 457(*/0xC9, 0x03/*)*/,
     /* 197731 */   GIR_MakeTempReg, /*TempRegID*//* 455(*/0xC7, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197735 */   GIR_BuildMI, /*InsnID*//* 456(*/0xC8, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 197740 */   GIR_AddTempRegister, /*InsnID*//* 456(*/0xC8, 0x03/*)*/, /*TempRegID*//* 455(*/0xC7, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197747 */   GIR_AddSimpleTempRegister, /*InsnID*//* 456(*/0xC8, 0x03/*)*/, /*TempRegID*//* 456(*/0xC8, 0x03/*)*/,
     /* 197752 */   GIR_AddSimpleTempRegister, /*InsnID*//* 456(*/0xC8, 0x03/*)*/, /*TempRegID*//* 457(*/0xC9, 0x03/*)*/,
     /* 197757 */   GIR_AddImm8, /*InsnID*//* 456(*/0xC8, 0x03/*)*/, /*Imm*/1,
     /* 197761 */   GIR_ConstrainOperandRC, /*InsnID*//* 456(*/0xC8, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 197767 */   GIR_ConstrainOperandRC, /*InsnID*//* 456(*/0xC8, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 197773 */   GIR_ConstrainOperandRC, /*InsnID*//* 456(*/0xC8, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 197779 */   GIR_MakeTempReg, /*TempRegID*//* 454(*/0xC6, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197783 */   GIR_BuildMI, /*InsnID*//* 455(*/0xC7, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 197788 */   GIR_AddTempRegister, /*InsnID*//* 455(*/0xC7, 0x03/*)*/, /*TempRegID*//* 454(*/0xC6, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197795 */   GIR_AddSimpleTempRegister, /*InsnID*//* 455(*/0xC7, 0x03/*)*/, /*TempRegID*//* 455(*/0xC7, 0x03/*)*/,
     /* 197800 */   GIR_AddImm8, /*InsnID*//* 455(*/0xC7, 0x03/*)*/, /*Imm*/32,
     /* 197804 */   GIR_AddImm8, /*InsnID*//* 455(*/0xC7, 0x03/*)*/, /*Imm*/31,
     /* 197808 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 455(*/0xC7, 0x03/*)*/,
     /* 197811 */   GIR_MakeTempReg, /*TempRegID*//* 453(*/0xC5, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197815 */   GIR_BuildMI, /*InsnID*//* 454(*/0xC6, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 197820 */   GIR_AddTempRegister, /*InsnID*//* 454(*/0xC6, 0x03/*)*/, /*TempRegID*//* 453(*/0xC5, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197827 */   GIR_AddSimpleTempRegister, /*InsnID*//* 454(*/0xC6, 0x03/*)*/, /*TempRegID*//* 454(*/0xC6, 0x03/*)*/,
     /* 197832 */   GIR_AddImm, /*InsnID*//* 454(*/0xC6, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 197843 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 454(*/0xC6, 0x03/*)*/,
     /* 197846 */   GIR_MakeTempReg, /*TempRegID*//* 452(*/0xC4, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197850 */   GIR_BuildMI, /*InsnID*//* 453(*/0xC5, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 197855 */   GIR_AddTempRegister, /*InsnID*//* 453(*/0xC5, 0x03/*)*/, /*TempRegID*//* 452(*/0xC4, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197862 */   GIR_AddSimpleTempRegister, /*InsnID*//* 453(*/0xC5, 0x03/*)*/, /*TempRegID*//* 453(*/0xC5, 0x03/*)*/,
     /* 197867 */   GIR_AddImm, /*InsnID*//* 453(*/0xC5, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 197878 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 453(*/0xC5, 0x03/*)*/,
     /* 197881 */   GIR_MakeTempReg, /*TempRegID*//* 451(*/0xC3, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197885 */   GIR_BuildMI, /*InsnID*//* 452(*/0xC4, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 197890 */   GIR_AddTempRegister, /*InsnID*//* 452(*/0xC4, 0x03/*)*/, /*TempRegID*//* 451(*/0xC3, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197897 */   GIR_Copy, /*NewInsnID*//* 452(*/0xC4, 0x03/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 197902 */   GIR_AddImm8, /*InsnID*//* 452(*/0xC4, 0x03/*)*/, /*Imm*/63,
     /* 197906 */   GIR_AddImm8, /*InsnID*//* 452(*/0xC4, 0x03/*)*/, /*Imm*/1,
     /* 197910 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 452(*/0xC4, 0x03/*)*/,
     /* 197913 */   GIR_MakeTempReg, /*TempRegID*//* 450(*/0xC2, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197917 */   GIR_BuildMI, /*InsnID*//* 451(*/0xC3, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 197922 */   GIR_AddTempRegister, /*InsnID*//* 451(*/0xC3, 0x03/*)*/, /*TempRegID*//* 450(*/0xC2, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197929 */   GIR_AddSimpleTempRegister, /*InsnID*//* 451(*/0xC3, 0x03/*)*/, /*TempRegID*//* 451(*/0xC3, 0x03/*)*/,
     /* 197934 */   GIR_AddSimpleTempRegister, /*InsnID*//* 451(*/0xC3, 0x03/*)*/, /*TempRegID*//* 452(*/0xC4, 0x03/*)*/,
     /* 197939 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 451(*/0xC3, 0x03/*)*/,
     /* 197942 */   GIR_MakeTempReg, /*TempRegID*//* 449(*/0xC1, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197946 */   GIR_BuildMI, /*InsnID*//* 450(*/0xC2, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 197951 */   GIR_AddTempRegister, /*InsnID*//* 450(*/0xC2, 0x03/*)*/, /*TempRegID*//* 449(*/0xC1, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197958 */   GIR_AddSimpleTempRegister, /*InsnID*//* 450(*/0xC2, 0x03/*)*/, /*TempRegID*//* 450(*/0xC2, 0x03/*)*/,
     /* 197963 */   GIR_AddSimpleTempRegister, /*InsnID*//* 450(*/0xC2, 0x03/*)*/, /*TempRegID*//* 459(*/0xCB, 0x03/*)*/,
     /* 197968 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 450(*/0xC2, 0x03/*)*/,
     /* 197971 */   GIR_MakeTempReg, /*TempRegID*//* 448(*/0xC0, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197975 */   GIR_BuildMI, /*InsnID*//* 449(*/0xC1, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 197980 */   GIR_AddTempRegister, /*InsnID*//* 449(*/0xC1, 0x03/*)*/, /*TempRegID*//* 448(*/0xC0, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197987 */   GIR_AddSimpleTempRegister, /*InsnID*//* 449(*/0xC1, 0x03/*)*/, /*TempRegID*//* 449(*/0xC1, 0x03/*)*/,
     /* 197992 */   GIR_AddImm8, /*InsnID*//* 449(*/0xC1, 0x03/*)*/, /*Imm*/2,
     /* 197996 */   GIR_AddImm8, /*InsnID*//* 449(*/0xC1, 0x03/*)*/, /*Imm*/61,
     /* 198000 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 449(*/0xC1, 0x03/*)*/,
     /* 198003 */   GIR_MakeTempReg, /*TempRegID*//* 447(*/0xBF, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198007 */   GIR_BuildMI, /*InsnID*//* 448(*/0xC0, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 198012 */   GIR_AddTempRegister, /*InsnID*//* 448(*/0xC0, 0x03/*)*/, /*TempRegID*//* 447(*/0xBF, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198019 */   GIR_AddSimpleTempRegister, /*InsnID*//* 448(*/0xC0, 0x03/*)*/, /*TempRegID*//* 448(*/0xC0, 0x03/*)*/,
     /* 198024 */   GIR_AddSimpleTempRegister, /*InsnID*//* 448(*/0xC0, 0x03/*)*/, /*TempRegID*//* 468(*/0xD4, 0x03/*)*/,
     /* 198029 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 448(*/0xC0, 0x03/*)*/,
     /* 198032 */   GIR_MakeTempReg, /*TempRegID*//* 446(*/0xBE, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 198036 */   GIR_BuildMI, /*InsnID*//* 447(*/0xBF, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 198041 */   GIR_AddTempRegister, /*InsnID*//* 447(*/0xBF, 0x03/*)*/, /*TempRegID*//* 446(*/0xBE, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198048 */   GIR_AddImm, /*InsnID*//* 447(*/0xBF, 0x03/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 198059 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 447(*/0xBF, 0x03/*)*/,
     /* 198062 */   GIR_MakeTempReg, /*TempRegID*//* 445(*/0xBD, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 198066 */   GIR_BuildMI, /*InsnID*//* 446(*/0xBE, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 198071 */   GIR_AddTempRegister, /*InsnID*//* 446(*/0xBE, 0x03/*)*/, /*TempRegID*//* 445(*/0xBD, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198078 */   GIR_AddSimpleTempRegister, /*InsnID*//* 446(*/0xBE, 0x03/*)*/, /*TempRegID*//* 446(*/0xBE, 0x03/*)*/,
     /* 198083 */   GIR_AddImm, /*InsnID*//* 446(*/0xBE, 0x03/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 198094 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 446(*/0xBE, 0x03/*)*/,
     /* 198097 */   GIR_MakeTempReg, /*TempRegID*//* 444(*/0xBC, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198101 */   GIR_BuildMI, /*InsnID*//* 445(*/0xBD, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 198106 */   GIR_AddTempRegister, /*InsnID*//* 445(*/0xBD, 0x03/*)*/, /*TempRegID*//* 444(*/0xBC, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198113 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 445(*/0xBD, 0x03/*)*/,
     /* 198116 */   GIR_MakeTempReg, /*TempRegID*//* 443(*/0xBB, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198120 */   GIR_BuildMI, /*InsnID*//* 444(*/0xBC, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 198125 */   GIR_AddTempRegister, /*InsnID*//* 444(*/0xBC, 0x03/*)*/, /*TempRegID*//* 443(*/0xBB, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198132 */   GIR_AddSimpleTempRegister, /*InsnID*//* 444(*/0xBC, 0x03/*)*/, /*TempRegID*//* 444(*/0xBC, 0x03/*)*/,
     /* 198137 */   GIR_AddSimpleTempRegister, /*InsnID*//* 444(*/0xBC, 0x03/*)*/, /*TempRegID*//* 445(*/0xBD, 0x03/*)*/,
     /* 198142 */   GIR_AddImm8, /*InsnID*//* 444(*/0xBC, 0x03/*)*/, /*Imm*/1,
     /* 198146 */   GIR_ConstrainOperandRC, /*InsnID*//* 444(*/0xBC, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 198152 */   GIR_ConstrainOperandRC, /*InsnID*//* 444(*/0xBC, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 198158 */   GIR_ConstrainOperandRC, /*InsnID*//* 444(*/0xBC, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 198164 */   GIR_MakeTempReg, /*TempRegID*//* 442(*/0xBA, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198168 */   GIR_BuildMI, /*InsnID*//* 443(*/0xBB, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 198173 */   GIR_AddTempRegister, /*InsnID*//* 443(*/0xBB, 0x03/*)*/, /*TempRegID*//* 442(*/0xBA, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198180 */   GIR_AddSimpleTempRegister, /*InsnID*//* 443(*/0xBB, 0x03/*)*/, /*TempRegID*//* 443(*/0xBB, 0x03/*)*/,
     /* 198185 */   GIR_AddImm8, /*InsnID*//* 443(*/0xBB, 0x03/*)*/, /*Imm*/32,
     /* 198189 */   GIR_AddImm8, /*InsnID*//* 443(*/0xBB, 0x03/*)*/, /*Imm*/31,
     /* 198193 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 443(*/0xBB, 0x03/*)*/,
     /* 198196 */   GIR_MakeTempReg, /*TempRegID*//* 441(*/0xB9, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198200 */   GIR_BuildMI, /*InsnID*//* 442(*/0xBA, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 198205 */   GIR_AddTempRegister, /*InsnID*//* 442(*/0xBA, 0x03/*)*/, /*TempRegID*//* 441(*/0xB9, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198212 */   GIR_AddSimpleTempRegister, /*InsnID*//* 442(*/0xBA, 0x03/*)*/, /*TempRegID*//* 442(*/0xBA, 0x03/*)*/,
     /* 198217 */   GIR_AddImm, /*InsnID*//* 442(*/0xBA, 0x03/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 198228 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 442(*/0xBA, 0x03/*)*/,
     /* 198231 */   GIR_MakeTempReg, /*TempRegID*//* 440(*/0xB8, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198235 */   GIR_BuildMI, /*InsnID*//* 441(*/0xB9, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 198240 */   GIR_AddTempRegister, /*InsnID*//* 441(*/0xB9, 0x03/*)*/, /*TempRegID*//* 440(*/0xB8, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198247 */   GIR_AddSimpleTempRegister, /*InsnID*//* 441(*/0xB9, 0x03/*)*/, /*TempRegID*//* 441(*/0xB9, 0x03/*)*/,
     /* 198252 */   GIR_AddImm, /*InsnID*//* 441(*/0xB9, 0x03/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 198263 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 441(*/0xB9, 0x03/*)*/,
     /* 198266 */   GIR_MakeTempReg, /*TempRegID*//* 439(*/0xB7, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 198270 */   GIR_BuildMI, /*InsnID*//* 440(*/0xB8, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 198275 */   GIR_AddTempRegister, /*InsnID*//* 440(*/0xB8, 0x03/*)*/, /*TempRegID*//* 439(*/0xB7, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198282 */   GIR_AddImm, /*InsnID*//* 440(*/0xB8, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 198293 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 440(*/0xB8, 0x03/*)*/,
     /* 198296 */   GIR_MakeTempReg, /*TempRegID*//* 438(*/0xB6, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 198300 */   GIR_BuildMI, /*InsnID*//* 439(*/0xB7, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 198305 */   GIR_AddTempRegister, /*InsnID*//* 439(*/0xB7, 0x03/*)*/, /*TempRegID*//* 438(*/0xB6, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198312 */   GIR_AddSimpleTempRegister, /*InsnID*//* 439(*/0xB7, 0x03/*)*/, /*TempRegID*//* 439(*/0xB7, 0x03/*)*/,
     /* 198317 */   GIR_AddImm, /*InsnID*//* 439(*/0xB7, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 198328 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 439(*/0xB7, 0x03/*)*/,
     /* 198331 */   GIR_MakeTempReg, /*TempRegID*//* 437(*/0xB5, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198335 */   GIR_BuildMI, /*InsnID*//* 438(*/0xB6, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 198340 */   GIR_AddTempRegister, /*InsnID*//* 438(*/0xB6, 0x03/*)*/, /*TempRegID*//* 437(*/0xB5, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198347 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 438(*/0xB6, 0x03/*)*/,
     /* 198350 */   GIR_MakeTempReg, /*TempRegID*//* 436(*/0xB4, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198354 */   GIR_BuildMI, /*InsnID*//* 437(*/0xB5, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 198359 */   GIR_AddTempRegister, /*InsnID*//* 437(*/0xB5, 0x03/*)*/, /*TempRegID*//* 436(*/0xB4, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198366 */   GIR_AddSimpleTempRegister, /*InsnID*//* 437(*/0xB5, 0x03/*)*/, /*TempRegID*//* 437(*/0xB5, 0x03/*)*/,
     /* 198371 */   GIR_AddSimpleTempRegister, /*InsnID*//* 437(*/0xB5, 0x03/*)*/, /*TempRegID*//* 438(*/0xB6, 0x03/*)*/,
     /* 198376 */   GIR_AddImm8, /*InsnID*//* 437(*/0xB5, 0x03/*)*/, /*Imm*/1,
     /* 198380 */   GIR_ConstrainOperandRC, /*InsnID*//* 437(*/0xB5, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 198386 */   GIR_ConstrainOperandRC, /*InsnID*//* 437(*/0xB5, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 198392 */   GIR_ConstrainOperandRC, /*InsnID*//* 437(*/0xB5, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 198398 */   GIR_MakeTempReg, /*TempRegID*//* 435(*/0xB3, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198402 */   GIR_BuildMI, /*InsnID*//* 436(*/0xB4, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 198407 */   GIR_AddTempRegister, /*InsnID*//* 436(*/0xB4, 0x03/*)*/, /*TempRegID*//* 435(*/0xB3, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198414 */   GIR_AddSimpleTempRegister, /*InsnID*//* 436(*/0xB4, 0x03/*)*/, /*TempRegID*//* 436(*/0xB4, 0x03/*)*/,
     /* 198419 */   GIR_AddImm8, /*InsnID*//* 436(*/0xB4, 0x03/*)*/, /*Imm*/32,
     /* 198423 */   GIR_AddImm8, /*InsnID*//* 436(*/0xB4, 0x03/*)*/, /*Imm*/31,
     /* 198427 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 436(*/0xB4, 0x03/*)*/,
     /* 198430 */   GIR_MakeTempReg, /*TempRegID*//* 434(*/0xB2, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198434 */   GIR_BuildMI, /*InsnID*//* 435(*/0xB3, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 198439 */   GIR_AddTempRegister, /*InsnID*//* 435(*/0xB3, 0x03/*)*/, /*TempRegID*//* 434(*/0xB2, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198446 */   GIR_AddSimpleTempRegister, /*InsnID*//* 435(*/0xB3, 0x03/*)*/, /*TempRegID*//* 435(*/0xB3, 0x03/*)*/,
     /* 198451 */   GIR_AddImm, /*InsnID*//* 435(*/0xB3, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 198462 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 435(*/0xB3, 0x03/*)*/,
     /* 198465 */   GIR_MakeTempReg, /*TempRegID*//* 433(*/0xB1, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198469 */   GIR_BuildMI, /*InsnID*//* 434(*/0xB2, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 198474 */   GIR_AddTempRegister, /*InsnID*//* 434(*/0xB2, 0x03/*)*/, /*TempRegID*//* 433(*/0xB1, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198481 */   GIR_AddSimpleTempRegister, /*InsnID*//* 434(*/0xB2, 0x03/*)*/, /*TempRegID*//* 434(*/0xB2, 0x03/*)*/,
     /* 198486 */   GIR_AddImm, /*InsnID*//* 434(*/0xB2, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 198497 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 434(*/0xB2, 0x03/*)*/,
     /* 198500 */   GIR_MakeTempReg, /*TempRegID*//* 432(*/0xB0, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198504 */   GIR_BuildMI, /*InsnID*//* 433(*/0xB1, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 198509 */   GIR_AddTempRegister, /*InsnID*//* 433(*/0xB1, 0x03/*)*/, /*TempRegID*//* 432(*/0xB0, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198516 */   GIR_Copy, /*NewInsnID*//* 433(*/0xB1, 0x03/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 198521 */   GIR_AddImm8, /*InsnID*//* 433(*/0xB1, 0x03/*)*/, /*Imm*/1,
     /* 198525 */   GIR_AddImm8, /*InsnID*//* 433(*/0xB1, 0x03/*)*/, /*Imm*/62,
     /* 198529 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 433(*/0xB1, 0x03/*)*/,
     /* 198532 */   GIR_MakeTempReg, /*TempRegID*//* 431(*/0xAF, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198536 */   GIR_BuildMI, /*InsnID*//* 432(*/0xB0, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 198541 */   GIR_AddTempRegister, /*InsnID*//* 432(*/0xB0, 0x03/*)*/, /*TempRegID*//* 431(*/0xAF, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198548 */   GIR_AddSimpleTempRegister, /*InsnID*//* 432(*/0xB0, 0x03/*)*/, /*TempRegID*//* 432(*/0xB0, 0x03/*)*/,
     /* 198553 */   GIR_AddSimpleTempRegister, /*InsnID*//* 432(*/0xB0, 0x03/*)*/, /*TempRegID*//* 433(*/0xB1, 0x03/*)*/,
     /* 198558 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 432(*/0xB0, 0x03/*)*/,
     /* 198561 */   GIR_MakeTempReg, /*TempRegID*//* 430(*/0xAE, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 198565 */   GIR_BuildMI, /*InsnID*//* 431(*/0xAF, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 198570 */   GIR_AddTempRegister, /*InsnID*//* 431(*/0xAF, 0x03/*)*/, /*TempRegID*//* 430(*/0xAE, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198577 */   GIR_AddImm, /*InsnID*//* 431(*/0xAF, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 198588 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 431(*/0xAF, 0x03/*)*/,
     /* 198591 */   GIR_MakeTempReg, /*TempRegID*//* 429(*/0xAD, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 198595 */   GIR_BuildMI, /*InsnID*//* 430(*/0xAE, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 198600 */   GIR_AddTempRegister, /*InsnID*//* 430(*/0xAE, 0x03/*)*/, /*TempRegID*//* 429(*/0xAD, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198607 */   GIR_AddSimpleTempRegister, /*InsnID*//* 430(*/0xAE, 0x03/*)*/, /*TempRegID*//* 430(*/0xAE, 0x03/*)*/,
     /* 198612 */   GIR_AddImm, /*InsnID*//* 430(*/0xAE, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 198623 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 430(*/0xAE, 0x03/*)*/,
     /* 198626 */   GIR_MakeTempReg, /*TempRegID*//* 428(*/0xAC, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198630 */   GIR_BuildMI, /*InsnID*//* 429(*/0xAD, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 198635 */   GIR_AddTempRegister, /*InsnID*//* 429(*/0xAD, 0x03/*)*/, /*TempRegID*//* 428(*/0xAC, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198642 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 429(*/0xAD, 0x03/*)*/,
     /* 198645 */   GIR_MakeTempReg, /*TempRegID*//* 427(*/0xAB, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198649 */   GIR_BuildMI, /*InsnID*//* 428(*/0xAC, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 198654 */   GIR_AddTempRegister, /*InsnID*//* 428(*/0xAC, 0x03/*)*/, /*TempRegID*//* 427(*/0xAB, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198661 */   GIR_AddSimpleTempRegister, /*InsnID*//* 428(*/0xAC, 0x03/*)*/, /*TempRegID*//* 428(*/0xAC, 0x03/*)*/,
     /* 198666 */   GIR_AddSimpleTempRegister, /*InsnID*//* 428(*/0xAC, 0x03/*)*/, /*TempRegID*//* 429(*/0xAD, 0x03/*)*/,
     /* 198671 */   GIR_AddImm8, /*InsnID*//* 428(*/0xAC, 0x03/*)*/, /*Imm*/1,
     /* 198675 */   GIR_ConstrainOperandRC, /*InsnID*//* 428(*/0xAC, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 198681 */   GIR_ConstrainOperandRC, /*InsnID*//* 428(*/0xAC, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 198687 */   GIR_ConstrainOperandRC, /*InsnID*//* 428(*/0xAC, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 198693 */   GIR_MakeTempReg, /*TempRegID*//* 426(*/0xAA, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198697 */   GIR_BuildMI, /*InsnID*//* 427(*/0xAB, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 198702 */   GIR_AddTempRegister, /*InsnID*//* 427(*/0xAB, 0x03/*)*/, /*TempRegID*//* 426(*/0xAA, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198709 */   GIR_AddSimpleTempRegister, /*InsnID*//* 427(*/0xAB, 0x03/*)*/, /*TempRegID*//* 427(*/0xAB, 0x03/*)*/,
     /* 198714 */   GIR_AddImm8, /*InsnID*//* 427(*/0xAB, 0x03/*)*/, /*Imm*/32,
     /* 198718 */   GIR_AddImm8, /*InsnID*//* 427(*/0xAB, 0x03/*)*/, /*Imm*/31,
     /* 198722 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 427(*/0xAB, 0x03/*)*/,
     /* 198725 */   GIR_MakeTempReg, /*TempRegID*//* 425(*/0xA9, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198729 */   GIR_BuildMI, /*InsnID*//* 426(*/0xAA, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 198734 */   GIR_AddTempRegister, /*InsnID*//* 426(*/0xAA, 0x03/*)*/, /*TempRegID*//* 425(*/0xA9, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198741 */   GIR_AddSimpleTempRegister, /*InsnID*//* 426(*/0xAA, 0x03/*)*/, /*TempRegID*//* 426(*/0xAA, 0x03/*)*/,
     /* 198746 */   GIR_AddImm, /*InsnID*//* 426(*/0xAA, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 198757 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 426(*/0xAA, 0x03/*)*/,
     /* 198760 */   GIR_MakeTempReg, /*TempRegID*//* 424(*/0xA8, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198764 */   GIR_BuildMI, /*InsnID*//* 425(*/0xA9, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 198769 */   GIR_AddTempRegister, /*InsnID*//* 425(*/0xA9, 0x03/*)*/, /*TempRegID*//* 424(*/0xA8, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198776 */   GIR_AddSimpleTempRegister, /*InsnID*//* 425(*/0xA9, 0x03/*)*/, /*TempRegID*//* 425(*/0xA9, 0x03/*)*/,
     /* 198781 */   GIR_AddImm, /*InsnID*//* 425(*/0xA9, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 198792 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 425(*/0xA9, 0x03/*)*/,
     /* 198795 */   GIR_MakeTempReg, /*TempRegID*//* 423(*/0xA7, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198799 */   GIR_BuildMI, /*InsnID*//* 424(*/0xA8, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 198804 */   GIR_AddTempRegister, /*InsnID*//* 424(*/0xA8, 0x03/*)*/, /*TempRegID*//* 423(*/0xA7, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198811 */   GIR_Copy, /*NewInsnID*//* 424(*/0xA8, 0x03/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 198816 */   GIR_AddImm8, /*InsnID*//* 424(*/0xA8, 0x03/*)*/, /*Imm*/63,
     /* 198820 */   GIR_AddImm8, /*InsnID*//* 424(*/0xA8, 0x03/*)*/, /*Imm*/1,
     /* 198824 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 424(*/0xA8, 0x03/*)*/,
     /* 198827 */   GIR_MakeTempReg, /*TempRegID*//* 422(*/0xA6, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198831 */   GIR_BuildMI, /*InsnID*//* 423(*/0xA7, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 198836 */   GIR_AddTempRegister, /*InsnID*//* 423(*/0xA7, 0x03/*)*/, /*TempRegID*//* 422(*/0xA6, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198843 */   GIR_AddSimpleTempRegister, /*InsnID*//* 423(*/0xA7, 0x03/*)*/, /*TempRegID*//* 423(*/0xA7, 0x03/*)*/,
     /* 198848 */   GIR_AddSimpleTempRegister, /*InsnID*//* 423(*/0xA7, 0x03/*)*/, /*TempRegID*//* 424(*/0xA8, 0x03/*)*/,
     /* 198853 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 423(*/0xA7, 0x03/*)*/,
     /* 198856 */   GIR_MakeTempReg, /*TempRegID*//* 421(*/0xA5, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198860 */   GIR_BuildMI, /*InsnID*//* 422(*/0xA6, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 198865 */   GIR_AddTempRegister, /*InsnID*//* 422(*/0xA6, 0x03/*)*/, /*TempRegID*//* 421(*/0xA5, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198872 */   GIR_AddSimpleTempRegister, /*InsnID*//* 422(*/0xA6, 0x03/*)*/, /*TempRegID*//* 422(*/0xA6, 0x03/*)*/,
     /* 198877 */   GIR_AddSimpleTempRegister, /*InsnID*//* 422(*/0xA6, 0x03/*)*/, /*TempRegID*//* 431(*/0xAF, 0x03/*)*/,
     /* 198882 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 422(*/0xA6, 0x03/*)*/,
     /* 198885 */   GIR_MakeTempReg, /*TempRegID*//* 420(*/0xA4, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198889 */   GIR_BuildMI, /*InsnID*//* 421(*/0xA5, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 198894 */   GIR_AddTempRegister, /*InsnID*//* 421(*/0xA5, 0x03/*)*/, /*TempRegID*//* 420(*/0xA4, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198901 */   GIR_AddSimpleTempRegister, /*InsnID*//* 421(*/0xA5, 0x03/*)*/, /*TempRegID*//* 421(*/0xA5, 0x03/*)*/,
     /* 198906 */   GIR_AddImm8, /*InsnID*//* 421(*/0xA5, 0x03/*)*/, /*Imm*/62,
     /* 198910 */   GIR_AddImm8, /*InsnID*//* 421(*/0xA5, 0x03/*)*/, /*Imm*/2,
     /* 198914 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 421(*/0xA5, 0x03/*)*/,
     /* 198917 */   GIR_MakeTempReg, /*TempRegID*//* 419(*/0xA3, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198921 */   GIR_BuildMI, /*InsnID*//* 420(*/0xA4, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 198926 */   GIR_AddTempRegister, /*InsnID*//* 420(*/0xA4, 0x03/*)*/, /*TempRegID*//* 419(*/0xA3, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198933 */   GIR_AddSimpleTempRegister, /*InsnID*//* 420(*/0xA4, 0x03/*)*/, /*TempRegID*//* 420(*/0xA4, 0x03/*)*/,
     /* 198938 */   GIR_AddSimpleTempRegister, /*InsnID*//* 420(*/0xA4, 0x03/*)*/, /*TempRegID*//* 440(*/0xB8, 0x03/*)*/,
     /* 198943 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 420(*/0xA4, 0x03/*)*/,
     /* 198946 */   GIR_MakeTempReg, /*TempRegID*//* 418(*/0xA2, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198950 */   GIR_BuildMI, /*InsnID*//* 419(*/0xA3, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 198955 */   GIR_AddTempRegister, /*InsnID*//* 419(*/0xA3, 0x03/*)*/, /*TempRegID*//* 418(*/0xA2, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198962 */   GIR_AddSimpleTempRegister, /*InsnID*//* 419(*/0xA3, 0x03/*)*/, /*TempRegID*//* 419(*/0xA3, 0x03/*)*/,
     /* 198967 */   GIR_AddSimpleTempRegister, /*InsnID*//* 419(*/0xA3, 0x03/*)*/, /*TempRegID*//* 447(*/0xBF, 0x03/*)*/,
     /* 198972 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 419(*/0xA3, 0x03/*)*/,
     /* 198975 */   GIR_MakeTempReg, /*TempRegID*//* 417(*/0xA1, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198979 */   GIR_BuildMI, /*InsnID*//* 418(*/0xA2, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 198984 */   GIR_AddTempRegister, /*InsnID*//* 418(*/0xA2, 0x03/*)*/, /*TempRegID*//* 417(*/0xA1, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198991 */   GIR_AddSimpleTempRegister, /*InsnID*//* 418(*/0xA2, 0x03/*)*/, /*TempRegID*//* 418(*/0xA2, 0x03/*)*/,
     /* 198996 */   GIR_AddImm8, /*InsnID*//* 418(*/0xA2, 0x03/*)*/, /*Imm*/60,
     /* 199000 */   GIR_AddImm8, /*InsnID*//* 418(*/0xA2, 0x03/*)*/, /*Imm*/4,
     /* 199004 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 418(*/0xA2, 0x03/*)*/,
     /* 199007 */   GIR_MakeTempReg, /*TempRegID*//* 416(*/0xA0, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 199011 */   GIR_BuildMI, /*InsnID*//* 417(*/0xA1, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 199016 */   GIR_AddTempRegister, /*InsnID*//* 417(*/0xA1, 0x03/*)*/, /*TempRegID*//* 416(*/0xA0, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199023 */   GIR_AddSimpleTempRegister, /*InsnID*//* 417(*/0xA1, 0x03/*)*/, /*TempRegID*//* 417(*/0xA1, 0x03/*)*/,
     /* 199028 */   GIR_AddSimpleTempRegister, /*InsnID*//* 417(*/0xA1, 0x03/*)*/, /*TempRegID*//* 475(*/0xDB, 0x03/*)*/,
     /* 199033 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 417(*/0xA1, 0x03/*)*/,
     /* 199036 */   GIR_MakeTempReg, /*TempRegID*//* 415(*/0x9F, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 199040 */   GIR_BuildMI, /*InsnID*//* 416(*/0xA0, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 199045 */   GIR_AddTempRegister, /*InsnID*//* 416(*/0xA0, 0x03/*)*/, /*TempRegID*//* 415(*/0x9F, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199052 */   GIR_AddSimpleTempRegister, /*InsnID*//* 416(*/0xA0, 0x03/*)*/, /*TempRegID*//* 416(*/0xA0, 0x03/*)*/,
     /* 199057 */   GIR_AddSimpleTempRegister, /*InsnID*//* 416(*/0xA0, 0x03/*)*/, /*TempRegID*//* 482(*/0xE2, 0x03/*)*/,
     /* 199062 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 416(*/0xA0, 0x03/*)*/,
     /* 199065 */   GIR_MakeTempReg, /*TempRegID*//* 414(*/0x9E, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 199069 */   GIR_BuildMI, /*InsnID*//* 415(*/0x9F, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 199074 */   GIR_AddTempRegister, /*InsnID*//* 415(*/0x9F, 0x03/*)*/, /*TempRegID*//* 414(*/0x9E, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199081 */   GIR_AddSimpleTempRegister, /*InsnID*//* 415(*/0x9F, 0x03/*)*/, /*TempRegID*//* 415(*/0x9F, 0x03/*)*/,
     /* 199086 */   GIR_AddImm8, /*InsnID*//* 415(*/0x9F, 0x03/*)*/, /*Imm*/32,
     /* 199090 */   GIR_AddImm8, /*InsnID*//* 415(*/0x9F, 0x03/*)*/, /*Imm*/32,
     /* 199094 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 415(*/0x9F, 0x03/*)*/,
     /* 199097 */   GIR_MakeTempReg, /*TempRegID*//* 682(*/0xAA, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 199101 */   GIR_BuildMI, /*InsnID*//* 683(*/0xAB, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 199106 */   GIR_AddTempRegister, /*InsnID*//* 683(*/0xAB, 0x05/*)*/, /*TempRegID*//* 682(*/0xAA, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199113 */   GIR_AddImm, /*InsnID*//* 683(*/0xAB, 0x05/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 199124 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 683(*/0xAB, 0x05/*)*/,
     /* 199127 */   GIR_MakeTempReg, /*TempRegID*//* 681(*/0xA9, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 199131 */   GIR_BuildMI, /*InsnID*//* 682(*/0xAA, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 199136 */   GIR_AddTempRegister, /*InsnID*//* 682(*/0xAA, 0x05/*)*/, /*TempRegID*//* 681(*/0xA9, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199143 */   GIR_AddSimpleTempRegister, /*InsnID*//* 682(*/0xAA, 0x05/*)*/, /*TempRegID*//* 682(*/0xAA, 0x05/*)*/,
     /* 199148 */   GIR_AddImm, /*InsnID*//* 682(*/0xAA, 0x05/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 199159 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 682(*/0xAA, 0x05/*)*/,
     /* 199162 */   GIR_MakeTempReg, /*TempRegID*//* 680(*/0xA8, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199166 */   GIR_BuildMI, /*InsnID*//* 681(*/0xA9, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 199171 */   GIR_AddTempRegister, /*InsnID*//* 681(*/0xA9, 0x05/*)*/, /*TempRegID*//* 680(*/0xA8, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199178 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 681(*/0xA9, 0x05/*)*/,
     /* 199181 */   GIR_MakeTempReg, /*TempRegID*//* 679(*/0xA7, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199185 */   GIR_BuildMI, /*InsnID*//* 680(*/0xA8, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 199190 */   GIR_AddTempRegister, /*InsnID*//* 680(*/0xA8, 0x05/*)*/, /*TempRegID*//* 679(*/0xA7, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199197 */   GIR_AddSimpleTempRegister, /*InsnID*//* 680(*/0xA8, 0x05/*)*/, /*TempRegID*//* 680(*/0xA8, 0x05/*)*/,
     /* 199202 */   GIR_AddSimpleTempRegister, /*InsnID*//* 680(*/0xA8, 0x05/*)*/, /*TempRegID*//* 681(*/0xA9, 0x05/*)*/,
     /* 199207 */   GIR_AddImm8, /*InsnID*//* 680(*/0xA8, 0x05/*)*/, /*Imm*/1,
     /* 199211 */   GIR_ConstrainOperandRC, /*InsnID*//* 680(*/0xA8, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 199217 */   GIR_ConstrainOperandRC, /*InsnID*//* 680(*/0xA8, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 199223 */   GIR_ConstrainOperandRC, /*InsnID*//* 680(*/0xA8, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 199229 */   GIR_MakeTempReg, /*TempRegID*//* 678(*/0xA6, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199233 */   GIR_BuildMI, /*InsnID*//* 679(*/0xA7, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 199238 */   GIR_AddTempRegister, /*InsnID*//* 679(*/0xA7, 0x05/*)*/, /*TempRegID*//* 678(*/0xA6, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199245 */   GIR_AddSimpleTempRegister, /*InsnID*//* 679(*/0xA7, 0x05/*)*/, /*TempRegID*//* 679(*/0xA7, 0x05/*)*/,
     /* 199250 */   GIR_AddImm8, /*InsnID*//* 679(*/0xA7, 0x05/*)*/, /*Imm*/32,
     /* 199254 */   GIR_AddImm8, /*InsnID*//* 679(*/0xA7, 0x05/*)*/, /*Imm*/31,
     /* 199258 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 679(*/0xA7, 0x05/*)*/,
     /* 199261 */   GIR_MakeTempReg, /*TempRegID*//* 677(*/0xA5, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199265 */   GIR_BuildMI, /*InsnID*//* 678(*/0xA6, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 199270 */   GIR_AddTempRegister, /*InsnID*//* 678(*/0xA6, 0x05/*)*/, /*TempRegID*//* 677(*/0xA5, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199277 */   GIR_AddSimpleTempRegister, /*InsnID*//* 678(*/0xA6, 0x05/*)*/, /*TempRegID*//* 678(*/0xA6, 0x05/*)*/,
     /* 199282 */   GIR_AddImm, /*InsnID*//* 678(*/0xA6, 0x05/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 199293 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 678(*/0xA6, 0x05/*)*/,
     /* 199296 */   GIR_MakeTempReg, /*TempRegID*//* 676(*/0xA4, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199300 */   GIR_BuildMI, /*InsnID*//* 677(*/0xA5, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 199305 */   GIR_AddTempRegister, /*InsnID*//* 677(*/0xA5, 0x05/*)*/, /*TempRegID*//* 676(*/0xA4, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199312 */   GIR_AddSimpleTempRegister, /*InsnID*//* 677(*/0xA5, 0x05/*)*/, /*TempRegID*//* 677(*/0xA5, 0x05/*)*/,
     /* 199317 */   GIR_AddImm, /*InsnID*//* 677(*/0xA5, 0x05/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 199328 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 677(*/0xA5, 0x05/*)*/,
     /* 199331 */   GIR_MakeTempReg, /*TempRegID*//* 675(*/0xA3, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 199335 */   GIR_BuildMI, /*InsnID*//* 676(*/0xA4, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 199340 */   GIR_AddTempRegister, /*InsnID*//* 676(*/0xA4, 0x05/*)*/, /*TempRegID*//* 675(*/0xA3, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199347 */   GIR_AddImm, /*InsnID*//* 676(*/0xA4, 0x05/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 199358 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 676(*/0xA4, 0x05/*)*/,
     /* 199361 */   GIR_MakeTempReg, /*TempRegID*//* 674(*/0xA2, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 199365 */   GIR_BuildMI, /*InsnID*//* 675(*/0xA3, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 199370 */   GIR_AddTempRegister, /*InsnID*//* 675(*/0xA3, 0x05/*)*/, /*TempRegID*//* 674(*/0xA2, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199377 */   GIR_AddSimpleTempRegister, /*InsnID*//* 675(*/0xA3, 0x05/*)*/, /*TempRegID*//* 675(*/0xA3, 0x05/*)*/,
     /* 199382 */   GIR_AddImm, /*InsnID*//* 675(*/0xA3, 0x05/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 199393 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 675(*/0xA3, 0x05/*)*/,
     /* 199396 */   GIR_MakeTempReg, /*TempRegID*//* 673(*/0xA1, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199400 */   GIR_BuildMI, /*InsnID*//* 674(*/0xA2, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 199405 */   GIR_AddTempRegister, /*InsnID*//* 674(*/0xA2, 0x05/*)*/, /*TempRegID*//* 673(*/0xA1, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199412 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 674(*/0xA2, 0x05/*)*/,
     /* 199415 */   GIR_MakeTempReg, /*TempRegID*//* 672(*/0xA0, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199419 */   GIR_BuildMI, /*InsnID*//* 673(*/0xA1, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 199424 */   GIR_AddTempRegister, /*InsnID*//* 673(*/0xA1, 0x05/*)*/, /*TempRegID*//* 672(*/0xA0, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199431 */   GIR_AddSimpleTempRegister, /*InsnID*//* 673(*/0xA1, 0x05/*)*/, /*TempRegID*//* 673(*/0xA1, 0x05/*)*/,
     /* 199436 */   GIR_AddSimpleTempRegister, /*InsnID*//* 673(*/0xA1, 0x05/*)*/, /*TempRegID*//* 674(*/0xA2, 0x05/*)*/,
     /* 199441 */   GIR_AddImm8, /*InsnID*//* 673(*/0xA1, 0x05/*)*/, /*Imm*/1,
     /* 199445 */   GIR_ConstrainOperandRC, /*InsnID*//* 673(*/0xA1, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 199451 */   GIR_ConstrainOperandRC, /*InsnID*//* 673(*/0xA1, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 199457 */   GIR_ConstrainOperandRC, /*InsnID*//* 673(*/0xA1, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 199463 */   GIR_MakeTempReg, /*TempRegID*//* 671(*/0x9F, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199467 */   GIR_BuildMI, /*InsnID*//* 672(*/0xA0, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 199472 */   GIR_AddTempRegister, /*InsnID*//* 672(*/0xA0, 0x05/*)*/, /*TempRegID*//* 671(*/0x9F, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199479 */   GIR_AddSimpleTempRegister, /*InsnID*//* 672(*/0xA0, 0x05/*)*/, /*TempRegID*//* 672(*/0xA0, 0x05/*)*/,
     /* 199484 */   GIR_AddImm8, /*InsnID*//* 672(*/0xA0, 0x05/*)*/, /*Imm*/32,
     /* 199488 */   GIR_AddImm8, /*InsnID*//* 672(*/0xA0, 0x05/*)*/, /*Imm*/31,
     /* 199492 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 672(*/0xA0, 0x05/*)*/,
     /* 199495 */   GIR_MakeTempReg, /*TempRegID*//* 670(*/0x9E, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199499 */   GIR_BuildMI, /*InsnID*//* 671(*/0x9F, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 199504 */   GIR_AddTempRegister, /*InsnID*//* 671(*/0x9F, 0x05/*)*/, /*TempRegID*//* 670(*/0x9E, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199511 */   GIR_AddSimpleTempRegister, /*InsnID*//* 671(*/0x9F, 0x05/*)*/, /*TempRegID*//* 671(*/0x9F, 0x05/*)*/,
     /* 199516 */   GIR_AddImm, /*InsnID*//* 671(*/0x9F, 0x05/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 199527 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 671(*/0x9F, 0x05/*)*/,
     /* 199530 */   GIR_MakeTempReg, /*TempRegID*//* 669(*/0x9D, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199534 */   GIR_BuildMI, /*InsnID*//* 670(*/0x9E, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 199539 */   GIR_AddTempRegister, /*InsnID*//* 670(*/0x9E, 0x05/*)*/, /*TempRegID*//* 669(*/0x9D, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199546 */   GIR_AddSimpleTempRegister, /*InsnID*//* 670(*/0x9E, 0x05/*)*/, /*TempRegID*//* 670(*/0x9E, 0x05/*)*/,
     /* 199551 */   GIR_AddImm, /*InsnID*//* 670(*/0x9E, 0x05/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 199562 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 670(*/0x9E, 0x05/*)*/,
     /* 199565 */   GIR_MakeTempReg, /*TempRegID*//* 668(*/0x9C, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 199569 */   GIR_BuildMI, /*InsnID*//* 669(*/0x9D, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 199574 */   GIR_AddTempRegister, /*InsnID*//* 669(*/0x9D, 0x05/*)*/, /*TempRegID*//* 668(*/0x9C, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199581 */   GIR_AddImm, /*InsnID*//* 669(*/0x9D, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 199592 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 669(*/0x9D, 0x05/*)*/,
     /* 199595 */   GIR_MakeTempReg, /*TempRegID*//* 667(*/0x9B, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 199599 */   GIR_BuildMI, /*InsnID*//* 668(*/0x9C, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 199604 */   GIR_AddTempRegister, /*InsnID*//* 668(*/0x9C, 0x05/*)*/, /*TempRegID*//* 667(*/0x9B, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199611 */   GIR_AddSimpleTempRegister, /*InsnID*//* 668(*/0x9C, 0x05/*)*/, /*TempRegID*//* 668(*/0x9C, 0x05/*)*/,
     /* 199616 */   GIR_AddImm, /*InsnID*//* 668(*/0x9C, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 199627 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 668(*/0x9C, 0x05/*)*/,
     /* 199630 */   GIR_MakeTempReg, /*TempRegID*//* 666(*/0x9A, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199634 */   GIR_BuildMI, /*InsnID*//* 667(*/0x9B, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 199639 */   GIR_AddTempRegister, /*InsnID*//* 667(*/0x9B, 0x05/*)*/, /*TempRegID*//* 666(*/0x9A, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199646 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 667(*/0x9B, 0x05/*)*/,
     /* 199649 */   GIR_MakeTempReg, /*TempRegID*//* 665(*/0x99, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199653 */   GIR_BuildMI, /*InsnID*//* 666(*/0x9A, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 199658 */   GIR_AddTempRegister, /*InsnID*//* 666(*/0x9A, 0x05/*)*/, /*TempRegID*//* 665(*/0x99, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199665 */   GIR_AddSimpleTempRegister, /*InsnID*//* 666(*/0x9A, 0x05/*)*/, /*TempRegID*//* 666(*/0x9A, 0x05/*)*/,
     /* 199670 */   GIR_AddSimpleTempRegister, /*InsnID*//* 666(*/0x9A, 0x05/*)*/, /*TempRegID*//* 667(*/0x9B, 0x05/*)*/,
     /* 199675 */   GIR_AddImm8, /*InsnID*//* 666(*/0x9A, 0x05/*)*/, /*Imm*/1,
     /* 199679 */   GIR_ConstrainOperandRC, /*InsnID*//* 666(*/0x9A, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 199685 */   GIR_ConstrainOperandRC, /*InsnID*//* 666(*/0x9A, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 199691 */   GIR_ConstrainOperandRC, /*InsnID*//* 666(*/0x9A, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 199697 */   GIR_MakeTempReg, /*TempRegID*//* 664(*/0x98, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199701 */   GIR_BuildMI, /*InsnID*//* 665(*/0x99, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 199706 */   GIR_AddTempRegister, /*InsnID*//* 665(*/0x99, 0x05/*)*/, /*TempRegID*//* 664(*/0x98, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199713 */   GIR_AddSimpleTempRegister, /*InsnID*//* 665(*/0x99, 0x05/*)*/, /*TempRegID*//* 665(*/0x99, 0x05/*)*/,
     /* 199718 */   GIR_AddImm8, /*InsnID*//* 665(*/0x99, 0x05/*)*/, /*Imm*/32,
     /* 199722 */   GIR_AddImm8, /*InsnID*//* 665(*/0x99, 0x05/*)*/, /*Imm*/31,
     /* 199726 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 665(*/0x99, 0x05/*)*/,
     /* 199729 */   GIR_MakeTempReg, /*TempRegID*//* 663(*/0x97, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199733 */   GIR_BuildMI, /*InsnID*//* 664(*/0x98, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 199738 */   GIR_AddTempRegister, /*InsnID*//* 664(*/0x98, 0x05/*)*/, /*TempRegID*//* 663(*/0x97, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199745 */   GIR_AddSimpleTempRegister, /*InsnID*//* 664(*/0x98, 0x05/*)*/, /*TempRegID*//* 664(*/0x98, 0x05/*)*/,
     /* 199750 */   GIR_AddImm, /*InsnID*//* 664(*/0x98, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 199761 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 664(*/0x98, 0x05/*)*/,
     /* 199764 */   GIR_MakeTempReg, /*TempRegID*//* 662(*/0x96, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199768 */   GIR_BuildMI, /*InsnID*//* 663(*/0x97, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 199773 */   GIR_AddTempRegister, /*InsnID*//* 663(*/0x97, 0x05/*)*/, /*TempRegID*//* 662(*/0x96, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199780 */   GIR_AddSimpleTempRegister, /*InsnID*//* 663(*/0x97, 0x05/*)*/, /*TempRegID*//* 663(*/0x97, 0x05/*)*/,
     /* 199785 */   GIR_AddImm, /*InsnID*//* 663(*/0x97, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 199796 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 663(*/0x97, 0x05/*)*/,
     /* 199799 */   GIR_MakeTempReg, /*TempRegID*//* 661(*/0x95, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199803 */   GIR_BuildMI, /*InsnID*//* 662(*/0x96, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 199808 */   GIR_AddTempRegister, /*InsnID*//* 662(*/0x96, 0x05/*)*/, /*TempRegID*//* 661(*/0x95, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199815 */   GIR_Copy, /*NewInsnID*//* 662(*/0x96, 0x05/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 199820 */   GIR_AddImm8, /*InsnID*//* 662(*/0x96, 0x05/*)*/, /*Imm*/1,
     /* 199824 */   GIR_AddImm8, /*InsnID*//* 662(*/0x96, 0x05/*)*/, /*Imm*/62,
     /* 199828 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 662(*/0x96, 0x05/*)*/,
     /* 199831 */   GIR_MakeTempReg, /*TempRegID*//* 660(*/0x94, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199835 */   GIR_BuildMI, /*InsnID*//* 661(*/0x95, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 199840 */   GIR_AddTempRegister, /*InsnID*//* 661(*/0x95, 0x05/*)*/, /*TempRegID*//* 660(*/0x94, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199847 */   GIR_AddSimpleTempRegister, /*InsnID*//* 661(*/0x95, 0x05/*)*/, /*TempRegID*//* 661(*/0x95, 0x05/*)*/,
     /* 199852 */   GIR_AddSimpleTempRegister, /*InsnID*//* 661(*/0x95, 0x05/*)*/, /*TempRegID*//* 662(*/0x96, 0x05/*)*/,
     /* 199857 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 661(*/0x95, 0x05/*)*/,
     /* 199860 */   GIR_MakeTempReg, /*TempRegID*//* 659(*/0x93, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 199864 */   GIR_BuildMI, /*InsnID*//* 660(*/0x94, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 199869 */   GIR_AddTempRegister, /*InsnID*//* 660(*/0x94, 0x05/*)*/, /*TempRegID*//* 659(*/0x93, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199876 */   GIR_AddImm, /*InsnID*//* 660(*/0x94, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 199887 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 660(*/0x94, 0x05/*)*/,
     /* 199890 */   GIR_MakeTempReg, /*TempRegID*//* 658(*/0x92, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 199894 */   GIR_BuildMI, /*InsnID*//* 659(*/0x93, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 199899 */   GIR_AddTempRegister, /*InsnID*//* 659(*/0x93, 0x05/*)*/, /*TempRegID*//* 658(*/0x92, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199906 */   GIR_AddSimpleTempRegister, /*InsnID*//* 659(*/0x93, 0x05/*)*/, /*TempRegID*//* 659(*/0x93, 0x05/*)*/,
     /* 199911 */   GIR_AddImm, /*InsnID*//* 659(*/0x93, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 199922 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 659(*/0x93, 0x05/*)*/,
     /* 199925 */   GIR_MakeTempReg, /*TempRegID*//* 657(*/0x91, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199929 */   GIR_BuildMI, /*InsnID*//* 658(*/0x92, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 199934 */   GIR_AddTempRegister, /*InsnID*//* 658(*/0x92, 0x05/*)*/, /*TempRegID*//* 657(*/0x91, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199941 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 658(*/0x92, 0x05/*)*/,
     /* 199944 */   GIR_MakeTempReg, /*TempRegID*//* 656(*/0x90, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199948 */   GIR_BuildMI, /*InsnID*//* 657(*/0x91, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 199953 */   GIR_AddTempRegister, /*InsnID*//* 657(*/0x91, 0x05/*)*/, /*TempRegID*//* 656(*/0x90, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199960 */   GIR_AddSimpleTempRegister, /*InsnID*//* 657(*/0x91, 0x05/*)*/, /*TempRegID*//* 657(*/0x91, 0x05/*)*/,
     /* 199965 */   GIR_AddSimpleTempRegister, /*InsnID*//* 657(*/0x91, 0x05/*)*/, /*TempRegID*//* 658(*/0x92, 0x05/*)*/,
     /* 199970 */   GIR_AddImm8, /*InsnID*//* 657(*/0x91, 0x05/*)*/, /*Imm*/1,
     /* 199974 */   GIR_ConstrainOperandRC, /*InsnID*//* 657(*/0x91, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 199980 */   GIR_ConstrainOperandRC, /*InsnID*//* 657(*/0x91, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 199986 */   GIR_ConstrainOperandRC, /*InsnID*//* 657(*/0x91, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 199992 */   GIR_MakeTempReg, /*TempRegID*//* 655(*/0x8F, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199996 */   GIR_BuildMI, /*InsnID*//* 656(*/0x90, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 200001 */   GIR_AddTempRegister, /*InsnID*//* 656(*/0x90, 0x05/*)*/, /*TempRegID*//* 655(*/0x8F, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200008 */   GIR_AddSimpleTempRegister, /*InsnID*//* 656(*/0x90, 0x05/*)*/, /*TempRegID*//* 656(*/0x90, 0x05/*)*/,
     /* 200013 */   GIR_AddImm8, /*InsnID*//* 656(*/0x90, 0x05/*)*/, /*Imm*/32,
     /* 200017 */   GIR_AddImm8, /*InsnID*//* 656(*/0x90, 0x05/*)*/, /*Imm*/31,
     /* 200021 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 656(*/0x90, 0x05/*)*/,
     /* 200024 */   GIR_MakeTempReg, /*TempRegID*//* 654(*/0x8E, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 200028 */   GIR_BuildMI, /*InsnID*//* 655(*/0x8F, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 200033 */   GIR_AddTempRegister, /*InsnID*//* 655(*/0x8F, 0x05/*)*/, /*TempRegID*//* 654(*/0x8E, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200040 */   GIR_AddSimpleTempRegister, /*InsnID*//* 655(*/0x8F, 0x05/*)*/, /*TempRegID*//* 655(*/0x8F, 0x05/*)*/,
     /* 200045 */   GIR_AddImm, /*InsnID*//* 655(*/0x8F, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 200056 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 655(*/0x8F, 0x05/*)*/,
     /* 200059 */   GIR_MakeTempReg, /*TempRegID*//* 653(*/0x8D, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 200063 */   GIR_BuildMI, /*InsnID*//* 654(*/0x8E, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 200068 */   GIR_AddTempRegister, /*InsnID*//* 654(*/0x8E, 0x05/*)*/, /*TempRegID*//* 653(*/0x8D, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200075 */   GIR_AddSimpleTempRegister, /*InsnID*//* 654(*/0x8E, 0x05/*)*/, /*TempRegID*//* 654(*/0x8E, 0x05/*)*/,
     /* 200080 */   GIR_AddImm, /*InsnID*//* 654(*/0x8E, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 200091 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 654(*/0x8E, 0x05/*)*/,
     /* 200094 */   GIR_MakeTempReg, /*TempRegID*//* 652(*/0x8C, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 200098 */   GIR_BuildMI, /*InsnID*//* 653(*/0x8D, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 200103 */   GIR_AddTempRegister, /*InsnID*//* 653(*/0x8D, 0x05/*)*/, /*TempRegID*//* 652(*/0x8C, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200110 */   GIR_Copy, /*NewInsnID*//* 653(*/0x8D, 0x05/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 200115 */   GIR_AddImm8, /*InsnID*//* 653(*/0x8D, 0x05/*)*/, /*Imm*/63,
     /* 200119 */   GIR_AddImm8, /*InsnID*//* 653(*/0x8D, 0x05/*)*/, /*Imm*/1,
     /* 200123 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 653(*/0x8D, 0x05/*)*/,
     /* 200126 */   GIR_MakeTempReg, /*TempRegID*//* 651(*/0x8B, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 200130 */   GIR_BuildMI, /*InsnID*//* 652(*/0x8C, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 200135 */   GIR_AddTempRegister, /*InsnID*//* 652(*/0x8C, 0x05/*)*/, /*TempRegID*//* 651(*/0x8B, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200142 */   GIR_AddSimpleTempRegister, /*InsnID*//* 652(*/0x8C, 0x05/*)*/, /*TempRegID*//* 652(*/0x8C, 0x05/*)*/,
     /* 200147 */   GIR_AddSimpleTempRegister, /*InsnID*//* 652(*/0x8C, 0x05/*)*/, /*TempRegID*//* 653(*/0x8D, 0x05/*)*/,
     /* 200152 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 652(*/0x8C, 0x05/*)*/,
     /* 200155 */   GIR_MakeTempReg, /*TempRegID*//* 650(*/0x8A, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 200159 */   GIR_BuildMI, /*InsnID*//* 651(*/0x8B, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 200164 */   GIR_AddTempRegister, /*InsnID*//* 651(*/0x8B, 0x05/*)*/, /*TempRegID*//* 650(*/0x8A, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200171 */   GIR_AddSimpleTempRegister, /*InsnID*//* 651(*/0x8B, 0x05/*)*/, /*TempRegID*//* 651(*/0x8B, 0x05/*)*/,
     /* 200176 */   GIR_AddSimpleTempRegister, /*InsnID*//* 651(*/0x8B, 0x05/*)*/, /*TempRegID*//* 660(*/0x94, 0x05/*)*/,
     /* 200181 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 651(*/0x8B, 0x05/*)*/,
     /* 200184 */   GIR_MakeTempReg, /*TempRegID*//* 649(*/0x89, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 200188 */   GIR_BuildMI, /*InsnID*//* 650(*/0x8A, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 200193 */   GIR_AddTempRegister, /*InsnID*//* 650(*/0x8A, 0x05/*)*/, /*TempRegID*//* 649(*/0x89, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200200 */   GIR_AddSimpleTempRegister, /*InsnID*//* 650(*/0x8A, 0x05/*)*/, /*TempRegID*//* 650(*/0x8A, 0x05/*)*/,
     /* 200205 */   GIR_AddImm8, /*InsnID*//* 650(*/0x8A, 0x05/*)*/, /*Imm*/2,
     /* 200209 */   GIR_AddImm8, /*InsnID*//* 650(*/0x8A, 0x05/*)*/, /*Imm*/61,
     /* 200213 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 650(*/0x8A, 0x05/*)*/,
     /* 200216 */   GIR_MakeTempReg, /*TempRegID*//* 648(*/0x88, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 200220 */   GIR_BuildMI, /*InsnID*//* 649(*/0x89, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 200225 */   GIR_AddTempRegister, /*InsnID*//* 649(*/0x89, 0x05/*)*/, /*TempRegID*//* 648(*/0x88, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200232 */   GIR_AddSimpleTempRegister, /*InsnID*//* 649(*/0x89, 0x05/*)*/, /*TempRegID*//* 649(*/0x89, 0x05/*)*/,
     /* 200237 */   GIR_AddSimpleTempRegister, /*InsnID*//* 649(*/0x89, 0x05/*)*/, /*TempRegID*//* 669(*/0x9D, 0x05/*)*/,
     /* 200242 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 649(*/0x89, 0x05/*)*/,
     /* 200245 */   GIR_MakeTempReg, /*TempRegID*//* 647(*/0x87, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 200249 */   GIR_BuildMI, /*InsnID*//* 648(*/0x88, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 200254 */   GIR_AddTempRegister, /*InsnID*//* 648(*/0x88, 0x05/*)*/, /*TempRegID*//* 647(*/0x87, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200261 */   GIR_AddImm, /*InsnID*//* 648(*/0x88, 0x05/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 200272 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 648(*/0x88, 0x05/*)*/,
     /* 200275 */   GIR_MakeTempReg, /*TempRegID*//* 646(*/0x86, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 200279 */   GIR_BuildMI, /*InsnID*//* 647(*/0x87, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 200284 */   GIR_AddTempRegister, /*InsnID*//* 647(*/0x87, 0x05/*)*/, /*TempRegID*//* 646(*/0x86, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200291 */   GIR_AddSimpleTempRegister, /*InsnID*//* 647(*/0x87, 0x05/*)*/, /*TempRegID*//* 647(*/0x87, 0x05/*)*/,
     /* 200296 */   GIR_AddImm, /*InsnID*//* 647(*/0x87, 0x05/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 200307 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 647(*/0x87, 0x05/*)*/,
     /* 200310 */   GIR_MakeTempReg, /*TempRegID*//* 645(*/0x85, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 200314 */   GIR_BuildMI, /*InsnID*//* 646(*/0x86, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 200319 */   GIR_AddTempRegister, /*InsnID*//* 646(*/0x86, 0x05/*)*/, /*TempRegID*//* 645(*/0x85, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200326 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 646(*/0x86, 0x05/*)*/,
     /* 200329 */   GIR_MakeTempReg, /*TempRegID*//* 644(*/0x84, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 200333 */   GIR_BuildMI, /*InsnID*//* 645(*/0x85, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 200338 */   GIR_AddTempRegister, /*InsnID*//* 645(*/0x85, 0x05/*)*/, /*TempRegID*//* 644(*/0x84, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200345 */   GIR_AddSimpleTempRegister, /*InsnID*//* 645(*/0x85, 0x05/*)*/, /*TempRegID*//* 645(*/0x85, 0x05/*)*/,
     /* 200350 */   GIR_AddSimpleTempRegister, /*InsnID*//* 645(*/0x85, 0x05/*)*/, /*TempRegID*//* 646(*/0x86, 0x05/*)*/,
     /* 200355 */   GIR_AddImm8, /*InsnID*//* 645(*/0x85, 0x05/*)*/, /*Imm*/1,
     /* 200359 */   GIR_ConstrainOperandRC, /*InsnID*//* 645(*/0x85, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 200365 */   GIR_ConstrainOperandRC, /*InsnID*//* 645(*/0x85, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 200371 */   GIR_ConstrainOperandRC, /*InsnID*//* 645(*/0x85, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 200377 */   GIR_MakeTempReg, /*TempRegID*//* 643(*/0x83, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 200381 */   GIR_BuildMI, /*InsnID*//* 644(*/0x84, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 200386 */   GIR_AddTempRegister, /*InsnID*//* 644(*/0x84, 0x05/*)*/, /*TempRegID*//* 643(*/0x83, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200393 */   GIR_AddSimpleTempRegister, /*InsnID*//* 644(*/0x84, 0x05/*)*/, /*TempRegID*//* 644(*/0x84, 0x05/*)*/,
     /* 200398 */   GIR_AddImm8, /*InsnID*//* 644(*/0x84, 0x05/*)*/, /*Imm*/32,
     /* 200402 */   GIR_AddImm8, /*InsnID*//* 644(*/0x84, 0x05/*)*/, /*Imm*/31,
     /* 200406 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 644(*/0x84, 0x05/*)*/,
     /* 200409 */   GIR_MakeTempReg, /*TempRegID*//* 642(*/0x82, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 200413 */   GIR_BuildMI, /*InsnID*//* 643(*/0x83, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 200418 */   GIR_AddTempRegister, /*InsnID*//* 643(*/0x83, 0x05/*)*/, /*TempRegID*//* 642(*/0x82, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200425 */   GIR_AddSimpleTempRegister, /*InsnID*//* 643(*/0x83, 0x05/*)*/, /*TempRegID*//* 643(*/0x83, 0x05/*)*/,
     /* 200430 */   GIR_AddImm, /*InsnID*//* 643(*/0x83, 0x05/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 200441 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 643(*/0x83, 0x05/*)*/,
     /* 200444 */   GIR_MakeTempReg, /*TempRegID*//* 641(*/0x81, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 200448 */   GIR_BuildMI, /*InsnID*//* 642(*/0x82, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 200453 */   GIR_AddTempRegister, /*InsnID*//* 642(*/0x82, 0x05/*)*/, /*TempRegID*//* 641(*/0x81, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200460 */   GIR_AddSimpleTempRegister, /*InsnID*//* 642(*/0x82, 0x05/*)*/, /*TempRegID*//* 642(*/0x82, 0x05/*)*/,
     /* 200465 */   GIR_AddImm, /*InsnID*//* 642(*/0x82, 0x05/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 200476 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 642(*/0x82, 0x05/*)*/,
     /* 200479 */   GIR_MakeTempReg, /*TempRegID*//* 640(*/0x80, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 200483 */   GIR_BuildMI, /*InsnID*//* 641(*/0x81, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 200488 */   GIR_AddTempRegister, /*InsnID*//* 641(*/0x81, 0x05/*)*/, /*TempRegID*//* 640(*/0x80, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200495 */   GIR_AddImm, /*InsnID*//* 641(*/0x81, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 200506 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 641(*/0x81, 0x05/*)*/,
     /* 200509 */   GIR_MakeTempReg, /*TempRegID*//* 639(*/0xFF, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 200513 */   GIR_BuildMI, /*InsnID*//* 640(*/0x80, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 200518 */   GIR_AddTempRegister, /*InsnID*//* 640(*/0x80, 0x05/*)*/, /*TempRegID*//* 639(*/0xFF, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200525 */   GIR_AddSimpleTempRegister, /*InsnID*//* 640(*/0x80, 0x05/*)*/, /*TempRegID*//* 640(*/0x80, 0x05/*)*/,
     /* 200530 */   GIR_AddImm, /*InsnID*//* 640(*/0x80, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 200541 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 640(*/0x80, 0x05/*)*/,
     /* 200544 */   GIR_MakeTempReg, /*TempRegID*//* 638(*/0xFE, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200548 */   GIR_BuildMI, /*InsnID*//* 639(*/0xFF, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 200553 */   GIR_AddTempRegister, /*InsnID*//* 639(*/0xFF, 0x04/*)*/, /*TempRegID*//* 638(*/0xFE, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200560 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 639(*/0xFF, 0x04/*)*/,
     /* 200563 */   GIR_MakeTempReg, /*TempRegID*//* 637(*/0xFD, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200567 */   GIR_BuildMI, /*InsnID*//* 638(*/0xFE, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 200572 */   GIR_AddTempRegister, /*InsnID*//* 638(*/0xFE, 0x04/*)*/, /*TempRegID*//* 637(*/0xFD, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200579 */   GIR_AddSimpleTempRegister, /*InsnID*//* 638(*/0xFE, 0x04/*)*/, /*TempRegID*//* 638(*/0xFE, 0x04/*)*/,
     /* 200584 */   GIR_AddSimpleTempRegister, /*InsnID*//* 638(*/0xFE, 0x04/*)*/, /*TempRegID*//* 639(*/0xFF, 0x04/*)*/,
     /* 200589 */   GIR_AddImm8, /*InsnID*//* 638(*/0xFE, 0x04/*)*/, /*Imm*/1,
     /* 200593 */   GIR_ConstrainOperandRC, /*InsnID*//* 638(*/0xFE, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 200599 */   GIR_ConstrainOperandRC, /*InsnID*//* 638(*/0xFE, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 200605 */   GIR_ConstrainOperandRC, /*InsnID*//* 638(*/0xFE, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 200611 */   GIR_MakeTempReg, /*TempRegID*//* 636(*/0xFC, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200615 */   GIR_BuildMI, /*InsnID*//* 637(*/0xFD, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 200620 */   GIR_AddTempRegister, /*InsnID*//* 637(*/0xFD, 0x04/*)*/, /*TempRegID*//* 636(*/0xFC, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200627 */   GIR_AddSimpleTempRegister, /*InsnID*//* 637(*/0xFD, 0x04/*)*/, /*TempRegID*//* 637(*/0xFD, 0x04/*)*/,
     /* 200632 */   GIR_AddImm8, /*InsnID*//* 637(*/0xFD, 0x04/*)*/, /*Imm*/32,
     /* 200636 */   GIR_AddImm8, /*InsnID*//* 637(*/0xFD, 0x04/*)*/, /*Imm*/31,
     /* 200640 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 637(*/0xFD, 0x04/*)*/,
     /* 200643 */   GIR_MakeTempReg, /*TempRegID*//* 635(*/0xFB, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200647 */   GIR_BuildMI, /*InsnID*//* 636(*/0xFC, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 200652 */   GIR_AddTempRegister, /*InsnID*//* 636(*/0xFC, 0x04/*)*/, /*TempRegID*//* 635(*/0xFB, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200659 */   GIR_AddSimpleTempRegister, /*InsnID*//* 636(*/0xFC, 0x04/*)*/, /*TempRegID*//* 636(*/0xFC, 0x04/*)*/,
     /* 200664 */   GIR_AddImm, /*InsnID*//* 636(*/0xFC, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 200675 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 636(*/0xFC, 0x04/*)*/,
     /* 200678 */   GIR_MakeTempReg, /*TempRegID*//* 634(*/0xFA, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200682 */   GIR_BuildMI, /*InsnID*//* 635(*/0xFB, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 200687 */   GIR_AddTempRegister, /*InsnID*//* 635(*/0xFB, 0x04/*)*/, /*TempRegID*//* 634(*/0xFA, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200694 */   GIR_AddSimpleTempRegister, /*InsnID*//* 635(*/0xFB, 0x04/*)*/, /*TempRegID*//* 635(*/0xFB, 0x04/*)*/,
     /* 200699 */   GIR_AddImm, /*InsnID*//* 635(*/0xFB, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 200710 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 635(*/0xFB, 0x04/*)*/,
     /* 200713 */   GIR_MakeTempReg, /*TempRegID*//* 633(*/0xF9, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200717 */   GIR_BuildMI, /*InsnID*//* 634(*/0xFA, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 200722 */   GIR_AddTempRegister, /*InsnID*//* 634(*/0xFA, 0x04/*)*/, /*TempRegID*//* 633(*/0xF9, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200729 */   GIR_Copy, /*NewInsnID*//* 634(*/0xFA, 0x04/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 200734 */   GIR_AddImm8, /*InsnID*//* 634(*/0xFA, 0x04/*)*/, /*Imm*/1,
     /* 200738 */   GIR_AddImm8, /*InsnID*//* 634(*/0xFA, 0x04/*)*/, /*Imm*/62,
     /* 200742 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 634(*/0xFA, 0x04/*)*/,
     /* 200745 */   GIR_MakeTempReg, /*TempRegID*//* 632(*/0xF8, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200749 */   GIR_BuildMI, /*InsnID*//* 633(*/0xF9, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 200754 */   GIR_AddTempRegister, /*InsnID*//* 633(*/0xF9, 0x04/*)*/, /*TempRegID*//* 632(*/0xF8, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200761 */   GIR_AddSimpleTempRegister, /*InsnID*//* 633(*/0xF9, 0x04/*)*/, /*TempRegID*//* 633(*/0xF9, 0x04/*)*/,
     /* 200766 */   GIR_AddSimpleTempRegister, /*InsnID*//* 633(*/0xF9, 0x04/*)*/, /*TempRegID*//* 634(*/0xFA, 0x04/*)*/,
     /* 200771 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 633(*/0xF9, 0x04/*)*/,
     /* 200774 */   GIR_MakeTempReg, /*TempRegID*//* 631(*/0xF7, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 200778 */   GIR_BuildMI, /*InsnID*//* 632(*/0xF8, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 200783 */   GIR_AddTempRegister, /*InsnID*//* 632(*/0xF8, 0x04/*)*/, /*TempRegID*//* 631(*/0xF7, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200790 */   GIR_AddImm, /*InsnID*//* 632(*/0xF8, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 200801 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 632(*/0xF8, 0x04/*)*/,
     /* 200804 */   GIR_MakeTempReg, /*TempRegID*//* 630(*/0xF6, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 200808 */   GIR_BuildMI, /*InsnID*//* 631(*/0xF7, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 200813 */   GIR_AddTempRegister, /*InsnID*//* 631(*/0xF7, 0x04/*)*/, /*TempRegID*//* 630(*/0xF6, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200820 */   GIR_AddSimpleTempRegister, /*InsnID*//* 631(*/0xF7, 0x04/*)*/, /*TempRegID*//* 631(*/0xF7, 0x04/*)*/,
     /* 200825 */   GIR_AddImm, /*InsnID*//* 631(*/0xF7, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 200836 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 631(*/0xF7, 0x04/*)*/,
     /* 200839 */   GIR_MakeTempReg, /*TempRegID*//* 629(*/0xF5, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200843 */   GIR_BuildMI, /*InsnID*//* 630(*/0xF6, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 200848 */   GIR_AddTempRegister, /*InsnID*//* 630(*/0xF6, 0x04/*)*/, /*TempRegID*//* 629(*/0xF5, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200855 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 630(*/0xF6, 0x04/*)*/,
     /* 200858 */   GIR_MakeTempReg, /*TempRegID*//* 628(*/0xF4, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200862 */   GIR_BuildMI, /*InsnID*//* 629(*/0xF5, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 200867 */   GIR_AddTempRegister, /*InsnID*//* 629(*/0xF5, 0x04/*)*/, /*TempRegID*//* 628(*/0xF4, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200874 */   GIR_AddSimpleTempRegister, /*InsnID*//* 629(*/0xF5, 0x04/*)*/, /*TempRegID*//* 629(*/0xF5, 0x04/*)*/,
     /* 200879 */   GIR_AddSimpleTempRegister, /*InsnID*//* 629(*/0xF5, 0x04/*)*/, /*TempRegID*//* 630(*/0xF6, 0x04/*)*/,
     /* 200884 */   GIR_AddImm8, /*InsnID*//* 629(*/0xF5, 0x04/*)*/, /*Imm*/1,
     /* 200888 */   GIR_ConstrainOperandRC, /*InsnID*//* 629(*/0xF5, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 200894 */   GIR_ConstrainOperandRC, /*InsnID*//* 629(*/0xF5, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 200900 */   GIR_ConstrainOperandRC, /*InsnID*//* 629(*/0xF5, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 200906 */   GIR_MakeTempReg, /*TempRegID*//* 627(*/0xF3, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200910 */   GIR_BuildMI, /*InsnID*//* 628(*/0xF4, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 200915 */   GIR_AddTempRegister, /*InsnID*//* 628(*/0xF4, 0x04/*)*/, /*TempRegID*//* 627(*/0xF3, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200922 */   GIR_AddSimpleTempRegister, /*InsnID*//* 628(*/0xF4, 0x04/*)*/, /*TempRegID*//* 628(*/0xF4, 0x04/*)*/,
     /* 200927 */   GIR_AddImm8, /*InsnID*//* 628(*/0xF4, 0x04/*)*/, /*Imm*/32,
     /* 200931 */   GIR_AddImm8, /*InsnID*//* 628(*/0xF4, 0x04/*)*/, /*Imm*/31,
     /* 200935 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 628(*/0xF4, 0x04/*)*/,
     /* 200938 */   GIR_MakeTempReg, /*TempRegID*//* 626(*/0xF2, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200942 */   GIR_BuildMI, /*InsnID*//* 627(*/0xF3, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 200947 */   GIR_AddTempRegister, /*InsnID*//* 627(*/0xF3, 0x04/*)*/, /*TempRegID*//* 626(*/0xF2, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200954 */   GIR_AddSimpleTempRegister, /*InsnID*//* 627(*/0xF3, 0x04/*)*/, /*TempRegID*//* 627(*/0xF3, 0x04/*)*/,
     /* 200959 */   GIR_AddImm, /*InsnID*//* 627(*/0xF3, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 200970 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 627(*/0xF3, 0x04/*)*/,
     /* 200973 */   GIR_MakeTempReg, /*TempRegID*//* 625(*/0xF1, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200977 */   GIR_BuildMI, /*InsnID*//* 626(*/0xF2, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 200982 */   GIR_AddTempRegister, /*InsnID*//* 626(*/0xF2, 0x04/*)*/, /*TempRegID*//* 625(*/0xF1, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200989 */   GIR_AddSimpleTempRegister, /*InsnID*//* 626(*/0xF2, 0x04/*)*/, /*TempRegID*//* 626(*/0xF2, 0x04/*)*/,
     /* 200994 */   GIR_AddImm, /*InsnID*//* 626(*/0xF2, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 201005 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 626(*/0xF2, 0x04/*)*/,
     /* 201008 */   GIR_MakeTempReg, /*TempRegID*//* 624(*/0xF0, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201012 */   GIR_BuildMI, /*InsnID*//* 625(*/0xF1, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 201017 */   GIR_AddTempRegister, /*InsnID*//* 625(*/0xF1, 0x04/*)*/, /*TempRegID*//* 624(*/0xF0, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201024 */   GIR_Copy, /*NewInsnID*//* 625(*/0xF1, 0x04/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 201029 */   GIR_AddImm8, /*InsnID*//* 625(*/0xF1, 0x04/*)*/, /*Imm*/63,
     /* 201033 */   GIR_AddImm8, /*InsnID*//* 625(*/0xF1, 0x04/*)*/, /*Imm*/1,
     /* 201037 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 625(*/0xF1, 0x04/*)*/,
     /* 201040 */   GIR_MakeTempReg, /*TempRegID*//* 623(*/0xEF, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201044 */   GIR_BuildMI, /*InsnID*//* 624(*/0xF0, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 201049 */   GIR_AddTempRegister, /*InsnID*//* 624(*/0xF0, 0x04/*)*/, /*TempRegID*//* 623(*/0xEF, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201056 */   GIR_AddSimpleTempRegister, /*InsnID*//* 624(*/0xF0, 0x04/*)*/, /*TempRegID*//* 624(*/0xF0, 0x04/*)*/,
     /* 201061 */   GIR_AddSimpleTempRegister, /*InsnID*//* 624(*/0xF0, 0x04/*)*/, /*TempRegID*//* 625(*/0xF1, 0x04/*)*/,
     /* 201066 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 624(*/0xF0, 0x04/*)*/,
     /* 201069 */   GIR_MakeTempReg, /*TempRegID*//* 622(*/0xEE, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201073 */   GIR_BuildMI, /*InsnID*//* 623(*/0xEF, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 201078 */   GIR_AddTempRegister, /*InsnID*//* 623(*/0xEF, 0x04/*)*/, /*TempRegID*//* 622(*/0xEE, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201085 */   GIR_AddSimpleTempRegister, /*InsnID*//* 623(*/0xEF, 0x04/*)*/, /*TempRegID*//* 623(*/0xEF, 0x04/*)*/,
     /* 201090 */   GIR_AddSimpleTempRegister, /*InsnID*//* 623(*/0xEF, 0x04/*)*/, /*TempRegID*//* 632(*/0xF8, 0x04/*)*/,
     /* 201095 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 623(*/0xEF, 0x04/*)*/,
     /* 201098 */   GIR_MakeTempReg, /*TempRegID*//* 621(*/0xED, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201102 */   GIR_BuildMI, /*InsnID*//* 622(*/0xEE, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 201107 */   GIR_AddTempRegister, /*InsnID*//* 622(*/0xEE, 0x04/*)*/, /*TempRegID*//* 621(*/0xED, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201114 */   GIR_AddSimpleTempRegister, /*InsnID*//* 622(*/0xEE, 0x04/*)*/, /*TempRegID*//* 622(*/0xEE, 0x04/*)*/,
     /* 201119 */   GIR_AddImm8, /*InsnID*//* 622(*/0xEE, 0x04/*)*/, /*Imm*/62,
     /* 201123 */   GIR_AddImm8, /*InsnID*//* 622(*/0xEE, 0x04/*)*/, /*Imm*/2,
     /* 201127 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 622(*/0xEE, 0x04/*)*/,
     /* 201130 */   GIR_MakeTempReg, /*TempRegID*//* 620(*/0xEC, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201134 */   GIR_BuildMI, /*InsnID*//* 621(*/0xED, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 201139 */   GIR_AddTempRegister, /*InsnID*//* 621(*/0xED, 0x04/*)*/, /*TempRegID*//* 620(*/0xEC, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201146 */   GIR_AddSimpleTempRegister, /*InsnID*//* 621(*/0xED, 0x04/*)*/, /*TempRegID*//* 621(*/0xED, 0x04/*)*/,
     /* 201151 */   GIR_AddSimpleTempRegister, /*InsnID*//* 621(*/0xED, 0x04/*)*/, /*TempRegID*//* 641(*/0x81, 0x05/*)*/,
     /* 201156 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 621(*/0xED, 0x04/*)*/,
     /* 201159 */   GIR_MakeTempReg, /*TempRegID*//* 619(*/0xEB, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201163 */   GIR_BuildMI, /*InsnID*//* 620(*/0xEC, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 201168 */   GIR_AddTempRegister, /*InsnID*//* 620(*/0xEC, 0x04/*)*/, /*TempRegID*//* 619(*/0xEB, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201175 */   GIR_AddSimpleTempRegister, /*InsnID*//* 620(*/0xEC, 0x04/*)*/, /*TempRegID*//* 620(*/0xEC, 0x04/*)*/,
     /* 201180 */   GIR_AddSimpleTempRegister, /*InsnID*//* 620(*/0xEC, 0x04/*)*/, /*TempRegID*//* 648(*/0x88, 0x05/*)*/,
     /* 201185 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 620(*/0xEC, 0x04/*)*/,
     /* 201188 */   GIR_MakeTempReg, /*TempRegID*//* 618(*/0xEA, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201192 */   GIR_BuildMI, /*InsnID*//* 619(*/0xEB, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 201197 */   GIR_AddTempRegister, /*InsnID*//* 619(*/0xEB, 0x04/*)*/, /*TempRegID*//* 618(*/0xEA, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201204 */   GIR_AddSimpleTempRegister, /*InsnID*//* 619(*/0xEB, 0x04/*)*/, /*TempRegID*//* 619(*/0xEB, 0x04/*)*/,
     /* 201209 */   GIR_AddImm8, /*InsnID*//* 619(*/0xEB, 0x04/*)*/, /*Imm*/4,
     /* 201213 */   GIR_AddImm8, /*InsnID*//* 619(*/0xEB, 0x04/*)*/, /*Imm*/59,
     /* 201217 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 619(*/0xEB, 0x04/*)*/,
     /* 201220 */   GIR_MakeTempReg, /*TempRegID*//* 617(*/0xE9, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201224 */   GIR_BuildMI, /*InsnID*//* 618(*/0xEA, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 201229 */   GIR_AddTempRegister, /*InsnID*//* 618(*/0xEA, 0x04/*)*/, /*TempRegID*//* 617(*/0xE9, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201236 */   GIR_AddSimpleTempRegister, /*InsnID*//* 618(*/0xEA, 0x04/*)*/, /*TempRegID*//* 618(*/0xEA, 0x04/*)*/,
     /* 201241 */   GIR_AddSimpleTempRegister, /*InsnID*//* 618(*/0xEA, 0x04/*)*/, /*TempRegID*//* 676(*/0xA4, 0x05/*)*/,
     /* 201246 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 618(*/0xEA, 0x04/*)*/,
     /* 201249 */   GIR_MakeTempReg, /*TempRegID*//* 616(*/0xE8, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 201253 */   GIR_BuildMI, /*InsnID*//* 617(*/0xE9, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 201258 */   GIR_AddTempRegister, /*InsnID*//* 617(*/0xE9, 0x04/*)*/, /*TempRegID*//* 616(*/0xE8, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201265 */   GIR_AddImm, /*InsnID*//* 617(*/0xE9, 0x04/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 201276 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 617(*/0xE9, 0x04/*)*/,
     /* 201279 */   GIR_MakeTempReg, /*TempRegID*//* 615(*/0xE7, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 201283 */   GIR_BuildMI, /*InsnID*//* 616(*/0xE8, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 201288 */   GIR_AddTempRegister, /*InsnID*//* 616(*/0xE8, 0x04/*)*/, /*TempRegID*//* 615(*/0xE7, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201295 */   GIR_AddSimpleTempRegister, /*InsnID*//* 616(*/0xE8, 0x04/*)*/, /*TempRegID*//* 616(*/0xE8, 0x04/*)*/,
     /* 201300 */   GIR_AddImm, /*InsnID*//* 616(*/0xE8, 0x04/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 201311 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 616(*/0xE8, 0x04/*)*/,
     /* 201314 */   GIR_MakeTempReg, /*TempRegID*//* 614(*/0xE6, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201318 */   GIR_BuildMI, /*InsnID*//* 615(*/0xE7, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 201323 */   GIR_AddTempRegister, /*InsnID*//* 615(*/0xE7, 0x04/*)*/, /*TempRegID*//* 614(*/0xE6, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201330 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 615(*/0xE7, 0x04/*)*/,
     /* 201333 */   GIR_MakeTempReg, /*TempRegID*//* 613(*/0xE5, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201337 */   GIR_BuildMI, /*InsnID*//* 614(*/0xE6, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 201342 */   GIR_AddTempRegister, /*InsnID*//* 614(*/0xE6, 0x04/*)*/, /*TempRegID*//* 613(*/0xE5, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201349 */   GIR_AddSimpleTempRegister, /*InsnID*//* 614(*/0xE6, 0x04/*)*/, /*TempRegID*//* 614(*/0xE6, 0x04/*)*/,
     /* 201354 */   GIR_AddSimpleTempRegister, /*InsnID*//* 614(*/0xE6, 0x04/*)*/, /*TempRegID*//* 615(*/0xE7, 0x04/*)*/,
     /* 201359 */   GIR_AddImm8, /*InsnID*//* 614(*/0xE6, 0x04/*)*/, /*Imm*/1,
     /* 201363 */   GIR_ConstrainOperandRC, /*InsnID*//* 614(*/0xE6, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 201369 */   GIR_ConstrainOperandRC, /*InsnID*//* 614(*/0xE6, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 201375 */   GIR_ConstrainOperandRC, /*InsnID*//* 614(*/0xE6, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 201381 */   GIR_MakeTempReg, /*TempRegID*//* 612(*/0xE4, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201385 */   GIR_BuildMI, /*InsnID*//* 613(*/0xE5, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 201390 */   GIR_AddTempRegister, /*InsnID*//* 613(*/0xE5, 0x04/*)*/, /*TempRegID*//* 612(*/0xE4, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201397 */   GIR_AddSimpleTempRegister, /*InsnID*//* 613(*/0xE5, 0x04/*)*/, /*TempRegID*//* 613(*/0xE5, 0x04/*)*/,
     /* 201402 */   GIR_AddImm8, /*InsnID*//* 613(*/0xE5, 0x04/*)*/, /*Imm*/32,
     /* 201406 */   GIR_AddImm8, /*InsnID*//* 613(*/0xE5, 0x04/*)*/, /*Imm*/31,
     /* 201410 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 613(*/0xE5, 0x04/*)*/,
     /* 201413 */   GIR_MakeTempReg, /*TempRegID*//* 611(*/0xE3, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201417 */   GIR_BuildMI, /*InsnID*//* 612(*/0xE4, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 201422 */   GIR_AddTempRegister, /*InsnID*//* 612(*/0xE4, 0x04/*)*/, /*TempRegID*//* 611(*/0xE3, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201429 */   GIR_AddSimpleTempRegister, /*InsnID*//* 612(*/0xE4, 0x04/*)*/, /*TempRegID*//* 612(*/0xE4, 0x04/*)*/,
     /* 201434 */   GIR_AddImm, /*InsnID*//* 612(*/0xE4, 0x04/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 201445 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 612(*/0xE4, 0x04/*)*/,
     /* 201448 */   GIR_MakeTempReg, /*TempRegID*//* 610(*/0xE2, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201452 */   GIR_BuildMI, /*InsnID*//* 611(*/0xE3, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 201457 */   GIR_AddTempRegister, /*InsnID*//* 611(*/0xE3, 0x04/*)*/, /*TempRegID*//* 610(*/0xE2, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201464 */   GIR_AddSimpleTempRegister, /*InsnID*//* 611(*/0xE3, 0x04/*)*/, /*TempRegID*//* 611(*/0xE3, 0x04/*)*/,
     /* 201469 */   GIR_AddImm, /*InsnID*//* 611(*/0xE3, 0x04/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 201480 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 611(*/0xE3, 0x04/*)*/,
     /* 201483 */   GIR_MakeTempReg, /*TempRegID*//* 609(*/0xE1, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 201487 */   GIR_BuildMI, /*InsnID*//* 610(*/0xE2, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 201492 */   GIR_AddTempRegister, /*InsnID*//* 610(*/0xE2, 0x04/*)*/, /*TempRegID*//* 609(*/0xE1, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201499 */   GIR_AddImm, /*InsnID*//* 610(*/0xE2, 0x04/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 201510 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 610(*/0xE2, 0x04/*)*/,
     /* 201513 */   GIR_MakeTempReg, /*TempRegID*//* 608(*/0xE0, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 201517 */   GIR_BuildMI, /*InsnID*//* 609(*/0xE1, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 201522 */   GIR_AddTempRegister, /*InsnID*//* 609(*/0xE1, 0x04/*)*/, /*TempRegID*//* 608(*/0xE0, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201529 */   GIR_AddSimpleTempRegister, /*InsnID*//* 609(*/0xE1, 0x04/*)*/, /*TempRegID*//* 609(*/0xE1, 0x04/*)*/,
     /* 201534 */   GIR_AddImm, /*InsnID*//* 609(*/0xE1, 0x04/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 201545 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 609(*/0xE1, 0x04/*)*/,
     /* 201548 */   GIR_MakeTempReg, /*TempRegID*//* 607(*/0xDF, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201552 */   GIR_BuildMI, /*InsnID*//* 608(*/0xE0, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 201557 */   GIR_AddTempRegister, /*InsnID*//* 608(*/0xE0, 0x04/*)*/, /*TempRegID*//* 607(*/0xDF, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201564 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 608(*/0xE0, 0x04/*)*/,
     /* 201567 */   GIR_MakeTempReg, /*TempRegID*//* 606(*/0xDE, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201571 */   GIR_BuildMI, /*InsnID*//* 607(*/0xDF, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 201576 */   GIR_AddTempRegister, /*InsnID*//* 607(*/0xDF, 0x04/*)*/, /*TempRegID*//* 606(*/0xDE, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201583 */   GIR_AddSimpleTempRegister, /*InsnID*//* 607(*/0xDF, 0x04/*)*/, /*TempRegID*//* 607(*/0xDF, 0x04/*)*/,
     /* 201588 */   GIR_AddSimpleTempRegister, /*InsnID*//* 607(*/0xDF, 0x04/*)*/, /*TempRegID*//* 608(*/0xE0, 0x04/*)*/,
     /* 201593 */   GIR_AddImm8, /*InsnID*//* 607(*/0xDF, 0x04/*)*/, /*Imm*/1,
     /* 201597 */   GIR_ConstrainOperandRC, /*InsnID*//* 607(*/0xDF, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 201603 */   GIR_ConstrainOperandRC, /*InsnID*//* 607(*/0xDF, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 201609 */   GIR_ConstrainOperandRC, /*InsnID*//* 607(*/0xDF, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 201615 */   GIR_MakeTempReg, /*TempRegID*//* 605(*/0xDD, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201619 */   GIR_BuildMI, /*InsnID*//* 606(*/0xDE, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 201624 */   GIR_AddTempRegister, /*InsnID*//* 606(*/0xDE, 0x04/*)*/, /*TempRegID*//* 605(*/0xDD, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201631 */   GIR_AddSimpleTempRegister, /*InsnID*//* 606(*/0xDE, 0x04/*)*/, /*TempRegID*//* 606(*/0xDE, 0x04/*)*/,
     /* 201636 */   GIR_AddImm8, /*InsnID*//* 606(*/0xDE, 0x04/*)*/, /*Imm*/32,
     /* 201640 */   GIR_AddImm8, /*InsnID*//* 606(*/0xDE, 0x04/*)*/, /*Imm*/31,
     /* 201644 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 606(*/0xDE, 0x04/*)*/,
     /* 201647 */   GIR_MakeTempReg, /*TempRegID*//* 604(*/0xDC, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201651 */   GIR_BuildMI, /*InsnID*//* 605(*/0xDD, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 201656 */   GIR_AddTempRegister, /*InsnID*//* 605(*/0xDD, 0x04/*)*/, /*TempRegID*//* 604(*/0xDC, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201663 */   GIR_AddSimpleTempRegister, /*InsnID*//* 605(*/0xDD, 0x04/*)*/, /*TempRegID*//* 605(*/0xDD, 0x04/*)*/,
     /* 201668 */   GIR_AddImm, /*InsnID*//* 605(*/0xDD, 0x04/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 201679 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 605(*/0xDD, 0x04/*)*/,
     /* 201682 */   GIR_MakeTempReg, /*TempRegID*//* 603(*/0xDB, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201686 */   GIR_BuildMI, /*InsnID*//* 604(*/0xDC, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 201691 */   GIR_AddTempRegister, /*InsnID*//* 604(*/0xDC, 0x04/*)*/, /*TempRegID*//* 603(*/0xDB, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201698 */   GIR_AddSimpleTempRegister, /*InsnID*//* 604(*/0xDC, 0x04/*)*/, /*TempRegID*//* 604(*/0xDC, 0x04/*)*/,
     /* 201703 */   GIR_AddImm, /*InsnID*//* 604(*/0xDC, 0x04/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 201714 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 604(*/0xDC, 0x04/*)*/,
     /* 201717 */   GIR_MakeTempReg, /*TempRegID*//* 602(*/0xDA, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 201721 */   GIR_BuildMI, /*InsnID*//* 603(*/0xDB, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 201726 */   GIR_AddTempRegister, /*InsnID*//* 603(*/0xDB, 0x04/*)*/, /*TempRegID*//* 602(*/0xDA, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201733 */   GIR_AddImm, /*InsnID*//* 603(*/0xDB, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 201744 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 603(*/0xDB, 0x04/*)*/,
     /* 201747 */   GIR_MakeTempReg, /*TempRegID*//* 601(*/0xD9, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 201751 */   GIR_BuildMI, /*InsnID*//* 602(*/0xDA, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 201756 */   GIR_AddTempRegister, /*InsnID*//* 602(*/0xDA, 0x04/*)*/, /*TempRegID*//* 601(*/0xD9, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201763 */   GIR_AddSimpleTempRegister, /*InsnID*//* 602(*/0xDA, 0x04/*)*/, /*TempRegID*//* 602(*/0xDA, 0x04/*)*/,
     /* 201768 */   GIR_AddImm, /*InsnID*//* 602(*/0xDA, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 201779 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 602(*/0xDA, 0x04/*)*/,
     /* 201782 */   GIR_MakeTempReg, /*TempRegID*//* 600(*/0xD8, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201786 */   GIR_BuildMI, /*InsnID*//* 601(*/0xD9, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 201791 */   GIR_AddTempRegister, /*InsnID*//* 601(*/0xD9, 0x04/*)*/, /*TempRegID*//* 600(*/0xD8, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201798 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 601(*/0xD9, 0x04/*)*/,
     /* 201801 */   GIR_MakeTempReg, /*TempRegID*//* 599(*/0xD7, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201805 */   GIR_BuildMI, /*InsnID*//* 600(*/0xD8, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 201810 */   GIR_AddTempRegister, /*InsnID*//* 600(*/0xD8, 0x04/*)*/, /*TempRegID*//* 599(*/0xD7, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201817 */   GIR_AddSimpleTempRegister, /*InsnID*//* 600(*/0xD8, 0x04/*)*/, /*TempRegID*//* 600(*/0xD8, 0x04/*)*/,
     /* 201822 */   GIR_AddSimpleTempRegister, /*InsnID*//* 600(*/0xD8, 0x04/*)*/, /*TempRegID*//* 601(*/0xD9, 0x04/*)*/,
     /* 201827 */   GIR_AddImm8, /*InsnID*//* 600(*/0xD8, 0x04/*)*/, /*Imm*/1,
     /* 201831 */   GIR_ConstrainOperandRC, /*InsnID*//* 600(*/0xD8, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 201837 */   GIR_ConstrainOperandRC, /*InsnID*//* 600(*/0xD8, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 201843 */   GIR_ConstrainOperandRC, /*InsnID*//* 600(*/0xD8, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 201849 */   GIR_MakeTempReg, /*TempRegID*//* 598(*/0xD6, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201853 */   GIR_BuildMI, /*InsnID*//* 599(*/0xD7, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 201858 */   GIR_AddTempRegister, /*InsnID*//* 599(*/0xD7, 0x04/*)*/, /*TempRegID*//* 598(*/0xD6, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201865 */   GIR_AddSimpleTempRegister, /*InsnID*//* 599(*/0xD7, 0x04/*)*/, /*TempRegID*//* 599(*/0xD7, 0x04/*)*/,
     /* 201870 */   GIR_AddImm8, /*InsnID*//* 599(*/0xD7, 0x04/*)*/, /*Imm*/32,
     /* 201874 */   GIR_AddImm8, /*InsnID*//* 599(*/0xD7, 0x04/*)*/, /*Imm*/31,
     /* 201878 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 599(*/0xD7, 0x04/*)*/,
     /* 201881 */   GIR_MakeTempReg, /*TempRegID*//* 597(*/0xD5, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201885 */   GIR_BuildMI, /*InsnID*//* 598(*/0xD6, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 201890 */   GIR_AddTempRegister, /*InsnID*//* 598(*/0xD6, 0x04/*)*/, /*TempRegID*//* 597(*/0xD5, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201897 */   GIR_AddSimpleTempRegister, /*InsnID*//* 598(*/0xD6, 0x04/*)*/, /*TempRegID*//* 598(*/0xD6, 0x04/*)*/,
     /* 201902 */   GIR_AddImm, /*InsnID*//* 598(*/0xD6, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 201913 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 598(*/0xD6, 0x04/*)*/,
     /* 201916 */   GIR_MakeTempReg, /*TempRegID*//* 596(*/0xD4, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201920 */   GIR_BuildMI, /*InsnID*//* 597(*/0xD5, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 201925 */   GIR_AddTempRegister, /*InsnID*//* 597(*/0xD5, 0x04/*)*/, /*TempRegID*//* 596(*/0xD4, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201932 */   GIR_AddSimpleTempRegister, /*InsnID*//* 597(*/0xD5, 0x04/*)*/, /*TempRegID*//* 597(*/0xD5, 0x04/*)*/,
     /* 201937 */   GIR_AddImm, /*InsnID*//* 597(*/0xD5, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 201948 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 597(*/0xD5, 0x04/*)*/,
     /* 201951 */   GIR_MakeTempReg, /*TempRegID*//* 595(*/0xD3, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201955 */   GIR_BuildMI, /*InsnID*//* 596(*/0xD4, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 201960 */   GIR_AddTempRegister, /*InsnID*//* 596(*/0xD4, 0x04/*)*/, /*TempRegID*//* 595(*/0xD3, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201967 */   GIR_Copy, /*NewInsnID*//* 596(*/0xD4, 0x04/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 201972 */   GIR_AddImm8, /*InsnID*//* 596(*/0xD4, 0x04/*)*/, /*Imm*/1,
     /* 201976 */   GIR_AddImm8, /*InsnID*//* 596(*/0xD4, 0x04/*)*/, /*Imm*/62,
     /* 201980 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 596(*/0xD4, 0x04/*)*/,
     /* 201983 */   GIR_MakeTempReg, /*TempRegID*//* 594(*/0xD2, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201987 */   GIR_BuildMI, /*InsnID*//* 595(*/0xD3, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 201992 */   GIR_AddTempRegister, /*InsnID*//* 595(*/0xD3, 0x04/*)*/, /*TempRegID*//* 594(*/0xD2, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201999 */   GIR_AddSimpleTempRegister, /*InsnID*//* 595(*/0xD3, 0x04/*)*/, /*TempRegID*//* 595(*/0xD3, 0x04/*)*/,
     /* 202004 */   GIR_AddSimpleTempRegister, /*InsnID*//* 595(*/0xD3, 0x04/*)*/, /*TempRegID*//* 596(*/0xD4, 0x04/*)*/,
     /* 202009 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 595(*/0xD3, 0x04/*)*/,
     /* 202012 */   GIR_MakeTempReg, /*TempRegID*//* 593(*/0xD1, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 202016 */   GIR_BuildMI, /*InsnID*//* 594(*/0xD2, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 202021 */   GIR_AddTempRegister, /*InsnID*//* 594(*/0xD2, 0x04/*)*/, /*TempRegID*//* 593(*/0xD1, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202028 */   GIR_AddImm, /*InsnID*//* 594(*/0xD2, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 202039 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 594(*/0xD2, 0x04/*)*/,
     /* 202042 */   GIR_MakeTempReg, /*TempRegID*//* 592(*/0xD0, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 202046 */   GIR_BuildMI, /*InsnID*//* 593(*/0xD1, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 202051 */   GIR_AddTempRegister, /*InsnID*//* 593(*/0xD1, 0x04/*)*/, /*TempRegID*//* 592(*/0xD0, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202058 */   GIR_AddSimpleTempRegister, /*InsnID*//* 593(*/0xD1, 0x04/*)*/, /*TempRegID*//* 593(*/0xD1, 0x04/*)*/,
     /* 202063 */   GIR_AddImm, /*InsnID*//* 593(*/0xD1, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 202074 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 593(*/0xD1, 0x04/*)*/,
     /* 202077 */   GIR_MakeTempReg, /*TempRegID*//* 591(*/0xCF, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202081 */   GIR_BuildMI, /*InsnID*//* 592(*/0xD0, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 202086 */   GIR_AddTempRegister, /*InsnID*//* 592(*/0xD0, 0x04/*)*/, /*TempRegID*//* 591(*/0xCF, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202093 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 592(*/0xD0, 0x04/*)*/,
     /* 202096 */   GIR_MakeTempReg, /*TempRegID*//* 590(*/0xCE, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202100 */   GIR_BuildMI, /*InsnID*//* 591(*/0xCF, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 202105 */   GIR_AddTempRegister, /*InsnID*//* 591(*/0xCF, 0x04/*)*/, /*TempRegID*//* 590(*/0xCE, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202112 */   GIR_AddSimpleTempRegister, /*InsnID*//* 591(*/0xCF, 0x04/*)*/, /*TempRegID*//* 591(*/0xCF, 0x04/*)*/,
     /* 202117 */   GIR_AddSimpleTempRegister, /*InsnID*//* 591(*/0xCF, 0x04/*)*/, /*TempRegID*//* 592(*/0xD0, 0x04/*)*/,
     /* 202122 */   GIR_AddImm8, /*InsnID*//* 591(*/0xCF, 0x04/*)*/, /*Imm*/1,
     /* 202126 */   GIR_ConstrainOperandRC, /*InsnID*//* 591(*/0xCF, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 202132 */   GIR_ConstrainOperandRC, /*InsnID*//* 591(*/0xCF, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 202138 */   GIR_ConstrainOperandRC, /*InsnID*//* 591(*/0xCF, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 202144 */   GIR_MakeTempReg, /*TempRegID*//* 589(*/0xCD, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202148 */   GIR_BuildMI, /*InsnID*//* 590(*/0xCE, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 202153 */   GIR_AddTempRegister, /*InsnID*//* 590(*/0xCE, 0x04/*)*/, /*TempRegID*//* 589(*/0xCD, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202160 */   GIR_AddSimpleTempRegister, /*InsnID*//* 590(*/0xCE, 0x04/*)*/, /*TempRegID*//* 590(*/0xCE, 0x04/*)*/,
     /* 202165 */   GIR_AddImm8, /*InsnID*//* 590(*/0xCE, 0x04/*)*/, /*Imm*/32,
     /* 202169 */   GIR_AddImm8, /*InsnID*//* 590(*/0xCE, 0x04/*)*/, /*Imm*/31,
     /* 202173 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 590(*/0xCE, 0x04/*)*/,
     /* 202176 */   GIR_MakeTempReg, /*TempRegID*//* 588(*/0xCC, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202180 */   GIR_BuildMI, /*InsnID*//* 589(*/0xCD, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 202185 */   GIR_AddTempRegister, /*InsnID*//* 589(*/0xCD, 0x04/*)*/, /*TempRegID*//* 588(*/0xCC, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202192 */   GIR_AddSimpleTempRegister, /*InsnID*//* 589(*/0xCD, 0x04/*)*/, /*TempRegID*//* 589(*/0xCD, 0x04/*)*/,
     /* 202197 */   GIR_AddImm, /*InsnID*//* 589(*/0xCD, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 202208 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 589(*/0xCD, 0x04/*)*/,
     /* 202211 */   GIR_MakeTempReg, /*TempRegID*//* 587(*/0xCB, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202215 */   GIR_BuildMI, /*InsnID*//* 588(*/0xCC, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 202220 */   GIR_AddTempRegister, /*InsnID*//* 588(*/0xCC, 0x04/*)*/, /*TempRegID*//* 587(*/0xCB, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202227 */   GIR_AddSimpleTempRegister, /*InsnID*//* 588(*/0xCC, 0x04/*)*/, /*TempRegID*//* 588(*/0xCC, 0x04/*)*/,
     /* 202232 */   GIR_AddImm, /*InsnID*//* 588(*/0xCC, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 202243 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 588(*/0xCC, 0x04/*)*/,
     /* 202246 */   GIR_MakeTempReg, /*TempRegID*//* 586(*/0xCA, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202250 */   GIR_BuildMI, /*InsnID*//* 587(*/0xCB, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 202255 */   GIR_AddTempRegister, /*InsnID*//* 587(*/0xCB, 0x04/*)*/, /*TempRegID*//* 586(*/0xCA, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202262 */   GIR_Copy, /*NewInsnID*//* 587(*/0xCB, 0x04/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 202267 */   GIR_AddImm8, /*InsnID*//* 587(*/0xCB, 0x04/*)*/, /*Imm*/63,
     /* 202271 */   GIR_AddImm8, /*InsnID*//* 587(*/0xCB, 0x04/*)*/, /*Imm*/1,
     /* 202275 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 587(*/0xCB, 0x04/*)*/,
     /* 202278 */   GIR_MakeTempReg, /*TempRegID*//* 585(*/0xC9, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202282 */   GIR_BuildMI, /*InsnID*//* 586(*/0xCA, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 202287 */   GIR_AddTempRegister, /*InsnID*//* 586(*/0xCA, 0x04/*)*/, /*TempRegID*//* 585(*/0xC9, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202294 */   GIR_AddSimpleTempRegister, /*InsnID*//* 586(*/0xCA, 0x04/*)*/, /*TempRegID*//* 586(*/0xCA, 0x04/*)*/,
     /* 202299 */   GIR_AddSimpleTempRegister, /*InsnID*//* 586(*/0xCA, 0x04/*)*/, /*TempRegID*//* 587(*/0xCB, 0x04/*)*/,
     /* 202304 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 586(*/0xCA, 0x04/*)*/,
     /* 202307 */   GIR_MakeTempReg, /*TempRegID*//* 584(*/0xC8, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202311 */   GIR_BuildMI, /*InsnID*//* 585(*/0xC9, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 202316 */   GIR_AddTempRegister, /*InsnID*//* 585(*/0xC9, 0x04/*)*/, /*TempRegID*//* 584(*/0xC8, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202323 */   GIR_AddSimpleTempRegister, /*InsnID*//* 585(*/0xC9, 0x04/*)*/, /*TempRegID*//* 585(*/0xC9, 0x04/*)*/,
     /* 202328 */   GIR_AddSimpleTempRegister, /*InsnID*//* 585(*/0xC9, 0x04/*)*/, /*TempRegID*//* 594(*/0xD2, 0x04/*)*/,
     /* 202333 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 585(*/0xC9, 0x04/*)*/,
     /* 202336 */   GIR_MakeTempReg, /*TempRegID*//* 583(*/0xC7, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202340 */   GIR_BuildMI, /*InsnID*//* 584(*/0xC8, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 202345 */   GIR_AddTempRegister, /*InsnID*//* 584(*/0xC8, 0x04/*)*/, /*TempRegID*//* 583(*/0xC7, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202352 */   GIR_AddSimpleTempRegister, /*InsnID*//* 584(*/0xC8, 0x04/*)*/, /*TempRegID*//* 584(*/0xC8, 0x04/*)*/,
     /* 202357 */   GIR_AddImm8, /*InsnID*//* 584(*/0xC8, 0x04/*)*/, /*Imm*/2,
     /* 202361 */   GIR_AddImm8, /*InsnID*//* 584(*/0xC8, 0x04/*)*/, /*Imm*/61,
     /* 202365 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 584(*/0xC8, 0x04/*)*/,
     /* 202368 */   GIR_MakeTempReg, /*TempRegID*//* 582(*/0xC6, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202372 */   GIR_BuildMI, /*InsnID*//* 583(*/0xC7, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 202377 */   GIR_AddTempRegister, /*InsnID*//* 583(*/0xC7, 0x04/*)*/, /*TempRegID*//* 582(*/0xC6, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202384 */   GIR_AddSimpleTempRegister, /*InsnID*//* 583(*/0xC7, 0x04/*)*/, /*TempRegID*//* 583(*/0xC7, 0x04/*)*/,
     /* 202389 */   GIR_AddSimpleTempRegister, /*InsnID*//* 583(*/0xC7, 0x04/*)*/, /*TempRegID*//* 603(*/0xDB, 0x04/*)*/,
     /* 202394 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 583(*/0xC7, 0x04/*)*/,
     /* 202397 */   GIR_MakeTempReg, /*TempRegID*//* 581(*/0xC5, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 202401 */   GIR_BuildMI, /*InsnID*//* 582(*/0xC6, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 202406 */   GIR_AddTempRegister, /*InsnID*//* 582(*/0xC6, 0x04/*)*/, /*TempRegID*//* 581(*/0xC5, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202413 */   GIR_AddImm, /*InsnID*//* 582(*/0xC6, 0x04/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 202424 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 582(*/0xC6, 0x04/*)*/,
     /* 202427 */   GIR_MakeTempReg, /*TempRegID*//* 580(*/0xC4, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 202431 */   GIR_BuildMI, /*InsnID*//* 581(*/0xC5, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 202436 */   GIR_AddTempRegister, /*InsnID*//* 581(*/0xC5, 0x04/*)*/, /*TempRegID*//* 580(*/0xC4, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202443 */   GIR_AddSimpleTempRegister, /*InsnID*//* 581(*/0xC5, 0x04/*)*/, /*TempRegID*//* 581(*/0xC5, 0x04/*)*/,
     /* 202448 */   GIR_AddImm, /*InsnID*//* 581(*/0xC5, 0x04/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 202459 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 581(*/0xC5, 0x04/*)*/,
     /* 202462 */   GIR_MakeTempReg, /*TempRegID*//* 579(*/0xC3, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202466 */   GIR_BuildMI, /*InsnID*//* 580(*/0xC4, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 202471 */   GIR_AddTempRegister, /*InsnID*//* 580(*/0xC4, 0x04/*)*/, /*TempRegID*//* 579(*/0xC3, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202478 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 580(*/0xC4, 0x04/*)*/,
     /* 202481 */   GIR_MakeTempReg, /*TempRegID*//* 578(*/0xC2, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202485 */   GIR_BuildMI, /*InsnID*//* 579(*/0xC3, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 202490 */   GIR_AddTempRegister, /*InsnID*//* 579(*/0xC3, 0x04/*)*/, /*TempRegID*//* 578(*/0xC2, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202497 */   GIR_AddSimpleTempRegister, /*InsnID*//* 579(*/0xC3, 0x04/*)*/, /*TempRegID*//* 579(*/0xC3, 0x04/*)*/,
     /* 202502 */   GIR_AddSimpleTempRegister, /*InsnID*//* 579(*/0xC3, 0x04/*)*/, /*TempRegID*//* 580(*/0xC4, 0x04/*)*/,
     /* 202507 */   GIR_AddImm8, /*InsnID*//* 579(*/0xC3, 0x04/*)*/, /*Imm*/1,
     /* 202511 */   GIR_ConstrainOperandRC, /*InsnID*//* 579(*/0xC3, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 202517 */   GIR_ConstrainOperandRC, /*InsnID*//* 579(*/0xC3, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 202523 */   GIR_ConstrainOperandRC, /*InsnID*//* 579(*/0xC3, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 202529 */   GIR_MakeTempReg, /*TempRegID*//* 577(*/0xC1, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202533 */   GIR_BuildMI, /*InsnID*//* 578(*/0xC2, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 202538 */   GIR_AddTempRegister, /*InsnID*//* 578(*/0xC2, 0x04/*)*/, /*TempRegID*//* 577(*/0xC1, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202545 */   GIR_AddSimpleTempRegister, /*InsnID*//* 578(*/0xC2, 0x04/*)*/, /*TempRegID*//* 578(*/0xC2, 0x04/*)*/,
     /* 202550 */   GIR_AddImm8, /*InsnID*//* 578(*/0xC2, 0x04/*)*/, /*Imm*/32,
     /* 202554 */   GIR_AddImm8, /*InsnID*//* 578(*/0xC2, 0x04/*)*/, /*Imm*/31,
     /* 202558 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 578(*/0xC2, 0x04/*)*/,
     /* 202561 */   GIR_MakeTempReg, /*TempRegID*//* 576(*/0xC0, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202565 */   GIR_BuildMI, /*InsnID*//* 577(*/0xC1, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 202570 */   GIR_AddTempRegister, /*InsnID*//* 577(*/0xC1, 0x04/*)*/, /*TempRegID*//* 576(*/0xC0, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202577 */   GIR_AddSimpleTempRegister, /*InsnID*//* 577(*/0xC1, 0x04/*)*/, /*TempRegID*//* 577(*/0xC1, 0x04/*)*/,
     /* 202582 */   GIR_AddImm, /*InsnID*//* 577(*/0xC1, 0x04/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 202593 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 577(*/0xC1, 0x04/*)*/,
     /* 202596 */   GIR_MakeTempReg, /*TempRegID*//* 575(*/0xBF, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202600 */   GIR_BuildMI, /*InsnID*//* 576(*/0xC0, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 202605 */   GIR_AddTempRegister, /*InsnID*//* 576(*/0xC0, 0x04/*)*/, /*TempRegID*//* 575(*/0xBF, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202612 */   GIR_AddSimpleTempRegister, /*InsnID*//* 576(*/0xC0, 0x04/*)*/, /*TempRegID*//* 576(*/0xC0, 0x04/*)*/,
     /* 202617 */   GIR_AddImm, /*InsnID*//* 576(*/0xC0, 0x04/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 202628 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 576(*/0xC0, 0x04/*)*/,
     /* 202631 */   GIR_MakeTempReg, /*TempRegID*//* 574(*/0xBE, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 202635 */   GIR_BuildMI, /*InsnID*//* 575(*/0xBF, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 202640 */   GIR_AddTempRegister, /*InsnID*//* 575(*/0xBF, 0x04/*)*/, /*TempRegID*//* 574(*/0xBE, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202647 */   GIR_AddImm, /*InsnID*//* 575(*/0xBF, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 202658 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 575(*/0xBF, 0x04/*)*/,
     /* 202661 */   GIR_MakeTempReg, /*TempRegID*//* 573(*/0xBD, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 202665 */   GIR_BuildMI, /*InsnID*//* 574(*/0xBE, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 202670 */   GIR_AddTempRegister, /*InsnID*//* 574(*/0xBE, 0x04/*)*/, /*TempRegID*//* 573(*/0xBD, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202677 */   GIR_AddSimpleTempRegister, /*InsnID*//* 574(*/0xBE, 0x04/*)*/, /*TempRegID*//* 574(*/0xBE, 0x04/*)*/,
     /* 202682 */   GIR_AddImm, /*InsnID*//* 574(*/0xBE, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 202693 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 574(*/0xBE, 0x04/*)*/,
     /* 202696 */   GIR_MakeTempReg, /*TempRegID*//* 572(*/0xBC, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202700 */   GIR_BuildMI, /*InsnID*//* 573(*/0xBD, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 202705 */   GIR_AddTempRegister, /*InsnID*//* 573(*/0xBD, 0x04/*)*/, /*TempRegID*//* 572(*/0xBC, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202712 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 573(*/0xBD, 0x04/*)*/,
     /* 202715 */   GIR_MakeTempReg, /*TempRegID*//* 571(*/0xBB, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202719 */   GIR_BuildMI, /*InsnID*//* 572(*/0xBC, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 202724 */   GIR_AddTempRegister, /*InsnID*//* 572(*/0xBC, 0x04/*)*/, /*TempRegID*//* 571(*/0xBB, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202731 */   GIR_AddSimpleTempRegister, /*InsnID*//* 572(*/0xBC, 0x04/*)*/, /*TempRegID*//* 572(*/0xBC, 0x04/*)*/,
     /* 202736 */   GIR_AddSimpleTempRegister, /*InsnID*//* 572(*/0xBC, 0x04/*)*/, /*TempRegID*//* 573(*/0xBD, 0x04/*)*/,
     /* 202741 */   GIR_AddImm8, /*InsnID*//* 572(*/0xBC, 0x04/*)*/, /*Imm*/1,
     /* 202745 */   GIR_ConstrainOperandRC, /*InsnID*//* 572(*/0xBC, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 202751 */   GIR_ConstrainOperandRC, /*InsnID*//* 572(*/0xBC, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 202757 */   GIR_ConstrainOperandRC, /*InsnID*//* 572(*/0xBC, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 202763 */   GIR_MakeTempReg, /*TempRegID*//* 570(*/0xBA, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202767 */   GIR_BuildMI, /*InsnID*//* 571(*/0xBB, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 202772 */   GIR_AddTempRegister, /*InsnID*//* 571(*/0xBB, 0x04/*)*/, /*TempRegID*//* 570(*/0xBA, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202779 */   GIR_AddSimpleTempRegister, /*InsnID*//* 571(*/0xBB, 0x04/*)*/, /*TempRegID*//* 571(*/0xBB, 0x04/*)*/,
     /* 202784 */   GIR_AddImm8, /*InsnID*//* 571(*/0xBB, 0x04/*)*/, /*Imm*/32,
     /* 202788 */   GIR_AddImm8, /*InsnID*//* 571(*/0xBB, 0x04/*)*/, /*Imm*/31,
     /* 202792 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 571(*/0xBB, 0x04/*)*/,
     /* 202795 */   GIR_MakeTempReg, /*TempRegID*//* 569(*/0xB9, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202799 */   GIR_BuildMI, /*InsnID*//* 570(*/0xBA, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 202804 */   GIR_AddTempRegister, /*InsnID*//* 570(*/0xBA, 0x04/*)*/, /*TempRegID*//* 569(*/0xB9, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202811 */   GIR_AddSimpleTempRegister, /*InsnID*//* 570(*/0xBA, 0x04/*)*/, /*TempRegID*//* 570(*/0xBA, 0x04/*)*/,
     /* 202816 */   GIR_AddImm, /*InsnID*//* 570(*/0xBA, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 202827 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 570(*/0xBA, 0x04/*)*/,
     /* 202830 */   GIR_MakeTempReg, /*TempRegID*//* 568(*/0xB8, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202834 */   GIR_BuildMI, /*InsnID*//* 569(*/0xB9, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 202839 */   GIR_AddTempRegister, /*InsnID*//* 569(*/0xB9, 0x04/*)*/, /*TempRegID*//* 568(*/0xB8, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202846 */   GIR_AddSimpleTempRegister, /*InsnID*//* 569(*/0xB9, 0x04/*)*/, /*TempRegID*//* 569(*/0xB9, 0x04/*)*/,
     /* 202851 */   GIR_AddImm, /*InsnID*//* 569(*/0xB9, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 202862 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 569(*/0xB9, 0x04/*)*/,
     /* 202865 */   GIR_MakeTempReg, /*TempRegID*//* 567(*/0xB7, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202869 */   GIR_BuildMI, /*InsnID*//* 568(*/0xB8, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 202874 */   GIR_AddTempRegister, /*InsnID*//* 568(*/0xB8, 0x04/*)*/, /*TempRegID*//* 567(*/0xB7, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202881 */   GIR_Copy, /*NewInsnID*//* 568(*/0xB8, 0x04/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 202886 */   GIR_AddImm8, /*InsnID*//* 568(*/0xB8, 0x04/*)*/, /*Imm*/1,
     /* 202890 */   GIR_AddImm8, /*InsnID*//* 568(*/0xB8, 0x04/*)*/, /*Imm*/62,
     /* 202894 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 568(*/0xB8, 0x04/*)*/,
     /* 202897 */   GIR_MakeTempReg, /*TempRegID*//* 566(*/0xB6, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202901 */   GIR_BuildMI, /*InsnID*//* 567(*/0xB7, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 202906 */   GIR_AddTempRegister, /*InsnID*//* 567(*/0xB7, 0x04/*)*/, /*TempRegID*//* 566(*/0xB6, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202913 */   GIR_AddSimpleTempRegister, /*InsnID*//* 567(*/0xB7, 0x04/*)*/, /*TempRegID*//* 567(*/0xB7, 0x04/*)*/,
     /* 202918 */   GIR_AddSimpleTempRegister, /*InsnID*//* 567(*/0xB7, 0x04/*)*/, /*TempRegID*//* 568(*/0xB8, 0x04/*)*/,
     /* 202923 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 567(*/0xB7, 0x04/*)*/,
     /* 202926 */   GIR_MakeTempReg, /*TempRegID*//* 565(*/0xB5, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 202930 */   GIR_BuildMI, /*InsnID*//* 566(*/0xB6, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 202935 */   GIR_AddTempRegister, /*InsnID*//* 566(*/0xB6, 0x04/*)*/, /*TempRegID*//* 565(*/0xB5, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202942 */   GIR_AddImm, /*InsnID*//* 566(*/0xB6, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 202953 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 566(*/0xB6, 0x04/*)*/,
     /* 202956 */   GIR_MakeTempReg, /*TempRegID*//* 564(*/0xB4, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 202960 */   GIR_BuildMI, /*InsnID*//* 565(*/0xB5, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 202965 */   GIR_AddTempRegister, /*InsnID*//* 565(*/0xB5, 0x04/*)*/, /*TempRegID*//* 564(*/0xB4, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202972 */   GIR_AddSimpleTempRegister, /*InsnID*//* 565(*/0xB5, 0x04/*)*/, /*TempRegID*//* 565(*/0xB5, 0x04/*)*/,
     /* 202977 */   GIR_AddImm, /*InsnID*//* 565(*/0xB5, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 202988 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 565(*/0xB5, 0x04/*)*/,
     /* 202991 */   GIR_MakeTempReg, /*TempRegID*//* 563(*/0xB3, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202995 */   GIR_BuildMI, /*InsnID*//* 564(*/0xB4, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 203000 */   GIR_AddTempRegister, /*InsnID*//* 564(*/0xB4, 0x04/*)*/, /*TempRegID*//* 563(*/0xB3, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203007 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 564(*/0xB4, 0x04/*)*/,
     /* 203010 */   GIR_MakeTempReg, /*TempRegID*//* 562(*/0xB2, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 203014 */   GIR_BuildMI, /*InsnID*//* 563(*/0xB3, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 203019 */   GIR_AddTempRegister, /*InsnID*//* 563(*/0xB3, 0x04/*)*/, /*TempRegID*//* 562(*/0xB2, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203026 */   GIR_AddSimpleTempRegister, /*InsnID*//* 563(*/0xB3, 0x04/*)*/, /*TempRegID*//* 563(*/0xB3, 0x04/*)*/,
     /* 203031 */   GIR_AddSimpleTempRegister, /*InsnID*//* 563(*/0xB3, 0x04/*)*/, /*TempRegID*//* 564(*/0xB4, 0x04/*)*/,
     /* 203036 */   GIR_AddImm8, /*InsnID*//* 563(*/0xB3, 0x04/*)*/, /*Imm*/1,
     /* 203040 */   GIR_ConstrainOperandRC, /*InsnID*//* 563(*/0xB3, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 203046 */   GIR_ConstrainOperandRC, /*InsnID*//* 563(*/0xB3, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 203052 */   GIR_ConstrainOperandRC, /*InsnID*//* 563(*/0xB3, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 203058 */   GIR_MakeTempReg, /*TempRegID*//* 561(*/0xB1, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 203062 */   GIR_BuildMI, /*InsnID*//* 562(*/0xB2, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 203067 */   GIR_AddTempRegister, /*InsnID*//* 562(*/0xB2, 0x04/*)*/, /*TempRegID*//* 561(*/0xB1, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203074 */   GIR_AddSimpleTempRegister, /*InsnID*//* 562(*/0xB2, 0x04/*)*/, /*TempRegID*//* 562(*/0xB2, 0x04/*)*/,
     /* 203079 */   GIR_AddImm8, /*InsnID*//* 562(*/0xB2, 0x04/*)*/, /*Imm*/32,
     /* 203083 */   GIR_AddImm8, /*InsnID*//* 562(*/0xB2, 0x04/*)*/, /*Imm*/31,
     /* 203087 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 562(*/0xB2, 0x04/*)*/,
     /* 203090 */   GIR_MakeTempReg, /*TempRegID*//* 560(*/0xB0, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 203094 */   GIR_BuildMI, /*InsnID*//* 561(*/0xB1, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 203099 */   GIR_AddTempRegister, /*InsnID*//* 561(*/0xB1, 0x04/*)*/, /*TempRegID*//* 560(*/0xB0, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203106 */   GIR_AddSimpleTempRegister, /*InsnID*//* 561(*/0xB1, 0x04/*)*/, /*TempRegID*//* 561(*/0xB1, 0x04/*)*/,
     /* 203111 */   GIR_AddImm, /*InsnID*//* 561(*/0xB1, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 203122 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 561(*/0xB1, 0x04/*)*/,
     /* 203125 */   GIR_MakeTempReg, /*TempRegID*//* 559(*/0xAF, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 203129 */   GIR_BuildMI, /*InsnID*//* 560(*/0xB0, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 203134 */   GIR_AddTempRegister, /*InsnID*//* 560(*/0xB0, 0x04/*)*/, /*TempRegID*//* 559(*/0xAF, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203141 */   GIR_AddSimpleTempRegister, /*InsnID*//* 560(*/0xB0, 0x04/*)*/, /*TempRegID*//* 560(*/0xB0, 0x04/*)*/,
     /* 203146 */   GIR_AddImm, /*InsnID*//* 560(*/0xB0, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 203157 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 560(*/0xB0, 0x04/*)*/,
     /* 203160 */   GIR_MakeTempReg, /*TempRegID*//* 558(*/0xAE, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 203164 */   GIR_BuildMI, /*InsnID*//* 559(*/0xAF, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 203169 */   GIR_AddTempRegister, /*InsnID*//* 559(*/0xAF, 0x04/*)*/, /*TempRegID*//* 558(*/0xAE, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203176 */   GIR_Copy, /*NewInsnID*//* 559(*/0xAF, 0x04/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 203181 */   GIR_AddImm8, /*InsnID*//* 559(*/0xAF, 0x04/*)*/, /*Imm*/63,
     /* 203185 */   GIR_AddImm8, /*InsnID*//* 559(*/0xAF, 0x04/*)*/, /*Imm*/1,
     /* 203189 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 559(*/0xAF, 0x04/*)*/,
     /* 203192 */   GIR_MakeTempReg, /*TempRegID*//* 557(*/0xAD, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 203196 */   GIR_BuildMI, /*InsnID*//* 558(*/0xAE, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 203201 */   GIR_AddTempRegister, /*InsnID*//* 558(*/0xAE, 0x04/*)*/, /*TempRegID*//* 557(*/0xAD, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203208 */   GIR_AddSimpleTempRegister, /*InsnID*//* 558(*/0xAE, 0x04/*)*/, /*TempRegID*//* 558(*/0xAE, 0x04/*)*/,
     /* 203213 */   GIR_AddSimpleTempRegister, /*InsnID*//* 558(*/0xAE, 0x04/*)*/, /*TempRegID*//* 559(*/0xAF, 0x04/*)*/,
     /* 203218 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 558(*/0xAE, 0x04/*)*/,
     /* 203221 */   GIR_MakeTempReg, /*TempRegID*//* 556(*/0xAC, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 203225 */   GIR_BuildMI, /*InsnID*//* 557(*/0xAD, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 203230 */   GIR_AddTempRegister, /*InsnID*//* 557(*/0xAD, 0x04/*)*/, /*TempRegID*//* 556(*/0xAC, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203237 */   GIR_AddSimpleTempRegister, /*InsnID*//* 557(*/0xAD, 0x04/*)*/, /*TempRegID*//* 557(*/0xAD, 0x04/*)*/,
     /* 203242 */   GIR_AddSimpleTempRegister, /*InsnID*//* 557(*/0xAD, 0x04/*)*/, /*TempRegID*//* 566(*/0xB6, 0x04/*)*/,
     /* 203247 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 557(*/0xAD, 0x04/*)*/,
     /* 203250 */   GIR_MakeTempReg, /*TempRegID*//* 555(*/0xAB, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 203254 */   GIR_BuildMI, /*InsnID*//* 556(*/0xAC, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 203259 */   GIR_AddTempRegister, /*InsnID*//* 556(*/0xAC, 0x04/*)*/, /*TempRegID*//* 555(*/0xAB, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203266 */   GIR_AddSimpleTempRegister, /*InsnID*//* 556(*/0xAC, 0x04/*)*/, /*TempRegID*//* 556(*/0xAC, 0x04/*)*/,
     /* 203271 */   GIR_AddImm8, /*InsnID*//* 556(*/0xAC, 0x04/*)*/, /*Imm*/62,
     /* 203275 */   GIR_AddImm8, /*InsnID*//* 556(*/0xAC, 0x04/*)*/, /*Imm*/2,
     /* 203279 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 556(*/0xAC, 0x04/*)*/,
     /* 203282 */   GIR_MakeTempReg, /*TempRegID*//* 554(*/0xAA, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 203286 */   GIR_BuildMI, /*InsnID*//* 555(*/0xAB, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 203291 */   GIR_AddTempRegister, /*InsnID*//* 555(*/0xAB, 0x04/*)*/, /*TempRegID*//* 554(*/0xAA, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203298 */   GIR_AddSimpleTempRegister, /*InsnID*//* 555(*/0xAB, 0x04/*)*/, /*TempRegID*//* 555(*/0xAB, 0x04/*)*/,
     /* 203303 */   GIR_AddSimpleTempRegister, /*InsnID*//* 555(*/0xAB, 0x04/*)*/, /*TempRegID*//* 575(*/0xBF, 0x04/*)*/,
     /* 203308 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 555(*/0xAB, 0x04/*)*/,
     /* 203311 */   GIR_MakeTempReg, /*TempRegID*//* 553(*/0xA9, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 203315 */   GIR_BuildMI, /*InsnID*//* 554(*/0xAA, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 203320 */   GIR_AddTempRegister, /*InsnID*//* 554(*/0xAA, 0x04/*)*/, /*TempRegID*//* 553(*/0xA9, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203327 */   GIR_AddSimpleTempRegister, /*InsnID*//* 554(*/0xAA, 0x04/*)*/, /*TempRegID*//* 554(*/0xAA, 0x04/*)*/,
     /* 203332 */   GIR_AddSimpleTempRegister, /*InsnID*//* 554(*/0xAA, 0x04/*)*/, /*TempRegID*//* 582(*/0xC6, 0x04/*)*/,
     /* 203337 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 554(*/0xAA, 0x04/*)*/,
     /* 203340 */   GIR_MakeTempReg, /*TempRegID*//* 552(*/0xA8, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 203344 */   GIR_BuildMI, /*InsnID*//* 553(*/0xA9, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 203349 */   GIR_AddTempRegister, /*InsnID*//* 553(*/0xA9, 0x04/*)*/, /*TempRegID*//* 552(*/0xA8, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203356 */   GIR_AddSimpleTempRegister, /*InsnID*//* 553(*/0xA9, 0x04/*)*/, /*TempRegID*//* 553(*/0xA9, 0x04/*)*/,
     /* 203361 */   GIR_AddImm8, /*InsnID*//* 553(*/0xA9, 0x04/*)*/, /*Imm*/60,
     /* 203365 */   GIR_AddImm8, /*InsnID*//* 553(*/0xA9, 0x04/*)*/, /*Imm*/4,
     /* 203369 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 553(*/0xA9, 0x04/*)*/,
     /* 203372 */   GIR_MakeTempReg, /*TempRegID*//* 551(*/0xA7, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 203376 */   GIR_BuildMI, /*InsnID*//* 552(*/0xA8, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 203381 */   GIR_AddTempRegister, /*InsnID*//* 552(*/0xA8, 0x04/*)*/, /*TempRegID*//* 551(*/0xA7, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203388 */   GIR_AddSimpleTempRegister, /*InsnID*//* 552(*/0xA8, 0x04/*)*/, /*TempRegID*//* 552(*/0xA8, 0x04/*)*/,
     /* 203393 */   GIR_AddSimpleTempRegister, /*InsnID*//* 552(*/0xA8, 0x04/*)*/, /*TempRegID*//* 610(*/0xE2, 0x04/*)*/,
     /* 203398 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 552(*/0xA8, 0x04/*)*/,
     /* 203401 */   GIR_MakeTempReg, /*TempRegID*//* 550(*/0xA6, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 203405 */   GIR_BuildMI, /*InsnID*//* 551(*/0xA7, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 203410 */   GIR_AddTempRegister, /*InsnID*//* 551(*/0xA7, 0x04/*)*/, /*TempRegID*//* 550(*/0xA6, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203417 */   GIR_AddSimpleTempRegister, /*InsnID*//* 551(*/0xA7, 0x04/*)*/, /*TempRegID*//* 551(*/0xA7, 0x04/*)*/,
     /* 203422 */   GIR_AddSimpleTempRegister, /*InsnID*//* 551(*/0xA7, 0x04/*)*/, /*TempRegID*//* 617(*/0xE9, 0x04/*)*/,
     /* 203427 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 551(*/0xA7, 0x04/*)*/,
     /* 203430 */   GIR_MakeTempReg, /*TempRegID*//* 549(*/0xA5, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 203434 */   GIR_BuildMI, /*InsnID*//* 550(*/0xA6, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 203439 */   GIR_AddTempRegister, /*InsnID*//* 550(*/0xA6, 0x04/*)*/, /*TempRegID*//* 549(*/0xA5, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203446 */   GIR_AddSimpleTempRegister, /*InsnID*//* 550(*/0xA6, 0x04/*)*/, /*TempRegID*//* 550(*/0xA6, 0x04/*)*/,
     /* 203451 */   GIR_AddImm8, /*InsnID*//* 550(*/0xA6, 0x04/*)*/, /*Imm*/32,
     /* 203455 */   GIR_AddImm8, /*InsnID*//* 550(*/0xA6, 0x04/*)*/, /*Imm*/32,
     /* 203459 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 550(*/0xA6, 0x04/*)*/,
     /* 203462 */   GIR_MakeTempReg, /*TempRegID*//* 817(*/0xB1, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 203466 */   GIR_BuildMI, /*InsnID*//* 818(*/0xB2, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 203471 */   GIR_AddTempRegister, /*InsnID*//* 818(*/0xB2, 0x06/*)*/, /*TempRegID*//* 817(*/0xB1, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203478 */   GIR_AddImm, /*InsnID*//* 818(*/0xB2, 0x06/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 203489 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 818(*/0xB2, 0x06/*)*/,
     /* 203492 */   GIR_MakeTempReg, /*TempRegID*//* 816(*/0xB0, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 203496 */   GIR_BuildMI, /*InsnID*//* 817(*/0xB1, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 203501 */   GIR_AddTempRegister, /*InsnID*//* 817(*/0xB1, 0x06/*)*/, /*TempRegID*//* 816(*/0xB0, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203508 */   GIR_AddSimpleTempRegister, /*InsnID*//* 817(*/0xB1, 0x06/*)*/, /*TempRegID*//* 817(*/0xB1, 0x06/*)*/,
     /* 203513 */   GIR_AddImm, /*InsnID*//* 817(*/0xB1, 0x06/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 203524 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 817(*/0xB1, 0x06/*)*/,
     /* 203527 */   GIR_MakeTempReg, /*TempRegID*//* 815(*/0xAF, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203531 */   GIR_BuildMI, /*InsnID*//* 816(*/0xB0, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 203536 */   GIR_AddTempRegister, /*InsnID*//* 816(*/0xB0, 0x06/*)*/, /*TempRegID*//* 815(*/0xAF, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203543 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 816(*/0xB0, 0x06/*)*/,
     /* 203546 */   GIR_MakeTempReg, /*TempRegID*//* 814(*/0xAE, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203550 */   GIR_BuildMI, /*InsnID*//* 815(*/0xAF, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 203555 */   GIR_AddTempRegister, /*InsnID*//* 815(*/0xAF, 0x06/*)*/, /*TempRegID*//* 814(*/0xAE, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203562 */   GIR_AddSimpleTempRegister, /*InsnID*//* 815(*/0xAF, 0x06/*)*/, /*TempRegID*//* 815(*/0xAF, 0x06/*)*/,
     /* 203567 */   GIR_AddSimpleTempRegister, /*InsnID*//* 815(*/0xAF, 0x06/*)*/, /*TempRegID*//* 816(*/0xB0, 0x06/*)*/,
     /* 203572 */   GIR_AddImm8, /*InsnID*//* 815(*/0xAF, 0x06/*)*/, /*Imm*/1,
     /* 203576 */   GIR_ConstrainOperandRC, /*InsnID*//* 815(*/0xAF, 0x06/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 203582 */   GIR_ConstrainOperandRC, /*InsnID*//* 815(*/0xAF, 0x06/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 203588 */   GIR_ConstrainOperandRC, /*InsnID*//* 815(*/0xAF, 0x06/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 203594 */   GIR_MakeTempReg, /*TempRegID*//* 813(*/0xAD, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203598 */   GIR_BuildMI, /*InsnID*//* 814(*/0xAE, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 203603 */   GIR_AddTempRegister, /*InsnID*//* 814(*/0xAE, 0x06/*)*/, /*TempRegID*//* 813(*/0xAD, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203610 */   GIR_AddSimpleTempRegister, /*InsnID*//* 814(*/0xAE, 0x06/*)*/, /*TempRegID*//* 814(*/0xAE, 0x06/*)*/,
     /* 203615 */   GIR_AddImm8, /*InsnID*//* 814(*/0xAE, 0x06/*)*/, /*Imm*/32,
     /* 203619 */   GIR_AddImm8, /*InsnID*//* 814(*/0xAE, 0x06/*)*/, /*Imm*/31,
     /* 203623 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 814(*/0xAE, 0x06/*)*/,
     /* 203626 */   GIR_MakeTempReg, /*TempRegID*//* 812(*/0xAC, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203630 */   GIR_BuildMI, /*InsnID*//* 813(*/0xAD, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 203635 */   GIR_AddTempRegister, /*InsnID*//* 813(*/0xAD, 0x06/*)*/, /*TempRegID*//* 812(*/0xAC, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203642 */   GIR_AddSimpleTempRegister, /*InsnID*//* 813(*/0xAD, 0x06/*)*/, /*TempRegID*//* 813(*/0xAD, 0x06/*)*/,
     /* 203647 */   GIR_AddImm, /*InsnID*//* 813(*/0xAD, 0x06/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 203658 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 813(*/0xAD, 0x06/*)*/,
     /* 203661 */   GIR_MakeTempReg, /*TempRegID*//* 811(*/0xAB, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203665 */   GIR_BuildMI, /*InsnID*//* 812(*/0xAC, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 203670 */   GIR_AddTempRegister, /*InsnID*//* 812(*/0xAC, 0x06/*)*/, /*TempRegID*//* 811(*/0xAB, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203677 */   GIR_AddSimpleTempRegister, /*InsnID*//* 812(*/0xAC, 0x06/*)*/, /*TempRegID*//* 812(*/0xAC, 0x06/*)*/,
     /* 203682 */   GIR_AddImm, /*InsnID*//* 812(*/0xAC, 0x06/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 203693 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 812(*/0xAC, 0x06/*)*/,
     /* 203696 */   GIR_MakeTempReg, /*TempRegID*//* 810(*/0xAA, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 203700 */   GIR_BuildMI, /*InsnID*//* 811(*/0xAB, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 203705 */   GIR_AddTempRegister, /*InsnID*//* 811(*/0xAB, 0x06/*)*/, /*TempRegID*//* 810(*/0xAA, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203712 */   GIR_AddImm, /*InsnID*//* 811(*/0xAB, 0x06/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 203723 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 811(*/0xAB, 0x06/*)*/,
     /* 203726 */   GIR_MakeTempReg, /*TempRegID*//* 809(*/0xA9, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 203730 */   GIR_BuildMI, /*InsnID*//* 810(*/0xAA, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 203735 */   GIR_AddTempRegister, /*InsnID*//* 810(*/0xAA, 0x06/*)*/, /*TempRegID*//* 809(*/0xA9, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203742 */   GIR_AddSimpleTempRegister, /*InsnID*//* 810(*/0xAA, 0x06/*)*/, /*TempRegID*//* 810(*/0xAA, 0x06/*)*/,
     /* 203747 */   GIR_AddImm, /*InsnID*//* 810(*/0xAA, 0x06/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 203758 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 810(*/0xAA, 0x06/*)*/,
     /* 203761 */   GIR_MakeTempReg, /*TempRegID*//* 808(*/0xA8, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203765 */   GIR_BuildMI, /*InsnID*//* 809(*/0xA9, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 203770 */   GIR_AddTempRegister, /*InsnID*//* 809(*/0xA9, 0x06/*)*/, /*TempRegID*//* 808(*/0xA8, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203777 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 809(*/0xA9, 0x06/*)*/,
     /* 203780 */   GIR_MakeTempReg, /*TempRegID*//* 807(*/0xA7, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203784 */   GIR_BuildMI, /*InsnID*//* 808(*/0xA8, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 203789 */   GIR_AddTempRegister, /*InsnID*//* 808(*/0xA8, 0x06/*)*/, /*TempRegID*//* 807(*/0xA7, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203796 */   GIR_AddSimpleTempRegister, /*InsnID*//* 808(*/0xA8, 0x06/*)*/, /*TempRegID*//* 808(*/0xA8, 0x06/*)*/,
     /* 203801 */   GIR_AddSimpleTempRegister, /*InsnID*//* 808(*/0xA8, 0x06/*)*/, /*TempRegID*//* 809(*/0xA9, 0x06/*)*/,
     /* 203806 */   GIR_AddImm8, /*InsnID*//* 808(*/0xA8, 0x06/*)*/, /*Imm*/1,
     /* 203810 */   GIR_ConstrainOperandRC, /*InsnID*//* 808(*/0xA8, 0x06/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 203816 */   GIR_ConstrainOperandRC, /*InsnID*//* 808(*/0xA8, 0x06/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 203822 */   GIR_ConstrainOperandRC, /*InsnID*//* 808(*/0xA8, 0x06/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 203828 */   GIR_MakeTempReg, /*TempRegID*//* 806(*/0xA6, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203832 */   GIR_BuildMI, /*InsnID*//* 807(*/0xA7, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 203837 */   GIR_AddTempRegister, /*InsnID*//* 807(*/0xA7, 0x06/*)*/, /*TempRegID*//* 806(*/0xA6, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203844 */   GIR_AddSimpleTempRegister, /*InsnID*//* 807(*/0xA7, 0x06/*)*/, /*TempRegID*//* 807(*/0xA7, 0x06/*)*/,
     /* 203849 */   GIR_AddImm8, /*InsnID*//* 807(*/0xA7, 0x06/*)*/, /*Imm*/32,
     /* 203853 */   GIR_AddImm8, /*InsnID*//* 807(*/0xA7, 0x06/*)*/, /*Imm*/31,
     /* 203857 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 807(*/0xA7, 0x06/*)*/,
     /* 203860 */   GIR_MakeTempReg, /*TempRegID*//* 805(*/0xA5, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203864 */   GIR_BuildMI, /*InsnID*//* 806(*/0xA6, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 203869 */   GIR_AddTempRegister, /*InsnID*//* 806(*/0xA6, 0x06/*)*/, /*TempRegID*//* 805(*/0xA5, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203876 */   GIR_AddSimpleTempRegister, /*InsnID*//* 806(*/0xA6, 0x06/*)*/, /*TempRegID*//* 806(*/0xA6, 0x06/*)*/,
     /* 203881 */   GIR_AddImm, /*InsnID*//* 806(*/0xA6, 0x06/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 203892 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 806(*/0xA6, 0x06/*)*/,
     /* 203895 */   GIR_MakeTempReg, /*TempRegID*//* 804(*/0xA4, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203899 */   GIR_BuildMI, /*InsnID*//* 805(*/0xA5, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 203904 */   GIR_AddTempRegister, /*InsnID*//* 805(*/0xA5, 0x06/*)*/, /*TempRegID*//* 804(*/0xA4, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203911 */   GIR_AddSimpleTempRegister, /*InsnID*//* 805(*/0xA5, 0x06/*)*/, /*TempRegID*//* 805(*/0xA5, 0x06/*)*/,
     /* 203916 */   GIR_AddImm, /*InsnID*//* 805(*/0xA5, 0x06/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 203927 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 805(*/0xA5, 0x06/*)*/,
     /* 203930 */   GIR_MakeTempReg, /*TempRegID*//* 803(*/0xA3, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 203934 */   GIR_BuildMI, /*InsnID*//* 804(*/0xA4, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 203939 */   GIR_AddTempRegister, /*InsnID*//* 804(*/0xA4, 0x06/*)*/, /*TempRegID*//* 803(*/0xA3, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203946 */   GIR_AddImm, /*InsnID*//* 804(*/0xA4, 0x06/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 203957 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 804(*/0xA4, 0x06/*)*/,
     /* 203960 */   GIR_MakeTempReg, /*TempRegID*//* 802(*/0xA2, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 203964 */   GIR_BuildMI, /*InsnID*//* 803(*/0xA3, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 203969 */   GIR_AddTempRegister, /*InsnID*//* 803(*/0xA3, 0x06/*)*/, /*TempRegID*//* 802(*/0xA2, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203976 */   GIR_AddSimpleTempRegister, /*InsnID*//* 803(*/0xA3, 0x06/*)*/, /*TempRegID*//* 803(*/0xA3, 0x06/*)*/,
     /* 203981 */   GIR_AddImm, /*InsnID*//* 803(*/0xA3, 0x06/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 203992 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 803(*/0xA3, 0x06/*)*/,
     /* 203995 */   GIR_MakeTempReg, /*TempRegID*//* 801(*/0xA1, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203999 */   GIR_BuildMI, /*InsnID*//* 802(*/0xA2, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 204004 */   GIR_AddTempRegister, /*InsnID*//* 802(*/0xA2, 0x06/*)*/, /*TempRegID*//* 801(*/0xA1, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204011 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 802(*/0xA2, 0x06/*)*/,
     /* 204014 */   GIR_MakeTempReg, /*TempRegID*//* 800(*/0xA0, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204018 */   GIR_BuildMI, /*InsnID*//* 801(*/0xA1, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 204023 */   GIR_AddTempRegister, /*InsnID*//* 801(*/0xA1, 0x06/*)*/, /*TempRegID*//* 800(*/0xA0, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204030 */   GIR_AddSimpleTempRegister, /*InsnID*//* 801(*/0xA1, 0x06/*)*/, /*TempRegID*//* 801(*/0xA1, 0x06/*)*/,
     /* 204035 */   GIR_AddSimpleTempRegister, /*InsnID*//* 801(*/0xA1, 0x06/*)*/, /*TempRegID*//* 802(*/0xA2, 0x06/*)*/,
     /* 204040 */   GIR_AddImm8, /*InsnID*//* 801(*/0xA1, 0x06/*)*/, /*Imm*/1,
     /* 204044 */   GIR_ConstrainOperandRC, /*InsnID*//* 801(*/0xA1, 0x06/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 204050 */   GIR_ConstrainOperandRC, /*InsnID*//* 801(*/0xA1, 0x06/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 204056 */   GIR_ConstrainOperandRC, /*InsnID*//* 801(*/0xA1, 0x06/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 204062 */   GIR_MakeTempReg, /*TempRegID*//* 799(*/0x9F, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204066 */   GIR_BuildMI, /*InsnID*//* 800(*/0xA0, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 204071 */   GIR_AddTempRegister, /*InsnID*//* 800(*/0xA0, 0x06/*)*/, /*TempRegID*//* 799(*/0x9F, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204078 */   GIR_AddSimpleTempRegister, /*InsnID*//* 800(*/0xA0, 0x06/*)*/, /*TempRegID*//* 800(*/0xA0, 0x06/*)*/,
     /* 204083 */   GIR_AddImm8, /*InsnID*//* 800(*/0xA0, 0x06/*)*/, /*Imm*/32,
     /* 204087 */   GIR_AddImm8, /*InsnID*//* 800(*/0xA0, 0x06/*)*/, /*Imm*/31,
     /* 204091 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 800(*/0xA0, 0x06/*)*/,
     /* 204094 */   GIR_MakeTempReg, /*TempRegID*//* 798(*/0x9E, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204098 */   GIR_BuildMI, /*InsnID*//* 799(*/0x9F, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 204103 */   GIR_AddTempRegister, /*InsnID*//* 799(*/0x9F, 0x06/*)*/, /*TempRegID*//* 798(*/0x9E, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204110 */   GIR_AddSimpleTempRegister, /*InsnID*//* 799(*/0x9F, 0x06/*)*/, /*TempRegID*//* 799(*/0x9F, 0x06/*)*/,
     /* 204115 */   GIR_AddImm, /*InsnID*//* 799(*/0x9F, 0x06/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 204126 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 799(*/0x9F, 0x06/*)*/,
     /* 204129 */   GIR_MakeTempReg, /*TempRegID*//* 797(*/0x9D, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204133 */   GIR_BuildMI, /*InsnID*//* 798(*/0x9E, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 204138 */   GIR_AddTempRegister, /*InsnID*//* 798(*/0x9E, 0x06/*)*/, /*TempRegID*//* 797(*/0x9D, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204145 */   GIR_AddSimpleTempRegister, /*InsnID*//* 798(*/0x9E, 0x06/*)*/, /*TempRegID*//* 798(*/0x9E, 0x06/*)*/,
     /* 204150 */   GIR_AddImm, /*InsnID*//* 798(*/0x9E, 0x06/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 204161 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 798(*/0x9E, 0x06/*)*/,
     /* 204164 */   GIR_MakeTempReg, /*TempRegID*//* 796(*/0x9C, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204168 */   GIR_BuildMI, /*InsnID*//* 797(*/0x9D, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 204173 */   GIR_AddTempRegister, /*InsnID*//* 797(*/0x9D, 0x06/*)*/, /*TempRegID*//* 796(*/0x9C, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204180 */   GIR_Copy, /*NewInsnID*//* 797(*/0x9D, 0x06/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 204185 */   GIR_AddImm8, /*InsnID*//* 797(*/0x9D, 0x06/*)*/, /*Imm*/1,
     /* 204189 */   GIR_AddImm8, /*InsnID*//* 797(*/0x9D, 0x06/*)*/, /*Imm*/62,
     /* 204193 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 797(*/0x9D, 0x06/*)*/,
     /* 204196 */   GIR_MakeTempReg, /*TempRegID*//* 795(*/0x9B, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204200 */   GIR_BuildMI, /*InsnID*//* 796(*/0x9C, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 204205 */   GIR_AddTempRegister, /*InsnID*//* 796(*/0x9C, 0x06/*)*/, /*TempRegID*//* 795(*/0x9B, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204212 */   GIR_AddSimpleTempRegister, /*InsnID*//* 796(*/0x9C, 0x06/*)*/, /*TempRegID*//* 796(*/0x9C, 0x06/*)*/,
     /* 204217 */   GIR_AddSimpleTempRegister, /*InsnID*//* 796(*/0x9C, 0x06/*)*/, /*TempRegID*//* 797(*/0x9D, 0x06/*)*/,
     /* 204222 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 796(*/0x9C, 0x06/*)*/,
     /* 204225 */   GIR_MakeTempReg, /*TempRegID*//* 794(*/0x9A, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 204229 */   GIR_BuildMI, /*InsnID*//* 795(*/0x9B, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 204234 */   GIR_AddTempRegister, /*InsnID*//* 795(*/0x9B, 0x06/*)*/, /*TempRegID*//* 794(*/0x9A, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204241 */   GIR_AddImm, /*InsnID*//* 795(*/0x9B, 0x06/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 204252 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 795(*/0x9B, 0x06/*)*/,
     /* 204255 */   GIR_MakeTempReg, /*TempRegID*//* 793(*/0x99, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 204259 */   GIR_BuildMI, /*InsnID*//* 794(*/0x9A, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 204264 */   GIR_AddTempRegister, /*InsnID*//* 794(*/0x9A, 0x06/*)*/, /*TempRegID*//* 793(*/0x99, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204271 */   GIR_AddSimpleTempRegister, /*InsnID*//* 794(*/0x9A, 0x06/*)*/, /*TempRegID*//* 794(*/0x9A, 0x06/*)*/,
     /* 204276 */   GIR_AddImm, /*InsnID*//* 794(*/0x9A, 0x06/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 204287 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 794(*/0x9A, 0x06/*)*/,
     /* 204290 */   GIR_MakeTempReg, /*TempRegID*//* 792(*/0x98, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204294 */   GIR_BuildMI, /*InsnID*//* 793(*/0x99, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 204299 */   GIR_AddTempRegister, /*InsnID*//* 793(*/0x99, 0x06/*)*/, /*TempRegID*//* 792(*/0x98, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204306 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 793(*/0x99, 0x06/*)*/,
     /* 204309 */   GIR_MakeTempReg, /*TempRegID*//* 791(*/0x97, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204313 */   GIR_BuildMI, /*InsnID*//* 792(*/0x98, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 204318 */   GIR_AddTempRegister, /*InsnID*//* 792(*/0x98, 0x06/*)*/, /*TempRegID*//* 791(*/0x97, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204325 */   GIR_AddSimpleTempRegister, /*InsnID*//* 792(*/0x98, 0x06/*)*/, /*TempRegID*//* 792(*/0x98, 0x06/*)*/,
     /* 204330 */   GIR_AddSimpleTempRegister, /*InsnID*//* 792(*/0x98, 0x06/*)*/, /*TempRegID*//* 793(*/0x99, 0x06/*)*/,
     /* 204335 */   GIR_AddImm8, /*InsnID*//* 792(*/0x98, 0x06/*)*/, /*Imm*/1,
     /* 204339 */   GIR_ConstrainOperandRC, /*InsnID*//* 792(*/0x98, 0x06/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 204345 */   GIR_ConstrainOperandRC, /*InsnID*//* 792(*/0x98, 0x06/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 204351 */   GIR_ConstrainOperandRC, /*InsnID*//* 792(*/0x98, 0x06/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 204357 */   GIR_MakeTempReg, /*TempRegID*//* 790(*/0x96, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204361 */   GIR_BuildMI, /*InsnID*//* 791(*/0x97, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 204366 */   GIR_AddTempRegister, /*InsnID*//* 791(*/0x97, 0x06/*)*/, /*TempRegID*//* 790(*/0x96, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204373 */   GIR_AddSimpleTempRegister, /*InsnID*//* 791(*/0x97, 0x06/*)*/, /*TempRegID*//* 791(*/0x97, 0x06/*)*/,
     /* 204378 */   GIR_AddImm8, /*InsnID*//* 791(*/0x97, 0x06/*)*/, /*Imm*/32,
     /* 204382 */   GIR_AddImm8, /*InsnID*//* 791(*/0x97, 0x06/*)*/, /*Imm*/31,
     /* 204386 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 791(*/0x97, 0x06/*)*/,
     /* 204389 */   GIR_MakeTempReg, /*TempRegID*//* 789(*/0x95, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204393 */   GIR_BuildMI, /*InsnID*//* 790(*/0x96, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 204398 */   GIR_AddTempRegister, /*InsnID*//* 790(*/0x96, 0x06/*)*/, /*TempRegID*//* 789(*/0x95, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204405 */   GIR_AddSimpleTempRegister, /*InsnID*//* 790(*/0x96, 0x06/*)*/, /*TempRegID*//* 790(*/0x96, 0x06/*)*/,
     /* 204410 */   GIR_AddImm, /*InsnID*//* 790(*/0x96, 0x06/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 204421 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 790(*/0x96, 0x06/*)*/,
     /* 204424 */   GIR_MakeTempReg, /*TempRegID*//* 788(*/0x94, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204428 */   GIR_BuildMI, /*InsnID*//* 789(*/0x95, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 204433 */   GIR_AddTempRegister, /*InsnID*//* 789(*/0x95, 0x06/*)*/, /*TempRegID*//* 788(*/0x94, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204440 */   GIR_AddSimpleTempRegister, /*InsnID*//* 789(*/0x95, 0x06/*)*/, /*TempRegID*//* 789(*/0x95, 0x06/*)*/,
     /* 204445 */   GIR_AddImm, /*InsnID*//* 789(*/0x95, 0x06/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 204456 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 789(*/0x95, 0x06/*)*/,
     /* 204459 */   GIR_MakeTempReg, /*TempRegID*//* 787(*/0x93, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204463 */   GIR_BuildMI, /*InsnID*//* 788(*/0x94, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 204468 */   GIR_AddTempRegister, /*InsnID*//* 788(*/0x94, 0x06/*)*/, /*TempRegID*//* 787(*/0x93, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204475 */   GIR_Copy, /*NewInsnID*//* 788(*/0x94, 0x06/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 204480 */   GIR_AddImm8, /*InsnID*//* 788(*/0x94, 0x06/*)*/, /*Imm*/63,
     /* 204484 */   GIR_AddImm8, /*InsnID*//* 788(*/0x94, 0x06/*)*/, /*Imm*/1,
     /* 204488 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 788(*/0x94, 0x06/*)*/,
     /* 204491 */   GIR_MakeTempReg, /*TempRegID*//* 786(*/0x92, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204495 */   GIR_BuildMI, /*InsnID*//* 787(*/0x93, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 204500 */   GIR_AddTempRegister, /*InsnID*//* 787(*/0x93, 0x06/*)*/, /*TempRegID*//* 786(*/0x92, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204507 */   GIR_AddSimpleTempRegister, /*InsnID*//* 787(*/0x93, 0x06/*)*/, /*TempRegID*//* 787(*/0x93, 0x06/*)*/,
     /* 204512 */   GIR_AddSimpleTempRegister, /*InsnID*//* 787(*/0x93, 0x06/*)*/, /*TempRegID*//* 788(*/0x94, 0x06/*)*/,
     /* 204517 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 787(*/0x93, 0x06/*)*/,
     /* 204520 */   GIR_MakeTempReg, /*TempRegID*//* 785(*/0x91, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204524 */   GIR_BuildMI, /*InsnID*//* 786(*/0x92, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 204529 */   GIR_AddTempRegister, /*InsnID*//* 786(*/0x92, 0x06/*)*/, /*TempRegID*//* 785(*/0x91, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204536 */   GIR_AddSimpleTempRegister, /*InsnID*//* 786(*/0x92, 0x06/*)*/, /*TempRegID*//* 786(*/0x92, 0x06/*)*/,
     /* 204541 */   GIR_AddSimpleTempRegister, /*InsnID*//* 786(*/0x92, 0x06/*)*/, /*TempRegID*//* 795(*/0x9B, 0x06/*)*/,
     /* 204546 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 786(*/0x92, 0x06/*)*/,
     /* 204549 */   GIR_MakeTempReg, /*TempRegID*//* 784(*/0x90, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204553 */   GIR_BuildMI, /*InsnID*//* 785(*/0x91, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 204558 */   GIR_AddTempRegister, /*InsnID*//* 785(*/0x91, 0x06/*)*/, /*TempRegID*//* 784(*/0x90, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204565 */   GIR_AddSimpleTempRegister, /*InsnID*//* 785(*/0x91, 0x06/*)*/, /*TempRegID*//* 785(*/0x91, 0x06/*)*/,
     /* 204570 */   GIR_AddImm8, /*InsnID*//* 785(*/0x91, 0x06/*)*/, /*Imm*/2,
     /* 204574 */   GIR_AddImm8, /*InsnID*//* 785(*/0x91, 0x06/*)*/, /*Imm*/61,
     /* 204578 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 785(*/0x91, 0x06/*)*/,
     /* 204581 */   GIR_MakeTempReg, /*TempRegID*//* 783(*/0x8F, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204585 */   GIR_BuildMI, /*InsnID*//* 784(*/0x90, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 204590 */   GIR_AddTempRegister, /*InsnID*//* 784(*/0x90, 0x06/*)*/, /*TempRegID*//* 783(*/0x8F, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204597 */   GIR_AddSimpleTempRegister, /*InsnID*//* 784(*/0x90, 0x06/*)*/, /*TempRegID*//* 784(*/0x90, 0x06/*)*/,
     /* 204602 */   GIR_AddSimpleTempRegister, /*InsnID*//* 784(*/0x90, 0x06/*)*/, /*TempRegID*//* 804(*/0xA4, 0x06/*)*/,
     /* 204607 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 784(*/0x90, 0x06/*)*/,
     /* 204610 */   GIR_MakeTempReg, /*TempRegID*//* 782(*/0x8E, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 204614 */   GIR_BuildMI, /*InsnID*//* 783(*/0x8F, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 204619 */   GIR_AddTempRegister, /*InsnID*//* 783(*/0x8F, 0x06/*)*/, /*TempRegID*//* 782(*/0x8E, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204626 */   GIR_AddImm, /*InsnID*//* 783(*/0x8F, 0x06/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 204637 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 783(*/0x8F, 0x06/*)*/,
     /* 204640 */   GIR_MakeTempReg, /*TempRegID*//* 781(*/0x8D, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 204644 */   GIR_BuildMI, /*InsnID*//* 782(*/0x8E, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 204649 */   GIR_AddTempRegister, /*InsnID*//* 782(*/0x8E, 0x06/*)*/, /*TempRegID*//* 781(*/0x8D, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204656 */   GIR_AddSimpleTempRegister, /*InsnID*//* 782(*/0x8E, 0x06/*)*/, /*TempRegID*//* 782(*/0x8E, 0x06/*)*/,
     /* 204661 */   GIR_AddImm, /*InsnID*//* 782(*/0x8E, 0x06/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 204672 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 782(*/0x8E, 0x06/*)*/,
     /* 204675 */   GIR_MakeTempReg, /*TempRegID*//* 780(*/0x8C, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204679 */   GIR_BuildMI, /*InsnID*//* 781(*/0x8D, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 204684 */   GIR_AddTempRegister, /*InsnID*//* 781(*/0x8D, 0x06/*)*/, /*TempRegID*//* 780(*/0x8C, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204691 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 781(*/0x8D, 0x06/*)*/,
     /* 204694 */   GIR_MakeTempReg, /*TempRegID*//* 779(*/0x8B, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204698 */   GIR_BuildMI, /*InsnID*//* 780(*/0x8C, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 204703 */   GIR_AddTempRegister, /*InsnID*//* 780(*/0x8C, 0x06/*)*/, /*TempRegID*//* 779(*/0x8B, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204710 */   GIR_AddSimpleTempRegister, /*InsnID*//* 780(*/0x8C, 0x06/*)*/, /*TempRegID*//* 780(*/0x8C, 0x06/*)*/,
     /* 204715 */   GIR_AddSimpleTempRegister, /*InsnID*//* 780(*/0x8C, 0x06/*)*/, /*TempRegID*//* 781(*/0x8D, 0x06/*)*/,
     /* 204720 */   GIR_AddImm8, /*InsnID*//* 780(*/0x8C, 0x06/*)*/, /*Imm*/1,
     /* 204724 */   GIR_ConstrainOperandRC, /*InsnID*//* 780(*/0x8C, 0x06/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 204730 */   GIR_ConstrainOperandRC, /*InsnID*//* 780(*/0x8C, 0x06/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 204736 */   GIR_ConstrainOperandRC, /*InsnID*//* 780(*/0x8C, 0x06/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 204742 */   GIR_MakeTempReg, /*TempRegID*//* 778(*/0x8A, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204746 */   GIR_BuildMI, /*InsnID*//* 779(*/0x8B, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 204751 */   GIR_AddTempRegister, /*InsnID*//* 779(*/0x8B, 0x06/*)*/, /*TempRegID*//* 778(*/0x8A, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204758 */   GIR_AddSimpleTempRegister, /*InsnID*//* 779(*/0x8B, 0x06/*)*/, /*TempRegID*//* 779(*/0x8B, 0x06/*)*/,
     /* 204763 */   GIR_AddImm8, /*InsnID*//* 779(*/0x8B, 0x06/*)*/, /*Imm*/32,
     /* 204767 */   GIR_AddImm8, /*InsnID*//* 779(*/0x8B, 0x06/*)*/, /*Imm*/31,
     /* 204771 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 779(*/0x8B, 0x06/*)*/,
     /* 204774 */   GIR_MakeTempReg, /*TempRegID*//* 777(*/0x89, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204778 */   GIR_BuildMI, /*InsnID*//* 778(*/0x8A, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 204783 */   GIR_AddTempRegister, /*InsnID*//* 778(*/0x8A, 0x06/*)*/, /*TempRegID*//* 777(*/0x89, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204790 */   GIR_AddSimpleTempRegister, /*InsnID*//* 778(*/0x8A, 0x06/*)*/, /*TempRegID*//* 778(*/0x8A, 0x06/*)*/,
     /* 204795 */   GIR_AddImm, /*InsnID*//* 778(*/0x8A, 0x06/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 204806 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 778(*/0x8A, 0x06/*)*/,
     /* 204809 */   GIR_MakeTempReg, /*TempRegID*//* 776(*/0x88, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204813 */   GIR_BuildMI, /*InsnID*//* 777(*/0x89, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 204818 */   GIR_AddTempRegister, /*InsnID*//* 777(*/0x89, 0x06/*)*/, /*TempRegID*//* 776(*/0x88, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204825 */   GIR_AddSimpleTempRegister, /*InsnID*//* 777(*/0x89, 0x06/*)*/, /*TempRegID*//* 777(*/0x89, 0x06/*)*/,
     /* 204830 */   GIR_AddImm, /*InsnID*//* 777(*/0x89, 0x06/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 204841 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 777(*/0x89, 0x06/*)*/,
     /* 204844 */   GIR_MakeTempReg, /*TempRegID*//* 775(*/0x87, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 204848 */   GIR_BuildMI, /*InsnID*//* 776(*/0x88, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 204853 */   GIR_AddTempRegister, /*InsnID*//* 776(*/0x88, 0x06/*)*/, /*TempRegID*//* 775(*/0x87, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204860 */   GIR_AddImm, /*InsnID*//* 776(*/0x88, 0x06/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 204871 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 776(*/0x88, 0x06/*)*/,
     /* 204874 */   GIR_MakeTempReg, /*TempRegID*//* 774(*/0x86, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 204878 */   GIR_BuildMI, /*InsnID*//* 775(*/0x87, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 204883 */   GIR_AddTempRegister, /*InsnID*//* 775(*/0x87, 0x06/*)*/, /*TempRegID*//* 774(*/0x86, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204890 */   GIR_AddSimpleTempRegister, /*InsnID*//* 775(*/0x87, 0x06/*)*/, /*TempRegID*//* 775(*/0x87, 0x06/*)*/,
     /* 204895 */   GIR_AddImm, /*InsnID*//* 775(*/0x87, 0x06/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 204906 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 775(*/0x87, 0x06/*)*/,
     /* 204909 */   GIR_MakeTempReg, /*TempRegID*//* 773(*/0x85, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204913 */   GIR_BuildMI, /*InsnID*//* 774(*/0x86, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 204918 */   GIR_AddTempRegister, /*InsnID*//* 774(*/0x86, 0x06/*)*/, /*TempRegID*//* 773(*/0x85, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204925 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 774(*/0x86, 0x06/*)*/,
     /* 204928 */   GIR_MakeTempReg, /*TempRegID*//* 772(*/0x84, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204932 */   GIR_BuildMI, /*InsnID*//* 773(*/0x85, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 204937 */   GIR_AddTempRegister, /*InsnID*//* 773(*/0x85, 0x06/*)*/, /*TempRegID*//* 772(*/0x84, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204944 */   GIR_AddSimpleTempRegister, /*InsnID*//* 773(*/0x85, 0x06/*)*/, /*TempRegID*//* 773(*/0x85, 0x06/*)*/,
     /* 204949 */   GIR_AddSimpleTempRegister, /*InsnID*//* 773(*/0x85, 0x06/*)*/, /*TempRegID*//* 774(*/0x86, 0x06/*)*/,
     /* 204954 */   GIR_AddImm8, /*InsnID*//* 773(*/0x85, 0x06/*)*/, /*Imm*/1,
     /* 204958 */   GIR_ConstrainOperandRC, /*InsnID*//* 773(*/0x85, 0x06/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 204964 */   GIR_ConstrainOperandRC, /*InsnID*//* 773(*/0x85, 0x06/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 204970 */   GIR_ConstrainOperandRC, /*InsnID*//* 773(*/0x85, 0x06/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 204976 */   GIR_MakeTempReg, /*TempRegID*//* 771(*/0x83, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204980 */   GIR_BuildMI, /*InsnID*//* 772(*/0x84, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 204985 */   GIR_AddTempRegister, /*InsnID*//* 772(*/0x84, 0x06/*)*/, /*TempRegID*//* 771(*/0x83, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204992 */   GIR_AddSimpleTempRegister, /*InsnID*//* 772(*/0x84, 0x06/*)*/, /*TempRegID*//* 772(*/0x84, 0x06/*)*/,
     /* 204997 */   GIR_AddImm8, /*InsnID*//* 772(*/0x84, 0x06/*)*/, /*Imm*/32,
     /* 205001 */   GIR_AddImm8, /*InsnID*//* 772(*/0x84, 0x06/*)*/, /*Imm*/31,
     /* 205005 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 772(*/0x84, 0x06/*)*/,
     /* 205008 */   GIR_MakeTempReg, /*TempRegID*//* 770(*/0x82, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 205012 */   GIR_BuildMI, /*InsnID*//* 771(*/0x83, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 205017 */   GIR_AddTempRegister, /*InsnID*//* 771(*/0x83, 0x06/*)*/, /*TempRegID*//* 770(*/0x82, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205024 */   GIR_AddSimpleTempRegister, /*InsnID*//* 771(*/0x83, 0x06/*)*/, /*TempRegID*//* 771(*/0x83, 0x06/*)*/,
     /* 205029 */   GIR_AddImm, /*InsnID*//* 771(*/0x83, 0x06/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 205040 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 771(*/0x83, 0x06/*)*/,
     /* 205043 */   GIR_MakeTempReg, /*TempRegID*//* 769(*/0x81, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 205047 */   GIR_BuildMI, /*InsnID*//* 770(*/0x82, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 205052 */   GIR_AddTempRegister, /*InsnID*//* 770(*/0x82, 0x06/*)*/, /*TempRegID*//* 769(*/0x81, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205059 */   GIR_AddSimpleTempRegister, /*InsnID*//* 770(*/0x82, 0x06/*)*/, /*TempRegID*//* 770(*/0x82, 0x06/*)*/,
     /* 205064 */   GIR_AddImm, /*InsnID*//* 770(*/0x82, 0x06/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 205075 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 770(*/0x82, 0x06/*)*/,
     /* 205078 */   GIR_MakeTempReg, /*TempRegID*//* 768(*/0x80, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 205082 */   GIR_BuildMI, /*InsnID*//* 769(*/0x81, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 205087 */   GIR_AddTempRegister, /*InsnID*//* 769(*/0x81, 0x06/*)*/, /*TempRegID*//* 768(*/0x80, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205094 */   GIR_Copy, /*NewInsnID*//* 769(*/0x81, 0x06/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 205099 */   GIR_AddImm8, /*InsnID*//* 769(*/0x81, 0x06/*)*/, /*Imm*/1,
     /* 205103 */   GIR_AddImm8, /*InsnID*//* 769(*/0x81, 0x06/*)*/, /*Imm*/62,
     /* 205107 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 769(*/0x81, 0x06/*)*/,
     /* 205110 */   GIR_MakeTempReg, /*TempRegID*//* 767(*/0xFF, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205114 */   GIR_BuildMI, /*InsnID*//* 768(*/0x80, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 205119 */   GIR_AddTempRegister, /*InsnID*//* 768(*/0x80, 0x06/*)*/, /*TempRegID*//* 767(*/0xFF, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205126 */   GIR_AddSimpleTempRegister, /*InsnID*//* 768(*/0x80, 0x06/*)*/, /*TempRegID*//* 768(*/0x80, 0x06/*)*/,
     /* 205131 */   GIR_AddSimpleTempRegister, /*InsnID*//* 768(*/0x80, 0x06/*)*/, /*TempRegID*//* 769(*/0x81, 0x06/*)*/,
     /* 205136 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 768(*/0x80, 0x06/*)*/,
     /* 205139 */   GIR_MakeTempReg, /*TempRegID*//* 766(*/0xFE, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 205143 */   GIR_BuildMI, /*InsnID*//* 767(*/0xFF, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 205148 */   GIR_AddTempRegister, /*InsnID*//* 767(*/0xFF, 0x05/*)*/, /*TempRegID*//* 766(*/0xFE, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205155 */   GIR_AddImm, /*InsnID*//* 767(*/0xFF, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 205166 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 767(*/0xFF, 0x05/*)*/,
     /* 205169 */   GIR_MakeTempReg, /*TempRegID*//* 765(*/0xFD, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 205173 */   GIR_BuildMI, /*InsnID*//* 766(*/0xFE, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 205178 */   GIR_AddTempRegister, /*InsnID*//* 766(*/0xFE, 0x05/*)*/, /*TempRegID*//* 765(*/0xFD, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205185 */   GIR_AddSimpleTempRegister, /*InsnID*//* 766(*/0xFE, 0x05/*)*/, /*TempRegID*//* 766(*/0xFE, 0x05/*)*/,
     /* 205190 */   GIR_AddImm, /*InsnID*//* 766(*/0xFE, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 205201 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 766(*/0xFE, 0x05/*)*/,
     /* 205204 */   GIR_MakeTempReg, /*TempRegID*//* 764(*/0xFC, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205208 */   GIR_BuildMI, /*InsnID*//* 765(*/0xFD, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 205213 */   GIR_AddTempRegister, /*InsnID*//* 765(*/0xFD, 0x05/*)*/, /*TempRegID*//* 764(*/0xFC, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205220 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 765(*/0xFD, 0x05/*)*/,
     /* 205223 */   GIR_MakeTempReg, /*TempRegID*//* 763(*/0xFB, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205227 */   GIR_BuildMI, /*InsnID*//* 764(*/0xFC, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 205232 */   GIR_AddTempRegister, /*InsnID*//* 764(*/0xFC, 0x05/*)*/, /*TempRegID*//* 763(*/0xFB, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205239 */   GIR_AddSimpleTempRegister, /*InsnID*//* 764(*/0xFC, 0x05/*)*/, /*TempRegID*//* 764(*/0xFC, 0x05/*)*/,
     /* 205244 */   GIR_AddSimpleTempRegister, /*InsnID*//* 764(*/0xFC, 0x05/*)*/, /*TempRegID*//* 765(*/0xFD, 0x05/*)*/,
     /* 205249 */   GIR_AddImm8, /*InsnID*//* 764(*/0xFC, 0x05/*)*/, /*Imm*/1,
     /* 205253 */   GIR_ConstrainOperandRC, /*InsnID*//* 764(*/0xFC, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 205259 */   GIR_ConstrainOperandRC, /*InsnID*//* 764(*/0xFC, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 205265 */   GIR_ConstrainOperandRC, /*InsnID*//* 764(*/0xFC, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 205271 */   GIR_MakeTempReg, /*TempRegID*//* 762(*/0xFA, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205275 */   GIR_BuildMI, /*InsnID*//* 763(*/0xFB, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 205280 */   GIR_AddTempRegister, /*InsnID*//* 763(*/0xFB, 0x05/*)*/, /*TempRegID*//* 762(*/0xFA, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205287 */   GIR_AddSimpleTempRegister, /*InsnID*//* 763(*/0xFB, 0x05/*)*/, /*TempRegID*//* 763(*/0xFB, 0x05/*)*/,
     /* 205292 */   GIR_AddImm8, /*InsnID*//* 763(*/0xFB, 0x05/*)*/, /*Imm*/32,
     /* 205296 */   GIR_AddImm8, /*InsnID*//* 763(*/0xFB, 0x05/*)*/, /*Imm*/31,
     /* 205300 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 763(*/0xFB, 0x05/*)*/,
     /* 205303 */   GIR_MakeTempReg, /*TempRegID*//* 761(*/0xF9, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205307 */   GIR_BuildMI, /*InsnID*//* 762(*/0xFA, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 205312 */   GIR_AddTempRegister, /*InsnID*//* 762(*/0xFA, 0x05/*)*/, /*TempRegID*//* 761(*/0xF9, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205319 */   GIR_AddSimpleTempRegister, /*InsnID*//* 762(*/0xFA, 0x05/*)*/, /*TempRegID*//* 762(*/0xFA, 0x05/*)*/,
     /* 205324 */   GIR_AddImm, /*InsnID*//* 762(*/0xFA, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 205335 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 762(*/0xFA, 0x05/*)*/,
     /* 205338 */   GIR_MakeTempReg, /*TempRegID*//* 760(*/0xF8, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205342 */   GIR_BuildMI, /*InsnID*//* 761(*/0xF9, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 205347 */   GIR_AddTempRegister, /*InsnID*//* 761(*/0xF9, 0x05/*)*/, /*TempRegID*//* 760(*/0xF8, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205354 */   GIR_AddSimpleTempRegister, /*InsnID*//* 761(*/0xF9, 0x05/*)*/, /*TempRegID*//* 761(*/0xF9, 0x05/*)*/,
     /* 205359 */   GIR_AddImm, /*InsnID*//* 761(*/0xF9, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 205370 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 761(*/0xF9, 0x05/*)*/,
     /* 205373 */   GIR_MakeTempReg, /*TempRegID*//* 759(*/0xF7, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205377 */   GIR_BuildMI, /*InsnID*//* 760(*/0xF8, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 205382 */   GIR_AddTempRegister, /*InsnID*//* 760(*/0xF8, 0x05/*)*/, /*TempRegID*//* 759(*/0xF7, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205389 */   GIR_Copy, /*NewInsnID*//* 760(*/0xF8, 0x05/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 205394 */   GIR_AddImm8, /*InsnID*//* 760(*/0xF8, 0x05/*)*/, /*Imm*/63,
     /* 205398 */   GIR_AddImm8, /*InsnID*//* 760(*/0xF8, 0x05/*)*/, /*Imm*/1,
     /* 205402 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 760(*/0xF8, 0x05/*)*/,
     /* 205405 */   GIR_MakeTempReg, /*TempRegID*//* 758(*/0xF6, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205409 */   GIR_BuildMI, /*InsnID*//* 759(*/0xF7, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 205414 */   GIR_AddTempRegister, /*InsnID*//* 759(*/0xF7, 0x05/*)*/, /*TempRegID*//* 758(*/0xF6, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205421 */   GIR_AddSimpleTempRegister, /*InsnID*//* 759(*/0xF7, 0x05/*)*/, /*TempRegID*//* 759(*/0xF7, 0x05/*)*/,
     /* 205426 */   GIR_AddSimpleTempRegister, /*InsnID*//* 759(*/0xF7, 0x05/*)*/, /*TempRegID*//* 760(*/0xF8, 0x05/*)*/,
     /* 205431 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 759(*/0xF7, 0x05/*)*/,
     /* 205434 */   GIR_MakeTempReg, /*TempRegID*//* 757(*/0xF5, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205438 */   GIR_BuildMI, /*InsnID*//* 758(*/0xF6, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 205443 */   GIR_AddTempRegister, /*InsnID*//* 758(*/0xF6, 0x05/*)*/, /*TempRegID*//* 757(*/0xF5, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205450 */   GIR_AddSimpleTempRegister, /*InsnID*//* 758(*/0xF6, 0x05/*)*/, /*TempRegID*//* 758(*/0xF6, 0x05/*)*/,
     /* 205455 */   GIR_AddSimpleTempRegister, /*InsnID*//* 758(*/0xF6, 0x05/*)*/, /*TempRegID*//* 767(*/0xFF, 0x05/*)*/,
     /* 205460 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 758(*/0xF6, 0x05/*)*/,
     /* 205463 */   GIR_MakeTempReg, /*TempRegID*//* 756(*/0xF4, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205467 */   GIR_BuildMI, /*InsnID*//* 757(*/0xF5, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 205472 */   GIR_AddTempRegister, /*InsnID*//* 757(*/0xF5, 0x05/*)*/, /*TempRegID*//* 756(*/0xF4, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205479 */   GIR_AddSimpleTempRegister, /*InsnID*//* 757(*/0xF5, 0x05/*)*/, /*TempRegID*//* 757(*/0xF5, 0x05/*)*/,
     /* 205484 */   GIR_AddImm8, /*InsnID*//* 757(*/0xF5, 0x05/*)*/, /*Imm*/62,
     /* 205488 */   GIR_AddImm8, /*InsnID*//* 757(*/0xF5, 0x05/*)*/, /*Imm*/2,
     /* 205492 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 757(*/0xF5, 0x05/*)*/,
     /* 205495 */   GIR_MakeTempReg, /*TempRegID*//* 755(*/0xF3, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205499 */   GIR_BuildMI, /*InsnID*//* 756(*/0xF4, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 205504 */   GIR_AddTempRegister, /*InsnID*//* 756(*/0xF4, 0x05/*)*/, /*TempRegID*//* 755(*/0xF3, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205511 */   GIR_AddSimpleTempRegister, /*InsnID*//* 756(*/0xF4, 0x05/*)*/, /*TempRegID*//* 756(*/0xF4, 0x05/*)*/,
     /* 205516 */   GIR_AddSimpleTempRegister, /*InsnID*//* 756(*/0xF4, 0x05/*)*/, /*TempRegID*//* 776(*/0x88, 0x06/*)*/,
     /* 205521 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 756(*/0xF4, 0x05/*)*/,
     /* 205524 */   GIR_MakeTempReg, /*TempRegID*//* 754(*/0xF2, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205528 */   GIR_BuildMI, /*InsnID*//* 755(*/0xF3, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 205533 */   GIR_AddTempRegister, /*InsnID*//* 755(*/0xF3, 0x05/*)*/, /*TempRegID*//* 754(*/0xF2, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205540 */   GIR_AddSimpleTempRegister, /*InsnID*//* 755(*/0xF3, 0x05/*)*/, /*TempRegID*//* 755(*/0xF3, 0x05/*)*/,
     /* 205545 */   GIR_AddSimpleTempRegister, /*InsnID*//* 755(*/0xF3, 0x05/*)*/, /*TempRegID*//* 783(*/0x8F, 0x06/*)*/,
     /* 205550 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 755(*/0xF3, 0x05/*)*/,
     /* 205553 */   GIR_MakeTempReg, /*TempRegID*//* 753(*/0xF1, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205557 */   GIR_BuildMI, /*InsnID*//* 754(*/0xF2, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 205562 */   GIR_AddTempRegister, /*InsnID*//* 754(*/0xF2, 0x05/*)*/, /*TempRegID*//* 753(*/0xF1, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205569 */   GIR_AddSimpleTempRegister, /*InsnID*//* 754(*/0xF2, 0x05/*)*/, /*TempRegID*//* 754(*/0xF2, 0x05/*)*/,
     /* 205574 */   GIR_AddImm8, /*InsnID*//* 754(*/0xF2, 0x05/*)*/, /*Imm*/4,
     /* 205578 */   GIR_AddImm8, /*InsnID*//* 754(*/0xF2, 0x05/*)*/, /*Imm*/59,
     /* 205582 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 754(*/0xF2, 0x05/*)*/,
     /* 205585 */   GIR_MakeTempReg, /*TempRegID*//* 752(*/0xF0, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205589 */   GIR_BuildMI, /*InsnID*//* 753(*/0xF1, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 205594 */   GIR_AddTempRegister, /*InsnID*//* 753(*/0xF1, 0x05/*)*/, /*TempRegID*//* 752(*/0xF0, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205601 */   GIR_AddSimpleTempRegister, /*InsnID*//* 753(*/0xF1, 0x05/*)*/, /*TempRegID*//* 753(*/0xF1, 0x05/*)*/,
     /* 205606 */   GIR_AddSimpleTempRegister, /*InsnID*//* 753(*/0xF1, 0x05/*)*/, /*TempRegID*//* 811(*/0xAB, 0x06/*)*/,
     /* 205611 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 753(*/0xF1, 0x05/*)*/,
     /* 205614 */   GIR_MakeTempReg, /*TempRegID*//* 751(*/0xEF, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 205618 */   GIR_BuildMI, /*InsnID*//* 752(*/0xF0, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 205623 */   GIR_AddTempRegister, /*InsnID*//* 752(*/0xF0, 0x05/*)*/, /*TempRegID*//* 751(*/0xEF, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205630 */   GIR_AddImm, /*InsnID*//* 752(*/0xF0, 0x05/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 205641 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 752(*/0xF0, 0x05/*)*/,
     /* 205644 */   GIR_MakeTempReg, /*TempRegID*//* 750(*/0xEE, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 205648 */   GIR_BuildMI, /*InsnID*//* 751(*/0xEF, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 205653 */   GIR_AddTempRegister, /*InsnID*//* 751(*/0xEF, 0x05/*)*/, /*TempRegID*//* 750(*/0xEE, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205660 */   GIR_AddSimpleTempRegister, /*InsnID*//* 751(*/0xEF, 0x05/*)*/, /*TempRegID*//* 751(*/0xEF, 0x05/*)*/,
     /* 205665 */   GIR_AddImm, /*InsnID*//* 751(*/0xEF, 0x05/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 205676 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 751(*/0xEF, 0x05/*)*/,
     /* 205679 */   GIR_MakeTempReg, /*TempRegID*//* 749(*/0xED, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205683 */   GIR_BuildMI, /*InsnID*//* 750(*/0xEE, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 205688 */   GIR_AddTempRegister, /*InsnID*//* 750(*/0xEE, 0x05/*)*/, /*TempRegID*//* 749(*/0xED, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205695 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 750(*/0xEE, 0x05/*)*/,
     /* 205698 */   GIR_MakeTempReg, /*TempRegID*//* 748(*/0xEC, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205702 */   GIR_BuildMI, /*InsnID*//* 749(*/0xED, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 205707 */   GIR_AddTempRegister, /*InsnID*//* 749(*/0xED, 0x05/*)*/, /*TempRegID*//* 748(*/0xEC, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205714 */   GIR_AddSimpleTempRegister, /*InsnID*//* 749(*/0xED, 0x05/*)*/, /*TempRegID*//* 749(*/0xED, 0x05/*)*/,
     /* 205719 */   GIR_AddSimpleTempRegister, /*InsnID*//* 749(*/0xED, 0x05/*)*/, /*TempRegID*//* 750(*/0xEE, 0x05/*)*/,
     /* 205724 */   GIR_AddImm8, /*InsnID*//* 749(*/0xED, 0x05/*)*/, /*Imm*/1,
     /* 205728 */   GIR_ConstrainOperandRC, /*InsnID*//* 749(*/0xED, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 205734 */   GIR_ConstrainOperandRC, /*InsnID*//* 749(*/0xED, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 205740 */   GIR_ConstrainOperandRC, /*InsnID*//* 749(*/0xED, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 205746 */   GIR_MakeTempReg, /*TempRegID*//* 747(*/0xEB, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205750 */   GIR_BuildMI, /*InsnID*//* 748(*/0xEC, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 205755 */   GIR_AddTempRegister, /*InsnID*//* 748(*/0xEC, 0x05/*)*/, /*TempRegID*//* 747(*/0xEB, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205762 */   GIR_AddSimpleTempRegister, /*InsnID*//* 748(*/0xEC, 0x05/*)*/, /*TempRegID*//* 748(*/0xEC, 0x05/*)*/,
     /* 205767 */   GIR_AddImm8, /*InsnID*//* 748(*/0xEC, 0x05/*)*/, /*Imm*/32,
     /* 205771 */   GIR_AddImm8, /*InsnID*//* 748(*/0xEC, 0x05/*)*/, /*Imm*/31,
     /* 205775 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 748(*/0xEC, 0x05/*)*/,
     /* 205778 */   GIR_MakeTempReg, /*TempRegID*//* 746(*/0xEA, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205782 */   GIR_BuildMI, /*InsnID*//* 747(*/0xEB, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 205787 */   GIR_AddTempRegister, /*InsnID*//* 747(*/0xEB, 0x05/*)*/, /*TempRegID*//* 746(*/0xEA, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205794 */   GIR_AddSimpleTempRegister, /*InsnID*//* 747(*/0xEB, 0x05/*)*/, /*TempRegID*//* 747(*/0xEB, 0x05/*)*/,
     /* 205799 */   GIR_AddImm, /*InsnID*//* 747(*/0xEB, 0x05/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 205810 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 747(*/0xEB, 0x05/*)*/,
     /* 205813 */   GIR_MakeTempReg, /*TempRegID*//* 745(*/0xE9, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205817 */   GIR_BuildMI, /*InsnID*//* 746(*/0xEA, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 205822 */   GIR_AddTempRegister, /*InsnID*//* 746(*/0xEA, 0x05/*)*/, /*TempRegID*//* 745(*/0xE9, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205829 */   GIR_AddSimpleTempRegister, /*InsnID*//* 746(*/0xEA, 0x05/*)*/, /*TempRegID*//* 746(*/0xEA, 0x05/*)*/,
     /* 205834 */   GIR_AddImm, /*InsnID*//* 746(*/0xEA, 0x05/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 205845 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 746(*/0xEA, 0x05/*)*/,
     /* 205848 */   GIR_MakeTempReg, /*TempRegID*//* 744(*/0xE8, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 205852 */   GIR_BuildMI, /*InsnID*//* 745(*/0xE9, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 205857 */   GIR_AddTempRegister, /*InsnID*//* 745(*/0xE9, 0x05/*)*/, /*TempRegID*//* 744(*/0xE8, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205864 */   GIR_AddImm, /*InsnID*//* 745(*/0xE9, 0x05/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 205875 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 745(*/0xE9, 0x05/*)*/,
     /* 205878 */   GIR_MakeTempReg, /*TempRegID*//* 743(*/0xE7, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 205882 */   GIR_BuildMI, /*InsnID*//* 744(*/0xE8, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 205887 */   GIR_AddTempRegister, /*InsnID*//* 744(*/0xE8, 0x05/*)*/, /*TempRegID*//* 743(*/0xE7, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205894 */   GIR_AddSimpleTempRegister, /*InsnID*//* 744(*/0xE8, 0x05/*)*/, /*TempRegID*//* 744(*/0xE8, 0x05/*)*/,
     /* 205899 */   GIR_AddImm, /*InsnID*//* 744(*/0xE8, 0x05/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 205910 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 744(*/0xE8, 0x05/*)*/,
     /* 205913 */   GIR_MakeTempReg, /*TempRegID*//* 742(*/0xE6, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205917 */   GIR_BuildMI, /*InsnID*//* 743(*/0xE7, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 205922 */   GIR_AddTempRegister, /*InsnID*//* 743(*/0xE7, 0x05/*)*/, /*TempRegID*//* 742(*/0xE6, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205929 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 743(*/0xE7, 0x05/*)*/,
     /* 205932 */   GIR_MakeTempReg, /*TempRegID*//* 741(*/0xE5, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205936 */   GIR_BuildMI, /*InsnID*//* 742(*/0xE6, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 205941 */   GIR_AddTempRegister, /*InsnID*//* 742(*/0xE6, 0x05/*)*/, /*TempRegID*//* 741(*/0xE5, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205948 */   GIR_AddSimpleTempRegister, /*InsnID*//* 742(*/0xE6, 0x05/*)*/, /*TempRegID*//* 742(*/0xE6, 0x05/*)*/,
     /* 205953 */   GIR_AddSimpleTempRegister, /*InsnID*//* 742(*/0xE6, 0x05/*)*/, /*TempRegID*//* 743(*/0xE7, 0x05/*)*/,
     /* 205958 */   GIR_AddImm8, /*InsnID*//* 742(*/0xE6, 0x05/*)*/, /*Imm*/1,
     /* 205962 */   GIR_ConstrainOperandRC, /*InsnID*//* 742(*/0xE6, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 205968 */   GIR_ConstrainOperandRC, /*InsnID*//* 742(*/0xE6, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 205974 */   GIR_ConstrainOperandRC, /*InsnID*//* 742(*/0xE6, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 205980 */   GIR_MakeTempReg, /*TempRegID*//* 740(*/0xE4, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205984 */   GIR_BuildMI, /*InsnID*//* 741(*/0xE5, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 205989 */   GIR_AddTempRegister, /*InsnID*//* 741(*/0xE5, 0x05/*)*/, /*TempRegID*//* 740(*/0xE4, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205996 */   GIR_AddSimpleTempRegister, /*InsnID*//* 741(*/0xE5, 0x05/*)*/, /*TempRegID*//* 741(*/0xE5, 0x05/*)*/,
     /* 206001 */   GIR_AddImm8, /*InsnID*//* 741(*/0xE5, 0x05/*)*/, /*Imm*/32,
     /* 206005 */   GIR_AddImm8, /*InsnID*//* 741(*/0xE5, 0x05/*)*/, /*Imm*/31,
     /* 206009 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 741(*/0xE5, 0x05/*)*/,
     /* 206012 */   GIR_MakeTempReg, /*TempRegID*//* 739(*/0xE3, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206016 */   GIR_BuildMI, /*InsnID*//* 740(*/0xE4, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 206021 */   GIR_AddTempRegister, /*InsnID*//* 740(*/0xE4, 0x05/*)*/, /*TempRegID*//* 739(*/0xE3, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206028 */   GIR_AddSimpleTempRegister, /*InsnID*//* 740(*/0xE4, 0x05/*)*/, /*TempRegID*//* 740(*/0xE4, 0x05/*)*/,
     /* 206033 */   GIR_AddImm, /*InsnID*//* 740(*/0xE4, 0x05/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 206044 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 740(*/0xE4, 0x05/*)*/,
     /* 206047 */   GIR_MakeTempReg, /*TempRegID*//* 738(*/0xE2, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206051 */   GIR_BuildMI, /*InsnID*//* 739(*/0xE3, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 206056 */   GIR_AddTempRegister, /*InsnID*//* 739(*/0xE3, 0x05/*)*/, /*TempRegID*//* 738(*/0xE2, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206063 */   GIR_AddSimpleTempRegister, /*InsnID*//* 739(*/0xE3, 0x05/*)*/, /*TempRegID*//* 739(*/0xE3, 0x05/*)*/,
     /* 206068 */   GIR_AddImm, /*InsnID*//* 739(*/0xE3, 0x05/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 206079 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 739(*/0xE3, 0x05/*)*/,
     /* 206082 */   GIR_MakeTempReg, /*TempRegID*//* 737(*/0xE1, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 206086 */   GIR_BuildMI, /*InsnID*//* 738(*/0xE2, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 206091 */   GIR_AddTempRegister, /*InsnID*//* 738(*/0xE2, 0x05/*)*/, /*TempRegID*//* 737(*/0xE1, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206098 */   GIR_AddImm, /*InsnID*//* 738(*/0xE2, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 206109 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 738(*/0xE2, 0x05/*)*/,
     /* 206112 */   GIR_MakeTempReg, /*TempRegID*//* 736(*/0xE0, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 206116 */   GIR_BuildMI, /*InsnID*//* 737(*/0xE1, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 206121 */   GIR_AddTempRegister, /*InsnID*//* 737(*/0xE1, 0x05/*)*/, /*TempRegID*//* 736(*/0xE0, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206128 */   GIR_AddSimpleTempRegister, /*InsnID*//* 737(*/0xE1, 0x05/*)*/, /*TempRegID*//* 737(*/0xE1, 0x05/*)*/,
     /* 206133 */   GIR_AddImm, /*InsnID*//* 737(*/0xE1, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 206144 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 737(*/0xE1, 0x05/*)*/,
     /* 206147 */   GIR_MakeTempReg, /*TempRegID*//* 735(*/0xDF, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206151 */   GIR_BuildMI, /*InsnID*//* 736(*/0xE0, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 206156 */   GIR_AddTempRegister, /*InsnID*//* 736(*/0xE0, 0x05/*)*/, /*TempRegID*//* 735(*/0xDF, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206163 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 736(*/0xE0, 0x05/*)*/,
     /* 206166 */   GIR_MakeTempReg, /*TempRegID*//* 734(*/0xDE, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206170 */   GIR_BuildMI, /*InsnID*//* 735(*/0xDF, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 206175 */   GIR_AddTempRegister, /*InsnID*//* 735(*/0xDF, 0x05/*)*/, /*TempRegID*//* 734(*/0xDE, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206182 */   GIR_AddSimpleTempRegister, /*InsnID*//* 735(*/0xDF, 0x05/*)*/, /*TempRegID*//* 735(*/0xDF, 0x05/*)*/,
     /* 206187 */   GIR_AddSimpleTempRegister, /*InsnID*//* 735(*/0xDF, 0x05/*)*/, /*TempRegID*//* 736(*/0xE0, 0x05/*)*/,
     /* 206192 */   GIR_AddImm8, /*InsnID*//* 735(*/0xDF, 0x05/*)*/, /*Imm*/1,
     /* 206196 */   GIR_ConstrainOperandRC, /*InsnID*//* 735(*/0xDF, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 206202 */   GIR_ConstrainOperandRC, /*InsnID*//* 735(*/0xDF, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 206208 */   GIR_ConstrainOperandRC, /*InsnID*//* 735(*/0xDF, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 206214 */   GIR_MakeTempReg, /*TempRegID*//* 733(*/0xDD, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206218 */   GIR_BuildMI, /*InsnID*//* 734(*/0xDE, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 206223 */   GIR_AddTempRegister, /*InsnID*//* 734(*/0xDE, 0x05/*)*/, /*TempRegID*//* 733(*/0xDD, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206230 */   GIR_AddSimpleTempRegister, /*InsnID*//* 734(*/0xDE, 0x05/*)*/, /*TempRegID*//* 734(*/0xDE, 0x05/*)*/,
     /* 206235 */   GIR_AddImm8, /*InsnID*//* 734(*/0xDE, 0x05/*)*/, /*Imm*/32,
     /* 206239 */   GIR_AddImm8, /*InsnID*//* 734(*/0xDE, 0x05/*)*/, /*Imm*/31,
     /* 206243 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 734(*/0xDE, 0x05/*)*/,
     /* 206246 */   GIR_MakeTempReg, /*TempRegID*//* 732(*/0xDC, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206250 */   GIR_BuildMI, /*InsnID*//* 733(*/0xDD, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 206255 */   GIR_AddTempRegister, /*InsnID*//* 733(*/0xDD, 0x05/*)*/, /*TempRegID*//* 732(*/0xDC, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206262 */   GIR_AddSimpleTempRegister, /*InsnID*//* 733(*/0xDD, 0x05/*)*/, /*TempRegID*//* 733(*/0xDD, 0x05/*)*/,
     /* 206267 */   GIR_AddImm, /*InsnID*//* 733(*/0xDD, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 206278 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 733(*/0xDD, 0x05/*)*/,
     /* 206281 */   GIR_MakeTempReg, /*TempRegID*//* 731(*/0xDB, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206285 */   GIR_BuildMI, /*InsnID*//* 732(*/0xDC, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 206290 */   GIR_AddTempRegister, /*InsnID*//* 732(*/0xDC, 0x05/*)*/, /*TempRegID*//* 731(*/0xDB, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206297 */   GIR_AddSimpleTempRegister, /*InsnID*//* 732(*/0xDC, 0x05/*)*/, /*TempRegID*//* 732(*/0xDC, 0x05/*)*/,
     /* 206302 */   GIR_AddImm, /*InsnID*//* 732(*/0xDC, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 206313 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 732(*/0xDC, 0x05/*)*/,
     /* 206316 */   GIR_MakeTempReg, /*TempRegID*//* 730(*/0xDA, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206320 */   GIR_BuildMI, /*InsnID*//* 731(*/0xDB, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 206325 */   GIR_AddTempRegister, /*InsnID*//* 731(*/0xDB, 0x05/*)*/, /*TempRegID*//* 730(*/0xDA, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206332 */   GIR_Copy, /*NewInsnID*//* 731(*/0xDB, 0x05/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 206337 */   GIR_AddImm8, /*InsnID*//* 731(*/0xDB, 0x05/*)*/, /*Imm*/1,
     /* 206341 */   GIR_AddImm8, /*InsnID*//* 731(*/0xDB, 0x05/*)*/, /*Imm*/62,
     /* 206345 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 731(*/0xDB, 0x05/*)*/,
     /* 206348 */   GIR_MakeTempReg, /*TempRegID*//* 729(*/0xD9, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206352 */   GIR_BuildMI, /*InsnID*//* 730(*/0xDA, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 206357 */   GIR_AddTempRegister, /*InsnID*//* 730(*/0xDA, 0x05/*)*/, /*TempRegID*//* 729(*/0xD9, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206364 */   GIR_AddSimpleTempRegister, /*InsnID*//* 730(*/0xDA, 0x05/*)*/, /*TempRegID*//* 730(*/0xDA, 0x05/*)*/,
     /* 206369 */   GIR_AddSimpleTempRegister, /*InsnID*//* 730(*/0xDA, 0x05/*)*/, /*TempRegID*//* 731(*/0xDB, 0x05/*)*/,
     /* 206374 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 730(*/0xDA, 0x05/*)*/,
     /* 206377 */   GIR_MakeTempReg, /*TempRegID*//* 728(*/0xD8, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 206381 */   GIR_BuildMI, /*InsnID*//* 729(*/0xD9, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 206386 */   GIR_AddTempRegister, /*InsnID*//* 729(*/0xD9, 0x05/*)*/, /*TempRegID*//* 728(*/0xD8, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206393 */   GIR_AddImm, /*InsnID*//* 729(*/0xD9, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 206404 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 729(*/0xD9, 0x05/*)*/,
     /* 206407 */   GIR_MakeTempReg, /*TempRegID*//* 727(*/0xD7, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 206411 */   GIR_BuildMI, /*InsnID*//* 728(*/0xD8, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 206416 */   GIR_AddTempRegister, /*InsnID*//* 728(*/0xD8, 0x05/*)*/, /*TempRegID*//* 727(*/0xD7, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206423 */   GIR_AddSimpleTempRegister, /*InsnID*//* 728(*/0xD8, 0x05/*)*/, /*TempRegID*//* 728(*/0xD8, 0x05/*)*/,
     /* 206428 */   GIR_AddImm, /*InsnID*//* 728(*/0xD8, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 206439 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 728(*/0xD8, 0x05/*)*/,
     /* 206442 */   GIR_MakeTempReg, /*TempRegID*//* 726(*/0xD6, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206446 */   GIR_BuildMI, /*InsnID*//* 727(*/0xD7, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 206451 */   GIR_AddTempRegister, /*InsnID*//* 727(*/0xD7, 0x05/*)*/, /*TempRegID*//* 726(*/0xD6, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206458 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 727(*/0xD7, 0x05/*)*/,
     /* 206461 */   GIR_MakeTempReg, /*TempRegID*//* 725(*/0xD5, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206465 */   GIR_BuildMI, /*InsnID*//* 726(*/0xD6, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 206470 */   GIR_AddTempRegister, /*InsnID*//* 726(*/0xD6, 0x05/*)*/, /*TempRegID*//* 725(*/0xD5, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206477 */   GIR_AddSimpleTempRegister, /*InsnID*//* 726(*/0xD6, 0x05/*)*/, /*TempRegID*//* 726(*/0xD6, 0x05/*)*/,
     /* 206482 */   GIR_AddSimpleTempRegister, /*InsnID*//* 726(*/0xD6, 0x05/*)*/, /*TempRegID*//* 727(*/0xD7, 0x05/*)*/,
     /* 206487 */   GIR_AddImm8, /*InsnID*//* 726(*/0xD6, 0x05/*)*/, /*Imm*/1,
     /* 206491 */   GIR_ConstrainOperandRC, /*InsnID*//* 726(*/0xD6, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 206497 */   GIR_ConstrainOperandRC, /*InsnID*//* 726(*/0xD6, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 206503 */   GIR_ConstrainOperandRC, /*InsnID*//* 726(*/0xD6, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 206509 */   GIR_MakeTempReg, /*TempRegID*//* 724(*/0xD4, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206513 */   GIR_BuildMI, /*InsnID*//* 725(*/0xD5, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 206518 */   GIR_AddTempRegister, /*InsnID*//* 725(*/0xD5, 0x05/*)*/, /*TempRegID*//* 724(*/0xD4, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206525 */   GIR_AddSimpleTempRegister, /*InsnID*//* 725(*/0xD5, 0x05/*)*/, /*TempRegID*//* 725(*/0xD5, 0x05/*)*/,
     /* 206530 */   GIR_AddImm8, /*InsnID*//* 725(*/0xD5, 0x05/*)*/, /*Imm*/32,
     /* 206534 */   GIR_AddImm8, /*InsnID*//* 725(*/0xD5, 0x05/*)*/, /*Imm*/31,
     /* 206538 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 725(*/0xD5, 0x05/*)*/,
     /* 206541 */   GIR_MakeTempReg, /*TempRegID*//* 723(*/0xD3, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206545 */   GIR_BuildMI, /*InsnID*//* 724(*/0xD4, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 206550 */   GIR_AddTempRegister, /*InsnID*//* 724(*/0xD4, 0x05/*)*/, /*TempRegID*//* 723(*/0xD3, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206557 */   GIR_AddSimpleTempRegister, /*InsnID*//* 724(*/0xD4, 0x05/*)*/, /*TempRegID*//* 724(*/0xD4, 0x05/*)*/,
     /* 206562 */   GIR_AddImm, /*InsnID*//* 724(*/0xD4, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 206573 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 724(*/0xD4, 0x05/*)*/,
     /* 206576 */   GIR_MakeTempReg, /*TempRegID*//* 722(*/0xD2, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206580 */   GIR_BuildMI, /*InsnID*//* 723(*/0xD3, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 206585 */   GIR_AddTempRegister, /*InsnID*//* 723(*/0xD3, 0x05/*)*/, /*TempRegID*//* 722(*/0xD2, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206592 */   GIR_AddSimpleTempRegister, /*InsnID*//* 723(*/0xD3, 0x05/*)*/, /*TempRegID*//* 723(*/0xD3, 0x05/*)*/,
     /* 206597 */   GIR_AddImm, /*InsnID*//* 723(*/0xD3, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 206608 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 723(*/0xD3, 0x05/*)*/,
     /* 206611 */   GIR_MakeTempReg, /*TempRegID*//* 721(*/0xD1, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206615 */   GIR_BuildMI, /*InsnID*//* 722(*/0xD2, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 206620 */   GIR_AddTempRegister, /*InsnID*//* 722(*/0xD2, 0x05/*)*/, /*TempRegID*//* 721(*/0xD1, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206627 */   GIR_Copy, /*NewInsnID*//* 722(*/0xD2, 0x05/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 206632 */   GIR_AddImm8, /*InsnID*//* 722(*/0xD2, 0x05/*)*/, /*Imm*/63,
     /* 206636 */   GIR_AddImm8, /*InsnID*//* 722(*/0xD2, 0x05/*)*/, /*Imm*/1,
     /* 206640 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 722(*/0xD2, 0x05/*)*/,
     /* 206643 */   GIR_MakeTempReg, /*TempRegID*//* 720(*/0xD0, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206647 */   GIR_BuildMI, /*InsnID*//* 721(*/0xD1, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 206652 */   GIR_AddTempRegister, /*InsnID*//* 721(*/0xD1, 0x05/*)*/, /*TempRegID*//* 720(*/0xD0, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206659 */   GIR_AddSimpleTempRegister, /*InsnID*//* 721(*/0xD1, 0x05/*)*/, /*TempRegID*//* 721(*/0xD1, 0x05/*)*/,
     /* 206664 */   GIR_AddSimpleTempRegister, /*InsnID*//* 721(*/0xD1, 0x05/*)*/, /*TempRegID*//* 722(*/0xD2, 0x05/*)*/,
     /* 206669 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 721(*/0xD1, 0x05/*)*/,
     /* 206672 */   GIR_MakeTempReg, /*TempRegID*//* 719(*/0xCF, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206676 */   GIR_BuildMI, /*InsnID*//* 720(*/0xD0, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 206681 */   GIR_AddTempRegister, /*InsnID*//* 720(*/0xD0, 0x05/*)*/, /*TempRegID*//* 719(*/0xCF, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206688 */   GIR_AddSimpleTempRegister, /*InsnID*//* 720(*/0xD0, 0x05/*)*/, /*TempRegID*//* 720(*/0xD0, 0x05/*)*/,
     /* 206693 */   GIR_AddSimpleTempRegister, /*InsnID*//* 720(*/0xD0, 0x05/*)*/, /*TempRegID*//* 729(*/0xD9, 0x05/*)*/,
     /* 206698 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 720(*/0xD0, 0x05/*)*/,
     /* 206701 */   GIR_MakeTempReg, /*TempRegID*//* 718(*/0xCE, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206705 */   GIR_BuildMI, /*InsnID*//* 719(*/0xCF, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 206710 */   GIR_AddTempRegister, /*InsnID*//* 719(*/0xCF, 0x05/*)*/, /*TempRegID*//* 718(*/0xCE, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206717 */   GIR_AddSimpleTempRegister, /*InsnID*//* 719(*/0xCF, 0x05/*)*/, /*TempRegID*//* 719(*/0xCF, 0x05/*)*/,
     /* 206722 */   GIR_AddImm8, /*InsnID*//* 719(*/0xCF, 0x05/*)*/, /*Imm*/2,
     /* 206726 */   GIR_AddImm8, /*InsnID*//* 719(*/0xCF, 0x05/*)*/, /*Imm*/61,
     /* 206730 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 719(*/0xCF, 0x05/*)*/,
     /* 206733 */   GIR_MakeTempReg, /*TempRegID*//* 717(*/0xCD, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206737 */   GIR_BuildMI, /*InsnID*//* 718(*/0xCE, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 206742 */   GIR_AddTempRegister, /*InsnID*//* 718(*/0xCE, 0x05/*)*/, /*TempRegID*//* 717(*/0xCD, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206749 */   GIR_AddSimpleTempRegister, /*InsnID*//* 718(*/0xCE, 0x05/*)*/, /*TempRegID*//* 718(*/0xCE, 0x05/*)*/,
     /* 206754 */   GIR_AddSimpleTempRegister, /*InsnID*//* 718(*/0xCE, 0x05/*)*/, /*TempRegID*//* 738(*/0xE2, 0x05/*)*/,
     /* 206759 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 718(*/0xCE, 0x05/*)*/,
     /* 206762 */   GIR_MakeTempReg, /*TempRegID*//* 716(*/0xCC, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 206766 */   GIR_BuildMI, /*InsnID*//* 717(*/0xCD, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 206771 */   GIR_AddTempRegister, /*InsnID*//* 717(*/0xCD, 0x05/*)*/, /*TempRegID*//* 716(*/0xCC, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206778 */   GIR_AddImm, /*InsnID*//* 717(*/0xCD, 0x05/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 206789 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 717(*/0xCD, 0x05/*)*/,
     /* 206792 */   GIR_MakeTempReg, /*TempRegID*//* 715(*/0xCB, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 206796 */   GIR_BuildMI, /*InsnID*//* 716(*/0xCC, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 206801 */   GIR_AddTempRegister, /*InsnID*//* 716(*/0xCC, 0x05/*)*/, /*TempRegID*//* 715(*/0xCB, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206808 */   GIR_AddSimpleTempRegister, /*InsnID*//* 716(*/0xCC, 0x05/*)*/, /*TempRegID*//* 716(*/0xCC, 0x05/*)*/,
     /* 206813 */   GIR_AddImm, /*InsnID*//* 716(*/0xCC, 0x05/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 206824 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 716(*/0xCC, 0x05/*)*/,
     /* 206827 */   GIR_MakeTempReg, /*TempRegID*//* 714(*/0xCA, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206831 */   GIR_BuildMI, /*InsnID*//* 715(*/0xCB, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 206836 */   GIR_AddTempRegister, /*InsnID*//* 715(*/0xCB, 0x05/*)*/, /*TempRegID*//* 714(*/0xCA, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206843 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 715(*/0xCB, 0x05/*)*/,
     /* 206846 */   GIR_MakeTempReg, /*TempRegID*//* 713(*/0xC9, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206850 */   GIR_BuildMI, /*InsnID*//* 714(*/0xCA, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 206855 */   GIR_AddTempRegister, /*InsnID*//* 714(*/0xCA, 0x05/*)*/, /*TempRegID*//* 713(*/0xC9, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206862 */   GIR_AddSimpleTempRegister, /*InsnID*//* 714(*/0xCA, 0x05/*)*/, /*TempRegID*//* 714(*/0xCA, 0x05/*)*/,
     /* 206867 */   GIR_AddSimpleTempRegister, /*InsnID*//* 714(*/0xCA, 0x05/*)*/, /*TempRegID*//* 715(*/0xCB, 0x05/*)*/,
     /* 206872 */   GIR_AddImm8, /*InsnID*//* 714(*/0xCA, 0x05/*)*/, /*Imm*/1,
     /* 206876 */   GIR_ConstrainOperandRC, /*InsnID*//* 714(*/0xCA, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 206882 */   GIR_ConstrainOperandRC, /*InsnID*//* 714(*/0xCA, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 206888 */   GIR_ConstrainOperandRC, /*InsnID*//* 714(*/0xCA, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 206894 */   GIR_MakeTempReg, /*TempRegID*//* 712(*/0xC8, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206898 */   GIR_BuildMI, /*InsnID*//* 713(*/0xC9, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 206903 */   GIR_AddTempRegister, /*InsnID*//* 713(*/0xC9, 0x05/*)*/, /*TempRegID*//* 712(*/0xC8, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206910 */   GIR_AddSimpleTempRegister, /*InsnID*//* 713(*/0xC9, 0x05/*)*/, /*TempRegID*//* 713(*/0xC9, 0x05/*)*/,
     /* 206915 */   GIR_AddImm8, /*InsnID*//* 713(*/0xC9, 0x05/*)*/, /*Imm*/32,
     /* 206919 */   GIR_AddImm8, /*InsnID*//* 713(*/0xC9, 0x05/*)*/, /*Imm*/31,
     /* 206923 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 713(*/0xC9, 0x05/*)*/,
     /* 206926 */   GIR_MakeTempReg, /*TempRegID*//* 711(*/0xC7, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206930 */   GIR_BuildMI, /*InsnID*//* 712(*/0xC8, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 206935 */   GIR_AddTempRegister, /*InsnID*//* 712(*/0xC8, 0x05/*)*/, /*TempRegID*//* 711(*/0xC7, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206942 */   GIR_AddSimpleTempRegister, /*InsnID*//* 712(*/0xC8, 0x05/*)*/, /*TempRegID*//* 712(*/0xC8, 0x05/*)*/,
     /* 206947 */   GIR_AddImm, /*InsnID*//* 712(*/0xC8, 0x05/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 206958 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 712(*/0xC8, 0x05/*)*/,
     /* 206961 */   GIR_MakeTempReg, /*TempRegID*//* 710(*/0xC6, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206965 */   GIR_BuildMI, /*InsnID*//* 711(*/0xC7, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 206970 */   GIR_AddTempRegister, /*InsnID*//* 711(*/0xC7, 0x05/*)*/, /*TempRegID*//* 710(*/0xC6, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206977 */   GIR_AddSimpleTempRegister, /*InsnID*//* 711(*/0xC7, 0x05/*)*/, /*TempRegID*//* 711(*/0xC7, 0x05/*)*/,
     /* 206982 */   GIR_AddImm, /*InsnID*//* 711(*/0xC7, 0x05/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 206993 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 711(*/0xC7, 0x05/*)*/,
     /* 206996 */   GIR_MakeTempReg, /*TempRegID*//* 709(*/0xC5, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 207000 */   GIR_BuildMI, /*InsnID*//* 710(*/0xC6, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 207005 */   GIR_AddTempRegister, /*InsnID*//* 710(*/0xC6, 0x05/*)*/, /*TempRegID*//* 709(*/0xC5, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207012 */   GIR_AddImm, /*InsnID*//* 710(*/0xC6, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 207023 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 710(*/0xC6, 0x05/*)*/,
     /* 207026 */   GIR_MakeTempReg, /*TempRegID*//* 708(*/0xC4, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 207030 */   GIR_BuildMI, /*InsnID*//* 709(*/0xC5, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 207035 */   GIR_AddTempRegister, /*InsnID*//* 709(*/0xC5, 0x05/*)*/, /*TempRegID*//* 708(*/0xC4, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207042 */   GIR_AddSimpleTempRegister, /*InsnID*//* 709(*/0xC5, 0x05/*)*/, /*TempRegID*//* 709(*/0xC5, 0x05/*)*/,
     /* 207047 */   GIR_AddImm, /*InsnID*//* 709(*/0xC5, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 207058 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 709(*/0xC5, 0x05/*)*/,
     /* 207061 */   GIR_MakeTempReg, /*TempRegID*//* 707(*/0xC3, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207065 */   GIR_BuildMI, /*InsnID*//* 708(*/0xC4, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 207070 */   GIR_AddTempRegister, /*InsnID*//* 708(*/0xC4, 0x05/*)*/, /*TempRegID*//* 707(*/0xC3, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207077 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 708(*/0xC4, 0x05/*)*/,
     /* 207080 */   GIR_MakeTempReg, /*TempRegID*//* 706(*/0xC2, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207084 */   GIR_BuildMI, /*InsnID*//* 707(*/0xC3, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 207089 */   GIR_AddTempRegister, /*InsnID*//* 707(*/0xC3, 0x05/*)*/, /*TempRegID*//* 706(*/0xC2, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207096 */   GIR_AddSimpleTempRegister, /*InsnID*//* 707(*/0xC3, 0x05/*)*/, /*TempRegID*//* 707(*/0xC3, 0x05/*)*/,
     /* 207101 */   GIR_AddSimpleTempRegister, /*InsnID*//* 707(*/0xC3, 0x05/*)*/, /*TempRegID*//* 708(*/0xC4, 0x05/*)*/,
     /* 207106 */   GIR_AddImm8, /*InsnID*//* 707(*/0xC3, 0x05/*)*/, /*Imm*/1,
     /* 207110 */   GIR_ConstrainOperandRC, /*InsnID*//* 707(*/0xC3, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 207116 */   GIR_ConstrainOperandRC, /*InsnID*//* 707(*/0xC3, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 207122 */   GIR_ConstrainOperandRC, /*InsnID*//* 707(*/0xC3, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 207128 */   GIR_MakeTempReg, /*TempRegID*//* 705(*/0xC1, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207132 */   GIR_BuildMI, /*InsnID*//* 706(*/0xC2, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 207137 */   GIR_AddTempRegister, /*InsnID*//* 706(*/0xC2, 0x05/*)*/, /*TempRegID*//* 705(*/0xC1, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207144 */   GIR_AddSimpleTempRegister, /*InsnID*//* 706(*/0xC2, 0x05/*)*/, /*TempRegID*//* 706(*/0xC2, 0x05/*)*/,
     /* 207149 */   GIR_AddImm8, /*InsnID*//* 706(*/0xC2, 0x05/*)*/, /*Imm*/32,
     /* 207153 */   GIR_AddImm8, /*InsnID*//* 706(*/0xC2, 0x05/*)*/, /*Imm*/31,
     /* 207157 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 706(*/0xC2, 0x05/*)*/,
     /* 207160 */   GIR_MakeTempReg, /*TempRegID*//* 704(*/0xC0, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207164 */   GIR_BuildMI, /*InsnID*//* 705(*/0xC1, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 207169 */   GIR_AddTempRegister, /*InsnID*//* 705(*/0xC1, 0x05/*)*/, /*TempRegID*//* 704(*/0xC0, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207176 */   GIR_AddSimpleTempRegister, /*InsnID*//* 705(*/0xC1, 0x05/*)*/, /*TempRegID*//* 705(*/0xC1, 0x05/*)*/,
     /* 207181 */   GIR_AddImm, /*InsnID*//* 705(*/0xC1, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 207192 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 705(*/0xC1, 0x05/*)*/,
     /* 207195 */   GIR_MakeTempReg, /*TempRegID*//* 703(*/0xBF, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207199 */   GIR_BuildMI, /*InsnID*//* 704(*/0xC0, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 207204 */   GIR_AddTempRegister, /*InsnID*//* 704(*/0xC0, 0x05/*)*/, /*TempRegID*//* 703(*/0xBF, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207211 */   GIR_AddSimpleTempRegister, /*InsnID*//* 704(*/0xC0, 0x05/*)*/, /*TempRegID*//* 704(*/0xC0, 0x05/*)*/,
     /* 207216 */   GIR_AddImm, /*InsnID*//* 704(*/0xC0, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 207227 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 704(*/0xC0, 0x05/*)*/,
     /* 207230 */   GIR_MakeTempReg, /*TempRegID*//* 702(*/0xBE, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207234 */   GIR_BuildMI, /*InsnID*//* 703(*/0xBF, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 207239 */   GIR_AddTempRegister, /*InsnID*//* 703(*/0xBF, 0x05/*)*/, /*TempRegID*//* 702(*/0xBE, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207246 */   GIR_Copy, /*NewInsnID*//* 703(*/0xBF, 0x05/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 207251 */   GIR_AddImm8, /*InsnID*//* 703(*/0xBF, 0x05/*)*/, /*Imm*/1,
     /* 207255 */   GIR_AddImm8, /*InsnID*//* 703(*/0xBF, 0x05/*)*/, /*Imm*/62,
     /* 207259 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 703(*/0xBF, 0x05/*)*/,
     /* 207262 */   GIR_MakeTempReg, /*TempRegID*//* 701(*/0xBD, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207266 */   GIR_BuildMI, /*InsnID*//* 702(*/0xBE, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 207271 */   GIR_AddTempRegister, /*InsnID*//* 702(*/0xBE, 0x05/*)*/, /*TempRegID*//* 701(*/0xBD, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207278 */   GIR_AddSimpleTempRegister, /*InsnID*//* 702(*/0xBE, 0x05/*)*/, /*TempRegID*//* 702(*/0xBE, 0x05/*)*/,
     /* 207283 */   GIR_AddSimpleTempRegister, /*InsnID*//* 702(*/0xBE, 0x05/*)*/, /*TempRegID*//* 703(*/0xBF, 0x05/*)*/,
     /* 207288 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 702(*/0xBE, 0x05/*)*/,
     /* 207291 */   GIR_MakeTempReg, /*TempRegID*//* 700(*/0xBC, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 207295 */   GIR_BuildMI, /*InsnID*//* 701(*/0xBD, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 207300 */   GIR_AddTempRegister, /*InsnID*//* 701(*/0xBD, 0x05/*)*/, /*TempRegID*//* 700(*/0xBC, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207307 */   GIR_AddImm, /*InsnID*//* 701(*/0xBD, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 207318 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 701(*/0xBD, 0x05/*)*/,
     /* 207321 */   GIR_MakeTempReg, /*TempRegID*//* 699(*/0xBB, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 207325 */   GIR_BuildMI, /*InsnID*//* 700(*/0xBC, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 207330 */   GIR_AddTempRegister, /*InsnID*//* 700(*/0xBC, 0x05/*)*/, /*TempRegID*//* 699(*/0xBB, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207337 */   GIR_AddSimpleTempRegister, /*InsnID*//* 700(*/0xBC, 0x05/*)*/, /*TempRegID*//* 700(*/0xBC, 0x05/*)*/,
     /* 207342 */   GIR_AddImm, /*InsnID*//* 700(*/0xBC, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 207353 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 700(*/0xBC, 0x05/*)*/,
     /* 207356 */   GIR_MakeTempReg, /*TempRegID*//* 698(*/0xBA, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207360 */   GIR_BuildMI, /*InsnID*//* 699(*/0xBB, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 207365 */   GIR_AddTempRegister, /*InsnID*//* 699(*/0xBB, 0x05/*)*/, /*TempRegID*//* 698(*/0xBA, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207372 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 699(*/0xBB, 0x05/*)*/,
     /* 207375 */   GIR_MakeTempReg, /*TempRegID*//* 697(*/0xB9, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207379 */   GIR_BuildMI, /*InsnID*//* 698(*/0xBA, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 207384 */   GIR_AddTempRegister, /*InsnID*//* 698(*/0xBA, 0x05/*)*/, /*TempRegID*//* 697(*/0xB9, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207391 */   GIR_AddSimpleTempRegister, /*InsnID*//* 698(*/0xBA, 0x05/*)*/, /*TempRegID*//* 698(*/0xBA, 0x05/*)*/,
     /* 207396 */   GIR_AddSimpleTempRegister, /*InsnID*//* 698(*/0xBA, 0x05/*)*/, /*TempRegID*//* 699(*/0xBB, 0x05/*)*/,
     /* 207401 */   GIR_AddImm8, /*InsnID*//* 698(*/0xBA, 0x05/*)*/, /*Imm*/1,
     /* 207405 */   GIR_ConstrainOperandRC, /*InsnID*//* 698(*/0xBA, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 207411 */   GIR_ConstrainOperandRC, /*InsnID*//* 698(*/0xBA, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 207417 */   GIR_ConstrainOperandRC, /*InsnID*//* 698(*/0xBA, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 207423 */   GIR_MakeTempReg, /*TempRegID*//* 696(*/0xB8, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207427 */   GIR_BuildMI, /*InsnID*//* 697(*/0xB9, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 207432 */   GIR_AddTempRegister, /*InsnID*//* 697(*/0xB9, 0x05/*)*/, /*TempRegID*//* 696(*/0xB8, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207439 */   GIR_AddSimpleTempRegister, /*InsnID*//* 697(*/0xB9, 0x05/*)*/, /*TempRegID*//* 697(*/0xB9, 0x05/*)*/,
     /* 207444 */   GIR_AddImm8, /*InsnID*//* 697(*/0xB9, 0x05/*)*/, /*Imm*/32,
     /* 207448 */   GIR_AddImm8, /*InsnID*//* 697(*/0xB9, 0x05/*)*/, /*Imm*/31,
     /* 207452 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 697(*/0xB9, 0x05/*)*/,
     /* 207455 */   GIR_MakeTempReg, /*TempRegID*//* 695(*/0xB7, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207459 */   GIR_BuildMI, /*InsnID*//* 696(*/0xB8, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 207464 */   GIR_AddTempRegister, /*InsnID*//* 696(*/0xB8, 0x05/*)*/, /*TempRegID*//* 695(*/0xB7, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207471 */   GIR_AddSimpleTempRegister, /*InsnID*//* 696(*/0xB8, 0x05/*)*/, /*TempRegID*//* 696(*/0xB8, 0x05/*)*/,
     /* 207476 */   GIR_AddImm, /*InsnID*//* 696(*/0xB8, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 207487 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 696(*/0xB8, 0x05/*)*/,
     /* 207490 */   GIR_MakeTempReg, /*TempRegID*//* 694(*/0xB6, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207494 */   GIR_BuildMI, /*InsnID*//* 695(*/0xB7, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 207499 */   GIR_AddTempRegister, /*InsnID*//* 695(*/0xB7, 0x05/*)*/, /*TempRegID*//* 694(*/0xB6, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207506 */   GIR_AddSimpleTempRegister, /*InsnID*//* 695(*/0xB7, 0x05/*)*/, /*TempRegID*//* 695(*/0xB7, 0x05/*)*/,
     /* 207511 */   GIR_AddImm, /*InsnID*//* 695(*/0xB7, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 207522 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 695(*/0xB7, 0x05/*)*/,
     /* 207525 */   GIR_MakeTempReg, /*TempRegID*//* 693(*/0xB5, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207529 */   GIR_BuildMI, /*InsnID*//* 694(*/0xB6, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 207534 */   GIR_AddTempRegister, /*InsnID*//* 694(*/0xB6, 0x05/*)*/, /*TempRegID*//* 693(*/0xB5, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207541 */   GIR_Copy, /*NewInsnID*//* 694(*/0xB6, 0x05/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 207546 */   GIR_AddImm8, /*InsnID*//* 694(*/0xB6, 0x05/*)*/, /*Imm*/63,
     /* 207550 */   GIR_AddImm8, /*InsnID*//* 694(*/0xB6, 0x05/*)*/, /*Imm*/1,
     /* 207554 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 694(*/0xB6, 0x05/*)*/,
     /* 207557 */   GIR_MakeTempReg, /*TempRegID*//* 692(*/0xB4, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207561 */   GIR_BuildMI, /*InsnID*//* 693(*/0xB5, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 207566 */   GIR_AddTempRegister, /*InsnID*//* 693(*/0xB5, 0x05/*)*/, /*TempRegID*//* 692(*/0xB4, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207573 */   GIR_AddSimpleTempRegister, /*InsnID*//* 693(*/0xB5, 0x05/*)*/, /*TempRegID*//* 693(*/0xB5, 0x05/*)*/,
     /* 207578 */   GIR_AddSimpleTempRegister, /*InsnID*//* 693(*/0xB5, 0x05/*)*/, /*TempRegID*//* 694(*/0xB6, 0x05/*)*/,
     /* 207583 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 693(*/0xB5, 0x05/*)*/,
     /* 207586 */   GIR_MakeTempReg, /*TempRegID*//* 691(*/0xB3, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207590 */   GIR_BuildMI, /*InsnID*//* 692(*/0xB4, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 207595 */   GIR_AddTempRegister, /*InsnID*//* 692(*/0xB4, 0x05/*)*/, /*TempRegID*//* 691(*/0xB3, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207602 */   GIR_AddSimpleTempRegister, /*InsnID*//* 692(*/0xB4, 0x05/*)*/, /*TempRegID*//* 692(*/0xB4, 0x05/*)*/,
     /* 207607 */   GIR_AddSimpleTempRegister, /*InsnID*//* 692(*/0xB4, 0x05/*)*/, /*TempRegID*//* 701(*/0xBD, 0x05/*)*/,
     /* 207612 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 692(*/0xB4, 0x05/*)*/,
     /* 207615 */   GIR_MakeTempReg, /*TempRegID*//* 690(*/0xB2, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207619 */   GIR_BuildMI, /*InsnID*//* 691(*/0xB3, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 207624 */   GIR_AddTempRegister, /*InsnID*//* 691(*/0xB3, 0x05/*)*/, /*TempRegID*//* 690(*/0xB2, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207631 */   GIR_AddSimpleTempRegister, /*InsnID*//* 691(*/0xB3, 0x05/*)*/, /*TempRegID*//* 691(*/0xB3, 0x05/*)*/,
     /* 207636 */   GIR_AddImm8, /*InsnID*//* 691(*/0xB3, 0x05/*)*/, /*Imm*/62,
     /* 207640 */   GIR_AddImm8, /*InsnID*//* 691(*/0xB3, 0x05/*)*/, /*Imm*/2,
     /* 207644 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 691(*/0xB3, 0x05/*)*/,
     /* 207647 */   GIR_MakeTempReg, /*TempRegID*//* 689(*/0xB1, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207651 */   GIR_BuildMI, /*InsnID*//* 690(*/0xB2, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 207656 */   GIR_AddTempRegister, /*InsnID*//* 690(*/0xB2, 0x05/*)*/, /*TempRegID*//* 689(*/0xB1, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207663 */   GIR_AddSimpleTempRegister, /*InsnID*//* 690(*/0xB2, 0x05/*)*/, /*TempRegID*//* 690(*/0xB2, 0x05/*)*/,
     /* 207668 */   GIR_AddSimpleTempRegister, /*InsnID*//* 690(*/0xB2, 0x05/*)*/, /*TempRegID*//* 710(*/0xC6, 0x05/*)*/,
     /* 207673 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 690(*/0xB2, 0x05/*)*/,
     /* 207676 */   GIR_MakeTempReg, /*TempRegID*//* 688(*/0xB0, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207680 */   GIR_BuildMI, /*InsnID*//* 689(*/0xB1, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 207685 */   GIR_AddTempRegister, /*InsnID*//* 689(*/0xB1, 0x05/*)*/, /*TempRegID*//* 688(*/0xB0, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207692 */   GIR_AddSimpleTempRegister, /*InsnID*//* 689(*/0xB1, 0x05/*)*/, /*TempRegID*//* 689(*/0xB1, 0x05/*)*/,
     /* 207697 */   GIR_AddSimpleTempRegister, /*InsnID*//* 689(*/0xB1, 0x05/*)*/, /*TempRegID*//* 717(*/0xCD, 0x05/*)*/,
     /* 207702 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 689(*/0xB1, 0x05/*)*/,
     /* 207705 */   GIR_MakeTempReg, /*TempRegID*//* 687(*/0xAF, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207709 */   GIR_BuildMI, /*InsnID*//* 688(*/0xB0, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 207714 */   GIR_AddTempRegister, /*InsnID*//* 688(*/0xB0, 0x05/*)*/, /*TempRegID*//* 687(*/0xAF, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207721 */   GIR_AddSimpleTempRegister, /*InsnID*//* 688(*/0xB0, 0x05/*)*/, /*TempRegID*//* 688(*/0xB0, 0x05/*)*/,
     /* 207726 */   GIR_AddImm8, /*InsnID*//* 688(*/0xB0, 0x05/*)*/, /*Imm*/60,
     /* 207730 */   GIR_AddImm8, /*InsnID*//* 688(*/0xB0, 0x05/*)*/, /*Imm*/4,
     /* 207734 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 688(*/0xB0, 0x05/*)*/,
     /* 207737 */   GIR_MakeTempReg, /*TempRegID*//* 686(*/0xAE, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207741 */   GIR_BuildMI, /*InsnID*//* 687(*/0xAF, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 207746 */   GIR_AddTempRegister, /*InsnID*//* 687(*/0xAF, 0x05/*)*/, /*TempRegID*//* 686(*/0xAE, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207753 */   GIR_AddSimpleTempRegister, /*InsnID*//* 687(*/0xAF, 0x05/*)*/, /*TempRegID*//* 687(*/0xAF, 0x05/*)*/,
     /* 207758 */   GIR_AddSimpleTempRegister, /*InsnID*//* 687(*/0xAF, 0x05/*)*/, /*TempRegID*//* 745(*/0xE9, 0x05/*)*/,
     /* 207763 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 687(*/0xAF, 0x05/*)*/,
     /* 207766 */   GIR_MakeTempReg, /*TempRegID*//* 685(*/0xAD, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207770 */   GIR_BuildMI, /*InsnID*//* 686(*/0xAE, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 207775 */   GIR_AddTempRegister, /*InsnID*//* 686(*/0xAE, 0x05/*)*/, /*TempRegID*//* 685(*/0xAD, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207782 */   GIR_AddSimpleTempRegister, /*InsnID*//* 686(*/0xAE, 0x05/*)*/, /*TempRegID*//* 686(*/0xAE, 0x05/*)*/,
     /* 207787 */   GIR_AddSimpleTempRegister, /*InsnID*//* 686(*/0xAE, 0x05/*)*/, /*TempRegID*//* 752(*/0xF0, 0x05/*)*/,
     /* 207792 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 686(*/0xAE, 0x05/*)*/,
     /* 207795 */   GIR_MakeTempReg, /*TempRegID*//* 684(*/0xAC, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207799 */   GIR_BuildMI, /*InsnID*//* 685(*/0xAD, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 207804 */   GIR_AddTempRegister, /*InsnID*//* 685(*/0xAD, 0x05/*)*/, /*TempRegID*//* 684(*/0xAC, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207811 */   GIR_AddSimpleTempRegister, /*InsnID*//* 685(*/0xAD, 0x05/*)*/, /*TempRegID*//* 685(*/0xAD, 0x05/*)*/,
     /* 207816 */   GIR_AddImm8, /*InsnID*//* 685(*/0xAD, 0x05/*)*/, /*Imm*/32,
     /* 207820 */   GIR_AddImm8, /*InsnID*//* 685(*/0xAD, 0x05/*)*/, /*Imm*/32,
     /* 207824 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 685(*/0xAD, 0x05/*)*/,
     /* 207827 */   GIR_MakeTempReg, /*TempRegID*//* 683(*/0xAB, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 207831 */   GIR_BuildMI, /*InsnID*//* 684(*/0xAC, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 207836 */   GIR_AddTempRegister, /*InsnID*//* 684(*/0xAC, 0x05/*)*/, /*TempRegID*//* 683(*/0xAB, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207843 */   GIR_AddTempSubRegister, /*InsnID*//* 684(*/0xAC, 0x05/*)*/, /*TempRegID*//* 684(*/0xAC, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 207852 */   GIR_ConstrainOperandRC, /*InsnID*//* 684(*/0xAC, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 207858 */   GIR_ConstrainOperandRC, /*InsnID*//* 684(*/0xAC, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 207864 */   GIR_MakeTempReg, /*TempRegID*//* 548(*/0xA4, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 207868 */   GIR_BuildMI, /*InsnID*//* 549(*/0xA5, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 207873 */   GIR_AddTempRegister, /*InsnID*//* 549(*/0xA5, 0x04/*)*/, /*TempRegID*//* 548(*/0xA4, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207880 */   GIR_AddTempSubRegister, /*InsnID*//* 549(*/0xA5, 0x04/*)*/, /*TempRegID*//* 549(*/0xA5, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 207889 */   GIR_ConstrainOperandRC, /*InsnID*//* 549(*/0xA5, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 207895 */   GIR_ConstrainOperandRC, /*InsnID*//* 549(*/0xA5, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 207901 */   GIR_MakeTempReg, /*TempRegID*//* 413(*/0x9D, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 207905 */   GIR_BuildMI, /*InsnID*//* 414(*/0x9E, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 207910 */   GIR_AddTempRegister, /*InsnID*//* 414(*/0x9E, 0x03/*)*/, /*TempRegID*//* 413(*/0x9D, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207917 */   GIR_AddTempSubRegister, /*InsnID*//* 414(*/0x9E, 0x03/*)*/, /*TempRegID*//* 414(*/0x9E, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 207926 */   GIR_ConstrainOperandRC, /*InsnID*//* 414(*/0x9E, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 207932 */   GIR_ConstrainOperandRC, /*InsnID*//* 414(*/0x9E, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 207938 */   GIR_MakeTempReg, /*TempRegID*//* 412(*/0x9C, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 207942 */   GIR_BuildMI, /*InsnID*//* 413(*/0x9D, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 207947 */   GIR_AddTempRegister, /*InsnID*//* 413(*/0x9D, 0x03/*)*/, /*TempRegID*//* 412(*/0x9C, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207954 */   GIR_AddSimpleTempRegister, /*InsnID*//* 413(*/0x9D, 0x03/*)*/, /*TempRegID*//* 413(*/0x9D, 0x03/*)*/,
     /* 207959 */   GIR_AddImm8, /*InsnID*//* 413(*/0x9D, 0x03/*)*/, /*Imm*/24,
     /* 207963 */   GIR_AddImm8, /*InsnID*//* 413(*/0x9D, 0x03/*)*/, /*Imm*/0,
     /* 207967 */   GIR_AddImm8, /*InsnID*//* 413(*/0x9D, 0x03/*)*/, /*Imm*/31,
     /* 207971 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 413(*/0x9D, 0x03/*)*/,
     /* 207974 */   GIR_MakeTempReg, /*TempRegID*//* 411(*/0x9B, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 207978 */   GIR_BuildMI, /*InsnID*//* 412(*/0x9C, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWIMI),
     /* 207983 */   GIR_AddTempRegister, /*InsnID*//* 412(*/0x9C, 0x03/*)*/, /*TempRegID*//* 411(*/0x9B, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207990 */   GIR_AddSimpleTempRegister, /*InsnID*//* 412(*/0x9C, 0x03/*)*/, /*TempRegID*//* 412(*/0x9C, 0x03/*)*/,
     /* 207995 */   GIR_AddSimpleTempRegister, /*InsnID*//* 412(*/0x9C, 0x03/*)*/, /*TempRegID*//* 548(*/0xA4, 0x04/*)*/,
     /* 208000 */   GIR_AddImm8, /*InsnID*//* 412(*/0x9C, 0x03/*)*/, /*Imm*/8,
     /* 208004 */   GIR_AddImm8, /*InsnID*//* 412(*/0x9C, 0x03/*)*/, /*Imm*/8,
     /* 208008 */   GIR_AddImm8, /*InsnID*//* 412(*/0x9C, 0x03/*)*/, /*Imm*/15,
     /* 208012 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 412(*/0x9C, 0x03/*)*/,
     /* 208015 */   GIR_MakeTempReg, /*TempRegID*//* 410(*/0x9A, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 208019 */   GIR_BuildMI, /*InsnID*//* 411(*/0x9B, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWIMI),
     /* 208024 */   GIR_AddTempRegister, /*InsnID*//* 411(*/0x9B, 0x03/*)*/, /*TempRegID*//* 410(*/0x9A, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208031 */   GIR_AddSimpleTempRegister, /*InsnID*//* 411(*/0x9B, 0x03/*)*/, /*TempRegID*//* 411(*/0x9B, 0x03/*)*/,
     /* 208036 */   GIR_AddSimpleTempRegister, /*InsnID*//* 411(*/0x9B, 0x03/*)*/, /*TempRegID*//* 683(*/0xAB, 0x05/*)*/,
     /* 208041 */   GIR_AddImm8, /*InsnID*//* 411(*/0x9B, 0x03/*)*/, /*Imm*/8,
     /* 208045 */   GIR_AddImm8, /*InsnID*//* 411(*/0x9B, 0x03/*)*/, /*Imm*/24,
     /* 208049 */   GIR_AddImm8, /*InsnID*//* 411(*/0x9B, 0x03/*)*/, /*Imm*/31,
     /* 208053 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 411(*/0x9B, 0x03/*)*/,
     /* 208056 */   GIR_MakeTempReg, /*TempRegID*//* 409(*/0x99, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 208060 */   GIR_BuildMI, /*InsnID*//* 410(*/0x9A, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 208065 */   GIR_AddTempRegister, /*InsnID*//* 410(*/0x9A, 0x03/*)*/, /*TempRegID*//* 409(*/0x99, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208072 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 410(*/0x9A, 0x03/*)*/,
     /* 208075 */   GIR_MakeTempReg, /*TempRegID*//* 408(*/0x98, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 208079 */   GIR_BuildMI, /*InsnID*//* 409(*/0x99, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 208084 */   GIR_AddTempRegister, /*InsnID*//* 409(*/0x99, 0x03/*)*/, /*TempRegID*//* 408(*/0x98, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208091 */   GIR_AddSimpleTempRegister, /*InsnID*//* 409(*/0x99, 0x03/*)*/, /*TempRegID*//* 409(*/0x99, 0x03/*)*/,
     /* 208096 */   GIR_AddSimpleTempRegister, /*InsnID*//* 409(*/0x99, 0x03/*)*/, /*TempRegID*//* 410(*/0x9A, 0x03/*)*/,
     /* 208101 */   GIR_AddImm8, /*InsnID*//* 409(*/0x99, 0x03/*)*/, /*Imm*/1,
     /* 208105 */   GIR_ConstrainOperandRC, /*InsnID*//* 409(*/0x99, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 208111 */   GIR_ConstrainOperandRC, /*InsnID*//* 409(*/0x99, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 208117 */   GIR_ConstrainOperandRC, /*InsnID*//* 409(*/0x99, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 208123 */   GIR_MakeTempReg, /*TempRegID*//* 274(*/0x92, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 208127 */   GIR_BuildMI, /*InsnID*//* 275(*/0x93, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 208132 */   GIR_AddTempRegister, /*InsnID*//* 275(*/0x93, 0x02/*)*/, /*TempRegID*//* 274(*/0x92, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208139 */   GIR_AddTempSubRegister, /*InsnID*//* 275(*/0x93, 0x02/*)*/, /*TempRegID*//* 275(*/0x93, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 208148 */   GIR_ConstrainOperandRC, /*InsnID*//* 275(*/0x93, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 208154 */   GIR_ConstrainOperandRC, /*InsnID*//* 275(*/0x93, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 208160 */   GIR_MakeTempReg, /*TempRegID*//* 140(*/0x8C, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 208164 */   GIR_BuildMI, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 208169 */   GIR_AddTempRegister, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*TempRegID*//* 140(*/0x8C, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208176 */   GIR_AddTempSubRegister, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*TempRegID*//* 141(*/0x8D, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 208185 */   GIR_ConstrainOperandRC, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 208191 */   GIR_ConstrainOperandRC, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 208197 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /* 208200 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 208204 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208209 */   GIR_AddTempSubRegister, /*InsnID*/7, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 208216 */   GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 208221 */   GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 208226 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /* 208229 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 208233 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208238 */   GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 208241 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/24,
     /* 208244 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/0,
     /* 208247 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/31,
     /* 208250 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 208252 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 208255 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(PPC::RLWIMI),
     /* 208259 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208264 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 208267 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*//* 140(*/0x8C, 0x01/*)*/,
     /* 208271 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/8,
     /* 208274 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/8,
     /* 208277 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/15,
     /* 208280 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 208282 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 208285 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::RLWIMI),
     /* 208289 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208294 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 208297 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*//* 274(*/0x92, 0x02/*)*/,
     /* 208301 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/8,
     /* 208304 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/24,
     /* 208307 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/31,
     /* 208310 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 208312 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 208315 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 208319 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208324 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 208326 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 208329 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 208333 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208338 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 208341 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 208344 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 208347 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 208352 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 208357 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 208362 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 208365 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 208369 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208374 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 208377 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 208380 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 208383 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 208385 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 208388 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 208390 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 208393 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*//* 408(*/0x98, 0x03/*)*/,
     /* 208397 */   GIR_RootConstrainSelectedInstOperands,
     /* 208398 */   // GIR_Coverage, 4891,
     /* 208398 */   GIR_EraseRootFromParent_Done,
     /* 208399 */ // Label 2770: @208399
     /* 208399 */ GIM_Reject,
     /* 208400 */ // Label 2766: @208400
     /* 208400 */ GIM_Reject,
     /* 208401 */ // Label 71: @208401
     /* 208401 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2776*/ GIMT_Encode4(208675),
     /* 208412 */ /*GILLT_s32*//*Label 2771*/ GIMT_Encode4(208432),
     /* 208416 */ /*GILLT_s64*//*Label 2772*/ GIMT_Encode4(208525),
     /* 208420 */ /*GILLT_s128*//*Label 2773*/ GIMT_Encode4(208573),
     /* 208424 */ /*GILLT_v2s64*//*Label 2774*/ GIMT_Encode4(208604),
     /* 208428 */ /*GILLT_v4s32*//*Label 2775*/ GIMT_Encode4(208627),
     /* 208432 */ // Label 2771: @208432
     /* 208432 */ GIM_Try, /*On fail goto*//*Label 2777*/ GIMT_Encode4(208524),
     /* 208437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 208440 */   GIM_Try, /*On fail goto*//*Label 2778*/ GIMT_Encode4(208504), // Rule ID 1711 //
     /* 208445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 208448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 208452 */     // (fceil:{ *:[f32] } f32:{ *:[f32] }:$S)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSRDPIP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 208452 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 208455 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 208459 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208464 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 208468 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 208473 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 208476 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSRDPIP),
     /* 208480 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208485 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 208488 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 208490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 208493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208495 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 208498 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 208503 */     // GIR_Coverage, 1711,
     /* 208503 */     GIR_EraseRootFromParent_Done,
     /* 208504 */   // Label 2778: @208504
     /* 208504 */   GIM_Try, /*On fail goto*//*Label 2779*/ GIMT_Encode4(208523), // Rule ID 146 //
     /* 208509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 208512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 208516 */     // (fceil:{ *:[f32] } f32:{ *:[f32] }:$RB)  =>  (FRIPS:{ *:[f32] } f32:{ *:[f32] }:$RB)
     /* 208516 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FRIPS),
     /* 208521 */     GIR_RootConstrainSelectedInstOperands,
     /* 208522 */     // GIR_Coverage, 146,
     /* 208522 */     GIR_Done,
     /* 208523 */   // Label 2779: @208523
     /* 208523 */   GIM_Reject,
     /* 208524 */ // Label 2777: @208524
     /* 208524 */ GIM_Reject,
     /* 208525 */ // Label 2772: @208525
     /* 208525 */ GIM_Try, /*On fail goto*//*Label 2780*/ GIMT_Encode4(208572),
     /* 208530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 208533 */   GIM_Try, /*On fail goto*//*Label 2781*/ GIMT_Encode4(208552), // Rule ID 913 //
     /* 208538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 208541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 208545 */     // (fceil:{ *:[f64] } f64:{ *:[f64] }:$XB)  =>  (XSRDPIP:{ *:[f64] } f64:{ *:[f64] }:$XB)
     /* 208545 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSRDPIP),
     /* 208550 */     GIR_RootConstrainSelectedInstOperands,
     /* 208551 */     // GIR_Coverage, 913,
     /* 208551 */     GIR_Done,
     /* 208552 */   // Label 2781: @208552
     /* 208552 */   GIM_Try, /*On fail goto*//*Label 2782*/ GIMT_Encode4(208571), // Rule ID 144 //
     /* 208557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 208560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 208564 */     // (fceil:{ *:[f64] } f64:{ *:[f64] }:$RB)  =>  (FRIPD:{ *:[f64] } f64:{ *:[f64] }:$RB)
     /* 208564 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FRIPD),
     /* 208569 */     GIR_RootConstrainSelectedInstOperands,
     /* 208570 */     // GIR_Coverage, 144,
     /* 208570 */     GIR_Done,
     /* 208571 */   // Label 2782: @208571
     /* 208571 */   GIM_Reject,
     /* 208572 */ // Label 2780: @208572
     /* 208572 */ GIM_Reject,
     /* 208573 */ // Label 2773: @208573
     /* 208573 */ GIM_Try, /*On fail goto*//*Label 2783*/ GIMT_Encode4(208603), // Rule ID 2166 //
     /* 208578 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 208581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 208584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 208588 */   // (fceil:{ *:[f128] } f128:{ *:[f128] }:$vB)  =>  (XSRQPI:{ *:[f128] } 1:{ *:[i32] }, ?:{ *:[f128] }:$vB, 2:{ *:[i32] })
     /* 208588 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSRQPI),
     /* 208591 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VRT]
     /* 208593 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 208596 */   GIR_RootToRootCopy, /*OpIdx*/1, // vB
     /* 208598 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 208601 */   GIR_RootConstrainSelectedInstOperands,
     /* 208602 */   // GIR_Coverage, 2166,
     /* 208602 */   GIR_EraseRootFromParent_Done,
     /* 208603 */ // Label 2783: @208603
     /* 208603 */ GIM_Reject,
     /* 208604 */ // Label 2774: @208604
     /* 208604 */ GIM_Try, /*On fail goto*//*Label 2784*/ GIMT_Encode4(208626), // Rule ID 921 //
     /* 208609 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 208612 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 208615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 208619 */   // (fceil:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)  =>  (XVRDPIP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)
     /* 208619 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRDPIP),
     /* 208624 */   GIR_RootConstrainSelectedInstOperands,
     /* 208625 */   // GIR_Coverage, 921,
     /* 208625 */   GIR_Done,
     /* 208626 */ // Label 2784: @208626
     /* 208626 */ GIM_Reject,
     /* 208627 */ // Label 2775: @208627
     /* 208627 */ GIM_Try, /*On fail goto*//*Label 2785*/ GIMT_Encode4(208674),
     /* 208632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 208635 */   GIM_Try, /*On fail goto*//*Label 2786*/ GIMT_Encode4(208654), // Rule ID 929 //
     /* 208640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 208643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 208647 */     // (fceil:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)  =>  (XVRSPIP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)
     /* 208647 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRSPIP),
     /* 208652 */     GIR_RootConstrainSelectedInstOperands,
     /* 208653 */     // GIR_Coverage, 929,
     /* 208653 */     GIR_Done,
     /* 208654 */   // Label 2786: @208654
     /* 208654 */   GIM_Try, /*On fail goto*//*Label 2787*/ GIMT_Encode4(208673), // Rule ID 1420 //
     /* 208659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 208662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 208666 */     // (fceil:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$vA)  =>  (VRFIP:{ *:[v4f32] } ?:{ *:[v4f32] }:$vA)
     /* 208666 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VRFIP),
     /* 208671 */     GIR_RootConstrainSelectedInstOperands,
     /* 208672 */     // GIR_Coverage, 1420,
     /* 208672 */     GIR_Done,
     /* 208673 */   // Label 2787: @208673
     /* 208673 */   GIM_Reject,
     /* 208674 */ // Label 2785: @208674
     /* 208674 */ GIM_Reject,
     /* 208675 */ // Label 2776: @208675
     /* 208675 */ GIM_Reject,
     /* 208676 */ // Label 72: @208676
     /* 208676 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2793*/ GIMT_Encode4(208892),
     /* 208687 */ /*GILLT_s32*//*Label 2788*/ GIMT_Encode4(208707),
     /* 208691 */ /*GILLT_s64*//*Label 2789*/ GIMT_Encode4(208759),
     /* 208695 */ /*GILLT_s128*//*Label 2790*/ GIMT_Encode4(208815),
     /* 208699 */ /*GILLT_v2s64*//*Label 2791*/ GIMT_Encode4(208838),
     /* 208703 */ /*GILLT_v4s32*//*Label 2792*/ GIMT_Encode4(208865),
     /* 208707 */ // Label 2788: @208707
     /* 208707 */ GIM_Try, /*On fail goto*//*Label 2794*/ GIMT_Encode4(208758),
     /* 208712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 208715 */   GIM_Try, /*On fail goto*//*Label 2795*/ GIMT_Encode4(208734), // Rule ID 964 //
     /* 208720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 208723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 208727 */     // (fsqrt:{ *:[f32] } f32:{ *:[f32] }:$XB)  =>  (XSSQRTSP:{ *:[f32] } f32:{ *:[f32] }:$XB)
     /* 208727 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSQRTSP),
     /* 208732 */     GIR_RootConstrainSelectedInstOperands,
     /* 208733 */     // GIR_Coverage, 964,
     /* 208733 */     GIR_Done,
     /* 208734 */   // Label 2795: @208734
     /* 208734 */   GIM_Try, /*On fail goto*//*Label 2796*/ GIMT_Encode4(208757), // Rule ID 162 //
     /* 208739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 208742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 208746 */     // (fsqrt:{ *:[f32] } f32:{ *:[f32] }:$RB)  =>  (FSQRTS:{ *:[f32] } f32:{ *:[f32] }:$RB)
     /* 208746 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FSQRTS),
     /* 208751 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 208755 */     GIR_RootConstrainSelectedInstOperands,
     /* 208756 */     // GIR_Coverage, 162,
     /* 208756 */     GIR_Done,
     /* 208757 */   // Label 2796: @208757
     /* 208757 */   GIM_Reject,
     /* 208758 */ // Label 2794: @208758
     /* 208758 */ GIM_Reject,
     /* 208759 */ // Label 2789: @208759
     /* 208759 */ GIM_Try, /*On fail goto*//*Label 2797*/ GIMT_Encode4(208814),
     /* 208764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 208767 */   GIM_Try, /*On fail goto*//*Label 2798*/ GIMT_Encode4(208790), // Rule ID 813 //
     /* 208772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 208775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 208779 */     // (fsqrt:{ *:[f64] } f64:{ *:[f64] }:$XB)  =>  (XSSQRTDP:{ *:[f64] } f64:{ *:[f64] }:$XB)
     /* 208779 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSQRTDP),
     /* 208784 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 208788 */     GIR_RootConstrainSelectedInstOperands,
     /* 208789 */     // GIR_Coverage, 813,
     /* 208789 */     GIR_Done,
     /* 208790 */   // Label 2798: @208790
     /* 208790 */   GIM_Try, /*On fail goto*//*Label 2799*/ GIMT_Encode4(208813), // Rule ID 160 //
     /* 208795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 208798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 208802 */     // (fsqrt:{ *:[f64] } f64:{ *:[f64] }:$RB)  =>  (FSQRT:{ *:[f64] } f64:{ *:[f64] }:$RB)
     /* 208802 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FSQRT),
     /* 208807 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 208811 */     GIR_RootConstrainSelectedInstOperands,
     /* 208812 */     // GIR_Coverage, 160,
     /* 208812 */     GIR_Done,
     /* 208813 */   // Label 2799: @208813
     /* 208813 */   GIM_Reject,
     /* 208814 */ // Label 2797: @208814
     /* 208814 */ GIM_Reject,
     /* 208815 */ // Label 2790: @208815
     /* 208815 */ GIM_Try, /*On fail goto*//*Label 2800*/ GIMT_Encode4(208837), // Rule ID 996 //
     /* 208820 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 208823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 208826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 208830 */   // (fsqrt:{ *:[f128] } f128:{ *:[f128] }:$RB)  =>  (XSSQRTQP:{ *:[f128] } f128:{ *:[f128] }:$RB)
     /* 208830 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSQRTQP),
     /* 208835 */   GIR_RootConstrainSelectedInstOperands,
     /* 208836 */   // GIR_Coverage, 996,
     /* 208836 */   GIR_Done,
     /* 208837 */ // Label 2800: @208837
     /* 208837 */ GIM_Reject,
     /* 208838 */ // Label 2791: @208838
     /* 208838 */ GIM_Try, /*On fail goto*//*Label 2801*/ GIMT_Encode4(208864), // Rule ID 824 //
     /* 208843 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 208846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 208849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 208853 */   // (fsqrt:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)  =>  (XVSQRTDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)
     /* 208853 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVSQRTDP),
     /* 208858 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 208862 */   GIR_RootConstrainSelectedInstOperands,
     /* 208863 */   // GIR_Coverage, 824,
     /* 208863 */   GIR_Done,
     /* 208864 */ // Label 2801: @208864
     /* 208864 */ GIM_Reject,
     /* 208865 */ // Label 2792: @208865
     /* 208865 */ GIM_Try, /*On fail goto*//*Label 2802*/ GIMT_Encode4(208891), // Rule ID 826 //
     /* 208870 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 208873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 208876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 208880 */   // (fsqrt:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)  =>  (XVSQRTSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)
     /* 208880 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVSQRTSP),
     /* 208885 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 208889 */   GIR_RootConstrainSelectedInstOperands,
     /* 208890 */   // GIR_Coverage, 826,
     /* 208890 */   GIR_Done,
     /* 208891 */ // Label 2802: @208891
     /* 208891 */ GIM_Reject,
     /* 208892 */ // Label 2793: @208892
     /* 208892 */ GIM_Reject,
     /* 208893 */ // Label 73: @208893
     /* 208893 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2808*/ GIMT_Encode4(209167),
     /* 208904 */ /*GILLT_s32*//*Label 2803*/ GIMT_Encode4(208924),
     /* 208908 */ /*GILLT_s64*//*Label 2804*/ GIMT_Encode4(209017),
     /* 208912 */ /*GILLT_s128*//*Label 2805*/ GIMT_Encode4(209065),
     /* 208916 */ /*GILLT_v2s64*//*Label 2806*/ GIMT_Encode4(209096),
     /* 208920 */ /*GILLT_v4s32*//*Label 2807*/ GIMT_Encode4(209119),
     /* 208924 */ // Label 2803: @208924
     /* 208924 */ GIM_Try, /*On fail goto*//*Label 2809*/ GIMT_Encode4(209016),
     /* 208929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 208932 */   GIM_Try, /*On fail goto*//*Label 2810*/ GIMT_Encode4(208996), // Rule ID 1709 //
     /* 208937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 208940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 208944 */     // (ffloor:{ *:[f32] } f32:{ *:[f32] }:$S)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSRDPIM:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 208944 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 208947 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 208951 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208956 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 208960 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 208965 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 208968 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSRDPIM),
     /* 208972 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208977 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 208980 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 208982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 208985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208987 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 208990 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 208995 */     // GIR_Coverage, 1709,
     /* 208995 */     GIR_EraseRootFromParent_Done,
     /* 208996 */   // Label 2810: @208996
     /* 208996 */   GIM_Try, /*On fail goto*//*Label 2811*/ GIMT_Encode4(209015), // Rule ID 154 //
     /* 209001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 209004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 209008 */     // (ffloor:{ *:[f32] } f32:{ *:[f32] }:$RB)  =>  (FRIMS:{ *:[f32] } f32:{ *:[f32] }:$RB)
     /* 209008 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FRIMS),
     /* 209013 */     GIR_RootConstrainSelectedInstOperands,
     /* 209014 */     // GIR_Coverage, 154,
     /* 209014 */     GIR_Done,
     /* 209015 */   // Label 2811: @209015
     /* 209015 */   GIM_Reject,
     /* 209016 */ // Label 2809: @209016
     /* 209016 */ GIM_Reject,
     /* 209017 */ // Label 2804: @209017
     /* 209017 */ GIM_Try, /*On fail goto*//*Label 2812*/ GIMT_Encode4(209064),
     /* 209022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 209025 */   GIM_Try, /*On fail goto*//*Label 2813*/ GIMT_Encode4(209044), // Rule ID 911 //
     /* 209030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 209033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 209037 */     // (ffloor:{ *:[f64] } f64:{ *:[f64] }:$XB)  =>  (XSRDPIM:{ *:[f64] } f64:{ *:[f64] }:$XB)
     /* 209037 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSRDPIM),
     /* 209042 */     GIR_RootConstrainSelectedInstOperands,
     /* 209043 */     // GIR_Coverage, 911,
     /* 209043 */     GIR_Done,
     /* 209044 */   // Label 2813: @209044
     /* 209044 */   GIM_Try, /*On fail goto*//*Label 2814*/ GIMT_Encode4(209063), // Rule ID 152 //
     /* 209049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 209052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 209056 */     // (ffloor:{ *:[f64] } f64:{ *:[f64] }:$RB)  =>  (FRIMD:{ *:[f64] } f64:{ *:[f64] }:$RB)
     /* 209056 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FRIMD),
     /* 209061 */     GIR_RootConstrainSelectedInstOperands,
     /* 209062 */     // GIR_Coverage, 152,
     /* 209062 */     GIR_Done,
     /* 209063 */   // Label 2814: @209063
     /* 209063 */   GIM_Reject,
     /* 209064 */ // Label 2812: @209064
     /* 209064 */ GIM_Reject,
     /* 209065 */ // Label 2805: @209065
     /* 209065 */ GIM_Try, /*On fail goto*//*Label 2815*/ GIMT_Encode4(209095), // Rule ID 2168 //
     /* 209070 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 209073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 209076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 209080 */   // (ffloor:{ *:[f128] } f128:{ *:[f128] }:$vB)  =>  (XSRQPI:{ *:[f128] } 1:{ *:[i32] }, ?:{ *:[f128] }:$vB, 3:{ *:[i32] })
     /* 209080 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSRQPI),
     /* 209083 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VRT]
     /* 209085 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 209088 */   GIR_RootToRootCopy, /*OpIdx*/1, // vB
     /* 209090 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 209093 */   GIR_RootConstrainSelectedInstOperands,
     /* 209094 */   // GIR_Coverage, 2168,
     /* 209094 */   GIR_EraseRootFromParent_Done,
     /* 209095 */ // Label 2815: @209095
     /* 209095 */ GIM_Reject,
     /* 209096 */ // Label 2806: @209096
     /* 209096 */ GIM_Try, /*On fail goto*//*Label 2816*/ GIMT_Encode4(209118), // Rule ID 919 //
     /* 209101 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 209104 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 209107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 209111 */   // (ffloor:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)  =>  (XVRDPIM:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)
     /* 209111 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRDPIM),
     /* 209116 */   GIR_RootConstrainSelectedInstOperands,
     /* 209117 */   // GIR_Coverage, 919,
     /* 209117 */   GIR_Done,
     /* 209118 */ // Label 2816: @209118
     /* 209118 */ GIM_Reject,
     /* 209119 */ // Label 2807: @209119
     /* 209119 */ GIM_Try, /*On fail goto*//*Label 2817*/ GIMT_Encode4(209166),
     /* 209124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 209127 */   GIM_Try, /*On fail goto*//*Label 2818*/ GIMT_Encode4(209146), // Rule ID 927 //
     /* 209132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 209135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 209139 */     // (ffloor:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)  =>  (XVRSPIM:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)
     /* 209139 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRSPIM),
     /* 209144 */     GIR_RootConstrainSelectedInstOperands,
     /* 209145 */     // GIR_Coverage, 927,
     /* 209145 */     GIR_Done,
     /* 209146 */   // Label 2818: @209146
     /* 209146 */   GIM_Try, /*On fail goto*//*Label 2819*/ GIMT_Encode4(209165), // Rule ID 1419 //
     /* 209151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 209154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 209158 */     // (ffloor:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$vA)  =>  (VRFIM:{ *:[v4f32] } ?:{ *:[v4f32] }:$vA)
     /* 209158 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VRFIM),
     /* 209163 */     GIR_RootConstrainSelectedInstOperands,
     /* 209164 */     // GIR_Coverage, 1419,
     /* 209164 */     GIR_Done,
     /* 209165 */   // Label 2819: @209165
     /* 209165 */   GIM_Reject,
     /* 209166 */ // Label 2817: @209166
     /* 209166 */ GIM_Reject,
     /* 209167 */ // Label 2808: @209167
     /* 209167 */ GIM_Reject,
     /* 209168 */ // Label 74: @209168
     /* 209168 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2825*/ GIMT_Encode4(209379),
     /* 209179 */ /*GILLT_s32*//*Label 2820*/ GIMT_Encode4(209199),
     /* 209183 */ /*GILLT_s64*//*Label 2821*/ GIMT_Encode4(209267),
     /* 209187 */ /*GILLT_s128*//*Label 2822*/ GIMT_Encode4(209294),
     /* 209191 */ /*GILLT_v2s64*//*Label 2823*/ GIMT_Encode4(209325),
     /* 209195 */ /*GILLT_v4s32*//*Label 2824*/ GIMT_Encode4(209352),
     /* 209199 */ // Label 2820: @209199
     /* 209199 */ GIM_Try, /*On fail goto*//*Label 2826*/ GIMT_Encode4(209266), // Rule ID 1715 //
     /* 209204 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 209207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 209210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 209214 */   // (frint:{ *:[f32] } f32:{ *:[f32] }:$S)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSRDPIC:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 209214 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 209217 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 209221 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 209226 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 209230 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 209235 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 209238 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSRDPIC),
     /* 209242 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 209247 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 209250 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 209252 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 209255 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209257 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 209260 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 209265 */   // GIR_Coverage, 1715,
     /* 209265 */   GIR_EraseRootFromParent_Done,
     /* 209266 */ // Label 2826: @209266
     /* 209266 */ GIM_Reject,
     /* 209267 */ // Label 2821: @209267
     /* 209267 */ GIM_Try, /*On fail goto*//*Label 2827*/ GIMT_Encode4(209293), // Rule ID 1719 //
     /* 209272 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 209275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 209278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 209282 */   // (frint:{ *:[f64] } f64:{ *:[f64] }:$S)  =>  (XSRDPIC:{ *:[f64] } ?:{ *:[f64] }:$S)
     /* 209282 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSRDPIC),
     /* 209287 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209291 */   GIR_RootConstrainSelectedInstOperands,
     /* 209292 */   // GIR_Coverage, 1719,
     /* 209292 */   GIR_Done,
     /* 209293 */ // Label 2827: @209293
     /* 209293 */ GIM_Reject,
     /* 209294 */ // Label 2822: @209294
     /* 209294 */ GIM_Try, /*On fail goto*//*Label 2828*/ GIMT_Encode4(209324), // Rule ID 2170 //
     /* 209299 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 209302 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 209305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 209309 */   // (frint:{ *:[f128] } f128:{ *:[f128] }:$vB)  =>  (XSRQPIX:{ *:[f128] } 0:{ *:[i32] }, ?:{ *:[f128] }:$vB, 3:{ *:[i32] })
     /* 209309 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSRQPIX),
     /* 209312 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VRT]
     /* 209314 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209317 */   GIR_RootToRootCopy, /*OpIdx*/1, // vB
     /* 209319 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 209322 */   GIR_RootConstrainSelectedInstOperands,
     /* 209323 */   // GIR_Coverage, 2170,
     /* 209323 */   GIR_EraseRootFromParent_Done,
     /* 209324 */ // Label 2828: @209324
     /* 209324 */ GIM_Reject,
     /* 209325 */ // Label 2823: @209325
     /* 209325 */ GIM_Try, /*On fail goto*//*Label 2829*/ GIMT_Encode4(209351), // Rule ID 1721 //
     /* 209330 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 209333 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 209336 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 209340 */   // (frint:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$S)  =>  (XVRDPIC:{ *:[v2f64] } ?:{ *:[v2f64] }:$S)
     /* 209340 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRDPIC),
     /* 209345 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209349 */   GIR_RootConstrainSelectedInstOperands,
     /* 209350 */   // GIR_Coverage, 1721,
     /* 209350 */   GIR_Done,
     /* 209351 */ // Label 2829: @209351
     /* 209351 */ GIM_Reject,
     /* 209352 */ // Label 2824: @209352
     /* 209352 */ GIM_Try, /*On fail goto*//*Label 2830*/ GIMT_Encode4(209378), // Rule ID 1717 //
     /* 209357 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 209360 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 209363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 209367 */   // (frint:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$S)  =>  (XVRSPIC:{ *:[v4f32] } ?:{ *:[v4f32] }:$S)
     /* 209367 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRSPIC),
     /* 209372 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209376 */   GIR_RootConstrainSelectedInstOperands,
     /* 209377 */   // GIR_Coverage, 1717,
     /* 209377 */   GIR_Done,
     /* 209378 */ // Label 2830: @209378
     /* 209378 */ GIM_Reject,
     /* 209379 */ // Label 2825: @209379
     /* 209379 */ GIM_Reject,
     /* 209380 */ // Label 75: @209380
     /* 209380 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2836*/ GIMT_Encode4(209616),
     /* 209391 */ /*GILLT_s32*//*Label 2831*/ GIMT_Encode4(209411),
     /* 209395 */ /*GILLT_s64*//*Label 2832*/ GIMT_Encode4(209479),
     /* 209399 */ /*GILLT_s128*//*Label 2833*/ GIMT_Encode4(209506),
     /* 209403 */ /*GILLT_v2s64*//*Label 2834*/ GIMT_Encode4(209537),
     /* 209407 */ /*GILLT_v4s32*//*Label 2835*/ GIMT_Encode4(209564),
     /* 209411 */ // Label 2831: @209411
     /* 209411 */ GIM_Try, /*On fail goto*//*Label 2837*/ GIMT_Encode4(209478), // Rule ID 1722 //
     /* 209416 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 209419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 209422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 209426 */   // (fnearbyint:{ *:[f32] } f32:{ *:[f32] }:$S)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSRDPIC:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 209426 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 209429 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 209433 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 209438 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 209442 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 209447 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 209450 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSRDPIC),
     /* 209454 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 209459 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 209462 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 209464 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 209467 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209469 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 209472 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 209477 */   // GIR_Coverage, 1722,
     /* 209477 */   GIR_EraseRootFromParent_Done,
     /* 209478 */ // Label 2837: @209478
     /* 209478 */ GIM_Reject,
     /* 209479 */ // Label 2832: @209479
     /* 209479 */ GIM_Try, /*On fail goto*//*Label 2838*/ GIMT_Encode4(209505), // Rule ID 1723 //
     /* 209484 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 209487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 209490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 209494 */   // (fnearbyint:{ *:[f64] } f64:{ *:[f64] }:$S)  =>  (XSRDPIC:{ *:[f64] } ?:{ *:[f64] }:$S)
     /* 209494 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSRDPIC),
     /* 209499 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209503 */   GIR_RootConstrainSelectedInstOperands,
     /* 209504 */   // GIR_Coverage, 1723,
     /* 209504 */   GIR_Done,
     /* 209505 */ // Label 2838: @209505
     /* 209505 */ GIM_Reject,
     /* 209506 */ // Label 2833: @209506
     /* 209506 */ GIM_Try, /*On fail goto*//*Label 2839*/ GIMT_Encode4(209536), // Rule ID 2160 //
     /* 209511 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 209514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 209517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 209521 */   // (fnearbyint:{ *:[f128] } f128:{ *:[f128] }:$vB)  =>  (XSRQPI:{ *:[f128] } 0:{ *:[i32] }, ?:{ *:[f128] }:$vB, 3:{ *:[i32] })
     /* 209521 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSRQPI),
     /* 209524 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VRT]
     /* 209526 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209529 */   GIR_RootToRootCopy, /*OpIdx*/1, // vB
     /* 209531 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 209534 */   GIR_RootConstrainSelectedInstOperands,
     /* 209535 */   // GIR_Coverage, 2160,
     /* 209535 */   GIR_EraseRootFromParent_Done,
     /* 209536 */ // Label 2839: @209536
     /* 209536 */ GIM_Reject,
     /* 209537 */ // Label 2834: @209537
     /* 209537 */ GIM_Try, /*On fail goto*//*Label 2840*/ GIMT_Encode4(209563), // Rule ID 1724 //
     /* 209542 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 209545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 209548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 209552 */   // (fnearbyint:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$S)  =>  (XVRDPIC:{ *:[v2f64] } ?:{ *:[v2f64] }:$S)
     /* 209552 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRDPIC),
     /* 209557 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209561 */   GIR_RootConstrainSelectedInstOperands,
     /* 209562 */   // GIR_Coverage, 1724,
     /* 209562 */   GIR_Done,
     /* 209563 */ // Label 2840: @209563
     /* 209563 */ GIM_Reject,
     /* 209564 */ // Label 2835: @209564
     /* 209564 */ GIM_Try, /*On fail goto*//*Label 2841*/ GIMT_Encode4(209615),
     /* 209569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 209572 */   GIM_Try, /*On fail goto*//*Label 2842*/ GIMT_Encode4(209595), // Rule ID 1725 //
     /* 209577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 209580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 209584 */     // (fnearbyint:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$S)  =>  (XVRSPIC:{ *:[v4f32] } ?:{ *:[v4f32] }:$S)
     /* 209584 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRSPIC),
     /* 209589 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209593 */     GIR_RootConstrainSelectedInstOperands,
     /* 209594 */     // GIR_Coverage, 1725,
     /* 209594 */     GIR_Done,
     /* 209595 */   // Label 2842: @209595
     /* 209595 */   GIM_Try, /*On fail goto*//*Label 2843*/ GIMT_Encode4(209614), // Rule ID 1422 //
     /* 209600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 209603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 209607 */     // (fnearbyint:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$vA)  =>  (VRFIN:{ *:[v4f32] } ?:{ *:[v4f32] }:$vA)
     /* 209607 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VRFIN),
     /* 209612 */     GIR_RootConstrainSelectedInstOperands,
     /* 209613 */     // GIR_Coverage, 1422,
     /* 209613 */     GIR_Done,
     /* 209614 */   // Label 2843: @209614
     /* 209614 */   GIM_Reject,
     /* 209615 */ // Label 2841: @209615
     /* 209615 */ GIM_Reject,
     /* 209616 */ // Label 2836: @209616
     /* 209616 */ GIM_Reject,
     /* 209617 */ // Label 76: @209617
     /* 209617 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2849*/ GIMT_Encode4(209886),
     /* 209628 */ /*GILLT_s32*//*Label 2844*/ GIMT_Encode4(209648),
     /* 209632 */ /*GILLT_s64*//*Label 2845*/ GIMT_Encode4(209722),
     /* 209636 */ /*GILLT_s128*//*Label 2846*/ GIMT_Encode4(209800),
     /* 209640 */ /*GILLT_v2s64*//*Label 2847*/ GIMT_Encode4(209826),
     /* 209644 */ /*GILLT_v4s32*//*Label 2848*/ GIMT_Encode4(209856),
     /* 209648 */ // Label 2844: @209648
     /* 209648 */ GIM_Try, /*On fail goto*//*Label 2850*/ GIMT_Encode4(209721),
     /* 209653 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 209656 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 209659 */   GIM_Try, /*On fail goto*//*Label 2851*/ GIMT_Encode4(209678), // Rule ID 952 //
     /* 209664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 209667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 209671 */     // (strict_fadd:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)  =>  (XSADDSP:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 209671 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSADDSP),
     /* 209676 */     GIR_RootConstrainSelectedInstOperands,
     /* 209677 */     // GIR_Coverage, 952,
     /* 209677 */     GIR_Done,
     /* 209678 */   // Label 2851: @209678
     /* 209678 */   GIM_Try, /*On fail goto*//*Label 2852*/ GIMT_Encode4(209701), // Rule ID 238 //
     /* 209683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 209686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 209690 */     // (strict_fadd:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)  =>  (FADDS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)
     /* 209690 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FADDS),
     /* 209695 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209699 */     GIR_RootConstrainSelectedInstOperands,
     /* 209700 */     // GIR_Coverage, 238,
     /* 209700 */     GIR_Done,
     /* 209701 */   // Label 2852: @209701
     /* 209701 */   GIM_Try, /*On fail goto*//*Label 2853*/ GIMT_Encode4(209720), // Rule ID 582 //
     /* 209706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 209709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 209713 */     // (strict_fadd:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)  =>  (EFSADD:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)
     /* 209713 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSADD),
     /* 209718 */     GIR_RootConstrainSelectedInstOperands,
     /* 209719 */     // GIR_Coverage, 582,
     /* 209719 */     GIR_Done,
     /* 209720 */   // Label 2853: @209720
     /* 209720 */   GIM_Reject,
     /* 209721 */ // Label 2850: @209721
     /* 209721 */ GIM_Reject,
     /* 209722 */ // Label 2845: @209722
     /* 209722 */ GIM_Try, /*On fail goto*//*Label 2854*/ GIMT_Encode4(209799),
     /* 209727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 209730 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 209733 */   GIM_Try, /*On fail goto*//*Label 2855*/ GIMT_Encode4(209756), // Rule ID 769 //
     /* 209738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 209741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 209745 */     // (strict_fadd:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)  =>  (XSADDDP:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 209745 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSADDDP),
     /* 209750 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209754 */     GIR_RootConstrainSelectedInstOperands,
     /* 209755 */     // GIR_Coverage, 769,
     /* 209755 */     GIR_Done,
     /* 209756 */   // Label 2855: @209756
     /* 209756 */   GIM_Try, /*On fail goto*//*Label 2856*/ GIMT_Encode4(209779), // Rule ID 236 //
     /* 209761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 209764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 209768 */     // (strict_fadd:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)  =>  (FADD:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)
     /* 209768 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FADD),
     /* 209773 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209777 */     GIR_RootConstrainSelectedInstOperands,
     /* 209778 */     // GIR_Coverage, 236,
     /* 209778 */     GIR_Done,
     /* 209779 */   // Label 2856: @209779
     /* 209779 */   GIM_Try, /*On fail goto*//*Label 2857*/ GIMT_Encode4(209798), // Rule ID 561 //
     /* 209784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 209787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 209791 */     // (strict_fadd:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)  =>  (EFDADD:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)
     /* 209791 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDADD),
     /* 209796 */     GIR_RootConstrainSelectedInstOperands,
     /* 209797 */     // GIR_Coverage, 561,
     /* 209797 */     GIR_Done,
     /* 209798 */   // Label 2857: @209798
     /* 209798 */   GIM_Reject,
     /* 209799 */ // Label 2854: @209799
     /* 209799 */ GIM_Reject,
     /* 209800 */ // Label 2846: @209800
     /* 209800 */ GIM_Try, /*On fail goto*//*Label 2858*/ GIMT_Encode4(209825), // Rule ID 987 //
     /* 209805 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 209808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 209811 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 209814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 209818 */   // (strict_fadd:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSADDQP:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 209818 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSADDQP),
     /* 209823 */   GIR_RootConstrainSelectedInstOperands,
     /* 209824 */   // GIR_Coverage, 987,
     /* 209824 */   GIR_Done,
     /* 209825 */ // Label 2858: @209825
     /* 209825 */ GIM_Reject,
     /* 209826 */ // Label 2847: @209826
     /* 209826 */ GIM_Try, /*On fail goto*//*Label 2859*/ GIMT_Encode4(209855), // Rule ID 773 //
     /* 209831 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 209834 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 209837 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 209840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 209844 */   // (strict_fadd:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)  =>  (XVADDDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 209844 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVADDDP),
     /* 209849 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209853 */   GIR_RootConstrainSelectedInstOperands,
     /* 209854 */   // GIR_Coverage, 773,
     /* 209854 */   GIR_Done,
     /* 209855 */ // Label 2859: @209855
     /* 209855 */ GIM_Reject,
     /* 209856 */ // Label 2848: @209856
     /* 209856 */ GIM_Try, /*On fail goto*//*Label 2860*/ GIMT_Encode4(209885), // Rule ID 775 //
     /* 209861 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 209864 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 209867 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 209870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 209874 */   // (strict_fadd:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)  =>  (XVADDSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 209874 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVADDSP),
     /* 209879 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209883 */   GIR_RootConstrainSelectedInstOperands,
     /* 209884 */   // GIR_Coverage, 775,
     /* 209884 */   GIR_Done,
     /* 209885 */ // Label 2860: @209885
     /* 209885 */ GIM_Reject,
     /* 209886 */ // Label 2849: @209886
     /* 209886 */ GIM_Reject,
     /* 209887 */ // Label 77: @209887
     /* 209887 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2866*/ GIMT_Encode4(210156),
     /* 209898 */ /*GILLT_s32*//*Label 2861*/ GIMT_Encode4(209918),
     /* 209902 */ /*GILLT_s64*//*Label 2862*/ GIMT_Encode4(209992),
     /* 209906 */ /*GILLT_s128*//*Label 2863*/ GIMT_Encode4(210070),
     /* 209910 */ /*GILLT_v2s64*//*Label 2864*/ GIMT_Encode4(210096),
     /* 209914 */ /*GILLT_v4s32*//*Label 2865*/ GIMT_Encode4(210126),
     /* 209918 */ // Label 2861: @209918
     /* 209918 */ GIM_Try, /*On fail goto*//*Label 2867*/ GIMT_Encode4(209991),
     /* 209923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 209926 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 209929 */   GIM_Try, /*On fail goto*//*Label 2868*/ GIMT_Encode4(209948), // Rule ID 956 //
     /* 209934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 209937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 209941 */     // (strict_fsub:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)  =>  (XSSUBSP:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 209941 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSUBSP),
     /* 209946 */     GIR_RootConstrainSelectedInstOperands,
     /* 209947 */     // GIR_Coverage, 956,
     /* 209947 */     GIR_Done,
     /* 209948 */   // Label 2868: @209948
     /* 209948 */   GIM_Try, /*On fail goto*//*Label 2869*/ GIMT_Encode4(209971), // Rule ID 250 //
     /* 209953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 209956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 209960 */     // (strict_fsub:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)  =>  (FSUBS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)
     /* 209960 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FSUBS),
     /* 209965 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209969 */     GIR_RootConstrainSelectedInstOperands,
     /* 209970 */     // GIR_Coverage, 250,
     /* 209970 */     GIR_Done,
     /* 209971 */   // Label 2869: @209971
     /* 209971 */   GIM_Try, /*On fail goto*//*Label 2870*/ GIMT_Encode4(209990), // Rule ID 600 //
     /* 209976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 209979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 209983 */     // (strict_fsub:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)  =>  (EFSSUB:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)
     /* 209983 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSSUB),
     /* 209988 */     GIR_RootConstrainSelectedInstOperands,
     /* 209989 */     // GIR_Coverage, 600,
     /* 209989 */     GIR_Done,
     /* 209990 */   // Label 2870: @209990
     /* 209990 */   GIM_Reject,
     /* 209991 */ // Label 2867: @209991
     /* 209991 */ GIM_Reject,
     /* 209992 */ // Label 2862: @209992
     /* 209992 */ GIM_Try, /*On fail goto*//*Label 2871*/ GIMT_Encode4(210069),
     /* 209997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 210000 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 210003 */   GIM_Try, /*On fail goto*//*Label 2872*/ GIMT_Encode4(210026), // Rule ID 781 //
     /* 210008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 210011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 210015 */     // (strict_fsub:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)  =>  (XSSUBDP:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 210015 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSUBDP),
     /* 210020 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 210024 */     GIR_RootConstrainSelectedInstOperands,
     /* 210025 */     // GIR_Coverage, 781,
     /* 210025 */     GIR_Done,
     /* 210026 */   // Label 2872: @210026
     /* 210026 */   GIM_Try, /*On fail goto*//*Label 2873*/ GIMT_Encode4(210049), // Rule ID 248 //
     /* 210031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 210034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 210038 */     // (strict_fsub:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)  =>  (FSUB:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)
     /* 210038 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FSUB),
     /* 210043 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 210047 */     GIR_RootConstrainSelectedInstOperands,
     /* 210048 */     // GIR_Coverage, 248,
     /* 210048 */     GIR_Done,
     /* 210049 */   // Label 2873: @210049
     /* 210049 */   GIM_Try, /*On fail goto*//*Label 2874*/ GIMT_Encode4(210068), // Rule ID 579 //
     /* 210054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 210057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 210061 */     // (strict_fsub:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)  =>  (EFDSUB:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)
     /* 210061 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDSUB),
     /* 210066 */     GIR_RootConstrainSelectedInstOperands,
     /* 210067 */     // GIR_Coverage, 579,
     /* 210067 */     GIR_Done,
     /* 210068 */   // Label 2874: @210068
     /* 210068 */   GIM_Reject,
     /* 210069 */ // Label 2871: @210069
     /* 210069 */ GIM_Reject,
     /* 210070 */ // Label 2863: @210070
     /* 210070 */ GIM_Try, /*On fail goto*//*Label 2875*/ GIMT_Encode4(210095), // Rule ID 991 //
     /* 210075 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 210078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 210081 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 210084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 210088 */   // (strict_fsub:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSSUBQP:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 210088 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSUBQP),
     /* 210093 */   GIR_RootConstrainSelectedInstOperands,
     /* 210094 */   // GIR_Coverage, 991,
     /* 210094 */   GIR_Done,
     /* 210095 */ // Label 2875: @210095
     /* 210095 */ GIM_Reject,
     /* 210096 */ // Label 2864: @210096
     /* 210096 */ GIM_Try, /*On fail goto*//*Label 2876*/ GIMT_Encode4(210125), // Rule ID 783 //
     /* 210101 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 210104 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 210107 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 210110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 210114 */   // (strict_fsub:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)  =>  (XVSUBDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 210114 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVSUBDP),
     /* 210119 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 210123 */   GIR_RootConstrainSelectedInstOperands,
     /* 210124 */   // GIR_Coverage, 783,
     /* 210124 */   GIR_Done,
     /* 210125 */ // Label 2876: @210125
     /* 210125 */ GIM_Reject,
     /* 210126 */ // Label 2865: @210126
     /* 210126 */ GIM_Try, /*On fail goto*//*Label 2877*/ GIMT_Encode4(210155), // Rule ID 785 //
     /* 210131 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 210134 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 210137 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 210140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 210144 */   // (strict_fsub:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)  =>  (XVSUBSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 210144 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVSUBSP),
     /* 210149 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 210153 */   GIR_RootConstrainSelectedInstOperands,
     /* 210154 */   // GIR_Coverage, 785,
     /* 210154 */   GIR_Done,
     /* 210155 */ // Label 2877: @210155
     /* 210155 */ GIM_Reject,
     /* 210156 */ // Label 2866: @210156
     /* 210156 */ GIM_Reject,
     /* 210157 */ // Label 78: @210157
     /* 210157 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2883*/ GIMT_Encode4(210426),
     /* 210168 */ /*GILLT_s32*//*Label 2878*/ GIMT_Encode4(210188),
     /* 210172 */ /*GILLT_s64*//*Label 2879*/ GIMT_Encode4(210262),
     /* 210176 */ /*GILLT_s128*//*Label 2880*/ GIMT_Encode4(210340),
     /* 210180 */ /*GILLT_v2s64*//*Label 2881*/ GIMT_Encode4(210366),
     /* 210184 */ /*GILLT_v4s32*//*Label 2882*/ GIMT_Encode4(210396),
     /* 210188 */ // Label 2878: @210188
     /* 210188 */ GIM_Try, /*On fail goto*//*Label 2884*/ GIMT_Encode4(210261),
     /* 210193 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 210196 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 210199 */   GIM_Try, /*On fail goto*//*Label 2885*/ GIMT_Encode4(210218), // Rule ID 954 //
     /* 210204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 210207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 210211 */     // (strict_fmul:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)  =>  (XSMULSP:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 210211 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSMULSP),
     /* 210216 */     GIR_RootConstrainSelectedInstOperands,
     /* 210217 */     // GIR_Coverage, 954,
     /* 210217 */     GIR_Done,
     /* 210218 */   // Label 2885: @210218
     /* 210218 */   GIM_Try, /*On fail goto*//*Label 2886*/ GIMT_Encode4(210241), // Rule ID 246 //
     /* 210223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 210226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 210230 */     // (strict_fmul:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC)  =>  (FMULS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC)
     /* 210230 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FMULS),
     /* 210235 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 210239 */     GIR_RootConstrainSelectedInstOperands,
     /* 210240 */     // GIR_Coverage, 246,
     /* 210240 */     GIR_Done,
     /* 210241 */   // Label 2886: @210241
     /* 210241 */   GIM_Try, /*On fail goto*//*Label 2887*/ GIMT_Encode4(210260), // Rule ID 596 //
     /* 210246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 210249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 210253 */     // (strict_fmul:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)  =>  (EFSMUL:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)
     /* 210253 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSMUL),
     /* 210258 */     GIR_RootConstrainSelectedInstOperands,
     /* 210259 */     // GIR_Coverage, 596,
     /* 210259 */     GIR_Done,
     /* 210260 */   // Label 2887: @210260
     /* 210260 */   GIM_Reject,
     /* 210261 */ // Label 2884: @210261
     /* 210261 */ GIM_Reject,
     /* 210262 */ // Label 2879: @210262
     /* 210262 */ GIM_Try, /*On fail goto*//*Label 2888*/ GIMT_Encode4(210339),
     /* 210267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 210270 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 210273 */   GIM_Try, /*On fail goto*//*Label 2889*/ GIMT_Encode4(210296), // Rule ID 771 //
     /* 210278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 210281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 210285 */     // (strict_fmul:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)  =>  (XSMULDP:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 210285 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSMULDP),
     /* 210290 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 210294 */     GIR_RootConstrainSelectedInstOperands,
     /* 210295 */     // GIR_Coverage, 771,
     /* 210295 */     GIR_Done,
     /* 210296 */   // Label 2889: @210296
     /* 210296 */   GIM_Try, /*On fail goto*//*Label 2890*/ GIMT_Encode4(210319), // Rule ID 244 //
     /* 210301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 210304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 210308 */     // (strict_fmul:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC)  =>  (FMUL:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC)
     /* 210308 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FMUL),
     /* 210313 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 210317 */     GIR_RootConstrainSelectedInstOperands,
     /* 210318 */     // GIR_Coverage, 244,
     /* 210318 */     GIR_Done,
     /* 210319 */   // Label 2890: @210319
     /* 210319 */   GIM_Try, /*On fail goto*//*Label 2891*/ GIMT_Encode4(210338), // Rule ID 575 //
     /* 210324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 210327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 210331 */     // (strict_fmul:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)  =>  (EFDMUL:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)
     /* 210331 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDMUL),
     /* 210336 */     GIR_RootConstrainSelectedInstOperands,
     /* 210337 */     // GIR_Coverage, 575,
     /* 210337 */     GIR_Done,
     /* 210338 */   // Label 2891: @210338
     /* 210338 */   GIM_Reject,
     /* 210339 */ // Label 2888: @210339
     /* 210339 */ GIM_Reject,
     /* 210340 */ // Label 2880: @210340
     /* 210340 */ GIM_Try, /*On fail goto*//*Label 2892*/ GIMT_Encode4(210365), // Rule ID 989 //
     /* 210345 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 210348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 210351 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 210354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 210358 */   // (strict_fmul:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSMULQP:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 210358 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSMULQP),
     /* 210363 */   GIR_RootConstrainSelectedInstOperands,
     /* 210364 */   // GIR_Coverage, 989,
     /* 210364 */   GIR_Done,
     /* 210365 */ // Label 2892: @210365
     /* 210365 */ GIM_Reject,
     /* 210366 */ // Label 2881: @210366
     /* 210366 */ GIM_Try, /*On fail goto*//*Label 2893*/ GIMT_Encode4(210395), // Rule ID 777 //
     /* 210371 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 210374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 210377 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 210380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 210384 */   // (strict_fmul:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)  =>  (XVMULDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 210384 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVMULDP),
     /* 210389 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 210393 */   GIR_RootConstrainSelectedInstOperands,
     /* 210394 */   // GIR_Coverage, 777,
     /* 210394 */   GIR_Done,
     /* 210395 */ // Label 2893: @210395
     /* 210395 */ GIM_Reject,
     /* 210396 */ // Label 2882: @210396
     /* 210396 */ GIM_Try, /*On fail goto*//*Label 2894*/ GIMT_Encode4(210425), // Rule ID 779 //
     /* 210401 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 210404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 210407 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 210410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 210414 */   // (strict_fmul:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)  =>  (XVMULSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 210414 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVMULSP),
     /* 210419 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 210423 */   GIR_RootConstrainSelectedInstOperands,
     /* 210424 */   // GIR_Coverage, 779,
     /* 210424 */   GIR_Done,
     /* 210425 */ // Label 2894: @210425
     /* 210425 */ GIM_Reject,
     /* 210426 */ // Label 2883: @210426
     /* 210426 */ GIM_Reject,
     /* 210427 */ // Label 79: @210427
     /* 210427 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2900*/ GIMT_Encode4(210696),
     /* 210438 */ /*GILLT_s32*//*Label 2895*/ GIMT_Encode4(210458),
     /* 210442 */ /*GILLT_s64*//*Label 2896*/ GIMT_Encode4(210532),
     /* 210446 */ /*GILLT_s128*//*Label 2897*/ GIMT_Encode4(210610),
     /* 210450 */ /*GILLT_v2s64*//*Label 2898*/ GIMT_Encode4(210636),
     /* 210454 */ /*GILLT_v4s32*//*Label 2899*/ GIMT_Encode4(210666),
     /* 210458 */ // Label 2895: @210458
     /* 210458 */ GIM_Try, /*On fail goto*//*Label 2901*/ GIMT_Encode4(210531),
     /* 210463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 210466 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 210469 */   GIM_Try, /*On fail goto*//*Label 2902*/ GIMT_Encode4(210488), // Rule ID 958 //
     /* 210474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 210477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 210481 */     // (strict_fdiv:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)  =>  (XSDIVSP:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 210481 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSDIVSP),
     /* 210486 */     GIR_RootConstrainSelectedInstOperands,
     /* 210487 */     // GIR_Coverage, 958,
     /* 210487 */     GIR_Done,
     /* 210488 */   // Label 2902: @210488
     /* 210488 */   GIM_Try, /*On fail goto*//*Label 2903*/ GIMT_Encode4(210511), // Rule ID 242 //
     /* 210493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 210496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 210500 */     // (strict_fdiv:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)  =>  (FDIVS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)
     /* 210500 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FDIVS),
     /* 210505 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 210509 */     GIR_RootConstrainSelectedInstOperands,
     /* 210510 */     // GIR_Coverage, 242,
     /* 210510 */     GIR_Done,
     /* 210511 */   // Label 2903: @210511
     /* 210511 */   GIM_Try, /*On fail goto*//*Label 2904*/ GIMT_Encode4(210530), // Rule ID 594 //
     /* 210516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 210519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 210523 */     // (strict_fdiv:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)  =>  (EFSDIV:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)
     /* 210523 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSDIV),
     /* 210528 */     GIR_RootConstrainSelectedInstOperands,
     /* 210529 */     // GIR_Coverage, 594,
     /* 210529 */     GIR_Done,
     /* 210530 */   // Label 2904: @210530
     /* 210530 */   GIM_Reject,
     /* 210531 */ // Label 2901: @210531
     /* 210531 */ GIM_Reject,
     /* 210532 */ // Label 2896: @210532
     /* 210532 */ GIM_Try, /*On fail goto*//*Label 2905*/ GIMT_Encode4(210609),
     /* 210537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 210540 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 210543 */   GIM_Try, /*On fail goto*//*Label 2906*/ GIMT_Encode4(210566), // Rule ID 810 //
     /* 210548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 210551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 210555 */     // (strict_fdiv:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)  =>  (XSDIVDP:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 210555 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSDIVDP),
     /* 210560 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 210564 */     GIR_RootConstrainSelectedInstOperands,
     /* 210565 */     // GIR_Coverage, 810,
     /* 210565 */     GIR_Done,
     /* 210566 */   // Label 2906: @210566
     /* 210566 */   GIM_Try, /*On fail goto*//*Label 2907*/ GIMT_Encode4(210589), // Rule ID 240 //
     /* 210571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 210574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 210578 */     // (strict_fdiv:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)  =>  (FDIV:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)
     /* 210578 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FDIV),
     /* 210583 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 210587 */     GIR_RootConstrainSelectedInstOperands,
     /* 210588 */     // GIR_Coverage, 240,
     /* 210588 */     GIR_Done,
     /* 210589 */   // Label 2907: @210589
     /* 210589 */   GIM_Try, /*On fail goto*//*Label 2908*/ GIMT_Encode4(210608), // Rule ID 573 //
     /* 210594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 210597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 210601 */     // (strict_fdiv:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)  =>  (EFDDIV:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)
     /* 210601 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDDIV),
     /* 210606 */     GIR_RootConstrainSelectedInstOperands,
     /* 210607 */     // GIR_Coverage, 573,
     /* 210607 */     GIR_Done,
     /* 210608 */   // Label 2908: @210608
     /* 210608 */   GIM_Reject,
     /* 210609 */ // Label 2905: @210609
     /* 210609 */ GIM_Reject,
     /* 210610 */ // Label 2897: @210610
     /* 210610 */ GIM_Try, /*On fail goto*//*Label 2909*/ GIMT_Encode4(210635), // Rule ID 993 //
     /* 210615 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 210618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 210621 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 210624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 210628 */   // (strict_fdiv:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSDIVQP:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 210628 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSDIVQP),
     /* 210633 */   GIR_RootConstrainSelectedInstOperands,
     /* 210634 */   // GIR_Coverage, 993,
     /* 210634 */   GIR_Done,
     /* 210635 */ // Label 2909: @210635
     /* 210635 */ GIM_Reject,
     /* 210636 */ // Label 2898: @210636
     /* 210636 */ GIM_Try, /*On fail goto*//*Label 2910*/ GIMT_Encode4(210665), // Rule ID 819 //
     /* 210641 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 210644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 210647 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 210650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 210654 */   // (strict_fdiv:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)  =>  (XVDIVDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 210654 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVDIVDP),
     /* 210659 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 210663 */   GIR_RootConstrainSelectedInstOperands,
     /* 210664 */   // GIR_Coverage, 819,
     /* 210664 */   GIR_Done,
     /* 210665 */ // Label 2910: @210665
     /* 210665 */ GIM_Reject,
     /* 210666 */ // Label 2899: @210666
     /* 210666 */ GIM_Try, /*On fail goto*//*Label 2911*/ GIMT_Encode4(210695), // Rule ID 821 //
     /* 210671 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 210674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 210677 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 210680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 210684 */   // (strict_fdiv:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)  =>  (XVDIVSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 210684 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVDIVSP),
     /* 210689 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 210693 */   GIR_RootConstrainSelectedInstOperands,
     /* 210694 */   // GIR_Coverage, 821,
     /* 210694 */   GIR_Done,
     /* 210695 */ // Label 2911: @210695
     /* 210695 */ GIM_Reject,
     /* 210696 */ // Label 2900: @210696
     /* 210696 */ GIM_Reject,
     /* 210697 */ // Label 80: @210697
     /* 210697 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2917*/ GIMT_Encode4(211254),
     /* 210708 */ /*GILLT_s32*//*Label 2912*/ GIMT_Encode4(210728),
     /* 210712 */ /*GILLT_s64*//*Label 2913*/ GIMT_Encode4(210874),
     /* 210716 */ /*GILLT_s128*//*Label 2914*/ GIMT_Encode4(211020),
     /* 210720 */ /*GILLT_v2s64*//*Label 2915*/ GIMT_Encode4(211098),
     /* 210724 */ /*GILLT_v4s32*//*Label 2916*/ GIMT_Encode4(211176),
     /* 210728 */ // Label 2912: @210728
     /* 210728 */ GIM_Try, /*On fail goto*//*Label 2918*/ GIMT_Encode4(210873),
     /* 210733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 210736 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 210739 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 210742 */   GIM_Try, /*On fail goto*//*Label 2919*/ GIMT_Encode4(210783), // Rule ID 968 //
     /* 210747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 210750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 210754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 210758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 210762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 210766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210768 */     // (strict_fma:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB, (fneg:{ *:[f32] } f32:{ *:[f32] }:$XTi))  =>  (XSMSUBASP:{ *:[f32] } f32:{ *:[f32] }:$XTi, f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 210768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMSUBASP),
     /* 210771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 210773 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XTi
     /* 210777 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 210779 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 210781 */     GIR_RootConstrainSelectedInstOperands,
     /* 210782 */     // GIR_Coverage, 968,
     /* 210782 */     GIR_EraseRootFromParent_Done,
     /* 210783 */   // Label 2919: @210783
     /* 210783 */   GIM_Try, /*On fail goto*//*Label 2920*/ GIMT_Encode4(210808), // Rule ID 966 //
     /* 210788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 210791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 210795 */     // (strict_fma:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB, f32:{ *:[f32] }:$XTi)  =>  (XSMADDASP:{ *:[f32] } f32:{ *:[f32] }:$XTi, f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 210795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMADDASP),
     /* 210798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 210800 */     GIR_RootToRootCopy, /*OpIdx*/3, // XTi
     /* 210802 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 210804 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 210806 */     GIR_RootConstrainSelectedInstOperands,
     /* 210807 */     // GIR_Coverage, 966,
     /* 210807 */     GIR_EraseRootFromParent_Done,
     /* 210808 */   // Label 2920: @210808
     /* 210808 */   GIM_Try, /*On fail goto*//*Label 2921*/ GIMT_Encode4(210849), // Rule ID 224 //
     /* 210813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 210816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 210820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 210824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 210828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 210832 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210834 */     // (strict_fma:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, (fneg:{ *:[f32] } f32:{ *:[f32] }:$FRB))  =>  (FMSUBS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB)
     /* 210834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FMSUBS),
     /* 210837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 210839 */     GIR_RootToRootCopy, /*OpIdx*/1, // FRA
     /* 210841 */     GIR_RootToRootCopy, /*OpIdx*/2, // FRC
     /* 210843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRB
     /* 210847 */     GIR_RootConstrainSelectedInstOperands,
     /* 210848 */     // GIR_Coverage, 224,
     /* 210848 */     GIR_EraseRootFromParent_Done,
     /* 210849 */   // Label 2921: @210849
     /* 210849 */   GIM_Try, /*On fail goto*//*Label 2922*/ GIMT_Encode4(210872), // Rule ID 220 //
     /* 210854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 210857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 210861 */     // (strict_fma:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB)  =>  (FMADDS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB)
     /* 210861 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FMADDS),
     /* 210866 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 210870 */     GIR_RootConstrainSelectedInstOperands,
     /* 210871 */     // GIR_Coverage, 220,
     /* 210871 */     GIR_Done,
     /* 210872 */   // Label 2922: @210872
     /* 210872 */   GIM_Reject,
     /* 210873 */ // Label 2918: @210873
     /* 210873 */ GIM_Reject,
     /* 210874 */ // Label 2913: @210874
     /* 210874 */ GIM_Try, /*On fail goto*//*Label 2923*/ GIMT_Encode4(211019),
     /* 210879 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 210882 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 210885 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 210888 */   GIM_Try, /*On fail goto*//*Label 2924*/ GIMT_Encode4(210929), // Rule ID 789 //
     /* 210893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 210896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 210900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 210904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 210908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 210912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210914 */     // (strict_fma:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB, (fneg:{ *:[f64] } f64:{ *:[f64] }:$XTi))  =>  (XSMSUBADP:{ *:[f64] } f64:{ *:[f64] }:$XTi, f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 210914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMSUBADP),
     /* 210917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 210919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XTi
     /* 210923 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 210925 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 210927 */     GIR_RootConstrainSelectedInstOperands,
     /* 210928 */     // GIR_Coverage, 789,
     /* 210928 */     GIR_EraseRootFromParent_Done,
     /* 210929 */   // Label 2924: @210929
     /* 210929 */   GIM_Try, /*On fail goto*//*Label 2925*/ GIMT_Encode4(210954), // Rule ID 787 //
     /* 210934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 210937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 210941 */     // (strict_fma:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB, f64:{ *:[f64] }:$XTi)  =>  (XSMADDADP:{ *:[f64] } f64:{ *:[f64] }:$XTi, f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 210941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMADDADP),
     /* 210944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 210946 */     GIR_RootToRootCopy, /*OpIdx*/3, // XTi
     /* 210948 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 210950 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 210952 */     GIR_RootConstrainSelectedInstOperands,
     /* 210953 */     // GIR_Coverage, 787,
     /* 210953 */     GIR_EraseRootFromParent_Done,
     /* 210954 */   // Label 2925: @210954
     /* 210954 */   GIM_Try, /*On fail goto*//*Label 2926*/ GIMT_Encode4(210995), // Rule ID 222 //
     /* 210959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 210962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 210966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 210970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 210974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 210978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210980 */     // (strict_fma:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, (fneg:{ *:[f64] } f64:{ *:[f64] }:$FRB))  =>  (FMSUB:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB)
     /* 210980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FMSUB),
     /* 210983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 210985 */     GIR_RootToRootCopy, /*OpIdx*/1, // FRA
     /* 210987 */     GIR_RootToRootCopy, /*OpIdx*/2, // FRC
     /* 210989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRB
     /* 210993 */     GIR_RootConstrainSelectedInstOperands,
     /* 210994 */     // GIR_Coverage, 222,
     /* 210994 */     GIR_EraseRootFromParent_Done,
     /* 210995 */   // Label 2926: @210995
     /* 210995 */   GIM_Try, /*On fail goto*//*Label 2927*/ GIMT_Encode4(211018), // Rule ID 218 //
     /* 211000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 211003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 211007 */     // (strict_fma:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB)  =>  (FMADD:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB)
     /* 211007 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FMADD),
     /* 211012 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 211016 */     GIR_RootConstrainSelectedInstOperands,
     /* 211017 */     // GIR_Coverage, 218,
     /* 211017 */     GIR_Done,
     /* 211018 */   // Label 2927: @211018
     /* 211018 */   GIM_Reject,
     /* 211019 */ // Label 2923: @211019
     /* 211019 */ GIM_Reject,
     /* 211020 */ // Label 2914: @211020
     /* 211020 */ GIM_Try, /*On fail goto*//*Label 2928*/ GIMT_Encode4(211097),
     /* 211025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 211028 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 211031 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /* 211034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 211038 */   GIM_Try, /*On fail goto*//*Label 2929*/ GIMT_Encode4(211075), // Rule ID 999 //
     /* 211043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 211046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 211050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 211054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s128,
     /* 211058 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211060 */     // (strict_fma:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, (fneg:{ *:[f128] } f128:{ *:[f128] }:$RSTi))  =>  (XSMSUBQP:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 211060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMSUBQP),
     /* 211063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 211065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RSTi
     /* 211069 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /* 211071 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /* 211073 */     GIR_RootConstrainSelectedInstOperands,
     /* 211074 */     // GIR_Coverage, 999,
     /* 211074 */     GIR_EraseRootFromParent_Done,
     /* 211075 */   // Label 2929: @211075
     /* 211075 */   GIM_Try, /*On fail goto*//*Label 2930*/ GIMT_Encode4(211096), // Rule ID 997 //
     /* 211080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 211083 */     // (strict_fma:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, f128:{ *:[f128] }:$RSTi)  =>  (XSMADDQP:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 211083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMADDQP),
     /* 211086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 211088 */     GIR_RootToRootCopy, /*OpIdx*/3, // RSTi
     /* 211090 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /* 211092 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /* 211094 */     GIR_RootConstrainSelectedInstOperands,
     /* 211095 */     // GIR_Coverage, 997,
     /* 211095 */     GIR_EraseRootFromParent_Done,
     /* 211096 */   // Label 2930: @211096
     /* 211096 */   GIM_Reject,
     /* 211097 */ // Label 2928: @211097
     /* 211097 */ GIM_Reject,
     /* 211098 */ // Label 2915: @211098
     /* 211098 */ GIM_Try, /*On fail goto*//*Label 2931*/ GIMT_Encode4(211175),
     /* 211103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 211106 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 211109 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 211112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 211116 */   GIM_Try, /*On fail goto*//*Label 2932*/ GIMT_Encode4(211153), // Rule ID 799 //
     /* 211121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 211124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 211128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 211132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 211136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211138 */     // (strict_fma:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB, (fneg:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi))  =>  (XVMSUBADP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi, v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 211138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMSUBADP),
     /* 211141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 211143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XTi
     /* 211147 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 211149 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 211151 */     GIR_RootConstrainSelectedInstOperands,
     /* 211152 */     // GIR_Coverage, 799,
     /* 211152 */     GIR_EraseRootFromParent_Done,
     /* 211153 */   // Label 2932: @211153
     /* 211153 */   GIM_Try, /*On fail goto*//*Label 2933*/ GIMT_Encode4(211174), // Rule ID 795 //
     /* 211158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 211161 */     // (strict_fma:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB, v2f64:{ *:[v2f64] }:$XTi)  =>  (XVMADDADP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi, v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 211161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMADDADP),
     /* 211164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 211166 */     GIR_RootToRootCopy, /*OpIdx*/3, // XTi
     /* 211168 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 211170 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 211172 */     GIR_RootConstrainSelectedInstOperands,
     /* 211173 */     // GIR_Coverage, 795,
     /* 211173 */     GIR_EraseRootFromParent_Done,
     /* 211174 */   // Label 2933: @211174
     /* 211174 */   GIM_Reject,
     /* 211175 */ // Label 2931: @211175
     /* 211175 */ GIM_Reject,
     /* 211176 */ // Label 2916: @211176
     /* 211176 */ GIM_Try, /*On fail goto*//*Label 2934*/ GIMT_Encode4(211253),
     /* 211181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 211184 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 211187 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 211190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 211194 */   GIM_Try, /*On fail goto*//*Label 2935*/ GIMT_Encode4(211231), // Rule ID 801 //
     /* 211199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 211202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 211206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 211210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 211214 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211216 */     // (strict_fma:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB, (fneg:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XTi))  =>  (XVMSUBASP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XTi, v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 211216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMSUBASP),
     /* 211219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 211221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XTi
     /* 211225 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 211227 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 211229 */     GIR_RootConstrainSelectedInstOperands,
     /* 211230 */     // GIR_Coverage, 801,
     /* 211230 */     GIR_EraseRootFromParent_Done,
     /* 211231 */   // Label 2935: @211231
     /* 211231 */   GIM_Try, /*On fail goto*//*Label 2936*/ GIMT_Encode4(211252), // Rule ID 797 //
     /* 211236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 211239 */     // (strict_fma:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB, v4f32:{ *:[v4f32] }:$XTi)  =>  (XVMADDASP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XTi, v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 211239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMADDASP),
     /* 211242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 211244 */     GIR_RootToRootCopy, /*OpIdx*/3, // XTi
     /* 211246 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 211248 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 211250 */     GIR_RootConstrainSelectedInstOperands,
     /* 211251 */     // GIR_Coverage, 797,
     /* 211251 */     GIR_EraseRootFromParent_Done,
     /* 211252 */   // Label 2936: @211252
     /* 211252 */   GIM_Reject,
     /* 211253 */ // Label 2934: @211253
     /* 211253 */ GIM_Reject,
     /* 211254 */ // Label 2917: @211254
     /* 211254 */ GIM_Reject,
     /* 211255 */ // Label 81: @211255
     /* 211255 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2942*/ GIMT_Encode4(211471),
     /* 211266 */ /*GILLT_s32*//*Label 2937*/ GIMT_Encode4(211286),
     /* 211270 */ /*GILLT_s64*//*Label 2938*/ GIMT_Encode4(211338),
     /* 211274 */ /*GILLT_s128*//*Label 2939*/ GIMT_Encode4(211394),
     /* 211278 */ /*GILLT_v2s64*//*Label 2940*/ GIMT_Encode4(211417),
     /* 211282 */ /*GILLT_v4s32*//*Label 2941*/ GIMT_Encode4(211444),
     /* 211286 */ // Label 2937: @211286
     /* 211286 */ GIM_Try, /*On fail goto*//*Label 2943*/ GIMT_Encode4(211337),
     /* 211291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 211294 */   GIM_Try, /*On fail goto*//*Label 2944*/ GIMT_Encode4(211313), // Rule ID 963 //
     /* 211299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 211302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 211306 */     // (strict_fsqrt:{ *:[f32] } f32:{ *:[f32] }:$XB)  =>  (XSSQRTSP:{ *:[f32] } f32:{ *:[f32] }:$XB)
     /* 211306 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSQRTSP),
     /* 211311 */     GIR_RootConstrainSelectedInstOperands,
     /* 211312 */     // GIR_Coverage, 963,
     /* 211312 */     GIR_Done,
     /* 211313 */   // Label 2944: @211313
     /* 211313 */   GIM_Try, /*On fail goto*//*Label 2945*/ GIMT_Encode4(211336), // Rule ID 161 //
     /* 211318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 211321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 211325 */     // (strict_fsqrt:{ *:[f32] } f32:{ *:[f32] }:$RB)  =>  (FSQRTS:{ *:[f32] } f32:{ *:[f32] }:$RB)
     /* 211325 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FSQRTS),
     /* 211330 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 211334 */     GIR_RootConstrainSelectedInstOperands,
     /* 211335 */     // GIR_Coverage, 161,
     /* 211335 */     GIR_Done,
     /* 211336 */   // Label 2945: @211336
     /* 211336 */   GIM_Reject,
     /* 211337 */ // Label 2943: @211337
     /* 211337 */ GIM_Reject,
     /* 211338 */ // Label 2938: @211338
     /* 211338 */ GIM_Try, /*On fail goto*//*Label 2946*/ GIMT_Encode4(211393),
     /* 211343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 211346 */   GIM_Try, /*On fail goto*//*Label 2947*/ GIMT_Encode4(211369), // Rule ID 812 //
     /* 211351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 211354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 211358 */     // (strict_fsqrt:{ *:[f64] } f64:{ *:[f64] }:$XB)  =>  (XSSQRTDP:{ *:[f64] } f64:{ *:[f64] }:$XB)
     /* 211358 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSQRTDP),
     /* 211363 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 211367 */     GIR_RootConstrainSelectedInstOperands,
     /* 211368 */     // GIR_Coverage, 812,
     /* 211368 */     GIR_Done,
     /* 211369 */   // Label 2947: @211369
     /* 211369 */   GIM_Try, /*On fail goto*//*Label 2948*/ GIMT_Encode4(211392), // Rule ID 159 //
     /* 211374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 211377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 211381 */     // (strict_fsqrt:{ *:[f64] } f64:{ *:[f64] }:$RB)  =>  (FSQRT:{ *:[f64] } f64:{ *:[f64] }:$RB)
     /* 211381 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FSQRT),
     /* 211386 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 211390 */     GIR_RootConstrainSelectedInstOperands,
     /* 211391 */     // GIR_Coverage, 159,
     /* 211391 */     GIR_Done,
     /* 211392 */   // Label 2948: @211392
     /* 211392 */   GIM_Reject,
     /* 211393 */ // Label 2946: @211393
     /* 211393 */ GIM_Reject,
     /* 211394 */ // Label 2939: @211394
     /* 211394 */ GIM_Try, /*On fail goto*//*Label 2949*/ GIMT_Encode4(211416), // Rule ID 995 //
     /* 211399 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 211402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 211405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 211409 */   // (strict_fsqrt:{ *:[f128] } f128:{ *:[f128] }:$RB)  =>  (XSSQRTQP:{ *:[f128] } f128:{ *:[f128] }:$RB)
     /* 211409 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSQRTQP),
     /* 211414 */   GIR_RootConstrainSelectedInstOperands,
     /* 211415 */   // GIR_Coverage, 995,
     /* 211415 */   GIR_Done,
     /* 211416 */ // Label 2949: @211416
     /* 211416 */ GIM_Reject,
     /* 211417 */ // Label 2940: @211417
     /* 211417 */ GIM_Try, /*On fail goto*//*Label 2950*/ GIMT_Encode4(211443), // Rule ID 823 //
     /* 211422 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 211425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 211428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 211432 */   // (strict_fsqrt:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)  =>  (XVSQRTDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)
     /* 211432 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVSQRTDP),
     /* 211437 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 211441 */   GIR_RootConstrainSelectedInstOperands,
     /* 211442 */   // GIR_Coverage, 823,
     /* 211442 */   GIR_Done,
     /* 211443 */ // Label 2950: @211443
     /* 211443 */ GIM_Reject,
     /* 211444 */ // Label 2941: @211444
     /* 211444 */ GIM_Try, /*On fail goto*//*Label 2951*/ GIMT_Encode4(211470), // Rule ID 825 //
     /* 211449 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 211452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 211455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 211459 */   // (strict_fsqrt:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)  =>  (XVSQRTSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)
     /* 211459 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVSQRTSP),
     /* 211464 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 211468 */   GIR_RootConstrainSelectedInstOperands,
     /* 211469 */   // GIR_Coverage, 825,
     /* 211469 */   GIR_Done,
     /* 211470 */ // Label 2951: @211470
     /* 211470 */ GIM_Reject,
     /* 211471 */ // Label 2942: @211471
     /* 211471 */ GIM_Reject,
     /* 211472 */ // Label 82: @211472
     /* 211472 */ GIM_Try, /*On fail goto*//*Label 2952*/ GIMT_Encode4(211484), // Rule ID 72 //
     /* 211477 */   // (trap)  =>  (TRAP)
     /* 211477 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::TRAP),
     /* 211482 */   GIR_RootConstrainSelectedInstOperands,
     /* 211483 */   // GIR_Coverage, 72,
     /* 211483 */   GIR_Done,
     /* 211484 */ // Label 2952: @211484
     /* 211484 */ GIM_Reject,
     /* 211485 */ // Label 83: @211485
     /* 211485 */ GIM_Reject,
     /* 211486 */ }; // Size: 211486 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const PPCSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const PPCSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
