/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* RISCVPreLegalizerCombinerImpl Combiner Match Table                         *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GICOMBINER_DEPS
#include "llvm/ADT/SparseBitVector.h"
namespace llvm {
extern cl::OptionCategory GICombinerOptionCategory;
} // end namespace llvm
#endif // ifdef GET_GICOMBINER_DEPS

#ifdef GET_GICOMBINER_TYPES
struct RISCVPreLegalizerCombinerImplRuleConfig {
  SparseBitVector<> DisabledRules;

  bool isRuleEnabled(unsigned RuleID) const;
  bool parseCommandLineOption();
  bool setRuleEnabled(StringRef RuleIdentifier);
  bool setRuleDisabled(StringRef RuleIdentifier);
};

static std::optional<uint64_t> getRuleIdxForIdentifier(StringRef RuleIdentifier) {
  uint64_t I;
  // getAtInteger(...) returns false on success
  bool Parsed = !RuleIdentifier.getAsInteger(0, I);
  if (Parsed)
    return I;

#ifndef NDEBUG
  switch (RuleIdentifier.size()) {
  default: break;
  case 9:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "opy_prop", 8) != 0)
        break;
      return 13;	 // "copy_prop"
    case 'm':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "tch_ors", 7) != 0)
          break;
        return 194;	 // "match_ors"
      case 'u':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "lo_by_", 6) != 0)
          break;
        switch (RuleIdentifier[8]) {
        default: break;
        case '0':	 // 1 string to match.
          return 144;	 // "mulo_by_0"
        case '2':	 // 1 string to match.
          return 143;	 // "mulo_by_2"
        }
        break;
      }
      break;
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "neg_zext", 8) != 0)
        break;
      return 199;	 // "nneg_zext"
    }
    break;
  case 10:	 // 7 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2p_to_p2i", 9) != 0)
        break;
      return 89;	 // "i2p_to_p2i"
    case 'm':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "tch_ands", 8) != 0)
          break;
        return 193;	 // "match_ands"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "l_to_shl", 8) != 0)
          break;
        return 14;	 // "mul_to_shl"
      }
      break;
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2i_to_i2p", 9) != 0)
        break;
      return 88;	 // "p2i_to_i2p"
    case 's':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "xt_trunc", 8) != 0)
          break;
        return 197;	 // "sext_trunc"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "b_to_add", 8) != 0)
          break;
        return 15;	 // "sub_to_add"
      }
      break;
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_trunc", 9) != 0)
        break;
      return 198;	 // "zext_trunc"
    }
    break;
  case 11:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dd_sub_reg", 10) != 0)
        break;
      return 94;	 // "add_sub_reg"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_addos", 10) != 0)
        break;
      return 213;	 // "match_addos"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ub_add_reg", 10) != 0)
        break;
      return 188;	 // "sub_add_reg"
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_shift", 10) != 0)
        break;
      return 131;	 // "trunc_shift"
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nmerge_cst", 10) != 0)
        break;
      return 207;	 // "unmerge_cst"
    }
    break;
  case 12:	 // 11 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "PlusBMinusB", 11) != 0)
        break;
      return 2;	 // "APlusBMinusB"
    case 'B':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "MinusAPlusA", 11) != 0)
        break;
      return 3;	 // "BMinusAPlusA"
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dde_to_addo", 11) != 0)
        break;
      return 145;	 // "adde_to_addo"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "sub_to_fneg", 11) != 0)
        break;
      return 190;	 // "fsub_to_fneg"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ulh_to_lshr", 11) != 0)
        break;
      return 175;	 // "mulh_to_lshr"
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ot_cmp_fold", 11) != 0)
        break;
      return 132;	 // "not_cmp_fold"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_or", 11) != 0)
        break;
      return 127;	 // "redundant_or"
    case 's':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "iv_by_pow2", 10) != 0)
          break;
        return 173;	 // "sdiv_by_pow2"
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "xt_of_sext", 10) != 0)
          break;
        return 48;	 // "sext_of_sext"
      }
      break;
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "div_by_pow2", 11) != 0)
        break;
      return 174;	 // "udiv_by_pow2"
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_of_zext", 11) != 0)
        break;
      return 46;	 // "zext_of_zext"
    }
    break;
  case 13:	 // 14 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dd_of_vscale", 12) != 0)
        break;
      return 37;	 // "add_of_vscale"
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ommute_shift", 12) != 0)
        break;
      return 161;	 // "commute_shift"
    case 'l':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oad_and_mask", 12) != 0)
        break;
      return 69;	 // "load_and_mask"
    case 'm':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "tch_selects", 11) != 0)
          break;
        return 124;	 // "match_selects"
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "rge_unmerge", 11) != 0)
          break;
        return 206;	 // "merge_unmerge"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "l_of_vscale", 11) != 0)
          break;
        return 38;	 // "mul_of_vscale"
      }
      break;
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_and", 12) != 0)
        break;
      return 125;	 // "redundant_and"
    case 's':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "iv_by_const", 11) != 0)
          break;
        return 172;	 // "sdiv_by_const"
      case 'h':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "l_of_vscale", 11) != 0)
          break;
        return 39;	 // "shl_of_vscale"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "b_of_vscale", 11) != 0)
          break;
        return 40;	 // "sub_of_vscale"
      }
      break;
    case 'u':	 // 4 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "iv_by_const", 11) != 0)
          break;
        return 171;	 // "udiv_by_const"
      case 'n':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "merge_", 6) != 0)
          break;
        switch (RuleIdentifier[8]) {
        default: break;
        case 'm':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+9, "erge", 4) != 0)
            break;
          return 205;	 // "unmerge_merge"
        case 'u':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+9, "ndef", 4) != 0)
            break;
          return 208;	 // "unmerge_undef"
        }
        break;
      case 'r':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "em_by_const", 11) != 0)
          break;
        return 187;	 // "urem_by_const"
      }
      break;
    }
    break;
  case 14:	 // 15 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'M':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "inusC1PlusC2", 12) != 0)
          break;
        return 12;	 // "AMinusC1PlusC2"
      case 'P':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lusC1MinusC2", 12) != 0)
          break;
        return 8;	 // "APlusC1MinusC2"
      }
      break;
    case 'C':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2MinusAPlusC1", 13) != 0)
        break;
      return 9;	 // "C2MinusAPlusC1"
    case 'a':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "nyext_of_", 9) != 0)
        break;
      switch (RuleIdentifier[10]) {
      default: break;
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+11, "ext", 3) != 0)
          break;
        return 52;	 // "anyext_of_sext"
      case 'z':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+11, "ext", 3) != 0)
          break;
        return 51;	 // "anyext_of_zext"
      }
      break;
    case 'b':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'i')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "op_same_val", 11) != 0)
          break;
        return 85;	 // "binop_same_val"
      case 't':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "reverse_shl", 11) != 0)
          break;
        return 159;	 // "bitreverse_shl"
      }
      break;
    case 'f':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "bs_fneg_fold", 12) != 0)
          break;
        return 170;	 // "fabs_fneg_fold"
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "eg_fneg_fold", 12) != 0)
          break;
        return 91;	 // "fneg_fneg_fold"
      }
      break;
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ul_by_neg_one", 13) != 0)
        break;
      return 17;	 // "mul_by_neg_one"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "eassoc_ptradd", 13) != 0)
        break;
      return 106;	 // "reassoc_ptradd"
    case 's':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 2 strings to match.
        switch (RuleIdentifier[2]) {
        default: break;
        case 'l':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+3, "ect_of_zext", 11) != 0)
            break;
          return 54;	 // "select_of_zext"
        case 'x':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+3, "t_of_anyext", 11) != 0)
            break;
          return 49;	 // "sext_of_anyext"
        }
        break;
      case 'h':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ifts_too_big", 12) != 0)
          break;
        return 105;	 // "shifts_too_big"
      }
      break;
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_of_anyext", 13) != 0)
        break;
      return 47;	 // "zext_of_anyext"
    }
    break;
  case 15:	 // 12 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'M':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "inusC1MinusC2", 13) != 0)
          break;
        return 10;	 // "AMinusC1MinusC2"
      case 'P':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lusZeroMinusB", 13) != 0)
          break;
        return 1;	 // "APlusZeroMinusB"
      }
      break;
    case 'C':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "1Minus2MinusC2", 14) != 0)
        break;
      return 11;	 // "C1Minus2MinusC2"
    case 'Z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "eroMinusAPlusB", 14) != 0)
        break;
      return 0;	 // "ZeroMinusAPlusB"
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itreverse_lshr", 14) != 0)
        break;
      return 160;	 // "bitreverse_lshr"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtending_loads", 14) != 0)
        break;
      return 68;	 // "extending_loads"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dempotent_prop", 14) != 0)
        break;
      return 18;	 // "idempotent_prop"
    case 'l':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oad_or_combine", 14) != 0)
        break;
      return 152;	 // "load_or_combine"
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "arrow_binop_or", 14) != 0)
        break;
      return 62;	 // "narrow_binop_or"
    case 'o':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "verlapping_and", 14) != 0)
        break;
      return 142;	 // "overlapping_and"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "elect_same_val", 14) != 0)
        break;
      return 83;	 // "select_same_val"
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_trunc_fold", 14) != 0)
        break;
      return 129;	 // "zext_trunc_fold"
    }
    break;
  case 16:	 // 12 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nyext_of_anyext", 15) != 0)
        break;
      return 50;	 // "anyext_of_anyext"
    case 'n':	 // 5 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "arrow_binop_", 12) != 0)
        break;
      switch (RuleIdentifier[13]) {
      default: break;
      case 'a':	 // 2 strings to match.
        switch (RuleIdentifier[14]) {
        default: break;
        case 'd':	 // 1 string to match.
          if (RuleIdentifier[15] != 'd')
            break;
          return 58;	 // "narrow_binop_add"
        case 'n':	 // 1 string to match.
          if (RuleIdentifier[15] != 'd')
            break;
          return 61;	 // "narrow_binop_and"
        }
        break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+14, "ul", 2) != 0)
          break;
        return 60;	 // "narrow_binop_mul"
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+14, "ub", 2) != 0)
          break;
        return 59;	 // "narrow_binop_sub"
      case 'x':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+14, "or", 2) != 0)
          break;
        return 63;	 // "narrow_binop_xor"
      }
      break;
    case 's':	 // 3 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "elect_", 6) != 0)
        break;
      switch (RuleIdentifier[7]) {
      default: break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+8, "f_anyext", 8) != 0)
          break;
        return 55;	 // "select_of_anyext"
      case 't':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+8, "o_minmax", 8) != 0)
          break;
        return 189;	 // "select_to_minmax"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+8, "ndef_cmp", 8) != 0)
          break;
        return 121;	 // "select_undef_cmp"
      }
      break;
    case 't':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "runcate_of_", 11) != 0)
        break;
      switch (RuleIdentifier[12]) {
      default: break;
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+13, "ext", 3) != 0)
          break;
        return 44;	 // "truncate_of_sext"
      case 'z':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+13, "ext", 3) != 0)
          break;
        return 43;	 // "truncate_of_zext"
      }
      break;
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ndef_to_fp_zero", 15) != 0)
        break;
      return 71;	 // "undef_to_fp_zero"
    }
    break;
  case 17:	 // 14 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "PlusBMinus", 10) != 0)
        break;
      switch (RuleIdentifier[11]) {
      default: break;
      case 'A':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "plusC", 5) != 0)
          break;
        return 6;	 // "APlusBMinusAplusC"
      case 'C':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "PlusA", 5) != 0)
          break;
        return 7;	 // "APlusBMinusCPlusA"
      }
      break;
    case 'a':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "d_p2i_to_ptradd", 15) != 0)
          break;
        return 16;	 // "add_p2i_to_ptradd"
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "yext_trunc_fold", 15) != 0)
          break;
        return 90;	 // "anyext_trunc_fold"
      }
      break;
    case 'c':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "nonicalize_", 11) != 0)
          break;
        switch (RuleIdentifier[13]) {
        default: break;
        case 'f':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "cmp", 3) != 0)
            break;
          return 110;	 // "canonicalize_fcmp"
        case 'i':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "cmp", 3) != 0)
            break;
          return 109;	 // "canonicalize_icmp"
        }
        break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "nstant_fold_fma", 15) != 0)
          break;
        return 168;	 // "constant_fold_fma"
      }
      break;
    case 'd':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "iv_rem_to_divrem", 16) != 0)
        break;
      return 153;	 // "div_rem_to_divrem"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "rase_undef_store", 16) != 0)
        break;
      return 81;	 // "erase_undef_store"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "tr_add_with_zero", 16) != 0)
        break;
      return 149;	 // "ptr_add_with_zero"
    case 's':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lect_to_iminmax", 15) != 0)
          break;
        return 123;	 // "select_to_iminmax"
      case 'h':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ift_immed_chain", 15) != 0)
          break;
        return 150;	 // "shift_immed_chain"
      }
      break;
    case 'u':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "def_to_int_zero", 15) != 0)
          break;
        return 72;	 // "undef_to_int_zero"
      case 'r':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "em_pow2_to_mask", 15) != 0)
          break;
        return 128;	 // "urem_pow2_to_mask"
      }
      break;
    }
    break;
  case 18:	 // 11 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "MinusBPlus", 10) != 0)
        break;
      switch (RuleIdentifier[11]) {
      default: break;
      case 'B':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "MinusC", 6) != 0)
          break;
        return 5;	 // "AMinusBPlusBMinusC"
      case 'C':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "MinusA", 6) != 0)
          break;
        return 4;	 // "AMinusBPlusCMinusA"
      }
      break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_left_to_zero", 17) != 0)
        break;
      return 86;	 // "binop_left_to_zero"
    case 'c':	 // 3 strings to match.
      if (RuleIdentifier[1] != 'o')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "bine_minmax_nan", 15) != 0)
          break;
        return 146;	 // "combine_minmax_nan"
      case 'n':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+3, "stant_fold_f", 12) != 0)
          break;
        switch (RuleIdentifier[15]) {
        default: break;
        case 'a':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+16, "bs", 2) != 0)
            break;
          return 135;	 // "constant_fold_fabs"
        case 'n':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+16, "eg", 2) != 0)
            break;
          return 134;	 // "constant_fold_fneg"
        }
        break;
      }
      break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xpand_const_fpowi", 17) != 0)
        break;
      return 147;	 // "expand_const_fpowi"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ptrunc_fpext_fold", 17) != 0)
        break;
      return 99;	 // "fptrunc_fpext_fold"
    case 's':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'e')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'l':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "ect_of_truncate", 15) != 0)
          break;
        return 56;	 // "select_of_truncate"
      case 'x':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "t_inreg_of_load", 15) != 0)
          break;
        return 118;	 // "sext_inreg_of_load"
      }
      break;
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runcate_of_anyext", 17) != 0)
        break;
      return 45;	 // "truncate_of_anyext"
    }
    break;
  case 19:	 // 15 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_right_to_zero", 18) != 0)
        break;
      return 87;	 // "binop_right_to_zero"
    case 'c':	 // 4 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "onst", 4) != 0)
        break;
      switch (RuleIdentifier[5]) {
      default: break;
      case '_':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+6, "ptradd_to_i2p", 13) != 0)
          break;
        return 141;	 // "const_ptradd_to_i2p"
      case 'a':	 // 3 strings to match.
        if (memcmp(RuleIdentifier.data()+6, "nt_fold_", 8) != 0)
          break;
        switch (RuleIdentifier[14]) {
        default: break;
        case 'b':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+15, "inop", 4) != 0)
            break;
          return 166;	 // "constant_fold_binop"
        case 'f':	 // 2 strings to match.
          switch (RuleIdentifier[15]) {
          default: break;
          case 'l':	 // 1 string to match.
            if (memcmp(RuleIdentifier.data()+16, "og2", 3) != 0)
              break;
            return 137;	 // "constant_fold_flog2"
          case 's':	 // 1 string to match.
            if (memcmp(RuleIdentifier.data()+16, "qrt", 3) != 0)
              break;
            return 136;	 // "constant_fold_fsqrt"
          }
          break;
        }
        break;
      }
      break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtend_through_phis", 18) != 0)
        break;
      return 102;	 // "extend_through_phis"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nteger_of_truncate", 18) != 0)
        break;
      return 64;	 // "integer_of_truncate"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "erge_of_x_and_zero", 18) != 0)
        break;
      return 212;	 // "merge_of_x_and_zero"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "tr_add_immed_chain", 18) != 0)
        break;
      return 108;	 // "ptr_add_immed_chain"
    case 'r':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "assoc_comm_binops", 17) != 0)
          break;
        return 107;	 // "reassoc_comm_binops"
      case 'i':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ght_identity_zero", 17) != 0)
          break;
        return 84;	 // "right_identity_zero"
      }
      break;
    case 's':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lect_constant_cmp", 17) != 0)
          break;
        return 122;	 // "select_constant_cmp"
      case 'i':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "mplify_", 7) != 0)
          break;
        switch (RuleIdentifier[9]) {
        default: break;
        case 'a':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+10, "dd_to_sub", 9) != 0)
            break;
          return 103;	 // "simplify_add_to_sub"
        case 'n':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+10, "eg_minmax", 9) != 0)
            break;
          return 195;	 // "simplify_neg_minmax"
        }
        break;
      }
      break;
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nary_undef_to_zero", 18) != 0)
        break;
      return 76;	 // "unary_undef_to_zero"
    }
    break;
  case 20:	 // 7 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nd_or_disjoint_mask", 19) != 0)
        break;
      return 177;	 // "and_or_disjoint_mask"
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itcast_bitcast_fold", 19) != 0)
        break;
      return 98;	 // "bitcast_bitcast_fold"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "erge_of_x_and_undef", 19) != 0)
        break;
      return 211;	 // "merge_of_x_and_undef"
    case 'r':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "edu", 3) != 0)
        break;
      switch (RuleIdentifier[4]) {
      default: break;
      case 'c':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+5, "e_shl_of_extend", 15) != 0)
          break;
        return 119;	 // "reduce_shl_of_extend"
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+5, "dant_sext_inreg", 15) != 0)
          break;
        return 126;	 // "redundant_sext_inreg"
      }
      break;
    case 'u':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'n')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "ry_undef_to_undef", 17) != 0)
          break;
        return 77;	 // "unary_undef_to_undef"
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "erge_zext_to_zext", 17) != 0)
          break;
        return 210;	 // "unmerge_zext_to_zext"
      }
      break;
    }
    break;
  case 21:	 // 7 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 3 strings to match.
      if (RuleIdentifier[1] != 'o')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "bine_concat_vector", 18) != 0)
          break;
        return 196;	 // "combine_concat_vector"
      case 'n':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+3, "stant_fold_", 11) != 0)
          break;
        switch (RuleIdentifier[14]) {
        default: break;
        case 'c':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+15, "ast_op", 6) != 0)
            break;
          return 169;	 // "constant_fold_cast_op"
        case 'f':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+15, "ptrunc", 6) != 0)
            break;
          return 138;	 // "constant_fold_fptrunc"
        }
        break;
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nsert_vector_elt_oob", 20) != 0)
        break;
      return 24;	 // "insert_vector_elt_oob"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_one_fp", 20) != 0)
        break;
      return 93;	 // "right_identity_one_fp"
    case 'u':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'n')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "ef_to_negative_one", 18) != 0)
          break;
        return 73;	 // "undef_to_negative_one"
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "erge_dead_to_trunc", 18) != 0)
          break;
        return 209;	 // "unmerge_dead_to_trunc"
      }
      break;
    }
    break;
  case 22:	 // 13 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'o')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "bine_shuffle_concat", 19) != 0)
          break;
        return 200;	 // "combine_shuffle_concat"
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "stant_fold_fp_binop", 19) != 0)
          break;
        return 167;	 // "constant_fold_fp_binop"
      }
      break;
    case 'f':	 // 4 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ld_binop_into_select", 20) != 0)
          break;
        return 186;	 // "fold_binop_into_select"
      case 'u':	 // 3 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "nnel_shift_", 11) != 0)
          break;
        switch (RuleIdentifier[13]) {
        default: break;
        case 'l':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "eft_zero", 8) != 0)
            break;
          return 157;	 // "funnel_shift_left_zero"
        case 'o':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "vershift", 8) != 0)
            break;
          return 158;	 // "funnel_shift_overshift"
        case 't':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "o_rotate", 8) != 0)
            break;
          return 155;	 // "funnel_shift_to_rotate"
        }
        break;
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "cmp_to_lhs_known_bits", 21) != 0)
        break;
      return 112;	 // "icmp_to_lhs_known_bits"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_subo_no_overflow", 21) != 0)
        break;
      return 214;	 // "match_subo_no_overflow"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ropagate_undef_any_op", 21) != 0)
        break;
      return 78;	 // "propagate_undef_any_op"
    case 'r':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "dundant_neg_operands", 20) != 0)
          break;
        return 176;	 // "redundant_neg_operands"
      case 'i':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ght_identity_one_int", 20) != 0)
          break;
        return 92;	 // "right_identity_one_int"
      }
      break;
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "hl_ashr_to_sext_inreg", 21) != 0)
        break;
      return 116;	 // "shl_ashr_to_sext_inreg"
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_buildvector_fold", 21) != 0)
        break;
      return 96;	 // "trunc_buildvector_fold"
    }
    break;
  case 23:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "uildvector_of_truncate", 22) != 0)
        break;
      return 57;	 // "buildvector_of_truncate"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "unnel_shift_right_zero", 22) != 0)
        break;
      return 156;	 // "funnel_shift_right_zero"
    case 'i':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "tof_const_zero_fold_", 20) != 0)
        break;
      switch (RuleIdentifier[21]) {
      default: break;
      case 's':	 // 1 string to match.
        if (RuleIdentifier[22] != 'i')
          break;
        return 139;	 // "itof_const_zero_fold_si"
      case 'u':	 // 1 string to match.
        if (RuleIdentifier[22] != 'i')
          break;
        return 140;	 // "itof_const_zero_fold_ui"
      }
      break;
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ropagate_undef_all_ops", 22) != 0)
        break;
      return 79;	 // "propagate_undef_all_ops"
    }
    break;
  case 24:	 // 6 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_left_undef_to_zero", 23) != 0)
        break;
      return 74;	 // "binop_left_undef_to_zero"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_extract_of_element", 23) != 0)
        break;
      return 23;	 // "match_extract_of_element"
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "arrow_binop_feeding_and", 23) != 0)
        break;
      return 120;	 // "narrow_binop_feeding_and"
    case 's':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_inreg_", 10) != 0)
        break;
      switch (RuleIdentifier[11]) {
      default: break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "f_sext_inreg", 12) != 0)
          break;
        return 53;	 // "sext_inreg_of_sext_inreg"
      case 't':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "o_zext_inreg", 12) != 0)
          break;
        return 130;	 // "sext_inreg_to_zext_inreg"
      }
      break;
    case 'x':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "or_of_and_with_same_reg", 23) != 0)
        break;
      return 148;	 // "xor_of_and_with_same_reg"
    }
    break;
  case 25:	 // 7 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'i':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "tfield_extract_from_", 20) != 0)
          break;
        switch (RuleIdentifier[22]) {
        default: break;
        case 'a':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+23, "nd", 2) != 0)
            break;
          return 163;	 // "bitfield_extract_from_and"
        case 's':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+23, "hr", 2) != 0)
            break;
          return 164;	 // "bitfield_extract_from_shr"
        }
        break;
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ildvector_identity_fold", 23) != 0)
          break;
        return 95;	 // "buildvector_identity_fold"
      }
      break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_shuffle_undef_rhs", 24) != 0)
        break;
      return 201;	 // "combine_shuffle_undef_rhs"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vec_elt_build_vec", 24) != 0)
        break;
      return 66;	 // "extract_vec_elt_build_vec"
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "eg_and_one_to_sext_inreg", 24) != 0)
        break;
      return 117;	 // "neg_and_one_to_sext_inreg"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_neg_one_fp", 24) != 0)
        break;
      return 101;	 // "right_identity_neg_one_fp"
    }
    break;
  case 26:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_right_undef_to_undef", 25) != 0)
        break;
      return 75;	 // "binop_right_undef_to_undef"
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ommute_fp_constant_to_rhs", 25) != 0)
        break;
      return 192;	 // "commute_fp_constant_to_rhs"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "unnel_shift_from_or_shift", 25) != 0)
        break;
      return 154;	 // "funnel_shift_from_or_shift"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_neg_zero_fp", 25) != 0)
        break;
      return 100;	 // "right_identity_neg_zero_fp"
    }
    break;
  case 27:	 // 6 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "om", 2) != 0)
        break;
      switch (RuleIdentifier[3]) {
      default: break;
      case 'b':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+4, "ine_use_vector_truncate", 23) != 0)
          break;
        return 203;	 // "combine_use_vector_truncate"
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+4, "ute_int_constant_to_rhs", 23) != 0)
          break;
        return 191;	 // "commute_int_constant_to_rhs"
      }
      break;
    case 'd':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ouble_icmp_zero_or_combine", 26) != 0)
        break;
      return 114;	 // "double_icmp_zero_or_combine"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_binop_in_equality", 26) != 0)
        break;
      return 115;	 // "redundant_binop_in_equality"
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_lshr_buildvector_fold", 26) != 0)
        break;
      return 97;	 // "trunc_lshr_buildvector_fold"
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nmerge_anyext_build_vector", 26) != 0)
        break;
      return 204;	 // "unmerge_anyext_build_vector"
    }
    break;
  case 28:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'd':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ouble_icmp_zero_and_combine", 27) != 0)
        break;
      return 113;	 // "double_icmp_zero_and_combine"
    case 'o':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "pt_brcond_by_inverting_cond", 27) != 0)
        break;
      return 133;	 // "opt_brcond_by_inverting_cond"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ropagate_undef_shuffle_mask", 27) != 0)
        break;
      return 80;	 // "propagate_undef_shuffle_mask"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "hift_of_shifted_logic_chain", 27) != 0)
        break;
      return 151;	 // "shift_of_shifted_logic_chain"
    }
    break;
  case 29:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itfield_extract_from_shr_and", 28) != 0)
        break;
      return 165;	 // "bitfield_extract_from_shr_and"
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_", 7) != 0)
        break;
      switch (RuleIdentifier[8]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "xtracted_vector_load", 20) != 0)
          break;
        return 70;	 // "combine_extracted_vector_load"
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "huffle_disjoint_mask", 20) != 0)
          break;
        return 202;	 // "combine_shuffle_disjoint_mask"
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "cmp_to_true_false_known_bits", 28) != 0)
        break;
      return 111;	 // "icmp_to_true_false_known_bits"
    }
    break;
  case 30:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "freeze_of_non_undef_non_poison", 30) != 0)
      break;
    return 41;	 // "freeze_of_non_undef_non_poison"
  case 31:	 // 2 strings to match.
    if (memcmp(RuleIdentifier.data()+0, "insert_vector_element_", 22) != 0)
      break;
    switch (RuleIdentifier[22]) {
    default: break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+23, "lt_undef", 8) != 0)
        break;
      return 22;	 // "insert_vector_element_elt_undef"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+23, "dx_undef", 8) != 0)
        break;
      return 21;	 // "insert_vector_element_idx_undef"
    }
    break;
  case 32:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itfield_extract_from_sext_inreg", 31) != 0)
        break;
      return 162;	 // "bitfield_extract_from_sext_inreg"
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_f", 8) != 0)
        break;
      switch (RuleIdentifier[9]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+10, "dd_fmul_to_fmad_or_fma", 22) != 0)
          break;
        return 178;	 // "combine_fadd_fmul_to_fmad_or_fma"
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+10, "ub_fmul_to_fmad_or_fma", 22) != 0)
          break;
        return 182;	 // "combine_fsub_fmul_to_fmad_or_fma"
      }
      break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vector_element_not_const", 31) != 0)
        break;
      return 25;	 // "extract_vector_element_not_const"
    }
    break;
  case 34:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "extract_all_elts_from_build_vector", 34) != 0)
      break;
    return 67;	 // "extract_all_elts_from_build_vector"
  case 35:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "extract_vector_element_build_vector", 35) != 0)
      break;
    return 27;	 // "extract_vector_element_build_vector"
  case 36:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_", 7) != 0)
        break;
      switch (RuleIdentifier[8]) {
      default: break;
      case 'f':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "add_fma_fmul_to_fmad_or_fma", 27) != 0)
          break;
        return 180;	 // "combine_fadd_fma_fmul_to_fmad_or_fma"
      case 'i':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "nsert_vec_elts_build_vector", 27) != 0)
          break;
        return 65;	 // "combine_insert_vec_elts_build_vector"
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nsert_extract_vec_elt_out_of_bounds", 35) != 0)
        break;
      return 82;	 // "insert_extract_vec_elt_out_of_bounds"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_extract_of_element_undef_index", 35) != 0)
        break;
      return 20;	 // "match_extract_of_element_undef_index"
    }
    break;
  case 37:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_fsub_fneg_fmul_to_fmad_or_fma", 36) != 0)
        break;
      return 183;	 // "combine_fsub_fneg_fmul_to_fmad_or_fma"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vector_element_shuffle_vector", 36) != 0)
        break;
      return 35;	 // "extract_vector_element_shuffle_vector"
    case 'h':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oist_logic_op_with_same_opcode_hands", 36) != 0)
        break;
      return 104;	 // "hoist_logic_op_with_same_opcode_hands"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_extract_of_element_undef_vector", 36) != 0)
        break;
      return 19;	 // "match_extract_of_element_undef_vector"
    }
    break;
  case 38:	 // 2 strings to match.
    if (memcmp(RuleIdentifier.data()+0, "combine_f", 9) != 0)
      break;
    switch (RuleIdentifier[9]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+10, "dd_fpext_fmul_to_fmad_or_fma", 28) != 0)
        break;
      return 179;	 // "combine_fadd_fpext_fmul_to_fmad_or_fma"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+10, "ub_fpext_fmul_to_fmad_or_fma", 28) != 0)
        break;
      return 184;	 // "combine_fsub_fpext_fmul_to_fmad_or_fma"
    }
    break;
  case 40:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "extract_vector_element_different_indices", 40) != 0)
      break;
    return 26;	 // "extract_vector_element_different_indices"
  case 42:	 // 8 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_fadd_fpext_fma_fmul_to_fmad_or_fma", 41) != 0)
        break;
      return 181;	 // "combine_fadd_fpext_fma_fmul_to_fmad_or_fma"
    case 'e':	 // 7 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vector_element_build_vector_trunc", 40) != 0)
        break;
      switch (RuleIdentifier[41]) {
      default: break;
      case '2':	 // 1 string to match.
        return 28;	 // "extract_vector_element_build_vector_trunc2"
      case '3':	 // 1 string to match.
        return 29;	 // "extract_vector_element_build_vector_trunc3"
      case '4':	 // 1 string to match.
        return 30;	 // "extract_vector_element_build_vector_trunc4"
      case '5':	 // 1 string to match.
        return 31;	 // "extract_vector_element_build_vector_trunc5"
      case '6':	 // 1 string to match.
        return 32;	 // "extract_vector_element_build_vector_trunc6"
      case '7':	 // 1 string to match.
        return 33;	 // "extract_vector_element_build_vector_trunc7"
      case '8':	 // 1 string to match.
        return 34;	 // "extract_vector_element_build_vector_trunc8"
      }
      break;
    }
    break;
  case 43:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "combine_fsub_fpext_fneg_fmul_to_fmad_or_fma", 43) != 0)
      break;
    return 185;	 // "combine_fsub_fpext_fneg_fmul_to_fmad_or_fma"
  case 44:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "insert_vector_element_extract_vector_element", 44) != 0)
      break;
    return 36;	 // "insert_vector_element_extract_vector_element"
  case 46:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "push_freeze_to_prevent_poison_from_propagating", 46) != 0)
      break;
    return 42;	 // "push_freeze_to_prevent_poison_from_propagating"
  }
#endif // ifndef NDEBUG

  return std::nullopt;
}
static std::optional<std::pair<uint64_t, uint64_t>> getRuleRangeForIdentifier(StringRef RuleIdentifier) {
  std::pair<StringRef, StringRef> RangePair = RuleIdentifier.split('-');
  if (!RangePair.second.empty()) {
    const auto First = getRuleIdxForIdentifier(RangePair.first);
    const auto Last = getRuleIdxForIdentifier(RangePair.second);
    if (!First || !Last)
      return std::nullopt;
    if (First >= Last)
      report_fatal_error("Beginning of range should be before end of range");
    return {{*First, *Last + 1}};
  }
  if (RangePair.first == "*") {
    return {{0, 215}};
  }
  const auto I = getRuleIdxForIdentifier(RangePair.first);
  if (!I)
    return std::nullopt;
  return {{*I, *I + 1}};
}

bool RISCVPreLegalizerCombinerImplRuleConfig::setRuleEnabled(StringRef RuleIdentifier) {
  auto MaybeRange = getRuleRangeForIdentifier(RuleIdentifier);
  if (!MaybeRange)
    return false;
  for (auto I = MaybeRange->first; I < MaybeRange->second; ++I)
    DisabledRules.reset(I);
  return true;
}

bool RISCVPreLegalizerCombinerImplRuleConfig::setRuleDisabled(StringRef RuleIdentifier) {
  auto MaybeRange = getRuleRangeForIdentifier(RuleIdentifier);
  if (!MaybeRange)
    return false;
  for (auto I = MaybeRange->first; I < MaybeRange->second; ++I)
    DisabledRules.set(I);
  return true;
}

static std::vector<std::string> RISCVPreLegalizerCombinerOption;
static cl::list<std::string> RISCVPreLegalizerCombinerDisableOption(
    "riscvprelegalizercombiner-disable-rule",
    cl::desc("Disable one or more combiner rules temporarily in the RISCVPreLegalizerCombiner pass"),
    cl::CommaSeparated,
    cl::Hidden,
    cl::cat(GICombinerOptionCategory),
    cl::callback([](const std::string &Str) {
      RISCVPreLegalizerCombinerOption.push_back(Str);
    }));
static cl::list<std::string> RISCVPreLegalizerCombinerOnlyEnableOption(
    "riscvprelegalizercombiner-only-enable-rule",
    cl::desc("Disable all rules in the RISCVPreLegalizerCombiner pass then re-enable the specified ones"),
    cl::Hidden,
    cl::cat(GICombinerOptionCategory),
    cl::callback([](const std::string &CommaSeparatedArg) {
      StringRef Str = CommaSeparatedArg;
      RISCVPreLegalizerCombinerOption.push_back("*");
      do {
        auto X = Str.split(",");
        RISCVPreLegalizerCombinerOption.push_back(("!" + X.first).str());
        Str = X.second;
      } while (!Str.empty());
    }));


bool RISCVPreLegalizerCombinerImplRuleConfig::isRuleEnabled(unsigned RuleID) const {
    return  !DisabledRules.test(RuleID);
}
bool RISCVPreLegalizerCombinerImplRuleConfig::parseCommandLineOption() {
  for (StringRef Identifier : RISCVPreLegalizerCombinerOption) {
    bool Enabled = Identifier.consume_front("!");
    if (Enabled && !setRuleEnabled(Identifier))
      return false;
    if (!Enabled && !setRuleDisabled(Identifier))
      return false;
  }
  return true;
}

#endif // ifdef GET_GICOMBINER_TYPES

#ifdef GET_GICOMBINER_TYPES
const unsigned MAX_SUBTARGET_PREDICATES = 0;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GICOMBINER_TYPES

#ifdef GET_GICOMBINER_CLASS_MEMBERS
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const RISCVSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const RISCVSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GICOMBINER_CLASS_MEMBERS
#ifdef GET_GICOMBINER_CLASS_MEMBERS
  mutable MatcherState State;
  typedef ComplexRendererFns(RISCVPreLegalizerCombinerImpl::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(RISCVPreLegalizerCombinerImpl::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static RISCVPreLegalizerCombinerImpl::ComplexMatcherMemFn ComplexPredicateFns[];
  static RISCVPreLegalizerCombinerImpl::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testMOPredicate_MO(unsigned PredicateID, const MachineOperand &MO, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GICOMBINER_CLASS_MEMBERS

#ifdef GET_GICOMBINER_IMPL
// LLT Objects.
enum {
  GILLT_s1,
};
const static size_t NumTypeObjects = 1;
const static LLT TypeObjects[] = {
  LLT::scalar(1),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
};

PredicateBitset RISCVPreLegalizerCombinerImpl::
computeAvailableModuleFeatures(const RISCVSubtarget *Subtarget) const {
  PredicateBitset Features{};
  return Features;
}

void RISCVPreLegalizerCombinerImpl::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const RISCVSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset RISCVPreLegalizerCombinerImpl::
computeAvailableFunctionFeatures(const RISCVSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
};
// See constructor for table contents

RISCVPreLegalizerCombinerImpl::ComplexMatcherMemFn
RISCVPreLegalizerCombinerImpl::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
};

enum {
  GICXXPred_MI_Predicate_GICombiner0 = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_GICombiner1,
  GICXXPred_MI_Predicate_GICombiner2,
  GICXXPred_MI_Predicate_GICombiner3,
  GICXXPred_MI_Predicate_GICombiner4,
  GICXXPred_MI_Predicate_GICombiner5,
  GICXXPred_MI_Predicate_GICombiner6,
  GICXXPred_MI_Predicate_GICombiner7,
  GICXXPred_MI_Predicate_GICombiner8,
  GICXXPred_MI_Predicate_GICombiner9,
};
bool RISCVPreLegalizerCombinerImpl::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_GICombiner0: {
    return isGuaranteedNotToBePoison(State.MIs[0]->getOperand(1).getReg(), MRI);
  }
  case GICXXPred_MI_Predicate_GICombiner1: {
    return isGuaranteedNotToBeUndefOrPoison(State.MIs[0]->getOperand(1).getReg(), MRI);
  }
  case GICXXPred_MI_Predicate_GICombiner2: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), 1.0);
  }
  case GICXXPred_MI_Predicate_GICombiner3: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), -0.0);
  }
  case GICXXPred_MI_Predicate_GICombiner4: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), -1.0);
  }
  case GICXXPred_MI_Predicate_GICombiner5: {
    return State.MIs[1]->getOperand(1).getPredicate() == CmpInst::ICMP_EQ &&
                               !MRI.getType(State.MIs[1]->getOperand(2).getReg()).getScalarType().isPointer() &&
                               (MRI.getType(State.MIs[1]->getOperand(2).getReg()) ==
                                   MRI.getType(State.MIs[2]->getOperand(2).getReg()));
  }
  case GICXXPred_MI_Predicate_GICombiner6: {
    return State.MIs[1]->getOperand(1).getPredicate() == CmpInst::ICMP_NE &&
                               !MRI.getType(State.MIs[1]->getOperand(2).getReg()).getScalarType().isPointer() &&
                               (MRI.getType(State.MIs[1]->getOperand(2).getReg()) ==
                                   MRI.getType(State.MIs[2]->getOperand(2).getReg()));
  }
  case GICXXPred_MI_Predicate_GICombiner7: {
    return MRI.hasOneNonDBGUse(State.MIs[0]->getOperand(2).getReg()) &&
                    Helper.isLegalOrBeforeLegalizer(
                      {TargetOpcode::G_SEXT_INREG, {MRI.getType(State.MIs[1]->getOperand(1).getReg())}});
  }
  case GICXXPred_MI_Predicate_GICombiner8: {
    return Helper.isLegalOrBeforeLegalizer({TargetOpcode::G_LSHR,
                                                           {MRI.getType(State.MIs[2]->getOperand(1).getReg()),
                                                            MRI.getType(State.MIs[1]->getOperand(2).getReg())}});
  }
  case GICXXPred_MI_Predicate_GICombiner9: {
    return Helper.isLegalOrBeforeLegalizer({TargetOpcode::G_SHL,
                                                           {MRI.getType(State.MIs[2]->getOperand(1).getReg()),
                                                            MRI.getType(State.MIs[1]->getOperand(2).getReg())}});
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool RISCVPreLegalizerCombinerImpl::testMOPredicate_MO(unsigned PredicateID, const MachineOperand & MO, const MatcherState &State) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool RISCVPreLegalizerCombinerImpl::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool RISCVPreLegalizerCombinerImpl::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool RISCVPreLegalizerCombinerImpl::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
enum {
  GICXXPred_Simple_IsRule0Enabled = GICXXPred_Invalid + 1,
  GICXXPred_Simple_IsRule1Enabled,
  GICXXPred_Simple_IsRule2Enabled,
  GICXXPred_Simple_IsRule3Enabled,
  GICXXPred_Simple_IsRule4Enabled,
  GICXXPred_Simple_IsRule5Enabled,
  GICXXPred_Simple_IsRule6Enabled,
  GICXXPred_Simple_IsRule7Enabled,
  GICXXPred_Simple_IsRule8Enabled,
  GICXXPred_Simple_IsRule9Enabled,
  GICXXPred_Simple_IsRule10Enabled,
  GICXXPred_Simple_IsRule11Enabled,
  GICXXPred_Simple_IsRule12Enabled,
  GICXXPred_Simple_IsRule13Enabled,
  GICXXPred_Simple_IsRule14Enabled,
  GICXXPred_Simple_IsRule15Enabled,
  GICXXPred_Simple_IsRule16Enabled,
  GICXXPred_Simple_IsRule17Enabled,
  GICXXPred_Simple_IsRule18Enabled,
  GICXXPred_Simple_IsRule19Enabled,
  GICXXPred_Simple_IsRule20Enabled,
  GICXXPred_Simple_IsRule21Enabled,
  GICXXPred_Simple_IsRule22Enabled,
  GICXXPred_Simple_IsRule23Enabled,
  GICXXPred_Simple_IsRule24Enabled,
  GICXXPred_Simple_IsRule25Enabled,
  GICXXPred_Simple_IsRule26Enabled,
  GICXXPred_Simple_IsRule27Enabled,
  GICXXPred_Simple_IsRule28Enabled,
  GICXXPred_Simple_IsRule29Enabled,
  GICXXPred_Simple_IsRule30Enabled,
  GICXXPred_Simple_IsRule31Enabled,
  GICXXPred_Simple_IsRule32Enabled,
  GICXXPred_Simple_IsRule33Enabled,
  GICXXPred_Simple_IsRule34Enabled,
  GICXXPred_Simple_IsRule35Enabled,
  GICXXPred_Simple_IsRule36Enabled,
  GICXXPred_Simple_IsRule37Enabled,
  GICXXPred_Simple_IsRule38Enabled,
  GICXXPred_Simple_IsRule39Enabled,
  GICXXPred_Simple_IsRule40Enabled,
  GICXXPred_Simple_IsRule41Enabled,
  GICXXPred_Simple_IsRule42Enabled,
  GICXXPred_Simple_IsRule43Enabled,
  GICXXPred_Simple_IsRule44Enabled,
  GICXXPred_Simple_IsRule45Enabled,
  GICXXPred_Simple_IsRule46Enabled,
  GICXXPred_Simple_IsRule47Enabled,
  GICXXPred_Simple_IsRule48Enabled,
  GICXXPred_Simple_IsRule49Enabled,
  GICXXPred_Simple_IsRule50Enabled,
  GICXXPred_Simple_IsRule51Enabled,
  GICXXPred_Simple_IsRule52Enabled,
  GICXXPred_Simple_IsRule53Enabled,
  GICXXPred_Simple_IsRule54Enabled,
  GICXXPred_Simple_IsRule55Enabled,
  GICXXPred_Simple_IsRule56Enabled,
  GICXXPred_Simple_IsRule57Enabled,
  GICXXPred_Simple_IsRule58Enabled,
  GICXXPred_Simple_IsRule59Enabled,
  GICXXPred_Simple_IsRule60Enabled,
  GICXXPred_Simple_IsRule61Enabled,
  GICXXPred_Simple_IsRule62Enabled,
  GICXXPred_Simple_IsRule63Enabled,
  GICXXPred_Simple_IsRule64Enabled,
  GICXXPred_Simple_IsRule65Enabled,
  GICXXPred_Simple_IsRule66Enabled,
  GICXXPred_Simple_IsRule67Enabled,
  GICXXPred_Simple_IsRule68Enabled,
  GICXXPred_Simple_IsRule69Enabled,
  GICXXPred_Simple_IsRule70Enabled,
  GICXXPred_Simple_IsRule71Enabled,
  GICXXPred_Simple_IsRule72Enabled,
  GICXXPred_Simple_IsRule73Enabled,
  GICXXPred_Simple_IsRule74Enabled,
  GICXXPred_Simple_IsRule75Enabled,
  GICXXPred_Simple_IsRule76Enabled,
  GICXXPred_Simple_IsRule77Enabled,
  GICXXPred_Simple_IsRule78Enabled,
  GICXXPred_Simple_IsRule79Enabled,
  GICXXPred_Simple_IsRule80Enabled,
  GICXXPred_Simple_IsRule81Enabled,
  GICXXPred_Simple_IsRule82Enabled,
  GICXXPred_Simple_IsRule83Enabled,
  GICXXPred_Simple_IsRule84Enabled,
  GICXXPred_Simple_IsRule85Enabled,
  GICXXPred_Simple_IsRule86Enabled,
  GICXXPred_Simple_IsRule87Enabled,
  GICXXPred_Simple_IsRule88Enabled,
  GICXXPred_Simple_IsRule89Enabled,
  GICXXPred_Simple_IsRule90Enabled,
  GICXXPred_Simple_IsRule91Enabled,
  GICXXPred_Simple_IsRule92Enabled,
  GICXXPred_Simple_IsRule93Enabled,
  GICXXPred_Simple_IsRule94Enabled,
  GICXXPred_Simple_IsRule95Enabled,
  GICXXPred_Simple_IsRule96Enabled,
  GICXXPred_Simple_IsRule97Enabled,
  GICXXPred_Simple_IsRule98Enabled,
  GICXXPred_Simple_IsRule99Enabled,
  GICXXPred_Simple_IsRule100Enabled,
  GICXXPred_Simple_IsRule101Enabled,
  GICXXPred_Simple_IsRule102Enabled,
  GICXXPred_Simple_IsRule103Enabled,
  GICXXPred_Simple_IsRule104Enabled,
  GICXXPred_Simple_IsRule105Enabled,
  GICXXPred_Simple_IsRule106Enabled,
  GICXXPred_Simple_IsRule107Enabled,
  GICXXPred_Simple_IsRule108Enabled,
  GICXXPred_Simple_IsRule109Enabled,
  GICXXPred_Simple_IsRule110Enabled,
  GICXXPred_Simple_IsRule111Enabled,
  GICXXPred_Simple_IsRule112Enabled,
  GICXXPred_Simple_IsRule113Enabled,
  GICXXPred_Simple_IsRule114Enabled,
  GICXXPred_Simple_IsRule115Enabled,
  GICXXPred_Simple_IsRule116Enabled,
  GICXXPred_Simple_IsRule117Enabled,
  GICXXPred_Simple_IsRule118Enabled,
  GICXXPred_Simple_IsRule119Enabled,
  GICXXPred_Simple_IsRule120Enabled,
  GICXXPred_Simple_IsRule121Enabled,
  GICXXPred_Simple_IsRule122Enabled,
  GICXXPred_Simple_IsRule123Enabled,
  GICXXPred_Simple_IsRule124Enabled,
  GICXXPred_Simple_IsRule125Enabled,
  GICXXPred_Simple_IsRule126Enabled,
  GICXXPred_Simple_IsRule127Enabled,
  GICXXPred_Simple_IsRule128Enabled,
  GICXXPred_Simple_IsRule129Enabled,
  GICXXPred_Simple_IsRule130Enabled,
  GICXXPred_Simple_IsRule131Enabled,
  GICXXPred_Simple_IsRule132Enabled,
  GICXXPred_Simple_IsRule133Enabled,
  GICXXPred_Simple_IsRule134Enabled,
  GICXXPred_Simple_IsRule135Enabled,
  GICXXPred_Simple_IsRule136Enabled,
  GICXXPred_Simple_IsRule137Enabled,
  GICXXPred_Simple_IsRule138Enabled,
  GICXXPred_Simple_IsRule139Enabled,
  GICXXPred_Simple_IsRule140Enabled,
  GICXXPred_Simple_IsRule141Enabled,
  GICXXPred_Simple_IsRule142Enabled,
  GICXXPred_Simple_IsRule143Enabled,
  GICXXPred_Simple_IsRule144Enabled,
  GICXXPred_Simple_IsRule145Enabled,
  GICXXPred_Simple_IsRule146Enabled,
  GICXXPred_Simple_IsRule147Enabled,
  GICXXPred_Simple_IsRule148Enabled,
  GICXXPred_Simple_IsRule149Enabled,
  GICXXPred_Simple_IsRule150Enabled,
  GICXXPred_Simple_IsRule151Enabled,
  GICXXPred_Simple_IsRule152Enabled,
  GICXXPred_Simple_IsRule153Enabled,
  GICXXPred_Simple_IsRule154Enabled,
  GICXXPred_Simple_IsRule155Enabled,
  GICXXPred_Simple_IsRule156Enabled,
  GICXXPred_Simple_IsRule157Enabled,
  GICXXPred_Simple_IsRule158Enabled,
  GICXXPred_Simple_IsRule159Enabled,
  GICXXPred_Simple_IsRule160Enabled,
  GICXXPred_Simple_IsRule161Enabled,
  GICXXPred_Simple_IsRule162Enabled,
  GICXXPred_Simple_IsRule163Enabled,
  GICXXPred_Simple_IsRule164Enabled,
  GICXXPred_Simple_IsRule165Enabled,
  GICXXPred_Simple_IsRule166Enabled,
  GICXXPred_Simple_IsRule167Enabled,
  GICXXPred_Simple_IsRule168Enabled,
  GICXXPred_Simple_IsRule169Enabled,
  GICXXPred_Simple_IsRule170Enabled,
  GICXXPred_Simple_IsRule171Enabled,
  GICXXPred_Simple_IsRule172Enabled,
  GICXXPred_Simple_IsRule173Enabled,
  GICXXPred_Simple_IsRule174Enabled,
  GICXXPred_Simple_IsRule175Enabled,
  GICXXPred_Simple_IsRule176Enabled,
  GICXXPred_Simple_IsRule177Enabled,
  GICXXPred_Simple_IsRule178Enabled,
  GICXXPred_Simple_IsRule179Enabled,
  GICXXPred_Simple_IsRule180Enabled,
  GICXXPred_Simple_IsRule181Enabled,
  GICXXPred_Simple_IsRule182Enabled,
  GICXXPred_Simple_IsRule183Enabled,
  GICXXPred_Simple_IsRule184Enabled,
  GICXXPred_Simple_IsRule185Enabled,
  GICXXPred_Simple_IsRule186Enabled,
  GICXXPred_Simple_IsRule187Enabled,
  GICXXPred_Simple_IsRule188Enabled,
  GICXXPred_Simple_IsRule189Enabled,
  GICXXPred_Simple_IsRule190Enabled,
  GICXXPred_Simple_IsRule191Enabled,
  GICXXPred_Simple_IsRule192Enabled,
  GICXXPred_Simple_IsRule193Enabled,
  GICXXPred_Simple_IsRule194Enabled,
  GICXXPred_Simple_IsRule195Enabled,
  GICXXPred_Simple_IsRule196Enabled,
  GICXXPred_Simple_IsRule197Enabled,
  GICXXPred_Simple_IsRule198Enabled,
  GICXXPred_Simple_IsRule199Enabled,
  GICXXPred_Simple_IsRule200Enabled,
  GICXXPred_Simple_IsRule201Enabled,
  GICXXPred_Simple_IsRule202Enabled,
  GICXXPred_Simple_IsRule203Enabled,
  GICXXPred_Simple_IsRule204Enabled,
  GICXXPred_Simple_IsRule205Enabled,
  GICXXPred_Simple_IsRule206Enabled,
  GICXXPred_Simple_IsRule207Enabled,
  GICXXPred_Simple_IsRule208Enabled,
  GICXXPred_Simple_IsRule209Enabled,
  GICXXPred_Simple_IsRule210Enabled,
  GICXXPred_Simple_IsRule211Enabled,
  GICXXPred_Simple_IsRule212Enabled,
  GICXXPred_Simple_IsRule213Enabled,
  GICXXPred_Simple_IsRule214Enabled,
};

bool RISCVPreLegalizerCombinerImpl::testSimplePredicate(unsigned Predicate) const {
    return RuleConfig.isRuleEnabled(Predicate - GICXXPred_Invalid - 1);
}
// Custom renderers.
enum {
  GICR_Invalid,
};
RISCVPreLegalizerCombinerImpl::CustomRendererFn
RISCVPreLegalizerCombinerImpl::CustomRenderers[] = {
  nullptr, // GICR_Invalid
};

bool RISCVPreLegalizerCombinerImpl::tryCombineAll(MachineInstr &I) const {
  const TargetSubtargetInfo &ST = MF.getSubtarget();
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  B.setInstrAndDebugLoc(I);
  State.MIs.clear();
  State.MIs.push_back(&I);
  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), *ST.getInstrInfo(), MRI, *MRI.getTargetRegisterInfo(), *ST.getRegBankInfo(), AvailableFeatures, /*CoverageInfo*/ nullptr)) {
    return true;
  }

  return false;
}

enum {
  GICXXCustomAction_GICombiner0 = GICXXCustomAction_Invalid + 1,
  GICXXCustomAction_GICombiner1,
  GICXXCustomAction_GICombiner2,
  GICXXCustomAction_GICombiner3,
  GICXXCustomAction_GICombiner4,
  GICXXCustomAction_GICombiner5,
  GICXXCustomAction_GICombiner6,
  GICXXCustomAction_GICombiner7,
  GICXXCustomAction_GICombiner8,
  GICXXCustomAction_GICombiner9,
  GICXXCustomAction_GICombiner10,
  GICXXCustomAction_GICombiner11,
  GICXXCustomAction_GICombiner12,
  GICXXCustomAction_GICombiner13,
  GICXXCustomAction_GICombiner14,
  GICXXCustomAction_GICombiner15,
  GICXXCustomAction_GICombiner16,
  GICXXCustomAction_GICombiner17,
  GICXXCustomAction_GICombiner18,
  GICXXCustomAction_GICombiner19,
  GICXXCustomAction_GICombiner20,
  GICXXCustomAction_GICombiner21,
  GICXXCustomAction_GICombiner22,
  GICXXCustomAction_GICombiner23,
  GICXXCustomAction_GICombiner24,
  GICXXCustomAction_GICombiner25,
  GICXXCustomAction_GICombiner26,
  GICXXCustomAction_GICombiner27,
  GICXXCustomAction_GICombiner28,
  GICXXCustomAction_GICombiner29,
  GICXXCustomAction_GICombiner30,
  GICXXCustomAction_GICombiner31,
  GICXXCustomAction_GICombiner32,
  GICXXCustomAction_GICombiner33,
  GICXXCustomAction_GICombiner34,
  GICXXCustomAction_GICombiner35,
  GICXXCustomAction_GICombiner36,
  GICXXCustomAction_GICombiner37,
  GICXXCustomAction_GICombiner38,
  GICXXCustomAction_GICombiner39,
  GICXXCustomAction_GICombiner40,
  GICXXCustomAction_GICombiner41,
  GICXXCustomAction_GICombiner42,
  GICXXCustomAction_GICombiner43,
  GICXXCustomAction_GICombiner44,
  GICXXCustomAction_GICombiner45,
  GICXXCustomAction_GICombiner46,
  GICXXCustomAction_GICombiner47,
  GICXXCustomAction_GICombiner48,
  GICXXCustomAction_GICombiner49,
  GICXXCustomAction_GICombiner50,
  GICXXCustomAction_GICombiner51,
  GICXXCustomAction_GICombiner52,
  GICXXCustomAction_GICombiner53,
  GICXXCustomAction_GICombiner54,
  GICXXCustomAction_GICombiner55,
  GICXXCustomAction_GICombiner56,
  GICXXCustomAction_GICombiner57,
  GICXXCustomAction_GICombiner58,
  GICXXCustomAction_GICombiner59,
  GICXXCustomAction_GICombiner60,
  GICXXCustomAction_GICombiner61,
  GICXXCustomAction_GICombiner62,
  GICXXCustomAction_GICombiner63,
  GICXXCustomAction_GICombiner64,
  GICXXCustomAction_GICombiner65,
  GICXXCustomAction_GICombiner66,
  GICXXCustomAction_GICombiner67,
  GICXXCustomAction_GICombiner68,
  GICXXCustomAction_GICombiner69,
  GICXXCustomAction_GICombiner70,
  GICXXCustomAction_GICombiner71,
  GICXXCustomAction_GICombiner72,
  GICXXCustomAction_GICombiner73,
  GICXXCustomAction_GICombiner74,
  GICXXCustomAction_GICombiner75,
  GICXXCustomAction_GICombiner76,
  GICXXCustomAction_GICombiner77,
  GICXXCustomAction_GICombiner78,
  GICXXCustomAction_GICombiner79,
  GICXXCustomAction_GICombiner80,
  GICXXCustomAction_GICombiner81,
  GICXXCustomAction_GICombiner82,
  GICXXCustomAction_GICombiner83,
  GICXXCustomAction_GICombiner84,
  GICXXCustomAction_GICombiner85,
  GICXXCustomAction_GICombiner86,
  GICXXCustomAction_GICombiner87,
  GICXXCustomAction_GICombiner88,
  GICXXCustomAction_GICombiner89,
  GICXXCustomAction_GICombiner90,
  GICXXCustomAction_GICombiner91,
  GICXXCustomAction_GICombiner92,
  GICXXCustomAction_GICombiner93,
  GICXXCustomAction_GICombiner94,
  GICXXCustomAction_GICombiner95,
  GICXXCustomAction_GICombiner96,
  GICXXCustomAction_GICombiner97,
  GICXXCustomAction_GICombiner98,
  GICXXCustomAction_GICombiner99,
  GICXXCustomAction_GICombiner100,
  GICXXCustomAction_GICombiner101,
  GICXXCustomAction_GICombiner102,
  GICXXCustomAction_GICombiner103,
  GICXXCustomAction_GICombiner104,
  GICXXCustomAction_GICombiner105,
  GICXXCustomAction_GICombiner106,
  GICXXCustomAction_GICombiner107,
  GICXXCustomAction_GICombiner108,
  GICXXCustomAction_GICombiner109,
  GICXXCustomAction_GICombiner110,
  GICXXCustomAction_GICombiner111,
  GICXXCustomAction_GICombiner112,
  GICXXCustomAction_GICombiner113,
  GICXXCustomAction_GICombiner114,
  GICXXCustomAction_GICombiner115,
  GICXXCustomAction_GICombiner116,
  GICXXCustomAction_GICombiner117,
  GICXXCustomAction_GICombiner118,
  GICXXCustomAction_GICombiner119,
  GICXXCustomAction_GICombiner120,
  GICXXCustomAction_GICombiner121,
  GICXXCustomAction_GICombiner122,
  GICXXCustomAction_GICombiner123,
  GICXXCustomAction_GICombiner124,
  GICXXCustomAction_GICombiner125,
  GICXXCustomAction_GICombiner126,
  GICXXCustomAction_GICombiner127,
  GICXXCustomAction_GICombiner128,
  GICXXCustomAction_GICombiner129,
  GICXXCustomAction_GICombiner130,
  GICXXCustomAction_GICombiner131,
  GICXXCustomAction_GICombiner132,
  GICXXCustomAction_GICombiner133,
  GICXXCustomAction_GICombiner134,
  GICXXCustomAction_GICombiner135,
  GICXXCustomAction_GICombiner136,
  GICXXCustomAction_GICombiner137,
  GICXXCustomAction_GICombiner138,
  GICXXCustomAction_GICombiner139,
  GICXXCustomAction_GICombiner140,
  GICXXCustomAction_GICombiner141,
  GICXXCustomAction_GICombiner142,
  GICXXCustomAction_GICombiner143,
  GICXXCustomAction_GICombiner144,
  GICXXCustomAction_GICombiner145,
  GICXXCustomAction_GICombiner146,
  GICXXCustomAction_GICombiner147,
  GICXXCustomAction_GICombiner148,
  GICXXCustomAction_GICombiner149,
  GICXXCustomAction_GICombiner150,
};
bool RISCVPreLegalizerCombinerImpl::runCustomAction(unsigned ApplyID, const MatcherState &State, NewMIVector &OutMIs) const {
  Helper.getBuilder().setInstrAndDebugLoc(*State.MIs[0]);
  switch(ApplyID) {
  case GICXXCustomAction_GICombiner0:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldAPlusC1MinusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner1:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldC2MinusAPlusC1(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner2:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldAMinusC1MinusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner3:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldC1Minus2MinusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner4:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldAMinusC1PlusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner5:{
    // Match Patterns
    if(![&](){return Helper.matchCombineCopy(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineCopy(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner6:{
    unsigned GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineMulToShl(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineMulToShl(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner7:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineSubToAdd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner8:{
    std::pair<Register, bool> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineAddP2IToPtrAdd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineAddP2IToPtrAdd(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner9:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElement(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner10:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchInsertVectorElementOOB(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner11:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithDifferentIndices(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner12:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithBuildVector(*State.MIs[0], *State.MIs[1],
              GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner13:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithBuildVectorTrunc(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner14:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithShuffleVector(*State.MIs[0], *State.MIs[1],
              GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner15:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAddOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner16:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMulOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner17:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShlOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner18:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSubOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner19:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return !isGuaranteedNotToBePoison(State.MIs[0]->getOperand(1).getReg(), MRI) && Helper.matchFreezeOfSingleMaybePoisonOperand(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner20:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncateOfExt(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner21:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtOfExt(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner22:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantSextInReg(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner23:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCastOfSelect(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner24:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCastOfBuildVector(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner25:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchNarrowBinop(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner26:{
    APInt GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCastOfInteger(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner27:{
    SmallVector<Register> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineInsertVecElts(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineInsertVecElts(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner28:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVecEltBuildVec(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExtractVecEltBuildVec(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner29:{
    SmallVector<std::pair<Register, MachineInstr*>> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractAllEltsFromBuildVector(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExtractAllEltsFromBuildVector(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner30:{
    PreferredTuple GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineExtendingLoads(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineExtendingLoads(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner31:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineLoadWithAndMask(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner32:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineExtractedVectorLoad(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner33:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0], 0.0);
    return true;
  }
  case GICXXCustomAction_GICombiner34:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], 0);
    return true;
  }
  case GICXXCustomAction_GICombiner35:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], -1);
    return true;
  }
  case GICXXCustomAction_GICombiner36:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsUndef(*State.MIs[0], 1);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], 0);
    return true;
  }
  case GICXXCustomAction_GICombiner37:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsUndef(*State.MIs[0], 2);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner38:{
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]->getOperand(0).getParent());
    return true;
  }
  case GICXXCustomAction_GICombiner39:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner40:{
    // Match Patterns
    if(![&](){return Helper.matchAllExplicitUsesAreUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner41:{
    // Match Patterns
    if(![&](){return Helper.matchUndefShuffleVectorMask(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner42:{
    // Match Patterns
    if(![&](){return Helper.matchUndefStore(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.eraseInst(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner43:{
    // Match Patterns
    if(![&](){return Helper.matchInsertExtractVecEltOutOfBounds(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner44:{
    // Match Patterns
    if(![&](){return Helper.matchSelectSameVal(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 2);
    return true;
  }
  case GICXXCustomAction_GICombiner45:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsZero(*State.MIs[0], 1);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 1);
    return true;
  }
  case GICXXCustomAction_GICombiner46:{
    Register GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineI2PToP2I(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineI2PToP2I(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner47:{
    Register GIMatchData_info;
    // Match Patterns
    if(![&](){GIMatchData_info = State.MIs[1]->getOperand(1).getReg(); return true;}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineP2IToI2P(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner48:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineAnyExtTrunc(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner49:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchBuildVectorIdentityFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner50:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncBuildVectorFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner51:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncLshrBuildVectorFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner52:{
    // Match Patterns
    if(![&](){return MRI.getType(State.MIs[1]->getOperand(1).getReg()) == MRI.getType(State.MIs[0]->getOperand(0).getReg());}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], State.MIs[1]->getOperand(1).getReg());
    return true;
  }
  case GICXXCustomAction_GICombiner53:{
    MachineInstr* GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtendThroughPhis(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExtendThroughPhis(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner54:{
    std::tuple<Register, Register> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchSimplifyAddToSub(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySimplifyAddToSub(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner55:{
    InstructionStepsMatchInfo GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchHoistLogicOpWithSameOpcodeHands(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildInstructionSteps(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner56:{
    std::optional<int64_t> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShiftsTooBig(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    if (GIMatchData_matchinfo) {
              Helper.replaceInstWithConstant(*State.MIs[0], *GIMatchData_matchinfo);
            } else {
              Helper.replaceInstWithUndef(*State.MIs[0]);
            }
    return true;
  }
  case GICXXCustomAction_GICombiner57:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchReassocPtrAdd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner58:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchReassocCommBinOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner59:{
    PtrAddChain GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchPtrAddImmedChain(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyPtrAddImmedChain(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner60:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCanonicalizeICmp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner61:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCanonicalizeFCmp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner62:{
    int64_t GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchICmpToTrueFalseKnownBits(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner63:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchICmpToLHSKnownBits(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner64:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchRedundantBinOpInEquality(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner65:{
    std::tuple<Register, int64_t> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchAshrShlToSextInreg(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyAshShlToSextInreg(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner66:{
    std::tuple<Register, unsigned> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSextInRegOfLoad(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySextInRegOfLoad(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner67:{
    RegisterImmPair GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineShlOfExtend(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineShlOfExtend(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner68:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchNarrowBinopFeedingAnd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner69:{
    unsigned GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantSelectCmp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner70:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchSelectIMinMax(State.MIs[0]->getOperand(0), GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner71:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSelect(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner72:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantAnd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner73:{
    // Match Patterns
    if(![&](){return Helper.matchRedundantSExtInReg(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 1);
    return true;
  }
  case GICXXCustomAction_GICombiner74:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantOr(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner75:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsKnownToBeAPowerOfTwo(*State.MIs[0], 2);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySimplifyURemByPow2(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner76:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineZextTrunc(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner77:{
    // Match Patterns
    if(![&](){unsigned BitWidth = MRI.getType(State.MIs[0]->getOperand(1).getReg()).getScalarSizeInBits();
                return Helper.getValueTracking()->maskedValueIsZero(State.MIs[0]->getOperand(1).getReg(),
                         APInt::getOneBitSet(BitWidth, State.MIs[0]->getOperand(2).getImm() - 1));}()) {
      return false;
    }
    // Apply Patterns
    Helper.getBuilder().setInstrAndDebugLoc(*State.MIs[0]);
              Helper.getBuilder().buildZExtInReg(State.MIs[0]->getOperand(0), State.MIs[0]->getOperand(1), State.MIs[0]->getOperand(2).getImm());
              State.MIs[0]->eraseFromParent();
    return true;
  }
  case GICXXCustomAction_GICombiner78:{
    std::pair<MachineInstr*, LLT> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineTruncOfShift(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineTruncOfShift(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner79:{
    SmallVector<Register> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchNotCmp(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyNotCmp(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner80:{
    MachineInstr * GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchOptBrCondByInvertingCond(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyOptBrCondByInvertingCond(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner81:{
    // Apply Patterns
    Helper.applyCombineConstantFoldFpUnary(*State.MIs[0], State.MIs[1]->getOperand(1).getFPImm());
    return true;
  }
  case GICXXCustomAction_GICombiner82:{
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0]->getOperand(0).getParent(), 0.0);
    return true;
  }
  case GICXXCustomAction_GICombiner83:{
    APInt GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineConstPtrAddToI2P(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineConstPtrAddToI2P(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner84:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchOverlappingAnd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner85:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMulOBy2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner86:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMulOBy0(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner87:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAddEToAddO(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner88:{
    unsigned GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFMinMaxNaN(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner89:{
    // Match Patterns
    if(![&](){return Helper.matchFPowIExpansion(*State.MIs[0], State.MIs[1]->getOperand(1).getCImm()->getSExtValue());}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExpandFPowI(*State.MIs[0], State.MIs[1]->getOperand(1).getCImm()->getSExtValue());
    return true;
  }
  case GICXXCustomAction_GICombiner90:{
    std::pair<Register, Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchXorOfAndWithSameReg(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyXorOfAndWithSameReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner91:{
    // Match Patterns
    if(![&](){return Helper.matchPtrAddZero(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyPtrAddZero(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner92:{
    RegisterImmPair GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShiftImmedChain(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyShiftImmedChain(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner93:{
    ShiftOfShiftedLogic GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShiftOfShiftedLogic(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyShiftOfShiftedLogic(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner94:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchLoadOrCombine(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner95:{
    MachineInstr * GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineDivRem(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineDivRem(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner96:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchOrShiftToFunnelShift(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner97:{
    // Match Patterns
    if(![&](){return Helper.matchFunnelShiftToRotate(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFunnelShiftToRotate(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner98:{
    // Match Patterns
    if(![&](){return Helper.matchConstantLargerBitWidth(*State.MIs[0], 3);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFunnelShiftConstantModulo(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner99:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCommuteShift(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner100:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromSExtInReg(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner101:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromAnd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner102:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromShr(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner103:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromShrAnd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner104:{
    APInt GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldBinOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner105:{
    ConstantFP* GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldFPBinOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner106:{
    ConstantFP* GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldFMA(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner107:{
    APInt GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldCastOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner108:{
    // Match Patterns
    if(![&](){return Helper.matchUDivorURemByConst(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUDivorURemByConst(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner109:{
    // Match Patterns
    if(![&](){return Helper.matchSDivByConst(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySDivByConst(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner110:{
    // Match Patterns
    if(![&](){return Helper.matchDivByPow2(*State.MIs[0], /*IsSigned=*/true);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySDivByPow2(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner111:{
    // Match Patterns
    if(![&](){return Helper.matchDivByPow2(*State.MIs[0], /*IsSigned=*/false);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUDivByPow2(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner112:{
    // Match Patterns
    if(![&](){return Helper.matchUMulHToLShr(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUMulHToLShr(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner113:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantNegOperands(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner114:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchAndOrDisjointMask(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner115:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFMulToFMadOrFMA(*State.MIs[0],
                                                                  GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner116:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFpExtFMulToFMadOrFMA(*State.MIs[0],
                                                                       GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner117:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFMAFMulToFMadOrFMA(*State.MIs[0],
                                                                     GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner118:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFpExtFMulToFMadOrFMAAggressive(
                                                          *State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner119:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFMulToFMadOrFMA(*State.MIs[0],
                                                                  GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner120:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFNegFMulToFMadOrFMA(*State.MIs[0],
                                                                      GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner121:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFpExtFMulToFMadOrFMA(*State.MIs[0],
                                                                       GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner122:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFpExtFNegFMulToFMadOrFMA(
                                                    *State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner123:{
    unsigned GIMatchData_select_op_no;
    // Match Patterns
    if(![&](){return Helper.matchFoldBinOpIntoSelect(*State.MIs[0], GIMatchData_select_op_no);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFoldBinOpIntoSelect(*State.MIs[0], GIMatchData_select_op_no);
    return true;
  }
  case GICXXCustomAction_GICombiner124:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSubAddSameReg(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner125:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchSimplifySelectToMinMax(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner126:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFsubToFneg(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFsubToFneg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner127:{
    // Match Patterns
    if(![&](){return Helper.matchCommuteConstantToRHS(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCommuteBinOpOperands(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner128:{
    // Match Patterns
    if(![&](){return Helper.matchCommuteFPConstantToRHS(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCommuteBinOpOperands(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner129:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAnd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner130:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchOr(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner131:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSimplifyNegMinMax(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner132:{
    SmallVector<Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineConcatVectors(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineConcatVectors(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner133:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSextOfTrunc(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner134:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchZextOfTrunc(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner135:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchNonNegZext(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner136:{
    SmallVector<Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineShuffleConcat(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineShuffleConcat(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner137:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShuffleUndefRHS(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner138:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShuffleDisjointMask(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner139:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchUseVectorTruncate(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUseVectorTruncate(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner140:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchUnmergeValuesAnyExtBuildVector(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner141:{
    SmallVector<Register> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeMergeToPlainValues(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeMergeToPlainValues(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner142:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineMergeUnmerge(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner143:{
    SmallVector<APInt, 8> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeConstant(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeConstant(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner144:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeUndef(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner145:{
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeWithDeadLanesToTrunc(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeWithDeadLanesToTrunc(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner146:{
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeZExtToZExt(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeZExtToZExt(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner147:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMergeXAndUndef(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner148:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMergeXAndZero(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner149:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAddOverflow(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner150:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSuboCarryOut(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  }
  llvm_unreachable("Unknown Apply Action");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *RISCVPreLegalizerCombinerImpl::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*    0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(20), GIMT_Encode2(267), /*)*//*default:*//*Label 95*/ GIMT_Encode4(7042),
     /*   10 */ /*TargetOpcode::COPY*//*Label 0*/ GIMT_Encode4(998), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  142 */ /*TargetOpcode::G_ADD*//*Label 1*/ GIMT_Encode4(1010),
     /*  146 */ /*TargetOpcode::G_SUB*//*Label 2*/ GIMT_Encode4(1567),
     /*  150 */ /*TargetOpcode::G_MUL*//*Label 3*/ GIMT_Encode4(1885),
     /*  154 */ /*TargetOpcode::G_SDIV*//*Label 4*/ GIMT_Encode4(2051),
     /*  158 */ /*TargetOpcode::G_UDIV*//*Label 5*/ GIMT_Encode4(2124),
     /*  162 */ /*TargetOpcode::G_SREM*//*Label 6*/ GIMT_Encode4(2208),
     /*  166 */ /*TargetOpcode::G_UREM*//*Label 7*/ GIMT_Encode4(2253), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  178 */ /*TargetOpcode::G_AND*//*Label 8*/ GIMT_Encode4(2331),
     /*  182 */ /*TargetOpcode::G_OR*//*Label 9*/ GIMT_Encode4(2612),
     /*  186 */ /*TargetOpcode::G_XOR*//*Label 10*/ GIMT_Encode4(2857), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  202 */ /*TargetOpcode::G_PHI*//*Label 11*/ GIMT_Encode4(2958), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  226 */ /*TargetOpcode::G_UNMERGE_VALUES*//*Label 12*/ GIMT_Encode4(2970), GIMT_Encode4(0),
     /*  234 */ /*TargetOpcode::G_MERGE_VALUES*//*Label 13*/ GIMT_Encode4(3037),
     /*  238 */ /*TargetOpcode::G_BUILD_VECTOR*//*Label 14*/ GIMT_Encode4(3111),
     /*  242 */ /*TargetOpcode::G_BUILD_VECTOR_TRUNC*//*Label 15*/ GIMT_Encode4(3159),
     /*  246 */ /*TargetOpcode::G_CONCAT_VECTORS*//*Label 16*/ GIMT_Encode4(3171),
     /*  250 */ /*TargetOpcode::G_PTRTOINT*//*Label 17*/ GIMT_Encode4(3183),
     /*  254 */ /*TargetOpcode::G_INTTOPTR*//*Label 18*/ GIMT_Encode4(3226),
     /*  258 */ /*TargetOpcode::G_BITCAST*//*Label 19*/ GIMT_Encode4(3259),
     /*  262 */ /*TargetOpcode::G_FREEZE*//*Label 20*/ GIMT_Encode4(3302), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  302 */ /*TargetOpcode::G_LOAD*//*Label 21*/ GIMT_Encode4(3366),
     /*  306 */ /*TargetOpcode::G_SEXTLOAD*//*Label 22*/ GIMT_Encode4(3378),
     /*  310 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 23*/ GIMT_Encode4(3390), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  326 */ /*TargetOpcode::G_STORE*//*Label 24*/ GIMT_Encode4(3402), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  462 */ /*TargetOpcode::G_ANYEXT*//*Label 25*/ GIMT_Encode4(3414),
     /*  466 */ /*TargetOpcode::G_TRUNC*//*Label 26*/ GIMT_Encode4(3542), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  498 */ /*TargetOpcode::G_SEXT*//*Label 27*/ GIMT_Encode4(3900),
     /*  502 */ /*TargetOpcode::G_SEXT_INREG*//*Label 28*/ GIMT_Encode4(3975),
     /*  506 */ /*TargetOpcode::G_ZEXT*//*Label 29*/ GIMT_Encode4(4041),
     /*  510 */ /*TargetOpcode::G_SHL*//*Label 30*/ GIMT_Encode4(4171),
     /*  514 */ /*TargetOpcode::G_LSHR*//*Label 31*/ GIMT_Encode4(4340),
     /*  518 */ /*TargetOpcode::G_ASHR*//*Label 32*/ GIMT_Encode4(4463),
     /*  522 */ /*TargetOpcode::G_FSHL*//*Label 33*/ GIMT_Encode4(4597),
     /*  526 */ /*TargetOpcode::G_FSHR*//*Label 34*/ GIMT_Encode4(4640),
     /*  530 */ /*TargetOpcode::G_ROTR*//*Label 35*/ GIMT_Encode4(4683),
     /*  534 */ /*TargetOpcode::G_ROTL*//*Label 36*/ GIMT_Encode4(4707),
     /*  538 */ /*TargetOpcode::G_ICMP*//*Label 37*/ GIMT_Encode4(4731),
     /*  542 */ /*TargetOpcode::G_FCMP*//*Label 38*/ GIMT_Encode4(4776), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  554 */ /*TargetOpcode::G_SELECT*//*Label 39*/ GIMT_Encode4(4788),
     /*  558 */ /*TargetOpcode::G_UADDO*//*Label 40*/ GIMT_Encode4(4883),
     /*  562 */ /*TargetOpcode::G_UADDE*//*Label 41*/ GIMT_Encode4(4906),
     /*  566 */ /*TargetOpcode::G_USUBO*//*Label 42*/ GIMT_Encode4(4918),
     /*  570 */ /*TargetOpcode::G_USUBE*//*Label 43*/ GIMT_Encode4(4930),
     /*  574 */ /*TargetOpcode::G_SADDO*//*Label 44*/ GIMT_Encode4(4942),
     /*  578 */ /*TargetOpcode::G_SADDE*//*Label 45*/ GIMT_Encode4(4965),
     /*  582 */ /*TargetOpcode::G_SSUBO*//*Label 46*/ GIMT_Encode4(4977),
     /*  586 */ /*TargetOpcode::G_SSUBE*//*Label 47*/ GIMT_Encode4(4989),
     /*  590 */ /*TargetOpcode::G_UMULO*//*Label 48*/ GIMT_Encode4(5001),
     /*  594 */ /*TargetOpcode::G_SMULO*//*Label 49*/ GIMT_Encode4(5035),
     /*  598 */ /*TargetOpcode::G_UMULH*//*Label 50*/ GIMT_Encode4(5069),
     /*  602 */ /*TargetOpcode::G_SMULH*//*Label 51*/ GIMT_Encode4(5092),
     /*  606 */ /*TargetOpcode::G_UADDSAT*//*Label 52*/ GIMT_Encode4(5104),
     /*  610 */ /*TargetOpcode::G_SADDSAT*//*Label 53*/ GIMT_Encode4(5116), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  622 */ /*TargetOpcode::G_USHLSAT*//*Label 54*/ GIMT_Encode4(5128),
     /*  626 */ /*TargetOpcode::G_SSHLSAT*//*Label 55*/ GIMT_Encode4(5151),
     /*  630 */ /*TargetOpcode::G_SMULFIX*//*Label 56*/ GIMT_Encode4(5174),
     /*  634 */ /*TargetOpcode::G_UMULFIX*//*Label 57*/ GIMT_Encode4(5186),
     /*  638 */ /*TargetOpcode::G_SMULFIXSAT*//*Label 58*/ GIMT_Encode4(5198),
     /*  642 */ /*TargetOpcode::G_UMULFIXSAT*//*Label 59*/ GIMT_Encode4(5210), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  662 */ /*TargetOpcode::G_FADD*//*Label 60*/ GIMT_Encode4(5222),
     /*  666 */ /*TargetOpcode::G_FSUB*//*Label 61*/ GIMT_Encode4(5334),
     /*  670 */ /*TargetOpcode::G_FMUL*//*Label 62*/ GIMT_Encode4(5423),
     /*  674 */ /*TargetOpcode::G_FMA*//*Label 63*/ GIMT_Encode4(5511),
     /*  678 */ /*TargetOpcode::G_FMAD*//*Label 64*/ GIMT_Encode4(5534),
     /*  682 */ /*TargetOpcode::G_FDIV*//*Label 65*/ GIMT_Encode4(5557),
     /*  686 */ /*TargetOpcode::G_FREM*//*Label 66*/ GIMT_Encode4(5591), GIMT_Encode4(0),
     /*  694 */ /*TargetOpcode::G_FPOWI*//*Label 67*/ GIMT_Encode4(5603), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  714 */ /*TargetOpcode::G_FLOG2*//*Label 68*/ GIMT_Encode4(5625), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  730 */ /*TargetOpcode::G_FNEG*//*Label 69*/ GIMT_Encode4(5647), GIMT_Encode4(0),
     /*  738 */ /*TargetOpcode::G_FPTRUNC*//*Label 70*/ GIMT_Encode4(5698),
     /*  742 */ /*TargetOpcode::G_FPTOSI*//*Label 71*/ GIMT_Encode4(5741),
     /*  746 */ /*TargetOpcode::G_FPTOUI*//*Label 72*/ GIMT_Encode4(5763),
     /*  750 */ /*TargetOpcode::G_SITOFP*//*Label 73*/ GIMT_Encode4(5785),
     /*  754 */ /*TargetOpcode::G_UITOFP*//*Label 74*/ GIMT_Encode4(5812), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  766 */ /*TargetOpcode::G_FABS*//*Label 75*/ GIMT_Encode4(5839), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  778 */ /*TargetOpcode::G_FCANONICALIZE*//*Label 76*/ GIMT_Encode4(5918),
     /*  782 */ /*TargetOpcode::G_FMINNUM*//*Label 77*/ GIMT_Encode4(5948),
     /*  786 */ /*TargetOpcode::G_FMAXNUM*//*Label 78*/ GIMT_Encode4(5982),
     /*  790 */ /*TargetOpcode::G_FMINNUM_IEEE*//*Label 79*/ GIMT_Encode4(6016),
     /*  794 */ /*TargetOpcode::G_FMAXNUM_IEEE*//*Label 80*/ GIMT_Encode4(6028),
     /*  798 */ /*TargetOpcode::G_FMINIMUM*//*Label 81*/ GIMT_Encode4(6040),
     /*  802 */ /*TargetOpcode::G_FMAXIMUM*//*Label 82*/ GIMT_Encode4(6074), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  838 */ /*TargetOpcode::G_PTR_ADD*//*Label 83*/ GIMT_Encode4(6108), GIMT_Encode4(0),
     /*  846 */ /*TargetOpcode::G_SMIN*//*Label 84*/ GIMT_Encode4(6198),
     /*  850 */ /*TargetOpcode::G_SMAX*//*Label 85*/ GIMT_Encode4(6232),
     /*  854 */ /*TargetOpcode::G_UMIN*//*Label 86*/ GIMT_Encode4(6266),
     /*  858 */ /*TargetOpcode::G_UMAX*//*Label 87*/ GIMT_Encode4(6300),
     /*  862 */ /*TargetOpcode::G_ABS*//*Label 88*/ GIMT_Encode4(6334), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  874 */ /*TargetOpcode::G_BR*//*Label 89*/ GIMT_Encode4(6346), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  894 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 90*/ GIMT_Encode4(6358),
     /*  898 */ /*TargetOpcode::G_EXTRACT_VECTOR_ELT*//*Label 91*/ GIMT_Encode4(6488),
     /*  902 */ /*TargetOpcode::G_SHUFFLE_VECTOR*//*Label 92*/ GIMT_Encode4(6865), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  942 */ /*TargetOpcode::G_BITREVERSE*//*Label 93*/ GIMT_Encode4(6931), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  994 */ /*TargetOpcode::G_FSQRT*//*Label 94*/ GIMT_Encode4(7020),
     /*  998 */ // Label 0: @998
     /*  998 */ GIM_Try, /*On fail goto*//*Label 96*/ GIMT_Encode4(1009), // Rule ID 13 //
     /* 1003 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule13Enabled),
     /* 1006 */   // MIs[0] d
     /* 1006 */   // No operand predicates
     /* 1006 */   // MIs[0] s
     /* 1006 */   // No operand predicates
     /* 1006 */   // Combiner Rule #13: copy_prop
     /* 1006 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner5),
     /* 1009 */ // Label 96: @1009
     /* 1009 */ GIM_Reject,
     /* 1010 */ // Label 1: @1010
     /* 1010 */ GIM_Try, /*On fail goto*//*Label 97*/ GIMT_Encode4(1021), // Rule ID 16 //
     /* 1015 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule16Enabled),
     /* 1018 */   // Combiner Rule #16: add_p2i_to_ptradd; wip_match_opcode 'G_ADD'
     /* 1018 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner8),
     /* 1021 */ // Label 97: @1021
     /* 1021 */ GIM_Try, /*On fail goto*//*Label 98*/ GIMT_Encode4(1032), // Rule ID 94 //
     /* 1026 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 1029 */   // Combiner Rule #78: propagate_undef_any_op; wip_match_opcode 'G_ADD'
     /* 1029 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 1032 */ // Label 98: @1032
     /* 1032 */ GIM_Try, /*On fail goto*//*Label 99*/ GIMT_Encode4(1043), // Rule ID 141 //
     /* 1037 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule103Enabled),
     /* 1040 */   // Combiner Rule #103: simplify_add_to_sub; wip_match_opcode 'G_ADD'
     /* 1040 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner54),
     /* 1043 */ // Label 99: @1043
     /* 1043 */ GIM_Try, /*On fail goto*//*Label 100*/ GIMT_Encode4(1054), // Rule ID 231 //
     /* 1048 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 1051 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_ADD'
     /* 1051 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 1054 */ // Label 100: @1054
     /* 1054 */ GIM_Try, /*On fail goto*//*Label 101*/ GIMT_Encode4(1065), // Rule ID 279 //
     /* 1059 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 1062 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_ADD'
     /* 1062 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 1065 */ // Label 101: @1065
     /* 1065 */ GIM_Try, /*On fail goto*//*Label 102*/ GIMT_Encode4(1076), // Rule ID 309 //
     /* 1070 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 1073 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_ADD'
     /* 1073 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 1076 */ // Label 102: @1076
     /* 1076 */ GIM_Try, /*On fail goto*//*Label 103*/ GIMT_Encode4(1110), // Rule ID 0 //
     /* 1081 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule0Enabled),
     /* 1084 */   // MIs[0] root
     /* 1084 */   // No operand predicates
     /* 1084 */   // MIs[0] sub
     /* 1084 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1088 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1092 */   // MIs[1] Operand 1
     /* 1092 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /* 1096 */   // MIs[1] A
     /* 1096 */   // No operand predicates
     /* 1096 */   // MIs[0] B
     /* 1096 */   // No operand predicates
     /* 1096 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1098 */   // Combiner Rule #0: ZeroMinusAPlusB
     /* 1098 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1101 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1103 */   GIR_RootToRootCopy, /*OpIdx*/2, // B
     /* 1105 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // A
     /* 1109 */   GIR_EraseRootFromParent_Done,
     /* 1110 */ // Label 103: @1110
     /* 1110 */ GIM_Try, /*On fail goto*//*Label 104*/ GIMT_Encode4(1147), // Rule ID 12 //
     /* 1115 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule12Enabled),
     /* 1118 */   // MIs[0] root
     /* 1118 */   // No operand predicates
     /* 1118 */   // MIs[0] sub
     /* 1118 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1122 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1126 */   // MIs[1] A
     /* 1126 */   // No operand predicates
     /* 1126 */   // MIs[1] c1
     /* 1126 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1130 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1134 */   // MIs[2] imm1
     /* 1134 */   // No operand predicates
     /* 1134 */   // MIs[0] c2
     /* 1134 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 1138 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1142 */   // MIs[3] imm2
     /* 1142 */   // No operand predicates
     /* 1142 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1144 */   // Combiner Rule #12: AMinusC1PlusC2
     /* 1144 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner4),
     /* 1147 */ // Label 104: @1147
     /* 1147 */ GIM_Try, /*On fail goto*//*Label 105*/ GIMT_Encode4(1181), // Rule ID 3 //
     /* 1152 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule3Enabled),
     /* 1155 */   // MIs[0] root
     /* 1155 */   // No operand predicates
     /* 1155 */   // MIs[0] sub
     /* 1155 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1159 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1163 */   // MIs[1] B
     /* 1163 */   // No operand predicates
     /* 1163 */   // MIs[1] A
     /* 1163 */   // No operand predicates
     /* 1163 */   // MIs[0] A
     /* 1163 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 1168 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1173 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1175 */   // Combiner Rule #3: BMinusAPlusA
     /* 1175 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1180 */   GIR_EraseRootFromParent_Done,
     /* 1181 */ // Label 105: @1181
     /* 1181 */ GIM_Try, /*On fail goto*//*Label 106*/ GIMT_Encode4(1215), // Rule ID 131 //
     /* 1186 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule94Enabled),
     /* 1189 */   // MIs[0] dst
     /* 1189 */   // No operand predicates
     /* 1189 */   // MIs[0] __add_sub_reg_match_0.tmp
     /* 1189 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1193 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1197 */   // MIs[1] src
     /* 1197 */   // No operand predicates
     /* 1197 */   // MIs[1] __add_sub_reg_match_0.x
     /* 1197 */   // No operand predicates
     /* 1197 */   // MIs[0] __add_sub_reg_match_0.x
     /* 1197 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 1202 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1207 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1209 */   // Combiner Rule #94: add_sub_reg @ [__add_sub_reg_match_0[1]]
     /* 1209 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1214 */   GIR_EraseRootFromParent_Done,
     /* 1215 */ // Label 106: @1215
     /* 1215 */ GIM_Try, /*On fail goto*//*Label 107*/ GIMT_Encode4(1260), // Rule ID 5 //
     /* 1220 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /* 1223 */   // MIs[0] root
     /* 1223 */   // No operand predicates
     /* 1223 */   // MIs[0] sub1
     /* 1223 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1227 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1231 */   // MIs[1] A
     /* 1231 */   // No operand predicates
     /* 1231 */   // MIs[1] B
     /* 1231 */   // No operand predicates
     /* 1231 */   // MIs[0] sub2
     /* 1231 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1235 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1239 */   // MIs[2] B
     /* 1239 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 1244 */   // MIs[2] C
     /* 1244 */   // No operand predicates
     /* 1244 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1246 */   // Combiner Rule #5: AMinusBPlusBMinusC
     /* 1246 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1249 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1251 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // A
     /* 1255 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // C
     /* 1259 */   GIR_EraseRootFromParent_Done,
     /* 1260 */ // Label 107: @1260
     /* 1260 */ GIM_Try, /*On fail goto*//*Label 108*/ GIMT_Encode4(1305), // Rule ID 4 //
     /* 1265 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule4Enabled),
     /* 1268 */   // MIs[0] root
     /* 1268 */   // No operand predicates
     /* 1268 */   // MIs[0] sub1
     /* 1268 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1272 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1276 */   // MIs[1] A
     /* 1276 */   // No operand predicates
     /* 1276 */   // MIs[1] B
     /* 1276 */   // No operand predicates
     /* 1276 */   // MIs[0] sub2
     /* 1276 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1280 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1284 */   // MIs[2] C
     /* 1284 */   // No operand predicates
     /* 1284 */   // MIs[2] A
     /* 1284 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 1289 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1291 */   // Combiner Rule #4: AMinusBPlusCMinusA
     /* 1291 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1294 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1296 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // C
     /* 1300 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // B
     /* 1304 */   GIR_EraseRootFromParent_Done,
     /* 1305 */ // Label 108: @1305
     /* 1305 */ GIM_Try, /*On fail goto*//*Label 109*/ GIMT_Encode4(1340), // Rule ID 39 //
     /* 1310 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule37Enabled),
     /* 1313 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 1319 */   // MIs[0] root
     /* 1319 */   // No operand predicates
     /* 1319 */   // MIs[0] left
     /* 1319 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1323 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 1327 */   // MIs[1] imm1
     /* 1327 */   // No operand predicates
     /* 1327 */   // MIs[0] right
     /* 1327 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1331 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 1335 */   // MIs[2] imm2
     /* 1335 */   // No operand predicates
     /* 1335 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1337 */   // Combiner Rule #37: add_of_vscale
     /* 1337 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner15),
     /* 1340 */ // Label 109: @1340
     /* 1340 */ GIM_Try, /*On fail goto*//*Label 110*/ GIMT_Encode4(1374), // Rule ID 1 //
     /* 1345 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule1Enabled),
     /* 1348 */   // MIs[0] root
     /* 1348 */   // No operand predicates
     /* 1348 */   // MIs[0] A
     /* 1348 */   // No operand predicates
     /* 1348 */   // MIs[0] sub
     /* 1348 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1352 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1356 */   // MIs[1] Operand 1
     /* 1356 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /* 1360 */   // MIs[1] B
     /* 1360 */   // No operand predicates
     /* 1360 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1362 */   // Combiner Rule #1: APlusZeroMinusB
     /* 1362 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1365 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1367 */   GIR_RootToRootCopy, /*OpIdx*/1, // A
     /* 1369 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // B
     /* 1373 */   GIR_EraseRootFromParent_Done,
     /* 1374 */ // Label 110: @1374
     /* 1374 */ GIM_Try, /*On fail goto*//*Label 111*/ GIMT_Encode4(1408), // Rule ID 2 //
     /* 1379 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule2Enabled),
     /* 1382 */   // MIs[0] root
     /* 1382 */   // No operand predicates
     /* 1382 */   // MIs[0] A
     /* 1382 */   // No operand predicates
     /* 1382 */   // MIs[0] sub
     /* 1382 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1386 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1390 */   // MIs[1] B
     /* 1390 */   // No operand predicates
     /* 1390 */   // MIs[1] A
     /* 1390 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1395 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1400 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1402 */   // Combiner Rule #2: APlusBMinusB
     /* 1402 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1407 */   GIR_EraseRootFromParent_Done,
     /* 1408 */ // Label 111: @1408
     /* 1408 */ GIM_Try, /*On fail goto*//*Label 112*/ GIMT_Encode4(1442), // Rule ID 130 //
     /* 1413 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule94Enabled),
     /* 1416 */   // MIs[0] dst
     /* 1416 */   // No operand predicates
     /* 1416 */   // MIs[0] __add_sub_reg_match_0.x
     /* 1416 */   // No operand predicates
     /* 1416 */   // MIs[0] __add_sub_reg_match_0.tmp
     /* 1416 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1420 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1424 */   // MIs[1] src
     /* 1424 */   // No operand predicates
     /* 1424 */   // MIs[1] __add_sub_reg_match_0.x
     /* 1424 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1429 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1434 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436 */   // Combiner Rule #94: add_sub_reg @ [__add_sub_reg_match_0[0]]
     /* 1436 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1441 */   GIR_EraseRootFromParent_Done,
     /* 1442 */ // Label 112: @1442
     /* 1442 */ GIM_Try, /*On fail goto*//*Label 113*/ GIMT_Encode4(1487), // Rule ID 6 //
     /* 1447 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule6Enabled),
     /* 1450 */   // MIs[0] root
     /* 1450 */   // No operand predicates
     /* 1450 */   // MIs[0] A
     /* 1450 */   // No operand predicates
     /* 1450 */   // MIs[0] sub1
     /* 1450 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1454 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1458 */   // MIs[1] B
     /* 1458 */   // No operand predicates
     /* 1458 */   // MIs[1] add1
     /* 1458 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1462 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 1466 */   // MIs[2] A
     /* 1466 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1471 */   // MIs[2] C
     /* 1471 */   // No operand predicates
     /* 1471 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1473 */   // Combiner Rule #6: APlusBMinusAplusC
     /* 1473 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1476 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1478 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // B
     /* 1482 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // C
     /* 1486 */   GIR_EraseRootFromParent_Done,
     /* 1487 */ // Label 113: @1487
     /* 1487 */ GIM_Try, /*On fail goto*//*Label 114*/ GIMT_Encode4(1532), // Rule ID 7 //
     /* 1492 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule7Enabled),
     /* 1495 */   // MIs[0] root
     /* 1495 */   // No operand predicates
     /* 1495 */   // MIs[0] A
     /* 1495 */   // No operand predicates
     /* 1495 */   // MIs[0] sub1
     /* 1495 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1499 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1503 */   // MIs[1] B
     /* 1503 */   // No operand predicates
     /* 1503 */   // MIs[1] add1
     /* 1503 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1507 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 1511 */   // MIs[2] C
     /* 1511 */   // No operand predicates
     /* 1511 */   // MIs[2] A
     /* 1511 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1516 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1518 */   // Combiner Rule #7: APlusBMinusCPlusA
     /* 1518 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1521 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1523 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // B
     /* 1527 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // C
     /* 1531 */   GIR_EraseRootFromParent_Done,
     /* 1532 */ // Label 114: @1532
     /* 1532 */ GIM_Try, /*On fail goto*//*Label 115*/ GIMT_Encode4(1555), // Rule ID 105 //
     /* 1537 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 1540 */   // MIs[0] dst
     /* 1540 */   // No operand predicates
     /* 1540 */   // MIs[0] lhs
     /* 1540 */   // No operand predicates
     /* 1540 */   // MIs[0] Operand 2
     /* 1540 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1544 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1549 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[1]]
     /* 1549 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1554 */   GIR_EraseRootFromParent_Done,
     /* 1555 */ // Label 115: @1555
     /* 1555 */ GIM_Try, /*On fail goto*//*Label 116*/ GIMT_Encode4(1566), // Rule ID 149 //
     /* 1560 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule107Enabled),
     /* 1563 */   // MIs[0] root
     /* 1563 */   // No operand predicates
     /* 1563 */   // MIs[0] src1
     /* 1563 */   // No operand predicates
     /* 1563 */   // MIs[0] src2
     /* 1563 */   // No operand predicates
     /* 1563 */   // Combiner Rule #107: reassoc_comm_binops
     /* 1563 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner58),
     /* 1566 */ // Label 116: @1566
     /* 1566 */ GIM_Reject,
     /* 1567 */ // Label 2: @1567
     /* 1567 */ GIM_Try, /*On fail goto*//*Label 117*/ GIMT_Encode4(1578), // Rule ID 95 //
     /* 1572 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 1575 */   // Combiner Rule #78: propagate_undef_any_op; wip_match_opcode 'G_SUB'
     /* 1575 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 1578 */ // Label 117: @1578
     /* 1578 */ GIM_Try, /*On fail goto*//*Label 118*/ GIMT_Encode4(1589), // Rule ID 239 //
     /* 1583 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 1586 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_SUB'
     /* 1586 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 1589 */ // Label 118: @1589
     /* 1589 */ GIM_Try, /*On fail goto*//*Label 119*/ GIMT_Encode4(1600), // Rule ID 280 //
     /* 1594 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 1597 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_SUB'
     /* 1597 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 1600 */ // Label 119: @1600
     /* 1600 */ GIM_Try, /*On fail goto*//*Label 120*/ GIMT_Encode4(1611), // Rule ID 306 //
     /* 1605 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 1608 */   // Combiner Rule #188: sub_add_reg; wip_match_opcode 'G_SUB'
     /* 1608 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner124),
     /* 1611 */ // Label 120: @1611
     /* 1611 */ GIM_Try, /*On fail goto*//*Label 121*/ GIMT_Encode4(1622), // Rule ID 340 //
     /* 1616 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule195Enabled),
     /* 1619 */   // Combiner Rule #195: simplify_neg_minmax; wip_match_opcode 'G_SUB'
     /* 1619 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner131),
     /* 1622 */ // Label 121: @1622
     /* 1622 */ GIM_Try, /*On fail goto*//*Label 122*/ GIMT_Encode4(1659), // Rule ID 8 //
     /* 1627 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule8Enabled),
     /* 1630 */   // MIs[0] root
     /* 1630 */   // No operand predicates
     /* 1630 */   // MIs[0] add
     /* 1630 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1634 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 1638 */   // MIs[1] A
     /* 1638 */   // No operand predicates
     /* 1638 */   // MIs[1] c1
     /* 1638 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1642 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1646 */   // MIs[2] imm1
     /* 1646 */   // No operand predicates
     /* 1646 */   // MIs[0] c2
     /* 1646 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 1650 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1654 */   // MIs[3] imm2
     /* 1654 */   // No operand predicates
     /* 1654 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1656 */   // Combiner Rule #8: APlusC1MinusC2
     /* 1656 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner0),
     /* 1659 */ // Label 122: @1659
     /* 1659 */ GIM_Try, /*On fail goto*//*Label 123*/ GIMT_Encode4(1696), // Rule ID 11 //
     /* 1664 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule11Enabled),
     /* 1667 */   // MIs[0] root
     /* 1667 */   // No operand predicates
     /* 1667 */   // MIs[0] sub1
     /* 1667 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1671 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1675 */   // MIs[1] c1
     /* 1675 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 1679 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1683 */   // MIs[2] imm1
     /* 1683 */   // No operand predicates
     /* 1683 */   // MIs[1] A
     /* 1683 */   // No operand predicates
     /* 1683 */   // MIs[0] c2
     /* 1683 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 1687 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1691 */   // MIs[3] imm2
     /* 1691 */   // No operand predicates
     /* 1691 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1693 */   // Combiner Rule #11: C1Minus2MinusC2
     /* 1693 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner3),
     /* 1696 */ // Label 123: @1696
     /* 1696 */ GIM_Try, /*On fail goto*//*Label 124*/ GIMT_Encode4(1733), // Rule ID 10 //
     /* 1701 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule10Enabled),
     /* 1704 */   // MIs[0] root
     /* 1704 */   // No operand predicates
     /* 1704 */   // MIs[0] sub1
     /* 1704 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1708 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1712 */   // MIs[1] A
     /* 1712 */   // No operand predicates
     /* 1712 */   // MIs[1] c1
     /* 1712 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1716 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1720 */   // MIs[2] imm1
     /* 1720 */   // No operand predicates
     /* 1720 */   // MIs[0] c2
     /* 1720 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 1724 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1728 */   // MIs[3] imm2
     /* 1728 */   // No operand predicates
     /* 1728 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1730 */   // Combiner Rule #10: AMinusC1MinusC2
     /* 1730 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner2),
     /* 1733 */ // Label 124: @1733
     /* 1733 */ GIM_Try, /*On fail goto*//*Label 125*/ GIMT_Encode4(1776), // Rule ID 159 //
     /* 1738 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule117Enabled),
     /* 1741 */   // MIs[0] dst
     /* 1741 */   // No operand predicates
     /* 1741 */   // MIs[0] Operand 1
     /* 1741 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 1745 */   // MIs[0] and
     /* 1745 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1749 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 1753 */   // MIs[1] x
     /* 1753 */   // No operand predicates
     /* 1753 */   // MIs[1] Operand 2
     /* 1753 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 1757 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner7),
     /* 1761 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1763 */   // Combiner Rule #117: neg_and_one_to_sext_inreg
     /* 1763 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 1766 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 1768 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // x
     /* 1772 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1775 */   GIR_EraseRootFromParent_Done,
     /* 1776 */ // Label 125: @1776
     /* 1776 */ GIM_Try, /*On fail goto*//*Label 126*/ GIMT_Encode4(1813), // Rule ID 9 //
     /* 1781 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule9Enabled),
     /* 1784 */   // MIs[0] root
     /* 1784 */   // No operand predicates
     /* 1784 */   // MIs[0] c2
     /* 1784 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1788 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1792 */   // MIs[1] imm2
     /* 1792 */   // No operand predicates
     /* 1792 */   // MIs[0] add
     /* 1792 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1796 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 1800 */   // MIs[2] A
     /* 1800 */   // No operand predicates
     /* 1800 */   // MIs[2] c1
     /* 1800 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 1804 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1808 */   // MIs[3] imm1
     /* 1808 */   // No operand predicates
     /* 1808 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1810 */   // Combiner Rule #9: C2MinusAPlusC1
     /* 1810 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner1),
     /* 1813 */ // Label 126: @1813
     /* 1813 */ GIM_Try, /*On fail goto*//*Label 127*/ GIMT_Encode4(1840), // Rule ID 42 //
     /* 1818 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule40Enabled),
     /* 1821 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 1827 */   // MIs[0] root
     /* 1827 */   // No operand predicates
     /* 1827 */   // MIs[0] x
     /* 1827 */   // No operand predicates
     /* 1827 */   // MIs[0] right
     /* 1827 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1831 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 1835 */   // MIs[1] imm
     /* 1835 */   // No operand predicates
     /* 1835 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1837 */   // Combiner Rule #40: sub_of_vscale
     /* 1837 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner18),
     /* 1840 */ // Label 127: @1840
     /* 1840 */ GIM_Try, /*On fail goto*//*Label 128*/ GIMT_Encode4(1863), // Rule ID 104 //
     /* 1845 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 1848 */   // MIs[0] dst
     /* 1848 */   // No operand predicates
     /* 1848 */   // MIs[0] lhs
     /* 1848 */   // No operand predicates
     /* 1848 */   // MIs[0] Operand 2
     /* 1848 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1852 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1857 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[0]]
     /* 1857 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1862 */   GIR_EraseRootFromParent_Done,
     /* 1863 */ // Label 128: @1863
     /* 1863 */ GIM_Try, /*On fail goto*//*Label 129*/ GIMT_Encode4(1884), // Rule ID 15 //
     /* 1868 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule15Enabled),
     /* 1871 */   // MIs[0] d
     /* 1871 */   // No operand predicates
     /* 1871 */   // MIs[0] op1
     /* 1871 */   // No operand predicates
     /* 1871 */   // MIs[0] c
     /* 1871 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1875 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1879 */   // MIs[1] imm
     /* 1879 */   // No operand predicates
     /* 1879 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1881 */   // Combiner Rule #15: sub_to_add
     /* 1881 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner7),
     /* 1884 */ // Label 129: @1884
     /* 1884 */ GIM_Reject,
     /* 1885 */ // Label 3: @1885
     /* 1885 */ GIM_Try, /*On fail goto*//*Label 130*/ GIMT_Encode4(1896), // Rule ID 78 //
     /* 1890 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule72Enabled),
     /* 1893 */   // Combiner Rule #72: undef_to_int_zero; wip_match_opcode 'G_MUL'
     /* 1893 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner34),
     /* 1896 */ // Label 130: @1896
     /* 1896 */ GIM_Try, /*On fail goto*//*Label 131*/ GIMT_Encode4(1907), // Rule ID 236 //
     /* 1901 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 1904 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_MUL'
     /* 1904 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 1907 */ // Label 131: @1907
     /* 1907 */ GIM_Try, /*On fail goto*//*Label 132*/ GIMT_Encode4(1918), // Rule ID 310 //
     /* 1912 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 1915 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_MUL'
     /* 1915 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 1918 */ // Label 132: @1918
     /* 1918 */ GIM_Try, /*On fail goto*//*Label 133*/ GIMT_Encode4(1958), // Rule ID 17 //
     /* 1923 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule17Enabled),
     /* 1926 */   // MIs[0] dst
     /* 1926 */   GIM_RecordRegType, /*MI*/0, /*Op*/0, /*TempTypeIdx*/uint8_t(-1),
     /* 1930 */   // MIs[0] x
     /* 1930 */   // No operand predicates
     /* 1930 */   // MIs[0] Operand 2
     /* 1930 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /* 1934 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/uint8_t(-1),
     /* 1937 */   GIR_BuildConstant, /*TempRegID*/0, /*Val*/GIMT_Encode8(0),
     /* 1947 */   // Combiner Rule #17: mul_by_neg_one
     /* 1947 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1950 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 1952 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 1955 */   GIR_RootToRootCopy, /*OpIdx*/1, // x
     /* 1957 */   GIR_EraseRootFromParent_Done,
     /* 1958 */ // Label 133: @1958
     /* 1958 */ GIM_Try, /*On fail goto*//*Label 134*/ GIMT_Encode4(1993), // Rule ID 40 //
     /* 1963 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule38Enabled),
     /* 1966 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 1972 */   // MIs[0] root
     /* 1972 */   // No operand predicates
     /* 1972 */   // MIs[0] left
     /* 1972 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1976 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 1980 */   // MIs[1] scale
     /* 1980 */   // No operand predicates
     /* 1980 */   // MIs[0] x
     /* 1980 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1984 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1988 */   // MIs[2] imm1
     /* 1988 */   // No operand predicates
     /* 1988 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1990 */   // Combiner Rule #38: mul_of_vscale
     /* 1990 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner16),
     /* 1993 */ // Label 134: @1993
     /* 1993 */ GIM_Try, /*On fail goto*//*Label 135*/ GIMT_Encode4(2016), // Rule ID 123 //
     /* 1998 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 2001 */   // MIs[0] dst
     /* 2001 */   // No operand predicates
     /* 2001 */   // MIs[0] lhs
     /* 2001 */   // No operand predicates
     /* 2001 */   // MIs[0] zero
     /* 2001 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 2005 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/2,
     /* 2010 */   // Combiner Rule #87: binop_right_to_zero
     /* 2010 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/2,
     /* 2015 */   GIR_EraseRootFromParent_Done,
     /* 2016 */ // Label 135: @2016
     /* 2016 */ GIM_Try, /*On fail goto*//*Label 136*/ GIMT_Encode4(2039), // Rule ID 128 //
     /* 2021 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule92Enabled),
     /* 2024 */   // MIs[0] dst
     /* 2024 */   // No operand predicates
     /* 2024 */   // MIs[0] x
     /* 2024 */   // No operand predicates
     /* 2024 */   // MIs[0] Operand 2
     /* 2024 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 2028 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2033 */   // Combiner Rule #92: right_identity_one_int
     /* 2033 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2038 */   GIR_EraseRootFromParent_Done,
     /* 2039 */ // Label 136: @2039
     /* 2039 */ GIM_Try, /*On fail goto*//*Label 137*/ GIMT_Encode4(2050), // Rule ID 14 //
     /* 2044 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule14Enabled),
     /* 2047 */   // MIs[0] d
     /* 2047 */   // No operand predicates
     /* 2047 */   // MIs[0] op1
     /* 2047 */   // No operand predicates
     /* 2047 */   // MIs[0] op2
     /* 2047 */   // No operand predicates
     /* 2047 */   // Combiner Rule #14: mul_to_shl
     /* 2047 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner6),
     /* 2050 */ // Label 137: @2050
     /* 2050 */ GIM_Reject,
     /* 2051 */ // Label 4: @2051
     /* 2051 */ GIM_Try, /*On fail goto*//*Label 138*/ GIMT_Encode4(2062), // Rule ID 119 //
     /* 2056 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 2059 */   // Combiner Rule #86: binop_left_to_zero; wip_match_opcode 'G_SDIV'
     /* 2059 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 2062 */ // Label 138: @2062
     /* 2062 */ GIM_Try, /*On fail goto*//*Label 139*/ GIMT_Encode4(2073), // Rule ID 211 //
     /* 2067 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule153Enabled),
     /* 2070 */   // Combiner Rule #153: div_rem_to_divrem; wip_match_opcode 'G_SDIV'
     /* 2070 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner95),
     /* 2073 */ // Label 139: @2073
     /* 2073 */ GIM_Try, /*On fail goto*//*Label 140*/ GIMT_Encode4(2084), // Rule ID 242 //
     /* 2078 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 2081 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_SDIV'
     /* 2081 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 2084 */ // Label 140: @2084
     /* 2084 */ GIM_Try, /*On fail goto*//*Label 141*/ GIMT_Encode4(2095), // Rule ID 260 //
     /* 2089 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule172Enabled),
     /* 2092 */   // Combiner Rule #172: sdiv_by_const; wip_match_opcode 'G_SDIV'
     /* 2092 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner109),
     /* 2095 */ // Label 141: @2095
     /* 2095 */ GIM_Try, /*On fail goto*//*Label 142*/ GIMT_Encode4(2106), // Rule ID 285 //
     /* 2100 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 2103 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_SDIV'
     /* 2103 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 2106 */ // Label 142: @2106
     /* 2106 */ GIM_Try, /*On fail goto*//*Label 143*/ GIMT_Encode4(2123), // Rule ID 261 //
     /* 2111 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule173Enabled),
     /* 2114 */   GIM_MIFlagsNot, /*MI*/0, GIMT_Encode4(MachineInstr::IsExact),
     /* 2120 */   // MIs[0] dst
     /* 2120 */   // No operand predicates
     /* 2120 */   // MIs[0] x
     /* 2120 */   // No operand predicates
     /* 2120 */   // MIs[0] y
     /* 2120 */   // No operand predicates
     /* 2120 */   // Combiner Rule #173: sdiv_by_pow2
     /* 2120 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner110),
     /* 2123 */ // Label 143: @2123
     /* 2123 */ GIM_Reject,
     /* 2124 */ // Label 5: @2124
     /* 2124 */ GIM_Try, /*On fail goto*//*Label 144*/ GIMT_Encode4(2135), // Rule ID 81 //
     /* 2129 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule74Enabled),
     /* 2132 */   // Combiner Rule #74: binop_left_undef_to_zero; wip_match_opcode 'G_UDIV'
     /* 2132 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner36),
     /* 2135 */ // Label 144: @2135
     /* 2135 */ GIM_Try, /*On fail goto*//*Label 145*/ GIMT_Encode4(2146), // Rule ID 120 //
     /* 2140 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 2143 */   // Combiner Rule #86: binop_left_to_zero; wip_match_opcode 'G_UDIV'
     /* 2143 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 2146 */ // Label 145: @2146
     /* 2146 */ GIM_Try, /*On fail goto*//*Label 146*/ GIMT_Encode4(2157), // Rule ID 212 //
     /* 2151 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule153Enabled),
     /* 2154 */   // Combiner Rule #153: div_rem_to_divrem; wip_match_opcode 'G_UDIV'
     /* 2154 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner95),
     /* 2157 */ // Label 146: @2157
     /* 2157 */ GIM_Try, /*On fail goto*//*Label 147*/ GIMT_Encode4(2168), // Rule ID 241 //
     /* 2162 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 2165 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_UDIV'
     /* 2165 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 2168 */ // Label 147: @2168
     /* 2168 */ GIM_Try, /*On fail goto*//*Label 148*/ GIMT_Encode4(2179), // Rule ID 259 //
     /* 2173 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule171Enabled),
     /* 2176 */   // Combiner Rule #171: udiv_by_const; wip_match_opcode 'G_UDIV'
     /* 2176 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner108),
     /* 2179 */ // Label 148: @2179
     /* 2179 */ GIM_Try, /*On fail goto*//*Label 149*/ GIMT_Encode4(2190), // Rule ID 287 //
     /* 2184 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 2187 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_UDIV'
     /* 2187 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 2190 */ // Label 149: @2190
     /* 2190 */ GIM_Try, /*On fail goto*//*Label 150*/ GIMT_Encode4(2207), // Rule ID 262 //
     /* 2195 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule174Enabled),
     /* 2198 */   GIM_MIFlagsNot, /*MI*/0, GIMT_Encode4(MachineInstr::IsExact),
     /* 2204 */   // MIs[0] dst
     /* 2204 */   // No operand predicates
     /* 2204 */   // MIs[0] x
     /* 2204 */   // No operand predicates
     /* 2204 */   // MIs[0] y
     /* 2204 */   // No operand predicates
     /* 2204 */   // Combiner Rule #174: udiv_by_pow2
     /* 2204 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner111),
     /* 2207 */ // Label 150: @2207
     /* 2207 */ GIM_Reject,
     /* 2208 */ // Label 6: @2208
     /* 2208 */ GIM_Try, /*On fail goto*//*Label 151*/ GIMT_Encode4(2219), // Rule ID 121 //
     /* 2213 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 2216 */   // Combiner Rule #86: binop_left_to_zero; wip_match_opcode 'G_SREM'
     /* 2216 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 2219 */ // Label 151: @2219
     /* 2219 */ GIM_Try, /*On fail goto*//*Label 152*/ GIMT_Encode4(2230), // Rule ID 213 //
     /* 2224 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule153Enabled),
     /* 2227 */   // Combiner Rule #153: div_rem_to_divrem; wip_match_opcode 'G_SREM'
     /* 2227 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner95),
     /* 2230 */ // Label 152: @2230
     /* 2230 */ GIM_Try, /*On fail goto*//*Label 153*/ GIMT_Encode4(2241), // Rule ID 244 //
     /* 2235 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 2238 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_SREM'
     /* 2238 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 2241 */ // Label 153: @2241
     /* 2241 */ GIM_Try, /*On fail goto*//*Label 154*/ GIMT_Encode4(2252), // Rule ID 286 //
     /* 2246 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 2249 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_SREM'
     /* 2249 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 2252 */ // Label 154: @2252
     /* 2252 */ GIM_Reject,
     /* 2253 */ // Label 7: @2253
     /* 2253 */ GIM_Try, /*On fail goto*//*Label 155*/ GIMT_Encode4(2264), // Rule ID 82 //
     /* 2258 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule74Enabled),
     /* 2261 */   // Combiner Rule #74: binop_left_undef_to_zero; wip_match_opcode 'G_UREM'
     /* 2261 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner36),
     /* 2264 */ // Label 155: @2264
     /* 2264 */ GIM_Try, /*On fail goto*//*Label 156*/ GIMT_Encode4(2275), // Rule ID 122 //
     /* 2269 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 2272 */   // Combiner Rule #86: binop_left_to_zero; wip_match_opcode 'G_UREM'
     /* 2272 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 2275 */ // Label 156: @2275
     /* 2275 */ GIM_Try, /*On fail goto*//*Label 157*/ GIMT_Encode4(2286), // Rule ID 170 //
     /* 2280 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule128Enabled),
     /* 2283 */   // Combiner Rule #128: urem_pow2_to_mask; wip_match_opcode 'G_UREM'
     /* 2283 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner75),
     /* 2286 */ // Label 157: @2286
     /* 2286 */ GIM_Try, /*On fail goto*//*Label 158*/ GIMT_Encode4(2297), // Rule ID 214 //
     /* 2291 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule153Enabled),
     /* 2294 */   // Combiner Rule #153: div_rem_to_divrem; wip_match_opcode 'G_UREM'
     /* 2294 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner95),
     /* 2297 */ // Label 158: @2297
     /* 2297 */ GIM_Try, /*On fail goto*//*Label 159*/ GIMT_Encode4(2308), // Rule ID 243 //
     /* 2302 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 2305 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_UREM'
     /* 2305 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 2308 */ // Label 159: @2308
     /* 2308 */ GIM_Try, /*On fail goto*//*Label 160*/ GIMT_Encode4(2319), // Rule ID 288 //
     /* 2313 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 2316 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_UREM'
     /* 2316 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 2319 */ // Label 160: @2319
     /* 2319 */ GIM_Try, /*On fail goto*//*Label 161*/ GIMT_Encode4(2330), // Rule ID 305 //
     /* 2324 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule187Enabled),
     /* 2327 */   // MIs[0] dst
     /* 2327 */   // No operand predicates
     /* 2327 */   // MIs[0] x
     /* 2327 */   // No operand predicates
     /* 2327 */   // MIs[0] y
     /* 2327 */   // No operand predicates
     /* 2327 */   // Combiner Rule #187: urem_by_const
     /* 2327 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner108),
     /* 2330 */ // Label 161: @2330
     /* 2330 */ GIM_Reject,
     /* 2331 */ // Label 8: @2331
     /* 2331 */ GIM_Try, /*On fail goto*//*Label 162*/ GIMT_Encode4(2342), // Rule ID 73 //
     /* 2336 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule69Enabled),
     /* 2339 */   // Combiner Rule #69: load_and_mask; wip_match_opcode 'G_AND'
     /* 2339 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner31),
     /* 2342 */ // Label 162: @2342
     /* 2342 */ GIM_Try, /*On fail goto*//*Label 163*/ GIMT_Encode4(2353), // Rule ID 77 //
     /* 2347 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule72Enabled),
     /* 2350 */   // Combiner Rule #72: undef_to_int_zero; wip_match_opcode 'G_AND'
     /* 2350 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner34),
     /* 2353 */ // Label 163: @2353
     /* 2353 */ GIM_Try, /*On fail goto*//*Label 164*/ GIMT_Encode4(2364), // Rule ID 142 //
     /* 2358 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule104Enabled),
     /* 2361 */   // Combiner Rule #104: hoist_logic_op_with_same_opcode_hands; wip_match_opcode 'G_AND'
     /* 2361 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner55),
     /* 2364 */ // Label 164: @2364
     /* 2364 */ GIM_Try, /*On fail goto*//*Label 165*/ GIMT_Encode4(2375), // Rule ID 162 //
     /* 2369 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule120Enabled),
     /* 2372 */   // Combiner Rule #120: narrow_binop_feeding_and; wip_match_opcode 'G_AND'
     /* 2372 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner68),
     /* 2375 */ // Label 165: @2375
     /* 2375 */ GIM_Try, /*On fail goto*//*Label 166*/ GIMT_Encode4(2386), // Rule ID 167 //
     /* 2380 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule125Enabled),
     /* 2383 */   // Combiner Rule #125: redundant_and; wip_match_opcode 'G_AND'
     /* 2383 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner72),
     /* 2386 */ // Label 166: @2386
     /* 2386 */ GIM_Try, /*On fail goto*//*Label 167*/ GIMT_Encode4(2397), // Rule ID 184 //
     /* 2391 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule142Enabled),
     /* 2394 */   // Combiner Rule #142: overlapping_and; wip_match_opcode 'G_AND'
     /* 2394 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner84),
     /* 2397 */ // Label 167: @2397
     /* 2397 */ GIM_Try, /*On fail goto*//*Label 168*/ GIMT_Encode4(2408), // Rule ID 233 //
     /* 2402 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 2405 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_AND'
     /* 2405 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 2408 */ // Label 168: @2408
     /* 2408 */ GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(2419), // Rule ID 270 //
     /* 2413 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule177Enabled),
     /* 2416 */   // Combiner Rule #177: and_or_disjoint_mask; wip_match_opcode 'G_AND'
     /* 2416 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner114),
     /* 2419 */ // Label 169: @2419
     /* 2419 */ GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(2430), // Rule ID 282 //
     /* 2424 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 2427 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_AND'
     /* 2427 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 2430 */ // Label 170: @2430
     /* 2430 */ GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(2441), // Rule ID 311 //
     /* 2435 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 2438 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_AND'
     /* 2438 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 2441 */ // Label 171: @2441
     /* 2441 */ GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(2452), // Rule ID 338 //
     /* 2446 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule193Enabled),
     /* 2449 */   // Combiner Rule #193: match_ands; wip_match_opcode 'G_AND'
     /* 2449 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner129),
     /* 2452 */ // Label 172: @2452
     /* 2452 */ GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(2550), // Rule ID 155 //
     /* 2457 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule113Enabled),
     /* 2460 */   // MIs[0] root
     /* 2460 */   // No operand predicates
     /* 2460 */   // MIs[0] d1
     /* 2460 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2464 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2468 */   // MIs[1] p
     /* 2468 */   // No operand predicates
     /* 2468 */   // MIs[1] s1
     /* 2468 */   GIM_RecordRegType, /*MI*/1, /*Op*/2, /*TempTypeIdx*/uint8_t(-1),
     /* 2472 */   // MIs[1] Operand 3
     /* 2472 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 2476 */   // MIs[0] d2
     /* 2476 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2480 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2484 */   // MIs[2] p
     /* 2484 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 2489 */   // MIs[2] s2
     /* 2489 */   // No operand predicates
     /* 2489 */   // MIs[2] Operand 3
     /* 2489 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/3, 0,
     /* 2493 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner5),
     /* 2497 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2499 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/uint8_t(-1),
     /* 2502 */   GIR_BuildConstant, /*TempRegID*/1, /*Val*/GIMT_Encode8(0),
     /* 2512 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/uint8_t(-1),
     /* 2515 */   // Combiner Rule #113: double_icmp_zero_and_combine
     /* 2515 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_OR),
     /* 2518 */   GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2523 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 2527 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // s2
     /* 2531 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2535 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, // root
     /* 2539 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // p
     /* 2543 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/0,
     /* 2546 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 2549 */   GIR_EraseRootFromParent_Done,
     /* 2550 */ // Label 173: @2550
     /* 2550 */ GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(2587), // Rule ID 226 //
     /* 2555 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule163Enabled),
     /* 2558 */   // MIs[0] root
     /* 2558 */   // No operand predicates
     /* 2558 */   // MIs[0] shift
     /* 2558 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2562 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 2566 */   // MIs[1] x
     /* 2566 */   // No operand predicates
     /* 2566 */   // MIs[1] lsb
     /* 2566 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 2570 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2574 */   // MIs[2] imm1
     /* 2574 */   // No operand predicates
     /* 2574 */   // MIs[0] mask
     /* 2574 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 2578 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2582 */   // MIs[3] imm2
     /* 2582 */   // No operand predicates
     /* 2582 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2584 */   // Combiner Rule #163: bitfield_extract_from_and
     /* 2584 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner101),
     /* 2587 */ // Label 174: @2587
     /* 2587 */ GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(2611), // Rule ID 114 //
     /* 2592 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 2595 */   // MIs[0] dst
     /* 2595 */   // No operand predicates
     /* 2595 */   // MIs[0] src
     /* 2595 */   // No operand predicates
     /* 2595 */   // MIs[0] src
     /* 2595 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 2600 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2605 */   // Combiner Rule #85: binop_same_val @ [__binop_same_val_match_0[0]]
     /* 2605 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2610 */   GIR_EraseRootFromParent_Done,
     /* 2611 */ // Label 175: @2611
     /* 2611 */ GIM_Reject,
     /* 2612 */ // Label 9: @2612
     /* 2612 */ GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(2623), // Rule ID 79 //
     /* 2617 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule73Enabled),
     /* 2620 */   // Combiner Rule #73: undef_to_negative_one; wip_match_opcode 'G_OR'
     /* 2620 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner35),
     /* 2623 */ // Label 176: @2623
     /* 2623 */ GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(2634), // Rule ID 143 //
     /* 2628 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule104Enabled),
     /* 2631 */   // Combiner Rule #104: hoist_logic_op_with_same_opcode_hands; wip_match_opcode 'G_OR'
     /* 2631 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner55),
     /* 2634 */ // Label 177: @2634
     /* 2634 */ GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(2645), // Rule ID 169 //
     /* 2639 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule127Enabled),
     /* 2642 */   // Combiner Rule #127: redundant_or; wip_match_opcode 'G_OR'
     /* 2642 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner74),
     /* 2645 */ // Label 178: @2645
     /* 2645 */ GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(2656), // Rule ID 210 //
     /* 2650 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule152Enabled),
     /* 2653 */   // Combiner Rule #152: load_or_combine; wip_match_opcode 'G_OR'
     /* 2653 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner94),
     /* 2656 */ // Label 179: @2656
     /* 2656 */ GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(2667), // Rule ID 215 //
     /* 2661 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule154Enabled),
     /* 2664 */   // Combiner Rule #154: funnel_shift_from_or_shift; wip_match_opcode 'G_OR'
     /* 2664 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner96),
     /* 2667 */ // Label 180: @2667
     /* 2667 */ GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(2678), // Rule ID 237 //
     /* 2672 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 2675 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_OR'
     /* 2675 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 2678 */ // Label 181: @2678
     /* 2678 */ GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(2689), // Rule ID 283 //
     /* 2683 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 2686 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_OR'
     /* 2686 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 2689 */ // Label 182: @2689
     /* 2689 */ GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(2700), // Rule ID 312 //
     /* 2694 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 2697 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_OR'
     /* 2697 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 2700 */ // Label 183: @2700
     /* 2700 */ GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(2711), // Rule ID 339 //
     /* 2705 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule194Enabled),
     /* 2708 */   // Combiner Rule #194: match_ors; wip_match_opcode 'G_OR'
     /* 2708 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner130),
     /* 2711 */ // Label 184: @2711
     /* 2711 */ GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(2809), // Rule ID 156 //
     /* 2716 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule114Enabled),
     /* 2719 */   // MIs[0] root
     /* 2719 */   // No operand predicates
     /* 2719 */   // MIs[0] d1
     /* 2719 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2723 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2727 */   // MIs[1] p
     /* 2727 */   // No operand predicates
     /* 2727 */   // MIs[1] s1
     /* 2727 */   GIM_RecordRegType, /*MI*/1, /*Op*/2, /*TempTypeIdx*/uint8_t(-1),
     /* 2731 */   // MIs[1] Operand 3
     /* 2731 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 2735 */   // MIs[0] d2
     /* 2735 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2739 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2743 */   // MIs[2] p
     /* 2743 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 2748 */   // MIs[2] s2
     /* 2748 */   // No operand predicates
     /* 2748 */   // MIs[2] Operand 3
     /* 2748 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/3, 0,
     /* 2752 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner6),
     /* 2756 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2758 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/uint8_t(-1),
     /* 2761 */   GIR_BuildConstant, /*TempRegID*/1, /*Val*/GIMT_Encode8(0),
     /* 2771 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/uint8_t(-1),
     /* 2774 */   // Combiner Rule #114: double_icmp_zero_or_combine
     /* 2774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_OR),
     /* 2777 */   GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2782 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 2786 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // s2
     /* 2790 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2794 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, // root
     /* 2798 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // p
     /* 2802 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/0,
     /* 2805 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 2808 */   GIR_EraseRootFromParent_Done,
     /* 2809 */ // Label 185: @2809
     /* 2809 */ GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(2833), // Rule ID 115 //
     /* 2814 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 2817 */   // MIs[0] dst
     /* 2817 */   // No operand predicates
     /* 2817 */   // MIs[0] src
     /* 2817 */   // No operand predicates
     /* 2817 */   // MIs[0] src
     /* 2817 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 2822 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2827 */   // Combiner Rule #85: binop_same_val @ [__binop_same_val_match_0[1]]
     /* 2827 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2832 */   GIR_EraseRootFromParent_Done,
     /* 2833 */ // Label 186: @2833
     /* 2833 */ GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(2856), // Rule ID 106 //
     /* 2838 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 2841 */   // MIs[0] dst
     /* 2841 */   // No operand predicates
     /* 2841 */   // MIs[0] lhs
     /* 2841 */   // No operand predicates
     /* 2841 */   // MIs[0] Operand 2
     /* 2841 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 2845 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2850 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[2]]
     /* 2850 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2855 */   GIR_EraseRootFromParent_Done,
     /* 2856 */ // Label 187: @2856
     /* 2856 */ GIM_Reject,
     /* 2857 */ // Label 10: @2857
     /* 2857 */ GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(2868), // Rule ID 96 //
     /* 2862 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 2865 */   // Combiner Rule #78: propagate_undef_any_op; wip_match_opcode 'G_XOR'
     /* 2865 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 2868 */ // Label 188: @2868
     /* 2868 */ GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(2879), // Rule ID 144 //
     /* 2873 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule104Enabled),
     /* 2876 */   // Combiner Rule #104: hoist_logic_op_with_same_opcode_hands; wip_match_opcode 'G_XOR'
     /* 2876 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner55),
     /* 2879 */ // Label 189: @2879
     /* 2879 */ GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(2890), // Rule ID 174 //
     /* 2884 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule132Enabled),
     /* 2887 */   // Combiner Rule #132: not_cmp_fold; wip_match_opcode 'G_XOR'
     /* 2887 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner79),
     /* 2890 */ // Label 190: @2890
     /* 2890 */ GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(2901), // Rule ID 198 //
     /* 2895 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule148Enabled),
     /* 2898 */   // Combiner Rule #148: xor_of_and_with_same_reg; wip_match_opcode 'G_XOR'
     /* 2898 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner90),
     /* 2901 */ // Label 191: @2901
     /* 2901 */ GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(2912), // Rule ID 240 //
     /* 2906 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 2909 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_XOR'
     /* 2909 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 2912 */ // Label 192: @2912
     /* 2912 */ GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(2923), // Rule ID 284 //
     /* 2917 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 2920 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_XOR'
     /* 2920 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 2923 */ // Label 193: @2923
     /* 2923 */ GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(2934), // Rule ID 313 //
     /* 2928 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 2931 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_XOR'
     /* 2931 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 2934 */ // Label 194: @2934
     /* 2934 */ GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(2957), // Rule ID 107 //
     /* 2939 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 2942 */   // MIs[0] dst
     /* 2942 */   // No operand predicates
     /* 2942 */   // MIs[0] lhs
     /* 2942 */   // No operand predicates
     /* 2942 */   // MIs[0] Operand 2
     /* 2942 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 2946 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2951 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[3]]
     /* 2951 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2956 */   GIR_EraseRootFromParent_Done,
     /* 2957 */ // Label 195: @2957
     /* 2957 */ GIM_Reject,
     /* 2958 */ // Label 11: @2958
     /* 2958 */ GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(2969), // Rule ID 140 //
     /* 2963 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule102Enabled),
     /* 2966 */   // Combiner Rule #102: extend_through_phis; wip_match_opcode 'G_PHI'
     /* 2966 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner53),
     /* 2969 */ // Label 196: @2969
     /* 2969 */ GIM_Reject,
     /* 2970 */ // Label 12: @2970
     /* 2970 */ GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(2981), // Rule ID 349 //
     /* 2975 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule204Enabled),
     /* 2978 */   // Combiner Rule #204: unmerge_anyext_build_vector; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 2978 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner140),
     /* 2981 */ // Label 197: @2981
     /* 2981 */ GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(2992), // Rule ID 350 //
     /* 2986 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule205Enabled),
     /* 2989 */   // Combiner Rule #205: unmerge_merge; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 2989 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner141),
     /* 2992 */ // Label 198: @2992
     /* 2992 */ GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(3003), // Rule ID 352 //
     /* 2997 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule207Enabled),
     /* 3000 */   // Combiner Rule #207: unmerge_cst; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 3000 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner143),
     /* 3003 */ // Label 199: @3003
     /* 3003 */ GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(3014), // Rule ID 353 //
     /* 3008 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule208Enabled),
     /* 3011 */   // Combiner Rule #208: unmerge_undef; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 3011 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner144),
     /* 3014 */ // Label 200: @3014
     /* 3014 */ GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(3025), // Rule ID 354 //
     /* 3019 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule209Enabled),
     /* 3022 */   // Combiner Rule #209: unmerge_dead_to_trunc; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 3022 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner145),
     /* 3025 */ // Label 201: @3025
     /* 3025 */ GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(3036), // Rule ID 355 //
     /* 3030 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule210Enabled),
     /* 3033 */   // Combiner Rule #210: unmerge_zext_to_zext; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 3033 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner146),
     /* 3036 */ // Label 202: @3036
     /* 3036 */ GIM_Reject,
     /* 3037 */ // Label 13: @3037
     /* 3037 */ GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(3048), // Rule ID 351 //
     /* 3042 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule206Enabled),
     /* 3045 */   // Combiner Rule #206: merge_unmerge; wip_match_opcode 'G_MERGE_VALUES'
     /* 3045 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner142),
     /* 3048 */ // Label 203: @3048
     /* 3048 */ GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(3110),
     /* 3053 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 3056 */   GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(3077), // Rule ID 356 //
     /* 3061 */     GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule211Enabled),
     /* 3064 */     // MIs[0] root
     /* 3064 */     // No operand predicates
     /* 3064 */     // MIs[0] x
     /* 3064 */     // No operand predicates
     /* 3064 */     // MIs[0] undef
     /* 3064 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 3068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3072 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3074 */     // Combiner Rule #211: merge_of_x_and_undef
     /* 3074 */     GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner147),
     /* 3077 */   // Label 205: @3077
     /* 3077 */   GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(3109), // Rule ID 357 //
     /* 3082 */     GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule212Enabled),
     /* 3085 */     // MIs[0] root
     /* 3085 */     // No operand predicates
     /* 3085 */     // MIs[0] x
     /* 3085 */     // No operand predicates
     /* 3085 */     // MIs[0] zero
     /* 3085 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 3089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3093 */     // MIs[1] Operand 1
     /* 3093 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/1, GIMT_Encode8(0),
     /* 3104 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3106 */     // Combiner Rule #212: merge_of_x_and_zero
     /* 3106 */     GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner148),
     /* 3109 */   // Label 206: @3109
     /* 3109 */   GIM_Reject,
     /* 3110 */ // Label 204: @3110
     /* 3110 */ GIM_Reject,
     /* 3111 */ // Label 14: @3111
     /* 3111 */ GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(3122), // Rule ID 69 //
     /* 3116 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule67Enabled),
     /* 3119 */   // Combiner Rule #67: extract_all_elts_from_build_vector; wip_match_opcode 'G_BUILD_VECTOR'
     /* 3119 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner29),
     /* 3122 */ // Label 207: @3122
     /* 3122 */ GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(3133), // Rule ID 98 //
     /* 3127 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule79Enabled),
     /* 3130 */   // Combiner Rule #79: propagate_undef_all_ops; wip_match_opcode 'G_BUILD_VECTOR'
     /* 3130 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner40),
     /* 3133 */ // Label 208: @3133
     /* 3133 */ GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(3144), // Rule ID 133 //
     /* 3138 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule95Enabled),
     /* 3141 */   // Combiner Rule #95: buildvector_identity_fold; wip_match_opcode 'G_BUILD_VECTOR'
     /* 3141 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner49),
     /* 3144 */ // Label 209: @3144
     /* 3144 */ GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(3158), // Rule ID 348 //
     /* 3149 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule203Enabled),
     /* 3152 */   GIM_CheckNumOperandsGE, /*MI*/0, /*Expected*/2,
     /* 3155 */   // MIs[0] dst
     /* 3155 */   // No operand predicates
     /* 3155 */   // MIs[0] unused
     /* 3155 */   // No operand predicates
     /* 3155 */   // Combiner Rule #203: combine_use_vector_truncate
     /* 3155 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner139),
     /* 3158 */ // Label 210: @3158
     /* 3158 */ GIM_Reject,
     /* 3159 */ // Label 15: @3159
     /* 3159 */ GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(3170), // Rule ID 132 //
     /* 3164 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule95Enabled),
     /* 3167 */   // Combiner Rule #95: buildvector_identity_fold; wip_match_opcode 'G_BUILD_VECTOR_TRUNC'
     /* 3167 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner49),
     /* 3170 */ // Label 211: @3170
     /* 3170 */ GIM_Reject,
     /* 3171 */ // Label 16: @3171
     /* 3171 */ GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(3182), // Rule ID 341 //
     /* 3176 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule196Enabled),
     /* 3179 */   // Combiner Rule #196: combine_concat_vector; wip_match_opcode 'G_CONCAT_VECTORS'
     /* 3179 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner132),
     /* 3182 */ // Label 212: @3182
     /* 3182 */ GIM_Reject,
     /* 3183 */ // Label 17: @3183
     /* 3183 */ GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(3204), // Rule ID 125 //
     /* 3188 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule89Enabled),
     /* 3191 */   // MIs[0] dst
     /* 3191 */   // No operand predicates
     /* 3191 */   // MIs[0] t
     /* 3191 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3195 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTTOPTR),
     /* 3199 */   // MIs[1] ptr
     /* 3199 */   // No operand predicates
     /* 3199 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3201 */   // Combiner Rule #89: i2p_to_p2i
     /* 3201 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner47),
     /* 3204 */ // Label 213: @3204
     /* 3204 */ GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(3225), // Rule ID 90 //
     /* 3209 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 3212 */   // MIs[0] dst
     /* 3212 */   // No operand predicates
     /* 3212 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3212 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3216 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3220 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3222 */   // Combiner Rule #77: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[3]]
     /* 3222 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 3225 */ // Label 214: @3225
     /* 3225 */ GIM_Reject,
     /* 3226 */ // Label 18: @3226
     /* 3226 */ GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(3237), // Rule ID 124 //
     /* 3231 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule88Enabled),
     /* 3234 */   // Combiner Rule #88: p2i_to_i2p; wip_match_opcode 'G_INTTOPTR'
     /* 3234 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner46),
     /* 3237 */ // Label 215: @3237
     /* 3237 */ GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(3258), // Rule ID 91 //
     /* 3242 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 3245 */   // MIs[0] dst
     /* 3245 */   // No operand predicates
     /* 3245 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3245 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3249 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3253 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3255 */   // Combiner Rule #77: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[4]]
     /* 3255 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 3258 */ // Label 216: @3258
     /* 3258 */ GIM_Reject,
     /* 3259 */ // Label 19: @3259
     /* 3259 */ GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(3280), // Rule ID 136 //
     /* 3264 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule98Enabled),
     /* 3267 */   // MIs[0] dst
     /* 3267 */   // No operand predicates
     /* 3267 */   // MIs[0] src1
     /* 3267 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3271 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 3275 */   // MIs[1] src0
     /* 3275 */   // No operand predicates
     /* 3275 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3277 */   // Combiner Rule #98: bitcast_bitcast_fold
     /* 3277 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner52),
     /* 3280 */ // Label 217: @3280
     /* 3280 */ GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(3301), // Rule ID 88 //
     /* 3285 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 3288 */   // MIs[0] dst
     /* 3288 */   // No operand predicates
     /* 3288 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3288 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3292 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3296 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3298 */   // Combiner Rule #77: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[1]]
     /* 3298 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 3301 */ // Label 218: @3301
     /* 3301 */ GIM_Reject,
     /* 3302 */ // Label 20: @3302
     /* 3302 */ GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(3331), // Rule ID 18 //
     /* 3307 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule18Enabled),
     /* 3310 */   // MIs[0] dst
     /* 3310 */   // No operand predicates
     /* 3310 */   // MIs[0] src
     /* 3310 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3314 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FREEZE),
     /* 3318 */   // MIs[1] __idempotent_prop_match_0.x
     /* 3318 */   // No operand predicates
     /* 3318 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3323 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3325 */   // Combiner Rule #18: idempotent_prop @ [__idempotent_prop_match_0[0]]
     /* 3325 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3330 */   GIR_EraseRootFromParent_Done,
     /* 3331 */ // Label 219: @3331
     /* 3331 */ GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(3354), // Rule ID 43 //
     /* 3336 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule41Enabled),
     /* 3339 */   // MIs[0] root
     /* 3339 */   // No operand predicates
     /* 3339 */   // MIs[0] src
     /* 3339 */   // No operand predicates
     /* 3339 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner1),
     /* 3343 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3348 */   // Combiner Rule #41: freeze_of_non_undef_non_poison
     /* 3348 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3353 */   GIR_EraseRootFromParent_Done,
     /* 3354 */ // Label 220: @3354
     /* 3354 */ GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(3365), // Rule ID 44 //
     /* 3359 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule42Enabled),
     /* 3362 */   // MIs[0] dst
     /* 3362 */   // No operand predicates
     /* 3362 */   // MIs[0] src
     /* 3362 */   // No operand predicates
     /* 3362 */   // Combiner Rule #42: push_freeze_to_prevent_poison_from_propagating
     /* 3362 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner19),
     /* 3365 */ // Label 221: @3365
     /* 3365 */ GIM_Reject,
     /* 3366 */ // Label 21: @3366
     /* 3366 */ GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(3377), // Rule ID 70 //
     /* 3371 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule68Enabled),
     /* 3374 */   // Combiner Rule #68: extending_loads; wip_match_opcode 'G_LOAD'
     /* 3374 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner30),
     /* 3377 */ // Label 222: @3377
     /* 3377 */ GIM_Reject,
     /* 3378 */ // Label 22: @3378
     /* 3378 */ GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(3389), // Rule ID 71 //
     /* 3383 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule68Enabled),
     /* 3386 */   // Combiner Rule #68: extending_loads; wip_match_opcode 'G_SEXTLOAD'
     /* 3386 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner30),
     /* 3389 */ // Label 223: @3389
     /* 3389 */ GIM_Reject,
     /* 3390 */ // Label 23: @3390
     /* 3390 */ GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(3401), // Rule ID 72 //
     /* 3395 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule68Enabled),
     /* 3398 */   // Combiner Rule #68: extending_loads; wip_match_opcode 'G_ZEXTLOAD'
     /* 3398 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner30),
     /* 3401 */ // Label 224: @3401
     /* 3401 */ GIM_Reject,
     /* 3402 */ // Label 24: @3402
     /* 3402 */ GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(3413), // Rule ID 100 //
     /* 3407 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule81Enabled),
     /* 3410 */   // Combiner Rule #81: erase_undef_store; wip_match_opcode 'G_STORE'
     /* 3410 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner42),
     /* 3413 */ // Label 225: @3413
     /* 3413 */ GIM_Reject,
     /* 3414 */ // Label 25: @3414
     /* 3414 */ GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(3425), // Rule ID 126 //
     /* 3419 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule90Enabled),
     /* 3422 */   // Combiner Rule #90: anyext_trunc_fold; wip_match_opcode 'G_ANYEXT'
     /* 3422 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner48),
     /* 3425 */ // Label 226: @3425
     /* 3425 */ GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(3436), // Rule ID 257 //
     /* 3430 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule169Enabled),
     /* 3433 */   // Combiner Rule #169: constant_fold_cast_op; wip_match_opcode 'G_ANYEXT'
     /* 3433 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner107),
     /* 3436 */ // Label 227: @3436
     /* 3436 */ GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(3457), // Rule ID 57 //
     /* 3441 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule55Enabled),
     /* 3444 */   // MIs[0] root
     /* 3444 */   // No operand predicates
     /* 3444 */   // MIs[0] select
     /* 3444 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3448 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /* 3452 */   // MIs[1] cond
     /* 3452 */   // No operand predicates
     /* 3452 */   // MIs[1] true
     /* 3452 */   // No operand predicates
     /* 3452 */   // MIs[1] false
     /* 3452 */   // No operand predicates
     /* 3452 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3454 */   // Combiner Rule #55: select_of_anyext
     /* 3454 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner23),
     /* 3457 */ // Label 228: @3457
     /* 3457 */ GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(3478), // Rule ID 52 //
     /* 3462 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule50Enabled),
     /* 3465 */   // MIs[0] root
     /* 3465 */   // No operand predicates
     /* 3465 */   // MIs[0] second
     /* 3465 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3469 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 3473 */   // MIs[1] src
     /* 3473 */   // No operand predicates
     /* 3473 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3475 */   // Combiner Rule #50: anyext_of_anyext
     /* 3475 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 3478 */ // Label 229: @3478
     /* 3478 */ GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(3499), // Rule ID 54 //
     /* 3483 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule52Enabled),
     /* 3486 */   // MIs[0] root
     /* 3486 */   // No operand predicates
     /* 3486 */   // MIs[0] second
     /* 3486 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3490 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 3494 */   // MIs[1] src
     /* 3494 */   // No operand predicates
     /* 3494 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3496 */   // Combiner Rule #52: anyext_of_sext
     /* 3496 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 3499 */ // Label 230: @3499
     /* 3499 */ GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(3520), // Rule ID 53 //
     /* 3504 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule51Enabled),
     /* 3507 */   // MIs[0] root
     /* 3507 */   // No operand predicates
     /* 3507 */   // MIs[0] second
     /* 3507 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3511 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 3515 */   // MIs[1] src
     /* 3515 */   // No operand predicates
     /* 3515 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3517 */   // Combiner Rule #51: anyext_of_zext
     /* 3517 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 3520 */ // Label 231: @3520
     /* 3520 */ GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(3541), // Rule ID 89 //
     /* 3525 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 3528 */   // MIs[0] dst
     /* 3528 */   // No operand predicates
     /* 3528 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3528 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3532 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3536 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3538 */   // Combiner Rule #77: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[2]]
     /* 3538 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 3541 */ // Label 232: @3541
     /* 3541 */ GIM_Reject,
     /* 3542 */ // Label 26: @3542
     /* 3542 */ GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(3553), // Rule ID 134 //
     /* 3547 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule96Enabled),
     /* 3550 */   // Combiner Rule #96: trunc_buildvector_fold; wip_match_opcode 'G_TRUNC'
     /* 3550 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner50),
     /* 3553 */ // Label 233: @3553
     /* 3553 */ GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(3564), // Rule ID 135 //
     /* 3558 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule97Enabled),
     /* 3561 */   // Combiner Rule #97: trunc_lshr_buildvector_fold; wip_match_opcode 'G_TRUNC'
     /* 3561 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner51),
     /* 3564 */ // Label 234: @3564
     /* 3564 */ GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(3575), // Rule ID 173 //
     /* 3569 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule131Enabled),
     /* 3572 */   // Combiner Rule #131: trunc_shift; wip_match_opcode 'G_TRUNC'
     /* 3572 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner78),
     /* 3575 */ // Label 235: @3575
     /* 3575 */ GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(3596), // Rule ID 58 //
     /* 3580 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule56Enabled),
     /* 3583 */   // MIs[0] root
     /* 3583 */   // No operand predicates
     /* 3583 */   // MIs[0] select
     /* 3583 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3587 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /* 3591 */   // MIs[1] cond
     /* 3591 */   // No operand predicates
     /* 3591 */   // MIs[1] true
     /* 3591 */   // No operand predicates
     /* 3591 */   // MIs[1] false
     /* 3591 */   // No operand predicates
     /* 3591 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3593 */   // Combiner Rule #56: select_of_truncate
     /* 3593 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner23),
     /* 3596 */ // Label 236: @3596
     /* 3596 */ GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(3625), // Rule ID 60 //
     /* 3601 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule58Enabled),
     /* 3604 */   // MIs[0] root
     /* 3604 */   // No operand predicates
     /* 3604 */   // MIs[0] binop
     /* 3604 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3608 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 3612 */   // MIs[1] x
     /* 3612 */   // No operand predicates
     /* 3612 */   // MIs[1] const
     /* 3612 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3616 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3620 */   // MIs[2] imm
     /* 3620 */   // No operand predicates
     /* 3620 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3622 */   // Combiner Rule #58: narrow_binop_add
     /* 3622 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 3625 */ // Label 237: @3625
     /* 3625 */ GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(3654), // Rule ID 63 //
     /* 3630 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule61Enabled),
     /* 3633 */   // MIs[0] root
     /* 3633 */   // No operand predicates
     /* 3633 */   // MIs[0] binop
     /* 3633 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3637 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 3641 */   // MIs[1] x
     /* 3641 */   // No operand predicates
     /* 3641 */   // MIs[1] const
     /* 3641 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3645 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3649 */   // MIs[2] imm
     /* 3649 */   // No operand predicates
     /* 3649 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3651 */   // Combiner Rule #61: narrow_binop_and
     /* 3651 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 3654 */ // Label 238: @3654
     /* 3654 */ GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(3683), // Rule ID 62 //
     /* 3659 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule60Enabled),
     /* 3662 */   // MIs[0] root
     /* 3662 */   // No operand predicates
     /* 3662 */   // MIs[0] binop
     /* 3662 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3666 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 3670 */   // MIs[1] x
     /* 3670 */   // No operand predicates
     /* 3670 */   // MIs[1] const
     /* 3670 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3674 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3678 */   // MIs[2] imm
     /* 3678 */   // No operand predicates
     /* 3678 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3680 */   // Combiner Rule #60: narrow_binop_mul
     /* 3680 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 3683 */ // Label 239: @3683
     /* 3683 */ GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(3712), // Rule ID 64 //
     /* 3688 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule62Enabled),
     /* 3691 */   // MIs[0] root
     /* 3691 */   // No operand predicates
     /* 3691 */   // MIs[0] binop
     /* 3691 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3695 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 3699 */   // MIs[1] x
     /* 3699 */   // No operand predicates
     /* 3699 */   // MIs[1] const
     /* 3699 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3703 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3707 */   // MIs[2] imm
     /* 3707 */   // No operand predicates
     /* 3707 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3709 */   // Combiner Rule #62: narrow_binop_or
     /* 3709 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 3712 */ // Label 240: @3712
     /* 3712 */ GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(3741), // Rule ID 61 //
     /* 3717 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule59Enabled),
     /* 3720 */   // MIs[0] root
     /* 3720 */   // No operand predicates
     /* 3720 */   // MIs[0] binop
     /* 3720 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3724 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 3728 */   // MIs[1] x
     /* 3728 */   // No operand predicates
     /* 3728 */   // MIs[1] const
     /* 3728 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3732 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3736 */   // MIs[2] imm
     /* 3736 */   // No operand predicates
     /* 3736 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3738 */   // Combiner Rule #59: narrow_binop_sub
     /* 3738 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 3741 */ // Label 241: @3741
     /* 3741 */ GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(3770), // Rule ID 65 //
     /* 3746 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule63Enabled),
     /* 3749 */   // MIs[0] root
     /* 3749 */   // No operand predicates
     /* 3749 */   // MIs[0] binop
     /* 3749 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3753 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 3757 */   // MIs[1] x
     /* 3757 */   // No operand predicates
     /* 3757 */   // MIs[1] const
     /* 3757 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3761 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3765 */   // MIs[2] imm
     /* 3765 */   // No operand predicates
     /* 3765 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3767 */   // Combiner Rule #63: narrow_binop_xor
     /* 3767 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 3770 */ // Label 242: @3770
     /* 3770 */ GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(3791), // Rule ID 47 //
     /* 3775 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule45Enabled),
     /* 3778 */   // MIs[0] root
     /* 3778 */   // No operand predicates
     /* 3778 */   // MIs[0] ext
     /* 3778 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3782 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 3786 */   // MIs[1] src
     /* 3786 */   // No operand predicates
     /* 3786 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3788 */   // Combiner Rule #45: truncate_of_anyext
     /* 3788 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner20),
     /* 3791 */ // Label 243: @3791
     /* 3791 */ GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(3815), // Rule ID 59 //
     /* 3796 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule57Enabled),
     /* 3799 */   // MIs[0] root
     /* 3799 */   // No operand predicates
     /* 3799 */   // MIs[0] bv
     /* 3799 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3803 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 3807 */   GIM_CheckNumOperandsGE, /*MI*/1, /*Expected*/2,
     /* 3810 */   // MIs[1] unused
     /* 3810 */   // No operand predicates
     /* 3810 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3812 */   // Combiner Rule #57: buildvector_of_truncate
     /* 3812 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner24),
     /* 3815 */ // Label 244: @3815
     /* 3815 */ GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(3836), // Rule ID 46 //
     /* 3820 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule44Enabled),
     /* 3823 */   // MIs[0] root
     /* 3823 */   // No operand predicates
     /* 3823 */   // MIs[0] ext
     /* 3823 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3827 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 3831 */   // MIs[1] src
     /* 3831 */   // No operand predicates
     /* 3831 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3833 */   // Combiner Rule #44: truncate_of_sext
     /* 3833 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner20),
     /* 3836 */ // Label 245: @3836
     /* 3836 */ GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(3857), // Rule ID 45 //
     /* 3841 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule43Enabled),
     /* 3844 */   // MIs[0] root
     /* 3844 */   // No operand predicates
     /* 3844 */   // MIs[0] ext
     /* 3844 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3848 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 3852 */   // MIs[1] src
     /* 3852 */   // No operand predicates
     /* 3852 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3854 */   // Combiner Rule #43: truncate_of_zext
     /* 3854 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner20),
     /* 3857 */ // Label 246: @3857
     /* 3857 */ GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(3878), // Rule ID 87 //
     /* 3862 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 3865 */   // MIs[0] dst
     /* 3865 */   // No operand predicates
     /* 3865 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3865 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3869 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3873 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3875 */   // Combiner Rule #77: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[0]]
     /* 3875 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 3878 */ // Label 247: @3878
     /* 3878 */ GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(3899), // Rule ID 66 //
     /* 3883 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule64Enabled),
     /* 3886 */   // MIs[0] root
     /* 3886 */   // No operand predicates
     /* 3886 */   // MIs[0] int
     /* 3886 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3890 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3894 */   // MIs[1] imm
     /* 3894 */   // No operand predicates
     /* 3894 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3896 */   // Combiner Rule #64: integer_of_truncate
     /* 3896 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner26),
     /* 3899 */ // Label 248: @3899
     /* 3899 */ GIM_Reject,
     /* 3900 */ // Label 27: @3900
     /* 3900 */ GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(3911), // Rule ID 256 //
     /* 3905 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule169Enabled),
     /* 3908 */   // Combiner Rule #169: constant_fold_cast_op; wip_match_opcode 'G_SEXT'
     /* 3908 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner107),
     /* 3911 */ // Label 249: @3911
     /* 3911 */ GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(3932), // Rule ID 51 //
     /* 3916 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule49Enabled),
     /* 3919 */   // MIs[0] root
     /* 3919 */   // No operand predicates
     /* 3919 */   // MIs[0] second
     /* 3919 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3923 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 3927 */   // MIs[1] src
     /* 3927 */   // No operand predicates
     /* 3927 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3929 */   // Combiner Rule #49: sext_of_anyext
     /* 3929 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 3932 */ // Label 250: @3932
     /* 3932 */ GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(3953), // Rule ID 50 //
     /* 3937 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 3940 */   // MIs[0] root
     /* 3940 */   // No operand predicates
     /* 3940 */   // MIs[0] second
     /* 3940 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3944 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 3948 */   // MIs[1] src
     /* 3948 */   // No operand predicates
     /* 3948 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3950 */   // Combiner Rule #48: sext_of_sext
     /* 3950 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 3953 */ // Label 251: @3953
     /* 3953 */ GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(3974), // Rule ID 342 //
     /* 3958 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule197Enabled),
     /* 3961 */   // MIs[0] root
     /* 3961 */   // No operand predicates
     /* 3961 */   // MIs[0] src
     /* 3961 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3965 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 3969 */   // MIs[1] x
     /* 3969 */   // No operand predicates
     /* 3969 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3971 */   // Combiner Rule #197: sext_trunc
     /* 3971 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner133),
     /* 3974 */ // Label 252: @3974
     /* 3974 */ GIM_Reject,
     /* 3975 */ // Label 28: @3975
     /* 3975 */ GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(3986), // Rule ID 160 //
     /* 3980 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule118Enabled),
     /* 3983 */   // Combiner Rule #118: sext_inreg_of_load; wip_match_opcode 'G_SEXT_INREG'
     /* 3983 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner66),
     /* 3986 */ // Label 253: @3986
     /* 3986 */ GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(3997), // Rule ID 168 //
     /* 3991 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule126Enabled),
     /* 3994 */   // Combiner Rule #126: redundant_sext_inreg; wip_match_opcode 'G_SEXT_INREG'
     /* 3994 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner73),
     /* 3997 */ // Label 254: @3997
     /* 3997 */ GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(4008), // Rule ID 225 //
     /* 4002 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule162Enabled),
     /* 4005 */   // Combiner Rule #162: bitfield_extract_from_sext_inreg; wip_match_opcode 'G_SEXT_INREG'
     /* 4005 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner100),
     /* 4008 */ // Label 255: @4008
     /* 4008 */ GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(4029), // Rule ID 55 //
     /* 4013 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule53Enabled),
     /* 4016 */   // MIs[0] dst
     /* 4016 */   // No operand predicates
     /* 4016 */   // MIs[0] x
     /* 4016 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4020 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 4024 */   // MIs[1] src
     /* 4024 */   // No operand predicates
     /* 4024 */   // MIs[1] a
     /* 4024 */   // No operand predicates
     /* 4024 */   // MIs[0] b
     /* 4024 */   // No operand predicates
     /* 4024 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4026 */   // Combiner Rule #53: sext_inreg_of_sext_inreg
     /* 4026 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner22),
     /* 4029 */ // Label 256: @4029
     /* 4029 */ GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(4040), // Rule ID 172 //
     /* 4034 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule130Enabled),
     /* 4037 */   // MIs[0] dst
     /* 4037 */   // No operand predicates
     /* 4037 */   // MIs[0] src
     /* 4037 */   // No operand predicates
     /* 4037 */   // MIs[0] imm
     /* 4037 */   // No operand predicates
     /* 4037 */   // Combiner Rule #130: sext_inreg_to_zext_inreg
     /* 4037 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner77),
     /* 4040 */ // Label 257: @4040
     /* 4040 */ GIM_Reject,
     /* 4041 */ // Label 29: @4041
     /* 4041 */ GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(4052), // Rule ID 171 //
     /* 4046 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule129Enabled),
     /* 4049 */   // Combiner Rule #129: zext_trunc_fold; wip_match_opcode 'G_ZEXT'
     /* 4049 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner76),
     /* 4052 */ // Label 258: @4052
     /* 4052 */ GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(4063), // Rule ID 255 //
     /* 4057 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule169Enabled),
     /* 4060 */   // Combiner Rule #169: constant_fold_cast_op; wip_match_opcode 'G_ZEXT'
     /* 4060 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner107),
     /* 4063 */ // Label 259: @4063
     /* 4063 */ GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(4084), // Rule ID 56 //
     /* 4068 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule54Enabled),
     /* 4071 */   // MIs[0] root
     /* 4071 */   // No operand predicates
     /* 4071 */   // MIs[0] select
     /* 4071 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4075 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /* 4079 */   // MIs[1] cond
     /* 4079 */   // No operand predicates
     /* 4079 */   // MIs[1] true
     /* 4079 */   // No operand predicates
     /* 4079 */   // MIs[1] false
     /* 4079 */   // No operand predicates
     /* 4079 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4081 */   // Combiner Rule #54: select_of_zext
     /* 4081 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner23),
     /* 4084 */ // Label 260: @4084
     /* 4084 */ GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(4105), // Rule ID 49 //
     /* 4089 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule47Enabled),
     /* 4092 */   // MIs[0] root
     /* 4092 */   // No operand predicates
     /* 4092 */   // MIs[0] second
     /* 4092 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4096 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 4100 */   // MIs[1] src
     /* 4100 */   // No operand predicates
     /* 4100 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4102 */   // Combiner Rule #47: zext_of_anyext
     /* 4102 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 4105 */ // Label 261: @4105
     /* 4105 */ GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(4132), // Rule ID 343 //
     /* 4110 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule198Enabled),
     /* 4113 */   // MIs[0] root
     /* 4113 */   // No operand predicates
     /* 4113 */   // MIs[0] src
     /* 4113 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4117 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 4121 */   GIM_MIFlags, /*MI*/1, GIMT_Encode4(MachineInstr::NoUWrap),
     /* 4127 */   // MIs[1] x
     /* 4127 */   // No operand predicates
     /* 4127 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4129 */   // Combiner Rule #198: zext_trunc
     /* 4129 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner134),
     /* 4132 */ // Label 262: @4132
     /* 4132 */ GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(4153), // Rule ID 48 //
     /* 4137 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule46Enabled),
     /* 4140 */   // MIs[0] root
     /* 4140 */   // No operand predicates
     /* 4140 */   // MIs[0] second
     /* 4140 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4144 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 4148 */   // MIs[1] src
     /* 4148 */   // No operand predicates
     /* 4148 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4150 */   // Combiner Rule #46: zext_of_zext
     /* 4150 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 4153 */ // Label 263: @4153
     /* 4153 */ GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(4170), // Rule ID 344 //
     /* 4158 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule199Enabled),
     /* 4161 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NonNeg),
     /* 4167 */   // MIs[0] root
     /* 4167 */   // No operand predicates
     /* 4167 */   // MIs[0] x
     /* 4167 */   // No operand predicates
     /* 4167 */   // Combiner Rule #199: nneg_zext
     /* 4167 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner135),
     /* 4170 */ // Label 264: @4170
     /* 4170 */ GIM_Reject,
     /* 4171 */ // Label 30: @4171
     /* 4171 */ GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(4182), // Rule ID 80 //
     /* 4176 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule74Enabled),
     /* 4179 */   // Combiner Rule #74: binop_left_undef_to_zero; wip_match_opcode 'G_SHL'
     /* 4179 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner36),
     /* 4182 */ // Label 265: @4182
     /* 4182 */ GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(4193), // Rule ID 83 //
     /* 4187 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule75Enabled),
     /* 4190 */   // Combiner Rule #75: binop_right_undef_to_undef; wip_match_opcode 'G_SHL'
     /* 4190 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 4193 */ // Label 266: @4193
     /* 4193 */ GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(4204), // Rule ID 116 //
     /* 4198 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 4201 */   // Combiner Rule #86: binop_left_to_zero; wip_match_opcode 'G_SHL'
     /* 4201 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 4204 */ // Label 267: @4204
     /* 4204 */ GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(4215), // Rule ID 200 //
     /* 4209 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 4212 */   // Combiner Rule #150: shift_immed_chain; wip_match_opcode 'G_SHL'
     /* 4212 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 4215 */ // Label 268: @4215
     /* 4215 */ GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(4226), // Rule ID 205 //
     /* 4220 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 4223 */   // Combiner Rule #151: shift_of_shifted_logic_chain; wip_match_opcode 'G_SHL'
     /* 4223 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner93),
     /* 4226 */ // Label 269: @4226
     /* 4226 */ GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(4237), // Rule ID 224 //
     /* 4231 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule161Enabled),
     /* 4234 */   // Combiner Rule #161: commute_shift; wip_match_opcode 'G_SHL'
     /* 4234 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner99),
     /* 4237 */ // Label 270: @4237
     /* 4237 */ GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(4248), // Rule ID 238 //
     /* 4242 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 4245 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_SHL'
     /* 4245 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 4248 */ // Label 271: @4248
     /* 4248 */ GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(4259), // Rule ID 291 //
     /* 4253 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 4256 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_SHL'
     /* 4256 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 4259 */ // Label 272: @4259
     /* 4259 */ GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(4294), // Rule ID 41 //
     /* 4264 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule39Enabled),
     /* 4267 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 4273 */   // MIs[0] root
     /* 4273 */   // No operand predicates
     /* 4273 */   // MIs[0] left
     /* 4273 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4277 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 4281 */   // MIs[1] imm
     /* 4281 */   // No operand predicates
     /* 4281 */   // MIs[0] x
     /* 4281 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 4285 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 4289 */   // MIs[2] imm1
     /* 4289 */   // No operand predicates
     /* 4289 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 4291 */   // Combiner Rule #39: shl_of_vscale
     /* 4291 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner17),
     /* 4294 */ // Label 273: @4294
     /* 4294 */ GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(4317), // Rule ID 108 //
     /* 4299 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 4302 */   // MIs[0] dst
     /* 4302 */   // No operand predicates
     /* 4302 */   // MIs[0] lhs
     /* 4302 */   // No operand predicates
     /* 4302 */   // MIs[0] Operand 2
     /* 4302 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4306 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4311 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[4]]
     /* 4311 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4316 */   GIR_EraseRootFromParent_Done,
     /* 4317 */ // Label 274: @4317
     /* 4317 */ GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(4328), // Rule ID 145 //
     /* 4322 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule105Enabled),
     /* 4325 */   // MIs[0] root
     /* 4325 */   // No operand predicates
     /* 4325 */   // MIs[0] mi.shifted
     /* 4325 */   // No operand predicates
     /* 4325 */   // MIs[0] mi.amt
     /* 4325 */   // No operand predicates
     /* 4325 */   // Combiner Rule #105: shifts_too_big @ [mi[0]]
     /* 4325 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner56),
     /* 4328 */ // Label 275: @4328
     /* 4328 */ GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(4339), // Rule ID 161 //
     /* 4333 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule119Enabled),
     /* 4336 */   // MIs[0] dst
     /* 4336 */   // No operand predicates
     /* 4336 */   // MIs[0] src0
     /* 4336 */   // No operand predicates
     /* 4336 */   // MIs[0] src1
     /* 4336 */   // No operand predicates
     /* 4336 */   // Combiner Rule #119: reduce_shl_of_extend
     /* 4336 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 4339 */ // Label 276: @4339
     /* 4339 */ GIM_Reject,
     /* 4340 */ // Label 31: @4340
     /* 4340 */ GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(4351), // Rule ID 85 //
     /* 4345 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule75Enabled),
     /* 4348 */   // Combiner Rule #75: binop_right_undef_to_undef; wip_match_opcode 'G_LSHR'
     /* 4348 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 4351 */ // Label 277: @4351
     /* 4351 */ GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(4362), // Rule ID 117 //
     /* 4356 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 4359 */   // Combiner Rule #86: binop_left_to_zero; wip_match_opcode 'G_LSHR'
     /* 4359 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 4362 */ // Label 278: @4362
     /* 4362 */ GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(4373), // Rule ID 202 //
     /* 4367 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 4370 */   // Combiner Rule #150: shift_immed_chain; wip_match_opcode 'G_LSHR'
     /* 4370 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 4373 */ // Label 279: @4373
     /* 4373 */ GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(4384), // Rule ID 207 //
     /* 4378 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 4381 */   // Combiner Rule #151: shift_of_shifted_logic_chain; wip_match_opcode 'G_LSHR'
     /* 4381 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner93),
     /* 4384 */ // Label 280: @4384
     /* 4384 */ GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(4395), // Rule ID 228 //
     /* 4389 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 4392 */   // Combiner Rule #164: bitfield_extract_from_shr; wip_match_opcode 'G_LSHR'
     /* 4392 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner102),
     /* 4395 */ // Label 281: @4395
     /* 4395 */ GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(4406), // Rule ID 230 //
     /* 4400 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 4403 */   // Combiner Rule #165: bitfield_extract_from_shr_and; wip_match_opcode 'G_LSHR'
     /* 4403 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 4406 */ // Label 282: @4406
     /* 4406 */ GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(4417), // Rule ID 235 //
     /* 4411 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 4414 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_LSHR'
     /* 4414 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 4417 */ // Label 283: @4417
     /* 4417 */ GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(4428), // Rule ID 289 //
     /* 4422 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 4425 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_LSHR'
     /* 4425 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 4428 */ // Label 284: @4428
     /* 4428 */ GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(4451), // Rule ID 110 //
     /* 4433 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 4436 */   // MIs[0] dst
     /* 4436 */   // No operand predicates
     /* 4436 */   // MIs[0] lhs
     /* 4436 */   // No operand predicates
     /* 4436 */   // MIs[0] Operand 2
     /* 4436 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4440 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4445 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[6]]
     /* 4445 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4450 */   GIR_EraseRootFromParent_Done,
     /* 4451 */ // Label 285: @4451
     /* 4451 */ GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(4462), // Rule ID 147 //
     /* 4456 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule105Enabled),
     /* 4459 */   // MIs[0] root
     /* 4459 */   // No operand predicates
     /* 4459 */   // MIs[0] mi.shifted
     /* 4459 */   // No operand predicates
     /* 4459 */   // MIs[0] mi.amt
     /* 4459 */   // No operand predicates
     /* 4459 */   // Combiner Rule #105: shifts_too_big @ [mi[2]]
     /* 4459 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner56),
     /* 4462 */ // Label 286: @4462
     /* 4462 */ GIM_Reject,
     /* 4463 */ // Label 32: @4463
     /* 4463 */ GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(4474), // Rule ID 84 //
     /* 4468 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule75Enabled),
     /* 4471 */   // Combiner Rule #75: binop_right_undef_to_undef; wip_match_opcode 'G_ASHR'
     /* 4471 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 4474 */ // Label 287: @4474
     /* 4474 */ GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(4485), // Rule ID 118 //
     /* 4479 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 4482 */   // Combiner Rule #86: binop_left_to_zero; wip_match_opcode 'G_ASHR'
     /* 4482 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 4485 */ // Label 288: @4485
     /* 4485 */ GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(4496), // Rule ID 158 //
     /* 4490 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule116Enabled),
     /* 4493 */   // Combiner Rule #116: shl_ashr_to_sext_inreg; wip_match_opcode 'G_ASHR'
     /* 4493 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner65),
     /* 4496 */ // Label 289: @4496
     /* 4496 */ GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(4507), // Rule ID 201 //
     /* 4501 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 4504 */   // Combiner Rule #150: shift_immed_chain; wip_match_opcode 'G_ASHR'
     /* 4504 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 4507 */ // Label 290: @4507
     /* 4507 */ GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(4518), // Rule ID 206 //
     /* 4512 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 4515 */   // Combiner Rule #151: shift_of_shifted_logic_chain; wip_match_opcode 'G_ASHR'
     /* 4515 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner93),
     /* 4518 */ // Label 291: @4518
     /* 4518 */ GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(4529), // Rule ID 227 //
     /* 4523 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 4526 */   // Combiner Rule #164: bitfield_extract_from_shr; wip_match_opcode 'G_ASHR'
     /* 4526 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner102),
     /* 4529 */ // Label 292: @4529
     /* 4529 */ GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(4540), // Rule ID 229 //
     /* 4534 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 4537 */   // Combiner Rule #165: bitfield_extract_from_shr_and; wip_match_opcode 'G_ASHR'
     /* 4537 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 4540 */ // Label 293: @4540
     /* 4540 */ GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(4551), // Rule ID 234 //
     /* 4545 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 4548 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_ASHR'
     /* 4548 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 4551 */ // Label 294: @4551
     /* 4551 */ GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(4562), // Rule ID 290 //
     /* 4556 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 4559 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_ASHR'
     /* 4559 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 4562 */ // Label 295: @4562
     /* 4562 */ GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(4585), // Rule ID 109 //
     /* 4567 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 4570 */   // MIs[0] dst
     /* 4570 */   // No operand predicates
     /* 4570 */   // MIs[0] lhs
     /* 4570 */   // No operand predicates
     /* 4570 */   // MIs[0] Operand 2
     /* 4570 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4574 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4579 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[5]]
     /* 4579 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4584 */   GIR_EraseRootFromParent_Done,
     /* 4585 */ // Label 296: @4585
     /* 4585 */ GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(4596), // Rule ID 146 //
     /* 4590 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule105Enabled),
     /* 4593 */   // MIs[0] root
     /* 4593 */   // No operand predicates
     /* 4593 */   // MIs[0] mi.shifted
     /* 4593 */   // No operand predicates
     /* 4593 */   // MIs[0] mi.amt
     /* 4593 */   // No operand predicates
     /* 4593 */   // Combiner Rule #105: shifts_too_big @ [mi[1]]
     /* 4593 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner56),
     /* 4596 */ // Label 297: @4596
     /* 4596 */ GIM_Reject,
     /* 4597 */ // Label 33: @4597
     /* 4597 */ GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(4608), // Rule ID 216 //
     /* 4602 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule155Enabled),
     /* 4605 */   // Combiner Rule #155: funnel_shift_to_rotate; wip_match_opcode 'G_FSHL'
     /* 4605 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner97),
     /* 4608 */ // Label 298: @4608
     /* 4608 */ GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(4619), // Rule ID 220 //
     /* 4613 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule158Enabled),
     /* 4616 */   // Combiner Rule #158: funnel_shift_overshift; wip_match_opcode 'G_FSHL'
     /* 4616 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner98),
     /* 4619 */ // Label 299: @4619
     /* 4619 */ GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(4639), // Rule ID 219 //
     /* 4624 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule157Enabled),
     /* 4627 */   // MIs[0] x
     /* 4627 */   // No operand predicates
     /* 4627 */   // MIs[0] y
     /* 4627 */   // No operand predicates
     /* 4627 */   // MIs[0] z
     /* 4627 */   // No operand predicates
     /* 4627 */   // MIs[0] Operand 3
     /* 4627 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 4631 */   // Combiner Rule #157: funnel_shift_left_zero
     /* 4631 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 4634 */   GIR_RootToRootCopy, /*OpIdx*/0, // x
     /* 4636 */   GIR_RootToRootCopy, /*OpIdx*/1, // y
     /* 4638 */   GIR_EraseRootFromParent_Done,
     /* 4639 */ // Label 300: @4639
     /* 4639 */ GIM_Reject,
     /* 4640 */ // Label 34: @4640
     /* 4640 */ GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(4651), // Rule ID 217 //
     /* 4645 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule155Enabled),
     /* 4648 */   // Combiner Rule #155: funnel_shift_to_rotate; wip_match_opcode 'G_FSHR'
     /* 4648 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner97),
     /* 4651 */ // Label 301: @4651
     /* 4651 */ GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(4662), // Rule ID 221 //
     /* 4656 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule158Enabled),
     /* 4659 */   // Combiner Rule #158: funnel_shift_overshift; wip_match_opcode 'G_FSHR'
     /* 4659 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner98),
     /* 4662 */ // Label 302: @4662
     /* 4662 */ GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(4682), // Rule ID 218 //
     /* 4667 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule156Enabled),
     /* 4670 */   // MIs[0] x
     /* 4670 */   // No operand predicates
     /* 4670 */   // MIs[0] y
     /* 4670 */   // No operand predicates
     /* 4670 */   // MIs[0] z
     /* 4670 */   // No operand predicates
     /* 4670 */   // MIs[0] Operand 3
     /* 4670 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 4674 */   // Combiner Rule #156: funnel_shift_right_zero
     /* 4674 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 4677 */   GIR_RootToRootCopy, /*OpIdx*/0, // x
     /* 4679 */   GIR_RootToRootCopy, /*OpIdx*/2, // z
     /* 4681 */   GIR_EraseRootFromParent_Done,
     /* 4682 */ // Label 303: @4682
     /* 4682 */ GIM_Reject,
     /* 4683 */ // Label 35: @4683
     /* 4683 */ GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(4706), // Rule ID 113 //
     /* 4688 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 4691 */   // MIs[0] dst
     /* 4691 */   // No operand predicates
     /* 4691 */   // MIs[0] lhs
     /* 4691 */   // No operand predicates
     /* 4691 */   // MIs[0] Operand 2
     /* 4691 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4695 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4700 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[9]]
     /* 4700 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4705 */   GIR_EraseRootFromParent_Done,
     /* 4706 */ // Label 304: @4706
     /* 4706 */ GIM_Reject,
     /* 4707 */ // Label 36: @4707
     /* 4707 */ GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(4730), // Rule ID 112 //
     /* 4712 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 4715 */   // MIs[0] dst
     /* 4715 */   // No operand predicates
     /* 4715 */   // MIs[0] lhs
     /* 4715 */   // No operand predicates
     /* 4715 */   // MIs[0] Operand 2
     /* 4715 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4719 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4724 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[8]]
     /* 4724 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4729 */   GIR_EraseRootFromParent_Done,
     /* 4730 */ // Label 305: @4730
     /* 4730 */ GIM_Reject,
     /* 4731 */ // Label 37: @4731
     /* 4731 */ GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(4742), // Rule ID 153 //
     /* 4736 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule111Enabled),
     /* 4739 */   // Combiner Rule #111: icmp_to_true_false_known_bits; wip_match_opcode 'G_ICMP'
     /* 4739 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner62),
     /* 4742 */ // Label 306: @4742
     /* 4742 */ GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(4753), // Rule ID 154 //
     /* 4747 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule112Enabled),
     /* 4750 */   // Combiner Rule #112: icmp_to_lhs_known_bits; wip_match_opcode 'G_ICMP'
     /* 4750 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner63),
     /* 4753 */ // Label 307: @4753
     /* 4753 */ GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(4764), // Rule ID 157 //
     /* 4758 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule115Enabled),
     /* 4761 */   // Combiner Rule #115: redundant_binop_in_equality; wip_match_opcode 'G_ICMP'
     /* 4761 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner64),
     /* 4764 */ // Label 308: @4764
     /* 4764 */ GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(4775), // Rule ID 151 //
     /* 4769 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule109Enabled),
     /* 4772 */   // MIs[0] root
     /* 4772 */   // No operand predicates
     /* 4772 */   // MIs[0] pred
     /* 4772 */   // No operand predicates
     /* 4772 */   // MIs[0] lhs
     /* 4772 */   // No operand predicates
     /* 4772 */   // MIs[0] rhs
     /* 4772 */   // No operand predicates
     /* 4772 */   // Combiner Rule #109: canonicalize_icmp
     /* 4772 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner60),
     /* 4775 */ // Label 309: @4775
     /* 4775 */ GIM_Reject,
     /* 4776 */ // Label 38: @4776
     /* 4776 */ GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(4787), // Rule ID 152 //
     /* 4781 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule110Enabled),
     /* 4784 */   // MIs[0] root
     /* 4784 */   // No operand predicates
     /* 4784 */   // MIs[0] pred
     /* 4784 */   // No operand predicates
     /* 4784 */   // MIs[0] lhs
     /* 4784 */   // No operand predicates
     /* 4784 */   // MIs[0] rhs
     /* 4784 */   // No operand predicates
     /* 4784 */   // Combiner Rule #110: canonicalize_fcmp
     /* 4784 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner61),
     /* 4787 */ // Label 310: @4787
     /* 4787 */ GIM_Reject,
     /* 4788 */ // Label 39: @4788
     /* 4788 */ GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(4799), // Rule ID 103 //
     /* 4793 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 4796 */   // Combiner Rule #83: select_same_val; wip_match_opcode 'G_SELECT'
     /* 4796 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 4799 */ // Label 311: @4799
     /* 4799 */ GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(4810), // Rule ID 164 //
     /* 4804 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule122Enabled),
     /* 4807 */   // Combiner Rule #122: select_constant_cmp; wip_match_opcode 'G_SELECT'
     /* 4807 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner69),
     /* 4810 */ // Label 312: @4810
     /* 4810 */ GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(4821), // Rule ID 166 //
     /* 4815 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule124Enabled),
     /* 4818 */   // Combiner Rule #124: match_selects; wip_match_opcode 'G_SELECT'
     /* 4818 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner71),
     /* 4821 */ // Label 313: @4821
     /* 4821 */ GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(4832), // Rule ID 307 //
     /* 4826 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 4829 */   // Combiner Rule #189: select_to_minmax; wip_match_opcode 'G_SELECT'
     /* 4829 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner125),
     /* 4832 */ // Label 314: @4832
     /* 4832 */ GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(4853), // Rule ID 165 //
     /* 4837 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule123Enabled),
     /* 4840 */   // MIs[0] root
     /* 4840 */   // No operand predicates
     /* 4840 */   // MIs[0] tst
     /* 4840 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4844 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 4848 */   // MIs[1] tst1
     /* 4848 */   // No operand predicates
     /* 4848 */   // MIs[1] a
     /* 4848 */   // No operand predicates
     /* 4848 */   // MIs[1] b
     /* 4848 */   // No operand predicates
     /* 4848 */   // MIs[0] x
     /* 4848 */   // No operand predicates
     /* 4848 */   // MIs[0] y
     /* 4848 */   // No operand predicates
     /* 4848 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4850 */   // Combiner Rule #123: select_to_iminmax
     /* 4850 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner70),
     /* 4853 */ // Label 315: @4853
     /* 4853 */ GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(4882), // Rule ID 163 //
     /* 4858 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule121Enabled),
     /* 4861 */   // MIs[0] dst
     /* 4861 */   // No operand predicates
     /* 4861 */   // MIs[0] undef
     /* 4861 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4865 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 4869 */   // MIs[0] x
     /* 4869 */   // No operand predicates
     /* 4869 */   // MIs[0] y
     /* 4869 */   // No operand predicates
     /* 4869 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/3,
     /* 4874 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4876 */   // Combiner Rule #121: select_undef_cmp
     /* 4876 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/3,
     /* 4881 */   GIR_EraseRootFromParent_Done,
     /* 4882 */ // Label 316: @4882
     /* 4882 */ GIM_Reject,
     /* 4883 */ // Label 40: @4883
     /* 4883 */ GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(4894), // Rule ID 318 //
     /* 4888 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 4891 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_UADDO'
     /* 4891 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 4894 */ // Label 317: @4894
     /* 4894 */ GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(4905), // Rule ID 359 //
     /* 4899 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule213Enabled),
     /* 4902 */   // Combiner Rule #213: match_addos; wip_match_opcode 'G_UADDO'
     /* 4902 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner149),
     /* 4905 */ // Label 318: @4905
     /* 4905 */ GIM_Reject,
     /* 4906 */ // Label 41: @4906
     /* 4906 */ GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(4917), // Rule ID 189 //
     /* 4911 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule145Enabled),
     /* 4914 */   // Combiner Rule #145: adde_to_addo; wip_match_opcode 'G_UADDE'
     /* 4914 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 4917 */ // Label 319: @4917
     /* 4917 */ GIM_Reject,
     /* 4918 */ // Label 42: @4918
     /* 4918 */ GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(4929), // Rule ID 361 //
     /* 4923 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule214Enabled),
     /* 4926 */   // Combiner Rule #214: match_subo_no_overflow; wip_match_opcode 'G_USUBO'
     /* 4926 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner150),
     /* 4929 */ // Label 320: @4929
     /* 4929 */ GIM_Reject,
     /* 4930 */ // Label 43: @4930
     /* 4930 */ GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(4941), // Rule ID 191 //
     /* 4935 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule145Enabled),
     /* 4938 */   // Combiner Rule #145: adde_to_addo; wip_match_opcode 'G_USUBE'
     /* 4938 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 4941 */ // Label 321: @4941
     /* 4941 */ GIM_Reject,
     /* 4942 */ // Label 44: @4942
     /* 4942 */ GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(4953), // Rule ID 319 //
     /* 4947 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 4950 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_SADDO'
     /* 4950 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 4953 */ // Label 322: @4953
     /* 4953 */ GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(4964), // Rule ID 358 //
     /* 4958 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule213Enabled),
     /* 4961 */   // Combiner Rule #213: match_addos; wip_match_opcode 'G_SADDO'
     /* 4961 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner149),
     /* 4964 */ // Label 323: @4964
     /* 4964 */ GIM_Reject,
     /* 4965 */ // Label 45: @4965
     /* 4965 */ GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(4976), // Rule ID 190 //
     /* 4970 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule145Enabled),
     /* 4973 */   // Combiner Rule #145: adde_to_addo; wip_match_opcode 'G_SADDE'
     /* 4973 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 4976 */ // Label 324: @4976
     /* 4976 */ GIM_Reject,
     /* 4977 */ // Label 46: @4977
     /* 4977 */ GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(4988), // Rule ID 360 //
     /* 4982 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule214Enabled),
     /* 4985 */   // Combiner Rule #214: match_subo_no_overflow; wip_match_opcode 'G_SSUBO'
     /* 4985 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner150),
     /* 4988 */ // Label 325: @4988
     /* 4988 */ GIM_Reject,
     /* 4989 */ // Label 47: @4989
     /* 4989 */ GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(5000), // Rule ID 192 //
     /* 4994 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule145Enabled),
     /* 4997 */   // Combiner Rule #145: adde_to_addo; wip_match_opcode 'G_SSUBE'
     /* 4997 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 5000 */ // Label 326: @5000
     /* 5000 */ GIM_Reject,
     /* 5001 */ // Label 48: @5001
     /* 5001 */ GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(5012), // Rule ID 185 //
     /* 5006 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule143Enabled),
     /* 5009 */   // Combiner Rule #143: mulo_by_2; wip_match_opcode 'G_UMULO'
     /* 5009 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner85),
     /* 5012 */ // Label 327: @5012
     /* 5012 */ GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(5023), // Rule ID 187 //
     /* 5017 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule144Enabled),
     /* 5020 */   // Combiner Rule #144: mulo_by_0; wip_match_opcode 'G_UMULO'
     /* 5020 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner86),
     /* 5023 */ // Label 328: @5023
     /* 5023 */ GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(5034), // Rule ID 320 //
     /* 5028 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 5031 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULO'
     /* 5031 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5034 */ // Label 329: @5034
     /* 5034 */ GIM_Reject,
     /* 5035 */ // Label 49: @5035
     /* 5035 */ GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(5046), // Rule ID 186 //
     /* 5040 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule143Enabled),
     /* 5043 */   // Combiner Rule #143: mulo_by_2; wip_match_opcode 'G_SMULO'
     /* 5043 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner85),
     /* 5046 */ // Label 330: @5046
     /* 5046 */ GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(5057), // Rule ID 188 //
     /* 5051 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule144Enabled),
     /* 5054 */   // Combiner Rule #144: mulo_by_0; wip_match_opcode 'G_SMULO'
     /* 5054 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner86),
     /* 5057 */ // Label 331: @5057
     /* 5057 */ GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(5068), // Rule ID 321 //
     /* 5062 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 5065 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULO'
     /* 5065 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5068 */ // Label 332: @5068
     /* 5068 */ GIM_Reject,
     /* 5069 */ // Label 50: @5069
     /* 5069 */ GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(5080), // Rule ID 263 //
     /* 5074 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule175Enabled),
     /* 5077 */   // Combiner Rule #175: mulh_to_lshr; wip_match_opcode 'G_UMULH'
     /* 5077 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner112),
     /* 5080 */ // Label 333: @5080
     /* 5080 */ GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(5091), // Rule ID 322 //
     /* 5085 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 5088 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULH'
     /* 5088 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5091 */ // Label 334: @5091
     /* 5091 */ GIM_Reject,
     /* 5092 */ // Label 51: @5092
     /* 5092 */ GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(5103), // Rule ID 323 //
     /* 5097 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 5100 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULH'
     /* 5100 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5103 */ // Label 335: @5103
     /* 5103 */ GIM_Reject,
     /* 5104 */ // Label 52: @5104
     /* 5104 */ GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(5115), // Rule ID 324 //
     /* 5109 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 5112 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_UADDSAT'
     /* 5112 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5115 */ // Label 336: @5115
     /* 5115 */ GIM_Reject,
     /* 5116 */ // Label 53: @5116
     /* 5116 */ GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(5127), // Rule ID 325 //
     /* 5121 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 5124 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_SADDSAT'
     /* 5124 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5127 */ // Label 337: @5127
     /* 5127 */ GIM_Reject,
     /* 5128 */ // Label 54: @5128
     /* 5128 */ GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(5139), // Rule ID 204 //
     /* 5133 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 5136 */   // Combiner Rule #150: shift_immed_chain; wip_match_opcode 'G_USHLSAT'
     /* 5136 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 5139 */ // Label 338: @5139
     /* 5139 */ GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(5150), // Rule ID 208 //
     /* 5144 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 5147 */   // Combiner Rule #151: shift_of_shifted_logic_chain; wip_match_opcode 'G_USHLSAT'
     /* 5147 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner93),
     /* 5150 */ // Label 339: @5150
     /* 5150 */ GIM_Reject,
     /* 5151 */ // Label 55: @5151
     /* 5151 */ GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(5162), // Rule ID 203 //
     /* 5156 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 5159 */   // Combiner Rule #150: shift_immed_chain; wip_match_opcode 'G_SSHLSAT'
     /* 5159 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 5162 */ // Label 340: @5162
     /* 5162 */ GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(5173), // Rule ID 209 //
     /* 5167 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 5170 */   // Combiner Rule #151: shift_of_shifted_logic_chain; wip_match_opcode 'G_SSHLSAT'
     /* 5170 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner93),
     /* 5173 */ // Label 341: @5173
     /* 5173 */ GIM_Reject,
     /* 5174 */ // Label 56: @5174
     /* 5174 */ GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(5185), // Rule ID 326 //
     /* 5179 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 5182 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULFIX'
     /* 5182 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5185 */ // Label 342: @5185
     /* 5185 */ GIM_Reject,
     /* 5186 */ // Label 57: @5186
     /* 5186 */ GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(5197), // Rule ID 327 //
     /* 5191 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 5194 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULFIX'
     /* 5194 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5197 */ // Label 343: @5197
     /* 5197 */ GIM_Reject,
     /* 5198 */ // Label 58: @5198
     /* 5198 */ GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(5209), // Rule ID 328 //
     /* 5203 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 5206 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULFIXSAT'
     /* 5206 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5209 */ // Label 344: @5209
     /* 5209 */ GIM_Reject,
     /* 5210 */ // Label 59: @5210
     /* 5210 */ GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(5221), // Rule ID 329 //
     /* 5215 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 5218 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULFIXSAT'
     /* 5218 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5221 */ // Label 345: @5221
     /* 5221 */ GIM_Reject,
     /* 5222 */ // Label 60: @5222
     /* 5222 */ GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(5233), // Rule ID 249 //
     /* 5227 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule167Enabled),
     /* 5230 */   // Combiner Rule #167: constant_fold_fp_binop; wip_match_opcode 'G_FADD'
     /* 5230 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner105),
     /* 5233 */ // Label 346: @5233
     /* 5233 */ GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(5244), // Rule ID 264 //
     /* 5238 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule176Enabled),
     /* 5241 */   // Combiner Rule #176: redundant_neg_operands; wip_match_opcode 'G_FADD'
     /* 5241 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner113),
     /* 5244 */ // Label 347: @5244
     /* 5244 */ GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(5255), // Rule ID 271 //
     /* 5249 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule178Enabled),
     /* 5252 */   // Combiner Rule #178: combine_fadd_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 5252 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner115),
     /* 5255 */ // Label 348: @5255
     /* 5255 */ GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(5266), // Rule ID 272 //
     /* 5260 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule179Enabled),
     /* 5263 */   // Combiner Rule #179: combine_fadd_fpext_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 5263 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner116),
     /* 5266 */ // Label 349: @5266
     /* 5266 */ GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(5277), // Rule ID 273 //
     /* 5271 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule180Enabled),
     /* 5274 */   // Combiner Rule #180: combine_fadd_fma_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 5274 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner117),
     /* 5277 */ // Label 350: @5277
     /* 5277 */ GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(5288), // Rule ID 274 //
     /* 5282 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule181Enabled),
     /* 5285 */   // Combiner Rule #181: combine_fadd_fpext_fma_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 5285 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner118),
     /* 5288 */ // Label 351: @5288
     /* 5288 */ GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(5299), // Rule ID 297 //
     /* 5293 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 5296 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_FADD'
     /* 5296 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 5299 */ // Label 352: @5299
     /* 5299 */ GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(5310), // Rule ID 330 //
     /* 5304 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule192Enabled),
     /* 5307 */   // Combiner Rule #192: commute_fp_constant_to_rhs; wip_match_opcode 'G_FADD'
     /* 5307 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 5310 */ // Label 353: @5310
     /* 5310 */ GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(5333), // Rule ID 138 //
     /* 5315 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule100Enabled),
     /* 5318 */   // MIs[0] dst
     /* 5318 */   // No operand predicates
     /* 5318 */   // MIs[0] x
     /* 5318 */   // No operand predicates
     /* 5318 */   // MIs[0] y
     /* 5318 */   // No operand predicates
     /* 5318 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner3),
     /* 5322 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5327 */   // Combiner Rule #100: right_identity_neg_zero_fp
     /* 5327 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5332 */   GIR_EraseRootFromParent_Done,
     /* 5333 */ // Label 354: @5333
     /* 5333 */ GIM_Reject,
     /* 5334 */ // Label 61: @5334
     /* 5334 */ GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(5345), // Rule ID 250 //
     /* 5339 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule167Enabled),
     /* 5342 */   // Combiner Rule #167: constant_fold_fp_binop; wip_match_opcode 'G_FSUB'
     /* 5342 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner105),
     /* 5345 */ // Label 355: @5345
     /* 5345 */ GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(5356), // Rule ID 265 //
     /* 5350 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule176Enabled),
     /* 5353 */   // Combiner Rule #176: redundant_neg_operands; wip_match_opcode 'G_FSUB'
     /* 5353 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner113),
     /* 5356 */ // Label 356: @5356
     /* 5356 */ GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(5367), // Rule ID 275 //
     /* 5361 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 5364 */   // Combiner Rule #182: combine_fsub_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 5364 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 5367 */ // Label 357: @5367
     /* 5367 */ GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(5378), // Rule ID 276 //
     /* 5372 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule183Enabled),
     /* 5375 */   // Combiner Rule #183: combine_fsub_fneg_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 5375 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner120),
     /* 5378 */ // Label 358: @5378
     /* 5378 */ GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(5389), // Rule ID 277 //
     /* 5383 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 5386 */   // Combiner Rule #184: combine_fsub_fpext_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 5386 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner121),
     /* 5389 */ // Label 359: @5389
     /* 5389 */ GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(5400), // Rule ID 278 //
     /* 5394 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 5397 */   // Combiner Rule #185: combine_fsub_fpext_fneg_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 5397 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 5400 */ // Label 360: @5400
     /* 5400 */ GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(5411), // Rule ID 298 //
     /* 5405 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 5408 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_FSUB'
     /* 5408 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 5411 */ // Label 361: @5411
     /* 5411 */ GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(5422), // Rule ID 308 //
     /* 5416 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5419 */   // Combiner Rule #190: fsub_to_fneg; wip_match_opcode 'G_FSUB'
     /* 5419 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 5422 */ // Label 362: @5422
     /* 5422 */ GIM_Reject,
     /* 5423 */ // Label 62: @5423
     /* 5423 */ GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(5434), // Rule ID 251 //
     /* 5428 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule167Enabled),
     /* 5431 */   // Combiner Rule #167: constant_fold_fp_binop; wip_match_opcode 'G_FMUL'
     /* 5431 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner105),
     /* 5434 */ // Label 363: @5434
     /* 5434 */ GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(5445), // Rule ID 266 //
     /* 5439 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule176Enabled),
     /* 5442 */   // Combiner Rule #176: redundant_neg_operands; wip_match_opcode 'G_FMUL'
     /* 5442 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner113),
     /* 5445 */ // Label 364: @5445
     /* 5445 */ GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(5456), // Rule ID 296 //
     /* 5450 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 5453 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_FMUL'
     /* 5453 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 5456 */ // Label 365: @5456
     /* 5456 */ GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(5467), // Rule ID 331 //
     /* 5461 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule192Enabled),
     /* 5464 */   // Combiner Rule #192: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMUL'
     /* 5464 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 5467 */ // Label 366: @5467
     /* 5467 */ GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(5490), // Rule ID 129 //
     /* 5472 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule93Enabled),
     /* 5475 */   // MIs[0] dst
     /* 5475 */   // No operand predicates
     /* 5475 */   // MIs[0] x
     /* 5475 */   // No operand predicates
     /* 5475 */   // MIs[0] y
     /* 5475 */   // No operand predicates
     /* 5475 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner2),
     /* 5479 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5484 */   // Combiner Rule #93: right_identity_one_fp
     /* 5484 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5489 */   GIR_EraseRootFromParent_Done,
     /* 5490 */ // Label 367: @5490
     /* 5490 */ GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(5510), // Rule ID 139 //
     /* 5495 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule101Enabled),
     /* 5498 */   // MIs[0] dst
     /* 5498 */   // No operand predicates
     /* 5498 */   // MIs[0] x
     /* 5498 */   // No operand predicates
     /* 5498 */   // MIs[0] y
     /* 5498 */   // No operand predicates
     /* 5498 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner4),
     /* 5502 */   // Combiner Rule #101: right_identity_neg_one_fp
     /* 5502 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 5505 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 5507 */   GIR_RootToRootCopy, /*OpIdx*/1, // x
     /* 5509 */   GIR_EraseRootFromParent_Done,
     /* 5510 */ // Label 368: @5510
     /* 5510 */ GIM_Reject,
     /* 5511 */ // Label 63: @5511
     /* 5511 */ GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(5522), // Rule ID 254 //
     /* 5516 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule168Enabled),
     /* 5519 */   // Combiner Rule #168: constant_fold_fma; wip_match_opcode 'G_FMA'
     /* 5519 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner106),
     /* 5522 */ // Label 369: @5522
     /* 5522 */ GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(5533), // Rule ID 269 //
     /* 5527 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule176Enabled),
     /* 5530 */   // Combiner Rule #176: redundant_neg_operands; wip_match_opcode 'G_FMA'
     /* 5530 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner113),
     /* 5533 */ // Label 370: @5533
     /* 5533 */ GIM_Reject,
     /* 5534 */ // Label 64: @5534
     /* 5534 */ GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(5545), // Rule ID 253 //
     /* 5539 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule168Enabled),
     /* 5542 */   // Combiner Rule #168: constant_fold_fma; wip_match_opcode 'G_FMAD'
     /* 5542 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner106),
     /* 5545 */ // Label 371: @5545
     /* 5545 */ GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(5556), // Rule ID 268 //
     /* 5550 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule176Enabled),
     /* 5553 */   // Combiner Rule #176: redundant_neg_operands; wip_match_opcode 'G_FMAD'
     /* 5553 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner113),
     /* 5556 */ // Label 372: @5556
     /* 5556 */ GIM_Reject,
     /* 5557 */ // Label 65: @5557
     /* 5557 */ GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(5568), // Rule ID 252 //
     /* 5562 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule167Enabled),
     /* 5565 */   // Combiner Rule #167: constant_fold_fp_binop; wip_match_opcode 'G_FDIV'
     /* 5565 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner105),
     /* 5568 */ // Label 373: @5568
     /* 5568 */ GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(5579), // Rule ID 267 //
     /* 5573 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule176Enabled),
     /* 5576 */   // Combiner Rule #176: redundant_neg_operands; wip_match_opcode 'G_FDIV'
     /* 5576 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner113),
     /* 5579 */ // Label 374: @5579
     /* 5579 */ GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(5590), // Rule ID 299 //
     /* 5584 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 5587 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_FDIV'
     /* 5587 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 5590 */ // Label 375: @5590
     /* 5590 */ GIM_Reject,
     /* 5591 */ // Label 66: @5591
     /* 5591 */ GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(5602), // Rule ID 300 //
     /* 5596 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 5599 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_FREM'
     /* 5599 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 5602 */ // Label 376: @5602
     /* 5602 */ GIM_Reject,
     /* 5603 */ // Label 67: @5603
     /* 5603 */ GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(5624), // Rule ID 197 //
     /* 5608 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule147Enabled),
     /* 5611 */   // MIs[0] dst
     /* 5611 */   // No operand predicates
     /* 5611 */   // MIs[0] float
     /* 5611 */   // No operand predicates
     /* 5611 */   // MIs[0] int
     /* 5611 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 5615 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 5619 */   // MIs[1] imm
     /* 5619 */   // No operand predicates
     /* 5619 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5621 */   // Combiner Rule #147: expand_const_fpowi
     /* 5621 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner89),
     /* 5624 */ // Label 377: @5624
     /* 5624 */ GIM_Reject,
     /* 5625 */ // Label 68: @5625
     /* 5625 */ GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(5646), // Rule ID 179 //
     /* 5630 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule137Enabled),
     /* 5633 */   // MIs[0] dst
     /* 5633 */   // No operand predicates
     /* 5633 */   // MIs[0] src0
     /* 5633 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5637 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 5641 */   // MIs[1] cst
     /* 5641 */   // No operand predicates
     /* 5641 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5643 */   // Combiner Rule #137: constant_fold_flog2
     /* 5643 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner81),
     /* 5646 */ // Label 378: @5646
     /* 5646 */ GIM_Reject,
     /* 5647 */ // Label 69: @5647
     /* 5647 */ GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(5668), // Rule ID 176 //
     /* 5652 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule134Enabled),
     /* 5655 */   // MIs[0] dst
     /* 5655 */   // No operand predicates
     /* 5655 */   // MIs[0] src0
     /* 5655 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5659 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 5663 */   // MIs[1] cst
     /* 5663 */   // No operand predicates
     /* 5663 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5665 */   // Combiner Rule #134: constant_fold_fneg
     /* 5665 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner81),
     /* 5668 */ // Label 379: @5668
     /* 5668 */ GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(5697), // Rule ID 127 //
     /* 5673 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule91Enabled),
     /* 5676 */   // MIs[0] dst
     /* 5676 */   // No operand predicates
     /* 5676 */   // MIs[0] t
     /* 5676 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5680 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 5684 */   // MIs[1] src
     /* 5684 */   // No operand predicates
     /* 5684 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 5689 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5691 */   // Combiner Rule #91: fneg_fneg_fold
     /* 5691 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 5696 */   GIR_EraseRootFromParent_Done,
     /* 5697 */ // Label 380: @5697
     /* 5697 */ GIM_Reject,
     /* 5698 */ // Label 70: @5698
     /* 5698 */ GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(5719), // Rule ID 180 //
     /* 5703 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule138Enabled),
     /* 5706 */   // MIs[0] dst
     /* 5706 */   // No operand predicates
     /* 5706 */   // MIs[0] src0
     /* 5706 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5710 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 5714 */   // MIs[1] cst
     /* 5714 */   // No operand predicates
     /* 5714 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5716 */   // Combiner Rule #138: constant_fold_fptrunc
     /* 5716 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner81),
     /* 5719 */ // Label 381: @5719
     /* 5719 */ GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(5740), // Rule ID 137 //
     /* 5724 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule99Enabled),
     /* 5727 */   // MIs[0] dst
     /* 5727 */   // No operand predicates
     /* 5727 */   // MIs[0] src1
     /* 5727 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5731 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPEXT),
     /* 5735 */   // MIs[1] src0
     /* 5735 */   // No operand predicates
     /* 5735 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5737 */   // Combiner Rule #99: fptrunc_fpext_fold
     /* 5737 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner52),
     /* 5740 */ // Label 382: @5740
     /* 5740 */ GIM_Reject,
     /* 5741 */ // Label 71: @5741
     /* 5741 */ GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(5762), // Rule ID 92 //
     /* 5746 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 5749 */   // MIs[0] dst
     /* 5749 */   // No operand predicates
     /* 5749 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 5749 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5753 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 5757 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5759 */   // Combiner Rule #77: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[5]]
     /* 5759 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 5762 */ // Label 383: @5762
     /* 5762 */ GIM_Reject,
     /* 5763 */ // Label 72: @5763
     /* 5763 */ GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(5784), // Rule ID 93 //
     /* 5768 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 5771 */   // MIs[0] dst
     /* 5771 */   // No operand predicates
     /* 5771 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 5771 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5775 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 5779 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5781 */   // Combiner Rule #77: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[6]]
     /* 5781 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 5784 */ // Label 384: @5784
     /* 5784 */ GIM_Reject,
     /* 5785 */ // Label 73: @5785
     /* 5785 */ GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(5796), // Rule ID 76 //
     /* 5790 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule71Enabled),
     /* 5793 */   // Combiner Rule #71: undef_to_fp_zero; wip_match_opcode 'G_SITOFP'
     /* 5793 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner33),
     /* 5796 */ // Label 385: @5796
     /* 5796 */ GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(5811), // Rule ID 181 //
     /* 5801 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule139Enabled),
     /* 5804 */   // MIs[0] dst
     /* 5804 */   // No operand predicates
     /* 5804 */   // MIs[0] Operand 1
     /* 5804 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 5808 */   // Combiner Rule #139: itof_const_zero_fold_si
     /* 5808 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner82),
     /* 5811 */ // Label 386: @5811
     /* 5811 */ GIM_Reject,
     /* 5812 */ // Label 74: @5812
     /* 5812 */ GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(5823), // Rule ID 75 //
     /* 5817 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule71Enabled),
     /* 5820 */   // Combiner Rule #71: undef_to_fp_zero; wip_match_opcode 'G_UITOFP'
     /* 5820 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner33),
     /* 5823 */ // Label 387: @5823
     /* 5823 */ GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(5838), // Rule ID 182 //
     /* 5828 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule140Enabled),
     /* 5831 */   // MIs[0] dst
     /* 5831 */   // No operand predicates
     /* 5831 */   // MIs[0] Operand 1
     /* 5831 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 5835 */   // Combiner Rule #140: itof_const_zero_fold_ui
     /* 5835 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner82),
     /* 5838 */ // Label 388: @5838
     /* 5838 */ GIM_Reject,
     /* 5839 */ // Label 75: @5839
     /* 5839 */ GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(5868), // Rule ID 19 //
     /* 5844 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule18Enabled),
     /* 5847 */   // MIs[0] dst
     /* 5847 */   // No operand predicates
     /* 5847 */   // MIs[0] src
     /* 5847 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5851 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 5855 */   // MIs[1] __idempotent_prop_match_0.x
     /* 5855 */   // No operand predicates
     /* 5855 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5860 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5862 */   // Combiner Rule #18: idempotent_prop @ [__idempotent_prop_match_0[1]]
     /* 5862 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5867 */   GIR_EraseRootFromParent_Done,
     /* 5868 */ // Label 389: @5868
     /* 5868 */ GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(5889), // Rule ID 177 //
     /* 5873 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule135Enabled),
     /* 5876 */   // MIs[0] dst
     /* 5876 */   // No operand predicates
     /* 5876 */   // MIs[0] src0
     /* 5876 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5880 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 5884 */   // MIs[1] cst
     /* 5884 */   // No operand predicates
     /* 5884 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5886 */   // Combiner Rule #135: constant_fold_fabs
     /* 5886 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner81),
     /* 5889 */ // Label 390: @5889
     /* 5889 */ GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(5917), // Rule ID 258 //
     /* 5894 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule170Enabled),
     /* 5897 */   // MIs[0] dst
     /* 5897 */   // No operand predicates
     /* 5897 */   // MIs[0] tmp
     /* 5897 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5901 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 5905 */   // MIs[1] x
     /* 5905 */   // No operand predicates
     /* 5905 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5907 */   // Combiner Rule #170: fabs_fneg_fold
     /* 5907 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_FABS),
     /* 5910 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 5912 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // x
     /* 5916 */   GIR_EraseRootFromParent_Done,
     /* 5917 */ // Label 391: @5917
     /* 5917 */ GIM_Reject,
     /* 5918 */ // Label 76: @5918
     /* 5918 */ GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(5947), // Rule ID 20 //
     /* 5923 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule18Enabled),
     /* 5926 */   // MIs[0] dst
     /* 5926 */   // No operand predicates
     /* 5926 */   // MIs[0] src
     /* 5926 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5930 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 5934 */   // MIs[1] __idempotent_prop_match_0.x
     /* 5934 */   // No operand predicates
     /* 5934 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5939 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5941 */   // Combiner Rule #18: idempotent_prop @ [__idempotent_prop_match_0[2]]
     /* 5941 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5946 */   GIR_EraseRootFromParent_Done,
     /* 5947 */ // Label 392: @5947
     /* 5947 */ GIM_Reject,
     /* 5948 */ // Label 77: @5948
     /* 5948 */ GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(5959), // Rule ID 193 //
     /* 5953 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule146Enabled),
     /* 5956 */   // Combiner Rule #146: combine_minmax_nan; wip_match_opcode 'G_FMINNUM'
     /* 5956 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner88),
     /* 5959 */ // Label 393: @5959
     /* 5959 */ GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(5970), // Rule ID 301 //
     /* 5964 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 5967 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_FMINNUM'
     /* 5967 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 5970 */ // Label 394: @5970
     /* 5970 */ GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(5981), // Rule ID 332 //
     /* 5975 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule192Enabled),
     /* 5978 */   // Combiner Rule #192: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINNUM'
     /* 5978 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 5981 */ // Label 395: @5981
     /* 5981 */ GIM_Reject,
     /* 5982 */ // Label 78: @5982
     /* 5982 */ GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(5993), // Rule ID 194 //
     /* 5987 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule146Enabled),
     /* 5990 */   // Combiner Rule #146: combine_minmax_nan; wip_match_opcode 'G_FMAXNUM'
     /* 5990 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner88),
     /* 5993 */ // Label 396: @5993
     /* 5993 */ GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(6004), // Rule ID 302 //
     /* 5998 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 6001 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_FMAXNUM'
     /* 6001 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 6004 */ // Label 397: @6004
     /* 6004 */ GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(6015), // Rule ID 333 //
     /* 6009 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule192Enabled),
     /* 6012 */   // Combiner Rule #192: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXNUM'
     /* 6012 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 6015 */ // Label 398: @6015
     /* 6015 */ GIM_Reject,
     /* 6016 */ // Label 79: @6016
     /* 6016 */ GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(6027), // Rule ID 334 //
     /* 6021 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule192Enabled),
     /* 6024 */   // Combiner Rule #192: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINNUM_IEEE'
     /* 6024 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 6027 */ // Label 399: @6027
     /* 6027 */ GIM_Reject,
     /* 6028 */ // Label 80: @6028
     /* 6028 */ GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(6039), // Rule ID 335 //
     /* 6033 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule192Enabled),
     /* 6036 */   // Combiner Rule #192: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXNUM_IEEE'
     /* 6036 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 6039 */ // Label 400: @6039
     /* 6039 */ GIM_Reject,
     /* 6040 */ // Label 81: @6040
     /* 6040 */ GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(6051), // Rule ID 195 //
     /* 6045 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule146Enabled),
     /* 6048 */   // Combiner Rule #146: combine_minmax_nan; wip_match_opcode 'G_FMINIMUM'
     /* 6048 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner88),
     /* 6051 */ // Label 401: @6051
     /* 6051 */ GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(6062), // Rule ID 303 //
     /* 6056 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 6059 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_FMINIMUM'
     /* 6059 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 6062 */ // Label 402: @6062
     /* 6062 */ GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(6073), // Rule ID 336 //
     /* 6067 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule192Enabled),
     /* 6070 */   // Combiner Rule #192: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINIMUM'
     /* 6070 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 6073 */ // Label 403: @6073
     /* 6073 */ GIM_Reject,
     /* 6074 */ // Label 82: @6074
     /* 6074 */ GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(6085), // Rule ID 196 //
     /* 6079 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule146Enabled),
     /* 6082 */   // Combiner Rule #146: combine_minmax_nan; wip_match_opcode 'G_FMAXIMUM'
     /* 6082 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner88),
     /* 6085 */ // Label 404: @6085
     /* 6085 */ GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(6096), // Rule ID 304 //
     /* 6090 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 6093 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_FMAXIMUM'
     /* 6093 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 6096 */ // Label 405: @6096
     /* 6096 */ GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(6107), // Rule ID 337 //
     /* 6101 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule192Enabled),
     /* 6104 */   // Combiner Rule #192: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXIMUM'
     /* 6104 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 6107 */ // Label 406: @6107
     /* 6107 */ GIM_Reject,
     /* 6108 */ // Label 83: @6108
     /* 6108 */ GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(6119), // Rule ID 148 //
     /* 6113 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule106Enabled),
     /* 6116 */   // Combiner Rule #106: reassoc_ptradd; wip_match_opcode 'G_PTR_ADD'
     /* 6116 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner57),
     /* 6119 */ // Label 407: @6119
     /* 6119 */ GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(6130), // Rule ID 150 //
     /* 6124 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule108Enabled),
     /* 6127 */   // Combiner Rule #108: ptr_add_immed_chain; wip_match_opcode 'G_PTR_ADD'
     /* 6127 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner59),
     /* 6130 */ // Label 408: @6130
     /* 6130 */ GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(6141), // Rule ID 183 //
     /* 6135 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule141Enabled),
     /* 6138 */   // Combiner Rule #141: const_ptradd_to_i2p; wip_match_opcode 'G_PTR_ADD'
     /* 6138 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner83),
     /* 6141 */ // Label 409: @6141
     /* 6141 */ GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(6152), // Rule ID 199 //
     /* 6146 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule149Enabled),
     /* 6149 */   // Combiner Rule #149: ptr_add_with_zero; wip_match_opcode 'G_PTR_ADD'
     /* 6149 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner91),
     /* 6152 */ // Label 410: @6152
     /* 6152 */ GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(6163), // Rule ID 232 //
     /* 6157 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 6160 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_PTR_ADD'
     /* 6160 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 6163 */ // Label 411: @6163
     /* 6163 */ GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(6174), // Rule ID 281 //
     /* 6168 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 6171 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_PTR_ADD'
     /* 6171 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 6174 */ // Label 412: @6174
     /* 6174 */ GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(6197), // Rule ID 111 //
     /* 6179 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 6182 */   // MIs[0] dst
     /* 6182 */   // No operand predicates
     /* 6182 */   // MIs[0] lhs
     /* 6182 */   // No operand predicates
     /* 6182 */   // MIs[0] Operand 2
     /* 6182 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 6186 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6191 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[7]]
     /* 6191 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6196 */   GIR_EraseRootFromParent_Done,
     /* 6197 */ // Label 413: @6197
     /* 6197 */ GIM_Reject,
     /* 6198 */ // Label 84: @6198
     /* 6198 */ GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(6209), // Rule ID 245 //
     /* 6203 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 6206 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_SMIN'
     /* 6206 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 6209 */ // Label 414: @6209
     /* 6209 */ GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(6220), // Rule ID 292 //
     /* 6214 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 6217 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_SMIN'
     /* 6217 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 6220 */ // Label 415: @6220
     /* 6220 */ GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(6231), // Rule ID 314 //
     /* 6225 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 6228 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_SMIN'
     /* 6228 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 6231 */ // Label 416: @6231
     /* 6231 */ GIM_Reject,
     /* 6232 */ // Label 85: @6232
     /* 6232 */ GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(6243), // Rule ID 246 //
     /* 6237 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 6240 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_SMAX'
     /* 6240 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 6243 */ // Label 417: @6243
     /* 6243 */ GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(6254), // Rule ID 293 //
     /* 6248 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 6251 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_SMAX'
     /* 6251 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 6254 */ // Label 418: @6254
     /* 6254 */ GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(6265), // Rule ID 315 //
     /* 6259 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 6262 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_SMAX'
     /* 6262 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 6265 */ // Label 419: @6265
     /* 6265 */ GIM_Reject,
     /* 6266 */ // Label 86: @6266
     /* 6266 */ GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(6277), // Rule ID 247 //
     /* 6271 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 6274 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_UMIN'
     /* 6274 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 6277 */ // Label 420: @6277
     /* 6277 */ GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(6288), // Rule ID 294 //
     /* 6282 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 6285 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_UMIN'
     /* 6285 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 6288 */ // Label 421: @6288
     /* 6288 */ GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(6299), // Rule ID 316 //
     /* 6293 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 6296 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_UMIN'
     /* 6296 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 6299 */ // Label 422: @6299
     /* 6299 */ GIM_Reject,
     /* 6300 */ // Label 87: @6300
     /* 6300 */ GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(6311), // Rule ID 248 //
     /* 6305 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 6308 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_UMAX'
     /* 6308 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 6311 */ // Label 423: @6311
     /* 6311 */ GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(6322), // Rule ID 295 //
     /* 6316 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 6319 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_UMAX'
     /* 6319 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 6322 */ // Label 424: @6322
     /* 6322 */ GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(6333), // Rule ID 317 //
     /* 6327 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 6330 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_UMAX'
     /* 6330 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 6333 */ // Label 425: @6333
     /* 6333 */ GIM_Reject,
     /* 6334 */ // Label 88: @6334
     /* 6334 */ GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(6345), // Rule ID 86 //
     /* 6339 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 6342 */   // Combiner Rule #76: unary_undef_to_zero; wip_match_opcode 'G_ABS'
     /* 6342 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner36),
     /* 6345 */ // Label 426: @6345
     /* 6345 */ GIM_Reject,
     /* 6346 */ // Label 89: @6346
     /* 6346 */ GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(6357), // Rule ID 175 //
     /* 6351 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule133Enabled),
     /* 6354 */   // Combiner Rule #133: opt_brcond_by_inverting_cond; wip_match_opcode 'G_BR'
     /* 6354 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner80),
     /* 6357 */ // Label 427: @6357
     /* 6357 */ GIM_Reject,
     /* 6358 */ // Label 90: @6358
     /* 6358 */ GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(6369), // Rule ID 26 //
     /* 6363 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 6366 */   // Combiner Rule #24: insert_vector_elt_oob; wip_match_opcode 'G_INSERT_VECTOR_ELT'
     /* 6366 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner10),
     /* 6369 */ // Label 428: @6369
     /* 6369 */ GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(6380), // Rule ID 67 //
     /* 6374 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule65Enabled),
     /* 6377 */   // Combiner Rule #65: combine_insert_vec_elts_build_vector; wip_match_opcode 'G_INSERT_VECTOR_ELT'
     /* 6377 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner27),
     /* 6380 */ // Label 429: @6380
     /* 6380 */ GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(6391), // Rule ID 101 //
     /* 6385 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule82Enabled),
     /* 6388 */   // Combiner Rule #82: insert_extract_vec_elt_out_of_bounds; wip_match_opcode 'G_INSERT_VECTOR_ELT'
     /* 6388 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner43),
     /* 6391 */ // Label 430: @6391
     /* 6391 */ GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(6430), // Rule ID 38 //
     /* 6396 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule36Enabled),
     /* 6399 */   // MIs[0] root
     /* 6399 */   // No operand predicates
     /* 6399 */   // MIs[0] src
     /* 6399 */   // No operand predicates
     /* 6399 */   // MIs[0] elt
     /* 6399 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 6403 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 6407 */   // MIs[1] src
     /* 6407 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 6412 */   // MIs[1] idx
     /* 6412 */   // No operand predicates
     /* 6412 */   // MIs[0] idx
     /* 6412 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 6417 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6422 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6424 */   // Combiner Rule #36: insert_vector_element_extract_vector_element
     /* 6424 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6429 */   GIR_EraseRootFromParent_Done,
     /* 6430 */ // Label 431: @6430
     /* 6430 */ GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(6463), // Rule ID 24 //
     /* 6435 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule22Enabled),
     /* 6438 */   // MIs[0] root
     /* 6438 */   // No operand predicates
     /* 6438 */   // MIs[0] src
     /* 6438 */   // No operand predicates
     /* 6438 */   // MIs[0] elt
     /* 6438 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 6442 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6446 */   // MIs[0] idx
     /* 6446 */   // No operand predicates
     /* 6446 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner0),
     /* 6450 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6455 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6457 */   // Combiner Rule #22: insert_vector_element_elt_undef
     /* 6457 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6462 */   GIR_EraseRootFromParent_Done,
     /* 6463 */ // Label 432: @6463
     /* 6463 */ GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(6487), // Rule ID 23 //
     /* 6468 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule21Enabled),
     /* 6471 */   // MIs[0] root
     /* 6471 */   // No operand predicates
     /* 6471 */   // MIs[0] src
     /* 6471 */   // No operand predicates
     /* 6471 */   // MIs[0] elt
     /* 6471 */   // No operand predicates
     /* 6471 */   // MIs[0] idx
     /* 6471 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 6475 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6479 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6481 */   // Combiner Rule #21: insert_vector_element_idx_undef
     /* 6481 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6484 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 6486 */   GIR_EraseRootFromParent_Done,
     /* 6487 */ // Label 433: @6487
     /* 6487 */ GIM_Reject,
     /* 6488 */ // Label 91: @6488
     /* 6488 */ GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(6499), // Rule ID 25 //
     /* 6493 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule23Enabled),
     /* 6496 */   // Combiner Rule #23: match_extract_of_element; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 6496 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner9),
     /* 6499 */ // Label 434: @6499
     /* 6499 */ GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(6510), // Rule ID 68 //
     /* 6504 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule66Enabled),
     /* 6507 */   // Combiner Rule #66: extract_vec_elt_build_vec; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 6507 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner28),
     /* 6510 */ // Label 435: @6510
     /* 6510 */ GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(6521), // Rule ID 74 //
     /* 6515 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule70Enabled),
     /* 6518 */   // Combiner Rule #70: combine_extracted_vector_load; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 6518 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner32),
     /* 6521 */ // Label 436: @6521
     /* 6521 */ GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(6532), // Rule ID 102 //
     /* 6526 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule82Enabled),
     /* 6529 */   // Combiner Rule #82: insert_extract_vec_elt_out_of_bounds; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 6529 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner43),
     /* 6532 */ // Label 437: @6532
     /* 6532 */ GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(6556), // Rule ID 36 //
     /* 6537 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule34Enabled),
     /* 6540 */   // MIs[0] root
     /* 6540 */   // No operand predicates
     /* 6540 */   // MIs[0] src
     /* 6540 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6544 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6548 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/9,
     /* 6551 */   // MIs[1] x
     /* 6551 */   // No operand predicates
     /* 6551 */   // MIs[1] y
     /* 6551 */   // No operand predicates
     /* 6551 */   // MIs[1] z
     /* 6551 */   // No operand predicates
     /* 6551 */   // MIs[1] a
     /* 6551 */   // No operand predicates
     /* 6551 */   // MIs[1] b
     /* 6551 */   // No operand predicates
     /* 6551 */   // MIs[1] c
     /* 6551 */   // No operand predicates
     /* 6551 */   // MIs[1] d
     /* 6551 */   // No operand predicates
     /* 6551 */   // MIs[1] e
     /* 6551 */   // No operand predicates
     /* 6551 */   // MIs[0] idx
     /* 6551 */   // No operand predicates
     /* 6551 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6553 */   // Combiner Rule #34: extract_vector_element_build_vector_trunc8
     /* 6553 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6556 */ // Label 438: @6556
     /* 6556 */ GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(6580), // Rule ID 35 //
     /* 6561 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule33Enabled),
     /* 6564 */   // MIs[0] root
     /* 6564 */   // No operand predicates
     /* 6564 */   // MIs[0] src
     /* 6564 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6568 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6572 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/8,
     /* 6575 */   // MIs[1] x
     /* 6575 */   // No operand predicates
     /* 6575 */   // MIs[1] y
     /* 6575 */   // No operand predicates
     /* 6575 */   // MIs[1] z
     /* 6575 */   // No operand predicates
     /* 6575 */   // MIs[1] a
     /* 6575 */   // No operand predicates
     /* 6575 */   // MIs[1] b
     /* 6575 */   // No operand predicates
     /* 6575 */   // MIs[1] c
     /* 6575 */   // No operand predicates
     /* 6575 */   // MIs[1] d
     /* 6575 */   // No operand predicates
     /* 6575 */   // MIs[0] idx
     /* 6575 */   // No operand predicates
     /* 6575 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6577 */   // Combiner Rule #33: extract_vector_element_build_vector_trunc7
     /* 6577 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6580 */ // Label 439: @6580
     /* 6580 */ GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(6604), // Rule ID 34 //
     /* 6585 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule32Enabled),
     /* 6588 */   // MIs[0] root
     /* 6588 */   // No operand predicates
     /* 6588 */   // MIs[0] src
     /* 6588 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6592 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6596 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/7,
     /* 6599 */   // MIs[1] x
     /* 6599 */   // No operand predicates
     /* 6599 */   // MIs[1] y
     /* 6599 */   // No operand predicates
     /* 6599 */   // MIs[1] z
     /* 6599 */   // No operand predicates
     /* 6599 */   // MIs[1] a
     /* 6599 */   // No operand predicates
     /* 6599 */   // MIs[1] b
     /* 6599 */   // No operand predicates
     /* 6599 */   // MIs[1] c
     /* 6599 */   // No operand predicates
     /* 6599 */   // MIs[0] idx
     /* 6599 */   // No operand predicates
     /* 6599 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6601 */   // Combiner Rule #32: extract_vector_element_build_vector_trunc6
     /* 6601 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6604 */ // Label 440: @6604
     /* 6604 */ GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(6628), // Rule ID 33 //
     /* 6609 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule31Enabled),
     /* 6612 */   // MIs[0] root
     /* 6612 */   // No operand predicates
     /* 6612 */   // MIs[0] src
     /* 6612 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6616 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6620 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/6,
     /* 6623 */   // MIs[1] x
     /* 6623 */   // No operand predicates
     /* 6623 */   // MIs[1] y
     /* 6623 */   // No operand predicates
     /* 6623 */   // MIs[1] z
     /* 6623 */   // No operand predicates
     /* 6623 */   // MIs[1] a
     /* 6623 */   // No operand predicates
     /* 6623 */   // MIs[1] b
     /* 6623 */   // No operand predicates
     /* 6623 */   // MIs[0] idx
     /* 6623 */   // No operand predicates
     /* 6623 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6625 */   // Combiner Rule #31: extract_vector_element_build_vector_trunc5
     /* 6625 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6628 */ // Label 441: @6628
     /* 6628 */ GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(6652), // Rule ID 32 //
     /* 6633 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule30Enabled),
     /* 6636 */   // MIs[0] root
     /* 6636 */   // No operand predicates
     /* 6636 */   // MIs[0] src
     /* 6636 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6640 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6644 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/5,
     /* 6647 */   // MIs[1] x
     /* 6647 */   // No operand predicates
     /* 6647 */   // MIs[1] y
     /* 6647 */   // No operand predicates
     /* 6647 */   // MIs[1] z
     /* 6647 */   // No operand predicates
     /* 6647 */   // MIs[1] a
     /* 6647 */   // No operand predicates
     /* 6647 */   // MIs[0] idx
     /* 6647 */   // No operand predicates
     /* 6647 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6649 */   // Combiner Rule #30: extract_vector_element_build_vector_trunc4
     /* 6649 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6652 */ // Label 442: @6652
     /* 6652 */ GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(6676), // Rule ID 31 //
     /* 6657 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule29Enabled),
     /* 6660 */   // MIs[0] root
     /* 6660 */   // No operand predicates
     /* 6660 */   // MIs[0] src
     /* 6660 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6664 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6668 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 6671 */   // MIs[1] x
     /* 6671 */   // No operand predicates
     /* 6671 */   // MIs[1] y
     /* 6671 */   // No operand predicates
     /* 6671 */   // MIs[1] z
     /* 6671 */   // No operand predicates
     /* 6671 */   // MIs[0] idx
     /* 6671 */   // No operand predicates
     /* 6671 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6673 */   // Combiner Rule #29: extract_vector_element_build_vector_trunc3
     /* 6673 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6676 */ // Label 443: @6676
     /* 6676 */ GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(6710), // Rule ID 27 //
     /* 6681 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule25Enabled),
     /* 6684 */   // MIs[0] root
     /* 6684 */   // No operand predicates
     /* 6684 */   // MIs[0] src
     /* 6684 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6688 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INSERT_VECTOR_ELT),
     /* 6692 */   // MIs[1] x
     /* 6692 */   // No operand predicates
     /* 6692 */   // MIs[1] value
     /* 6692 */   // No operand predicates
     /* 6692 */   // MIs[1] idx
     /* 6692 */   // No operand predicates
     /* 6692 */   // MIs[0] idx
     /* 6692 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/3,
     /* 6697 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/2,
     /* 6702 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6704 */   // Combiner Rule #25: extract_vector_element_not_const
     /* 6704 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/2,
     /* 6709 */   GIR_EraseRootFromParent_Done,
     /* 6710 */ // Label 444: @6710
     /* 6710 */ GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(6731), // Rule ID 28 //
     /* 6715 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule26Enabled),
     /* 6718 */   // MIs[0] root
     /* 6718 */   // No operand predicates
     /* 6718 */   // MIs[0] src
     /* 6718 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6722 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INSERT_VECTOR_ELT),
     /* 6726 */   // MIs[1] x
     /* 6726 */   // No operand predicates
     /* 6726 */   // MIs[1] value
     /* 6726 */   // No operand predicates
     /* 6726 */   // MIs[1] idx2
     /* 6726 */   // No operand predicates
     /* 6726 */   // MIs[0] idx1
     /* 6726 */   // No operand predicates
     /* 6726 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6728 */   // Combiner Rule #26: extract_vector_element_different_indices
     /* 6728 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner11),
     /* 6731 */ // Label 445: @6731
     /* 6731 */ GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(6760), // Rule ID 37 //
     /* 6736 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule35Enabled),
     /* 6739 */   // MIs[0] root
     /* 6739 */   // No operand predicates
     /* 6739 */   // MIs[0] src
     /* 6739 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6743 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHUFFLE_VECTOR),
     /* 6747 */   // MIs[1] src1
     /* 6747 */   // No operand predicates
     /* 6747 */   // MIs[1] src2
     /* 6747 */   // No operand predicates
     /* 6747 */   // MIs[1] mask
     /* 6747 */   // No operand predicates
     /* 6747 */   // MIs[0] idx
     /* 6747 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 6751 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 6755 */   // MIs[2] imm
     /* 6755 */   // No operand predicates
     /* 6755 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 6757 */   // Combiner Rule #35: extract_vector_element_shuffle_vector
     /* 6757 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 6760 */ // Label 446: @6760
     /* 6760 */ GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(6784), // Rule ID 30 //
     /* 6765 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule28Enabled),
     /* 6768 */   // MIs[0] root
     /* 6768 */   // No operand predicates
     /* 6768 */   // MIs[0] src
     /* 6768 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6772 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6776 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 6779 */   // MIs[1] x
     /* 6779 */   // No operand predicates
     /* 6779 */   // MIs[1] y
     /* 6779 */   // No operand predicates
     /* 6779 */   // MIs[0] idx
     /* 6779 */   // No operand predicates
     /* 6779 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6781 */   // Combiner Rule #28: extract_vector_element_build_vector_trunc2
     /* 6781 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6784 */ // Label 447: @6784
     /* 6784 */ GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(6816), // Rule ID 29 //
     /* 6789 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule27Enabled),
     /* 6792 */   // MIs[0] root
     /* 6792 */   // No operand predicates
     /* 6792 */   // MIs[0] src
     /* 6792 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6796 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 6800 */   GIM_CheckNumOperandsGE, /*MI*/1, /*Expected*/2,
     /* 6803 */   // MIs[1] unused
     /* 6803 */   // No operand predicates
     /* 6803 */   // MIs[0] idx
     /* 6803 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 6807 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 6811 */   // MIs[2] imm
     /* 6811 */   // No operand predicates
     /* 6811 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 6813 */   // Combiner Rule #27: extract_vector_element_build_vector
     /* 6813 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner12),
     /* 6816 */ // Label 448: @6816
     /* 6816 */ GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(6840), // Rule ID 21 //
     /* 6821 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule19Enabled),
     /* 6824 */   // MIs[0] root
     /* 6824 */   // No operand predicates
     /* 6824 */   // MIs[0] vector
     /* 6824 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6828 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6832 */   // MIs[0] idx
     /* 6832 */   // No operand predicates
     /* 6832 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6834 */   // Combiner Rule #19: match_extract_of_element_undef_vector
     /* 6834 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6837 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 6839 */   GIR_EraseRootFromParent_Done,
     /* 6840 */ // Label 449: @6840
     /* 6840 */ GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(6864), // Rule ID 22 //
     /* 6845 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule20Enabled),
     /* 6848 */   // MIs[0] root
     /* 6848 */   // No operand predicates
     /* 6848 */   // MIs[0] vector
     /* 6848 */   // No operand predicates
     /* 6848 */   // MIs[0] idx
     /* 6848 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 6852 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6856 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6858 */   // Combiner Rule #20: match_extract_of_element_undef_index
     /* 6858 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6861 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 6863 */   GIR_EraseRootFromParent_Done,
     /* 6864 */ // Label 450: @6864
     /* 6864 */ GIM_Reject,
     /* 6865 */ // Label 92: @6865
     /* 6865 */ GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(6876), // Rule ID 97 //
     /* 6870 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule79Enabled),
     /* 6873 */   // Combiner Rule #79: propagate_undef_all_ops; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 6873 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner40),
     /* 6876 */ // Label 451: @6876
     /* 6876 */ GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(6887), // Rule ID 99 //
     /* 6881 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule80Enabled),
     /* 6884 */   // Combiner Rule #80: propagate_undef_shuffle_mask; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 6884 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner41),
     /* 6887 */ // Label 452: @6887
     /* 6887 */ GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(6898), // Rule ID 345 //
     /* 6892 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule200Enabled),
     /* 6895 */   // Combiner Rule #200: combine_shuffle_concat; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 6895 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner136),
     /* 6898 */ // Label 453: @6898
     /* 6898 */ GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(6909), // Rule ID 347 //
     /* 6903 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule202Enabled),
     /* 6906 */   // Combiner Rule #202: combine_shuffle_disjoint_mask; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 6906 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner138),
     /* 6909 */ // Label 454: @6909
     /* 6909 */ GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(6930), // Rule ID 346 //
     /* 6914 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule201Enabled),
     /* 6917 */   // MIs[0] root
     /* 6917 */   // No operand predicates
     /* 6917 */   // MIs[0] src1
     /* 6917 */   // No operand predicates
     /* 6917 */   // MIs[0] undef
     /* 6917 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 6921 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6925 */   // MIs[0] mask
     /* 6925 */   // No operand predicates
     /* 6925 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6927 */   // Combiner Rule #201: combine_shuffle_undef_rhs
     /* 6927 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner137),
     /* 6930 */ // Label 455: @6930
     /* 6930 */ GIM_Reject,
     /* 6931 */ // Label 93: @6931
     /* 6931 */ GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(6975), // Rule ID 223 //
     /* 6936 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule160Enabled),
     /* 6939 */   // MIs[0] d
     /* 6939 */   // No operand predicates
     /* 6939 */   // MIs[0] src
     /* 6939 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6943 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 6947 */   // MIs[1] rev
     /* 6947 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 6951 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITREVERSE),
     /* 6955 */   // MIs[2] val
     /* 6955 */   // No operand predicates
     /* 6955 */   // MIs[1] amt
     /* 6955 */   // No operand predicates
     /* 6955 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner9),
     /* 6959 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 6961 */   // Combiner Rule #160: bitreverse_lshr
     /* 6961 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SHL),
     /* 6964 */   GIR_RootToRootCopy, /*OpIdx*/0, // d
     /* 6966 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 6970 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // amt
     /* 6974 */   GIR_EraseRootFromParent_Done,
     /* 6975 */ // Label 456: @6975
     /* 6975 */ GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(7019), // Rule ID 222 //
     /* 6980 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule159Enabled),
     /* 6983 */   // MIs[0] d
     /* 6983 */   // No operand predicates
     /* 6983 */   // MIs[0] src
     /* 6983 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6987 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 6991 */   // MIs[1] rev
     /* 6991 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 6995 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITREVERSE),
     /* 6999 */   // MIs[2] val
     /* 6999 */   // No operand predicates
     /* 6999 */   // MIs[1] amt
     /* 6999 */   // No operand predicates
     /* 6999 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner8),
     /* 7003 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 7005 */   // Combiner Rule #159: bitreverse_shl
     /* 7005 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 7008 */   GIR_RootToRootCopy, /*OpIdx*/0, // d
     /* 7010 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 7014 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // amt
     /* 7018 */   GIR_EraseRootFromParent_Done,
     /* 7019 */ // Label 457: @7019
     /* 7019 */ GIM_Reject,
     /* 7020 */ // Label 94: @7020
     /* 7020 */ GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(7041), // Rule ID 178 //
     /* 7025 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule136Enabled),
     /* 7028 */   // MIs[0] dst
     /* 7028 */   // No operand predicates
     /* 7028 */   // MIs[0] src0
     /* 7028 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 7032 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 7036 */   // MIs[1] cst
     /* 7036 */   // No operand predicates
     /* 7036 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 7038 */   // Combiner Rule #136: constant_fold_fsqrt
     /* 7038 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner81),
     /* 7041 */ // Label 458: @7041
     /* 7041 */ GIM_Reject,
     /* 7042 */ // Label 95: @7042
     /* 7042 */ GIM_Reject,
     /* 7043 */ }; // Size: 7043 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GICOMBINER_IMPL

#ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
#ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
, State(0),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GICOMBINER_CONSTRUCTOR_INITS

